#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 2857
#define SYMBOL_COUNT 154
#define ALIAS_COUNT 2
#define TOKEN_COUNT 97
#define EXTERNAL_TOKEN_COUNT 13
#define MAX_ALIAS_SEQUENCE_LENGTH 8

enum {
  sym_heredoc_start = 1,
  sym__simple_heredoc_body = 2,
  sym__heredoc_body_beginning = 3,
  sym__heredoc_body_middle = 4,
  sym__heredoc_body_end = 5,
  sym_file_descriptor = 6,
  sym__empty_value = 7,
  sym__concat = 8,
  sym_variable_name = 9,
  sym_regex = 10,
  anon_sym_for = 11,
  anon_sym_in = 12,
  anon_sym_LPAREN_LPAREN = 13,
  anon_sym_RPAREN_RPAREN = 14,
  anon_sym_SEMI = 15,
  anon_sym_while = 16,
  anon_sym_do = 17,
  anon_sym_done = 18,
  anon_sym_if = 19,
  anon_sym_then = 20,
  anon_sym_fi = 21,
  anon_sym_elif = 22,
  anon_sym_else = 23,
  anon_sym_case = 24,
  anon_sym_esac = 25,
  anon_sym_PIPE = 26,
  anon_sym_RPAREN = 27,
  anon_sym_SEMI_SEMI = 28,
  anon_sym_function = 29,
  anon_sym_LPAREN = 30,
  anon_sym_LBRACE = 31,
  anon_sym_RBRACE = 32,
  anon_sym_PIPE_AMP = 33,
  anon_sym_AMP_AMP = 34,
  anon_sym_PIPE_PIPE = 35,
  anon_sym_BANG = 36,
  anon_sym_LBRACK = 37,
  anon_sym_RBRACK = 38,
  anon_sym_LBRACK_LBRACK = 39,
  anon_sym_RBRACK_RBRACK = 40,
  anon_sym_declare = 41,
  anon_sym_typeset = 42,
  anon_sym_export = 43,
  anon_sym_readonly = 44,
  anon_sym_local = 45,
  anon_sym_unset = 46,
  anon_sym_unsetenv = 47,
  anon_sym_EQ_TILDE = 48,
  anon_sym_EQ_EQ = 49,
  anon_sym_EQ = 50,
  anon_sym_PLUS_EQ = 51,
  anon_sym_LT = 52,
  anon_sym_GT = 53,
  anon_sym_GT_GT = 54,
  anon_sym_AMP_GT = 55,
  anon_sym_AMP_GT_GT = 56,
  anon_sym_LT_AMP = 57,
  anon_sym_GT_AMP = 58,
  anon_sym_LT_LT = 59,
  anon_sym_LT_LT_DASH = 60,
  anon_sym_LT_LT_LT = 61,
  anon_sym_BANG_EQ = 62,
  anon_sym_PLUS = 63,
  anon_sym_DASH = 64,
  anon_sym_DASH_EQ = 65,
  anon_sym_LT_EQ = 66,
  anon_sym_GT_EQ = 67,
  anon_sym_PLUS_PLUS = 68,
  anon_sym_DASH_DASH = 69,
  sym__special_characters = 70,
  anon_sym_DQUOTE = 71,
  anon_sym_DOLLAR = 72,
  sym__string_content = 73,
  sym_raw_string = 74,
  anon_sym_POUND = 75,
  anon_sym_DOLLAR_LBRACE = 76,
  anon_sym_SLASH = 77,
  anon_sym_COLON = 78,
  anon_sym_COLON_QMARK = 79,
  anon_sym_COLON_DASH = 80,
  anon_sym_PERCENT = 81,
  anon_sym_DOLLAR_LPAREN = 82,
  anon_sym_BQUOTE = 83,
  anon_sym_LT_LPAREN = 84,
  anon_sym_GT_LPAREN = 85,
  sym_comment = 86,
  aux_sym_SLASH_BSLASHw_PLUS_SLASH = 87,
  anon_sym_STAR = 88,
  anon_sym_AT = 89,
  anon_sym_QMARK = 90,
  anon_sym_0 = 91,
  anon_sym__ = 92,
  sym_word = 93,
  sym_test_operator = 94,
  anon_sym_LF = 95,
  anon_sym_AMP = 96,
  sym_program = 97,
  sym__terminated_statement = 98,
  sym_redirected_statement = 99,
  sym_for_statement = 100,
  sym_c_style_for_statement = 101,
  sym_while_statement = 102,
  sym_do_group = 103,
  sym_if_statement = 104,
  sym_elif_clause = 105,
  sym_else_clause = 106,
  sym_case_statement = 107,
  sym_case_item = 108,
  sym_last_case_item = 109,
  sym_function_definition = 110,
  sym_compound_statement = 111,
  sym_subshell = 112,
  sym_pipeline = 113,
  sym_list = 114,
  sym_negated_command = 115,
  sym_test_command = 116,
  sym_declaration_command = 117,
  sym_unset_command = 118,
  sym_command = 119,
  sym_command_name = 120,
  sym_variable_assignment = 121,
  sym_subscript = 122,
  sym_file_redirect = 123,
  sym_heredoc_redirect = 124,
  sym_heredoc_body = 125,
  sym_herestring_redirect = 126,
  sym__expression = 127,
  sym_binary_expression = 128,
  sym_unary_expression = 129,
  sym_postfix_expression = 130,
  sym_parenthesized_expression = 131,
  sym_concatenation = 132,
  sym_string = 133,
  sym_array = 134,
  sym_simple_expansion = 135,
  sym_string_expansion = 136,
  sym_expansion = 137,
  sym_command_substitution = 138,
  sym_process_substitution = 139,
  aux_sym__statements_repeat1 = 140,
  aux_sym_redirected_statement_repeat1 = 141,
  aux_sym_for_statement_repeat1 = 142,
  aux_sym_if_statement_repeat1 = 143,
  aux_sym_case_statement_repeat1 = 144,
  aux_sym_case_item_repeat1 = 145,
  aux_sym_declaration_command_repeat1 = 146,
  aux_sym_unset_command_repeat1 = 147,
  aux_sym_command_repeat1 = 148,
  aux_sym_command_repeat2 = 149,
  aux_sym_heredoc_body_repeat1 = 150,
  aux_sym_concatenation_repeat1 = 151,
  aux_sym_string_repeat1 = 152,
  aux_sym_expansion_repeat1 = 153,
  alias_sym_special_variable_name = 154,
  alias_sym_word = 155,
};

static const char *ts_symbol_names[] = {
  [sym_heredoc_start] = "heredoc_start",
  [sym__simple_heredoc_body] = "_simple_heredoc_body",
  [sym__heredoc_body_beginning] = "_heredoc_body_beginning",
  [sym__heredoc_body_middle] = "_heredoc_body_middle",
  [sym__heredoc_body_end] = "_heredoc_body_end",
  [sym_file_descriptor] = "file_descriptor",
  [sym__empty_value] = "_empty_value",
  [sym__concat] = "_concat",
  [sym_variable_name] = "variable_name",
  [sym_regex] = "regex",
  [ts_builtin_sym_end] = "END",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_LPAREN_LPAREN] = "((",
  [anon_sym_RPAREN_RPAREN] = "))",
  [anon_sym_SEMI] = ";",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_done] = "done",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_fi] = "fi",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_esac] = "esac",
  [anon_sym_PIPE] = "|",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI_SEMI] = ";;",
  [anon_sym_function] = "function",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_BANG] = "!",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym_declare] = "declare",
  [anon_sym_typeset] = "typeset",
  [anon_sym_export] = "export",
  [anon_sym_readonly] = "readonly",
  [anon_sym_local] = "local",
  [anon_sym_unset] = "unset",
  [anon_sym_unsetenv] = "unsetenv",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_GT] = "&>",
  [anon_sym_AMP_GT_GT] = "&>>",
  [anon_sym_LT_AMP] = "<&",
  [anon_sym_GT_AMP] = ">&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_LT_LT_LT] = "<<<",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [sym__special_characters] = "_special_characters",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_DOLLAR] = "$",
  [sym__string_content] = "_string_content",
  [sym_raw_string] = "raw_string",
  [anon_sym_POUND] = "#",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH] = "/",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_QMARK] = ":?",
  [anon_sym_COLON_DASH] = ":-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LT_LPAREN] = "<(",
  [anon_sym_GT_LPAREN] = ">(",
  [sym_comment] = "comment",
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = "variable_name",
  [anon_sym_STAR] = "special_variable_name",
  [anon_sym_AT] = "special_variable_name",
  [anon_sym_QMARK] = "special_variable_name",
  [anon_sym_0] = "special_variable_name",
  [anon_sym__] = "special_variable_name",
  [sym_word] = "word",
  [sym_test_operator] = "test_operator",
  [anon_sym_LF] = "\n",
  [anon_sym_AMP] = "&",
  [sym_program] = "program",
  [sym__terminated_statement] = "_terminated_statement",
  [sym_redirected_statement] = "redirected_statement",
  [sym_for_statement] = "for_statement",
  [sym_c_style_for_statement] = "c_style_for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_group] = "do_group",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_last_case_item] = "case_item",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_subshell] = "subshell",
  [sym_pipeline] = "pipeline",
  [sym_list] = "list",
  [sym_negated_command] = "negated_command",
  [sym_test_command] = "test_command",
  [sym_declaration_command] = "declaration_command",
  [sym_unset_command] = "unset_command",
  [sym_command] = "command",
  [sym_command_name] = "command_name",
  [sym_variable_assignment] = "variable_assignment",
  [sym_subscript] = "subscript",
  [sym_file_redirect] = "file_redirect",
  [sym_heredoc_redirect] = "heredoc_redirect",
  [sym_heredoc_body] = "heredoc_body",
  [sym_herestring_redirect] = "herestring_redirect",
  [sym__expression] = "_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_postfix_expression] = "postfix_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_concatenation] = "concatenation",
  [sym_string] = "string",
  [sym_array] = "array",
  [sym_simple_expansion] = "simple_expansion",
  [sym_string_expansion] = "string_expansion",
  [sym_expansion] = "expansion",
  [sym_command_substitution] = "command_substitution",
  [sym_process_substitution] = "process_substitution",
  [aux_sym__statements_repeat1] = "_statements_repeat1",
  [aux_sym_redirected_statement_repeat1] = "redirected_statement_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_case_item_repeat1] = "case_item_repeat1",
  [aux_sym_declaration_command_repeat1] = "declaration_command_repeat1",
  [aux_sym_unset_command_repeat1] = "unset_command_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_command_repeat2] = "command_repeat2",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_expansion_repeat1] = "expansion_repeat1",
  [alias_sym_special_variable_name] = "special_variable_name",
  [alias_sym_word] = "word",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym_heredoc_start] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_heredoc_body] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_beginning] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_middle] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_end] = {
    .visible = false,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_value] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_esac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsetenv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym__special_characters] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__] = {
    .visible = true,
    .named = true,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [sym_test_operator] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_redirected_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_c_style_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_group] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_last_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_negated_command] = {
    .visible = true,
    .named = true,
  },
  [sym_test_command] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_command] = {
    .visible = true,
    .named = true,
  },
  [sym_unset_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym_herestring_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_string_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_process_substitution] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_redirected_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unset_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expansion_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_special_variable_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_word] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[8][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_word,
  },
  [2] = {
    [1] = alias_sym_word,
  },
  [3] = {
    [1] = alias_sym_special_variable_name,
  },
  [4] = {
    [2] = alias_sym_word,
  },
  [5] = {
    [2] = alias_sym_special_variable_name,
  },
  [6] = {
    [3] = alias_sym_word,
  },
  [7] = {
    [4] = alias_sym_word,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(11);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(21);
      if (lookahead == '+')
        ADVANCE(22);
      if (lookahead == '-')
        ADVANCE(25);
      if (lookahead == '/')
        ADVANCE(29);
      if (lookahead == '0')
        ADVANCE(30);
      if (lookahead == ':')
        ADVANCE(31);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(36);
      if (lookahead == '=')
        ADVANCE(43);
      if (lookahead == '>')
        ADVANCE(46);
      if (lookahead == '?')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(52);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(55);
      if (lookahead == ']')
        ADVANCE(56);
      if (lookahead == '_')
        ADVANCE(58);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(60);
      if (lookahead == 'i')
        ADVANCE(64);
      if (lookahead == '{')
        ADVANCE(66);
      if (lookahead == '|')
        ADVANCE(67);
      if (lookahead == '}')
        ADVANCE(70);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      ADVANCE(5);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 4:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(5);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '{')
        ADVANCE(10);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(13);
      if (lookahead == '>')
        ADVANCE(14);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(15);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      END_STATE();
    case 16:
      if (lookahead == '\'')
        ADVANCE(17);
      if (lookahead != 0)
        ADVANCE(16);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(sym_raw_string);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '(')
        ADVANCE(19);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_LPAREN_LPAREN);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(23);
      if (lookahead == '=')
        ADVANCE(24);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(26);
      if (lookahead == '=')
        ADVANCE(27);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(28);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '`' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(28);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(32);
      if (lookahead == '?')
        ADVANCE(33);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '?' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(35);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '(')
        ADVANCE(38);
      if (lookahead == '<')
        ADVANCE(39);
      if (lookahead == '=')
        ADVANCE(42);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(40);
      if (lookahead == '<')
        ADVANCE(41);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_LT_LT_LT);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(44);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == '~')
        ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(5);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(47);
      if (lookahead == '(')
        ADVANCE(48);
      if (lookahead == '=')
        ADVANCE(49);
      if (lookahead == '>')
        ADVANCE(50);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(54);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 55:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']')
        ADVANCE(57);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 's')
        ADVANCE(61);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'a')
        ADVANCE(62);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'c')
        ADVANCE(63);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'n')
        ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(68);
      if (lookahead == '|')
        ADVANCE(69);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 71:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(73);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(74);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(66);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(71);
      if ((lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(72);
      END_STATE();
    case 73:
      if (lookahead == '>')
        ADVANCE(14);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '(')
        ADVANCE(38);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(47);
      if (lookahead == '(')
        ADVANCE(48);
      if (lookahead == '>')
        ADVANCE(50);
      END_STATE();
    case 76:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(71);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym__special_characters);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '}')
        ADVANCE(77);
      END_STATE();
    case 78:
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '+')
        ADVANCE(79);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(78);
      END_STATE();
    case 79:
      if (lookahead == '=')
        ADVANCE(80);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 83:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(78);
      END_STATE();
    case 84:
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '(')
        ADVANCE(85);
      if (lookahead == '\\')
        SKIP(86);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(84);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(87);
      END_STATE();
    case 85:
      if (lookahead == '(')
        ADVANCE(19);
      END_STATE();
    case 86:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(84);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(87);
      END_STATE();
    case 88:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(89);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '<')
        ADVANCE(91);
      if (lookahead == '>')
        ADVANCE(92);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(93);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(88);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(28);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '`' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 91:
      if (lookahead == '(')
        ADVANCE(38);
      END_STATE();
    case 92:
      if (lookahead == '(')
        ADVANCE(48);
      END_STATE();
    case 93:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(88);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 94:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(73);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(74);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(95);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(94);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 95:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(94);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 96:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(73);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(74);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(97);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(66);
      if (lookahead == '}')
        ADVANCE(70);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(96);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 97:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(96);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 98:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(73);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(74);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(99);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(98);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 99:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(98);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 100:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(101);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(102);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(67);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(100);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(103);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '(')
        ADVANCE(38);
      if (lookahead == '<')
        ADVANCE(39);
      END_STATE();
    case 102:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(100);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(103);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 104:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(101);
      if (lookahead == '=')
        ADVANCE(105);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(106);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(67);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(104);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '=')
        ADVANCE(44);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == '~')
        ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(5);
      END_STATE();
    case 106:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(104);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 107:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(108);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\\')
        ADVANCE(112);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(113);
      if (lookahead != 0)
        ADVANCE(109);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(109);
      if (lookahead == '\\')
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(108);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\\')
        ADVANCE(110);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(109);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(109);
      if (lookahead == '\\')
        ADVANCE(110);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(109);
      if (lookahead != 0)
        ADVANCE(109);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(109);
      if (lookahead == '\\')
        ADVANCE(111);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(108);
      if (lookahead != 0)
        ADVANCE(108);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(113);
      if (lookahead == '\\')
        ADVANCE(110);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(113);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(109);
      if (lookahead != 0)
        ADVANCE(109);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(108);
      if (lookahead == '\\')
        ADVANCE(112);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(113);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(109);
      END_STATE();
    case 114:
      if (lookahead == '!')
        ADVANCE(115);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(116);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(117);
      if (lookahead == '-')
        ADVANCE(118);
      if (lookahead == '0')
        ADVANCE(119);
      if (lookahead == '?')
        ADVANCE(120);
      if (lookahead == '@')
        ADVANCE(121);
      if (lookahead == '\\')
        SKIP(122);
      if (lookahead == '_')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(114);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(87);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(87);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 122:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(114);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(87);
      END_STATE();
    case 124:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(89);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(101);
      if (lookahead == '=')
        ADVANCE(105);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(125);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(67);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(124);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 125:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(124);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 126:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '\\')
        SKIP(127);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(126);
      END_STATE();
    case 127:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(126);
      END_STATE();
    case 128:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '\\')
        SKIP(131);
      if (lookahead == '|')
        ADVANCE(67);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(128);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '<')
        ADVANCE(39);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(47);
      if (lookahead == '>')
        ADVANCE(50);
      END_STATE();
    case 131:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(128);
      END_STATE();
    case 132:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(101);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(133);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(67);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(132);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 133:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(132);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 134:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(101);
      if (lookahead == '=')
        ADVANCE(105);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(135);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(67);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(134);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 135:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(134);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 136:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(89);
      if (lookahead == '<')
        ADVANCE(91);
      if (lookahead == '>')
        ADVANCE(92);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(136);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 137:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(136);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 138:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(139);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(89);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(91);
      if (lookahead == '>')
        ADVANCE(92);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(140);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(138);
      if (lookahead != 0 &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 140:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(138);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 141:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '&')
        ADVANCE(139);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(142);
      if (lookahead == 'i')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(141);
      END_STATE();
    case 142:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(141);
      END_STATE();
    case 143:
      if (lookahead == 'n')
        ADVANCE(144);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 145:
      if (lookahead == '!')
        ADVANCE(146);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '&')
        ADVANCE(148);
      if (lookahead == ')')
        ADVANCE(149);
      if (lookahead == '+')
        ADVANCE(151);
      if (lookahead == '-')
        ADVANCE(153);
      if (lookahead == '<')
        ADVANCE(157);
      if (lookahead == '=')
        ADVANCE(158);
      if (lookahead == '>')
        ADVANCE(161);
      if (lookahead == '\\')
        SKIP(162);
      if (lookahead == '|')
        ADVANCE(163);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(145);
      END_STATE();
    case 146:
      if (lookahead == '=')
        ADVANCE(147);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 148:
      if (lookahead == '&')
        ADVANCE(13);
      END_STATE();
    case 149:
      if (lookahead == ')')
        ADVANCE(150);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_RPAREN_RPAREN);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(152);
      if (lookahead == '=')
        ADVANCE(80);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(154);
      if (lookahead == '=')
        ADVANCE(155);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(156);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(156);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=')
        ADVANCE(42);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(159);
      if (lookahead == '~')
        ADVANCE(160);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(49);
      END_STATE();
    case 162:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(145);
      END_STATE();
    case 163:
      if (lookahead == '|')
        ADVANCE(69);
      END_STATE();
    case 164:
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '(')
        ADVANCE(89);
      if (lookahead == ';')
        ADVANCE(165);
      if (lookahead == '\\')
        ADVANCE(166);
      if (lookahead == '{')
        ADVANCE(66);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(164);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 166:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(164);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 167:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(101);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(168);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(67);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(167);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(103);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 168:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(167);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 169:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(89);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(101);
      if (lookahead == '=')
        ADVANCE(105);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(170);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(67);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(169);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 170:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(169);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 171:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '\\')
        SKIP(172);
      if (lookahead == '|')
        ADVANCE(67);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(171);
      END_STATE();
    case 172:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(171);
      END_STATE();
    case 173:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(101);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(174);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(67);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 174:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 175:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '\\')
        SKIP(176);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(177);
      if (lookahead == '|')
        ADVANCE(67);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(175);
      END_STATE();
    case 176:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(175);
      END_STATE();
    case 177:
      if (lookahead == 's')
        ADVANCE(178);
      END_STATE();
    case 178:
      if (lookahead == 'a')
        ADVANCE(179);
      END_STATE();
    case 179:
      if (lookahead == 'c')
        ADVANCE(180);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_esac);
      END_STATE();
    case 181:
      if (lookahead == '!')
        ADVANCE(146);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '&')
        ADVANCE(148);
      if (lookahead == '+')
        ADVANCE(151);
      if (lookahead == '-')
        ADVANCE(153);
      if (lookahead == '<')
        ADVANCE(157);
      if (lookahead == '=')
        ADVANCE(158);
      if (lookahead == '>')
        ADVANCE(161);
      if (lookahead == '\\')
        SKIP(182);
      if (lookahead == ']')
        ADVANCE(183);
      if (lookahead == '|')
        ADVANCE(163);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(181);
      END_STATE();
    case 182:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(181);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 184:
      if (lookahead == '!')
        ADVANCE(146);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '&')
        ADVANCE(148);
      if (lookahead == '+')
        ADVANCE(151);
      if (lookahead == '-')
        ADVANCE(153);
      if (lookahead == '<')
        ADVANCE(157);
      if (lookahead == '=')
        ADVANCE(158);
      if (lookahead == '>')
        ADVANCE(161);
      if (lookahead == '\\')
        SKIP(185);
      if (lookahead == ']')
        ADVANCE(186);
      if (lookahead == '|')
        ADVANCE(163);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(184);
      END_STATE();
    case 185:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(184);
      END_STATE();
    case 186:
      if (lookahead == ']')
        ADVANCE(57);
      END_STATE();
    case 187:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(116);
      if (lookahead == '*')
        ADVANCE(117);
      if (lookahead == '-')
        ADVANCE(118);
      if (lookahead == '0')
        ADVANCE(188);
      if (lookahead == '?')
        ADVANCE(120);
      if (lookahead == '@')
        ADVANCE(121);
      if (lookahead == '\\')
        ADVANCE(190);
      if (lookahead == '_')
        ADVANCE(192);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(191);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(189);
      if (lookahead != 0 &&
          (lookahead < '_' || lookahead > 'z'))
        ADVANCE(109);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(189);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(189);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(191);
      if (lookahead == '\\')
        ADVANCE(110);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(191);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(109);
      if (lookahead != 0)
        ADVANCE(109);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '*')
        ADVANCE(117);
      if (lookahead == '-')
        ADVANCE(118);
      if (lookahead == '0')
        ADVANCE(188);
      if (lookahead == '?')
        ADVANCE(120);
      if (lookahead == '@')
        ADVANCE(121);
      if (lookahead == '\\')
        ADVANCE(190);
      if (lookahead == '_')
        ADVANCE(192);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(191);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(189);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '_' || lookahead > 'z'))
        ADVANCE(109);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(189);
      END_STATE();
    case 193:
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(116);
      if (lookahead == '*')
        ADVANCE(117);
      if (lookahead == '-')
        ADVANCE(118);
      if (lookahead == '0')
        ADVANCE(119);
      if (lookahead == '?')
        ADVANCE(120);
      if (lookahead == '@')
        ADVANCE(121);
      if (lookahead == '\\')
        SKIP(194);
      if (lookahead == '_')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(193);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(87);
      END_STATE();
    case 194:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(193);
      END_STATE();
    case 195:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(196);
      if (lookahead == '/')
        ADVANCE(29);
      if (lookahead == ':')
        ADVANCE(31);
      if (lookahead == '<')
        ADVANCE(91);
      if (lookahead == '=')
        ADVANCE(197);
      if (lookahead == '>')
        ADVANCE(92);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(198);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '}')
        ADVANCE(70);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(195);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 198:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(195);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 199:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '\\')
        SKIP(200);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '|')
        ADVANCE(67);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(199);
      END_STATE();
    case 200:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(199);
      END_STATE();
    case 201:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '&')
        ADVANCE(139);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(202);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(201);
      END_STATE();
    case 202:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(201);
      END_STATE();
    case 203:
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(204);
      if (lookahead == '\\')
        SKIP(205);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(203);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '{')
        ADVANCE(10);
      END_STATE();
    case 205:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(203);
      END_STATE();
    case 206:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '&')
        ADVANCE(139);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(207);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(206);
      END_STATE();
    case 207:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(206);
      END_STATE();
    case 208:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(91);
      if (lookahead == '>')
        ADVANCE(92);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(209);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(208);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 209:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(208);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 210:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(91);
      if (lookahead == '>')
        ADVANCE(92);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(211);
      if (lookahead == ']')
        ADVANCE(183);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(210);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 211:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(210);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 212:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '<')
        ADVANCE(91);
      if (lookahead == '>')
        ADVANCE(92);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(213);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 213:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 214:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(146);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '&')
        ADVANCE(215);
      if (lookahead == '+')
        ADVANCE(151);
      if (lookahead == '-')
        ADVANCE(153);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(157);
      if (lookahead == '=')
        ADVANCE(158);
      if (lookahead == '>')
        ADVANCE(161);
      if (lookahead == '\\')
        SKIP(216);
      if (lookahead == '|')
        ADVANCE(163);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(214);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(13);
      END_STATE();
    case 216:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(214);
      END_STATE();
    case 217:
      if (lookahead == '!')
        ADVANCE(146);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '&')
        ADVANCE(148);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '+')
        ADVANCE(151);
      if (lookahead == '-')
        ADVANCE(153);
      if (lookahead == '<')
        ADVANCE(157);
      if (lookahead == '=')
        ADVANCE(158);
      if (lookahead == '>')
        ADVANCE(161);
      if (lookahead == '\\')
        SKIP(218);
      if (lookahead == '|')
        ADVANCE(163);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(217);
      END_STATE();
    case 218:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(217);
      END_STATE();
    case 219:
      if (lookahead == '!')
        ADVANCE(146);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '&')
        ADVANCE(148);
      if (lookahead == ')')
        ADVANCE(149);
      if (lookahead == '+')
        ADVANCE(151);
      if (lookahead == '-')
        ADVANCE(153);
      if (lookahead == '<')
        ADVANCE(157);
      if (lookahead == '=')
        ADVANCE(158);
      if (lookahead == '>')
        ADVANCE(161);
      if (lookahead == '\\')
        SKIP(220);
      if (lookahead == ']')
        ADVANCE(186);
      if (lookahead == '|')
        ADVANCE(163);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(219);
      END_STATE();
    case 220:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(219);
      END_STATE();
    case 221:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(73);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(222);
      if (lookahead == '<')
        ADVANCE(74);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(223);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(66);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(221);
      if (lookahead != 0 &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 222:
      if (lookahead == ';')
        ADVANCE(35);
      END_STATE();
    case 223:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(221);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 224:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(91);
      if (lookahead == '>')
        ADVANCE(92);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(225);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '}')
        ADVANCE(70);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(224);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 225:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(224);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 226:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(196);
      if (lookahead == ':')
        ADVANCE(31);
      if (lookahead == '<')
        ADVANCE(91);
      if (lookahead == '=')
        ADVANCE(197);
      if (lookahead == '>')
        ADVANCE(92);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(227);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '}')
        ADVANCE(70);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(226);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 227:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(226);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 228:
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '+')
        ADVANCE(79);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '\\')
        SKIP(229);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(228);
      END_STATE();
    case 229:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(228);
      END_STATE();
    case 230:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(89);
      if (lookahead == ')')
        ADVANCE(149);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '<')
        ADVANCE(91);
      if (lookahead == '>')
        ADVANCE(92);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(231);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(230);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 231:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(230);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 232:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(139);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(91);
      if (lookahead == '>')
        ADVANCE(92);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(233);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(232);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 233:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(232);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 234:
      if (lookahead == '!')
        ADVANCE(146);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '&')
        ADVANCE(148);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '+')
        ADVANCE(151);
      if (lookahead == '-')
        ADVANCE(153);
      if (lookahead == '<')
        ADVANCE(157);
      if (lookahead == '=')
        ADVANCE(158);
      if (lookahead == '>')
        ADVANCE(161);
      if (lookahead == '\\')
        SKIP(235);
      if (lookahead == '|')
        ADVANCE(236);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(234);
      END_STATE();
    case 235:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(234);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(69);
      END_STATE();
    case 237:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(91);
      if (lookahead == '>')
        ADVANCE(92);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(238);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(60);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(237);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 238:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(237);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 239:
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '\\')
        SKIP(240);
      if (lookahead == '|')
        ADVANCE(241);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(239);
      END_STATE();
    case 240:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(239);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 242:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '\\')
        SKIP(243);
      if (lookahead == 'e')
        ADVANCE(177);
      if (lookahead == '|')
        ADVANCE(67);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(242);
      END_STATE();
    case 243:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(242);
      END_STATE();
    case 244:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(73);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(222);
      if (lookahead == '<')
        ADVANCE(74);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(245);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(60);
      if (lookahead == '{')
        ADVANCE(66);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 245:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 246:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(101);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(247);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(248);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(67);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(246);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(103);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 247:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(246);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 's')
        ADVANCE(249);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(103);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'a')
        ADVANCE(250);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(103);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'c')
        ADVANCE(251);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(103);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(103);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 252:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(101);
      if (lookahead == '=')
        ADVANCE(105);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(253);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(60);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(67);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(252);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 253:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(252);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 254:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(89);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(101);
      if (lookahead == '=')
        ADVANCE(105);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(255);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(60);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(67);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(254);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 255:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(254);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 256:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(72);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(101);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(77);
      if (lookahead == '\\')
        ADVANCE(257);
      if (lookahead == ']')
        ADVANCE(77);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(60);
      if (lookahead == '{')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(67);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(256);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 257:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(256);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'c')
        ADVANCE(1);
      if (lookahead == 'd')
        ADVANCE(5);
      if (lookahead == 'e')
        ADVANCE(15);
      if (lookahead == 'f')
        ADVANCE(26);
      if (lookahead == 'i')
        ADVANCE(37);
      if (lookahead == 'l')
        ADVANCE(39);
      if (lookahead == 'r')
        ADVANCE(44);
      if (lookahead == 't')
        ADVANCE(52);
      if (lookahead == 'u')
        ADVANCE(62);
      if (lookahead == 'w')
        ADVANCE(70);
      END_STATE();
    case 1:
      if (lookahead == 'a')
        ADVANCE(2);
      END_STATE();
    case 2:
      if (lookahead == 's')
        ADVANCE(3);
      END_STATE();
    case 3:
      if (lookahead == 'e')
        ADVANCE(4);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 5:
      if (lookahead == 'e')
        ADVANCE(6);
      if (lookahead == 'o')
        ADVANCE(12);
      END_STATE();
    case 6:
      if (lookahead == 'c')
        ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == 'l')
        ADVANCE(8);
      END_STATE();
    case 8:
      if (lookahead == 'a')
        ADVANCE(9);
      END_STATE();
    case 9:
      if (lookahead == 'r')
        ADVANCE(10);
      END_STATE();
    case 10:
      if (lookahead == 'e')
        ADVANCE(11);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'n')
        ADVANCE(13);
      END_STATE();
    case 13:
      if (lookahead == 'e')
        ADVANCE(14);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_done);
      END_STATE();
    case 15:
      if (lookahead == 'l')
        ADVANCE(16);
      if (lookahead == 'x')
        ADVANCE(21);
      END_STATE();
    case 16:
      if (lookahead == 'i')
        ADVANCE(17);
      if (lookahead == 's')
        ADVANCE(19);
      END_STATE();
    case 17:
      if (lookahead == 'f')
        ADVANCE(18);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 19:
      if (lookahead == 'e')
        ADVANCE(20);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 21:
      if (lookahead == 'p')
        ADVANCE(22);
      END_STATE();
    case 22:
      if (lookahead == 'o')
        ADVANCE(23);
      END_STATE();
    case 23:
      if (lookahead == 'r')
        ADVANCE(24);
      END_STATE();
    case 24:
      if (lookahead == 't')
        ADVANCE(25);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 26:
      if (lookahead == 'i')
        ADVANCE(27);
      if (lookahead == 'o')
        ADVANCE(28);
      if (lookahead == 'u')
        ADVANCE(30);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_fi);
      END_STATE();
    case 28:
      if (lookahead == 'r')
        ADVANCE(29);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 30:
      if (lookahead == 'n')
        ADVANCE(31);
      END_STATE();
    case 31:
      if (lookahead == 'c')
        ADVANCE(32);
      END_STATE();
    case 32:
      if (lookahead == 't')
        ADVANCE(33);
      END_STATE();
    case 33:
      if (lookahead == 'i')
        ADVANCE(34);
      END_STATE();
    case 34:
      if (lookahead == 'o')
        ADVANCE(35);
      END_STATE();
    case 35:
      if (lookahead == 'n')
        ADVANCE(36);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 37:
      if (lookahead == 'f')
        ADVANCE(38);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 39:
      if (lookahead == 'o')
        ADVANCE(40);
      END_STATE();
    case 40:
      if (lookahead == 'c')
        ADVANCE(41);
      END_STATE();
    case 41:
      if (lookahead == 'a')
        ADVANCE(42);
      END_STATE();
    case 42:
      if (lookahead == 'l')
        ADVANCE(43);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 44:
      if (lookahead == 'e')
        ADVANCE(45);
      END_STATE();
    case 45:
      if (lookahead == 'a')
        ADVANCE(46);
      END_STATE();
    case 46:
      if (lookahead == 'd')
        ADVANCE(47);
      END_STATE();
    case 47:
      if (lookahead == 'o')
        ADVANCE(48);
      END_STATE();
    case 48:
      if (lookahead == 'n')
        ADVANCE(49);
      END_STATE();
    case 49:
      if (lookahead == 'l')
        ADVANCE(50);
      END_STATE();
    case 50:
      if (lookahead == 'y')
        ADVANCE(51);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 52:
      if (lookahead == 'h')
        ADVANCE(53);
      if (lookahead == 'y')
        ADVANCE(56);
      END_STATE();
    case 53:
      if (lookahead == 'e')
        ADVANCE(54);
      END_STATE();
    case 54:
      if (lookahead == 'n')
        ADVANCE(55);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 56:
      if (lookahead == 'p')
        ADVANCE(57);
      END_STATE();
    case 57:
      if (lookahead == 'e')
        ADVANCE(58);
      END_STATE();
    case 58:
      if (lookahead == 's')
        ADVANCE(59);
      END_STATE();
    case 59:
      if (lookahead == 'e')
        ADVANCE(60);
      END_STATE();
    case 60:
      if (lookahead == 't')
        ADVANCE(61);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_typeset);
      END_STATE();
    case 62:
      if (lookahead == 'n')
        ADVANCE(63);
      END_STATE();
    case 63:
      if (lookahead == 's')
        ADVANCE(64);
      END_STATE();
    case 64:
      if (lookahead == 'e')
        ADVANCE(65);
      END_STATE();
    case 65:
      if (lookahead == 't')
        ADVANCE(66);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_unset);
      if (lookahead == 'e')
        ADVANCE(67);
      END_STATE();
    case 67:
      if (lookahead == 'n')
        ADVANCE(68);
      END_STATE();
    case 68:
      if (lookahead == 'v')
        ADVANCE(69);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_unsetenv);
      END_STATE();
    case 70:
      if (lookahead == 'h')
        ADVANCE(71);
      END_STATE();
    case 71:
      if (lookahead == 'i')
        ADVANCE(72);
      END_STATE();
    case 72:
      if (lookahead == 'l')
        ADVANCE(73);
      END_STATE();
    case 73:
      if (lookahead == 'e')
        ADVANCE(74);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 71, .external_lex_state = 2},
  [2] = {.lex_state = 71},
  [3] = {.lex_state = 78},
  [4] = {.lex_state = 84},
  [5] = {.lex_state = 88},
  [6] = {.lex_state = 71, .external_lex_state = 2},
  [7] = {.lex_state = 71, .external_lex_state = 2},
  [8] = {.lex_state = 94},
  [9] = {.lex_state = 94},
  [10] = {.lex_state = 71, .external_lex_state = 2},
  [11] = {.lex_state = 96, .external_lex_state = 3},
  [12] = {.lex_state = 98, .external_lex_state = 2},
  [13] = {.lex_state = 88},
  [14] = {.lex_state = 88},
  [15] = {.lex_state = 100, .external_lex_state = 4},
  [16] = {.lex_state = 100, .external_lex_state = 5},
  [17] = {.lex_state = 94},
  [18] = {.lex_state = 104, .external_lex_state = 6},
  [19] = {.lex_state = 107},
  [20] = {.lex_state = 114},
  [21] = {.lex_state = 104, .external_lex_state = 6},
  [22] = {.lex_state = 114, .external_lex_state = 7},
  [23] = {.lex_state = 71, .external_lex_state = 2},
  [24] = {.lex_state = 71, .external_lex_state = 2},
  [25] = {.lex_state = 71, .external_lex_state = 2},
  [26] = {.lex_state = 124, .external_lex_state = 6},
  [27] = {.lex_state = 126},
  [28] = {.lex_state = 128, .external_lex_state = 5},
  [29] = {.lex_state = 104, .external_lex_state = 5},
  [30] = {.lex_state = 132, .external_lex_state = 4},
  [31] = {.lex_state = 78},
  [32] = {.lex_state = 134, .external_lex_state = 5},
  [33] = {.lex_state = 71, .external_lex_state = 2},
  [34] = {.lex_state = 94, .external_lex_state = 2},
  [35] = {.lex_state = 94},
  [36] = {.lex_state = 94},
  [37] = {.lex_state = 136, .external_lex_state = 8},
  [38] = {.lex_state = 138, .external_lex_state = 9},
  [39] = {.lex_state = 141, .external_lex_state = 9},
  [40] = {.lex_state = 88},
  [41] = {.lex_state = 88},
  [42] = {.lex_state = 145, .external_lex_state = 10},
  [43] = {.lex_state = 107},
  [44] = {.lex_state = 114},
  [45] = {.lex_state = 145, .external_lex_state = 10},
  [46] = {.lex_state = 114, .external_lex_state = 7},
  [47] = {.lex_state = 71, .external_lex_state = 2},
  [48] = {.lex_state = 71, .external_lex_state = 2},
  [49] = {.lex_state = 71, .external_lex_state = 2},
  [50] = {.lex_state = 145},
  [51] = {.lex_state = 78},
  [52] = {.lex_state = 98, .external_lex_state = 2},
  [53] = {.lex_state = 100, .external_lex_state = 4},
  [54] = {.lex_state = 100, .external_lex_state = 5},
  [55] = {.lex_state = 104, .external_lex_state = 6},
  [56] = {.lex_state = 104, .external_lex_state = 6},
  [57] = {.lex_state = 124, .external_lex_state = 6},
  [58] = {.lex_state = 94},
  [59] = {.lex_state = 128, .external_lex_state = 5},
  [60] = {.lex_state = 104, .external_lex_state = 5},
  [61] = {.lex_state = 132, .external_lex_state = 4},
  [62] = {.lex_state = 78},
  [63] = {.lex_state = 94, .external_lex_state = 2},
  [64] = {.lex_state = 94},
  [65] = {.lex_state = 141, .external_lex_state = 11},
  [66] = {.lex_state = 107},
  [67] = {.lex_state = 114},
  [68] = {.lex_state = 141, .external_lex_state = 11},
  [69] = {.lex_state = 114, .external_lex_state = 7},
  [70] = {.lex_state = 71, .external_lex_state = 2},
  [71] = {.lex_state = 71, .external_lex_state = 2},
  [72] = {.lex_state = 71, .external_lex_state = 2},
  [73] = {.lex_state = 141, .external_lex_state = 9},
  [74] = {.lex_state = 164},
  [75] = {.lex_state = 78},
  [76] = {.lex_state = 98, .external_lex_state = 2},
  [77] = {.lex_state = 167, .external_lex_state = 4},
  [78] = {.lex_state = 167, .external_lex_state = 5},
  [79] = {.lex_state = 134, .external_lex_state = 6},
  [80] = {.lex_state = 134, .external_lex_state = 6},
  [81] = {.lex_state = 169, .external_lex_state = 6},
  [82] = {.lex_state = 171, .external_lex_state = 5},
  [83] = {.lex_state = 134, .external_lex_state = 5},
  [84] = {.lex_state = 173, .external_lex_state = 4},
  [85] = {.lex_state = 78},
  [86] = {.lex_state = 71, .external_lex_state = 2},
  [87] = {.lex_state = 94, .external_lex_state = 2},
  [88] = {.lex_state = 175, .external_lex_state = 5},
  [89] = {.lex_state = 128, .external_lex_state = 5},
  [90] = {.lex_state = 132, .external_lex_state = 4},
  [91] = {.lex_state = 96, .external_lex_state = 3},
  [92] = {.lex_state = 78},
  [93] = {.lex_state = 175, .external_lex_state = 5},
  [94] = {.lex_state = 78},
  [95] = {.lex_state = 88},
  [96] = {.lex_state = 88},
  [97] = {.lex_state = 181, .external_lex_state = 12},
  [98] = {.lex_state = 107},
  [99] = {.lex_state = 114},
  [100] = {.lex_state = 181, .external_lex_state = 12},
  [101] = {.lex_state = 114, .external_lex_state = 7},
  [102] = {.lex_state = 71, .external_lex_state = 2},
  [103] = {.lex_state = 71, .external_lex_state = 2},
  [104] = {.lex_state = 71, .external_lex_state = 2},
  [105] = {.lex_state = 181, .external_lex_state = 13},
  [106] = {.lex_state = 88},
  [107] = {.lex_state = 184, .external_lex_state = 10},
  [108] = {.lex_state = 184, .external_lex_state = 10},
  [109] = {.lex_state = 184},
  [110] = {.lex_state = 78},
  [111] = {.lex_state = 100, .external_lex_state = 14},
  [112] = {.lex_state = 107},
  [113] = {.lex_state = 114},
  [114] = {.lex_state = 100, .external_lex_state = 14},
  [115] = {.lex_state = 114, .external_lex_state = 7},
  [116] = {.lex_state = 71, .external_lex_state = 2},
  [117] = {.lex_state = 71, .external_lex_state = 2},
  [118] = {.lex_state = 71, .external_lex_state = 2},
  [119] = {.lex_state = 78},
  [120] = {.lex_state = 100, .external_lex_state = 4},
  [121] = {.lex_state = 100, .external_lex_state = 6},
  [122] = {.lex_state = 107},
  [123] = {.lex_state = 114},
  [124] = {.lex_state = 100, .external_lex_state = 6},
  [125] = {.lex_state = 114, .external_lex_state = 7},
  [126] = {.lex_state = 71, .external_lex_state = 2},
  [127] = {.lex_state = 71, .external_lex_state = 2},
  [128] = {.lex_state = 71, .external_lex_state = 2},
  [129] = {.lex_state = 100, .external_lex_state = 5},
  [130] = {.lex_state = 94, .external_lex_state = 15},
  [131] = {.lex_state = 107},
  [132] = {.lex_state = 114},
  [133] = {.lex_state = 94, .external_lex_state = 15},
  [134] = {.lex_state = 114, .external_lex_state = 7},
  [135] = {.lex_state = 71, .external_lex_state = 2},
  [136] = {.lex_state = 71, .external_lex_state = 2},
  [137] = {.lex_state = 71, .external_lex_state = 2},
  [138] = {.lex_state = 94, .external_lex_state = 2},
  [139] = {.lex_state = 94},
  [140] = {.lex_state = 104, .external_lex_state = 6},
  [141] = {.lex_state = 134, .external_lex_state = 6},
  [142] = {.lex_state = 187},
  [143] = {.lex_state = 107, .external_lex_state = 10},
  [144] = {.lex_state = 114, .external_lex_state = 7},
  [145] = {.lex_state = 71, .external_lex_state = 2},
  [146] = {.lex_state = 71, .external_lex_state = 2},
  [147] = {.lex_state = 107},
  [148] = {.lex_state = 134, .external_lex_state = 6},
  [149] = {.lex_state = 134, .external_lex_state = 6},
  [150] = {.lex_state = 134, .external_lex_state = 6},
  [151] = {.lex_state = 78},
  [152] = {.lex_state = 193, .external_lex_state = 7},
  [153] = {.lex_state = 195, .external_lex_state = 16},
  [154] = {.lex_state = 195, .external_lex_state = 16},
  [155] = {.lex_state = 171, .external_lex_state = 5},
  [156] = {.lex_state = 173, .external_lex_state = 4},
  [157] = {.lex_state = 71, .external_lex_state = 2},
  [158] = {.lex_state = 98, .external_lex_state = 2},
  [159] = {.lex_state = 100, .external_lex_state = 4},
  [160] = {.lex_state = 100, .external_lex_state = 5},
  [161] = {.lex_state = 199, .external_lex_state = 5},
  [162] = {.lex_state = 104, .external_lex_state = 5},
  [163] = {.lex_state = 132, .external_lex_state = 4},
  [164] = {.lex_state = 71, .external_lex_state = 2},
  [165] = {.lex_state = 94, .external_lex_state = 2},
  [166] = {.lex_state = 171, .external_lex_state = 5},
  [167] = {.lex_state = 173, .external_lex_state = 4},
  [168] = {.lex_state = 71, .external_lex_state = 2},
  [169] = {.lex_state = 78},
  [170] = {.lex_state = 201, .external_lex_state = 9},
  [171] = {.lex_state = 203, .external_lex_state = 17},
  [172] = {.lex_state = 71},
  [173] = {.lex_state = 71, .external_lex_state = 2},
  [174] = {.lex_state = 71, .external_lex_state = 2},
  [175] = {.lex_state = 71, .external_lex_state = 2},
  [176] = {.lex_state = 94},
  [177] = {.lex_state = 71, .external_lex_state = 18},
  [178] = {.lex_state = 94},
  [179] = {.lex_state = 206, .external_lex_state = 9},
  [180] = {.lex_state = 128, .external_lex_state = 5},
  [181] = {.lex_state = 208, .external_lex_state = 19},
  [182] = {.lex_state = 104, .external_lex_state = 6},
  [183] = {.lex_state = 104, .external_lex_state = 6},
  [184] = {.lex_state = 104, .external_lex_state = 5},
  [185] = {.lex_state = 128, .external_lex_state = 5},
  [186] = {.lex_state = 132, .external_lex_state = 4},
  [187] = {.lex_state = 71, .external_lex_state = 2},
  [188] = {.lex_state = 104, .external_lex_state = 5},
  [189] = {.lex_state = 94, .external_lex_state = 2},
  [190] = {.lex_state = 94, .external_lex_state = 15},
  [191] = {.lex_state = 94, .external_lex_state = 15},
  [192] = {.lex_state = 94, .external_lex_state = 2},
  [193] = {.lex_state = 210, .external_lex_state = 12},
  [194] = {.lex_state = 210, .external_lex_state = 12},
  [195] = {.lex_state = 210, .external_lex_state = 12},
  [196] = {.lex_state = 173, .external_lex_state = 4},
  [197] = {.lex_state = 212},
  [198] = {.lex_state = 132, .external_lex_state = 14},
  [199] = {.lex_state = 107},
  [200] = {.lex_state = 114},
  [201] = {.lex_state = 132, .external_lex_state = 14},
  [202] = {.lex_state = 114, .external_lex_state = 7},
  [203] = {.lex_state = 71, .external_lex_state = 2},
  [204] = {.lex_state = 71, .external_lex_state = 2},
  [205] = {.lex_state = 71, .external_lex_state = 2},
  [206] = {.lex_state = 138, .external_lex_state = 9},
  [207] = {.lex_state = 88},
  [208] = {.lex_state = 88},
  [209] = {.lex_state = 214, .external_lex_state = 11},
  [210] = {.lex_state = 107},
  [211] = {.lex_state = 114},
  [212] = {.lex_state = 214, .external_lex_state = 11},
  [213] = {.lex_state = 114, .external_lex_state = 7},
  [214] = {.lex_state = 71, .external_lex_state = 2},
  [215] = {.lex_state = 71, .external_lex_state = 2},
  [216] = {.lex_state = 71, .external_lex_state = 2},
  [217] = {.lex_state = 214, .external_lex_state = 9},
  [218] = {.lex_state = 94},
  [219] = {.lex_state = 94},
  [220] = {.lex_state = 88},
  [221] = {.lex_state = 88},
  [222] = {.lex_state = 217, .external_lex_state = 10},
  [223] = {.lex_state = 107},
  [224] = {.lex_state = 114},
  [225] = {.lex_state = 217, .external_lex_state = 10},
  [226] = {.lex_state = 114, .external_lex_state = 7},
  [227] = {.lex_state = 71, .external_lex_state = 2},
  [228] = {.lex_state = 71, .external_lex_state = 2},
  [229] = {.lex_state = 71, .external_lex_state = 2},
  [230] = {.lex_state = 217},
  [231] = {.lex_state = 145},
  [232] = {.lex_state = 94},
  [233] = {.lex_state = 145, .external_lex_state = 10},
  [234] = {.lex_state = 219, .external_lex_state = 10},
  [235] = {.lex_state = 187},
  [236] = {.lex_state = 107},
  [237] = {.lex_state = 219, .external_lex_state = 10},
  [238] = {.lex_state = 219, .external_lex_state = 10},
  [239] = {.lex_state = 219, .external_lex_state = 10},
  [240] = {.lex_state = 78},
  [241] = {.lex_state = 193, .external_lex_state = 7},
  [242] = {.lex_state = 195, .external_lex_state = 16},
  [243] = {.lex_state = 195, .external_lex_state = 16},
  [244] = {.lex_state = 171, .external_lex_state = 5},
  [245] = {.lex_state = 173, .external_lex_state = 4},
  [246] = {.lex_state = 71, .external_lex_state = 2},
  [247] = {.lex_state = 199, .external_lex_state = 5},
  [248] = {.lex_state = 132, .external_lex_state = 4},
  [249] = {.lex_state = 71, .external_lex_state = 2},
  [250] = {.lex_state = 171, .external_lex_state = 5},
  [251] = {.lex_state = 173, .external_lex_state = 4},
  [252] = {.lex_state = 71, .external_lex_state = 2},
  [253] = {.lex_state = 175, .external_lex_state = 5},
  [254] = {.lex_state = 88},
  [255] = {.lex_state = 88, .external_lex_state = 19},
  [256] = {.lex_state = 219},
  [257] = {.lex_state = 136, .external_lex_state = 8},
  [258] = {.lex_state = 78},
  [259] = {.lex_state = 100, .external_lex_state = 14},
  [260] = {.lex_state = 100, .external_lex_state = 14},
  [261] = {.lex_state = 78},
  [262] = {.lex_state = 100, .external_lex_state = 4},
  [263] = {.lex_state = 100, .external_lex_state = 6},
  [264] = {.lex_state = 100, .external_lex_state = 6},
  [265] = {.lex_state = 100, .external_lex_state = 5},
  [266] = {.lex_state = 104, .external_lex_state = 6},
  [267] = {.lex_state = 71, .external_lex_state = 2},
  [268] = {.lex_state = 175, .external_lex_state = 5},
  [269] = {.lex_state = 71},
  [270] = {.lex_state = 94},
  [271] = {.lex_state = 71, .external_lex_state = 2},
  [272] = {.lex_state = 71, .external_lex_state = 2},
  [273] = {.lex_state = 94},
  [274] = {.lex_state = 94},
  [275] = {.lex_state = 138, .external_lex_state = 9},
  [276] = {.lex_state = 128, .external_lex_state = 5},
  [277] = {.lex_state = 208, .external_lex_state = 19},
  [278] = {.lex_state = 104, .external_lex_state = 6},
  [279] = {.lex_state = 104, .external_lex_state = 6},
  [280] = {.lex_state = 104, .external_lex_state = 5},
  [281] = {.lex_state = 104, .external_lex_state = 5},
  [282] = {.lex_state = 71, .external_lex_state = 2},
  [283] = {.lex_state = 94},
  [284] = {.lex_state = 138, .external_lex_state = 9},
  [285] = {.lex_state = 141},
  [286] = {.lex_state = 141, .external_lex_state = 11},
  [287] = {.lex_state = 141, .external_lex_state = 11},
  [288] = {.lex_state = 187},
  [289] = {.lex_state = 107},
  [290] = {.lex_state = 141, .external_lex_state = 11},
  [291] = {.lex_state = 141, .external_lex_state = 11},
  [292] = {.lex_state = 141, .external_lex_state = 11},
  [293] = {.lex_state = 138, .external_lex_state = 9},
  [294] = {.lex_state = 141},
  [295] = {.lex_state = 78},
  [296] = {.lex_state = 193, .external_lex_state = 7},
  [297] = {.lex_state = 195, .external_lex_state = 16},
  [298] = {.lex_state = 195, .external_lex_state = 16},
  [299] = {.lex_state = 171, .external_lex_state = 5},
  [300] = {.lex_state = 173, .external_lex_state = 4},
  [301] = {.lex_state = 71, .external_lex_state = 2},
  [302] = {.lex_state = 199, .external_lex_state = 5},
  [303] = {.lex_state = 132, .external_lex_state = 4},
  [304] = {.lex_state = 71, .external_lex_state = 2},
  [305] = {.lex_state = 171, .external_lex_state = 5},
  [306] = {.lex_state = 173, .external_lex_state = 4},
  [307] = {.lex_state = 71, .external_lex_state = 2},
  [308] = {.lex_state = 78},
  [309] = {.lex_state = 175, .external_lex_state = 5},
  [310] = {.lex_state = 136, .external_lex_state = 8},
  [311] = {.lex_state = 78},
  [312] = {.lex_state = 167, .external_lex_state = 14},
  [313] = {.lex_state = 167, .external_lex_state = 14},
  [314] = {.lex_state = 78},
  [315] = {.lex_state = 167, .external_lex_state = 4},
  [316] = {.lex_state = 167, .external_lex_state = 6},
  [317] = {.lex_state = 167, .external_lex_state = 6},
  [318] = {.lex_state = 167, .external_lex_state = 5},
  [319] = {.lex_state = 134, .external_lex_state = 6},
  [320] = {.lex_state = 71},
  [321] = {.lex_state = 221, .external_lex_state = 2},
  [322] = {.lex_state = 71, .external_lex_state = 2},
  [323] = {.lex_state = 175, .external_lex_state = 5},
  [324] = {.lex_state = 71, .external_lex_state = 2},
  [325] = {.lex_state = 94},
  [326] = {.lex_state = 94},
  [327] = {.lex_state = 138, .external_lex_state = 9},
  [328] = {.lex_state = 171, .external_lex_state = 5},
  [329] = {.lex_state = 208, .external_lex_state = 19},
  [330] = {.lex_state = 134, .external_lex_state = 6},
  [331] = {.lex_state = 134, .external_lex_state = 6},
  [332] = {.lex_state = 134, .external_lex_state = 5},
  [333] = {.lex_state = 171, .external_lex_state = 5},
  [334] = {.lex_state = 173, .external_lex_state = 4},
  [335] = {.lex_state = 134, .external_lex_state = 5},
  [336] = {.lex_state = 96, .external_lex_state = 3},
  [337] = {.lex_state = 138, .external_lex_state = 9},
  [338] = {.lex_state = 175, .external_lex_state = 5},
  [339] = {.lex_state = 96, .external_lex_state = 3},
  [340] = {.lex_state = 136, .external_lex_state = 8},
  [341] = {.lex_state = 217},
  [342] = {.lex_state = 181, .external_lex_state = 13},
  [343] = {.lex_state = 94},
  [344] = {.lex_state = 181, .external_lex_state = 12},
  [345] = {.lex_state = 181, .external_lex_state = 12},
  [346] = {.lex_state = 187},
  [347] = {.lex_state = 107},
  [348] = {.lex_state = 181, .external_lex_state = 12},
  [349] = {.lex_state = 181, .external_lex_state = 12},
  [350] = {.lex_state = 181, .external_lex_state = 12},
  [351] = {.lex_state = 78},
  [352] = {.lex_state = 193, .external_lex_state = 7},
  [353] = {.lex_state = 195, .external_lex_state = 16},
  [354] = {.lex_state = 195, .external_lex_state = 16},
  [355] = {.lex_state = 171, .external_lex_state = 5},
  [356] = {.lex_state = 173, .external_lex_state = 4},
  [357] = {.lex_state = 71, .external_lex_state = 2},
  [358] = {.lex_state = 199, .external_lex_state = 5},
  [359] = {.lex_state = 132, .external_lex_state = 4},
  [360] = {.lex_state = 71, .external_lex_state = 2},
  [361] = {.lex_state = 171, .external_lex_state = 5},
  [362] = {.lex_state = 173, .external_lex_state = 4},
  [363] = {.lex_state = 71, .external_lex_state = 2},
  [364] = {.lex_state = 88},
  [365] = {.lex_state = 88, .external_lex_state = 19},
  [366] = {.lex_state = 181, .external_lex_state = 13},
  [367] = {.lex_state = 184},
  [368] = {.lex_state = 184, .external_lex_state = 10},
  [369] = {.lex_state = 88},
  [370] = {.lex_state = 88, .external_lex_state = 19},
  [371] = {.lex_state = 136, .external_lex_state = 8},
  [372] = {.lex_state = 94},
  [373] = {.lex_state = 100, .external_lex_state = 14},
  [374] = {.lex_state = 167, .external_lex_state = 14},
  [375] = {.lex_state = 187},
  [376] = {.lex_state = 107},
  [377] = {.lex_state = 167, .external_lex_state = 14},
  [378] = {.lex_state = 167, .external_lex_state = 14},
  [379] = {.lex_state = 167, .external_lex_state = 14},
  [380] = {.lex_state = 78},
  [381] = {.lex_state = 193, .external_lex_state = 7},
  [382] = {.lex_state = 195, .external_lex_state = 16},
  [383] = {.lex_state = 195, .external_lex_state = 16},
  [384] = {.lex_state = 171, .external_lex_state = 5},
  [385] = {.lex_state = 173, .external_lex_state = 4},
  [386] = {.lex_state = 71, .external_lex_state = 2},
  [387] = {.lex_state = 199, .external_lex_state = 5},
  [388] = {.lex_state = 132, .external_lex_state = 4},
  [389] = {.lex_state = 71, .external_lex_state = 2},
  [390] = {.lex_state = 171, .external_lex_state = 5},
  [391] = {.lex_state = 173, .external_lex_state = 4},
  [392] = {.lex_state = 71, .external_lex_state = 2},
  [393] = {.lex_state = 100, .external_lex_state = 4},
  [394] = {.lex_state = 94},
  [395] = {.lex_state = 100, .external_lex_state = 6},
  [396] = {.lex_state = 167, .external_lex_state = 6},
  [397] = {.lex_state = 187},
  [398] = {.lex_state = 107},
  [399] = {.lex_state = 167, .external_lex_state = 6},
  [400] = {.lex_state = 167, .external_lex_state = 6},
  [401] = {.lex_state = 167, .external_lex_state = 6},
  [402] = {.lex_state = 78},
  [403] = {.lex_state = 193, .external_lex_state = 7},
  [404] = {.lex_state = 195, .external_lex_state = 16},
  [405] = {.lex_state = 195, .external_lex_state = 16},
  [406] = {.lex_state = 171, .external_lex_state = 5},
  [407] = {.lex_state = 173, .external_lex_state = 4},
  [408] = {.lex_state = 71, .external_lex_state = 2},
  [409] = {.lex_state = 199, .external_lex_state = 5},
  [410] = {.lex_state = 132, .external_lex_state = 4},
  [411] = {.lex_state = 71, .external_lex_state = 2},
  [412] = {.lex_state = 171, .external_lex_state = 5},
  [413] = {.lex_state = 173, .external_lex_state = 4},
  [414] = {.lex_state = 71, .external_lex_state = 2},
  [415] = {.lex_state = 100, .external_lex_state = 5},
  [416] = {.lex_state = 94},
  [417] = {.lex_state = 94, .external_lex_state = 15},
  [418] = {.lex_state = 94, .external_lex_state = 15},
  [419] = {.lex_state = 187},
  [420] = {.lex_state = 107},
  [421] = {.lex_state = 94, .external_lex_state = 15},
  [422] = {.lex_state = 94, .external_lex_state = 15},
  [423] = {.lex_state = 94, .external_lex_state = 15},
  [424] = {.lex_state = 78},
  [425] = {.lex_state = 193, .external_lex_state = 7},
  [426] = {.lex_state = 195, .external_lex_state = 16},
  [427] = {.lex_state = 195, .external_lex_state = 16},
  [428] = {.lex_state = 171, .external_lex_state = 5},
  [429] = {.lex_state = 173, .external_lex_state = 4},
  [430] = {.lex_state = 71, .external_lex_state = 2},
  [431] = {.lex_state = 199, .external_lex_state = 5},
  [432] = {.lex_state = 132, .external_lex_state = 4},
  [433] = {.lex_state = 71, .external_lex_state = 2},
  [434] = {.lex_state = 171, .external_lex_state = 5},
  [435] = {.lex_state = 173, .external_lex_state = 4},
  [436] = {.lex_state = 71, .external_lex_state = 2},
  [437] = {.lex_state = 134, .external_lex_state = 6},
  [438] = {.lex_state = 104, .external_lex_state = 6},
  [439] = {.lex_state = 107, .external_lex_state = 10},
  [440] = {.lex_state = 134, .external_lex_state = 6},
  [441] = {.lex_state = 107, .external_lex_state = 10},
  [442] = {.lex_state = 107, .external_lex_state = 10},
  [443] = {.lex_state = 107},
  [444] = {.lex_state = 78},
  [445] = {.lex_state = 193, .external_lex_state = 7},
  [446] = {.lex_state = 195, .external_lex_state = 16},
  [447] = {.lex_state = 195, .external_lex_state = 16},
  [448] = {.lex_state = 171, .external_lex_state = 5},
  [449] = {.lex_state = 173, .external_lex_state = 4},
  [450] = {.lex_state = 71, .external_lex_state = 2},
  [451] = {.lex_state = 199, .external_lex_state = 5},
  [452] = {.lex_state = 132, .external_lex_state = 4},
  [453] = {.lex_state = 71, .external_lex_state = 2},
  [454] = {.lex_state = 187},
  [455] = {.lex_state = 107},
  [456] = {.lex_state = 94},
  [457] = {.lex_state = 224, .external_lex_state = 16},
  [458] = {.lex_state = 78},
  [459] = {.lex_state = 195, .external_lex_state = 16},
  [460] = {.lex_state = 195, .external_lex_state = 16},
  [461] = {.lex_state = 134, .external_lex_state = 6},
  [462] = {.lex_state = 226, .external_lex_state = 20},
  [463] = {.lex_state = 107},
  [464] = {.lex_state = 114},
  [465] = {.lex_state = 226, .external_lex_state = 20},
  [466] = {.lex_state = 114, .external_lex_state = 7},
  [467] = {.lex_state = 226, .external_lex_state = 21},
  [468] = {.lex_state = 71, .external_lex_state = 2},
  [469] = {.lex_state = 71, .external_lex_state = 2},
  [470] = {.lex_state = 71, .external_lex_state = 2},
  [471] = {.lex_state = 226, .external_lex_state = 16},
  [472] = {.lex_state = 134, .external_lex_state = 6},
  [473] = {.lex_state = 226, .external_lex_state = 21},
  [474] = {.lex_state = 226, .external_lex_state = 16},
  [475] = {.lex_state = 221, .external_lex_state = 2},
  [476] = {.lex_state = 134, .external_lex_state = 6},
  [477] = {.lex_state = 138, .external_lex_state = 9},
  [478] = {.lex_state = 171, .external_lex_state = 5},
  [479] = {.lex_state = 173, .external_lex_state = 4},
  [480] = {.lex_state = 100, .external_lex_state = 4},
  [481] = {.lex_state = 100, .external_lex_state = 5},
  [482] = {.lex_state = 71},
  [483] = {.lex_state = 71, .external_lex_state = 2},
  [484] = {.lex_state = 71, .external_lex_state = 2},
  [485] = {.lex_state = 71, .external_lex_state = 2},
  [486] = {.lex_state = 94},
  [487] = {.lex_state = 94},
  [488] = {.lex_state = 138, .external_lex_state = 9},
  [489] = {.lex_state = 199, .external_lex_state = 5},
  [490] = {.lex_state = 104, .external_lex_state = 5},
  [491] = {.lex_state = 199, .external_lex_state = 5},
  [492] = {.lex_state = 132, .external_lex_state = 4},
  [493] = {.lex_state = 104, .external_lex_state = 5},
  [494] = {.lex_state = 221, .external_lex_state = 2},
  [495] = {.lex_state = 134, .external_lex_state = 6},
  [496] = {.lex_state = 138, .external_lex_state = 9},
  [497] = {.lex_state = 171, .external_lex_state = 5},
  [498] = {.lex_state = 173, .external_lex_state = 4},
  [499] = {.lex_state = 71},
  [500] = {.lex_state = 201, .external_lex_state = 9},
  [501] = {.lex_state = 114},
  [502] = {.lex_state = 114, .external_lex_state = 7},
  [503] = {.lex_state = 203, .external_lex_state = 17},
  [504] = {.lex_state = 94},
  [505] = {.lex_state = 128, .external_lex_state = 5},
  [506] = {.lex_state = 132, .external_lex_state = 4},
  [507] = {.lex_state = 128, .external_lex_state = 5},
  [508] = {.lex_state = 132, .external_lex_state = 4},
  [509] = {.lex_state = 128, .external_lex_state = 6},
  [510] = {.lex_state = 128, .external_lex_state = 6},
  [511] = {.lex_state = 175, .external_lex_state = 5},
  [512] = {.lex_state = 175, .external_lex_state = 5},
  [513] = {.lex_state = 128, .external_lex_state = 6},
  [514] = {.lex_state = 128, .external_lex_state = 6},
  [515] = {.lex_state = 175, .external_lex_state = 5},
  [516] = {.lex_state = 71, .external_lex_state = 2},
  [517] = {.lex_state = 128, .external_lex_state = 5},
  [518] = {.lex_state = 134, .external_lex_state = 5},
  [519] = {.lex_state = 104, .external_lex_state = 6},
  [520] = {.lex_state = 104, .external_lex_state = 6},
  [521] = {.lex_state = 104, .external_lex_state = 5},
  [522] = {.lex_state = 71, .external_lex_state = 2},
  [523] = {.lex_state = 206, .external_lex_state = 9},
  [524] = {.lex_state = 128, .external_lex_state = 5},
  [525] = {.lex_state = 132, .external_lex_state = 4},
  [526] = {.lex_state = 104, .external_lex_state = 5},
  [527] = {.lex_state = 210, .external_lex_state = 13},
  [528] = {.lex_state = 228, .external_lex_state = 10},
  [529] = {.lex_state = 210, .external_lex_state = 12},
  [530] = {.lex_state = 210, .external_lex_state = 13},
  [531] = {.lex_state = 228, .external_lex_state = 10},
  [532] = {.lex_state = 181, .external_lex_state = 13},
  [533] = {.lex_state = 173, .external_lex_state = 4},
  [534] = {.lex_state = 212, .external_lex_state = 10},
  [535] = {.lex_state = 107},
  [536] = {.lex_state = 114},
  [537] = {.lex_state = 212, .external_lex_state = 10},
  [538] = {.lex_state = 114, .external_lex_state = 7},
  [539] = {.lex_state = 71, .external_lex_state = 2},
  [540] = {.lex_state = 71, .external_lex_state = 2},
  [541] = {.lex_state = 71, .external_lex_state = 2},
  [542] = {.lex_state = 212},
  [543] = {.lex_state = 94},
  [544] = {.lex_state = 132, .external_lex_state = 14},
  [545] = {.lex_state = 173, .external_lex_state = 14},
  [546] = {.lex_state = 187},
  [547] = {.lex_state = 107},
  [548] = {.lex_state = 173, .external_lex_state = 14},
  [549] = {.lex_state = 173, .external_lex_state = 14},
  [550] = {.lex_state = 173, .external_lex_state = 14},
  [551] = {.lex_state = 78},
  [552] = {.lex_state = 193, .external_lex_state = 7},
  [553] = {.lex_state = 195, .external_lex_state = 16},
  [554] = {.lex_state = 195, .external_lex_state = 16},
  [555] = {.lex_state = 171, .external_lex_state = 5},
  [556] = {.lex_state = 173, .external_lex_state = 4},
  [557] = {.lex_state = 71, .external_lex_state = 2},
  [558] = {.lex_state = 199, .external_lex_state = 5},
  [559] = {.lex_state = 132, .external_lex_state = 4},
  [560] = {.lex_state = 71, .external_lex_state = 2},
  [561] = {.lex_state = 171, .external_lex_state = 5},
  [562] = {.lex_state = 173, .external_lex_state = 4},
  [563] = {.lex_state = 71, .external_lex_state = 2},
  [564] = {.lex_state = 230},
  [565] = {.lex_state = 214, .external_lex_state = 9},
  [566] = {.lex_state = 217},
  [567] = {.lex_state = 214, .external_lex_state = 9},
  [568] = {.lex_state = 94},
  [569] = {.lex_state = 214, .external_lex_state = 11},
  [570] = {.lex_state = 214, .external_lex_state = 11},
  [571] = {.lex_state = 187},
  [572] = {.lex_state = 107},
  [573] = {.lex_state = 214, .external_lex_state = 11},
  [574] = {.lex_state = 214, .external_lex_state = 11},
  [575] = {.lex_state = 214, .external_lex_state = 11},
  [576] = {.lex_state = 78},
  [577] = {.lex_state = 193, .external_lex_state = 7},
  [578] = {.lex_state = 195, .external_lex_state = 16},
  [579] = {.lex_state = 195, .external_lex_state = 16},
  [580] = {.lex_state = 171, .external_lex_state = 5},
  [581] = {.lex_state = 173, .external_lex_state = 4},
  [582] = {.lex_state = 71, .external_lex_state = 2},
  [583] = {.lex_state = 199, .external_lex_state = 5},
  [584] = {.lex_state = 132, .external_lex_state = 4},
  [585] = {.lex_state = 71, .external_lex_state = 2},
  [586] = {.lex_state = 171, .external_lex_state = 5},
  [587] = {.lex_state = 173, .external_lex_state = 4},
  [588] = {.lex_state = 71, .external_lex_state = 2},
  [589] = {.lex_state = 138, .external_lex_state = 9},
  [590] = {.lex_state = 88},
  [591] = {.lex_state = 88, .external_lex_state = 19},
  [592] = {.lex_state = 214, .external_lex_state = 9},
  [593] = {.lex_state = 232, .external_lex_state = 11},
  [594] = {.lex_state = 107},
  [595] = {.lex_state = 114},
  [596] = {.lex_state = 232, .external_lex_state = 11},
  [597] = {.lex_state = 114, .external_lex_state = 7},
  [598] = {.lex_state = 71, .external_lex_state = 2},
  [599] = {.lex_state = 71, .external_lex_state = 2},
  [600] = {.lex_state = 71, .external_lex_state = 2},
  [601] = {.lex_state = 232, .external_lex_state = 9},
  [602] = {.lex_state = 175, .external_lex_state = 5},
  [603] = {.lex_state = 217},
  [604] = {.lex_state = 217},
  [605] = {.lex_state = 94},
  [606] = {.lex_state = 217, .external_lex_state = 10},
  [607] = {.lex_state = 234, .external_lex_state = 10},
  [608] = {.lex_state = 187},
  [609] = {.lex_state = 107},
  [610] = {.lex_state = 234, .external_lex_state = 10},
  [611] = {.lex_state = 234, .external_lex_state = 10},
  [612] = {.lex_state = 234, .external_lex_state = 10},
  [613] = {.lex_state = 78},
  [614] = {.lex_state = 193, .external_lex_state = 7},
  [615] = {.lex_state = 195, .external_lex_state = 16},
  [616] = {.lex_state = 195, .external_lex_state = 16},
  [617] = {.lex_state = 171, .external_lex_state = 5},
  [618] = {.lex_state = 173, .external_lex_state = 4},
  [619] = {.lex_state = 71, .external_lex_state = 2},
  [620] = {.lex_state = 199, .external_lex_state = 5},
  [621] = {.lex_state = 132, .external_lex_state = 4},
  [622] = {.lex_state = 71, .external_lex_state = 2},
  [623] = {.lex_state = 171, .external_lex_state = 5},
  [624] = {.lex_state = 173, .external_lex_state = 4},
  [625] = {.lex_state = 71, .external_lex_state = 2},
  [626] = {.lex_state = 219},
  [627] = {.lex_state = 88},
  [628] = {.lex_state = 88, .external_lex_state = 19},
  [629] = {.lex_state = 217},
  [630] = {.lex_state = 219, .external_lex_state = 10},
  [631] = {.lex_state = 145, .external_lex_state = 10},
  [632] = {.lex_state = 219, .external_lex_state = 10},
  [633] = {.lex_state = 187},
  [634] = {.lex_state = 224, .external_lex_state = 16},
  [635] = {.lex_state = 78},
  [636] = {.lex_state = 195, .external_lex_state = 16},
  [637] = {.lex_state = 195, .external_lex_state = 16},
  [638] = {.lex_state = 219, .external_lex_state = 10},
  [639] = {.lex_state = 226, .external_lex_state = 21},
  [640] = {.lex_state = 226, .external_lex_state = 16},
  [641] = {.lex_state = 219, .external_lex_state = 10},
  [642] = {.lex_state = 226, .external_lex_state = 21},
  [643] = {.lex_state = 226, .external_lex_state = 16},
  [644] = {.lex_state = 221, .external_lex_state = 2},
  [645] = {.lex_state = 219, .external_lex_state = 10},
  [646] = {.lex_state = 138, .external_lex_state = 9},
  [647] = {.lex_state = 171, .external_lex_state = 5},
  [648] = {.lex_state = 173, .external_lex_state = 4},
  [649] = {.lex_state = 71, .external_lex_state = 2},
  [650] = {.lex_state = 138, .external_lex_state = 9},
  [651] = {.lex_state = 199, .external_lex_state = 5},
  [652] = {.lex_state = 132, .external_lex_state = 4},
  [653] = {.lex_state = 221, .external_lex_state = 2},
  [654] = {.lex_state = 219, .external_lex_state = 10},
  [655] = {.lex_state = 138, .external_lex_state = 9},
  [656] = {.lex_state = 171, .external_lex_state = 5},
  [657] = {.lex_state = 173, .external_lex_state = 4},
  [658] = {.lex_state = 219},
  [659] = {.lex_state = 219},
  [660] = {.lex_state = 132, .external_lex_state = 14},
  [661] = {.lex_state = 132, .external_lex_state = 14},
  [662] = {.lex_state = 136, .external_lex_state = 8},
  [663] = {.lex_state = 100, .external_lex_state = 14},
  [664] = {.lex_state = 100, .external_lex_state = 4},
  [665] = {.lex_state = 100, .external_lex_state = 6},
  [666] = {.lex_state = 100, .external_lex_state = 5},
  [667] = {.lex_state = 104, .external_lex_state = 6},
  [668] = {.lex_state = 175, .external_lex_state = 5},
  [669] = {.lex_state = 71, .external_lex_state = 2},
  [670] = {.lex_state = 94},
  [671] = {.lex_state = 128, .external_lex_state = 5},
  [672] = {.lex_state = 132, .external_lex_state = 4},
  [673] = {.lex_state = 128, .external_lex_state = 5},
  [674] = {.lex_state = 132, .external_lex_state = 4},
  [675] = {.lex_state = 128, .external_lex_state = 6},
  [676] = {.lex_state = 128, .external_lex_state = 6},
  [677] = {.lex_state = 128, .external_lex_state = 6},
  [678] = {.lex_state = 128, .external_lex_state = 6},
  [679] = {.lex_state = 94},
  [680] = {.lex_state = 128, .external_lex_state = 5},
  [681] = {.lex_state = 104, .external_lex_state = 6},
  [682] = {.lex_state = 104, .external_lex_state = 6},
  [683] = {.lex_state = 104, .external_lex_state = 5},
  [684] = {.lex_state = 104, .external_lex_state = 5},
  [685] = {.lex_state = 175, .external_lex_state = 5},
  [686] = {.lex_state = 71, .external_lex_state = 2},
  [687] = {.lex_state = 71, .external_lex_state = 2},
  [688] = {.lex_state = 94},
  [689] = {.lex_state = 71, .external_lex_state = 2},
  [690] = {.lex_state = 94},
  [691] = {.lex_state = 141, .external_lex_state = 11},
  [692] = {.lex_state = 237},
  [693] = {.lex_state = 138, .external_lex_state = 9},
  [694] = {.lex_state = 141, .external_lex_state = 11},
  [695] = {.lex_state = 141, .external_lex_state = 11},
  [696] = {.lex_state = 187},
  [697] = {.lex_state = 237},
  [698] = {.lex_state = 138, .external_lex_state = 9},
  [699] = {.lex_state = 224, .external_lex_state = 16},
  [700] = {.lex_state = 78},
  [701] = {.lex_state = 195, .external_lex_state = 16},
  [702] = {.lex_state = 195, .external_lex_state = 16},
  [703] = {.lex_state = 141, .external_lex_state = 11},
  [704] = {.lex_state = 226, .external_lex_state = 21},
  [705] = {.lex_state = 226, .external_lex_state = 16},
  [706] = {.lex_state = 141, .external_lex_state = 11},
  [707] = {.lex_state = 226, .external_lex_state = 21},
  [708] = {.lex_state = 226, .external_lex_state = 16},
  [709] = {.lex_state = 221, .external_lex_state = 2},
  [710] = {.lex_state = 141, .external_lex_state = 11},
  [711] = {.lex_state = 138, .external_lex_state = 9},
  [712] = {.lex_state = 171, .external_lex_state = 5},
  [713] = {.lex_state = 173, .external_lex_state = 4},
  [714] = {.lex_state = 71, .external_lex_state = 2},
  [715] = {.lex_state = 138, .external_lex_state = 9},
  [716] = {.lex_state = 199, .external_lex_state = 5},
  [717] = {.lex_state = 132, .external_lex_state = 4},
  [718] = {.lex_state = 221, .external_lex_state = 2},
  [719] = {.lex_state = 141, .external_lex_state = 11},
  [720] = {.lex_state = 138, .external_lex_state = 9},
  [721] = {.lex_state = 171, .external_lex_state = 5},
  [722] = {.lex_state = 173, .external_lex_state = 4},
  [723] = {.lex_state = 71},
  [724] = {.lex_state = 173, .external_lex_state = 14},
  [725] = {.lex_state = 173, .external_lex_state = 14},
  [726] = {.lex_state = 136, .external_lex_state = 8},
  [727] = {.lex_state = 167, .external_lex_state = 14},
  [728] = {.lex_state = 167, .external_lex_state = 4},
  [729] = {.lex_state = 167, .external_lex_state = 6},
  [730] = {.lex_state = 167, .external_lex_state = 5},
  [731] = {.lex_state = 134, .external_lex_state = 6},
  [732] = {.lex_state = 94},
  [733] = {.lex_state = 175, .external_lex_state = 5},
  [734] = {.lex_state = 171, .external_lex_state = 5},
  [735] = {.lex_state = 173, .external_lex_state = 4},
  [736] = {.lex_state = 171, .external_lex_state = 5},
  [737] = {.lex_state = 173, .external_lex_state = 4},
  [738] = {.lex_state = 171, .external_lex_state = 6},
  [739] = {.lex_state = 171, .external_lex_state = 6},
  [740] = {.lex_state = 171, .external_lex_state = 6},
  [741] = {.lex_state = 171, .external_lex_state = 6},
  [742] = {.lex_state = 221, .external_lex_state = 2},
  [743] = {.lex_state = 171, .external_lex_state = 5},
  [744] = {.lex_state = 134, .external_lex_state = 6},
  [745] = {.lex_state = 134, .external_lex_state = 6},
  [746] = {.lex_state = 134, .external_lex_state = 5},
  [747] = {.lex_state = 221, .external_lex_state = 2},
  [748] = {.lex_state = 138, .external_lex_state = 9},
  [749] = {.lex_state = 134, .external_lex_state = 5},
  [750] = {.lex_state = 96, .external_lex_state = 3},
  [751] = {.lex_state = 94, .external_lex_state = 2},
  [752] = {.lex_state = 212},
  [753] = {.lex_state = 94, .external_lex_state = 15},
  [754] = {.lex_state = 94, .external_lex_state = 15},
  [755] = {.lex_state = 181, .external_lex_state = 13},
  [756] = {.lex_state = 181, .external_lex_state = 12},
  [757] = {.lex_state = 181, .external_lex_state = 12},
  [758] = {.lex_state = 181, .external_lex_state = 12},
  [759] = {.lex_state = 187},
  [760] = {.lex_state = 224, .external_lex_state = 16},
  [761] = {.lex_state = 78},
  [762] = {.lex_state = 195, .external_lex_state = 16},
  [763] = {.lex_state = 195, .external_lex_state = 16},
  [764] = {.lex_state = 181, .external_lex_state = 12},
  [765] = {.lex_state = 226, .external_lex_state = 21},
  [766] = {.lex_state = 226, .external_lex_state = 16},
  [767] = {.lex_state = 181, .external_lex_state = 12},
  [768] = {.lex_state = 226, .external_lex_state = 21},
  [769] = {.lex_state = 226, .external_lex_state = 16},
  [770] = {.lex_state = 221, .external_lex_state = 2},
  [771] = {.lex_state = 181, .external_lex_state = 12},
  [772] = {.lex_state = 138, .external_lex_state = 9},
  [773] = {.lex_state = 171, .external_lex_state = 5},
  [774] = {.lex_state = 173, .external_lex_state = 4},
  [775] = {.lex_state = 71, .external_lex_state = 2},
  [776] = {.lex_state = 138, .external_lex_state = 9},
  [777] = {.lex_state = 199, .external_lex_state = 5},
  [778] = {.lex_state = 132, .external_lex_state = 4},
  [779] = {.lex_state = 221, .external_lex_state = 2},
  [780] = {.lex_state = 181, .external_lex_state = 12},
  [781] = {.lex_state = 138, .external_lex_state = 9},
  [782] = {.lex_state = 171, .external_lex_state = 5},
  [783] = {.lex_state = 173, .external_lex_state = 4},
  [784] = {.lex_state = 181, .external_lex_state = 13},
  [785] = {.lex_state = 181, .external_lex_state = 13},
  [786] = {.lex_state = 184, .external_lex_state = 10},
  [787] = {.lex_state = 167, .external_lex_state = 4},
  [788] = {.lex_state = 212},
  [789] = {.lex_state = 100, .external_lex_state = 14},
  [790] = {.lex_state = 100, .external_lex_state = 14},
  [791] = {.lex_state = 167, .external_lex_state = 14},
  [792] = {.lex_state = 100, .external_lex_state = 14},
  [793] = {.lex_state = 167, .external_lex_state = 14},
  [794] = {.lex_state = 187},
  [795] = {.lex_state = 224, .external_lex_state = 16},
  [796] = {.lex_state = 78},
  [797] = {.lex_state = 195, .external_lex_state = 16},
  [798] = {.lex_state = 195, .external_lex_state = 16},
  [799] = {.lex_state = 167, .external_lex_state = 14},
  [800] = {.lex_state = 226, .external_lex_state = 21},
  [801] = {.lex_state = 226, .external_lex_state = 16},
  [802] = {.lex_state = 167, .external_lex_state = 14},
  [803] = {.lex_state = 226, .external_lex_state = 21},
  [804] = {.lex_state = 226, .external_lex_state = 16},
  [805] = {.lex_state = 221, .external_lex_state = 2},
  [806] = {.lex_state = 167, .external_lex_state = 14},
  [807] = {.lex_state = 138, .external_lex_state = 9},
  [808] = {.lex_state = 171, .external_lex_state = 5},
  [809] = {.lex_state = 173, .external_lex_state = 4},
  [810] = {.lex_state = 71, .external_lex_state = 2},
  [811] = {.lex_state = 138, .external_lex_state = 9},
  [812] = {.lex_state = 199, .external_lex_state = 5},
  [813] = {.lex_state = 132, .external_lex_state = 4},
  [814] = {.lex_state = 221, .external_lex_state = 2},
  [815] = {.lex_state = 167, .external_lex_state = 14},
  [816] = {.lex_state = 138, .external_lex_state = 9},
  [817] = {.lex_state = 171, .external_lex_state = 5},
  [818] = {.lex_state = 173, .external_lex_state = 4},
  [819] = {.lex_state = 167, .external_lex_state = 6},
  [820] = {.lex_state = 100, .external_lex_state = 6},
  [821] = {.lex_state = 167, .external_lex_state = 6},
  [822] = {.lex_state = 187},
  [823] = {.lex_state = 224, .external_lex_state = 16},
  [824] = {.lex_state = 78},
  [825] = {.lex_state = 195, .external_lex_state = 16},
  [826] = {.lex_state = 195, .external_lex_state = 16},
  [827] = {.lex_state = 167, .external_lex_state = 6},
  [828] = {.lex_state = 226, .external_lex_state = 21},
  [829] = {.lex_state = 226, .external_lex_state = 16},
  [830] = {.lex_state = 167, .external_lex_state = 6},
  [831] = {.lex_state = 226, .external_lex_state = 21},
  [832] = {.lex_state = 226, .external_lex_state = 16},
  [833] = {.lex_state = 221, .external_lex_state = 2},
  [834] = {.lex_state = 167, .external_lex_state = 6},
  [835] = {.lex_state = 138, .external_lex_state = 9},
  [836] = {.lex_state = 171, .external_lex_state = 5},
  [837] = {.lex_state = 173, .external_lex_state = 4},
  [838] = {.lex_state = 71, .external_lex_state = 2},
  [839] = {.lex_state = 138, .external_lex_state = 9},
  [840] = {.lex_state = 199, .external_lex_state = 5},
  [841] = {.lex_state = 132, .external_lex_state = 4},
  [842] = {.lex_state = 221, .external_lex_state = 2},
  [843] = {.lex_state = 167, .external_lex_state = 6},
  [844] = {.lex_state = 138, .external_lex_state = 9},
  [845] = {.lex_state = 171, .external_lex_state = 5},
  [846] = {.lex_state = 173, .external_lex_state = 4},
  [847] = {.lex_state = 94, .external_lex_state = 15},
  [848] = {.lex_state = 94, .external_lex_state = 15},
  [849] = {.lex_state = 94, .external_lex_state = 15},
  [850] = {.lex_state = 187},
  [851] = {.lex_state = 224, .external_lex_state = 16},
  [852] = {.lex_state = 78},
  [853] = {.lex_state = 195, .external_lex_state = 16},
  [854] = {.lex_state = 195, .external_lex_state = 16},
  [855] = {.lex_state = 94, .external_lex_state = 15},
  [856] = {.lex_state = 226, .external_lex_state = 21},
  [857] = {.lex_state = 226, .external_lex_state = 16},
  [858] = {.lex_state = 94, .external_lex_state = 15},
  [859] = {.lex_state = 226, .external_lex_state = 21},
  [860] = {.lex_state = 226, .external_lex_state = 16},
  [861] = {.lex_state = 221, .external_lex_state = 2},
  [862] = {.lex_state = 94, .external_lex_state = 15},
  [863] = {.lex_state = 138, .external_lex_state = 9},
  [864] = {.lex_state = 171, .external_lex_state = 5},
  [865] = {.lex_state = 173, .external_lex_state = 4},
  [866] = {.lex_state = 71, .external_lex_state = 2},
  [867] = {.lex_state = 138, .external_lex_state = 9},
  [868] = {.lex_state = 199, .external_lex_state = 5},
  [869] = {.lex_state = 132, .external_lex_state = 4},
  [870] = {.lex_state = 221, .external_lex_state = 2},
  [871] = {.lex_state = 94, .external_lex_state = 15},
  [872] = {.lex_state = 138, .external_lex_state = 9},
  [873] = {.lex_state = 171, .external_lex_state = 5},
  [874] = {.lex_state = 173, .external_lex_state = 4},
  [875] = {.lex_state = 107},
  [876] = {.lex_state = 224, .external_lex_state = 16},
  [877] = {.lex_state = 78},
  [878] = {.lex_state = 195, .external_lex_state = 16},
  [879] = {.lex_state = 195, .external_lex_state = 16},
  [880] = {.lex_state = 107, .external_lex_state = 10},
  [881] = {.lex_state = 226, .external_lex_state = 21},
  [882] = {.lex_state = 226, .external_lex_state = 16},
  [883] = {.lex_state = 107, .external_lex_state = 10},
  [884] = {.lex_state = 226, .external_lex_state = 21},
  [885] = {.lex_state = 226, .external_lex_state = 16},
  [886] = {.lex_state = 221, .external_lex_state = 2},
  [887] = {.lex_state = 107, .external_lex_state = 10},
  [888] = {.lex_state = 138, .external_lex_state = 9},
  [889] = {.lex_state = 171, .external_lex_state = 5},
  [890] = {.lex_state = 173, .external_lex_state = 4},
  [891] = {.lex_state = 71, .external_lex_state = 2},
  [892] = {.lex_state = 138, .external_lex_state = 9},
  [893] = {.lex_state = 199, .external_lex_state = 5},
  [894] = {.lex_state = 132, .external_lex_state = 4},
  [895] = {.lex_state = 134, .external_lex_state = 6},
  [896] = {.lex_state = 187},
  [897] = {.lex_state = 210, .external_lex_state = 12},
  [898] = {.lex_state = 210, .external_lex_state = 12},
  [899] = {.lex_state = 210, .external_lex_state = 12},
  [900] = {.lex_state = 134, .external_lex_state = 6},
  [901] = {.lex_state = 96, .external_lex_state = 20},
  [902] = {.lex_state = 107},
  [903] = {.lex_state = 114},
  [904] = {.lex_state = 96, .external_lex_state = 20},
  [905] = {.lex_state = 114, .external_lex_state = 7},
  [906] = {.lex_state = 71, .external_lex_state = 2},
  [907] = {.lex_state = 71, .external_lex_state = 2},
  [908] = {.lex_state = 71, .external_lex_state = 2},
  [909] = {.lex_state = 96, .external_lex_state = 16},
  [910] = {.lex_state = 224, .external_lex_state = 16},
  [911] = {.lex_state = 134, .external_lex_state = 6},
  [912] = {.lex_state = 226, .external_lex_state = 21},
  [913] = {.lex_state = 226, .external_lex_state = 16},
  [914] = {.lex_state = 226, .external_lex_state = 21},
  [915] = {.lex_state = 226, .external_lex_state = 16},
  [916] = {.lex_state = 94},
  [917] = {.lex_state = 226, .external_lex_state = 20},
  [918] = {.lex_state = 226, .external_lex_state = 20},
  [919] = {.lex_state = 187},
  [920] = {.lex_state = 107},
  [921] = {.lex_state = 226, .external_lex_state = 20},
  [922] = {.lex_state = 226, .external_lex_state = 20},
  [923] = {.lex_state = 226, .external_lex_state = 20},
  [924] = {.lex_state = 78},
  [925] = {.lex_state = 193, .external_lex_state = 7},
  [926] = {.lex_state = 195, .external_lex_state = 16},
  [927] = {.lex_state = 195, .external_lex_state = 16},
  [928] = {.lex_state = 226, .external_lex_state = 16},
  [929] = {.lex_state = 134, .external_lex_state = 6},
  [930] = {.lex_state = 226, .external_lex_state = 16},
  [931] = {.lex_state = 171, .external_lex_state = 5},
  [932] = {.lex_state = 173, .external_lex_state = 4},
  [933] = {.lex_state = 71, .external_lex_state = 2},
  [934] = {.lex_state = 199, .external_lex_state = 5},
  [935] = {.lex_state = 132, .external_lex_state = 4},
  [936] = {.lex_state = 71, .external_lex_state = 2},
  [937] = {.lex_state = 171, .external_lex_state = 5},
  [938] = {.lex_state = 173, .external_lex_state = 4},
  [939] = {.lex_state = 71, .external_lex_state = 2},
  [940] = {.lex_state = 226, .external_lex_state = 16},
  [941] = {.lex_state = 226, .external_lex_state = 16},
  [942] = {.lex_state = 134, .external_lex_state = 6},
  [943] = {.lex_state = 221, .external_lex_state = 2},
  [944] = {.lex_state = 221, .external_lex_state = 2},
  [945] = {.lex_state = 138, .external_lex_state = 9},
  [946] = {.lex_state = 94},
  [947] = {.lex_state = 199, .external_lex_state = 5},
  [948] = {.lex_state = 132, .external_lex_state = 4},
  [949] = {.lex_state = 199, .external_lex_state = 5},
  [950] = {.lex_state = 132, .external_lex_state = 4},
  [951] = {.lex_state = 199, .external_lex_state = 6},
  [952] = {.lex_state = 199, .external_lex_state = 6},
  [953] = {.lex_state = 199, .external_lex_state = 6},
  [954] = {.lex_state = 199, .external_lex_state = 6},
  [955] = {.lex_state = 71, .external_lex_state = 2},
  [956] = {.lex_state = 199, .external_lex_state = 5},
  [957] = {.lex_state = 71, .external_lex_state = 2},
  [958] = {.lex_state = 138, .external_lex_state = 9},
  [959] = {.lex_state = 104, .external_lex_state = 5},
  [960] = {.lex_state = 134, .external_lex_state = 6},
  [961] = {.lex_state = 221, .external_lex_state = 2},
  [962] = {.lex_state = 221, .external_lex_state = 2},
  [963] = {.lex_state = 138, .external_lex_state = 9},
  [964] = {.lex_state = 175, .external_lex_state = 5},
  [965] = {.lex_state = 203, .external_lex_state = 17},
  [966] = {.lex_state = 203, .external_lex_state = 17},
  [967] = {.lex_state = 78},
  [968] = {.lex_state = 193, .external_lex_state = 7},
  [969] = {.lex_state = 195, .external_lex_state = 16},
  [970] = {.lex_state = 195, .external_lex_state = 16},
  [971] = {.lex_state = 201, .external_lex_state = 9},
  [972] = {.lex_state = 203, .external_lex_state = 17},
  [973] = {.lex_state = 128, .external_lex_state = 6},
  [974] = {.lex_state = 128, .external_lex_state = 6},
  [975] = {.lex_state = 175, .external_lex_state = 5},
  [976] = {.lex_state = 128, .external_lex_state = 6},
  [977] = {.lex_state = 71, .external_lex_state = 2},
  [978] = {.lex_state = 221, .external_lex_state = 2},
  [979] = {.lex_state = 138, .external_lex_state = 9},
  [980] = {.lex_state = 228, .external_lex_state = 10},
  [981] = {.lex_state = 78},
  [982] = {.lex_state = 210, .external_lex_state = 12},
  [983] = {.lex_state = 228, .external_lex_state = 10},
  [984] = {.lex_state = 78},
  [985] = {.lex_state = 94},
  [986] = {.lex_state = 212, .external_lex_state = 10},
  [987] = {.lex_state = 212, .external_lex_state = 10},
  [988] = {.lex_state = 187},
  [989] = {.lex_state = 107},
  [990] = {.lex_state = 212, .external_lex_state = 10},
  [991] = {.lex_state = 212, .external_lex_state = 10},
  [992] = {.lex_state = 212, .external_lex_state = 10},
  [993] = {.lex_state = 78},
  [994] = {.lex_state = 193, .external_lex_state = 7},
  [995] = {.lex_state = 195, .external_lex_state = 16},
  [996] = {.lex_state = 195, .external_lex_state = 16},
  [997] = {.lex_state = 171, .external_lex_state = 5},
  [998] = {.lex_state = 173, .external_lex_state = 4},
  [999] = {.lex_state = 71, .external_lex_state = 2},
  [1000] = {.lex_state = 199, .external_lex_state = 5},
  [1001] = {.lex_state = 132, .external_lex_state = 4},
  [1002] = {.lex_state = 71, .external_lex_state = 2},
  [1003] = {.lex_state = 171, .external_lex_state = 5},
  [1004] = {.lex_state = 173, .external_lex_state = 4},
  [1005] = {.lex_state = 71, .external_lex_state = 2},
  [1006] = {.lex_state = 173, .external_lex_state = 4},
  [1007] = {.lex_state = 212},
  [1008] = {.lex_state = 173, .external_lex_state = 14},
  [1009] = {.lex_state = 132, .external_lex_state = 14},
  [1010] = {.lex_state = 173, .external_lex_state = 14},
  [1011] = {.lex_state = 187},
  [1012] = {.lex_state = 224, .external_lex_state = 16},
  [1013] = {.lex_state = 78},
  [1014] = {.lex_state = 195, .external_lex_state = 16},
  [1015] = {.lex_state = 195, .external_lex_state = 16},
  [1016] = {.lex_state = 173, .external_lex_state = 14},
  [1017] = {.lex_state = 226, .external_lex_state = 21},
  [1018] = {.lex_state = 226, .external_lex_state = 16},
  [1019] = {.lex_state = 173, .external_lex_state = 14},
  [1020] = {.lex_state = 226, .external_lex_state = 21},
  [1021] = {.lex_state = 226, .external_lex_state = 16},
  [1022] = {.lex_state = 221, .external_lex_state = 2},
  [1023] = {.lex_state = 173, .external_lex_state = 14},
  [1024] = {.lex_state = 138, .external_lex_state = 9},
  [1025] = {.lex_state = 171, .external_lex_state = 5},
  [1026] = {.lex_state = 173, .external_lex_state = 4},
  [1027] = {.lex_state = 71, .external_lex_state = 2},
  [1028] = {.lex_state = 138, .external_lex_state = 9},
  [1029] = {.lex_state = 199, .external_lex_state = 5},
  [1030] = {.lex_state = 132, .external_lex_state = 4},
  [1031] = {.lex_state = 221, .external_lex_state = 2},
  [1032] = {.lex_state = 173, .external_lex_state = 14},
  [1033] = {.lex_state = 138, .external_lex_state = 9},
  [1034] = {.lex_state = 171, .external_lex_state = 5},
  [1035] = {.lex_state = 173, .external_lex_state = 4},
  [1036] = {.lex_state = 164},
  [1037] = {.lex_state = 145},
  [1038] = {.lex_state = 230},
  [1039] = {.lex_state = 214, .external_lex_state = 9},
  [1040] = {.lex_state = 214, .external_lex_state = 11},
  [1041] = {.lex_state = 214, .external_lex_state = 11},
  [1042] = {.lex_state = 214, .external_lex_state = 11},
  [1043] = {.lex_state = 187},
  [1044] = {.lex_state = 224, .external_lex_state = 16},
  [1045] = {.lex_state = 78},
  [1046] = {.lex_state = 195, .external_lex_state = 16},
  [1047] = {.lex_state = 195, .external_lex_state = 16},
  [1048] = {.lex_state = 214, .external_lex_state = 11},
  [1049] = {.lex_state = 226, .external_lex_state = 21},
  [1050] = {.lex_state = 226, .external_lex_state = 16},
  [1051] = {.lex_state = 214, .external_lex_state = 11},
  [1052] = {.lex_state = 226, .external_lex_state = 21},
  [1053] = {.lex_state = 226, .external_lex_state = 16},
  [1054] = {.lex_state = 221, .external_lex_state = 2},
  [1055] = {.lex_state = 214, .external_lex_state = 11},
  [1056] = {.lex_state = 138, .external_lex_state = 9},
  [1057] = {.lex_state = 171, .external_lex_state = 5},
  [1058] = {.lex_state = 173, .external_lex_state = 4},
  [1059] = {.lex_state = 71, .external_lex_state = 2},
  [1060] = {.lex_state = 138, .external_lex_state = 9},
  [1061] = {.lex_state = 199, .external_lex_state = 5},
  [1062] = {.lex_state = 132, .external_lex_state = 4},
  [1063] = {.lex_state = 221, .external_lex_state = 2},
  [1064] = {.lex_state = 214, .external_lex_state = 11},
  [1065] = {.lex_state = 138, .external_lex_state = 9},
  [1066] = {.lex_state = 171, .external_lex_state = 5},
  [1067] = {.lex_state = 173, .external_lex_state = 4},
  [1068] = {.lex_state = 214, .external_lex_state = 9},
  [1069] = {.lex_state = 214, .external_lex_state = 9},
  [1070] = {.lex_state = 214, .external_lex_state = 9},
  [1071] = {.lex_state = 94},
  [1072] = {.lex_state = 232, .external_lex_state = 11},
  [1073] = {.lex_state = 232, .external_lex_state = 11},
  [1074] = {.lex_state = 187},
  [1075] = {.lex_state = 107},
  [1076] = {.lex_state = 232, .external_lex_state = 11},
  [1077] = {.lex_state = 232, .external_lex_state = 11},
  [1078] = {.lex_state = 232, .external_lex_state = 11},
  [1079] = {.lex_state = 78},
  [1080] = {.lex_state = 193, .external_lex_state = 7},
  [1081] = {.lex_state = 195, .external_lex_state = 16},
  [1082] = {.lex_state = 195, .external_lex_state = 16},
  [1083] = {.lex_state = 171, .external_lex_state = 5},
  [1084] = {.lex_state = 173, .external_lex_state = 4},
  [1085] = {.lex_state = 71, .external_lex_state = 2},
  [1086] = {.lex_state = 199, .external_lex_state = 5},
  [1087] = {.lex_state = 132, .external_lex_state = 4},
  [1088] = {.lex_state = 71, .external_lex_state = 2},
  [1089] = {.lex_state = 171, .external_lex_state = 5},
  [1090] = {.lex_state = 173, .external_lex_state = 4},
  [1091] = {.lex_state = 71, .external_lex_state = 2},
  [1092] = {.lex_state = 94},
  [1093] = {.lex_state = 232, .external_lex_state = 9},
  [1094] = {.lex_state = 217},
  [1095] = {.lex_state = 234, .external_lex_state = 10},
  [1096] = {.lex_state = 217, .external_lex_state = 10},
  [1097] = {.lex_state = 234, .external_lex_state = 10},
  [1098] = {.lex_state = 187},
  [1099] = {.lex_state = 224, .external_lex_state = 16},
  [1100] = {.lex_state = 78},
  [1101] = {.lex_state = 195, .external_lex_state = 16},
  [1102] = {.lex_state = 195, .external_lex_state = 16},
  [1103] = {.lex_state = 234, .external_lex_state = 10},
  [1104] = {.lex_state = 226, .external_lex_state = 21},
  [1105] = {.lex_state = 226, .external_lex_state = 16},
  [1106] = {.lex_state = 234, .external_lex_state = 10},
  [1107] = {.lex_state = 226, .external_lex_state = 21},
  [1108] = {.lex_state = 226, .external_lex_state = 16},
  [1109] = {.lex_state = 221, .external_lex_state = 2},
  [1110] = {.lex_state = 234, .external_lex_state = 10},
  [1111] = {.lex_state = 138, .external_lex_state = 9},
  [1112] = {.lex_state = 171, .external_lex_state = 5},
  [1113] = {.lex_state = 173, .external_lex_state = 4},
  [1114] = {.lex_state = 71, .external_lex_state = 2},
  [1115] = {.lex_state = 138, .external_lex_state = 9},
  [1116] = {.lex_state = 199, .external_lex_state = 5},
  [1117] = {.lex_state = 132, .external_lex_state = 4},
  [1118] = {.lex_state = 221, .external_lex_state = 2},
  [1119] = {.lex_state = 234, .external_lex_state = 10},
  [1120] = {.lex_state = 138, .external_lex_state = 9},
  [1121] = {.lex_state = 171, .external_lex_state = 5},
  [1122] = {.lex_state = 173, .external_lex_state = 4},
  [1123] = {.lex_state = 217},
  [1124] = {.lex_state = 217},
  [1125] = {.lex_state = 219, .external_lex_state = 10},
  [1126] = {.lex_state = 219, .external_lex_state = 10},
  [1127] = {.lex_state = 96, .external_lex_state = 20},
  [1128] = {.lex_state = 96, .external_lex_state = 20},
  [1129] = {.lex_state = 96, .external_lex_state = 16},
  [1130] = {.lex_state = 224, .external_lex_state = 16},
  [1131] = {.lex_state = 219, .external_lex_state = 10},
  [1132] = {.lex_state = 226, .external_lex_state = 21},
  [1133] = {.lex_state = 226, .external_lex_state = 16},
  [1134] = {.lex_state = 226, .external_lex_state = 21},
  [1135] = {.lex_state = 226, .external_lex_state = 16},
  [1136] = {.lex_state = 226, .external_lex_state = 16},
  [1137] = {.lex_state = 219, .external_lex_state = 10},
  [1138] = {.lex_state = 226, .external_lex_state = 16},
  [1139] = {.lex_state = 226, .external_lex_state = 16},
  [1140] = {.lex_state = 219, .external_lex_state = 10},
  [1141] = {.lex_state = 221, .external_lex_state = 2},
  [1142] = {.lex_state = 221, .external_lex_state = 2},
  [1143] = {.lex_state = 138, .external_lex_state = 9},
  [1144] = {.lex_state = 71, .external_lex_state = 2},
  [1145] = {.lex_state = 71, .external_lex_state = 2},
  [1146] = {.lex_state = 138, .external_lex_state = 9},
  [1147] = {.lex_state = 219, .external_lex_state = 10},
  [1148] = {.lex_state = 221, .external_lex_state = 2},
  [1149] = {.lex_state = 221, .external_lex_state = 2},
  [1150] = {.lex_state = 138, .external_lex_state = 9},
  [1151] = {.lex_state = 132, .external_lex_state = 14},
  [1152] = {.lex_state = 100, .external_lex_state = 14},
  [1153] = {.lex_state = 100, .external_lex_state = 14},
  [1154] = {.lex_state = 100, .external_lex_state = 14},
  [1155] = {.lex_state = 100, .external_lex_state = 6},
  [1156] = {.lex_state = 175, .external_lex_state = 5},
  [1157] = {.lex_state = 71, .external_lex_state = 2},
  [1158] = {.lex_state = 128, .external_lex_state = 6},
  [1159] = {.lex_state = 128, .external_lex_state = 6},
  [1160] = {.lex_state = 128, .external_lex_state = 6},
  [1161] = {.lex_state = 94},
  [1162] = {.lex_state = 71, .external_lex_state = 2},
  [1163] = {.lex_state = 175, .external_lex_state = 5},
  [1164] = {.lex_state = 94},
  [1165] = {.lex_state = 71, .external_lex_state = 2},
  [1166] = {.lex_state = 94},
  [1167] = {.lex_state = 94},
  [1168] = {.lex_state = 175, .external_lex_state = 5},
  [1169] = {.lex_state = 239, .external_lex_state = 10},
  [1170] = {.lex_state = 239, .external_lex_state = 10},
  [1171] = {.lex_state = 242},
  [1172] = {.lex_state = 239},
  [1173] = {.lex_state = 94},
  [1174] = {.lex_state = 237},
  [1175] = {.lex_state = 141, .external_lex_state = 11},
  [1176] = {.lex_state = 175, .external_lex_state = 5},
  [1177] = {.lex_state = 242},
  [1178] = {.lex_state = 94},
  [1179] = {.lex_state = 237},
  [1180] = {.lex_state = 141, .external_lex_state = 11},
  [1181] = {.lex_state = 96, .external_lex_state = 20},
  [1182] = {.lex_state = 96, .external_lex_state = 20},
  [1183] = {.lex_state = 96, .external_lex_state = 16},
  [1184] = {.lex_state = 224, .external_lex_state = 16},
  [1185] = {.lex_state = 141, .external_lex_state = 11},
  [1186] = {.lex_state = 226, .external_lex_state = 21},
  [1187] = {.lex_state = 226, .external_lex_state = 16},
  [1188] = {.lex_state = 226, .external_lex_state = 21},
  [1189] = {.lex_state = 226, .external_lex_state = 16},
  [1190] = {.lex_state = 226, .external_lex_state = 16},
  [1191] = {.lex_state = 141, .external_lex_state = 11},
  [1192] = {.lex_state = 226, .external_lex_state = 16},
  [1193] = {.lex_state = 226, .external_lex_state = 16},
  [1194] = {.lex_state = 141, .external_lex_state = 11},
  [1195] = {.lex_state = 221, .external_lex_state = 2},
  [1196] = {.lex_state = 221, .external_lex_state = 2},
  [1197] = {.lex_state = 138, .external_lex_state = 9},
  [1198] = {.lex_state = 71, .external_lex_state = 2},
  [1199] = {.lex_state = 71, .external_lex_state = 2},
  [1200] = {.lex_state = 138, .external_lex_state = 9},
  [1201] = {.lex_state = 141, .external_lex_state = 11},
  [1202] = {.lex_state = 221, .external_lex_state = 2},
  [1203] = {.lex_state = 221, .external_lex_state = 2},
  [1204] = {.lex_state = 138, .external_lex_state = 9},
  [1205] = {.lex_state = 175, .external_lex_state = 5},
  [1206] = {.lex_state = 173, .external_lex_state = 14},
  [1207] = {.lex_state = 167, .external_lex_state = 14},
  [1208] = {.lex_state = 167, .external_lex_state = 14},
  [1209] = {.lex_state = 167, .external_lex_state = 14},
  [1210] = {.lex_state = 167, .external_lex_state = 6},
  [1211] = {.lex_state = 171, .external_lex_state = 6},
  [1212] = {.lex_state = 171, .external_lex_state = 6},
  [1213] = {.lex_state = 171, .external_lex_state = 6},
  [1214] = {.lex_state = 175, .external_lex_state = 5},
  [1215] = {.lex_state = 221, .external_lex_state = 2},
  [1216] = {.lex_state = 94, .external_lex_state = 2},
  [1217] = {.lex_state = 212},
  [1218] = {.lex_state = 181, .external_lex_state = 12},
  [1219] = {.lex_state = 181, .external_lex_state = 12},
  [1220] = {.lex_state = 96, .external_lex_state = 20},
  [1221] = {.lex_state = 96, .external_lex_state = 20},
  [1222] = {.lex_state = 96, .external_lex_state = 16},
  [1223] = {.lex_state = 224, .external_lex_state = 16},
  [1224] = {.lex_state = 181, .external_lex_state = 12},
  [1225] = {.lex_state = 226, .external_lex_state = 21},
  [1226] = {.lex_state = 226, .external_lex_state = 16},
  [1227] = {.lex_state = 226, .external_lex_state = 21},
  [1228] = {.lex_state = 226, .external_lex_state = 16},
  [1229] = {.lex_state = 226, .external_lex_state = 16},
  [1230] = {.lex_state = 181, .external_lex_state = 12},
  [1231] = {.lex_state = 226, .external_lex_state = 16},
  [1232] = {.lex_state = 226, .external_lex_state = 16},
  [1233] = {.lex_state = 181, .external_lex_state = 12},
  [1234] = {.lex_state = 221, .external_lex_state = 2},
  [1235] = {.lex_state = 221, .external_lex_state = 2},
  [1236] = {.lex_state = 138, .external_lex_state = 9},
  [1237] = {.lex_state = 71, .external_lex_state = 2},
  [1238] = {.lex_state = 71, .external_lex_state = 2},
  [1239] = {.lex_state = 138, .external_lex_state = 9},
  [1240] = {.lex_state = 181, .external_lex_state = 12},
  [1241] = {.lex_state = 221, .external_lex_state = 2},
  [1242] = {.lex_state = 221, .external_lex_state = 2},
  [1243] = {.lex_state = 138, .external_lex_state = 9},
  [1244] = {.lex_state = 167, .external_lex_state = 4},
  [1245] = {.lex_state = 212},
  [1246] = {.lex_state = 167, .external_lex_state = 14},
  [1247] = {.lex_state = 167, .external_lex_state = 14},
  [1248] = {.lex_state = 96, .external_lex_state = 20},
  [1249] = {.lex_state = 96, .external_lex_state = 20},
  [1250] = {.lex_state = 96, .external_lex_state = 16},
  [1251] = {.lex_state = 224, .external_lex_state = 16},
  [1252] = {.lex_state = 167, .external_lex_state = 14},
  [1253] = {.lex_state = 226, .external_lex_state = 21},
  [1254] = {.lex_state = 226, .external_lex_state = 16},
  [1255] = {.lex_state = 226, .external_lex_state = 21},
  [1256] = {.lex_state = 226, .external_lex_state = 16},
  [1257] = {.lex_state = 226, .external_lex_state = 16},
  [1258] = {.lex_state = 167, .external_lex_state = 14},
  [1259] = {.lex_state = 226, .external_lex_state = 16},
  [1260] = {.lex_state = 226, .external_lex_state = 16},
  [1261] = {.lex_state = 167, .external_lex_state = 14},
  [1262] = {.lex_state = 221, .external_lex_state = 2},
  [1263] = {.lex_state = 221, .external_lex_state = 2},
  [1264] = {.lex_state = 138, .external_lex_state = 9},
  [1265] = {.lex_state = 71, .external_lex_state = 2},
  [1266] = {.lex_state = 71, .external_lex_state = 2},
  [1267] = {.lex_state = 138, .external_lex_state = 9},
  [1268] = {.lex_state = 167, .external_lex_state = 14},
  [1269] = {.lex_state = 221, .external_lex_state = 2},
  [1270] = {.lex_state = 221, .external_lex_state = 2},
  [1271] = {.lex_state = 138, .external_lex_state = 9},
  [1272] = {.lex_state = 167, .external_lex_state = 6},
  [1273] = {.lex_state = 167, .external_lex_state = 6},
  [1274] = {.lex_state = 96, .external_lex_state = 20},
  [1275] = {.lex_state = 96, .external_lex_state = 20},
  [1276] = {.lex_state = 96, .external_lex_state = 16},
  [1277] = {.lex_state = 224, .external_lex_state = 16},
  [1278] = {.lex_state = 167, .external_lex_state = 6},
  [1279] = {.lex_state = 226, .external_lex_state = 21},
  [1280] = {.lex_state = 226, .external_lex_state = 16},
  [1281] = {.lex_state = 226, .external_lex_state = 21},
  [1282] = {.lex_state = 226, .external_lex_state = 16},
  [1283] = {.lex_state = 226, .external_lex_state = 16},
  [1284] = {.lex_state = 167, .external_lex_state = 6},
  [1285] = {.lex_state = 226, .external_lex_state = 16},
  [1286] = {.lex_state = 226, .external_lex_state = 16},
  [1287] = {.lex_state = 167, .external_lex_state = 6},
  [1288] = {.lex_state = 221, .external_lex_state = 2},
  [1289] = {.lex_state = 221, .external_lex_state = 2},
  [1290] = {.lex_state = 138, .external_lex_state = 9},
  [1291] = {.lex_state = 71, .external_lex_state = 2},
  [1292] = {.lex_state = 71, .external_lex_state = 2},
  [1293] = {.lex_state = 138, .external_lex_state = 9},
  [1294] = {.lex_state = 167, .external_lex_state = 6},
  [1295] = {.lex_state = 221, .external_lex_state = 2},
  [1296] = {.lex_state = 221, .external_lex_state = 2},
  [1297] = {.lex_state = 138, .external_lex_state = 9},
  [1298] = {.lex_state = 94, .external_lex_state = 15},
  [1299] = {.lex_state = 94, .external_lex_state = 15},
  [1300] = {.lex_state = 96, .external_lex_state = 20},
  [1301] = {.lex_state = 96, .external_lex_state = 20},
  [1302] = {.lex_state = 96, .external_lex_state = 16},
  [1303] = {.lex_state = 224, .external_lex_state = 16},
  [1304] = {.lex_state = 94, .external_lex_state = 15},
  [1305] = {.lex_state = 226, .external_lex_state = 21},
  [1306] = {.lex_state = 226, .external_lex_state = 16},
  [1307] = {.lex_state = 226, .external_lex_state = 21},
  [1308] = {.lex_state = 226, .external_lex_state = 16},
  [1309] = {.lex_state = 226, .external_lex_state = 16},
  [1310] = {.lex_state = 94, .external_lex_state = 15},
  [1311] = {.lex_state = 226, .external_lex_state = 16},
  [1312] = {.lex_state = 226, .external_lex_state = 16},
  [1313] = {.lex_state = 94, .external_lex_state = 15},
  [1314] = {.lex_state = 221, .external_lex_state = 2},
  [1315] = {.lex_state = 221, .external_lex_state = 2},
  [1316] = {.lex_state = 138, .external_lex_state = 9},
  [1317] = {.lex_state = 71, .external_lex_state = 2},
  [1318] = {.lex_state = 71, .external_lex_state = 2},
  [1319] = {.lex_state = 138, .external_lex_state = 9},
  [1320] = {.lex_state = 94, .external_lex_state = 15},
  [1321] = {.lex_state = 221, .external_lex_state = 2},
  [1322] = {.lex_state = 221, .external_lex_state = 2},
  [1323] = {.lex_state = 138, .external_lex_state = 9},
  [1324] = {.lex_state = 107, .external_lex_state = 10},
  [1325] = {.lex_state = 96, .external_lex_state = 20},
  [1326] = {.lex_state = 96, .external_lex_state = 20},
  [1327] = {.lex_state = 96, .external_lex_state = 16},
  [1328] = {.lex_state = 224, .external_lex_state = 16},
  [1329] = {.lex_state = 107, .external_lex_state = 10},
  [1330] = {.lex_state = 226, .external_lex_state = 21},
  [1331] = {.lex_state = 226, .external_lex_state = 16},
  [1332] = {.lex_state = 226, .external_lex_state = 21},
  [1333] = {.lex_state = 226, .external_lex_state = 16},
  [1334] = {.lex_state = 226, .external_lex_state = 16},
  [1335] = {.lex_state = 107, .external_lex_state = 10},
  [1336] = {.lex_state = 226, .external_lex_state = 16},
  [1337] = {.lex_state = 226, .external_lex_state = 16},
  [1338] = {.lex_state = 107, .external_lex_state = 10},
  [1339] = {.lex_state = 221, .external_lex_state = 2},
  [1340] = {.lex_state = 221, .external_lex_state = 2},
  [1341] = {.lex_state = 138, .external_lex_state = 9},
  [1342] = {.lex_state = 71, .external_lex_state = 2},
  [1343] = {.lex_state = 71, .external_lex_state = 2},
  [1344] = {.lex_state = 138, .external_lex_state = 9},
  [1345] = {.lex_state = 210, .external_lex_state = 13},
  [1346] = {.lex_state = 195, .external_lex_state = 20},
  [1347] = {.lex_state = 210, .external_lex_state = 13},
  [1348] = {.lex_state = 195, .external_lex_state = 20},
  [1349] = {.lex_state = 181, .external_lex_state = 13},
  [1350] = {.lex_state = 94},
  [1351] = {.lex_state = 134, .external_lex_state = 6},
  [1352] = {.lex_state = 96, .external_lex_state = 20},
  [1353] = {.lex_state = 96, .external_lex_state = 20},
  [1354] = {.lex_state = 187},
  [1355] = {.lex_state = 107},
  [1356] = {.lex_state = 96, .external_lex_state = 20},
  [1357] = {.lex_state = 96, .external_lex_state = 20},
  [1358] = {.lex_state = 96, .external_lex_state = 20},
  [1359] = {.lex_state = 134, .external_lex_state = 6},
  [1360] = {.lex_state = 78},
  [1361] = {.lex_state = 193, .external_lex_state = 7},
  [1362] = {.lex_state = 195, .external_lex_state = 16},
  [1363] = {.lex_state = 195, .external_lex_state = 16},
  [1364] = {.lex_state = 171, .external_lex_state = 5},
  [1365] = {.lex_state = 173, .external_lex_state = 4},
  [1366] = {.lex_state = 71, .external_lex_state = 2},
  [1367] = {.lex_state = 199, .external_lex_state = 5},
  [1368] = {.lex_state = 132, .external_lex_state = 4},
  [1369] = {.lex_state = 71, .external_lex_state = 2},
  [1370] = {.lex_state = 171, .external_lex_state = 5},
  [1371] = {.lex_state = 173, .external_lex_state = 4},
  [1372] = {.lex_state = 71, .external_lex_state = 2},
  [1373] = {.lex_state = 96, .external_lex_state = 20},
  [1374] = {.lex_state = 96, .external_lex_state = 20},
  [1375] = {.lex_state = 96, .external_lex_state = 16},
  [1376] = {.lex_state = 226, .external_lex_state = 16},
  [1377] = {.lex_state = 134, .external_lex_state = 6},
  [1378] = {.lex_state = 226, .external_lex_state = 16},
  [1379] = {.lex_state = 226, .external_lex_state = 16},
  [1380] = {.lex_state = 226, .external_lex_state = 16},
  [1381] = {.lex_state = 226, .external_lex_state = 20},
  [1382] = {.lex_state = 226, .external_lex_state = 20},
  [1383] = {.lex_state = 226, .external_lex_state = 20},
  [1384] = {.lex_state = 187},
  [1385] = {.lex_state = 224, .external_lex_state = 16},
  [1386] = {.lex_state = 78},
  [1387] = {.lex_state = 195, .external_lex_state = 16},
  [1388] = {.lex_state = 195, .external_lex_state = 16},
  [1389] = {.lex_state = 226, .external_lex_state = 20},
  [1390] = {.lex_state = 226, .external_lex_state = 21},
  [1391] = {.lex_state = 226, .external_lex_state = 16},
  [1392] = {.lex_state = 226, .external_lex_state = 20},
  [1393] = {.lex_state = 226, .external_lex_state = 21},
  [1394] = {.lex_state = 226, .external_lex_state = 16},
  [1395] = {.lex_state = 134, .external_lex_state = 6},
  [1396] = {.lex_state = 226, .external_lex_state = 16},
  [1397] = {.lex_state = 221, .external_lex_state = 2},
  [1398] = {.lex_state = 226, .external_lex_state = 20},
  [1399] = {.lex_state = 138, .external_lex_state = 9},
  [1400] = {.lex_state = 171, .external_lex_state = 5},
  [1401] = {.lex_state = 173, .external_lex_state = 4},
  [1402] = {.lex_state = 71, .external_lex_state = 2},
  [1403] = {.lex_state = 138, .external_lex_state = 9},
  [1404] = {.lex_state = 199, .external_lex_state = 5},
  [1405] = {.lex_state = 132, .external_lex_state = 4},
  [1406] = {.lex_state = 221, .external_lex_state = 2},
  [1407] = {.lex_state = 226, .external_lex_state = 20},
  [1408] = {.lex_state = 138, .external_lex_state = 9},
  [1409] = {.lex_state = 171, .external_lex_state = 5},
  [1410] = {.lex_state = 173, .external_lex_state = 4},
  [1411] = {.lex_state = 134, .external_lex_state = 6},
  [1412] = {.lex_state = 221, .external_lex_state = 2},
  [1413] = {.lex_state = 199, .external_lex_state = 6},
  [1414] = {.lex_state = 199, .external_lex_state = 6},
  [1415] = {.lex_state = 199, .external_lex_state = 6},
  [1416] = {.lex_state = 71, .external_lex_state = 2},
  [1417] = {.lex_state = 134, .external_lex_state = 6},
  [1418] = {.lex_state = 221, .external_lex_state = 2},
  [1419] = {.lex_state = 224, .external_lex_state = 16},
  [1420] = {.lex_state = 78},
  [1421] = {.lex_state = 195, .external_lex_state = 16},
  [1422] = {.lex_state = 195, .external_lex_state = 16},
  [1423] = {.lex_state = 203, .external_lex_state = 17},
  [1424] = {.lex_state = 226, .external_lex_state = 21},
  [1425] = {.lex_state = 226, .external_lex_state = 16},
  [1426] = {.lex_state = 203, .external_lex_state = 17},
  [1427] = {.lex_state = 226, .external_lex_state = 21},
  [1428] = {.lex_state = 226, .external_lex_state = 16},
  [1429] = {.lex_state = 128, .external_lex_state = 6},
  [1430] = {.lex_state = 221, .external_lex_state = 2},
  [1431] = {.lex_state = 78},
  [1432] = {.lex_state = 78},
  [1433] = {.lex_state = 212, .external_lex_state = 10},
  [1434] = {.lex_state = 212, .external_lex_state = 10},
  [1435] = {.lex_state = 212, .external_lex_state = 10},
  [1436] = {.lex_state = 187},
  [1437] = {.lex_state = 224, .external_lex_state = 16},
  [1438] = {.lex_state = 78},
  [1439] = {.lex_state = 195, .external_lex_state = 16},
  [1440] = {.lex_state = 195, .external_lex_state = 16},
  [1441] = {.lex_state = 212, .external_lex_state = 10},
  [1442] = {.lex_state = 226, .external_lex_state = 21},
  [1443] = {.lex_state = 226, .external_lex_state = 16},
  [1444] = {.lex_state = 212, .external_lex_state = 10},
  [1445] = {.lex_state = 226, .external_lex_state = 21},
  [1446] = {.lex_state = 226, .external_lex_state = 16},
  [1447] = {.lex_state = 221, .external_lex_state = 2},
  [1448] = {.lex_state = 212, .external_lex_state = 10},
  [1449] = {.lex_state = 138, .external_lex_state = 9},
  [1450] = {.lex_state = 171, .external_lex_state = 5},
  [1451] = {.lex_state = 173, .external_lex_state = 4},
  [1452] = {.lex_state = 71, .external_lex_state = 2},
  [1453] = {.lex_state = 138, .external_lex_state = 9},
  [1454] = {.lex_state = 199, .external_lex_state = 5},
  [1455] = {.lex_state = 132, .external_lex_state = 4},
  [1456] = {.lex_state = 221, .external_lex_state = 2},
  [1457] = {.lex_state = 212, .external_lex_state = 10},
  [1458] = {.lex_state = 138, .external_lex_state = 9},
  [1459] = {.lex_state = 171, .external_lex_state = 5},
  [1460] = {.lex_state = 173, .external_lex_state = 4},
  [1461] = {.lex_state = 173, .external_lex_state = 14},
  [1462] = {.lex_state = 173, .external_lex_state = 14},
  [1463] = {.lex_state = 96, .external_lex_state = 20},
  [1464] = {.lex_state = 96, .external_lex_state = 20},
  [1465] = {.lex_state = 96, .external_lex_state = 16},
  [1466] = {.lex_state = 224, .external_lex_state = 16},
  [1467] = {.lex_state = 173, .external_lex_state = 14},
  [1468] = {.lex_state = 226, .external_lex_state = 21},
  [1469] = {.lex_state = 226, .external_lex_state = 16},
  [1470] = {.lex_state = 226, .external_lex_state = 21},
  [1471] = {.lex_state = 226, .external_lex_state = 16},
  [1472] = {.lex_state = 226, .external_lex_state = 16},
  [1473] = {.lex_state = 173, .external_lex_state = 14},
  [1474] = {.lex_state = 226, .external_lex_state = 16},
  [1475] = {.lex_state = 226, .external_lex_state = 16},
  [1476] = {.lex_state = 173, .external_lex_state = 14},
  [1477] = {.lex_state = 221, .external_lex_state = 2},
  [1478] = {.lex_state = 221, .external_lex_state = 2},
  [1479] = {.lex_state = 138, .external_lex_state = 9},
  [1480] = {.lex_state = 71, .external_lex_state = 2},
  [1481] = {.lex_state = 71, .external_lex_state = 2},
  [1482] = {.lex_state = 138, .external_lex_state = 9},
  [1483] = {.lex_state = 173, .external_lex_state = 14},
  [1484] = {.lex_state = 221, .external_lex_state = 2},
  [1485] = {.lex_state = 221, .external_lex_state = 2},
  [1486] = {.lex_state = 138, .external_lex_state = 9},
  [1487] = {.lex_state = 164},
  [1488] = {.lex_state = 175, .external_lex_state = 5},
  [1489] = {.lex_state = 164},
  [1490] = {.lex_state = 145},
  [1491] = {.lex_state = 214, .external_lex_state = 11},
  [1492] = {.lex_state = 214, .external_lex_state = 11},
  [1493] = {.lex_state = 96, .external_lex_state = 20},
  [1494] = {.lex_state = 96, .external_lex_state = 20},
  [1495] = {.lex_state = 96, .external_lex_state = 16},
  [1496] = {.lex_state = 224, .external_lex_state = 16},
  [1497] = {.lex_state = 214, .external_lex_state = 11},
  [1498] = {.lex_state = 226, .external_lex_state = 21},
  [1499] = {.lex_state = 226, .external_lex_state = 16},
  [1500] = {.lex_state = 226, .external_lex_state = 21},
  [1501] = {.lex_state = 226, .external_lex_state = 16},
  [1502] = {.lex_state = 226, .external_lex_state = 16},
  [1503] = {.lex_state = 214, .external_lex_state = 11},
  [1504] = {.lex_state = 226, .external_lex_state = 16},
  [1505] = {.lex_state = 226, .external_lex_state = 16},
  [1506] = {.lex_state = 214, .external_lex_state = 11},
  [1507] = {.lex_state = 221, .external_lex_state = 2},
  [1508] = {.lex_state = 221, .external_lex_state = 2},
  [1509] = {.lex_state = 138, .external_lex_state = 9},
  [1510] = {.lex_state = 71, .external_lex_state = 2},
  [1511] = {.lex_state = 71, .external_lex_state = 2},
  [1512] = {.lex_state = 138, .external_lex_state = 9},
  [1513] = {.lex_state = 214, .external_lex_state = 11},
  [1514] = {.lex_state = 221, .external_lex_state = 2},
  [1515] = {.lex_state = 221, .external_lex_state = 2},
  [1516] = {.lex_state = 138, .external_lex_state = 9},
  [1517] = {.lex_state = 230},
  [1518] = {.lex_state = 232, .external_lex_state = 11},
  [1519] = {.lex_state = 232, .external_lex_state = 11},
  [1520] = {.lex_state = 232, .external_lex_state = 11},
  [1521] = {.lex_state = 187},
  [1522] = {.lex_state = 224, .external_lex_state = 16},
  [1523] = {.lex_state = 78},
  [1524] = {.lex_state = 195, .external_lex_state = 16},
  [1525] = {.lex_state = 195, .external_lex_state = 16},
  [1526] = {.lex_state = 232, .external_lex_state = 11},
  [1527] = {.lex_state = 226, .external_lex_state = 21},
  [1528] = {.lex_state = 226, .external_lex_state = 16},
  [1529] = {.lex_state = 232, .external_lex_state = 11},
  [1530] = {.lex_state = 226, .external_lex_state = 21},
  [1531] = {.lex_state = 226, .external_lex_state = 16},
  [1532] = {.lex_state = 221, .external_lex_state = 2},
  [1533] = {.lex_state = 232, .external_lex_state = 11},
  [1534] = {.lex_state = 138, .external_lex_state = 9},
  [1535] = {.lex_state = 171, .external_lex_state = 5},
  [1536] = {.lex_state = 173, .external_lex_state = 4},
  [1537] = {.lex_state = 71, .external_lex_state = 2},
  [1538] = {.lex_state = 138, .external_lex_state = 9},
  [1539] = {.lex_state = 199, .external_lex_state = 5},
  [1540] = {.lex_state = 132, .external_lex_state = 4},
  [1541] = {.lex_state = 221, .external_lex_state = 2},
  [1542] = {.lex_state = 232, .external_lex_state = 11},
  [1543] = {.lex_state = 138, .external_lex_state = 9},
  [1544] = {.lex_state = 171, .external_lex_state = 5},
  [1545] = {.lex_state = 173, .external_lex_state = 4},
  [1546] = {.lex_state = 175, .external_lex_state = 5},
  [1547] = {.lex_state = 234, .external_lex_state = 10},
  [1548] = {.lex_state = 234, .external_lex_state = 10},
  [1549] = {.lex_state = 96, .external_lex_state = 20},
  [1550] = {.lex_state = 96, .external_lex_state = 20},
  [1551] = {.lex_state = 96, .external_lex_state = 16},
  [1552] = {.lex_state = 224, .external_lex_state = 16},
  [1553] = {.lex_state = 234, .external_lex_state = 10},
  [1554] = {.lex_state = 226, .external_lex_state = 21},
  [1555] = {.lex_state = 226, .external_lex_state = 16},
  [1556] = {.lex_state = 226, .external_lex_state = 21},
  [1557] = {.lex_state = 226, .external_lex_state = 16},
  [1558] = {.lex_state = 226, .external_lex_state = 16},
  [1559] = {.lex_state = 234, .external_lex_state = 10},
  [1560] = {.lex_state = 226, .external_lex_state = 16},
  [1561] = {.lex_state = 226, .external_lex_state = 16},
  [1562] = {.lex_state = 234, .external_lex_state = 10},
  [1563] = {.lex_state = 221, .external_lex_state = 2},
  [1564] = {.lex_state = 221, .external_lex_state = 2},
  [1565] = {.lex_state = 138, .external_lex_state = 9},
  [1566] = {.lex_state = 71, .external_lex_state = 2},
  [1567] = {.lex_state = 71, .external_lex_state = 2},
  [1568] = {.lex_state = 138, .external_lex_state = 9},
  [1569] = {.lex_state = 234, .external_lex_state = 10},
  [1570] = {.lex_state = 221, .external_lex_state = 2},
  [1571] = {.lex_state = 221, .external_lex_state = 2},
  [1572] = {.lex_state = 138, .external_lex_state = 9},
  [1573] = {.lex_state = 219, .external_lex_state = 10},
  [1574] = {.lex_state = 219, .external_lex_state = 10},
  [1575] = {.lex_state = 96, .external_lex_state = 20},
  [1576] = {.lex_state = 96, .external_lex_state = 20},
  [1577] = {.lex_state = 96, .external_lex_state = 16},
  [1578] = {.lex_state = 226, .external_lex_state = 16},
  [1579] = {.lex_state = 219, .external_lex_state = 10},
  [1580] = {.lex_state = 226, .external_lex_state = 16},
  [1581] = {.lex_state = 226, .external_lex_state = 16},
  [1582] = {.lex_state = 226, .external_lex_state = 16},
  [1583] = {.lex_state = 219, .external_lex_state = 10},
  [1584] = {.lex_state = 226, .external_lex_state = 16},
  [1585] = {.lex_state = 219, .external_lex_state = 10},
  [1586] = {.lex_state = 221, .external_lex_state = 2},
  [1587] = {.lex_state = 71, .external_lex_state = 2},
  [1588] = {.lex_state = 219, .external_lex_state = 10},
  [1589] = {.lex_state = 221, .external_lex_state = 2},
  [1590] = {.lex_state = 132, .external_lex_state = 14},
  [1591] = {.lex_state = 128, .external_lex_state = 6},
  [1592] = {.lex_state = 71, .external_lex_state = 2},
  [1593] = {.lex_state = 71, .external_lex_state = 2},
  [1594] = {.lex_state = 175, .external_lex_state = 5},
  [1595] = {.lex_state = 94},
  [1596] = {.lex_state = 94},
  [1597] = {.lex_state = 244, .external_lex_state = 2},
  [1598] = {.lex_state = 239},
  [1599] = {.lex_state = 239, .external_lex_state = 10},
  [1600] = {.lex_state = 244, .external_lex_state = 2},
  [1601] = {.lex_state = 239},
  [1602] = {.lex_state = 175, .external_lex_state = 5},
  [1603] = {.lex_state = 242},
  [1604] = {.lex_state = 94},
  [1605] = {.lex_state = 94},
  [1606] = {.lex_state = 175, .external_lex_state = 5},
  [1607] = {.lex_state = 242},
  [1608] = {.lex_state = 94},
  [1609] = {.lex_state = 141, .external_lex_state = 11},
  [1610] = {.lex_state = 141, .external_lex_state = 11},
  [1611] = {.lex_state = 96, .external_lex_state = 20},
  [1612] = {.lex_state = 96, .external_lex_state = 20},
  [1613] = {.lex_state = 96, .external_lex_state = 16},
  [1614] = {.lex_state = 226, .external_lex_state = 16},
  [1615] = {.lex_state = 141, .external_lex_state = 11},
  [1616] = {.lex_state = 226, .external_lex_state = 16},
  [1617] = {.lex_state = 226, .external_lex_state = 16},
  [1618] = {.lex_state = 226, .external_lex_state = 16},
  [1619] = {.lex_state = 141, .external_lex_state = 11},
  [1620] = {.lex_state = 226, .external_lex_state = 16},
  [1621] = {.lex_state = 141, .external_lex_state = 11},
  [1622] = {.lex_state = 221, .external_lex_state = 2},
  [1623] = {.lex_state = 71, .external_lex_state = 2},
  [1624] = {.lex_state = 141, .external_lex_state = 11},
  [1625] = {.lex_state = 221, .external_lex_state = 2},
  [1626] = {.lex_state = 173, .external_lex_state = 14},
  [1627] = {.lex_state = 171, .external_lex_state = 6},
  [1628] = {.lex_state = 175, .external_lex_state = 5},
  [1629] = {.lex_state = 94, .external_lex_state = 2},
  [1630] = {.lex_state = 181, .external_lex_state = 12},
  [1631] = {.lex_state = 181, .external_lex_state = 12},
  [1632] = {.lex_state = 96, .external_lex_state = 20},
  [1633] = {.lex_state = 96, .external_lex_state = 20},
  [1634] = {.lex_state = 96, .external_lex_state = 16},
  [1635] = {.lex_state = 226, .external_lex_state = 16},
  [1636] = {.lex_state = 181, .external_lex_state = 12},
  [1637] = {.lex_state = 226, .external_lex_state = 16},
  [1638] = {.lex_state = 226, .external_lex_state = 16},
  [1639] = {.lex_state = 226, .external_lex_state = 16},
  [1640] = {.lex_state = 181, .external_lex_state = 12},
  [1641] = {.lex_state = 226, .external_lex_state = 16},
  [1642] = {.lex_state = 181, .external_lex_state = 12},
  [1643] = {.lex_state = 221, .external_lex_state = 2},
  [1644] = {.lex_state = 71, .external_lex_state = 2},
  [1645] = {.lex_state = 181, .external_lex_state = 12},
  [1646] = {.lex_state = 221, .external_lex_state = 2},
  [1647] = {.lex_state = 167, .external_lex_state = 4},
  [1648] = {.lex_state = 167, .external_lex_state = 14},
  [1649] = {.lex_state = 167, .external_lex_state = 14},
  [1650] = {.lex_state = 96, .external_lex_state = 20},
  [1651] = {.lex_state = 96, .external_lex_state = 20},
  [1652] = {.lex_state = 96, .external_lex_state = 16},
  [1653] = {.lex_state = 226, .external_lex_state = 16},
  [1654] = {.lex_state = 167, .external_lex_state = 14},
  [1655] = {.lex_state = 226, .external_lex_state = 16},
  [1656] = {.lex_state = 226, .external_lex_state = 16},
  [1657] = {.lex_state = 226, .external_lex_state = 16},
  [1658] = {.lex_state = 167, .external_lex_state = 14},
  [1659] = {.lex_state = 226, .external_lex_state = 16},
  [1660] = {.lex_state = 167, .external_lex_state = 14},
  [1661] = {.lex_state = 221, .external_lex_state = 2},
  [1662] = {.lex_state = 71, .external_lex_state = 2},
  [1663] = {.lex_state = 167, .external_lex_state = 14},
  [1664] = {.lex_state = 221, .external_lex_state = 2},
  [1665] = {.lex_state = 167, .external_lex_state = 6},
  [1666] = {.lex_state = 167, .external_lex_state = 6},
  [1667] = {.lex_state = 96, .external_lex_state = 20},
  [1668] = {.lex_state = 96, .external_lex_state = 20},
  [1669] = {.lex_state = 96, .external_lex_state = 16},
  [1670] = {.lex_state = 226, .external_lex_state = 16},
  [1671] = {.lex_state = 167, .external_lex_state = 6},
  [1672] = {.lex_state = 226, .external_lex_state = 16},
  [1673] = {.lex_state = 226, .external_lex_state = 16},
  [1674] = {.lex_state = 226, .external_lex_state = 16},
  [1675] = {.lex_state = 167, .external_lex_state = 6},
  [1676] = {.lex_state = 226, .external_lex_state = 16},
  [1677] = {.lex_state = 167, .external_lex_state = 6},
  [1678] = {.lex_state = 221, .external_lex_state = 2},
  [1679] = {.lex_state = 71, .external_lex_state = 2},
  [1680] = {.lex_state = 167, .external_lex_state = 6},
  [1681] = {.lex_state = 221, .external_lex_state = 2},
  [1682] = {.lex_state = 94, .external_lex_state = 15},
  [1683] = {.lex_state = 94, .external_lex_state = 15},
  [1684] = {.lex_state = 96, .external_lex_state = 20},
  [1685] = {.lex_state = 96, .external_lex_state = 20},
  [1686] = {.lex_state = 96, .external_lex_state = 16},
  [1687] = {.lex_state = 226, .external_lex_state = 16},
  [1688] = {.lex_state = 94, .external_lex_state = 15},
  [1689] = {.lex_state = 226, .external_lex_state = 16},
  [1690] = {.lex_state = 226, .external_lex_state = 16},
  [1691] = {.lex_state = 226, .external_lex_state = 16},
  [1692] = {.lex_state = 94, .external_lex_state = 15},
  [1693] = {.lex_state = 226, .external_lex_state = 16},
  [1694] = {.lex_state = 94, .external_lex_state = 15},
  [1695] = {.lex_state = 221, .external_lex_state = 2},
  [1696] = {.lex_state = 71, .external_lex_state = 2},
  [1697] = {.lex_state = 94, .external_lex_state = 15},
  [1698] = {.lex_state = 221, .external_lex_state = 2},
  [1699] = {.lex_state = 107, .external_lex_state = 10},
  [1700] = {.lex_state = 107, .external_lex_state = 10},
  [1701] = {.lex_state = 96, .external_lex_state = 20},
  [1702] = {.lex_state = 96, .external_lex_state = 20},
  [1703] = {.lex_state = 96, .external_lex_state = 16},
  [1704] = {.lex_state = 226, .external_lex_state = 16},
  [1705] = {.lex_state = 107, .external_lex_state = 10},
  [1706] = {.lex_state = 226, .external_lex_state = 16},
  [1707] = {.lex_state = 226, .external_lex_state = 16},
  [1708] = {.lex_state = 226, .external_lex_state = 16},
  [1709] = {.lex_state = 107, .external_lex_state = 10},
  [1710] = {.lex_state = 226, .external_lex_state = 16},
  [1711] = {.lex_state = 107, .external_lex_state = 10},
  [1712] = {.lex_state = 221, .external_lex_state = 2},
  [1713] = {.lex_state = 71, .external_lex_state = 2},
  [1714] = {.lex_state = 195, .external_lex_state = 20},
  [1715] = {.lex_state = 195, .external_lex_state = 16},
  [1716] = {.lex_state = 195, .external_lex_state = 20},
  [1717] = {.lex_state = 195, .external_lex_state = 16},
  [1718] = {.lex_state = 96, .external_lex_state = 20},
  [1719] = {.lex_state = 96, .external_lex_state = 20},
  [1720] = {.lex_state = 96, .external_lex_state = 20},
  [1721] = {.lex_state = 187},
  [1722] = {.lex_state = 224, .external_lex_state = 16},
  [1723] = {.lex_state = 78},
  [1724] = {.lex_state = 195, .external_lex_state = 16},
  [1725] = {.lex_state = 195, .external_lex_state = 16},
  [1726] = {.lex_state = 96, .external_lex_state = 20},
  [1727] = {.lex_state = 226, .external_lex_state = 21},
  [1728] = {.lex_state = 226, .external_lex_state = 16},
  [1729] = {.lex_state = 96, .external_lex_state = 20},
  [1730] = {.lex_state = 226, .external_lex_state = 21},
  [1731] = {.lex_state = 226, .external_lex_state = 16},
  [1732] = {.lex_state = 221, .external_lex_state = 2},
  [1733] = {.lex_state = 96, .external_lex_state = 20},
  [1734] = {.lex_state = 138, .external_lex_state = 9},
  [1735] = {.lex_state = 171, .external_lex_state = 5},
  [1736] = {.lex_state = 173, .external_lex_state = 4},
  [1737] = {.lex_state = 71, .external_lex_state = 2},
  [1738] = {.lex_state = 138, .external_lex_state = 9},
  [1739] = {.lex_state = 199, .external_lex_state = 5},
  [1740] = {.lex_state = 132, .external_lex_state = 4},
  [1741] = {.lex_state = 221, .external_lex_state = 2},
  [1742] = {.lex_state = 96, .external_lex_state = 20},
  [1743] = {.lex_state = 138, .external_lex_state = 9},
  [1744] = {.lex_state = 171, .external_lex_state = 5},
  [1745] = {.lex_state = 173, .external_lex_state = 4},
  [1746] = {.lex_state = 134, .external_lex_state = 6},
  [1747] = {.lex_state = 134, .external_lex_state = 6},
  [1748] = {.lex_state = 134, .external_lex_state = 6},
  [1749] = {.lex_state = 226, .external_lex_state = 16},
  [1750] = {.lex_state = 226, .external_lex_state = 16},
  [1751] = {.lex_state = 226, .external_lex_state = 20},
  [1752] = {.lex_state = 226, .external_lex_state = 20},
  [1753] = {.lex_state = 96, .external_lex_state = 20},
  [1754] = {.lex_state = 96, .external_lex_state = 20},
  [1755] = {.lex_state = 96, .external_lex_state = 16},
  [1756] = {.lex_state = 224, .external_lex_state = 16},
  [1757] = {.lex_state = 226, .external_lex_state = 20},
  [1758] = {.lex_state = 226, .external_lex_state = 21},
  [1759] = {.lex_state = 226, .external_lex_state = 16},
  [1760] = {.lex_state = 226, .external_lex_state = 21},
  [1761] = {.lex_state = 226, .external_lex_state = 16},
  [1762] = {.lex_state = 226, .external_lex_state = 16},
  [1763] = {.lex_state = 226, .external_lex_state = 20},
  [1764] = {.lex_state = 226, .external_lex_state = 16},
  [1765] = {.lex_state = 226, .external_lex_state = 16},
  [1766] = {.lex_state = 134, .external_lex_state = 6},
  [1767] = {.lex_state = 226, .external_lex_state = 20},
  [1768] = {.lex_state = 221, .external_lex_state = 2},
  [1769] = {.lex_state = 221, .external_lex_state = 2},
  [1770] = {.lex_state = 138, .external_lex_state = 9},
  [1771] = {.lex_state = 71, .external_lex_state = 2},
  [1772] = {.lex_state = 71, .external_lex_state = 2},
  [1773] = {.lex_state = 138, .external_lex_state = 9},
  [1774] = {.lex_state = 226, .external_lex_state = 20},
  [1775] = {.lex_state = 221, .external_lex_state = 2},
  [1776] = {.lex_state = 221, .external_lex_state = 2},
  [1777] = {.lex_state = 138, .external_lex_state = 9},
  [1778] = {.lex_state = 134, .external_lex_state = 6},
  [1779] = {.lex_state = 199, .external_lex_state = 6},
  [1780] = {.lex_state = 134, .external_lex_state = 6},
  [1781] = {.lex_state = 203, .external_lex_state = 17},
  [1782] = {.lex_state = 96, .external_lex_state = 20},
  [1783] = {.lex_state = 96, .external_lex_state = 20},
  [1784] = {.lex_state = 96, .external_lex_state = 16},
  [1785] = {.lex_state = 224, .external_lex_state = 16},
  [1786] = {.lex_state = 203, .external_lex_state = 17},
  [1787] = {.lex_state = 226, .external_lex_state = 21},
  [1788] = {.lex_state = 226, .external_lex_state = 16},
  [1789] = {.lex_state = 226, .external_lex_state = 21},
  [1790] = {.lex_state = 226, .external_lex_state = 16},
  [1791] = {.lex_state = 226, .external_lex_state = 16},
  [1792] = {.lex_state = 203, .external_lex_state = 17},
  [1793] = {.lex_state = 226, .external_lex_state = 16},
  [1794] = {.lex_state = 226, .external_lex_state = 16},
  [1795] = {.lex_state = 212, .external_lex_state = 10},
  [1796] = {.lex_state = 212, .external_lex_state = 10},
  [1797] = {.lex_state = 96, .external_lex_state = 20},
  [1798] = {.lex_state = 96, .external_lex_state = 20},
  [1799] = {.lex_state = 96, .external_lex_state = 16},
  [1800] = {.lex_state = 224, .external_lex_state = 16},
  [1801] = {.lex_state = 212, .external_lex_state = 10},
  [1802] = {.lex_state = 226, .external_lex_state = 21},
  [1803] = {.lex_state = 226, .external_lex_state = 16},
  [1804] = {.lex_state = 226, .external_lex_state = 21},
  [1805] = {.lex_state = 226, .external_lex_state = 16},
  [1806] = {.lex_state = 226, .external_lex_state = 16},
  [1807] = {.lex_state = 212, .external_lex_state = 10},
  [1808] = {.lex_state = 226, .external_lex_state = 16},
  [1809] = {.lex_state = 226, .external_lex_state = 16},
  [1810] = {.lex_state = 212, .external_lex_state = 10},
  [1811] = {.lex_state = 221, .external_lex_state = 2},
  [1812] = {.lex_state = 221, .external_lex_state = 2},
  [1813] = {.lex_state = 138, .external_lex_state = 9},
  [1814] = {.lex_state = 71, .external_lex_state = 2},
  [1815] = {.lex_state = 71, .external_lex_state = 2},
  [1816] = {.lex_state = 138, .external_lex_state = 9},
  [1817] = {.lex_state = 212, .external_lex_state = 10},
  [1818] = {.lex_state = 221, .external_lex_state = 2},
  [1819] = {.lex_state = 221, .external_lex_state = 2},
  [1820] = {.lex_state = 138, .external_lex_state = 9},
  [1821] = {.lex_state = 173, .external_lex_state = 14},
  [1822] = {.lex_state = 173, .external_lex_state = 14},
  [1823] = {.lex_state = 96, .external_lex_state = 20},
  [1824] = {.lex_state = 96, .external_lex_state = 20},
  [1825] = {.lex_state = 96, .external_lex_state = 16},
  [1826] = {.lex_state = 226, .external_lex_state = 16},
  [1827] = {.lex_state = 173, .external_lex_state = 14},
  [1828] = {.lex_state = 226, .external_lex_state = 16},
  [1829] = {.lex_state = 226, .external_lex_state = 16},
  [1830] = {.lex_state = 226, .external_lex_state = 16},
  [1831] = {.lex_state = 173, .external_lex_state = 14},
  [1832] = {.lex_state = 226, .external_lex_state = 16},
  [1833] = {.lex_state = 173, .external_lex_state = 14},
  [1834] = {.lex_state = 221, .external_lex_state = 2},
  [1835] = {.lex_state = 71, .external_lex_state = 2},
  [1836] = {.lex_state = 173, .external_lex_state = 14},
  [1837] = {.lex_state = 221, .external_lex_state = 2},
  [1838] = {.lex_state = 175, .external_lex_state = 5},
  [1839] = {.lex_state = 164},
  [1840] = {.lex_state = 164},
  [1841] = {.lex_state = 214, .external_lex_state = 11},
  [1842] = {.lex_state = 214, .external_lex_state = 11},
  [1843] = {.lex_state = 96, .external_lex_state = 20},
  [1844] = {.lex_state = 96, .external_lex_state = 20},
  [1845] = {.lex_state = 96, .external_lex_state = 16},
  [1846] = {.lex_state = 226, .external_lex_state = 16},
  [1847] = {.lex_state = 214, .external_lex_state = 11},
  [1848] = {.lex_state = 226, .external_lex_state = 16},
  [1849] = {.lex_state = 226, .external_lex_state = 16},
  [1850] = {.lex_state = 226, .external_lex_state = 16},
  [1851] = {.lex_state = 214, .external_lex_state = 11},
  [1852] = {.lex_state = 226, .external_lex_state = 16},
  [1853] = {.lex_state = 214, .external_lex_state = 11},
  [1854] = {.lex_state = 221, .external_lex_state = 2},
  [1855] = {.lex_state = 71, .external_lex_state = 2},
  [1856] = {.lex_state = 214, .external_lex_state = 11},
  [1857] = {.lex_state = 221, .external_lex_state = 2},
  [1858] = {.lex_state = 145},
  [1859] = {.lex_state = 232, .external_lex_state = 11},
  [1860] = {.lex_state = 232, .external_lex_state = 11},
  [1861] = {.lex_state = 96, .external_lex_state = 20},
  [1862] = {.lex_state = 96, .external_lex_state = 20},
  [1863] = {.lex_state = 96, .external_lex_state = 16},
  [1864] = {.lex_state = 224, .external_lex_state = 16},
  [1865] = {.lex_state = 232, .external_lex_state = 11},
  [1866] = {.lex_state = 226, .external_lex_state = 21},
  [1867] = {.lex_state = 226, .external_lex_state = 16},
  [1868] = {.lex_state = 226, .external_lex_state = 21},
  [1869] = {.lex_state = 226, .external_lex_state = 16},
  [1870] = {.lex_state = 226, .external_lex_state = 16},
  [1871] = {.lex_state = 232, .external_lex_state = 11},
  [1872] = {.lex_state = 226, .external_lex_state = 16},
  [1873] = {.lex_state = 226, .external_lex_state = 16},
  [1874] = {.lex_state = 232, .external_lex_state = 11},
  [1875] = {.lex_state = 221, .external_lex_state = 2},
  [1876] = {.lex_state = 221, .external_lex_state = 2},
  [1877] = {.lex_state = 138, .external_lex_state = 9},
  [1878] = {.lex_state = 71, .external_lex_state = 2},
  [1879] = {.lex_state = 71, .external_lex_state = 2},
  [1880] = {.lex_state = 138, .external_lex_state = 9},
  [1881] = {.lex_state = 232, .external_lex_state = 11},
  [1882] = {.lex_state = 221, .external_lex_state = 2},
  [1883] = {.lex_state = 221, .external_lex_state = 2},
  [1884] = {.lex_state = 138, .external_lex_state = 9},
  [1885] = {.lex_state = 234, .external_lex_state = 10},
  [1886] = {.lex_state = 234, .external_lex_state = 10},
  [1887] = {.lex_state = 96, .external_lex_state = 20},
  [1888] = {.lex_state = 96, .external_lex_state = 20},
  [1889] = {.lex_state = 96, .external_lex_state = 16},
  [1890] = {.lex_state = 226, .external_lex_state = 16},
  [1891] = {.lex_state = 234, .external_lex_state = 10},
  [1892] = {.lex_state = 226, .external_lex_state = 16},
  [1893] = {.lex_state = 226, .external_lex_state = 16},
  [1894] = {.lex_state = 226, .external_lex_state = 16},
  [1895] = {.lex_state = 234, .external_lex_state = 10},
  [1896] = {.lex_state = 226, .external_lex_state = 16},
  [1897] = {.lex_state = 234, .external_lex_state = 10},
  [1898] = {.lex_state = 221, .external_lex_state = 2},
  [1899] = {.lex_state = 71, .external_lex_state = 2},
  [1900] = {.lex_state = 234, .external_lex_state = 10},
  [1901] = {.lex_state = 221, .external_lex_state = 2},
  [1902] = {.lex_state = 219, .external_lex_state = 10},
  [1903] = {.lex_state = 219, .external_lex_state = 10},
  [1904] = {.lex_state = 219, .external_lex_state = 10},
  [1905] = {.lex_state = 226, .external_lex_state = 16},
  [1906] = {.lex_state = 226, .external_lex_state = 16},
  [1907] = {.lex_state = 219, .external_lex_state = 10},
  [1908] = {.lex_state = 219, .external_lex_state = 10},
  [1909] = {.lex_state = 219, .external_lex_state = 10},
  [1910] = {.lex_state = 71, .external_lex_state = 2},
  [1911] = {.lex_state = 175, .external_lex_state = 5},
  [1912] = {.lex_state = 239, .external_lex_state = 10},
  [1913] = {.lex_state = 239, .external_lex_state = 10},
  [1914] = {.lex_state = 239},
  [1915] = {.lex_state = 78},
  [1916] = {.lex_state = 237},
  [1917] = {.lex_state = 98, .external_lex_state = 2},
  [1918] = {.lex_state = 246, .external_lex_state = 4},
  [1919] = {.lex_state = 246, .external_lex_state = 5},
  [1920] = {.lex_state = 252, .external_lex_state = 6},
  [1921] = {.lex_state = 107},
  [1922] = {.lex_state = 114},
  [1923] = {.lex_state = 252, .external_lex_state = 6},
  [1924] = {.lex_state = 114, .external_lex_state = 7},
  [1925] = {.lex_state = 71, .external_lex_state = 2},
  [1926] = {.lex_state = 71, .external_lex_state = 2},
  [1927] = {.lex_state = 71, .external_lex_state = 2},
  [1928] = {.lex_state = 254, .external_lex_state = 6},
  [1929] = {.lex_state = 242, .external_lex_state = 5},
  [1930] = {.lex_state = 252, .external_lex_state = 5},
  [1931] = {.lex_state = 256, .external_lex_state = 4},
  [1932] = {.lex_state = 78},
  [1933] = {.lex_state = 252, .external_lex_state = 5},
  [1934] = {.lex_state = 244, .external_lex_state = 2},
  [1935] = {.lex_state = 94, .external_lex_state = 2},
  [1936] = {.lex_state = 244, .external_lex_state = 2},
  [1937] = {.lex_state = 239},
  [1938] = {.lex_state = 239, .external_lex_state = 10},
  [1939] = {.lex_state = 237},
  [1940] = {.lex_state = 242, .external_lex_state = 5},
  [1941] = {.lex_state = 256, .external_lex_state = 4},
  [1942] = {.lex_state = 244, .external_lex_state = 2},
  [1943] = {.lex_state = 244, .external_lex_state = 2},
  [1944] = {.lex_state = 175, .external_lex_state = 5},
  [1945] = {.lex_state = 239, .external_lex_state = 10},
  [1946] = {.lex_state = 239, .external_lex_state = 10},
  [1947] = {.lex_state = 239},
  [1948] = {.lex_state = 242},
  [1949] = {.lex_state = 175, .external_lex_state = 5},
  [1950] = {.lex_state = 242},
  [1951] = {.lex_state = 141, .external_lex_state = 11},
  [1952] = {.lex_state = 141, .external_lex_state = 11},
  [1953] = {.lex_state = 141, .external_lex_state = 11},
  [1954] = {.lex_state = 226, .external_lex_state = 16},
  [1955] = {.lex_state = 226, .external_lex_state = 16},
  [1956] = {.lex_state = 141, .external_lex_state = 11},
  [1957] = {.lex_state = 141, .external_lex_state = 11},
  [1958] = {.lex_state = 141, .external_lex_state = 11},
  [1959] = {.lex_state = 181, .external_lex_state = 12},
  [1960] = {.lex_state = 181, .external_lex_state = 12},
  [1961] = {.lex_state = 181, .external_lex_state = 12},
  [1962] = {.lex_state = 226, .external_lex_state = 16},
  [1963] = {.lex_state = 226, .external_lex_state = 16},
  [1964] = {.lex_state = 181, .external_lex_state = 12},
  [1965] = {.lex_state = 181, .external_lex_state = 12},
  [1966] = {.lex_state = 181, .external_lex_state = 12},
  [1967] = {.lex_state = 167, .external_lex_state = 14},
  [1968] = {.lex_state = 167, .external_lex_state = 14},
  [1969] = {.lex_state = 167, .external_lex_state = 14},
  [1970] = {.lex_state = 226, .external_lex_state = 16},
  [1971] = {.lex_state = 226, .external_lex_state = 16},
  [1972] = {.lex_state = 167, .external_lex_state = 14},
  [1973] = {.lex_state = 167, .external_lex_state = 14},
  [1974] = {.lex_state = 167, .external_lex_state = 14},
  [1975] = {.lex_state = 167, .external_lex_state = 6},
  [1976] = {.lex_state = 167, .external_lex_state = 6},
  [1977] = {.lex_state = 167, .external_lex_state = 6},
  [1978] = {.lex_state = 226, .external_lex_state = 16},
  [1979] = {.lex_state = 226, .external_lex_state = 16},
  [1980] = {.lex_state = 167, .external_lex_state = 6},
  [1981] = {.lex_state = 167, .external_lex_state = 6},
  [1982] = {.lex_state = 167, .external_lex_state = 6},
  [1983] = {.lex_state = 94, .external_lex_state = 15},
  [1984] = {.lex_state = 94, .external_lex_state = 15},
  [1985] = {.lex_state = 94, .external_lex_state = 15},
  [1986] = {.lex_state = 226, .external_lex_state = 16},
  [1987] = {.lex_state = 226, .external_lex_state = 16},
  [1988] = {.lex_state = 94, .external_lex_state = 15},
  [1989] = {.lex_state = 94, .external_lex_state = 15},
  [1990] = {.lex_state = 94, .external_lex_state = 15},
  [1991] = {.lex_state = 107, .external_lex_state = 10},
  [1992] = {.lex_state = 107, .external_lex_state = 10},
  [1993] = {.lex_state = 107, .external_lex_state = 10},
  [1994] = {.lex_state = 226, .external_lex_state = 16},
  [1995] = {.lex_state = 226, .external_lex_state = 16},
  [1996] = {.lex_state = 107, .external_lex_state = 10},
  [1997] = {.lex_state = 107, .external_lex_state = 10},
  [1998] = {.lex_state = 195, .external_lex_state = 16},
  [1999] = {.lex_state = 195, .external_lex_state = 16},
  [2000] = {.lex_state = 96, .external_lex_state = 20},
  [2001] = {.lex_state = 96, .external_lex_state = 20},
  [2002] = {.lex_state = 96, .external_lex_state = 20},
  [2003] = {.lex_state = 96, .external_lex_state = 20},
  [2004] = {.lex_state = 96, .external_lex_state = 16},
  [2005] = {.lex_state = 224, .external_lex_state = 16},
  [2006] = {.lex_state = 96, .external_lex_state = 20},
  [2007] = {.lex_state = 226, .external_lex_state = 21},
  [2008] = {.lex_state = 226, .external_lex_state = 16},
  [2009] = {.lex_state = 226, .external_lex_state = 21},
  [2010] = {.lex_state = 226, .external_lex_state = 16},
  [2011] = {.lex_state = 226, .external_lex_state = 16},
  [2012] = {.lex_state = 96, .external_lex_state = 20},
  [2013] = {.lex_state = 226, .external_lex_state = 16},
  [2014] = {.lex_state = 226, .external_lex_state = 16},
  [2015] = {.lex_state = 96, .external_lex_state = 20},
  [2016] = {.lex_state = 221, .external_lex_state = 2},
  [2017] = {.lex_state = 221, .external_lex_state = 2},
  [2018] = {.lex_state = 138, .external_lex_state = 9},
  [2019] = {.lex_state = 71, .external_lex_state = 2},
  [2020] = {.lex_state = 71, .external_lex_state = 2},
  [2021] = {.lex_state = 138, .external_lex_state = 9},
  [2022] = {.lex_state = 96, .external_lex_state = 20},
  [2023] = {.lex_state = 221, .external_lex_state = 2},
  [2024] = {.lex_state = 221, .external_lex_state = 2},
  [2025] = {.lex_state = 138, .external_lex_state = 9},
  [2026] = {.lex_state = 134, .external_lex_state = 6},
  [2027] = {.lex_state = 134, .external_lex_state = 6},
  [2028] = {.lex_state = 226, .external_lex_state = 20},
  [2029] = {.lex_state = 226, .external_lex_state = 20},
  [2030] = {.lex_state = 96, .external_lex_state = 20},
  [2031] = {.lex_state = 96, .external_lex_state = 20},
  [2032] = {.lex_state = 96, .external_lex_state = 16},
  [2033] = {.lex_state = 226, .external_lex_state = 16},
  [2034] = {.lex_state = 226, .external_lex_state = 20},
  [2035] = {.lex_state = 226, .external_lex_state = 16},
  [2036] = {.lex_state = 226, .external_lex_state = 16},
  [2037] = {.lex_state = 226, .external_lex_state = 16},
  [2038] = {.lex_state = 226, .external_lex_state = 20},
  [2039] = {.lex_state = 226, .external_lex_state = 16},
  [2040] = {.lex_state = 226, .external_lex_state = 20},
  [2041] = {.lex_state = 221, .external_lex_state = 2},
  [2042] = {.lex_state = 71, .external_lex_state = 2},
  [2043] = {.lex_state = 226, .external_lex_state = 20},
  [2044] = {.lex_state = 221, .external_lex_state = 2},
  [2045] = {.lex_state = 203, .external_lex_state = 17},
  [2046] = {.lex_state = 203, .external_lex_state = 17},
  [2047] = {.lex_state = 96, .external_lex_state = 20},
  [2048] = {.lex_state = 96, .external_lex_state = 20},
  [2049] = {.lex_state = 96, .external_lex_state = 16},
  [2050] = {.lex_state = 226, .external_lex_state = 16},
  [2051] = {.lex_state = 203, .external_lex_state = 17},
  [2052] = {.lex_state = 226, .external_lex_state = 16},
  [2053] = {.lex_state = 226, .external_lex_state = 16},
  [2054] = {.lex_state = 226, .external_lex_state = 16},
  [2055] = {.lex_state = 203, .external_lex_state = 17},
  [2056] = {.lex_state = 226, .external_lex_state = 16},
  [2057] = {.lex_state = 212, .external_lex_state = 10},
  [2058] = {.lex_state = 212, .external_lex_state = 10},
  [2059] = {.lex_state = 96, .external_lex_state = 20},
  [2060] = {.lex_state = 96, .external_lex_state = 20},
  [2061] = {.lex_state = 96, .external_lex_state = 16},
  [2062] = {.lex_state = 226, .external_lex_state = 16},
  [2063] = {.lex_state = 212, .external_lex_state = 10},
  [2064] = {.lex_state = 226, .external_lex_state = 16},
  [2065] = {.lex_state = 226, .external_lex_state = 16},
  [2066] = {.lex_state = 226, .external_lex_state = 16},
  [2067] = {.lex_state = 212, .external_lex_state = 10},
  [2068] = {.lex_state = 226, .external_lex_state = 16},
  [2069] = {.lex_state = 212, .external_lex_state = 10},
  [2070] = {.lex_state = 221, .external_lex_state = 2},
  [2071] = {.lex_state = 71, .external_lex_state = 2},
  [2072] = {.lex_state = 212, .external_lex_state = 10},
  [2073] = {.lex_state = 221, .external_lex_state = 2},
  [2074] = {.lex_state = 173, .external_lex_state = 14},
  [2075] = {.lex_state = 173, .external_lex_state = 14},
  [2076] = {.lex_state = 173, .external_lex_state = 14},
  [2077] = {.lex_state = 226, .external_lex_state = 16},
  [2078] = {.lex_state = 226, .external_lex_state = 16},
  [2079] = {.lex_state = 173, .external_lex_state = 14},
  [2080] = {.lex_state = 173, .external_lex_state = 14},
  [2081] = {.lex_state = 173, .external_lex_state = 14},
  [2082] = {.lex_state = 175, .external_lex_state = 5},
  [2083] = {.lex_state = 164},
  [2084] = {.lex_state = 214, .external_lex_state = 11},
  [2085] = {.lex_state = 214, .external_lex_state = 11},
  [2086] = {.lex_state = 214, .external_lex_state = 11},
  [2087] = {.lex_state = 226, .external_lex_state = 16},
  [2088] = {.lex_state = 226, .external_lex_state = 16},
  [2089] = {.lex_state = 214, .external_lex_state = 11},
  [2090] = {.lex_state = 214, .external_lex_state = 11},
  [2091] = {.lex_state = 214, .external_lex_state = 11},
  [2092] = {.lex_state = 164},
  [2093] = {.lex_state = 232, .external_lex_state = 11},
  [2094] = {.lex_state = 232, .external_lex_state = 11},
  [2095] = {.lex_state = 96, .external_lex_state = 20},
  [2096] = {.lex_state = 96, .external_lex_state = 20},
  [2097] = {.lex_state = 96, .external_lex_state = 16},
  [2098] = {.lex_state = 226, .external_lex_state = 16},
  [2099] = {.lex_state = 232, .external_lex_state = 11},
  [2100] = {.lex_state = 226, .external_lex_state = 16},
  [2101] = {.lex_state = 226, .external_lex_state = 16},
  [2102] = {.lex_state = 226, .external_lex_state = 16},
  [2103] = {.lex_state = 232, .external_lex_state = 11},
  [2104] = {.lex_state = 226, .external_lex_state = 16},
  [2105] = {.lex_state = 232, .external_lex_state = 11},
  [2106] = {.lex_state = 221, .external_lex_state = 2},
  [2107] = {.lex_state = 71, .external_lex_state = 2},
  [2108] = {.lex_state = 232, .external_lex_state = 11},
  [2109] = {.lex_state = 221, .external_lex_state = 2},
  [2110] = {.lex_state = 234, .external_lex_state = 10},
  [2111] = {.lex_state = 234, .external_lex_state = 10},
  [2112] = {.lex_state = 234, .external_lex_state = 10},
  [2113] = {.lex_state = 226, .external_lex_state = 16},
  [2114] = {.lex_state = 226, .external_lex_state = 16},
  [2115] = {.lex_state = 234, .external_lex_state = 10},
  [2116] = {.lex_state = 234, .external_lex_state = 10},
  [2117] = {.lex_state = 234, .external_lex_state = 10},
  [2118] = {.lex_state = 219, .external_lex_state = 10},
  [2119] = {.lex_state = 219, .external_lex_state = 10},
  [2120] = {.lex_state = 136, .external_lex_state = 8},
  [2121] = {.lex_state = 78},
  [2122] = {.lex_state = 246, .external_lex_state = 14},
  [2123] = {.lex_state = 107},
  [2124] = {.lex_state = 114},
  [2125] = {.lex_state = 246, .external_lex_state = 14},
  [2126] = {.lex_state = 114, .external_lex_state = 7},
  [2127] = {.lex_state = 71, .external_lex_state = 2},
  [2128] = {.lex_state = 71, .external_lex_state = 2},
  [2129] = {.lex_state = 71, .external_lex_state = 2},
  [2130] = {.lex_state = 78},
  [2131] = {.lex_state = 246, .external_lex_state = 4},
  [2132] = {.lex_state = 246, .external_lex_state = 6},
  [2133] = {.lex_state = 107},
  [2134] = {.lex_state = 114},
  [2135] = {.lex_state = 246, .external_lex_state = 6},
  [2136] = {.lex_state = 114, .external_lex_state = 7},
  [2137] = {.lex_state = 71, .external_lex_state = 2},
  [2138] = {.lex_state = 71, .external_lex_state = 2},
  [2139] = {.lex_state = 71, .external_lex_state = 2},
  [2140] = {.lex_state = 246, .external_lex_state = 5},
  [2141] = {.lex_state = 94},
  [2142] = {.lex_state = 252, .external_lex_state = 6},
  [2143] = {.lex_state = 252, .external_lex_state = 6},
  [2144] = {.lex_state = 187},
  [2145] = {.lex_state = 107},
  [2146] = {.lex_state = 252, .external_lex_state = 6},
  [2147] = {.lex_state = 252, .external_lex_state = 6},
  [2148] = {.lex_state = 252, .external_lex_state = 6},
  [2149] = {.lex_state = 78},
  [2150] = {.lex_state = 193, .external_lex_state = 7},
  [2151] = {.lex_state = 195, .external_lex_state = 16},
  [2152] = {.lex_state = 195, .external_lex_state = 16},
  [2153] = {.lex_state = 171, .external_lex_state = 5},
  [2154] = {.lex_state = 173, .external_lex_state = 4},
  [2155] = {.lex_state = 71, .external_lex_state = 2},
  [2156] = {.lex_state = 199, .external_lex_state = 5},
  [2157] = {.lex_state = 132, .external_lex_state = 4},
  [2158] = {.lex_state = 71, .external_lex_state = 2},
  [2159] = {.lex_state = 171, .external_lex_state = 5},
  [2160] = {.lex_state = 173, .external_lex_state = 4},
  [2161] = {.lex_state = 71, .external_lex_state = 2},
  [2162] = {.lex_state = 71},
  [2163] = {.lex_state = 244, .external_lex_state = 2},
  [2164] = {.lex_state = 71, .external_lex_state = 2},
  [2165] = {.lex_state = 244, .external_lex_state = 2},
  [2166] = {.lex_state = 71, .external_lex_state = 2},
  [2167] = {.lex_state = 94},
  [2168] = {.lex_state = 94},
  [2169] = {.lex_state = 138, .external_lex_state = 9},
  [2170] = {.lex_state = 242, .external_lex_state = 5},
  [2171] = {.lex_state = 208, .external_lex_state = 19},
  [2172] = {.lex_state = 252, .external_lex_state = 6},
  [2173] = {.lex_state = 252, .external_lex_state = 6},
  [2174] = {.lex_state = 252, .external_lex_state = 5},
  [2175] = {.lex_state = 237},
  [2176] = {.lex_state = 242, .external_lex_state = 5},
  [2177] = {.lex_state = 256, .external_lex_state = 4},
  [2178] = {.lex_state = 244, .external_lex_state = 2},
  [2179] = {.lex_state = 252, .external_lex_state = 5},
  [2180] = {.lex_state = 244, .external_lex_state = 2},
  [2181] = {.lex_state = 244, .external_lex_state = 2},
  [2182] = {.lex_state = 237},
  [2183] = {.lex_state = 242, .external_lex_state = 5},
  [2184] = {.lex_state = 256, .external_lex_state = 4},
  [2185] = {.lex_state = 244, .external_lex_state = 2},
  [2186] = {.lex_state = 221, .external_lex_state = 2},
  [2187] = {.lex_state = 239},
  [2188] = {.lex_state = 221, .external_lex_state = 2},
  [2189] = {.lex_state = 239},
  [2190] = {.lex_state = 175, .external_lex_state = 5},
  [2191] = {.lex_state = 175, .external_lex_state = 5},
  [2192] = {.lex_state = 141, .external_lex_state = 11},
  [2193] = {.lex_state = 141, .external_lex_state = 11},
  [2194] = {.lex_state = 181, .external_lex_state = 12},
  [2195] = {.lex_state = 181, .external_lex_state = 12},
  [2196] = {.lex_state = 167, .external_lex_state = 14},
  [2197] = {.lex_state = 167, .external_lex_state = 14},
  [2198] = {.lex_state = 167, .external_lex_state = 6},
  [2199] = {.lex_state = 167, .external_lex_state = 6},
  [2200] = {.lex_state = 94, .external_lex_state = 15},
  [2201] = {.lex_state = 94, .external_lex_state = 15},
  [2202] = {.lex_state = 107, .external_lex_state = 10},
  [2203] = {.lex_state = 107, .external_lex_state = 10},
  [2204] = {.lex_state = 96, .external_lex_state = 20},
  [2205] = {.lex_state = 96, .external_lex_state = 20},
  [2206] = {.lex_state = 96, .external_lex_state = 20},
  [2207] = {.lex_state = 96, .external_lex_state = 20},
  [2208] = {.lex_state = 96, .external_lex_state = 16},
  [2209] = {.lex_state = 226, .external_lex_state = 16},
  [2210] = {.lex_state = 96, .external_lex_state = 20},
  [2211] = {.lex_state = 226, .external_lex_state = 16},
  [2212] = {.lex_state = 226, .external_lex_state = 16},
  [2213] = {.lex_state = 226, .external_lex_state = 16},
  [2214] = {.lex_state = 96, .external_lex_state = 20},
  [2215] = {.lex_state = 226, .external_lex_state = 16},
  [2216] = {.lex_state = 96, .external_lex_state = 20},
  [2217] = {.lex_state = 221, .external_lex_state = 2},
  [2218] = {.lex_state = 71, .external_lex_state = 2},
  [2219] = {.lex_state = 96, .external_lex_state = 20},
  [2220] = {.lex_state = 221, .external_lex_state = 2},
  [2221] = {.lex_state = 226, .external_lex_state = 20},
  [2222] = {.lex_state = 226, .external_lex_state = 20},
  [2223] = {.lex_state = 226, .external_lex_state = 20},
  [2224] = {.lex_state = 226, .external_lex_state = 16},
  [2225] = {.lex_state = 226, .external_lex_state = 16},
  [2226] = {.lex_state = 226, .external_lex_state = 20},
  [2227] = {.lex_state = 226, .external_lex_state = 20},
  [2228] = {.lex_state = 226, .external_lex_state = 20},
  [2229] = {.lex_state = 203, .external_lex_state = 17},
  [2230] = {.lex_state = 203, .external_lex_state = 17},
  [2231] = {.lex_state = 203, .external_lex_state = 17},
  [2232] = {.lex_state = 226, .external_lex_state = 16},
  [2233] = {.lex_state = 226, .external_lex_state = 16},
  [2234] = {.lex_state = 203, .external_lex_state = 17},
  [2235] = {.lex_state = 212, .external_lex_state = 10},
  [2236] = {.lex_state = 212, .external_lex_state = 10},
  [2237] = {.lex_state = 212, .external_lex_state = 10},
  [2238] = {.lex_state = 226, .external_lex_state = 16},
  [2239] = {.lex_state = 226, .external_lex_state = 16},
  [2240] = {.lex_state = 212, .external_lex_state = 10},
  [2241] = {.lex_state = 212, .external_lex_state = 10},
  [2242] = {.lex_state = 212, .external_lex_state = 10},
  [2243] = {.lex_state = 173, .external_lex_state = 14},
  [2244] = {.lex_state = 173, .external_lex_state = 14},
  [2245] = {.lex_state = 175, .external_lex_state = 5},
  [2246] = {.lex_state = 214, .external_lex_state = 11},
  [2247] = {.lex_state = 214, .external_lex_state = 11},
  [2248] = {.lex_state = 164},
  [2249] = {.lex_state = 232, .external_lex_state = 11},
  [2250] = {.lex_state = 232, .external_lex_state = 11},
  [2251] = {.lex_state = 232, .external_lex_state = 11},
  [2252] = {.lex_state = 226, .external_lex_state = 16},
  [2253] = {.lex_state = 226, .external_lex_state = 16},
  [2254] = {.lex_state = 232, .external_lex_state = 11},
  [2255] = {.lex_state = 232, .external_lex_state = 11},
  [2256] = {.lex_state = 232, .external_lex_state = 11},
  [2257] = {.lex_state = 234, .external_lex_state = 10},
  [2258] = {.lex_state = 234, .external_lex_state = 10},
  [2259] = {.lex_state = 256, .external_lex_state = 4},
  [2260] = {.lex_state = 212},
  [2261] = {.lex_state = 256, .external_lex_state = 14},
  [2262] = {.lex_state = 107},
  [2263] = {.lex_state = 114},
  [2264] = {.lex_state = 256, .external_lex_state = 14},
  [2265] = {.lex_state = 114, .external_lex_state = 7},
  [2266] = {.lex_state = 71, .external_lex_state = 2},
  [2267] = {.lex_state = 71, .external_lex_state = 2},
  [2268] = {.lex_state = 71, .external_lex_state = 2},
  [2269] = {.lex_state = 136, .external_lex_state = 8},
  [2270] = {.lex_state = 94},
  [2271] = {.lex_state = 246, .external_lex_state = 14},
  [2272] = {.lex_state = 246, .external_lex_state = 14},
  [2273] = {.lex_state = 187},
  [2274] = {.lex_state = 107},
  [2275] = {.lex_state = 246, .external_lex_state = 14},
  [2276] = {.lex_state = 246, .external_lex_state = 14},
  [2277] = {.lex_state = 246, .external_lex_state = 14},
  [2278] = {.lex_state = 78},
  [2279] = {.lex_state = 193, .external_lex_state = 7},
  [2280] = {.lex_state = 195, .external_lex_state = 16},
  [2281] = {.lex_state = 195, .external_lex_state = 16},
  [2282] = {.lex_state = 171, .external_lex_state = 5},
  [2283] = {.lex_state = 173, .external_lex_state = 4},
  [2284] = {.lex_state = 71, .external_lex_state = 2},
  [2285] = {.lex_state = 199, .external_lex_state = 5},
  [2286] = {.lex_state = 132, .external_lex_state = 4},
  [2287] = {.lex_state = 71, .external_lex_state = 2},
  [2288] = {.lex_state = 171, .external_lex_state = 5},
  [2289] = {.lex_state = 173, .external_lex_state = 4},
  [2290] = {.lex_state = 71, .external_lex_state = 2},
  [2291] = {.lex_state = 246, .external_lex_state = 4},
  [2292] = {.lex_state = 94},
  [2293] = {.lex_state = 246, .external_lex_state = 6},
  [2294] = {.lex_state = 246, .external_lex_state = 6},
  [2295] = {.lex_state = 187},
  [2296] = {.lex_state = 107},
  [2297] = {.lex_state = 246, .external_lex_state = 6},
  [2298] = {.lex_state = 246, .external_lex_state = 6},
  [2299] = {.lex_state = 246, .external_lex_state = 6},
  [2300] = {.lex_state = 78},
  [2301] = {.lex_state = 193, .external_lex_state = 7},
  [2302] = {.lex_state = 195, .external_lex_state = 16},
  [2303] = {.lex_state = 195, .external_lex_state = 16},
  [2304] = {.lex_state = 171, .external_lex_state = 5},
  [2305] = {.lex_state = 173, .external_lex_state = 4},
  [2306] = {.lex_state = 71, .external_lex_state = 2},
  [2307] = {.lex_state = 199, .external_lex_state = 5},
  [2308] = {.lex_state = 132, .external_lex_state = 4},
  [2309] = {.lex_state = 71, .external_lex_state = 2},
  [2310] = {.lex_state = 171, .external_lex_state = 5},
  [2311] = {.lex_state = 173, .external_lex_state = 4},
  [2312] = {.lex_state = 71, .external_lex_state = 2},
  [2313] = {.lex_state = 246, .external_lex_state = 5},
  [2314] = {.lex_state = 252, .external_lex_state = 6},
  [2315] = {.lex_state = 252, .external_lex_state = 6},
  [2316] = {.lex_state = 252, .external_lex_state = 6},
  [2317] = {.lex_state = 187},
  [2318] = {.lex_state = 224, .external_lex_state = 16},
  [2319] = {.lex_state = 78},
  [2320] = {.lex_state = 195, .external_lex_state = 16},
  [2321] = {.lex_state = 195, .external_lex_state = 16},
  [2322] = {.lex_state = 252, .external_lex_state = 6},
  [2323] = {.lex_state = 226, .external_lex_state = 21},
  [2324] = {.lex_state = 226, .external_lex_state = 16},
  [2325] = {.lex_state = 252, .external_lex_state = 6},
  [2326] = {.lex_state = 226, .external_lex_state = 21},
  [2327] = {.lex_state = 226, .external_lex_state = 16},
  [2328] = {.lex_state = 221, .external_lex_state = 2},
  [2329] = {.lex_state = 252, .external_lex_state = 6},
  [2330] = {.lex_state = 138, .external_lex_state = 9},
  [2331] = {.lex_state = 171, .external_lex_state = 5},
  [2332] = {.lex_state = 173, .external_lex_state = 4},
  [2333] = {.lex_state = 71, .external_lex_state = 2},
  [2334] = {.lex_state = 138, .external_lex_state = 9},
  [2335] = {.lex_state = 199, .external_lex_state = 5},
  [2336] = {.lex_state = 132, .external_lex_state = 4},
  [2337] = {.lex_state = 221, .external_lex_state = 2},
  [2338] = {.lex_state = 252, .external_lex_state = 6},
  [2339] = {.lex_state = 138, .external_lex_state = 9},
  [2340] = {.lex_state = 171, .external_lex_state = 5},
  [2341] = {.lex_state = 173, .external_lex_state = 4},
  [2342] = {.lex_state = 94},
  [2343] = {.lex_state = 242, .external_lex_state = 5},
  [2344] = {.lex_state = 256, .external_lex_state = 4},
  [2345] = {.lex_state = 242, .external_lex_state = 5},
  [2346] = {.lex_state = 256, .external_lex_state = 4},
  [2347] = {.lex_state = 242, .external_lex_state = 6},
  [2348] = {.lex_state = 107},
  [2349] = {.lex_state = 114},
  [2350] = {.lex_state = 242, .external_lex_state = 6},
  [2351] = {.lex_state = 114, .external_lex_state = 7},
  [2352] = {.lex_state = 71, .external_lex_state = 2},
  [2353] = {.lex_state = 71, .external_lex_state = 2},
  [2354] = {.lex_state = 71, .external_lex_state = 2},
  [2355] = {.lex_state = 242, .external_lex_state = 6},
  [2356] = {.lex_state = 242, .external_lex_state = 6},
  [2357] = {.lex_state = 244, .external_lex_state = 2},
  [2358] = {.lex_state = 242, .external_lex_state = 5},
  [2359] = {.lex_state = 252, .external_lex_state = 5},
  [2360] = {.lex_state = 252, .external_lex_state = 6},
  [2361] = {.lex_state = 252, .external_lex_state = 6},
  [2362] = {.lex_state = 252, .external_lex_state = 5},
  [2363] = {.lex_state = 244, .external_lex_state = 2},
  [2364] = {.lex_state = 128, .external_lex_state = 5},
  [2365] = {.lex_state = 132, .external_lex_state = 4},
  [2366] = {.lex_state = 252, .external_lex_state = 5},
  [2367] = {.lex_state = 237},
  [2368] = {.lex_state = 242, .external_lex_state = 5},
  [2369] = {.lex_state = 256, .external_lex_state = 4},
  [2370] = {.lex_state = 244, .external_lex_state = 2},
  [2371] = {.lex_state = 237},
  [2372] = {.lex_state = 242, .external_lex_state = 5},
  [2373] = {.lex_state = 256, .external_lex_state = 4},
  [2374] = {.lex_state = 94},
  [2375] = {.lex_state = 128, .external_lex_state = 5},
  [2376] = {.lex_state = 132, .external_lex_state = 4},
  [2377] = {.lex_state = 221, .external_lex_state = 2},
  [2378] = {.lex_state = 221, .external_lex_state = 2},
  [2379] = {.lex_state = 94},
  [2380] = {.lex_state = 128, .external_lex_state = 5},
  [2381] = {.lex_state = 132, .external_lex_state = 4},
  [2382] = {.lex_state = 221, .external_lex_state = 2},
  [2383] = {.lex_state = 221, .external_lex_state = 2},
  [2384] = {.lex_state = 96, .external_lex_state = 20},
  [2385] = {.lex_state = 96, .external_lex_state = 20},
  [2386] = {.lex_state = 96, .external_lex_state = 20},
  [2387] = {.lex_state = 226, .external_lex_state = 16},
  [2388] = {.lex_state = 226, .external_lex_state = 16},
  [2389] = {.lex_state = 96, .external_lex_state = 20},
  [2390] = {.lex_state = 96, .external_lex_state = 20},
  [2391] = {.lex_state = 96, .external_lex_state = 20},
  [2392] = {.lex_state = 226, .external_lex_state = 20},
  [2393] = {.lex_state = 226, .external_lex_state = 20},
  [2394] = {.lex_state = 203, .external_lex_state = 17},
  [2395] = {.lex_state = 203, .external_lex_state = 17},
  [2396] = {.lex_state = 212, .external_lex_state = 10},
  [2397] = {.lex_state = 212, .external_lex_state = 10},
  [2398] = {.lex_state = 175, .external_lex_state = 5},
  [2399] = {.lex_state = 232, .external_lex_state = 11},
  [2400] = {.lex_state = 232, .external_lex_state = 11},
  [2401] = {.lex_state = 256, .external_lex_state = 4},
  [2402] = {.lex_state = 212},
  [2403] = {.lex_state = 94},
  [2404] = {.lex_state = 256, .external_lex_state = 14},
  [2405] = {.lex_state = 256, .external_lex_state = 14},
  [2406] = {.lex_state = 187},
  [2407] = {.lex_state = 107},
  [2408] = {.lex_state = 256, .external_lex_state = 14},
  [2409] = {.lex_state = 256, .external_lex_state = 14},
  [2410] = {.lex_state = 256, .external_lex_state = 14},
  [2411] = {.lex_state = 78},
  [2412] = {.lex_state = 193, .external_lex_state = 7},
  [2413] = {.lex_state = 195, .external_lex_state = 16},
  [2414] = {.lex_state = 195, .external_lex_state = 16},
  [2415] = {.lex_state = 171, .external_lex_state = 5},
  [2416] = {.lex_state = 173, .external_lex_state = 4},
  [2417] = {.lex_state = 71, .external_lex_state = 2},
  [2418] = {.lex_state = 199, .external_lex_state = 5},
  [2419] = {.lex_state = 132, .external_lex_state = 4},
  [2420] = {.lex_state = 71, .external_lex_state = 2},
  [2421] = {.lex_state = 171, .external_lex_state = 5},
  [2422] = {.lex_state = 173, .external_lex_state = 4},
  [2423] = {.lex_state = 71, .external_lex_state = 2},
  [2424] = {.lex_state = 246, .external_lex_state = 4},
  [2425] = {.lex_state = 212},
  [2426] = {.lex_state = 246, .external_lex_state = 14},
  [2427] = {.lex_state = 246, .external_lex_state = 14},
  [2428] = {.lex_state = 246, .external_lex_state = 14},
  [2429] = {.lex_state = 246, .external_lex_state = 14},
  [2430] = {.lex_state = 246, .external_lex_state = 14},
  [2431] = {.lex_state = 187},
  [2432] = {.lex_state = 224, .external_lex_state = 16},
  [2433] = {.lex_state = 78},
  [2434] = {.lex_state = 195, .external_lex_state = 16},
  [2435] = {.lex_state = 195, .external_lex_state = 16},
  [2436] = {.lex_state = 246, .external_lex_state = 14},
  [2437] = {.lex_state = 226, .external_lex_state = 21},
  [2438] = {.lex_state = 226, .external_lex_state = 16},
  [2439] = {.lex_state = 246, .external_lex_state = 14},
  [2440] = {.lex_state = 226, .external_lex_state = 21},
  [2441] = {.lex_state = 226, .external_lex_state = 16},
  [2442] = {.lex_state = 221, .external_lex_state = 2},
  [2443] = {.lex_state = 246, .external_lex_state = 14},
  [2444] = {.lex_state = 138, .external_lex_state = 9},
  [2445] = {.lex_state = 171, .external_lex_state = 5},
  [2446] = {.lex_state = 173, .external_lex_state = 4},
  [2447] = {.lex_state = 71, .external_lex_state = 2},
  [2448] = {.lex_state = 138, .external_lex_state = 9},
  [2449] = {.lex_state = 199, .external_lex_state = 5},
  [2450] = {.lex_state = 132, .external_lex_state = 4},
  [2451] = {.lex_state = 221, .external_lex_state = 2},
  [2452] = {.lex_state = 246, .external_lex_state = 14},
  [2453] = {.lex_state = 138, .external_lex_state = 9},
  [2454] = {.lex_state = 171, .external_lex_state = 5},
  [2455] = {.lex_state = 173, .external_lex_state = 4},
  [2456] = {.lex_state = 246, .external_lex_state = 6},
  [2457] = {.lex_state = 246, .external_lex_state = 6},
  [2458] = {.lex_state = 246, .external_lex_state = 6},
  [2459] = {.lex_state = 187},
  [2460] = {.lex_state = 224, .external_lex_state = 16},
  [2461] = {.lex_state = 78},
  [2462] = {.lex_state = 195, .external_lex_state = 16},
  [2463] = {.lex_state = 195, .external_lex_state = 16},
  [2464] = {.lex_state = 246, .external_lex_state = 6},
  [2465] = {.lex_state = 226, .external_lex_state = 21},
  [2466] = {.lex_state = 226, .external_lex_state = 16},
  [2467] = {.lex_state = 246, .external_lex_state = 6},
  [2468] = {.lex_state = 226, .external_lex_state = 21},
  [2469] = {.lex_state = 226, .external_lex_state = 16},
  [2470] = {.lex_state = 221, .external_lex_state = 2},
  [2471] = {.lex_state = 246, .external_lex_state = 6},
  [2472] = {.lex_state = 138, .external_lex_state = 9},
  [2473] = {.lex_state = 171, .external_lex_state = 5},
  [2474] = {.lex_state = 173, .external_lex_state = 4},
  [2475] = {.lex_state = 71, .external_lex_state = 2},
  [2476] = {.lex_state = 138, .external_lex_state = 9},
  [2477] = {.lex_state = 199, .external_lex_state = 5},
  [2478] = {.lex_state = 132, .external_lex_state = 4},
  [2479] = {.lex_state = 221, .external_lex_state = 2},
  [2480] = {.lex_state = 246, .external_lex_state = 6},
  [2481] = {.lex_state = 138, .external_lex_state = 9},
  [2482] = {.lex_state = 171, .external_lex_state = 5},
  [2483] = {.lex_state = 173, .external_lex_state = 4},
  [2484] = {.lex_state = 252, .external_lex_state = 6},
  [2485] = {.lex_state = 252, .external_lex_state = 6},
  [2486] = {.lex_state = 96, .external_lex_state = 20},
  [2487] = {.lex_state = 96, .external_lex_state = 20},
  [2488] = {.lex_state = 96, .external_lex_state = 16},
  [2489] = {.lex_state = 224, .external_lex_state = 16},
  [2490] = {.lex_state = 252, .external_lex_state = 6},
  [2491] = {.lex_state = 226, .external_lex_state = 21},
  [2492] = {.lex_state = 226, .external_lex_state = 16},
  [2493] = {.lex_state = 226, .external_lex_state = 21},
  [2494] = {.lex_state = 226, .external_lex_state = 16},
  [2495] = {.lex_state = 226, .external_lex_state = 16},
  [2496] = {.lex_state = 252, .external_lex_state = 6},
  [2497] = {.lex_state = 226, .external_lex_state = 16},
  [2498] = {.lex_state = 226, .external_lex_state = 16},
  [2499] = {.lex_state = 252, .external_lex_state = 6},
  [2500] = {.lex_state = 221, .external_lex_state = 2},
  [2501] = {.lex_state = 221, .external_lex_state = 2},
  [2502] = {.lex_state = 138, .external_lex_state = 9},
  [2503] = {.lex_state = 71, .external_lex_state = 2},
  [2504] = {.lex_state = 71, .external_lex_state = 2},
  [2505] = {.lex_state = 138, .external_lex_state = 9},
  [2506] = {.lex_state = 252, .external_lex_state = 6},
  [2507] = {.lex_state = 221, .external_lex_state = 2},
  [2508] = {.lex_state = 221, .external_lex_state = 2},
  [2509] = {.lex_state = 138, .external_lex_state = 9},
  [2510] = {.lex_state = 242, .external_lex_state = 6},
  [2511] = {.lex_state = 242, .external_lex_state = 6},
  [2512] = {.lex_state = 94},
  [2513] = {.lex_state = 242, .external_lex_state = 6},
  [2514] = {.lex_state = 242, .external_lex_state = 6},
  [2515] = {.lex_state = 187},
  [2516] = {.lex_state = 107},
  [2517] = {.lex_state = 242, .external_lex_state = 6},
  [2518] = {.lex_state = 242, .external_lex_state = 6},
  [2519] = {.lex_state = 242, .external_lex_state = 6},
  [2520] = {.lex_state = 78},
  [2521] = {.lex_state = 193, .external_lex_state = 7},
  [2522] = {.lex_state = 195, .external_lex_state = 16},
  [2523] = {.lex_state = 195, .external_lex_state = 16},
  [2524] = {.lex_state = 171, .external_lex_state = 5},
  [2525] = {.lex_state = 173, .external_lex_state = 4},
  [2526] = {.lex_state = 71, .external_lex_state = 2},
  [2527] = {.lex_state = 199, .external_lex_state = 5},
  [2528] = {.lex_state = 132, .external_lex_state = 4},
  [2529] = {.lex_state = 71, .external_lex_state = 2},
  [2530] = {.lex_state = 171, .external_lex_state = 5},
  [2531] = {.lex_state = 173, .external_lex_state = 4},
  [2532] = {.lex_state = 71, .external_lex_state = 2},
  [2533] = {.lex_state = 244, .external_lex_state = 2},
  [2534] = {.lex_state = 244, .external_lex_state = 2},
  [2535] = {.lex_state = 221, .external_lex_state = 2},
  [2536] = {.lex_state = 94},
  [2537] = {.lex_state = 128, .external_lex_state = 5},
  [2538] = {.lex_state = 132, .external_lex_state = 4},
  [2539] = {.lex_state = 221, .external_lex_state = 2},
  [2540] = {.lex_state = 221, .external_lex_state = 2},
  [2541] = {.lex_state = 221, .external_lex_state = 2},
  [2542] = {.lex_state = 94},
  [2543] = {.lex_state = 128, .external_lex_state = 5},
  [2544] = {.lex_state = 132, .external_lex_state = 4},
  [2545] = {.lex_state = 221, .external_lex_state = 2},
  [2546] = {.lex_state = 96, .external_lex_state = 20},
  [2547] = {.lex_state = 96, .external_lex_state = 20},
  [2548] = {.lex_state = 256, .external_lex_state = 4},
  [2549] = {.lex_state = 256, .external_lex_state = 14},
  [2550] = {.lex_state = 256, .external_lex_state = 14},
  [2551] = {.lex_state = 256, .external_lex_state = 14},
  [2552] = {.lex_state = 187},
  [2553] = {.lex_state = 224, .external_lex_state = 16},
  [2554] = {.lex_state = 78},
  [2555] = {.lex_state = 195, .external_lex_state = 16},
  [2556] = {.lex_state = 195, .external_lex_state = 16},
  [2557] = {.lex_state = 256, .external_lex_state = 14},
  [2558] = {.lex_state = 226, .external_lex_state = 21},
  [2559] = {.lex_state = 226, .external_lex_state = 16},
  [2560] = {.lex_state = 256, .external_lex_state = 14},
  [2561] = {.lex_state = 226, .external_lex_state = 21},
  [2562] = {.lex_state = 226, .external_lex_state = 16},
  [2563] = {.lex_state = 221, .external_lex_state = 2},
  [2564] = {.lex_state = 256, .external_lex_state = 14},
  [2565] = {.lex_state = 138, .external_lex_state = 9},
  [2566] = {.lex_state = 171, .external_lex_state = 5},
  [2567] = {.lex_state = 173, .external_lex_state = 4},
  [2568] = {.lex_state = 71, .external_lex_state = 2},
  [2569] = {.lex_state = 138, .external_lex_state = 9},
  [2570] = {.lex_state = 199, .external_lex_state = 5},
  [2571] = {.lex_state = 132, .external_lex_state = 4},
  [2572] = {.lex_state = 221, .external_lex_state = 2},
  [2573] = {.lex_state = 256, .external_lex_state = 14},
  [2574] = {.lex_state = 138, .external_lex_state = 9},
  [2575] = {.lex_state = 171, .external_lex_state = 5},
  [2576] = {.lex_state = 173, .external_lex_state = 4},
  [2577] = {.lex_state = 246, .external_lex_state = 4},
  [2578] = {.lex_state = 212},
  [2579] = {.lex_state = 246, .external_lex_state = 14},
  [2580] = {.lex_state = 246, .external_lex_state = 14},
  [2581] = {.lex_state = 96, .external_lex_state = 20},
  [2582] = {.lex_state = 96, .external_lex_state = 20},
  [2583] = {.lex_state = 96, .external_lex_state = 16},
  [2584] = {.lex_state = 224, .external_lex_state = 16},
  [2585] = {.lex_state = 246, .external_lex_state = 14},
  [2586] = {.lex_state = 226, .external_lex_state = 21},
  [2587] = {.lex_state = 226, .external_lex_state = 16},
  [2588] = {.lex_state = 226, .external_lex_state = 21},
  [2589] = {.lex_state = 226, .external_lex_state = 16},
  [2590] = {.lex_state = 226, .external_lex_state = 16},
  [2591] = {.lex_state = 246, .external_lex_state = 14},
  [2592] = {.lex_state = 226, .external_lex_state = 16},
  [2593] = {.lex_state = 226, .external_lex_state = 16},
  [2594] = {.lex_state = 246, .external_lex_state = 14},
  [2595] = {.lex_state = 221, .external_lex_state = 2},
  [2596] = {.lex_state = 221, .external_lex_state = 2},
  [2597] = {.lex_state = 138, .external_lex_state = 9},
  [2598] = {.lex_state = 71, .external_lex_state = 2},
  [2599] = {.lex_state = 71, .external_lex_state = 2},
  [2600] = {.lex_state = 138, .external_lex_state = 9},
  [2601] = {.lex_state = 246, .external_lex_state = 14},
  [2602] = {.lex_state = 221, .external_lex_state = 2},
  [2603] = {.lex_state = 221, .external_lex_state = 2},
  [2604] = {.lex_state = 138, .external_lex_state = 9},
  [2605] = {.lex_state = 246, .external_lex_state = 6},
  [2606] = {.lex_state = 246, .external_lex_state = 6},
  [2607] = {.lex_state = 96, .external_lex_state = 20},
  [2608] = {.lex_state = 96, .external_lex_state = 20},
  [2609] = {.lex_state = 96, .external_lex_state = 16},
  [2610] = {.lex_state = 224, .external_lex_state = 16},
  [2611] = {.lex_state = 246, .external_lex_state = 6},
  [2612] = {.lex_state = 226, .external_lex_state = 21},
  [2613] = {.lex_state = 226, .external_lex_state = 16},
  [2614] = {.lex_state = 226, .external_lex_state = 21},
  [2615] = {.lex_state = 226, .external_lex_state = 16},
  [2616] = {.lex_state = 226, .external_lex_state = 16},
  [2617] = {.lex_state = 246, .external_lex_state = 6},
  [2618] = {.lex_state = 226, .external_lex_state = 16},
  [2619] = {.lex_state = 226, .external_lex_state = 16},
  [2620] = {.lex_state = 246, .external_lex_state = 6},
  [2621] = {.lex_state = 221, .external_lex_state = 2},
  [2622] = {.lex_state = 221, .external_lex_state = 2},
  [2623] = {.lex_state = 138, .external_lex_state = 9},
  [2624] = {.lex_state = 71, .external_lex_state = 2},
  [2625] = {.lex_state = 71, .external_lex_state = 2},
  [2626] = {.lex_state = 138, .external_lex_state = 9},
  [2627] = {.lex_state = 246, .external_lex_state = 6},
  [2628] = {.lex_state = 221, .external_lex_state = 2},
  [2629] = {.lex_state = 221, .external_lex_state = 2},
  [2630] = {.lex_state = 138, .external_lex_state = 9},
  [2631] = {.lex_state = 252, .external_lex_state = 6},
  [2632] = {.lex_state = 252, .external_lex_state = 6},
  [2633] = {.lex_state = 96, .external_lex_state = 20},
  [2634] = {.lex_state = 96, .external_lex_state = 20},
  [2635] = {.lex_state = 96, .external_lex_state = 16},
  [2636] = {.lex_state = 226, .external_lex_state = 16},
  [2637] = {.lex_state = 252, .external_lex_state = 6},
  [2638] = {.lex_state = 226, .external_lex_state = 16},
  [2639] = {.lex_state = 226, .external_lex_state = 16},
  [2640] = {.lex_state = 226, .external_lex_state = 16},
  [2641] = {.lex_state = 252, .external_lex_state = 6},
  [2642] = {.lex_state = 226, .external_lex_state = 16},
  [2643] = {.lex_state = 252, .external_lex_state = 6},
  [2644] = {.lex_state = 221, .external_lex_state = 2},
  [2645] = {.lex_state = 71, .external_lex_state = 2},
  [2646] = {.lex_state = 252, .external_lex_state = 6},
  [2647] = {.lex_state = 221, .external_lex_state = 2},
  [2648] = {.lex_state = 242, .external_lex_state = 6},
  [2649] = {.lex_state = 242, .external_lex_state = 6},
  [2650] = {.lex_state = 242, .external_lex_state = 6},
  [2651] = {.lex_state = 187},
  [2652] = {.lex_state = 224, .external_lex_state = 16},
  [2653] = {.lex_state = 78},
  [2654] = {.lex_state = 195, .external_lex_state = 16},
  [2655] = {.lex_state = 195, .external_lex_state = 16},
  [2656] = {.lex_state = 242, .external_lex_state = 6},
  [2657] = {.lex_state = 226, .external_lex_state = 21},
  [2658] = {.lex_state = 226, .external_lex_state = 16},
  [2659] = {.lex_state = 242, .external_lex_state = 6},
  [2660] = {.lex_state = 226, .external_lex_state = 21},
  [2661] = {.lex_state = 226, .external_lex_state = 16},
  [2662] = {.lex_state = 221, .external_lex_state = 2},
  [2663] = {.lex_state = 242, .external_lex_state = 6},
  [2664] = {.lex_state = 138, .external_lex_state = 9},
  [2665] = {.lex_state = 171, .external_lex_state = 5},
  [2666] = {.lex_state = 173, .external_lex_state = 4},
  [2667] = {.lex_state = 71, .external_lex_state = 2},
  [2668] = {.lex_state = 138, .external_lex_state = 9},
  [2669] = {.lex_state = 199, .external_lex_state = 5},
  [2670] = {.lex_state = 132, .external_lex_state = 4},
  [2671] = {.lex_state = 221, .external_lex_state = 2},
  [2672] = {.lex_state = 242, .external_lex_state = 6},
  [2673] = {.lex_state = 138, .external_lex_state = 9},
  [2674] = {.lex_state = 171, .external_lex_state = 5},
  [2675] = {.lex_state = 173, .external_lex_state = 4},
  [2676] = {.lex_state = 221, .external_lex_state = 2},
  [2677] = {.lex_state = 94},
  [2678] = {.lex_state = 128, .external_lex_state = 5},
  [2679] = {.lex_state = 132, .external_lex_state = 4},
  [2680] = {.lex_state = 221, .external_lex_state = 2},
  [2681] = {.lex_state = 94},
  [2682] = {.lex_state = 128, .external_lex_state = 5},
  [2683] = {.lex_state = 132, .external_lex_state = 4},
  [2684] = {.lex_state = 256, .external_lex_state = 14},
  [2685] = {.lex_state = 256, .external_lex_state = 14},
  [2686] = {.lex_state = 96, .external_lex_state = 20},
  [2687] = {.lex_state = 96, .external_lex_state = 20},
  [2688] = {.lex_state = 96, .external_lex_state = 16},
  [2689] = {.lex_state = 224, .external_lex_state = 16},
  [2690] = {.lex_state = 256, .external_lex_state = 14},
  [2691] = {.lex_state = 226, .external_lex_state = 21},
  [2692] = {.lex_state = 226, .external_lex_state = 16},
  [2693] = {.lex_state = 226, .external_lex_state = 21},
  [2694] = {.lex_state = 226, .external_lex_state = 16},
  [2695] = {.lex_state = 226, .external_lex_state = 16},
  [2696] = {.lex_state = 256, .external_lex_state = 14},
  [2697] = {.lex_state = 226, .external_lex_state = 16},
  [2698] = {.lex_state = 226, .external_lex_state = 16},
  [2699] = {.lex_state = 256, .external_lex_state = 14},
  [2700] = {.lex_state = 221, .external_lex_state = 2},
  [2701] = {.lex_state = 221, .external_lex_state = 2},
  [2702] = {.lex_state = 138, .external_lex_state = 9},
  [2703] = {.lex_state = 71, .external_lex_state = 2},
  [2704] = {.lex_state = 71, .external_lex_state = 2},
  [2705] = {.lex_state = 138, .external_lex_state = 9},
  [2706] = {.lex_state = 256, .external_lex_state = 14},
  [2707] = {.lex_state = 221, .external_lex_state = 2},
  [2708] = {.lex_state = 221, .external_lex_state = 2},
  [2709] = {.lex_state = 138, .external_lex_state = 9},
  [2710] = {.lex_state = 246, .external_lex_state = 4},
  [2711] = {.lex_state = 246, .external_lex_state = 14},
  [2712] = {.lex_state = 246, .external_lex_state = 14},
  [2713] = {.lex_state = 96, .external_lex_state = 20},
  [2714] = {.lex_state = 96, .external_lex_state = 20},
  [2715] = {.lex_state = 96, .external_lex_state = 16},
  [2716] = {.lex_state = 226, .external_lex_state = 16},
  [2717] = {.lex_state = 246, .external_lex_state = 14},
  [2718] = {.lex_state = 226, .external_lex_state = 16},
  [2719] = {.lex_state = 226, .external_lex_state = 16},
  [2720] = {.lex_state = 226, .external_lex_state = 16},
  [2721] = {.lex_state = 246, .external_lex_state = 14},
  [2722] = {.lex_state = 226, .external_lex_state = 16},
  [2723] = {.lex_state = 246, .external_lex_state = 14},
  [2724] = {.lex_state = 221, .external_lex_state = 2},
  [2725] = {.lex_state = 71, .external_lex_state = 2},
  [2726] = {.lex_state = 246, .external_lex_state = 14},
  [2727] = {.lex_state = 221, .external_lex_state = 2},
  [2728] = {.lex_state = 246, .external_lex_state = 6},
  [2729] = {.lex_state = 246, .external_lex_state = 6},
  [2730] = {.lex_state = 96, .external_lex_state = 20},
  [2731] = {.lex_state = 96, .external_lex_state = 20},
  [2732] = {.lex_state = 96, .external_lex_state = 16},
  [2733] = {.lex_state = 226, .external_lex_state = 16},
  [2734] = {.lex_state = 246, .external_lex_state = 6},
  [2735] = {.lex_state = 226, .external_lex_state = 16},
  [2736] = {.lex_state = 226, .external_lex_state = 16},
  [2737] = {.lex_state = 226, .external_lex_state = 16},
  [2738] = {.lex_state = 246, .external_lex_state = 6},
  [2739] = {.lex_state = 226, .external_lex_state = 16},
  [2740] = {.lex_state = 246, .external_lex_state = 6},
  [2741] = {.lex_state = 221, .external_lex_state = 2},
  [2742] = {.lex_state = 71, .external_lex_state = 2},
  [2743] = {.lex_state = 246, .external_lex_state = 6},
  [2744] = {.lex_state = 221, .external_lex_state = 2},
  [2745] = {.lex_state = 252, .external_lex_state = 6},
  [2746] = {.lex_state = 252, .external_lex_state = 6},
  [2747] = {.lex_state = 252, .external_lex_state = 6},
  [2748] = {.lex_state = 226, .external_lex_state = 16},
  [2749] = {.lex_state = 226, .external_lex_state = 16},
  [2750] = {.lex_state = 252, .external_lex_state = 6},
  [2751] = {.lex_state = 252, .external_lex_state = 6},
  [2752] = {.lex_state = 252, .external_lex_state = 6},
  [2753] = {.lex_state = 242, .external_lex_state = 6},
  [2754] = {.lex_state = 242, .external_lex_state = 6},
  [2755] = {.lex_state = 96, .external_lex_state = 20},
  [2756] = {.lex_state = 96, .external_lex_state = 20},
  [2757] = {.lex_state = 96, .external_lex_state = 16},
  [2758] = {.lex_state = 224, .external_lex_state = 16},
  [2759] = {.lex_state = 242, .external_lex_state = 6},
  [2760] = {.lex_state = 226, .external_lex_state = 21},
  [2761] = {.lex_state = 226, .external_lex_state = 16},
  [2762] = {.lex_state = 226, .external_lex_state = 21},
  [2763] = {.lex_state = 226, .external_lex_state = 16},
  [2764] = {.lex_state = 226, .external_lex_state = 16},
  [2765] = {.lex_state = 242, .external_lex_state = 6},
  [2766] = {.lex_state = 226, .external_lex_state = 16},
  [2767] = {.lex_state = 226, .external_lex_state = 16},
  [2768] = {.lex_state = 242, .external_lex_state = 6},
  [2769] = {.lex_state = 221, .external_lex_state = 2},
  [2770] = {.lex_state = 221, .external_lex_state = 2},
  [2771] = {.lex_state = 138, .external_lex_state = 9},
  [2772] = {.lex_state = 71, .external_lex_state = 2},
  [2773] = {.lex_state = 71, .external_lex_state = 2},
  [2774] = {.lex_state = 138, .external_lex_state = 9},
  [2775] = {.lex_state = 242, .external_lex_state = 6},
  [2776] = {.lex_state = 221, .external_lex_state = 2},
  [2777] = {.lex_state = 221, .external_lex_state = 2},
  [2778] = {.lex_state = 138, .external_lex_state = 9},
  [2779] = {.lex_state = 221, .external_lex_state = 2},
  [2780] = {.lex_state = 221, .external_lex_state = 2},
  [2781] = {.lex_state = 256, .external_lex_state = 14},
  [2782] = {.lex_state = 256, .external_lex_state = 14},
  [2783] = {.lex_state = 96, .external_lex_state = 20},
  [2784] = {.lex_state = 96, .external_lex_state = 20},
  [2785] = {.lex_state = 96, .external_lex_state = 16},
  [2786] = {.lex_state = 226, .external_lex_state = 16},
  [2787] = {.lex_state = 256, .external_lex_state = 14},
  [2788] = {.lex_state = 226, .external_lex_state = 16},
  [2789] = {.lex_state = 226, .external_lex_state = 16},
  [2790] = {.lex_state = 226, .external_lex_state = 16},
  [2791] = {.lex_state = 256, .external_lex_state = 14},
  [2792] = {.lex_state = 226, .external_lex_state = 16},
  [2793] = {.lex_state = 256, .external_lex_state = 14},
  [2794] = {.lex_state = 221, .external_lex_state = 2},
  [2795] = {.lex_state = 71, .external_lex_state = 2},
  [2796] = {.lex_state = 256, .external_lex_state = 14},
  [2797] = {.lex_state = 221, .external_lex_state = 2},
  [2798] = {.lex_state = 246, .external_lex_state = 14},
  [2799] = {.lex_state = 246, .external_lex_state = 14},
  [2800] = {.lex_state = 246, .external_lex_state = 14},
  [2801] = {.lex_state = 226, .external_lex_state = 16},
  [2802] = {.lex_state = 226, .external_lex_state = 16},
  [2803] = {.lex_state = 246, .external_lex_state = 14},
  [2804] = {.lex_state = 246, .external_lex_state = 14},
  [2805] = {.lex_state = 246, .external_lex_state = 14},
  [2806] = {.lex_state = 246, .external_lex_state = 6},
  [2807] = {.lex_state = 246, .external_lex_state = 6},
  [2808] = {.lex_state = 246, .external_lex_state = 6},
  [2809] = {.lex_state = 226, .external_lex_state = 16},
  [2810] = {.lex_state = 226, .external_lex_state = 16},
  [2811] = {.lex_state = 246, .external_lex_state = 6},
  [2812] = {.lex_state = 246, .external_lex_state = 6},
  [2813] = {.lex_state = 246, .external_lex_state = 6},
  [2814] = {.lex_state = 252, .external_lex_state = 6},
  [2815] = {.lex_state = 252, .external_lex_state = 6},
  [2816] = {.lex_state = 242, .external_lex_state = 6},
  [2817] = {.lex_state = 242, .external_lex_state = 6},
  [2818] = {.lex_state = 96, .external_lex_state = 20},
  [2819] = {.lex_state = 96, .external_lex_state = 20},
  [2820] = {.lex_state = 96, .external_lex_state = 16},
  [2821] = {.lex_state = 226, .external_lex_state = 16},
  [2822] = {.lex_state = 242, .external_lex_state = 6},
  [2823] = {.lex_state = 226, .external_lex_state = 16},
  [2824] = {.lex_state = 226, .external_lex_state = 16},
  [2825] = {.lex_state = 226, .external_lex_state = 16},
  [2826] = {.lex_state = 242, .external_lex_state = 6},
  [2827] = {.lex_state = 226, .external_lex_state = 16},
  [2828] = {.lex_state = 242, .external_lex_state = 6},
  [2829] = {.lex_state = 221, .external_lex_state = 2},
  [2830] = {.lex_state = 71, .external_lex_state = 2},
  [2831] = {.lex_state = 242, .external_lex_state = 6},
  [2832] = {.lex_state = 221, .external_lex_state = 2},
  [2833] = {.lex_state = 256, .external_lex_state = 14},
  [2834] = {.lex_state = 256, .external_lex_state = 14},
  [2835] = {.lex_state = 256, .external_lex_state = 14},
  [2836] = {.lex_state = 226, .external_lex_state = 16},
  [2837] = {.lex_state = 226, .external_lex_state = 16},
  [2838] = {.lex_state = 256, .external_lex_state = 14},
  [2839] = {.lex_state = 256, .external_lex_state = 14},
  [2840] = {.lex_state = 256, .external_lex_state = 14},
  [2841] = {.lex_state = 246, .external_lex_state = 14},
  [2842] = {.lex_state = 246, .external_lex_state = 14},
  [2843] = {.lex_state = 246, .external_lex_state = 6},
  [2844] = {.lex_state = 246, .external_lex_state = 6},
  [2845] = {.lex_state = 242, .external_lex_state = 6},
  [2846] = {.lex_state = 242, .external_lex_state = 6},
  [2847] = {.lex_state = 242, .external_lex_state = 6},
  [2848] = {.lex_state = 226, .external_lex_state = 16},
  [2849] = {.lex_state = 226, .external_lex_state = 16},
  [2850] = {.lex_state = 242, .external_lex_state = 6},
  [2851] = {.lex_state = 242, .external_lex_state = 6},
  [2852] = {.lex_state = 242, .external_lex_state = 6},
  [2853] = {.lex_state = 256, .external_lex_state = 14},
  [2854] = {.lex_state = 256, .external_lex_state = 14},
  [2855] = {.lex_state = 242, .external_lex_state = 6},
  [2856] = {.lex_state = 242, .external_lex_state = 6},
};

enum {
  ts_external_token_heredoc_start,
  ts_external_token__simple_heredoc_body,
  ts_external_token__heredoc_body_beginning,
  ts_external_token__heredoc_body_middle,
  ts_external_token__heredoc_body_end,
  ts_external_token_file_descriptor,
  ts_external_token__empty_value,
  ts_external_token__concat,
  ts_external_token_variable_name,
  ts_external_token_regex,
  ts_external_token_RBRACE,
  ts_external_token_RBRACK,
  ts_external_token_LF,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_heredoc_start] = sym_heredoc_start,
  [ts_external_token__simple_heredoc_body] = sym__simple_heredoc_body,
  [ts_external_token__heredoc_body_beginning] = sym__heredoc_body_beginning,
  [ts_external_token__heredoc_body_middle] = sym__heredoc_body_middle,
  [ts_external_token__heredoc_body_end] = sym__heredoc_body_end,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__empty_value] = sym__empty_value,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token_variable_name] = sym_variable_name,
  [ts_external_token_regex] = sym_regex,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_LF] = anon_sym_LF,
};

static bool ts_external_scanner_states[22][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_heredoc_start] = true,
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token__heredoc_body_middle] = true,
    [ts_external_token__heredoc_body_end] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__empty_value] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_regex] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_LF] = true,
  },
  [2] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
  },
  [3] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
  },
  [4] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [5] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LF] = true,
  },
  [6] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [7] = {
    [ts_external_token_variable_name] = true,
  },
  [8] = {
    [ts_external_token__empty_value] = true,
  },
  [9] = {
    [ts_external_token_LF] = true,
  },
  [10] = {
    [ts_external_token__concat] = true,
  },
  [11] = {
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [12] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACK] = true,
  },
  [13] = {
    [ts_external_token_RBRACK] = true,
  },
  [14] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [15] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [16] = {
    [ts_external_token_RBRACE] = true,
  },
  [17] = {
    [ts_external_token__heredoc_body_middle] = true,
    [ts_external_token__heredoc_body_end] = true,
  },
  [18] = {
    [ts_external_token_heredoc_start] = true,
  },
  [19] = {
    [ts_external_token_regex] = true,
  },
  [20] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACE] = true,
  },
  [21] = {
    [ts_external_token_regex] = true,
    [ts_external_token_RBRACE] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_heredoc_start] = ACTIONS(1),
    [sym__simple_heredoc_body] = ACTIONS(1),
    [sym__heredoc_body_beginning] = ACTIONS(1),
    [sym__heredoc_body_middle] = ACTIONS(1),
    [sym__heredoc_body_end] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [sym__empty_value] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [sym_variable_name] = ACTIONS(1),
    [sym_regex] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(3),
    [anon_sym_done] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_fi] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_esac] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SEMI_SEMI] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PIPE_AMP] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(3),
    [anon_sym_RBRACK] = ACTIONS(3),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_typeset] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_unset] = ACTIONS(3),
    [anon_sym_unsetenv] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_AMP_GT] = ACTIONS(3),
    [anon_sym_AMP_GT_GT] = ACTIONS(1),
    [anon_sym_LT_AMP] = ACTIONS(1),
    [anon_sym_GT_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_LT_LT_DASH] = ACTIONS(1),
    [anon_sym_LT_LT_LT] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [sym__special_characters] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(3),
    [sym_raw_string] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_COLON_QMARK] = ACTIONS(1),
    [anon_sym_COLON_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_LT_LPAREN] = ACTIONS(1),
    [anon_sym_GT_LPAREN] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [sym_test_operator] = ACTIONS(1),
    [anon_sym_LF] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(27),
    [sym__terminated_statement] = STATE(33),
    [sym_redirected_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_c_style_for_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_case_statement] = STATE(28),
    [sym_function_definition] = STATE(28),
    [sym_compound_statement] = STATE(28),
    [sym_subshell] = STATE(28),
    [sym_pipeline] = STATE(28),
    [sym_list] = STATE(28),
    [sym_negated_command] = STATE(28),
    [sym_test_command] = STATE(28),
    [sym_declaration_command] = STATE(28),
    [sym_unset_command] = STATE(28),
    [sym_command] = STATE(28),
    [sym_command_name] = STATE(29),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(31),
    [sym_file_redirect] = STATE(34),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym__statements_repeat1] = STATE(33),
    [aux_sym_command_repeat1] = STATE(34),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(9),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(33),
    [anon_sym_typeset] = ACTIONS(33),
    [anon_sym_export] = ACTIONS(33),
    [anon_sym_readonly] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym_unset] = ACTIONS(35),
    [anon_sym_unsetenv] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(41),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(59),
  },
  [2] = {
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_GT] = ACTIONS(63),
    [anon_sym_AMP_GT] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(63),
    [anon_sym_LT_AMP] = ACTIONS(63),
    [anon_sym_GT_AMP] = ACTIONS(63),
    [sym_comment] = ACTIONS(57),
  },
  [3] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(67),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [sym_comment] = ACTIONS(57),
  },
  [4] = {
    [anon_sym_LPAREN_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(71),
  },
  [5] = {
    [sym__expression] = STATE(50),
    [sym_binary_expression] = STATE(50),
    [sym_unary_expression] = STATE(50),
    [sym_postfix_expression] = STATE(50),
    [sym_parenthesized_expression] = STATE(50),
    [sym_concatenation] = STATE(50),
    [sym_string] = STATE(45),
    [sym_simple_expansion] = STATE(45),
    [sym_string_expansion] = STATE(45),
    [sym_expansion] = STATE(45),
    [sym_command_substitution] = STATE(45),
    [sym_process_substitution] = STATE(45),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [6] = {
    [sym__terminated_statement] = STATE(58),
    [sym_redirected_statement] = STATE(59),
    [sym_for_statement] = STATE(59),
    [sym_c_style_for_statement] = STATE(59),
    [sym_while_statement] = STATE(59),
    [sym_if_statement] = STATE(59),
    [sym_case_statement] = STATE(59),
    [sym_function_definition] = STATE(59),
    [sym_compound_statement] = STATE(59),
    [sym_subshell] = STATE(59),
    [sym_pipeline] = STATE(59),
    [sym_list] = STATE(59),
    [sym_negated_command] = STATE(59),
    [sym_test_command] = STATE(59),
    [sym_declaration_command] = STATE(59),
    [sym_unset_command] = STATE(59),
    [sym_command] = STATE(59),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(61),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [7] = {
    [sym__terminated_statement] = STATE(64),
    [sym_redirected_statement] = STATE(59),
    [sym_for_statement] = STATE(59),
    [sym_c_style_for_statement] = STATE(59),
    [sym_while_statement] = STATE(59),
    [sym_if_statement] = STATE(59),
    [sym_case_statement] = STATE(59),
    [sym_function_definition] = STATE(59),
    [sym_compound_statement] = STATE(59),
    [sym_subshell] = STATE(59),
    [sym_pipeline] = STATE(59),
    [sym_list] = STATE(59),
    [sym_negated_command] = STATE(59),
    [sym_test_command] = STATE(59),
    [sym_declaration_command] = STATE(59),
    [sym_unset_command] = STATE(59),
    [sym_command] = STATE(59),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(61),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [8] = {
    [sym_concatenation] = STATE(73),
    [sym_string] = STATE(68),
    [sym_simple_expansion] = STATE(68),
    [sym_string_expansion] = STATE(68),
    [sym_expansion] = STATE(68),
    [sym_command_substitution] = STATE(68),
    [sym_process_substitution] = STATE(68),
    [sym__special_characters] = ACTIONS(111),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [sym_raw_string] = ACTIONS(117),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(121),
    [anon_sym_BQUOTE] = ACTIONS(123),
    [anon_sym_LT_LPAREN] = ACTIONS(125),
    [anon_sym_GT_LPAREN] = ACTIONS(125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(117),
  },
  [9] = {
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(127),
  },
  [10] = {
    [sym__terminated_statement] = STATE(86),
    [sym_redirected_statement] = STATE(82),
    [sym_for_statement] = STATE(82),
    [sym_c_style_for_statement] = STATE(82),
    [sym_while_statement] = STATE(82),
    [sym_if_statement] = STATE(82),
    [sym_case_statement] = STATE(82),
    [sym_function_definition] = STATE(82),
    [sym_compound_statement] = STATE(82),
    [sym_subshell] = STATE(82),
    [sym_pipeline] = STATE(82),
    [sym_list] = STATE(82),
    [sym_negated_command] = STATE(82),
    [sym_test_command] = STATE(82),
    [sym_declaration_command] = STATE(82),
    [sym_unset_command] = STATE(82),
    [sym_command] = STATE(82),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(84),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(86),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [11] = {
    [sym__terminated_statement] = STATE(91),
    [sym_redirected_statement] = STATE(89),
    [sym_for_statement] = STATE(89),
    [sym_c_style_for_statement] = STATE(89),
    [sym_while_statement] = STATE(89),
    [sym_if_statement] = STATE(89),
    [sym_case_statement] = STATE(89),
    [sym_function_definition] = STATE(89),
    [sym_compound_statement] = STATE(89),
    [sym_subshell] = STATE(89),
    [sym_pipeline] = STATE(89),
    [sym_list] = STATE(89),
    [sym_negated_command] = STATE(89),
    [sym_test_command] = STATE(89),
    [sym_declaration_command] = STATE(89),
    [sym_unset_command] = STATE(89),
    [sym_command] = STATE(89),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(90),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(91),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_RBRACE] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [12] = {
    [sym_subshell] = STATE(93),
    [sym_test_command] = STATE(93),
    [sym_command] = STATE(93),
    [sym_command_name] = STATE(29),
    [sym_variable_assignment] = STATE(34),
    [sym_subscript] = STATE(94),
    [sym_file_redirect] = STATE(34),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym_command_repeat1] = STATE(34),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(145),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(41),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(47),
  },
  [13] = {
    [sym__expression] = STATE(105),
    [sym_binary_expression] = STATE(105),
    [sym_unary_expression] = STATE(105),
    [sym_postfix_expression] = STATE(105),
    [sym_parenthesized_expression] = STATE(105),
    [sym_concatenation] = STATE(105),
    [sym_string] = STATE(100),
    [sym_simple_expansion] = STATE(100),
    [sym_string_expansion] = STATE(100),
    [sym_expansion] = STATE(100),
    [sym_command_substitution] = STATE(100),
    [sym_process_substitution] = STATE(100),
    [anon_sym_LPAREN] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [sym__special_characters] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [sym_raw_string] = ACTIONS(157),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(167),
    [sym_test_operator] = ACTIONS(169),
  },
  [14] = {
    [sym__expression] = STATE(109),
    [sym_binary_expression] = STATE(109),
    [sym_unary_expression] = STATE(109),
    [sym_postfix_expression] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_concatenation] = STATE(109),
    [sym_string] = STATE(108),
    [sym_simple_expansion] = STATE(108),
    [sym_string_expansion] = STATE(108),
    [sym_expansion] = STATE(108),
    [sym_command_substitution] = STATE(108),
    [sym_process_substitution] = STATE(108),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(171),
    [sym__special_characters] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(175),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(177),
    [sym_test_operator] = ACTIONS(179),
  },
  [15] = {
    [sym_variable_assignment] = STATE(120),
    [sym_subscript] = STATE(119),
    [sym_concatenation] = STATE(120),
    [sym_string] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [sym_expansion] = STATE(114),
    [sym_command_substitution] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [aux_sym_declaration_command_repeat1] = STATE(120),
    [sym__simple_heredoc_body] = ACTIONS(181),
    [sym__heredoc_body_beginning] = ACTIONS(181),
    [sym_file_descriptor] = ACTIONS(181),
    [sym_variable_name] = ACTIONS(183),
    [ts_builtin_sym_end] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(185),
    [anon_sym_PIPE] = ACTIONS(185),
    [anon_sym_SEMI_SEMI] = ACTIONS(181),
    [anon_sym_PIPE_AMP] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_GT] = ACTIONS(185),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_AMP_GT] = ACTIONS(185),
    [anon_sym_AMP_GT_GT] = ACTIONS(181),
    [anon_sym_LT_AMP] = ACTIONS(181),
    [anon_sym_GT_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(185),
    [anon_sym_LT_LT_DASH] = ACTIONS(181),
    [anon_sym_LT_LT_LT] = ACTIONS(181),
    [sym__special_characters] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(193),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(203),
    [sym_word] = ACTIONS(205),
    [anon_sym_LF] = ACTIONS(181),
    [anon_sym_AMP] = ACTIONS(185),
  },
  [16] = {
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(124),
    [sym_simple_expansion] = STATE(124),
    [sym_string_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [sym_process_substitution] = STATE(124),
    [aux_sym_unset_command_repeat1] = STATE(129),
    [sym__simple_heredoc_body] = ACTIONS(207),
    [sym__heredoc_body_beginning] = ACTIONS(207),
    [sym_file_descriptor] = ACTIONS(207),
    [ts_builtin_sym_end] = ACTIONS(207),
    [anon_sym_SEMI] = ACTIONS(209),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_SEMI_SEMI] = ACTIONS(207),
    [anon_sym_PIPE_AMP] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_GT] = ACTIONS(209),
    [anon_sym_AMP_GT_GT] = ACTIONS(207),
    [anon_sym_LT_AMP] = ACTIONS(207),
    [anon_sym_GT_AMP] = ACTIONS(207),
    [anon_sym_LT_LT] = ACTIONS(209),
    [anon_sym_LT_LT_DASH] = ACTIONS(207),
    [anon_sym_LT_LT_LT] = ACTIONS(207),
    [sym__special_characters] = ACTIONS(211),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(217),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(227),
    [sym_word] = ACTIONS(229),
    [anon_sym_LF] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(209),
  },
  [17] = {
    [sym_concatenation] = STATE(138),
    [sym_string] = STATE(133),
    [sym_simple_expansion] = STATE(133),
    [sym_string_expansion] = STATE(133),
    [sym_expansion] = STATE(133),
    [sym_command_substitution] = STATE(133),
    [sym_process_substitution] = STATE(133),
    [sym__special_characters] = ACTIONS(231),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_raw_string] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(241),
    [anon_sym_BQUOTE] = ACTIONS(243),
    [anon_sym_LT_LPAREN] = ACTIONS(245),
    [anon_sym_GT_LPAREN] = ACTIONS(245),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(237),
  },
  [18] = {
    [aux_sym_concatenation_repeat1] = STATE(140),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(251),
    [anon_sym_PIPE] = ACTIONS(251),
    [anon_sym_SEMI_SEMI] = ACTIONS(247),
    [anon_sym_PIPE_AMP] = ACTIONS(247),
    [anon_sym_AMP_AMP] = ACTIONS(247),
    [anon_sym_PIPE_PIPE] = ACTIONS(247),
    [anon_sym_EQ_TILDE] = ACTIONS(251),
    [anon_sym_EQ_EQ] = ACTIONS(251),
    [anon_sym_LT] = ACTIONS(251),
    [anon_sym_GT] = ACTIONS(251),
    [anon_sym_GT_GT] = ACTIONS(247),
    [anon_sym_AMP_GT] = ACTIONS(251),
    [anon_sym_AMP_GT_GT] = ACTIONS(247),
    [anon_sym_LT_AMP] = ACTIONS(247),
    [anon_sym_GT_AMP] = ACTIONS(247),
    [anon_sym_LT_LT] = ACTIONS(251),
    [anon_sym_LT_LT_DASH] = ACTIONS(247),
    [anon_sym_LT_LT_LT] = ACTIONS(247),
    [sym__special_characters] = ACTIONS(247),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(251),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [anon_sym_BQUOTE] = ACTIONS(247),
    [anon_sym_LT_LPAREN] = ACTIONS(247),
    [anon_sym_GT_LPAREN] = ACTIONS(247),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(251),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(251),
  },
  [19] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(147),
    [anon_sym_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [20] = {
    [sym_string] = STATE(149),
    [anon_sym_DASH] = ACTIONS(267),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(267),
    [sym_raw_string] = ACTIONS(269),
    [anon_sym_POUND] = ACTIONS(267),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(271),
    [anon_sym_STAR] = ACTIONS(273),
    [anon_sym_AT] = ACTIONS(273),
    [anon_sym_QMARK] = ACTIONS(273),
    [anon_sym_0] = ACTIONS(271),
    [anon_sym__] = ACTIONS(271),
  },
  [21] = {
    [aux_sym_concatenation_repeat1] = STATE(140),
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [22] = {
    [sym_subscript] = STATE(154),
    [sym_variable_name] = ACTIONS(279),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DOLLAR] = ACTIONS(283),
    [anon_sym_POUND] = ACTIONS(281),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(285),
    [anon_sym_STAR] = ACTIONS(287),
    [anon_sym_AT] = ACTIONS(287),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_0] = ACTIONS(285),
    [anon_sym__] = ACTIONS(285),
  },
  [23] = {
    [sym__terminated_statement] = STATE(157),
    [sym_redirected_statement] = STATE(155),
    [sym_for_statement] = STATE(155),
    [sym_c_style_for_statement] = STATE(155),
    [sym_while_statement] = STATE(155),
    [sym_if_statement] = STATE(155),
    [sym_case_statement] = STATE(155),
    [sym_function_definition] = STATE(155),
    [sym_compound_statement] = STATE(155),
    [sym_subshell] = STATE(155),
    [sym_pipeline] = STATE(155),
    [sym_list] = STATE(155),
    [sym_negated_command] = STATE(155),
    [sym_test_command] = STATE(155),
    [sym_declaration_command] = STATE(155),
    [sym_unset_command] = STATE(155),
    [sym_command] = STATE(155),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(156),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(157),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [24] = {
    [sym__terminated_statement] = STATE(164),
    [sym_redirected_statement] = STATE(161),
    [sym_for_statement] = STATE(161),
    [sym_c_style_for_statement] = STATE(161),
    [sym_while_statement] = STATE(161),
    [sym_if_statement] = STATE(161),
    [sym_case_statement] = STATE(161),
    [sym_function_definition] = STATE(161),
    [sym_compound_statement] = STATE(161),
    [sym_subshell] = STATE(161),
    [sym_pipeline] = STATE(161),
    [sym_list] = STATE(161),
    [sym_negated_command] = STATE(161),
    [sym_test_command] = STATE(161),
    [sym_declaration_command] = STATE(161),
    [sym_unset_command] = STATE(161),
    [sym_command] = STATE(161),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(163),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(164),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [25] = {
    [sym__terminated_statement] = STATE(168),
    [sym_redirected_statement] = STATE(166),
    [sym_for_statement] = STATE(166),
    [sym_c_style_for_statement] = STATE(166),
    [sym_while_statement] = STATE(166),
    [sym_if_statement] = STATE(166),
    [sym_case_statement] = STATE(166),
    [sym_function_definition] = STATE(166),
    [sym_compound_statement] = STATE(166),
    [sym_subshell] = STATE(166),
    [sym_pipeline] = STATE(166),
    [sym_list] = STATE(166),
    [sym_negated_command] = STATE(166),
    [sym_test_command] = STATE(166),
    [sym_declaration_command] = STATE(166),
    [sym_unset_command] = STATE(166),
    [sym_command] = STATE(166),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(167),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(168),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [26] = {
    [aux_sym_concatenation_repeat1] = STATE(140),
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [27] = {
    [ts_builtin_sym_end] = ACTIONS(297),
    [sym_comment] = ACTIONS(57),
  },
  [28] = {
    [sym_file_redirect] = STATE(180),
    [sym_heredoc_redirect] = STATE(180),
    [sym_heredoc_body] = STATE(179),
    [sym_herestring_redirect] = STATE(180),
    [aux_sym_redirected_statement_repeat1] = STATE(180),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(303),
    [ts_builtin_sym_end] = ACTIONS(305),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym_PIPE] = ACTIONS(309),
    [anon_sym_SEMI_SEMI] = ACTIONS(311),
    [anon_sym_PIPE_AMP] = ACTIONS(313),
    [anon_sym_AMP_AMP] = ACTIONS(315),
    [anon_sym_PIPE_PIPE] = ACTIONS(315),
    [anon_sym_LT] = ACTIONS(317),
    [anon_sym_GT] = ACTIONS(317),
    [anon_sym_GT_GT] = ACTIONS(319),
    [anon_sym_AMP_GT] = ACTIONS(317),
    [anon_sym_AMP_GT_GT] = ACTIONS(319),
    [anon_sym_LT_AMP] = ACTIONS(319),
    [anon_sym_GT_AMP] = ACTIONS(319),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(311),
    [anon_sym_AMP] = ACTIONS(307),
  },
  [29] = {
    [sym_concatenation] = STATE(184),
    [sym_string] = STATE(183),
    [sym_simple_expansion] = STATE(183),
    [sym_string_expansion] = STATE(183),
    [sym_expansion] = STATE(183),
    [sym_command_substitution] = STATE(183),
    [sym_process_substitution] = STATE(183),
    [aux_sym_command_repeat2] = STATE(184),
    [sym__simple_heredoc_body] = ACTIONS(327),
    [sym__heredoc_body_beginning] = ACTIONS(327),
    [sym_file_descriptor] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(327),
    [anon_sym_PIPE_AMP] = ACTIONS(327),
    [anon_sym_AMP_AMP] = ACTIONS(327),
    [anon_sym_PIPE_PIPE] = ACTIONS(327),
    [anon_sym_EQ_TILDE] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(327),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(327),
    [anon_sym_LT_AMP] = ACTIONS(327),
    [anon_sym_GT_AMP] = ACTIONS(327),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(327),
    [anon_sym_LT_LT_LT] = ACTIONS(327),
    [sym__special_characters] = ACTIONS(333),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(337),
    [anon_sym_LF] = ACTIONS(327),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [30] = {
    [sym_file_redirect] = STATE(180),
    [sym_heredoc_redirect] = STATE(180),
    [sym_heredoc_body] = STATE(179),
    [sym_herestring_redirect] = STATE(180),
    [aux_sym_redirected_statement_repeat1] = STATE(180),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [ts_builtin_sym_end] = ACTIONS(305),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym_PIPE] = ACTIONS(309),
    [anon_sym_SEMI_SEMI] = ACTIONS(311),
    [anon_sym_PIPE_AMP] = ACTIONS(313),
    [anon_sym_AMP_AMP] = ACTIONS(315),
    [anon_sym_PIPE_PIPE] = ACTIONS(315),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(311),
    [anon_sym_AMP] = ACTIONS(307),
  },
  [31] = {
    [anon_sym_EQ] = ACTIONS(67),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [sym_comment] = ACTIONS(57),
  },
  [32] = {
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [ts_builtin_sym_end] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(275),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [33] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(185),
    [sym_for_statement] = STATE(185),
    [sym_c_style_for_statement] = STATE(185),
    [sym_while_statement] = STATE(185),
    [sym_if_statement] = STATE(185),
    [sym_case_statement] = STATE(185),
    [sym_function_definition] = STATE(185),
    [sym_compound_statement] = STATE(185),
    [sym_subshell] = STATE(185),
    [sym_pipeline] = STATE(185),
    [sym_list] = STATE(185),
    [sym_negated_command] = STATE(185),
    [sym_test_command] = STATE(185),
    [sym_declaration_command] = STATE(185),
    [sym_unset_command] = STATE(185),
    [sym_command] = STATE(185),
    [sym_command_name] = STATE(29),
    [sym_variable_assignment] = STATE(186),
    [sym_subscript] = STATE(31),
    [sym_file_redirect] = STATE(34),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(34),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(33),
    [anon_sym_typeset] = ACTIONS(33),
    [anon_sym_export] = ACTIONS(33),
    [anon_sym_readonly] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym_unset] = ACTIONS(35),
    [anon_sym_unsetenv] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(41),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(59),
  },
  [34] = {
    [sym_command_name] = STATE(188),
    [sym_variable_assignment] = STATE(189),
    [sym_subscript] = STATE(94),
    [sym_file_redirect] = STATE(189),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym_command_repeat1] = STATE(189),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(145),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(47),
  },
  [35] = {
    [sym_concatenation] = STATE(192),
    [sym_string] = STATE(191),
    [sym_simple_expansion] = STATE(191),
    [sym_string_expansion] = STATE(191),
    [sym_expansion] = STATE(191),
    [sym_command_substitution] = STATE(191),
    [sym_process_substitution] = STATE(191),
    [sym__special_characters] = ACTIONS(345),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_raw_string] = ACTIONS(347),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(241),
    [anon_sym_BQUOTE] = ACTIONS(243),
    [anon_sym_LT_LPAREN] = ACTIONS(245),
    [anon_sym_GT_LPAREN] = ACTIONS(245),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(347),
  },
  [36] = {
    [sym_concatenation] = STATE(195),
    [sym_string] = STATE(194),
    [sym_simple_expansion] = STATE(194),
    [sym_string_expansion] = STATE(194),
    [sym_expansion] = STATE(194),
    [sym_command_substitution] = STATE(194),
    [sym_process_substitution] = STATE(194),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [sym_raw_string] = ACTIONS(351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(351),
  },
  [37] = {
    [sym_concatenation] = STATE(196),
    [sym_string] = STATE(201),
    [sym_array] = STATE(196),
    [sym_simple_expansion] = STATE(201),
    [sym_string_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [sym_process_substitution] = STATE(201),
    [sym__empty_value] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(355),
    [sym__special_characters] = ACTIONS(357),
    [anon_sym_DQUOTE] = ACTIONS(359),
    [anon_sym_DOLLAR] = ACTIONS(361),
    [sym_raw_string] = ACTIONS(363),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(365),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(363),
  },
  [38] = {
    [sym__expression] = STATE(217),
    [sym_binary_expression] = STATE(217),
    [sym_unary_expression] = STATE(217),
    [sym_postfix_expression] = STATE(217),
    [sym_parenthesized_expression] = STATE(217),
    [sym_concatenation] = STATE(217),
    [sym_string] = STATE(212),
    [sym_simple_expansion] = STATE(212),
    [sym_string_expansion] = STATE(212),
    [sym_expansion] = STATE(212),
    [sym_command_substitution] = STATE(212),
    [sym_process_substitution] = STATE(212),
    [anon_sym_SEMI] = ACTIONS(373),
    [anon_sym_SEMI_SEMI] = ACTIONS(375),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_BANG] = ACTIONS(379),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(391),
    [anon_sym_BQUOTE] = ACTIONS(393),
    [anon_sym_LT_LPAREN] = ACTIONS(395),
    [anon_sym_GT_LPAREN] = ACTIONS(395),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(397),
    [sym_test_operator] = ACTIONS(399),
    [anon_sym_LF] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
  },
  [39] = {
    [anon_sym_in] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(405),
  },
  [40] = {
    [sym__expression] = STATE(230),
    [sym_binary_expression] = STATE(230),
    [sym_unary_expression] = STATE(230),
    [sym_postfix_expression] = STATE(230),
    [sym_parenthesized_expression] = STATE(230),
    [sym_concatenation] = STATE(230),
    [sym_string] = STATE(225),
    [sym_simple_expansion] = STATE(225),
    [sym_string_expansion] = STATE(225),
    [sym_expansion] = STATE(225),
    [sym_command_substitution] = STATE(225),
    [sym_process_substitution] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_BANG] = ACTIONS(409),
    [sym__special_characters] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [sym_raw_string] = ACTIONS(417),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(421),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(425),
    [anon_sym_GT_LPAREN] = ACTIONS(425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(427),
    [sym_test_operator] = ACTIONS(429),
  },
  [41] = {
    [sym__expression] = STATE(231),
    [sym_binary_expression] = STATE(231),
    [sym_unary_expression] = STATE(231),
    [sym_postfix_expression] = STATE(231),
    [sym_parenthesized_expression] = STATE(231),
    [sym_concatenation] = STATE(231),
    [sym_string] = STATE(45),
    [sym_simple_expansion] = STATE(45),
    [sym_string_expansion] = STATE(45),
    [sym_expansion] = STATE(45),
    [sym_command_substitution] = STATE(45),
    [sym_process_substitution] = STATE(45),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [42] = {
    [aux_sym_concatenation_repeat1] = STATE(233),
    [sym__concat] = ACTIONS(431),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_EQ_TILDE] = ACTIONS(433),
    [anon_sym_EQ_EQ] = ACTIONS(433),
    [anon_sym_EQ] = ACTIONS(435),
    [anon_sym_PLUS_EQ] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_BANG_EQ] = ACTIONS(433),
    [anon_sym_PLUS] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(435),
    [anon_sym_DASH_EQ] = ACTIONS(433),
    [anon_sym_LT_EQ] = ACTIONS(433),
    [anon_sym_GT_EQ] = ACTIONS(433),
    [anon_sym_PLUS_PLUS] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(433),
  },
  [43] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(236),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [44] = {
    [sym_string] = STATE(238),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(441),
    [sym_raw_string] = ACTIONS(443),
    [anon_sym_POUND] = ACTIONS(441),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(445),
    [anon_sym_STAR] = ACTIONS(447),
    [anon_sym_AT] = ACTIONS(447),
    [anon_sym_QMARK] = ACTIONS(447),
    [anon_sym_0] = ACTIONS(445),
    [anon_sym__] = ACTIONS(445),
  },
  [45] = {
    [aux_sym_concatenation_repeat1] = STATE(233),
    [sym__concat] = ACTIONS(431),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(451),
    [anon_sym_GT] = ACTIONS(451),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(451),
    [anon_sym_DASH] = ACTIONS(451),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(449),
  },
  [46] = {
    [sym_subscript] = STATE(243),
    [sym_variable_name] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(455),
    [anon_sym_DASH] = ACTIONS(457),
    [anon_sym_DOLLAR] = ACTIONS(457),
    [anon_sym_POUND] = ACTIONS(455),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AT] = ACTIONS(461),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_0] = ACTIONS(459),
    [anon_sym__] = ACTIONS(459),
  },
  [47] = {
    [sym__terminated_statement] = STATE(246),
    [sym_redirected_statement] = STATE(244),
    [sym_for_statement] = STATE(244),
    [sym_c_style_for_statement] = STATE(244),
    [sym_while_statement] = STATE(244),
    [sym_if_statement] = STATE(244),
    [sym_case_statement] = STATE(244),
    [sym_function_definition] = STATE(244),
    [sym_compound_statement] = STATE(244),
    [sym_subshell] = STATE(244),
    [sym_pipeline] = STATE(244),
    [sym_list] = STATE(244),
    [sym_negated_command] = STATE(244),
    [sym_test_command] = STATE(244),
    [sym_declaration_command] = STATE(244),
    [sym_unset_command] = STATE(244),
    [sym_command] = STATE(244),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(245),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(246),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [48] = {
    [sym__terminated_statement] = STATE(249),
    [sym_redirected_statement] = STATE(247),
    [sym_for_statement] = STATE(247),
    [sym_c_style_for_statement] = STATE(247),
    [sym_while_statement] = STATE(247),
    [sym_if_statement] = STATE(247),
    [sym_case_statement] = STATE(247),
    [sym_function_definition] = STATE(247),
    [sym_compound_statement] = STATE(247),
    [sym_subshell] = STATE(247),
    [sym_pipeline] = STATE(247),
    [sym_list] = STATE(247),
    [sym_negated_command] = STATE(247),
    [sym_test_command] = STATE(247),
    [sym_declaration_command] = STATE(247),
    [sym_unset_command] = STATE(247),
    [sym_command] = STATE(247),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(248),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(249),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [49] = {
    [sym__terminated_statement] = STATE(252),
    [sym_redirected_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_c_style_for_statement] = STATE(250),
    [sym_while_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_case_statement] = STATE(250),
    [sym_function_definition] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_subshell] = STATE(250),
    [sym_pipeline] = STATE(250),
    [sym_list] = STATE(250),
    [sym_negated_command] = STATE(250),
    [sym_test_command] = STATE(250),
    [sym_declaration_command] = STATE(250),
    [sym_unset_command] = STATE(250),
    [sym_command] = STATE(250),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(251),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(252),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [50] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE_PIPE] = ACTIONS(465),
    [anon_sym_EQ_TILDE] = ACTIONS(467),
    [anon_sym_EQ_EQ] = ACTIONS(467),
    [anon_sym_EQ] = ACTIONS(469),
    [anon_sym_PLUS_EQ] = ACTIONS(465),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_BANG_EQ] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(469),
    [anon_sym_DASH] = ACTIONS(469),
    [anon_sym_DASH_EQ] = ACTIONS(465),
    [anon_sym_LT_EQ] = ACTIONS(465),
    [anon_sym_GT_EQ] = ACTIONS(465),
    [anon_sym_PLUS_PLUS] = ACTIONS(471),
    [anon_sym_DASH_DASH] = ACTIONS(471),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(465),
  },
  [51] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_PLUS_EQ] = ACTIONS(473),
    [sym_comment] = ACTIONS(57),
  },
  [52] = {
    [sym_subshell] = STATE(93),
    [sym_test_command] = STATE(93),
    [sym_command] = STATE(93),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(63),
    [sym_subscript] = STATE(94),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(145),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(107),
  },
  [53] = {
    [sym_variable_assignment] = STATE(262),
    [sym_subscript] = STATE(261),
    [sym_concatenation] = STATE(262),
    [sym_string] = STATE(260),
    [sym_simple_expansion] = STATE(260),
    [sym_string_expansion] = STATE(260),
    [sym_expansion] = STATE(260),
    [sym_command_substitution] = STATE(260),
    [sym_process_substitution] = STATE(260),
    [aux_sym_declaration_command_repeat1] = STATE(262),
    [sym__simple_heredoc_body] = ACTIONS(181),
    [sym__heredoc_body_beginning] = ACTIONS(181),
    [sym_file_descriptor] = ACTIONS(181),
    [sym_variable_name] = ACTIONS(475),
    [anon_sym_SEMI] = ACTIONS(185),
    [anon_sym_PIPE] = ACTIONS(185),
    [anon_sym_SEMI_SEMI] = ACTIONS(181),
    [anon_sym_PIPE_AMP] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_GT] = ACTIONS(185),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_AMP_GT] = ACTIONS(185),
    [anon_sym_AMP_GT_GT] = ACTIONS(181),
    [anon_sym_LT_AMP] = ACTIONS(181),
    [anon_sym_GT_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(185),
    [anon_sym_LT_LT_DASH] = ACTIONS(181),
    [anon_sym_LT_LT_LT] = ACTIONS(181),
    [sym__special_characters] = ACTIONS(477),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(479),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(481),
    [sym_word] = ACTIONS(483),
    [anon_sym_LF] = ACTIONS(181),
    [anon_sym_AMP] = ACTIONS(185),
  },
  [54] = {
    [sym_concatenation] = STATE(265),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [aux_sym_unset_command_repeat1] = STATE(265),
    [sym__simple_heredoc_body] = ACTIONS(207),
    [sym__heredoc_body_beginning] = ACTIONS(207),
    [sym_file_descriptor] = ACTIONS(207),
    [anon_sym_SEMI] = ACTIONS(209),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_SEMI_SEMI] = ACTIONS(207),
    [anon_sym_PIPE_AMP] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_GT] = ACTIONS(209),
    [anon_sym_AMP_GT_GT] = ACTIONS(207),
    [anon_sym_LT_AMP] = ACTIONS(207),
    [anon_sym_GT_AMP] = ACTIONS(207),
    [anon_sym_LT_LT] = ACTIONS(209),
    [anon_sym_LT_LT_DASH] = ACTIONS(207),
    [anon_sym_LT_LT_LT] = ACTIONS(207),
    [sym__special_characters] = ACTIONS(485),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(487),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(489),
    [sym_word] = ACTIONS(491),
    [anon_sym_LF] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(209),
  },
  [55] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(251),
    [anon_sym_PIPE] = ACTIONS(251),
    [anon_sym_SEMI_SEMI] = ACTIONS(247),
    [anon_sym_PIPE_AMP] = ACTIONS(247),
    [anon_sym_AMP_AMP] = ACTIONS(247),
    [anon_sym_PIPE_PIPE] = ACTIONS(247),
    [anon_sym_EQ_TILDE] = ACTIONS(251),
    [anon_sym_EQ_EQ] = ACTIONS(251),
    [anon_sym_LT] = ACTIONS(251),
    [anon_sym_GT] = ACTIONS(251),
    [anon_sym_GT_GT] = ACTIONS(247),
    [anon_sym_AMP_GT] = ACTIONS(251),
    [anon_sym_AMP_GT_GT] = ACTIONS(247),
    [anon_sym_LT_AMP] = ACTIONS(247),
    [anon_sym_GT_AMP] = ACTIONS(247),
    [anon_sym_LT_LT] = ACTIONS(251),
    [anon_sym_LT_LT_DASH] = ACTIONS(247),
    [anon_sym_LT_LT_LT] = ACTIONS(247),
    [sym__special_characters] = ACTIONS(247),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(251),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [anon_sym_BQUOTE] = ACTIONS(247),
    [anon_sym_LT_LPAREN] = ACTIONS(247),
    [anon_sym_GT_LPAREN] = ACTIONS(247),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(251),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(251),
  },
  [56] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [57] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [58] = {
    [sym_do_group] = STATE(268),
    [anon_sym_do] = ACTIONS(493),
    [sym_comment] = ACTIONS(57),
  },
  [59] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(275),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(497),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(501),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(507),
    [anon_sym_GT_GT] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(507),
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(497),
  },
  [60] = {
    [sym_concatenation] = STATE(280),
    [sym_string] = STATE(279),
    [sym_simple_expansion] = STATE(279),
    [sym_string_expansion] = STATE(279),
    [sym_expansion] = STATE(279),
    [sym_command_substitution] = STATE(279),
    [sym_process_substitution] = STATE(279),
    [aux_sym_command_repeat2] = STATE(280),
    [sym__simple_heredoc_body] = ACTIONS(327),
    [sym__heredoc_body_beginning] = ACTIONS(327),
    [sym_file_descriptor] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(327),
    [anon_sym_PIPE_AMP] = ACTIONS(327),
    [anon_sym_AMP_AMP] = ACTIONS(327),
    [anon_sym_PIPE_PIPE] = ACTIONS(327),
    [anon_sym_EQ_TILDE] = ACTIONS(513),
    [anon_sym_EQ_EQ] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(327),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(327),
    [anon_sym_LT_AMP] = ACTIONS(327),
    [anon_sym_GT_AMP] = ACTIONS(327),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(327),
    [anon_sym_LT_LT_LT] = ACTIONS(327),
    [sym__special_characters] = ACTIONS(515),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(517),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(327),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [61] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(275),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(497),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(501),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(497),
  },
  [62] = {
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_PLUS_EQ] = ACTIONS(473),
    [sym_comment] = ACTIONS(57),
  },
  [63] = {
    [sym_command_name] = STATE(281),
    [sym_variable_assignment] = STATE(189),
    [sym_subscript] = STATE(94),
    [sym_file_redirect] = STATE(189),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym_command_repeat1] = STATE(189),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(145),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(107),
  },
  [64] = {
    [anon_sym_then] = ACTIONS(523),
    [sym_comment] = ACTIONS(57),
  },
  [65] = {
    [aux_sym_concatenation_repeat1] = STATE(286),
    [sym__concat] = ACTIONS(525),
    [anon_sym_in] = ACTIONS(527),
    [anon_sym_SEMI] = ACTIONS(529),
    [anon_sym_SEMI_SEMI] = ACTIONS(531),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(531),
    [anon_sym_AMP] = ACTIONS(531),
  },
  [66] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(289),
    [anon_sym_DQUOTE] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(535),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [67] = {
    [sym_string] = STATE(291),
    [anon_sym_DASH] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [sym_raw_string] = ACTIONS(539),
    [anon_sym_POUND] = ACTIONS(537),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(541),
    [anon_sym_STAR] = ACTIONS(543),
    [anon_sym_AT] = ACTIONS(543),
    [anon_sym_QMARK] = ACTIONS(543),
    [anon_sym_0] = ACTIONS(541),
    [anon_sym__] = ACTIONS(541),
  },
  [68] = {
    [aux_sym_concatenation_repeat1] = STATE(286),
    [sym__concat] = ACTIONS(525),
    [anon_sym_in] = ACTIONS(545),
    [anon_sym_SEMI] = ACTIONS(547),
    [anon_sym_SEMI_SEMI] = ACTIONS(549),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(549),
    [anon_sym_AMP] = ACTIONS(549),
  },
  [69] = {
    [sym_subscript] = STATE(298),
    [sym_variable_name] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_POUND] = ACTIONS(553),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(557),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_0] = ACTIONS(557),
    [anon_sym__] = ACTIONS(557),
  },
  [70] = {
    [sym__terminated_statement] = STATE(301),
    [sym_redirected_statement] = STATE(299),
    [sym_for_statement] = STATE(299),
    [sym_c_style_for_statement] = STATE(299),
    [sym_while_statement] = STATE(299),
    [sym_if_statement] = STATE(299),
    [sym_case_statement] = STATE(299),
    [sym_function_definition] = STATE(299),
    [sym_compound_statement] = STATE(299),
    [sym_subshell] = STATE(299),
    [sym_pipeline] = STATE(299),
    [sym_list] = STATE(299),
    [sym_negated_command] = STATE(299),
    [sym_test_command] = STATE(299),
    [sym_declaration_command] = STATE(299),
    [sym_unset_command] = STATE(299),
    [sym_command] = STATE(299),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(300),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(301),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [71] = {
    [sym__terminated_statement] = STATE(304),
    [sym_redirected_statement] = STATE(302),
    [sym_for_statement] = STATE(302),
    [sym_c_style_for_statement] = STATE(302),
    [sym_while_statement] = STATE(302),
    [sym_if_statement] = STATE(302),
    [sym_case_statement] = STATE(302),
    [sym_function_definition] = STATE(302),
    [sym_compound_statement] = STATE(302),
    [sym_subshell] = STATE(302),
    [sym_pipeline] = STATE(302),
    [sym_list] = STATE(302),
    [sym_negated_command] = STATE(302),
    [sym_test_command] = STATE(302),
    [sym_declaration_command] = STATE(302),
    [sym_unset_command] = STATE(302),
    [sym_command] = STATE(302),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(303),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(304),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [72] = {
    [sym__terminated_statement] = STATE(307),
    [sym_redirected_statement] = STATE(305),
    [sym_for_statement] = STATE(305),
    [sym_c_style_for_statement] = STATE(305),
    [sym_while_statement] = STATE(305),
    [sym_if_statement] = STATE(305),
    [sym_case_statement] = STATE(305),
    [sym_function_definition] = STATE(305),
    [sym_compound_statement] = STATE(305),
    [sym_subshell] = STATE(305),
    [sym_pipeline] = STATE(305),
    [sym_list] = STATE(305),
    [sym_negated_command] = STATE(305),
    [sym_test_command] = STATE(305),
    [sym_declaration_command] = STATE(305),
    [sym_unset_command] = STATE(305),
    [sym_command] = STATE(305),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(306),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(307),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [73] = {
    [anon_sym_in] = ACTIONS(545),
    [anon_sym_SEMI] = ACTIONS(547),
    [anon_sym_SEMI_SEMI] = ACTIONS(549),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(549),
    [anon_sym_AMP] = ACTIONS(549),
  },
  [74] = {
    [sym_compound_statement] = STATE(309),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [75] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
  },
  [76] = {
    [sym_subshell] = STATE(93),
    [sym_test_command] = STATE(93),
    [sym_command] = STATE(93),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(87),
    [sym_subscript] = STATE(94),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(145),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(139),
  },
  [77] = {
    [sym_variable_assignment] = STATE(315),
    [sym_subscript] = STATE(314),
    [sym_concatenation] = STATE(315),
    [sym_string] = STATE(313),
    [sym_simple_expansion] = STATE(313),
    [sym_string_expansion] = STATE(313),
    [sym_expansion] = STATE(313),
    [sym_command_substitution] = STATE(313),
    [sym_process_substitution] = STATE(313),
    [aux_sym_declaration_command_repeat1] = STATE(315),
    [sym__simple_heredoc_body] = ACTIONS(181),
    [sym__heredoc_body_beginning] = ACTIONS(181),
    [sym_file_descriptor] = ACTIONS(181),
    [sym_variable_name] = ACTIONS(565),
    [anon_sym_SEMI] = ACTIONS(185),
    [anon_sym_PIPE] = ACTIONS(185),
    [anon_sym_RPAREN] = ACTIONS(181),
    [anon_sym_SEMI_SEMI] = ACTIONS(181),
    [anon_sym_PIPE_AMP] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_GT] = ACTIONS(185),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_AMP_GT] = ACTIONS(185),
    [anon_sym_AMP_GT_GT] = ACTIONS(181),
    [anon_sym_LT_AMP] = ACTIONS(181),
    [anon_sym_GT_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(185),
    [anon_sym_LT_LT_DASH] = ACTIONS(181),
    [anon_sym_LT_LT_LT] = ACTIONS(181),
    [sym__special_characters] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(569),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(571),
    [sym_word] = ACTIONS(573),
    [anon_sym_LF] = ACTIONS(181),
    [anon_sym_AMP] = ACTIONS(185),
  },
  [78] = {
    [sym_concatenation] = STATE(318),
    [sym_string] = STATE(317),
    [sym_simple_expansion] = STATE(317),
    [sym_string_expansion] = STATE(317),
    [sym_expansion] = STATE(317),
    [sym_command_substitution] = STATE(317),
    [sym_process_substitution] = STATE(317),
    [aux_sym_unset_command_repeat1] = STATE(318),
    [sym__simple_heredoc_body] = ACTIONS(207),
    [sym__heredoc_body_beginning] = ACTIONS(207),
    [sym_file_descriptor] = ACTIONS(207),
    [anon_sym_SEMI] = ACTIONS(209),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_SEMI_SEMI] = ACTIONS(207),
    [anon_sym_PIPE_AMP] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_GT] = ACTIONS(209),
    [anon_sym_AMP_GT_GT] = ACTIONS(207),
    [anon_sym_LT_AMP] = ACTIONS(207),
    [anon_sym_GT_AMP] = ACTIONS(207),
    [anon_sym_LT_LT] = ACTIONS(209),
    [anon_sym_LT_LT_DASH] = ACTIONS(207),
    [anon_sym_LT_LT_LT] = ACTIONS(207),
    [sym__special_characters] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(579),
    [sym_word] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(209),
  },
  [79] = {
    [aux_sym_concatenation_repeat1] = STATE(319),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(251),
    [anon_sym_PIPE] = ACTIONS(251),
    [anon_sym_RPAREN] = ACTIONS(247),
    [anon_sym_SEMI_SEMI] = ACTIONS(247),
    [anon_sym_PIPE_AMP] = ACTIONS(247),
    [anon_sym_AMP_AMP] = ACTIONS(247),
    [anon_sym_PIPE_PIPE] = ACTIONS(247),
    [anon_sym_EQ_TILDE] = ACTIONS(251),
    [anon_sym_EQ_EQ] = ACTIONS(251),
    [anon_sym_LT] = ACTIONS(251),
    [anon_sym_GT] = ACTIONS(251),
    [anon_sym_GT_GT] = ACTIONS(247),
    [anon_sym_AMP_GT] = ACTIONS(251),
    [anon_sym_AMP_GT_GT] = ACTIONS(247),
    [anon_sym_LT_AMP] = ACTIONS(247),
    [anon_sym_GT_AMP] = ACTIONS(247),
    [anon_sym_LT_LT] = ACTIONS(251),
    [anon_sym_LT_LT_DASH] = ACTIONS(247),
    [anon_sym_LT_LT_LT] = ACTIONS(247),
    [sym__special_characters] = ACTIONS(247),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(251),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [anon_sym_BQUOTE] = ACTIONS(247),
    [anon_sym_LT_LPAREN] = ACTIONS(247),
    [anon_sym_GT_LPAREN] = ACTIONS(247),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(251),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(251),
  },
  [80] = {
    [aux_sym_concatenation_repeat1] = STATE(319),
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(275),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [81] = {
    [aux_sym_concatenation_repeat1] = STATE(319),
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(275),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [82] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(327),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(585),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(589),
    [anon_sym_SEMI_SEMI] = ACTIONS(591),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(585),
  },
  [83] = {
    [sym_concatenation] = STATE(332),
    [sym_string] = STATE(331),
    [sym_simple_expansion] = STATE(331),
    [sym_string_expansion] = STATE(331),
    [sym_expansion] = STATE(331),
    [sym_command_substitution] = STATE(331),
    [sym_process_substitution] = STATE(331),
    [aux_sym_command_repeat2] = STATE(332),
    [sym__simple_heredoc_body] = ACTIONS(327),
    [sym__heredoc_body_beginning] = ACTIONS(327),
    [sym_file_descriptor] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_RPAREN] = ACTIONS(327),
    [anon_sym_SEMI_SEMI] = ACTIONS(327),
    [anon_sym_PIPE_AMP] = ACTIONS(327),
    [anon_sym_AMP_AMP] = ACTIONS(327),
    [anon_sym_PIPE_PIPE] = ACTIONS(327),
    [anon_sym_EQ_TILDE] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(603),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(327),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(327),
    [anon_sym_LT_AMP] = ACTIONS(327),
    [anon_sym_GT_AMP] = ACTIONS(327),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(327),
    [anon_sym_LT_LT_LT] = ACTIONS(327),
    [sym__special_characters] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(607),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(609),
    [anon_sym_LF] = ACTIONS(327),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [84] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(327),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(585),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(589),
    [anon_sym_SEMI_SEMI] = ACTIONS(591),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(585),
  },
  [85] = {
    [anon_sym_EQ] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
  },
  [86] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(333),
    [sym_for_statement] = STATE(333),
    [sym_c_style_for_statement] = STATE(333),
    [sym_while_statement] = STATE(333),
    [sym_if_statement] = STATE(333),
    [sym_case_statement] = STATE(333),
    [sym_function_definition] = STATE(333),
    [sym_compound_statement] = STATE(333),
    [sym_subshell] = STATE(333),
    [sym_pipeline] = STATE(333),
    [sym_list] = STATE(333),
    [sym_negated_command] = STATE(333),
    [sym_test_command] = STATE(333),
    [sym_declaration_command] = STATE(333),
    [sym_unset_command] = STATE(333),
    [sym_command] = STATE(333),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(334),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [87] = {
    [sym_command_name] = STATE(335),
    [sym_variable_assignment] = STATE(189),
    [sym_subscript] = STATE(94),
    [sym_file_redirect] = STATE(189),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym_command_repeat1] = STATE(189),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(145),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(611),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(139),
  },
  [88] = {
    [sym__simple_heredoc_body] = ACTIONS(613),
    [sym__heredoc_body_beginning] = ACTIONS(613),
    [sym_file_descriptor] = ACTIONS(613),
    [ts_builtin_sym_end] = ACTIONS(613),
    [anon_sym_SEMI] = ACTIONS(615),
    [anon_sym_esac] = ACTIONS(613),
    [anon_sym_PIPE] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(613),
    [anon_sym_SEMI_SEMI] = ACTIONS(613),
    [anon_sym_PIPE_AMP] = ACTIONS(613),
    [anon_sym_AMP_AMP] = ACTIONS(613),
    [anon_sym_PIPE_PIPE] = ACTIONS(613),
    [anon_sym_LT] = ACTIONS(615),
    [anon_sym_GT] = ACTIONS(615),
    [anon_sym_GT_GT] = ACTIONS(613),
    [anon_sym_AMP_GT] = ACTIONS(615),
    [anon_sym_AMP_GT_GT] = ACTIONS(613),
    [anon_sym_LT_AMP] = ACTIONS(613),
    [anon_sym_GT_AMP] = ACTIONS(613),
    [anon_sym_LT_LT] = ACTIONS(615),
    [anon_sym_LT_LT_DASH] = ACTIONS(613),
    [anon_sym_LT_LT_LT] = ACTIONS(613),
    [anon_sym_BQUOTE] = ACTIONS(613),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(615),
  },
  [89] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(337),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(619),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(507),
    [anon_sym_GT_GT] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(507),
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(617),
  },
  [90] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(337),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(619),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(617),
  },
  [91] = {
    [sym__terminated_statement] = STATE(339),
    [sym_redirected_statement] = STATE(89),
    [sym_for_statement] = STATE(89),
    [sym_c_style_for_statement] = STATE(89),
    [sym_while_statement] = STATE(89),
    [sym_if_statement] = STATE(89),
    [sym_case_statement] = STATE(89),
    [sym_function_definition] = STATE(89),
    [sym_compound_statement] = STATE(89),
    [sym_subshell] = STATE(89),
    [sym_pipeline] = STATE(89),
    [sym_list] = STATE(89),
    [sym_negated_command] = STATE(89),
    [sym_test_command] = STATE(89),
    [sym_declaration_command] = STATE(89),
    [sym_unset_command] = STATE(89),
    [sym_command] = STATE(89),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(90),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(339),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_RBRACE] = ACTIONS(621),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [92] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [sym_comment] = ACTIONS(57),
  },
  [93] = {
    [sym__simple_heredoc_body] = ACTIONS(625),
    [sym__heredoc_body_beginning] = ACTIONS(625),
    [sym_file_descriptor] = ACTIONS(625),
    [ts_builtin_sym_end] = ACTIONS(625),
    [anon_sym_SEMI] = ACTIONS(627),
    [anon_sym_esac] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_RPAREN] = ACTIONS(625),
    [anon_sym_SEMI_SEMI] = ACTIONS(625),
    [anon_sym_PIPE_AMP] = ACTIONS(625),
    [anon_sym_AMP_AMP] = ACTIONS(625),
    [anon_sym_PIPE_PIPE] = ACTIONS(625),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(625),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_AMP_GT_GT] = ACTIONS(625),
    [anon_sym_LT_AMP] = ACTIONS(625),
    [anon_sym_GT_AMP] = ACTIONS(625),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(625),
    [anon_sym_LT_LT_LT] = ACTIONS(625),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(627),
  },
  [94] = {
    [anon_sym_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [sym_comment] = ACTIONS(57),
  },
  [95] = {
    [sym__expression] = STATE(341),
    [sym_binary_expression] = STATE(341),
    [sym_unary_expression] = STATE(341),
    [sym_postfix_expression] = STATE(341),
    [sym_parenthesized_expression] = STATE(341),
    [sym_concatenation] = STATE(341),
    [sym_string] = STATE(225),
    [sym_simple_expansion] = STATE(225),
    [sym_string_expansion] = STATE(225),
    [sym_expansion] = STATE(225),
    [sym_command_substitution] = STATE(225),
    [sym_process_substitution] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_BANG] = ACTIONS(409),
    [sym__special_characters] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [sym_raw_string] = ACTIONS(417),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(421),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(425),
    [anon_sym_GT_LPAREN] = ACTIONS(425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(427),
    [sym_test_operator] = ACTIONS(429),
  },
  [96] = {
    [sym__expression] = STATE(342),
    [sym_binary_expression] = STATE(342),
    [sym_unary_expression] = STATE(342),
    [sym_postfix_expression] = STATE(342),
    [sym_parenthesized_expression] = STATE(342),
    [sym_concatenation] = STATE(342),
    [sym_string] = STATE(100),
    [sym_simple_expansion] = STATE(100),
    [sym_string_expansion] = STATE(100),
    [sym_expansion] = STATE(100),
    [sym_command_substitution] = STATE(100),
    [sym_process_substitution] = STATE(100),
    [anon_sym_LPAREN] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [sym__special_characters] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [sym_raw_string] = ACTIONS(157),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(167),
    [sym_test_operator] = ACTIONS(169),
  },
  [97] = {
    [aux_sym_concatenation_repeat1] = STATE(344),
    [sym__concat] = ACTIONS(629),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(433),
    [anon_sym_EQ_TILDE] = ACTIONS(433),
    [anon_sym_EQ_EQ] = ACTIONS(433),
    [anon_sym_EQ] = ACTIONS(435),
    [anon_sym_PLUS_EQ] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_BANG_EQ] = ACTIONS(433),
    [anon_sym_PLUS] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(435),
    [anon_sym_DASH_EQ] = ACTIONS(433),
    [anon_sym_LT_EQ] = ACTIONS(433),
    [anon_sym_GT_EQ] = ACTIONS(433),
    [anon_sym_PLUS_PLUS] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(433),
  },
  [98] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(347),
    [anon_sym_DQUOTE] = ACTIONS(631),
    [anon_sym_DOLLAR] = ACTIONS(633),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [99] = {
    [sym_string] = STATE(349),
    [anon_sym_DASH] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [sym_raw_string] = ACTIONS(637),
    [anon_sym_POUND] = ACTIONS(635),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(639),
    [anon_sym_STAR] = ACTIONS(641),
    [anon_sym_AT] = ACTIONS(641),
    [anon_sym_QMARK] = ACTIONS(641),
    [anon_sym_0] = ACTIONS(639),
    [anon_sym__] = ACTIONS(639),
  },
  [100] = {
    [aux_sym_concatenation_repeat1] = STATE(344),
    [sym__concat] = ACTIONS(629),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_RBRACK] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(451),
    [anon_sym_GT] = ACTIONS(451),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(451),
    [anon_sym_DASH] = ACTIONS(451),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(449),
  },
  [101] = {
    [sym_subscript] = STATE(354),
    [sym_variable_name] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_DOLLAR] = ACTIONS(647),
    [anon_sym_POUND] = ACTIONS(645),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(651),
    [anon_sym_AT] = ACTIONS(651),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_0] = ACTIONS(649),
    [anon_sym__] = ACTIONS(649),
  },
  [102] = {
    [sym__terminated_statement] = STATE(357),
    [sym_redirected_statement] = STATE(355),
    [sym_for_statement] = STATE(355),
    [sym_c_style_for_statement] = STATE(355),
    [sym_while_statement] = STATE(355),
    [sym_if_statement] = STATE(355),
    [sym_case_statement] = STATE(355),
    [sym_function_definition] = STATE(355),
    [sym_compound_statement] = STATE(355),
    [sym_subshell] = STATE(355),
    [sym_pipeline] = STATE(355),
    [sym_list] = STATE(355),
    [sym_negated_command] = STATE(355),
    [sym_test_command] = STATE(355),
    [sym_declaration_command] = STATE(355),
    [sym_unset_command] = STATE(355),
    [sym_command] = STATE(355),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(356),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(357),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [103] = {
    [sym__terminated_statement] = STATE(360),
    [sym_redirected_statement] = STATE(358),
    [sym_for_statement] = STATE(358),
    [sym_c_style_for_statement] = STATE(358),
    [sym_while_statement] = STATE(358),
    [sym_if_statement] = STATE(358),
    [sym_case_statement] = STATE(358),
    [sym_function_definition] = STATE(358),
    [sym_compound_statement] = STATE(358),
    [sym_subshell] = STATE(358),
    [sym_pipeline] = STATE(358),
    [sym_list] = STATE(358),
    [sym_negated_command] = STATE(358),
    [sym_test_command] = STATE(358),
    [sym_declaration_command] = STATE(358),
    [sym_unset_command] = STATE(358),
    [sym_command] = STATE(358),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(359),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(360),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [104] = {
    [sym__terminated_statement] = STATE(363),
    [sym_redirected_statement] = STATE(361),
    [sym_for_statement] = STATE(361),
    [sym_c_style_for_statement] = STATE(361),
    [sym_while_statement] = STATE(361),
    [sym_if_statement] = STATE(361),
    [sym_case_statement] = STATE(361),
    [sym_function_definition] = STATE(361),
    [sym_compound_statement] = STATE(361),
    [sym_subshell] = STATE(361),
    [sym_pipeline] = STATE(361),
    [sym_list] = STATE(361),
    [sym_negated_command] = STATE(361),
    [sym_test_command] = STATE(361),
    [sym_declaration_command] = STATE(361),
    [sym_unset_command] = STATE(361),
    [sym_command] = STATE(361),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(362),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(363),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [105] = {
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [anon_sym_RBRACK] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(655),
    [anon_sym_EQ_EQ] = ACTIONS(655),
    [anon_sym_EQ] = ACTIONS(657),
    [anon_sym_PLUS_EQ] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(657),
    [anon_sym_GT] = ACTIONS(657),
    [anon_sym_BANG_EQ] = ACTIONS(653),
    [anon_sym_PLUS] = ACTIONS(657),
    [anon_sym_DASH] = ACTIONS(657),
    [anon_sym_DASH_EQ] = ACTIONS(653),
    [anon_sym_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(653),
    [anon_sym_PLUS_PLUS] = ACTIONS(659),
    [anon_sym_DASH_DASH] = ACTIONS(659),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(653),
  },
  [106] = {
    [sym__expression] = STATE(367),
    [sym_binary_expression] = STATE(367),
    [sym_unary_expression] = STATE(367),
    [sym_postfix_expression] = STATE(367),
    [sym_parenthesized_expression] = STATE(367),
    [sym_concatenation] = STATE(367),
    [sym_string] = STATE(108),
    [sym_simple_expansion] = STATE(108),
    [sym_string_expansion] = STATE(108),
    [sym_expansion] = STATE(108),
    [sym_command_substitution] = STATE(108),
    [sym_process_substitution] = STATE(108),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(171),
    [sym__special_characters] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(175),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(177),
    [sym_test_operator] = ACTIONS(179),
  },
  [107] = {
    [aux_sym_concatenation_repeat1] = STATE(368),
    [sym__concat] = ACTIONS(431),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(433),
    [anon_sym_EQ_TILDE] = ACTIONS(433),
    [anon_sym_EQ_EQ] = ACTIONS(433),
    [anon_sym_EQ] = ACTIONS(435),
    [anon_sym_PLUS_EQ] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_BANG_EQ] = ACTIONS(433),
    [anon_sym_PLUS] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(435),
    [anon_sym_DASH_EQ] = ACTIONS(433),
    [anon_sym_LT_EQ] = ACTIONS(433),
    [anon_sym_GT_EQ] = ACTIONS(433),
    [anon_sym_PLUS_PLUS] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(433),
  },
  [108] = {
    [aux_sym_concatenation_repeat1] = STATE(368),
    [sym__concat] = ACTIONS(431),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(451),
    [anon_sym_GT] = ACTIONS(451),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(451),
    [anon_sym_DASH] = ACTIONS(451),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(449),
  },
  [109] = {
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(463),
    [anon_sym_EQ_TILDE] = ACTIONS(663),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(665),
    [anon_sym_PLUS_EQ] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(661),
    [anon_sym_PLUS] = ACTIONS(665),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_DASH_EQ] = ACTIONS(661),
    [anon_sym_LT_EQ] = ACTIONS(661),
    [anon_sym_GT_EQ] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(471),
    [anon_sym_DASH_DASH] = ACTIONS(471),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(661),
  },
  [110] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(667),
    [anon_sym_PLUS_EQ] = ACTIONS(667),
    [sym_comment] = ACTIONS(57),
  },
  [111] = {
    [aux_sym_concatenation_repeat1] = STATE(373),
    [sym__simple_heredoc_body] = ACTIONS(669),
    [sym__heredoc_body_beginning] = ACTIONS(669),
    [sym_file_descriptor] = ACTIONS(669),
    [sym__concat] = ACTIONS(671),
    [sym_variable_name] = ACTIONS(669),
    [ts_builtin_sym_end] = ACTIONS(669),
    [anon_sym_SEMI] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_SEMI_SEMI] = ACTIONS(669),
    [anon_sym_PIPE_AMP] = ACTIONS(669),
    [anon_sym_AMP_AMP] = ACTIONS(669),
    [anon_sym_PIPE_PIPE] = ACTIONS(669),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(669),
    [anon_sym_AMP_GT] = ACTIONS(673),
    [anon_sym_AMP_GT_GT] = ACTIONS(669),
    [anon_sym_LT_AMP] = ACTIONS(669),
    [anon_sym_GT_AMP] = ACTIONS(669),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_LT_LT_DASH] = ACTIONS(669),
    [anon_sym_LT_LT_LT] = ACTIONS(669),
    [sym__special_characters] = ACTIONS(669),
    [anon_sym_DQUOTE] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(673),
    [sym_raw_string] = ACTIONS(669),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(669),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(669),
    [anon_sym_BQUOTE] = ACTIONS(669),
    [anon_sym_LT_LPAREN] = ACTIONS(669),
    [anon_sym_GT_LPAREN] = ACTIONS(669),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(673),
    [sym_word] = ACTIONS(673),
    [anon_sym_LF] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(673),
  },
  [112] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(376),
    [anon_sym_DQUOTE] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [113] = {
    [sym_string] = STATE(378),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [sym_raw_string] = ACTIONS(681),
    [anon_sym_POUND] = ACTIONS(679),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(685),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_QMARK] = ACTIONS(685),
    [anon_sym_0] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
  },
  [114] = {
    [aux_sym_concatenation_repeat1] = STATE(373),
    [sym__simple_heredoc_body] = ACTIONS(687),
    [sym__heredoc_body_beginning] = ACTIONS(687),
    [sym_file_descriptor] = ACTIONS(687),
    [sym__concat] = ACTIONS(671),
    [sym_variable_name] = ACTIONS(687),
    [ts_builtin_sym_end] = ACTIONS(687),
    [anon_sym_SEMI] = ACTIONS(689),
    [anon_sym_PIPE] = ACTIONS(689),
    [anon_sym_SEMI_SEMI] = ACTIONS(687),
    [anon_sym_PIPE_AMP] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(687),
    [anon_sym_PIPE_PIPE] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(689),
    [anon_sym_GT] = ACTIONS(689),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_AMP_GT] = ACTIONS(689),
    [anon_sym_AMP_GT_GT] = ACTIONS(687),
    [anon_sym_LT_AMP] = ACTIONS(687),
    [anon_sym_GT_AMP] = ACTIONS(687),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_LT_LT_LT] = ACTIONS(687),
    [sym__special_characters] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(687),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(687),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_LT_LPAREN] = ACTIONS(687),
    [anon_sym_GT_LPAREN] = ACTIONS(687),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(689),
    [sym_word] = ACTIONS(689),
    [anon_sym_LF] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(689),
  },
  [115] = {
    [sym_subscript] = STATE(383),
    [sym_variable_name] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [anon_sym_POUND] = ACTIONS(693),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(697),
    [anon_sym_STAR] = ACTIONS(699),
    [anon_sym_AT] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_0] = ACTIONS(697),
    [anon_sym__] = ACTIONS(697),
  },
  [116] = {
    [sym__terminated_statement] = STATE(386),
    [sym_redirected_statement] = STATE(384),
    [sym_for_statement] = STATE(384),
    [sym_c_style_for_statement] = STATE(384),
    [sym_while_statement] = STATE(384),
    [sym_if_statement] = STATE(384),
    [sym_case_statement] = STATE(384),
    [sym_function_definition] = STATE(384),
    [sym_compound_statement] = STATE(384),
    [sym_subshell] = STATE(384),
    [sym_pipeline] = STATE(384),
    [sym_list] = STATE(384),
    [sym_negated_command] = STATE(384),
    [sym_test_command] = STATE(384),
    [sym_declaration_command] = STATE(384),
    [sym_unset_command] = STATE(384),
    [sym_command] = STATE(384),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(385),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(386),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [117] = {
    [sym__terminated_statement] = STATE(389),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_if_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(389),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [118] = {
    [sym__terminated_statement] = STATE(392),
    [sym_redirected_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_c_style_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_case_statement] = STATE(390),
    [sym_function_definition] = STATE(390),
    [sym_compound_statement] = STATE(390),
    [sym_subshell] = STATE(390),
    [sym_pipeline] = STATE(390),
    [sym_list] = STATE(390),
    [sym_negated_command] = STATE(390),
    [sym_test_command] = STATE(390),
    [sym_declaration_command] = STATE(390),
    [sym_unset_command] = STATE(390),
    [sym_command] = STATE(390),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(391),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(392),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [119] = {
    [anon_sym_EQ] = ACTIONS(667),
    [anon_sym_PLUS_EQ] = ACTIONS(667),
    [sym_comment] = ACTIONS(57),
  },
  [120] = {
    [sym_variable_assignment] = STATE(393),
    [sym_subscript] = STATE(119),
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [sym_expansion] = STATE(114),
    [sym_command_substitution] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [aux_sym_declaration_command_repeat1] = STATE(393),
    [sym__simple_heredoc_body] = ACTIONS(701),
    [sym__heredoc_body_beginning] = ACTIONS(701),
    [sym_file_descriptor] = ACTIONS(701),
    [sym_variable_name] = ACTIONS(183),
    [ts_builtin_sym_end] = ACTIONS(701),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_SEMI_SEMI] = ACTIONS(701),
    [anon_sym_PIPE_AMP] = ACTIONS(701),
    [anon_sym_AMP_AMP] = ACTIONS(701),
    [anon_sym_PIPE_PIPE] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(703),
    [anon_sym_GT] = ACTIONS(703),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_AMP_GT] = ACTIONS(703),
    [anon_sym_AMP_GT_GT] = ACTIONS(701),
    [anon_sym_LT_AMP] = ACTIONS(701),
    [anon_sym_GT_AMP] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(703),
    [anon_sym_LT_LT_DASH] = ACTIONS(701),
    [anon_sym_LT_LT_LT] = ACTIONS(701),
    [sym__special_characters] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(193),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(705),
    [sym_word] = ACTIONS(205),
    [anon_sym_LF] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(703),
  },
  [121] = {
    [aux_sym_concatenation_repeat1] = STATE(395),
    [sym__simple_heredoc_body] = ACTIONS(707),
    [sym__heredoc_body_beginning] = ACTIONS(707),
    [sym_file_descriptor] = ACTIONS(707),
    [sym__concat] = ACTIONS(709),
    [ts_builtin_sym_end] = ACTIONS(707),
    [anon_sym_SEMI] = ACTIONS(711),
    [anon_sym_PIPE] = ACTIONS(711),
    [anon_sym_SEMI_SEMI] = ACTIONS(707),
    [anon_sym_PIPE_AMP] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(707),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_GT] = ACTIONS(707),
    [anon_sym_AMP_GT] = ACTIONS(711),
    [anon_sym_AMP_GT_GT] = ACTIONS(707),
    [anon_sym_LT_AMP] = ACTIONS(707),
    [anon_sym_GT_AMP] = ACTIONS(707),
    [anon_sym_LT_LT] = ACTIONS(711),
    [anon_sym_LT_LT_DASH] = ACTIONS(707),
    [anon_sym_LT_LT_LT] = ACTIONS(707),
    [sym__special_characters] = ACTIONS(707),
    [anon_sym_DQUOTE] = ACTIONS(707),
    [anon_sym_DOLLAR] = ACTIONS(711),
    [sym_raw_string] = ACTIONS(707),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(707),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(707),
    [anon_sym_BQUOTE] = ACTIONS(707),
    [anon_sym_LT_LPAREN] = ACTIONS(707),
    [anon_sym_GT_LPAREN] = ACTIONS(707),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [sym_word] = ACTIONS(711),
    [anon_sym_LF] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(711),
  },
  [122] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(398),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR] = ACTIONS(715),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [123] = {
    [sym_string] = STATE(400),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(717),
    [sym_raw_string] = ACTIONS(719),
    [anon_sym_POUND] = ACTIONS(717),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(721),
    [anon_sym_STAR] = ACTIONS(723),
    [anon_sym_AT] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_0] = ACTIONS(721),
    [anon_sym__] = ACTIONS(721),
  },
  [124] = {
    [aux_sym_concatenation_repeat1] = STATE(395),
    [sym__simple_heredoc_body] = ACTIONS(725),
    [sym__heredoc_body_beginning] = ACTIONS(725),
    [sym_file_descriptor] = ACTIONS(725),
    [sym__concat] = ACTIONS(709),
    [ts_builtin_sym_end] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(727),
    [anon_sym_SEMI_SEMI] = ACTIONS(725),
    [anon_sym_PIPE_AMP] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_LT] = ACTIONS(727),
    [anon_sym_GT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_AMP_GT] = ACTIONS(727),
    [anon_sym_AMP_GT_GT] = ACTIONS(725),
    [anon_sym_LT_AMP] = ACTIONS(725),
    [anon_sym_GT_AMP] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_LT_LT_DASH] = ACTIONS(725),
    [anon_sym_LT_LT_LT] = ACTIONS(725),
    [sym__special_characters] = ACTIONS(725),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(727),
    [sym_raw_string] = ACTIONS(725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LT_LPAREN] = ACTIONS(725),
    [anon_sym_GT_LPAREN] = ACTIONS(725),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(727),
    [sym_word] = ACTIONS(727),
    [anon_sym_LF] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(727),
  },
  [125] = {
    [sym_subscript] = STATE(405),
    [sym_variable_name] = ACTIONS(729),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [anon_sym_POUND] = ACTIONS(731),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(735),
    [anon_sym_STAR] = ACTIONS(737),
    [anon_sym_AT] = ACTIONS(737),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_0] = ACTIONS(735),
    [anon_sym__] = ACTIONS(735),
  },
  [126] = {
    [sym__terminated_statement] = STATE(408),
    [sym_redirected_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_c_style_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_function_definition] = STATE(406),
    [sym_compound_statement] = STATE(406),
    [sym_subshell] = STATE(406),
    [sym_pipeline] = STATE(406),
    [sym_list] = STATE(406),
    [sym_negated_command] = STATE(406),
    [sym_test_command] = STATE(406),
    [sym_declaration_command] = STATE(406),
    [sym_unset_command] = STATE(406),
    [sym_command] = STATE(406),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(407),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(408),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [127] = {
    [sym__terminated_statement] = STATE(411),
    [sym_redirected_statement] = STATE(409),
    [sym_for_statement] = STATE(409),
    [sym_c_style_for_statement] = STATE(409),
    [sym_while_statement] = STATE(409),
    [sym_if_statement] = STATE(409),
    [sym_case_statement] = STATE(409),
    [sym_function_definition] = STATE(409),
    [sym_compound_statement] = STATE(409),
    [sym_subshell] = STATE(409),
    [sym_pipeline] = STATE(409),
    [sym_list] = STATE(409),
    [sym_negated_command] = STATE(409),
    [sym_test_command] = STATE(409),
    [sym_declaration_command] = STATE(409),
    [sym_unset_command] = STATE(409),
    [sym_command] = STATE(409),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(410),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(411),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [128] = {
    [sym__terminated_statement] = STATE(414),
    [sym_redirected_statement] = STATE(412),
    [sym_for_statement] = STATE(412),
    [sym_c_style_for_statement] = STATE(412),
    [sym_while_statement] = STATE(412),
    [sym_if_statement] = STATE(412),
    [sym_case_statement] = STATE(412),
    [sym_function_definition] = STATE(412),
    [sym_compound_statement] = STATE(412),
    [sym_subshell] = STATE(412),
    [sym_pipeline] = STATE(412),
    [sym_list] = STATE(412),
    [sym_negated_command] = STATE(412),
    [sym_test_command] = STATE(412),
    [sym_declaration_command] = STATE(412),
    [sym_unset_command] = STATE(412),
    [sym_command] = STATE(412),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(413),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(414),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [129] = {
    [sym_concatenation] = STATE(415),
    [sym_string] = STATE(124),
    [sym_simple_expansion] = STATE(124),
    [sym_string_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [sym_process_substitution] = STATE(124),
    [aux_sym_unset_command_repeat1] = STATE(415),
    [sym__simple_heredoc_body] = ACTIONS(739),
    [sym__heredoc_body_beginning] = ACTIONS(739),
    [sym_file_descriptor] = ACTIONS(739),
    [ts_builtin_sym_end] = ACTIONS(739),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_GT] = ACTIONS(739),
    [anon_sym_AMP_GT] = ACTIONS(741),
    [anon_sym_AMP_GT_GT] = ACTIONS(739),
    [anon_sym_LT_AMP] = ACTIONS(739),
    [anon_sym_GT_AMP] = ACTIONS(739),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_LT_LT_DASH] = ACTIONS(739),
    [anon_sym_LT_LT_LT] = ACTIONS(739),
    [sym__special_characters] = ACTIONS(211),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(217),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(743),
    [sym_word] = ACTIONS(229),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(741),
  },
  [130] = {
    [aux_sym_concatenation_repeat1] = STATE(417),
    [sym_file_descriptor] = ACTIONS(745),
    [sym__concat] = ACTIONS(747),
    [sym_variable_name] = ACTIONS(745),
    [anon_sym_LT] = ACTIONS(749),
    [anon_sym_GT] = ACTIONS(749),
    [anon_sym_GT_GT] = ACTIONS(745),
    [anon_sym_AMP_GT] = ACTIONS(749),
    [anon_sym_AMP_GT_GT] = ACTIONS(745),
    [anon_sym_LT_AMP] = ACTIONS(745),
    [anon_sym_GT_AMP] = ACTIONS(745),
    [sym__special_characters] = ACTIONS(745),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_DOLLAR] = ACTIONS(749),
    [sym_raw_string] = ACTIONS(745),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(745),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(745),
    [anon_sym_BQUOTE] = ACTIONS(745),
    [anon_sym_LT_LPAREN] = ACTIONS(745),
    [anon_sym_GT_LPAREN] = ACTIONS(745),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(745),
  },
  [131] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(420),
    [anon_sym_DQUOTE] = ACTIONS(751),
    [anon_sym_DOLLAR] = ACTIONS(753),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [132] = {
    [sym_string] = STATE(422),
    [anon_sym_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(755),
    [sym_raw_string] = ACTIONS(757),
    [anon_sym_POUND] = ACTIONS(755),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(759),
    [anon_sym_STAR] = ACTIONS(761),
    [anon_sym_AT] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(761),
    [anon_sym_0] = ACTIONS(759),
    [anon_sym__] = ACTIONS(759),
  },
  [133] = {
    [aux_sym_concatenation_repeat1] = STATE(417),
    [sym_file_descriptor] = ACTIONS(763),
    [sym__concat] = ACTIONS(747),
    [sym_variable_name] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(765),
    [anon_sym_GT_GT] = ACTIONS(763),
    [anon_sym_AMP_GT] = ACTIONS(765),
    [anon_sym_AMP_GT_GT] = ACTIONS(763),
    [anon_sym_LT_AMP] = ACTIONS(763),
    [anon_sym_GT_AMP] = ACTIONS(763),
    [sym__special_characters] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(763),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [sym_raw_string] = ACTIONS(763),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(763),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(763),
    [anon_sym_GT_LPAREN] = ACTIONS(763),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(763),
  },
  [134] = {
    [sym_subscript] = STATE(427),
    [sym_variable_name] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_DASH] = ACTIONS(771),
    [anon_sym_DOLLAR] = ACTIONS(771),
    [anon_sym_POUND] = ACTIONS(769),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(775),
    [anon_sym_AT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_0] = ACTIONS(773),
    [anon_sym__] = ACTIONS(773),
  },
  [135] = {
    [sym__terminated_statement] = STATE(430),
    [sym_redirected_statement] = STATE(428),
    [sym_for_statement] = STATE(428),
    [sym_c_style_for_statement] = STATE(428),
    [sym_while_statement] = STATE(428),
    [sym_if_statement] = STATE(428),
    [sym_case_statement] = STATE(428),
    [sym_function_definition] = STATE(428),
    [sym_compound_statement] = STATE(428),
    [sym_subshell] = STATE(428),
    [sym_pipeline] = STATE(428),
    [sym_list] = STATE(428),
    [sym_negated_command] = STATE(428),
    [sym_test_command] = STATE(428),
    [sym_declaration_command] = STATE(428),
    [sym_unset_command] = STATE(428),
    [sym_command] = STATE(428),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(429),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(430),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [136] = {
    [sym__terminated_statement] = STATE(433),
    [sym_redirected_statement] = STATE(431),
    [sym_for_statement] = STATE(431),
    [sym_c_style_for_statement] = STATE(431),
    [sym_while_statement] = STATE(431),
    [sym_if_statement] = STATE(431),
    [sym_case_statement] = STATE(431),
    [sym_function_definition] = STATE(431),
    [sym_compound_statement] = STATE(431),
    [sym_subshell] = STATE(431),
    [sym_pipeline] = STATE(431),
    [sym_list] = STATE(431),
    [sym_negated_command] = STATE(431),
    [sym_test_command] = STATE(431),
    [sym_declaration_command] = STATE(431),
    [sym_unset_command] = STATE(431),
    [sym_command] = STATE(431),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(432),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(433),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [137] = {
    [sym__terminated_statement] = STATE(436),
    [sym_redirected_statement] = STATE(434),
    [sym_for_statement] = STATE(434),
    [sym_c_style_for_statement] = STATE(434),
    [sym_while_statement] = STATE(434),
    [sym_if_statement] = STATE(434),
    [sym_case_statement] = STATE(434),
    [sym_function_definition] = STATE(434),
    [sym_compound_statement] = STATE(434),
    [sym_subshell] = STATE(434),
    [sym_pipeline] = STATE(434),
    [sym_list] = STATE(434),
    [sym_negated_command] = STATE(434),
    [sym_test_command] = STATE(434),
    [sym_declaration_command] = STATE(434),
    [sym_unset_command] = STATE(434),
    [sym_command] = STATE(434),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(435),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(436),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [138] = {
    [sym_file_descriptor] = ACTIONS(763),
    [sym_variable_name] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(765),
    [anon_sym_GT_GT] = ACTIONS(763),
    [anon_sym_AMP_GT] = ACTIONS(765),
    [anon_sym_AMP_GT_GT] = ACTIONS(763),
    [anon_sym_LT_AMP] = ACTIONS(763),
    [anon_sym_GT_AMP] = ACTIONS(763),
    [sym__special_characters] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(763),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [sym_raw_string] = ACTIONS(763),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(763),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(763),
    [anon_sym_GT_LPAREN] = ACTIONS(763),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(763),
  },
  [139] = {
    [sym_string] = STATE(437),
    [sym_simple_expansion] = STATE(437),
    [sym_string_expansion] = STATE(437),
    [sym_expansion] = STATE(437),
    [sym_command_substitution] = STATE(437),
    [sym_process_substitution] = STATE(437),
    [sym__special_characters] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(777),
  },
  [140] = {
    [aux_sym_concatenation_repeat1] = STATE(438),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(779),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_EQ_TILDE] = ACTIONS(781),
    [anon_sym_EQ_EQ] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(781),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [141] = {
    [sym__simple_heredoc_body] = ACTIONS(783),
    [sym__heredoc_body_beginning] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(783),
    [sym__concat] = ACTIONS(783),
    [ts_builtin_sym_end] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_RPAREN] = ACTIONS(783),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [anon_sym_PIPE_AMP] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_EQ_TILDE] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(785),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(783),
    [anon_sym_AMP_GT] = ACTIONS(785),
    [anon_sym_AMP_GT_GT] = ACTIONS(783),
    [anon_sym_LT_AMP] = ACTIONS(783),
    [anon_sym_GT_AMP] = ACTIONS(783),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_DASH] = ACTIONS(783),
    [anon_sym_LT_LT_LT] = ACTIONS(783),
    [sym__special_characters] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(783),
    [anon_sym_DOLLAR] = ACTIONS(785),
    [sym_raw_string] = ACTIONS(783),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(783),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(783),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [anon_sym_LT_LPAREN] = ACTIONS(783),
    [anon_sym_GT_LPAREN] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(785),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
  },
  [142] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [143] = {
    [sym__concat] = ACTIONS(799),
    [anon_sym_DQUOTE] = ACTIONS(801),
    [anon_sym_DOLLAR] = ACTIONS(801),
    [sym__string_content] = ACTIONS(803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(801),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(801),
    [anon_sym_BQUOTE] = ACTIONS(801),
    [sym_comment] = ACTIONS(265),
  },
  [144] = {
    [sym_subscript] = STATE(447),
    [sym_variable_name] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [anon_sym_POUND] = ACTIONS(807),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(811),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_AT] = ACTIONS(813),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_0] = ACTIONS(811),
    [anon_sym__] = ACTIONS(811),
  },
  [145] = {
    [sym__terminated_statement] = STATE(450),
    [sym_redirected_statement] = STATE(448),
    [sym_for_statement] = STATE(448),
    [sym_c_style_for_statement] = STATE(448),
    [sym_while_statement] = STATE(448),
    [sym_if_statement] = STATE(448),
    [sym_case_statement] = STATE(448),
    [sym_function_definition] = STATE(448),
    [sym_compound_statement] = STATE(448),
    [sym_subshell] = STATE(448),
    [sym_pipeline] = STATE(448),
    [sym_list] = STATE(448),
    [sym_negated_command] = STATE(448),
    [sym_test_command] = STATE(448),
    [sym_declaration_command] = STATE(448),
    [sym_unset_command] = STATE(448),
    [sym_command] = STATE(448),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(449),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(450),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [146] = {
    [sym__terminated_statement] = STATE(453),
    [sym_redirected_statement] = STATE(451),
    [sym_for_statement] = STATE(451),
    [sym_c_style_for_statement] = STATE(451),
    [sym_while_statement] = STATE(451),
    [sym_if_statement] = STATE(451),
    [sym_case_statement] = STATE(451),
    [sym_function_definition] = STATE(451),
    [sym_compound_statement] = STATE(451),
    [sym_subshell] = STATE(451),
    [sym_pipeline] = STATE(451),
    [sym_list] = STATE(451),
    [sym_negated_command] = STATE(451),
    [sym_test_command] = STATE(451),
    [sym_declaration_command] = STATE(451),
    [sym_unset_command] = STATE(451),
    [sym_command] = STATE(451),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(452),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(453),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [147] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_DOLLAR] = ACTIONS(815),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [148] = {
    [sym__simple_heredoc_body] = ACTIONS(817),
    [sym__heredoc_body_beginning] = ACTIONS(817),
    [sym_file_descriptor] = ACTIONS(817),
    [sym__concat] = ACTIONS(817),
    [ts_builtin_sym_end] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_SEMI_SEMI] = ACTIONS(817),
    [anon_sym_PIPE_AMP] = ACTIONS(817),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_EQ_TILDE] = ACTIONS(819),
    [anon_sym_EQ_EQ] = ACTIONS(819),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(817),
    [anon_sym_AMP_GT] = ACTIONS(819),
    [anon_sym_AMP_GT_GT] = ACTIONS(817),
    [anon_sym_LT_AMP] = ACTIONS(817),
    [anon_sym_GT_AMP] = ACTIONS(817),
    [anon_sym_LT_LT] = ACTIONS(819),
    [anon_sym_LT_LT_DASH] = ACTIONS(817),
    [anon_sym_LT_LT_LT] = ACTIONS(817),
    [sym__special_characters] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR] = ACTIONS(819),
    [sym_raw_string] = ACTIONS(817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(817),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(817),
    [anon_sym_GT_LPAREN] = ACTIONS(817),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(819),
    [anon_sym_LF] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(819),
  },
  [149] = {
    [sym__simple_heredoc_body] = ACTIONS(821),
    [sym__heredoc_body_beginning] = ACTIONS(821),
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [ts_builtin_sym_end] = ACTIONS(821),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(821),
    [anon_sym_SEMI_SEMI] = ACTIONS(821),
    [anon_sym_PIPE_AMP] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_EQ_TILDE] = ACTIONS(823),
    [anon_sym_EQ_EQ] = ACTIONS(823),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(823),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(823),
    [anon_sym_LT_LT_DASH] = ACTIONS(821),
    [anon_sym_LT_LT_LT] = ACTIONS(821),
    [sym__special_characters] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [anon_sym_DOLLAR] = ACTIONS(823),
    [sym_raw_string] = ACTIONS(821),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(821),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(821),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(821),
    [anon_sym_GT_LPAREN] = ACTIONS(821),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(823),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [150] = {
    [sym__simple_heredoc_body] = ACTIONS(825),
    [sym__heredoc_body_beginning] = ACTIONS(825),
    [sym_file_descriptor] = ACTIONS(825),
    [sym__concat] = ACTIONS(825),
    [ts_builtin_sym_end] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(827),
    [anon_sym_PIPE] = ACTIONS(827),
    [anon_sym_RPAREN] = ACTIONS(825),
    [anon_sym_SEMI_SEMI] = ACTIONS(825),
    [anon_sym_PIPE_AMP] = ACTIONS(825),
    [anon_sym_AMP_AMP] = ACTIONS(825),
    [anon_sym_PIPE_PIPE] = ACTIONS(825),
    [anon_sym_EQ_TILDE] = ACTIONS(827),
    [anon_sym_EQ_EQ] = ACTIONS(827),
    [anon_sym_LT] = ACTIONS(827),
    [anon_sym_GT] = ACTIONS(827),
    [anon_sym_GT_GT] = ACTIONS(825),
    [anon_sym_AMP_GT] = ACTIONS(827),
    [anon_sym_AMP_GT_GT] = ACTIONS(825),
    [anon_sym_LT_AMP] = ACTIONS(825),
    [anon_sym_GT_AMP] = ACTIONS(825),
    [anon_sym_LT_LT] = ACTIONS(827),
    [anon_sym_LT_LT_DASH] = ACTIONS(825),
    [anon_sym_LT_LT_LT] = ACTIONS(825),
    [sym__special_characters] = ACTIONS(825),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [sym_raw_string] = ACTIONS(825),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(825),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(825),
    [anon_sym_BQUOTE] = ACTIONS(825),
    [anon_sym_LT_LPAREN] = ACTIONS(825),
    [anon_sym_GT_LPAREN] = ACTIONS(825),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(827),
    [anon_sym_LF] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(827),
  },
  [151] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(831),
    [sym_comment] = ACTIONS(57),
  },
  [152] = {
    [sym_subscript] = STATE(460),
    [sym_variable_name] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(835),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(837),
    [anon_sym_STAR] = ACTIONS(839),
    [anon_sym_AT] = ACTIONS(839),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_0] = ACTIONS(837),
    [anon_sym__] = ACTIONS(837),
  },
  [153] = {
    [sym_concatenation] = STATE(471),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(471),
    [anon_sym_RBRACE] = ACTIONS(841),
    [anon_sym_EQ] = ACTIONS(843),
    [anon_sym_DASH] = ACTIONS(843),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(853),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(857),
    [anon_sym_COLON] = ACTIONS(843),
    [anon_sym_COLON_QMARK] = ACTIONS(843),
    [anon_sym_COLON_DASH] = ACTIONS(843),
    [anon_sym_PERCENT] = ACTIONS(843),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [154] = {
    [sym_concatenation] = STATE(474),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(474),
    [anon_sym_RBRACE] = ACTIONS(867),
    [anon_sym_EQ] = ACTIONS(869),
    [anon_sym_DASH] = ACTIONS(869),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(873),
    [anon_sym_COLON] = ACTIONS(869),
    [anon_sym_COLON_QMARK] = ACTIONS(869),
    [anon_sym_COLON_DASH] = ACTIONS(869),
    [anon_sym_PERCENT] = ACTIONS(869),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [155] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(477),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(875),
  },
  [156] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(477),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(875),
  },
  [157] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(478),
    [sym_for_statement] = STATE(478),
    [sym_c_style_for_statement] = STATE(478),
    [sym_while_statement] = STATE(478),
    [sym_if_statement] = STATE(478),
    [sym_case_statement] = STATE(478),
    [sym_function_definition] = STATE(478),
    [sym_compound_statement] = STATE(478),
    [sym_subshell] = STATE(478),
    [sym_pipeline] = STATE(478),
    [sym_list] = STATE(478),
    [sym_negated_command] = STATE(478),
    [sym_test_command] = STATE(478),
    [sym_declaration_command] = STATE(478),
    [sym_unset_command] = STATE(478),
    [sym_command] = STATE(478),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(479),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [158] = {
    [sym_subshell] = STATE(93),
    [sym_test_command] = STATE(93),
    [sym_command] = STATE(93),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(165),
    [sym_subscript] = STATE(94),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(145),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(107),
  },
  [159] = {
    [sym_variable_assignment] = STATE(480),
    [sym_subscript] = STATE(261),
    [sym_concatenation] = STATE(480),
    [sym_string] = STATE(260),
    [sym_simple_expansion] = STATE(260),
    [sym_string_expansion] = STATE(260),
    [sym_expansion] = STATE(260),
    [sym_command_substitution] = STATE(260),
    [sym_process_substitution] = STATE(260),
    [aux_sym_declaration_command_repeat1] = STATE(480),
    [sym__simple_heredoc_body] = ACTIONS(181),
    [sym__heredoc_body_beginning] = ACTIONS(181),
    [sym_file_descriptor] = ACTIONS(181),
    [sym_variable_name] = ACTIONS(475),
    [anon_sym_SEMI] = ACTIONS(185),
    [anon_sym_PIPE] = ACTIONS(185),
    [anon_sym_SEMI_SEMI] = ACTIONS(181),
    [anon_sym_PIPE_AMP] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_GT] = ACTIONS(185),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_AMP_GT] = ACTIONS(185),
    [anon_sym_AMP_GT_GT] = ACTIONS(181),
    [anon_sym_LT_AMP] = ACTIONS(181),
    [anon_sym_GT_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(185),
    [anon_sym_LT_LT_DASH] = ACTIONS(181),
    [anon_sym_LT_LT_LT] = ACTIONS(181),
    [sym__special_characters] = ACTIONS(477),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(479),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(881),
    [sym_word] = ACTIONS(483),
    [anon_sym_LF] = ACTIONS(181),
    [anon_sym_AMP] = ACTIONS(185),
  },
  [160] = {
    [sym_concatenation] = STATE(481),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [aux_sym_unset_command_repeat1] = STATE(481),
    [sym__simple_heredoc_body] = ACTIONS(207),
    [sym__heredoc_body_beginning] = ACTIONS(207),
    [sym_file_descriptor] = ACTIONS(207),
    [anon_sym_SEMI] = ACTIONS(209),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_SEMI_SEMI] = ACTIONS(207),
    [anon_sym_PIPE_AMP] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_GT] = ACTIONS(209),
    [anon_sym_AMP_GT_GT] = ACTIONS(207),
    [anon_sym_LT_AMP] = ACTIONS(207),
    [anon_sym_GT_AMP] = ACTIONS(207),
    [anon_sym_LT_LT] = ACTIONS(209),
    [anon_sym_LT_LT_DASH] = ACTIONS(207),
    [anon_sym_LT_LT_LT] = ACTIONS(207),
    [sym__special_characters] = ACTIONS(485),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(487),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(883),
    [sym_word] = ACTIONS(491),
    [anon_sym_LF] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(209),
  },
  [161] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(488),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(891),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(877),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(887),
  },
  [162] = {
    [sym_concatenation] = STATE(490),
    [sym_string] = STATE(279),
    [sym_simple_expansion] = STATE(279),
    [sym_string_expansion] = STATE(279),
    [sym_expansion] = STATE(279),
    [sym_command_substitution] = STATE(279),
    [sym_process_substitution] = STATE(279),
    [aux_sym_command_repeat2] = STATE(490),
    [sym__simple_heredoc_body] = ACTIONS(327),
    [sym__heredoc_body_beginning] = ACTIONS(327),
    [sym_file_descriptor] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(327),
    [anon_sym_PIPE_AMP] = ACTIONS(327),
    [anon_sym_AMP_AMP] = ACTIONS(327),
    [anon_sym_PIPE_PIPE] = ACTIONS(327),
    [anon_sym_EQ_TILDE] = ACTIONS(513),
    [anon_sym_EQ_EQ] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(327),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(327),
    [anon_sym_LT_AMP] = ACTIONS(327),
    [anon_sym_GT_AMP] = ACTIONS(327),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(327),
    [anon_sym_LT_LT_LT] = ACTIONS(327),
    [sym__special_characters] = ACTIONS(515),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(517),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(327),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(327),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [163] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(488),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(891),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(877),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(887),
  },
  [164] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_c_style_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_case_statement] = STATE(491),
    [sym_function_definition] = STATE(491),
    [sym_compound_statement] = STATE(491),
    [sym_subshell] = STATE(491),
    [sym_pipeline] = STATE(491),
    [sym_list] = STATE(491),
    [sym_negated_command] = STATE(491),
    [sym_test_command] = STATE(491),
    [sym_declaration_command] = STATE(491),
    [sym_unset_command] = STATE(491),
    [sym_command] = STATE(491),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(492),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [165] = {
    [sym_command_name] = STATE(493),
    [sym_variable_assignment] = STATE(189),
    [sym_subscript] = STATE(94),
    [sym_file_redirect] = STATE(189),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym_command_repeat1] = STATE(189),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(145),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(107),
  },
  [166] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(496),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_SEMI_SEMI] = ACTIONS(907),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(903),
  },
  [167] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(496),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_SEMI_SEMI] = ACTIONS(907),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(903),
  },
  [168] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(497),
    [sym_for_statement] = STATE(497),
    [sym_c_style_for_statement] = STATE(497),
    [sym_while_statement] = STATE(497),
    [sym_if_statement] = STATE(497),
    [sym_case_statement] = STATE(497),
    [sym_function_definition] = STATE(497),
    [sym_compound_statement] = STATE(497),
    [sym_subshell] = STATE(497),
    [sym_pipeline] = STATE(497),
    [sym_list] = STATE(497),
    [sym_negated_command] = STATE(497),
    [sym_test_command] = STATE(497),
    [sym_declaration_command] = STATE(497),
    [sym_unset_command] = STATE(497),
    [sym_command] = STATE(497),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(498),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [169] = {
    [anon_sym_RPAREN] = ACTIONS(909),
    [sym_comment] = ACTIONS(57),
  },
  [170] = {
    [ts_builtin_sym_end] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_RPAREN] = ACTIONS(911),
    [anon_sym_SEMI_SEMI] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(911),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(911),
    [anon_sym_AMP] = ACTIONS(911),
  },
  [171] = {
    [sym_simple_expansion] = STATE(503),
    [sym_expansion] = STATE(503),
    [aux_sym_heredoc_body_repeat1] = STATE(503),
    [sym__heredoc_body_middle] = ACTIONS(915),
    [sym__heredoc_body_end] = ACTIONS(917),
    [anon_sym_DOLLAR] = ACTIONS(919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(921),
    [sym_comment] = ACTIONS(57),
  },
  [172] = {
    [anon_sym_LT] = ACTIONS(923),
    [anon_sym_GT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_AMP_GT] = ACTIONS(923),
    [anon_sym_AMP_GT_GT] = ACTIONS(925),
    [anon_sym_LT_AMP] = ACTIONS(925),
    [anon_sym_GT_AMP] = ACTIONS(925),
    [sym_comment] = ACTIONS(57),
  },
  [173] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [ts_builtin_sym_end] = ACTIONS(929),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [174] = {
    [sym_redirected_statement] = STATE(505),
    [sym_for_statement] = STATE(505),
    [sym_c_style_for_statement] = STATE(505),
    [sym_while_statement] = STATE(505),
    [sym_if_statement] = STATE(505),
    [sym_case_statement] = STATE(505),
    [sym_function_definition] = STATE(505),
    [sym_compound_statement] = STATE(505),
    [sym_subshell] = STATE(505),
    [sym_pipeline] = STATE(505),
    [sym_list] = STATE(505),
    [sym_negated_command] = STATE(505),
    [sym_test_command] = STATE(505),
    [sym_declaration_command] = STATE(505),
    [sym_unset_command] = STATE(505),
    [sym_command] = STATE(505),
    [sym_command_name] = STATE(29),
    [sym_variable_assignment] = STATE(506),
    [sym_subscript] = STATE(31),
    [sym_file_redirect] = STATE(34),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym_command_repeat1] = STATE(34),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(33),
    [anon_sym_typeset] = ACTIONS(33),
    [anon_sym_export] = ACTIONS(33),
    [anon_sym_readonly] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym_unset] = ACTIONS(35),
    [anon_sym_unsetenv] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(41),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(59),
  },
  [175] = {
    [sym_redirected_statement] = STATE(507),
    [sym_for_statement] = STATE(507),
    [sym_c_style_for_statement] = STATE(507),
    [sym_while_statement] = STATE(507),
    [sym_if_statement] = STATE(507),
    [sym_case_statement] = STATE(507),
    [sym_function_definition] = STATE(507),
    [sym_compound_statement] = STATE(507),
    [sym_subshell] = STATE(507),
    [sym_pipeline] = STATE(507),
    [sym_list] = STATE(507),
    [sym_negated_command] = STATE(507),
    [sym_test_command] = STATE(507),
    [sym_declaration_command] = STATE(507),
    [sym_unset_command] = STATE(507),
    [sym_command] = STATE(507),
    [sym_command_name] = STATE(29),
    [sym_variable_assignment] = STATE(508),
    [sym_subscript] = STATE(31),
    [sym_file_redirect] = STATE(34),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym_command_repeat1] = STATE(34),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(33),
    [anon_sym_typeset] = ACTIONS(33),
    [anon_sym_export] = ACTIONS(33),
    [anon_sym_readonly] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym_unset] = ACTIONS(35),
    [anon_sym_unsetenv] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(41),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(59),
  },
  [176] = {
    [sym_concatenation] = STATE(511),
    [sym_string] = STATE(510),
    [sym_simple_expansion] = STATE(510),
    [sym_string_expansion] = STATE(510),
    [sym_expansion] = STATE(510),
    [sym_command_substitution] = STATE(510),
    [sym_process_substitution] = STATE(510),
    [sym__special_characters] = ACTIONS(933),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(935),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(935),
  },
  [177] = {
    [sym_heredoc_start] = ACTIONS(937),
    [sym_comment] = ACTIONS(57),
  },
  [178] = {
    [sym_concatenation] = STATE(515),
    [sym_string] = STATE(514),
    [sym_simple_expansion] = STATE(514),
    [sym_string_expansion] = STATE(514),
    [sym_expansion] = STATE(514),
    [sym_command_substitution] = STATE(514),
    [sym_process_substitution] = STATE(514),
    [sym__special_characters] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(941),
  },
  [179] = {
    [ts_builtin_sym_end] = ACTIONS(929),
    [anon_sym_SEMI] = ACTIONS(943),
    [anon_sym_SEMI_SEMI] = ACTIONS(945),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(945),
  },
  [180] = {
    [sym_file_redirect] = STATE(517),
    [sym_heredoc_redirect] = STATE(517),
    [sym_herestring_redirect] = STATE(517),
    [aux_sym_redirected_statement_repeat1] = STATE(517),
    [sym__simple_heredoc_body] = ACTIONS(947),
    [sym__heredoc_body_beginning] = ACTIONS(947),
    [sym_file_descriptor] = ACTIONS(303),
    [ts_builtin_sym_end] = ACTIONS(947),
    [anon_sym_SEMI] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI_SEMI] = ACTIONS(947),
    [anon_sym_PIPE_AMP] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_LT] = ACTIONS(317),
    [anon_sym_GT] = ACTIONS(317),
    [anon_sym_GT_GT] = ACTIONS(319),
    [anon_sym_AMP_GT] = ACTIONS(317),
    [anon_sym_AMP_GT_GT] = ACTIONS(319),
    [anon_sym_LT_AMP] = ACTIONS(319),
    [anon_sym_GT_AMP] = ACTIONS(319),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
  },
  [181] = {
    [sym_concatenation] = STATE(518),
    [sym_string] = STATE(520),
    [sym_simple_expansion] = STATE(520),
    [sym_string_expansion] = STATE(520),
    [sym_expansion] = STATE(520),
    [sym_command_substitution] = STATE(520),
    [sym_process_substitution] = STATE(520),
    [sym_regex] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(955),
  },
  [182] = {
    [aux_sym_concatenation_repeat1] = STATE(140),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_EQ_TILDE] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(959),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_characters] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [183] = {
    [aux_sym_concatenation_repeat1] = STATE(140),
    [sym__simple_heredoc_body] = ACTIONS(961),
    [sym__heredoc_body_beginning] = ACTIONS(961),
    [sym_file_descriptor] = ACTIONS(961),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(961),
    [anon_sym_SEMI] = ACTIONS(963),
    [anon_sym_PIPE] = ACTIONS(963),
    [anon_sym_SEMI_SEMI] = ACTIONS(961),
    [anon_sym_PIPE_AMP] = ACTIONS(961),
    [anon_sym_AMP_AMP] = ACTIONS(961),
    [anon_sym_PIPE_PIPE] = ACTIONS(961),
    [anon_sym_EQ_TILDE] = ACTIONS(963),
    [anon_sym_EQ_EQ] = ACTIONS(963),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_GT_GT] = ACTIONS(961),
    [anon_sym_AMP_GT] = ACTIONS(963),
    [anon_sym_AMP_GT_GT] = ACTIONS(961),
    [anon_sym_LT_AMP] = ACTIONS(961),
    [anon_sym_GT_AMP] = ACTIONS(961),
    [anon_sym_LT_LT] = ACTIONS(963),
    [anon_sym_LT_LT_DASH] = ACTIONS(961),
    [anon_sym_LT_LT_LT] = ACTIONS(961),
    [sym__special_characters] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(961),
    [anon_sym_DOLLAR] = ACTIONS(963),
    [sym_raw_string] = ACTIONS(961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(961),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(961),
    [anon_sym_BQUOTE] = ACTIONS(961),
    [anon_sym_LT_LPAREN] = ACTIONS(961),
    [anon_sym_GT_LPAREN] = ACTIONS(961),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(963),
    [anon_sym_LF] = ACTIONS(961),
    [anon_sym_AMP] = ACTIONS(963),
  },
  [184] = {
    [sym_concatenation] = STATE(521),
    [sym_string] = STATE(183),
    [sym_simple_expansion] = STATE(183),
    [sym_string_expansion] = STATE(183),
    [sym_expansion] = STATE(183),
    [sym_command_substitution] = STATE(183),
    [sym_process_substitution] = STATE(183),
    [aux_sym_command_repeat2] = STATE(521),
    [sym__simple_heredoc_body] = ACTIONS(965),
    [sym__heredoc_body_beginning] = ACTIONS(965),
    [sym_file_descriptor] = ACTIONS(965),
    [ts_builtin_sym_end] = ACTIONS(965),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(967),
    [anon_sym_SEMI_SEMI] = ACTIONS(965),
    [anon_sym_PIPE_AMP] = ACTIONS(965),
    [anon_sym_AMP_AMP] = ACTIONS(965),
    [anon_sym_PIPE_PIPE] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(965),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(965),
    [anon_sym_LT_AMP] = ACTIONS(965),
    [anon_sym_GT_AMP] = ACTIONS(965),
    [anon_sym_LT_LT] = ACTIONS(967),
    [anon_sym_LT_LT_DASH] = ACTIONS(965),
    [anon_sym_LT_LT_LT] = ACTIONS(965),
    [sym__special_characters] = ACTIONS(333),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(337),
    [anon_sym_LF] = ACTIONS(965),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [185] = {
    [sym_file_redirect] = STATE(180),
    [sym_heredoc_redirect] = STATE(180),
    [sym_heredoc_body] = STATE(523),
    [sym_herestring_redirect] = STATE(180),
    [aux_sym_redirected_statement_repeat1] = STATE(180),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(303),
    [ts_builtin_sym_end] = ACTIONS(929),
    [anon_sym_SEMI] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(309),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(313),
    [anon_sym_AMP_AMP] = ACTIONS(315),
    [anon_sym_PIPE_PIPE] = ACTIONS(315),
    [anon_sym_LT] = ACTIONS(317),
    [anon_sym_GT] = ACTIONS(317),
    [anon_sym_GT_GT] = ACTIONS(319),
    [anon_sym_AMP_GT] = ACTIONS(317),
    [anon_sym_AMP_GT_GT] = ACTIONS(319),
    [anon_sym_LT_AMP] = ACTIONS(319),
    [anon_sym_GT_AMP] = ACTIONS(319),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(969),
  },
  [186] = {
    [sym_file_redirect] = STATE(180),
    [sym_heredoc_redirect] = STATE(180),
    [sym_heredoc_body] = STATE(523),
    [sym_herestring_redirect] = STATE(180),
    [aux_sym_redirected_statement_repeat1] = STATE(180),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [ts_builtin_sym_end] = ACTIONS(929),
    [anon_sym_SEMI] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(309),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(313),
    [anon_sym_AMP_AMP] = ACTIONS(315),
    [anon_sym_PIPE_PIPE] = ACTIONS(315),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(969),
  },
  [187] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(524),
    [sym_for_statement] = STATE(524),
    [sym_c_style_for_statement] = STATE(524),
    [sym_while_statement] = STATE(524),
    [sym_if_statement] = STATE(524),
    [sym_case_statement] = STATE(524),
    [sym_function_definition] = STATE(524),
    [sym_compound_statement] = STATE(524),
    [sym_subshell] = STATE(524),
    [sym_pipeline] = STATE(524),
    [sym_list] = STATE(524),
    [sym_negated_command] = STATE(524),
    [sym_test_command] = STATE(524),
    [sym_declaration_command] = STATE(524),
    [sym_unset_command] = STATE(524),
    [sym_command] = STATE(524),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(525),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(973),
    [sym_variable_name] = ACTIONS(976),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(982),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(988),
    [anon_sym_case] = ACTIONS(991),
    [anon_sym_function] = ACTIONS(994),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(1000),
    [anon_sym_BANG] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1006),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1009),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_typeset] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_readonly] = ACTIONS(1012),
    [anon_sym_local] = ACTIONS(1012),
    [anon_sym_unset] = ACTIONS(1015),
    [anon_sym_unsetenv] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1018),
    [anon_sym_GT] = ACTIONS(1018),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1018),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [sym__special_characters] = ACTIONS(1024),
    [anon_sym_DQUOTE] = ACTIONS(1027),
    [anon_sym_DOLLAR] = ACTIONS(1030),
    [sym_raw_string] = ACTIONS(1033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1039),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LPAREN] = ACTIONS(1045),
    [anon_sym_GT_LPAREN] = ACTIONS(1045),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1048),
  },
  [188] = {
    [sym_concatenation] = STATE(526),
    [sym_string] = STATE(183),
    [sym_simple_expansion] = STATE(183),
    [sym_string_expansion] = STATE(183),
    [sym_expansion] = STATE(183),
    [sym_command_substitution] = STATE(183),
    [sym_process_substitution] = STATE(183),
    [aux_sym_command_repeat2] = STATE(526),
    [sym__simple_heredoc_body] = ACTIONS(965),
    [sym__heredoc_body_beginning] = ACTIONS(965),
    [sym_file_descriptor] = ACTIONS(965),
    [ts_builtin_sym_end] = ACTIONS(965),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(967),
    [anon_sym_SEMI_SEMI] = ACTIONS(965),
    [anon_sym_PIPE_AMP] = ACTIONS(965),
    [anon_sym_AMP_AMP] = ACTIONS(965),
    [anon_sym_PIPE_PIPE] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(965),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(965),
    [anon_sym_LT_AMP] = ACTIONS(965),
    [anon_sym_GT_AMP] = ACTIONS(965),
    [anon_sym_LT_LT] = ACTIONS(967),
    [anon_sym_LT_LT_DASH] = ACTIONS(965),
    [anon_sym_LT_LT_LT] = ACTIONS(965),
    [sym__special_characters] = ACTIONS(333),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(337),
    [anon_sym_LF] = ACTIONS(965),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [189] = {
    [sym_variable_assignment] = STATE(189),
    [sym_subscript] = STATE(94),
    [sym_file_redirect] = STATE(189),
    [aux_sym_command_repeat1] = STATE(189),
    [sym_file_descriptor] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1054),
    [anon_sym_LT] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1060),
    [anon_sym_AMP_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT_GT] = ACTIONS(1060),
    [anon_sym_LT_AMP] = ACTIONS(1060),
    [anon_sym_GT_AMP] = ACTIONS(1060),
    [sym__special_characters] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1063),
  },
  [190] = {
    [aux_sym_concatenation_repeat1] = STATE(417),
    [sym_file_descriptor] = ACTIONS(1067),
    [sym__concat] = ACTIONS(747),
    [sym_variable_name] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1069),
    [anon_sym_GT_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT] = ACTIONS(1069),
    [anon_sym_AMP_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_AMP] = ACTIONS(1067),
    [anon_sym_GT_AMP] = ACTIONS(1067),
    [sym__special_characters] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_DOLLAR] = ACTIONS(1069),
    [sym_raw_string] = ACTIONS(1067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1067),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [anon_sym_LT_LPAREN] = ACTIONS(1067),
    [anon_sym_GT_LPAREN] = ACTIONS(1067),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1067),
  },
  [191] = {
    [aux_sym_concatenation_repeat1] = STATE(417),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(747),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [sym__special_characters] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1071),
  },
  [192] = {
    [sym_file_descriptor] = ACTIONS(1071),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [sym__special_characters] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1071),
  },
  [193] = {
    [aux_sym_concatenation_repeat1] = STATE(529),
    [sym__concat] = ACTIONS(1075),
    [anon_sym_RBRACK] = ACTIONS(1077),
    [sym_comment] = ACTIONS(57),
  },
  [194] = {
    [aux_sym_concatenation_repeat1] = STATE(529),
    [sym__concat] = ACTIONS(1079),
    [anon_sym_RBRACK] = ACTIONS(1081),
    [sym_comment] = ACTIONS(57),
  },
  [195] = {
    [sym__concat] = ACTIONS(1083),
    [anon_sym_RBRACK] = ACTIONS(1081),
    [sym_comment] = ACTIONS(57),
  },
  [196] = {
    [sym__simple_heredoc_body] = ACTIONS(1085),
    [sym__heredoc_body_beginning] = ACTIONS(1085),
    [sym_file_descriptor] = ACTIONS(1085),
    [sym_variable_name] = ACTIONS(1085),
    [ts_builtin_sym_end] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(1085),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1087),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym__special_characters] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_DOLLAR] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1085),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [anon_sym_LT_LPAREN] = ACTIONS(1085),
    [anon_sym_GT_LPAREN] = ACTIONS(1085),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1087),
    [anon_sym_LF] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1087),
  },
  [197] = {
    [sym_concatenation] = STATE(542),
    [sym_string] = STATE(537),
    [sym_simple_expansion] = STATE(537),
    [sym_string_expansion] = STATE(537),
    [sym_expansion] = STATE(537),
    [sym_command_substitution] = STATE(537),
    [sym_process_substitution] = STATE(537),
    [aux_sym_for_statement_repeat1] = STATE(542),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1095),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
  },
  [198] = {
    [aux_sym_concatenation_repeat1] = STATE(544),
    [sym__simple_heredoc_body] = ACTIONS(1107),
    [sym__heredoc_body_beginning] = ACTIONS(1107),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(1109),
    [sym_variable_name] = ACTIONS(1107),
    [ts_builtin_sym_end] = ACTIONS(1107),
    [anon_sym_SEMI] = ACTIONS(1111),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_SEMI_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT] = ACTIONS(1111),
    [anon_sym_AMP_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_AMP] = ACTIONS(1107),
    [anon_sym_GT_AMP] = ACTIONS(1107),
    [anon_sym_LT_LT] = ACTIONS(1111),
    [anon_sym_LT_LT_DASH] = ACTIONS(1107),
    [anon_sym_LT_LT_LT] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1111),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1111),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1111),
  },
  [199] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(547),
    [anon_sym_DQUOTE] = ACTIONS(1113),
    [anon_sym_DOLLAR] = ACTIONS(1115),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [200] = {
    [sym_string] = STATE(549),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DQUOTE] = ACTIONS(359),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1121),
    [anon_sym_STAR] = ACTIONS(1123),
    [anon_sym_AT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_0] = ACTIONS(1121),
    [anon_sym__] = ACTIONS(1121),
  },
  [201] = {
    [aux_sym_concatenation_repeat1] = STATE(544),
    [sym__simple_heredoc_body] = ACTIONS(1085),
    [sym__heredoc_body_beginning] = ACTIONS(1085),
    [sym_file_descriptor] = ACTIONS(1085),
    [sym__concat] = ACTIONS(1109),
    [sym_variable_name] = ACTIONS(1085),
    [ts_builtin_sym_end] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1087),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym__special_characters] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_DOLLAR] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1085),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [anon_sym_LT_LPAREN] = ACTIONS(1085),
    [anon_sym_GT_LPAREN] = ACTIONS(1085),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1087),
    [anon_sym_LF] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1087),
  },
  [202] = {
    [sym_subscript] = STATE(554),
    [sym_variable_name] = ACTIONS(1125),
    [anon_sym_BANG] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [anon_sym_POUND] = ACTIONS(1127),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_QMARK] = ACTIONS(1133),
    [anon_sym_0] = ACTIONS(1131),
    [anon_sym__] = ACTIONS(1131),
  },
  [203] = {
    [sym__terminated_statement] = STATE(557),
    [sym_redirected_statement] = STATE(555),
    [sym_for_statement] = STATE(555),
    [sym_c_style_for_statement] = STATE(555),
    [sym_while_statement] = STATE(555),
    [sym_if_statement] = STATE(555),
    [sym_case_statement] = STATE(555),
    [sym_function_definition] = STATE(555),
    [sym_compound_statement] = STATE(555),
    [sym_subshell] = STATE(555),
    [sym_pipeline] = STATE(555),
    [sym_list] = STATE(555),
    [sym_negated_command] = STATE(555),
    [sym_test_command] = STATE(555),
    [sym_declaration_command] = STATE(555),
    [sym_unset_command] = STATE(555),
    [sym_command] = STATE(555),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(556),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(557),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [204] = {
    [sym__terminated_statement] = STATE(560),
    [sym_redirected_statement] = STATE(558),
    [sym_for_statement] = STATE(558),
    [sym_c_style_for_statement] = STATE(558),
    [sym_while_statement] = STATE(558),
    [sym_if_statement] = STATE(558),
    [sym_case_statement] = STATE(558),
    [sym_function_definition] = STATE(558),
    [sym_compound_statement] = STATE(558),
    [sym_subshell] = STATE(558),
    [sym_pipeline] = STATE(558),
    [sym_list] = STATE(558),
    [sym_negated_command] = STATE(558),
    [sym_test_command] = STATE(558),
    [sym_declaration_command] = STATE(558),
    [sym_unset_command] = STATE(558),
    [sym_command] = STATE(558),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(559),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(560),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [205] = {
    [sym__terminated_statement] = STATE(563),
    [sym_redirected_statement] = STATE(561),
    [sym_for_statement] = STATE(561),
    [sym_c_style_for_statement] = STATE(561),
    [sym_while_statement] = STATE(561),
    [sym_if_statement] = STATE(561),
    [sym_case_statement] = STATE(561),
    [sym_function_definition] = STATE(561),
    [sym_compound_statement] = STATE(561),
    [sym_subshell] = STATE(561),
    [sym_pipeline] = STATE(561),
    [sym_list] = STATE(561),
    [sym_negated_command] = STATE(561),
    [sym_test_command] = STATE(561),
    [sym_declaration_command] = STATE(561),
    [sym_unset_command] = STATE(561),
    [sym_command] = STATE(561),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(562),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(563),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [206] = {
    [sym__expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_postfix_expression] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_concatenation] = STATE(565),
    [sym_string] = STATE(212),
    [sym_simple_expansion] = STATE(212),
    [sym_string_expansion] = STATE(212),
    [sym_expansion] = STATE(212),
    [sym_command_substitution] = STATE(212),
    [sym_process_substitution] = STATE(212),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym_SEMI_SEMI] = ACTIONS(1137),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_BANG] = ACTIONS(379),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(391),
    [anon_sym_BQUOTE] = ACTIONS(393),
    [anon_sym_LT_LPAREN] = ACTIONS(395),
    [anon_sym_GT_LPAREN] = ACTIONS(395),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(397),
    [sym_test_operator] = ACTIONS(399),
    [anon_sym_LF] = ACTIONS(1137),
    [anon_sym_AMP] = ACTIONS(1137),
  },
  [207] = {
    [sym__expression] = STATE(566),
    [sym_binary_expression] = STATE(566),
    [sym_unary_expression] = STATE(566),
    [sym_postfix_expression] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym_concatenation] = STATE(566),
    [sym_string] = STATE(225),
    [sym_simple_expansion] = STATE(225),
    [sym_string_expansion] = STATE(225),
    [sym_expansion] = STATE(225),
    [sym_command_substitution] = STATE(225),
    [sym_process_substitution] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_BANG] = ACTIONS(409),
    [sym__special_characters] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [sym_raw_string] = ACTIONS(417),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(421),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(425),
    [anon_sym_GT_LPAREN] = ACTIONS(425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(427),
    [sym_test_operator] = ACTIONS(429),
  },
  [208] = {
    [sym__expression] = STATE(567),
    [sym_binary_expression] = STATE(567),
    [sym_unary_expression] = STATE(567),
    [sym_postfix_expression] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_concatenation] = STATE(567),
    [sym_string] = STATE(212),
    [sym_simple_expansion] = STATE(212),
    [sym_string_expansion] = STATE(212),
    [sym_expansion] = STATE(212),
    [sym_command_substitution] = STATE(212),
    [sym_process_substitution] = STATE(212),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_BANG] = ACTIONS(379),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(391),
    [anon_sym_BQUOTE] = ACTIONS(393),
    [anon_sym_LT_LPAREN] = ACTIONS(395),
    [anon_sym_GT_LPAREN] = ACTIONS(395),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(397),
    [sym_test_operator] = ACTIONS(399),
  },
  [209] = {
    [aux_sym_concatenation_repeat1] = STATE(569),
    [sym__concat] = ACTIONS(1139),
    [anon_sym_SEMI] = ACTIONS(435),
    [anon_sym_SEMI_SEMI] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_EQ_TILDE] = ACTIONS(433),
    [anon_sym_EQ_EQ] = ACTIONS(433),
    [anon_sym_EQ] = ACTIONS(435),
    [anon_sym_PLUS_EQ] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_BANG_EQ] = ACTIONS(433),
    [anon_sym_PLUS] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(435),
    [anon_sym_DASH_EQ] = ACTIONS(433),
    [anon_sym_LT_EQ] = ACTIONS(433),
    [anon_sym_GT_EQ] = ACTIONS(433),
    [anon_sym_PLUS_PLUS] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(433),
    [anon_sym_LF] = ACTIONS(433),
    [anon_sym_AMP] = ACTIONS(435),
  },
  [210] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(572),
    [anon_sym_DQUOTE] = ACTIONS(1141),
    [anon_sym_DOLLAR] = ACTIONS(1143),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [211] = {
    [sym_string] = STATE(574),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DOLLAR] = ACTIONS(1145),
    [sym_raw_string] = ACTIONS(1147),
    [anon_sym_POUND] = ACTIONS(1145),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1149),
    [anon_sym_STAR] = ACTIONS(1151),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym_QMARK] = ACTIONS(1151),
    [anon_sym_0] = ACTIONS(1149),
    [anon_sym__] = ACTIONS(1149),
  },
  [212] = {
    [aux_sym_concatenation_repeat1] = STATE(569),
    [sym__concat] = ACTIONS(1139),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_SEMI_SEMI] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(451),
    [anon_sym_GT] = ACTIONS(451),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(451),
    [anon_sym_DASH] = ACTIONS(451),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(449),
    [anon_sym_LF] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(451),
  },
  [213] = {
    [sym_subscript] = STATE(579),
    [sym_variable_name] = ACTIONS(1153),
    [anon_sym_BANG] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1157),
    [anon_sym_DOLLAR] = ACTIONS(1157),
    [anon_sym_POUND] = ACTIONS(1155),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1159),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_QMARK] = ACTIONS(1161),
    [anon_sym_0] = ACTIONS(1159),
    [anon_sym__] = ACTIONS(1159),
  },
  [214] = {
    [sym__terminated_statement] = STATE(582),
    [sym_redirected_statement] = STATE(580),
    [sym_for_statement] = STATE(580),
    [sym_c_style_for_statement] = STATE(580),
    [sym_while_statement] = STATE(580),
    [sym_if_statement] = STATE(580),
    [sym_case_statement] = STATE(580),
    [sym_function_definition] = STATE(580),
    [sym_compound_statement] = STATE(580),
    [sym_subshell] = STATE(580),
    [sym_pipeline] = STATE(580),
    [sym_list] = STATE(580),
    [sym_negated_command] = STATE(580),
    [sym_test_command] = STATE(580),
    [sym_declaration_command] = STATE(580),
    [sym_unset_command] = STATE(580),
    [sym_command] = STATE(580),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(581),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(582),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [215] = {
    [sym__terminated_statement] = STATE(585),
    [sym_redirected_statement] = STATE(583),
    [sym_for_statement] = STATE(583),
    [sym_c_style_for_statement] = STATE(583),
    [sym_while_statement] = STATE(583),
    [sym_if_statement] = STATE(583),
    [sym_case_statement] = STATE(583),
    [sym_function_definition] = STATE(583),
    [sym_compound_statement] = STATE(583),
    [sym_subshell] = STATE(583),
    [sym_pipeline] = STATE(583),
    [sym_list] = STATE(583),
    [sym_negated_command] = STATE(583),
    [sym_test_command] = STATE(583),
    [sym_declaration_command] = STATE(583),
    [sym_unset_command] = STATE(583),
    [sym_command] = STATE(583),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(584),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(585),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [216] = {
    [sym__terminated_statement] = STATE(588),
    [sym_redirected_statement] = STATE(586),
    [sym_for_statement] = STATE(586),
    [sym_c_style_for_statement] = STATE(586),
    [sym_while_statement] = STATE(586),
    [sym_if_statement] = STATE(586),
    [sym_case_statement] = STATE(586),
    [sym_function_definition] = STATE(586),
    [sym_compound_statement] = STATE(586),
    [sym_subshell] = STATE(586),
    [sym_pipeline] = STATE(586),
    [sym_list] = STATE(586),
    [sym_negated_command] = STATE(586),
    [sym_test_command] = STATE(586),
    [sym_declaration_command] = STATE(586),
    [sym_unset_command] = STATE(586),
    [sym_command] = STATE(586),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(587),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(588),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [217] = {
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym_SEMI_SEMI] = ACTIONS(1165),
    [anon_sym_AMP_AMP] = ACTIONS(1167),
    [anon_sym_PIPE_PIPE] = ACTIONS(1167),
    [anon_sym_EQ_TILDE] = ACTIONS(1169),
    [anon_sym_EQ_EQ] = ACTIONS(1169),
    [anon_sym_EQ] = ACTIONS(1171),
    [anon_sym_PLUS_EQ] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(1171),
    [anon_sym_BANG_EQ] = ACTIONS(1167),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1171),
    [anon_sym_DASH_EQ] = ACTIONS(1167),
    [anon_sym_LT_EQ] = ACTIONS(1167),
    [anon_sym_GT_EQ] = ACTIONS(1167),
    [anon_sym_PLUS_PLUS] = ACTIONS(1173),
    [anon_sym_DASH_DASH] = ACTIONS(1173),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1167),
    [anon_sym_LF] = ACTIONS(1165),
    [anon_sym_AMP] = ACTIONS(1163),
  },
  [218] = {
    [sym_concatenation] = STATE(601),
    [sym_string] = STATE(596),
    [sym_simple_expansion] = STATE(596),
    [sym_string_expansion] = STATE(596),
    [sym_expansion] = STATE(596),
    [sym_command_substitution] = STATE(596),
    [sym_process_substitution] = STATE(596),
    [aux_sym_for_statement_repeat1] = STATE(601),
    [sym__special_characters] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_DOLLAR] = ACTIONS(1179),
    [sym_raw_string] = ACTIONS(1181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1183),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1185),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1189),
    [anon_sym_GT_LPAREN] = ACTIONS(1189),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1181),
  },
  [219] = {
    [sym_do_group] = STATE(602),
    [anon_sym_do] = ACTIONS(493),
    [sym_comment] = ACTIONS(57),
  },
  [220] = {
    [sym__expression] = STATE(603),
    [sym_binary_expression] = STATE(603),
    [sym_unary_expression] = STATE(603),
    [sym_postfix_expression] = STATE(603),
    [sym_parenthesized_expression] = STATE(603),
    [sym_concatenation] = STATE(603),
    [sym_string] = STATE(225),
    [sym_simple_expansion] = STATE(225),
    [sym_string_expansion] = STATE(225),
    [sym_expansion] = STATE(225),
    [sym_command_substitution] = STATE(225),
    [sym_process_substitution] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_BANG] = ACTIONS(409),
    [sym__special_characters] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [sym_raw_string] = ACTIONS(417),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(421),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(425),
    [anon_sym_GT_LPAREN] = ACTIONS(425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(427),
    [sym_test_operator] = ACTIONS(429),
  },
  [221] = {
    [sym__expression] = STATE(604),
    [sym_binary_expression] = STATE(604),
    [sym_unary_expression] = STATE(604),
    [sym_postfix_expression] = STATE(604),
    [sym_parenthesized_expression] = STATE(604),
    [sym_concatenation] = STATE(604),
    [sym_string] = STATE(225),
    [sym_simple_expansion] = STATE(225),
    [sym_string_expansion] = STATE(225),
    [sym_expansion] = STATE(225),
    [sym_command_substitution] = STATE(225),
    [sym_process_substitution] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_BANG] = ACTIONS(409),
    [sym__special_characters] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [sym_raw_string] = ACTIONS(417),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(421),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(425),
    [anon_sym_GT_LPAREN] = ACTIONS(425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(427),
    [sym_test_operator] = ACTIONS(429),
  },
  [222] = {
    [aux_sym_concatenation_repeat1] = STATE(606),
    [sym__concat] = ACTIONS(1191),
    [anon_sym_RPAREN] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_EQ_TILDE] = ACTIONS(433),
    [anon_sym_EQ_EQ] = ACTIONS(433),
    [anon_sym_EQ] = ACTIONS(435),
    [anon_sym_PLUS_EQ] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_BANG_EQ] = ACTIONS(433),
    [anon_sym_PLUS] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(435),
    [anon_sym_DASH_EQ] = ACTIONS(433),
    [anon_sym_LT_EQ] = ACTIONS(433),
    [anon_sym_GT_EQ] = ACTIONS(433),
    [anon_sym_PLUS_PLUS] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(433),
  },
  [223] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(609),
    [anon_sym_DQUOTE] = ACTIONS(1193),
    [anon_sym_DOLLAR] = ACTIONS(1195),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [224] = {
    [sym_string] = STATE(611),
    [anon_sym_DASH] = ACTIONS(1197),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(1197),
    [sym_raw_string] = ACTIONS(1199),
    [anon_sym_POUND] = ACTIONS(1197),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_AT] = ACTIONS(1203),
    [anon_sym_QMARK] = ACTIONS(1203),
    [anon_sym_0] = ACTIONS(1201),
    [anon_sym__] = ACTIONS(1201),
  },
  [225] = {
    [aux_sym_concatenation_repeat1] = STATE(606),
    [sym__concat] = ACTIONS(1191),
    [anon_sym_RPAREN] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_EQ_TILDE] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_PLUS_EQ] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(451),
    [anon_sym_GT] = ACTIONS(451),
    [anon_sym_BANG_EQ] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(451),
    [anon_sym_DASH] = ACTIONS(451),
    [anon_sym_DASH_EQ] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(449),
  },
  [226] = {
    [sym_subscript] = STATE(616),
    [sym_variable_name] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1209),
    [anon_sym_DOLLAR] = ACTIONS(1209),
    [anon_sym_POUND] = ACTIONS(1207),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1211),
    [anon_sym_STAR] = ACTIONS(1213),
    [anon_sym_AT] = ACTIONS(1213),
    [anon_sym_QMARK] = ACTIONS(1213),
    [anon_sym_0] = ACTIONS(1211),
    [anon_sym__] = ACTIONS(1211),
  },
  [227] = {
    [sym__terminated_statement] = STATE(619),
    [sym_redirected_statement] = STATE(617),
    [sym_for_statement] = STATE(617),
    [sym_c_style_for_statement] = STATE(617),
    [sym_while_statement] = STATE(617),
    [sym_if_statement] = STATE(617),
    [sym_case_statement] = STATE(617),
    [sym_function_definition] = STATE(617),
    [sym_compound_statement] = STATE(617),
    [sym_subshell] = STATE(617),
    [sym_pipeline] = STATE(617),
    [sym_list] = STATE(617),
    [sym_negated_command] = STATE(617),
    [sym_test_command] = STATE(617),
    [sym_declaration_command] = STATE(617),
    [sym_unset_command] = STATE(617),
    [sym_command] = STATE(617),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(618),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(619),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [228] = {
    [sym__terminated_statement] = STATE(622),
    [sym_redirected_statement] = STATE(620),
    [sym_for_statement] = STATE(620),
    [sym_c_style_for_statement] = STATE(620),
    [sym_while_statement] = STATE(620),
    [sym_if_statement] = STATE(620),
    [sym_case_statement] = STATE(620),
    [sym_function_definition] = STATE(620),
    [sym_compound_statement] = STATE(620),
    [sym_subshell] = STATE(620),
    [sym_pipeline] = STATE(620),
    [sym_list] = STATE(620),
    [sym_negated_command] = STATE(620),
    [sym_test_command] = STATE(620),
    [sym_declaration_command] = STATE(620),
    [sym_unset_command] = STATE(620),
    [sym_command] = STATE(620),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(621),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(622),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [229] = {
    [sym__terminated_statement] = STATE(625),
    [sym_redirected_statement] = STATE(623),
    [sym_for_statement] = STATE(623),
    [sym_c_style_for_statement] = STATE(623),
    [sym_while_statement] = STATE(623),
    [sym_if_statement] = STATE(623),
    [sym_case_statement] = STATE(623),
    [sym_function_definition] = STATE(623),
    [sym_compound_statement] = STATE(623),
    [sym_subshell] = STATE(623),
    [sym_pipeline] = STATE(623),
    [sym_list] = STATE(623),
    [sym_negated_command] = STATE(623),
    [sym_test_command] = STATE(623),
    [sym_declaration_command] = STATE(623),
    [sym_unset_command] = STATE(623),
    [sym_command] = STATE(623),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(624),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(625),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [230] = {
    [anon_sym_RPAREN] = ACTIONS(1215),
    [anon_sym_AMP_AMP] = ACTIONS(1217),
    [anon_sym_PIPE_PIPE] = ACTIONS(1217),
    [anon_sym_EQ_TILDE] = ACTIONS(1219),
    [anon_sym_EQ_EQ] = ACTIONS(1219),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_PLUS_EQ] = ACTIONS(1217),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_BANG_EQ] = ACTIONS(1217),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_DASH_EQ] = ACTIONS(1217),
    [anon_sym_LT_EQ] = ACTIONS(1217),
    [anon_sym_GT_EQ] = ACTIONS(1217),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1217),
  },
  [231] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE_PIPE] = ACTIONS(465),
    [anon_sym_EQ_TILDE] = ACTIONS(467),
    [anon_sym_EQ_EQ] = ACTIONS(467),
    [anon_sym_EQ] = ACTIONS(469),
    [anon_sym_PLUS_EQ] = ACTIONS(465),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_BANG_EQ] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(469),
    [anon_sym_DASH] = ACTIONS(469),
    [anon_sym_DASH_EQ] = ACTIONS(465),
    [anon_sym_LT_EQ] = ACTIONS(465),
    [anon_sym_GT_EQ] = ACTIONS(465),
    [anon_sym_PLUS_PLUS] = ACTIONS(471),
    [anon_sym_DASH_DASH] = ACTIONS(471),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(465),
  },
  [232] = {
    [sym_string] = STATE(630),
    [sym_simple_expansion] = STATE(630),
    [sym_string_expansion] = STATE(630),
    [sym_expansion] = STATE(630),
    [sym_command_substitution] = STATE(630),
    [sym_process_substitution] = STATE(630),
    [sym__special_characters] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(1227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1227),
  },
  [233] = {
    [aux_sym_concatenation_repeat1] = STATE(631),
    [sym__concat] = ACTIONS(431),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_EQ_TILDE] = ACTIONS(779),
    [anon_sym_EQ_EQ] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(781),
    [anon_sym_PLUS_EQ] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_BANG_EQ] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_DASH_EQ] = ACTIONS(779),
    [anon_sym_LT_EQ] = ACTIONS(779),
    [anon_sym_GT_EQ] = ACTIONS(779),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(779),
  },
  [234] = {
    [sym__concat] = ACTIONS(783),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(783),
    [anon_sym_EQ_TILDE] = ACTIONS(783),
    [anon_sym_EQ_EQ] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_PLUS_EQ] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_BANG_EQ] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_DASH_EQ] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(783),
    [anon_sym_GT_EQ] = ACTIONS(783),
    [anon_sym_PLUS_PLUS] = ACTIONS(783),
    [anon_sym_DASH_DASH] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(783),
  },
  [235] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(1229),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [236] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(1229),
    [anon_sym_DOLLAR] = ACTIONS(1231),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [237] = {
    [sym__concat] = ACTIONS(817),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(817),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(817),
    [anon_sym_EQ_TILDE] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(817),
    [anon_sym_EQ] = ACTIONS(819),
    [anon_sym_PLUS_EQ] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_BANG_EQ] = ACTIONS(817),
    [anon_sym_PLUS] = ACTIONS(819),
    [anon_sym_DASH] = ACTIONS(819),
    [anon_sym_DASH_EQ] = ACTIONS(817),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(817),
    [anon_sym_DASH_DASH] = ACTIONS(817),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(817),
  },
  [238] = {
    [sym__concat] = ACTIONS(821),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(821),
    [anon_sym_EQ_TILDE] = ACTIONS(821),
    [anon_sym_EQ_EQ] = ACTIONS(821),
    [anon_sym_EQ] = ACTIONS(823),
    [anon_sym_PLUS_EQ] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_BANG_EQ] = ACTIONS(821),
    [anon_sym_PLUS] = ACTIONS(823),
    [anon_sym_DASH] = ACTIONS(823),
    [anon_sym_DASH_EQ] = ACTIONS(821),
    [anon_sym_LT_EQ] = ACTIONS(821),
    [anon_sym_GT_EQ] = ACTIONS(821),
    [anon_sym_PLUS_PLUS] = ACTIONS(821),
    [anon_sym_DASH_DASH] = ACTIONS(821),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(821),
  },
  [239] = {
    [sym__concat] = ACTIONS(825),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(825),
    [anon_sym_AMP_AMP] = ACTIONS(825),
    [anon_sym_PIPE_PIPE] = ACTIONS(825),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(825),
    [anon_sym_EQ_TILDE] = ACTIONS(825),
    [anon_sym_EQ_EQ] = ACTIONS(825),
    [anon_sym_EQ] = ACTIONS(827),
    [anon_sym_PLUS_EQ] = ACTIONS(825),
    [anon_sym_LT] = ACTIONS(827),
    [anon_sym_GT] = ACTIONS(827),
    [anon_sym_BANG_EQ] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_DASH_EQ] = ACTIONS(825),
    [anon_sym_LT_EQ] = ACTIONS(825),
    [anon_sym_GT_EQ] = ACTIONS(825),
    [anon_sym_PLUS_PLUS] = ACTIONS(825),
    [anon_sym_DASH_DASH] = ACTIONS(825),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(825),
  },
  [240] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(1233),
    [sym_comment] = ACTIONS(57),
  },
  [241] = {
    [sym_subscript] = STATE(637),
    [sym_variable_name] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_DOLLAR] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(1241),
    [anon_sym_AT] = ACTIONS(1241),
    [anon_sym_QMARK] = ACTIONS(1241),
    [anon_sym_0] = ACTIONS(1239),
    [anon_sym__] = ACTIONS(1239),
  },
  [242] = {
    [sym_concatenation] = STATE(640),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(640),
    [anon_sym_RBRACE] = ACTIONS(1243),
    [anon_sym_EQ] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1245),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(1249),
    [anon_sym_COLON] = ACTIONS(1245),
    [anon_sym_COLON_QMARK] = ACTIONS(1245),
    [anon_sym_COLON_DASH] = ACTIONS(1245),
    [anon_sym_PERCENT] = ACTIONS(1245),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [243] = {
    [sym_concatenation] = STATE(643),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(643),
    [anon_sym_RBRACE] = ACTIONS(1251),
    [anon_sym_EQ] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1255),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(1257),
    [anon_sym_COLON] = ACTIONS(1253),
    [anon_sym_COLON_QMARK] = ACTIONS(1253),
    [anon_sym_COLON_DASH] = ACTIONS(1253),
    [anon_sym_PERCENT] = ACTIONS(1253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [244] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(646),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [245] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(646),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [246] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(647),
    [sym_for_statement] = STATE(647),
    [sym_c_style_for_statement] = STATE(647),
    [sym_while_statement] = STATE(647),
    [sym_if_statement] = STATE(647),
    [sym_case_statement] = STATE(647),
    [sym_function_definition] = STATE(647),
    [sym_compound_statement] = STATE(647),
    [sym_subshell] = STATE(647),
    [sym_pipeline] = STATE(647),
    [sym_list] = STATE(647),
    [sym_negated_command] = STATE(647),
    [sym_test_command] = STATE(647),
    [sym_declaration_command] = STATE(647),
    [sym_unset_command] = STATE(647),
    [sym_command] = STATE(647),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(648),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [247] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(650),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1265),
  },
  [248] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(650),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1265),
  },
  [249] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(651),
    [sym_for_statement] = STATE(651),
    [sym_c_style_for_statement] = STATE(651),
    [sym_while_statement] = STATE(651),
    [sym_if_statement] = STATE(651),
    [sym_case_statement] = STATE(651),
    [sym_function_definition] = STATE(651),
    [sym_compound_statement] = STATE(651),
    [sym_subshell] = STATE(651),
    [sym_pipeline] = STATE(651),
    [sym_list] = STATE(651),
    [sym_negated_command] = STATE(651),
    [sym_test_command] = STATE(651),
    [sym_declaration_command] = STATE(651),
    [sym_unset_command] = STATE(651),
    [sym_command] = STATE(651),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(652),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [250] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(655),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1273),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [251] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(655),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1273),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [252] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(656),
    [sym_for_statement] = STATE(656),
    [sym_c_style_for_statement] = STATE(656),
    [sym_while_statement] = STATE(656),
    [sym_if_statement] = STATE(656),
    [sym_case_statement] = STATE(656),
    [sym_function_definition] = STATE(656),
    [sym_compound_statement] = STATE(656),
    [sym_subshell] = STATE(656),
    [sym_pipeline] = STATE(656),
    [sym_list] = STATE(656),
    [sym_negated_command] = STATE(656),
    [sym_test_command] = STATE(656),
    [sym_declaration_command] = STATE(656),
    [sym_unset_command] = STATE(656),
    [sym_command] = STATE(656),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(657),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [253] = {
    [sym__simple_heredoc_body] = ACTIONS(1275),
    [sym__heredoc_body_beginning] = ACTIONS(1275),
    [sym_file_descriptor] = ACTIONS(1275),
    [ts_builtin_sym_end] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1277),
    [anon_sym_esac] = ACTIONS(1275),
    [anon_sym_PIPE] = ACTIONS(1277),
    [anon_sym_RPAREN] = ACTIONS(1275),
    [anon_sym_SEMI_SEMI] = ACTIONS(1275),
    [anon_sym_PIPE_AMP] = ACTIONS(1275),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1277),
    [anon_sym_GT] = ACTIONS(1277),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_AMP_GT] = ACTIONS(1277),
    [anon_sym_AMP_GT_GT] = ACTIONS(1275),
    [anon_sym_LT_AMP] = ACTIONS(1275),
    [anon_sym_GT_AMP] = ACTIONS(1275),
    [anon_sym_LT_LT] = ACTIONS(1277),
    [anon_sym_LT_LT_DASH] = ACTIONS(1275),
    [anon_sym_LT_LT_LT] = ACTIONS(1275),
    [anon_sym_BQUOTE] = ACTIONS(1275),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1277),
  },
  [254] = {
    [sym__expression] = STATE(658),
    [sym_binary_expression] = STATE(658),
    [sym_unary_expression] = STATE(658),
    [sym_postfix_expression] = STATE(658),
    [sym_parenthesized_expression] = STATE(658),
    [sym_concatenation] = STATE(658),
    [sym_string] = STATE(45),
    [sym_simple_expansion] = STATE(45),
    [sym_string_expansion] = STATE(45),
    [sym_expansion] = STATE(45),
    [sym_command_substitution] = STATE(45),
    [sym_process_substitution] = STATE(45),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [255] = {
    [sym__expression] = STATE(658),
    [sym_binary_expression] = STATE(658),
    [sym_unary_expression] = STATE(658),
    [sym_postfix_expression] = STATE(658),
    [sym_parenthesized_expression] = STATE(658),
    [sym_concatenation] = STATE(658),
    [sym_string] = STATE(45),
    [sym_simple_expansion] = STATE(45),
    [sym_string_expansion] = STATE(45),
    [sym_expansion] = STATE(45),
    [sym_command_substitution] = STATE(45),
    [sym_process_substitution] = STATE(45),
    [sym_regex] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [256] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1281),
    [anon_sym_AMP_AMP] = ACTIONS(1281),
    [anon_sym_PIPE_PIPE] = ACTIONS(1281),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1281),
    [anon_sym_EQ_TILDE] = ACTIONS(1281),
    [anon_sym_EQ_EQ] = ACTIONS(1281),
    [anon_sym_EQ] = ACTIONS(1283),
    [anon_sym_PLUS_EQ] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_BANG_EQ] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_EQ] = ACTIONS(1281),
    [anon_sym_LT_EQ] = ACTIONS(1281),
    [anon_sym_GT_EQ] = ACTIONS(1281),
    [anon_sym_PLUS_PLUS] = ACTIONS(1281),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1281),
  },
  [257] = {
    [sym_concatenation] = STATE(196),
    [sym_string] = STATE(661),
    [sym_array] = STATE(196),
    [sym_simple_expansion] = STATE(661),
    [sym_string_expansion] = STATE(661),
    [sym_expansion] = STATE(661),
    [sym_command_substitution] = STATE(661),
    [sym_process_substitution] = STATE(661),
    [sym__empty_value] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(355),
    [sym__special_characters] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(359),
    [anon_sym_DOLLAR] = ACTIONS(361),
    [sym_raw_string] = ACTIONS(1287),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(365),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1287),
  },
  [258] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1289),
    [anon_sym_PLUS_EQ] = ACTIONS(1289),
    [sym_comment] = ACTIONS(57),
  },
  [259] = {
    [aux_sym_concatenation_repeat1] = STATE(663),
    [sym__simple_heredoc_body] = ACTIONS(669),
    [sym__heredoc_body_beginning] = ACTIONS(669),
    [sym_file_descriptor] = ACTIONS(669),
    [sym__concat] = ACTIONS(671),
    [sym_variable_name] = ACTIONS(669),
    [anon_sym_SEMI] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_SEMI_SEMI] = ACTIONS(669),
    [anon_sym_PIPE_AMP] = ACTIONS(669),
    [anon_sym_AMP_AMP] = ACTIONS(669),
    [anon_sym_PIPE_PIPE] = ACTIONS(669),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(669),
    [anon_sym_AMP_GT] = ACTIONS(673),
    [anon_sym_AMP_GT_GT] = ACTIONS(669),
    [anon_sym_LT_AMP] = ACTIONS(669),
    [anon_sym_GT_AMP] = ACTIONS(669),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_LT_LT_DASH] = ACTIONS(669),
    [anon_sym_LT_LT_LT] = ACTIONS(669),
    [sym__special_characters] = ACTIONS(669),
    [anon_sym_DQUOTE] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(673),
    [sym_raw_string] = ACTIONS(669),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(669),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(669),
    [anon_sym_BQUOTE] = ACTIONS(669),
    [anon_sym_LT_LPAREN] = ACTIONS(669),
    [anon_sym_GT_LPAREN] = ACTIONS(669),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(673),
    [sym_word] = ACTIONS(673),
    [anon_sym_LF] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(673),
  },
  [260] = {
    [aux_sym_concatenation_repeat1] = STATE(663),
    [sym__simple_heredoc_body] = ACTIONS(687),
    [sym__heredoc_body_beginning] = ACTIONS(687),
    [sym_file_descriptor] = ACTIONS(687),
    [sym__concat] = ACTIONS(671),
    [sym_variable_name] = ACTIONS(687),
    [anon_sym_SEMI] = ACTIONS(689),
    [anon_sym_PIPE] = ACTIONS(689),
    [anon_sym_SEMI_SEMI] = ACTIONS(687),
    [anon_sym_PIPE_AMP] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(687),
    [anon_sym_PIPE_PIPE] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(689),
    [anon_sym_GT] = ACTIONS(689),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_AMP_GT] = ACTIONS(689),
    [anon_sym_AMP_GT_GT] = ACTIONS(687),
    [anon_sym_LT_AMP] = ACTIONS(687),
    [anon_sym_GT_AMP] = ACTIONS(687),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_LT_LT_LT] = ACTIONS(687),
    [sym__special_characters] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(687),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(687),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_LT_LPAREN] = ACTIONS(687),
    [anon_sym_GT_LPAREN] = ACTIONS(687),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(689),
    [sym_word] = ACTIONS(689),
    [anon_sym_LF] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(689),
  },
  [261] = {
    [anon_sym_EQ] = ACTIONS(1289),
    [anon_sym_PLUS_EQ] = ACTIONS(1289),
    [sym_comment] = ACTIONS(57),
  },
  [262] = {
    [sym_variable_assignment] = STATE(664),
    [sym_subscript] = STATE(261),
    [sym_concatenation] = STATE(664),
    [sym_string] = STATE(260),
    [sym_simple_expansion] = STATE(260),
    [sym_string_expansion] = STATE(260),
    [sym_expansion] = STATE(260),
    [sym_command_substitution] = STATE(260),
    [sym_process_substitution] = STATE(260),
    [aux_sym_declaration_command_repeat1] = STATE(664),
    [sym__simple_heredoc_body] = ACTIONS(701),
    [sym__heredoc_body_beginning] = ACTIONS(701),
    [sym_file_descriptor] = ACTIONS(701),
    [sym_variable_name] = ACTIONS(475),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_SEMI_SEMI] = ACTIONS(701),
    [anon_sym_PIPE_AMP] = ACTIONS(701),
    [anon_sym_AMP_AMP] = ACTIONS(701),
    [anon_sym_PIPE_PIPE] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(703),
    [anon_sym_GT] = ACTIONS(703),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_AMP_GT] = ACTIONS(703),
    [anon_sym_AMP_GT_GT] = ACTIONS(701),
    [anon_sym_LT_AMP] = ACTIONS(701),
    [anon_sym_GT_AMP] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(703),
    [anon_sym_LT_LT_DASH] = ACTIONS(701),
    [anon_sym_LT_LT_LT] = ACTIONS(701),
    [sym__special_characters] = ACTIONS(477),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(479),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1291),
    [sym_word] = ACTIONS(483),
    [anon_sym_LF] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(703),
  },
  [263] = {
    [aux_sym_concatenation_repeat1] = STATE(665),
    [sym__simple_heredoc_body] = ACTIONS(707),
    [sym__heredoc_body_beginning] = ACTIONS(707),
    [sym_file_descriptor] = ACTIONS(707),
    [sym__concat] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(711),
    [anon_sym_PIPE] = ACTIONS(711),
    [anon_sym_SEMI_SEMI] = ACTIONS(707),
    [anon_sym_PIPE_AMP] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(707),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_GT] = ACTIONS(707),
    [anon_sym_AMP_GT] = ACTIONS(711),
    [anon_sym_AMP_GT_GT] = ACTIONS(707),
    [anon_sym_LT_AMP] = ACTIONS(707),
    [anon_sym_GT_AMP] = ACTIONS(707),
    [anon_sym_LT_LT] = ACTIONS(711),
    [anon_sym_LT_LT_DASH] = ACTIONS(707),
    [anon_sym_LT_LT_LT] = ACTIONS(707),
    [sym__special_characters] = ACTIONS(707),
    [anon_sym_DQUOTE] = ACTIONS(707),
    [anon_sym_DOLLAR] = ACTIONS(711),
    [sym_raw_string] = ACTIONS(707),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(707),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(707),
    [anon_sym_BQUOTE] = ACTIONS(707),
    [anon_sym_LT_LPAREN] = ACTIONS(707),
    [anon_sym_GT_LPAREN] = ACTIONS(707),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [sym_word] = ACTIONS(711),
    [anon_sym_LF] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(711),
  },
  [264] = {
    [aux_sym_concatenation_repeat1] = STATE(665),
    [sym__simple_heredoc_body] = ACTIONS(725),
    [sym__heredoc_body_beginning] = ACTIONS(725),
    [sym_file_descriptor] = ACTIONS(725),
    [sym__concat] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(727),
    [anon_sym_SEMI_SEMI] = ACTIONS(725),
    [anon_sym_PIPE_AMP] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_LT] = ACTIONS(727),
    [anon_sym_GT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_AMP_GT] = ACTIONS(727),
    [anon_sym_AMP_GT_GT] = ACTIONS(725),
    [anon_sym_LT_AMP] = ACTIONS(725),
    [anon_sym_GT_AMP] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_LT_LT_DASH] = ACTIONS(725),
    [anon_sym_LT_LT_LT] = ACTIONS(725),
    [sym__special_characters] = ACTIONS(725),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(727),
    [sym_raw_string] = ACTIONS(725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LT_LPAREN] = ACTIONS(725),
    [anon_sym_GT_LPAREN] = ACTIONS(725),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(727),
    [sym_word] = ACTIONS(727),
    [anon_sym_LF] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(727),
  },
  [265] = {
    [sym_concatenation] = STATE(666),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [aux_sym_unset_command_repeat1] = STATE(666),
    [sym__simple_heredoc_body] = ACTIONS(739),
    [sym__heredoc_body_beginning] = ACTIONS(739),
    [sym_file_descriptor] = ACTIONS(739),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_GT] = ACTIONS(739),
    [anon_sym_AMP_GT] = ACTIONS(741),
    [anon_sym_AMP_GT_GT] = ACTIONS(739),
    [anon_sym_LT_AMP] = ACTIONS(739),
    [anon_sym_GT_AMP] = ACTIONS(739),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_LT_LT_DASH] = ACTIONS(739),
    [anon_sym_LT_LT_LT] = ACTIONS(739),
    [sym__special_characters] = ACTIONS(485),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(487),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1293),
    [sym_word] = ACTIONS(491),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(741),
  },
  [266] = {
    [aux_sym_concatenation_repeat1] = STATE(667),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_EQ_TILDE] = ACTIONS(781),
    [anon_sym_EQ_EQ] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(781),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [267] = {
    [sym__terminated_statement] = STATE(669),
    [sym_redirected_statement] = STATE(524),
    [sym_for_statement] = STATE(524),
    [sym_c_style_for_statement] = STATE(524),
    [sym_while_statement] = STATE(524),
    [sym_if_statement] = STATE(524),
    [sym_case_statement] = STATE(524),
    [sym_function_definition] = STATE(524),
    [sym_compound_statement] = STATE(524),
    [sym_subshell] = STATE(524),
    [sym_pipeline] = STATE(524),
    [sym_list] = STATE(524),
    [sym_negated_command] = STATE(524),
    [sym_test_command] = STATE(524),
    [sym_declaration_command] = STATE(524),
    [sym_unset_command] = STATE(524),
    [sym_command] = STATE(524),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(525),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(669),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_done] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [268] = {
    [sym__simple_heredoc_body] = ACTIONS(1297),
    [sym__heredoc_body_beginning] = ACTIONS(1297),
    [sym_file_descriptor] = ACTIONS(1297),
    [ts_builtin_sym_end] = ACTIONS(1297),
    [anon_sym_SEMI] = ACTIONS(1299),
    [anon_sym_esac] = ACTIONS(1297),
    [anon_sym_PIPE] = ACTIONS(1299),
    [anon_sym_RPAREN] = ACTIONS(1297),
    [anon_sym_SEMI_SEMI] = ACTIONS(1297),
    [anon_sym_PIPE_AMP] = ACTIONS(1297),
    [anon_sym_AMP_AMP] = ACTIONS(1297),
    [anon_sym_PIPE_PIPE] = ACTIONS(1297),
    [anon_sym_LT] = ACTIONS(1299),
    [anon_sym_GT] = ACTIONS(1299),
    [anon_sym_GT_GT] = ACTIONS(1297),
    [anon_sym_AMP_GT] = ACTIONS(1299),
    [anon_sym_AMP_GT_GT] = ACTIONS(1297),
    [anon_sym_LT_AMP] = ACTIONS(1297),
    [anon_sym_GT_AMP] = ACTIONS(1297),
    [anon_sym_LT_LT] = ACTIONS(1299),
    [anon_sym_LT_LT_DASH] = ACTIONS(1297),
    [anon_sym_LT_LT_LT] = ACTIONS(1297),
    [anon_sym_BQUOTE] = ACTIONS(1297),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1297),
    [anon_sym_AMP] = ACTIONS(1299),
  },
  [269] = {
    [anon_sym_LT] = ACTIONS(1301),
    [anon_sym_GT] = ACTIONS(1301),
    [anon_sym_GT_GT] = ACTIONS(1303),
    [anon_sym_AMP_GT] = ACTIONS(1301),
    [anon_sym_AMP_GT_GT] = ACTIONS(1303),
    [anon_sym_LT_AMP] = ACTIONS(1303),
    [anon_sym_GT_AMP] = ACTIONS(1303),
    [sym_comment] = ACTIONS(57),
  },
  [270] = {
    [anon_sym_do] = ACTIONS(927),
    [anon_sym_then] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
  },
  [271] = {
    [sym_redirected_statement] = STATE(671),
    [sym_for_statement] = STATE(671),
    [sym_c_style_for_statement] = STATE(671),
    [sym_while_statement] = STATE(671),
    [sym_if_statement] = STATE(671),
    [sym_case_statement] = STATE(671),
    [sym_function_definition] = STATE(671),
    [sym_compound_statement] = STATE(671),
    [sym_subshell] = STATE(671),
    [sym_pipeline] = STATE(671),
    [sym_list] = STATE(671),
    [sym_negated_command] = STATE(671),
    [sym_test_command] = STATE(671),
    [sym_declaration_command] = STATE(671),
    [sym_unset_command] = STATE(671),
    [sym_command] = STATE(671),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(672),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [272] = {
    [sym_redirected_statement] = STATE(673),
    [sym_for_statement] = STATE(673),
    [sym_c_style_for_statement] = STATE(673),
    [sym_while_statement] = STATE(673),
    [sym_if_statement] = STATE(673),
    [sym_case_statement] = STATE(673),
    [sym_function_definition] = STATE(673),
    [sym_compound_statement] = STATE(673),
    [sym_subshell] = STATE(673),
    [sym_pipeline] = STATE(673),
    [sym_list] = STATE(673),
    [sym_negated_command] = STATE(673),
    [sym_test_command] = STATE(673),
    [sym_declaration_command] = STATE(673),
    [sym_unset_command] = STATE(673),
    [sym_command] = STATE(673),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(674),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [273] = {
    [sym_concatenation] = STATE(511),
    [sym_string] = STATE(676),
    [sym_simple_expansion] = STATE(676),
    [sym_string_expansion] = STATE(676),
    [sym_expansion] = STATE(676),
    [sym_command_substitution] = STATE(676),
    [sym_process_substitution] = STATE(676),
    [sym__special_characters] = ACTIONS(1305),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1307),
  },
  [274] = {
    [sym_concatenation] = STATE(515),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [sym__special_characters] = ACTIONS(1309),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1311),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1311),
  },
  [275] = {
    [anon_sym_SEMI] = ACTIONS(1313),
    [anon_sym_SEMI_SEMI] = ACTIONS(1315),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1315),
    [anon_sym_AMP] = ACTIONS(1315),
  },
  [276] = {
    [sym_file_redirect] = STATE(680),
    [sym_heredoc_redirect] = STATE(680),
    [sym_herestring_redirect] = STATE(680),
    [aux_sym_redirected_statement_repeat1] = STATE(680),
    [sym__simple_heredoc_body] = ACTIONS(947),
    [sym__heredoc_body_beginning] = ACTIONS(947),
    [sym_file_descriptor] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI_SEMI] = ACTIONS(947),
    [anon_sym_PIPE_AMP] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_LT] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(507),
    [anon_sym_GT_GT] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(507),
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
  },
  [277] = {
    [sym_concatenation] = STATE(518),
    [sym_string] = STATE(682),
    [sym_simple_expansion] = STATE(682),
    [sym_string_expansion] = STATE(682),
    [sym_expansion] = STATE(682),
    [sym_command_substitution] = STATE(682),
    [sym_process_substitution] = STATE(682),
    [sym_regex] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1319),
  },
  [278] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_EQ_TILDE] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(959),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_characters] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [279] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(961),
    [sym__heredoc_body_beginning] = ACTIONS(961),
    [sym_file_descriptor] = ACTIONS(961),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(963),
    [anon_sym_PIPE] = ACTIONS(963),
    [anon_sym_SEMI_SEMI] = ACTIONS(961),
    [anon_sym_PIPE_AMP] = ACTIONS(961),
    [anon_sym_AMP_AMP] = ACTIONS(961),
    [anon_sym_PIPE_PIPE] = ACTIONS(961),
    [anon_sym_EQ_TILDE] = ACTIONS(963),
    [anon_sym_EQ_EQ] = ACTIONS(963),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_GT_GT] = ACTIONS(961),
    [anon_sym_AMP_GT] = ACTIONS(963),
    [anon_sym_AMP_GT_GT] = ACTIONS(961),
    [anon_sym_LT_AMP] = ACTIONS(961),
    [anon_sym_GT_AMP] = ACTIONS(961),
    [anon_sym_LT_LT] = ACTIONS(963),
    [anon_sym_LT_LT_DASH] = ACTIONS(961),
    [anon_sym_LT_LT_LT] = ACTIONS(961),
    [sym__special_characters] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(961),
    [anon_sym_DOLLAR] = ACTIONS(963),
    [sym_raw_string] = ACTIONS(961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(961),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(961),
    [anon_sym_BQUOTE] = ACTIONS(961),
    [anon_sym_LT_LPAREN] = ACTIONS(961),
    [anon_sym_GT_LPAREN] = ACTIONS(961),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(963),
    [anon_sym_LF] = ACTIONS(961),
    [anon_sym_AMP] = ACTIONS(963),
  },
  [280] = {
    [sym_concatenation] = STATE(683),
    [sym_string] = STATE(279),
    [sym_simple_expansion] = STATE(279),
    [sym_string_expansion] = STATE(279),
    [sym_expansion] = STATE(279),
    [sym_command_substitution] = STATE(279),
    [sym_process_substitution] = STATE(279),
    [aux_sym_command_repeat2] = STATE(683),
    [sym__simple_heredoc_body] = ACTIONS(965),
    [sym__heredoc_body_beginning] = ACTIONS(965),
    [sym_file_descriptor] = ACTIONS(965),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(967),
    [anon_sym_SEMI_SEMI] = ACTIONS(965),
    [anon_sym_PIPE_AMP] = ACTIONS(965),
    [anon_sym_AMP_AMP] = ACTIONS(965),
    [anon_sym_PIPE_PIPE] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(513),
    [anon_sym_EQ_EQ] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(965),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(965),
    [anon_sym_LT_AMP] = ACTIONS(965),
    [anon_sym_GT_AMP] = ACTIONS(965),
    [anon_sym_LT_LT] = ACTIONS(967),
    [anon_sym_LT_LT_DASH] = ACTIONS(965),
    [anon_sym_LT_LT_LT] = ACTIONS(965),
    [sym__special_characters] = ACTIONS(515),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(517),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(965),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [281] = {
    [sym_concatenation] = STATE(684),
    [sym_string] = STATE(279),
    [sym_simple_expansion] = STATE(279),
    [sym_string_expansion] = STATE(279),
    [sym_expansion] = STATE(279),
    [sym_command_substitution] = STATE(279),
    [sym_process_substitution] = STATE(279),
    [aux_sym_command_repeat2] = STATE(684),
    [sym__simple_heredoc_body] = ACTIONS(965),
    [sym__heredoc_body_beginning] = ACTIONS(965),
    [sym_file_descriptor] = ACTIONS(965),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(967),
    [anon_sym_SEMI_SEMI] = ACTIONS(965),
    [anon_sym_PIPE_AMP] = ACTIONS(965),
    [anon_sym_AMP_AMP] = ACTIONS(965),
    [anon_sym_PIPE_PIPE] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(513),
    [anon_sym_EQ_EQ] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(965),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(965),
    [anon_sym_LT_AMP] = ACTIONS(965),
    [anon_sym_GT_AMP] = ACTIONS(965),
    [anon_sym_LT_LT] = ACTIONS(967),
    [anon_sym_LT_LT_DASH] = ACTIONS(965),
    [anon_sym_LT_LT_LT] = ACTIONS(965),
    [sym__special_characters] = ACTIONS(515),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(517),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(965),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [282] = {
    [sym__terminated_statement] = STATE(689),
    [sym_redirected_statement] = STATE(524),
    [sym_for_statement] = STATE(524),
    [sym_c_style_for_statement] = STATE(524),
    [sym_while_statement] = STATE(524),
    [sym_if_statement] = STATE(524),
    [sym_elif_clause] = STATE(690),
    [sym_else_clause] = STATE(688),
    [sym_case_statement] = STATE(524),
    [sym_function_definition] = STATE(524),
    [sym_compound_statement] = STATE(524),
    [sym_subshell] = STATE(524),
    [sym_pipeline] = STATE(524),
    [sym_list] = STATE(524),
    [sym_negated_command] = STATE(524),
    [sym_test_command] = STATE(524),
    [sym_declaration_command] = STATE(524),
    [sym_unset_command] = STATE(524),
    [sym_command] = STATE(524),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(525),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(689),
    [aux_sym_if_statement_repeat1] = STATE(690),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(1321),
    [anon_sym_elif] = ACTIONS(1323),
    [anon_sym_else] = ACTIONS(1325),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [283] = {
    [sym_string] = STATE(691),
    [sym_simple_expansion] = STATE(691),
    [sym_string_expansion] = STATE(691),
    [sym_expansion] = STATE(691),
    [sym_command_substitution] = STATE(691),
    [sym_process_substitution] = STATE(691),
    [sym__special_characters] = ACTIONS(1327),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [sym_raw_string] = ACTIONS(1327),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(121),
    [anon_sym_BQUOTE] = ACTIONS(123),
    [anon_sym_LT_LPAREN] = ACTIONS(125),
    [anon_sym_GT_LPAREN] = ACTIONS(125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1327),
  },
  [284] = {
    [anon_sym_SEMI] = ACTIONS(1329),
    [anon_sym_SEMI_SEMI] = ACTIONS(1331),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
  },
  [285] = {
    [anon_sym_in] = ACTIONS(1333),
    [sym_comment] = ACTIONS(57),
  },
  [286] = {
    [aux_sym_concatenation_repeat1] = STATE(694),
    [sym__concat] = ACTIONS(525),
    [anon_sym_in] = ACTIONS(779),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(779),
  },
  [287] = {
    [sym__concat] = ACTIONS(783),
    [anon_sym_in] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(783),
  },
  [288] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [289] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [anon_sym_DOLLAR] = ACTIONS(1337),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [290] = {
    [sym__concat] = ACTIONS(817),
    [anon_sym_in] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(819),
    [anon_sym_SEMI_SEMI] = ACTIONS(817),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(817),
  },
  [291] = {
    [sym__concat] = ACTIONS(821),
    [anon_sym_in] = ACTIONS(821),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_SEMI_SEMI] = ACTIONS(821),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(821),
  },
  [292] = {
    [sym__concat] = ACTIONS(825),
    [anon_sym_in] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(827),
    [anon_sym_SEMI_SEMI] = ACTIONS(825),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(825),
  },
  [293] = {
    [anon_sym_SEMI] = ACTIONS(1339),
    [anon_sym_SEMI_SEMI] = ACTIONS(1341),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1341),
    [anon_sym_AMP] = ACTIONS(1341),
  },
  [294] = {
    [anon_sym_in] = ACTIONS(1343),
    [sym_comment] = ACTIONS(57),
  },
  [295] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(1345),
    [sym_comment] = ACTIONS(57),
  },
  [296] = {
    [sym_subscript] = STATE(702),
    [sym_variable_name] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1353),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_0] = ACTIONS(1351),
    [anon_sym__] = ACTIONS(1351),
  },
  [297] = {
    [sym_concatenation] = STATE(705),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(705),
    [anon_sym_RBRACE] = ACTIONS(1355),
    [anon_sym_EQ] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1357),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1359),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(1361),
    [anon_sym_COLON] = ACTIONS(1357),
    [anon_sym_COLON_QMARK] = ACTIONS(1357),
    [anon_sym_COLON_DASH] = ACTIONS(1357),
    [anon_sym_PERCENT] = ACTIONS(1357),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [298] = {
    [sym_concatenation] = STATE(708),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(708),
    [anon_sym_RBRACE] = ACTIONS(1363),
    [anon_sym_EQ] = ACTIONS(1365),
    [anon_sym_DASH] = ACTIONS(1365),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1367),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(1369),
    [anon_sym_COLON] = ACTIONS(1365),
    [anon_sym_COLON_QMARK] = ACTIONS(1365),
    [anon_sym_COLON_DASH] = ACTIONS(1365),
    [anon_sym_PERCENT] = ACTIONS(1365),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [299] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(711),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1375),
    [anon_sym_AMP] = ACTIONS(1371),
  },
  [300] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(711),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1375),
    [anon_sym_AMP] = ACTIONS(1371),
  },
  [301] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(712),
    [sym_for_statement] = STATE(712),
    [sym_c_style_for_statement] = STATE(712),
    [sym_while_statement] = STATE(712),
    [sym_if_statement] = STATE(712),
    [sym_case_statement] = STATE(712),
    [sym_function_definition] = STATE(712),
    [sym_compound_statement] = STATE(712),
    [sym_subshell] = STATE(712),
    [sym_pipeline] = STATE(712),
    [sym_list] = STATE(712),
    [sym_negated_command] = STATE(712),
    [sym_test_command] = STATE(712),
    [sym_declaration_command] = STATE(712),
    [sym_unset_command] = STATE(712),
    [sym_command] = STATE(712),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(713),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [302] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(715),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1379),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1377),
  },
  [303] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(715),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1379),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1377),
  },
  [304] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(716),
    [sym_for_statement] = STATE(716),
    [sym_c_style_for_statement] = STATE(716),
    [sym_while_statement] = STATE(716),
    [sym_if_statement] = STATE(716),
    [sym_case_statement] = STATE(716),
    [sym_function_definition] = STATE(716),
    [sym_compound_statement] = STATE(716),
    [sym_subshell] = STATE(716),
    [sym_pipeline] = STATE(716),
    [sym_list] = STATE(716),
    [sym_negated_command] = STATE(716),
    [sym_test_command] = STATE(716),
    [sym_declaration_command] = STATE(716),
    [sym_unset_command] = STATE(716),
    [sym_command] = STATE(716),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(717),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [305] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(720),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(1381),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1383),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1381),
  },
  [306] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(720),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1381),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1383),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1381),
  },
  [307] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(721),
    [sym_for_statement] = STATE(721),
    [sym_c_style_for_statement] = STATE(721),
    [sym_while_statement] = STATE(721),
    [sym_if_statement] = STATE(721),
    [sym_case_statement] = STATE(721),
    [sym_function_definition] = STATE(721),
    [sym_compound_statement] = STATE(721),
    [sym_subshell] = STATE(721),
    [sym_pipeline] = STATE(721),
    [sym_list] = STATE(721),
    [sym_negated_command] = STATE(721),
    [sym_test_command] = STATE(721),
    [sym_declaration_command] = STATE(721),
    [sym_unset_command] = STATE(721),
    [sym_command] = STATE(721),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(722),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [308] = {
    [anon_sym_RPAREN] = ACTIONS(1387),
    [sym_comment] = ACTIONS(57),
  },
  [309] = {
    [sym__simple_heredoc_body] = ACTIONS(1389),
    [sym__heredoc_body_beginning] = ACTIONS(1389),
    [sym_file_descriptor] = ACTIONS(1389),
    [ts_builtin_sym_end] = ACTIONS(1389),
    [anon_sym_SEMI] = ACTIONS(1391),
    [anon_sym_esac] = ACTIONS(1389),
    [anon_sym_PIPE] = ACTIONS(1391),
    [anon_sym_RPAREN] = ACTIONS(1389),
    [anon_sym_SEMI_SEMI] = ACTIONS(1389),
    [anon_sym_PIPE_AMP] = ACTIONS(1389),
    [anon_sym_AMP_AMP] = ACTIONS(1389),
    [anon_sym_PIPE_PIPE] = ACTIONS(1389),
    [anon_sym_LT] = ACTIONS(1391),
    [anon_sym_GT] = ACTIONS(1391),
    [anon_sym_GT_GT] = ACTIONS(1389),
    [anon_sym_AMP_GT] = ACTIONS(1391),
    [anon_sym_AMP_GT_GT] = ACTIONS(1389),
    [anon_sym_LT_AMP] = ACTIONS(1389),
    [anon_sym_GT_AMP] = ACTIONS(1389),
    [anon_sym_LT_LT] = ACTIONS(1391),
    [anon_sym_LT_LT_DASH] = ACTIONS(1389),
    [anon_sym_LT_LT_LT] = ACTIONS(1389),
    [anon_sym_BQUOTE] = ACTIONS(1389),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1391),
  },
  [310] = {
    [sym_concatenation] = STATE(196),
    [sym_string] = STATE(725),
    [sym_array] = STATE(196),
    [sym_simple_expansion] = STATE(725),
    [sym_string_expansion] = STATE(725),
    [sym_expansion] = STATE(725),
    [sym_command_substitution] = STATE(725),
    [sym_process_substitution] = STATE(725),
    [sym__empty_value] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(355),
    [sym__special_characters] = ACTIONS(1393),
    [anon_sym_DQUOTE] = ACTIONS(359),
    [anon_sym_DOLLAR] = ACTIONS(361),
    [sym_raw_string] = ACTIONS(1395),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(365),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1395),
  },
  [311] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1397),
    [anon_sym_PLUS_EQ] = ACTIONS(1397),
    [sym_comment] = ACTIONS(57),
  },
  [312] = {
    [aux_sym_concatenation_repeat1] = STATE(727),
    [sym__simple_heredoc_body] = ACTIONS(669),
    [sym__heredoc_body_beginning] = ACTIONS(669),
    [sym_file_descriptor] = ACTIONS(669),
    [sym__concat] = ACTIONS(671),
    [sym_variable_name] = ACTIONS(669),
    [anon_sym_SEMI] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(669),
    [anon_sym_SEMI_SEMI] = ACTIONS(669),
    [anon_sym_PIPE_AMP] = ACTIONS(669),
    [anon_sym_AMP_AMP] = ACTIONS(669),
    [anon_sym_PIPE_PIPE] = ACTIONS(669),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(669),
    [anon_sym_AMP_GT] = ACTIONS(673),
    [anon_sym_AMP_GT_GT] = ACTIONS(669),
    [anon_sym_LT_AMP] = ACTIONS(669),
    [anon_sym_GT_AMP] = ACTIONS(669),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_LT_LT_DASH] = ACTIONS(669),
    [anon_sym_LT_LT_LT] = ACTIONS(669),
    [sym__special_characters] = ACTIONS(669),
    [anon_sym_DQUOTE] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(673),
    [sym_raw_string] = ACTIONS(669),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(669),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(669),
    [anon_sym_BQUOTE] = ACTIONS(669),
    [anon_sym_LT_LPAREN] = ACTIONS(669),
    [anon_sym_GT_LPAREN] = ACTIONS(669),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(673),
    [sym_word] = ACTIONS(673),
    [anon_sym_LF] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(673),
  },
  [313] = {
    [aux_sym_concatenation_repeat1] = STATE(727),
    [sym__simple_heredoc_body] = ACTIONS(687),
    [sym__heredoc_body_beginning] = ACTIONS(687),
    [sym_file_descriptor] = ACTIONS(687),
    [sym__concat] = ACTIONS(671),
    [sym_variable_name] = ACTIONS(687),
    [anon_sym_SEMI] = ACTIONS(689),
    [anon_sym_PIPE] = ACTIONS(689),
    [anon_sym_RPAREN] = ACTIONS(687),
    [anon_sym_SEMI_SEMI] = ACTIONS(687),
    [anon_sym_PIPE_AMP] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(687),
    [anon_sym_PIPE_PIPE] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(689),
    [anon_sym_GT] = ACTIONS(689),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_AMP_GT] = ACTIONS(689),
    [anon_sym_AMP_GT_GT] = ACTIONS(687),
    [anon_sym_LT_AMP] = ACTIONS(687),
    [anon_sym_GT_AMP] = ACTIONS(687),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_LT_LT_LT] = ACTIONS(687),
    [sym__special_characters] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(687),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(687),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_LT_LPAREN] = ACTIONS(687),
    [anon_sym_GT_LPAREN] = ACTIONS(687),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(689),
    [sym_word] = ACTIONS(689),
    [anon_sym_LF] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(689),
  },
  [314] = {
    [anon_sym_EQ] = ACTIONS(1397),
    [anon_sym_PLUS_EQ] = ACTIONS(1397),
    [sym_comment] = ACTIONS(57),
  },
  [315] = {
    [sym_variable_assignment] = STATE(728),
    [sym_subscript] = STATE(314),
    [sym_concatenation] = STATE(728),
    [sym_string] = STATE(313),
    [sym_simple_expansion] = STATE(313),
    [sym_string_expansion] = STATE(313),
    [sym_expansion] = STATE(313),
    [sym_command_substitution] = STATE(313),
    [sym_process_substitution] = STATE(313),
    [aux_sym_declaration_command_repeat1] = STATE(728),
    [sym__simple_heredoc_body] = ACTIONS(701),
    [sym__heredoc_body_beginning] = ACTIONS(701),
    [sym_file_descriptor] = ACTIONS(701),
    [sym_variable_name] = ACTIONS(565),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_RPAREN] = ACTIONS(701),
    [anon_sym_SEMI_SEMI] = ACTIONS(701),
    [anon_sym_PIPE_AMP] = ACTIONS(701),
    [anon_sym_AMP_AMP] = ACTIONS(701),
    [anon_sym_PIPE_PIPE] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(703),
    [anon_sym_GT] = ACTIONS(703),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_AMP_GT] = ACTIONS(703),
    [anon_sym_AMP_GT_GT] = ACTIONS(701),
    [anon_sym_LT_AMP] = ACTIONS(701),
    [anon_sym_GT_AMP] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(703),
    [anon_sym_LT_LT_DASH] = ACTIONS(701),
    [anon_sym_LT_LT_LT] = ACTIONS(701),
    [sym__special_characters] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(569),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1399),
    [sym_word] = ACTIONS(573),
    [anon_sym_LF] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(703),
  },
  [316] = {
    [aux_sym_concatenation_repeat1] = STATE(729),
    [sym__simple_heredoc_body] = ACTIONS(707),
    [sym__heredoc_body_beginning] = ACTIONS(707),
    [sym_file_descriptor] = ACTIONS(707),
    [sym__concat] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(711),
    [anon_sym_PIPE] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(707),
    [anon_sym_SEMI_SEMI] = ACTIONS(707),
    [anon_sym_PIPE_AMP] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(707),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_GT] = ACTIONS(707),
    [anon_sym_AMP_GT] = ACTIONS(711),
    [anon_sym_AMP_GT_GT] = ACTIONS(707),
    [anon_sym_LT_AMP] = ACTIONS(707),
    [anon_sym_GT_AMP] = ACTIONS(707),
    [anon_sym_LT_LT] = ACTIONS(711),
    [anon_sym_LT_LT_DASH] = ACTIONS(707),
    [anon_sym_LT_LT_LT] = ACTIONS(707),
    [sym__special_characters] = ACTIONS(707),
    [anon_sym_DQUOTE] = ACTIONS(707),
    [anon_sym_DOLLAR] = ACTIONS(711),
    [sym_raw_string] = ACTIONS(707),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(707),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(707),
    [anon_sym_BQUOTE] = ACTIONS(707),
    [anon_sym_LT_LPAREN] = ACTIONS(707),
    [anon_sym_GT_LPAREN] = ACTIONS(707),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [sym_word] = ACTIONS(711),
    [anon_sym_LF] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(711),
  },
  [317] = {
    [aux_sym_concatenation_repeat1] = STATE(729),
    [sym__simple_heredoc_body] = ACTIONS(725),
    [sym__heredoc_body_beginning] = ACTIONS(725),
    [sym_file_descriptor] = ACTIONS(725),
    [sym__concat] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(727),
    [anon_sym_RPAREN] = ACTIONS(725),
    [anon_sym_SEMI_SEMI] = ACTIONS(725),
    [anon_sym_PIPE_AMP] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_LT] = ACTIONS(727),
    [anon_sym_GT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_AMP_GT] = ACTIONS(727),
    [anon_sym_AMP_GT_GT] = ACTIONS(725),
    [anon_sym_LT_AMP] = ACTIONS(725),
    [anon_sym_GT_AMP] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_LT_LT_DASH] = ACTIONS(725),
    [anon_sym_LT_LT_LT] = ACTIONS(725),
    [sym__special_characters] = ACTIONS(725),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(727),
    [sym_raw_string] = ACTIONS(725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LT_LPAREN] = ACTIONS(725),
    [anon_sym_GT_LPAREN] = ACTIONS(725),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(727),
    [sym_word] = ACTIONS(727),
    [anon_sym_LF] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(727),
  },
  [318] = {
    [sym_concatenation] = STATE(730),
    [sym_string] = STATE(317),
    [sym_simple_expansion] = STATE(317),
    [sym_string_expansion] = STATE(317),
    [sym_expansion] = STATE(317),
    [sym_command_substitution] = STATE(317),
    [sym_process_substitution] = STATE(317),
    [aux_sym_unset_command_repeat1] = STATE(730),
    [sym__simple_heredoc_body] = ACTIONS(739),
    [sym__heredoc_body_beginning] = ACTIONS(739),
    [sym_file_descriptor] = ACTIONS(739),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_RPAREN] = ACTIONS(739),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_GT] = ACTIONS(739),
    [anon_sym_AMP_GT] = ACTIONS(741),
    [anon_sym_AMP_GT_GT] = ACTIONS(739),
    [anon_sym_LT_AMP] = ACTIONS(739),
    [anon_sym_GT_AMP] = ACTIONS(739),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_LT_LT_DASH] = ACTIONS(739),
    [anon_sym_LT_LT_LT] = ACTIONS(739),
    [sym__special_characters] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1401),
    [sym_word] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(741),
  },
  [319] = {
    [aux_sym_concatenation_repeat1] = STATE(731),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_RPAREN] = ACTIONS(779),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_EQ_TILDE] = ACTIONS(781),
    [anon_sym_EQ_EQ] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(781),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [320] = {
    [anon_sym_LT] = ACTIONS(1403),
    [anon_sym_GT] = ACTIONS(1403),
    [anon_sym_GT_GT] = ACTIONS(1405),
    [anon_sym_AMP_GT] = ACTIONS(1403),
    [anon_sym_AMP_GT_GT] = ACTIONS(1405),
    [anon_sym_LT_AMP] = ACTIONS(1405),
    [anon_sym_GT_AMP] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
  },
  [321] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [322] = {
    [sym_redirected_statement] = STATE(734),
    [sym_for_statement] = STATE(734),
    [sym_c_style_for_statement] = STATE(734),
    [sym_while_statement] = STATE(734),
    [sym_if_statement] = STATE(734),
    [sym_case_statement] = STATE(734),
    [sym_function_definition] = STATE(734),
    [sym_compound_statement] = STATE(734),
    [sym_subshell] = STATE(734),
    [sym_pipeline] = STATE(734),
    [sym_list] = STATE(734),
    [sym_negated_command] = STATE(734),
    [sym_test_command] = STATE(734),
    [sym_declaration_command] = STATE(734),
    [sym_unset_command] = STATE(734),
    [sym_command] = STATE(734),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(735),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [323] = {
    [sym__simple_heredoc_body] = ACTIONS(1409),
    [sym__heredoc_body_beginning] = ACTIONS(1409),
    [sym_file_descriptor] = ACTIONS(1409),
    [ts_builtin_sym_end] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_esac] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_RPAREN] = ACTIONS(1409),
    [anon_sym_SEMI_SEMI] = ACTIONS(1409),
    [anon_sym_PIPE_AMP] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1409),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1409),
    [anon_sym_LT_AMP] = ACTIONS(1409),
    [anon_sym_GT_AMP] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_LT_LT_LT] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1411),
  },
  [324] = {
    [sym_redirected_statement] = STATE(736),
    [sym_for_statement] = STATE(736),
    [sym_c_style_for_statement] = STATE(736),
    [sym_while_statement] = STATE(736),
    [sym_if_statement] = STATE(736),
    [sym_case_statement] = STATE(736),
    [sym_function_definition] = STATE(736),
    [sym_compound_statement] = STATE(736),
    [sym_subshell] = STATE(736),
    [sym_pipeline] = STATE(736),
    [sym_list] = STATE(736),
    [sym_negated_command] = STATE(736),
    [sym_test_command] = STATE(736),
    [sym_declaration_command] = STATE(736),
    [sym_unset_command] = STATE(736),
    [sym_command] = STATE(736),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(737),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [325] = {
    [sym_concatenation] = STATE(511),
    [sym_string] = STATE(739),
    [sym_simple_expansion] = STATE(739),
    [sym_string_expansion] = STATE(739),
    [sym_expansion] = STATE(739),
    [sym_command_substitution] = STATE(739),
    [sym_process_substitution] = STATE(739),
    [sym__special_characters] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1415),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1415),
  },
  [326] = {
    [sym_concatenation] = STATE(515),
    [sym_string] = STATE(741),
    [sym_simple_expansion] = STATE(741),
    [sym_string_expansion] = STATE(741),
    [sym_expansion] = STATE(741),
    [sym_command_substitution] = STATE(741),
    [sym_process_substitution] = STATE(741),
    [sym__special_characters] = ACTIONS(1417),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1419),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1419),
  },
  [327] = {
    [anon_sym_SEMI] = ACTIONS(1421),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_SEMI_SEMI] = ACTIONS(1423),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1423),
    [anon_sym_AMP] = ACTIONS(1423),
  },
  [328] = {
    [sym_file_redirect] = STATE(743),
    [sym_heredoc_redirect] = STATE(743),
    [sym_herestring_redirect] = STATE(743),
    [aux_sym_redirected_statement_repeat1] = STATE(743),
    [sym__simple_heredoc_body] = ACTIONS(947),
    [sym__heredoc_body_beginning] = ACTIONS(947),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_SEMI_SEMI] = ACTIONS(947),
    [anon_sym_PIPE_AMP] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
  },
  [329] = {
    [sym_concatenation] = STATE(518),
    [sym_string] = STATE(745),
    [sym_simple_expansion] = STATE(745),
    [sym_string_expansion] = STATE(745),
    [sym_expansion] = STATE(745),
    [sym_command_substitution] = STATE(745),
    [sym_process_substitution] = STATE(745),
    [sym_regex] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(1425),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1427),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1427),
  },
  [330] = {
    [aux_sym_concatenation_repeat1] = STATE(319),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_RPAREN] = ACTIONS(957),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_EQ_TILDE] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(959),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_characters] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [331] = {
    [aux_sym_concatenation_repeat1] = STATE(319),
    [sym__simple_heredoc_body] = ACTIONS(961),
    [sym__heredoc_body_beginning] = ACTIONS(961),
    [sym_file_descriptor] = ACTIONS(961),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(963),
    [anon_sym_PIPE] = ACTIONS(963),
    [anon_sym_RPAREN] = ACTIONS(961),
    [anon_sym_SEMI_SEMI] = ACTIONS(961),
    [anon_sym_PIPE_AMP] = ACTIONS(961),
    [anon_sym_AMP_AMP] = ACTIONS(961),
    [anon_sym_PIPE_PIPE] = ACTIONS(961),
    [anon_sym_EQ_TILDE] = ACTIONS(963),
    [anon_sym_EQ_EQ] = ACTIONS(963),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_GT_GT] = ACTIONS(961),
    [anon_sym_AMP_GT] = ACTIONS(963),
    [anon_sym_AMP_GT_GT] = ACTIONS(961),
    [anon_sym_LT_AMP] = ACTIONS(961),
    [anon_sym_GT_AMP] = ACTIONS(961),
    [anon_sym_LT_LT] = ACTIONS(963),
    [anon_sym_LT_LT_DASH] = ACTIONS(961),
    [anon_sym_LT_LT_LT] = ACTIONS(961),
    [sym__special_characters] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(961),
    [anon_sym_DOLLAR] = ACTIONS(963),
    [sym_raw_string] = ACTIONS(961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(961),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(961),
    [anon_sym_BQUOTE] = ACTIONS(961),
    [anon_sym_LT_LPAREN] = ACTIONS(961),
    [anon_sym_GT_LPAREN] = ACTIONS(961),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(963),
    [anon_sym_LF] = ACTIONS(961),
    [anon_sym_AMP] = ACTIONS(963),
  },
  [332] = {
    [sym_concatenation] = STATE(746),
    [sym_string] = STATE(331),
    [sym_simple_expansion] = STATE(331),
    [sym_string_expansion] = STATE(331),
    [sym_expansion] = STATE(331),
    [sym_command_substitution] = STATE(331),
    [sym_process_substitution] = STATE(331),
    [aux_sym_command_repeat2] = STATE(746),
    [sym__simple_heredoc_body] = ACTIONS(965),
    [sym__heredoc_body_beginning] = ACTIONS(965),
    [sym_file_descriptor] = ACTIONS(965),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(967),
    [anon_sym_RPAREN] = ACTIONS(965),
    [anon_sym_SEMI_SEMI] = ACTIONS(965),
    [anon_sym_PIPE_AMP] = ACTIONS(965),
    [anon_sym_AMP_AMP] = ACTIONS(965),
    [anon_sym_PIPE_PIPE] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(603),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(965),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(965),
    [anon_sym_LT_AMP] = ACTIONS(965),
    [anon_sym_GT_AMP] = ACTIONS(965),
    [anon_sym_LT_LT] = ACTIONS(967),
    [anon_sym_LT_LT_DASH] = ACTIONS(965),
    [anon_sym_LT_LT_LT] = ACTIONS(965),
    [sym__special_characters] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(607),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(609),
    [anon_sym_LF] = ACTIONS(965),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [333] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(748),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(1429),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_SEMI_SEMI] = ACTIONS(1431),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1431),
    [anon_sym_AMP] = ACTIONS(1429),
  },
  [334] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(748),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1429),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_SEMI_SEMI] = ACTIONS(1431),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1431),
    [anon_sym_AMP] = ACTIONS(1429),
  },
  [335] = {
    [sym_concatenation] = STATE(749),
    [sym_string] = STATE(331),
    [sym_simple_expansion] = STATE(331),
    [sym_string_expansion] = STATE(331),
    [sym_expansion] = STATE(331),
    [sym_command_substitution] = STATE(331),
    [sym_process_substitution] = STATE(331),
    [aux_sym_command_repeat2] = STATE(749),
    [sym__simple_heredoc_body] = ACTIONS(965),
    [sym__heredoc_body_beginning] = ACTIONS(965),
    [sym_file_descriptor] = ACTIONS(965),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(967),
    [anon_sym_RPAREN] = ACTIONS(965),
    [anon_sym_SEMI_SEMI] = ACTIONS(965),
    [anon_sym_PIPE_AMP] = ACTIONS(965),
    [anon_sym_AMP_AMP] = ACTIONS(965),
    [anon_sym_PIPE_PIPE] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(603),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(965),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(965),
    [anon_sym_LT_AMP] = ACTIONS(965),
    [anon_sym_GT_AMP] = ACTIONS(965),
    [anon_sym_LT_LT] = ACTIONS(967),
    [anon_sym_LT_LT_DASH] = ACTIONS(965),
    [anon_sym_LT_LT_LT] = ACTIONS(965),
    [sym__special_characters] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(607),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(609),
    [anon_sym_LF] = ACTIONS(965),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [336] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [337] = {
    [anon_sym_SEMI] = ACTIONS(1433),
    [anon_sym_SEMI_SEMI] = ACTIONS(1435),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
  },
  [338] = {
    [sym__simple_heredoc_body] = ACTIONS(1437),
    [sym__heredoc_body_beginning] = ACTIONS(1437),
    [sym_file_descriptor] = ACTIONS(1437),
    [ts_builtin_sym_end] = ACTIONS(1437),
    [anon_sym_SEMI] = ACTIONS(1439),
    [anon_sym_esac] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1439),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [anon_sym_SEMI_SEMI] = ACTIONS(1437),
    [anon_sym_PIPE_AMP] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1439),
    [anon_sym_GT_GT] = ACTIONS(1437),
    [anon_sym_AMP_GT] = ACTIONS(1439),
    [anon_sym_AMP_GT_GT] = ACTIONS(1437),
    [anon_sym_LT_AMP] = ACTIONS(1437),
    [anon_sym_GT_AMP] = ACTIONS(1437),
    [anon_sym_LT_LT] = ACTIONS(1439),
    [anon_sym_LT_LT_DASH] = ACTIONS(1437),
    [anon_sym_LT_LT_LT] = ACTIONS(1437),
    [anon_sym_BQUOTE] = ACTIONS(1437),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1439),
  },
  [339] = {
    [sym__terminated_statement] = STATE(339),
    [sym_redirected_statement] = STATE(89),
    [sym_for_statement] = STATE(89),
    [sym_c_style_for_statement] = STATE(89),
    [sym_while_statement] = STATE(89),
    [sym_if_statement] = STATE(89),
    [sym_case_statement] = STATE(89),
    [sym_function_definition] = STATE(89),
    [sym_compound_statement] = STATE(89),
    [sym_subshell] = STATE(89),
    [sym_pipeline] = STATE(89),
    [sym_list] = STATE(89),
    [sym_negated_command] = STATE(89),
    [sym_test_command] = STATE(89),
    [sym_declaration_command] = STATE(89),
    [sym_unset_command] = STATE(89),
    [sym_command] = STATE(89),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(90),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(339),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(973),
    [sym_variable_name] = ACTIONS(976),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(982),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(988),
    [anon_sym_case] = ACTIONS(991),
    [anon_sym_function] = ACTIONS(994),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(1000),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1006),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1009),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_typeset] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_readonly] = ACTIONS(1012),
    [anon_sym_local] = ACTIONS(1012),
    [anon_sym_unset] = ACTIONS(1015),
    [anon_sym_unsetenv] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1018),
    [anon_sym_GT] = ACTIONS(1018),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1018),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [sym__special_characters] = ACTIONS(1024),
    [anon_sym_DQUOTE] = ACTIONS(1027),
    [anon_sym_DOLLAR] = ACTIONS(1030),
    [sym_raw_string] = ACTIONS(1033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1039),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LPAREN] = ACTIONS(1045),
    [anon_sym_GT_LPAREN] = ACTIONS(1045),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1048),
  },
  [340] = {
    [sym_concatenation] = STATE(751),
    [sym_string] = STATE(754),
    [sym_array] = STATE(751),
    [sym_simple_expansion] = STATE(754),
    [sym_string_expansion] = STATE(754),
    [sym_expansion] = STATE(754),
    [sym_command_substitution] = STATE(754),
    [sym_process_substitution] = STATE(754),
    [sym__empty_value] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(1445),
    [sym__special_characters] = ACTIONS(1447),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_raw_string] = ACTIONS(1449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(241),
    [anon_sym_BQUOTE] = ACTIONS(243),
    [anon_sym_LT_LPAREN] = ACTIONS(245),
    [anon_sym_GT_LPAREN] = ACTIONS(245),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1449),
  },
  [341] = {
    [anon_sym_RPAREN] = ACTIONS(1451),
    [anon_sym_AMP_AMP] = ACTIONS(1217),
    [anon_sym_PIPE_PIPE] = ACTIONS(1217),
    [anon_sym_EQ_TILDE] = ACTIONS(1219),
    [anon_sym_EQ_EQ] = ACTIONS(1219),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_PLUS_EQ] = ACTIONS(1217),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_BANG_EQ] = ACTIONS(1217),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_DASH_EQ] = ACTIONS(1217),
    [anon_sym_LT_EQ] = ACTIONS(1217),
    [anon_sym_GT_EQ] = ACTIONS(1217),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1217),
  },
  [342] = {
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [anon_sym_RBRACK] = ACTIONS(1225),
    [anon_sym_EQ_TILDE] = ACTIONS(655),
    [anon_sym_EQ_EQ] = ACTIONS(655),
    [anon_sym_EQ] = ACTIONS(657),
    [anon_sym_PLUS_EQ] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(657),
    [anon_sym_GT] = ACTIONS(657),
    [anon_sym_BANG_EQ] = ACTIONS(653),
    [anon_sym_PLUS] = ACTIONS(657),
    [anon_sym_DASH] = ACTIONS(657),
    [anon_sym_DASH_EQ] = ACTIONS(653),
    [anon_sym_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(653),
    [anon_sym_PLUS_PLUS] = ACTIONS(659),
    [anon_sym_DASH_DASH] = ACTIONS(659),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(653),
  },
  [343] = {
    [sym_string] = STATE(756),
    [sym_simple_expansion] = STATE(756),
    [sym_string_expansion] = STATE(756),
    [sym_expansion] = STATE(756),
    [sym_command_substitution] = STATE(756),
    [sym_process_substitution] = STATE(756),
    [sym__special_characters] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [sym_raw_string] = ACTIONS(1453),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1453),
  },
  [344] = {
    [aux_sym_concatenation_repeat1] = STATE(757),
    [sym__concat] = ACTIONS(629),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_RBRACK] = ACTIONS(779),
    [anon_sym_EQ_TILDE] = ACTIONS(779),
    [anon_sym_EQ_EQ] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(781),
    [anon_sym_PLUS_EQ] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_BANG_EQ] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_DASH_EQ] = ACTIONS(779),
    [anon_sym_LT_EQ] = ACTIONS(779),
    [anon_sym_GT_EQ] = ACTIONS(779),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(779),
  },
  [345] = {
    [sym__concat] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_RBRACK] = ACTIONS(783),
    [anon_sym_EQ_TILDE] = ACTIONS(783),
    [anon_sym_EQ_EQ] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_PLUS_EQ] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_BANG_EQ] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_DASH_EQ] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(783),
    [anon_sym_GT_EQ] = ACTIONS(783),
    [anon_sym_PLUS_PLUS] = ACTIONS(783),
    [anon_sym_DASH_DASH] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(783),
  },
  [346] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [347] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [anon_sym_DOLLAR] = ACTIONS(1457),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [348] = {
    [sym__concat] = ACTIONS(817),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_RBRACK] = ACTIONS(817),
    [anon_sym_EQ_TILDE] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(817),
    [anon_sym_EQ] = ACTIONS(819),
    [anon_sym_PLUS_EQ] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_BANG_EQ] = ACTIONS(817),
    [anon_sym_PLUS] = ACTIONS(819),
    [anon_sym_DASH] = ACTIONS(819),
    [anon_sym_DASH_EQ] = ACTIONS(817),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(817),
    [anon_sym_DASH_DASH] = ACTIONS(817),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(817),
  },
  [349] = {
    [sym__concat] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(821),
    [anon_sym_EQ_TILDE] = ACTIONS(821),
    [anon_sym_EQ_EQ] = ACTIONS(821),
    [anon_sym_EQ] = ACTIONS(823),
    [anon_sym_PLUS_EQ] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_BANG_EQ] = ACTIONS(821),
    [anon_sym_PLUS] = ACTIONS(823),
    [anon_sym_DASH] = ACTIONS(823),
    [anon_sym_DASH_EQ] = ACTIONS(821),
    [anon_sym_LT_EQ] = ACTIONS(821),
    [anon_sym_GT_EQ] = ACTIONS(821),
    [anon_sym_PLUS_PLUS] = ACTIONS(821),
    [anon_sym_DASH_DASH] = ACTIONS(821),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(821),
  },
  [350] = {
    [sym__concat] = ACTIONS(825),
    [anon_sym_AMP_AMP] = ACTIONS(825),
    [anon_sym_PIPE_PIPE] = ACTIONS(825),
    [anon_sym_RBRACK] = ACTIONS(825),
    [anon_sym_EQ_TILDE] = ACTIONS(825),
    [anon_sym_EQ_EQ] = ACTIONS(825),
    [anon_sym_EQ] = ACTIONS(827),
    [anon_sym_PLUS_EQ] = ACTIONS(825),
    [anon_sym_LT] = ACTIONS(827),
    [anon_sym_GT] = ACTIONS(827),
    [anon_sym_BANG_EQ] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_DASH_EQ] = ACTIONS(825),
    [anon_sym_LT_EQ] = ACTIONS(825),
    [anon_sym_GT_EQ] = ACTIONS(825),
    [anon_sym_PLUS_PLUS] = ACTIONS(825),
    [anon_sym_DASH_DASH] = ACTIONS(825),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(825),
  },
  [351] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(1459),
    [sym_comment] = ACTIONS(57),
  },
  [352] = {
    [sym_subscript] = STATE(763),
    [sym_variable_name] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1463),
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1465),
    [anon_sym_STAR] = ACTIONS(1467),
    [anon_sym_AT] = ACTIONS(1467),
    [anon_sym_QMARK] = ACTIONS(1467),
    [anon_sym_0] = ACTIONS(1465),
    [anon_sym__] = ACTIONS(1465),
  },
  [353] = {
    [sym_concatenation] = STATE(766),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(766),
    [anon_sym_RBRACE] = ACTIONS(1469),
    [anon_sym_EQ] = ACTIONS(1471),
    [anon_sym_DASH] = ACTIONS(1471),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1473),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(1475),
    [anon_sym_COLON] = ACTIONS(1471),
    [anon_sym_COLON_QMARK] = ACTIONS(1471),
    [anon_sym_COLON_DASH] = ACTIONS(1471),
    [anon_sym_PERCENT] = ACTIONS(1471),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [354] = {
    [sym_concatenation] = STATE(769),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(769),
    [anon_sym_RBRACE] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(1483),
    [anon_sym_COLON] = ACTIONS(1479),
    [anon_sym_COLON_QMARK] = ACTIONS(1479),
    [anon_sym_COLON_DASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [355] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(772),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(1485),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1487),
    [anon_sym_SEMI_SEMI] = ACTIONS(1489),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1489),
    [anon_sym_AMP] = ACTIONS(1485),
  },
  [356] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(772),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1485),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1487),
    [anon_sym_SEMI_SEMI] = ACTIONS(1489),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1489),
    [anon_sym_AMP] = ACTIONS(1485),
  },
  [357] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(773),
    [sym_for_statement] = STATE(773),
    [sym_c_style_for_statement] = STATE(773),
    [sym_while_statement] = STATE(773),
    [sym_if_statement] = STATE(773),
    [sym_case_statement] = STATE(773),
    [sym_function_definition] = STATE(773),
    [sym_compound_statement] = STATE(773),
    [sym_subshell] = STATE(773),
    [sym_pipeline] = STATE(773),
    [sym_list] = STATE(773),
    [sym_negated_command] = STATE(773),
    [sym_test_command] = STATE(773),
    [sym_declaration_command] = STATE(773),
    [sym_unset_command] = STATE(773),
    [sym_command] = STATE(773),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(774),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [358] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(776),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1493),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(1487),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1493),
    [anon_sym_AMP] = ACTIONS(1491),
  },
  [359] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(776),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1493),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(1487),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1493),
    [anon_sym_AMP] = ACTIONS(1491),
  },
  [360] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(777),
    [sym_for_statement] = STATE(777),
    [sym_c_style_for_statement] = STATE(777),
    [sym_while_statement] = STATE(777),
    [sym_if_statement] = STATE(777),
    [sym_case_statement] = STATE(777),
    [sym_function_definition] = STATE(777),
    [sym_compound_statement] = STATE(777),
    [sym_subshell] = STATE(777),
    [sym_pipeline] = STATE(777),
    [sym_list] = STATE(777),
    [sym_negated_command] = STATE(777),
    [sym_test_command] = STATE(777),
    [sym_declaration_command] = STATE(777),
    [sym_unset_command] = STATE(777),
    [sym_command] = STATE(777),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(778),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [361] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(781),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(1495),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1497),
    [anon_sym_SEMI_SEMI] = ACTIONS(1499),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1495),
  },
  [362] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(781),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1495),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1497),
    [anon_sym_SEMI_SEMI] = ACTIONS(1499),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1495),
  },
  [363] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(782),
    [sym_for_statement] = STATE(782),
    [sym_c_style_for_statement] = STATE(782),
    [sym_while_statement] = STATE(782),
    [sym_if_statement] = STATE(782),
    [sym_case_statement] = STATE(782),
    [sym_function_definition] = STATE(782),
    [sym_compound_statement] = STATE(782),
    [sym_subshell] = STATE(782),
    [sym_pipeline] = STATE(782),
    [sym_list] = STATE(782),
    [sym_negated_command] = STATE(782),
    [sym_test_command] = STATE(782),
    [sym_declaration_command] = STATE(782),
    [sym_unset_command] = STATE(782),
    [sym_command] = STATE(782),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(783),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [364] = {
    [sym__expression] = STATE(784),
    [sym_binary_expression] = STATE(784),
    [sym_unary_expression] = STATE(784),
    [sym_postfix_expression] = STATE(784),
    [sym_parenthesized_expression] = STATE(784),
    [sym_concatenation] = STATE(784),
    [sym_string] = STATE(100),
    [sym_simple_expansion] = STATE(100),
    [sym_string_expansion] = STATE(100),
    [sym_expansion] = STATE(100),
    [sym_command_substitution] = STATE(100),
    [sym_process_substitution] = STATE(100),
    [anon_sym_LPAREN] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [sym__special_characters] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [sym_raw_string] = ACTIONS(157),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(167),
    [sym_test_operator] = ACTIONS(169),
  },
  [365] = {
    [sym__expression] = STATE(784),
    [sym_binary_expression] = STATE(784),
    [sym_unary_expression] = STATE(784),
    [sym_postfix_expression] = STATE(784),
    [sym_parenthesized_expression] = STATE(784),
    [sym_concatenation] = STATE(784),
    [sym_string] = STATE(100),
    [sym_simple_expansion] = STATE(100),
    [sym_string_expansion] = STATE(100),
    [sym_expansion] = STATE(100),
    [sym_command_substitution] = STATE(100),
    [sym_process_substitution] = STATE(100),
    [sym_regex] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [sym__special_characters] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [sym_raw_string] = ACTIONS(157),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(167),
    [sym_test_operator] = ACTIONS(169),
  },
  [366] = {
    [anon_sym_AMP_AMP] = ACTIONS(1281),
    [anon_sym_PIPE_PIPE] = ACTIONS(1281),
    [anon_sym_RBRACK] = ACTIONS(1281),
    [anon_sym_EQ_TILDE] = ACTIONS(1281),
    [anon_sym_EQ_EQ] = ACTIONS(1281),
    [anon_sym_EQ] = ACTIONS(1283),
    [anon_sym_PLUS_EQ] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_BANG_EQ] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_EQ] = ACTIONS(1281),
    [anon_sym_LT_EQ] = ACTIONS(1281),
    [anon_sym_GT_EQ] = ACTIONS(1281),
    [anon_sym_PLUS_PLUS] = ACTIONS(1281),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1281),
  },
  [367] = {
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1225),
    [anon_sym_EQ_TILDE] = ACTIONS(663),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(665),
    [anon_sym_PLUS_EQ] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(661),
    [anon_sym_PLUS] = ACTIONS(665),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_DASH_EQ] = ACTIONS(661),
    [anon_sym_LT_EQ] = ACTIONS(661),
    [anon_sym_GT_EQ] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(471),
    [anon_sym_DASH_DASH] = ACTIONS(471),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(661),
  },
  [368] = {
    [aux_sym_concatenation_repeat1] = STATE(786),
    [sym__concat] = ACTIONS(431),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(779),
    [anon_sym_EQ_TILDE] = ACTIONS(779),
    [anon_sym_EQ_EQ] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(781),
    [anon_sym_PLUS_EQ] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_BANG_EQ] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_DASH_EQ] = ACTIONS(779),
    [anon_sym_LT_EQ] = ACTIONS(779),
    [anon_sym_GT_EQ] = ACTIONS(779),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(779),
  },
  [369] = {
    [sym__expression] = STATE(658),
    [sym_binary_expression] = STATE(658),
    [sym_unary_expression] = STATE(658),
    [sym_postfix_expression] = STATE(658),
    [sym_parenthesized_expression] = STATE(658),
    [sym_concatenation] = STATE(658),
    [sym_string] = STATE(108),
    [sym_simple_expansion] = STATE(108),
    [sym_string_expansion] = STATE(108),
    [sym_expansion] = STATE(108),
    [sym_command_substitution] = STATE(108),
    [sym_process_substitution] = STATE(108),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(171),
    [sym__special_characters] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(175),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(177),
    [sym_test_operator] = ACTIONS(179),
  },
  [370] = {
    [sym__expression] = STATE(658),
    [sym_binary_expression] = STATE(658),
    [sym_unary_expression] = STATE(658),
    [sym_postfix_expression] = STATE(658),
    [sym_parenthesized_expression] = STATE(658),
    [sym_concatenation] = STATE(658),
    [sym_string] = STATE(108),
    [sym_simple_expansion] = STATE(108),
    [sym_string_expansion] = STATE(108),
    [sym_expansion] = STATE(108),
    [sym_command_substitution] = STATE(108),
    [sym_process_substitution] = STATE(108),
    [sym_regex] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(171),
    [sym__special_characters] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(175),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(177),
    [sym_test_operator] = ACTIONS(179),
  },
  [371] = {
    [sym_concatenation] = STATE(787),
    [sym_string] = STATE(790),
    [sym_array] = STATE(787),
    [sym_simple_expansion] = STATE(790),
    [sym_string_expansion] = STATE(790),
    [sym_expansion] = STATE(790),
    [sym_command_substitution] = STATE(790),
    [sym_process_substitution] = STATE(790),
    [sym__empty_value] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1505),
    [sym__special_characters] = ACTIONS(1507),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(1509),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1509),
  },
  [372] = {
    [sym_string] = STATE(791),
    [sym_simple_expansion] = STATE(791),
    [sym_string_expansion] = STATE(791),
    [sym_expansion] = STATE(791),
    [sym_command_substitution] = STATE(791),
    [sym_process_substitution] = STATE(791),
    [sym__special_characters] = ACTIONS(1511),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(1511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1511),
  },
  [373] = {
    [aux_sym_concatenation_repeat1] = STATE(792),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(671),
    [sym_variable_name] = ACTIONS(779),
    [ts_builtin_sym_end] = ACTIONS(779),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [sym_word] = ACTIONS(781),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [374] = {
    [sym__simple_heredoc_body] = ACTIONS(783),
    [sym__heredoc_body_beginning] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(783),
    [sym__concat] = ACTIONS(783),
    [sym_variable_name] = ACTIONS(783),
    [ts_builtin_sym_end] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_RPAREN] = ACTIONS(783),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [anon_sym_PIPE_AMP] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(783),
    [anon_sym_AMP_GT] = ACTIONS(785),
    [anon_sym_AMP_GT_GT] = ACTIONS(783),
    [anon_sym_LT_AMP] = ACTIONS(783),
    [anon_sym_GT_AMP] = ACTIONS(783),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_DASH] = ACTIONS(783),
    [anon_sym_LT_LT_LT] = ACTIONS(783),
    [sym__special_characters] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(783),
    [anon_sym_DOLLAR] = ACTIONS(785),
    [sym_raw_string] = ACTIONS(783),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(783),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(783),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [anon_sym_LT_LPAREN] = ACTIONS(783),
    [anon_sym_GT_LPAREN] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(785),
    [sym_word] = ACTIONS(785),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
  },
  [375] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(1513),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [376] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(1513),
    [anon_sym_DOLLAR] = ACTIONS(1515),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [377] = {
    [sym__simple_heredoc_body] = ACTIONS(817),
    [sym__heredoc_body_beginning] = ACTIONS(817),
    [sym_file_descriptor] = ACTIONS(817),
    [sym__concat] = ACTIONS(817),
    [sym_variable_name] = ACTIONS(817),
    [ts_builtin_sym_end] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_SEMI_SEMI] = ACTIONS(817),
    [anon_sym_PIPE_AMP] = ACTIONS(817),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(817),
    [anon_sym_AMP_GT] = ACTIONS(819),
    [anon_sym_AMP_GT_GT] = ACTIONS(817),
    [anon_sym_LT_AMP] = ACTIONS(817),
    [anon_sym_GT_AMP] = ACTIONS(817),
    [anon_sym_LT_LT] = ACTIONS(819),
    [anon_sym_LT_LT_DASH] = ACTIONS(817),
    [anon_sym_LT_LT_LT] = ACTIONS(817),
    [sym__special_characters] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR] = ACTIONS(819),
    [sym_raw_string] = ACTIONS(817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(817),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(817),
    [anon_sym_GT_LPAREN] = ACTIONS(817),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(819),
    [sym_word] = ACTIONS(819),
    [anon_sym_LF] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(819),
  },
  [378] = {
    [sym__simple_heredoc_body] = ACTIONS(821),
    [sym__heredoc_body_beginning] = ACTIONS(821),
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [sym_variable_name] = ACTIONS(821),
    [ts_builtin_sym_end] = ACTIONS(821),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(821),
    [anon_sym_SEMI_SEMI] = ACTIONS(821),
    [anon_sym_PIPE_AMP] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(823),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(823),
    [anon_sym_LT_LT_DASH] = ACTIONS(821),
    [anon_sym_LT_LT_LT] = ACTIONS(821),
    [sym__special_characters] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [anon_sym_DOLLAR] = ACTIONS(823),
    [sym_raw_string] = ACTIONS(821),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(821),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(821),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(821),
    [anon_sym_GT_LPAREN] = ACTIONS(821),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(823),
    [sym_word] = ACTIONS(823),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [379] = {
    [sym__simple_heredoc_body] = ACTIONS(825),
    [sym__heredoc_body_beginning] = ACTIONS(825),
    [sym_file_descriptor] = ACTIONS(825),
    [sym__concat] = ACTIONS(825),
    [sym_variable_name] = ACTIONS(825),
    [ts_builtin_sym_end] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(827),
    [anon_sym_PIPE] = ACTIONS(827),
    [anon_sym_RPAREN] = ACTIONS(825),
    [anon_sym_SEMI_SEMI] = ACTIONS(825),
    [anon_sym_PIPE_AMP] = ACTIONS(825),
    [anon_sym_AMP_AMP] = ACTIONS(825),
    [anon_sym_PIPE_PIPE] = ACTIONS(825),
    [anon_sym_LT] = ACTIONS(827),
    [anon_sym_GT] = ACTIONS(827),
    [anon_sym_GT_GT] = ACTIONS(825),
    [anon_sym_AMP_GT] = ACTIONS(827),
    [anon_sym_AMP_GT_GT] = ACTIONS(825),
    [anon_sym_LT_AMP] = ACTIONS(825),
    [anon_sym_GT_AMP] = ACTIONS(825),
    [anon_sym_LT_LT] = ACTIONS(827),
    [anon_sym_LT_LT_DASH] = ACTIONS(825),
    [anon_sym_LT_LT_LT] = ACTIONS(825),
    [sym__special_characters] = ACTIONS(825),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [sym_raw_string] = ACTIONS(825),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(825),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(825),
    [anon_sym_BQUOTE] = ACTIONS(825),
    [anon_sym_LT_LPAREN] = ACTIONS(825),
    [anon_sym_GT_LPAREN] = ACTIONS(825),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(827),
    [sym_word] = ACTIONS(827),
    [anon_sym_LF] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(827),
  },
  [380] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(1517),
    [sym_comment] = ACTIONS(57),
  },
  [381] = {
    [sym_subscript] = STATE(798),
    [sym_variable_name] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1521),
    [anon_sym_DOLLAR] = ACTIONS(1521),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(1525),
    [anon_sym_AT] = ACTIONS(1525),
    [anon_sym_QMARK] = ACTIONS(1525),
    [anon_sym_0] = ACTIONS(1523),
    [anon_sym__] = ACTIONS(1523),
  },
  [382] = {
    [sym_concatenation] = STATE(801),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(801),
    [anon_sym_RBRACE] = ACTIONS(1527),
    [anon_sym_EQ] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1531),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_COLON] = ACTIONS(1529),
    [anon_sym_COLON_QMARK] = ACTIONS(1529),
    [anon_sym_COLON_DASH] = ACTIONS(1529),
    [anon_sym_PERCENT] = ACTIONS(1529),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [383] = {
    [sym_concatenation] = STATE(804),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(804),
    [anon_sym_RBRACE] = ACTIONS(1535),
    [anon_sym_EQ] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1539),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(1541),
    [anon_sym_COLON] = ACTIONS(1537),
    [anon_sym_COLON_QMARK] = ACTIONS(1537),
    [anon_sym_COLON_DASH] = ACTIONS(1537),
    [anon_sym_PERCENT] = ACTIONS(1537),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [384] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(807),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(1543),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1545),
    [anon_sym_SEMI_SEMI] = ACTIONS(1547),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1543),
  },
  [385] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(807),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1543),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1545),
    [anon_sym_SEMI_SEMI] = ACTIONS(1547),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1543),
  },
  [386] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(808),
    [sym_for_statement] = STATE(808),
    [sym_c_style_for_statement] = STATE(808),
    [sym_while_statement] = STATE(808),
    [sym_if_statement] = STATE(808),
    [sym_case_statement] = STATE(808),
    [sym_function_definition] = STATE(808),
    [sym_compound_statement] = STATE(808),
    [sym_subshell] = STATE(808),
    [sym_pipeline] = STATE(808),
    [sym_list] = STATE(808),
    [sym_negated_command] = STATE(808),
    [sym_test_command] = STATE(808),
    [sym_declaration_command] = STATE(808),
    [sym_unset_command] = STATE(808),
    [sym_command] = STATE(808),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(809),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [387] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(811),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(1549),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1551),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1549),
  },
  [388] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(811),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1549),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1551),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(1545),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1549),
  },
  [389] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(812),
    [sym_for_statement] = STATE(812),
    [sym_c_style_for_statement] = STATE(812),
    [sym_while_statement] = STATE(812),
    [sym_if_statement] = STATE(812),
    [sym_case_statement] = STATE(812),
    [sym_function_definition] = STATE(812),
    [sym_compound_statement] = STATE(812),
    [sym_subshell] = STATE(812),
    [sym_pipeline] = STATE(812),
    [sym_list] = STATE(812),
    [sym_negated_command] = STATE(812),
    [sym_test_command] = STATE(812),
    [sym_declaration_command] = STATE(812),
    [sym_unset_command] = STATE(812),
    [sym_command] = STATE(812),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(813),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [390] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(816),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1555),
    [anon_sym_SEMI_SEMI] = ACTIONS(1557),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1557),
    [anon_sym_AMP] = ACTIONS(1553),
  },
  [391] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(816),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1555),
    [anon_sym_SEMI_SEMI] = ACTIONS(1557),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1557),
    [anon_sym_AMP] = ACTIONS(1553),
  },
  [392] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(817),
    [sym_for_statement] = STATE(817),
    [sym_c_style_for_statement] = STATE(817),
    [sym_while_statement] = STATE(817),
    [sym_if_statement] = STATE(817),
    [sym_case_statement] = STATE(817),
    [sym_function_definition] = STATE(817),
    [sym_compound_statement] = STATE(817),
    [sym_subshell] = STATE(817),
    [sym_pipeline] = STATE(817),
    [sym_list] = STATE(817),
    [sym_negated_command] = STATE(817),
    [sym_test_command] = STATE(817),
    [sym_declaration_command] = STATE(817),
    [sym_unset_command] = STATE(817),
    [sym_command] = STATE(817),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(818),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [393] = {
    [sym_variable_assignment] = STATE(393),
    [sym_subscript] = STATE(119),
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [sym_expansion] = STATE(114),
    [sym_command_substitution] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [aux_sym_declaration_command_repeat1] = STATE(393),
    [sym__simple_heredoc_body] = ACTIONS(1559),
    [sym__heredoc_body_beginning] = ACTIONS(1559),
    [sym_file_descriptor] = ACTIONS(1559),
    [sym_variable_name] = ACTIONS(1561),
    [ts_builtin_sym_end] = ACTIONS(1559),
    [anon_sym_SEMI] = ACTIONS(1564),
    [anon_sym_PIPE] = ACTIONS(1564),
    [anon_sym_SEMI_SEMI] = ACTIONS(1559),
    [anon_sym_PIPE_AMP] = ACTIONS(1559),
    [anon_sym_AMP_AMP] = ACTIONS(1559),
    [anon_sym_PIPE_PIPE] = ACTIONS(1559),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1564),
    [anon_sym_GT_GT] = ACTIONS(1559),
    [anon_sym_AMP_GT] = ACTIONS(1564),
    [anon_sym_AMP_GT_GT] = ACTIONS(1559),
    [anon_sym_LT_AMP] = ACTIONS(1559),
    [anon_sym_GT_AMP] = ACTIONS(1559),
    [anon_sym_LT_LT] = ACTIONS(1564),
    [anon_sym_LT_LT_DASH] = ACTIONS(1559),
    [anon_sym_LT_LT_LT] = ACTIONS(1559),
    [sym__special_characters] = ACTIONS(1566),
    [anon_sym_DQUOTE] = ACTIONS(1569),
    [anon_sym_DOLLAR] = ACTIONS(1572),
    [sym_raw_string] = ACTIONS(1575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1581),
    [anon_sym_BQUOTE] = ACTIONS(1584),
    [anon_sym_LT_LPAREN] = ACTIONS(1587),
    [anon_sym_GT_LPAREN] = ACTIONS(1587),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1590),
    [sym_word] = ACTIONS(1593),
    [anon_sym_LF] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1564),
  },
  [394] = {
    [sym_string] = STATE(819),
    [sym_simple_expansion] = STATE(819),
    [sym_string_expansion] = STATE(819),
    [sym_expansion] = STATE(819),
    [sym_command_substitution] = STATE(819),
    [sym_process_substitution] = STATE(819),
    [sym__special_characters] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(1596),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1596),
  },
  [395] = {
    [aux_sym_concatenation_repeat1] = STATE(820),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(709),
    [ts_builtin_sym_end] = ACTIONS(779),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [sym_word] = ACTIONS(781),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [396] = {
    [sym__simple_heredoc_body] = ACTIONS(783),
    [sym__heredoc_body_beginning] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(783),
    [sym__concat] = ACTIONS(783),
    [ts_builtin_sym_end] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_RPAREN] = ACTIONS(783),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [anon_sym_PIPE_AMP] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(783),
    [anon_sym_AMP_GT] = ACTIONS(785),
    [anon_sym_AMP_GT_GT] = ACTIONS(783),
    [anon_sym_LT_AMP] = ACTIONS(783),
    [anon_sym_GT_AMP] = ACTIONS(783),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_DASH] = ACTIONS(783),
    [anon_sym_LT_LT_LT] = ACTIONS(783),
    [sym__special_characters] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(783),
    [anon_sym_DOLLAR] = ACTIONS(785),
    [sym_raw_string] = ACTIONS(783),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(783),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(783),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [anon_sym_LT_LPAREN] = ACTIONS(783),
    [anon_sym_GT_LPAREN] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(785),
    [sym_word] = ACTIONS(785),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
  },
  [397] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [398] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [anon_sym_DOLLAR] = ACTIONS(1600),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [399] = {
    [sym__simple_heredoc_body] = ACTIONS(817),
    [sym__heredoc_body_beginning] = ACTIONS(817),
    [sym_file_descriptor] = ACTIONS(817),
    [sym__concat] = ACTIONS(817),
    [ts_builtin_sym_end] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_SEMI_SEMI] = ACTIONS(817),
    [anon_sym_PIPE_AMP] = ACTIONS(817),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(817),
    [anon_sym_AMP_GT] = ACTIONS(819),
    [anon_sym_AMP_GT_GT] = ACTIONS(817),
    [anon_sym_LT_AMP] = ACTIONS(817),
    [anon_sym_GT_AMP] = ACTIONS(817),
    [anon_sym_LT_LT] = ACTIONS(819),
    [anon_sym_LT_LT_DASH] = ACTIONS(817),
    [anon_sym_LT_LT_LT] = ACTIONS(817),
    [sym__special_characters] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR] = ACTIONS(819),
    [sym_raw_string] = ACTIONS(817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(817),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(817),
    [anon_sym_GT_LPAREN] = ACTIONS(817),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(819),
    [sym_word] = ACTIONS(819),
    [anon_sym_LF] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(819),
  },
  [400] = {
    [sym__simple_heredoc_body] = ACTIONS(821),
    [sym__heredoc_body_beginning] = ACTIONS(821),
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [ts_builtin_sym_end] = ACTIONS(821),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(821),
    [anon_sym_SEMI_SEMI] = ACTIONS(821),
    [anon_sym_PIPE_AMP] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(823),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(823),
    [anon_sym_LT_LT_DASH] = ACTIONS(821),
    [anon_sym_LT_LT_LT] = ACTIONS(821),
    [sym__special_characters] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [anon_sym_DOLLAR] = ACTIONS(823),
    [sym_raw_string] = ACTIONS(821),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(821),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(821),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(821),
    [anon_sym_GT_LPAREN] = ACTIONS(821),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(823),
    [sym_word] = ACTIONS(823),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [401] = {
    [sym__simple_heredoc_body] = ACTIONS(825),
    [sym__heredoc_body_beginning] = ACTIONS(825),
    [sym_file_descriptor] = ACTIONS(825),
    [sym__concat] = ACTIONS(825),
    [ts_builtin_sym_end] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(827),
    [anon_sym_PIPE] = ACTIONS(827),
    [anon_sym_RPAREN] = ACTIONS(825),
    [anon_sym_SEMI_SEMI] = ACTIONS(825),
    [anon_sym_PIPE_AMP] = ACTIONS(825),
    [anon_sym_AMP_AMP] = ACTIONS(825),
    [anon_sym_PIPE_PIPE] = ACTIONS(825),
    [anon_sym_LT] = ACTIONS(827),
    [anon_sym_GT] = ACTIONS(827),
    [anon_sym_GT_GT] = ACTIONS(825),
    [anon_sym_AMP_GT] = ACTIONS(827),
    [anon_sym_AMP_GT_GT] = ACTIONS(825),
    [anon_sym_LT_AMP] = ACTIONS(825),
    [anon_sym_GT_AMP] = ACTIONS(825),
    [anon_sym_LT_LT] = ACTIONS(827),
    [anon_sym_LT_LT_DASH] = ACTIONS(825),
    [anon_sym_LT_LT_LT] = ACTIONS(825),
    [sym__special_characters] = ACTIONS(825),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [sym_raw_string] = ACTIONS(825),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(825),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(825),
    [anon_sym_BQUOTE] = ACTIONS(825),
    [anon_sym_LT_LPAREN] = ACTIONS(825),
    [anon_sym_GT_LPAREN] = ACTIONS(825),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(827),
    [sym_word] = ACTIONS(827),
    [anon_sym_LF] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(827),
  },
  [402] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(1602),
    [sym_comment] = ACTIONS(57),
  },
  [403] = {
    [sym_subscript] = STATE(826),
    [sym_variable_name] = ACTIONS(1604),
    [anon_sym_DASH] = ACTIONS(1606),
    [anon_sym_DOLLAR] = ACTIONS(1606),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1608),
    [anon_sym_STAR] = ACTIONS(1610),
    [anon_sym_AT] = ACTIONS(1610),
    [anon_sym_QMARK] = ACTIONS(1610),
    [anon_sym_0] = ACTIONS(1608),
    [anon_sym__] = ACTIONS(1608),
  },
  [404] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(1612),
    [anon_sym_EQ] = ACTIONS(1614),
    [anon_sym_DASH] = ACTIONS(1614),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(1618),
    [anon_sym_COLON] = ACTIONS(1614),
    [anon_sym_COLON_QMARK] = ACTIONS(1614),
    [anon_sym_COLON_DASH] = ACTIONS(1614),
    [anon_sym_PERCENT] = ACTIONS(1614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [405] = {
    [sym_concatenation] = STATE(832),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(832),
    [anon_sym_RBRACE] = ACTIONS(1620),
    [anon_sym_EQ] = ACTIONS(1622),
    [anon_sym_DASH] = ACTIONS(1622),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1624),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(1626),
    [anon_sym_COLON] = ACTIONS(1622),
    [anon_sym_COLON_QMARK] = ACTIONS(1622),
    [anon_sym_COLON_DASH] = ACTIONS(1622),
    [anon_sym_PERCENT] = ACTIONS(1622),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [406] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(835),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(1628),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1630),
    [anon_sym_SEMI_SEMI] = ACTIONS(1632),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1632),
    [anon_sym_AMP] = ACTIONS(1628),
  },
  [407] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(835),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1628),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1630),
    [anon_sym_SEMI_SEMI] = ACTIONS(1632),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1632),
    [anon_sym_AMP] = ACTIONS(1628),
  },
  [408] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(836),
    [sym_for_statement] = STATE(836),
    [sym_c_style_for_statement] = STATE(836),
    [sym_while_statement] = STATE(836),
    [sym_if_statement] = STATE(836),
    [sym_case_statement] = STATE(836),
    [sym_function_definition] = STATE(836),
    [sym_compound_statement] = STATE(836),
    [sym_subshell] = STATE(836),
    [sym_pipeline] = STATE(836),
    [sym_list] = STATE(836),
    [sym_negated_command] = STATE(836),
    [sym_test_command] = STATE(836),
    [sym_declaration_command] = STATE(836),
    [sym_unset_command] = STATE(836),
    [sym_command] = STATE(836),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(837),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [409] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(839),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(1634),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1636),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(1630),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1636),
    [anon_sym_AMP] = ACTIONS(1634),
  },
  [410] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(839),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1634),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1636),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(1630),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1636),
    [anon_sym_AMP] = ACTIONS(1634),
  },
  [411] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(840),
    [sym_for_statement] = STATE(840),
    [sym_c_style_for_statement] = STATE(840),
    [sym_while_statement] = STATE(840),
    [sym_if_statement] = STATE(840),
    [sym_case_statement] = STATE(840),
    [sym_function_definition] = STATE(840),
    [sym_compound_statement] = STATE(840),
    [sym_subshell] = STATE(840),
    [sym_pipeline] = STATE(840),
    [sym_list] = STATE(840),
    [sym_negated_command] = STATE(840),
    [sym_test_command] = STATE(840),
    [sym_declaration_command] = STATE(840),
    [sym_unset_command] = STATE(840),
    [sym_command] = STATE(840),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(841),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [412] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(844),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(1638),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1640),
    [anon_sym_SEMI_SEMI] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1638),
  },
  [413] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(844),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1638),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1640),
    [anon_sym_SEMI_SEMI] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1638),
  },
  [414] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(845),
    [sym_for_statement] = STATE(845),
    [sym_c_style_for_statement] = STATE(845),
    [sym_while_statement] = STATE(845),
    [sym_if_statement] = STATE(845),
    [sym_case_statement] = STATE(845),
    [sym_function_definition] = STATE(845),
    [sym_compound_statement] = STATE(845),
    [sym_subshell] = STATE(845),
    [sym_pipeline] = STATE(845),
    [sym_list] = STATE(845),
    [sym_negated_command] = STATE(845),
    [sym_test_command] = STATE(845),
    [sym_declaration_command] = STATE(845),
    [sym_unset_command] = STATE(845),
    [sym_command] = STATE(845),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(846),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [415] = {
    [sym_concatenation] = STATE(415),
    [sym_string] = STATE(124),
    [sym_simple_expansion] = STATE(124),
    [sym_string_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [sym_process_substitution] = STATE(124),
    [aux_sym_unset_command_repeat1] = STATE(415),
    [sym__simple_heredoc_body] = ACTIONS(1644),
    [sym__heredoc_body_beginning] = ACTIONS(1644),
    [sym_file_descriptor] = ACTIONS(1644),
    [ts_builtin_sym_end] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1646),
    [anon_sym_PIPE] = ACTIONS(1646),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1646),
    [anon_sym_GT] = ACTIONS(1646),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1646),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1644),
    [anon_sym_LT_LT_LT] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1648),
    [anon_sym_DQUOTE] = ACTIONS(1651),
    [anon_sym_DOLLAR] = ACTIONS(1654),
    [sym_raw_string] = ACTIONS(1657),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1663),
    [anon_sym_BQUOTE] = ACTIONS(1666),
    [anon_sym_LT_LPAREN] = ACTIONS(1669),
    [anon_sym_GT_LPAREN] = ACTIONS(1669),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1672),
    [sym_word] = ACTIONS(1675),
    [anon_sym_LF] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1646),
  },
  [416] = {
    [sym_string] = STATE(847),
    [sym_simple_expansion] = STATE(847),
    [sym_string_expansion] = STATE(847),
    [sym_expansion] = STATE(847),
    [sym_command_substitution] = STATE(847),
    [sym_process_substitution] = STATE(847),
    [sym__special_characters] = ACTIONS(1678),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_raw_string] = ACTIONS(1678),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(241),
    [anon_sym_BQUOTE] = ACTIONS(243),
    [anon_sym_LT_LPAREN] = ACTIONS(245),
    [anon_sym_GT_LPAREN] = ACTIONS(245),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1678),
  },
  [417] = {
    [aux_sym_concatenation_repeat1] = STATE(848),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(747),
    [sym_variable_name] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(779),
  },
  [418] = {
    [sym_file_descriptor] = ACTIONS(783),
    [sym__concat] = ACTIONS(783),
    [sym_variable_name] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(783),
    [anon_sym_AMP_GT] = ACTIONS(785),
    [anon_sym_AMP_GT_GT] = ACTIONS(783),
    [anon_sym_LT_AMP] = ACTIONS(783),
    [anon_sym_GT_AMP] = ACTIONS(783),
    [sym__special_characters] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(783),
    [anon_sym_DOLLAR] = ACTIONS(785),
    [sym_raw_string] = ACTIONS(783),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(783),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(783),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [anon_sym_LT_LPAREN] = ACTIONS(783),
    [anon_sym_GT_LPAREN] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(783),
  },
  [419] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(1680),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [420] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(1680),
    [anon_sym_DOLLAR] = ACTIONS(1682),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [421] = {
    [sym_file_descriptor] = ACTIONS(817),
    [sym__concat] = ACTIONS(817),
    [sym_variable_name] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(817),
    [anon_sym_AMP_GT] = ACTIONS(819),
    [anon_sym_AMP_GT_GT] = ACTIONS(817),
    [anon_sym_LT_AMP] = ACTIONS(817),
    [anon_sym_GT_AMP] = ACTIONS(817),
    [sym__special_characters] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR] = ACTIONS(819),
    [sym_raw_string] = ACTIONS(817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(817),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(817),
    [anon_sym_GT_LPAREN] = ACTIONS(817),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(817),
  },
  [422] = {
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [sym_variable_name] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(823),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [sym__special_characters] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [anon_sym_DOLLAR] = ACTIONS(823),
    [sym_raw_string] = ACTIONS(821),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(821),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(821),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(821),
    [anon_sym_GT_LPAREN] = ACTIONS(821),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(821),
  },
  [423] = {
    [sym_file_descriptor] = ACTIONS(825),
    [sym__concat] = ACTIONS(825),
    [sym_variable_name] = ACTIONS(825),
    [anon_sym_LT] = ACTIONS(827),
    [anon_sym_GT] = ACTIONS(827),
    [anon_sym_GT_GT] = ACTIONS(825),
    [anon_sym_AMP_GT] = ACTIONS(827),
    [anon_sym_AMP_GT_GT] = ACTIONS(825),
    [anon_sym_LT_AMP] = ACTIONS(825),
    [anon_sym_GT_AMP] = ACTIONS(825),
    [sym__special_characters] = ACTIONS(825),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [sym_raw_string] = ACTIONS(825),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(825),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(825),
    [anon_sym_BQUOTE] = ACTIONS(825),
    [anon_sym_LT_LPAREN] = ACTIONS(825),
    [anon_sym_GT_LPAREN] = ACTIONS(825),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(825),
  },
  [424] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(1684),
    [sym_comment] = ACTIONS(57),
  },
  [425] = {
    [sym_subscript] = STATE(854),
    [sym_variable_name] = ACTIONS(1686),
    [anon_sym_DASH] = ACTIONS(1688),
    [anon_sym_DOLLAR] = ACTIONS(1688),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1690),
    [anon_sym_STAR] = ACTIONS(1692),
    [anon_sym_AT] = ACTIONS(1692),
    [anon_sym_QMARK] = ACTIONS(1692),
    [anon_sym_0] = ACTIONS(1690),
    [anon_sym__] = ACTIONS(1690),
  },
  [426] = {
    [sym_concatenation] = STATE(857),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(857),
    [anon_sym_RBRACE] = ACTIONS(1694),
    [anon_sym_EQ] = ACTIONS(1696),
    [anon_sym_DASH] = ACTIONS(1696),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(1700),
    [anon_sym_COLON] = ACTIONS(1696),
    [anon_sym_COLON_QMARK] = ACTIONS(1696),
    [anon_sym_COLON_DASH] = ACTIONS(1696),
    [anon_sym_PERCENT] = ACTIONS(1696),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [427] = {
    [sym_concatenation] = STATE(860),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(860),
    [anon_sym_RBRACE] = ACTIONS(1702),
    [anon_sym_EQ] = ACTIONS(1704),
    [anon_sym_DASH] = ACTIONS(1704),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1706),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(1708),
    [anon_sym_COLON] = ACTIONS(1704),
    [anon_sym_COLON_QMARK] = ACTIONS(1704),
    [anon_sym_COLON_DASH] = ACTIONS(1704),
    [anon_sym_PERCENT] = ACTIONS(1704),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [428] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(863),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(1710),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1712),
    [anon_sym_SEMI_SEMI] = ACTIONS(1714),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1714),
    [anon_sym_AMP] = ACTIONS(1710),
  },
  [429] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(863),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1710),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1712),
    [anon_sym_SEMI_SEMI] = ACTIONS(1714),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1714),
    [anon_sym_AMP] = ACTIONS(1710),
  },
  [430] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(864),
    [sym_for_statement] = STATE(864),
    [sym_c_style_for_statement] = STATE(864),
    [sym_while_statement] = STATE(864),
    [sym_if_statement] = STATE(864),
    [sym_case_statement] = STATE(864),
    [sym_function_definition] = STATE(864),
    [sym_compound_statement] = STATE(864),
    [sym_subshell] = STATE(864),
    [sym_pipeline] = STATE(864),
    [sym_list] = STATE(864),
    [sym_negated_command] = STATE(864),
    [sym_test_command] = STATE(864),
    [sym_declaration_command] = STATE(864),
    [sym_unset_command] = STATE(864),
    [sym_command] = STATE(864),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(865),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [431] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(867),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(1716),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1718),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(1712),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1718),
    [anon_sym_AMP] = ACTIONS(1716),
  },
  [432] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(867),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1716),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1718),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(1712),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1718),
    [anon_sym_AMP] = ACTIONS(1716),
  },
  [433] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(868),
    [sym_for_statement] = STATE(868),
    [sym_c_style_for_statement] = STATE(868),
    [sym_while_statement] = STATE(868),
    [sym_if_statement] = STATE(868),
    [sym_case_statement] = STATE(868),
    [sym_function_definition] = STATE(868),
    [sym_compound_statement] = STATE(868),
    [sym_subshell] = STATE(868),
    [sym_pipeline] = STATE(868),
    [sym_list] = STATE(868),
    [sym_negated_command] = STATE(868),
    [sym_test_command] = STATE(868),
    [sym_declaration_command] = STATE(868),
    [sym_unset_command] = STATE(868),
    [sym_command] = STATE(868),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(869),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [434] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(872),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1722),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1720),
  },
  [435] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(872),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1722),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1720),
  },
  [436] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(873),
    [sym_for_statement] = STATE(873),
    [sym_c_style_for_statement] = STATE(873),
    [sym_while_statement] = STATE(873),
    [sym_if_statement] = STATE(873),
    [sym_case_statement] = STATE(873),
    [sym_function_definition] = STATE(873),
    [sym_compound_statement] = STATE(873),
    [sym_subshell] = STATE(873),
    [sym_pipeline] = STATE(873),
    [sym_list] = STATE(873),
    [sym_negated_command] = STATE(873),
    [sym_test_command] = STATE(873),
    [sym_declaration_command] = STATE(873),
    [sym_unset_command] = STATE(873),
    [sym_command] = STATE(873),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(874),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [437] = {
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(1726),
    [ts_builtin_sym_end] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_EQ_TILDE] = ACTIONS(1728),
    [anon_sym_EQ_EQ] = ACTIONS(1728),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [438] = {
    [aux_sym_concatenation_repeat1] = STATE(438),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(1730),
    [ts_builtin_sym_end] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_EQ_TILDE] = ACTIONS(1728),
    [anon_sym_EQ_EQ] = ACTIONS(1728),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [439] = {
    [sym__concat] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(819),
    [anon_sym_DOLLAR] = ACTIONS(819),
    [sym__string_content] = ACTIONS(817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(819),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(819),
    [anon_sym_BQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(265),
  },
  [440] = {
    [sym__simple_heredoc_body] = ACTIONS(1733),
    [sym__heredoc_body_beginning] = ACTIONS(1733),
    [sym_file_descriptor] = ACTIONS(1733),
    [sym__concat] = ACTIONS(1733),
    [ts_builtin_sym_end] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_PIPE] = ACTIONS(1735),
    [anon_sym_RPAREN] = ACTIONS(1733),
    [anon_sym_SEMI_SEMI] = ACTIONS(1733),
    [anon_sym_PIPE_AMP] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1733),
    [anon_sym_EQ_TILDE] = ACTIONS(1735),
    [anon_sym_EQ_EQ] = ACTIONS(1735),
    [anon_sym_LT] = ACTIONS(1735),
    [anon_sym_GT] = ACTIONS(1735),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_AMP_GT] = ACTIONS(1735),
    [anon_sym_AMP_GT_GT] = ACTIONS(1733),
    [anon_sym_LT_AMP] = ACTIONS(1733),
    [anon_sym_GT_AMP] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1735),
    [anon_sym_LT_LT_DASH] = ACTIONS(1733),
    [anon_sym_LT_LT_LT] = ACTIONS(1733),
    [sym__special_characters] = ACTIONS(1733),
    [anon_sym_DQUOTE] = ACTIONS(1733),
    [anon_sym_DOLLAR] = ACTIONS(1735),
    [sym_raw_string] = ACTIONS(1733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1733),
    [anon_sym_BQUOTE] = ACTIONS(1733),
    [anon_sym_LT_LPAREN] = ACTIONS(1733),
    [anon_sym_GT_LPAREN] = ACTIONS(1733),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1735),
    [anon_sym_LF] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1735),
  },
  [441] = {
    [sym__concat] = ACTIONS(1737),
    [anon_sym_DQUOTE] = ACTIONS(1739),
    [anon_sym_DOLLAR] = ACTIONS(1739),
    [sym__string_content] = ACTIONS(1741),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1739),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(1739),
    [sym_comment] = ACTIONS(265),
  },
  [442] = {
    [sym__concat] = ACTIONS(825),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [sym__string_content] = ACTIONS(825),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(827),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(827),
    [anon_sym_BQUOTE] = ACTIONS(827),
    [sym_comment] = ACTIONS(265),
  },
  [443] = {
    [anon_sym_DQUOTE] = ACTIONS(1739),
    [anon_sym_DOLLAR] = ACTIONS(1739),
    [sym__string_content] = ACTIONS(1741),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1739),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(1739),
    [sym_comment] = ACTIONS(265),
  },
  [444] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(1743),
    [sym_comment] = ACTIONS(57),
  },
  [445] = {
    [sym_subscript] = STATE(879),
    [sym_variable_name] = ACTIONS(1745),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_DOLLAR] = ACTIONS(1747),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AT] = ACTIONS(1751),
    [anon_sym_QMARK] = ACTIONS(1751),
    [anon_sym_0] = ACTIONS(1749),
    [anon_sym__] = ACTIONS(1749),
  },
  [446] = {
    [sym_concatenation] = STATE(882),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(882),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1757),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(1755),
    [anon_sym_COLON_QMARK] = ACTIONS(1755),
    [anon_sym_COLON_DASH] = ACTIONS(1755),
    [anon_sym_PERCENT] = ACTIONS(1755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [447] = {
    [sym_concatenation] = STATE(885),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(885),
    [anon_sym_RBRACE] = ACTIONS(1761),
    [anon_sym_EQ] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(1767),
    [anon_sym_COLON] = ACTIONS(1763),
    [anon_sym_COLON_QMARK] = ACTIONS(1763),
    [anon_sym_COLON_DASH] = ACTIONS(1763),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [448] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(888),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(1769),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1771),
    [anon_sym_SEMI_SEMI] = ACTIONS(1773),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1769),
  },
  [449] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(888),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1769),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1771),
    [anon_sym_SEMI_SEMI] = ACTIONS(1773),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1769),
  },
  [450] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(889),
    [sym_for_statement] = STATE(889),
    [sym_c_style_for_statement] = STATE(889),
    [sym_while_statement] = STATE(889),
    [sym_if_statement] = STATE(889),
    [sym_case_statement] = STATE(889),
    [sym_function_definition] = STATE(889),
    [sym_compound_statement] = STATE(889),
    [sym_subshell] = STATE(889),
    [sym_pipeline] = STATE(889),
    [sym_list] = STATE(889),
    [sym_negated_command] = STATE(889),
    [sym_test_command] = STATE(889),
    [sym_declaration_command] = STATE(889),
    [sym_unset_command] = STATE(889),
    [sym_command] = STATE(889),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(890),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [451] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(892),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(1775),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1777),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(1771),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1777),
    [anon_sym_AMP] = ACTIONS(1775),
  },
  [452] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(892),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1775),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1777),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(1771),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1777),
    [anon_sym_AMP] = ACTIONS(1775),
  },
  [453] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(893),
    [sym_for_statement] = STATE(893),
    [sym_c_style_for_statement] = STATE(893),
    [sym_while_statement] = STATE(893),
    [sym_if_statement] = STATE(893),
    [sym_case_statement] = STATE(893),
    [sym_function_definition] = STATE(893),
    [sym_compound_statement] = STATE(893),
    [sym_subshell] = STATE(893),
    [sym_pipeline] = STATE(893),
    [sym_list] = STATE(893),
    [sym_negated_command] = STATE(893),
    [sym_test_command] = STATE(893),
    [sym_declaration_command] = STATE(893),
    [sym_unset_command] = STATE(893),
    [sym_command] = STATE(893),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(894),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [454] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(1779),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [455] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(1739),
    [anon_sym_DOLLAR] = ACTIONS(1781),
    [sym__string_content] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1787),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1790),
    [anon_sym_BQUOTE] = ACTIONS(1793),
    [sym_comment] = ACTIONS(265),
  },
  [456] = {
    [sym_concatenation] = STATE(899),
    [sym_string] = STATE(898),
    [sym_simple_expansion] = STATE(898),
    [sym_string_expansion] = STATE(898),
    [sym_expansion] = STATE(898),
    [sym_command_substitution] = STATE(898),
    [sym_process_substitution] = STATE(898),
    [sym__special_characters] = ACTIONS(1796),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [sym_raw_string] = ACTIONS(1798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1798),
  },
  [457] = {
    [sym_concatenation] = STATE(909),
    [sym_string] = STATE(904),
    [sym_simple_expansion] = STATE(904),
    [sym_string_expansion] = STATE(904),
    [sym_expansion] = STATE(904),
    [sym_command_substitution] = STATE(904),
    [sym_process_substitution] = STATE(904),
    [anon_sym_RBRACE] = ACTIONS(1800),
    [sym__special_characters] = ACTIONS(1802),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(1808),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1808),
  },
  [458] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(1818),
    [sym_comment] = ACTIONS(57),
  },
  [459] = {
    [sym_concatenation] = STATE(913),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(913),
    [anon_sym_RBRACE] = ACTIONS(1820),
    [anon_sym_EQ] = ACTIONS(1822),
    [anon_sym_DASH] = ACTIONS(1822),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(1826),
    [anon_sym_COLON] = ACTIONS(1822),
    [anon_sym_COLON_QMARK] = ACTIONS(1822),
    [anon_sym_COLON_DASH] = ACTIONS(1822),
    [anon_sym_PERCENT] = ACTIONS(1822),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [460] = {
    [sym_concatenation] = STATE(915),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(915),
    [anon_sym_RBRACE] = ACTIONS(1800),
    [anon_sym_EQ] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(1832),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [461] = {
    [sym__simple_heredoc_body] = ACTIONS(1834),
    [sym__heredoc_body_beginning] = ACTIONS(1834),
    [sym_file_descriptor] = ACTIONS(1834),
    [sym__concat] = ACTIONS(1834),
    [ts_builtin_sym_end] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1836),
    [anon_sym_PIPE] = ACTIONS(1836),
    [anon_sym_RPAREN] = ACTIONS(1834),
    [anon_sym_SEMI_SEMI] = ACTIONS(1834),
    [anon_sym_PIPE_AMP] = ACTIONS(1834),
    [anon_sym_AMP_AMP] = ACTIONS(1834),
    [anon_sym_PIPE_PIPE] = ACTIONS(1834),
    [anon_sym_EQ_TILDE] = ACTIONS(1836),
    [anon_sym_EQ_EQ] = ACTIONS(1836),
    [anon_sym_LT] = ACTIONS(1836),
    [anon_sym_GT] = ACTIONS(1836),
    [anon_sym_GT_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT] = ACTIONS(1836),
    [anon_sym_AMP_GT_GT] = ACTIONS(1834),
    [anon_sym_LT_AMP] = ACTIONS(1834),
    [anon_sym_GT_AMP] = ACTIONS(1834),
    [anon_sym_LT_LT] = ACTIONS(1836),
    [anon_sym_LT_LT_DASH] = ACTIONS(1834),
    [anon_sym_LT_LT_LT] = ACTIONS(1834),
    [sym__special_characters] = ACTIONS(1834),
    [anon_sym_DQUOTE] = ACTIONS(1834),
    [anon_sym_DOLLAR] = ACTIONS(1836),
    [sym_raw_string] = ACTIONS(1834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1834),
    [anon_sym_BQUOTE] = ACTIONS(1834),
    [anon_sym_LT_LPAREN] = ACTIONS(1834),
    [anon_sym_GT_LPAREN] = ACTIONS(1834),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1836),
    [anon_sym_LF] = ACTIONS(1834),
    [anon_sym_AMP] = ACTIONS(1836),
  },
  [462] = {
    [aux_sym_concatenation_repeat1] = STATE(917),
    [sym__concat] = ACTIONS(1838),
    [anon_sym_RBRACE] = ACTIONS(1840),
    [anon_sym_EQ] = ACTIONS(1842),
    [anon_sym_DASH] = ACTIONS(1842),
    [sym__special_characters] = ACTIONS(1842),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [anon_sym_DOLLAR] = ACTIONS(1842),
    [sym_raw_string] = ACTIONS(1840),
    [anon_sym_POUND] = ACTIONS(1840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1840),
    [anon_sym_COLON] = ACTIONS(1842),
    [anon_sym_COLON_QMARK] = ACTIONS(1842),
    [anon_sym_COLON_DASH] = ACTIONS(1842),
    [anon_sym_PERCENT] = ACTIONS(1842),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1840),
    [anon_sym_BQUOTE] = ACTIONS(1840),
    [anon_sym_LT_LPAREN] = ACTIONS(1840),
    [anon_sym_GT_LPAREN] = ACTIONS(1840),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1842),
  },
  [463] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(920),
    [anon_sym_DQUOTE] = ACTIONS(1844),
    [anon_sym_DOLLAR] = ACTIONS(1846),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [464] = {
    [sym_string] = STATE(922),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(1848),
    [sym_raw_string] = ACTIONS(1850),
    [anon_sym_POUND] = ACTIONS(1848),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1852),
    [anon_sym_STAR] = ACTIONS(1854),
    [anon_sym_AT] = ACTIONS(1854),
    [anon_sym_QMARK] = ACTIONS(1854),
    [anon_sym_0] = ACTIONS(1852),
    [anon_sym__] = ACTIONS(1852),
  },
  [465] = {
    [aux_sym_concatenation_repeat1] = STATE(917),
    [sym__concat] = ACTIONS(1838),
    [anon_sym_RBRACE] = ACTIONS(1856),
    [anon_sym_EQ] = ACTIONS(1858),
    [anon_sym_DASH] = ACTIONS(1858),
    [sym__special_characters] = ACTIONS(1858),
    [anon_sym_DQUOTE] = ACTIONS(1856),
    [anon_sym_DOLLAR] = ACTIONS(1858),
    [sym_raw_string] = ACTIONS(1856),
    [anon_sym_POUND] = ACTIONS(1856),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1856),
    [anon_sym_COLON] = ACTIONS(1858),
    [anon_sym_COLON_QMARK] = ACTIONS(1858),
    [anon_sym_COLON_DASH] = ACTIONS(1858),
    [anon_sym_PERCENT] = ACTIONS(1858),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1856),
    [anon_sym_BQUOTE] = ACTIONS(1856),
    [anon_sym_LT_LPAREN] = ACTIONS(1856),
    [anon_sym_GT_LPAREN] = ACTIONS(1856),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1858),
  },
  [466] = {
    [sym_subscript] = STATE(927),
    [sym_variable_name] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1864),
    [anon_sym_DOLLAR] = ACTIONS(1864),
    [anon_sym_POUND] = ACTIONS(1862),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(1868),
    [anon_sym_AT] = ACTIONS(1868),
    [anon_sym_QMARK] = ACTIONS(1868),
    [anon_sym_0] = ACTIONS(1866),
    [anon_sym__] = ACTIONS(1866),
  },
  [467] = {
    [sym_concatenation] = STATE(930),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(930),
    [sym_regex] = ACTIONS(1870),
    [anon_sym_RBRACE] = ACTIONS(1872),
    [anon_sym_EQ] = ACTIONS(1874),
    [anon_sym_DASH] = ACTIONS(1874),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1874),
    [anon_sym_COLON_QMARK] = ACTIONS(1874),
    [anon_sym_COLON_DASH] = ACTIONS(1874),
    [anon_sym_PERCENT] = ACTIONS(1874),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [468] = {
    [sym__terminated_statement] = STATE(933),
    [sym_redirected_statement] = STATE(931),
    [sym_for_statement] = STATE(931),
    [sym_c_style_for_statement] = STATE(931),
    [sym_while_statement] = STATE(931),
    [sym_if_statement] = STATE(931),
    [sym_case_statement] = STATE(931),
    [sym_function_definition] = STATE(931),
    [sym_compound_statement] = STATE(931),
    [sym_subshell] = STATE(931),
    [sym_pipeline] = STATE(931),
    [sym_list] = STATE(931),
    [sym_negated_command] = STATE(931),
    [sym_test_command] = STATE(931),
    [sym_declaration_command] = STATE(931),
    [sym_unset_command] = STATE(931),
    [sym_command] = STATE(931),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(932),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(933),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [469] = {
    [sym__terminated_statement] = STATE(936),
    [sym_redirected_statement] = STATE(934),
    [sym_for_statement] = STATE(934),
    [sym_c_style_for_statement] = STATE(934),
    [sym_while_statement] = STATE(934),
    [sym_if_statement] = STATE(934),
    [sym_case_statement] = STATE(934),
    [sym_function_definition] = STATE(934),
    [sym_compound_statement] = STATE(934),
    [sym_subshell] = STATE(934),
    [sym_pipeline] = STATE(934),
    [sym_list] = STATE(934),
    [sym_negated_command] = STATE(934),
    [sym_test_command] = STATE(934),
    [sym_declaration_command] = STATE(934),
    [sym_unset_command] = STATE(934),
    [sym_command] = STATE(934),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(935),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(936),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [470] = {
    [sym__terminated_statement] = STATE(939),
    [sym_redirected_statement] = STATE(937),
    [sym_for_statement] = STATE(937),
    [sym_c_style_for_statement] = STATE(937),
    [sym_while_statement] = STATE(937),
    [sym_if_statement] = STATE(937),
    [sym_case_statement] = STATE(937),
    [sym_function_definition] = STATE(937),
    [sym_compound_statement] = STATE(937),
    [sym_subshell] = STATE(937),
    [sym_pipeline] = STATE(937),
    [sym_list] = STATE(937),
    [sym_negated_command] = STATE(937),
    [sym_test_command] = STATE(937),
    [sym_declaration_command] = STATE(937),
    [sym_unset_command] = STATE(937),
    [sym_command] = STATE(937),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(938),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(939),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [471] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(1872),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [472] = {
    [sym__simple_heredoc_body] = ACTIONS(1882),
    [sym__heredoc_body_beginning] = ACTIONS(1882),
    [sym_file_descriptor] = ACTIONS(1882),
    [sym__concat] = ACTIONS(1882),
    [ts_builtin_sym_end] = ACTIONS(1882),
    [anon_sym_SEMI] = ACTIONS(1884),
    [anon_sym_PIPE] = ACTIONS(1884),
    [anon_sym_RPAREN] = ACTIONS(1882),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [anon_sym_PIPE_AMP] = ACTIONS(1882),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_EQ_TILDE] = ACTIONS(1884),
    [anon_sym_EQ_EQ] = ACTIONS(1884),
    [anon_sym_LT] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1884),
    [anon_sym_GT_GT] = ACTIONS(1882),
    [anon_sym_AMP_GT] = ACTIONS(1884),
    [anon_sym_AMP_GT_GT] = ACTIONS(1882),
    [anon_sym_LT_AMP] = ACTIONS(1882),
    [anon_sym_GT_AMP] = ACTIONS(1882),
    [anon_sym_LT_LT] = ACTIONS(1884),
    [anon_sym_LT_LT_DASH] = ACTIONS(1882),
    [anon_sym_LT_LT_LT] = ACTIONS(1882),
    [sym__special_characters] = ACTIONS(1882),
    [anon_sym_DQUOTE] = ACTIONS(1882),
    [anon_sym_DOLLAR] = ACTIONS(1884),
    [sym_raw_string] = ACTIONS(1882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1882),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [anon_sym_LT_LPAREN] = ACTIONS(1882),
    [anon_sym_GT_LPAREN] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1884),
    [anon_sym_LF] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1884),
  },
  [473] = {
    [sym_concatenation] = STATE(915),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(915),
    [sym_regex] = ACTIONS(1886),
    [anon_sym_RBRACE] = ACTIONS(1800),
    [anon_sym_EQ] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [474] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(1800),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [475] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(1888),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [476] = {
    [sym__simple_heredoc_body] = ACTIONS(1890),
    [sym__heredoc_body_beginning] = ACTIONS(1890),
    [sym_file_descriptor] = ACTIONS(1890),
    [sym__concat] = ACTIONS(1890),
    [ts_builtin_sym_end] = ACTIONS(1890),
    [anon_sym_SEMI] = ACTIONS(1892),
    [anon_sym_PIPE] = ACTIONS(1892),
    [anon_sym_RPAREN] = ACTIONS(1890),
    [anon_sym_SEMI_SEMI] = ACTIONS(1890),
    [anon_sym_PIPE_AMP] = ACTIONS(1890),
    [anon_sym_AMP_AMP] = ACTIONS(1890),
    [anon_sym_PIPE_PIPE] = ACTIONS(1890),
    [anon_sym_EQ_TILDE] = ACTIONS(1892),
    [anon_sym_EQ_EQ] = ACTIONS(1892),
    [anon_sym_LT] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(1892),
    [anon_sym_GT_GT] = ACTIONS(1890),
    [anon_sym_AMP_GT] = ACTIONS(1892),
    [anon_sym_AMP_GT_GT] = ACTIONS(1890),
    [anon_sym_LT_AMP] = ACTIONS(1890),
    [anon_sym_GT_AMP] = ACTIONS(1890),
    [anon_sym_LT_LT] = ACTIONS(1892),
    [anon_sym_LT_LT_DASH] = ACTIONS(1890),
    [anon_sym_LT_LT_LT] = ACTIONS(1890),
    [sym__special_characters] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1890),
    [anon_sym_DOLLAR] = ACTIONS(1892),
    [sym_raw_string] = ACTIONS(1890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1890),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [anon_sym_LT_LPAREN] = ACTIONS(1890),
    [anon_sym_GT_LPAREN] = ACTIONS(1890),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1892),
    [anon_sym_LF] = ACTIONS(1890),
    [anon_sym_AMP] = ACTIONS(1892),
  },
  [477] = {
    [anon_sym_SEMI] = ACTIONS(1894),
    [anon_sym_RPAREN] = ACTIONS(1888),
    [anon_sym_SEMI_SEMI] = ACTIONS(1896),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1896),
    [anon_sym_AMP] = ACTIONS(1896),
  },
  [478] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(945),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(1898),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1888),
    [anon_sym_SEMI_SEMI] = ACTIONS(1900),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1900),
    [anon_sym_AMP] = ACTIONS(1898),
  },
  [479] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(945),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1898),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1888),
    [anon_sym_SEMI_SEMI] = ACTIONS(1900),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1900),
    [anon_sym_AMP] = ACTIONS(1898),
  },
  [480] = {
    [sym_variable_assignment] = STATE(664),
    [sym_subscript] = STATE(261),
    [sym_concatenation] = STATE(664),
    [sym_string] = STATE(260),
    [sym_simple_expansion] = STATE(260),
    [sym_string_expansion] = STATE(260),
    [sym_expansion] = STATE(260),
    [sym_command_substitution] = STATE(260),
    [sym_process_substitution] = STATE(260),
    [aux_sym_declaration_command_repeat1] = STATE(664),
    [sym__simple_heredoc_body] = ACTIONS(701),
    [sym__heredoc_body_beginning] = ACTIONS(701),
    [sym_file_descriptor] = ACTIONS(701),
    [sym_variable_name] = ACTIONS(475),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_SEMI_SEMI] = ACTIONS(701),
    [anon_sym_PIPE_AMP] = ACTIONS(701),
    [anon_sym_AMP_AMP] = ACTIONS(701),
    [anon_sym_PIPE_PIPE] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(703),
    [anon_sym_GT] = ACTIONS(703),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_AMP_GT] = ACTIONS(703),
    [anon_sym_AMP_GT_GT] = ACTIONS(701),
    [anon_sym_LT_AMP] = ACTIONS(701),
    [anon_sym_GT_AMP] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(703),
    [anon_sym_LT_LT_DASH] = ACTIONS(701),
    [anon_sym_LT_LT_LT] = ACTIONS(701),
    [sym__special_characters] = ACTIONS(477),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(479),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(701),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1291),
    [sym_word] = ACTIONS(483),
    [anon_sym_LF] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(703),
  },
  [481] = {
    [sym_concatenation] = STATE(666),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [aux_sym_unset_command_repeat1] = STATE(666),
    [sym__simple_heredoc_body] = ACTIONS(739),
    [sym__heredoc_body_beginning] = ACTIONS(739),
    [sym_file_descriptor] = ACTIONS(739),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_GT] = ACTIONS(739),
    [anon_sym_AMP_GT] = ACTIONS(741),
    [anon_sym_AMP_GT_GT] = ACTIONS(739),
    [anon_sym_LT_AMP] = ACTIONS(739),
    [anon_sym_GT_AMP] = ACTIONS(739),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_LT_LT_DASH] = ACTIONS(739),
    [anon_sym_LT_LT_LT] = ACTIONS(739),
    [sym__special_characters] = ACTIONS(485),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(487),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(739),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1293),
    [sym_word] = ACTIONS(491),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(741),
  },
  [482] = {
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_GT] = ACTIONS(1902),
    [anon_sym_GT_GT] = ACTIONS(1904),
    [anon_sym_AMP_GT] = ACTIONS(1902),
    [anon_sym_AMP_GT_GT] = ACTIONS(1904),
    [anon_sym_LT_AMP] = ACTIONS(1904),
    [anon_sym_GT_AMP] = ACTIONS(1904),
    [sym_comment] = ACTIONS(57),
  },
  [483] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(1888),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [484] = {
    [sym_redirected_statement] = STATE(947),
    [sym_for_statement] = STATE(947),
    [sym_c_style_for_statement] = STATE(947),
    [sym_while_statement] = STATE(947),
    [sym_if_statement] = STATE(947),
    [sym_case_statement] = STATE(947),
    [sym_function_definition] = STATE(947),
    [sym_compound_statement] = STATE(947),
    [sym_subshell] = STATE(947),
    [sym_pipeline] = STATE(947),
    [sym_list] = STATE(947),
    [sym_negated_command] = STATE(947),
    [sym_test_command] = STATE(947),
    [sym_declaration_command] = STATE(947),
    [sym_unset_command] = STATE(947),
    [sym_command] = STATE(947),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(948),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [485] = {
    [sym_redirected_statement] = STATE(949),
    [sym_for_statement] = STATE(949),
    [sym_c_style_for_statement] = STATE(949),
    [sym_while_statement] = STATE(949),
    [sym_if_statement] = STATE(949),
    [sym_case_statement] = STATE(949),
    [sym_function_definition] = STATE(949),
    [sym_compound_statement] = STATE(949),
    [sym_subshell] = STATE(949),
    [sym_pipeline] = STATE(949),
    [sym_list] = STATE(949),
    [sym_negated_command] = STATE(949),
    [sym_test_command] = STATE(949),
    [sym_declaration_command] = STATE(949),
    [sym_unset_command] = STATE(949),
    [sym_command] = STATE(949),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(950),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [486] = {
    [sym_concatenation] = STATE(511),
    [sym_string] = STATE(952),
    [sym_simple_expansion] = STATE(952),
    [sym_string_expansion] = STATE(952),
    [sym_expansion] = STATE(952),
    [sym_command_substitution] = STATE(952),
    [sym_process_substitution] = STATE(952),
    [sym__special_characters] = ACTIONS(1906),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1908),
  },
  [487] = {
    [sym_concatenation] = STATE(515),
    [sym_string] = STATE(954),
    [sym_simple_expansion] = STATE(954),
    [sym_string_expansion] = STATE(954),
    [sym_expansion] = STATE(954),
    [sym_command_substitution] = STATE(954),
    [sym_process_substitution] = STATE(954),
    [sym__special_characters] = ACTIONS(1910),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1912),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1912),
  },
  [488] = {
    [anon_sym_SEMI] = ACTIONS(1914),
    [anon_sym_SEMI_SEMI] = ACTIONS(1916),
    [anon_sym_BQUOTE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1916),
  },
  [489] = {
    [sym_file_redirect] = STATE(956),
    [sym_heredoc_redirect] = STATE(956),
    [sym_herestring_redirect] = STATE(956),
    [aux_sym_redirected_statement_repeat1] = STATE(956),
    [sym__simple_heredoc_body] = ACTIONS(947),
    [sym__heredoc_body_beginning] = ACTIONS(947),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI_SEMI] = ACTIONS(947),
    [anon_sym_PIPE_AMP] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(947),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
  },
  [490] = {
    [sym_concatenation] = STATE(683),
    [sym_string] = STATE(279),
    [sym_simple_expansion] = STATE(279),
    [sym_string_expansion] = STATE(279),
    [sym_expansion] = STATE(279),
    [sym_command_substitution] = STATE(279),
    [sym_process_substitution] = STATE(279),
    [aux_sym_command_repeat2] = STATE(683),
    [sym__simple_heredoc_body] = ACTIONS(965),
    [sym__heredoc_body_beginning] = ACTIONS(965),
    [sym_file_descriptor] = ACTIONS(965),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(967),
    [anon_sym_SEMI_SEMI] = ACTIONS(965),
    [anon_sym_PIPE_AMP] = ACTIONS(965),
    [anon_sym_AMP_AMP] = ACTIONS(965),
    [anon_sym_PIPE_PIPE] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(513),
    [anon_sym_EQ_EQ] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(965),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(965),
    [anon_sym_LT_AMP] = ACTIONS(965),
    [anon_sym_GT_AMP] = ACTIONS(965),
    [anon_sym_LT_LT] = ACTIONS(967),
    [anon_sym_LT_LT_DASH] = ACTIONS(965),
    [anon_sym_LT_LT_LT] = ACTIONS(965),
    [sym__special_characters] = ACTIONS(515),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(517),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(965),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(965),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [491] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(958),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1920),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1920),
    [anon_sym_AMP] = ACTIONS(1918),
  },
  [492] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(958),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1920),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(1888),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1920),
    [anon_sym_AMP] = ACTIONS(1918),
  },
  [493] = {
    [sym_concatenation] = STATE(959),
    [sym_string] = STATE(279),
    [sym_simple_expansion] = STATE(279),
    [sym_string_expansion] = STATE(279),
    [sym_expansion] = STATE(279),
    [sym_command_substitution] = STATE(279),
    [sym_process_substitution] = STATE(279),
    [aux_sym_command_repeat2] = STATE(959),
    [sym__simple_heredoc_body] = ACTIONS(965),
    [sym__heredoc_body_beginning] = ACTIONS(965),
    [sym_file_descriptor] = ACTIONS(965),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(967),
    [anon_sym_SEMI_SEMI] = ACTIONS(965),
    [anon_sym_PIPE_AMP] = ACTIONS(965),
    [anon_sym_AMP_AMP] = ACTIONS(965),
    [anon_sym_PIPE_PIPE] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(513),
    [anon_sym_EQ_EQ] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(965),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(965),
    [anon_sym_LT_AMP] = ACTIONS(965),
    [anon_sym_GT_AMP] = ACTIONS(965),
    [anon_sym_LT_LT] = ACTIONS(967),
    [anon_sym_LT_LT_DASH] = ACTIONS(965),
    [anon_sym_LT_LT_LT] = ACTIONS(965),
    [sym__special_characters] = ACTIONS(515),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(517),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(965),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(965),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [494] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(1922),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [495] = {
    [sym__simple_heredoc_body] = ACTIONS(1924),
    [sym__heredoc_body_beginning] = ACTIONS(1924),
    [sym_file_descriptor] = ACTIONS(1924),
    [sym__concat] = ACTIONS(1924),
    [ts_builtin_sym_end] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_RPAREN] = ACTIONS(1924),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [anon_sym_PIPE_AMP] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_EQ_TILDE] = ACTIONS(1926),
    [anon_sym_EQ_EQ] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_GT_GT] = ACTIONS(1924),
    [anon_sym_AMP_GT] = ACTIONS(1926),
    [anon_sym_AMP_GT_GT] = ACTIONS(1924),
    [anon_sym_LT_AMP] = ACTIONS(1924),
    [anon_sym_GT_AMP] = ACTIONS(1924),
    [anon_sym_LT_LT] = ACTIONS(1926),
    [anon_sym_LT_LT_DASH] = ACTIONS(1924),
    [anon_sym_LT_LT_LT] = ACTIONS(1924),
    [sym__special_characters] = ACTIONS(1924),
    [anon_sym_DQUOTE] = ACTIONS(1924),
    [anon_sym_DOLLAR] = ACTIONS(1926),
    [sym_raw_string] = ACTIONS(1924),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1924),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1924),
    [anon_sym_BQUOTE] = ACTIONS(1924),
    [anon_sym_LT_LPAREN] = ACTIONS(1924),
    [anon_sym_GT_LPAREN] = ACTIONS(1924),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1926),
    [anon_sym_LF] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1926),
  },
  [496] = {
    [anon_sym_SEMI] = ACTIONS(1928),
    [anon_sym_RPAREN] = ACTIONS(1922),
    [anon_sym_SEMI_SEMI] = ACTIONS(1930),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1930),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [497] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(963),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(1932),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1922),
    [anon_sym_SEMI_SEMI] = ACTIONS(1934),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1934),
    [anon_sym_AMP] = ACTIONS(1932),
  },
  [498] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(963),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1932),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1922),
    [anon_sym_SEMI_SEMI] = ACTIONS(1934),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1934),
    [anon_sym_AMP] = ACTIONS(1932),
  },
  [499] = {
    [sym_compound_statement] = STATE(964),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [500] = {
    [ts_builtin_sym_end] = ACTIONS(1936),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym_RPAREN] = ACTIONS(1936),
    [anon_sym_SEMI_SEMI] = ACTIONS(1936),
    [anon_sym_BQUOTE] = ACTIONS(1936),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1936),
  },
  [501] = {
    [anon_sym_DASH] = ACTIONS(1940),
    [anon_sym_DOLLAR] = ACTIONS(1940),
    [anon_sym_POUND] = ACTIONS(1940),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_AT] = ACTIONS(1944),
    [anon_sym_QMARK] = ACTIONS(1944),
    [anon_sym_0] = ACTIONS(1942),
    [anon_sym__] = ACTIONS(1942),
  },
  [502] = {
    [sym_subscript] = STATE(970),
    [sym_variable_name] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1950),
    [anon_sym_DOLLAR] = ACTIONS(1950),
    [anon_sym_POUND] = ACTIONS(1948),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1952),
    [anon_sym_STAR] = ACTIONS(1954),
    [anon_sym_AT] = ACTIONS(1954),
    [anon_sym_QMARK] = ACTIONS(1954),
    [anon_sym_0] = ACTIONS(1952),
    [anon_sym__] = ACTIONS(1952),
  },
  [503] = {
    [sym_simple_expansion] = STATE(972),
    [sym_expansion] = STATE(972),
    [aux_sym_heredoc_body_repeat1] = STATE(972),
    [sym__heredoc_body_middle] = ACTIONS(1956),
    [sym__heredoc_body_end] = ACTIONS(1958),
    [anon_sym_DOLLAR] = ACTIONS(919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(921),
    [sym_comment] = ACTIONS(57),
  },
  [504] = {
    [sym_concatenation] = STATE(975),
    [sym_string] = STATE(974),
    [sym_simple_expansion] = STATE(974),
    [sym_string_expansion] = STATE(974),
    [sym_expansion] = STATE(974),
    [sym_command_substitution] = STATE(974),
    [sym_process_substitution] = STATE(974),
    [sym__special_characters] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1962),
  },
  [505] = {
    [sym_file_redirect] = STATE(180),
    [sym_heredoc_redirect] = STATE(180),
    [sym_herestring_redirect] = STATE(180),
    [aux_sym_redirected_statement_repeat1] = STATE(180),
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [ts_builtin_sym_end] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [506] = {
    [sym_file_redirect] = STATE(180),
    [sym_heredoc_redirect] = STATE(180),
    [sym_herestring_redirect] = STATE(180),
    [aux_sym_redirected_statement_repeat1] = STATE(180),
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [sym_variable_name] = ACTIONS(339),
    [ts_builtin_sym_end] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [507] = {
    [sym_file_redirect] = STATE(180),
    [sym_heredoc_redirect] = STATE(180),
    [sym_herestring_redirect] = STATE(180),
    [aux_sym_redirected_statement_repeat1] = STATE(180),
    [sym__simple_heredoc_body] = ACTIONS(1968),
    [sym__heredoc_body_beginning] = ACTIONS(1968),
    [sym_file_descriptor] = ACTIONS(1968),
    [ts_builtin_sym_end] = ACTIONS(1968),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_PIPE] = ACTIONS(309),
    [anon_sym_SEMI_SEMI] = ACTIONS(1968),
    [anon_sym_PIPE_AMP] = ACTIONS(313),
    [anon_sym_AMP_AMP] = ACTIONS(1968),
    [anon_sym_PIPE_PIPE] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(1970),
    [anon_sym_GT] = ACTIONS(1970),
    [anon_sym_GT_GT] = ACTIONS(1968),
    [anon_sym_AMP_GT] = ACTIONS(1970),
    [anon_sym_AMP_GT_GT] = ACTIONS(1968),
    [anon_sym_LT_AMP] = ACTIONS(1968),
    [anon_sym_GT_AMP] = ACTIONS(1968),
    [anon_sym_LT_LT] = ACTIONS(1970),
    [anon_sym_LT_LT_DASH] = ACTIONS(1968),
    [anon_sym_LT_LT_LT] = ACTIONS(1968),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1968),
    [anon_sym_AMP] = ACTIONS(1970),
  },
  [508] = {
    [sym_file_redirect] = STATE(180),
    [sym_heredoc_redirect] = STATE(180),
    [sym_herestring_redirect] = STATE(180),
    [aux_sym_redirected_statement_repeat1] = STATE(180),
    [sym__simple_heredoc_body] = ACTIONS(1968),
    [sym__heredoc_body_beginning] = ACTIONS(1968),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [ts_builtin_sym_end] = ACTIONS(1968),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_PIPE] = ACTIONS(309),
    [anon_sym_SEMI_SEMI] = ACTIONS(1968),
    [anon_sym_PIPE_AMP] = ACTIONS(313),
    [anon_sym_AMP_AMP] = ACTIONS(1968),
    [anon_sym_PIPE_PIPE] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(1970),
    [anon_sym_LT_LT_DASH] = ACTIONS(1968),
    [anon_sym_LT_LT_LT] = ACTIONS(1968),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1968),
    [anon_sym_AMP] = ACTIONS(1970),
  },
  [509] = {
    [aux_sym_concatenation_repeat1] = STATE(976),
    [sym__simple_heredoc_body] = ACTIONS(745),
    [sym__heredoc_body_beginning] = ACTIONS(745),
    [sym_file_descriptor] = ACTIONS(745),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(745),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_SEMI_SEMI] = ACTIONS(745),
    [anon_sym_PIPE_AMP] = ACTIONS(745),
    [anon_sym_AMP_AMP] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(745),
    [anon_sym_LT] = ACTIONS(749),
    [anon_sym_GT] = ACTIONS(749),
    [anon_sym_GT_GT] = ACTIONS(745),
    [anon_sym_AMP_GT] = ACTIONS(749),
    [anon_sym_AMP_GT_GT] = ACTIONS(745),
    [anon_sym_LT_AMP] = ACTIONS(745),
    [anon_sym_GT_AMP] = ACTIONS(745),
    [anon_sym_LT_LT] = ACTIONS(749),
    [anon_sym_LT_LT_DASH] = ACTIONS(745),
    [anon_sym_LT_LT_LT] = ACTIONS(745),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(749),
  },
  [510] = {
    [aux_sym_concatenation_repeat1] = STATE(976),
    [sym__simple_heredoc_body] = ACTIONS(763),
    [sym__heredoc_body_beginning] = ACTIONS(763),
    [sym_file_descriptor] = ACTIONS(763),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(763),
    [anon_sym_SEMI] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(765),
    [anon_sym_SEMI_SEMI] = ACTIONS(763),
    [anon_sym_PIPE_AMP] = ACTIONS(763),
    [anon_sym_AMP_AMP] = ACTIONS(763),
    [anon_sym_PIPE_PIPE] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(765),
    [anon_sym_GT_GT] = ACTIONS(763),
    [anon_sym_AMP_GT] = ACTIONS(765),
    [anon_sym_AMP_GT_GT] = ACTIONS(763),
    [anon_sym_LT_AMP] = ACTIONS(763),
    [anon_sym_GT_AMP] = ACTIONS(763),
    [anon_sym_LT_LT] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(763),
    [anon_sym_LT_LT_LT] = ACTIONS(763),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(763),
    [anon_sym_AMP] = ACTIONS(765),
  },
  [511] = {
    [sym__simple_heredoc_body] = ACTIONS(763),
    [sym__heredoc_body_beginning] = ACTIONS(763),
    [sym_file_descriptor] = ACTIONS(763),
    [ts_builtin_sym_end] = ACTIONS(763),
    [anon_sym_SEMI] = ACTIONS(765),
    [anon_sym_esac] = ACTIONS(763),
    [anon_sym_PIPE] = ACTIONS(765),
    [anon_sym_RPAREN] = ACTIONS(763),
    [anon_sym_SEMI_SEMI] = ACTIONS(763),
    [anon_sym_PIPE_AMP] = ACTIONS(763),
    [anon_sym_AMP_AMP] = ACTIONS(763),
    [anon_sym_PIPE_PIPE] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(765),
    [anon_sym_GT_GT] = ACTIONS(763),
    [anon_sym_AMP_GT] = ACTIONS(765),
    [anon_sym_AMP_GT_GT] = ACTIONS(763),
    [anon_sym_LT_AMP] = ACTIONS(763),
    [anon_sym_GT_AMP] = ACTIONS(763),
    [anon_sym_LT_LT] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(763),
    [anon_sym_LT_LT_LT] = ACTIONS(763),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(763),
    [anon_sym_AMP] = ACTIONS(765),
  },
  [512] = {
    [sym__simple_heredoc_body] = ACTIONS(1972),
    [sym__heredoc_body_beginning] = ACTIONS(1972),
    [sym_file_descriptor] = ACTIONS(1972),
    [ts_builtin_sym_end] = ACTIONS(1972),
    [anon_sym_SEMI] = ACTIONS(1974),
    [anon_sym_esac] = ACTIONS(1972),
    [anon_sym_PIPE] = ACTIONS(1974),
    [anon_sym_RPAREN] = ACTIONS(1972),
    [anon_sym_SEMI_SEMI] = ACTIONS(1972),
    [anon_sym_PIPE_AMP] = ACTIONS(1972),
    [anon_sym_AMP_AMP] = ACTIONS(1972),
    [anon_sym_PIPE_PIPE] = ACTIONS(1972),
    [anon_sym_LT] = ACTIONS(1974),
    [anon_sym_GT] = ACTIONS(1974),
    [anon_sym_GT_GT] = ACTIONS(1972),
    [anon_sym_AMP_GT] = ACTIONS(1974),
    [anon_sym_AMP_GT_GT] = ACTIONS(1972),
    [anon_sym_LT_AMP] = ACTIONS(1972),
    [anon_sym_GT_AMP] = ACTIONS(1972),
    [anon_sym_LT_LT] = ACTIONS(1974),
    [anon_sym_LT_LT_DASH] = ACTIONS(1972),
    [anon_sym_LT_LT_LT] = ACTIONS(1972),
    [anon_sym_BQUOTE] = ACTIONS(1972),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1972),
    [anon_sym_AMP] = ACTIONS(1974),
  },
  [513] = {
    [aux_sym_concatenation_repeat1] = STATE(976),
    [sym__simple_heredoc_body] = ACTIONS(1976),
    [sym__heredoc_body_beginning] = ACTIONS(1976),
    [sym_file_descriptor] = ACTIONS(1976),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(1976),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1978),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(1976),
    [anon_sym_AMP_AMP] = ACTIONS(1976),
    [anon_sym_PIPE_PIPE] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1976),
    [anon_sym_AMP_GT] = ACTIONS(1978),
    [anon_sym_AMP_GT_GT] = ACTIONS(1976),
    [anon_sym_LT_AMP] = ACTIONS(1976),
    [anon_sym_GT_AMP] = ACTIONS(1976),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_LT_LT_DASH] = ACTIONS(1976),
    [anon_sym_LT_LT_LT] = ACTIONS(1976),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1978),
  },
  [514] = {
    [aux_sym_concatenation_repeat1] = STATE(976),
    [sym__simple_heredoc_body] = ACTIONS(1980),
    [sym__heredoc_body_beginning] = ACTIONS(1980),
    [sym_file_descriptor] = ACTIONS(1980),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(1980),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_SEMI_SEMI] = ACTIONS(1980),
    [anon_sym_PIPE_AMP] = ACTIONS(1980),
    [anon_sym_AMP_AMP] = ACTIONS(1980),
    [anon_sym_PIPE_PIPE] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_AMP_GT] = ACTIONS(1982),
    [anon_sym_AMP_GT_GT] = ACTIONS(1980),
    [anon_sym_LT_AMP] = ACTIONS(1980),
    [anon_sym_GT_AMP] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1982),
    [anon_sym_LT_LT_DASH] = ACTIONS(1980),
    [anon_sym_LT_LT_LT] = ACTIONS(1980),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1982),
  },
  [515] = {
    [sym__simple_heredoc_body] = ACTIONS(1980),
    [sym__heredoc_body_beginning] = ACTIONS(1980),
    [sym_file_descriptor] = ACTIONS(1980),
    [ts_builtin_sym_end] = ACTIONS(1980),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_esac] = ACTIONS(1980),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_SEMI_SEMI] = ACTIONS(1980),
    [anon_sym_PIPE_AMP] = ACTIONS(1980),
    [anon_sym_AMP_AMP] = ACTIONS(1980),
    [anon_sym_PIPE_PIPE] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_AMP_GT] = ACTIONS(1982),
    [anon_sym_AMP_GT_GT] = ACTIONS(1980),
    [anon_sym_LT_AMP] = ACTIONS(1980),
    [anon_sym_GT_AMP] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1982),
    [anon_sym_LT_LT_DASH] = ACTIONS(1980),
    [anon_sym_LT_LT_LT] = ACTIONS(1980),
    [anon_sym_BQUOTE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1982),
  },
  [516] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [ts_builtin_sym_end] = ACTIONS(1986),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [517] = {
    [sym_file_redirect] = STATE(517),
    [sym_heredoc_redirect] = STATE(517),
    [sym_herestring_redirect] = STATE(517),
    [aux_sym_redirected_statement_repeat1] = STATE(517),
    [sym__simple_heredoc_body] = ACTIONS(1990),
    [sym__heredoc_body_beginning] = ACTIONS(1990),
    [sym_file_descriptor] = ACTIONS(1992),
    [ts_builtin_sym_end] = ACTIONS(1990),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_SEMI_SEMI] = ACTIONS(1990),
    [anon_sym_PIPE_AMP] = ACTIONS(1990),
    [anon_sym_AMP_AMP] = ACTIONS(1990),
    [anon_sym_PIPE_PIPE] = ACTIONS(1990),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(2000),
    [anon_sym_AMP_GT] = ACTIONS(1997),
    [anon_sym_AMP_GT_GT] = ACTIONS(2000),
    [anon_sym_LT_AMP] = ACTIONS(2000),
    [anon_sym_GT_AMP] = ACTIONS(2000),
    [anon_sym_LT_LT] = ACTIONS(2003),
    [anon_sym_LT_LT_DASH] = ACTIONS(2006),
    [anon_sym_LT_LT_LT] = ACTIONS(2009),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1995),
  },
  [518] = {
    [sym__simple_heredoc_body] = ACTIONS(2012),
    [sym__heredoc_body_beginning] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [ts_builtin_sym_end] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_RPAREN] = ACTIONS(2012),
    [anon_sym_SEMI_SEMI] = ACTIONS(2012),
    [anon_sym_PIPE_AMP] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_EQ_TILDE] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_GT] = ACTIONS(2012),
    [anon_sym_AMP_GT] = ACTIONS(2014),
    [anon_sym_AMP_GT_GT] = ACTIONS(2012),
    [anon_sym_LT_AMP] = ACTIONS(2012),
    [anon_sym_GT_AMP] = ACTIONS(2012),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_DASH] = ACTIONS(2012),
    [anon_sym_LT_LT_LT] = ACTIONS(2012),
    [sym__special_characters] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2012),
    [anon_sym_DOLLAR] = ACTIONS(2014),
    [sym_raw_string] = ACTIONS(2012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2012),
    [anon_sym_BQUOTE] = ACTIONS(2012),
    [anon_sym_LT_LPAREN] = ACTIONS(2012),
    [anon_sym_GT_LPAREN] = ACTIONS(2012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2014),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2014),
  },
  [519] = {
    [aux_sym_concatenation_repeat1] = STATE(140),
    [sym__simple_heredoc_body] = ACTIONS(2016),
    [sym__heredoc_body_beginning] = ACTIONS(2016),
    [sym_file_descriptor] = ACTIONS(2016),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(2016),
    [anon_sym_SEMI] = ACTIONS(2018),
    [anon_sym_PIPE] = ACTIONS(2018),
    [anon_sym_SEMI_SEMI] = ACTIONS(2016),
    [anon_sym_PIPE_AMP] = ACTIONS(2016),
    [anon_sym_AMP_AMP] = ACTIONS(2016),
    [anon_sym_PIPE_PIPE] = ACTIONS(2016),
    [anon_sym_EQ_TILDE] = ACTIONS(2018),
    [anon_sym_EQ_EQ] = ACTIONS(2018),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(2018),
    [anon_sym_GT_GT] = ACTIONS(2016),
    [anon_sym_AMP_GT] = ACTIONS(2018),
    [anon_sym_AMP_GT_GT] = ACTIONS(2016),
    [anon_sym_LT_AMP] = ACTIONS(2016),
    [anon_sym_GT_AMP] = ACTIONS(2016),
    [anon_sym_LT_LT] = ACTIONS(2018),
    [anon_sym_LT_LT_DASH] = ACTIONS(2016),
    [anon_sym_LT_LT_LT] = ACTIONS(2016),
    [sym__special_characters] = ACTIONS(2016),
    [anon_sym_DQUOTE] = ACTIONS(2016),
    [anon_sym_DOLLAR] = ACTIONS(2018),
    [sym_raw_string] = ACTIONS(2016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2016),
    [anon_sym_BQUOTE] = ACTIONS(2016),
    [anon_sym_LT_LPAREN] = ACTIONS(2016),
    [anon_sym_GT_LPAREN] = ACTIONS(2016),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2018),
    [anon_sym_LF] = ACTIONS(2016),
    [anon_sym_AMP] = ACTIONS(2018),
  },
  [520] = {
    [aux_sym_concatenation_repeat1] = STATE(140),
    [sym__simple_heredoc_body] = ACTIONS(2012),
    [sym__heredoc_body_beginning] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_SEMI_SEMI] = ACTIONS(2012),
    [anon_sym_PIPE_AMP] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_EQ_TILDE] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_GT] = ACTIONS(2012),
    [anon_sym_AMP_GT] = ACTIONS(2014),
    [anon_sym_AMP_GT_GT] = ACTIONS(2012),
    [anon_sym_LT_AMP] = ACTIONS(2012),
    [anon_sym_GT_AMP] = ACTIONS(2012),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_DASH] = ACTIONS(2012),
    [anon_sym_LT_LT_LT] = ACTIONS(2012),
    [sym__special_characters] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2012),
    [anon_sym_DOLLAR] = ACTIONS(2014),
    [sym_raw_string] = ACTIONS(2012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2012),
    [anon_sym_BQUOTE] = ACTIONS(2012),
    [anon_sym_LT_LPAREN] = ACTIONS(2012),
    [anon_sym_GT_LPAREN] = ACTIONS(2012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2014),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2014),
  },
  [521] = {
    [sym_concatenation] = STATE(521),
    [sym_string] = STATE(183),
    [sym_simple_expansion] = STATE(183),
    [sym_string_expansion] = STATE(183),
    [sym_expansion] = STATE(183),
    [sym_command_substitution] = STATE(183),
    [sym_process_substitution] = STATE(183),
    [aux_sym_command_repeat2] = STATE(521),
    [sym__simple_heredoc_body] = ACTIONS(2012),
    [sym__heredoc_body_beginning] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [ts_builtin_sym_end] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_SEMI_SEMI] = ACTIONS(2012),
    [anon_sym_PIPE_AMP] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_EQ_TILDE] = ACTIONS(2020),
    [anon_sym_EQ_EQ] = ACTIONS(2020),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_GT] = ACTIONS(2012),
    [anon_sym_AMP_GT] = ACTIONS(2014),
    [anon_sym_AMP_GT_GT] = ACTIONS(2012),
    [anon_sym_LT_AMP] = ACTIONS(2012),
    [anon_sym_GT_AMP] = ACTIONS(2012),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_DASH] = ACTIONS(2012),
    [anon_sym_LT_LT_LT] = ACTIONS(2012),
    [sym__special_characters] = ACTIONS(2023),
    [anon_sym_DQUOTE] = ACTIONS(2026),
    [anon_sym_DOLLAR] = ACTIONS(2029),
    [sym_raw_string] = ACTIONS(2032),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2035),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2038),
    [anon_sym_BQUOTE] = ACTIONS(2041),
    [anon_sym_LT_LPAREN] = ACTIONS(2044),
    [anon_sym_GT_LPAREN] = ACTIONS(2044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2047),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2014),
  },
  [522] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [ts_builtin_sym_end] = ACTIONS(1986),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [523] = {
    [ts_builtin_sym_end] = ACTIONS(1986),
    [anon_sym_SEMI] = ACTIONS(2050),
    [anon_sym_SEMI_SEMI] = ACTIONS(2052),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2052),
    [anon_sym_AMP] = ACTIONS(2052),
  },
  [524] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(979),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(2056),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(507),
    [anon_sym_GT_GT] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(507),
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2056),
    [anon_sym_AMP] = ACTIONS(2054),
  },
  [525] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(979),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(2056),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2056),
    [anon_sym_AMP] = ACTIONS(2054),
  },
  [526] = {
    [sym_concatenation] = STATE(521),
    [sym_string] = STATE(183),
    [sym_simple_expansion] = STATE(183),
    [sym_string_expansion] = STATE(183),
    [sym_expansion] = STATE(183),
    [sym_command_substitution] = STATE(183),
    [sym_process_substitution] = STATE(183),
    [aux_sym_command_repeat2] = STATE(521),
    [sym__simple_heredoc_body] = ACTIONS(2058),
    [sym__heredoc_body_beginning] = ACTIONS(2058),
    [sym_file_descriptor] = ACTIONS(2058),
    [ts_builtin_sym_end] = ACTIONS(2058),
    [anon_sym_SEMI] = ACTIONS(2060),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_SEMI_SEMI] = ACTIONS(2058),
    [anon_sym_PIPE_AMP] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_PIPE_PIPE] = ACTIONS(2058),
    [anon_sym_EQ_TILDE] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2058),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2058),
    [anon_sym_LT_AMP] = ACTIONS(2058),
    [anon_sym_GT_AMP] = ACTIONS(2058),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2058),
    [anon_sym_LT_LT_LT] = ACTIONS(2058),
    [sym__special_characters] = ACTIONS(333),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(337),
    [anon_sym_LF] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2060),
  },
  [527] = {
    [sym_string] = STATE(756),
    [sym_simple_expansion] = STATE(756),
    [sym_string_expansion] = STATE(756),
    [sym_expansion] = STATE(756),
    [sym_command_substitution] = STATE(756),
    [sym_process_substitution] = STATE(756),
    [anon_sym_RBRACK] = ACTIONS(2062),
    [sym__special_characters] = ACTIONS(2064),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [sym_raw_string] = ACTIONS(1453),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1453),
  },
  [528] = {
    [sym__concat] = ACTIONS(2066),
    [anon_sym_EQ] = ACTIONS(2068),
    [anon_sym_PLUS_EQ] = ACTIONS(2068),
    [sym_comment] = ACTIONS(57),
  },
  [529] = {
    [aux_sym_concatenation_repeat1] = STATE(982),
    [sym__concat] = ACTIONS(629),
    [anon_sym_RBRACK] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
  },
  [530] = {
    [sym_string] = STATE(756),
    [sym_simple_expansion] = STATE(756),
    [sym_string_expansion] = STATE(756),
    [sym_expansion] = STATE(756),
    [sym_command_substitution] = STATE(756),
    [sym_process_substitution] = STATE(756),
    [anon_sym_RBRACK] = ACTIONS(2070),
    [sym__special_characters] = ACTIONS(2064),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [sym_raw_string] = ACTIONS(1453),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1453),
  },
  [531] = {
    [sym__concat] = ACTIONS(2072),
    [anon_sym_EQ] = ACTIONS(2074),
    [anon_sym_PLUS_EQ] = ACTIONS(2074),
    [sym_comment] = ACTIONS(57),
  },
  [532] = {
    [anon_sym_RBRACK] = ACTIONS(2070),
    [sym_comment] = ACTIONS(57),
  },
  [533] = {
    [sym__simple_heredoc_body] = ACTIONS(2076),
    [sym__heredoc_body_beginning] = ACTIONS(2076),
    [sym_file_descriptor] = ACTIONS(2076),
    [sym_variable_name] = ACTIONS(2076),
    [ts_builtin_sym_end] = ACTIONS(2076),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_RPAREN] = ACTIONS(2076),
    [anon_sym_SEMI_SEMI] = ACTIONS(2076),
    [anon_sym_PIPE_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2076),
    [anon_sym_PIPE_PIPE] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_GT] = ACTIONS(2078),
    [anon_sym_GT_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT_GT] = ACTIONS(2076),
    [anon_sym_LT_AMP] = ACTIONS(2076),
    [anon_sym_GT_AMP] = ACTIONS(2076),
    [anon_sym_LT_LT] = ACTIONS(2078),
    [anon_sym_LT_LT_DASH] = ACTIONS(2076),
    [anon_sym_LT_LT_LT] = ACTIONS(2076),
    [sym__special_characters] = ACTIONS(2076),
    [anon_sym_DQUOTE] = ACTIONS(2076),
    [anon_sym_DOLLAR] = ACTIONS(2078),
    [sym_raw_string] = ACTIONS(2076),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2076),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2076),
    [anon_sym_BQUOTE] = ACTIONS(2076),
    [anon_sym_LT_LPAREN] = ACTIONS(2076),
    [anon_sym_GT_LPAREN] = ACTIONS(2076),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2078),
    [anon_sym_LF] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [534] = {
    [aux_sym_concatenation_repeat1] = STATE(986),
    [sym__concat] = ACTIONS(2080),
    [anon_sym_RPAREN] = ACTIONS(2082),
    [sym__special_characters] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_DOLLAR] = ACTIONS(2084),
    [sym_raw_string] = ACTIONS(2082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2082),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [anon_sym_LT_LPAREN] = ACTIONS(2082),
    [anon_sym_GT_LPAREN] = ACTIONS(2082),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2082),
  },
  [535] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(989),
    [anon_sym_DQUOTE] = ACTIONS(2086),
    [anon_sym_DOLLAR] = ACTIONS(2088),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [536] = {
    [sym_string] = STATE(991),
    [anon_sym_DASH] = ACTIONS(2090),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(2090),
    [sym_raw_string] = ACTIONS(2092),
    [anon_sym_POUND] = ACTIONS(2090),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(2096),
    [anon_sym_AT] = ACTIONS(2096),
    [anon_sym_QMARK] = ACTIONS(2096),
    [anon_sym_0] = ACTIONS(2094),
    [anon_sym__] = ACTIONS(2094),
  },
  [537] = {
    [aux_sym_concatenation_repeat1] = STATE(986),
    [sym__concat] = ACTIONS(2080),
    [anon_sym_RPAREN] = ACTIONS(2098),
    [sym__special_characters] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_DOLLAR] = ACTIONS(2100),
    [sym_raw_string] = ACTIONS(2098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2098),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [anon_sym_LT_LPAREN] = ACTIONS(2098),
    [anon_sym_GT_LPAREN] = ACTIONS(2098),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2098),
  },
  [538] = {
    [sym_subscript] = STATE(996),
    [sym_variable_name] = ACTIONS(2102),
    [anon_sym_BANG] = ACTIONS(2104),
    [anon_sym_DASH] = ACTIONS(2106),
    [anon_sym_DOLLAR] = ACTIONS(2106),
    [anon_sym_POUND] = ACTIONS(2104),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2108),
    [anon_sym_STAR] = ACTIONS(2110),
    [anon_sym_AT] = ACTIONS(2110),
    [anon_sym_QMARK] = ACTIONS(2110),
    [anon_sym_0] = ACTIONS(2108),
    [anon_sym__] = ACTIONS(2108),
  },
  [539] = {
    [sym__terminated_statement] = STATE(999),
    [sym_redirected_statement] = STATE(997),
    [sym_for_statement] = STATE(997),
    [sym_c_style_for_statement] = STATE(997),
    [sym_while_statement] = STATE(997),
    [sym_if_statement] = STATE(997),
    [sym_case_statement] = STATE(997),
    [sym_function_definition] = STATE(997),
    [sym_compound_statement] = STATE(997),
    [sym_subshell] = STATE(997),
    [sym_pipeline] = STATE(997),
    [sym_list] = STATE(997),
    [sym_negated_command] = STATE(997),
    [sym_test_command] = STATE(997),
    [sym_declaration_command] = STATE(997),
    [sym_unset_command] = STATE(997),
    [sym_command] = STATE(997),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(998),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(999),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [540] = {
    [sym__terminated_statement] = STATE(1002),
    [sym_redirected_statement] = STATE(1000),
    [sym_for_statement] = STATE(1000),
    [sym_c_style_for_statement] = STATE(1000),
    [sym_while_statement] = STATE(1000),
    [sym_if_statement] = STATE(1000),
    [sym_case_statement] = STATE(1000),
    [sym_function_definition] = STATE(1000),
    [sym_compound_statement] = STATE(1000),
    [sym_subshell] = STATE(1000),
    [sym_pipeline] = STATE(1000),
    [sym_list] = STATE(1000),
    [sym_negated_command] = STATE(1000),
    [sym_test_command] = STATE(1000),
    [sym_declaration_command] = STATE(1000),
    [sym_unset_command] = STATE(1000),
    [sym_command] = STATE(1000),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(1001),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(1002),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [541] = {
    [sym__terminated_statement] = STATE(1005),
    [sym_redirected_statement] = STATE(1003),
    [sym_for_statement] = STATE(1003),
    [sym_c_style_for_statement] = STATE(1003),
    [sym_while_statement] = STATE(1003),
    [sym_if_statement] = STATE(1003),
    [sym_case_statement] = STATE(1003),
    [sym_function_definition] = STATE(1003),
    [sym_compound_statement] = STATE(1003),
    [sym_subshell] = STATE(1003),
    [sym_pipeline] = STATE(1003),
    [sym_list] = STATE(1003),
    [sym_negated_command] = STATE(1003),
    [sym_test_command] = STATE(1003),
    [sym_declaration_command] = STATE(1003),
    [sym_unset_command] = STATE(1003),
    [sym_command] = STATE(1003),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(1004),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(1005),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [542] = {
    [sym_concatenation] = STATE(1007),
    [sym_string] = STATE(537),
    [sym_simple_expansion] = STATE(537),
    [sym_string_expansion] = STATE(537),
    [sym_expansion] = STATE(537),
    [sym_command_substitution] = STATE(537),
    [sym_process_substitution] = STATE(537),
    [aux_sym_for_statement_repeat1] = STATE(1007),
    [anon_sym_RPAREN] = ACTIONS(2112),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1095),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
  },
  [543] = {
    [sym_string] = STATE(1008),
    [sym_simple_expansion] = STATE(1008),
    [sym_string_expansion] = STATE(1008),
    [sym_expansion] = STATE(1008),
    [sym_command_substitution] = STATE(1008),
    [sym_process_substitution] = STATE(1008),
    [sym__special_characters] = ACTIONS(2114),
    [anon_sym_DQUOTE] = ACTIONS(359),
    [anon_sym_DOLLAR] = ACTIONS(361),
    [sym_raw_string] = ACTIONS(2114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(365),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2114),
  },
  [544] = {
    [aux_sym_concatenation_repeat1] = STATE(1009),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(1109),
    [sym_variable_name] = ACTIONS(779),
    [ts_builtin_sym_end] = ACTIONS(779),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(781),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [545] = {
    [sym__simple_heredoc_body] = ACTIONS(783),
    [sym__heredoc_body_beginning] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(783),
    [sym__concat] = ACTIONS(783),
    [sym_variable_name] = ACTIONS(783),
    [ts_builtin_sym_end] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_RPAREN] = ACTIONS(783),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [anon_sym_PIPE_AMP] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(783),
    [anon_sym_AMP_GT] = ACTIONS(785),
    [anon_sym_AMP_GT_GT] = ACTIONS(783),
    [anon_sym_LT_AMP] = ACTIONS(783),
    [anon_sym_GT_AMP] = ACTIONS(783),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_DASH] = ACTIONS(783),
    [anon_sym_LT_LT_LT] = ACTIONS(783),
    [sym__special_characters] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(783),
    [anon_sym_DOLLAR] = ACTIONS(785),
    [sym_raw_string] = ACTIONS(783),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(783),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(783),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [anon_sym_LT_LPAREN] = ACTIONS(783),
    [anon_sym_GT_LPAREN] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(785),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
  },
  [546] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(2116),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [547] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(2116),
    [anon_sym_DOLLAR] = ACTIONS(2118),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [548] = {
    [sym__simple_heredoc_body] = ACTIONS(817),
    [sym__heredoc_body_beginning] = ACTIONS(817),
    [sym_file_descriptor] = ACTIONS(817),
    [sym__concat] = ACTIONS(817),
    [sym_variable_name] = ACTIONS(817),
    [ts_builtin_sym_end] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_SEMI_SEMI] = ACTIONS(817),
    [anon_sym_PIPE_AMP] = ACTIONS(817),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(817),
    [anon_sym_AMP_GT] = ACTIONS(819),
    [anon_sym_AMP_GT_GT] = ACTIONS(817),
    [anon_sym_LT_AMP] = ACTIONS(817),
    [anon_sym_GT_AMP] = ACTIONS(817),
    [anon_sym_LT_LT] = ACTIONS(819),
    [anon_sym_LT_LT_DASH] = ACTIONS(817),
    [anon_sym_LT_LT_LT] = ACTIONS(817),
    [sym__special_characters] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR] = ACTIONS(819),
    [sym_raw_string] = ACTIONS(817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(817),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(817),
    [anon_sym_GT_LPAREN] = ACTIONS(817),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(819),
    [anon_sym_LF] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(819),
  },
  [549] = {
    [sym__simple_heredoc_body] = ACTIONS(821),
    [sym__heredoc_body_beginning] = ACTIONS(821),
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [sym_variable_name] = ACTIONS(821),
    [ts_builtin_sym_end] = ACTIONS(821),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(821),
    [anon_sym_SEMI_SEMI] = ACTIONS(821),
    [anon_sym_PIPE_AMP] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(823),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(823),
    [anon_sym_LT_LT_DASH] = ACTIONS(821),
    [anon_sym_LT_LT_LT] = ACTIONS(821),
    [sym__special_characters] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [anon_sym_DOLLAR] = ACTIONS(823),
    [sym_raw_string] = ACTIONS(821),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(821),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(821),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(821),
    [anon_sym_GT_LPAREN] = ACTIONS(821),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(823),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [550] = {
    [sym__simple_heredoc_body] = ACTIONS(825),
    [sym__heredoc_body_beginning] = ACTIONS(825),
    [sym_file_descriptor] = ACTIONS(825),
    [sym__concat] = ACTIONS(825),
    [sym_variable_name] = ACTIONS(825),
    [ts_builtin_sym_end] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(827),
    [anon_sym_PIPE] = ACTIONS(827),
    [anon_sym_RPAREN] = ACTIONS(825),
    [anon_sym_SEMI_SEMI] = ACTIONS(825),
    [anon_sym_PIPE_AMP] = ACTIONS(825),
    [anon_sym_AMP_AMP] = ACTIONS(825),
    [anon_sym_PIPE_PIPE] = ACTIONS(825),
    [anon_sym_LT] = ACTIONS(827),
    [anon_sym_GT] = ACTIONS(827),
    [anon_sym_GT_GT] = ACTIONS(825),
    [anon_sym_AMP_GT] = ACTIONS(827),
    [anon_sym_AMP_GT_GT] = ACTIONS(825),
    [anon_sym_LT_AMP] = ACTIONS(825),
    [anon_sym_GT_AMP] = ACTIONS(825),
    [anon_sym_LT_LT] = ACTIONS(827),
    [anon_sym_LT_LT_DASH] = ACTIONS(825),
    [anon_sym_LT_LT_LT] = ACTIONS(825),
    [sym__special_characters] = ACTIONS(825),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [sym_raw_string] = ACTIONS(825),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(825),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(825),
    [anon_sym_BQUOTE] = ACTIONS(825),
    [anon_sym_LT_LPAREN] = ACTIONS(825),
    [anon_sym_GT_LPAREN] = ACTIONS(825),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(827),
    [anon_sym_LF] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(827),
  },
  [551] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(2120),
    [sym_comment] = ACTIONS(57),
  },
  [552] = {
    [sym_subscript] = STATE(1015),
    [sym_variable_name] = ACTIONS(2122),
    [anon_sym_DASH] = ACTIONS(2124),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_AT] = ACTIONS(2128),
    [anon_sym_QMARK] = ACTIONS(2128),
    [anon_sym_0] = ACTIONS(2126),
    [anon_sym__] = ACTIONS(2126),
  },
  [553] = {
    [sym_concatenation] = STATE(1018),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1018),
    [anon_sym_RBRACE] = ACTIONS(2130),
    [anon_sym_EQ] = ACTIONS(2132),
    [anon_sym_DASH] = ACTIONS(2132),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2134),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2136),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_COLON_QMARK] = ACTIONS(2132),
    [anon_sym_COLON_DASH] = ACTIONS(2132),
    [anon_sym_PERCENT] = ACTIONS(2132),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [554] = {
    [sym_concatenation] = STATE(1021),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1021),
    [anon_sym_RBRACE] = ACTIONS(2138),
    [anon_sym_EQ] = ACTIONS(2140),
    [anon_sym_DASH] = ACTIONS(2140),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2140),
    [anon_sym_COLON_QMARK] = ACTIONS(2140),
    [anon_sym_COLON_DASH] = ACTIONS(2140),
    [anon_sym_PERCENT] = ACTIONS(2140),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [555] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1024),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(2146),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2148),
    [anon_sym_SEMI_SEMI] = ACTIONS(2150),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2150),
    [anon_sym_AMP] = ACTIONS(2146),
  },
  [556] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1024),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2146),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2148),
    [anon_sym_SEMI_SEMI] = ACTIONS(2150),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2150),
    [anon_sym_AMP] = ACTIONS(2146),
  },
  [557] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1025),
    [sym_for_statement] = STATE(1025),
    [sym_c_style_for_statement] = STATE(1025),
    [sym_while_statement] = STATE(1025),
    [sym_if_statement] = STATE(1025),
    [sym_case_statement] = STATE(1025),
    [sym_function_definition] = STATE(1025),
    [sym_compound_statement] = STATE(1025),
    [sym_subshell] = STATE(1025),
    [sym_pipeline] = STATE(1025),
    [sym_list] = STATE(1025),
    [sym_negated_command] = STATE(1025),
    [sym_test_command] = STATE(1025),
    [sym_declaration_command] = STATE(1025),
    [sym_unset_command] = STATE(1025),
    [sym_command] = STATE(1025),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(1026),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [558] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1028),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(2152),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2154),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(2148),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2154),
    [anon_sym_AMP] = ACTIONS(2152),
  },
  [559] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1028),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2152),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2154),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(2148),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2154),
    [anon_sym_AMP] = ACTIONS(2152),
  },
  [560] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1029),
    [sym_for_statement] = STATE(1029),
    [sym_c_style_for_statement] = STATE(1029),
    [sym_while_statement] = STATE(1029),
    [sym_if_statement] = STATE(1029),
    [sym_case_statement] = STATE(1029),
    [sym_function_definition] = STATE(1029),
    [sym_compound_statement] = STATE(1029),
    [sym_subshell] = STATE(1029),
    [sym_pipeline] = STATE(1029),
    [sym_list] = STATE(1029),
    [sym_negated_command] = STATE(1029),
    [sym_test_command] = STATE(1029),
    [sym_declaration_command] = STATE(1029),
    [sym_unset_command] = STATE(1029),
    [sym_command] = STATE(1029),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(1030),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [561] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1033),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(2156),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2158),
    [anon_sym_SEMI_SEMI] = ACTIONS(2160),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2156),
  },
  [562] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1033),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2156),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2158),
    [anon_sym_SEMI_SEMI] = ACTIONS(2160),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2156),
  },
  [563] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1034),
    [sym_for_statement] = STATE(1034),
    [sym_c_style_for_statement] = STATE(1034),
    [sym_while_statement] = STATE(1034),
    [sym_if_statement] = STATE(1034),
    [sym_case_statement] = STATE(1034),
    [sym_function_definition] = STATE(1034),
    [sym_compound_statement] = STATE(1034),
    [sym_subshell] = STATE(1034),
    [sym_pipeline] = STATE(1034),
    [sym_list] = STATE(1034),
    [sym_negated_command] = STATE(1034),
    [sym_test_command] = STATE(1034),
    [sym_declaration_command] = STATE(1034),
    [sym_unset_command] = STATE(1034),
    [sym_command] = STATE(1034),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(1035),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [564] = {
    [sym__expression] = STATE(1037),
    [sym_binary_expression] = STATE(1037),
    [sym_unary_expression] = STATE(1037),
    [sym_postfix_expression] = STATE(1037),
    [sym_parenthesized_expression] = STATE(1037),
    [sym_concatenation] = STATE(1037),
    [sym_string] = STATE(45),
    [sym_simple_expansion] = STATE(45),
    [sym_string_expansion] = STATE(45),
    [sym_expansion] = STATE(45),
    [sym_command_substitution] = STATE(45),
    [sym_process_substitution] = STATE(45),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [565] = {
    [anon_sym_SEMI] = ACTIONS(2164),
    [anon_sym_SEMI_SEMI] = ACTIONS(2166),
    [anon_sym_AMP_AMP] = ACTIONS(1167),
    [anon_sym_PIPE_PIPE] = ACTIONS(1167),
    [anon_sym_EQ_TILDE] = ACTIONS(1169),
    [anon_sym_EQ_EQ] = ACTIONS(1169),
    [anon_sym_EQ] = ACTIONS(1171),
    [anon_sym_PLUS_EQ] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(1171),
    [anon_sym_BANG_EQ] = ACTIONS(1167),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1171),
    [anon_sym_DASH_EQ] = ACTIONS(1167),
    [anon_sym_LT_EQ] = ACTIONS(1167),
    [anon_sym_GT_EQ] = ACTIONS(1167),
    [anon_sym_PLUS_PLUS] = ACTIONS(1173),
    [anon_sym_DASH_DASH] = ACTIONS(1173),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1167),
    [anon_sym_LF] = ACTIONS(2166),
    [anon_sym_AMP] = ACTIONS(2164),
  },
  [566] = {
    [anon_sym_RPAREN] = ACTIONS(2168),
    [anon_sym_AMP_AMP] = ACTIONS(1217),
    [anon_sym_PIPE_PIPE] = ACTIONS(1217),
    [anon_sym_EQ_TILDE] = ACTIONS(1219),
    [anon_sym_EQ_EQ] = ACTIONS(1219),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_PLUS_EQ] = ACTIONS(1217),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_BANG_EQ] = ACTIONS(1217),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_DASH_EQ] = ACTIONS(1217),
    [anon_sym_LT_EQ] = ACTIONS(1217),
    [anon_sym_GT_EQ] = ACTIONS(1217),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1217),
  },
  [567] = {
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_SEMI_SEMI] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(1167),
    [anon_sym_PIPE_PIPE] = ACTIONS(1167),
    [anon_sym_EQ_TILDE] = ACTIONS(1169),
    [anon_sym_EQ_EQ] = ACTIONS(1169),
    [anon_sym_EQ] = ACTIONS(1171),
    [anon_sym_PLUS_EQ] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(1171),
    [anon_sym_BANG_EQ] = ACTIONS(1167),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1171),
    [anon_sym_DASH_EQ] = ACTIONS(1167),
    [anon_sym_LT_EQ] = ACTIONS(1167),
    [anon_sym_GT_EQ] = ACTIONS(1167),
    [anon_sym_PLUS_PLUS] = ACTIONS(1173),
    [anon_sym_DASH_DASH] = ACTIONS(1173),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1167),
    [anon_sym_LF] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(2170),
  },
  [568] = {
    [sym_string] = STATE(1040),
    [sym_simple_expansion] = STATE(1040),
    [sym_string_expansion] = STATE(1040),
    [sym_expansion] = STATE(1040),
    [sym_command_substitution] = STATE(1040),
    [sym_process_substitution] = STATE(1040),
    [sym__special_characters] = ACTIONS(2172),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(2172),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(391),
    [anon_sym_BQUOTE] = ACTIONS(393),
    [anon_sym_LT_LPAREN] = ACTIONS(395),
    [anon_sym_GT_LPAREN] = ACTIONS(395),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2172),
  },
  [569] = {
    [aux_sym_concatenation_repeat1] = STATE(1041),
    [sym__concat] = ACTIONS(1139),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_EQ_TILDE] = ACTIONS(779),
    [anon_sym_EQ_EQ] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(781),
    [anon_sym_PLUS_EQ] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_BANG_EQ] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_DASH_EQ] = ACTIONS(779),
    [anon_sym_LT_EQ] = ACTIONS(779),
    [anon_sym_GT_EQ] = ACTIONS(779),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(779),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [570] = {
    [sym__concat] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_EQ_TILDE] = ACTIONS(783),
    [anon_sym_EQ_EQ] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_PLUS_EQ] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_BANG_EQ] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_DASH_EQ] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(783),
    [anon_sym_GT_EQ] = ACTIONS(783),
    [anon_sym_PLUS_PLUS] = ACTIONS(783),
    [anon_sym_DASH_DASH] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(783),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
  },
  [571] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(2174),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [572] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(2174),
    [anon_sym_DOLLAR] = ACTIONS(2176),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [573] = {
    [sym__concat] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(819),
    [anon_sym_SEMI_SEMI] = ACTIONS(817),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_EQ_TILDE] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(817),
    [anon_sym_EQ] = ACTIONS(819),
    [anon_sym_PLUS_EQ] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_BANG_EQ] = ACTIONS(817),
    [anon_sym_PLUS] = ACTIONS(819),
    [anon_sym_DASH] = ACTIONS(819),
    [anon_sym_DASH_EQ] = ACTIONS(817),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(817),
    [anon_sym_DASH_DASH] = ACTIONS(817),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(817),
    [anon_sym_LF] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(819),
  },
  [574] = {
    [sym__concat] = ACTIONS(821),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_SEMI_SEMI] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_EQ_TILDE] = ACTIONS(821),
    [anon_sym_EQ_EQ] = ACTIONS(821),
    [anon_sym_EQ] = ACTIONS(823),
    [anon_sym_PLUS_EQ] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_BANG_EQ] = ACTIONS(821),
    [anon_sym_PLUS] = ACTIONS(823),
    [anon_sym_DASH] = ACTIONS(823),
    [anon_sym_DASH_EQ] = ACTIONS(821),
    [anon_sym_LT_EQ] = ACTIONS(821),
    [anon_sym_GT_EQ] = ACTIONS(821),
    [anon_sym_PLUS_PLUS] = ACTIONS(821),
    [anon_sym_DASH_DASH] = ACTIONS(821),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(821),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [575] = {
    [sym__concat] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(827),
    [anon_sym_SEMI_SEMI] = ACTIONS(825),
    [anon_sym_AMP_AMP] = ACTIONS(825),
    [anon_sym_PIPE_PIPE] = ACTIONS(825),
    [anon_sym_EQ_TILDE] = ACTIONS(825),
    [anon_sym_EQ_EQ] = ACTIONS(825),
    [anon_sym_EQ] = ACTIONS(827),
    [anon_sym_PLUS_EQ] = ACTIONS(825),
    [anon_sym_LT] = ACTIONS(827),
    [anon_sym_GT] = ACTIONS(827),
    [anon_sym_BANG_EQ] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_DASH_EQ] = ACTIONS(825),
    [anon_sym_LT_EQ] = ACTIONS(825),
    [anon_sym_GT_EQ] = ACTIONS(825),
    [anon_sym_PLUS_PLUS] = ACTIONS(825),
    [anon_sym_DASH_DASH] = ACTIONS(825),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(825),
    [anon_sym_LF] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(827),
  },
  [576] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(2178),
    [sym_comment] = ACTIONS(57),
  },
  [577] = {
    [sym_subscript] = STATE(1047),
    [sym_variable_name] = ACTIONS(2180),
    [anon_sym_DASH] = ACTIONS(2182),
    [anon_sym_DOLLAR] = ACTIONS(2182),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2184),
    [anon_sym_STAR] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_0] = ACTIONS(2184),
    [anon_sym__] = ACTIONS(2184),
  },
  [578] = {
    [sym_concatenation] = STATE(1050),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1050),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_EQ] = ACTIONS(2190),
    [anon_sym_DASH] = ACTIONS(2190),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2192),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2194),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_COLON_QMARK] = ACTIONS(2190),
    [anon_sym_COLON_DASH] = ACTIONS(2190),
    [anon_sym_PERCENT] = ACTIONS(2190),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [579] = {
    [sym_concatenation] = STATE(1053),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1053),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_EQ] = ACTIONS(2198),
    [anon_sym_DASH] = ACTIONS(2198),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2202),
    [anon_sym_COLON] = ACTIONS(2198),
    [anon_sym_COLON_QMARK] = ACTIONS(2198),
    [anon_sym_COLON_DASH] = ACTIONS(2198),
    [anon_sym_PERCENT] = ACTIONS(2198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [580] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1056),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2206),
    [anon_sym_SEMI_SEMI] = ACTIONS(2208),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2204),
  },
  [581] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1056),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2206),
    [anon_sym_SEMI_SEMI] = ACTIONS(2208),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2204),
  },
  [582] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1057),
    [sym_for_statement] = STATE(1057),
    [sym_c_style_for_statement] = STATE(1057),
    [sym_while_statement] = STATE(1057),
    [sym_if_statement] = STATE(1057),
    [sym_case_statement] = STATE(1057),
    [sym_function_definition] = STATE(1057),
    [sym_compound_statement] = STATE(1057),
    [sym_subshell] = STATE(1057),
    [sym_pipeline] = STATE(1057),
    [sym_list] = STATE(1057),
    [sym_negated_command] = STATE(1057),
    [sym_test_command] = STATE(1057),
    [sym_declaration_command] = STATE(1057),
    [sym_unset_command] = STATE(1057),
    [sym_command] = STATE(1057),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(1058),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [583] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1060),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(2210),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2212),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(2206),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2212),
    [anon_sym_AMP] = ACTIONS(2210),
  },
  [584] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1060),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2210),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2212),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(2206),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2212),
    [anon_sym_AMP] = ACTIONS(2210),
  },
  [585] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1061),
    [sym_for_statement] = STATE(1061),
    [sym_c_style_for_statement] = STATE(1061),
    [sym_while_statement] = STATE(1061),
    [sym_if_statement] = STATE(1061),
    [sym_case_statement] = STATE(1061),
    [sym_function_definition] = STATE(1061),
    [sym_compound_statement] = STATE(1061),
    [sym_subshell] = STATE(1061),
    [sym_pipeline] = STATE(1061),
    [sym_list] = STATE(1061),
    [sym_negated_command] = STATE(1061),
    [sym_test_command] = STATE(1061),
    [sym_declaration_command] = STATE(1061),
    [sym_unset_command] = STATE(1061),
    [sym_command] = STATE(1061),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(1062),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [586] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1065),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2216),
    [anon_sym_SEMI_SEMI] = ACTIONS(2218),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2218),
    [anon_sym_AMP] = ACTIONS(2214),
  },
  [587] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1065),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2216),
    [anon_sym_SEMI_SEMI] = ACTIONS(2218),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2218),
    [anon_sym_AMP] = ACTIONS(2214),
  },
  [588] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1066),
    [sym_for_statement] = STATE(1066),
    [sym_c_style_for_statement] = STATE(1066),
    [sym_while_statement] = STATE(1066),
    [sym_if_statement] = STATE(1066),
    [sym_case_statement] = STATE(1066),
    [sym_function_definition] = STATE(1066),
    [sym_compound_statement] = STATE(1066),
    [sym_subshell] = STATE(1066),
    [sym_pipeline] = STATE(1066),
    [sym_list] = STATE(1066),
    [sym_negated_command] = STATE(1066),
    [sym_test_command] = STATE(1066),
    [sym_declaration_command] = STATE(1066),
    [sym_unset_command] = STATE(1066),
    [sym_command] = STATE(1066),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(1067),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [589] = {
    [sym__expression] = STATE(1068),
    [sym_binary_expression] = STATE(1068),
    [sym_unary_expression] = STATE(1068),
    [sym_postfix_expression] = STATE(1068),
    [sym_parenthesized_expression] = STATE(1068),
    [sym_concatenation] = STATE(1068),
    [sym_string] = STATE(212),
    [sym_simple_expansion] = STATE(212),
    [sym_string_expansion] = STATE(212),
    [sym_expansion] = STATE(212),
    [sym_command_substitution] = STATE(212),
    [sym_process_substitution] = STATE(212),
    [anon_sym_SEMI] = ACTIONS(2164),
    [anon_sym_SEMI_SEMI] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_BANG] = ACTIONS(379),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(391),
    [anon_sym_BQUOTE] = ACTIONS(393),
    [anon_sym_LT_LPAREN] = ACTIONS(395),
    [anon_sym_GT_LPAREN] = ACTIONS(395),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(397),
    [sym_test_operator] = ACTIONS(399),
    [anon_sym_LF] = ACTIONS(2166),
    [anon_sym_AMP] = ACTIONS(2166),
  },
  [590] = {
    [sym__expression] = STATE(1069),
    [sym_binary_expression] = STATE(1069),
    [sym_unary_expression] = STATE(1069),
    [sym_postfix_expression] = STATE(1069),
    [sym_parenthesized_expression] = STATE(1069),
    [sym_concatenation] = STATE(1069),
    [sym_string] = STATE(212),
    [sym_simple_expansion] = STATE(212),
    [sym_string_expansion] = STATE(212),
    [sym_expansion] = STATE(212),
    [sym_command_substitution] = STATE(212),
    [sym_process_substitution] = STATE(212),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_BANG] = ACTIONS(379),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(391),
    [anon_sym_BQUOTE] = ACTIONS(393),
    [anon_sym_LT_LPAREN] = ACTIONS(395),
    [anon_sym_GT_LPAREN] = ACTIONS(395),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(397),
    [sym_test_operator] = ACTIONS(399),
  },
  [591] = {
    [sym__expression] = STATE(1069),
    [sym_binary_expression] = STATE(1069),
    [sym_unary_expression] = STATE(1069),
    [sym_postfix_expression] = STATE(1069),
    [sym_parenthesized_expression] = STATE(1069),
    [sym_concatenation] = STATE(1069),
    [sym_string] = STATE(212),
    [sym_simple_expansion] = STATE(212),
    [sym_string_expansion] = STATE(212),
    [sym_expansion] = STATE(212),
    [sym_command_substitution] = STATE(212),
    [sym_process_substitution] = STATE(212),
    [sym_regex] = ACTIONS(2220),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_BANG] = ACTIONS(379),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(391),
    [anon_sym_BQUOTE] = ACTIONS(393),
    [anon_sym_LT_LPAREN] = ACTIONS(395),
    [anon_sym_GT_LPAREN] = ACTIONS(395),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(397),
    [sym_test_operator] = ACTIONS(399),
  },
  [592] = {
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_SEMI_SEMI] = ACTIONS(1281),
    [anon_sym_AMP_AMP] = ACTIONS(1281),
    [anon_sym_PIPE_PIPE] = ACTIONS(1281),
    [anon_sym_EQ_TILDE] = ACTIONS(1281),
    [anon_sym_EQ_EQ] = ACTIONS(1281),
    [anon_sym_EQ] = ACTIONS(1283),
    [anon_sym_PLUS_EQ] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_BANG_EQ] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_EQ] = ACTIONS(1281),
    [anon_sym_LT_EQ] = ACTIONS(1281),
    [anon_sym_GT_EQ] = ACTIONS(1281),
    [anon_sym_PLUS_PLUS] = ACTIONS(1281),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1281),
    [anon_sym_LF] = ACTIONS(1281),
    [anon_sym_AMP] = ACTIONS(1283),
  },
  [593] = {
    [aux_sym_concatenation_repeat1] = STATE(1072),
    [sym__concat] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2084),
    [anon_sym_SEMI_SEMI] = ACTIONS(2082),
    [sym__special_characters] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_DOLLAR] = ACTIONS(2084),
    [sym_raw_string] = ACTIONS(2082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2082),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [anon_sym_LT_LPAREN] = ACTIONS(2082),
    [anon_sym_GT_LPAREN] = ACTIONS(2082),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2084),
    [anon_sym_LF] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2082),
  },
  [594] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(1075),
    [anon_sym_DQUOTE] = ACTIONS(2224),
    [anon_sym_DOLLAR] = ACTIONS(2226),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [595] = {
    [sym_string] = STATE(1077),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_DOLLAR] = ACTIONS(2228),
    [sym_raw_string] = ACTIONS(2230),
    [anon_sym_POUND] = ACTIONS(2228),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_AT] = ACTIONS(2234),
    [anon_sym_QMARK] = ACTIONS(2234),
    [anon_sym_0] = ACTIONS(2232),
    [anon_sym__] = ACTIONS(2232),
  },
  [596] = {
    [aux_sym_concatenation_repeat1] = STATE(1072),
    [sym__concat] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2100),
    [anon_sym_SEMI_SEMI] = ACTIONS(2098),
    [sym__special_characters] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_DOLLAR] = ACTIONS(2100),
    [sym_raw_string] = ACTIONS(2098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2098),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [anon_sym_LT_LPAREN] = ACTIONS(2098),
    [anon_sym_GT_LPAREN] = ACTIONS(2098),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2100),
    [anon_sym_LF] = ACTIONS(2098),
    [anon_sym_AMP] = ACTIONS(2098),
  },
  [597] = {
    [sym_subscript] = STATE(1082),
    [sym_variable_name] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_DOLLAR] = ACTIONS(2240),
    [anon_sym_POUND] = ACTIONS(2238),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_AT] = ACTIONS(2244),
    [anon_sym_QMARK] = ACTIONS(2244),
    [anon_sym_0] = ACTIONS(2242),
    [anon_sym__] = ACTIONS(2242),
  },
  [598] = {
    [sym__terminated_statement] = STATE(1085),
    [sym_redirected_statement] = STATE(1083),
    [sym_for_statement] = STATE(1083),
    [sym_c_style_for_statement] = STATE(1083),
    [sym_while_statement] = STATE(1083),
    [sym_if_statement] = STATE(1083),
    [sym_case_statement] = STATE(1083),
    [sym_function_definition] = STATE(1083),
    [sym_compound_statement] = STATE(1083),
    [sym_subshell] = STATE(1083),
    [sym_pipeline] = STATE(1083),
    [sym_list] = STATE(1083),
    [sym_negated_command] = STATE(1083),
    [sym_test_command] = STATE(1083),
    [sym_declaration_command] = STATE(1083),
    [sym_unset_command] = STATE(1083),
    [sym_command] = STATE(1083),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(1084),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(1085),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [599] = {
    [sym__terminated_statement] = STATE(1088),
    [sym_redirected_statement] = STATE(1086),
    [sym_for_statement] = STATE(1086),
    [sym_c_style_for_statement] = STATE(1086),
    [sym_while_statement] = STATE(1086),
    [sym_if_statement] = STATE(1086),
    [sym_case_statement] = STATE(1086),
    [sym_function_definition] = STATE(1086),
    [sym_compound_statement] = STATE(1086),
    [sym_subshell] = STATE(1086),
    [sym_pipeline] = STATE(1086),
    [sym_list] = STATE(1086),
    [sym_negated_command] = STATE(1086),
    [sym_test_command] = STATE(1086),
    [sym_declaration_command] = STATE(1086),
    [sym_unset_command] = STATE(1086),
    [sym_command] = STATE(1086),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(1087),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(1088),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [600] = {
    [sym__terminated_statement] = STATE(1091),
    [sym_redirected_statement] = STATE(1089),
    [sym_for_statement] = STATE(1089),
    [sym_c_style_for_statement] = STATE(1089),
    [sym_while_statement] = STATE(1089),
    [sym_if_statement] = STATE(1089),
    [sym_case_statement] = STATE(1089),
    [sym_function_definition] = STATE(1089),
    [sym_compound_statement] = STATE(1089),
    [sym_subshell] = STATE(1089),
    [sym_pipeline] = STATE(1089),
    [sym_list] = STATE(1089),
    [sym_negated_command] = STATE(1089),
    [sym_test_command] = STATE(1089),
    [sym_declaration_command] = STATE(1089),
    [sym_unset_command] = STATE(1089),
    [sym_command] = STATE(1089),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(1090),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(1091),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [601] = {
    [sym_concatenation] = STATE(1093),
    [sym_string] = STATE(596),
    [sym_simple_expansion] = STATE(596),
    [sym_string_expansion] = STATE(596),
    [sym_expansion] = STATE(596),
    [sym_command_substitution] = STATE(596),
    [sym_process_substitution] = STATE(596),
    [aux_sym_for_statement_repeat1] = STATE(1093),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym_SEMI_SEMI] = ACTIONS(2248),
    [sym__special_characters] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_DOLLAR] = ACTIONS(1179),
    [sym_raw_string] = ACTIONS(1181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1183),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1185),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1189),
    [anon_sym_GT_LPAREN] = ACTIONS(1189),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2250),
    [anon_sym_LF] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2248),
  },
  [602] = {
    [sym__simple_heredoc_body] = ACTIONS(2252),
    [sym__heredoc_body_beginning] = ACTIONS(2252),
    [sym_file_descriptor] = ACTIONS(2252),
    [ts_builtin_sym_end] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym_esac] = ACTIONS(2252),
    [anon_sym_PIPE] = ACTIONS(2254),
    [anon_sym_RPAREN] = ACTIONS(2252),
    [anon_sym_SEMI_SEMI] = ACTIONS(2252),
    [anon_sym_PIPE_AMP] = ACTIONS(2252),
    [anon_sym_AMP_AMP] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_GT_GT] = ACTIONS(2252),
    [anon_sym_AMP_GT] = ACTIONS(2254),
    [anon_sym_AMP_GT_GT] = ACTIONS(2252),
    [anon_sym_LT_AMP] = ACTIONS(2252),
    [anon_sym_GT_AMP] = ACTIONS(2252),
    [anon_sym_LT_LT] = ACTIONS(2254),
    [anon_sym_LT_LT_DASH] = ACTIONS(2252),
    [anon_sym_LT_LT_LT] = ACTIONS(2252),
    [anon_sym_BQUOTE] = ACTIONS(2252),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2254),
  },
  [603] = {
    [anon_sym_RPAREN] = ACTIONS(2256),
    [anon_sym_AMP_AMP] = ACTIONS(1217),
    [anon_sym_PIPE_PIPE] = ACTIONS(1217),
    [anon_sym_EQ_TILDE] = ACTIONS(1219),
    [anon_sym_EQ_EQ] = ACTIONS(1219),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_PLUS_EQ] = ACTIONS(1217),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_BANG_EQ] = ACTIONS(1217),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_DASH_EQ] = ACTIONS(1217),
    [anon_sym_LT_EQ] = ACTIONS(1217),
    [anon_sym_GT_EQ] = ACTIONS(1217),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1217),
  },
  [604] = {
    [anon_sym_RPAREN] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(1217),
    [anon_sym_PIPE_PIPE] = ACTIONS(1217),
    [anon_sym_EQ_TILDE] = ACTIONS(1219),
    [anon_sym_EQ_EQ] = ACTIONS(1219),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_PLUS_EQ] = ACTIONS(1217),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_BANG_EQ] = ACTIONS(1217),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_DASH_EQ] = ACTIONS(1217),
    [anon_sym_LT_EQ] = ACTIONS(1217),
    [anon_sym_GT_EQ] = ACTIONS(1217),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1217),
  },
  [605] = {
    [sym_string] = STATE(1095),
    [sym_simple_expansion] = STATE(1095),
    [sym_string_expansion] = STATE(1095),
    [sym_expansion] = STATE(1095),
    [sym_command_substitution] = STATE(1095),
    [sym_process_substitution] = STATE(1095),
    [sym__special_characters] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [sym_raw_string] = ACTIONS(2258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(421),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(425),
    [anon_sym_GT_LPAREN] = ACTIONS(425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2258),
  },
  [606] = {
    [aux_sym_concatenation_repeat1] = STATE(1096),
    [sym__concat] = ACTIONS(1191),
    [anon_sym_RPAREN] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_EQ_TILDE] = ACTIONS(779),
    [anon_sym_EQ_EQ] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(781),
    [anon_sym_PLUS_EQ] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_BANG_EQ] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_DASH_EQ] = ACTIONS(779),
    [anon_sym_LT_EQ] = ACTIONS(779),
    [anon_sym_GT_EQ] = ACTIONS(779),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(779),
  },
  [607] = {
    [sym__concat] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_RPAREN] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_EQ_TILDE] = ACTIONS(783),
    [anon_sym_EQ_EQ] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_PLUS_EQ] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_BANG_EQ] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_DASH_EQ] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(783),
    [anon_sym_GT_EQ] = ACTIONS(783),
    [anon_sym_PLUS_PLUS] = ACTIONS(783),
    [anon_sym_DASH_DASH] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(783),
  },
  [608] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(2260),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [609] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(2260),
    [anon_sym_DOLLAR] = ACTIONS(2262),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [610] = {
    [sym__concat] = ACTIONS(817),
    [anon_sym_PIPE] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_EQ_TILDE] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(817),
    [anon_sym_EQ] = ACTIONS(819),
    [anon_sym_PLUS_EQ] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_BANG_EQ] = ACTIONS(817),
    [anon_sym_PLUS] = ACTIONS(819),
    [anon_sym_DASH] = ACTIONS(819),
    [anon_sym_DASH_EQ] = ACTIONS(817),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(817),
    [anon_sym_DASH_DASH] = ACTIONS(817),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(817),
  },
  [611] = {
    [sym__concat] = ACTIONS(821),
    [anon_sym_PIPE] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_EQ_TILDE] = ACTIONS(821),
    [anon_sym_EQ_EQ] = ACTIONS(821),
    [anon_sym_EQ] = ACTIONS(823),
    [anon_sym_PLUS_EQ] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_BANG_EQ] = ACTIONS(821),
    [anon_sym_PLUS] = ACTIONS(823),
    [anon_sym_DASH] = ACTIONS(823),
    [anon_sym_DASH_EQ] = ACTIONS(821),
    [anon_sym_LT_EQ] = ACTIONS(821),
    [anon_sym_GT_EQ] = ACTIONS(821),
    [anon_sym_PLUS_PLUS] = ACTIONS(821),
    [anon_sym_DASH_DASH] = ACTIONS(821),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(821),
  },
  [612] = {
    [sym__concat] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(827),
    [anon_sym_RPAREN] = ACTIONS(825),
    [anon_sym_AMP_AMP] = ACTIONS(825),
    [anon_sym_PIPE_PIPE] = ACTIONS(825),
    [anon_sym_EQ_TILDE] = ACTIONS(825),
    [anon_sym_EQ_EQ] = ACTIONS(825),
    [anon_sym_EQ] = ACTIONS(827),
    [anon_sym_PLUS_EQ] = ACTIONS(825),
    [anon_sym_LT] = ACTIONS(827),
    [anon_sym_GT] = ACTIONS(827),
    [anon_sym_BANG_EQ] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_DASH_EQ] = ACTIONS(825),
    [anon_sym_LT_EQ] = ACTIONS(825),
    [anon_sym_GT_EQ] = ACTIONS(825),
    [anon_sym_PLUS_PLUS] = ACTIONS(825),
    [anon_sym_DASH_DASH] = ACTIONS(825),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(825),
  },
  [613] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(2264),
    [sym_comment] = ACTIONS(57),
  },
  [614] = {
    [sym_subscript] = STATE(1102),
    [sym_variable_name] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_DOLLAR] = ACTIONS(2268),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(2272),
    [anon_sym_AT] = ACTIONS(2272),
    [anon_sym_QMARK] = ACTIONS(2272),
    [anon_sym_0] = ACTIONS(2270),
    [anon_sym__] = ACTIONS(2270),
  },
  [615] = {
    [sym_concatenation] = STATE(1105),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1105),
    [anon_sym_RBRACE] = ACTIONS(2274),
    [anon_sym_EQ] = ACTIONS(2276),
    [anon_sym_DASH] = ACTIONS(2276),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_COLON] = ACTIONS(2276),
    [anon_sym_COLON_QMARK] = ACTIONS(2276),
    [anon_sym_COLON_DASH] = ACTIONS(2276),
    [anon_sym_PERCENT] = ACTIONS(2276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [616] = {
    [sym_concatenation] = STATE(1108),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1108),
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(2284),
    [anon_sym_DASH] = ACTIONS(2284),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2286),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym_COLON_QMARK] = ACTIONS(2284),
    [anon_sym_COLON_DASH] = ACTIONS(2284),
    [anon_sym_PERCENT] = ACTIONS(2284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [617] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1111),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2292),
    [anon_sym_SEMI_SEMI] = ACTIONS(2294),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2290),
  },
  [618] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1111),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2292),
    [anon_sym_SEMI_SEMI] = ACTIONS(2294),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2290),
  },
  [619] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1112),
    [sym_for_statement] = STATE(1112),
    [sym_c_style_for_statement] = STATE(1112),
    [sym_while_statement] = STATE(1112),
    [sym_if_statement] = STATE(1112),
    [sym_case_statement] = STATE(1112),
    [sym_function_definition] = STATE(1112),
    [sym_compound_statement] = STATE(1112),
    [sym_subshell] = STATE(1112),
    [sym_pipeline] = STATE(1112),
    [sym_list] = STATE(1112),
    [sym_negated_command] = STATE(1112),
    [sym_test_command] = STATE(1112),
    [sym_declaration_command] = STATE(1112),
    [sym_unset_command] = STATE(1112),
    [sym_command] = STATE(1112),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(1113),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [620] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1115),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(2296),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2298),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(2292),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
  },
  [621] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1115),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2296),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2298),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(2292),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
  },
  [622] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1116),
    [sym_for_statement] = STATE(1116),
    [sym_c_style_for_statement] = STATE(1116),
    [sym_while_statement] = STATE(1116),
    [sym_if_statement] = STATE(1116),
    [sym_case_statement] = STATE(1116),
    [sym_function_definition] = STATE(1116),
    [sym_compound_statement] = STATE(1116),
    [sym_subshell] = STATE(1116),
    [sym_pipeline] = STATE(1116),
    [sym_list] = STATE(1116),
    [sym_negated_command] = STATE(1116),
    [sym_test_command] = STATE(1116),
    [sym_declaration_command] = STATE(1116),
    [sym_unset_command] = STATE(1116),
    [sym_command] = STATE(1116),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(1117),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [623] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1120),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2302),
    [anon_sym_SEMI_SEMI] = ACTIONS(2304),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2300),
  },
  [624] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1120),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2302),
    [anon_sym_SEMI_SEMI] = ACTIONS(2304),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2300),
  },
  [625] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1121),
    [sym_for_statement] = STATE(1121),
    [sym_c_style_for_statement] = STATE(1121),
    [sym_while_statement] = STATE(1121),
    [sym_if_statement] = STATE(1121),
    [sym_case_statement] = STATE(1121),
    [sym_function_definition] = STATE(1121),
    [sym_compound_statement] = STATE(1121),
    [sym_subshell] = STATE(1121),
    [sym_pipeline] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_negated_command] = STATE(1121),
    [sym_test_command] = STATE(1121),
    [sym_declaration_command] = STATE(1121),
    [sym_unset_command] = STATE(1121),
    [sym_command] = STATE(1121),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(1122),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [626] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2306),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2306),
  },
  [627] = {
    [sym__expression] = STATE(1123),
    [sym_binary_expression] = STATE(1123),
    [sym_unary_expression] = STATE(1123),
    [sym_postfix_expression] = STATE(1123),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_concatenation] = STATE(1123),
    [sym_string] = STATE(225),
    [sym_simple_expansion] = STATE(225),
    [sym_string_expansion] = STATE(225),
    [sym_expansion] = STATE(225),
    [sym_command_substitution] = STATE(225),
    [sym_process_substitution] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_BANG] = ACTIONS(409),
    [sym__special_characters] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [sym_raw_string] = ACTIONS(417),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(421),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(425),
    [anon_sym_GT_LPAREN] = ACTIONS(425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(427),
    [sym_test_operator] = ACTIONS(429),
  },
  [628] = {
    [sym__expression] = STATE(1123),
    [sym_binary_expression] = STATE(1123),
    [sym_unary_expression] = STATE(1123),
    [sym_postfix_expression] = STATE(1123),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_concatenation] = STATE(1123),
    [sym_string] = STATE(225),
    [sym_simple_expansion] = STATE(225),
    [sym_string_expansion] = STATE(225),
    [sym_expansion] = STATE(225),
    [sym_command_substitution] = STATE(225),
    [sym_process_substitution] = STATE(225),
    [sym_regex] = ACTIONS(2310),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_BANG] = ACTIONS(409),
    [sym__special_characters] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [sym_raw_string] = ACTIONS(417),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(421),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(425),
    [anon_sym_GT_LPAREN] = ACTIONS(425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(427),
    [sym_test_operator] = ACTIONS(429),
  },
  [629] = {
    [anon_sym_RPAREN] = ACTIONS(1281),
    [anon_sym_AMP_AMP] = ACTIONS(1281),
    [anon_sym_PIPE_PIPE] = ACTIONS(1281),
    [anon_sym_EQ_TILDE] = ACTIONS(1281),
    [anon_sym_EQ_EQ] = ACTIONS(1281),
    [anon_sym_EQ] = ACTIONS(1283),
    [anon_sym_PLUS_EQ] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_BANG_EQ] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_EQ] = ACTIONS(1281),
    [anon_sym_LT_EQ] = ACTIONS(1281),
    [anon_sym_GT_EQ] = ACTIONS(1281),
    [anon_sym_PLUS_PLUS] = ACTIONS(1281),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1281),
  },
  [630] = {
    [sym__concat] = ACTIONS(1726),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1726),
    [anon_sym_EQ_TILDE] = ACTIONS(1726),
    [anon_sym_EQ_EQ] = ACTIONS(1726),
    [anon_sym_EQ] = ACTIONS(1728),
    [anon_sym_PLUS_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_BANG_EQ] = ACTIONS(1726),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_DASH] = ACTIONS(1728),
    [anon_sym_DASH_EQ] = ACTIONS(1726),
    [anon_sym_LT_EQ] = ACTIONS(1726),
    [anon_sym_GT_EQ] = ACTIONS(1726),
    [anon_sym_PLUS_PLUS] = ACTIONS(1726),
    [anon_sym_DASH_DASH] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1726),
  },
  [631] = {
    [aux_sym_concatenation_repeat1] = STATE(631),
    [sym__concat] = ACTIONS(2312),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_EQ_TILDE] = ACTIONS(1726),
    [anon_sym_EQ_EQ] = ACTIONS(1726),
    [anon_sym_EQ] = ACTIONS(1728),
    [anon_sym_PLUS_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_BANG_EQ] = ACTIONS(1726),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_DASH] = ACTIONS(1728),
    [anon_sym_DASH_EQ] = ACTIONS(1726),
    [anon_sym_LT_EQ] = ACTIONS(1726),
    [anon_sym_GT_EQ] = ACTIONS(1726),
    [anon_sym_PLUS_PLUS] = ACTIONS(1726),
    [anon_sym_DASH_DASH] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1726),
  },
  [632] = {
    [sym__concat] = ACTIONS(1733),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1733),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1733),
    [anon_sym_EQ_TILDE] = ACTIONS(1733),
    [anon_sym_EQ_EQ] = ACTIONS(1733),
    [anon_sym_EQ] = ACTIONS(1735),
    [anon_sym_PLUS_EQ] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1735),
    [anon_sym_GT] = ACTIONS(1735),
    [anon_sym_BANG_EQ] = ACTIONS(1733),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_DASH_EQ] = ACTIONS(1733),
    [anon_sym_LT_EQ] = ACTIONS(1733),
    [anon_sym_GT_EQ] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1733),
  },
  [633] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(2315),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [634] = {
    [sym_concatenation] = STATE(1129),
    [sym_string] = STATE(1128),
    [sym_simple_expansion] = STATE(1128),
    [sym_string_expansion] = STATE(1128),
    [sym_expansion] = STATE(1128),
    [sym_command_substitution] = STATE(1128),
    [sym_process_substitution] = STATE(1128),
    [anon_sym_RBRACE] = ACTIONS(2317),
    [sym__special_characters] = ACTIONS(2319),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(2321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2321),
  },
  [635] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(2323),
    [sym_comment] = ACTIONS(57),
  },
  [636] = {
    [sym_concatenation] = STATE(1133),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1133),
    [anon_sym_RBRACE] = ACTIONS(2325),
    [anon_sym_EQ] = ACTIONS(2327),
    [anon_sym_DASH] = ACTIONS(2327),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2331),
    [anon_sym_COLON] = ACTIONS(2327),
    [anon_sym_COLON_QMARK] = ACTIONS(2327),
    [anon_sym_COLON_DASH] = ACTIONS(2327),
    [anon_sym_PERCENT] = ACTIONS(2327),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [637] = {
    [sym_concatenation] = STATE(1135),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1135),
    [anon_sym_RBRACE] = ACTIONS(2317),
    [anon_sym_EQ] = ACTIONS(2333),
    [anon_sym_DASH] = ACTIONS(2333),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2337),
    [anon_sym_COLON] = ACTIONS(2333),
    [anon_sym_COLON_QMARK] = ACTIONS(2333),
    [anon_sym_COLON_DASH] = ACTIONS(2333),
    [anon_sym_PERCENT] = ACTIONS(2333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [638] = {
    [sym__concat] = ACTIONS(1834),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1834),
    [anon_sym_AMP_AMP] = ACTIONS(1834),
    [anon_sym_PIPE_PIPE] = ACTIONS(1834),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1834),
    [anon_sym_EQ_TILDE] = ACTIONS(1834),
    [anon_sym_EQ_EQ] = ACTIONS(1834),
    [anon_sym_EQ] = ACTIONS(1836),
    [anon_sym_PLUS_EQ] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1836),
    [anon_sym_GT] = ACTIONS(1836),
    [anon_sym_BANG_EQ] = ACTIONS(1834),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_DASH] = ACTIONS(1836),
    [anon_sym_DASH_EQ] = ACTIONS(1834),
    [anon_sym_LT_EQ] = ACTIONS(1834),
    [anon_sym_GT_EQ] = ACTIONS(1834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1834),
    [anon_sym_DASH_DASH] = ACTIONS(1834),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1834),
  },
  [639] = {
    [sym_concatenation] = STATE(1138),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1138),
    [sym_regex] = ACTIONS(2339),
    [anon_sym_RBRACE] = ACTIONS(2341),
    [anon_sym_EQ] = ACTIONS(2343),
    [anon_sym_DASH] = ACTIONS(2343),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(2343),
    [anon_sym_COLON_QMARK] = ACTIONS(2343),
    [anon_sym_COLON_DASH] = ACTIONS(2343),
    [anon_sym_PERCENT] = ACTIONS(2343),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [640] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(2341),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [641] = {
    [sym__concat] = ACTIONS(1882),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1882),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1882),
    [anon_sym_EQ_TILDE] = ACTIONS(1882),
    [anon_sym_EQ_EQ] = ACTIONS(1882),
    [anon_sym_EQ] = ACTIONS(1884),
    [anon_sym_PLUS_EQ] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1884),
    [anon_sym_BANG_EQ] = ACTIONS(1882),
    [anon_sym_PLUS] = ACTIONS(1884),
    [anon_sym_DASH] = ACTIONS(1884),
    [anon_sym_DASH_EQ] = ACTIONS(1882),
    [anon_sym_LT_EQ] = ACTIONS(1882),
    [anon_sym_GT_EQ] = ACTIONS(1882),
    [anon_sym_PLUS_PLUS] = ACTIONS(1882),
    [anon_sym_DASH_DASH] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1882),
  },
  [642] = {
    [sym_concatenation] = STATE(1135),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1135),
    [sym_regex] = ACTIONS(2347),
    [anon_sym_RBRACE] = ACTIONS(2317),
    [anon_sym_EQ] = ACTIONS(2333),
    [anon_sym_DASH] = ACTIONS(2333),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(2333),
    [anon_sym_COLON_QMARK] = ACTIONS(2333),
    [anon_sym_COLON_DASH] = ACTIONS(2333),
    [anon_sym_PERCENT] = ACTIONS(2333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [643] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(2317),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [644] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(2349),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [645] = {
    [sym__concat] = ACTIONS(1890),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1890),
    [anon_sym_AMP_AMP] = ACTIONS(1890),
    [anon_sym_PIPE_PIPE] = ACTIONS(1890),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1890),
    [anon_sym_EQ_TILDE] = ACTIONS(1890),
    [anon_sym_EQ_EQ] = ACTIONS(1890),
    [anon_sym_EQ] = ACTIONS(1892),
    [anon_sym_PLUS_EQ] = ACTIONS(1890),
    [anon_sym_LT] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(1892),
    [anon_sym_BANG_EQ] = ACTIONS(1890),
    [anon_sym_PLUS] = ACTIONS(1892),
    [anon_sym_DASH] = ACTIONS(1892),
    [anon_sym_DASH_EQ] = ACTIONS(1890),
    [anon_sym_LT_EQ] = ACTIONS(1890),
    [anon_sym_GT_EQ] = ACTIONS(1890),
    [anon_sym_PLUS_PLUS] = ACTIONS(1890),
    [anon_sym_DASH_DASH] = ACTIONS(1890),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1890),
  },
  [646] = {
    [anon_sym_SEMI] = ACTIONS(2351),
    [anon_sym_RPAREN] = ACTIONS(2349),
    [anon_sym_SEMI_SEMI] = ACTIONS(2353),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2353),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [647] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1143),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(2355),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2349),
    [anon_sym_SEMI_SEMI] = ACTIONS(2357),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2357),
    [anon_sym_AMP] = ACTIONS(2355),
  },
  [648] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1143),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2355),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2349),
    [anon_sym_SEMI_SEMI] = ACTIONS(2357),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2357),
    [anon_sym_AMP] = ACTIONS(2355),
  },
  [649] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(2349),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [650] = {
    [anon_sym_SEMI] = ACTIONS(2359),
    [anon_sym_SEMI_SEMI] = ACTIONS(2361),
    [anon_sym_BQUOTE] = ACTIONS(2349),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2361),
  },
  [651] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1146),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(2363),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2365),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(2349),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2365),
    [anon_sym_AMP] = ACTIONS(2363),
  },
  [652] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1146),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2363),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2365),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(2349),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2365),
    [anon_sym_AMP] = ACTIONS(2363),
  },
  [653] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(2367),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [654] = {
    [sym__concat] = ACTIONS(1924),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1924),
    [anon_sym_EQ_TILDE] = ACTIONS(1924),
    [anon_sym_EQ_EQ] = ACTIONS(1924),
    [anon_sym_EQ] = ACTIONS(1926),
    [anon_sym_PLUS_EQ] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_BANG_EQ] = ACTIONS(1924),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_DASH_EQ] = ACTIONS(1924),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_PLUS_PLUS] = ACTIONS(1924),
    [anon_sym_DASH_DASH] = ACTIONS(1924),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1924),
  },
  [655] = {
    [anon_sym_SEMI] = ACTIONS(2369),
    [anon_sym_RPAREN] = ACTIONS(2367),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2371),
  },
  [656] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1150),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2367),
    [anon_sym_SEMI_SEMI] = ACTIONS(2375),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2375),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [657] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1150),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2367),
    [anon_sym_SEMI_SEMI] = ACTIONS(2375),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2375),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [658] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2377),
    [anon_sym_EQ_TILDE] = ACTIONS(2377),
    [anon_sym_EQ_EQ] = ACTIONS(2377),
    [anon_sym_EQ] = ACTIONS(2379),
    [anon_sym_PLUS_EQ] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2379),
    [anon_sym_GT] = ACTIONS(2379),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2379),
    [anon_sym_DASH] = ACTIONS(2379),
    [anon_sym_DASH_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_PLUS_PLUS] = ACTIONS(2377),
    [anon_sym_DASH_DASH] = ACTIONS(2377),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2377),
  },
  [659] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2377),
    [anon_sym_EQ_TILDE] = ACTIONS(2377),
    [anon_sym_EQ_EQ] = ACTIONS(2377),
    [anon_sym_EQ] = ACTIONS(2379),
    [anon_sym_PLUS_EQ] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2379),
    [anon_sym_GT] = ACTIONS(2379),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2379),
    [anon_sym_DASH] = ACTIONS(2379),
    [anon_sym_DASH_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_PLUS_PLUS] = ACTIONS(2377),
    [anon_sym_DASH_DASH] = ACTIONS(2377),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2377),
  },
  [660] = {
    [aux_sym_concatenation_repeat1] = STATE(1151),
    [sym__simple_heredoc_body] = ACTIONS(1107),
    [sym__heredoc_body_beginning] = ACTIONS(1107),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(1109),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_SEMI] = ACTIONS(1111),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_SEMI_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT] = ACTIONS(1111),
    [anon_sym_AMP_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_AMP] = ACTIONS(1107),
    [anon_sym_GT_AMP] = ACTIONS(1107),
    [anon_sym_LT_LT] = ACTIONS(1111),
    [anon_sym_LT_LT_DASH] = ACTIONS(1107),
    [anon_sym_LT_LT_LT] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1111),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1111),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1111),
  },
  [661] = {
    [aux_sym_concatenation_repeat1] = STATE(1151),
    [sym__simple_heredoc_body] = ACTIONS(1085),
    [sym__heredoc_body_beginning] = ACTIONS(1085),
    [sym_file_descriptor] = ACTIONS(1085),
    [sym__concat] = ACTIONS(1109),
    [sym_variable_name] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1087),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym__special_characters] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_DOLLAR] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1085),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [anon_sym_LT_LPAREN] = ACTIONS(1085),
    [anon_sym_GT_LPAREN] = ACTIONS(1085),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1087),
    [anon_sym_LF] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1087),
  },
  [662] = {
    [sym_concatenation] = STATE(787),
    [sym_string] = STATE(1153),
    [sym_array] = STATE(787),
    [sym_simple_expansion] = STATE(1153),
    [sym_string_expansion] = STATE(1153),
    [sym_expansion] = STATE(1153),
    [sym_command_substitution] = STATE(1153),
    [sym_process_substitution] = STATE(1153),
    [sym__empty_value] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1505),
    [sym__special_characters] = ACTIONS(2381),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(2383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2383),
  },
  [663] = {
    [aux_sym_concatenation_repeat1] = STATE(1154),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(671),
    [sym_variable_name] = ACTIONS(779),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [sym_word] = ACTIONS(781),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [664] = {
    [sym_variable_assignment] = STATE(664),
    [sym_subscript] = STATE(261),
    [sym_concatenation] = STATE(664),
    [sym_string] = STATE(260),
    [sym_simple_expansion] = STATE(260),
    [sym_string_expansion] = STATE(260),
    [sym_expansion] = STATE(260),
    [sym_command_substitution] = STATE(260),
    [sym_process_substitution] = STATE(260),
    [aux_sym_declaration_command_repeat1] = STATE(664),
    [sym__simple_heredoc_body] = ACTIONS(1559),
    [sym__heredoc_body_beginning] = ACTIONS(1559),
    [sym_file_descriptor] = ACTIONS(1559),
    [sym_variable_name] = ACTIONS(2385),
    [anon_sym_SEMI] = ACTIONS(1564),
    [anon_sym_PIPE] = ACTIONS(1564),
    [anon_sym_SEMI_SEMI] = ACTIONS(1559),
    [anon_sym_PIPE_AMP] = ACTIONS(1559),
    [anon_sym_AMP_AMP] = ACTIONS(1559),
    [anon_sym_PIPE_PIPE] = ACTIONS(1559),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1564),
    [anon_sym_GT_GT] = ACTIONS(1559),
    [anon_sym_AMP_GT] = ACTIONS(1564),
    [anon_sym_AMP_GT_GT] = ACTIONS(1559),
    [anon_sym_LT_AMP] = ACTIONS(1559),
    [anon_sym_GT_AMP] = ACTIONS(1559),
    [anon_sym_LT_LT] = ACTIONS(1564),
    [anon_sym_LT_LT_DASH] = ACTIONS(1559),
    [anon_sym_LT_LT_LT] = ACTIONS(1559),
    [sym__special_characters] = ACTIONS(2388),
    [anon_sym_DQUOTE] = ACTIONS(1569),
    [anon_sym_DOLLAR] = ACTIONS(1572),
    [sym_raw_string] = ACTIONS(2391),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1581),
    [anon_sym_BQUOTE] = ACTIONS(1584),
    [anon_sym_LT_LPAREN] = ACTIONS(1587),
    [anon_sym_GT_LPAREN] = ACTIONS(1587),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2394),
    [sym_word] = ACTIONS(2397),
    [anon_sym_LF] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1564),
  },
  [665] = {
    [aux_sym_concatenation_repeat1] = STATE(1155),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [sym_word] = ACTIONS(781),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [666] = {
    [sym_concatenation] = STATE(666),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [aux_sym_unset_command_repeat1] = STATE(666),
    [sym__simple_heredoc_body] = ACTIONS(1644),
    [sym__heredoc_body_beginning] = ACTIONS(1644),
    [sym_file_descriptor] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1646),
    [anon_sym_PIPE] = ACTIONS(1646),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1646),
    [anon_sym_GT] = ACTIONS(1646),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1646),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1644),
    [anon_sym_LT_LT_LT] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(2400),
    [anon_sym_DQUOTE] = ACTIONS(1651),
    [anon_sym_DOLLAR] = ACTIONS(1654),
    [sym_raw_string] = ACTIONS(2403),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1663),
    [anon_sym_BQUOTE] = ACTIONS(1666),
    [anon_sym_LT_LPAREN] = ACTIONS(1669),
    [anon_sym_GT_LPAREN] = ACTIONS(1669),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2406),
    [sym_word] = ACTIONS(2409),
    [anon_sym_LF] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1646),
  },
  [667] = {
    [aux_sym_concatenation_repeat1] = STATE(667),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(1730),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_EQ_TILDE] = ACTIONS(1728),
    [anon_sym_EQ_EQ] = ACTIONS(1728),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [668] = {
    [sym__simple_heredoc_body] = ACTIONS(2412),
    [sym__heredoc_body_beginning] = ACTIONS(2412),
    [sym_file_descriptor] = ACTIONS(2412),
    [ts_builtin_sym_end] = ACTIONS(2412),
    [anon_sym_SEMI] = ACTIONS(2414),
    [anon_sym_esac] = ACTIONS(2412),
    [anon_sym_PIPE] = ACTIONS(2414),
    [anon_sym_RPAREN] = ACTIONS(2412),
    [anon_sym_SEMI_SEMI] = ACTIONS(2412),
    [anon_sym_PIPE_AMP] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_PIPE_PIPE] = ACTIONS(2412),
    [anon_sym_LT] = ACTIONS(2414),
    [anon_sym_GT] = ACTIONS(2414),
    [anon_sym_GT_GT] = ACTIONS(2412),
    [anon_sym_AMP_GT] = ACTIONS(2414),
    [anon_sym_AMP_GT_GT] = ACTIONS(2412),
    [anon_sym_LT_AMP] = ACTIONS(2412),
    [anon_sym_GT_AMP] = ACTIONS(2412),
    [anon_sym_LT_LT] = ACTIONS(2414),
    [anon_sym_LT_LT_DASH] = ACTIONS(2412),
    [anon_sym_LT_LT_LT] = ACTIONS(2412),
    [anon_sym_BQUOTE] = ACTIONS(2412),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2414),
  },
  [669] = {
    [sym__terminated_statement] = STATE(1157),
    [sym_redirected_statement] = STATE(524),
    [sym_for_statement] = STATE(524),
    [sym_c_style_for_statement] = STATE(524),
    [sym_while_statement] = STATE(524),
    [sym_if_statement] = STATE(524),
    [sym_case_statement] = STATE(524),
    [sym_function_definition] = STATE(524),
    [sym_compound_statement] = STATE(524),
    [sym_subshell] = STATE(524),
    [sym_pipeline] = STATE(524),
    [sym_list] = STATE(524),
    [sym_negated_command] = STATE(524),
    [sym_test_command] = STATE(524),
    [sym_declaration_command] = STATE(524),
    [sym_unset_command] = STATE(524),
    [sym_command] = STATE(524),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(525),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(1157),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_done] = ACTIONS(2416),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [670] = {
    [sym_concatenation] = STATE(975),
    [sym_string] = STATE(1159),
    [sym_simple_expansion] = STATE(1159),
    [sym_string_expansion] = STATE(1159),
    [sym_expansion] = STATE(1159),
    [sym_command_substitution] = STATE(1159),
    [sym_process_substitution] = STATE(1159),
    [sym__special_characters] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(2420),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2420),
  },
  [671] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [672] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [673] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(1968),
    [sym__heredoc_body_beginning] = ACTIONS(1968),
    [sym_file_descriptor] = ACTIONS(1968),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(1968),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(1968),
    [anon_sym_PIPE_PIPE] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(1970),
    [anon_sym_GT] = ACTIONS(1970),
    [anon_sym_GT_GT] = ACTIONS(1968),
    [anon_sym_AMP_GT] = ACTIONS(1970),
    [anon_sym_AMP_GT_GT] = ACTIONS(1968),
    [anon_sym_LT_AMP] = ACTIONS(1968),
    [anon_sym_GT_AMP] = ACTIONS(1968),
    [anon_sym_LT_LT] = ACTIONS(1970),
    [anon_sym_LT_LT_DASH] = ACTIONS(1968),
    [anon_sym_LT_LT_LT] = ACTIONS(1968),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1968),
    [anon_sym_AMP] = ACTIONS(1970),
  },
  [674] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(1968),
    [sym__heredoc_body_beginning] = ACTIONS(1968),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(1968),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(1968),
    [anon_sym_PIPE_PIPE] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(1970),
    [anon_sym_LT_LT_DASH] = ACTIONS(1968),
    [anon_sym_LT_LT_LT] = ACTIONS(1968),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1968),
    [anon_sym_AMP] = ACTIONS(1970),
  },
  [675] = {
    [aux_sym_concatenation_repeat1] = STATE(1160),
    [sym__simple_heredoc_body] = ACTIONS(745),
    [sym__heredoc_body_beginning] = ACTIONS(745),
    [sym_file_descriptor] = ACTIONS(745),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_SEMI_SEMI] = ACTIONS(745),
    [anon_sym_PIPE_AMP] = ACTIONS(745),
    [anon_sym_AMP_AMP] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(745),
    [anon_sym_LT] = ACTIONS(749),
    [anon_sym_GT] = ACTIONS(749),
    [anon_sym_GT_GT] = ACTIONS(745),
    [anon_sym_AMP_GT] = ACTIONS(749),
    [anon_sym_AMP_GT_GT] = ACTIONS(745),
    [anon_sym_LT_AMP] = ACTIONS(745),
    [anon_sym_GT_AMP] = ACTIONS(745),
    [anon_sym_LT_LT] = ACTIONS(749),
    [anon_sym_LT_LT_DASH] = ACTIONS(745),
    [anon_sym_LT_LT_LT] = ACTIONS(745),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(749),
  },
  [676] = {
    [aux_sym_concatenation_repeat1] = STATE(1160),
    [sym__simple_heredoc_body] = ACTIONS(763),
    [sym__heredoc_body_beginning] = ACTIONS(763),
    [sym_file_descriptor] = ACTIONS(763),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(765),
    [anon_sym_SEMI_SEMI] = ACTIONS(763),
    [anon_sym_PIPE_AMP] = ACTIONS(763),
    [anon_sym_AMP_AMP] = ACTIONS(763),
    [anon_sym_PIPE_PIPE] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(765),
    [anon_sym_GT_GT] = ACTIONS(763),
    [anon_sym_AMP_GT] = ACTIONS(765),
    [anon_sym_AMP_GT_GT] = ACTIONS(763),
    [anon_sym_LT_AMP] = ACTIONS(763),
    [anon_sym_GT_AMP] = ACTIONS(763),
    [anon_sym_LT_LT] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(763),
    [anon_sym_LT_LT_LT] = ACTIONS(763),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(763),
    [anon_sym_AMP] = ACTIONS(765),
  },
  [677] = {
    [aux_sym_concatenation_repeat1] = STATE(1160),
    [sym__simple_heredoc_body] = ACTIONS(1976),
    [sym__heredoc_body_beginning] = ACTIONS(1976),
    [sym_file_descriptor] = ACTIONS(1976),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1978),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(1976),
    [anon_sym_AMP_AMP] = ACTIONS(1976),
    [anon_sym_PIPE_PIPE] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1976),
    [anon_sym_AMP_GT] = ACTIONS(1978),
    [anon_sym_AMP_GT_GT] = ACTIONS(1976),
    [anon_sym_LT_AMP] = ACTIONS(1976),
    [anon_sym_GT_AMP] = ACTIONS(1976),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_LT_LT_DASH] = ACTIONS(1976),
    [anon_sym_LT_LT_LT] = ACTIONS(1976),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1978),
  },
  [678] = {
    [aux_sym_concatenation_repeat1] = STATE(1160),
    [sym__simple_heredoc_body] = ACTIONS(1980),
    [sym__heredoc_body_beginning] = ACTIONS(1980),
    [sym_file_descriptor] = ACTIONS(1980),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_SEMI_SEMI] = ACTIONS(1980),
    [anon_sym_PIPE_AMP] = ACTIONS(1980),
    [anon_sym_AMP_AMP] = ACTIONS(1980),
    [anon_sym_PIPE_PIPE] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_AMP_GT] = ACTIONS(1982),
    [anon_sym_AMP_GT_GT] = ACTIONS(1980),
    [anon_sym_LT_AMP] = ACTIONS(1980),
    [anon_sym_GT_AMP] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1982),
    [anon_sym_LT_LT_DASH] = ACTIONS(1980),
    [anon_sym_LT_LT_LT] = ACTIONS(1980),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1982),
  },
  [679] = {
    [anon_sym_do] = ACTIONS(1984),
    [anon_sym_then] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
  },
  [680] = {
    [sym_file_redirect] = STATE(680),
    [sym_heredoc_redirect] = STATE(680),
    [sym_herestring_redirect] = STATE(680),
    [aux_sym_redirected_statement_repeat1] = STATE(680),
    [sym__simple_heredoc_body] = ACTIONS(1990),
    [sym__heredoc_body_beginning] = ACTIONS(1990),
    [sym_file_descriptor] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_SEMI_SEMI] = ACTIONS(1990),
    [anon_sym_PIPE_AMP] = ACTIONS(1990),
    [anon_sym_AMP_AMP] = ACTIONS(1990),
    [anon_sym_PIPE_PIPE] = ACTIONS(1990),
    [anon_sym_LT] = ACTIONS(2425),
    [anon_sym_GT] = ACTIONS(2425),
    [anon_sym_GT_GT] = ACTIONS(2428),
    [anon_sym_AMP_GT] = ACTIONS(2425),
    [anon_sym_AMP_GT_GT] = ACTIONS(2428),
    [anon_sym_LT_AMP] = ACTIONS(2428),
    [anon_sym_GT_AMP] = ACTIONS(2428),
    [anon_sym_LT_LT] = ACTIONS(2003),
    [anon_sym_LT_LT_DASH] = ACTIONS(2006),
    [anon_sym_LT_LT_LT] = ACTIONS(2431),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1995),
  },
  [681] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(2016),
    [sym__heredoc_body_beginning] = ACTIONS(2016),
    [sym_file_descriptor] = ACTIONS(2016),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(2018),
    [anon_sym_PIPE] = ACTIONS(2018),
    [anon_sym_SEMI_SEMI] = ACTIONS(2016),
    [anon_sym_PIPE_AMP] = ACTIONS(2016),
    [anon_sym_AMP_AMP] = ACTIONS(2016),
    [anon_sym_PIPE_PIPE] = ACTIONS(2016),
    [anon_sym_EQ_TILDE] = ACTIONS(2018),
    [anon_sym_EQ_EQ] = ACTIONS(2018),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(2018),
    [anon_sym_GT_GT] = ACTIONS(2016),
    [anon_sym_AMP_GT] = ACTIONS(2018),
    [anon_sym_AMP_GT_GT] = ACTIONS(2016),
    [anon_sym_LT_AMP] = ACTIONS(2016),
    [anon_sym_GT_AMP] = ACTIONS(2016),
    [anon_sym_LT_LT] = ACTIONS(2018),
    [anon_sym_LT_LT_DASH] = ACTIONS(2016),
    [anon_sym_LT_LT_LT] = ACTIONS(2016),
    [sym__special_characters] = ACTIONS(2016),
    [anon_sym_DQUOTE] = ACTIONS(2016),
    [anon_sym_DOLLAR] = ACTIONS(2018),
    [sym_raw_string] = ACTIONS(2016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2016),
    [anon_sym_BQUOTE] = ACTIONS(2016),
    [anon_sym_LT_LPAREN] = ACTIONS(2016),
    [anon_sym_GT_LPAREN] = ACTIONS(2016),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2018),
    [anon_sym_LF] = ACTIONS(2016),
    [anon_sym_AMP] = ACTIONS(2018),
  },
  [682] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(2012),
    [sym__heredoc_body_beginning] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_SEMI_SEMI] = ACTIONS(2012),
    [anon_sym_PIPE_AMP] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_EQ_TILDE] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_GT] = ACTIONS(2012),
    [anon_sym_AMP_GT] = ACTIONS(2014),
    [anon_sym_AMP_GT_GT] = ACTIONS(2012),
    [anon_sym_LT_AMP] = ACTIONS(2012),
    [anon_sym_GT_AMP] = ACTIONS(2012),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_DASH] = ACTIONS(2012),
    [anon_sym_LT_LT_LT] = ACTIONS(2012),
    [sym__special_characters] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2012),
    [anon_sym_DOLLAR] = ACTIONS(2014),
    [sym_raw_string] = ACTIONS(2012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2012),
    [anon_sym_BQUOTE] = ACTIONS(2012),
    [anon_sym_LT_LPAREN] = ACTIONS(2012),
    [anon_sym_GT_LPAREN] = ACTIONS(2012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2014),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2014),
  },
  [683] = {
    [sym_concatenation] = STATE(683),
    [sym_string] = STATE(279),
    [sym_simple_expansion] = STATE(279),
    [sym_string_expansion] = STATE(279),
    [sym_expansion] = STATE(279),
    [sym_command_substitution] = STATE(279),
    [sym_process_substitution] = STATE(279),
    [aux_sym_command_repeat2] = STATE(683),
    [sym__simple_heredoc_body] = ACTIONS(2012),
    [sym__heredoc_body_beginning] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_SEMI_SEMI] = ACTIONS(2012),
    [anon_sym_PIPE_AMP] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_EQ_TILDE] = ACTIONS(2434),
    [anon_sym_EQ_EQ] = ACTIONS(2434),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_GT] = ACTIONS(2012),
    [anon_sym_AMP_GT] = ACTIONS(2014),
    [anon_sym_AMP_GT_GT] = ACTIONS(2012),
    [anon_sym_LT_AMP] = ACTIONS(2012),
    [anon_sym_GT_AMP] = ACTIONS(2012),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_DASH] = ACTIONS(2012),
    [anon_sym_LT_LT_LT] = ACTIONS(2012),
    [sym__special_characters] = ACTIONS(2437),
    [anon_sym_DQUOTE] = ACTIONS(2026),
    [anon_sym_DOLLAR] = ACTIONS(2029),
    [sym_raw_string] = ACTIONS(2440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2035),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2038),
    [anon_sym_BQUOTE] = ACTIONS(2041),
    [anon_sym_LT_LPAREN] = ACTIONS(2044),
    [anon_sym_GT_LPAREN] = ACTIONS(2044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2443),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2014),
  },
  [684] = {
    [sym_concatenation] = STATE(683),
    [sym_string] = STATE(279),
    [sym_simple_expansion] = STATE(279),
    [sym_string_expansion] = STATE(279),
    [sym_expansion] = STATE(279),
    [sym_command_substitution] = STATE(279),
    [sym_process_substitution] = STATE(279),
    [aux_sym_command_repeat2] = STATE(683),
    [sym__simple_heredoc_body] = ACTIONS(2058),
    [sym__heredoc_body_beginning] = ACTIONS(2058),
    [sym_file_descriptor] = ACTIONS(2058),
    [anon_sym_SEMI] = ACTIONS(2060),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_SEMI_SEMI] = ACTIONS(2058),
    [anon_sym_PIPE_AMP] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_PIPE_PIPE] = ACTIONS(2058),
    [anon_sym_EQ_TILDE] = ACTIONS(513),
    [anon_sym_EQ_EQ] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2058),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2058),
    [anon_sym_LT_AMP] = ACTIONS(2058),
    [anon_sym_GT_AMP] = ACTIONS(2058),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2058),
    [anon_sym_LT_LT_LT] = ACTIONS(2058),
    [sym__special_characters] = ACTIONS(515),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(517),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2060),
  },
  [685] = {
    [sym__simple_heredoc_body] = ACTIONS(2446),
    [sym__heredoc_body_beginning] = ACTIONS(2446),
    [sym_file_descriptor] = ACTIONS(2446),
    [ts_builtin_sym_end] = ACTIONS(2446),
    [anon_sym_SEMI] = ACTIONS(2448),
    [anon_sym_esac] = ACTIONS(2446),
    [anon_sym_PIPE] = ACTIONS(2448),
    [anon_sym_RPAREN] = ACTIONS(2446),
    [anon_sym_SEMI_SEMI] = ACTIONS(2446),
    [anon_sym_PIPE_AMP] = ACTIONS(2446),
    [anon_sym_AMP_AMP] = ACTIONS(2446),
    [anon_sym_PIPE_PIPE] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_GT_GT] = ACTIONS(2446),
    [anon_sym_AMP_GT] = ACTIONS(2448),
    [anon_sym_AMP_GT_GT] = ACTIONS(2446),
    [anon_sym_LT_AMP] = ACTIONS(2446),
    [anon_sym_GT_AMP] = ACTIONS(2446),
    [anon_sym_LT_LT] = ACTIONS(2448),
    [anon_sym_LT_LT_DASH] = ACTIONS(2446),
    [anon_sym_LT_LT_LT] = ACTIONS(2446),
    [anon_sym_BQUOTE] = ACTIONS(2446),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2446),
    [anon_sym_AMP] = ACTIONS(2448),
  },
  [686] = {
    [sym__terminated_statement] = STATE(1161),
    [sym_redirected_statement] = STATE(59),
    [sym_for_statement] = STATE(59),
    [sym_c_style_for_statement] = STATE(59),
    [sym_while_statement] = STATE(59),
    [sym_if_statement] = STATE(59),
    [sym_case_statement] = STATE(59),
    [sym_function_definition] = STATE(59),
    [sym_compound_statement] = STATE(59),
    [sym_subshell] = STATE(59),
    [sym_pipeline] = STATE(59),
    [sym_list] = STATE(59),
    [sym_negated_command] = STATE(59),
    [sym_test_command] = STATE(59),
    [sym_declaration_command] = STATE(59),
    [sym_unset_command] = STATE(59),
    [sym_command] = STATE(59),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(61),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [687] = {
    [sym__terminated_statement] = STATE(1162),
    [sym_redirected_statement] = STATE(524),
    [sym_for_statement] = STATE(524),
    [sym_c_style_for_statement] = STATE(524),
    [sym_while_statement] = STATE(524),
    [sym_if_statement] = STATE(524),
    [sym_case_statement] = STATE(524),
    [sym_function_definition] = STATE(524),
    [sym_compound_statement] = STATE(524),
    [sym_subshell] = STATE(524),
    [sym_pipeline] = STATE(524),
    [sym_list] = STATE(524),
    [sym_negated_command] = STATE(524),
    [sym_test_command] = STATE(524),
    [sym_declaration_command] = STATE(524),
    [sym_unset_command] = STATE(524),
    [sym_command] = STATE(524),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(525),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(1162),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(2450),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [688] = {
    [anon_sym_fi] = ACTIONS(2452),
    [sym_comment] = ACTIONS(57),
  },
  [689] = {
    [sym__terminated_statement] = STATE(1165),
    [sym_redirected_statement] = STATE(524),
    [sym_for_statement] = STATE(524),
    [sym_c_style_for_statement] = STATE(524),
    [sym_while_statement] = STATE(524),
    [sym_if_statement] = STATE(524),
    [sym_elif_clause] = STATE(1166),
    [sym_else_clause] = STATE(1164),
    [sym_case_statement] = STATE(524),
    [sym_function_definition] = STATE(524),
    [sym_compound_statement] = STATE(524),
    [sym_subshell] = STATE(524),
    [sym_pipeline] = STATE(524),
    [sym_list] = STATE(524),
    [sym_negated_command] = STATE(524),
    [sym_test_command] = STATE(524),
    [sym_declaration_command] = STATE(524),
    [sym_unset_command] = STATE(524),
    [sym_command] = STATE(524),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(525),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(1165),
    [aux_sym_if_statement_repeat1] = STATE(1166),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(2454),
    [anon_sym_elif] = ACTIONS(1323),
    [anon_sym_else] = ACTIONS(1325),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [690] = {
    [sym_elif_clause] = STATE(1167),
    [sym_else_clause] = STATE(1164),
    [aux_sym_if_statement_repeat1] = STATE(1167),
    [anon_sym_fi] = ACTIONS(2452),
    [anon_sym_elif] = ACTIONS(2456),
    [anon_sym_else] = ACTIONS(2458),
    [sym_comment] = ACTIONS(57),
  },
  [691] = {
    [sym__concat] = ACTIONS(1726),
    [anon_sym_in] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [692] = {
    [sym_case_item] = STATE(1173),
    [sym_last_case_item] = STATE(1171),
    [sym_concatenation] = STATE(1172),
    [sym_string] = STATE(1170),
    [sym_simple_expansion] = STATE(1170),
    [sym_string_expansion] = STATE(1170),
    [sym_expansion] = STATE(1170),
    [sym_command_substitution] = STATE(1170),
    [sym_process_substitution] = STATE(1170),
    [aux_sym_case_statement_repeat1] = STATE(1173),
    [anon_sym_esac] = ACTIONS(2460),
    [sym__special_characters] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(421),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(425),
    [anon_sym_GT_LPAREN] = ACTIONS(425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2466),
  },
  [693] = {
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym_SEMI_SEMI] = ACTIONS(2470),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2470),
    [anon_sym_AMP] = ACTIONS(2470),
  },
  [694] = {
    [aux_sym_concatenation_repeat1] = STATE(694),
    [sym__concat] = ACTIONS(2472),
    [anon_sym_in] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [695] = {
    [sym__concat] = ACTIONS(1733),
    [anon_sym_in] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_SEMI_SEMI] = ACTIONS(1733),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
  },
  [696] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(2475),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [697] = {
    [sym_case_item] = STATE(1178),
    [sym_last_case_item] = STATE(1177),
    [sym_concatenation] = STATE(1172),
    [sym_string] = STATE(1170),
    [sym_simple_expansion] = STATE(1170),
    [sym_string_expansion] = STATE(1170),
    [sym_expansion] = STATE(1170),
    [sym_command_substitution] = STATE(1170),
    [sym_process_substitution] = STATE(1170),
    [aux_sym_case_statement_repeat1] = STATE(1178),
    [anon_sym_esac] = ACTIONS(2477),
    [sym__special_characters] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(421),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(425),
    [anon_sym_GT_LPAREN] = ACTIONS(425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2466),
  },
  [698] = {
    [anon_sym_SEMI] = ACTIONS(2479),
    [anon_sym_SEMI_SEMI] = ACTIONS(2481),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2481),
    [anon_sym_AMP] = ACTIONS(2481),
  },
  [699] = {
    [sym_concatenation] = STATE(1183),
    [sym_string] = STATE(1182),
    [sym_simple_expansion] = STATE(1182),
    [sym_string_expansion] = STATE(1182),
    [sym_expansion] = STATE(1182),
    [sym_command_substitution] = STATE(1182),
    [sym_process_substitution] = STATE(1182),
    [anon_sym_RBRACE] = ACTIONS(2483),
    [sym__special_characters] = ACTIONS(2485),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(2487),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2487),
  },
  [700] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(2489),
    [sym_comment] = ACTIONS(57),
  },
  [701] = {
    [sym_concatenation] = STATE(1187),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1187),
    [anon_sym_RBRACE] = ACTIONS(2491),
    [anon_sym_EQ] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2493),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2495),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2497),
    [anon_sym_COLON] = ACTIONS(2493),
    [anon_sym_COLON_QMARK] = ACTIONS(2493),
    [anon_sym_COLON_DASH] = ACTIONS(2493),
    [anon_sym_PERCENT] = ACTIONS(2493),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [702] = {
    [sym_concatenation] = STATE(1189),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1189),
    [anon_sym_RBRACE] = ACTIONS(2483),
    [anon_sym_EQ] = ACTIONS(2499),
    [anon_sym_DASH] = ACTIONS(2499),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2501),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2503),
    [anon_sym_COLON] = ACTIONS(2499),
    [anon_sym_COLON_QMARK] = ACTIONS(2499),
    [anon_sym_COLON_DASH] = ACTIONS(2499),
    [anon_sym_PERCENT] = ACTIONS(2499),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [703] = {
    [sym__concat] = ACTIONS(1834),
    [anon_sym_in] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1836),
    [anon_sym_SEMI_SEMI] = ACTIONS(1834),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1834),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [704] = {
    [sym_concatenation] = STATE(1192),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1192),
    [sym_regex] = ACTIONS(2505),
    [anon_sym_RBRACE] = ACTIONS(2507),
    [anon_sym_EQ] = ACTIONS(2509),
    [anon_sym_DASH] = ACTIONS(2509),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(2509),
    [anon_sym_COLON_QMARK] = ACTIONS(2509),
    [anon_sym_COLON_DASH] = ACTIONS(2509),
    [anon_sym_PERCENT] = ACTIONS(2509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [705] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(2507),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [706] = {
    [sym__concat] = ACTIONS(1882),
    [anon_sym_in] = ACTIONS(1882),
    [anon_sym_SEMI] = ACTIONS(1884),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1882),
  },
  [707] = {
    [sym_concatenation] = STATE(1189),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1189),
    [sym_regex] = ACTIONS(2513),
    [anon_sym_RBRACE] = ACTIONS(2483),
    [anon_sym_EQ] = ACTIONS(2499),
    [anon_sym_DASH] = ACTIONS(2499),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2501),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(2499),
    [anon_sym_COLON_QMARK] = ACTIONS(2499),
    [anon_sym_COLON_DASH] = ACTIONS(2499),
    [anon_sym_PERCENT] = ACTIONS(2499),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [708] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(2483),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [709] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(2515),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [710] = {
    [sym__concat] = ACTIONS(1890),
    [anon_sym_in] = ACTIONS(1890),
    [anon_sym_SEMI] = ACTIONS(1892),
    [anon_sym_SEMI_SEMI] = ACTIONS(1890),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1890),
    [anon_sym_AMP] = ACTIONS(1890),
  },
  [711] = {
    [anon_sym_SEMI] = ACTIONS(2517),
    [anon_sym_RPAREN] = ACTIONS(2515),
    [anon_sym_SEMI_SEMI] = ACTIONS(2519),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2519),
    [anon_sym_AMP] = ACTIONS(2519),
  },
  [712] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1197),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(2521),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2515),
    [anon_sym_SEMI_SEMI] = ACTIONS(2523),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2523),
    [anon_sym_AMP] = ACTIONS(2521),
  },
  [713] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1197),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2521),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2515),
    [anon_sym_SEMI_SEMI] = ACTIONS(2523),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2523),
    [anon_sym_AMP] = ACTIONS(2521),
  },
  [714] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(2515),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [715] = {
    [anon_sym_SEMI] = ACTIONS(2525),
    [anon_sym_SEMI_SEMI] = ACTIONS(2527),
    [anon_sym_BQUOTE] = ACTIONS(2515),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2527),
    [anon_sym_AMP] = ACTIONS(2527),
  },
  [716] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1200),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(2529),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2531),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(2515),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2531),
    [anon_sym_AMP] = ACTIONS(2529),
  },
  [717] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1200),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2529),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2531),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(2515),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2531),
    [anon_sym_AMP] = ACTIONS(2529),
  },
  [718] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(2533),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [719] = {
    [sym__concat] = ACTIONS(1924),
    [anon_sym_in] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1924),
  },
  [720] = {
    [anon_sym_SEMI] = ACTIONS(2535),
    [anon_sym_RPAREN] = ACTIONS(2533),
    [anon_sym_SEMI_SEMI] = ACTIONS(2537),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2537),
    [anon_sym_AMP] = ACTIONS(2537),
  },
  [721] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1204),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(2539),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2533),
    [anon_sym_SEMI_SEMI] = ACTIONS(2541),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2541),
    [anon_sym_AMP] = ACTIONS(2539),
  },
  [722] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1204),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2539),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2533),
    [anon_sym_SEMI_SEMI] = ACTIONS(2541),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2541),
    [anon_sym_AMP] = ACTIONS(2539),
  },
  [723] = {
    [sym_compound_statement] = STATE(1205),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [724] = {
    [aux_sym_concatenation_repeat1] = STATE(1206),
    [sym__simple_heredoc_body] = ACTIONS(1107),
    [sym__heredoc_body_beginning] = ACTIONS(1107),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(1109),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_SEMI] = ACTIONS(1111),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_RPAREN] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT] = ACTIONS(1111),
    [anon_sym_AMP_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_AMP] = ACTIONS(1107),
    [anon_sym_GT_AMP] = ACTIONS(1107),
    [anon_sym_LT_LT] = ACTIONS(1111),
    [anon_sym_LT_LT_DASH] = ACTIONS(1107),
    [anon_sym_LT_LT_LT] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1111),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1111),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1111),
  },
  [725] = {
    [aux_sym_concatenation_repeat1] = STATE(1206),
    [sym__simple_heredoc_body] = ACTIONS(1085),
    [sym__heredoc_body_beginning] = ACTIONS(1085),
    [sym_file_descriptor] = ACTIONS(1085),
    [sym__concat] = ACTIONS(1109),
    [sym_variable_name] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(1085),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1087),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym__special_characters] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_DOLLAR] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1085),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [anon_sym_LT_LPAREN] = ACTIONS(1085),
    [anon_sym_GT_LPAREN] = ACTIONS(1085),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1087),
    [anon_sym_LF] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1087),
  },
  [726] = {
    [sym_concatenation] = STATE(787),
    [sym_string] = STATE(1208),
    [sym_array] = STATE(787),
    [sym_simple_expansion] = STATE(1208),
    [sym_string_expansion] = STATE(1208),
    [sym_expansion] = STATE(1208),
    [sym_command_substitution] = STATE(1208),
    [sym_process_substitution] = STATE(1208),
    [sym__empty_value] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1505),
    [sym__special_characters] = ACTIONS(2543),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(2545),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2545),
  },
  [727] = {
    [aux_sym_concatenation_repeat1] = STATE(1209),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(671),
    [sym_variable_name] = ACTIONS(779),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_RPAREN] = ACTIONS(779),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [sym_word] = ACTIONS(781),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [728] = {
    [sym_variable_assignment] = STATE(728),
    [sym_subscript] = STATE(314),
    [sym_concatenation] = STATE(728),
    [sym_string] = STATE(313),
    [sym_simple_expansion] = STATE(313),
    [sym_string_expansion] = STATE(313),
    [sym_expansion] = STATE(313),
    [sym_command_substitution] = STATE(313),
    [sym_process_substitution] = STATE(313),
    [aux_sym_declaration_command_repeat1] = STATE(728),
    [sym__simple_heredoc_body] = ACTIONS(1559),
    [sym__heredoc_body_beginning] = ACTIONS(1559),
    [sym_file_descriptor] = ACTIONS(1559),
    [sym_variable_name] = ACTIONS(2547),
    [anon_sym_SEMI] = ACTIONS(1564),
    [anon_sym_PIPE] = ACTIONS(1564),
    [anon_sym_RPAREN] = ACTIONS(1559),
    [anon_sym_SEMI_SEMI] = ACTIONS(1559),
    [anon_sym_PIPE_AMP] = ACTIONS(1559),
    [anon_sym_AMP_AMP] = ACTIONS(1559),
    [anon_sym_PIPE_PIPE] = ACTIONS(1559),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1564),
    [anon_sym_GT_GT] = ACTIONS(1559),
    [anon_sym_AMP_GT] = ACTIONS(1564),
    [anon_sym_AMP_GT_GT] = ACTIONS(1559),
    [anon_sym_LT_AMP] = ACTIONS(1559),
    [anon_sym_GT_AMP] = ACTIONS(1559),
    [anon_sym_LT_LT] = ACTIONS(1564),
    [anon_sym_LT_LT_DASH] = ACTIONS(1559),
    [anon_sym_LT_LT_LT] = ACTIONS(1559),
    [sym__special_characters] = ACTIONS(2550),
    [anon_sym_DQUOTE] = ACTIONS(1569),
    [anon_sym_DOLLAR] = ACTIONS(1572),
    [sym_raw_string] = ACTIONS(2553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1581),
    [anon_sym_BQUOTE] = ACTIONS(1584),
    [anon_sym_LT_LPAREN] = ACTIONS(1587),
    [anon_sym_GT_LPAREN] = ACTIONS(1587),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2556),
    [sym_word] = ACTIONS(2559),
    [anon_sym_LF] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1564),
  },
  [729] = {
    [aux_sym_concatenation_repeat1] = STATE(1210),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_RPAREN] = ACTIONS(779),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [sym_word] = ACTIONS(781),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [730] = {
    [sym_concatenation] = STATE(730),
    [sym_string] = STATE(317),
    [sym_simple_expansion] = STATE(317),
    [sym_string_expansion] = STATE(317),
    [sym_expansion] = STATE(317),
    [sym_command_substitution] = STATE(317),
    [sym_process_substitution] = STATE(317),
    [aux_sym_unset_command_repeat1] = STATE(730),
    [sym__simple_heredoc_body] = ACTIONS(1644),
    [sym__heredoc_body_beginning] = ACTIONS(1644),
    [sym_file_descriptor] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1646),
    [anon_sym_PIPE] = ACTIONS(1646),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1646),
    [anon_sym_GT] = ACTIONS(1646),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1646),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1644),
    [anon_sym_LT_LT_LT] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(1651),
    [anon_sym_DOLLAR] = ACTIONS(1654),
    [sym_raw_string] = ACTIONS(2565),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1663),
    [anon_sym_BQUOTE] = ACTIONS(1666),
    [anon_sym_LT_LPAREN] = ACTIONS(1669),
    [anon_sym_GT_LPAREN] = ACTIONS(1669),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2568),
    [sym_word] = ACTIONS(2571),
    [anon_sym_LF] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1646),
  },
  [731] = {
    [aux_sym_concatenation_repeat1] = STATE(731),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(1730),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_EQ_TILDE] = ACTIONS(1728),
    [anon_sym_EQ_EQ] = ACTIONS(1728),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [732] = {
    [sym_concatenation] = STATE(975),
    [sym_string] = STATE(1212),
    [sym_simple_expansion] = STATE(1212),
    [sym_string_expansion] = STATE(1212),
    [sym_expansion] = STATE(1212),
    [sym_command_substitution] = STATE(1212),
    [sym_process_substitution] = STATE(1212),
    [sym__special_characters] = ACTIONS(2574),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(2576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2576),
  },
  [733] = {
    [sym__simple_heredoc_body] = ACTIONS(2578),
    [sym__heredoc_body_beginning] = ACTIONS(2578),
    [sym_file_descriptor] = ACTIONS(2578),
    [ts_builtin_sym_end] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_esac] = ACTIONS(2578),
    [anon_sym_PIPE] = ACTIONS(2580),
    [anon_sym_RPAREN] = ACTIONS(2578),
    [anon_sym_SEMI_SEMI] = ACTIONS(2578),
    [anon_sym_PIPE_AMP] = ACTIONS(2578),
    [anon_sym_AMP_AMP] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2580),
    [anon_sym_GT] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2578),
    [anon_sym_AMP_GT] = ACTIONS(2580),
    [anon_sym_AMP_GT_GT] = ACTIONS(2578),
    [anon_sym_LT_AMP] = ACTIONS(2578),
    [anon_sym_GT_AMP] = ACTIONS(2578),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_LT_LT_DASH] = ACTIONS(2578),
    [anon_sym_LT_LT_LT] = ACTIONS(2578),
    [anon_sym_BQUOTE] = ACTIONS(2578),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2580),
  },
  [734] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_RPAREN] = ACTIONS(1964),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [735] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_RPAREN] = ACTIONS(1964),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [736] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(1968),
    [sym__heredoc_body_beginning] = ACTIONS(1968),
    [sym_file_descriptor] = ACTIONS(1968),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1968),
    [anon_sym_SEMI_SEMI] = ACTIONS(1968),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(1968),
    [anon_sym_PIPE_PIPE] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(1970),
    [anon_sym_GT] = ACTIONS(1970),
    [anon_sym_GT_GT] = ACTIONS(1968),
    [anon_sym_AMP_GT] = ACTIONS(1970),
    [anon_sym_AMP_GT_GT] = ACTIONS(1968),
    [anon_sym_LT_AMP] = ACTIONS(1968),
    [anon_sym_GT_AMP] = ACTIONS(1968),
    [anon_sym_LT_LT] = ACTIONS(1970),
    [anon_sym_LT_LT_DASH] = ACTIONS(1968),
    [anon_sym_LT_LT_LT] = ACTIONS(1968),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1968),
    [anon_sym_AMP] = ACTIONS(1970),
  },
  [737] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(1968),
    [sym__heredoc_body_beginning] = ACTIONS(1968),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(1968),
    [anon_sym_SEMI_SEMI] = ACTIONS(1968),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(1968),
    [anon_sym_PIPE_PIPE] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(1970),
    [anon_sym_LT_LT_DASH] = ACTIONS(1968),
    [anon_sym_LT_LT_LT] = ACTIONS(1968),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1968),
    [anon_sym_AMP] = ACTIONS(1970),
  },
  [738] = {
    [aux_sym_concatenation_repeat1] = STATE(1213),
    [sym__simple_heredoc_body] = ACTIONS(745),
    [sym__heredoc_body_beginning] = ACTIONS(745),
    [sym_file_descriptor] = ACTIONS(745),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_SEMI_SEMI] = ACTIONS(745),
    [anon_sym_PIPE_AMP] = ACTIONS(745),
    [anon_sym_AMP_AMP] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(745),
    [anon_sym_LT] = ACTIONS(749),
    [anon_sym_GT] = ACTIONS(749),
    [anon_sym_GT_GT] = ACTIONS(745),
    [anon_sym_AMP_GT] = ACTIONS(749),
    [anon_sym_AMP_GT_GT] = ACTIONS(745),
    [anon_sym_LT_AMP] = ACTIONS(745),
    [anon_sym_GT_AMP] = ACTIONS(745),
    [anon_sym_LT_LT] = ACTIONS(749),
    [anon_sym_LT_LT_DASH] = ACTIONS(745),
    [anon_sym_LT_LT_LT] = ACTIONS(745),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(749),
  },
  [739] = {
    [aux_sym_concatenation_repeat1] = STATE(1213),
    [sym__simple_heredoc_body] = ACTIONS(763),
    [sym__heredoc_body_beginning] = ACTIONS(763),
    [sym_file_descriptor] = ACTIONS(763),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(765),
    [anon_sym_RPAREN] = ACTIONS(763),
    [anon_sym_SEMI_SEMI] = ACTIONS(763),
    [anon_sym_PIPE_AMP] = ACTIONS(763),
    [anon_sym_AMP_AMP] = ACTIONS(763),
    [anon_sym_PIPE_PIPE] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(765),
    [anon_sym_GT_GT] = ACTIONS(763),
    [anon_sym_AMP_GT] = ACTIONS(765),
    [anon_sym_AMP_GT_GT] = ACTIONS(763),
    [anon_sym_LT_AMP] = ACTIONS(763),
    [anon_sym_GT_AMP] = ACTIONS(763),
    [anon_sym_LT_LT] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(763),
    [anon_sym_LT_LT_LT] = ACTIONS(763),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(763),
    [anon_sym_AMP] = ACTIONS(765),
  },
  [740] = {
    [aux_sym_concatenation_repeat1] = STATE(1213),
    [sym__simple_heredoc_body] = ACTIONS(1976),
    [sym__heredoc_body_beginning] = ACTIONS(1976),
    [sym_file_descriptor] = ACTIONS(1976),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1978),
    [anon_sym_RPAREN] = ACTIONS(1976),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(1976),
    [anon_sym_AMP_AMP] = ACTIONS(1976),
    [anon_sym_PIPE_PIPE] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1976),
    [anon_sym_AMP_GT] = ACTIONS(1978),
    [anon_sym_AMP_GT_GT] = ACTIONS(1976),
    [anon_sym_LT_AMP] = ACTIONS(1976),
    [anon_sym_GT_AMP] = ACTIONS(1976),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_LT_LT_DASH] = ACTIONS(1976),
    [anon_sym_LT_LT_LT] = ACTIONS(1976),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1978),
  },
  [741] = {
    [aux_sym_concatenation_repeat1] = STATE(1213),
    [sym__simple_heredoc_body] = ACTIONS(1980),
    [sym__heredoc_body_beginning] = ACTIONS(1980),
    [sym_file_descriptor] = ACTIONS(1980),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_SEMI_SEMI] = ACTIONS(1980),
    [anon_sym_PIPE_AMP] = ACTIONS(1980),
    [anon_sym_AMP_AMP] = ACTIONS(1980),
    [anon_sym_PIPE_PIPE] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_AMP_GT] = ACTIONS(1982),
    [anon_sym_AMP_GT_GT] = ACTIONS(1980),
    [anon_sym_LT_AMP] = ACTIONS(1980),
    [anon_sym_GT_AMP] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1982),
    [anon_sym_LT_LT_DASH] = ACTIONS(1980),
    [anon_sym_LT_LT_LT] = ACTIONS(1980),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1982),
  },
  [742] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(2582),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [743] = {
    [sym_file_redirect] = STATE(743),
    [sym_heredoc_redirect] = STATE(743),
    [sym_herestring_redirect] = STATE(743),
    [aux_sym_redirected_statement_repeat1] = STATE(743),
    [sym__simple_heredoc_body] = ACTIONS(1990),
    [sym__heredoc_body_beginning] = ACTIONS(1990),
    [sym_file_descriptor] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_RPAREN] = ACTIONS(1990),
    [anon_sym_SEMI_SEMI] = ACTIONS(1990),
    [anon_sym_PIPE_AMP] = ACTIONS(1990),
    [anon_sym_AMP_AMP] = ACTIONS(1990),
    [anon_sym_PIPE_PIPE] = ACTIONS(1990),
    [anon_sym_LT] = ACTIONS(2587),
    [anon_sym_GT] = ACTIONS(2587),
    [anon_sym_GT_GT] = ACTIONS(2590),
    [anon_sym_AMP_GT] = ACTIONS(2587),
    [anon_sym_AMP_GT_GT] = ACTIONS(2590),
    [anon_sym_LT_AMP] = ACTIONS(2590),
    [anon_sym_GT_AMP] = ACTIONS(2590),
    [anon_sym_LT_LT] = ACTIONS(2003),
    [anon_sym_LT_LT_DASH] = ACTIONS(2006),
    [anon_sym_LT_LT_LT] = ACTIONS(2593),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1995),
  },
  [744] = {
    [aux_sym_concatenation_repeat1] = STATE(319),
    [sym__simple_heredoc_body] = ACTIONS(2016),
    [sym__heredoc_body_beginning] = ACTIONS(2016),
    [sym_file_descriptor] = ACTIONS(2016),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(2018),
    [anon_sym_PIPE] = ACTIONS(2018),
    [anon_sym_RPAREN] = ACTIONS(2016),
    [anon_sym_SEMI_SEMI] = ACTIONS(2016),
    [anon_sym_PIPE_AMP] = ACTIONS(2016),
    [anon_sym_AMP_AMP] = ACTIONS(2016),
    [anon_sym_PIPE_PIPE] = ACTIONS(2016),
    [anon_sym_EQ_TILDE] = ACTIONS(2018),
    [anon_sym_EQ_EQ] = ACTIONS(2018),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(2018),
    [anon_sym_GT_GT] = ACTIONS(2016),
    [anon_sym_AMP_GT] = ACTIONS(2018),
    [anon_sym_AMP_GT_GT] = ACTIONS(2016),
    [anon_sym_LT_AMP] = ACTIONS(2016),
    [anon_sym_GT_AMP] = ACTIONS(2016),
    [anon_sym_LT_LT] = ACTIONS(2018),
    [anon_sym_LT_LT_DASH] = ACTIONS(2016),
    [anon_sym_LT_LT_LT] = ACTIONS(2016),
    [sym__special_characters] = ACTIONS(2016),
    [anon_sym_DQUOTE] = ACTIONS(2016),
    [anon_sym_DOLLAR] = ACTIONS(2018),
    [sym_raw_string] = ACTIONS(2016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2016),
    [anon_sym_BQUOTE] = ACTIONS(2016),
    [anon_sym_LT_LPAREN] = ACTIONS(2016),
    [anon_sym_GT_LPAREN] = ACTIONS(2016),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2018),
    [anon_sym_LF] = ACTIONS(2016),
    [anon_sym_AMP] = ACTIONS(2018),
  },
  [745] = {
    [aux_sym_concatenation_repeat1] = STATE(319),
    [sym__simple_heredoc_body] = ACTIONS(2012),
    [sym__heredoc_body_beginning] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_RPAREN] = ACTIONS(2012),
    [anon_sym_SEMI_SEMI] = ACTIONS(2012),
    [anon_sym_PIPE_AMP] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_EQ_TILDE] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_GT] = ACTIONS(2012),
    [anon_sym_AMP_GT] = ACTIONS(2014),
    [anon_sym_AMP_GT_GT] = ACTIONS(2012),
    [anon_sym_LT_AMP] = ACTIONS(2012),
    [anon_sym_GT_AMP] = ACTIONS(2012),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_DASH] = ACTIONS(2012),
    [anon_sym_LT_LT_LT] = ACTIONS(2012),
    [sym__special_characters] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2012),
    [anon_sym_DOLLAR] = ACTIONS(2014),
    [sym_raw_string] = ACTIONS(2012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2012),
    [anon_sym_BQUOTE] = ACTIONS(2012),
    [anon_sym_LT_LPAREN] = ACTIONS(2012),
    [anon_sym_GT_LPAREN] = ACTIONS(2012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2014),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2014),
  },
  [746] = {
    [sym_concatenation] = STATE(746),
    [sym_string] = STATE(331),
    [sym_simple_expansion] = STATE(331),
    [sym_string_expansion] = STATE(331),
    [sym_expansion] = STATE(331),
    [sym_command_substitution] = STATE(331),
    [sym_process_substitution] = STATE(331),
    [aux_sym_command_repeat2] = STATE(746),
    [sym__simple_heredoc_body] = ACTIONS(2012),
    [sym__heredoc_body_beginning] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_RPAREN] = ACTIONS(2012),
    [anon_sym_SEMI_SEMI] = ACTIONS(2012),
    [anon_sym_PIPE_AMP] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_EQ_TILDE] = ACTIONS(2596),
    [anon_sym_EQ_EQ] = ACTIONS(2596),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_GT] = ACTIONS(2012),
    [anon_sym_AMP_GT] = ACTIONS(2014),
    [anon_sym_AMP_GT_GT] = ACTIONS(2012),
    [anon_sym_LT_AMP] = ACTIONS(2012),
    [anon_sym_GT_AMP] = ACTIONS(2012),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_DASH] = ACTIONS(2012),
    [anon_sym_LT_LT_LT] = ACTIONS(2012),
    [sym__special_characters] = ACTIONS(2599),
    [anon_sym_DQUOTE] = ACTIONS(2026),
    [anon_sym_DOLLAR] = ACTIONS(2029),
    [sym_raw_string] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2035),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2038),
    [anon_sym_BQUOTE] = ACTIONS(2041),
    [anon_sym_LT_LPAREN] = ACTIONS(2044),
    [anon_sym_GT_LPAREN] = ACTIONS(2044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2605),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2014),
  },
  [747] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(2582),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [748] = {
    [anon_sym_SEMI] = ACTIONS(2608),
    [anon_sym_RPAREN] = ACTIONS(2582),
    [anon_sym_SEMI_SEMI] = ACTIONS(2610),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2610),
    [anon_sym_AMP] = ACTIONS(2610),
  },
  [749] = {
    [sym_concatenation] = STATE(746),
    [sym_string] = STATE(331),
    [sym_simple_expansion] = STATE(331),
    [sym_string_expansion] = STATE(331),
    [sym_expansion] = STATE(331),
    [sym_command_substitution] = STATE(331),
    [sym_process_substitution] = STATE(331),
    [aux_sym_command_repeat2] = STATE(746),
    [sym__simple_heredoc_body] = ACTIONS(2058),
    [sym__heredoc_body_beginning] = ACTIONS(2058),
    [sym_file_descriptor] = ACTIONS(2058),
    [anon_sym_SEMI] = ACTIONS(2060),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_RPAREN] = ACTIONS(2058),
    [anon_sym_SEMI_SEMI] = ACTIONS(2058),
    [anon_sym_PIPE_AMP] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_PIPE_PIPE] = ACTIONS(2058),
    [anon_sym_EQ_TILDE] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(603),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2058),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2058),
    [anon_sym_LT_AMP] = ACTIONS(2058),
    [anon_sym_GT_AMP] = ACTIONS(2058),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2058),
    [anon_sym_LT_LT_LT] = ACTIONS(2058),
    [sym__special_characters] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(607),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(609),
    [anon_sym_LF] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2060),
  },
  [750] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [751] = {
    [sym_file_descriptor] = ACTIONS(1085),
    [sym_variable_name] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [sym__special_characters] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_DOLLAR] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1085),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [anon_sym_LT_LPAREN] = ACTIONS(1085),
    [anon_sym_GT_LPAREN] = ACTIONS(1085),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1085),
  },
  [752] = {
    [sym_concatenation] = STATE(1217),
    [sym_string] = STATE(537),
    [sym_simple_expansion] = STATE(537),
    [sym_string_expansion] = STATE(537),
    [sym_expansion] = STATE(537),
    [sym_command_substitution] = STATE(537),
    [sym_process_substitution] = STATE(537),
    [aux_sym_for_statement_repeat1] = STATE(1217),
    [anon_sym_RPAREN] = ACTIONS(2612),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1095),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
  },
  [753] = {
    [aux_sym_concatenation_repeat1] = STATE(417),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(747),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT] = ACTIONS(1111),
    [anon_sym_AMP_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_AMP] = ACTIONS(1107),
    [anon_sym_GT_AMP] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1111),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1107),
  },
  [754] = {
    [aux_sym_concatenation_repeat1] = STATE(417),
    [sym_file_descriptor] = ACTIONS(1085),
    [sym__concat] = ACTIONS(747),
    [sym_variable_name] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [sym__special_characters] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_DOLLAR] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1085),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [anon_sym_LT_LPAREN] = ACTIONS(1085),
    [anon_sym_GT_LPAREN] = ACTIONS(1085),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1085),
  },
  [755] = {
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_RBRACK] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2306),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2306),
  },
  [756] = {
    [sym__concat] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_RBRACK] = ACTIONS(1726),
    [anon_sym_EQ_TILDE] = ACTIONS(1726),
    [anon_sym_EQ_EQ] = ACTIONS(1726),
    [anon_sym_EQ] = ACTIONS(1728),
    [anon_sym_PLUS_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_BANG_EQ] = ACTIONS(1726),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_DASH] = ACTIONS(1728),
    [anon_sym_DASH_EQ] = ACTIONS(1726),
    [anon_sym_LT_EQ] = ACTIONS(1726),
    [anon_sym_GT_EQ] = ACTIONS(1726),
    [anon_sym_PLUS_PLUS] = ACTIONS(1726),
    [anon_sym_DASH_DASH] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1726),
  },
  [757] = {
    [aux_sym_concatenation_repeat1] = STATE(757),
    [sym__concat] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_RBRACK] = ACTIONS(1726),
    [anon_sym_EQ_TILDE] = ACTIONS(1726),
    [anon_sym_EQ_EQ] = ACTIONS(1726),
    [anon_sym_EQ] = ACTIONS(1728),
    [anon_sym_PLUS_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_BANG_EQ] = ACTIONS(1726),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_DASH] = ACTIONS(1728),
    [anon_sym_DASH_EQ] = ACTIONS(1726),
    [anon_sym_LT_EQ] = ACTIONS(1726),
    [anon_sym_GT_EQ] = ACTIONS(1726),
    [anon_sym_PLUS_PLUS] = ACTIONS(1726),
    [anon_sym_DASH_DASH] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1726),
  },
  [758] = {
    [sym__concat] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1733),
    [anon_sym_RBRACK] = ACTIONS(1733),
    [anon_sym_EQ_TILDE] = ACTIONS(1733),
    [anon_sym_EQ_EQ] = ACTIONS(1733),
    [anon_sym_EQ] = ACTIONS(1735),
    [anon_sym_PLUS_EQ] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1735),
    [anon_sym_GT] = ACTIONS(1735),
    [anon_sym_BANG_EQ] = ACTIONS(1733),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_DASH_EQ] = ACTIONS(1733),
    [anon_sym_LT_EQ] = ACTIONS(1733),
    [anon_sym_GT_EQ] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1733),
  },
  [759] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(2617),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [760] = {
    [sym_concatenation] = STATE(1222),
    [sym_string] = STATE(1221),
    [sym_simple_expansion] = STATE(1221),
    [sym_string_expansion] = STATE(1221),
    [sym_expansion] = STATE(1221),
    [sym_command_substitution] = STATE(1221),
    [sym_process_substitution] = STATE(1221),
    [anon_sym_RBRACE] = ACTIONS(2619),
    [sym__special_characters] = ACTIONS(2621),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(2623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2623),
  },
  [761] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(2625),
    [sym_comment] = ACTIONS(57),
  },
  [762] = {
    [sym_concatenation] = STATE(1226),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1226),
    [anon_sym_RBRACE] = ACTIONS(2627),
    [anon_sym_EQ] = ACTIONS(2629),
    [anon_sym_DASH] = ACTIONS(2629),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2631),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2633),
    [anon_sym_COLON] = ACTIONS(2629),
    [anon_sym_COLON_QMARK] = ACTIONS(2629),
    [anon_sym_COLON_DASH] = ACTIONS(2629),
    [anon_sym_PERCENT] = ACTIONS(2629),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [763] = {
    [sym_concatenation] = STATE(1228),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1228),
    [anon_sym_RBRACE] = ACTIONS(2619),
    [anon_sym_EQ] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2637),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2639),
    [anon_sym_COLON] = ACTIONS(2635),
    [anon_sym_COLON_QMARK] = ACTIONS(2635),
    [anon_sym_COLON_DASH] = ACTIONS(2635),
    [anon_sym_PERCENT] = ACTIONS(2635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [764] = {
    [sym__concat] = ACTIONS(1834),
    [anon_sym_AMP_AMP] = ACTIONS(1834),
    [anon_sym_PIPE_PIPE] = ACTIONS(1834),
    [anon_sym_RBRACK] = ACTIONS(1834),
    [anon_sym_EQ_TILDE] = ACTIONS(1834),
    [anon_sym_EQ_EQ] = ACTIONS(1834),
    [anon_sym_EQ] = ACTIONS(1836),
    [anon_sym_PLUS_EQ] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1836),
    [anon_sym_GT] = ACTIONS(1836),
    [anon_sym_BANG_EQ] = ACTIONS(1834),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_DASH] = ACTIONS(1836),
    [anon_sym_DASH_EQ] = ACTIONS(1834),
    [anon_sym_LT_EQ] = ACTIONS(1834),
    [anon_sym_GT_EQ] = ACTIONS(1834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1834),
    [anon_sym_DASH_DASH] = ACTIONS(1834),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1834),
  },
  [765] = {
    [sym_concatenation] = STATE(1231),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1231),
    [sym_regex] = ACTIONS(2641),
    [anon_sym_RBRACE] = ACTIONS(2643),
    [anon_sym_EQ] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2645),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2647),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(2645),
    [anon_sym_COLON_QMARK] = ACTIONS(2645),
    [anon_sym_COLON_DASH] = ACTIONS(2645),
    [anon_sym_PERCENT] = ACTIONS(2645),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [766] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(2643),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [767] = {
    [sym__concat] = ACTIONS(1882),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_RBRACK] = ACTIONS(1882),
    [anon_sym_EQ_TILDE] = ACTIONS(1882),
    [anon_sym_EQ_EQ] = ACTIONS(1882),
    [anon_sym_EQ] = ACTIONS(1884),
    [anon_sym_PLUS_EQ] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1884),
    [anon_sym_BANG_EQ] = ACTIONS(1882),
    [anon_sym_PLUS] = ACTIONS(1884),
    [anon_sym_DASH] = ACTIONS(1884),
    [anon_sym_DASH_EQ] = ACTIONS(1882),
    [anon_sym_LT_EQ] = ACTIONS(1882),
    [anon_sym_GT_EQ] = ACTIONS(1882),
    [anon_sym_PLUS_PLUS] = ACTIONS(1882),
    [anon_sym_DASH_DASH] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1882),
  },
  [768] = {
    [sym_concatenation] = STATE(1228),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1228),
    [sym_regex] = ACTIONS(2649),
    [anon_sym_RBRACE] = ACTIONS(2619),
    [anon_sym_EQ] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2637),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(2635),
    [anon_sym_COLON_QMARK] = ACTIONS(2635),
    [anon_sym_COLON_DASH] = ACTIONS(2635),
    [anon_sym_PERCENT] = ACTIONS(2635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [769] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(2619),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [770] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(2651),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [771] = {
    [sym__concat] = ACTIONS(1890),
    [anon_sym_AMP_AMP] = ACTIONS(1890),
    [anon_sym_PIPE_PIPE] = ACTIONS(1890),
    [anon_sym_RBRACK] = ACTIONS(1890),
    [anon_sym_EQ_TILDE] = ACTIONS(1890),
    [anon_sym_EQ_EQ] = ACTIONS(1890),
    [anon_sym_EQ] = ACTIONS(1892),
    [anon_sym_PLUS_EQ] = ACTIONS(1890),
    [anon_sym_LT] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(1892),
    [anon_sym_BANG_EQ] = ACTIONS(1890),
    [anon_sym_PLUS] = ACTIONS(1892),
    [anon_sym_DASH] = ACTIONS(1892),
    [anon_sym_DASH_EQ] = ACTIONS(1890),
    [anon_sym_LT_EQ] = ACTIONS(1890),
    [anon_sym_GT_EQ] = ACTIONS(1890),
    [anon_sym_PLUS_PLUS] = ACTIONS(1890),
    [anon_sym_DASH_DASH] = ACTIONS(1890),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1890),
  },
  [772] = {
    [anon_sym_SEMI] = ACTIONS(2653),
    [anon_sym_RPAREN] = ACTIONS(2651),
    [anon_sym_SEMI_SEMI] = ACTIONS(2655),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2655),
  },
  [773] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1236),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(2657),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2651),
    [anon_sym_SEMI_SEMI] = ACTIONS(2659),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2657),
  },
  [774] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1236),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2657),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2651),
    [anon_sym_SEMI_SEMI] = ACTIONS(2659),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2657),
  },
  [775] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(2651),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [776] = {
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym_SEMI_SEMI] = ACTIONS(2663),
    [anon_sym_BQUOTE] = ACTIONS(2651),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2663),
  },
  [777] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1239),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2667),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(2651),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2665),
  },
  [778] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1239),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2667),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(2651),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2665),
  },
  [779] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(2669),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [780] = {
    [sym__concat] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_RBRACK] = ACTIONS(1924),
    [anon_sym_EQ_TILDE] = ACTIONS(1924),
    [anon_sym_EQ_EQ] = ACTIONS(1924),
    [anon_sym_EQ] = ACTIONS(1926),
    [anon_sym_PLUS_EQ] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_BANG_EQ] = ACTIONS(1924),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_DASH_EQ] = ACTIONS(1924),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_PLUS_PLUS] = ACTIONS(1924),
    [anon_sym_DASH_DASH] = ACTIONS(1924),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1924),
  },
  [781] = {
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym_RPAREN] = ACTIONS(2669),
    [anon_sym_SEMI_SEMI] = ACTIONS(2673),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2673),
    [anon_sym_AMP] = ACTIONS(2673),
  },
  [782] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1243),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2669),
    [anon_sym_SEMI_SEMI] = ACTIONS(2677),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2677),
    [anon_sym_AMP] = ACTIONS(2675),
  },
  [783] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1243),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2669),
    [anon_sym_SEMI_SEMI] = ACTIONS(2677),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2677),
    [anon_sym_AMP] = ACTIONS(2675),
  },
  [784] = {
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_RBRACK] = ACTIONS(2377),
    [anon_sym_EQ_TILDE] = ACTIONS(2377),
    [anon_sym_EQ_EQ] = ACTIONS(2377),
    [anon_sym_EQ] = ACTIONS(2379),
    [anon_sym_PLUS_EQ] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2379),
    [anon_sym_GT] = ACTIONS(2379),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2379),
    [anon_sym_DASH] = ACTIONS(2379),
    [anon_sym_DASH_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_PLUS_PLUS] = ACTIONS(2377),
    [anon_sym_DASH_DASH] = ACTIONS(2377),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2377),
  },
  [785] = {
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_RBRACK] = ACTIONS(2377),
    [anon_sym_EQ_TILDE] = ACTIONS(2377),
    [anon_sym_EQ_EQ] = ACTIONS(2377),
    [anon_sym_EQ] = ACTIONS(2379),
    [anon_sym_PLUS_EQ] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2379),
    [anon_sym_GT] = ACTIONS(2379),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2379),
    [anon_sym_DASH] = ACTIONS(2379),
    [anon_sym_DASH_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_PLUS_PLUS] = ACTIONS(2377),
    [anon_sym_DASH_DASH] = ACTIONS(2377),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2377),
  },
  [786] = {
    [aux_sym_concatenation_repeat1] = STATE(786),
    [sym__concat] = ACTIONS(2312),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1726),
    [anon_sym_EQ_TILDE] = ACTIONS(1726),
    [anon_sym_EQ_EQ] = ACTIONS(1726),
    [anon_sym_EQ] = ACTIONS(1728),
    [anon_sym_PLUS_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_BANG_EQ] = ACTIONS(1726),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_DASH] = ACTIONS(1728),
    [anon_sym_DASH_EQ] = ACTIONS(1726),
    [anon_sym_LT_EQ] = ACTIONS(1726),
    [anon_sym_GT_EQ] = ACTIONS(1726),
    [anon_sym_PLUS_PLUS] = ACTIONS(1726),
    [anon_sym_DASH_DASH] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1726),
  },
  [787] = {
    [sym__simple_heredoc_body] = ACTIONS(1085),
    [sym__heredoc_body_beginning] = ACTIONS(1085),
    [sym_file_descriptor] = ACTIONS(1085),
    [sym_variable_name] = ACTIONS(1085),
    [ts_builtin_sym_end] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(1085),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1087),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym__special_characters] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_DOLLAR] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1085),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [anon_sym_LT_LPAREN] = ACTIONS(1085),
    [anon_sym_GT_LPAREN] = ACTIONS(1085),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1087),
    [sym_word] = ACTIONS(1087),
    [anon_sym_LF] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1087),
  },
  [788] = {
    [sym_concatenation] = STATE(1245),
    [sym_string] = STATE(537),
    [sym_simple_expansion] = STATE(537),
    [sym_string_expansion] = STATE(537),
    [sym_expansion] = STATE(537),
    [sym_command_substitution] = STATE(537),
    [sym_process_substitution] = STATE(537),
    [aux_sym_for_statement_repeat1] = STATE(1245),
    [anon_sym_RPAREN] = ACTIONS(2679),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1095),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
  },
  [789] = {
    [aux_sym_concatenation_repeat1] = STATE(373),
    [sym__simple_heredoc_body] = ACTIONS(1107),
    [sym__heredoc_body_beginning] = ACTIONS(1107),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(671),
    [sym_variable_name] = ACTIONS(1107),
    [ts_builtin_sym_end] = ACTIONS(1107),
    [anon_sym_SEMI] = ACTIONS(1111),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_SEMI_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT] = ACTIONS(1111),
    [anon_sym_AMP_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_AMP] = ACTIONS(1107),
    [anon_sym_GT_AMP] = ACTIONS(1107),
    [anon_sym_LT_LT] = ACTIONS(1111),
    [anon_sym_LT_LT_DASH] = ACTIONS(1107),
    [anon_sym_LT_LT_LT] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1111),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1111),
    [sym_word] = ACTIONS(1111),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1111),
  },
  [790] = {
    [aux_sym_concatenation_repeat1] = STATE(373),
    [sym__simple_heredoc_body] = ACTIONS(1085),
    [sym__heredoc_body_beginning] = ACTIONS(1085),
    [sym_file_descriptor] = ACTIONS(1085),
    [sym__concat] = ACTIONS(671),
    [sym_variable_name] = ACTIONS(1085),
    [ts_builtin_sym_end] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1087),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym__special_characters] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_DOLLAR] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1085),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [anon_sym_LT_LPAREN] = ACTIONS(1085),
    [anon_sym_GT_LPAREN] = ACTIONS(1085),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1087),
    [sym_word] = ACTIONS(1087),
    [anon_sym_LF] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1087),
  },
  [791] = {
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(1726),
    [sym_variable_name] = ACTIONS(1726),
    [ts_builtin_sym_end] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1728),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [792] = {
    [aux_sym_concatenation_repeat1] = STATE(792),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(2681),
    [sym_variable_name] = ACTIONS(1726),
    [ts_builtin_sym_end] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1728),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [793] = {
    [sym__simple_heredoc_body] = ACTIONS(1733),
    [sym__heredoc_body_beginning] = ACTIONS(1733),
    [sym_file_descriptor] = ACTIONS(1733),
    [sym__concat] = ACTIONS(1733),
    [sym_variable_name] = ACTIONS(1733),
    [ts_builtin_sym_end] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_PIPE] = ACTIONS(1735),
    [anon_sym_RPAREN] = ACTIONS(1733),
    [anon_sym_SEMI_SEMI] = ACTIONS(1733),
    [anon_sym_PIPE_AMP] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1735),
    [anon_sym_GT] = ACTIONS(1735),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_AMP_GT] = ACTIONS(1735),
    [anon_sym_AMP_GT_GT] = ACTIONS(1733),
    [anon_sym_LT_AMP] = ACTIONS(1733),
    [anon_sym_GT_AMP] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1735),
    [anon_sym_LT_LT_DASH] = ACTIONS(1733),
    [anon_sym_LT_LT_LT] = ACTIONS(1733),
    [sym__special_characters] = ACTIONS(1733),
    [anon_sym_DQUOTE] = ACTIONS(1733),
    [anon_sym_DOLLAR] = ACTIONS(1735),
    [sym_raw_string] = ACTIONS(1733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1733),
    [anon_sym_BQUOTE] = ACTIONS(1733),
    [anon_sym_LT_LPAREN] = ACTIONS(1733),
    [anon_sym_GT_LPAREN] = ACTIONS(1733),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1735),
    [sym_word] = ACTIONS(1735),
    [anon_sym_LF] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1735),
  },
  [794] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(2684),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [795] = {
    [sym_concatenation] = STATE(1250),
    [sym_string] = STATE(1249),
    [sym_simple_expansion] = STATE(1249),
    [sym_string_expansion] = STATE(1249),
    [sym_expansion] = STATE(1249),
    [sym_command_substitution] = STATE(1249),
    [sym_process_substitution] = STATE(1249),
    [anon_sym_RBRACE] = ACTIONS(2686),
    [sym__special_characters] = ACTIONS(2688),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(2690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2690),
  },
  [796] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(2692),
    [sym_comment] = ACTIONS(57),
  },
  [797] = {
    [sym_concatenation] = STATE(1254),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1254),
    [anon_sym_RBRACE] = ACTIONS(2694),
    [anon_sym_EQ] = ACTIONS(2696),
    [anon_sym_DASH] = ACTIONS(2696),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2696),
    [anon_sym_COLON_QMARK] = ACTIONS(2696),
    [anon_sym_COLON_DASH] = ACTIONS(2696),
    [anon_sym_PERCENT] = ACTIONS(2696),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [798] = {
    [sym_concatenation] = STATE(1256),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1256),
    [anon_sym_RBRACE] = ACTIONS(2686),
    [anon_sym_EQ] = ACTIONS(2702),
    [anon_sym_DASH] = ACTIONS(2702),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2706),
    [anon_sym_COLON] = ACTIONS(2702),
    [anon_sym_COLON_QMARK] = ACTIONS(2702),
    [anon_sym_COLON_DASH] = ACTIONS(2702),
    [anon_sym_PERCENT] = ACTIONS(2702),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [799] = {
    [sym__simple_heredoc_body] = ACTIONS(1834),
    [sym__heredoc_body_beginning] = ACTIONS(1834),
    [sym_file_descriptor] = ACTIONS(1834),
    [sym__concat] = ACTIONS(1834),
    [sym_variable_name] = ACTIONS(1834),
    [ts_builtin_sym_end] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1836),
    [anon_sym_PIPE] = ACTIONS(1836),
    [anon_sym_RPAREN] = ACTIONS(1834),
    [anon_sym_SEMI_SEMI] = ACTIONS(1834),
    [anon_sym_PIPE_AMP] = ACTIONS(1834),
    [anon_sym_AMP_AMP] = ACTIONS(1834),
    [anon_sym_PIPE_PIPE] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1836),
    [anon_sym_GT] = ACTIONS(1836),
    [anon_sym_GT_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT] = ACTIONS(1836),
    [anon_sym_AMP_GT_GT] = ACTIONS(1834),
    [anon_sym_LT_AMP] = ACTIONS(1834),
    [anon_sym_GT_AMP] = ACTIONS(1834),
    [anon_sym_LT_LT] = ACTIONS(1836),
    [anon_sym_LT_LT_DASH] = ACTIONS(1834),
    [anon_sym_LT_LT_LT] = ACTIONS(1834),
    [sym__special_characters] = ACTIONS(1834),
    [anon_sym_DQUOTE] = ACTIONS(1834),
    [anon_sym_DOLLAR] = ACTIONS(1836),
    [sym_raw_string] = ACTIONS(1834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1834),
    [anon_sym_BQUOTE] = ACTIONS(1834),
    [anon_sym_LT_LPAREN] = ACTIONS(1834),
    [anon_sym_GT_LPAREN] = ACTIONS(1834),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1836),
    [sym_word] = ACTIONS(1836),
    [anon_sym_LF] = ACTIONS(1834),
    [anon_sym_AMP] = ACTIONS(1836),
  },
  [800] = {
    [sym_concatenation] = STATE(1259),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1259),
    [sym_regex] = ACTIONS(2708),
    [anon_sym_RBRACE] = ACTIONS(2710),
    [anon_sym_EQ] = ACTIONS(2712),
    [anon_sym_DASH] = ACTIONS(2712),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2714),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(2712),
    [anon_sym_COLON_QMARK] = ACTIONS(2712),
    [anon_sym_COLON_DASH] = ACTIONS(2712),
    [anon_sym_PERCENT] = ACTIONS(2712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [801] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(2710),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [802] = {
    [sym__simple_heredoc_body] = ACTIONS(1882),
    [sym__heredoc_body_beginning] = ACTIONS(1882),
    [sym_file_descriptor] = ACTIONS(1882),
    [sym__concat] = ACTIONS(1882),
    [sym_variable_name] = ACTIONS(1882),
    [ts_builtin_sym_end] = ACTIONS(1882),
    [anon_sym_SEMI] = ACTIONS(1884),
    [anon_sym_PIPE] = ACTIONS(1884),
    [anon_sym_RPAREN] = ACTIONS(1882),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [anon_sym_PIPE_AMP] = ACTIONS(1882),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1884),
    [anon_sym_GT_GT] = ACTIONS(1882),
    [anon_sym_AMP_GT] = ACTIONS(1884),
    [anon_sym_AMP_GT_GT] = ACTIONS(1882),
    [anon_sym_LT_AMP] = ACTIONS(1882),
    [anon_sym_GT_AMP] = ACTIONS(1882),
    [anon_sym_LT_LT] = ACTIONS(1884),
    [anon_sym_LT_LT_DASH] = ACTIONS(1882),
    [anon_sym_LT_LT_LT] = ACTIONS(1882),
    [sym__special_characters] = ACTIONS(1882),
    [anon_sym_DQUOTE] = ACTIONS(1882),
    [anon_sym_DOLLAR] = ACTIONS(1884),
    [sym_raw_string] = ACTIONS(1882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1882),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [anon_sym_LT_LPAREN] = ACTIONS(1882),
    [anon_sym_GT_LPAREN] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1884),
    [sym_word] = ACTIONS(1884),
    [anon_sym_LF] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1884),
  },
  [803] = {
    [sym_concatenation] = STATE(1256),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1256),
    [sym_regex] = ACTIONS(2716),
    [anon_sym_RBRACE] = ACTIONS(2686),
    [anon_sym_EQ] = ACTIONS(2702),
    [anon_sym_DASH] = ACTIONS(2702),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(2702),
    [anon_sym_COLON_QMARK] = ACTIONS(2702),
    [anon_sym_COLON_DASH] = ACTIONS(2702),
    [anon_sym_PERCENT] = ACTIONS(2702),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [804] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(2686),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [805] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(2718),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [806] = {
    [sym__simple_heredoc_body] = ACTIONS(1890),
    [sym__heredoc_body_beginning] = ACTIONS(1890),
    [sym_file_descriptor] = ACTIONS(1890),
    [sym__concat] = ACTIONS(1890),
    [sym_variable_name] = ACTIONS(1890),
    [ts_builtin_sym_end] = ACTIONS(1890),
    [anon_sym_SEMI] = ACTIONS(1892),
    [anon_sym_PIPE] = ACTIONS(1892),
    [anon_sym_RPAREN] = ACTIONS(1890),
    [anon_sym_SEMI_SEMI] = ACTIONS(1890),
    [anon_sym_PIPE_AMP] = ACTIONS(1890),
    [anon_sym_AMP_AMP] = ACTIONS(1890),
    [anon_sym_PIPE_PIPE] = ACTIONS(1890),
    [anon_sym_LT] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(1892),
    [anon_sym_GT_GT] = ACTIONS(1890),
    [anon_sym_AMP_GT] = ACTIONS(1892),
    [anon_sym_AMP_GT_GT] = ACTIONS(1890),
    [anon_sym_LT_AMP] = ACTIONS(1890),
    [anon_sym_GT_AMP] = ACTIONS(1890),
    [anon_sym_LT_LT] = ACTIONS(1892),
    [anon_sym_LT_LT_DASH] = ACTIONS(1890),
    [anon_sym_LT_LT_LT] = ACTIONS(1890),
    [sym__special_characters] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1890),
    [anon_sym_DOLLAR] = ACTIONS(1892),
    [sym_raw_string] = ACTIONS(1890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1890),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [anon_sym_LT_LPAREN] = ACTIONS(1890),
    [anon_sym_GT_LPAREN] = ACTIONS(1890),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1892),
    [sym_word] = ACTIONS(1892),
    [anon_sym_LF] = ACTIONS(1890),
    [anon_sym_AMP] = ACTIONS(1892),
  },
  [807] = {
    [anon_sym_SEMI] = ACTIONS(2720),
    [anon_sym_RPAREN] = ACTIONS(2718),
    [anon_sym_SEMI_SEMI] = ACTIONS(2722),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2722),
    [anon_sym_AMP] = ACTIONS(2722),
  },
  [808] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1264),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(2724),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2718),
    [anon_sym_SEMI_SEMI] = ACTIONS(2726),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2726),
    [anon_sym_AMP] = ACTIONS(2724),
  },
  [809] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1264),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2724),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2718),
    [anon_sym_SEMI_SEMI] = ACTIONS(2726),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2726),
    [anon_sym_AMP] = ACTIONS(2724),
  },
  [810] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(2718),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [811] = {
    [anon_sym_SEMI] = ACTIONS(2728),
    [anon_sym_SEMI_SEMI] = ACTIONS(2730),
    [anon_sym_BQUOTE] = ACTIONS(2718),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2730),
    [anon_sym_AMP] = ACTIONS(2730),
  },
  [812] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1267),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(2732),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2734),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(2718),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2732),
  },
  [813] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1267),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2732),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2734),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(2718),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2732),
  },
  [814] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [815] = {
    [sym__simple_heredoc_body] = ACTIONS(1924),
    [sym__heredoc_body_beginning] = ACTIONS(1924),
    [sym_file_descriptor] = ACTIONS(1924),
    [sym__concat] = ACTIONS(1924),
    [sym_variable_name] = ACTIONS(1924),
    [ts_builtin_sym_end] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_RPAREN] = ACTIONS(1924),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [anon_sym_PIPE_AMP] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_GT_GT] = ACTIONS(1924),
    [anon_sym_AMP_GT] = ACTIONS(1926),
    [anon_sym_AMP_GT_GT] = ACTIONS(1924),
    [anon_sym_LT_AMP] = ACTIONS(1924),
    [anon_sym_GT_AMP] = ACTIONS(1924),
    [anon_sym_LT_LT] = ACTIONS(1926),
    [anon_sym_LT_LT_DASH] = ACTIONS(1924),
    [anon_sym_LT_LT_LT] = ACTIONS(1924),
    [sym__special_characters] = ACTIONS(1924),
    [anon_sym_DQUOTE] = ACTIONS(1924),
    [anon_sym_DOLLAR] = ACTIONS(1926),
    [sym_raw_string] = ACTIONS(1924),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1924),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1924),
    [anon_sym_BQUOTE] = ACTIONS(1924),
    [anon_sym_LT_LPAREN] = ACTIONS(1924),
    [anon_sym_GT_LPAREN] = ACTIONS(1924),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1926),
    [sym_word] = ACTIONS(1926),
    [anon_sym_LF] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1926),
  },
  [816] = {
    [anon_sym_SEMI] = ACTIONS(2738),
    [anon_sym_RPAREN] = ACTIONS(2736),
    [anon_sym_SEMI_SEMI] = ACTIONS(2740),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2740),
  },
  [817] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1271),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(2742),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2736),
    [anon_sym_SEMI_SEMI] = ACTIONS(2744),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2742),
  },
  [818] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1271),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2742),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2736),
    [anon_sym_SEMI_SEMI] = ACTIONS(2744),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2742),
  },
  [819] = {
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(1726),
    [ts_builtin_sym_end] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1728),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [820] = {
    [aux_sym_concatenation_repeat1] = STATE(820),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(2746),
    [ts_builtin_sym_end] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1728),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [821] = {
    [sym__simple_heredoc_body] = ACTIONS(1733),
    [sym__heredoc_body_beginning] = ACTIONS(1733),
    [sym_file_descriptor] = ACTIONS(1733),
    [sym__concat] = ACTIONS(1733),
    [ts_builtin_sym_end] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_PIPE] = ACTIONS(1735),
    [anon_sym_RPAREN] = ACTIONS(1733),
    [anon_sym_SEMI_SEMI] = ACTIONS(1733),
    [anon_sym_PIPE_AMP] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1735),
    [anon_sym_GT] = ACTIONS(1735),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_AMP_GT] = ACTIONS(1735),
    [anon_sym_AMP_GT_GT] = ACTIONS(1733),
    [anon_sym_LT_AMP] = ACTIONS(1733),
    [anon_sym_GT_AMP] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1735),
    [anon_sym_LT_LT_DASH] = ACTIONS(1733),
    [anon_sym_LT_LT_LT] = ACTIONS(1733),
    [sym__special_characters] = ACTIONS(1733),
    [anon_sym_DQUOTE] = ACTIONS(1733),
    [anon_sym_DOLLAR] = ACTIONS(1735),
    [sym_raw_string] = ACTIONS(1733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1733),
    [anon_sym_BQUOTE] = ACTIONS(1733),
    [anon_sym_LT_LPAREN] = ACTIONS(1733),
    [anon_sym_GT_LPAREN] = ACTIONS(1733),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1735),
    [sym_word] = ACTIONS(1735),
    [anon_sym_LF] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1735),
  },
  [822] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [823] = {
    [sym_concatenation] = STATE(1276),
    [sym_string] = STATE(1275),
    [sym_simple_expansion] = STATE(1275),
    [sym_string_expansion] = STATE(1275),
    [sym_expansion] = STATE(1275),
    [sym_command_substitution] = STATE(1275),
    [sym_process_substitution] = STATE(1275),
    [anon_sym_RBRACE] = ACTIONS(2751),
    [sym__special_characters] = ACTIONS(2753),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(2755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2755),
  },
  [824] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(2757),
    [sym_comment] = ACTIONS(57),
  },
  [825] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_DASH] = ACTIONS(2761),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2763),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2765),
    [anon_sym_COLON] = ACTIONS(2761),
    [anon_sym_COLON_QMARK] = ACTIONS(2761),
    [anon_sym_COLON_DASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [826] = {
    [sym_concatenation] = STATE(1282),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1282),
    [anon_sym_RBRACE] = ACTIONS(2751),
    [anon_sym_EQ] = ACTIONS(2767),
    [anon_sym_DASH] = ACTIONS(2767),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2771),
    [anon_sym_COLON] = ACTIONS(2767),
    [anon_sym_COLON_QMARK] = ACTIONS(2767),
    [anon_sym_COLON_DASH] = ACTIONS(2767),
    [anon_sym_PERCENT] = ACTIONS(2767),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [827] = {
    [sym__simple_heredoc_body] = ACTIONS(1834),
    [sym__heredoc_body_beginning] = ACTIONS(1834),
    [sym_file_descriptor] = ACTIONS(1834),
    [sym__concat] = ACTIONS(1834),
    [ts_builtin_sym_end] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1836),
    [anon_sym_PIPE] = ACTIONS(1836),
    [anon_sym_RPAREN] = ACTIONS(1834),
    [anon_sym_SEMI_SEMI] = ACTIONS(1834),
    [anon_sym_PIPE_AMP] = ACTIONS(1834),
    [anon_sym_AMP_AMP] = ACTIONS(1834),
    [anon_sym_PIPE_PIPE] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1836),
    [anon_sym_GT] = ACTIONS(1836),
    [anon_sym_GT_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT] = ACTIONS(1836),
    [anon_sym_AMP_GT_GT] = ACTIONS(1834),
    [anon_sym_LT_AMP] = ACTIONS(1834),
    [anon_sym_GT_AMP] = ACTIONS(1834),
    [anon_sym_LT_LT] = ACTIONS(1836),
    [anon_sym_LT_LT_DASH] = ACTIONS(1834),
    [anon_sym_LT_LT_LT] = ACTIONS(1834),
    [sym__special_characters] = ACTIONS(1834),
    [anon_sym_DQUOTE] = ACTIONS(1834),
    [anon_sym_DOLLAR] = ACTIONS(1836),
    [sym_raw_string] = ACTIONS(1834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1834),
    [anon_sym_BQUOTE] = ACTIONS(1834),
    [anon_sym_LT_LPAREN] = ACTIONS(1834),
    [anon_sym_GT_LPAREN] = ACTIONS(1834),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1836),
    [sym_word] = ACTIONS(1836),
    [anon_sym_LF] = ACTIONS(1834),
    [anon_sym_AMP] = ACTIONS(1836),
  },
  [828] = {
    [sym_concatenation] = STATE(1285),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1285),
    [sym_regex] = ACTIONS(2773),
    [anon_sym_RBRACE] = ACTIONS(2775),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_DASH] = ACTIONS(2777),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(2777),
    [anon_sym_COLON_QMARK] = ACTIONS(2777),
    [anon_sym_COLON_DASH] = ACTIONS(2777),
    [anon_sym_PERCENT] = ACTIONS(2777),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [829] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(2775),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [830] = {
    [sym__simple_heredoc_body] = ACTIONS(1882),
    [sym__heredoc_body_beginning] = ACTIONS(1882),
    [sym_file_descriptor] = ACTIONS(1882),
    [sym__concat] = ACTIONS(1882),
    [ts_builtin_sym_end] = ACTIONS(1882),
    [anon_sym_SEMI] = ACTIONS(1884),
    [anon_sym_PIPE] = ACTIONS(1884),
    [anon_sym_RPAREN] = ACTIONS(1882),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [anon_sym_PIPE_AMP] = ACTIONS(1882),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1884),
    [anon_sym_GT_GT] = ACTIONS(1882),
    [anon_sym_AMP_GT] = ACTIONS(1884),
    [anon_sym_AMP_GT_GT] = ACTIONS(1882),
    [anon_sym_LT_AMP] = ACTIONS(1882),
    [anon_sym_GT_AMP] = ACTIONS(1882),
    [anon_sym_LT_LT] = ACTIONS(1884),
    [anon_sym_LT_LT_DASH] = ACTIONS(1882),
    [anon_sym_LT_LT_LT] = ACTIONS(1882),
    [sym__special_characters] = ACTIONS(1882),
    [anon_sym_DQUOTE] = ACTIONS(1882),
    [anon_sym_DOLLAR] = ACTIONS(1884),
    [sym_raw_string] = ACTIONS(1882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1882),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [anon_sym_LT_LPAREN] = ACTIONS(1882),
    [anon_sym_GT_LPAREN] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1884),
    [sym_word] = ACTIONS(1884),
    [anon_sym_LF] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1884),
  },
  [831] = {
    [sym_concatenation] = STATE(1282),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1282),
    [sym_regex] = ACTIONS(2781),
    [anon_sym_RBRACE] = ACTIONS(2751),
    [anon_sym_EQ] = ACTIONS(2767),
    [anon_sym_DASH] = ACTIONS(2767),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(2767),
    [anon_sym_COLON_QMARK] = ACTIONS(2767),
    [anon_sym_COLON_DASH] = ACTIONS(2767),
    [anon_sym_PERCENT] = ACTIONS(2767),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [832] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(2751),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [833] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(2783),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [834] = {
    [sym__simple_heredoc_body] = ACTIONS(1890),
    [sym__heredoc_body_beginning] = ACTIONS(1890),
    [sym_file_descriptor] = ACTIONS(1890),
    [sym__concat] = ACTIONS(1890),
    [ts_builtin_sym_end] = ACTIONS(1890),
    [anon_sym_SEMI] = ACTIONS(1892),
    [anon_sym_PIPE] = ACTIONS(1892),
    [anon_sym_RPAREN] = ACTIONS(1890),
    [anon_sym_SEMI_SEMI] = ACTIONS(1890),
    [anon_sym_PIPE_AMP] = ACTIONS(1890),
    [anon_sym_AMP_AMP] = ACTIONS(1890),
    [anon_sym_PIPE_PIPE] = ACTIONS(1890),
    [anon_sym_LT] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(1892),
    [anon_sym_GT_GT] = ACTIONS(1890),
    [anon_sym_AMP_GT] = ACTIONS(1892),
    [anon_sym_AMP_GT_GT] = ACTIONS(1890),
    [anon_sym_LT_AMP] = ACTIONS(1890),
    [anon_sym_GT_AMP] = ACTIONS(1890),
    [anon_sym_LT_LT] = ACTIONS(1892),
    [anon_sym_LT_LT_DASH] = ACTIONS(1890),
    [anon_sym_LT_LT_LT] = ACTIONS(1890),
    [sym__special_characters] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1890),
    [anon_sym_DOLLAR] = ACTIONS(1892),
    [sym_raw_string] = ACTIONS(1890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1890),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [anon_sym_LT_LPAREN] = ACTIONS(1890),
    [anon_sym_GT_LPAREN] = ACTIONS(1890),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1892),
    [sym_word] = ACTIONS(1892),
    [anon_sym_LF] = ACTIONS(1890),
    [anon_sym_AMP] = ACTIONS(1892),
  },
  [835] = {
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym_RPAREN] = ACTIONS(2783),
    [anon_sym_SEMI_SEMI] = ACTIONS(2787),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2787),
    [anon_sym_AMP] = ACTIONS(2787),
  },
  [836] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1290),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2783),
    [anon_sym_SEMI_SEMI] = ACTIONS(2791),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2791),
    [anon_sym_AMP] = ACTIONS(2789),
  },
  [837] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1290),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2783),
    [anon_sym_SEMI_SEMI] = ACTIONS(2791),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2791),
    [anon_sym_AMP] = ACTIONS(2789),
  },
  [838] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(2783),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [839] = {
    [anon_sym_SEMI] = ACTIONS(2793),
    [anon_sym_SEMI_SEMI] = ACTIONS(2795),
    [anon_sym_BQUOTE] = ACTIONS(2783),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2795),
    [anon_sym_AMP] = ACTIONS(2795),
  },
  [840] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1293),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(2797),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2799),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(2783),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2799),
    [anon_sym_AMP] = ACTIONS(2797),
  },
  [841] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1293),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2797),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2799),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(2783),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2799),
    [anon_sym_AMP] = ACTIONS(2797),
  },
  [842] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(2801),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [843] = {
    [sym__simple_heredoc_body] = ACTIONS(1924),
    [sym__heredoc_body_beginning] = ACTIONS(1924),
    [sym_file_descriptor] = ACTIONS(1924),
    [sym__concat] = ACTIONS(1924),
    [ts_builtin_sym_end] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_RPAREN] = ACTIONS(1924),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [anon_sym_PIPE_AMP] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_GT_GT] = ACTIONS(1924),
    [anon_sym_AMP_GT] = ACTIONS(1926),
    [anon_sym_AMP_GT_GT] = ACTIONS(1924),
    [anon_sym_LT_AMP] = ACTIONS(1924),
    [anon_sym_GT_AMP] = ACTIONS(1924),
    [anon_sym_LT_LT] = ACTIONS(1926),
    [anon_sym_LT_LT_DASH] = ACTIONS(1924),
    [anon_sym_LT_LT_LT] = ACTIONS(1924),
    [sym__special_characters] = ACTIONS(1924),
    [anon_sym_DQUOTE] = ACTIONS(1924),
    [anon_sym_DOLLAR] = ACTIONS(1926),
    [sym_raw_string] = ACTIONS(1924),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1924),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1924),
    [anon_sym_BQUOTE] = ACTIONS(1924),
    [anon_sym_LT_LPAREN] = ACTIONS(1924),
    [anon_sym_GT_LPAREN] = ACTIONS(1924),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1926),
    [sym_word] = ACTIONS(1926),
    [anon_sym_LF] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1926),
  },
  [844] = {
    [anon_sym_SEMI] = ACTIONS(2803),
    [anon_sym_RPAREN] = ACTIONS(2801),
    [anon_sym_SEMI_SEMI] = ACTIONS(2805),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2805),
    [anon_sym_AMP] = ACTIONS(2805),
  },
  [845] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1297),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2801),
    [anon_sym_SEMI_SEMI] = ACTIONS(2809),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2807),
  },
  [846] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1297),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2801),
    [anon_sym_SEMI_SEMI] = ACTIONS(2809),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2807),
  },
  [847] = {
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(1726),
    [sym_variable_name] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1726),
  },
  [848] = {
    [aux_sym_concatenation_repeat1] = STATE(848),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(2811),
    [sym_variable_name] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1726),
  },
  [849] = {
    [sym_file_descriptor] = ACTIONS(1733),
    [sym__concat] = ACTIONS(1733),
    [sym_variable_name] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1735),
    [anon_sym_GT] = ACTIONS(1735),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_AMP_GT] = ACTIONS(1735),
    [anon_sym_AMP_GT_GT] = ACTIONS(1733),
    [anon_sym_LT_AMP] = ACTIONS(1733),
    [anon_sym_GT_AMP] = ACTIONS(1733),
    [sym__special_characters] = ACTIONS(1733),
    [anon_sym_DQUOTE] = ACTIONS(1733),
    [anon_sym_DOLLAR] = ACTIONS(1735),
    [sym_raw_string] = ACTIONS(1733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1733),
    [anon_sym_BQUOTE] = ACTIONS(1733),
    [anon_sym_LT_LPAREN] = ACTIONS(1733),
    [anon_sym_GT_LPAREN] = ACTIONS(1733),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1733),
  },
  [850] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [851] = {
    [sym_concatenation] = STATE(1302),
    [sym_string] = STATE(1301),
    [sym_simple_expansion] = STATE(1301),
    [sym_string_expansion] = STATE(1301),
    [sym_expansion] = STATE(1301),
    [sym_command_substitution] = STATE(1301),
    [sym_process_substitution] = STATE(1301),
    [anon_sym_RBRACE] = ACTIONS(2816),
    [sym__special_characters] = ACTIONS(2818),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(2820),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2820),
  },
  [852] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(2822),
    [sym_comment] = ACTIONS(57),
  },
  [853] = {
    [sym_concatenation] = STATE(1306),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1306),
    [anon_sym_RBRACE] = ACTIONS(2824),
    [anon_sym_EQ] = ACTIONS(2826),
    [anon_sym_DASH] = ACTIONS(2826),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2828),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2830),
    [anon_sym_COLON] = ACTIONS(2826),
    [anon_sym_COLON_QMARK] = ACTIONS(2826),
    [anon_sym_COLON_DASH] = ACTIONS(2826),
    [anon_sym_PERCENT] = ACTIONS(2826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [854] = {
    [sym_concatenation] = STATE(1308),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1308),
    [anon_sym_RBRACE] = ACTIONS(2816),
    [anon_sym_EQ] = ACTIONS(2832),
    [anon_sym_DASH] = ACTIONS(2832),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2836),
    [anon_sym_COLON] = ACTIONS(2832),
    [anon_sym_COLON_QMARK] = ACTIONS(2832),
    [anon_sym_COLON_DASH] = ACTIONS(2832),
    [anon_sym_PERCENT] = ACTIONS(2832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [855] = {
    [sym_file_descriptor] = ACTIONS(1834),
    [sym__concat] = ACTIONS(1834),
    [sym_variable_name] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1836),
    [anon_sym_GT] = ACTIONS(1836),
    [anon_sym_GT_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT] = ACTIONS(1836),
    [anon_sym_AMP_GT_GT] = ACTIONS(1834),
    [anon_sym_LT_AMP] = ACTIONS(1834),
    [anon_sym_GT_AMP] = ACTIONS(1834),
    [sym__special_characters] = ACTIONS(1834),
    [anon_sym_DQUOTE] = ACTIONS(1834),
    [anon_sym_DOLLAR] = ACTIONS(1836),
    [sym_raw_string] = ACTIONS(1834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1834),
    [anon_sym_BQUOTE] = ACTIONS(1834),
    [anon_sym_LT_LPAREN] = ACTIONS(1834),
    [anon_sym_GT_LPAREN] = ACTIONS(1834),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1834),
  },
  [856] = {
    [sym_concatenation] = STATE(1311),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1311),
    [sym_regex] = ACTIONS(2838),
    [anon_sym_RBRACE] = ACTIONS(2840),
    [anon_sym_EQ] = ACTIONS(2842),
    [anon_sym_DASH] = ACTIONS(2842),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2844),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(2842),
    [anon_sym_COLON_QMARK] = ACTIONS(2842),
    [anon_sym_COLON_DASH] = ACTIONS(2842),
    [anon_sym_PERCENT] = ACTIONS(2842),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [857] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(2840),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [858] = {
    [sym_file_descriptor] = ACTIONS(1882),
    [sym__concat] = ACTIONS(1882),
    [sym_variable_name] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1884),
    [anon_sym_GT_GT] = ACTIONS(1882),
    [anon_sym_AMP_GT] = ACTIONS(1884),
    [anon_sym_AMP_GT_GT] = ACTIONS(1882),
    [anon_sym_LT_AMP] = ACTIONS(1882),
    [anon_sym_GT_AMP] = ACTIONS(1882),
    [sym__special_characters] = ACTIONS(1882),
    [anon_sym_DQUOTE] = ACTIONS(1882),
    [anon_sym_DOLLAR] = ACTIONS(1884),
    [sym_raw_string] = ACTIONS(1882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1882),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [anon_sym_LT_LPAREN] = ACTIONS(1882),
    [anon_sym_GT_LPAREN] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1882),
  },
  [859] = {
    [sym_concatenation] = STATE(1308),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1308),
    [sym_regex] = ACTIONS(2846),
    [anon_sym_RBRACE] = ACTIONS(2816),
    [anon_sym_EQ] = ACTIONS(2832),
    [anon_sym_DASH] = ACTIONS(2832),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(2832),
    [anon_sym_COLON_QMARK] = ACTIONS(2832),
    [anon_sym_COLON_DASH] = ACTIONS(2832),
    [anon_sym_PERCENT] = ACTIONS(2832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [860] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(2816),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [861] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(2848),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [862] = {
    [sym_file_descriptor] = ACTIONS(1890),
    [sym__concat] = ACTIONS(1890),
    [sym_variable_name] = ACTIONS(1890),
    [anon_sym_LT] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(1892),
    [anon_sym_GT_GT] = ACTIONS(1890),
    [anon_sym_AMP_GT] = ACTIONS(1892),
    [anon_sym_AMP_GT_GT] = ACTIONS(1890),
    [anon_sym_LT_AMP] = ACTIONS(1890),
    [anon_sym_GT_AMP] = ACTIONS(1890),
    [sym__special_characters] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1890),
    [anon_sym_DOLLAR] = ACTIONS(1892),
    [sym_raw_string] = ACTIONS(1890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1890),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [anon_sym_LT_LPAREN] = ACTIONS(1890),
    [anon_sym_GT_LPAREN] = ACTIONS(1890),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1890),
  },
  [863] = {
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_RPAREN] = ACTIONS(2848),
    [anon_sym_SEMI_SEMI] = ACTIONS(2852),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2852),
  },
  [864] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1316),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(2854),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2848),
    [anon_sym_SEMI_SEMI] = ACTIONS(2856),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2856),
    [anon_sym_AMP] = ACTIONS(2854),
  },
  [865] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1316),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2854),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2848),
    [anon_sym_SEMI_SEMI] = ACTIONS(2856),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2856),
    [anon_sym_AMP] = ACTIONS(2854),
  },
  [866] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(2848),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [867] = {
    [anon_sym_SEMI] = ACTIONS(2858),
    [anon_sym_SEMI_SEMI] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2848),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2860),
    [anon_sym_AMP] = ACTIONS(2860),
  },
  [868] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1319),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(2862),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2864),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(2848),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2864),
    [anon_sym_AMP] = ACTIONS(2862),
  },
  [869] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1319),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2862),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2864),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(2848),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2864),
    [anon_sym_AMP] = ACTIONS(2862),
  },
  [870] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(2866),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [871] = {
    [sym_file_descriptor] = ACTIONS(1924),
    [sym__concat] = ACTIONS(1924),
    [sym_variable_name] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_GT_GT] = ACTIONS(1924),
    [anon_sym_AMP_GT] = ACTIONS(1926),
    [anon_sym_AMP_GT_GT] = ACTIONS(1924),
    [anon_sym_LT_AMP] = ACTIONS(1924),
    [anon_sym_GT_AMP] = ACTIONS(1924),
    [sym__special_characters] = ACTIONS(1924),
    [anon_sym_DQUOTE] = ACTIONS(1924),
    [anon_sym_DOLLAR] = ACTIONS(1926),
    [sym_raw_string] = ACTIONS(1924),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1924),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1924),
    [anon_sym_BQUOTE] = ACTIONS(1924),
    [anon_sym_LT_LPAREN] = ACTIONS(1924),
    [anon_sym_GT_LPAREN] = ACTIONS(1924),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1924),
  },
  [872] = {
    [anon_sym_SEMI] = ACTIONS(2868),
    [anon_sym_RPAREN] = ACTIONS(2866),
    [anon_sym_SEMI_SEMI] = ACTIONS(2870),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2870),
    [anon_sym_AMP] = ACTIONS(2870),
  },
  [873] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1323),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(2872),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2866),
    [anon_sym_SEMI_SEMI] = ACTIONS(2874),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2872),
  },
  [874] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1323),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2872),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2866),
    [anon_sym_SEMI_SEMI] = ACTIONS(2874),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2872),
  },
  [875] = {
    [anon_sym_DQUOTE] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2876),
    [sym__string_content] = ACTIONS(2878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2876),
    [anon_sym_BQUOTE] = ACTIONS(2876),
    [sym_comment] = ACTIONS(265),
  },
  [876] = {
    [sym_concatenation] = STATE(1327),
    [sym_string] = STATE(1326),
    [sym_simple_expansion] = STATE(1326),
    [sym_string_expansion] = STATE(1326),
    [sym_expansion] = STATE(1326),
    [sym_command_substitution] = STATE(1326),
    [sym_process_substitution] = STATE(1326),
    [anon_sym_RBRACE] = ACTIONS(2880),
    [sym__special_characters] = ACTIONS(2882),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(2884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2884),
  },
  [877] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(2886),
    [sym_comment] = ACTIONS(57),
  },
  [878] = {
    [sym_concatenation] = STATE(1331),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1331),
    [anon_sym_RBRACE] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(2890),
    [anon_sym_DASH] = ACTIONS(2890),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2892),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2894),
    [anon_sym_COLON] = ACTIONS(2890),
    [anon_sym_COLON_QMARK] = ACTIONS(2890),
    [anon_sym_COLON_DASH] = ACTIONS(2890),
    [anon_sym_PERCENT] = ACTIONS(2890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [879] = {
    [sym_concatenation] = STATE(1333),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1333),
    [anon_sym_RBRACE] = ACTIONS(2880),
    [anon_sym_EQ] = ACTIONS(2896),
    [anon_sym_DASH] = ACTIONS(2896),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2898),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(2900),
    [anon_sym_COLON] = ACTIONS(2896),
    [anon_sym_COLON_QMARK] = ACTIONS(2896),
    [anon_sym_COLON_DASH] = ACTIONS(2896),
    [anon_sym_PERCENT] = ACTIONS(2896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [880] = {
    [sym__concat] = ACTIONS(1834),
    [anon_sym_DQUOTE] = ACTIONS(1836),
    [anon_sym_DOLLAR] = ACTIONS(1836),
    [sym__string_content] = ACTIONS(1834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1836),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1836),
    [anon_sym_BQUOTE] = ACTIONS(1836),
    [sym_comment] = ACTIONS(265),
  },
  [881] = {
    [sym_concatenation] = STATE(1336),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1336),
    [sym_regex] = ACTIONS(2902),
    [anon_sym_RBRACE] = ACTIONS(2904),
    [anon_sym_EQ] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(2906),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(2906),
    [anon_sym_COLON_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_DASH] = ACTIONS(2906),
    [anon_sym_PERCENT] = ACTIONS(2906),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [882] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(2904),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [883] = {
    [sym__concat] = ACTIONS(1882),
    [anon_sym_DQUOTE] = ACTIONS(1884),
    [anon_sym_DOLLAR] = ACTIONS(1884),
    [sym__string_content] = ACTIONS(1882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1884),
    [anon_sym_BQUOTE] = ACTIONS(1884),
    [sym_comment] = ACTIONS(265),
  },
  [884] = {
    [sym_concatenation] = STATE(1333),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1333),
    [sym_regex] = ACTIONS(2910),
    [anon_sym_RBRACE] = ACTIONS(2880),
    [anon_sym_EQ] = ACTIONS(2896),
    [anon_sym_DASH] = ACTIONS(2896),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2898),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(2896),
    [anon_sym_COLON_QMARK] = ACTIONS(2896),
    [anon_sym_COLON_DASH] = ACTIONS(2896),
    [anon_sym_PERCENT] = ACTIONS(2896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [885] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(2880),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [886] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [887] = {
    [sym__concat] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_DOLLAR] = ACTIONS(1892),
    [sym__string_content] = ACTIONS(1890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1892),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1892),
    [anon_sym_BQUOTE] = ACTIONS(1892),
    [sym_comment] = ACTIONS(265),
  },
  [888] = {
    [anon_sym_SEMI] = ACTIONS(2914),
    [anon_sym_RPAREN] = ACTIONS(2912),
    [anon_sym_SEMI_SEMI] = ACTIONS(2916),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(2916),
  },
  [889] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1341),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(2918),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2912),
    [anon_sym_SEMI_SEMI] = ACTIONS(2920),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2918),
  },
  [890] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1341),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2918),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(2912),
    [anon_sym_SEMI_SEMI] = ACTIONS(2920),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2918),
  },
  [891] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(2912),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [892] = {
    [anon_sym_SEMI] = ACTIONS(2922),
    [anon_sym_SEMI_SEMI] = ACTIONS(2924),
    [anon_sym_BQUOTE] = ACTIONS(2912),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2924),
    [anon_sym_AMP] = ACTIONS(2924),
  },
  [893] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1344),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(2926),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2928),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(2912),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2928),
    [anon_sym_AMP] = ACTIONS(2926),
  },
  [894] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1344),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2926),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2928),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(2912),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2928),
    [anon_sym_AMP] = ACTIONS(2926),
  },
  [895] = {
    [sym__simple_heredoc_body] = ACTIONS(2930),
    [sym__heredoc_body_beginning] = ACTIONS(2930),
    [sym_file_descriptor] = ACTIONS(2930),
    [sym__concat] = ACTIONS(2930),
    [ts_builtin_sym_end] = ACTIONS(2930),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym_PIPE] = ACTIONS(2932),
    [anon_sym_RPAREN] = ACTIONS(2930),
    [anon_sym_SEMI_SEMI] = ACTIONS(2930),
    [anon_sym_PIPE_AMP] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_EQ_TILDE] = ACTIONS(2932),
    [anon_sym_EQ_EQ] = ACTIONS(2932),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2932),
    [anon_sym_GT_GT] = ACTIONS(2930),
    [anon_sym_AMP_GT] = ACTIONS(2932),
    [anon_sym_AMP_GT_GT] = ACTIONS(2930),
    [anon_sym_LT_AMP] = ACTIONS(2930),
    [anon_sym_GT_AMP] = ACTIONS(2930),
    [anon_sym_LT_LT] = ACTIONS(2932),
    [anon_sym_LT_LT_DASH] = ACTIONS(2930),
    [anon_sym_LT_LT_LT] = ACTIONS(2930),
    [sym__special_characters] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_DOLLAR] = ACTIONS(2932),
    [sym_raw_string] = ACTIONS(2930),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2930),
    [anon_sym_BQUOTE] = ACTIONS(2930),
    [anon_sym_LT_LPAREN] = ACTIONS(2930),
    [anon_sym_GT_LPAREN] = ACTIONS(2930),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2932),
    [anon_sym_LF] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2932),
  },
  [896] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [897] = {
    [aux_sym_concatenation_repeat1] = STATE(529),
    [sym__concat] = ACTIONS(2934),
    [anon_sym_RBRACK] = ACTIONS(2936),
    [sym_comment] = ACTIONS(57),
  },
  [898] = {
    [aux_sym_concatenation_repeat1] = STATE(529),
    [sym__concat] = ACTIONS(2938),
    [anon_sym_RBRACK] = ACTIONS(2940),
    [sym_comment] = ACTIONS(57),
  },
  [899] = {
    [sym__concat] = ACTIONS(2942),
    [anon_sym_RBRACK] = ACTIONS(2940),
    [sym_comment] = ACTIONS(57),
  },
  [900] = {
    [sym__simple_heredoc_body] = ACTIONS(2944),
    [sym__heredoc_body_beginning] = ACTIONS(2944),
    [sym_file_descriptor] = ACTIONS(2944),
    [sym__concat] = ACTIONS(2944),
    [ts_builtin_sym_end] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym_PIPE] = ACTIONS(2946),
    [anon_sym_RPAREN] = ACTIONS(2944),
    [anon_sym_SEMI_SEMI] = ACTIONS(2944),
    [anon_sym_PIPE_AMP] = ACTIONS(2944),
    [anon_sym_AMP_AMP] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2944),
    [anon_sym_EQ_TILDE] = ACTIONS(2946),
    [anon_sym_EQ_EQ] = ACTIONS(2946),
    [anon_sym_LT] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2946),
    [anon_sym_GT_GT] = ACTIONS(2944),
    [anon_sym_AMP_GT] = ACTIONS(2946),
    [anon_sym_AMP_GT_GT] = ACTIONS(2944),
    [anon_sym_LT_AMP] = ACTIONS(2944),
    [anon_sym_GT_AMP] = ACTIONS(2944),
    [anon_sym_LT_LT] = ACTIONS(2946),
    [anon_sym_LT_LT_DASH] = ACTIONS(2944),
    [anon_sym_LT_LT_LT] = ACTIONS(2944),
    [sym__special_characters] = ACTIONS(2944),
    [anon_sym_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [sym_raw_string] = ACTIONS(2944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2944),
    [anon_sym_BQUOTE] = ACTIONS(2944),
    [anon_sym_LT_LPAREN] = ACTIONS(2944),
    [anon_sym_GT_LPAREN] = ACTIONS(2944),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2946),
    [anon_sym_LF] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2946),
  },
  [901] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2950),
    [sym_comment] = ACTIONS(57),
  },
  [902] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(1355),
    [anon_sym_DQUOTE] = ACTIONS(2952),
    [anon_sym_DOLLAR] = ACTIONS(2954),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [903] = {
    [sym_string] = STATE(1357),
    [anon_sym_DASH] = ACTIONS(2956),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(2956),
    [sym_raw_string] = ACTIONS(2958),
    [anon_sym_POUND] = ACTIONS(2956),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2960),
    [anon_sym_STAR] = ACTIONS(2962),
    [anon_sym_AT] = ACTIONS(2962),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_0] = ACTIONS(2960),
    [anon_sym__] = ACTIONS(2960),
  },
  [904] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2964),
    [sym_comment] = ACTIONS(57),
  },
  [905] = {
    [sym_subscript] = STATE(1363),
    [sym_variable_name] = ACTIONS(2966),
    [anon_sym_BANG] = ACTIONS(2968),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_DOLLAR] = ACTIONS(2970),
    [anon_sym_POUND] = ACTIONS(2968),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2974),
    [anon_sym_AT] = ACTIONS(2974),
    [anon_sym_QMARK] = ACTIONS(2974),
    [anon_sym_0] = ACTIONS(2972),
    [anon_sym__] = ACTIONS(2972),
  },
  [906] = {
    [sym__terminated_statement] = STATE(1366),
    [sym_redirected_statement] = STATE(1364),
    [sym_for_statement] = STATE(1364),
    [sym_c_style_for_statement] = STATE(1364),
    [sym_while_statement] = STATE(1364),
    [sym_if_statement] = STATE(1364),
    [sym_case_statement] = STATE(1364),
    [sym_function_definition] = STATE(1364),
    [sym_compound_statement] = STATE(1364),
    [sym_subshell] = STATE(1364),
    [sym_pipeline] = STATE(1364),
    [sym_list] = STATE(1364),
    [sym_negated_command] = STATE(1364),
    [sym_test_command] = STATE(1364),
    [sym_declaration_command] = STATE(1364),
    [sym_unset_command] = STATE(1364),
    [sym_command] = STATE(1364),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(1365),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(1366),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [907] = {
    [sym__terminated_statement] = STATE(1369),
    [sym_redirected_statement] = STATE(1367),
    [sym_for_statement] = STATE(1367),
    [sym_c_style_for_statement] = STATE(1367),
    [sym_while_statement] = STATE(1367),
    [sym_if_statement] = STATE(1367),
    [sym_case_statement] = STATE(1367),
    [sym_function_definition] = STATE(1367),
    [sym_compound_statement] = STATE(1367),
    [sym_subshell] = STATE(1367),
    [sym_pipeline] = STATE(1367),
    [sym_list] = STATE(1367),
    [sym_negated_command] = STATE(1367),
    [sym_test_command] = STATE(1367),
    [sym_declaration_command] = STATE(1367),
    [sym_unset_command] = STATE(1367),
    [sym_command] = STATE(1367),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(1368),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(1369),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [908] = {
    [sym__terminated_statement] = STATE(1372),
    [sym_redirected_statement] = STATE(1370),
    [sym_for_statement] = STATE(1370),
    [sym_c_style_for_statement] = STATE(1370),
    [sym_while_statement] = STATE(1370),
    [sym_if_statement] = STATE(1370),
    [sym_case_statement] = STATE(1370),
    [sym_function_definition] = STATE(1370),
    [sym_compound_statement] = STATE(1370),
    [sym_subshell] = STATE(1370),
    [sym_pipeline] = STATE(1370),
    [sym_list] = STATE(1370),
    [sym_negated_command] = STATE(1370),
    [sym_test_command] = STATE(1370),
    [sym_declaration_command] = STATE(1370),
    [sym_unset_command] = STATE(1370),
    [sym_command] = STATE(1370),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(1371),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(1372),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [909] = {
    [anon_sym_RBRACE] = ACTIONS(2964),
    [sym_comment] = ACTIONS(57),
  },
  [910] = {
    [sym_concatenation] = STATE(1375),
    [sym_string] = STATE(1374),
    [sym_simple_expansion] = STATE(1374),
    [sym_string_expansion] = STATE(1374),
    [sym_expansion] = STATE(1374),
    [sym_command_substitution] = STATE(1374),
    [sym_process_substitution] = STATE(1374),
    [anon_sym_RBRACE] = ACTIONS(2964),
    [sym__special_characters] = ACTIONS(2976),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(2978),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2978),
  },
  [911] = {
    [sym__simple_heredoc_body] = ACTIONS(2980),
    [sym__heredoc_body_beginning] = ACTIONS(2980),
    [sym_file_descriptor] = ACTIONS(2980),
    [sym__concat] = ACTIONS(2980),
    [ts_builtin_sym_end] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym_PIPE] = ACTIONS(2982),
    [anon_sym_RPAREN] = ACTIONS(2980),
    [anon_sym_SEMI_SEMI] = ACTIONS(2980),
    [anon_sym_PIPE_AMP] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_PIPE_PIPE] = ACTIONS(2980),
    [anon_sym_EQ_TILDE] = ACTIONS(2982),
    [anon_sym_EQ_EQ] = ACTIONS(2982),
    [anon_sym_LT] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2982),
    [anon_sym_GT_GT] = ACTIONS(2980),
    [anon_sym_AMP_GT] = ACTIONS(2982),
    [anon_sym_AMP_GT_GT] = ACTIONS(2980),
    [anon_sym_LT_AMP] = ACTIONS(2980),
    [anon_sym_GT_AMP] = ACTIONS(2980),
    [anon_sym_LT_LT] = ACTIONS(2982),
    [anon_sym_LT_LT_DASH] = ACTIONS(2980),
    [anon_sym_LT_LT_LT] = ACTIONS(2980),
    [sym__special_characters] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2982),
    [sym_raw_string] = ACTIONS(2980),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2980),
    [anon_sym_BQUOTE] = ACTIONS(2980),
    [anon_sym_LT_LPAREN] = ACTIONS(2980),
    [anon_sym_GT_LPAREN] = ACTIONS(2980),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2982),
    [anon_sym_LF] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2982),
  },
  [912] = {
    [sym_concatenation] = STATE(1378),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1378),
    [sym_regex] = ACTIONS(2984),
    [anon_sym_RBRACE] = ACTIONS(2986),
    [anon_sym_EQ] = ACTIONS(2988),
    [anon_sym_DASH] = ACTIONS(2988),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2990),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(2988),
    [anon_sym_COLON_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_DASH] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(2988),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [913] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(2986),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [914] = {
    [sym_concatenation] = STATE(1380),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1380),
    [sym_regex] = ACTIONS(2992),
    [anon_sym_RBRACE] = ACTIONS(2964),
    [anon_sym_EQ] = ACTIONS(2994),
    [anon_sym_DASH] = ACTIONS(2994),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(2994),
    [anon_sym_COLON_QMARK] = ACTIONS(2994),
    [anon_sym_COLON_DASH] = ACTIONS(2994),
    [anon_sym_PERCENT] = ACTIONS(2994),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [915] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(2964),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [916] = {
    [sym_string] = STATE(1381),
    [sym_simple_expansion] = STATE(1381),
    [sym_string_expansion] = STATE(1381),
    [sym_expansion] = STATE(1381),
    [sym_command_substitution] = STATE(1381),
    [sym_process_substitution] = STATE(1381),
    [sym__special_characters] = ACTIONS(2998),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(2998),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2998),
  },
  [917] = {
    [aux_sym_concatenation_repeat1] = STATE(1382),
    [sym__concat] = ACTIONS(1838),
    [anon_sym_RBRACE] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [sym__special_characters] = ACTIONS(781),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_COLON] = ACTIONS(781),
    [anon_sym_COLON_QMARK] = ACTIONS(781),
    [anon_sym_COLON_DASH] = ACTIONS(781),
    [anon_sym_PERCENT] = ACTIONS(781),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(781),
  },
  [918] = {
    [sym__concat] = ACTIONS(783),
    [anon_sym_RBRACE] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [sym__special_characters] = ACTIONS(785),
    [anon_sym_DQUOTE] = ACTIONS(783),
    [anon_sym_DOLLAR] = ACTIONS(785),
    [sym_raw_string] = ACTIONS(783),
    [anon_sym_POUND] = ACTIONS(783),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(783),
    [anon_sym_COLON] = ACTIONS(785),
    [anon_sym_COLON_QMARK] = ACTIONS(785),
    [anon_sym_COLON_DASH] = ACTIONS(785),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(783),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [anon_sym_LT_LPAREN] = ACTIONS(783),
    [anon_sym_GT_LPAREN] = ACTIONS(783),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(785),
  },
  [919] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(3000),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [920] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(3000),
    [anon_sym_DOLLAR] = ACTIONS(3002),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [921] = {
    [sym__concat] = ACTIONS(817),
    [anon_sym_RBRACE] = ACTIONS(817),
    [anon_sym_EQ] = ACTIONS(819),
    [anon_sym_DASH] = ACTIONS(819),
    [sym__special_characters] = ACTIONS(819),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR] = ACTIONS(819),
    [sym_raw_string] = ACTIONS(817),
    [anon_sym_POUND] = ACTIONS(817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_COLON] = ACTIONS(819),
    [anon_sym_COLON_QMARK] = ACTIONS(819),
    [anon_sym_COLON_DASH] = ACTIONS(819),
    [anon_sym_PERCENT] = ACTIONS(819),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(817),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(817),
    [anon_sym_GT_LPAREN] = ACTIONS(817),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(819),
  },
  [922] = {
    [sym__concat] = ACTIONS(821),
    [anon_sym_RBRACE] = ACTIONS(821),
    [anon_sym_EQ] = ACTIONS(823),
    [anon_sym_DASH] = ACTIONS(823),
    [sym__special_characters] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [anon_sym_DOLLAR] = ACTIONS(823),
    [sym_raw_string] = ACTIONS(821),
    [anon_sym_POUND] = ACTIONS(821),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(821),
    [anon_sym_COLON] = ACTIONS(823),
    [anon_sym_COLON_QMARK] = ACTIONS(823),
    [anon_sym_COLON_DASH] = ACTIONS(823),
    [anon_sym_PERCENT] = ACTIONS(823),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(821),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(821),
    [anon_sym_GT_LPAREN] = ACTIONS(821),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(823),
  },
  [923] = {
    [sym__concat] = ACTIONS(825),
    [anon_sym_RBRACE] = ACTIONS(825),
    [anon_sym_EQ] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [sym__special_characters] = ACTIONS(827),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [sym_raw_string] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(825),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(825),
    [anon_sym_COLON] = ACTIONS(827),
    [anon_sym_COLON_QMARK] = ACTIONS(827),
    [anon_sym_COLON_DASH] = ACTIONS(827),
    [anon_sym_PERCENT] = ACTIONS(827),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(825),
    [anon_sym_BQUOTE] = ACTIONS(825),
    [anon_sym_LT_LPAREN] = ACTIONS(825),
    [anon_sym_GT_LPAREN] = ACTIONS(825),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(827),
  },
  [924] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(3004),
    [sym_comment] = ACTIONS(57),
  },
  [925] = {
    [sym_subscript] = STATE(1388),
    [sym_variable_name] = ACTIONS(3006),
    [anon_sym_DASH] = ACTIONS(3008),
    [anon_sym_DOLLAR] = ACTIONS(3008),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3012),
    [anon_sym_AT] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_0] = ACTIONS(3010),
    [anon_sym__] = ACTIONS(3010),
  },
  [926] = {
    [sym_concatenation] = STATE(1391),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1391),
    [anon_sym_RBRACE] = ACTIONS(3014),
    [anon_sym_EQ] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3016),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(3020),
    [anon_sym_COLON] = ACTIONS(3016),
    [anon_sym_COLON_QMARK] = ACTIONS(3016),
    [anon_sym_COLON_DASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [927] = {
    [sym_concatenation] = STATE(1394),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1394),
    [anon_sym_RBRACE] = ACTIONS(3022),
    [anon_sym_EQ] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(3028),
    [anon_sym_COLON] = ACTIONS(3024),
    [anon_sym_COLON_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_DASH] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [928] = {
    [sym_concatenation] = STATE(1396),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1396),
    [anon_sym_RBRACE] = ACTIONS(3030),
    [anon_sym_EQ] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_DASH] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [929] = {
    [sym__simple_heredoc_body] = ACTIONS(3036),
    [sym__heredoc_body_beginning] = ACTIONS(3036),
    [sym_file_descriptor] = ACTIONS(3036),
    [sym__concat] = ACTIONS(3036),
    [ts_builtin_sym_end] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym_PIPE] = ACTIONS(3038),
    [anon_sym_RPAREN] = ACTIONS(3036),
    [anon_sym_SEMI_SEMI] = ACTIONS(3036),
    [anon_sym_PIPE_AMP] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_PIPE_PIPE] = ACTIONS(3036),
    [anon_sym_EQ_TILDE] = ACTIONS(3038),
    [anon_sym_EQ_EQ] = ACTIONS(3038),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_GT] = ACTIONS(3038),
    [anon_sym_GT_GT] = ACTIONS(3036),
    [anon_sym_AMP_GT] = ACTIONS(3038),
    [anon_sym_AMP_GT_GT] = ACTIONS(3036),
    [anon_sym_LT_AMP] = ACTIONS(3036),
    [anon_sym_GT_AMP] = ACTIONS(3036),
    [anon_sym_LT_LT] = ACTIONS(3038),
    [anon_sym_LT_LT_DASH] = ACTIONS(3036),
    [anon_sym_LT_LT_LT] = ACTIONS(3036),
    [sym__special_characters] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [anon_sym_DOLLAR] = ACTIONS(3038),
    [sym_raw_string] = ACTIONS(3036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3036),
    [anon_sym_BQUOTE] = ACTIONS(3036),
    [anon_sym_LT_LPAREN] = ACTIONS(3036),
    [anon_sym_GT_LPAREN] = ACTIONS(3036),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3038),
    [anon_sym_LF] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3038),
  },
  [930] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3030),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [931] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1399),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3042),
    [anon_sym_SEMI_SEMI] = ACTIONS(3044),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3040),
  },
  [932] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1399),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3042),
    [anon_sym_SEMI_SEMI] = ACTIONS(3044),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3040),
  },
  [933] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1400),
    [sym_for_statement] = STATE(1400),
    [sym_c_style_for_statement] = STATE(1400),
    [sym_while_statement] = STATE(1400),
    [sym_if_statement] = STATE(1400),
    [sym_case_statement] = STATE(1400),
    [sym_function_definition] = STATE(1400),
    [sym_compound_statement] = STATE(1400),
    [sym_subshell] = STATE(1400),
    [sym_pipeline] = STATE(1400),
    [sym_list] = STATE(1400),
    [sym_negated_command] = STATE(1400),
    [sym_test_command] = STATE(1400),
    [sym_declaration_command] = STATE(1400),
    [sym_unset_command] = STATE(1400),
    [sym_command] = STATE(1400),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(1401),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [934] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1403),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(3048),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(3042),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3046),
  },
  [935] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1403),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(3048),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(3042),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3046),
  },
  [936] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1404),
    [sym_for_statement] = STATE(1404),
    [sym_c_style_for_statement] = STATE(1404),
    [sym_while_statement] = STATE(1404),
    [sym_if_statement] = STATE(1404),
    [sym_case_statement] = STATE(1404),
    [sym_function_definition] = STATE(1404),
    [sym_compound_statement] = STATE(1404),
    [sym_subshell] = STATE(1404),
    [sym_pipeline] = STATE(1404),
    [sym_list] = STATE(1404),
    [sym_negated_command] = STATE(1404),
    [sym_test_command] = STATE(1404),
    [sym_declaration_command] = STATE(1404),
    [sym_unset_command] = STATE(1404),
    [sym_command] = STATE(1404),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(1405),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [937] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1408),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(3050),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3052),
    [anon_sym_SEMI_SEMI] = ACTIONS(3054),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3050),
  },
  [938] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1408),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3050),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3052),
    [anon_sym_SEMI_SEMI] = ACTIONS(3054),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3050),
  },
  [939] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1409),
    [sym_for_statement] = STATE(1409),
    [sym_c_style_for_statement] = STATE(1409),
    [sym_while_statement] = STATE(1409),
    [sym_if_statement] = STATE(1409),
    [sym_case_statement] = STATE(1409),
    [sym_function_definition] = STATE(1409),
    [sym_compound_statement] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_pipeline] = STATE(1409),
    [sym_list] = STATE(1409),
    [sym_negated_command] = STATE(1409),
    [sym_test_command] = STATE(1409),
    [sym_declaration_command] = STATE(1409),
    [sym_unset_command] = STATE(1409),
    [sym_command] = STATE(1409),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(1410),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [940] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_EQ] = ACTIONS(3058),
    [anon_sym_DASH] = ACTIONS(3058),
    [sym__special_characters] = ACTIONS(3061),
    [anon_sym_DQUOTE] = ACTIONS(3064),
    [anon_sym_DOLLAR] = ACTIONS(3067),
    [sym_raw_string] = ACTIONS(3070),
    [anon_sym_POUND] = ACTIONS(3073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3076),
    [anon_sym_COLON] = ACTIONS(3058),
    [anon_sym_COLON_QMARK] = ACTIONS(3058),
    [anon_sym_COLON_DASH] = ACTIONS(3058),
    [anon_sym_PERCENT] = ACTIONS(3058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3079),
    [anon_sym_BQUOTE] = ACTIONS(3082),
    [anon_sym_LT_LPAREN] = ACTIONS(3085),
    [anon_sym_GT_LPAREN] = ACTIONS(3085),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3088),
  },
  [941] = {
    [sym_concatenation] = STATE(1380),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1380),
    [anon_sym_RBRACE] = ACTIONS(2964),
    [anon_sym_EQ] = ACTIONS(2994),
    [anon_sym_DASH] = ACTIONS(2994),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(2996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(2994),
    [anon_sym_COLON_QMARK] = ACTIONS(2994),
    [anon_sym_COLON_DASH] = ACTIONS(2994),
    [anon_sym_PERCENT] = ACTIONS(2994),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [942] = {
    [sym__simple_heredoc_body] = ACTIONS(3091),
    [sym__heredoc_body_beginning] = ACTIONS(3091),
    [sym_file_descriptor] = ACTIONS(3091),
    [sym__concat] = ACTIONS(3091),
    [ts_builtin_sym_end] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_PIPE] = ACTIONS(3093),
    [anon_sym_RPAREN] = ACTIONS(3091),
    [anon_sym_SEMI_SEMI] = ACTIONS(3091),
    [anon_sym_PIPE_AMP] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_EQ_TILDE] = ACTIONS(3093),
    [anon_sym_EQ_EQ] = ACTIONS(3093),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_GT] = ACTIONS(3093),
    [anon_sym_GT_GT] = ACTIONS(3091),
    [anon_sym_AMP_GT] = ACTIONS(3093),
    [anon_sym_AMP_GT_GT] = ACTIONS(3091),
    [anon_sym_LT_AMP] = ACTIONS(3091),
    [anon_sym_GT_AMP] = ACTIONS(3091),
    [anon_sym_LT_LT] = ACTIONS(3093),
    [anon_sym_LT_LT_DASH] = ACTIONS(3091),
    [anon_sym_LT_LT_LT] = ACTIONS(3091),
    [sym__special_characters] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_DOLLAR] = ACTIONS(3093),
    [sym_raw_string] = ACTIONS(3091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3091),
    [anon_sym_BQUOTE] = ACTIONS(3091),
    [anon_sym_LT_LPAREN] = ACTIONS(3091),
    [anon_sym_GT_LPAREN] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3093),
    [anon_sym_LF] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3093),
  },
  [943] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(3095),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [944] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3095),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [945] = {
    [anon_sym_SEMI] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(3095),
    [anon_sym_SEMI_SEMI] = ACTIONS(3099),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3099),
    [anon_sym_AMP] = ACTIONS(3099),
  },
  [946] = {
    [sym_concatenation] = STATE(975),
    [sym_string] = STATE(1414),
    [sym_simple_expansion] = STATE(1414),
    [sym_string_expansion] = STATE(1414),
    [sym_expansion] = STATE(1414),
    [sym_command_substitution] = STATE(1414),
    [sym_process_substitution] = STATE(1414),
    [sym__special_characters] = ACTIONS(3101),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(3103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3103),
  },
  [947] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [948] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [949] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(1968),
    [sym__heredoc_body_beginning] = ACTIONS(1968),
    [sym_file_descriptor] = ACTIONS(1968),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1968),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(1968),
    [anon_sym_PIPE_PIPE] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(1970),
    [anon_sym_GT] = ACTIONS(1970),
    [anon_sym_GT_GT] = ACTIONS(1968),
    [anon_sym_AMP_GT] = ACTIONS(1970),
    [anon_sym_AMP_GT_GT] = ACTIONS(1968),
    [anon_sym_LT_AMP] = ACTIONS(1968),
    [anon_sym_GT_AMP] = ACTIONS(1968),
    [anon_sym_LT_LT] = ACTIONS(1970),
    [anon_sym_LT_LT_DASH] = ACTIONS(1968),
    [anon_sym_LT_LT_LT] = ACTIONS(1968),
    [anon_sym_BQUOTE] = ACTIONS(1968),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1968),
    [anon_sym_AMP] = ACTIONS(1970),
  },
  [950] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(1968),
    [sym__heredoc_body_beginning] = ACTIONS(1968),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1968),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(1968),
    [anon_sym_PIPE_PIPE] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(1970),
    [anon_sym_LT_LT_DASH] = ACTIONS(1968),
    [anon_sym_LT_LT_LT] = ACTIONS(1968),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1968),
    [anon_sym_AMP] = ACTIONS(1970),
  },
  [951] = {
    [aux_sym_concatenation_repeat1] = STATE(1415),
    [sym__simple_heredoc_body] = ACTIONS(745),
    [sym__heredoc_body_beginning] = ACTIONS(745),
    [sym_file_descriptor] = ACTIONS(745),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_SEMI_SEMI] = ACTIONS(745),
    [anon_sym_PIPE_AMP] = ACTIONS(745),
    [anon_sym_AMP_AMP] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(745),
    [anon_sym_LT] = ACTIONS(749),
    [anon_sym_GT] = ACTIONS(749),
    [anon_sym_GT_GT] = ACTIONS(745),
    [anon_sym_AMP_GT] = ACTIONS(749),
    [anon_sym_AMP_GT_GT] = ACTIONS(745),
    [anon_sym_LT_AMP] = ACTIONS(745),
    [anon_sym_GT_AMP] = ACTIONS(745),
    [anon_sym_LT_LT] = ACTIONS(749),
    [anon_sym_LT_LT_DASH] = ACTIONS(745),
    [anon_sym_LT_LT_LT] = ACTIONS(745),
    [anon_sym_BQUOTE] = ACTIONS(745),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(749),
  },
  [952] = {
    [aux_sym_concatenation_repeat1] = STATE(1415),
    [sym__simple_heredoc_body] = ACTIONS(763),
    [sym__heredoc_body_beginning] = ACTIONS(763),
    [sym_file_descriptor] = ACTIONS(763),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(765),
    [anon_sym_SEMI_SEMI] = ACTIONS(763),
    [anon_sym_PIPE_AMP] = ACTIONS(763),
    [anon_sym_AMP_AMP] = ACTIONS(763),
    [anon_sym_PIPE_PIPE] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(765),
    [anon_sym_GT_GT] = ACTIONS(763),
    [anon_sym_AMP_GT] = ACTIONS(765),
    [anon_sym_AMP_GT_GT] = ACTIONS(763),
    [anon_sym_LT_AMP] = ACTIONS(763),
    [anon_sym_GT_AMP] = ACTIONS(763),
    [anon_sym_LT_LT] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(763),
    [anon_sym_LT_LT_LT] = ACTIONS(763),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(763),
    [anon_sym_AMP] = ACTIONS(765),
  },
  [953] = {
    [aux_sym_concatenation_repeat1] = STATE(1415),
    [sym__simple_heredoc_body] = ACTIONS(1976),
    [sym__heredoc_body_beginning] = ACTIONS(1976),
    [sym_file_descriptor] = ACTIONS(1976),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1978),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(1976),
    [anon_sym_AMP_AMP] = ACTIONS(1976),
    [anon_sym_PIPE_PIPE] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1976),
    [anon_sym_AMP_GT] = ACTIONS(1978),
    [anon_sym_AMP_GT_GT] = ACTIONS(1976),
    [anon_sym_LT_AMP] = ACTIONS(1976),
    [anon_sym_GT_AMP] = ACTIONS(1976),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_LT_LT_DASH] = ACTIONS(1976),
    [anon_sym_LT_LT_LT] = ACTIONS(1976),
    [anon_sym_BQUOTE] = ACTIONS(1976),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1978),
  },
  [954] = {
    [aux_sym_concatenation_repeat1] = STATE(1415),
    [sym__simple_heredoc_body] = ACTIONS(1980),
    [sym__heredoc_body_beginning] = ACTIONS(1980),
    [sym_file_descriptor] = ACTIONS(1980),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_SEMI_SEMI] = ACTIONS(1980),
    [anon_sym_PIPE_AMP] = ACTIONS(1980),
    [anon_sym_AMP_AMP] = ACTIONS(1980),
    [anon_sym_PIPE_PIPE] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_AMP_GT] = ACTIONS(1982),
    [anon_sym_AMP_GT_GT] = ACTIONS(1980),
    [anon_sym_LT_AMP] = ACTIONS(1980),
    [anon_sym_GT_AMP] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1982),
    [anon_sym_LT_LT_DASH] = ACTIONS(1980),
    [anon_sym_LT_LT_LT] = ACTIONS(1980),
    [anon_sym_BQUOTE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1982),
  },
  [955] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(3095),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [956] = {
    [sym_file_redirect] = STATE(956),
    [sym_heredoc_redirect] = STATE(956),
    [sym_herestring_redirect] = STATE(956),
    [aux_sym_redirected_statement_repeat1] = STATE(956),
    [sym__simple_heredoc_body] = ACTIONS(1990),
    [sym__heredoc_body_beginning] = ACTIONS(1990),
    [sym_file_descriptor] = ACTIONS(3105),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_SEMI_SEMI] = ACTIONS(1990),
    [anon_sym_PIPE_AMP] = ACTIONS(1990),
    [anon_sym_AMP_AMP] = ACTIONS(1990),
    [anon_sym_PIPE_PIPE] = ACTIONS(1990),
    [anon_sym_LT] = ACTIONS(3108),
    [anon_sym_GT] = ACTIONS(3108),
    [anon_sym_GT_GT] = ACTIONS(3111),
    [anon_sym_AMP_GT] = ACTIONS(3108),
    [anon_sym_AMP_GT_GT] = ACTIONS(3111),
    [anon_sym_LT_AMP] = ACTIONS(3111),
    [anon_sym_GT_AMP] = ACTIONS(3111),
    [anon_sym_LT_LT] = ACTIONS(2003),
    [anon_sym_LT_LT_DASH] = ACTIONS(2006),
    [anon_sym_LT_LT_LT] = ACTIONS(3114),
    [anon_sym_BQUOTE] = ACTIONS(1990),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1995),
  },
  [957] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(3095),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [958] = {
    [anon_sym_SEMI] = ACTIONS(3117),
    [anon_sym_SEMI_SEMI] = ACTIONS(3119),
    [anon_sym_BQUOTE] = ACTIONS(3095),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3119),
    [anon_sym_AMP] = ACTIONS(3119),
  },
  [959] = {
    [sym_concatenation] = STATE(683),
    [sym_string] = STATE(279),
    [sym_simple_expansion] = STATE(279),
    [sym_string_expansion] = STATE(279),
    [sym_expansion] = STATE(279),
    [sym_command_substitution] = STATE(279),
    [sym_process_substitution] = STATE(279),
    [aux_sym_command_repeat2] = STATE(683),
    [sym__simple_heredoc_body] = ACTIONS(2058),
    [sym__heredoc_body_beginning] = ACTIONS(2058),
    [sym_file_descriptor] = ACTIONS(2058),
    [anon_sym_SEMI] = ACTIONS(2060),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_SEMI_SEMI] = ACTIONS(2058),
    [anon_sym_PIPE_AMP] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_PIPE_PIPE] = ACTIONS(2058),
    [anon_sym_EQ_TILDE] = ACTIONS(513),
    [anon_sym_EQ_EQ] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2058),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2058),
    [anon_sym_LT_AMP] = ACTIONS(2058),
    [anon_sym_GT_AMP] = ACTIONS(2058),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2058),
    [anon_sym_LT_LT_LT] = ACTIONS(2058),
    [sym__special_characters] = ACTIONS(515),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(517),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2060),
  },
  [960] = {
    [sym__simple_heredoc_body] = ACTIONS(3121),
    [sym__heredoc_body_beginning] = ACTIONS(3121),
    [sym_file_descriptor] = ACTIONS(3121),
    [sym__concat] = ACTIONS(3121),
    [ts_builtin_sym_end] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3123),
    [anon_sym_RPAREN] = ACTIONS(3121),
    [anon_sym_SEMI_SEMI] = ACTIONS(3121),
    [anon_sym_PIPE_AMP] = ACTIONS(3121),
    [anon_sym_AMP_AMP] = ACTIONS(3121),
    [anon_sym_PIPE_PIPE] = ACTIONS(3121),
    [anon_sym_EQ_TILDE] = ACTIONS(3123),
    [anon_sym_EQ_EQ] = ACTIONS(3123),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_GT] = ACTIONS(3123),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_AMP_GT] = ACTIONS(3123),
    [anon_sym_AMP_GT_GT] = ACTIONS(3121),
    [anon_sym_LT_AMP] = ACTIONS(3121),
    [anon_sym_GT_AMP] = ACTIONS(3121),
    [anon_sym_LT_LT] = ACTIONS(3123),
    [anon_sym_LT_LT_DASH] = ACTIONS(3121),
    [anon_sym_LT_LT_LT] = ACTIONS(3121),
    [sym__special_characters] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [sym_raw_string] = ACTIONS(3121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3121),
    [anon_sym_BQUOTE] = ACTIONS(3121),
    [anon_sym_LT_LPAREN] = ACTIONS(3121),
    [anon_sym_GT_LPAREN] = ACTIONS(3121),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3123),
    [anon_sym_LF] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
  },
  [961] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(3125),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [962] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3125),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [963] = {
    [anon_sym_SEMI] = ACTIONS(3127),
    [anon_sym_RPAREN] = ACTIONS(3125),
    [anon_sym_SEMI_SEMI] = ACTIONS(3129),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3129),
  },
  [964] = {
    [sym__simple_heredoc_body] = ACTIONS(3131),
    [sym__heredoc_body_beginning] = ACTIONS(3131),
    [sym_file_descriptor] = ACTIONS(3131),
    [ts_builtin_sym_end] = ACTIONS(3131),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym_esac] = ACTIONS(3131),
    [anon_sym_PIPE] = ACTIONS(3133),
    [anon_sym_RPAREN] = ACTIONS(3131),
    [anon_sym_SEMI_SEMI] = ACTIONS(3131),
    [anon_sym_PIPE_AMP] = ACTIONS(3131),
    [anon_sym_AMP_AMP] = ACTIONS(3131),
    [anon_sym_PIPE_PIPE] = ACTIONS(3131),
    [anon_sym_LT] = ACTIONS(3133),
    [anon_sym_GT] = ACTIONS(3133),
    [anon_sym_GT_GT] = ACTIONS(3131),
    [anon_sym_AMP_GT] = ACTIONS(3133),
    [anon_sym_AMP_GT_GT] = ACTIONS(3131),
    [anon_sym_LT_AMP] = ACTIONS(3131),
    [anon_sym_GT_AMP] = ACTIONS(3131),
    [anon_sym_LT_LT] = ACTIONS(3133),
    [anon_sym_LT_LT_DASH] = ACTIONS(3131),
    [anon_sym_LT_LT_LT] = ACTIONS(3131),
    [anon_sym_BQUOTE] = ACTIONS(3131),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3131),
    [anon_sym_AMP] = ACTIONS(3133),
  },
  [965] = {
    [sym__heredoc_body_middle] = ACTIONS(817),
    [sym__heredoc_body_end] = ACTIONS(817),
    [anon_sym_DOLLAR] = ACTIONS(819),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [sym_comment] = ACTIONS(57),
  },
  [966] = {
    [sym__heredoc_body_middle] = ACTIONS(825),
    [sym__heredoc_body_end] = ACTIONS(825),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(825),
    [sym_comment] = ACTIONS(57),
  },
  [967] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(3135),
    [sym_comment] = ACTIONS(57),
  },
  [968] = {
    [sym_subscript] = STATE(1422),
    [sym_variable_name] = ACTIONS(3137),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_DOLLAR] = ACTIONS(3139),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3141),
    [anon_sym_STAR] = ACTIONS(3143),
    [anon_sym_AT] = ACTIONS(3143),
    [anon_sym_QMARK] = ACTIONS(3143),
    [anon_sym_0] = ACTIONS(3141),
    [anon_sym__] = ACTIONS(3141),
  },
  [969] = {
    [sym_concatenation] = STATE(1425),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1425),
    [anon_sym_RBRACE] = ACTIONS(3145),
    [anon_sym_EQ] = ACTIONS(3147),
    [anon_sym_DASH] = ACTIONS(3147),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(3151),
    [anon_sym_COLON] = ACTIONS(3147),
    [anon_sym_COLON_QMARK] = ACTIONS(3147),
    [anon_sym_COLON_DASH] = ACTIONS(3147),
    [anon_sym_PERCENT] = ACTIONS(3147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [970] = {
    [sym_concatenation] = STATE(1428),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1428),
    [anon_sym_RBRACE] = ACTIONS(3153),
    [anon_sym_EQ] = ACTIONS(3155),
    [anon_sym_DASH] = ACTIONS(3155),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3157),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(3159),
    [anon_sym_COLON] = ACTIONS(3155),
    [anon_sym_COLON_QMARK] = ACTIONS(3155),
    [anon_sym_COLON_DASH] = ACTIONS(3155),
    [anon_sym_PERCENT] = ACTIONS(3155),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [971] = {
    [ts_builtin_sym_end] = ACTIONS(3161),
    [anon_sym_SEMI] = ACTIONS(3163),
    [anon_sym_RPAREN] = ACTIONS(3161),
    [anon_sym_SEMI_SEMI] = ACTIONS(3161),
    [anon_sym_BQUOTE] = ACTIONS(3161),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3161),
    [anon_sym_AMP] = ACTIONS(3161),
  },
  [972] = {
    [sym_simple_expansion] = STATE(972),
    [sym_expansion] = STATE(972),
    [aux_sym_heredoc_body_repeat1] = STATE(972),
    [sym__heredoc_body_middle] = ACTIONS(3165),
    [sym__heredoc_body_end] = ACTIONS(3168),
    [anon_sym_DOLLAR] = ACTIONS(3170),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3173),
    [sym_comment] = ACTIONS(57),
  },
  [973] = {
    [aux_sym_concatenation_repeat1] = STATE(976),
    [sym__simple_heredoc_body] = ACTIONS(1067),
    [sym__heredoc_body_beginning] = ACTIONS(1067),
    [sym_file_descriptor] = ACTIONS(1067),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(1067),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(1069),
    [anon_sym_SEMI_SEMI] = ACTIONS(1067),
    [anon_sym_PIPE_AMP] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1069),
    [anon_sym_GT_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT] = ACTIONS(1069),
    [anon_sym_AMP_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_AMP] = ACTIONS(1067),
    [anon_sym_GT_AMP] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1069),
    [anon_sym_LT_LT_DASH] = ACTIONS(1067),
    [anon_sym_LT_LT_LT] = ACTIONS(1067),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1069),
  },
  [974] = {
    [aux_sym_concatenation_repeat1] = STATE(976),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
  },
  [975] = {
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [ts_builtin_sym_end] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_esac] = ACTIONS(1071),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
  },
  [976] = {
    [aux_sym_concatenation_repeat1] = STATE(1429),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(779),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [977] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [ts_builtin_sym_end] = ACTIONS(3176),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [978] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_done] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_fi] = ACTIONS(931),
    [anon_sym_elif] = ACTIONS(931),
    [anon_sym_else] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_SEMI_SEMI] = ACTIONS(927),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [979] = {
    [anon_sym_SEMI] = ACTIONS(3178),
    [anon_sym_SEMI_SEMI] = ACTIONS(3180),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3180),
  },
  [980] = {
    [sym__concat] = ACTIONS(3182),
    [anon_sym_EQ] = ACTIONS(3184),
    [anon_sym_PLUS_EQ] = ACTIONS(3184),
    [sym_comment] = ACTIONS(57),
  },
  [981] = {
    [anon_sym_EQ] = ACTIONS(3184),
    [anon_sym_PLUS_EQ] = ACTIONS(3184),
    [sym_comment] = ACTIONS(57),
  },
  [982] = {
    [aux_sym_concatenation_repeat1] = STATE(982),
    [sym__concat] = ACTIONS(2614),
    [anon_sym_RBRACK] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
  },
  [983] = {
    [sym__concat] = ACTIONS(3186),
    [anon_sym_EQ] = ACTIONS(3188),
    [anon_sym_PLUS_EQ] = ACTIONS(3188),
    [sym_comment] = ACTIONS(57),
  },
  [984] = {
    [anon_sym_EQ] = ACTIONS(3188),
    [anon_sym_PLUS_EQ] = ACTIONS(3188),
    [sym_comment] = ACTIONS(57),
  },
  [985] = {
    [sym_string] = STATE(1433),
    [sym_simple_expansion] = STATE(1433),
    [sym_string_expansion] = STATE(1433),
    [sym_expansion] = STATE(1433),
    [sym_command_substitution] = STATE(1433),
    [sym_process_substitution] = STATE(1433),
    [sym__special_characters] = ACTIONS(3190),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1095),
    [sym_raw_string] = ACTIONS(3190),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3190),
  },
  [986] = {
    [aux_sym_concatenation_repeat1] = STATE(1434),
    [sym__concat] = ACTIONS(2080),
    [anon_sym_RPAREN] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(779),
  },
  [987] = {
    [sym__concat] = ACTIONS(783),
    [anon_sym_RPAREN] = ACTIONS(783),
    [sym__special_characters] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(783),
    [anon_sym_DOLLAR] = ACTIONS(785),
    [sym_raw_string] = ACTIONS(783),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(783),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(783),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [anon_sym_LT_LPAREN] = ACTIONS(783),
    [anon_sym_GT_LPAREN] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(783),
  },
  [988] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(3192),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [989] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(3192),
    [anon_sym_DOLLAR] = ACTIONS(3194),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [990] = {
    [sym__concat] = ACTIONS(817),
    [anon_sym_RPAREN] = ACTIONS(817),
    [sym__special_characters] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR] = ACTIONS(819),
    [sym_raw_string] = ACTIONS(817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(817),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(817),
    [anon_sym_GT_LPAREN] = ACTIONS(817),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(817),
  },
  [991] = {
    [sym__concat] = ACTIONS(821),
    [anon_sym_RPAREN] = ACTIONS(821),
    [sym__special_characters] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [anon_sym_DOLLAR] = ACTIONS(823),
    [sym_raw_string] = ACTIONS(821),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(821),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(821),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(821),
    [anon_sym_GT_LPAREN] = ACTIONS(821),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(821),
  },
  [992] = {
    [sym__concat] = ACTIONS(825),
    [anon_sym_RPAREN] = ACTIONS(825),
    [sym__special_characters] = ACTIONS(825),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [sym_raw_string] = ACTIONS(825),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(825),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(825),
    [anon_sym_BQUOTE] = ACTIONS(825),
    [anon_sym_LT_LPAREN] = ACTIONS(825),
    [anon_sym_GT_LPAREN] = ACTIONS(825),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(825),
  },
  [993] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(3196),
    [sym_comment] = ACTIONS(57),
  },
  [994] = {
    [sym_subscript] = STATE(1440),
    [sym_variable_name] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3200),
    [anon_sym_DOLLAR] = ACTIONS(3200),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3202),
    [anon_sym_STAR] = ACTIONS(3204),
    [anon_sym_AT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(3204),
    [anon_sym_0] = ACTIONS(3202),
    [anon_sym__] = ACTIONS(3202),
  },
  [995] = {
    [sym_concatenation] = STATE(1443),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1443),
    [anon_sym_RBRACE] = ACTIONS(3206),
    [anon_sym_EQ] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_COLON] = ACTIONS(3208),
    [anon_sym_COLON_QMARK] = ACTIONS(3208),
    [anon_sym_COLON_DASH] = ACTIONS(3208),
    [anon_sym_PERCENT] = ACTIONS(3208),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [996] = {
    [sym_concatenation] = STATE(1446),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1446),
    [anon_sym_RBRACE] = ACTIONS(3214),
    [anon_sym_EQ] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3216),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3218),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(3220),
    [anon_sym_COLON] = ACTIONS(3216),
    [anon_sym_COLON_QMARK] = ACTIONS(3216),
    [anon_sym_COLON_DASH] = ACTIONS(3216),
    [anon_sym_PERCENT] = ACTIONS(3216),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [997] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1449),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(3222),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3224),
    [anon_sym_SEMI_SEMI] = ACTIONS(3226),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3226),
    [anon_sym_AMP] = ACTIONS(3222),
  },
  [998] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1449),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3222),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3224),
    [anon_sym_SEMI_SEMI] = ACTIONS(3226),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3226),
    [anon_sym_AMP] = ACTIONS(3222),
  },
  [999] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1450),
    [sym_for_statement] = STATE(1450),
    [sym_c_style_for_statement] = STATE(1450),
    [sym_while_statement] = STATE(1450),
    [sym_if_statement] = STATE(1450),
    [sym_case_statement] = STATE(1450),
    [sym_function_definition] = STATE(1450),
    [sym_compound_statement] = STATE(1450),
    [sym_subshell] = STATE(1450),
    [sym_pipeline] = STATE(1450),
    [sym_list] = STATE(1450),
    [sym_negated_command] = STATE(1450),
    [sym_test_command] = STATE(1450),
    [sym_declaration_command] = STATE(1450),
    [sym_unset_command] = STATE(1450),
    [sym_command] = STATE(1450),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(1451),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [1000] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1453),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(3228),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(3230),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(3224),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3230),
    [anon_sym_AMP] = ACTIONS(3228),
  },
  [1001] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1453),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3228),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(3230),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(3224),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3230),
    [anon_sym_AMP] = ACTIONS(3228),
  },
  [1002] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1454),
    [sym_for_statement] = STATE(1454),
    [sym_c_style_for_statement] = STATE(1454),
    [sym_while_statement] = STATE(1454),
    [sym_if_statement] = STATE(1454),
    [sym_case_statement] = STATE(1454),
    [sym_function_definition] = STATE(1454),
    [sym_compound_statement] = STATE(1454),
    [sym_subshell] = STATE(1454),
    [sym_pipeline] = STATE(1454),
    [sym_list] = STATE(1454),
    [sym_negated_command] = STATE(1454),
    [sym_test_command] = STATE(1454),
    [sym_declaration_command] = STATE(1454),
    [sym_unset_command] = STATE(1454),
    [sym_command] = STATE(1454),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(1455),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [1003] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1458),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(3232),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3234),
    [anon_sym_SEMI_SEMI] = ACTIONS(3236),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3236),
    [anon_sym_AMP] = ACTIONS(3232),
  },
  [1004] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1458),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3232),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3234),
    [anon_sym_SEMI_SEMI] = ACTIONS(3236),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3236),
    [anon_sym_AMP] = ACTIONS(3232),
  },
  [1005] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1459),
    [sym_for_statement] = STATE(1459),
    [sym_c_style_for_statement] = STATE(1459),
    [sym_while_statement] = STATE(1459),
    [sym_if_statement] = STATE(1459),
    [sym_case_statement] = STATE(1459),
    [sym_function_definition] = STATE(1459),
    [sym_compound_statement] = STATE(1459),
    [sym_subshell] = STATE(1459),
    [sym_pipeline] = STATE(1459),
    [sym_list] = STATE(1459),
    [sym_negated_command] = STATE(1459),
    [sym_test_command] = STATE(1459),
    [sym_declaration_command] = STATE(1459),
    [sym_unset_command] = STATE(1459),
    [sym_command] = STATE(1459),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(1460),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [1006] = {
    [sym__simple_heredoc_body] = ACTIONS(3238),
    [sym__heredoc_body_beginning] = ACTIONS(3238),
    [sym_file_descriptor] = ACTIONS(3238),
    [sym_variable_name] = ACTIONS(3238),
    [ts_builtin_sym_end] = ACTIONS(3238),
    [anon_sym_SEMI] = ACTIONS(3240),
    [anon_sym_PIPE] = ACTIONS(3240),
    [anon_sym_RPAREN] = ACTIONS(3238),
    [anon_sym_SEMI_SEMI] = ACTIONS(3238),
    [anon_sym_PIPE_AMP] = ACTIONS(3238),
    [anon_sym_AMP_AMP] = ACTIONS(3238),
    [anon_sym_PIPE_PIPE] = ACTIONS(3238),
    [anon_sym_LT] = ACTIONS(3240),
    [anon_sym_GT] = ACTIONS(3240),
    [anon_sym_GT_GT] = ACTIONS(3238),
    [anon_sym_AMP_GT] = ACTIONS(3240),
    [anon_sym_AMP_GT_GT] = ACTIONS(3238),
    [anon_sym_LT_AMP] = ACTIONS(3238),
    [anon_sym_GT_AMP] = ACTIONS(3238),
    [anon_sym_LT_LT] = ACTIONS(3240),
    [anon_sym_LT_LT_DASH] = ACTIONS(3238),
    [anon_sym_LT_LT_LT] = ACTIONS(3238),
    [sym__special_characters] = ACTIONS(3238),
    [anon_sym_DQUOTE] = ACTIONS(3238),
    [anon_sym_DOLLAR] = ACTIONS(3240),
    [sym_raw_string] = ACTIONS(3238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3238),
    [anon_sym_BQUOTE] = ACTIONS(3238),
    [anon_sym_LT_LPAREN] = ACTIONS(3238),
    [anon_sym_GT_LPAREN] = ACTIONS(3238),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3240),
    [anon_sym_LF] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
  },
  [1007] = {
    [sym_concatenation] = STATE(1007),
    [sym_string] = STATE(537),
    [sym_simple_expansion] = STATE(537),
    [sym_string_expansion] = STATE(537),
    [sym_expansion] = STATE(537),
    [sym_command_substitution] = STATE(537),
    [sym_process_substitution] = STATE(537),
    [aux_sym_for_statement_repeat1] = STATE(1007),
    [anon_sym_RPAREN] = ACTIONS(3242),
    [sym__special_characters] = ACTIONS(3244),
    [anon_sym_DQUOTE] = ACTIONS(3247),
    [anon_sym_DOLLAR] = ACTIONS(3250),
    [sym_raw_string] = ACTIONS(3253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3259),
    [anon_sym_BQUOTE] = ACTIONS(3262),
    [anon_sym_LT_LPAREN] = ACTIONS(3265),
    [anon_sym_GT_LPAREN] = ACTIONS(3265),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3253),
  },
  [1008] = {
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(1726),
    [sym_variable_name] = ACTIONS(1726),
    [ts_builtin_sym_end] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [1009] = {
    [aux_sym_concatenation_repeat1] = STATE(1009),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(3268),
    [sym_variable_name] = ACTIONS(1726),
    [ts_builtin_sym_end] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [1010] = {
    [sym__simple_heredoc_body] = ACTIONS(1733),
    [sym__heredoc_body_beginning] = ACTIONS(1733),
    [sym_file_descriptor] = ACTIONS(1733),
    [sym__concat] = ACTIONS(1733),
    [sym_variable_name] = ACTIONS(1733),
    [ts_builtin_sym_end] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_PIPE] = ACTIONS(1735),
    [anon_sym_RPAREN] = ACTIONS(1733),
    [anon_sym_SEMI_SEMI] = ACTIONS(1733),
    [anon_sym_PIPE_AMP] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1735),
    [anon_sym_GT] = ACTIONS(1735),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_AMP_GT] = ACTIONS(1735),
    [anon_sym_AMP_GT_GT] = ACTIONS(1733),
    [anon_sym_LT_AMP] = ACTIONS(1733),
    [anon_sym_GT_AMP] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1735),
    [anon_sym_LT_LT_DASH] = ACTIONS(1733),
    [anon_sym_LT_LT_LT] = ACTIONS(1733),
    [sym__special_characters] = ACTIONS(1733),
    [anon_sym_DQUOTE] = ACTIONS(1733),
    [anon_sym_DOLLAR] = ACTIONS(1735),
    [sym_raw_string] = ACTIONS(1733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1733),
    [anon_sym_BQUOTE] = ACTIONS(1733),
    [anon_sym_LT_LPAREN] = ACTIONS(1733),
    [anon_sym_GT_LPAREN] = ACTIONS(1733),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1735),
    [anon_sym_LF] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1735),
  },
  [1011] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(3271),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [1012] = {
    [sym_concatenation] = STATE(1465),
    [sym_string] = STATE(1464),
    [sym_simple_expansion] = STATE(1464),
    [sym_string_expansion] = STATE(1464),
    [sym_expansion] = STATE(1464),
    [sym_command_substitution] = STATE(1464),
    [sym_process_substitution] = STATE(1464),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [sym__special_characters] = ACTIONS(3275),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(3277),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3277),
  },
  [1013] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(3279),
    [sym_comment] = ACTIONS(57),
  },
  [1014] = {
    [sym_concatenation] = STATE(1469),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1469),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3283),
    [anon_sym_COLON_QMARK] = ACTIONS(3283),
    [anon_sym_COLON_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1015] = {
    [sym_concatenation] = STATE(1471),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1471),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [anon_sym_EQ] = ACTIONS(3289),
    [anon_sym_DASH] = ACTIONS(3289),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(3293),
    [anon_sym_COLON] = ACTIONS(3289),
    [anon_sym_COLON_QMARK] = ACTIONS(3289),
    [anon_sym_COLON_DASH] = ACTIONS(3289),
    [anon_sym_PERCENT] = ACTIONS(3289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1016] = {
    [sym__simple_heredoc_body] = ACTIONS(1834),
    [sym__heredoc_body_beginning] = ACTIONS(1834),
    [sym_file_descriptor] = ACTIONS(1834),
    [sym__concat] = ACTIONS(1834),
    [sym_variable_name] = ACTIONS(1834),
    [ts_builtin_sym_end] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1836),
    [anon_sym_PIPE] = ACTIONS(1836),
    [anon_sym_RPAREN] = ACTIONS(1834),
    [anon_sym_SEMI_SEMI] = ACTIONS(1834),
    [anon_sym_PIPE_AMP] = ACTIONS(1834),
    [anon_sym_AMP_AMP] = ACTIONS(1834),
    [anon_sym_PIPE_PIPE] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1836),
    [anon_sym_GT] = ACTIONS(1836),
    [anon_sym_GT_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT] = ACTIONS(1836),
    [anon_sym_AMP_GT_GT] = ACTIONS(1834),
    [anon_sym_LT_AMP] = ACTIONS(1834),
    [anon_sym_GT_AMP] = ACTIONS(1834),
    [anon_sym_LT_LT] = ACTIONS(1836),
    [anon_sym_LT_LT_DASH] = ACTIONS(1834),
    [anon_sym_LT_LT_LT] = ACTIONS(1834),
    [sym__special_characters] = ACTIONS(1834),
    [anon_sym_DQUOTE] = ACTIONS(1834),
    [anon_sym_DOLLAR] = ACTIONS(1836),
    [sym_raw_string] = ACTIONS(1834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1834),
    [anon_sym_BQUOTE] = ACTIONS(1834),
    [anon_sym_LT_LPAREN] = ACTIONS(1834),
    [anon_sym_GT_LPAREN] = ACTIONS(1834),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1836),
    [anon_sym_LF] = ACTIONS(1834),
    [anon_sym_AMP] = ACTIONS(1836),
  },
  [1017] = {
    [sym_concatenation] = STATE(1474),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1474),
    [sym_regex] = ACTIONS(3295),
    [anon_sym_RBRACE] = ACTIONS(3297),
    [anon_sym_EQ] = ACTIONS(3299),
    [anon_sym_DASH] = ACTIONS(3299),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3299),
    [anon_sym_COLON_QMARK] = ACTIONS(3299),
    [anon_sym_COLON_DASH] = ACTIONS(3299),
    [anon_sym_PERCENT] = ACTIONS(3299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1018] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3297),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1019] = {
    [sym__simple_heredoc_body] = ACTIONS(1882),
    [sym__heredoc_body_beginning] = ACTIONS(1882),
    [sym_file_descriptor] = ACTIONS(1882),
    [sym__concat] = ACTIONS(1882),
    [sym_variable_name] = ACTIONS(1882),
    [ts_builtin_sym_end] = ACTIONS(1882),
    [anon_sym_SEMI] = ACTIONS(1884),
    [anon_sym_PIPE] = ACTIONS(1884),
    [anon_sym_RPAREN] = ACTIONS(1882),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [anon_sym_PIPE_AMP] = ACTIONS(1882),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1884),
    [anon_sym_GT_GT] = ACTIONS(1882),
    [anon_sym_AMP_GT] = ACTIONS(1884),
    [anon_sym_AMP_GT_GT] = ACTIONS(1882),
    [anon_sym_LT_AMP] = ACTIONS(1882),
    [anon_sym_GT_AMP] = ACTIONS(1882),
    [anon_sym_LT_LT] = ACTIONS(1884),
    [anon_sym_LT_LT_DASH] = ACTIONS(1882),
    [anon_sym_LT_LT_LT] = ACTIONS(1882),
    [sym__special_characters] = ACTIONS(1882),
    [anon_sym_DQUOTE] = ACTIONS(1882),
    [anon_sym_DOLLAR] = ACTIONS(1884),
    [sym_raw_string] = ACTIONS(1882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1882),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [anon_sym_LT_LPAREN] = ACTIONS(1882),
    [anon_sym_GT_LPAREN] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1884),
    [anon_sym_LF] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1884),
  },
  [1020] = {
    [sym_concatenation] = STATE(1471),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1471),
    [sym_regex] = ACTIONS(3303),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [anon_sym_EQ] = ACTIONS(3289),
    [anon_sym_DASH] = ACTIONS(3289),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3289),
    [anon_sym_COLON_QMARK] = ACTIONS(3289),
    [anon_sym_COLON_DASH] = ACTIONS(3289),
    [anon_sym_PERCENT] = ACTIONS(3289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1021] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1022] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3305),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1023] = {
    [sym__simple_heredoc_body] = ACTIONS(1890),
    [sym__heredoc_body_beginning] = ACTIONS(1890),
    [sym_file_descriptor] = ACTIONS(1890),
    [sym__concat] = ACTIONS(1890),
    [sym_variable_name] = ACTIONS(1890),
    [ts_builtin_sym_end] = ACTIONS(1890),
    [anon_sym_SEMI] = ACTIONS(1892),
    [anon_sym_PIPE] = ACTIONS(1892),
    [anon_sym_RPAREN] = ACTIONS(1890),
    [anon_sym_SEMI_SEMI] = ACTIONS(1890),
    [anon_sym_PIPE_AMP] = ACTIONS(1890),
    [anon_sym_AMP_AMP] = ACTIONS(1890),
    [anon_sym_PIPE_PIPE] = ACTIONS(1890),
    [anon_sym_LT] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(1892),
    [anon_sym_GT_GT] = ACTIONS(1890),
    [anon_sym_AMP_GT] = ACTIONS(1892),
    [anon_sym_AMP_GT_GT] = ACTIONS(1890),
    [anon_sym_LT_AMP] = ACTIONS(1890),
    [anon_sym_GT_AMP] = ACTIONS(1890),
    [anon_sym_LT_LT] = ACTIONS(1892),
    [anon_sym_LT_LT_DASH] = ACTIONS(1890),
    [anon_sym_LT_LT_LT] = ACTIONS(1890),
    [sym__special_characters] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1890),
    [anon_sym_DOLLAR] = ACTIONS(1892),
    [sym_raw_string] = ACTIONS(1890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1890),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [anon_sym_LT_LPAREN] = ACTIONS(1890),
    [anon_sym_GT_LPAREN] = ACTIONS(1890),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1892),
    [anon_sym_LF] = ACTIONS(1890),
    [anon_sym_AMP] = ACTIONS(1892),
  },
  [1024] = {
    [anon_sym_SEMI] = ACTIONS(3307),
    [anon_sym_RPAREN] = ACTIONS(3305),
    [anon_sym_SEMI_SEMI] = ACTIONS(3309),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3309),
    [anon_sym_AMP] = ACTIONS(3309),
  },
  [1025] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1479),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(3311),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3305),
    [anon_sym_SEMI_SEMI] = ACTIONS(3313),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3313),
    [anon_sym_AMP] = ACTIONS(3311),
  },
  [1026] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1479),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3311),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3305),
    [anon_sym_SEMI_SEMI] = ACTIONS(3313),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3313),
    [anon_sym_AMP] = ACTIONS(3311),
  },
  [1027] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1028] = {
    [anon_sym_SEMI] = ACTIONS(3315),
    [anon_sym_SEMI_SEMI] = ACTIONS(3317),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3317),
    [anon_sym_AMP] = ACTIONS(3317),
  },
  [1029] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1482),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(3321),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3319),
  },
  [1030] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1482),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(3321),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3319),
  },
  [1031] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3323),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1032] = {
    [sym__simple_heredoc_body] = ACTIONS(1924),
    [sym__heredoc_body_beginning] = ACTIONS(1924),
    [sym_file_descriptor] = ACTIONS(1924),
    [sym__concat] = ACTIONS(1924),
    [sym_variable_name] = ACTIONS(1924),
    [ts_builtin_sym_end] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_RPAREN] = ACTIONS(1924),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [anon_sym_PIPE_AMP] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_GT_GT] = ACTIONS(1924),
    [anon_sym_AMP_GT] = ACTIONS(1926),
    [anon_sym_AMP_GT_GT] = ACTIONS(1924),
    [anon_sym_LT_AMP] = ACTIONS(1924),
    [anon_sym_GT_AMP] = ACTIONS(1924),
    [anon_sym_LT_LT] = ACTIONS(1926),
    [anon_sym_LT_LT_DASH] = ACTIONS(1924),
    [anon_sym_LT_LT_LT] = ACTIONS(1924),
    [sym__special_characters] = ACTIONS(1924),
    [anon_sym_DQUOTE] = ACTIONS(1924),
    [anon_sym_DOLLAR] = ACTIONS(1926),
    [sym_raw_string] = ACTIONS(1924),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1924),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1924),
    [anon_sym_BQUOTE] = ACTIONS(1924),
    [anon_sym_LT_LPAREN] = ACTIONS(1924),
    [anon_sym_GT_LPAREN] = ACTIONS(1924),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1926),
    [anon_sym_LF] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1926),
  },
  [1033] = {
    [anon_sym_SEMI] = ACTIONS(3325),
    [anon_sym_RPAREN] = ACTIONS(3323),
    [anon_sym_SEMI_SEMI] = ACTIONS(3327),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3327),
    [anon_sym_AMP] = ACTIONS(3327),
  },
  [1034] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1486),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(3329),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3323),
    [anon_sym_SEMI_SEMI] = ACTIONS(3331),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3331),
    [anon_sym_AMP] = ACTIONS(3329),
  },
  [1035] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1486),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3329),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3323),
    [anon_sym_SEMI_SEMI] = ACTIONS(3331),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3331),
    [anon_sym_AMP] = ACTIONS(3329),
  },
  [1036] = {
    [sym_do_group] = STATE(1488),
    [sym_compound_statement] = STATE(1488),
    [anon_sym_SEMI] = ACTIONS(3333),
    [anon_sym_do] = ACTIONS(493),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [1037] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3335),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE_PIPE] = ACTIONS(465),
    [anon_sym_EQ_TILDE] = ACTIONS(467),
    [anon_sym_EQ_EQ] = ACTIONS(467),
    [anon_sym_EQ] = ACTIONS(469),
    [anon_sym_PLUS_EQ] = ACTIONS(465),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_BANG_EQ] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(469),
    [anon_sym_DASH] = ACTIONS(469),
    [anon_sym_DASH_EQ] = ACTIONS(465),
    [anon_sym_LT_EQ] = ACTIONS(465),
    [anon_sym_GT_EQ] = ACTIONS(465),
    [anon_sym_PLUS_PLUS] = ACTIONS(471),
    [anon_sym_DASH_DASH] = ACTIONS(471),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(465),
  },
  [1038] = {
    [sym__expression] = STATE(1490),
    [sym_binary_expression] = STATE(1490),
    [sym_unary_expression] = STATE(1490),
    [sym_postfix_expression] = STATE(1490),
    [sym_parenthesized_expression] = STATE(1490),
    [sym_concatenation] = STATE(1490),
    [sym_string] = STATE(45),
    [sym_simple_expansion] = STATE(45),
    [sym_string_expansion] = STATE(45),
    [sym_expansion] = STATE(45),
    [sym_command_substitution] = STATE(45),
    [sym_process_substitution] = STATE(45),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3335),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [1039] = {
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2306),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2306),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1040] = {
    [sym__concat] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_EQ_TILDE] = ACTIONS(1726),
    [anon_sym_EQ_EQ] = ACTIONS(1726),
    [anon_sym_EQ] = ACTIONS(1728),
    [anon_sym_PLUS_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_BANG_EQ] = ACTIONS(1726),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_DASH] = ACTIONS(1728),
    [anon_sym_DASH_EQ] = ACTIONS(1726),
    [anon_sym_LT_EQ] = ACTIONS(1726),
    [anon_sym_GT_EQ] = ACTIONS(1726),
    [anon_sym_PLUS_PLUS] = ACTIONS(1726),
    [anon_sym_DASH_DASH] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [1041] = {
    [aux_sym_concatenation_repeat1] = STATE(1041),
    [sym__concat] = ACTIONS(3337),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_EQ_TILDE] = ACTIONS(1726),
    [anon_sym_EQ_EQ] = ACTIONS(1726),
    [anon_sym_EQ] = ACTIONS(1728),
    [anon_sym_PLUS_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_BANG_EQ] = ACTIONS(1726),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_DASH] = ACTIONS(1728),
    [anon_sym_DASH_EQ] = ACTIONS(1726),
    [anon_sym_LT_EQ] = ACTIONS(1726),
    [anon_sym_GT_EQ] = ACTIONS(1726),
    [anon_sym_PLUS_PLUS] = ACTIONS(1726),
    [anon_sym_DASH_DASH] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [1042] = {
    [sym__concat] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_SEMI_SEMI] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1733),
    [anon_sym_EQ_TILDE] = ACTIONS(1733),
    [anon_sym_EQ_EQ] = ACTIONS(1733),
    [anon_sym_EQ] = ACTIONS(1735),
    [anon_sym_PLUS_EQ] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1735),
    [anon_sym_GT] = ACTIONS(1735),
    [anon_sym_BANG_EQ] = ACTIONS(1733),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_DASH_EQ] = ACTIONS(1733),
    [anon_sym_LT_EQ] = ACTIONS(1733),
    [anon_sym_GT_EQ] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1733),
    [anon_sym_LF] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1735),
  },
  [1043] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [1044] = {
    [sym_concatenation] = STATE(1495),
    [sym_string] = STATE(1494),
    [sym_simple_expansion] = STATE(1494),
    [sym_string_expansion] = STATE(1494),
    [sym_expansion] = STATE(1494),
    [sym_command_substitution] = STATE(1494),
    [sym_process_substitution] = STATE(1494),
    [anon_sym_RBRACE] = ACTIONS(3342),
    [sym__special_characters] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(3346),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3346),
  },
  [1045] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(3348),
    [sym_comment] = ACTIONS(57),
  },
  [1046] = {
    [sym_concatenation] = STATE(1499),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1499),
    [anon_sym_RBRACE] = ACTIONS(3350),
    [anon_sym_EQ] = ACTIONS(3352),
    [anon_sym_DASH] = ACTIONS(3352),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_COLON] = ACTIONS(3352),
    [anon_sym_COLON_QMARK] = ACTIONS(3352),
    [anon_sym_COLON_DASH] = ACTIONS(3352),
    [anon_sym_PERCENT] = ACTIONS(3352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1047] = {
    [sym_concatenation] = STATE(1501),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1501),
    [anon_sym_RBRACE] = ACTIONS(3342),
    [anon_sym_EQ] = ACTIONS(3358),
    [anon_sym_DASH] = ACTIONS(3358),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(3362),
    [anon_sym_COLON] = ACTIONS(3358),
    [anon_sym_COLON_QMARK] = ACTIONS(3358),
    [anon_sym_COLON_DASH] = ACTIONS(3358),
    [anon_sym_PERCENT] = ACTIONS(3358),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1048] = {
    [sym__concat] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1836),
    [anon_sym_SEMI_SEMI] = ACTIONS(1834),
    [anon_sym_AMP_AMP] = ACTIONS(1834),
    [anon_sym_PIPE_PIPE] = ACTIONS(1834),
    [anon_sym_EQ_TILDE] = ACTIONS(1834),
    [anon_sym_EQ_EQ] = ACTIONS(1834),
    [anon_sym_EQ] = ACTIONS(1836),
    [anon_sym_PLUS_EQ] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1836),
    [anon_sym_GT] = ACTIONS(1836),
    [anon_sym_BANG_EQ] = ACTIONS(1834),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_DASH] = ACTIONS(1836),
    [anon_sym_DASH_EQ] = ACTIONS(1834),
    [anon_sym_LT_EQ] = ACTIONS(1834),
    [anon_sym_GT_EQ] = ACTIONS(1834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1834),
    [anon_sym_DASH_DASH] = ACTIONS(1834),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1834),
    [anon_sym_AMP] = ACTIONS(1836),
  },
  [1049] = {
    [sym_concatenation] = STATE(1504),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1504),
    [sym_regex] = ACTIONS(3364),
    [anon_sym_RBRACE] = ACTIONS(3366),
    [anon_sym_EQ] = ACTIONS(3368),
    [anon_sym_DASH] = ACTIONS(3368),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3370),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3368),
    [anon_sym_COLON_QMARK] = ACTIONS(3368),
    [anon_sym_COLON_DASH] = ACTIONS(3368),
    [anon_sym_PERCENT] = ACTIONS(3368),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1050] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3366),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1051] = {
    [sym__concat] = ACTIONS(1882),
    [anon_sym_SEMI] = ACTIONS(1884),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_EQ_TILDE] = ACTIONS(1882),
    [anon_sym_EQ_EQ] = ACTIONS(1882),
    [anon_sym_EQ] = ACTIONS(1884),
    [anon_sym_PLUS_EQ] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1884),
    [anon_sym_BANG_EQ] = ACTIONS(1882),
    [anon_sym_PLUS] = ACTIONS(1884),
    [anon_sym_DASH] = ACTIONS(1884),
    [anon_sym_DASH_EQ] = ACTIONS(1882),
    [anon_sym_LT_EQ] = ACTIONS(1882),
    [anon_sym_GT_EQ] = ACTIONS(1882),
    [anon_sym_PLUS_PLUS] = ACTIONS(1882),
    [anon_sym_DASH_DASH] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1882),
    [anon_sym_LF] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1884),
  },
  [1052] = {
    [sym_concatenation] = STATE(1501),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1501),
    [sym_regex] = ACTIONS(3372),
    [anon_sym_RBRACE] = ACTIONS(3342),
    [anon_sym_EQ] = ACTIONS(3358),
    [anon_sym_DASH] = ACTIONS(3358),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3358),
    [anon_sym_COLON_QMARK] = ACTIONS(3358),
    [anon_sym_COLON_DASH] = ACTIONS(3358),
    [anon_sym_PERCENT] = ACTIONS(3358),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1053] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3342),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1054] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3374),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1055] = {
    [sym__concat] = ACTIONS(1890),
    [anon_sym_SEMI] = ACTIONS(1892),
    [anon_sym_SEMI_SEMI] = ACTIONS(1890),
    [anon_sym_AMP_AMP] = ACTIONS(1890),
    [anon_sym_PIPE_PIPE] = ACTIONS(1890),
    [anon_sym_EQ_TILDE] = ACTIONS(1890),
    [anon_sym_EQ_EQ] = ACTIONS(1890),
    [anon_sym_EQ] = ACTIONS(1892),
    [anon_sym_PLUS_EQ] = ACTIONS(1890),
    [anon_sym_LT] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(1892),
    [anon_sym_BANG_EQ] = ACTIONS(1890),
    [anon_sym_PLUS] = ACTIONS(1892),
    [anon_sym_DASH] = ACTIONS(1892),
    [anon_sym_DASH_EQ] = ACTIONS(1890),
    [anon_sym_LT_EQ] = ACTIONS(1890),
    [anon_sym_GT_EQ] = ACTIONS(1890),
    [anon_sym_PLUS_PLUS] = ACTIONS(1890),
    [anon_sym_DASH_DASH] = ACTIONS(1890),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1890),
    [anon_sym_LF] = ACTIONS(1890),
    [anon_sym_AMP] = ACTIONS(1892),
  },
  [1056] = {
    [anon_sym_SEMI] = ACTIONS(3376),
    [anon_sym_RPAREN] = ACTIONS(3374),
    [anon_sym_SEMI_SEMI] = ACTIONS(3378),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3378),
    [anon_sym_AMP] = ACTIONS(3378),
  },
  [1057] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1509),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(3380),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3374),
    [anon_sym_SEMI_SEMI] = ACTIONS(3382),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3382),
    [anon_sym_AMP] = ACTIONS(3380),
  },
  [1058] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1509),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3380),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3374),
    [anon_sym_SEMI_SEMI] = ACTIONS(3382),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3382),
    [anon_sym_AMP] = ACTIONS(3380),
  },
  [1059] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(3374),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1060] = {
    [anon_sym_SEMI] = ACTIONS(3384),
    [anon_sym_SEMI_SEMI] = ACTIONS(3386),
    [anon_sym_BQUOTE] = ACTIONS(3374),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3386),
    [anon_sym_AMP] = ACTIONS(3386),
  },
  [1061] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1512),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(3388),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(3390),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(3374),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3390),
    [anon_sym_AMP] = ACTIONS(3388),
  },
  [1062] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1512),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3388),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(3390),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(3374),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3390),
    [anon_sym_AMP] = ACTIONS(3388),
  },
  [1063] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3392),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1064] = {
    [sym__concat] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_EQ_TILDE] = ACTIONS(1924),
    [anon_sym_EQ_EQ] = ACTIONS(1924),
    [anon_sym_EQ] = ACTIONS(1926),
    [anon_sym_PLUS_EQ] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_BANG_EQ] = ACTIONS(1924),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_DASH_EQ] = ACTIONS(1924),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_PLUS_PLUS] = ACTIONS(1924),
    [anon_sym_DASH_DASH] = ACTIONS(1924),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1924),
    [anon_sym_LF] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1926),
  },
  [1065] = {
    [anon_sym_SEMI] = ACTIONS(3394),
    [anon_sym_RPAREN] = ACTIONS(3392),
    [anon_sym_SEMI_SEMI] = ACTIONS(3396),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3396),
    [anon_sym_AMP] = ACTIONS(3396),
  },
  [1066] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1516),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(3398),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3392),
    [anon_sym_SEMI_SEMI] = ACTIONS(3400),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3400),
    [anon_sym_AMP] = ACTIONS(3398),
  },
  [1067] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1516),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3398),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3392),
    [anon_sym_SEMI_SEMI] = ACTIONS(3400),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3400),
    [anon_sym_AMP] = ACTIONS(3398),
  },
  [1068] = {
    [anon_sym_SEMI] = ACTIONS(3402),
    [anon_sym_SEMI_SEMI] = ACTIONS(3404),
    [anon_sym_AMP_AMP] = ACTIONS(1167),
    [anon_sym_PIPE_PIPE] = ACTIONS(1167),
    [anon_sym_EQ_TILDE] = ACTIONS(1169),
    [anon_sym_EQ_EQ] = ACTIONS(1169),
    [anon_sym_EQ] = ACTIONS(1171),
    [anon_sym_PLUS_EQ] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(1171),
    [anon_sym_BANG_EQ] = ACTIONS(1167),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1171),
    [anon_sym_DASH_EQ] = ACTIONS(1167),
    [anon_sym_LT_EQ] = ACTIONS(1167),
    [anon_sym_GT_EQ] = ACTIONS(1167),
    [anon_sym_PLUS_PLUS] = ACTIONS(1173),
    [anon_sym_DASH_DASH] = ACTIONS(1173),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1167),
    [anon_sym_LF] = ACTIONS(3404),
    [anon_sym_AMP] = ACTIONS(3402),
  },
  [1069] = {
    [anon_sym_SEMI] = ACTIONS(2379),
    [anon_sym_SEMI_SEMI] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_EQ_TILDE] = ACTIONS(2377),
    [anon_sym_EQ_EQ] = ACTIONS(2377),
    [anon_sym_EQ] = ACTIONS(2379),
    [anon_sym_PLUS_EQ] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2379),
    [anon_sym_GT] = ACTIONS(2379),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2379),
    [anon_sym_DASH] = ACTIONS(2379),
    [anon_sym_DASH_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_PLUS_PLUS] = ACTIONS(2377),
    [anon_sym_DASH_DASH] = ACTIONS(2377),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2377),
    [anon_sym_LF] = ACTIONS(2377),
    [anon_sym_AMP] = ACTIONS(2379),
  },
  [1070] = {
    [anon_sym_SEMI] = ACTIONS(2379),
    [anon_sym_SEMI_SEMI] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_EQ_TILDE] = ACTIONS(2377),
    [anon_sym_EQ_EQ] = ACTIONS(2377),
    [anon_sym_EQ] = ACTIONS(2379),
    [anon_sym_PLUS_EQ] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2379),
    [anon_sym_GT] = ACTIONS(2379),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2379),
    [anon_sym_DASH] = ACTIONS(2379),
    [anon_sym_DASH_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_PLUS_PLUS] = ACTIONS(2377),
    [anon_sym_DASH_DASH] = ACTIONS(2377),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2377),
    [anon_sym_LF] = ACTIONS(2377),
    [anon_sym_AMP] = ACTIONS(2379),
  },
  [1071] = {
    [sym_string] = STATE(1518),
    [sym_simple_expansion] = STATE(1518),
    [sym_string_expansion] = STATE(1518),
    [sym_expansion] = STATE(1518),
    [sym_command_substitution] = STATE(1518),
    [sym_process_substitution] = STATE(1518),
    [sym__special_characters] = ACTIONS(3406),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_DOLLAR] = ACTIONS(1179),
    [sym_raw_string] = ACTIONS(3406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1183),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1185),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1189),
    [anon_sym_GT_LPAREN] = ACTIONS(1189),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3406),
  },
  [1072] = {
    [aux_sym_concatenation_repeat1] = STATE(1519),
    [sym__concat] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(781),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(779),
  },
  [1073] = {
    [sym__concat] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [sym__special_characters] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(783),
    [anon_sym_DOLLAR] = ACTIONS(785),
    [sym_raw_string] = ACTIONS(783),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(783),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(783),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [anon_sym_LT_LPAREN] = ACTIONS(783),
    [anon_sym_GT_LPAREN] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(785),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(783),
  },
  [1074] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(3408),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [1075] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(3408),
    [anon_sym_DOLLAR] = ACTIONS(3410),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [1076] = {
    [sym__concat] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(819),
    [anon_sym_SEMI_SEMI] = ACTIONS(817),
    [sym__special_characters] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR] = ACTIONS(819),
    [sym_raw_string] = ACTIONS(817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(817),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(817),
    [anon_sym_GT_LPAREN] = ACTIONS(817),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(819),
    [anon_sym_LF] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(817),
  },
  [1077] = {
    [sym__concat] = ACTIONS(821),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_SEMI_SEMI] = ACTIONS(821),
    [sym__special_characters] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [anon_sym_DOLLAR] = ACTIONS(823),
    [sym_raw_string] = ACTIONS(821),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(821),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(821),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(821),
    [anon_sym_GT_LPAREN] = ACTIONS(821),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(823),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(821),
  },
  [1078] = {
    [sym__concat] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(827),
    [anon_sym_SEMI_SEMI] = ACTIONS(825),
    [sym__special_characters] = ACTIONS(825),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [sym_raw_string] = ACTIONS(825),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(825),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(825),
    [anon_sym_BQUOTE] = ACTIONS(825),
    [anon_sym_LT_LPAREN] = ACTIONS(825),
    [anon_sym_GT_LPAREN] = ACTIONS(825),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(827),
    [anon_sym_LF] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(825),
  },
  [1079] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(3412),
    [sym_comment] = ACTIONS(57),
  },
  [1080] = {
    [sym_subscript] = STATE(1525),
    [sym_variable_name] = ACTIONS(3414),
    [anon_sym_DASH] = ACTIONS(3416),
    [anon_sym_DOLLAR] = ACTIONS(3416),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3418),
    [anon_sym_STAR] = ACTIONS(3420),
    [anon_sym_AT] = ACTIONS(3420),
    [anon_sym_QMARK] = ACTIONS(3420),
    [anon_sym_0] = ACTIONS(3418),
    [anon_sym__] = ACTIONS(3418),
  },
  [1081] = {
    [sym_concatenation] = STATE(1528),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1528),
    [anon_sym_RBRACE] = ACTIONS(3422),
    [anon_sym_EQ] = ACTIONS(3424),
    [anon_sym_DASH] = ACTIONS(3424),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3426),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(3428),
    [anon_sym_COLON] = ACTIONS(3424),
    [anon_sym_COLON_QMARK] = ACTIONS(3424),
    [anon_sym_COLON_DASH] = ACTIONS(3424),
    [anon_sym_PERCENT] = ACTIONS(3424),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1082] = {
    [sym_concatenation] = STATE(1531),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1531),
    [anon_sym_RBRACE] = ACTIONS(3430),
    [anon_sym_EQ] = ACTIONS(3432),
    [anon_sym_DASH] = ACTIONS(3432),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(3436),
    [anon_sym_COLON] = ACTIONS(3432),
    [anon_sym_COLON_QMARK] = ACTIONS(3432),
    [anon_sym_COLON_DASH] = ACTIONS(3432),
    [anon_sym_PERCENT] = ACTIONS(3432),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1083] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1534),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(3438),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3440),
    [anon_sym_SEMI_SEMI] = ACTIONS(3442),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3442),
    [anon_sym_AMP] = ACTIONS(3438),
  },
  [1084] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1534),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3438),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3440),
    [anon_sym_SEMI_SEMI] = ACTIONS(3442),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3442),
    [anon_sym_AMP] = ACTIONS(3438),
  },
  [1085] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1535),
    [sym_for_statement] = STATE(1535),
    [sym_c_style_for_statement] = STATE(1535),
    [sym_while_statement] = STATE(1535),
    [sym_if_statement] = STATE(1535),
    [sym_case_statement] = STATE(1535),
    [sym_function_definition] = STATE(1535),
    [sym_compound_statement] = STATE(1535),
    [sym_subshell] = STATE(1535),
    [sym_pipeline] = STATE(1535),
    [sym_list] = STATE(1535),
    [sym_negated_command] = STATE(1535),
    [sym_test_command] = STATE(1535),
    [sym_declaration_command] = STATE(1535),
    [sym_unset_command] = STATE(1535),
    [sym_command] = STATE(1535),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(1536),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [1086] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1538),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(3446),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(3440),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3444),
  },
  [1087] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1538),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(3446),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(3440),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3444),
  },
  [1088] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1539),
    [sym_for_statement] = STATE(1539),
    [sym_c_style_for_statement] = STATE(1539),
    [sym_while_statement] = STATE(1539),
    [sym_if_statement] = STATE(1539),
    [sym_case_statement] = STATE(1539),
    [sym_function_definition] = STATE(1539),
    [sym_compound_statement] = STATE(1539),
    [sym_subshell] = STATE(1539),
    [sym_pipeline] = STATE(1539),
    [sym_list] = STATE(1539),
    [sym_negated_command] = STATE(1539),
    [sym_test_command] = STATE(1539),
    [sym_declaration_command] = STATE(1539),
    [sym_unset_command] = STATE(1539),
    [sym_command] = STATE(1539),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(1540),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [1089] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1543),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(3448),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3450),
    [anon_sym_SEMI_SEMI] = ACTIONS(3452),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3452),
    [anon_sym_AMP] = ACTIONS(3448),
  },
  [1090] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1543),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3448),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3450),
    [anon_sym_SEMI_SEMI] = ACTIONS(3452),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3452),
    [anon_sym_AMP] = ACTIONS(3448),
  },
  [1091] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1544),
    [sym_for_statement] = STATE(1544),
    [sym_c_style_for_statement] = STATE(1544),
    [sym_while_statement] = STATE(1544),
    [sym_if_statement] = STATE(1544),
    [sym_case_statement] = STATE(1544),
    [sym_function_definition] = STATE(1544),
    [sym_compound_statement] = STATE(1544),
    [sym_subshell] = STATE(1544),
    [sym_pipeline] = STATE(1544),
    [sym_list] = STATE(1544),
    [sym_negated_command] = STATE(1544),
    [sym_test_command] = STATE(1544),
    [sym_declaration_command] = STATE(1544),
    [sym_unset_command] = STATE(1544),
    [sym_command] = STATE(1544),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(1545),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [1092] = {
    [sym_do_group] = STATE(1546),
    [anon_sym_do] = ACTIONS(493),
    [sym_comment] = ACTIONS(57),
  },
  [1093] = {
    [sym_concatenation] = STATE(1093),
    [sym_string] = STATE(596),
    [sym_simple_expansion] = STATE(596),
    [sym_string_expansion] = STATE(596),
    [sym_expansion] = STATE(596),
    [sym_command_substitution] = STATE(596),
    [sym_process_substitution] = STATE(596),
    [aux_sym_for_statement_repeat1] = STATE(1093),
    [anon_sym_SEMI] = ACTIONS(3454),
    [anon_sym_SEMI_SEMI] = ACTIONS(3242),
    [sym__special_characters] = ACTIONS(3456),
    [anon_sym_DQUOTE] = ACTIONS(3459),
    [anon_sym_DOLLAR] = ACTIONS(3462),
    [sym_raw_string] = ACTIONS(3465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3471),
    [anon_sym_BQUOTE] = ACTIONS(3474),
    [anon_sym_LT_LPAREN] = ACTIONS(3477),
    [anon_sym_GT_LPAREN] = ACTIONS(3477),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3480),
    [anon_sym_LF] = ACTIONS(3242),
    [anon_sym_AMP] = ACTIONS(3242),
  },
  [1094] = {
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2306),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2306),
  },
  [1095] = {
    [sym__concat] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_EQ_TILDE] = ACTIONS(1726),
    [anon_sym_EQ_EQ] = ACTIONS(1726),
    [anon_sym_EQ] = ACTIONS(1728),
    [anon_sym_PLUS_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_BANG_EQ] = ACTIONS(1726),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_DASH] = ACTIONS(1728),
    [anon_sym_DASH_EQ] = ACTIONS(1726),
    [anon_sym_LT_EQ] = ACTIONS(1726),
    [anon_sym_GT_EQ] = ACTIONS(1726),
    [anon_sym_PLUS_PLUS] = ACTIONS(1726),
    [anon_sym_DASH_DASH] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1726),
  },
  [1096] = {
    [aux_sym_concatenation_repeat1] = STATE(1096),
    [sym__concat] = ACTIONS(3483),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_EQ_TILDE] = ACTIONS(1726),
    [anon_sym_EQ_EQ] = ACTIONS(1726),
    [anon_sym_EQ] = ACTIONS(1728),
    [anon_sym_PLUS_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_BANG_EQ] = ACTIONS(1726),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_DASH] = ACTIONS(1728),
    [anon_sym_DASH_EQ] = ACTIONS(1726),
    [anon_sym_LT_EQ] = ACTIONS(1726),
    [anon_sym_GT_EQ] = ACTIONS(1726),
    [anon_sym_PLUS_PLUS] = ACTIONS(1726),
    [anon_sym_DASH_DASH] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1726),
  },
  [1097] = {
    [sym__concat] = ACTIONS(1733),
    [anon_sym_PIPE] = ACTIONS(1735),
    [anon_sym_RPAREN] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1733),
    [anon_sym_EQ_TILDE] = ACTIONS(1733),
    [anon_sym_EQ_EQ] = ACTIONS(1733),
    [anon_sym_EQ] = ACTIONS(1735),
    [anon_sym_PLUS_EQ] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1735),
    [anon_sym_GT] = ACTIONS(1735),
    [anon_sym_BANG_EQ] = ACTIONS(1733),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_DASH_EQ] = ACTIONS(1733),
    [anon_sym_LT_EQ] = ACTIONS(1733),
    [anon_sym_GT_EQ] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1733),
  },
  [1098] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(3486),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [1099] = {
    [sym_concatenation] = STATE(1551),
    [sym_string] = STATE(1550),
    [sym_simple_expansion] = STATE(1550),
    [sym_string_expansion] = STATE(1550),
    [sym_expansion] = STATE(1550),
    [sym_command_substitution] = STATE(1550),
    [sym_process_substitution] = STATE(1550),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [sym__special_characters] = ACTIONS(3490),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(3492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3492),
  },
  [1100] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(3494),
    [sym_comment] = ACTIONS(57),
  },
  [1101] = {
    [sym_concatenation] = STATE(1555),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1555),
    [anon_sym_RBRACE] = ACTIONS(3496),
    [anon_sym_EQ] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(3502),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_DASH] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1102] = {
    [sym_concatenation] = STATE(1557),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1557),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_EQ] = ACTIONS(3504),
    [anon_sym_DASH] = ACTIONS(3504),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(3508),
    [anon_sym_COLON] = ACTIONS(3504),
    [anon_sym_COLON_QMARK] = ACTIONS(3504),
    [anon_sym_COLON_DASH] = ACTIONS(3504),
    [anon_sym_PERCENT] = ACTIONS(3504),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1103] = {
    [sym__concat] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1836),
    [anon_sym_RPAREN] = ACTIONS(1834),
    [anon_sym_AMP_AMP] = ACTIONS(1834),
    [anon_sym_PIPE_PIPE] = ACTIONS(1834),
    [anon_sym_EQ_TILDE] = ACTIONS(1834),
    [anon_sym_EQ_EQ] = ACTIONS(1834),
    [anon_sym_EQ] = ACTIONS(1836),
    [anon_sym_PLUS_EQ] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1836),
    [anon_sym_GT] = ACTIONS(1836),
    [anon_sym_BANG_EQ] = ACTIONS(1834),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_DASH] = ACTIONS(1836),
    [anon_sym_DASH_EQ] = ACTIONS(1834),
    [anon_sym_LT_EQ] = ACTIONS(1834),
    [anon_sym_GT_EQ] = ACTIONS(1834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1834),
    [anon_sym_DASH_DASH] = ACTIONS(1834),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1834),
  },
  [1104] = {
    [sym_concatenation] = STATE(1560),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1560),
    [sym_regex] = ACTIONS(3510),
    [anon_sym_RBRACE] = ACTIONS(3512),
    [anon_sym_EQ] = ACTIONS(3514),
    [anon_sym_DASH] = ACTIONS(3514),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3516),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3514),
    [anon_sym_COLON_QMARK] = ACTIONS(3514),
    [anon_sym_COLON_DASH] = ACTIONS(3514),
    [anon_sym_PERCENT] = ACTIONS(3514),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1105] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3512),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1106] = {
    [sym__concat] = ACTIONS(1882),
    [anon_sym_PIPE] = ACTIONS(1884),
    [anon_sym_RPAREN] = ACTIONS(1882),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_EQ_TILDE] = ACTIONS(1882),
    [anon_sym_EQ_EQ] = ACTIONS(1882),
    [anon_sym_EQ] = ACTIONS(1884),
    [anon_sym_PLUS_EQ] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1884),
    [anon_sym_BANG_EQ] = ACTIONS(1882),
    [anon_sym_PLUS] = ACTIONS(1884),
    [anon_sym_DASH] = ACTIONS(1884),
    [anon_sym_DASH_EQ] = ACTIONS(1882),
    [anon_sym_LT_EQ] = ACTIONS(1882),
    [anon_sym_GT_EQ] = ACTIONS(1882),
    [anon_sym_PLUS_PLUS] = ACTIONS(1882),
    [anon_sym_DASH_DASH] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1882),
  },
  [1107] = {
    [sym_concatenation] = STATE(1557),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1557),
    [sym_regex] = ACTIONS(3518),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_EQ] = ACTIONS(3504),
    [anon_sym_DASH] = ACTIONS(3504),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3504),
    [anon_sym_COLON_QMARK] = ACTIONS(3504),
    [anon_sym_COLON_DASH] = ACTIONS(3504),
    [anon_sym_PERCENT] = ACTIONS(3504),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1108] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1109] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3520),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1110] = {
    [sym__concat] = ACTIONS(1890),
    [anon_sym_PIPE] = ACTIONS(1892),
    [anon_sym_RPAREN] = ACTIONS(1890),
    [anon_sym_AMP_AMP] = ACTIONS(1890),
    [anon_sym_PIPE_PIPE] = ACTIONS(1890),
    [anon_sym_EQ_TILDE] = ACTIONS(1890),
    [anon_sym_EQ_EQ] = ACTIONS(1890),
    [anon_sym_EQ] = ACTIONS(1892),
    [anon_sym_PLUS_EQ] = ACTIONS(1890),
    [anon_sym_LT] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(1892),
    [anon_sym_BANG_EQ] = ACTIONS(1890),
    [anon_sym_PLUS] = ACTIONS(1892),
    [anon_sym_DASH] = ACTIONS(1892),
    [anon_sym_DASH_EQ] = ACTIONS(1890),
    [anon_sym_LT_EQ] = ACTIONS(1890),
    [anon_sym_GT_EQ] = ACTIONS(1890),
    [anon_sym_PLUS_PLUS] = ACTIONS(1890),
    [anon_sym_DASH_DASH] = ACTIONS(1890),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1890),
  },
  [1111] = {
    [anon_sym_SEMI] = ACTIONS(3522),
    [anon_sym_RPAREN] = ACTIONS(3520),
    [anon_sym_SEMI_SEMI] = ACTIONS(3524),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3524),
    [anon_sym_AMP] = ACTIONS(3524),
  },
  [1112] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1565),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(3526),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3520),
    [anon_sym_SEMI_SEMI] = ACTIONS(3528),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3528),
    [anon_sym_AMP] = ACTIONS(3526),
  },
  [1113] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1565),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3526),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3520),
    [anon_sym_SEMI_SEMI] = ACTIONS(3528),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3528),
    [anon_sym_AMP] = ACTIONS(3526),
  },
  [1114] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(3520),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1115] = {
    [anon_sym_SEMI] = ACTIONS(3530),
    [anon_sym_SEMI_SEMI] = ACTIONS(3532),
    [anon_sym_BQUOTE] = ACTIONS(3520),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3532),
    [anon_sym_AMP] = ACTIONS(3532),
  },
  [1116] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1568),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(3534),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(3536),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(3520),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3536),
    [anon_sym_AMP] = ACTIONS(3534),
  },
  [1117] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1568),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3534),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(3536),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(3520),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3536),
    [anon_sym_AMP] = ACTIONS(3534),
  },
  [1118] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3538),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1119] = {
    [sym__concat] = ACTIONS(1924),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_RPAREN] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_EQ_TILDE] = ACTIONS(1924),
    [anon_sym_EQ_EQ] = ACTIONS(1924),
    [anon_sym_EQ] = ACTIONS(1926),
    [anon_sym_PLUS_EQ] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_BANG_EQ] = ACTIONS(1924),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_DASH_EQ] = ACTIONS(1924),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_PLUS_PLUS] = ACTIONS(1924),
    [anon_sym_DASH_DASH] = ACTIONS(1924),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1924),
  },
  [1120] = {
    [anon_sym_SEMI] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(3538),
    [anon_sym_SEMI_SEMI] = ACTIONS(3542),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3542),
  },
  [1121] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1572),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(3544),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3538),
    [anon_sym_SEMI_SEMI] = ACTIONS(3546),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3544),
  },
  [1122] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1572),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3544),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3538),
    [anon_sym_SEMI_SEMI] = ACTIONS(3546),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3544),
  },
  [1123] = {
    [anon_sym_RPAREN] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_EQ_TILDE] = ACTIONS(2377),
    [anon_sym_EQ_EQ] = ACTIONS(2377),
    [anon_sym_EQ] = ACTIONS(2379),
    [anon_sym_PLUS_EQ] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2379),
    [anon_sym_GT] = ACTIONS(2379),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2379),
    [anon_sym_DASH] = ACTIONS(2379),
    [anon_sym_DASH_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_PLUS_PLUS] = ACTIONS(2377),
    [anon_sym_DASH_DASH] = ACTIONS(2377),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2377),
  },
  [1124] = {
    [anon_sym_RPAREN] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_EQ_TILDE] = ACTIONS(2377),
    [anon_sym_EQ_EQ] = ACTIONS(2377),
    [anon_sym_EQ] = ACTIONS(2379),
    [anon_sym_PLUS_EQ] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2379),
    [anon_sym_GT] = ACTIONS(2379),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2379),
    [anon_sym_DASH] = ACTIONS(2379),
    [anon_sym_DASH_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_PLUS_PLUS] = ACTIONS(2377),
    [anon_sym_DASH_DASH] = ACTIONS(2377),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2377),
  },
  [1125] = {
    [sym__concat] = ACTIONS(2930),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2930),
    [anon_sym_EQ_TILDE] = ACTIONS(2930),
    [anon_sym_EQ_EQ] = ACTIONS(2930),
    [anon_sym_EQ] = ACTIONS(2932),
    [anon_sym_PLUS_EQ] = ACTIONS(2930),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2932),
    [anon_sym_BANG_EQ] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2932),
    [anon_sym_DASH_EQ] = ACTIONS(2930),
    [anon_sym_LT_EQ] = ACTIONS(2930),
    [anon_sym_GT_EQ] = ACTIONS(2930),
    [anon_sym_PLUS_PLUS] = ACTIONS(2930),
    [anon_sym_DASH_DASH] = ACTIONS(2930),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2930),
  },
  [1126] = {
    [sym__concat] = ACTIONS(2944),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2944),
    [anon_sym_AMP_AMP] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2944),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2944),
    [anon_sym_EQ_TILDE] = ACTIONS(2944),
    [anon_sym_EQ_EQ] = ACTIONS(2944),
    [anon_sym_EQ] = ACTIONS(2946),
    [anon_sym_PLUS_EQ] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2944),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_DASH_EQ] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2944),
    [anon_sym_GT_EQ] = ACTIONS(2944),
    [anon_sym_PLUS_PLUS] = ACTIONS(2944),
    [anon_sym_DASH_DASH] = ACTIONS(2944),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2944),
  },
  [1127] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(3548),
    [sym_comment] = ACTIONS(57),
  },
  [1128] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(3550),
    [sym_comment] = ACTIONS(57),
  },
  [1129] = {
    [anon_sym_RBRACE] = ACTIONS(3550),
    [sym_comment] = ACTIONS(57),
  },
  [1130] = {
    [sym_concatenation] = STATE(1577),
    [sym_string] = STATE(1576),
    [sym_simple_expansion] = STATE(1576),
    [sym_string_expansion] = STATE(1576),
    [sym_expansion] = STATE(1576),
    [sym_command_substitution] = STATE(1576),
    [sym_process_substitution] = STATE(1576),
    [anon_sym_RBRACE] = ACTIONS(3550),
    [sym__special_characters] = ACTIONS(3552),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(3554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3554),
  },
  [1131] = {
    [sym__concat] = ACTIONS(2980),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_PIPE_PIPE] = ACTIONS(2980),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2980),
    [anon_sym_EQ_TILDE] = ACTIONS(2980),
    [anon_sym_EQ_EQ] = ACTIONS(2980),
    [anon_sym_EQ] = ACTIONS(2982),
    [anon_sym_PLUS_EQ] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2982),
    [anon_sym_BANG_EQ] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2982),
    [anon_sym_DASH] = ACTIONS(2982),
    [anon_sym_DASH_EQ] = ACTIONS(2980),
    [anon_sym_LT_EQ] = ACTIONS(2980),
    [anon_sym_GT_EQ] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2980),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2980),
  },
  [1132] = {
    [sym_concatenation] = STATE(1580),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1580),
    [sym_regex] = ACTIONS(3556),
    [anon_sym_RBRACE] = ACTIONS(3558),
    [anon_sym_EQ] = ACTIONS(3560),
    [anon_sym_DASH] = ACTIONS(3560),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3562),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3560),
    [anon_sym_COLON_QMARK] = ACTIONS(3560),
    [anon_sym_COLON_DASH] = ACTIONS(3560),
    [anon_sym_PERCENT] = ACTIONS(3560),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1133] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3558),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1134] = {
    [sym_concatenation] = STATE(1582),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1582),
    [sym_regex] = ACTIONS(3564),
    [anon_sym_RBRACE] = ACTIONS(3550),
    [anon_sym_EQ] = ACTIONS(3566),
    [anon_sym_DASH] = ACTIONS(3566),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3566),
    [anon_sym_COLON_QMARK] = ACTIONS(3566),
    [anon_sym_COLON_DASH] = ACTIONS(3566),
    [anon_sym_PERCENT] = ACTIONS(3566),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1135] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3550),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1136] = {
    [sym_concatenation] = STATE(1584),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1584),
    [anon_sym_RBRACE] = ACTIONS(3570),
    [anon_sym_EQ] = ACTIONS(3572),
    [anon_sym_DASH] = ACTIONS(3572),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3574),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3572),
    [anon_sym_COLON_QMARK] = ACTIONS(3572),
    [anon_sym_COLON_DASH] = ACTIONS(3572),
    [anon_sym_PERCENT] = ACTIONS(3572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1137] = {
    [sym__concat] = ACTIONS(3036),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_PIPE_PIPE] = ACTIONS(3036),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3036),
    [anon_sym_EQ_TILDE] = ACTIONS(3036),
    [anon_sym_EQ_EQ] = ACTIONS(3036),
    [anon_sym_EQ] = ACTIONS(3038),
    [anon_sym_PLUS_EQ] = ACTIONS(3036),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_GT] = ACTIONS(3038),
    [anon_sym_BANG_EQ] = ACTIONS(3036),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_DASH_EQ] = ACTIONS(3036),
    [anon_sym_LT_EQ] = ACTIONS(3036),
    [anon_sym_GT_EQ] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3036),
  },
  [1138] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3570),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1139] = {
    [sym_concatenation] = STATE(1582),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1582),
    [anon_sym_RBRACE] = ACTIONS(3550),
    [anon_sym_EQ] = ACTIONS(3566),
    [anon_sym_DASH] = ACTIONS(3566),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3566),
    [anon_sym_COLON_QMARK] = ACTIONS(3566),
    [anon_sym_COLON_DASH] = ACTIONS(3566),
    [anon_sym_PERCENT] = ACTIONS(3566),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1140] = {
    [sym__concat] = ACTIONS(3091),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3091),
    [anon_sym_EQ_TILDE] = ACTIONS(3091),
    [anon_sym_EQ_EQ] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_PLUS_EQ] = ACTIONS(3091),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_GT] = ACTIONS(3093),
    [anon_sym_BANG_EQ] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3093),
    [anon_sym_DASH] = ACTIONS(3093),
    [anon_sym_DASH_EQ] = ACTIONS(3091),
    [anon_sym_LT_EQ] = ACTIONS(3091),
    [anon_sym_GT_EQ] = ACTIONS(3091),
    [anon_sym_PLUS_PLUS] = ACTIONS(3091),
    [anon_sym_DASH_DASH] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3091),
  },
  [1141] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(3576),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1142] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3576),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1143] = {
    [anon_sym_SEMI] = ACTIONS(3578),
    [anon_sym_RPAREN] = ACTIONS(3576),
    [anon_sym_SEMI_SEMI] = ACTIONS(3580),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3580),
    [anon_sym_AMP] = ACTIONS(3580),
  },
  [1144] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(3576),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1145] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(3576),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1146] = {
    [anon_sym_SEMI] = ACTIONS(3582),
    [anon_sym_SEMI_SEMI] = ACTIONS(3584),
    [anon_sym_BQUOTE] = ACTIONS(3576),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3584),
    [anon_sym_AMP] = ACTIONS(3584),
  },
  [1147] = {
    [sym__concat] = ACTIONS(3121),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3121),
    [anon_sym_AMP_AMP] = ACTIONS(3121),
    [anon_sym_PIPE_PIPE] = ACTIONS(3121),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3121),
    [anon_sym_EQ_TILDE] = ACTIONS(3121),
    [anon_sym_EQ_EQ] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(3123),
    [anon_sym_PLUS_EQ] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_GT] = ACTIONS(3123),
    [anon_sym_BANG_EQ] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_DASH_EQ] = ACTIONS(3121),
    [anon_sym_LT_EQ] = ACTIONS(3121),
    [anon_sym_GT_EQ] = ACTIONS(3121),
    [anon_sym_PLUS_PLUS] = ACTIONS(3121),
    [anon_sym_DASH_DASH] = ACTIONS(3121),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3121),
  },
  [1148] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(3586),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1149] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3586),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1150] = {
    [anon_sym_SEMI] = ACTIONS(3588),
    [anon_sym_RPAREN] = ACTIONS(3586),
    [anon_sym_SEMI_SEMI] = ACTIONS(3590),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3590),
    [anon_sym_AMP] = ACTIONS(3590),
  },
  [1151] = {
    [aux_sym_concatenation_repeat1] = STATE(1590),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(1109),
    [sym_variable_name] = ACTIONS(779),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(781),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [1152] = {
    [aux_sym_concatenation_repeat1] = STATE(663),
    [sym__simple_heredoc_body] = ACTIONS(1107),
    [sym__heredoc_body_beginning] = ACTIONS(1107),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(671),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_SEMI] = ACTIONS(1111),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_SEMI_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT] = ACTIONS(1111),
    [anon_sym_AMP_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_AMP] = ACTIONS(1107),
    [anon_sym_GT_AMP] = ACTIONS(1107),
    [anon_sym_LT_LT] = ACTIONS(1111),
    [anon_sym_LT_LT_DASH] = ACTIONS(1107),
    [anon_sym_LT_LT_LT] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1111),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1111),
    [sym_word] = ACTIONS(1111),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1111),
  },
  [1153] = {
    [aux_sym_concatenation_repeat1] = STATE(663),
    [sym__simple_heredoc_body] = ACTIONS(1085),
    [sym__heredoc_body_beginning] = ACTIONS(1085),
    [sym_file_descriptor] = ACTIONS(1085),
    [sym__concat] = ACTIONS(671),
    [sym_variable_name] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1087),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym__special_characters] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_DOLLAR] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1085),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [anon_sym_LT_LPAREN] = ACTIONS(1085),
    [anon_sym_GT_LPAREN] = ACTIONS(1085),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1087),
    [sym_word] = ACTIONS(1087),
    [anon_sym_LF] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1087),
  },
  [1154] = {
    [aux_sym_concatenation_repeat1] = STATE(1154),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(2681),
    [sym_variable_name] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1728),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [1155] = {
    [aux_sym_concatenation_repeat1] = STATE(1155),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(2746),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1728),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [1156] = {
    [sym__simple_heredoc_body] = ACTIONS(3592),
    [sym__heredoc_body_beginning] = ACTIONS(3592),
    [sym_file_descriptor] = ACTIONS(3592),
    [ts_builtin_sym_end] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(3594),
    [anon_sym_esac] = ACTIONS(3592),
    [anon_sym_PIPE] = ACTIONS(3594),
    [anon_sym_RPAREN] = ACTIONS(3592),
    [anon_sym_SEMI_SEMI] = ACTIONS(3592),
    [anon_sym_PIPE_AMP] = ACTIONS(3592),
    [anon_sym_AMP_AMP] = ACTIONS(3592),
    [anon_sym_PIPE_PIPE] = ACTIONS(3592),
    [anon_sym_LT] = ACTIONS(3594),
    [anon_sym_GT] = ACTIONS(3594),
    [anon_sym_GT_GT] = ACTIONS(3592),
    [anon_sym_AMP_GT] = ACTIONS(3594),
    [anon_sym_AMP_GT_GT] = ACTIONS(3592),
    [anon_sym_LT_AMP] = ACTIONS(3592),
    [anon_sym_GT_AMP] = ACTIONS(3592),
    [anon_sym_LT_LT] = ACTIONS(3594),
    [anon_sym_LT_LT_DASH] = ACTIONS(3592),
    [anon_sym_LT_LT_LT] = ACTIONS(3592),
    [anon_sym_BQUOTE] = ACTIONS(3592),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3592),
    [anon_sym_AMP] = ACTIONS(3594),
  },
  [1157] = {
    [sym__terminated_statement] = STATE(1157),
    [sym_redirected_statement] = STATE(524),
    [sym_for_statement] = STATE(524),
    [sym_c_style_for_statement] = STATE(524),
    [sym_while_statement] = STATE(524),
    [sym_if_statement] = STATE(524),
    [sym_case_statement] = STATE(524),
    [sym_function_definition] = STATE(524),
    [sym_compound_statement] = STATE(524),
    [sym_subshell] = STATE(524),
    [sym_pipeline] = STATE(524),
    [sym_list] = STATE(524),
    [sym_negated_command] = STATE(524),
    [sym_test_command] = STATE(524),
    [sym_declaration_command] = STATE(524),
    [sym_unset_command] = STATE(524),
    [sym_command] = STATE(524),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(525),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(1157),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(973),
    [sym_variable_name] = ACTIONS(976),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(982),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_done] = ACTIONS(3596),
    [anon_sym_if] = ACTIONS(988),
    [anon_sym_case] = ACTIONS(991),
    [anon_sym_function] = ACTIONS(994),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(1000),
    [anon_sym_BANG] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1006),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1009),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_typeset] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_readonly] = ACTIONS(1012),
    [anon_sym_local] = ACTIONS(1012),
    [anon_sym_unset] = ACTIONS(1015),
    [anon_sym_unsetenv] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1018),
    [anon_sym_GT] = ACTIONS(1018),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1018),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [sym__special_characters] = ACTIONS(1024),
    [anon_sym_DQUOTE] = ACTIONS(1027),
    [anon_sym_DOLLAR] = ACTIONS(1030),
    [sym_raw_string] = ACTIONS(1033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1039),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LPAREN] = ACTIONS(1045),
    [anon_sym_GT_LPAREN] = ACTIONS(1045),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1048),
  },
  [1158] = {
    [aux_sym_concatenation_repeat1] = STATE(1160),
    [sym__simple_heredoc_body] = ACTIONS(1067),
    [sym__heredoc_body_beginning] = ACTIONS(1067),
    [sym_file_descriptor] = ACTIONS(1067),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(1069),
    [anon_sym_SEMI_SEMI] = ACTIONS(1067),
    [anon_sym_PIPE_AMP] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1069),
    [anon_sym_GT_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT] = ACTIONS(1069),
    [anon_sym_AMP_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_AMP] = ACTIONS(1067),
    [anon_sym_GT_AMP] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1069),
    [anon_sym_LT_LT_DASH] = ACTIONS(1067),
    [anon_sym_LT_LT_LT] = ACTIONS(1067),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1069),
  },
  [1159] = {
    [aux_sym_concatenation_repeat1] = STATE(1160),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
  },
  [1160] = {
    [aux_sym_concatenation_repeat1] = STATE(1591),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [1161] = {
    [anon_sym_then] = ACTIONS(3598),
    [sym_comment] = ACTIONS(57),
  },
  [1162] = {
    [sym__terminated_statement] = STATE(1593),
    [sym_redirected_statement] = STATE(524),
    [sym_for_statement] = STATE(524),
    [sym_c_style_for_statement] = STATE(524),
    [sym_while_statement] = STATE(524),
    [sym_if_statement] = STATE(524),
    [sym_case_statement] = STATE(524),
    [sym_function_definition] = STATE(524),
    [sym_compound_statement] = STATE(524),
    [sym_subshell] = STATE(524),
    [sym_pipeline] = STATE(524),
    [sym_list] = STATE(524),
    [sym_negated_command] = STATE(524),
    [sym_test_command] = STATE(524),
    [sym_declaration_command] = STATE(524),
    [sym_unset_command] = STATE(524),
    [sym_command] = STATE(524),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(525),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(1593),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(3600),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [1163] = {
    [sym__simple_heredoc_body] = ACTIONS(3602),
    [sym__heredoc_body_beginning] = ACTIONS(3602),
    [sym_file_descriptor] = ACTIONS(3602),
    [ts_builtin_sym_end] = ACTIONS(3602),
    [anon_sym_SEMI] = ACTIONS(3604),
    [anon_sym_esac] = ACTIONS(3602),
    [anon_sym_PIPE] = ACTIONS(3604),
    [anon_sym_RPAREN] = ACTIONS(3602),
    [anon_sym_SEMI_SEMI] = ACTIONS(3602),
    [anon_sym_PIPE_AMP] = ACTIONS(3602),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3604),
    [anon_sym_GT] = ACTIONS(3604),
    [anon_sym_GT_GT] = ACTIONS(3602),
    [anon_sym_AMP_GT] = ACTIONS(3604),
    [anon_sym_AMP_GT_GT] = ACTIONS(3602),
    [anon_sym_LT_AMP] = ACTIONS(3602),
    [anon_sym_GT_AMP] = ACTIONS(3602),
    [anon_sym_LT_LT] = ACTIONS(3604),
    [anon_sym_LT_LT_DASH] = ACTIONS(3602),
    [anon_sym_LT_LT_LT] = ACTIONS(3602),
    [anon_sym_BQUOTE] = ACTIONS(3602),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
  },
  [1164] = {
    [anon_sym_fi] = ACTIONS(3606),
    [sym_comment] = ACTIONS(57),
  },
  [1165] = {
    [sym__terminated_statement] = STATE(1165),
    [sym_redirected_statement] = STATE(524),
    [sym_for_statement] = STATE(524),
    [sym_c_style_for_statement] = STATE(524),
    [sym_while_statement] = STATE(524),
    [sym_if_statement] = STATE(524),
    [sym_case_statement] = STATE(524),
    [sym_function_definition] = STATE(524),
    [sym_compound_statement] = STATE(524),
    [sym_subshell] = STATE(524),
    [sym_pipeline] = STATE(524),
    [sym_list] = STATE(524),
    [sym_negated_command] = STATE(524),
    [sym_test_command] = STATE(524),
    [sym_declaration_command] = STATE(524),
    [sym_unset_command] = STATE(524),
    [sym_command] = STATE(524),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(525),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(1165),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(973),
    [sym_variable_name] = ACTIONS(976),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(982),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(988),
    [anon_sym_fi] = ACTIONS(3596),
    [anon_sym_elif] = ACTIONS(3596),
    [anon_sym_else] = ACTIONS(3596),
    [anon_sym_case] = ACTIONS(991),
    [anon_sym_function] = ACTIONS(994),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(1000),
    [anon_sym_BANG] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1006),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1009),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_typeset] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_readonly] = ACTIONS(1012),
    [anon_sym_local] = ACTIONS(1012),
    [anon_sym_unset] = ACTIONS(1015),
    [anon_sym_unsetenv] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1018),
    [anon_sym_GT] = ACTIONS(1018),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1018),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [sym__special_characters] = ACTIONS(1024),
    [anon_sym_DQUOTE] = ACTIONS(1027),
    [anon_sym_DOLLAR] = ACTIONS(1030),
    [sym_raw_string] = ACTIONS(1033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1039),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LPAREN] = ACTIONS(1045),
    [anon_sym_GT_LPAREN] = ACTIONS(1045),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1048),
  },
  [1166] = {
    [sym_elif_clause] = STATE(1167),
    [sym_else_clause] = STATE(1595),
    [aux_sym_if_statement_repeat1] = STATE(1167),
    [anon_sym_fi] = ACTIONS(3606),
    [anon_sym_elif] = ACTIONS(2456),
    [anon_sym_else] = ACTIONS(2458),
    [sym_comment] = ACTIONS(57),
  },
  [1167] = {
    [sym_elif_clause] = STATE(1167),
    [aux_sym_if_statement_repeat1] = STATE(1167),
    [anon_sym_fi] = ACTIONS(3608),
    [anon_sym_elif] = ACTIONS(3610),
    [anon_sym_else] = ACTIONS(3608),
    [sym_comment] = ACTIONS(57),
  },
  [1168] = {
    [sym__simple_heredoc_body] = ACTIONS(3613),
    [sym__heredoc_body_beginning] = ACTIONS(3613),
    [sym_file_descriptor] = ACTIONS(3613),
    [ts_builtin_sym_end] = ACTIONS(3613),
    [anon_sym_SEMI] = ACTIONS(3615),
    [anon_sym_esac] = ACTIONS(3613),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_RPAREN] = ACTIONS(3613),
    [anon_sym_SEMI_SEMI] = ACTIONS(3613),
    [anon_sym_PIPE_AMP] = ACTIONS(3613),
    [anon_sym_AMP_AMP] = ACTIONS(3613),
    [anon_sym_PIPE_PIPE] = ACTIONS(3613),
    [anon_sym_LT] = ACTIONS(3615),
    [anon_sym_GT] = ACTIONS(3615),
    [anon_sym_GT_GT] = ACTIONS(3613),
    [anon_sym_AMP_GT] = ACTIONS(3615),
    [anon_sym_AMP_GT_GT] = ACTIONS(3613),
    [anon_sym_LT_AMP] = ACTIONS(3613),
    [anon_sym_GT_AMP] = ACTIONS(3613),
    [anon_sym_LT_LT] = ACTIONS(3615),
    [anon_sym_LT_LT_DASH] = ACTIONS(3613),
    [anon_sym_LT_LT_LT] = ACTIONS(3613),
    [anon_sym_BQUOTE] = ACTIONS(3613),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3613),
    [anon_sym_AMP] = ACTIONS(3615),
  },
  [1169] = {
    [aux_sym_case_item_repeat1] = STATE(1598),
    [aux_sym_concatenation_repeat1] = STATE(1599),
    [sym__concat] = ACTIONS(1191),
    [anon_sym_PIPE] = ACTIONS(3617),
    [anon_sym_RPAREN] = ACTIONS(3619),
    [sym_comment] = ACTIONS(57),
  },
  [1170] = {
    [aux_sym_case_item_repeat1] = STATE(1601),
    [aux_sym_concatenation_repeat1] = STATE(1599),
    [sym__concat] = ACTIONS(1191),
    [anon_sym_PIPE] = ACTIONS(3617),
    [anon_sym_RPAREN] = ACTIONS(3621),
    [sym_comment] = ACTIONS(57),
  },
  [1171] = {
    [anon_sym_esac] = ACTIONS(3623),
    [sym_comment] = ACTIONS(57),
  },
  [1172] = {
    [aux_sym_case_item_repeat1] = STATE(1601),
    [anon_sym_PIPE] = ACTIONS(3617),
    [anon_sym_RPAREN] = ACTIONS(3621),
    [sym_comment] = ACTIONS(57),
  },
  [1173] = {
    [sym_case_item] = STATE(1604),
    [sym_last_case_item] = STATE(1603),
    [sym_concatenation] = STATE(1172),
    [sym_string] = STATE(1170),
    [sym_simple_expansion] = STATE(1170),
    [sym_string_expansion] = STATE(1170),
    [sym_expansion] = STATE(1170),
    [sym_command_substitution] = STATE(1170),
    [sym_process_substitution] = STATE(1170),
    [aux_sym_case_statement_repeat1] = STATE(1604),
    [sym__special_characters] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(421),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(425),
    [anon_sym_GT_LPAREN] = ACTIONS(425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
  },
  [1174] = {
    [sym_case_item] = STATE(1605),
    [sym_last_case_item] = STATE(1603),
    [sym_concatenation] = STATE(1172),
    [sym_string] = STATE(1170),
    [sym_simple_expansion] = STATE(1170),
    [sym_string_expansion] = STATE(1170),
    [sym_expansion] = STATE(1170),
    [sym_command_substitution] = STATE(1170),
    [sym_process_substitution] = STATE(1170),
    [aux_sym_case_statement_repeat1] = STATE(1605),
    [anon_sym_esac] = ACTIONS(3625),
    [sym__special_characters] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(421),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(425),
    [anon_sym_GT_LPAREN] = ACTIONS(425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2466),
  },
  [1175] = {
    [sym__concat] = ACTIONS(2930),
    [anon_sym_in] = ACTIONS(2930),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym_SEMI_SEMI] = ACTIONS(2930),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2930),
  },
  [1176] = {
    [sym__simple_heredoc_body] = ACTIONS(3627),
    [sym__heredoc_body_beginning] = ACTIONS(3627),
    [sym_file_descriptor] = ACTIONS(3627),
    [ts_builtin_sym_end] = ACTIONS(3627),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym_esac] = ACTIONS(3627),
    [anon_sym_PIPE] = ACTIONS(3629),
    [anon_sym_RPAREN] = ACTIONS(3627),
    [anon_sym_SEMI_SEMI] = ACTIONS(3627),
    [anon_sym_PIPE_AMP] = ACTIONS(3627),
    [anon_sym_AMP_AMP] = ACTIONS(3627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3627),
    [anon_sym_LT] = ACTIONS(3629),
    [anon_sym_GT] = ACTIONS(3629),
    [anon_sym_GT_GT] = ACTIONS(3627),
    [anon_sym_AMP_GT] = ACTIONS(3629),
    [anon_sym_AMP_GT_GT] = ACTIONS(3627),
    [anon_sym_LT_AMP] = ACTIONS(3627),
    [anon_sym_GT_AMP] = ACTIONS(3627),
    [anon_sym_LT_LT] = ACTIONS(3629),
    [anon_sym_LT_LT_DASH] = ACTIONS(3627),
    [anon_sym_LT_LT_LT] = ACTIONS(3627),
    [anon_sym_BQUOTE] = ACTIONS(3627),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3629),
  },
  [1177] = {
    [anon_sym_esac] = ACTIONS(3631),
    [sym_comment] = ACTIONS(57),
  },
  [1178] = {
    [sym_case_item] = STATE(1604),
    [sym_last_case_item] = STATE(1607),
    [sym_concatenation] = STATE(1172),
    [sym_string] = STATE(1170),
    [sym_simple_expansion] = STATE(1170),
    [sym_string_expansion] = STATE(1170),
    [sym_expansion] = STATE(1170),
    [sym_command_substitution] = STATE(1170),
    [sym_process_substitution] = STATE(1170),
    [aux_sym_case_statement_repeat1] = STATE(1604),
    [sym__special_characters] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(421),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(425),
    [anon_sym_GT_LPAREN] = ACTIONS(425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
  },
  [1179] = {
    [sym_case_item] = STATE(1608),
    [sym_last_case_item] = STATE(1607),
    [sym_concatenation] = STATE(1172),
    [sym_string] = STATE(1170),
    [sym_simple_expansion] = STATE(1170),
    [sym_string_expansion] = STATE(1170),
    [sym_expansion] = STATE(1170),
    [sym_command_substitution] = STATE(1170),
    [sym_process_substitution] = STATE(1170),
    [aux_sym_case_statement_repeat1] = STATE(1608),
    [anon_sym_esac] = ACTIONS(3633),
    [sym__special_characters] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(421),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(425),
    [anon_sym_GT_LPAREN] = ACTIONS(425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2466),
  },
  [1180] = {
    [sym__concat] = ACTIONS(2944),
    [anon_sym_in] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym_SEMI_SEMI] = ACTIONS(2944),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2944),
  },
  [1181] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(3635),
    [sym_comment] = ACTIONS(57),
  },
  [1182] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(3637),
    [sym_comment] = ACTIONS(57),
  },
  [1183] = {
    [anon_sym_RBRACE] = ACTIONS(3637),
    [sym_comment] = ACTIONS(57),
  },
  [1184] = {
    [sym_concatenation] = STATE(1613),
    [sym_string] = STATE(1612),
    [sym_simple_expansion] = STATE(1612),
    [sym_string_expansion] = STATE(1612),
    [sym_expansion] = STATE(1612),
    [sym_command_substitution] = STATE(1612),
    [sym_process_substitution] = STATE(1612),
    [anon_sym_RBRACE] = ACTIONS(3637),
    [sym__special_characters] = ACTIONS(3639),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(3641),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3641),
  },
  [1185] = {
    [sym__concat] = ACTIONS(2980),
    [anon_sym_in] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym_SEMI_SEMI] = ACTIONS(2980),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2980),
  },
  [1186] = {
    [sym_concatenation] = STATE(1616),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1616),
    [sym_regex] = ACTIONS(3643),
    [anon_sym_RBRACE] = ACTIONS(3645),
    [anon_sym_EQ] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3647),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3649),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3647),
    [anon_sym_COLON_QMARK] = ACTIONS(3647),
    [anon_sym_COLON_DASH] = ACTIONS(3647),
    [anon_sym_PERCENT] = ACTIONS(3647),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1187] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3645),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1188] = {
    [sym_concatenation] = STATE(1618),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1618),
    [sym_regex] = ACTIONS(3651),
    [anon_sym_RBRACE] = ACTIONS(3637),
    [anon_sym_EQ] = ACTIONS(3653),
    [anon_sym_DASH] = ACTIONS(3653),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3655),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3653),
    [anon_sym_COLON_QMARK] = ACTIONS(3653),
    [anon_sym_COLON_DASH] = ACTIONS(3653),
    [anon_sym_PERCENT] = ACTIONS(3653),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1189] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3637),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1190] = {
    [sym_concatenation] = STATE(1620),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1620),
    [anon_sym_RBRACE] = ACTIONS(3657),
    [anon_sym_EQ] = ACTIONS(3659),
    [anon_sym_DASH] = ACTIONS(3659),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3661),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3659),
    [anon_sym_COLON_QMARK] = ACTIONS(3659),
    [anon_sym_COLON_DASH] = ACTIONS(3659),
    [anon_sym_PERCENT] = ACTIONS(3659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1191] = {
    [sym__concat] = ACTIONS(3036),
    [anon_sym_in] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym_SEMI_SEMI] = ACTIONS(3036),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3036),
  },
  [1192] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3657),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1193] = {
    [sym_concatenation] = STATE(1618),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1618),
    [anon_sym_RBRACE] = ACTIONS(3637),
    [anon_sym_EQ] = ACTIONS(3653),
    [anon_sym_DASH] = ACTIONS(3653),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3655),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3653),
    [anon_sym_COLON_QMARK] = ACTIONS(3653),
    [anon_sym_COLON_DASH] = ACTIONS(3653),
    [anon_sym_PERCENT] = ACTIONS(3653),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1194] = {
    [sym__concat] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_SEMI_SEMI] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3091),
  },
  [1195] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1196] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1197] = {
    [anon_sym_SEMI] = ACTIONS(3665),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_SEMI_SEMI] = ACTIONS(3667),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3667),
  },
  [1198] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(3663),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1199] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(3663),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1200] = {
    [anon_sym_SEMI] = ACTIONS(3669),
    [anon_sym_SEMI_SEMI] = ACTIONS(3671),
    [anon_sym_BQUOTE] = ACTIONS(3663),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3671),
  },
  [1201] = {
    [sym__concat] = ACTIONS(3121),
    [anon_sym_in] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3123),
    [anon_sym_SEMI_SEMI] = ACTIONS(3121),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3121),
  },
  [1202] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(3673),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1203] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3673),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1204] = {
    [anon_sym_SEMI] = ACTIONS(3675),
    [anon_sym_RPAREN] = ACTIONS(3673),
    [anon_sym_SEMI_SEMI] = ACTIONS(3677),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3677),
    [anon_sym_AMP] = ACTIONS(3677),
  },
  [1205] = {
    [sym__simple_heredoc_body] = ACTIONS(3679),
    [sym__heredoc_body_beginning] = ACTIONS(3679),
    [sym_file_descriptor] = ACTIONS(3679),
    [ts_builtin_sym_end] = ACTIONS(3679),
    [anon_sym_SEMI] = ACTIONS(3681),
    [anon_sym_esac] = ACTIONS(3679),
    [anon_sym_PIPE] = ACTIONS(3681),
    [anon_sym_RPAREN] = ACTIONS(3679),
    [anon_sym_SEMI_SEMI] = ACTIONS(3679),
    [anon_sym_PIPE_AMP] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_PIPE_PIPE] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(3681),
    [anon_sym_GT] = ACTIONS(3681),
    [anon_sym_GT_GT] = ACTIONS(3679),
    [anon_sym_AMP_GT] = ACTIONS(3681),
    [anon_sym_AMP_GT_GT] = ACTIONS(3679),
    [anon_sym_LT_AMP] = ACTIONS(3679),
    [anon_sym_GT_AMP] = ACTIONS(3679),
    [anon_sym_LT_LT] = ACTIONS(3681),
    [anon_sym_LT_LT_DASH] = ACTIONS(3679),
    [anon_sym_LT_LT_LT] = ACTIONS(3679),
    [anon_sym_BQUOTE] = ACTIONS(3679),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3681),
  },
  [1206] = {
    [aux_sym_concatenation_repeat1] = STATE(1626),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(1109),
    [sym_variable_name] = ACTIONS(779),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_RPAREN] = ACTIONS(779),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(781),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [1207] = {
    [aux_sym_concatenation_repeat1] = STATE(727),
    [sym__simple_heredoc_body] = ACTIONS(1107),
    [sym__heredoc_body_beginning] = ACTIONS(1107),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(671),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_SEMI] = ACTIONS(1111),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_RPAREN] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT] = ACTIONS(1111),
    [anon_sym_AMP_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_AMP] = ACTIONS(1107),
    [anon_sym_GT_AMP] = ACTIONS(1107),
    [anon_sym_LT_LT] = ACTIONS(1111),
    [anon_sym_LT_LT_DASH] = ACTIONS(1107),
    [anon_sym_LT_LT_LT] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1111),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1111),
    [sym_word] = ACTIONS(1111),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1111),
  },
  [1208] = {
    [aux_sym_concatenation_repeat1] = STATE(727),
    [sym__simple_heredoc_body] = ACTIONS(1085),
    [sym__heredoc_body_beginning] = ACTIONS(1085),
    [sym_file_descriptor] = ACTIONS(1085),
    [sym__concat] = ACTIONS(671),
    [sym_variable_name] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(1085),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1087),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym__special_characters] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_DOLLAR] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1085),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [anon_sym_LT_LPAREN] = ACTIONS(1085),
    [anon_sym_GT_LPAREN] = ACTIONS(1085),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1087),
    [sym_word] = ACTIONS(1087),
    [anon_sym_LF] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1087),
  },
  [1209] = {
    [aux_sym_concatenation_repeat1] = STATE(1209),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(2681),
    [sym_variable_name] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1728),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [1210] = {
    [aux_sym_concatenation_repeat1] = STATE(1210),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(2746),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1728),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [1211] = {
    [aux_sym_concatenation_repeat1] = STATE(1213),
    [sym__simple_heredoc_body] = ACTIONS(1067),
    [sym__heredoc_body_beginning] = ACTIONS(1067),
    [sym_file_descriptor] = ACTIONS(1067),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(1069),
    [anon_sym_RPAREN] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1067),
    [anon_sym_PIPE_AMP] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1069),
    [anon_sym_GT_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT] = ACTIONS(1069),
    [anon_sym_AMP_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_AMP] = ACTIONS(1067),
    [anon_sym_GT_AMP] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1069),
    [anon_sym_LT_LT_DASH] = ACTIONS(1067),
    [anon_sym_LT_LT_LT] = ACTIONS(1067),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1069),
  },
  [1212] = {
    [aux_sym_concatenation_repeat1] = STATE(1213),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
  },
  [1213] = {
    [aux_sym_concatenation_repeat1] = STATE(1627),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_RPAREN] = ACTIONS(779),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [1214] = {
    [sym__simple_heredoc_body] = ACTIONS(3683),
    [sym__heredoc_body_beginning] = ACTIONS(3683),
    [sym_file_descriptor] = ACTIONS(3683),
    [ts_builtin_sym_end] = ACTIONS(3683),
    [anon_sym_SEMI] = ACTIONS(3685),
    [anon_sym_esac] = ACTIONS(3683),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_RPAREN] = ACTIONS(3683),
    [anon_sym_SEMI_SEMI] = ACTIONS(3683),
    [anon_sym_PIPE_AMP] = ACTIONS(3683),
    [anon_sym_AMP_AMP] = ACTIONS(3683),
    [anon_sym_PIPE_PIPE] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3685),
    [anon_sym_GT] = ACTIONS(3685),
    [anon_sym_GT_GT] = ACTIONS(3683),
    [anon_sym_AMP_GT] = ACTIONS(3685),
    [anon_sym_AMP_GT_GT] = ACTIONS(3683),
    [anon_sym_LT_AMP] = ACTIONS(3683),
    [anon_sym_GT_AMP] = ACTIONS(3683),
    [anon_sym_LT_LT] = ACTIONS(3685),
    [anon_sym_LT_LT_DASH] = ACTIONS(3683),
    [anon_sym_LT_LT_LT] = ACTIONS(3683),
    [anon_sym_BQUOTE] = ACTIONS(3683),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
  },
  [1215] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(3687),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1216] = {
    [sym_file_descriptor] = ACTIONS(2076),
    [sym_variable_name] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_GT] = ACTIONS(2078),
    [anon_sym_GT_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT_GT] = ACTIONS(2076),
    [anon_sym_LT_AMP] = ACTIONS(2076),
    [anon_sym_GT_AMP] = ACTIONS(2076),
    [sym__special_characters] = ACTIONS(2076),
    [anon_sym_DQUOTE] = ACTIONS(2076),
    [anon_sym_DOLLAR] = ACTIONS(2078),
    [sym_raw_string] = ACTIONS(2076),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2076),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2076),
    [anon_sym_BQUOTE] = ACTIONS(2076),
    [anon_sym_LT_LPAREN] = ACTIONS(2076),
    [anon_sym_GT_LPAREN] = ACTIONS(2076),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2076),
  },
  [1217] = {
    [sym_concatenation] = STATE(1007),
    [sym_string] = STATE(537),
    [sym_simple_expansion] = STATE(537),
    [sym_string_expansion] = STATE(537),
    [sym_expansion] = STATE(537),
    [sym_command_substitution] = STATE(537),
    [sym_process_substitution] = STATE(537),
    [aux_sym_for_statement_repeat1] = STATE(1007),
    [anon_sym_RPAREN] = ACTIONS(3689),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1095),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
  },
  [1218] = {
    [sym__concat] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_RBRACK] = ACTIONS(2930),
    [anon_sym_EQ_TILDE] = ACTIONS(2930),
    [anon_sym_EQ_EQ] = ACTIONS(2930),
    [anon_sym_EQ] = ACTIONS(2932),
    [anon_sym_PLUS_EQ] = ACTIONS(2930),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2932),
    [anon_sym_BANG_EQ] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2932),
    [anon_sym_DASH_EQ] = ACTIONS(2930),
    [anon_sym_LT_EQ] = ACTIONS(2930),
    [anon_sym_GT_EQ] = ACTIONS(2930),
    [anon_sym_PLUS_PLUS] = ACTIONS(2930),
    [anon_sym_DASH_DASH] = ACTIONS(2930),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2930),
  },
  [1219] = {
    [sym__concat] = ACTIONS(2944),
    [anon_sym_AMP_AMP] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2944),
    [anon_sym_RBRACK] = ACTIONS(2944),
    [anon_sym_EQ_TILDE] = ACTIONS(2944),
    [anon_sym_EQ_EQ] = ACTIONS(2944),
    [anon_sym_EQ] = ACTIONS(2946),
    [anon_sym_PLUS_EQ] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2944),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_DASH_EQ] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2944),
    [anon_sym_GT_EQ] = ACTIONS(2944),
    [anon_sym_PLUS_PLUS] = ACTIONS(2944),
    [anon_sym_DASH_DASH] = ACTIONS(2944),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2944),
  },
  [1220] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(3691),
    [sym_comment] = ACTIONS(57),
  },
  [1221] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(3693),
    [sym_comment] = ACTIONS(57),
  },
  [1222] = {
    [anon_sym_RBRACE] = ACTIONS(3693),
    [sym_comment] = ACTIONS(57),
  },
  [1223] = {
    [sym_concatenation] = STATE(1634),
    [sym_string] = STATE(1633),
    [sym_simple_expansion] = STATE(1633),
    [sym_string_expansion] = STATE(1633),
    [sym_expansion] = STATE(1633),
    [sym_command_substitution] = STATE(1633),
    [sym_process_substitution] = STATE(1633),
    [anon_sym_RBRACE] = ACTIONS(3693),
    [sym__special_characters] = ACTIONS(3695),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(3697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3697),
  },
  [1224] = {
    [sym__concat] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_PIPE_PIPE] = ACTIONS(2980),
    [anon_sym_RBRACK] = ACTIONS(2980),
    [anon_sym_EQ_TILDE] = ACTIONS(2980),
    [anon_sym_EQ_EQ] = ACTIONS(2980),
    [anon_sym_EQ] = ACTIONS(2982),
    [anon_sym_PLUS_EQ] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2982),
    [anon_sym_BANG_EQ] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2982),
    [anon_sym_DASH] = ACTIONS(2982),
    [anon_sym_DASH_EQ] = ACTIONS(2980),
    [anon_sym_LT_EQ] = ACTIONS(2980),
    [anon_sym_GT_EQ] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2980),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2980),
  },
  [1225] = {
    [sym_concatenation] = STATE(1637),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1637),
    [sym_regex] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(3701),
    [anon_sym_EQ] = ACTIONS(3703),
    [anon_sym_DASH] = ACTIONS(3703),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3705),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3703),
    [anon_sym_COLON_QMARK] = ACTIONS(3703),
    [anon_sym_COLON_DASH] = ACTIONS(3703),
    [anon_sym_PERCENT] = ACTIONS(3703),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1226] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3701),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1227] = {
    [sym_concatenation] = STATE(1639),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1639),
    [sym_regex] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3709),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_COLON_QMARK] = ACTIONS(3709),
    [anon_sym_COLON_DASH] = ACTIONS(3709),
    [anon_sym_PERCENT] = ACTIONS(3709),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1228] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1229] = {
    [sym_concatenation] = STATE(1641),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1641),
    [anon_sym_RBRACE] = ACTIONS(3713),
    [anon_sym_EQ] = ACTIONS(3715),
    [anon_sym_DASH] = ACTIONS(3715),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3717),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3715),
    [anon_sym_COLON_QMARK] = ACTIONS(3715),
    [anon_sym_COLON_DASH] = ACTIONS(3715),
    [anon_sym_PERCENT] = ACTIONS(3715),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1230] = {
    [sym__concat] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_PIPE_PIPE] = ACTIONS(3036),
    [anon_sym_RBRACK] = ACTIONS(3036),
    [anon_sym_EQ_TILDE] = ACTIONS(3036),
    [anon_sym_EQ_EQ] = ACTIONS(3036),
    [anon_sym_EQ] = ACTIONS(3038),
    [anon_sym_PLUS_EQ] = ACTIONS(3036),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_GT] = ACTIONS(3038),
    [anon_sym_BANG_EQ] = ACTIONS(3036),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_DASH_EQ] = ACTIONS(3036),
    [anon_sym_LT_EQ] = ACTIONS(3036),
    [anon_sym_GT_EQ] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3036),
  },
  [1231] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3713),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1232] = {
    [sym_concatenation] = STATE(1639),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1639),
    [anon_sym_RBRACE] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3709),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_COLON_QMARK] = ACTIONS(3709),
    [anon_sym_COLON_DASH] = ACTIONS(3709),
    [anon_sym_PERCENT] = ACTIONS(3709),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1233] = {
    [sym__concat] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_RBRACK] = ACTIONS(3091),
    [anon_sym_EQ_TILDE] = ACTIONS(3091),
    [anon_sym_EQ_EQ] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_PLUS_EQ] = ACTIONS(3091),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_GT] = ACTIONS(3093),
    [anon_sym_BANG_EQ] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3093),
    [anon_sym_DASH] = ACTIONS(3093),
    [anon_sym_DASH_EQ] = ACTIONS(3091),
    [anon_sym_LT_EQ] = ACTIONS(3091),
    [anon_sym_GT_EQ] = ACTIONS(3091),
    [anon_sym_PLUS_PLUS] = ACTIONS(3091),
    [anon_sym_DASH_DASH] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3091),
  },
  [1234] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1235] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1236] = {
    [anon_sym_SEMI] = ACTIONS(3721),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_SEMI_SEMI] = ACTIONS(3723),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3723),
    [anon_sym_AMP] = ACTIONS(3723),
  },
  [1237] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(3719),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1238] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(3719),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1239] = {
    [anon_sym_SEMI] = ACTIONS(3725),
    [anon_sym_SEMI_SEMI] = ACTIONS(3727),
    [anon_sym_BQUOTE] = ACTIONS(3719),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3727),
    [anon_sym_AMP] = ACTIONS(3727),
  },
  [1240] = {
    [sym__concat] = ACTIONS(3121),
    [anon_sym_AMP_AMP] = ACTIONS(3121),
    [anon_sym_PIPE_PIPE] = ACTIONS(3121),
    [anon_sym_RBRACK] = ACTIONS(3121),
    [anon_sym_EQ_TILDE] = ACTIONS(3121),
    [anon_sym_EQ_EQ] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(3123),
    [anon_sym_PLUS_EQ] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_GT] = ACTIONS(3123),
    [anon_sym_BANG_EQ] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_DASH_EQ] = ACTIONS(3121),
    [anon_sym_LT_EQ] = ACTIONS(3121),
    [anon_sym_GT_EQ] = ACTIONS(3121),
    [anon_sym_PLUS_PLUS] = ACTIONS(3121),
    [anon_sym_DASH_DASH] = ACTIONS(3121),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3121),
  },
  [1241] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(3729),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1242] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3729),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1243] = {
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_RPAREN] = ACTIONS(3729),
    [anon_sym_SEMI_SEMI] = ACTIONS(3733),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3733),
    [anon_sym_AMP] = ACTIONS(3733),
  },
  [1244] = {
    [sym__simple_heredoc_body] = ACTIONS(2076),
    [sym__heredoc_body_beginning] = ACTIONS(2076),
    [sym_file_descriptor] = ACTIONS(2076),
    [sym_variable_name] = ACTIONS(2076),
    [ts_builtin_sym_end] = ACTIONS(2076),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_RPAREN] = ACTIONS(2076),
    [anon_sym_SEMI_SEMI] = ACTIONS(2076),
    [anon_sym_PIPE_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2076),
    [anon_sym_PIPE_PIPE] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_GT] = ACTIONS(2078),
    [anon_sym_GT_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT_GT] = ACTIONS(2076),
    [anon_sym_LT_AMP] = ACTIONS(2076),
    [anon_sym_GT_AMP] = ACTIONS(2076),
    [anon_sym_LT_LT] = ACTIONS(2078),
    [anon_sym_LT_LT_DASH] = ACTIONS(2076),
    [anon_sym_LT_LT_LT] = ACTIONS(2076),
    [sym__special_characters] = ACTIONS(2076),
    [anon_sym_DQUOTE] = ACTIONS(2076),
    [anon_sym_DOLLAR] = ACTIONS(2078),
    [sym_raw_string] = ACTIONS(2076),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2076),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2076),
    [anon_sym_BQUOTE] = ACTIONS(2076),
    [anon_sym_LT_LPAREN] = ACTIONS(2076),
    [anon_sym_GT_LPAREN] = ACTIONS(2076),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2078),
    [sym_word] = ACTIONS(2078),
    [anon_sym_LF] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [1245] = {
    [sym_concatenation] = STATE(1007),
    [sym_string] = STATE(537),
    [sym_simple_expansion] = STATE(537),
    [sym_string_expansion] = STATE(537),
    [sym_expansion] = STATE(537),
    [sym_command_substitution] = STATE(537),
    [sym_process_substitution] = STATE(537),
    [aux_sym_for_statement_repeat1] = STATE(1007),
    [anon_sym_RPAREN] = ACTIONS(3735),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1095),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
  },
  [1246] = {
    [sym__simple_heredoc_body] = ACTIONS(2930),
    [sym__heredoc_body_beginning] = ACTIONS(2930),
    [sym_file_descriptor] = ACTIONS(2930),
    [sym__concat] = ACTIONS(2930),
    [sym_variable_name] = ACTIONS(2930),
    [ts_builtin_sym_end] = ACTIONS(2930),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym_PIPE] = ACTIONS(2932),
    [anon_sym_RPAREN] = ACTIONS(2930),
    [anon_sym_SEMI_SEMI] = ACTIONS(2930),
    [anon_sym_PIPE_AMP] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2932),
    [anon_sym_GT_GT] = ACTIONS(2930),
    [anon_sym_AMP_GT] = ACTIONS(2932),
    [anon_sym_AMP_GT_GT] = ACTIONS(2930),
    [anon_sym_LT_AMP] = ACTIONS(2930),
    [anon_sym_GT_AMP] = ACTIONS(2930),
    [anon_sym_LT_LT] = ACTIONS(2932),
    [anon_sym_LT_LT_DASH] = ACTIONS(2930),
    [anon_sym_LT_LT_LT] = ACTIONS(2930),
    [sym__special_characters] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_DOLLAR] = ACTIONS(2932),
    [sym_raw_string] = ACTIONS(2930),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2930),
    [anon_sym_BQUOTE] = ACTIONS(2930),
    [anon_sym_LT_LPAREN] = ACTIONS(2930),
    [anon_sym_GT_LPAREN] = ACTIONS(2930),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2932),
    [sym_word] = ACTIONS(2932),
    [anon_sym_LF] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2932),
  },
  [1247] = {
    [sym__simple_heredoc_body] = ACTIONS(2944),
    [sym__heredoc_body_beginning] = ACTIONS(2944),
    [sym_file_descriptor] = ACTIONS(2944),
    [sym__concat] = ACTIONS(2944),
    [sym_variable_name] = ACTIONS(2944),
    [ts_builtin_sym_end] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym_PIPE] = ACTIONS(2946),
    [anon_sym_RPAREN] = ACTIONS(2944),
    [anon_sym_SEMI_SEMI] = ACTIONS(2944),
    [anon_sym_PIPE_AMP] = ACTIONS(2944),
    [anon_sym_AMP_AMP] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2946),
    [anon_sym_GT_GT] = ACTIONS(2944),
    [anon_sym_AMP_GT] = ACTIONS(2946),
    [anon_sym_AMP_GT_GT] = ACTIONS(2944),
    [anon_sym_LT_AMP] = ACTIONS(2944),
    [anon_sym_GT_AMP] = ACTIONS(2944),
    [anon_sym_LT_LT] = ACTIONS(2946),
    [anon_sym_LT_LT_DASH] = ACTIONS(2944),
    [anon_sym_LT_LT_LT] = ACTIONS(2944),
    [sym__special_characters] = ACTIONS(2944),
    [anon_sym_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [sym_raw_string] = ACTIONS(2944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2944),
    [anon_sym_BQUOTE] = ACTIONS(2944),
    [anon_sym_LT_LPAREN] = ACTIONS(2944),
    [anon_sym_GT_LPAREN] = ACTIONS(2944),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2946),
    [sym_word] = ACTIONS(2946),
    [anon_sym_LF] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2946),
  },
  [1248] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(3737),
    [sym_comment] = ACTIONS(57),
  },
  [1249] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(3739),
    [sym_comment] = ACTIONS(57),
  },
  [1250] = {
    [anon_sym_RBRACE] = ACTIONS(3739),
    [sym_comment] = ACTIONS(57),
  },
  [1251] = {
    [sym_concatenation] = STATE(1652),
    [sym_string] = STATE(1651),
    [sym_simple_expansion] = STATE(1651),
    [sym_string_expansion] = STATE(1651),
    [sym_expansion] = STATE(1651),
    [sym_command_substitution] = STATE(1651),
    [sym_process_substitution] = STATE(1651),
    [anon_sym_RBRACE] = ACTIONS(3739),
    [sym__special_characters] = ACTIONS(3741),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(3743),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3743),
  },
  [1252] = {
    [sym__simple_heredoc_body] = ACTIONS(2980),
    [sym__heredoc_body_beginning] = ACTIONS(2980),
    [sym_file_descriptor] = ACTIONS(2980),
    [sym__concat] = ACTIONS(2980),
    [sym_variable_name] = ACTIONS(2980),
    [ts_builtin_sym_end] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym_PIPE] = ACTIONS(2982),
    [anon_sym_RPAREN] = ACTIONS(2980),
    [anon_sym_SEMI_SEMI] = ACTIONS(2980),
    [anon_sym_PIPE_AMP] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_PIPE_PIPE] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2982),
    [anon_sym_GT_GT] = ACTIONS(2980),
    [anon_sym_AMP_GT] = ACTIONS(2982),
    [anon_sym_AMP_GT_GT] = ACTIONS(2980),
    [anon_sym_LT_AMP] = ACTIONS(2980),
    [anon_sym_GT_AMP] = ACTIONS(2980),
    [anon_sym_LT_LT] = ACTIONS(2982),
    [anon_sym_LT_LT_DASH] = ACTIONS(2980),
    [anon_sym_LT_LT_LT] = ACTIONS(2980),
    [sym__special_characters] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2982),
    [sym_raw_string] = ACTIONS(2980),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2980),
    [anon_sym_BQUOTE] = ACTIONS(2980),
    [anon_sym_LT_LPAREN] = ACTIONS(2980),
    [anon_sym_GT_LPAREN] = ACTIONS(2980),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2982),
    [sym_word] = ACTIONS(2982),
    [anon_sym_LF] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2982),
  },
  [1253] = {
    [sym_concatenation] = STATE(1655),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1655),
    [sym_regex] = ACTIONS(3745),
    [anon_sym_RBRACE] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3749),
    [anon_sym_COLON_QMARK] = ACTIONS(3749),
    [anon_sym_COLON_DASH] = ACTIONS(3749),
    [anon_sym_PERCENT] = ACTIONS(3749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1254] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1255] = {
    [sym_concatenation] = STATE(1657),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1657),
    [sym_regex] = ACTIONS(3753),
    [anon_sym_RBRACE] = ACTIONS(3739),
    [anon_sym_EQ] = ACTIONS(3755),
    [anon_sym_DASH] = ACTIONS(3755),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3757),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3755),
    [anon_sym_COLON_QMARK] = ACTIONS(3755),
    [anon_sym_COLON_DASH] = ACTIONS(3755),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1256] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3739),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1257] = {
    [sym_concatenation] = STATE(1659),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1659),
    [anon_sym_RBRACE] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3761),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3763),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3761),
    [anon_sym_COLON_QMARK] = ACTIONS(3761),
    [anon_sym_COLON_DASH] = ACTIONS(3761),
    [anon_sym_PERCENT] = ACTIONS(3761),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1258] = {
    [sym__simple_heredoc_body] = ACTIONS(3036),
    [sym__heredoc_body_beginning] = ACTIONS(3036),
    [sym_file_descriptor] = ACTIONS(3036),
    [sym__concat] = ACTIONS(3036),
    [sym_variable_name] = ACTIONS(3036),
    [ts_builtin_sym_end] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym_PIPE] = ACTIONS(3038),
    [anon_sym_RPAREN] = ACTIONS(3036),
    [anon_sym_SEMI_SEMI] = ACTIONS(3036),
    [anon_sym_PIPE_AMP] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_PIPE_PIPE] = ACTIONS(3036),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_GT] = ACTIONS(3038),
    [anon_sym_GT_GT] = ACTIONS(3036),
    [anon_sym_AMP_GT] = ACTIONS(3038),
    [anon_sym_AMP_GT_GT] = ACTIONS(3036),
    [anon_sym_LT_AMP] = ACTIONS(3036),
    [anon_sym_GT_AMP] = ACTIONS(3036),
    [anon_sym_LT_LT] = ACTIONS(3038),
    [anon_sym_LT_LT_DASH] = ACTIONS(3036),
    [anon_sym_LT_LT_LT] = ACTIONS(3036),
    [sym__special_characters] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [anon_sym_DOLLAR] = ACTIONS(3038),
    [sym_raw_string] = ACTIONS(3036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3036),
    [anon_sym_BQUOTE] = ACTIONS(3036),
    [anon_sym_LT_LPAREN] = ACTIONS(3036),
    [anon_sym_GT_LPAREN] = ACTIONS(3036),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3038),
    [sym_word] = ACTIONS(3038),
    [anon_sym_LF] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3038),
  },
  [1259] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1260] = {
    [sym_concatenation] = STATE(1657),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1657),
    [anon_sym_RBRACE] = ACTIONS(3739),
    [anon_sym_EQ] = ACTIONS(3755),
    [anon_sym_DASH] = ACTIONS(3755),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3757),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3755),
    [anon_sym_COLON_QMARK] = ACTIONS(3755),
    [anon_sym_COLON_DASH] = ACTIONS(3755),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1261] = {
    [sym__simple_heredoc_body] = ACTIONS(3091),
    [sym__heredoc_body_beginning] = ACTIONS(3091),
    [sym_file_descriptor] = ACTIONS(3091),
    [sym__concat] = ACTIONS(3091),
    [sym_variable_name] = ACTIONS(3091),
    [ts_builtin_sym_end] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_PIPE] = ACTIONS(3093),
    [anon_sym_RPAREN] = ACTIONS(3091),
    [anon_sym_SEMI_SEMI] = ACTIONS(3091),
    [anon_sym_PIPE_AMP] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_GT] = ACTIONS(3093),
    [anon_sym_GT_GT] = ACTIONS(3091),
    [anon_sym_AMP_GT] = ACTIONS(3093),
    [anon_sym_AMP_GT_GT] = ACTIONS(3091),
    [anon_sym_LT_AMP] = ACTIONS(3091),
    [anon_sym_GT_AMP] = ACTIONS(3091),
    [anon_sym_LT_LT] = ACTIONS(3093),
    [anon_sym_LT_LT_DASH] = ACTIONS(3091),
    [anon_sym_LT_LT_LT] = ACTIONS(3091),
    [sym__special_characters] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_DOLLAR] = ACTIONS(3093),
    [sym_raw_string] = ACTIONS(3091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3091),
    [anon_sym_BQUOTE] = ACTIONS(3091),
    [anon_sym_LT_LPAREN] = ACTIONS(3091),
    [anon_sym_GT_LPAREN] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3093),
    [sym_word] = ACTIONS(3093),
    [anon_sym_LF] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3093),
  },
  [1262] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1263] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1264] = {
    [anon_sym_SEMI] = ACTIONS(3767),
    [anon_sym_RPAREN] = ACTIONS(3765),
    [anon_sym_SEMI_SEMI] = ACTIONS(3769),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
  },
  [1265] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(3765),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1266] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(3765),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1267] = {
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym_SEMI_SEMI] = ACTIONS(3773),
    [anon_sym_BQUOTE] = ACTIONS(3765),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3773),
    [anon_sym_AMP] = ACTIONS(3773),
  },
  [1268] = {
    [sym__simple_heredoc_body] = ACTIONS(3121),
    [sym__heredoc_body_beginning] = ACTIONS(3121),
    [sym_file_descriptor] = ACTIONS(3121),
    [sym__concat] = ACTIONS(3121),
    [sym_variable_name] = ACTIONS(3121),
    [ts_builtin_sym_end] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3123),
    [anon_sym_RPAREN] = ACTIONS(3121),
    [anon_sym_SEMI_SEMI] = ACTIONS(3121),
    [anon_sym_PIPE_AMP] = ACTIONS(3121),
    [anon_sym_AMP_AMP] = ACTIONS(3121),
    [anon_sym_PIPE_PIPE] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_GT] = ACTIONS(3123),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_AMP_GT] = ACTIONS(3123),
    [anon_sym_AMP_GT_GT] = ACTIONS(3121),
    [anon_sym_LT_AMP] = ACTIONS(3121),
    [anon_sym_GT_AMP] = ACTIONS(3121),
    [anon_sym_LT_LT] = ACTIONS(3123),
    [anon_sym_LT_LT_DASH] = ACTIONS(3121),
    [anon_sym_LT_LT_LT] = ACTIONS(3121),
    [sym__special_characters] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [sym_raw_string] = ACTIONS(3121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3121),
    [anon_sym_BQUOTE] = ACTIONS(3121),
    [anon_sym_LT_LPAREN] = ACTIONS(3121),
    [anon_sym_GT_LPAREN] = ACTIONS(3121),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3123),
    [sym_word] = ACTIONS(3123),
    [anon_sym_LF] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
  },
  [1269] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(3775),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1270] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3775),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1271] = {
    [anon_sym_SEMI] = ACTIONS(3777),
    [anon_sym_RPAREN] = ACTIONS(3775),
    [anon_sym_SEMI_SEMI] = ACTIONS(3779),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3779),
    [anon_sym_AMP] = ACTIONS(3779),
  },
  [1272] = {
    [sym__simple_heredoc_body] = ACTIONS(2930),
    [sym__heredoc_body_beginning] = ACTIONS(2930),
    [sym_file_descriptor] = ACTIONS(2930),
    [sym__concat] = ACTIONS(2930),
    [ts_builtin_sym_end] = ACTIONS(2930),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym_PIPE] = ACTIONS(2932),
    [anon_sym_RPAREN] = ACTIONS(2930),
    [anon_sym_SEMI_SEMI] = ACTIONS(2930),
    [anon_sym_PIPE_AMP] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2932),
    [anon_sym_GT_GT] = ACTIONS(2930),
    [anon_sym_AMP_GT] = ACTIONS(2932),
    [anon_sym_AMP_GT_GT] = ACTIONS(2930),
    [anon_sym_LT_AMP] = ACTIONS(2930),
    [anon_sym_GT_AMP] = ACTIONS(2930),
    [anon_sym_LT_LT] = ACTIONS(2932),
    [anon_sym_LT_LT_DASH] = ACTIONS(2930),
    [anon_sym_LT_LT_LT] = ACTIONS(2930),
    [sym__special_characters] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_DOLLAR] = ACTIONS(2932),
    [sym_raw_string] = ACTIONS(2930),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2930),
    [anon_sym_BQUOTE] = ACTIONS(2930),
    [anon_sym_LT_LPAREN] = ACTIONS(2930),
    [anon_sym_GT_LPAREN] = ACTIONS(2930),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2932),
    [sym_word] = ACTIONS(2932),
    [anon_sym_LF] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2932),
  },
  [1273] = {
    [sym__simple_heredoc_body] = ACTIONS(2944),
    [sym__heredoc_body_beginning] = ACTIONS(2944),
    [sym_file_descriptor] = ACTIONS(2944),
    [sym__concat] = ACTIONS(2944),
    [ts_builtin_sym_end] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym_PIPE] = ACTIONS(2946),
    [anon_sym_RPAREN] = ACTIONS(2944),
    [anon_sym_SEMI_SEMI] = ACTIONS(2944),
    [anon_sym_PIPE_AMP] = ACTIONS(2944),
    [anon_sym_AMP_AMP] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2946),
    [anon_sym_GT_GT] = ACTIONS(2944),
    [anon_sym_AMP_GT] = ACTIONS(2946),
    [anon_sym_AMP_GT_GT] = ACTIONS(2944),
    [anon_sym_LT_AMP] = ACTIONS(2944),
    [anon_sym_GT_AMP] = ACTIONS(2944),
    [anon_sym_LT_LT] = ACTIONS(2946),
    [anon_sym_LT_LT_DASH] = ACTIONS(2944),
    [anon_sym_LT_LT_LT] = ACTIONS(2944),
    [sym__special_characters] = ACTIONS(2944),
    [anon_sym_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [sym_raw_string] = ACTIONS(2944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2944),
    [anon_sym_BQUOTE] = ACTIONS(2944),
    [anon_sym_LT_LPAREN] = ACTIONS(2944),
    [anon_sym_GT_LPAREN] = ACTIONS(2944),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2946),
    [sym_word] = ACTIONS(2946),
    [anon_sym_LF] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2946),
  },
  [1274] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [sym_comment] = ACTIONS(57),
  },
  [1275] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(3783),
    [sym_comment] = ACTIONS(57),
  },
  [1276] = {
    [anon_sym_RBRACE] = ACTIONS(3783),
    [sym_comment] = ACTIONS(57),
  },
  [1277] = {
    [sym_concatenation] = STATE(1669),
    [sym_string] = STATE(1668),
    [sym_simple_expansion] = STATE(1668),
    [sym_string_expansion] = STATE(1668),
    [sym_expansion] = STATE(1668),
    [sym_command_substitution] = STATE(1668),
    [sym_process_substitution] = STATE(1668),
    [anon_sym_RBRACE] = ACTIONS(3783),
    [sym__special_characters] = ACTIONS(3785),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(3787),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3787),
  },
  [1278] = {
    [sym__simple_heredoc_body] = ACTIONS(2980),
    [sym__heredoc_body_beginning] = ACTIONS(2980),
    [sym_file_descriptor] = ACTIONS(2980),
    [sym__concat] = ACTIONS(2980),
    [ts_builtin_sym_end] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym_PIPE] = ACTIONS(2982),
    [anon_sym_RPAREN] = ACTIONS(2980),
    [anon_sym_SEMI_SEMI] = ACTIONS(2980),
    [anon_sym_PIPE_AMP] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_PIPE_PIPE] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2982),
    [anon_sym_GT_GT] = ACTIONS(2980),
    [anon_sym_AMP_GT] = ACTIONS(2982),
    [anon_sym_AMP_GT_GT] = ACTIONS(2980),
    [anon_sym_LT_AMP] = ACTIONS(2980),
    [anon_sym_GT_AMP] = ACTIONS(2980),
    [anon_sym_LT_LT] = ACTIONS(2982),
    [anon_sym_LT_LT_DASH] = ACTIONS(2980),
    [anon_sym_LT_LT_LT] = ACTIONS(2980),
    [sym__special_characters] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2982),
    [sym_raw_string] = ACTIONS(2980),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2980),
    [anon_sym_BQUOTE] = ACTIONS(2980),
    [anon_sym_LT_LPAREN] = ACTIONS(2980),
    [anon_sym_GT_LPAREN] = ACTIONS(2980),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2982),
    [sym_word] = ACTIONS(2982),
    [anon_sym_LF] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2982),
  },
  [1279] = {
    [sym_concatenation] = STATE(1672),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1672),
    [sym_regex] = ACTIONS(3789),
    [anon_sym_RBRACE] = ACTIONS(3791),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_DASH] = ACTIONS(3793),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3795),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3793),
    [anon_sym_COLON_QMARK] = ACTIONS(3793),
    [anon_sym_COLON_DASH] = ACTIONS(3793),
    [anon_sym_PERCENT] = ACTIONS(3793),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1280] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3791),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1281] = {
    [sym_concatenation] = STATE(1674),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1674),
    [sym_regex] = ACTIONS(3797),
    [anon_sym_RBRACE] = ACTIONS(3783),
    [anon_sym_EQ] = ACTIONS(3799),
    [anon_sym_DASH] = ACTIONS(3799),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3801),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3799),
    [anon_sym_COLON_QMARK] = ACTIONS(3799),
    [anon_sym_COLON_DASH] = ACTIONS(3799),
    [anon_sym_PERCENT] = ACTIONS(3799),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1282] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3783),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1283] = {
    [sym_concatenation] = STATE(1676),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1676),
    [anon_sym_RBRACE] = ACTIONS(3803),
    [anon_sym_EQ] = ACTIONS(3805),
    [anon_sym_DASH] = ACTIONS(3805),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3805),
    [anon_sym_COLON_QMARK] = ACTIONS(3805),
    [anon_sym_COLON_DASH] = ACTIONS(3805),
    [anon_sym_PERCENT] = ACTIONS(3805),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1284] = {
    [sym__simple_heredoc_body] = ACTIONS(3036),
    [sym__heredoc_body_beginning] = ACTIONS(3036),
    [sym_file_descriptor] = ACTIONS(3036),
    [sym__concat] = ACTIONS(3036),
    [ts_builtin_sym_end] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym_PIPE] = ACTIONS(3038),
    [anon_sym_RPAREN] = ACTIONS(3036),
    [anon_sym_SEMI_SEMI] = ACTIONS(3036),
    [anon_sym_PIPE_AMP] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_PIPE_PIPE] = ACTIONS(3036),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_GT] = ACTIONS(3038),
    [anon_sym_GT_GT] = ACTIONS(3036),
    [anon_sym_AMP_GT] = ACTIONS(3038),
    [anon_sym_AMP_GT_GT] = ACTIONS(3036),
    [anon_sym_LT_AMP] = ACTIONS(3036),
    [anon_sym_GT_AMP] = ACTIONS(3036),
    [anon_sym_LT_LT] = ACTIONS(3038),
    [anon_sym_LT_LT_DASH] = ACTIONS(3036),
    [anon_sym_LT_LT_LT] = ACTIONS(3036),
    [sym__special_characters] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [anon_sym_DOLLAR] = ACTIONS(3038),
    [sym_raw_string] = ACTIONS(3036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3036),
    [anon_sym_BQUOTE] = ACTIONS(3036),
    [anon_sym_LT_LPAREN] = ACTIONS(3036),
    [anon_sym_GT_LPAREN] = ACTIONS(3036),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3038),
    [sym_word] = ACTIONS(3038),
    [anon_sym_LF] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3038),
  },
  [1285] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3803),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1286] = {
    [sym_concatenation] = STATE(1674),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1674),
    [anon_sym_RBRACE] = ACTIONS(3783),
    [anon_sym_EQ] = ACTIONS(3799),
    [anon_sym_DASH] = ACTIONS(3799),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3801),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3799),
    [anon_sym_COLON_QMARK] = ACTIONS(3799),
    [anon_sym_COLON_DASH] = ACTIONS(3799),
    [anon_sym_PERCENT] = ACTIONS(3799),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1287] = {
    [sym__simple_heredoc_body] = ACTIONS(3091),
    [sym__heredoc_body_beginning] = ACTIONS(3091),
    [sym_file_descriptor] = ACTIONS(3091),
    [sym__concat] = ACTIONS(3091),
    [ts_builtin_sym_end] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_PIPE] = ACTIONS(3093),
    [anon_sym_RPAREN] = ACTIONS(3091),
    [anon_sym_SEMI_SEMI] = ACTIONS(3091),
    [anon_sym_PIPE_AMP] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_GT] = ACTIONS(3093),
    [anon_sym_GT_GT] = ACTIONS(3091),
    [anon_sym_AMP_GT] = ACTIONS(3093),
    [anon_sym_AMP_GT_GT] = ACTIONS(3091),
    [anon_sym_LT_AMP] = ACTIONS(3091),
    [anon_sym_GT_AMP] = ACTIONS(3091),
    [anon_sym_LT_LT] = ACTIONS(3093),
    [anon_sym_LT_LT_DASH] = ACTIONS(3091),
    [anon_sym_LT_LT_LT] = ACTIONS(3091),
    [sym__special_characters] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_DOLLAR] = ACTIONS(3093),
    [sym_raw_string] = ACTIONS(3091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3091),
    [anon_sym_BQUOTE] = ACTIONS(3091),
    [anon_sym_LT_LPAREN] = ACTIONS(3091),
    [anon_sym_GT_LPAREN] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3093),
    [sym_word] = ACTIONS(3093),
    [anon_sym_LF] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3093),
  },
  [1288] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(3809),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1289] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3809),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1290] = {
    [anon_sym_SEMI] = ACTIONS(3811),
    [anon_sym_RPAREN] = ACTIONS(3809),
    [anon_sym_SEMI_SEMI] = ACTIONS(3813),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3813),
    [anon_sym_AMP] = ACTIONS(3813),
  },
  [1291] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(3809),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1292] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(3809),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1293] = {
    [anon_sym_SEMI] = ACTIONS(3815),
    [anon_sym_SEMI_SEMI] = ACTIONS(3817),
    [anon_sym_BQUOTE] = ACTIONS(3809),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3817),
    [anon_sym_AMP] = ACTIONS(3817),
  },
  [1294] = {
    [sym__simple_heredoc_body] = ACTIONS(3121),
    [sym__heredoc_body_beginning] = ACTIONS(3121),
    [sym_file_descriptor] = ACTIONS(3121),
    [sym__concat] = ACTIONS(3121),
    [ts_builtin_sym_end] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3123),
    [anon_sym_RPAREN] = ACTIONS(3121),
    [anon_sym_SEMI_SEMI] = ACTIONS(3121),
    [anon_sym_PIPE_AMP] = ACTIONS(3121),
    [anon_sym_AMP_AMP] = ACTIONS(3121),
    [anon_sym_PIPE_PIPE] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_GT] = ACTIONS(3123),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_AMP_GT] = ACTIONS(3123),
    [anon_sym_AMP_GT_GT] = ACTIONS(3121),
    [anon_sym_LT_AMP] = ACTIONS(3121),
    [anon_sym_GT_AMP] = ACTIONS(3121),
    [anon_sym_LT_LT] = ACTIONS(3123),
    [anon_sym_LT_LT_DASH] = ACTIONS(3121),
    [anon_sym_LT_LT_LT] = ACTIONS(3121),
    [sym__special_characters] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [sym_raw_string] = ACTIONS(3121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3121),
    [anon_sym_BQUOTE] = ACTIONS(3121),
    [anon_sym_LT_LPAREN] = ACTIONS(3121),
    [anon_sym_GT_LPAREN] = ACTIONS(3121),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3123),
    [sym_word] = ACTIONS(3123),
    [anon_sym_LF] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
  },
  [1295] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(3819),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1296] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3819),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1297] = {
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_RPAREN] = ACTIONS(3819),
    [anon_sym_SEMI_SEMI] = ACTIONS(3823),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3823),
    [anon_sym_AMP] = ACTIONS(3823),
  },
  [1298] = {
    [sym_file_descriptor] = ACTIONS(2930),
    [sym__concat] = ACTIONS(2930),
    [sym_variable_name] = ACTIONS(2930),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2932),
    [anon_sym_GT_GT] = ACTIONS(2930),
    [anon_sym_AMP_GT] = ACTIONS(2932),
    [anon_sym_AMP_GT_GT] = ACTIONS(2930),
    [anon_sym_LT_AMP] = ACTIONS(2930),
    [anon_sym_GT_AMP] = ACTIONS(2930),
    [sym__special_characters] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_DOLLAR] = ACTIONS(2932),
    [sym_raw_string] = ACTIONS(2930),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2930),
    [anon_sym_BQUOTE] = ACTIONS(2930),
    [anon_sym_LT_LPAREN] = ACTIONS(2930),
    [anon_sym_GT_LPAREN] = ACTIONS(2930),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2930),
  },
  [1299] = {
    [sym_file_descriptor] = ACTIONS(2944),
    [sym__concat] = ACTIONS(2944),
    [sym_variable_name] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2946),
    [anon_sym_GT_GT] = ACTIONS(2944),
    [anon_sym_AMP_GT] = ACTIONS(2946),
    [anon_sym_AMP_GT_GT] = ACTIONS(2944),
    [anon_sym_LT_AMP] = ACTIONS(2944),
    [anon_sym_GT_AMP] = ACTIONS(2944),
    [sym__special_characters] = ACTIONS(2944),
    [anon_sym_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [sym_raw_string] = ACTIONS(2944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2944),
    [anon_sym_BQUOTE] = ACTIONS(2944),
    [anon_sym_LT_LPAREN] = ACTIONS(2944),
    [anon_sym_GT_LPAREN] = ACTIONS(2944),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2944),
  },
  [1300] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(3825),
    [sym_comment] = ACTIONS(57),
  },
  [1301] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(3827),
    [sym_comment] = ACTIONS(57),
  },
  [1302] = {
    [anon_sym_RBRACE] = ACTIONS(3827),
    [sym_comment] = ACTIONS(57),
  },
  [1303] = {
    [sym_concatenation] = STATE(1686),
    [sym_string] = STATE(1685),
    [sym_simple_expansion] = STATE(1685),
    [sym_string_expansion] = STATE(1685),
    [sym_expansion] = STATE(1685),
    [sym_command_substitution] = STATE(1685),
    [sym_process_substitution] = STATE(1685),
    [anon_sym_RBRACE] = ACTIONS(3827),
    [sym__special_characters] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(3831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3831),
  },
  [1304] = {
    [sym_file_descriptor] = ACTIONS(2980),
    [sym__concat] = ACTIONS(2980),
    [sym_variable_name] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2982),
    [anon_sym_GT_GT] = ACTIONS(2980),
    [anon_sym_AMP_GT] = ACTIONS(2982),
    [anon_sym_AMP_GT_GT] = ACTIONS(2980),
    [anon_sym_LT_AMP] = ACTIONS(2980),
    [anon_sym_GT_AMP] = ACTIONS(2980),
    [sym__special_characters] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2982),
    [sym_raw_string] = ACTIONS(2980),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2980),
    [anon_sym_BQUOTE] = ACTIONS(2980),
    [anon_sym_LT_LPAREN] = ACTIONS(2980),
    [anon_sym_GT_LPAREN] = ACTIONS(2980),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2980),
  },
  [1305] = {
    [sym_concatenation] = STATE(1689),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1689),
    [sym_regex] = ACTIONS(3833),
    [anon_sym_RBRACE] = ACTIONS(3835),
    [anon_sym_EQ] = ACTIONS(3837),
    [anon_sym_DASH] = ACTIONS(3837),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3839),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3837),
    [anon_sym_COLON_QMARK] = ACTIONS(3837),
    [anon_sym_COLON_DASH] = ACTIONS(3837),
    [anon_sym_PERCENT] = ACTIONS(3837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1306] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3835),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1307] = {
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1691),
    [sym_regex] = ACTIONS(3841),
    [anon_sym_RBRACE] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(3843),
    [anon_sym_DASH] = ACTIONS(3843),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3843),
    [anon_sym_COLON_QMARK] = ACTIONS(3843),
    [anon_sym_COLON_DASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1308] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1309] = {
    [sym_concatenation] = STATE(1693),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1693),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [anon_sym_EQ] = ACTIONS(3849),
    [anon_sym_DASH] = ACTIONS(3849),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3851),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3849),
    [anon_sym_COLON_QMARK] = ACTIONS(3849),
    [anon_sym_COLON_DASH] = ACTIONS(3849),
    [anon_sym_PERCENT] = ACTIONS(3849),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1310] = {
    [sym_file_descriptor] = ACTIONS(3036),
    [sym__concat] = ACTIONS(3036),
    [sym_variable_name] = ACTIONS(3036),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_GT] = ACTIONS(3038),
    [anon_sym_GT_GT] = ACTIONS(3036),
    [anon_sym_AMP_GT] = ACTIONS(3038),
    [anon_sym_AMP_GT_GT] = ACTIONS(3036),
    [anon_sym_LT_AMP] = ACTIONS(3036),
    [anon_sym_GT_AMP] = ACTIONS(3036),
    [sym__special_characters] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [anon_sym_DOLLAR] = ACTIONS(3038),
    [sym_raw_string] = ACTIONS(3036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3036),
    [anon_sym_BQUOTE] = ACTIONS(3036),
    [anon_sym_LT_LPAREN] = ACTIONS(3036),
    [anon_sym_GT_LPAREN] = ACTIONS(3036),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3036),
  },
  [1311] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1312] = {
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1691),
    [anon_sym_RBRACE] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(3843),
    [anon_sym_DASH] = ACTIONS(3843),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3843),
    [anon_sym_COLON_QMARK] = ACTIONS(3843),
    [anon_sym_COLON_DASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1313] = {
    [sym_file_descriptor] = ACTIONS(3091),
    [sym__concat] = ACTIONS(3091),
    [sym_variable_name] = ACTIONS(3091),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_GT] = ACTIONS(3093),
    [anon_sym_GT_GT] = ACTIONS(3091),
    [anon_sym_AMP_GT] = ACTIONS(3093),
    [anon_sym_AMP_GT_GT] = ACTIONS(3091),
    [anon_sym_LT_AMP] = ACTIONS(3091),
    [anon_sym_GT_AMP] = ACTIONS(3091),
    [sym__special_characters] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_DOLLAR] = ACTIONS(3093),
    [sym_raw_string] = ACTIONS(3091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3091),
    [anon_sym_BQUOTE] = ACTIONS(3091),
    [anon_sym_LT_LPAREN] = ACTIONS(3091),
    [anon_sym_GT_LPAREN] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3091),
  },
  [1314] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(3853),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1315] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3853),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1316] = {
    [anon_sym_SEMI] = ACTIONS(3855),
    [anon_sym_RPAREN] = ACTIONS(3853),
    [anon_sym_SEMI_SEMI] = ACTIONS(3857),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3857),
    [anon_sym_AMP] = ACTIONS(3857),
  },
  [1317] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(3853),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1318] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(3853),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1319] = {
    [anon_sym_SEMI] = ACTIONS(3859),
    [anon_sym_SEMI_SEMI] = ACTIONS(3861),
    [anon_sym_BQUOTE] = ACTIONS(3853),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3861),
  },
  [1320] = {
    [sym_file_descriptor] = ACTIONS(3121),
    [sym__concat] = ACTIONS(3121),
    [sym_variable_name] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_GT] = ACTIONS(3123),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_AMP_GT] = ACTIONS(3123),
    [anon_sym_AMP_GT_GT] = ACTIONS(3121),
    [anon_sym_LT_AMP] = ACTIONS(3121),
    [anon_sym_GT_AMP] = ACTIONS(3121),
    [sym__special_characters] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [sym_raw_string] = ACTIONS(3121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3121),
    [anon_sym_BQUOTE] = ACTIONS(3121),
    [anon_sym_LT_LPAREN] = ACTIONS(3121),
    [anon_sym_GT_LPAREN] = ACTIONS(3121),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3121),
  },
  [1321] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(3863),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1322] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3863),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1323] = {
    [anon_sym_SEMI] = ACTIONS(3865),
    [anon_sym_RPAREN] = ACTIONS(3863),
    [anon_sym_SEMI_SEMI] = ACTIONS(3867),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3867),
    [anon_sym_AMP] = ACTIONS(3867),
  },
  [1324] = {
    [sym__concat] = ACTIONS(2944),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [sym__string_content] = ACTIONS(2944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2946),
    [anon_sym_BQUOTE] = ACTIONS(2946),
    [sym_comment] = ACTIONS(265),
  },
  [1325] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(3869),
    [sym_comment] = ACTIONS(57),
  },
  [1326] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(3871),
    [sym_comment] = ACTIONS(57),
  },
  [1327] = {
    [anon_sym_RBRACE] = ACTIONS(3871),
    [sym_comment] = ACTIONS(57),
  },
  [1328] = {
    [sym_concatenation] = STATE(1703),
    [sym_string] = STATE(1702),
    [sym_simple_expansion] = STATE(1702),
    [sym_string_expansion] = STATE(1702),
    [sym_expansion] = STATE(1702),
    [sym_command_substitution] = STATE(1702),
    [sym_process_substitution] = STATE(1702),
    [anon_sym_RBRACE] = ACTIONS(3871),
    [sym__special_characters] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(3875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3875),
  },
  [1329] = {
    [sym__concat] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2982),
    [anon_sym_DOLLAR] = ACTIONS(2982),
    [sym__string_content] = ACTIONS(2980),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2982),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2982),
    [anon_sym_BQUOTE] = ACTIONS(2982),
    [sym_comment] = ACTIONS(265),
  },
  [1330] = {
    [sym_concatenation] = STATE(1706),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1706),
    [sym_regex] = ACTIONS(3877),
    [anon_sym_RBRACE] = ACTIONS(3879),
    [anon_sym_EQ] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3881),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_COLON_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_DASH] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1331] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3879),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1332] = {
    [sym_concatenation] = STATE(1708),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1708),
    [sym_regex] = ACTIONS(3885),
    [anon_sym_RBRACE] = ACTIONS(3871),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_DASH] = ACTIONS(3887),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3887),
    [anon_sym_COLON_QMARK] = ACTIONS(3887),
    [anon_sym_COLON_DASH] = ACTIONS(3887),
    [anon_sym_PERCENT] = ACTIONS(3887),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1333] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3871),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1334] = {
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1710),
    [anon_sym_RBRACE] = ACTIONS(3891),
    [anon_sym_EQ] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3895),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_DASH] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1335] = {
    [sym__concat] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3038),
    [anon_sym_DOLLAR] = ACTIONS(3038),
    [sym__string_content] = ACTIONS(3036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3038),
    [anon_sym_BQUOTE] = ACTIONS(3038),
    [sym_comment] = ACTIONS(265),
  },
  [1336] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3891),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1337] = {
    [sym_concatenation] = STATE(1708),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1708),
    [anon_sym_RBRACE] = ACTIONS(3871),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_DASH] = ACTIONS(3887),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3887),
    [anon_sym_COLON_QMARK] = ACTIONS(3887),
    [anon_sym_COLON_DASH] = ACTIONS(3887),
    [anon_sym_PERCENT] = ACTIONS(3887),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1338] = {
    [sym__concat] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3093),
    [anon_sym_DOLLAR] = ACTIONS(3093),
    [sym__string_content] = ACTIONS(3091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3093),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_comment] = ACTIONS(265),
  },
  [1339] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(3897),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1340] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(3897),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1341] = {
    [anon_sym_SEMI] = ACTIONS(3899),
    [anon_sym_RPAREN] = ACTIONS(3897),
    [anon_sym_SEMI_SEMI] = ACTIONS(3901),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3901),
    [anon_sym_AMP] = ACTIONS(3901),
  },
  [1342] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(3897),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1343] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(3897),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1344] = {
    [anon_sym_SEMI] = ACTIONS(3903),
    [anon_sym_SEMI_SEMI] = ACTIONS(3905),
    [anon_sym_BQUOTE] = ACTIONS(3897),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
  },
  [1345] = {
    [sym_string] = STATE(756),
    [sym_simple_expansion] = STATE(756),
    [sym_string_expansion] = STATE(756),
    [sym_expansion] = STATE(756),
    [sym_command_substitution] = STATE(756),
    [sym_process_substitution] = STATE(756),
    [anon_sym_RBRACK] = ACTIONS(3907),
    [sym__special_characters] = ACTIONS(2064),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [sym_raw_string] = ACTIONS(1453),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1453),
  },
  [1346] = {
    [sym__concat] = ACTIONS(3909),
    [anon_sym_RBRACE] = ACTIONS(2068),
    [anon_sym_EQ] = ACTIONS(3911),
    [anon_sym_DASH] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(2068),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [sym_raw_string] = ACTIONS(2068),
    [anon_sym_POUND] = ACTIONS(2068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2068),
    [anon_sym_SLASH] = ACTIONS(2068),
    [anon_sym_COLON] = ACTIONS(3911),
    [anon_sym_COLON_QMARK] = ACTIONS(3911),
    [anon_sym_COLON_DASH] = ACTIONS(3911),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2068),
    [anon_sym_BQUOTE] = ACTIONS(2068),
    [anon_sym_LT_LPAREN] = ACTIONS(2068),
    [anon_sym_GT_LPAREN] = ACTIONS(2068),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3911),
  },
  [1347] = {
    [sym_string] = STATE(756),
    [sym_simple_expansion] = STATE(756),
    [sym_string_expansion] = STATE(756),
    [sym_expansion] = STATE(756),
    [sym_command_substitution] = STATE(756),
    [sym_process_substitution] = STATE(756),
    [anon_sym_RBRACK] = ACTIONS(3913),
    [sym__special_characters] = ACTIONS(2064),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [sym_raw_string] = ACTIONS(1453),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1453),
  },
  [1348] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_RBRACE] = ACTIONS(2074),
    [anon_sym_EQ] = ACTIONS(3917),
    [anon_sym_DASH] = ACTIONS(3917),
    [sym__special_characters] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(2074),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(2074),
    [anon_sym_POUND] = ACTIONS(2074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2074),
    [anon_sym_SLASH] = ACTIONS(2074),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_COLON_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_DASH] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2074),
    [anon_sym_BQUOTE] = ACTIONS(2074),
    [anon_sym_LT_LPAREN] = ACTIONS(2074),
    [anon_sym_GT_LPAREN] = ACTIONS(2074),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3917),
  },
  [1349] = {
    [anon_sym_RBRACK] = ACTIONS(3913),
    [sym_comment] = ACTIONS(57),
  },
  [1350] = {
    [sym_string] = STATE(1718),
    [sym_simple_expansion] = STATE(1718),
    [sym_string_expansion] = STATE(1718),
    [sym_expansion] = STATE(1718),
    [sym_command_substitution] = STATE(1718),
    [sym_process_substitution] = STATE(1718),
    [sym__special_characters] = ACTIONS(3919),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(3919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3919),
  },
  [1351] = {
    [sym__simple_heredoc_body] = ACTIONS(3921),
    [sym__heredoc_body_beginning] = ACTIONS(3921),
    [sym_file_descriptor] = ACTIONS(3921),
    [sym__concat] = ACTIONS(3921),
    [ts_builtin_sym_end] = ACTIONS(3921),
    [anon_sym_SEMI] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_RPAREN] = ACTIONS(3921),
    [anon_sym_SEMI_SEMI] = ACTIONS(3921),
    [anon_sym_PIPE_AMP] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_EQ_TILDE] = ACTIONS(3923),
    [anon_sym_EQ_EQ] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_GT_GT] = ACTIONS(3921),
    [anon_sym_AMP_GT] = ACTIONS(3923),
    [anon_sym_AMP_GT_GT] = ACTIONS(3921),
    [anon_sym_LT_AMP] = ACTIONS(3921),
    [anon_sym_GT_AMP] = ACTIONS(3921),
    [anon_sym_LT_LT] = ACTIONS(3923),
    [anon_sym_LT_LT_DASH] = ACTIONS(3921),
    [anon_sym_LT_LT_LT] = ACTIONS(3921),
    [sym__special_characters] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_DOLLAR] = ACTIONS(3923),
    [sym_raw_string] = ACTIONS(3921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3921),
    [anon_sym_BQUOTE] = ACTIONS(3921),
    [anon_sym_LT_LPAREN] = ACTIONS(3921),
    [anon_sym_GT_LPAREN] = ACTIONS(3921),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3923),
    [anon_sym_LF] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3923),
  },
  [1352] = {
    [aux_sym_concatenation_repeat1] = STATE(1719),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
  },
  [1353] = {
    [sym__concat] = ACTIONS(783),
    [anon_sym_RBRACE] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
  },
  [1354] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [1355] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [1356] = {
    [sym__concat] = ACTIONS(817),
    [anon_sym_RBRACE] = ACTIONS(817),
    [sym_comment] = ACTIONS(57),
  },
  [1357] = {
    [sym__concat] = ACTIONS(821),
    [anon_sym_RBRACE] = ACTIONS(821),
    [sym_comment] = ACTIONS(57),
  },
  [1358] = {
    [sym__concat] = ACTIONS(825),
    [anon_sym_RBRACE] = ACTIONS(825),
    [sym_comment] = ACTIONS(57),
  },
  [1359] = {
    [sym__simple_heredoc_body] = ACTIONS(3929),
    [sym__heredoc_body_beginning] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [sym__concat] = ACTIONS(3929),
    [ts_builtin_sym_end] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3931),
    [anon_sym_RPAREN] = ACTIONS(3929),
    [anon_sym_SEMI_SEMI] = ACTIONS(3929),
    [anon_sym_PIPE_AMP] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_EQ_TILDE] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_AMP_GT] = ACTIONS(3931),
    [anon_sym_AMP_GT_GT] = ACTIONS(3929),
    [anon_sym_LT_AMP] = ACTIONS(3929),
    [anon_sym_GT_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_LT_LT_DASH] = ACTIONS(3929),
    [anon_sym_LT_LT_LT] = ACTIONS(3929),
    [sym__special_characters] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [sym_raw_string] = ACTIONS(3929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3929),
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [anon_sym_LT_LPAREN] = ACTIONS(3929),
    [anon_sym_GT_LPAREN] = ACTIONS(3929),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3931),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
  },
  [1360] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(3933),
    [sym_comment] = ACTIONS(57),
  },
  [1361] = {
    [sym_subscript] = STATE(1725),
    [sym_variable_name] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_DOLLAR] = ACTIONS(3937),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3939),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_AT] = ACTIONS(3941),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_0] = ACTIONS(3939),
    [anon_sym__] = ACTIONS(3939),
  },
  [1362] = {
    [sym_concatenation] = STATE(1728),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1728),
    [anon_sym_RBRACE] = ACTIONS(3943),
    [anon_sym_EQ] = ACTIONS(3945),
    [anon_sym_DASH] = ACTIONS(3945),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(3949),
    [anon_sym_COLON] = ACTIONS(3945),
    [anon_sym_COLON_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_DASH] = ACTIONS(3945),
    [anon_sym_PERCENT] = ACTIONS(3945),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1363] = {
    [sym_concatenation] = STATE(1731),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1731),
    [anon_sym_RBRACE] = ACTIONS(3951),
    [anon_sym_EQ] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3953),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(3957),
    [anon_sym_COLON] = ACTIONS(3953),
    [anon_sym_COLON_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_DASH] = ACTIONS(3953),
    [anon_sym_PERCENT] = ACTIONS(3953),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1364] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1734),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(3959),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3961),
    [anon_sym_SEMI_SEMI] = ACTIONS(3963),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3959),
  },
  [1365] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1734),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3959),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3961),
    [anon_sym_SEMI_SEMI] = ACTIONS(3963),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3959),
  },
  [1366] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1735),
    [sym_for_statement] = STATE(1735),
    [sym_c_style_for_statement] = STATE(1735),
    [sym_while_statement] = STATE(1735),
    [sym_if_statement] = STATE(1735),
    [sym_case_statement] = STATE(1735),
    [sym_function_definition] = STATE(1735),
    [sym_compound_statement] = STATE(1735),
    [sym_subshell] = STATE(1735),
    [sym_pipeline] = STATE(1735),
    [sym_list] = STATE(1735),
    [sym_negated_command] = STATE(1735),
    [sym_test_command] = STATE(1735),
    [sym_declaration_command] = STATE(1735),
    [sym_unset_command] = STATE(1735),
    [sym_command] = STATE(1735),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(1736),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [1367] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1738),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(3965),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(3967),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(3961),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3965),
  },
  [1368] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1738),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3965),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(3967),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(3961),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3965),
  },
  [1369] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1739),
    [sym_for_statement] = STATE(1739),
    [sym_c_style_for_statement] = STATE(1739),
    [sym_while_statement] = STATE(1739),
    [sym_if_statement] = STATE(1739),
    [sym_case_statement] = STATE(1739),
    [sym_function_definition] = STATE(1739),
    [sym_compound_statement] = STATE(1739),
    [sym_subshell] = STATE(1739),
    [sym_pipeline] = STATE(1739),
    [sym_list] = STATE(1739),
    [sym_negated_command] = STATE(1739),
    [sym_test_command] = STATE(1739),
    [sym_declaration_command] = STATE(1739),
    [sym_unset_command] = STATE(1739),
    [sym_command] = STATE(1739),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(1740),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [1370] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1743),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(3969),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3971),
    [anon_sym_SEMI_SEMI] = ACTIONS(3973),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3973),
    [anon_sym_AMP] = ACTIONS(3969),
  },
  [1371] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1743),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(3969),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(3971),
    [anon_sym_SEMI_SEMI] = ACTIONS(3973),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(3973),
    [anon_sym_AMP] = ACTIONS(3969),
  },
  [1372] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(1744),
    [sym_for_statement] = STATE(1744),
    [sym_c_style_for_statement] = STATE(1744),
    [sym_while_statement] = STATE(1744),
    [sym_if_statement] = STATE(1744),
    [sym_case_statement] = STATE(1744),
    [sym_function_definition] = STATE(1744),
    [sym_compound_statement] = STATE(1744),
    [sym_subshell] = STATE(1744),
    [sym_pipeline] = STATE(1744),
    [sym_list] = STATE(1744),
    [sym_negated_command] = STATE(1744),
    [sym_test_command] = STATE(1744),
    [sym_declaration_command] = STATE(1744),
    [sym_unset_command] = STATE(1744),
    [sym_command] = STATE(1744),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(1745),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [1373] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(3975),
    [sym_comment] = ACTIONS(57),
  },
  [1374] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(3977),
    [sym_comment] = ACTIONS(57),
  },
  [1375] = {
    [anon_sym_RBRACE] = ACTIONS(3977),
    [sym_comment] = ACTIONS(57),
  },
  [1376] = {
    [sym_concatenation] = STATE(1749),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1749),
    [anon_sym_RBRACE] = ACTIONS(3979),
    [anon_sym_EQ] = ACTIONS(3981),
    [anon_sym_DASH] = ACTIONS(3981),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3981),
    [anon_sym_COLON_QMARK] = ACTIONS(3981),
    [anon_sym_COLON_DASH] = ACTIONS(3981),
    [anon_sym_PERCENT] = ACTIONS(3981),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1377] = {
    [sym__simple_heredoc_body] = ACTIONS(3985),
    [sym__heredoc_body_beginning] = ACTIONS(3985),
    [sym_file_descriptor] = ACTIONS(3985),
    [sym__concat] = ACTIONS(3985),
    [ts_builtin_sym_end] = ACTIONS(3985),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_RPAREN] = ACTIONS(3985),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_EQ_TILDE] = ACTIONS(3987),
    [anon_sym_EQ_EQ] = ACTIONS(3987),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_AMP_GT] = ACTIONS(3987),
    [anon_sym_AMP_GT_GT] = ACTIONS(3985),
    [anon_sym_LT_AMP] = ACTIONS(3985),
    [anon_sym_GT_AMP] = ACTIONS(3985),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_LT_LT_DASH] = ACTIONS(3985),
    [anon_sym_LT_LT_LT] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [1378] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3979),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1379] = {
    [sym_concatenation] = STATE(1750),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1750),
    [anon_sym_RBRACE] = ACTIONS(3977),
    [anon_sym_EQ] = ACTIONS(3989),
    [anon_sym_DASH] = ACTIONS(3989),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(3991),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3989),
    [anon_sym_COLON_QMARK] = ACTIONS(3989),
    [anon_sym_COLON_DASH] = ACTIONS(3989),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1380] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3977),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1381] = {
    [sym__concat] = ACTIONS(1726),
    [anon_sym_RBRACE] = ACTIONS(1726),
    [anon_sym_EQ] = ACTIONS(1728),
    [anon_sym_DASH] = ACTIONS(1728),
    [sym__special_characters] = ACTIONS(1728),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_POUND] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_COLON] = ACTIONS(1728),
    [anon_sym_COLON_QMARK] = ACTIONS(1728),
    [anon_sym_COLON_DASH] = ACTIONS(1728),
    [anon_sym_PERCENT] = ACTIONS(1728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1728),
  },
  [1382] = {
    [aux_sym_concatenation_repeat1] = STATE(1382),
    [sym__concat] = ACTIONS(3993),
    [anon_sym_RBRACE] = ACTIONS(1726),
    [anon_sym_EQ] = ACTIONS(1728),
    [anon_sym_DASH] = ACTIONS(1728),
    [sym__special_characters] = ACTIONS(1728),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_POUND] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_COLON] = ACTIONS(1728),
    [anon_sym_COLON_QMARK] = ACTIONS(1728),
    [anon_sym_COLON_DASH] = ACTIONS(1728),
    [anon_sym_PERCENT] = ACTIONS(1728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1728),
  },
  [1383] = {
    [sym__concat] = ACTIONS(1733),
    [anon_sym_RBRACE] = ACTIONS(1733),
    [anon_sym_EQ] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [sym__special_characters] = ACTIONS(1735),
    [anon_sym_DQUOTE] = ACTIONS(1733),
    [anon_sym_DOLLAR] = ACTIONS(1735),
    [sym_raw_string] = ACTIONS(1733),
    [anon_sym_POUND] = ACTIONS(1733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1733),
    [anon_sym_COLON] = ACTIONS(1735),
    [anon_sym_COLON_QMARK] = ACTIONS(1735),
    [anon_sym_COLON_DASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1733),
    [anon_sym_BQUOTE] = ACTIONS(1733),
    [anon_sym_LT_LPAREN] = ACTIONS(1733),
    [anon_sym_GT_LPAREN] = ACTIONS(1733),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1735),
  },
  [1384] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(3996),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [1385] = {
    [sym_concatenation] = STATE(1755),
    [sym_string] = STATE(1754),
    [sym_simple_expansion] = STATE(1754),
    [sym_string_expansion] = STATE(1754),
    [sym_expansion] = STATE(1754),
    [sym_command_substitution] = STATE(1754),
    [sym_process_substitution] = STATE(1754),
    [anon_sym_RBRACE] = ACTIONS(3998),
    [sym__special_characters] = ACTIONS(4000),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(4002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4002),
  },
  [1386] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(4004),
    [sym_comment] = ACTIONS(57),
  },
  [1387] = {
    [sym_concatenation] = STATE(1759),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1759),
    [anon_sym_RBRACE] = ACTIONS(4006),
    [anon_sym_EQ] = ACTIONS(4008),
    [anon_sym_DASH] = ACTIONS(4008),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(4012),
    [anon_sym_COLON] = ACTIONS(4008),
    [anon_sym_COLON_QMARK] = ACTIONS(4008),
    [anon_sym_COLON_DASH] = ACTIONS(4008),
    [anon_sym_PERCENT] = ACTIONS(4008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1388] = {
    [sym_concatenation] = STATE(1761),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1761),
    [anon_sym_RBRACE] = ACTIONS(3998),
    [anon_sym_EQ] = ACTIONS(4014),
    [anon_sym_DASH] = ACTIONS(4014),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(4018),
    [anon_sym_COLON] = ACTIONS(4014),
    [anon_sym_COLON_QMARK] = ACTIONS(4014),
    [anon_sym_COLON_DASH] = ACTIONS(4014),
    [anon_sym_PERCENT] = ACTIONS(4014),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1389] = {
    [sym__concat] = ACTIONS(1834),
    [anon_sym_RBRACE] = ACTIONS(1834),
    [anon_sym_EQ] = ACTIONS(1836),
    [anon_sym_DASH] = ACTIONS(1836),
    [sym__special_characters] = ACTIONS(1836),
    [anon_sym_DQUOTE] = ACTIONS(1834),
    [anon_sym_DOLLAR] = ACTIONS(1836),
    [sym_raw_string] = ACTIONS(1834),
    [anon_sym_POUND] = ACTIONS(1834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1834),
    [anon_sym_COLON] = ACTIONS(1836),
    [anon_sym_COLON_QMARK] = ACTIONS(1836),
    [anon_sym_COLON_DASH] = ACTIONS(1836),
    [anon_sym_PERCENT] = ACTIONS(1836),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1834),
    [anon_sym_BQUOTE] = ACTIONS(1834),
    [anon_sym_LT_LPAREN] = ACTIONS(1834),
    [anon_sym_GT_LPAREN] = ACTIONS(1834),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1836),
  },
  [1390] = {
    [sym_concatenation] = STATE(1764),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1764),
    [sym_regex] = ACTIONS(4020),
    [anon_sym_RBRACE] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4024),
    [anon_sym_DASH] = ACTIONS(4024),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COLON_QMARK] = ACTIONS(4024),
    [anon_sym_COLON_DASH] = ACTIONS(4024),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1391] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1392] = {
    [sym__concat] = ACTIONS(1882),
    [anon_sym_RBRACE] = ACTIONS(1882),
    [anon_sym_EQ] = ACTIONS(1884),
    [anon_sym_DASH] = ACTIONS(1884),
    [sym__special_characters] = ACTIONS(1884),
    [anon_sym_DQUOTE] = ACTIONS(1882),
    [anon_sym_DOLLAR] = ACTIONS(1884),
    [sym_raw_string] = ACTIONS(1882),
    [anon_sym_POUND] = ACTIONS(1882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1882),
    [anon_sym_COLON] = ACTIONS(1884),
    [anon_sym_COLON_QMARK] = ACTIONS(1884),
    [anon_sym_COLON_DASH] = ACTIONS(1884),
    [anon_sym_PERCENT] = ACTIONS(1884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1882),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [anon_sym_LT_LPAREN] = ACTIONS(1882),
    [anon_sym_GT_LPAREN] = ACTIONS(1882),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1884),
  },
  [1393] = {
    [sym_concatenation] = STATE(1761),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1761),
    [sym_regex] = ACTIONS(4028),
    [anon_sym_RBRACE] = ACTIONS(3998),
    [anon_sym_EQ] = ACTIONS(4014),
    [anon_sym_DASH] = ACTIONS(4014),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4014),
    [anon_sym_COLON_QMARK] = ACTIONS(4014),
    [anon_sym_COLON_DASH] = ACTIONS(4014),
    [anon_sym_PERCENT] = ACTIONS(4014),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1394] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(3998),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1395] = {
    [sym__simple_heredoc_body] = ACTIONS(4030),
    [sym__heredoc_body_beginning] = ACTIONS(4030),
    [sym_file_descriptor] = ACTIONS(4030),
    [sym__concat] = ACTIONS(4030),
    [ts_builtin_sym_end] = ACTIONS(4030),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_RPAREN] = ACTIONS(4030),
    [anon_sym_SEMI_SEMI] = ACTIONS(4030),
    [anon_sym_PIPE_AMP] = ACTIONS(4030),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_EQ_TILDE] = ACTIONS(4032),
    [anon_sym_EQ_EQ] = ACTIONS(4032),
    [anon_sym_LT] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(4032),
    [anon_sym_GT_GT] = ACTIONS(4030),
    [anon_sym_AMP_GT] = ACTIONS(4032),
    [anon_sym_AMP_GT_GT] = ACTIONS(4030),
    [anon_sym_LT_AMP] = ACTIONS(4030),
    [anon_sym_GT_AMP] = ACTIONS(4030),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_LT_LT_DASH] = ACTIONS(4030),
    [anon_sym_LT_LT_LT] = ACTIONS(4030),
    [sym__special_characters] = ACTIONS(4030),
    [anon_sym_DQUOTE] = ACTIONS(4030),
    [anon_sym_DOLLAR] = ACTIONS(4032),
    [sym_raw_string] = ACTIONS(4030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4030),
    [anon_sym_BQUOTE] = ACTIONS(4030),
    [anon_sym_LT_LPAREN] = ACTIONS(4030),
    [anon_sym_GT_LPAREN] = ACTIONS(4030),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4032),
    [anon_sym_LF] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4032),
  },
  [1396] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4034),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1397] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1398] = {
    [sym__concat] = ACTIONS(1890),
    [anon_sym_RBRACE] = ACTIONS(1890),
    [anon_sym_EQ] = ACTIONS(1892),
    [anon_sym_DASH] = ACTIONS(1892),
    [sym__special_characters] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1890),
    [anon_sym_DOLLAR] = ACTIONS(1892),
    [sym_raw_string] = ACTIONS(1890),
    [anon_sym_POUND] = ACTIONS(1890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1890),
    [anon_sym_COLON] = ACTIONS(1892),
    [anon_sym_COLON_QMARK] = ACTIONS(1892),
    [anon_sym_COLON_DASH] = ACTIONS(1892),
    [anon_sym_PERCENT] = ACTIONS(1892),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1890),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [anon_sym_LT_LPAREN] = ACTIONS(1890),
    [anon_sym_GT_LPAREN] = ACTIONS(1890),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1892),
  },
  [1399] = {
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_SEMI_SEMI] = ACTIONS(4040),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(4040),
  },
  [1400] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1770),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(4042),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_SEMI_SEMI] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4042),
  },
  [1401] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1770),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(4042),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_SEMI_SEMI] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4042),
  },
  [1402] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1403] = {
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_SEMI_SEMI] = ACTIONS(4048),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
  },
  [1404] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1773),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4050),
  },
  [1405] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1773),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4050),
  },
  [1406] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4054),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1407] = {
    [sym__concat] = ACTIONS(1924),
    [anon_sym_RBRACE] = ACTIONS(1924),
    [anon_sym_EQ] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [sym__special_characters] = ACTIONS(1926),
    [anon_sym_DQUOTE] = ACTIONS(1924),
    [anon_sym_DOLLAR] = ACTIONS(1926),
    [sym_raw_string] = ACTIONS(1924),
    [anon_sym_POUND] = ACTIONS(1924),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1924),
    [anon_sym_COLON] = ACTIONS(1926),
    [anon_sym_COLON_QMARK] = ACTIONS(1926),
    [anon_sym_COLON_DASH] = ACTIONS(1926),
    [anon_sym_PERCENT] = ACTIONS(1926),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1924),
    [anon_sym_BQUOTE] = ACTIONS(1924),
    [anon_sym_LT_LPAREN] = ACTIONS(1924),
    [anon_sym_GT_LPAREN] = ACTIONS(1924),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1926),
  },
  [1408] = {
    [anon_sym_SEMI] = ACTIONS(4056),
    [anon_sym_RPAREN] = ACTIONS(4054),
    [anon_sym_SEMI_SEMI] = ACTIONS(4058),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4058),
    [anon_sym_AMP] = ACTIONS(4058),
  },
  [1409] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1777),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(4060),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(4054),
    [anon_sym_SEMI_SEMI] = ACTIONS(4062),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4060),
  },
  [1410] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1777),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(4060),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(4054),
    [anon_sym_SEMI_SEMI] = ACTIONS(4062),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4060),
  },
  [1411] = {
    [sym__simple_heredoc_body] = ACTIONS(4064),
    [sym__heredoc_body_beginning] = ACTIONS(4064),
    [sym_file_descriptor] = ACTIONS(4064),
    [sym__concat] = ACTIONS(4064),
    [ts_builtin_sym_end] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_RPAREN] = ACTIONS(4064),
    [anon_sym_SEMI_SEMI] = ACTIONS(4064),
    [anon_sym_PIPE_AMP] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_EQ_TILDE] = ACTIONS(4066),
    [anon_sym_EQ_EQ] = ACTIONS(4066),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_GT_GT] = ACTIONS(4064),
    [anon_sym_AMP_GT] = ACTIONS(4066),
    [anon_sym_AMP_GT_GT] = ACTIONS(4064),
    [anon_sym_LT_AMP] = ACTIONS(4064),
    [anon_sym_GT_AMP] = ACTIONS(4064),
    [anon_sym_LT_LT] = ACTIONS(4066),
    [anon_sym_LT_LT_DASH] = ACTIONS(4064),
    [anon_sym_LT_LT_LT] = ACTIONS(4064),
    [sym__special_characters] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_DOLLAR] = ACTIONS(4066),
    [sym_raw_string] = ACTIONS(4064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4064),
    [anon_sym_BQUOTE] = ACTIONS(4064),
    [anon_sym_LT_LPAREN] = ACTIONS(4064),
    [anon_sym_GT_LPAREN] = ACTIONS(4064),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4066),
    [anon_sym_LF] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4066),
  },
  [1412] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1413] = {
    [aux_sym_concatenation_repeat1] = STATE(1415),
    [sym__simple_heredoc_body] = ACTIONS(1067),
    [sym__heredoc_body_beginning] = ACTIONS(1067),
    [sym_file_descriptor] = ACTIONS(1067),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(1069),
    [anon_sym_SEMI_SEMI] = ACTIONS(1067),
    [anon_sym_PIPE_AMP] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1069),
    [anon_sym_GT_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT] = ACTIONS(1069),
    [anon_sym_AMP_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_AMP] = ACTIONS(1067),
    [anon_sym_GT_AMP] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1069),
    [anon_sym_LT_LT_DASH] = ACTIONS(1067),
    [anon_sym_LT_LT_LT] = ACTIONS(1067),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1069),
  },
  [1414] = {
    [aux_sym_concatenation_repeat1] = STATE(1415),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
  },
  [1415] = {
    [aux_sym_concatenation_repeat1] = STATE(1779),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [1416] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(4068),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1417] = {
    [sym__simple_heredoc_body] = ACTIONS(4070),
    [sym__heredoc_body_beginning] = ACTIONS(4070),
    [sym_file_descriptor] = ACTIONS(4070),
    [sym__concat] = ACTIONS(4070),
    [ts_builtin_sym_end] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_PIPE] = ACTIONS(4072),
    [anon_sym_RPAREN] = ACTIONS(4070),
    [anon_sym_SEMI_SEMI] = ACTIONS(4070),
    [anon_sym_PIPE_AMP] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4070),
    [anon_sym_PIPE_PIPE] = ACTIONS(4070),
    [anon_sym_EQ_TILDE] = ACTIONS(4072),
    [anon_sym_EQ_EQ] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_GT] = ACTIONS(4072),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_AMP_GT] = ACTIONS(4072),
    [anon_sym_AMP_GT_GT] = ACTIONS(4070),
    [anon_sym_LT_AMP] = ACTIONS(4070),
    [anon_sym_GT_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4072),
    [anon_sym_LT_LT_DASH] = ACTIONS(4070),
    [anon_sym_LT_LT_LT] = ACTIONS(4070),
    [sym__special_characters] = ACTIONS(4070),
    [anon_sym_DQUOTE] = ACTIONS(4070),
    [anon_sym_DOLLAR] = ACTIONS(4072),
    [sym_raw_string] = ACTIONS(4070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4070),
    [anon_sym_BQUOTE] = ACTIONS(4070),
    [anon_sym_LT_LPAREN] = ACTIONS(4070),
    [anon_sym_GT_LPAREN] = ACTIONS(4070),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4072),
    [anon_sym_LF] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4072),
  },
  [1418] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1419] = {
    [sym_concatenation] = STATE(1784),
    [sym_string] = STATE(1783),
    [sym_simple_expansion] = STATE(1783),
    [sym_string_expansion] = STATE(1783),
    [sym_expansion] = STATE(1783),
    [sym_command_substitution] = STATE(1783),
    [sym_process_substitution] = STATE(1783),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [sym__special_characters] = ACTIONS(4078),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(4080),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4080),
  },
  [1420] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(4082),
    [sym_comment] = ACTIONS(57),
  },
  [1421] = {
    [sym_concatenation] = STATE(1788),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1788),
    [anon_sym_RBRACE] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4088),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(4090),
    [anon_sym_COLON] = ACTIONS(4086),
    [anon_sym_COLON_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_DASH] = ACTIONS(4086),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1422] = {
    [sym_concatenation] = STATE(1790),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1790),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_EQ] = ACTIONS(4092),
    [anon_sym_DASH] = ACTIONS(4092),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4094),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(4096),
    [anon_sym_COLON] = ACTIONS(4092),
    [anon_sym_COLON_QMARK] = ACTIONS(4092),
    [anon_sym_COLON_DASH] = ACTIONS(4092),
    [anon_sym_PERCENT] = ACTIONS(4092),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1423] = {
    [sym__heredoc_body_middle] = ACTIONS(1834),
    [sym__heredoc_body_end] = ACTIONS(1834),
    [anon_sym_DOLLAR] = ACTIONS(1836),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1834),
    [sym_comment] = ACTIONS(57),
  },
  [1424] = {
    [sym_concatenation] = STATE(1793),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1793),
    [sym_regex] = ACTIONS(4098),
    [anon_sym_RBRACE] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_DASH] = ACTIONS(4102),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4102),
    [anon_sym_COLON_QMARK] = ACTIONS(4102),
    [anon_sym_COLON_DASH] = ACTIONS(4102),
    [anon_sym_PERCENT] = ACTIONS(4102),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1425] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1426] = {
    [sym__heredoc_body_middle] = ACTIONS(1882),
    [sym__heredoc_body_end] = ACTIONS(1882),
    [anon_sym_DOLLAR] = ACTIONS(1884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
  },
  [1427] = {
    [sym_concatenation] = STATE(1790),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1790),
    [sym_regex] = ACTIONS(4106),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_EQ] = ACTIONS(4092),
    [anon_sym_DASH] = ACTIONS(4092),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4094),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4092),
    [anon_sym_COLON_QMARK] = ACTIONS(4092),
    [anon_sym_COLON_DASH] = ACTIONS(4092),
    [anon_sym_PERCENT] = ACTIONS(4092),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1428] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1429] = {
    [aux_sym_concatenation_repeat1] = STATE(1429),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(1730),
    [ts_builtin_sym_end] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [1430] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_done] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_fi] = ACTIONS(1988),
    [anon_sym_elif] = ACTIONS(1988),
    [anon_sym_else] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1431] = {
    [anon_sym_EQ] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4108),
    [sym_comment] = ACTIONS(57),
  },
  [1432] = {
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [sym_comment] = ACTIONS(57),
  },
  [1433] = {
    [sym__concat] = ACTIONS(1726),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1726),
  },
  [1434] = {
    [aux_sym_concatenation_repeat1] = STATE(1434),
    [sym__concat] = ACTIONS(4112),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1726),
  },
  [1435] = {
    [sym__concat] = ACTIONS(1733),
    [anon_sym_RPAREN] = ACTIONS(1733),
    [sym__special_characters] = ACTIONS(1733),
    [anon_sym_DQUOTE] = ACTIONS(1733),
    [anon_sym_DOLLAR] = ACTIONS(1735),
    [sym_raw_string] = ACTIONS(1733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1733),
    [anon_sym_BQUOTE] = ACTIONS(1733),
    [anon_sym_LT_LPAREN] = ACTIONS(1733),
    [anon_sym_GT_LPAREN] = ACTIONS(1733),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1733),
  },
  [1436] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(4115),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [1437] = {
    [sym_concatenation] = STATE(1799),
    [sym_string] = STATE(1798),
    [sym_simple_expansion] = STATE(1798),
    [sym_string_expansion] = STATE(1798),
    [sym_expansion] = STATE(1798),
    [sym_command_substitution] = STATE(1798),
    [sym_process_substitution] = STATE(1798),
    [anon_sym_RBRACE] = ACTIONS(4117),
    [sym__special_characters] = ACTIONS(4119),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(4121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4121),
  },
  [1438] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(4123),
    [sym_comment] = ACTIONS(57),
  },
  [1439] = {
    [sym_concatenation] = STATE(1803),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1803),
    [anon_sym_RBRACE] = ACTIONS(4125),
    [anon_sym_EQ] = ACTIONS(4127),
    [anon_sym_DASH] = ACTIONS(4127),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(4131),
    [anon_sym_COLON] = ACTIONS(4127),
    [anon_sym_COLON_QMARK] = ACTIONS(4127),
    [anon_sym_COLON_DASH] = ACTIONS(4127),
    [anon_sym_PERCENT] = ACTIONS(4127),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1440] = {
    [sym_concatenation] = STATE(1805),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1805),
    [anon_sym_RBRACE] = ACTIONS(4117),
    [anon_sym_EQ] = ACTIONS(4133),
    [anon_sym_DASH] = ACTIONS(4133),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4135),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(4137),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COLON_QMARK] = ACTIONS(4133),
    [anon_sym_COLON_DASH] = ACTIONS(4133),
    [anon_sym_PERCENT] = ACTIONS(4133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1441] = {
    [sym__concat] = ACTIONS(1834),
    [anon_sym_RPAREN] = ACTIONS(1834),
    [sym__special_characters] = ACTIONS(1834),
    [anon_sym_DQUOTE] = ACTIONS(1834),
    [anon_sym_DOLLAR] = ACTIONS(1836),
    [sym_raw_string] = ACTIONS(1834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1834),
    [anon_sym_BQUOTE] = ACTIONS(1834),
    [anon_sym_LT_LPAREN] = ACTIONS(1834),
    [anon_sym_GT_LPAREN] = ACTIONS(1834),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1834),
  },
  [1442] = {
    [sym_concatenation] = STATE(1808),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1808),
    [sym_regex] = ACTIONS(4139),
    [anon_sym_RBRACE] = ACTIONS(4141),
    [anon_sym_EQ] = ACTIONS(4143),
    [anon_sym_DASH] = ACTIONS(4143),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4143),
    [anon_sym_COLON_QMARK] = ACTIONS(4143),
    [anon_sym_COLON_DASH] = ACTIONS(4143),
    [anon_sym_PERCENT] = ACTIONS(4143),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1443] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4141),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1444] = {
    [sym__concat] = ACTIONS(1882),
    [anon_sym_RPAREN] = ACTIONS(1882),
    [sym__special_characters] = ACTIONS(1882),
    [anon_sym_DQUOTE] = ACTIONS(1882),
    [anon_sym_DOLLAR] = ACTIONS(1884),
    [sym_raw_string] = ACTIONS(1882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1882),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [anon_sym_LT_LPAREN] = ACTIONS(1882),
    [anon_sym_GT_LPAREN] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1882),
  },
  [1445] = {
    [sym_concatenation] = STATE(1805),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1805),
    [sym_regex] = ACTIONS(4147),
    [anon_sym_RBRACE] = ACTIONS(4117),
    [anon_sym_EQ] = ACTIONS(4133),
    [anon_sym_DASH] = ACTIONS(4133),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4135),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COLON_QMARK] = ACTIONS(4133),
    [anon_sym_COLON_DASH] = ACTIONS(4133),
    [anon_sym_PERCENT] = ACTIONS(4133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1446] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4117),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1447] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4149),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1448] = {
    [sym__concat] = ACTIONS(1890),
    [anon_sym_RPAREN] = ACTIONS(1890),
    [sym__special_characters] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1890),
    [anon_sym_DOLLAR] = ACTIONS(1892),
    [sym_raw_string] = ACTIONS(1890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1890),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [anon_sym_LT_LPAREN] = ACTIONS(1890),
    [anon_sym_GT_LPAREN] = ACTIONS(1890),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1890),
  },
  [1449] = {
    [anon_sym_SEMI] = ACTIONS(4151),
    [anon_sym_RPAREN] = ACTIONS(4149),
    [anon_sym_SEMI_SEMI] = ACTIONS(4153),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4153),
    [anon_sym_AMP] = ACTIONS(4153),
  },
  [1450] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1813),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(4155),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(4149),
    [anon_sym_SEMI_SEMI] = ACTIONS(4157),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4157),
    [anon_sym_AMP] = ACTIONS(4155),
  },
  [1451] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1813),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(4155),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(4149),
    [anon_sym_SEMI_SEMI] = ACTIONS(4157),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(4157),
    [anon_sym_AMP] = ACTIONS(4155),
  },
  [1452] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(4149),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1453] = {
    [anon_sym_SEMI] = ACTIONS(4159),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4149),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [1454] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1816),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(4165),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(4149),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4165),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [1455] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1816),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(4165),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(4149),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(4165),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [1456] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4167),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1457] = {
    [sym__concat] = ACTIONS(1924),
    [anon_sym_RPAREN] = ACTIONS(1924),
    [sym__special_characters] = ACTIONS(1924),
    [anon_sym_DQUOTE] = ACTIONS(1924),
    [anon_sym_DOLLAR] = ACTIONS(1926),
    [sym_raw_string] = ACTIONS(1924),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1924),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1924),
    [anon_sym_BQUOTE] = ACTIONS(1924),
    [anon_sym_LT_LPAREN] = ACTIONS(1924),
    [anon_sym_GT_LPAREN] = ACTIONS(1924),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1924),
  },
  [1458] = {
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym_RPAREN] = ACTIONS(4167),
    [anon_sym_SEMI_SEMI] = ACTIONS(4171),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4171),
    [anon_sym_AMP] = ACTIONS(4171),
  },
  [1459] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1820),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(4167),
    [anon_sym_SEMI_SEMI] = ACTIONS(4175),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4175),
    [anon_sym_AMP] = ACTIONS(4173),
  },
  [1460] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1820),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(4167),
    [anon_sym_SEMI_SEMI] = ACTIONS(4175),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(4175),
    [anon_sym_AMP] = ACTIONS(4173),
  },
  [1461] = {
    [sym__simple_heredoc_body] = ACTIONS(2930),
    [sym__heredoc_body_beginning] = ACTIONS(2930),
    [sym_file_descriptor] = ACTIONS(2930),
    [sym__concat] = ACTIONS(2930),
    [sym_variable_name] = ACTIONS(2930),
    [ts_builtin_sym_end] = ACTIONS(2930),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym_PIPE] = ACTIONS(2932),
    [anon_sym_RPAREN] = ACTIONS(2930),
    [anon_sym_SEMI_SEMI] = ACTIONS(2930),
    [anon_sym_PIPE_AMP] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2932),
    [anon_sym_GT_GT] = ACTIONS(2930),
    [anon_sym_AMP_GT] = ACTIONS(2932),
    [anon_sym_AMP_GT_GT] = ACTIONS(2930),
    [anon_sym_LT_AMP] = ACTIONS(2930),
    [anon_sym_GT_AMP] = ACTIONS(2930),
    [anon_sym_LT_LT] = ACTIONS(2932),
    [anon_sym_LT_LT_DASH] = ACTIONS(2930),
    [anon_sym_LT_LT_LT] = ACTIONS(2930),
    [sym__special_characters] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_DOLLAR] = ACTIONS(2932),
    [sym_raw_string] = ACTIONS(2930),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2930),
    [anon_sym_BQUOTE] = ACTIONS(2930),
    [anon_sym_LT_LPAREN] = ACTIONS(2930),
    [anon_sym_GT_LPAREN] = ACTIONS(2930),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2932),
    [anon_sym_LF] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2932),
  },
  [1462] = {
    [sym__simple_heredoc_body] = ACTIONS(2944),
    [sym__heredoc_body_beginning] = ACTIONS(2944),
    [sym_file_descriptor] = ACTIONS(2944),
    [sym__concat] = ACTIONS(2944),
    [sym_variable_name] = ACTIONS(2944),
    [ts_builtin_sym_end] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym_PIPE] = ACTIONS(2946),
    [anon_sym_RPAREN] = ACTIONS(2944),
    [anon_sym_SEMI_SEMI] = ACTIONS(2944),
    [anon_sym_PIPE_AMP] = ACTIONS(2944),
    [anon_sym_AMP_AMP] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2946),
    [anon_sym_GT_GT] = ACTIONS(2944),
    [anon_sym_AMP_GT] = ACTIONS(2946),
    [anon_sym_AMP_GT_GT] = ACTIONS(2944),
    [anon_sym_LT_AMP] = ACTIONS(2944),
    [anon_sym_GT_AMP] = ACTIONS(2944),
    [anon_sym_LT_LT] = ACTIONS(2946),
    [anon_sym_LT_LT_DASH] = ACTIONS(2944),
    [anon_sym_LT_LT_LT] = ACTIONS(2944),
    [sym__special_characters] = ACTIONS(2944),
    [anon_sym_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [sym_raw_string] = ACTIONS(2944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2944),
    [anon_sym_BQUOTE] = ACTIONS(2944),
    [anon_sym_LT_LPAREN] = ACTIONS(2944),
    [anon_sym_GT_LPAREN] = ACTIONS(2944),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2946),
    [anon_sym_LF] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2946),
  },
  [1463] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4177),
    [sym_comment] = ACTIONS(57),
  },
  [1464] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4179),
    [sym_comment] = ACTIONS(57),
  },
  [1465] = {
    [anon_sym_RBRACE] = ACTIONS(4179),
    [sym_comment] = ACTIONS(57),
  },
  [1466] = {
    [sym_concatenation] = STATE(1825),
    [sym_string] = STATE(1824),
    [sym_simple_expansion] = STATE(1824),
    [sym_string_expansion] = STATE(1824),
    [sym_expansion] = STATE(1824),
    [sym_command_substitution] = STATE(1824),
    [sym_process_substitution] = STATE(1824),
    [anon_sym_RBRACE] = ACTIONS(4179),
    [sym__special_characters] = ACTIONS(4181),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(4183),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4183),
  },
  [1467] = {
    [sym__simple_heredoc_body] = ACTIONS(2980),
    [sym__heredoc_body_beginning] = ACTIONS(2980),
    [sym_file_descriptor] = ACTIONS(2980),
    [sym__concat] = ACTIONS(2980),
    [sym_variable_name] = ACTIONS(2980),
    [ts_builtin_sym_end] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym_PIPE] = ACTIONS(2982),
    [anon_sym_RPAREN] = ACTIONS(2980),
    [anon_sym_SEMI_SEMI] = ACTIONS(2980),
    [anon_sym_PIPE_AMP] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_PIPE_PIPE] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2982),
    [anon_sym_GT_GT] = ACTIONS(2980),
    [anon_sym_AMP_GT] = ACTIONS(2982),
    [anon_sym_AMP_GT_GT] = ACTIONS(2980),
    [anon_sym_LT_AMP] = ACTIONS(2980),
    [anon_sym_GT_AMP] = ACTIONS(2980),
    [anon_sym_LT_LT] = ACTIONS(2982),
    [anon_sym_LT_LT_DASH] = ACTIONS(2980),
    [anon_sym_LT_LT_LT] = ACTIONS(2980),
    [sym__special_characters] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2982),
    [sym_raw_string] = ACTIONS(2980),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2980),
    [anon_sym_BQUOTE] = ACTIONS(2980),
    [anon_sym_LT_LPAREN] = ACTIONS(2980),
    [anon_sym_GT_LPAREN] = ACTIONS(2980),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2982),
    [anon_sym_LF] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2982),
  },
  [1468] = {
    [sym_concatenation] = STATE(1828),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1828),
    [sym_regex] = ACTIONS(4185),
    [anon_sym_RBRACE] = ACTIONS(4187),
    [anon_sym_EQ] = ACTIONS(4189),
    [anon_sym_DASH] = ACTIONS(4189),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4189),
    [anon_sym_COLON_QMARK] = ACTIONS(4189),
    [anon_sym_COLON_DASH] = ACTIONS(4189),
    [anon_sym_PERCENT] = ACTIONS(4189),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1469] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4187),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1470] = {
    [sym_concatenation] = STATE(1830),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1830),
    [sym_regex] = ACTIONS(4193),
    [anon_sym_RBRACE] = ACTIONS(4179),
    [anon_sym_EQ] = ACTIONS(4195),
    [anon_sym_DASH] = ACTIONS(4195),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4195),
    [anon_sym_COLON_QMARK] = ACTIONS(4195),
    [anon_sym_COLON_DASH] = ACTIONS(4195),
    [anon_sym_PERCENT] = ACTIONS(4195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1471] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4179),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1472] = {
    [sym_concatenation] = STATE(1832),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1832),
    [anon_sym_RBRACE] = ACTIONS(4199),
    [anon_sym_EQ] = ACTIONS(4201),
    [anon_sym_DASH] = ACTIONS(4201),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4203),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4201),
    [anon_sym_COLON_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_DASH] = ACTIONS(4201),
    [anon_sym_PERCENT] = ACTIONS(4201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1473] = {
    [sym__simple_heredoc_body] = ACTIONS(3036),
    [sym__heredoc_body_beginning] = ACTIONS(3036),
    [sym_file_descriptor] = ACTIONS(3036),
    [sym__concat] = ACTIONS(3036),
    [sym_variable_name] = ACTIONS(3036),
    [ts_builtin_sym_end] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym_PIPE] = ACTIONS(3038),
    [anon_sym_RPAREN] = ACTIONS(3036),
    [anon_sym_SEMI_SEMI] = ACTIONS(3036),
    [anon_sym_PIPE_AMP] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_PIPE_PIPE] = ACTIONS(3036),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_GT] = ACTIONS(3038),
    [anon_sym_GT_GT] = ACTIONS(3036),
    [anon_sym_AMP_GT] = ACTIONS(3038),
    [anon_sym_AMP_GT_GT] = ACTIONS(3036),
    [anon_sym_LT_AMP] = ACTIONS(3036),
    [anon_sym_GT_AMP] = ACTIONS(3036),
    [anon_sym_LT_LT] = ACTIONS(3038),
    [anon_sym_LT_LT_DASH] = ACTIONS(3036),
    [anon_sym_LT_LT_LT] = ACTIONS(3036),
    [sym__special_characters] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [anon_sym_DOLLAR] = ACTIONS(3038),
    [sym_raw_string] = ACTIONS(3036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3036),
    [anon_sym_BQUOTE] = ACTIONS(3036),
    [anon_sym_LT_LPAREN] = ACTIONS(3036),
    [anon_sym_GT_LPAREN] = ACTIONS(3036),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3038),
    [anon_sym_LF] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3038),
  },
  [1474] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4199),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1475] = {
    [sym_concatenation] = STATE(1830),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1830),
    [anon_sym_RBRACE] = ACTIONS(4179),
    [anon_sym_EQ] = ACTIONS(4195),
    [anon_sym_DASH] = ACTIONS(4195),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4195),
    [anon_sym_COLON_QMARK] = ACTIONS(4195),
    [anon_sym_COLON_DASH] = ACTIONS(4195),
    [anon_sym_PERCENT] = ACTIONS(4195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1476] = {
    [sym__simple_heredoc_body] = ACTIONS(3091),
    [sym__heredoc_body_beginning] = ACTIONS(3091),
    [sym_file_descriptor] = ACTIONS(3091),
    [sym__concat] = ACTIONS(3091),
    [sym_variable_name] = ACTIONS(3091),
    [ts_builtin_sym_end] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_PIPE] = ACTIONS(3093),
    [anon_sym_RPAREN] = ACTIONS(3091),
    [anon_sym_SEMI_SEMI] = ACTIONS(3091),
    [anon_sym_PIPE_AMP] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_GT] = ACTIONS(3093),
    [anon_sym_GT_GT] = ACTIONS(3091),
    [anon_sym_AMP_GT] = ACTIONS(3093),
    [anon_sym_AMP_GT_GT] = ACTIONS(3091),
    [anon_sym_LT_AMP] = ACTIONS(3091),
    [anon_sym_GT_AMP] = ACTIONS(3091),
    [anon_sym_LT_LT] = ACTIONS(3093),
    [anon_sym_LT_LT_DASH] = ACTIONS(3091),
    [anon_sym_LT_LT_LT] = ACTIONS(3091),
    [sym__special_characters] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_DOLLAR] = ACTIONS(3093),
    [sym_raw_string] = ACTIONS(3091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3091),
    [anon_sym_BQUOTE] = ACTIONS(3091),
    [anon_sym_LT_LPAREN] = ACTIONS(3091),
    [anon_sym_GT_LPAREN] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3093),
    [anon_sym_LF] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3093),
  },
  [1477] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4205),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1478] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4205),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1479] = {
    [anon_sym_SEMI] = ACTIONS(4207),
    [anon_sym_RPAREN] = ACTIONS(4205),
    [anon_sym_SEMI_SEMI] = ACTIONS(4209),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4209),
    [anon_sym_AMP] = ACTIONS(4209),
  },
  [1480] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(4205),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1481] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(4205),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1482] = {
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_SEMI_SEMI] = ACTIONS(4213),
    [anon_sym_BQUOTE] = ACTIONS(4205),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4213),
    [anon_sym_AMP] = ACTIONS(4213),
  },
  [1483] = {
    [sym__simple_heredoc_body] = ACTIONS(3121),
    [sym__heredoc_body_beginning] = ACTIONS(3121),
    [sym_file_descriptor] = ACTIONS(3121),
    [sym__concat] = ACTIONS(3121),
    [sym_variable_name] = ACTIONS(3121),
    [ts_builtin_sym_end] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3123),
    [anon_sym_RPAREN] = ACTIONS(3121),
    [anon_sym_SEMI_SEMI] = ACTIONS(3121),
    [anon_sym_PIPE_AMP] = ACTIONS(3121),
    [anon_sym_AMP_AMP] = ACTIONS(3121),
    [anon_sym_PIPE_PIPE] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_GT] = ACTIONS(3123),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_AMP_GT] = ACTIONS(3123),
    [anon_sym_AMP_GT_GT] = ACTIONS(3121),
    [anon_sym_LT_AMP] = ACTIONS(3121),
    [anon_sym_GT_AMP] = ACTIONS(3121),
    [anon_sym_LT_LT] = ACTIONS(3123),
    [anon_sym_LT_LT_DASH] = ACTIONS(3121),
    [anon_sym_LT_LT_LT] = ACTIONS(3121),
    [sym__special_characters] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [sym_raw_string] = ACTIONS(3121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3121),
    [anon_sym_BQUOTE] = ACTIONS(3121),
    [anon_sym_LT_LPAREN] = ACTIONS(3121),
    [anon_sym_GT_LPAREN] = ACTIONS(3121),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3123),
    [anon_sym_LF] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
  },
  [1484] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4215),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1485] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4215),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1486] = {
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(4215),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4219),
  },
  [1487] = {
    [sym_do_group] = STATE(1838),
    [sym_compound_statement] = STATE(1838),
    [anon_sym_do] = ACTIONS(493),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [1488] = {
    [sym__simple_heredoc_body] = ACTIONS(4221),
    [sym__heredoc_body_beginning] = ACTIONS(4221),
    [sym_file_descriptor] = ACTIONS(4221),
    [ts_builtin_sym_end] = ACTIONS(4221),
    [anon_sym_SEMI] = ACTIONS(4223),
    [anon_sym_esac] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4223),
    [anon_sym_RPAREN] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4221),
    [anon_sym_PIPE_AMP] = ACTIONS(4221),
    [anon_sym_AMP_AMP] = ACTIONS(4221),
    [anon_sym_PIPE_PIPE] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4223),
    [anon_sym_GT] = ACTIONS(4223),
    [anon_sym_GT_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT] = ACTIONS(4223),
    [anon_sym_AMP_GT_GT] = ACTIONS(4221),
    [anon_sym_LT_AMP] = ACTIONS(4221),
    [anon_sym_GT_AMP] = ACTIONS(4221),
    [anon_sym_LT_LT] = ACTIONS(4223),
    [anon_sym_LT_LT_DASH] = ACTIONS(4221),
    [anon_sym_LT_LT_LT] = ACTIONS(4221),
    [anon_sym_BQUOTE] = ACTIONS(4221),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4221),
    [anon_sym_AMP] = ACTIONS(4223),
  },
  [1489] = {
    [sym_do_group] = STATE(1838),
    [sym_compound_statement] = STATE(1838),
    [anon_sym_SEMI] = ACTIONS(4225),
    [anon_sym_do] = ACTIONS(493),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [1490] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4227),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE_PIPE] = ACTIONS(465),
    [anon_sym_EQ_TILDE] = ACTIONS(467),
    [anon_sym_EQ_EQ] = ACTIONS(467),
    [anon_sym_EQ] = ACTIONS(469),
    [anon_sym_PLUS_EQ] = ACTIONS(465),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_BANG_EQ] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(469),
    [anon_sym_DASH] = ACTIONS(469),
    [anon_sym_DASH_EQ] = ACTIONS(465),
    [anon_sym_LT_EQ] = ACTIONS(465),
    [anon_sym_GT_EQ] = ACTIONS(465),
    [anon_sym_PLUS_PLUS] = ACTIONS(471),
    [anon_sym_DASH_DASH] = ACTIONS(471),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(465),
  },
  [1491] = {
    [sym__concat] = ACTIONS(2930),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym_SEMI_SEMI] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_EQ_TILDE] = ACTIONS(2930),
    [anon_sym_EQ_EQ] = ACTIONS(2930),
    [anon_sym_EQ] = ACTIONS(2932),
    [anon_sym_PLUS_EQ] = ACTIONS(2930),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2932),
    [anon_sym_BANG_EQ] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2932),
    [anon_sym_DASH_EQ] = ACTIONS(2930),
    [anon_sym_LT_EQ] = ACTIONS(2930),
    [anon_sym_GT_EQ] = ACTIONS(2930),
    [anon_sym_PLUS_PLUS] = ACTIONS(2930),
    [anon_sym_DASH_DASH] = ACTIONS(2930),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2930),
    [anon_sym_LF] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2932),
  },
  [1492] = {
    [sym__concat] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym_SEMI_SEMI] = ACTIONS(2944),
    [anon_sym_AMP_AMP] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2944),
    [anon_sym_EQ_TILDE] = ACTIONS(2944),
    [anon_sym_EQ_EQ] = ACTIONS(2944),
    [anon_sym_EQ] = ACTIONS(2946),
    [anon_sym_PLUS_EQ] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2944),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_DASH_EQ] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2944),
    [anon_sym_GT_EQ] = ACTIONS(2944),
    [anon_sym_PLUS_PLUS] = ACTIONS(2944),
    [anon_sym_DASH_DASH] = ACTIONS(2944),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2944),
    [anon_sym_LF] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2946),
  },
  [1493] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4229),
    [sym_comment] = ACTIONS(57),
  },
  [1494] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4231),
    [sym_comment] = ACTIONS(57),
  },
  [1495] = {
    [anon_sym_RBRACE] = ACTIONS(4231),
    [sym_comment] = ACTIONS(57),
  },
  [1496] = {
    [sym_concatenation] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_simple_expansion] = STATE(1844),
    [sym_string_expansion] = STATE(1844),
    [sym_expansion] = STATE(1844),
    [sym_command_substitution] = STATE(1844),
    [sym_process_substitution] = STATE(1844),
    [anon_sym_RBRACE] = ACTIONS(4231),
    [sym__special_characters] = ACTIONS(4233),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(4235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4235),
  },
  [1497] = {
    [sym__concat] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym_SEMI_SEMI] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_PIPE_PIPE] = ACTIONS(2980),
    [anon_sym_EQ_TILDE] = ACTIONS(2980),
    [anon_sym_EQ_EQ] = ACTIONS(2980),
    [anon_sym_EQ] = ACTIONS(2982),
    [anon_sym_PLUS_EQ] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2982),
    [anon_sym_BANG_EQ] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2982),
    [anon_sym_DASH] = ACTIONS(2982),
    [anon_sym_DASH_EQ] = ACTIONS(2980),
    [anon_sym_LT_EQ] = ACTIONS(2980),
    [anon_sym_GT_EQ] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2980),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2980),
    [anon_sym_LF] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2982),
  },
  [1498] = {
    [sym_concatenation] = STATE(1848),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1848),
    [sym_regex] = ACTIONS(4237),
    [anon_sym_RBRACE] = ACTIONS(4239),
    [anon_sym_EQ] = ACTIONS(4241),
    [anon_sym_DASH] = ACTIONS(4241),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4243),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4241),
    [anon_sym_COLON_QMARK] = ACTIONS(4241),
    [anon_sym_COLON_DASH] = ACTIONS(4241),
    [anon_sym_PERCENT] = ACTIONS(4241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1499] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4239),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1500] = {
    [sym_concatenation] = STATE(1850),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1850),
    [sym_regex] = ACTIONS(4245),
    [anon_sym_RBRACE] = ACTIONS(4231),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_DASH] = ACTIONS(4247),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4247),
    [anon_sym_COLON_QMARK] = ACTIONS(4247),
    [anon_sym_COLON_DASH] = ACTIONS(4247),
    [anon_sym_PERCENT] = ACTIONS(4247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1501] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4231),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1502] = {
    [sym_concatenation] = STATE(1852),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1852),
    [anon_sym_RBRACE] = ACTIONS(4251),
    [anon_sym_EQ] = ACTIONS(4253),
    [anon_sym_DASH] = ACTIONS(4253),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4255),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4253),
    [anon_sym_COLON_QMARK] = ACTIONS(4253),
    [anon_sym_COLON_DASH] = ACTIONS(4253),
    [anon_sym_PERCENT] = ACTIONS(4253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1503] = {
    [sym__concat] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym_SEMI_SEMI] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_PIPE_PIPE] = ACTIONS(3036),
    [anon_sym_EQ_TILDE] = ACTIONS(3036),
    [anon_sym_EQ_EQ] = ACTIONS(3036),
    [anon_sym_EQ] = ACTIONS(3038),
    [anon_sym_PLUS_EQ] = ACTIONS(3036),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_GT] = ACTIONS(3038),
    [anon_sym_BANG_EQ] = ACTIONS(3036),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_DASH_EQ] = ACTIONS(3036),
    [anon_sym_LT_EQ] = ACTIONS(3036),
    [anon_sym_GT_EQ] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3036),
    [anon_sym_LF] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3038),
  },
  [1504] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4251),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1505] = {
    [sym_concatenation] = STATE(1850),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1850),
    [anon_sym_RBRACE] = ACTIONS(4231),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_DASH] = ACTIONS(4247),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4247),
    [anon_sym_COLON_QMARK] = ACTIONS(4247),
    [anon_sym_COLON_DASH] = ACTIONS(4247),
    [anon_sym_PERCENT] = ACTIONS(4247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1506] = {
    [sym__concat] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_SEMI_SEMI] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_EQ_TILDE] = ACTIONS(3091),
    [anon_sym_EQ_EQ] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_PLUS_EQ] = ACTIONS(3091),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_GT] = ACTIONS(3093),
    [anon_sym_BANG_EQ] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3093),
    [anon_sym_DASH] = ACTIONS(3093),
    [anon_sym_DASH_EQ] = ACTIONS(3091),
    [anon_sym_LT_EQ] = ACTIONS(3091),
    [anon_sym_GT_EQ] = ACTIONS(3091),
    [anon_sym_PLUS_PLUS] = ACTIONS(3091),
    [anon_sym_DASH_DASH] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3091),
    [anon_sym_LF] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3093),
  },
  [1507] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4257),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1508] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4257),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1509] = {
    [anon_sym_SEMI] = ACTIONS(4259),
    [anon_sym_RPAREN] = ACTIONS(4257),
    [anon_sym_SEMI_SEMI] = ACTIONS(4261),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4261),
    [anon_sym_AMP] = ACTIONS(4261),
  },
  [1510] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(4257),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1511] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(4257),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1512] = {
    [anon_sym_SEMI] = ACTIONS(4263),
    [anon_sym_SEMI_SEMI] = ACTIONS(4265),
    [anon_sym_BQUOTE] = ACTIONS(4257),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4265),
    [anon_sym_AMP] = ACTIONS(4265),
  },
  [1513] = {
    [sym__concat] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3123),
    [anon_sym_SEMI_SEMI] = ACTIONS(3121),
    [anon_sym_AMP_AMP] = ACTIONS(3121),
    [anon_sym_PIPE_PIPE] = ACTIONS(3121),
    [anon_sym_EQ_TILDE] = ACTIONS(3121),
    [anon_sym_EQ_EQ] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(3123),
    [anon_sym_PLUS_EQ] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_GT] = ACTIONS(3123),
    [anon_sym_BANG_EQ] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_DASH_EQ] = ACTIONS(3121),
    [anon_sym_LT_EQ] = ACTIONS(3121),
    [anon_sym_GT_EQ] = ACTIONS(3121),
    [anon_sym_PLUS_PLUS] = ACTIONS(3121),
    [anon_sym_DASH_DASH] = ACTIONS(3121),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3121),
    [anon_sym_LF] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
  },
  [1514] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4267),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1515] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4267),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1516] = {
    [anon_sym_SEMI] = ACTIONS(4269),
    [anon_sym_RPAREN] = ACTIONS(4267),
    [anon_sym_SEMI_SEMI] = ACTIONS(4271),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4271),
    [anon_sym_AMP] = ACTIONS(4271),
  },
  [1517] = {
    [sym__expression] = STATE(1858),
    [sym_binary_expression] = STATE(1858),
    [sym_unary_expression] = STATE(1858),
    [sym_postfix_expression] = STATE(1858),
    [sym_parenthesized_expression] = STATE(1858),
    [sym_concatenation] = STATE(1858),
    [sym_string] = STATE(45),
    [sym_simple_expansion] = STATE(45),
    [sym_string_expansion] = STATE(45),
    [sym_expansion] = STATE(45),
    [sym_command_substitution] = STATE(45),
    [sym_process_substitution] = STATE(45),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4227),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [1518] = {
    [sym__concat] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [1519] = {
    [aux_sym_concatenation_repeat1] = STATE(1519),
    [sym__concat] = ACTIONS(4273),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [1520] = {
    [sym__concat] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_SEMI_SEMI] = ACTIONS(1733),
    [sym__special_characters] = ACTIONS(1733),
    [anon_sym_DQUOTE] = ACTIONS(1733),
    [anon_sym_DOLLAR] = ACTIONS(1735),
    [sym_raw_string] = ACTIONS(1733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1733),
    [anon_sym_BQUOTE] = ACTIONS(1733),
    [anon_sym_LT_LPAREN] = ACTIONS(1733),
    [anon_sym_GT_LPAREN] = ACTIONS(1733),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1735),
    [anon_sym_LF] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
  },
  [1521] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(4276),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [1522] = {
    [sym_concatenation] = STATE(1863),
    [sym_string] = STATE(1862),
    [sym_simple_expansion] = STATE(1862),
    [sym_string_expansion] = STATE(1862),
    [sym_expansion] = STATE(1862),
    [sym_command_substitution] = STATE(1862),
    [sym_process_substitution] = STATE(1862),
    [anon_sym_RBRACE] = ACTIONS(4278),
    [sym__special_characters] = ACTIONS(4280),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(4282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4282),
  },
  [1523] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(4284),
    [sym_comment] = ACTIONS(57),
  },
  [1524] = {
    [sym_concatenation] = STATE(1867),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1867),
    [anon_sym_RBRACE] = ACTIONS(4286),
    [anon_sym_EQ] = ACTIONS(4288),
    [anon_sym_DASH] = ACTIONS(4288),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4290),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(4292),
    [anon_sym_COLON] = ACTIONS(4288),
    [anon_sym_COLON_QMARK] = ACTIONS(4288),
    [anon_sym_COLON_DASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1525] = {
    [sym_concatenation] = STATE(1869),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1869),
    [anon_sym_RBRACE] = ACTIONS(4278),
    [anon_sym_EQ] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4296),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(4298),
    [anon_sym_COLON] = ACTIONS(4294),
    [anon_sym_COLON_QMARK] = ACTIONS(4294),
    [anon_sym_COLON_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4294),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1526] = {
    [sym__concat] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1836),
    [anon_sym_SEMI_SEMI] = ACTIONS(1834),
    [sym__special_characters] = ACTIONS(1834),
    [anon_sym_DQUOTE] = ACTIONS(1834),
    [anon_sym_DOLLAR] = ACTIONS(1836),
    [sym_raw_string] = ACTIONS(1834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1834),
    [anon_sym_BQUOTE] = ACTIONS(1834),
    [anon_sym_LT_LPAREN] = ACTIONS(1834),
    [anon_sym_GT_LPAREN] = ACTIONS(1834),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1836),
    [anon_sym_LF] = ACTIONS(1834),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [1527] = {
    [sym_concatenation] = STATE(1872),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1872),
    [sym_regex] = ACTIONS(4300),
    [anon_sym_RBRACE] = ACTIONS(4302),
    [anon_sym_EQ] = ACTIONS(4304),
    [anon_sym_DASH] = ACTIONS(4304),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4304),
    [anon_sym_COLON_QMARK] = ACTIONS(4304),
    [anon_sym_COLON_DASH] = ACTIONS(4304),
    [anon_sym_PERCENT] = ACTIONS(4304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1528] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4302),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1529] = {
    [sym__concat] = ACTIONS(1882),
    [anon_sym_SEMI] = ACTIONS(1884),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [sym__special_characters] = ACTIONS(1882),
    [anon_sym_DQUOTE] = ACTIONS(1882),
    [anon_sym_DOLLAR] = ACTIONS(1884),
    [sym_raw_string] = ACTIONS(1882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1882),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [anon_sym_LT_LPAREN] = ACTIONS(1882),
    [anon_sym_GT_LPAREN] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1884),
    [anon_sym_LF] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1882),
  },
  [1530] = {
    [sym_concatenation] = STATE(1869),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1869),
    [sym_regex] = ACTIONS(4308),
    [anon_sym_RBRACE] = ACTIONS(4278),
    [anon_sym_EQ] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4296),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4294),
    [anon_sym_COLON_QMARK] = ACTIONS(4294),
    [anon_sym_COLON_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4294),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1531] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4278),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1532] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4310),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1533] = {
    [sym__concat] = ACTIONS(1890),
    [anon_sym_SEMI] = ACTIONS(1892),
    [anon_sym_SEMI_SEMI] = ACTIONS(1890),
    [sym__special_characters] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1890),
    [anon_sym_DOLLAR] = ACTIONS(1892),
    [sym_raw_string] = ACTIONS(1890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1890),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [anon_sym_LT_LPAREN] = ACTIONS(1890),
    [anon_sym_GT_LPAREN] = ACTIONS(1890),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1892),
    [anon_sym_LF] = ACTIONS(1890),
    [anon_sym_AMP] = ACTIONS(1890),
  },
  [1534] = {
    [anon_sym_SEMI] = ACTIONS(4312),
    [anon_sym_RPAREN] = ACTIONS(4310),
    [anon_sym_SEMI_SEMI] = ACTIONS(4314),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4314),
    [anon_sym_AMP] = ACTIONS(4314),
  },
  [1535] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1877),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(4316),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(4310),
    [anon_sym_SEMI_SEMI] = ACTIONS(4318),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4318),
    [anon_sym_AMP] = ACTIONS(4316),
  },
  [1536] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1877),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(4316),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(4310),
    [anon_sym_SEMI_SEMI] = ACTIONS(4318),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(4318),
    [anon_sym_AMP] = ACTIONS(4316),
  },
  [1537] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(4310),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1538] = {
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_SEMI_SEMI] = ACTIONS(4322),
    [anon_sym_BQUOTE] = ACTIONS(4310),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4322),
    [anon_sym_AMP] = ACTIONS(4322),
  },
  [1539] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1880),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(4324),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(4326),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(4310),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4326),
    [anon_sym_AMP] = ACTIONS(4324),
  },
  [1540] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(1880),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(4324),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(4326),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(4310),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(4326),
    [anon_sym_AMP] = ACTIONS(4324),
  },
  [1541] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4328),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1542] = {
    [sym__concat] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [sym__special_characters] = ACTIONS(1924),
    [anon_sym_DQUOTE] = ACTIONS(1924),
    [anon_sym_DOLLAR] = ACTIONS(1926),
    [sym_raw_string] = ACTIONS(1924),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1924),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1924),
    [anon_sym_BQUOTE] = ACTIONS(1924),
    [anon_sym_LT_LPAREN] = ACTIONS(1924),
    [anon_sym_GT_LPAREN] = ACTIONS(1924),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1926),
    [anon_sym_LF] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1924),
  },
  [1543] = {
    [anon_sym_SEMI] = ACTIONS(4330),
    [anon_sym_RPAREN] = ACTIONS(4328),
    [anon_sym_SEMI_SEMI] = ACTIONS(4332),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4332),
    [anon_sym_AMP] = ACTIONS(4332),
  },
  [1544] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1884),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(4334),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(4328),
    [anon_sym_SEMI_SEMI] = ACTIONS(4336),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4334),
  },
  [1545] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(1884),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(4334),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(4328),
    [anon_sym_SEMI_SEMI] = ACTIONS(4336),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4334),
  },
  [1546] = {
    [sym__simple_heredoc_body] = ACTIONS(4338),
    [sym__heredoc_body_beginning] = ACTIONS(4338),
    [sym_file_descriptor] = ACTIONS(4338),
    [ts_builtin_sym_end] = ACTIONS(4338),
    [anon_sym_SEMI] = ACTIONS(4340),
    [anon_sym_esac] = ACTIONS(4338),
    [anon_sym_PIPE] = ACTIONS(4340),
    [anon_sym_RPAREN] = ACTIONS(4338),
    [anon_sym_SEMI_SEMI] = ACTIONS(4338),
    [anon_sym_PIPE_AMP] = ACTIONS(4338),
    [anon_sym_AMP_AMP] = ACTIONS(4338),
    [anon_sym_PIPE_PIPE] = ACTIONS(4338),
    [anon_sym_LT] = ACTIONS(4340),
    [anon_sym_GT] = ACTIONS(4340),
    [anon_sym_GT_GT] = ACTIONS(4338),
    [anon_sym_AMP_GT] = ACTIONS(4340),
    [anon_sym_AMP_GT_GT] = ACTIONS(4338),
    [anon_sym_LT_AMP] = ACTIONS(4338),
    [anon_sym_GT_AMP] = ACTIONS(4338),
    [anon_sym_LT_LT] = ACTIONS(4340),
    [anon_sym_LT_LT_DASH] = ACTIONS(4338),
    [anon_sym_LT_LT_LT] = ACTIONS(4338),
    [anon_sym_BQUOTE] = ACTIONS(4338),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4338),
    [anon_sym_AMP] = ACTIONS(4340),
  },
  [1547] = {
    [sym__concat] = ACTIONS(2930),
    [anon_sym_PIPE] = ACTIONS(2932),
    [anon_sym_RPAREN] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_EQ_TILDE] = ACTIONS(2930),
    [anon_sym_EQ_EQ] = ACTIONS(2930),
    [anon_sym_EQ] = ACTIONS(2932),
    [anon_sym_PLUS_EQ] = ACTIONS(2930),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2932),
    [anon_sym_BANG_EQ] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2932),
    [anon_sym_DASH_EQ] = ACTIONS(2930),
    [anon_sym_LT_EQ] = ACTIONS(2930),
    [anon_sym_GT_EQ] = ACTIONS(2930),
    [anon_sym_PLUS_PLUS] = ACTIONS(2930),
    [anon_sym_DASH_DASH] = ACTIONS(2930),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2930),
  },
  [1548] = {
    [sym__concat] = ACTIONS(2944),
    [anon_sym_PIPE] = ACTIONS(2946),
    [anon_sym_RPAREN] = ACTIONS(2944),
    [anon_sym_AMP_AMP] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2944),
    [anon_sym_EQ_TILDE] = ACTIONS(2944),
    [anon_sym_EQ_EQ] = ACTIONS(2944),
    [anon_sym_EQ] = ACTIONS(2946),
    [anon_sym_PLUS_EQ] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2944),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_DASH_EQ] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2944),
    [anon_sym_GT_EQ] = ACTIONS(2944),
    [anon_sym_PLUS_PLUS] = ACTIONS(2944),
    [anon_sym_DASH_DASH] = ACTIONS(2944),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2944),
  },
  [1549] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4342),
    [sym_comment] = ACTIONS(57),
  },
  [1550] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4344),
    [sym_comment] = ACTIONS(57),
  },
  [1551] = {
    [anon_sym_RBRACE] = ACTIONS(4344),
    [sym_comment] = ACTIONS(57),
  },
  [1552] = {
    [sym_concatenation] = STATE(1889),
    [sym_string] = STATE(1888),
    [sym_simple_expansion] = STATE(1888),
    [sym_string_expansion] = STATE(1888),
    [sym_expansion] = STATE(1888),
    [sym_command_substitution] = STATE(1888),
    [sym_process_substitution] = STATE(1888),
    [anon_sym_RBRACE] = ACTIONS(4344),
    [sym__special_characters] = ACTIONS(4346),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(4348),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4348),
  },
  [1553] = {
    [sym__concat] = ACTIONS(2980),
    [anon_sym_PIPE] = ACTIONS(2982),
    [anon_sym_RPAREN] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_PIPE_PIPE] = ACTIONS(2980),
    [anon_sym_EQ_TILDE] = ACTIONS(2980),
    [anon_sym_EQ_EQ] = ACTIONS(2980),
    [anon_sym_EQ] = ACTIONS(2982),
    [anon_sym_PLUS_EQ] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2982),
    [anon_sym_BANG_EQ] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2982),
    [anon_sym_DASH] = ACTIONS(2982),
    [anon_sym_DASH_EQ] = ACTIONS(2980),
    [anon_sym_LT_EQ] = ACTIONS(2980),
    [anon_sym_GT_EQ] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2980),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2980),
  },
  [1554] = {
    [sym_concatenation] = STATE(1892),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1892),
    [sym_regex] = ACTIONS(4350),
    [anon_sym_RBRACE] = ACTIONS(4352),
    [anon_sym_EQ] = ACTIONS(4354),
    [anon_sym_DASH] = ACTIONS(4354),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4354),
    [anon_sym_COLON_QMARK] = ACTIONS(4354),
    [anon_sym_COLON_DASH] = ACTIONS(4354),
    [anon_sym_PERCENT] = ACTIONS(4354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1555] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4352),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1556] = {
    [sym_concatenation] = STATE(1894),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1894),
    [sym_regex] = ACTIONS(4358),
    [anon_sym_RBRACE] = ACTIONS(4344),
    [anon_sym_EQ] = ACTIONS(4360),
    [anon_sym_DASH] = ACTIONS(4360),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4360),
    [anon_sym_COLON_QMARK] = ACTIONS(4360),
    [anon_sym_COLON_DASH] = ACTIONS(4360),
    [anon_sym_PERCENT] = ACTIONS(4360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1557] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4344),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1558] = {
    [sym_concatenation] = STATE(1896),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1896),
    [anon_sym_RBRACE] = ACTIONS(4364),
    [anon_sym_EQ] = ACTIONS(4366),
    [anon_sym_DASH] = ACTIONS(4366),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4368),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4366),
    [anon_sym_COLON_QMARK] = ACTIONS(4366),
    [anon_sym_COLON_DASH] = ACTIONS(4366),
    [anon_sym_PERCENT] = ACTIONS(4366),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1559] = {
    [sym__concat] = ACTIONS(3036),
    [anon_sym_PIPE] = ACTIONS(3038),
    [anon_sym_RPAREN] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_PIPE_PIPE] = ACTIONS(3036),
    [anon_sym_EQ_TILDE] = ACTIONS(3036),
    [anon_sym_EQ_EQ] = ACTIONS(3036),
    [anon_sym_EQ] = ACTIONS(3038),
    [anon_sym_PLUS_EQ] = ACTIONS(3036),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_GT] = ACTIONS(3038),
    [anon_sym_BANG_EQ] = ACTIONS(3036),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_DASH_EQ] = ACTIONS(3036),
    [anon_sym_LT_EQ] = ACTIONS(3036),
    [anon_sym_GT_EQ] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3036),
  },
  [1560] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4364),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1561] = {
    [sym_concatenation] = STATE(1894),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1894),
    [anon_sym_RBRACE] = ACTIONS(4344),
    [anon_sym_EQ] = ACTIONS(4360),
    [anon_sym_DASH] = ACTIONS(4360),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4360),
    [anon_sym_COLON_QMARK] = ACTIONS(4360),
    [anon_sym_COLON_DASH] = ACTIONS(4360),
    [anon_sym_PERCENT] = ACTIONS(4360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1562] = {
    [sym__concat] = ACTIONS(3091),
    [anon_sym_PIPE] = ACTIONS(3093),
    [anon_sym_RPAREN] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_EQ_TILDE] = ACTIONS(3091),
    [anon_sym_EQ_EQ] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_PLUS_EQ] = ACTIONS(3091),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_GT] = ACTIONS(3093),
    [anon_sym_BANG_EQ] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3093),
    [anon_sym_DASH] = ACTIONS(3093),
    [anon_sym_DASH_EQ] = ACTIONS(3091),
    [anon_sym_LT_EQ] = ACTIONS(3091),
    [anon_sym_GT_EQ] = ACTIONS(3091),
    [anon_sym_PLUS_PLUS] = ACTIONS(3091),
    [anon_sym_DASH_DASH] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3091),
  },
  [1563] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4370),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1564] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4370),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1565] = {
    [anon_sym_SEMI] = ACTIONS(4372),
    [anon_sym_RPAREN] = ACTIONS(4370),
    [anon_sym_SEMI_SEMI] = ACTIONS(4374),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4374),
    [anon_sym_AMP] = ACTIONS(4374),
  },
  [1566] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(4370),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1567] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(4370),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1568] = {
    [anon_sym_SEMI] = ACTIONS(4376),
    [anon_sym_SEMI_SEMI] = ACTIONS(4378),
    [anon_sym_BQUOTE] = ACTIONS(4370),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4378),
    [anon_sym_AMP] = ACTIONS(4378),
  },
  [1569] = {
    [sym__concat] = ACTIONS(3121),
    [anon_sym_PIPE] = ACTIONS(3123),
    [anon_sym_RPAREN] = ACTIONS(3121),
    [anon_sym_AMP_AMP] = ACTIONS(3121),
    [anon_sym_PIPE_PIPE] = ACTIONS(3121),
    [anon_sym_EQ_TILDE] = ACTIONS(3121),
    [anon_sym_EQ_EQ] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(3123),
    [anon_sym_PLUS_EQ] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_GT] = ACTIONS(3123),
    [anon_sym_BANG_EQ] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_DASH_EQ] = ACTIONS(3121),
    [anon_sym_LT_EQ] = ACTIONS(3121),
    [anon_sym_GT_EQ] = ACTIONS(3121),
    [anon_sym_PLUS_PLUS] = ACTIONS(3121),
    [anon_sym_DASH_DASH] = ACTIONS(3121),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3121),
  },
  [1570] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4380),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1571] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4380),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1572] = {
    [anon_sym_SEMI] = ACTIONS(4382),
    [anon_sym_RPAREN] = ACTIONS(4380),
    [anon_sym_SEMI_SEMI] = ACTIONS(4384),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4384),
    [anon_sym_AMP] = ACTIONS(4384),
  },
  [1573] = {
    [sym__concat] = ACTIONS(3921),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3921),
    [anon_sym_EQ_TILDE] = ACTIONS(3921),
    [anon_sym_EQ_EQ] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_PLUS_EQ] = ACTIONS(3921),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_EQ] = ACTIONS(3921),
    [anon_sym_LT_EQ] = ACTIONS(3921),
    [anon_sym_GT_EQ] = ACTIONS(3921),
    [anon_sym_PLUS_PLUS] = ACTIONS(3921),
    [anon_sym_DASH_DASH] = ACTIONS(3921),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3921),
  },
  [1574] = {
    [sym__concat] = ACTIONS(3929),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3929),
    [anon_sym_EQ_TILDE] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_PLUS_EQ] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_DASH_EQ] = ACTIONS(3929),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3929),
    [anon_sym_DASH_DASH] = ACTIONS(3929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3929),
  },
  [1575] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4386),
    [sym_comment] = ACTIONS(57),
  },
  [1576] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4388),
    [sym_comment] = ACTIONS(57),
  },
  [1577] = {
    [anon_sym_RBRACE] = ACTIONS(4388),
    [sym_comment] = ACTIONS(57),
  },
  [1578] = {
    [sym_concatenation] = STATE(1905),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1905),
    [anon_sym_RBRACE] = ACTIONS(4390),
    [anon_sym_EQ] = ACTIONS(4392),
    [anon_sym_DASH] = ACTIONS(4392),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4394),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4392),
    [anon_sym_COLON_QMARK] = ACTIONS(4392),
    [anon_sym_COLON_DASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1579] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3985),
    [anon_sym_EQ_TILDE] = ACTIONS(3985),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_EQ] = ACTIONS(3987),
    [anon_sym_PLUS_EQ] = ACTIONS(3985),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_PLUS] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3987),
    [anon_sym_DASH_EQ] = ACTIONS(3985),
    [anon_sym_LT_EQ] = ACTIONS(3985),
    [anon_sym_GT_EQ] = ACTIONS(3985),
    [anon_sym_PLUS_PLUS] = ACTIONS(3985),
    [anon_sym_DASH_DASH] = ACTIONS(3985),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3985),
  },
  [1580] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4390),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1581] = {
    [sym_concatenation] = STATE(1906),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1906),
    [anon_sym_RBRACE] = ACTIONS(4388),
    [anon_sym_EQ] = ACTIONS(4396),
    [anon_sym_DASH] = ACTIONS(4396),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4396),
    [anon_sym_COLON_QMARK] = ACTIONS(4396),
    [anon_sym_COLON_DASH] = ACTIONS(4396),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1582] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4388),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1583] = {
    [sym__concat] = ACTIONS(4030),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4030),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4030),
    [anon_sym_EQ_TILDE] = ACTIONS(4030),
    [anon_sym_EQ_EQ] = ACTIONS(4030),
    [anon_sym_EQ] = ACTIONS(4032),
    [anon_sym_PLUS_EQ] = ACTIONS(4030),
    [anon_sym_LT] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(4032),
    [anon_sym_BANG_EQ] = ACTIONS(4030),
    [anon_sym_PLUS] = ACTIONS(4032),
    [anon_sym_DASH] = ACTIONS(4032),
    [anon_sym_DASH_EQ] = ACTIONS(4030),
    [anon_sym_LT_EQ] = ACTIONS(4030),
    [anon_sym_GT_EQ] = ACTIONS(4030),
    [anon_sym_PLUS_PLUS] = ACTIONS(4030),
    [anon_sym_DASH_DASH] = ACTIONS(4030),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4030),
  },
  [1584] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4400),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1585] = {
    [sym__concat] = ACTIONS(4064),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4064),
    [anon_sym_EQ_TILDE] = ACTIONS(4064),
    [anon_sym_EQ_EQ] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4066),
    [anon_sym_PLUS_EQ] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_DASH_EQ] = ACTIONS(4064),
    [anon_sym_LT_EQ] = ACTIONS(4064),
    [anon_sym_GT_EQ] = ACTIONS(4064),
    [anon_sym_PLUS_PLUS] = ACTIONS(4064),
    [anon_sym_DASH_DASH] = ACTIONS(4064),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4064),
  },
  [1586] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4402),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1587] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(4402),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1588] = {
    [sym__concat] = ACTIONS(4070),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4070),
    [anon_sym_PIPE_PIPE] = ACTIONS(4070),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4070),
    [anon_sym_EQ_TILDE] = ACTIONS(4070),
    [anon_sym_EQ_EQ] = ACTIONS(4070),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_PLUS_EQ] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_GT] = ACTIONS(4072),
    [anon_sym_BANG_EQ] = ACTIONS(4070),
    [anon_sym_PLUS] = ACTIONS(4072),
    [anon_sym_DASH] = ACTIONS(4072),
    [anon_sym_DASH_EQ] = ACTIONS(4070),
    [anon_sym_LT_EQ] = ACTIONS(4070),
    [anon_sym_GT_EQ] = ACTIONS(4070),
    [anon_sym_PLUS_PLUS] = ACTIONS(4070),
    [anon_sym_DASH_DASH] = ACTIONS(4070),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4070),
  },
  [1589] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4404),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1590] = {
    [aux_sym_concatenation_repeat1] = STATE(1590),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(3268),
    [sym_variable_name] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [1591] = {
    [aux_sym_concatenation_repeat1] = STATE(1591),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(1730),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [1592] = {
    [sym__terminated_statement] = STATE(1910),
    [sym_redirected_statement] = STATE(524),
    [sym_for_statement] = STATE(524),
    [sym_c_style_for_statement] = STATE(524),
    [sym_while_statement] = STATE(524),
    [sym_if_statement] = STATE(524),
    [sym_case_statement] = STATE(524),
    [sym_function_definition] = STATE(524),
    [sym_compound_statement] = STATE(524),
    [sym_subshell] = STATE(524),
    [sym_pipeline] = STATE(524),
    [sym_list] = STATE(524),
    [sym_negated_command] = STATE(524),
    [sym_test_command] = STATE(524),
    [sym_declaration_command] = STATE(524),
    [sym_unset_command] = STATE(524),
    [sym_command] = STATE(524),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(525),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(1910),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(4406),
    [anon_sym_elif] = ACTIONS(4406),
    [anon_sym_else] = ACTIONS(4406),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [1593] = {
    [sym__terminated_statement] = STATE(1593),
    [sym_redirected_statement] = STATE(524),
    [sym_for_statement] = STATE(524),
    [sym_c_style_for_statement] = STATE(524),
    [sym_while_statement] = STATE(524),
    [sym_if_statement] = STATE(524),
    [sym_case_statement] = STATE(524),
    [sym_function_definition] = STATE(524),
    [sym_compound_statement] = STATE(524),
    [sym_subshell] = STATE(524),
    [sym_pipeline] = STATE(524),
    [sym_list] = STATE(524),
    [sym_negated_command] = STATE(524),
    [sym_test_command] = STATE(524),
    [sym_declaration_command] = STATE(524),
    [sym_unset_command] = STATE(524),
    [sym_command] = STATE(524),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(525),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(1593),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(973),
    [sym_variable_name] = ACTIONS(976),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(982),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(988),
    [anon_sym_fi] = ACTIONS(3596),
    [anon_sym_case] = ACTIONS(991),
    [anon_sym_function] = ACTIONS(994),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(1000),
    [anon_sym_BANG] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1006),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1009),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_typeset] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_readonly] = ACTIONS(1012),
    [anon_sym_local] = ACTIONS(1012),
    [anon_sym_unset] = ACTIONS(1015),
    [anon_sym_unsetenv] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1018),
    [anon_sym_GT] = ACTIONS(1018),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1018),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [sym__special_characters] = ACTIONS(1024),
    [anon_sym_DQUOTE] = ACTIONS(1027),
    [anon_sym_DOLLAR] = ACTIONS(1030),
    [sym_raw_string] = ACTIONS(1033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1039),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LPAREN] = ACTIONS(1045),
    [anon_sym_GT_LPAREN] = ACTIONS(1045),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1048),
  },
  [1594] = {
    [sym__simple_heredoc_body] = ACTIONS(4408),
    [sym__heredoc_body_beginning] = ACTIONS(4408),
    [sym_file_descriptor] = ACTIONS(4408),
    [ts_builtin_sym_end] = ACTIONS(4408),
    [anon_sym_SEMI] = ACTIONS(4410),
    [anon_sym_esac] = ACTIONS(4408),
    [anon_sym_PIPE] = ACTIONS(4410),
    [anon_sym_RPAREN] = ACTIONS(4408),
    [anon_sym_SEMI_SEMI] = ACTIONS(4408),
    [anon_sym_PIPE_AMP] = ACTIONS(4408),
    [anon_sym_AMP_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4410),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_AMP_GT] = ACTIONS(4410),
    [anon_sym_AMP_GT_GT] = ACTIONS(4408),
    [anon_sym_LT_AMP] = ACTIONS(4408),
    [anon_sym_GT_AMP] = ACTIONS(4408),
    [anon_sym_LT_LT] = ACTIONS(4410),
    [anon_sym_LT_LT_DASH] = ACTIONS(4408),
    [anon_sym_LT_LT_LT] = ACTIONS(4408),
    [anon_sym_BQUOTE] = ACTIONS(4408),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4410),
  },
  [1595] = {
    [anon_sym_fi] = ACTIONS(4412),
    [sym_comment] = ACTIONS(57),
  },
  [1596] = {
    [sym_concatenation] = STATE(1914),
    [sym_string] = STATE(1913),
    [sym_simple_expansion] = STATE(1913),
    [sym_string_expansion] = STATE(1913),
    [sym_expansion] = STATE(1913),
    [sym_command_substitution] = STATE(1913),
    [sym_process_substitution] = STATE(1913),
    [sym__special_characters] = ACTIONS(4414),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [sym_raw_string] = ACTIONS(4416),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(421),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(425),
    [anon_sym_GT_LPAREN] = ACTIONS(425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4416),
  },
  [1597] = {
    [sym__terminated_statement] = STATE(1934),
    [sym_redirected_statement] = STATE(1929),
    [sym_for_statement] = STATE(1929),
    [sym_c_style_for_statement] = STATE(1929),
    [sym_while_statement] = STATE(1929),
    [sym_if_statement] = STATE(1929),
    [sym_case_statement] = STATE(1929),
    [sym_function_definition] = STATE(1929),
    [sym_compound_statement] = STATE(1929),
    [sym_subshell] = STATE(1929),
    [sym_pipeline] = STATE(1929),
    [sym_list] = STATE(1929),
    [sym_negated_command] = STATE(1929),
    [sym_test_command] = STATE(1929),
    [sym_declaration_command] = STATE(1929),
    [sym_unset_command] = STATE(1929),
    [sym_command] = STATE(1929),
    [sym_command_name] = STATE(1930),
    [sym_variable_assignment] = STATE(1931),
    [sym_subscript] = STATE(1932),
    [sym_file_redirect] = STATE(1935),
    [sym_concatenation] = STATE(1933),
    [sym_string] = STATE(1923),
    [sym_simple_expansion] = STATE(1923),
    [sym_string_expansion] = STATE(1923),
    [sym_expansion] = STATE(1923),
    [sym_command_substitution] = STATE(1923),
    [sym_process_substitution] = STATE(1923),
    [aux_sym__statements_repeat1] = STATE(1934),
    [aux_sym_command_repeat1] = STATE(1935),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4418),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(4420),
    [anon_sym_SEMI_SEMI] = ACTIONS(4422),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4426),
    [anon_sym_typeset] = ACTIONS(4426),
    [anon_sym_export] = ACTIONS(4426),
    [anon_sym_readonly] = ACTIONS(4426),
    [anon_sym_local] = ACTIONS(4426),
    [anon_sym_unset] = ACTIONS(4428),
    [anon_sym_unsetenv] = ACTIONS(4428),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(4430),
    [anon_sym_DQUOTE] = ACTIONS(4432),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [sym_raw_string] = ACTIONS(4436),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_LT_LPAREN] = ACTIONS(4444),
    [anon_sym_GT_LPAREN] = ACTIONS(4444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4446),
  },
  [1598] = {
    [aux_sym_case_item_repeat1] = STATE(1937),
    [anon_sym_PIPE] = ACTIONS(3617),
    [anon_sym_RPAREN] = ACTIONS(4448),
    [sym_comment] = ACTIONS(57),
  },
  [1599] = {
    [aux_sym_concatenation_repeat1] = STATE(1938),
    [sym__concat] = ACTIONS(1191),
    [anon_sym_PIPE] = ACTIONS(779),
    [anon_sym_RPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
  },
  [1600] = {
    [sym__terminated_statement] = STATE(1942),
    [sym_redirected_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_c_style_for_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_case_statement] = STATE(1940),
    [sym_function_definition] = STATE(1940),
    [sym_compound_statement] = STATE(1940),
    [sym_subshell] = STATE(1940),
    [sym_pipeline] = STATE(1940),
    [sym_list] = STATE(1940),
    [sym_negated_command] = STATE(1940),
    [sym_test_command] = STATE(1940),
    [sym_declaration_command] = STATE(1940),
    [sym_unset_command] = STATE(1940),
    [sym_command] = STATE(1940),
    [sym_command_name] = STATE(1930),
    [sym_variable_assignment] = STATE(1941),
    [sym_subscript] = STATE(1932),
    [sym_file_redirect] = STATE(1935),
    [sym_concatenation] = STATE(1933),
    [sym_string] = STATE(1923),
    [sym_simple_expansion] = STATE(1923),
    [sym_string_expansion] = STATE(1923),
    [sym_expansion] = STATE(1923),
    [sym_command_substitution] = STATE(1923),
    [sym_process_substitution] = STATE(1923),
    [aux_sym__statements_repeat1] = STATE(1942),
    [aux_sym_command_repeat1] = STATE(1935),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4418),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(4450),
    [anon_sym_SEMI_SEMI] = ACTIONS(4452),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4426),
    [anon_sym_typeset] = ACTIONS(4426),
    [anon_sym_export] = ACTIONS(4426),
    [anon_sym_readonly] = ACTIONS(4426),
    [anon_sym_local] = ACTIONS(4426),
    [anon_sym_unset] = ACTIONS(4428),
    [anon_sym_unsetenv] = ACTIONS(4428),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(4430),
    [anon_sym_DQUOTE] = ACTIONS(4432),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [sym_raw_string] = ACTIONS(4436),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_LT_LPAREN] = ACTIONS(4444),
    [anon_sym_GT_LPAREN] = ACTIONS(4444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4446),
  },
  [1601] = {
    [aux_sym_case_item_repeat1] = STATE(1937),
    [anon_sym_PIPE] = ACTIONS(3617),
    [anon_sym_RPAREN] = ACTIONS(4454),
    [sym_comment] = ACTIONS(57),
  },
  [1602] = {
    [sym__simple_heredoc_body] = ACTIONS(4456),
    [sym__heredoc_body_beginning] = ACTIONS(4456),
    [sym_file_descriptor] = ACTIONS(4456),
    [ts_builtin_sym_end] = ACTIONS(4456),
    [anon_sym_SEMI] = ACTIONS(4458),
    [anon_sym_esac] = ACTIONS(4456),
    [anon_sym_PIPE] = ACTIONS(4458),
    [anon_sym_RPAREN] = ACTIONS(4456),
    [anon_sym_SEMI_SEMI] = ACTIONS(4456),
    [anon_sym_PIPE_AMP] = ACTIONS(4456),
    [anon_sym_AMP_AMP] = ACTIONS(4456),
    [anon_sym_PIPE_PIPE] = ACTIONS(4456),
    [anon_sym_LT] = ACTIONS(4458),
    [anon_sym_GT] = ACTIONS(4458),
    [anon_sym_GT_GT] = ACTIONS(4456),
    [anon_sym_AMP_GT] = ACTIONS(4458),
    [anon_sym_AMP_GT_GT] = ACTIONS(4456),
    [anon_sym_LT_AMP] = ACTIONS(4456),
    [anon_sym_GT_AMP] = ACTIONS(4456),
    [anon_sym_LT_LT] = ACTIONS(4458),
    [anon_sym_LT_LT_DASH] = ACTIONS(4456),
    [anon_sym_LT_LT_LT] = ACTIONS(4456),
    [anon_sym_BQUOTE] = ACTIONS(4456),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4456),
    [anon_sym_AMP] = ACTIONS(4458),
  },
  [1603] = {
    [anon_sym_esac] = ACTIONS(4460),
    [sym_comment] = ACTIONS(57),
  },
  [1604] = {
    [sym_case_item] = STATE(1604),
    [sym_concatenation] = STATE(1947),
    [sym_string] = STATE(1946),
    [sym_simple_expansion] = STATE(1946),
    [sym_string_expansion] = STATE(1946),
    [sym_expansion] = STATE(1946),
    [sym_command_substitution] = STATE(1946),
    [sym_process_substitution] = STATE(1946),
    [aux_sym_case_statement_repeat1] = STATE(1604),
    [sym__special_characters] = ACTIONS(4462),
    [anon_sym_DQUOTE] = ACTIONS(4465),
    [anon_sym_DOLLAR] = ACTIONS(4468),
    [sym_raw_string] = ACTIONS(4471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4474),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4477),
    [anon_sym_BQUOTE] = ACTIONS(4480),
    [anon_sym_LT_LPAREN] = ACTIONS(4483),
    [anon_sym_GT_LPAREN] = ACTIONS(4483),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4471),
  },
  [1605] = {
    [sym_case_item] = STATE(1604),
    [sym_last_case_item] = STATE(1948),
    [sym_concatenation] = STATE(1172),
    [sym_string] = STATE(1170),
    [sym_simple_expansion] = STATE(1170),
    [sym_string_expansion] = STATE(1170),
    [sym_expansion] = STATE(1170),
    [sym_command_substitution] = STATE(1170),
    [sym_process_substitution] = STATE(1170),
    [aux_sym_case_statement_repeat1] = STATE(1604),
    [sym__special_characters] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(421),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(425),
    [anon_sym_GT_LPAREN] = ACTIONS(425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
  },
  [1606] = {
    [sym__simple_heredoc_body] = ACTIONS(4486),
    [sym__heredoc_body_beginning] = ACTIONS(4486),
    [sym_file_descriptor] = ACTIONS(4486),
    [ts_builtin_sym_end] = ACTIONS(4486),
    [anon_sym_SEMI] = ACTIONS(4488),
    [anon_sym_esac] = ACTIONS(4486),
    [anon_sym_PIPE] = ACTIONS(4488),
    [anon_sym_RPAREN] = ACTIONS(4486),
    [anon_sym_SEMI_SEMI] = ACTIONS(4486),
    [anon_sym_PIPE_AMP] = ACTIONS(4486),
    [anon_sym_AMP_AMP] = ACTIONS(4486),
    [anon_sym_PIPE_PIPE] = ACTIONS(4486),
    [anon_sym_LT] = ACTIONS(4488),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_AMP_GT] = ACTIONS(4488),
    [anon_sym_AMP_GT_GT] = ACTIONS(4486),
    [anon_sym_LT_AMP] = ACTIONS(4486),
    [anon_sym_GT_AMP] = ACTIONS(4486),
    [anon_sym_LT_LT] = ACTIONS(4488),
    [anon_sym_LT_LT_DASH] = ACTIONS(4486),
    [anon_sym_LT_LT_LT] = ACTIONS(4486),
    [anon_sym_BQUOTE] = ACTIONS(4486),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4486),
    [anon_sym_AMP] = ACTIONS(4488),
  },
  [1607] = {
    [anon_sym_esac] = ACTIONS(4490),
    [sym_comment] = ACTIONS(57),
  },
  [1608] = {
    [sym_case_item] = STATE(1604),
    [sym_last_case_item] = STATE(1950),
    [sym_concatenation] = STATE(1172),
    [sym_string] = STATE(1170),
    [sym_simple_expansion] = STATE(1170),
    [sym_string_expansion] = STATE(1170),
    [sym_expansion] = STATE(1170),
    [sym_command_substitution] = STATE(1170),
    [sym_process_substitution] = STATE(1170),
    [aux_sym_case_statement_repeat1] = STATE(1604),
    [sym__special_characters] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(421),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(425),
    [anon_sym_GT_LPAREN] = ACTIONS(425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
  },
  [1609] = {
    [sym__concat] = ACTIONS(3921),
    [anon_sym_in] = ACTIONS(3921),
    [anon_sym_SEMI] = ACTIONS(3923),
    [anon_sym_SEMI_SEMI] = ACTIONS(3921),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3921),
  },
  [1610] = {
    [sym__concat] = ACTIONS(3929),
    [anon_sym_in] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3931),
    [anon_sym_SEMI_SEMI] = ACTIONS(3929),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
  },
  [1611] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4492),
    [sym_comment] = ACTIONS(57),
  },
  [1612] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4494),
    [sym_comment] = ACTIONS(57),
  },
  [1613] = {
    [anon_sym_RBRACE] = ACTIONS(4494),
    [sym_comment] = ACTIONS(57),
  },
  [1614] = {
    [sym_concatenation] = STATE(1954),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1954),
    [anon_sym_RBRACE] = ACTIONS(4496),
    [anon_sym_EQ] = ACTIONS(4498),
    [anon_sym_DASH] = ACTIONS(4498),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4498),
    [anon_sym_COLON_QMARK] = ACTIONS(4498),
    [anon_sym_COLON_DASH] = ACTIONS(4498),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1615] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_in] = ACTIONS(3985),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3985),
  },
  [1616] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4496),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1617] = {
    [sym_concatenation] = STATE(1955),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1955),
    [anon_sym_RBRACE] = ACTIONS(4494),
    [anon_sym_EQ] = ACTIONS(4502),
    [anon_sym_DASH] = ACTIONS(4502),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4504),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4502),
    [anon_sym_COLON_QMARK] = ACTIONS(4502),
    [anon_sym_COLON_DASH] = ACTIONS(4502),
    [anon_sym_PERCENT] = ACTIONS(4502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1618] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4494),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1619] = {
    [sym__concat] = ACTIONS(4030),
    [anon_sym_in] = ACTIONS(4030),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_SEMI_SEMI] = ACTIONS(4030),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4030),
  },
  [1620] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4506),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1621] = {
    [sym__concat] = ACTIONS(4064),
    [anon_sym_in] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_SEMI_SEMI] = ACTIONS(4064),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4064),
  },
  [1622] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4508),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1623] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(4508),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1624] = {
    [sym__concat] = ACTIONS(4070),
    [anon_sym_in] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_SEMI_SEMI] = ACTIONS(4070),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4070),
  },
  [1625] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4510),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1626] = {
    [aux_sym_concatenation_repeat1] = STATE(1626),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(3268),
    [sym_variable_name] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [1627] = {
    [aux_sym_concatenation_repeat1] = STATE(1627),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(1730),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [1628] = {
    [sym__simple_heredoc_body] = ACTIONS(4512),
    [sym__heredoc_body_beginning] = ACTIONS(4512),
    [sym_file_descriptor] = ACTIONS(4512),
    [ts_builtin_sym_end] = ACTIONS(4512),
    [anon_sym_SEMI] = ACTIONS(4514),
    [anon_sym_esac] = ACTIONS(4512),
    [anon_sym_PIPE] = ACTIONS(4514),
    [anon_sym_RPAREN] = ACTIONS(4512),
    [anon_sym_SEMI_SEMI] = ACTIONS(4512),
    [anon_sym_PIPE_AMP] = ACTIONS(4512),
    [anon_sym_AMP_AMP] = ACTIONS(4512),
    [anon_sym_PIPE_PIPE] = ACTIONS(4512),
    [anon_sym_LT] = ACTIONS(4514),
    [anon_sym_GT] = ACTIONS(4514),
    [anon_sym_GT_GT] = ACTIONS(4512),
    [anon_sym_AMP_GT] = ACTIONS(4514),
    [anon_sym_AMP_GT_GT] = ACTIONS(4512),
    [anon_sym_LT_AMP] = ACTIONS(4512),
    [anon_sym_GT_AMP] = ACTIONS(4512),
    [anon_sym_LT_LT] = ACTIONS(4514),
    [anon_sym_LT_LT_DASH] = ACTIONS(4512),
    [anon_sym_LT_LT_LT] = ACTIONS(4512),
    [anon_sym_BQUOTE] = ACTIONS(4512),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4514),
  },
  [1629] = {
    [sym_file_descriptor] = ACTIONS(3238),
    [sym_variable_name] = ACTIONS(3238),
    [anon_sym_LT] = ACTIONS(3240),
    [anon_sym_GT] = ACTIONS(3240),
    [anon_sym_GT_GT] = ACTIONS(3238),
    [anon_sym_AMP_GT] = ACTIONS(3240),
    [anon_sym_AMP_GT_GT] = ACTIONS(3238),
    [anon_sym_LT_AMP] = ACTIONS(3238),
    [anon_sym_GT_AMP] = ACTIONS(3238),
    [sym__special_characters] = ACTIONS(3238),
    [anon_sym_DQUOTE] = ACTIONS(3238),
    [anon_sym_DOLLAR] = ACTIONS(3240),
    [sym_raw_string] = ACTIONS(3238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3238),
    [anon_sym_BQUOTE] = ACTIONS(3238),
    [anon_sym_LT_LPAREN] = ACTIONS(3238),
    [anon_sym_GT_LPAREN] = ACTIONS(3238),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3238),
  },
  [1630] = {
    [sym__concat] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_RBRACK] = ACTIONS(3921),
    [anon_sym_EQ_TILDE] = ACTIONS(3921),
    [anon_sym_EQ_EQ] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_PLUS_EQ] = ACTIONS(3921),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_EQ] = ACTIONS(3921),
    [anon_sym_LT_EQ] = ACTIONS(3921),
    [anon_sym_GT_EQ] = ACTIONS(3921),
    [anon_sym_PLUS_PLUS] = ACTIONS(3921),
    [anon_sym_DASH_DASH] = ACTIONS(3921),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3921),
  },
  [1631] = {
    [sym__concat] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_RBRACK] = ACTIONS(3929),
    [anon_sym_EQ_TILDE] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_PLUS_EQ] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_DASH_EQ] = ACTIONS(3929),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3929),
    [anon_sym_DASH_DASH] = ACTIONS(3929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3929),
  },
  [1632] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4516),
    [sym_comment] = ACTIONS(57),
  },
  [1633] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4518),
    [sym_comment] = ACTIONS(57),
  },
  [1634] = {
    [anon_sym_RBRACE] = ACTIONS(4518),
    [sym_comment] = ACTIONS(57),
  },
  [1635] = {
    [sym_concatenation] = STATE(1962),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1962),
    [anon_sym_RBRACE] = ACTIONS(4520),
    [anon_sym_EQ] = ACTIONS(4522),
    [anon_sym_DASH] = ACTIONS(4522),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4522),
    [anon_sym_COLON_QMARK] = ACTIONS(4522),
    [anon_sym_COLON_DASH] = ACTIONS(4522),
    [anon_sym_PERCENT] = ACTIONS(4522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1636] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_RBRACK] = ACTIONS(3985),
    [anon_sym_EQ_TILDE] = ACTIONS(3985),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_EQ] = ACTIONS(3987),
    [anon_sym_PLUS_EQ] = ACTIONS(3985),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_PLUS] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3987),
    [anon_sym_DASH_EQ] = ACTIONS(3985),
    [anon_sym_LT_EQ] = ACTIONS(3985),
    [anon_sym_GT_EQ] = ACTIONS(3985),
    [anon_sym_PLUS_PLUS] = ACTIONS(3985),
    [anon_sym_DASH_DASH] = ACTIONS(3985),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3985),
  },
  [1637] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4520),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1638] = {
    [sym_concatenation] = STATE(1963),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1963),
    [anon_sym_RBRACE] = ACTIONS(4518),
    [anon_sym_EQ] = ACTIONS(4526),
    [anon_sym_DASH] = ACTIONS(4526),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4526),
    [anon_sym_COLON_QMARK] = ACTIONS(4526),
    [anon_sym_COLON_DASH] = ACTIONS(4526),
    [anon_sym_PERCENT] = ACTIONS(4526),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1639] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4518),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1640] = {
    [sym__concat] = ACTIONS(4030),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_RBRACK] = ACTIONS(4030),
    [anon_sym_EQ_TILDE] = ACTIONS(4030),
    [anon_sym_EQ_EQ] = ACTIONS(4030),
    [anon_sym_EQ] = ACTIONS(4032),
    [anon_sym_PLUS_EQ] = ACTIONS(4030),
    [anon_sym_LT] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(4032),
    [anon_sym_BANG_EQ] = ACTIONS(4030),
    [anon_sym_PLUS] = ACTIONS(4032),
    [anon_sym_DASH] = ACTIONS(4032),
    [anon_sym_DASH_EQ] = ACTIONS(4030),
    [anon_sym_LT_EQ] = ACTIONS(4030),
    [anon_sym_GT_EQ] = ACTIONS(4030),
    [anon_sym_PLUS_PLUS] = ACTIONS(4030),
    [anon_sym_DASH_DASH] = ACTIONS(4030),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4030),
  },
  [1641] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4530),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1642] = {
    [sym__concat] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_RBRACK] = ACTIONS(4064),
    [anon_sym_EQ_TILDE] = ACTIONS(4064),
    [anon_sym_EQ_EQ] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4066),
    [anon_sym_PLUS_EQ] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_DASH_EQ] = ACTIONS(4064),
    [anon_sym_LT_EQ] = ACTIONS(4064),
    [anon_sym_GT_EQ] = ACTIONS(4064),
    [anon_sym_PLUS_PLUS] = ACTIONS(4064),
    [anon_sym_DASH_DASH] = ACTIONS(4064),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4064),
  },
  [1643] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4532),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1644] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(4532),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1645] = {
    [sym__concat] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4070),
    [anon_sym_PIPE_PIPE] = ACTIONS(4070),
    [anon_sym_RBRACK] = ACTIONS(4070),
    [anon_sym_EQ_TILDE] = ACTIONS(4070),
    [anon_sym_EQ_EQ] = ACTIONS(4070),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_PLUS_EQ] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_GT] = ACTIONS(4072),
    [anon_sym_BANG_EQ] = ACTIONS(4070),
    [anon_sym_PLUS] = ACTIONS(4072),
    [anon_sym_DASH] = ACTIONS(4072),
    [anon_sym_DASH_EQ] = ACTIONS(4070),
    [anon_sym_LT_EQ] = ACTIONS(4070),
    [anon_sym_GT_EQ] = ACTIONS(4070),
    [anon_sym_PLUS_PLUS] = ACTIONS(4070),
    [anon_sym_DASH_DASH] = ACTIONS(4070),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4070),
  },
  [1646] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4534),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1647] = {
    [sym__simple_heredoc_body] = ACTIONS(3238),
    [sym__heredoc_body_beginning] = ACTIONS(3238),
    [sym_file_descriptor] = ACTIONS(3238),
    [sym_variable_name] = ACTIONS(3238),
    [ts_builtin_sym_end] = ACTIONS(3238),
    [anon_sym_SEMI] = ACTIONS(3240),
    [anon_sym_PIPE] = ACTIONS(3240),
    [anon_sym_RPAREN] = ACTIONS(3238),
    [anon_sym_SEMI_SEMI] = ACTIONS(3238),
    [anon_sym_PIPE_AMP] = ACTIONS(3238),
    [anon_sym_AMP_AMP] = ACTIONS(3238),
    [anon_sym_PIPE_PIPE] = ACTIONS(3238),
    [anon_sym_LT] = ACTIONS(3240),
    [anon_sym_GT] = ACTIONS(3240),
    [anon_sym_GT_GT] = ACTIONS(3238),
    [anon_sym_AMP_GT] = ACTIONS(3240),
    [anon_sym_AMP_GT_GT] = ACTIONS(3238),
    [anon_sym_LT_AMP] = ACTIONS(3238),
    [anon_sym_GT_AMP] = ACTIONS(3238),
    [anon_sym_LT_LT] = ACTIONS(3240),
    [anon_sym_LT_LT_DASH] = ACTIONS(3238),
    [anon_sym_LT_LT_LT] = ACTIONS(3238),
    [sym__special_characters] = ACTIONS(3238),
    [anon_sym_DQUOTE] = ACTIONS(3238),
    [anon_sym_DOLLAR] = ACTIONS(3240),
    [sym_raw_string] = ACTIONS(3238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3238),
    [anon_sym_BQUOTE] = ACTIONS(3238),
    [anon_sym_LT_LPAREN] = ACTIONS(3238),
    [anon_sym_GT_LPAREN] = ACTIONS(3238),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3240),
    [sym_word] = ACTIONS(3240),
    [anon_sym_LF] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
  },
  [1648] = {
    [sym__simple_heredoc_body] = ACTIONS(3921),
    [sym__heredoc_body_beginning] = ACTIONS(3921),
    [sym_file_descriptor] = ACTIONS(3921),
    [sym__concat] = ACTIONS(3921),
    [sym_variable_name] = ACTIONS(3921),
    [ts_builtin_sym_end] = ACTIONS(3921),
    [anon_sym_SEMI] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_RPAREN] = ACTIONS(3921),
    [anon_sym_SEMI_SEMI] = ACTIONS(3921),
    [anon_sym_PIPE_AMP] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_GT_GT] = ACTIONS(3921),
    [anon_sym_AMP_GT] = ACTIONS(3923),
    [anon_sym_AMP_GT_GT] = ACTIONS(3921),
    [anon_sym_LT_AMP] = ACTIONS(3921),
    [anon_sym_GT_AMP] = ACTIONS(3921),
    [anon_sym_LT_LT] = ACTIONS(3923),
    [anon_sym_LT_LT_DASH] = ACTIONS(3921),
    [anon_sym_LT_LT_LT] = ACTIONS(3921),
    [sym__special_characters] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_DOLLAR] = ACTIONS(3923),
    [sym_raw_string] = ACTIONS(3921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3921),
    [anon_sym_BQUOTE] = ACTIONS(3921),
    [anon_sym_LT_LPAREN] = ACTIONS(3921),
    [anon_sym_GT_LPAREN] = ACTIONS(3921),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3923),
    [sym_word] = ACTIONS(3923),
    [anon_sym_LF] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3923),
  },
  [1649] = {
    [sym__simple_heredoc_body] = ACTIONS(3929),
    [sym__heredoc_body_beginning] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [sym__concat] = ACTIONS(3929),
    [sym_variable_name] = ACTIONS(3929),
    [ts_builtin_sym_end] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3931),
    [anon_sym_RPAREN] = ACTIONS(3929),
    [anon_sym_SEMI_SEMI] = ACTIONS(3929),
    [anon_sym_PIPE_AMP] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_AMP_GT] = ACTIONS(3931),
    [anon_sym_AMP_GT_GT] = ACTIONS(3929),
    [anon_sym_LT_AMP] = ACTIONS(3929),
    [anon_sym_GT_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_LT_LT_DASH] = ACTIONS(3929),
    [anon_sym_LT_LT_LT] = ACTIONS(3929),
    [sym__special_characters] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [sym_raw_string] = ACTIONS(3929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3929),
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [anon_sym_LT_LPAREN] = ACTIONS(3929),
    [anon_sym_GT_LPAREN] = ACTIONS(3929),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3931),
    [sym_word] = ACTIONS(3931),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
  },
  [1650] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4536),
    [sym_comment] = ACTIONS(57),
  },
  [1651] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4538),
    [sym_comment] = ACTIONS(57),
  },
  [1652] = {
    [anon_sym_RBRACE] = ACTIONS(4538),
    [sym_comment] = ACTIONS(57),
  },
  [1653] = {
    [sym_concatenation] = STATE(1970),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1970),
    [anon_sym_RBRACE] = ACTIONS(4540),
    [anon_sym_EQ] = ACTIONS(4542),
    [anon_sym_DASH] = ACTIONS(4542),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4542),
    [anon_sym_COLON_QMARK] = ACTIONS(4542),
    [anon_sym_COLON_DASH] = ACTIONS(4542),
    [anon_sym_PERCENT] = ACTIONS(4542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1654] = {
    [sym__simple_heredoc_body] = ACTIONS(3985),
    [sym__heredoc_body_beginning] = ACTIONS(3985),
    [sym_file_descriptor] = ACTIONS(3985),
    [sym__concat] = ACTIONS(3985),
    [sym_variable_name] = ACTIONS(3985),
    [ts_builtin_sym_end] = ACTIONS(3985),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_RPAREN] = ACTIONS(3985),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_AMP_GT] = ACTIONS(3987),
    [anon_sym_AMP_GT_GT] = ACTIONS(3985),
    [anon_sym_LT_AMP] = ACTIONS(3985),
    [anon_sym_GT_AMP] = ACTIONS(3985),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_LT_LT_DASH] = ACTIONS(3985),
    [anon_sym_LT_LT_LT] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3987),
    [sym_word] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [1655] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4540),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1656] = {
    [sym_concatenation] = STATE(1971),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1971),
    [anon_sym_RBRACE] = ACTIONS(4538),
    [anon_sym_EQ] = ACTIONS(4546),
    [anon_sym_DASH] = ACTIONS(4546),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4546),
    [anon_sym_COLON_QMARK] = ACTIONS(4546),
    [anon_sym_COLON_DASH] = ACTIONS(4546),
    [anon_sym_PERCENT] = ACTIONS(4546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1657] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4538),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1658] = {
    [sym__simple_heredoc_body] = ACTIONS(4030),
    [sym__heredoc_body_beginning] = ACTIONS(4030),
    [sym_file_descriptor] = ACTIONS(4030),
    [sym__concat] = ACTIONS(4030),
    [sym_variable_name] = ACTIONS(4030),
    [ts_builtin_sym_end] = ACTIONS(4030),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_RPAREN] = ACTIONS(4030),
    [anon_sym_SEMI_SEMI] = ACTIONS(4030),
    [anon_sym_PIPE_AMP] = ACTIONS(4030),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_LT] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(4032),
    [anon_sym_GT_GT] = ACTIONS(4030),
    [anon_sym_AMP_GT] = ACTIONS(4032),
    [anon_sym_AMP_GT_GT] = ACTIONS(4030),
    [anon_sym_LT_AMP] = ACTIONS(4030),
    [anon_sym_GT_AMP] = ACTIONS(4030),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_LT_LT_DASH] = ACTIONS(4030),
    [anon_sym_LT_LT_LT] = ACTIONS(4030),
    [sym__special_characters] = ACTIONS(4030),
    [anon_sym_DQUOTE] = ACTIONS(4030),
    [anon_sym_DOLLAR] = ACTIONS(4032),
    [sym_raw_string] = ACTIONS(4030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4030),
    [anon_sym_BQUOTE] = ACTIONS(4030),
    [anon_sym_LT_LPAREN] = ACTIONS(4030),
    [anon_sym_GT_LPAREN] = ACTIONS(4030),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4032),
    [sym_word] = ACTIONS(4032),
    [anon_sym_LF] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4032),
  },
  [1659] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4550),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1660] = {
    [sym__simple_heredoc_body] = ACTIONS(4064),
    [sym__heredoc_body_beginning] = ACTIONS(4064),
    [sym_file_descriptor] = ACTIONS(4064),
    [sym__concat] = ACTIONS(4064),
    [sym_variable_name] = ACTIONS(4064),
    [ts_builtin_sym_end] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_RPAREN] = ACTIONS(4064),
    [anon_sym_SEMI_SEMI] = ACTIONS(4064),
    [anon_sym_PIPE_AMP] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_GT_GT] = ACTIONS(4064),
    [anon_sym_AMP_GT] = ACTIONS(4066),
    [anon_sym_AMP_GT_GT] = ACTIONS(4064),
    [anon_sym_LT_AMP] = ACTIONS(4064),
    [anon_sym_GT_AMP] = ACTIONS(4064),
    [anon_sym_LT_LT] = ACTIONS(4066),
    [anon_sym_LT_LT_DASH] = ACTIONS(4064),
    [anon_sym_LT_LT_LT] = ACTIONS(4064),
    [sym__special_characters] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_DOLLAR] = ACTIONS(4066),
    [sym_raw_string] = ACTIONS(4064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4064),
    [anon_sym_BQUOTE] = ACTIONS(4064),
    [anon_sym_LT_LPAREN] = ACTIONS(4064),
    [anon_sym_GT_LPAREN] = ACTIONS(4064),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4066),
    [sym_word] = ACTIONS(4066),
    [anon_sym_LF] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4066),
  },
  [1661] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4552),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1662] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(4552),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1663] = {
    [sym__simple_heredoc_body] = ACTIONS(4070),
    [sym__heredoc_body_beginning] = ACTIONS(4070),
    [sym_file_descriptor] = ACTIONS(4070),
    [sym__concat] = ACTIONS(4070),
    [sym_variable_name] = ACTIONS(4070),
    [ts_builtin_sym_end] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_PIPE] = ACTIONS(4072),
    [anon_sym_RPAREN] = ACTIONS(4070),
    [anon_sym_SEMI_SEMI] = ACTIONS(4070),
    [anon_sym_PIPE_AMP] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4070),
    [anon_sym_PIPE_PIPE] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_GT] = ACTIONS(4072),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_AMP_GT] = ACTIONS(4072),
    [anon_sym_AMP_GT_GT] = ACTIONS(4070),
    [anon_sym_LT_AMP] = ACTIONS(4070),
    [anon_sym_GT_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4072),
    [anon_sym_LT_LT_DASH] = ACTIONS(4070),
    [anon_sym_LT_LT_LT] = ACTIONS(4070),
    [sym__special_characters] = ACTIONS(4070),
    [anon_sym_DQUOTE] = ACTIONS(4070),
    [anon_sym_DOLLAR] = ACTIONS(4072),
    [sym_raw_string] = ACTIONS(4070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4070),
    [anon_sym_BQUOTE] = ACTIONS(4070),
    [anon_sym_LT_LPAREN] = ACTIONS(4070),
    [anon_sym_GT_LPAREN] = ACTIONS(4070),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4072),
    [sym_word] = ACTIONS(4072),
    [anon_sym_LF] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4072),
  },
  [1664] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4554),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1665] = {
    [sym__simple_heredoc_body] = ACTIONS(3921),
    [sym__heredoc_body_beginning] = ACTIONS(3921),
    [sym_file_descriptor] = ACTIONS(3921),
    [sym__concat] = ACTIONS(3921),
    [ts_builtin_sym_end] = ACTIONS(3921),
    [anon_sym_SEMI] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_RPAREN] = ACTIONS(3921),
    [anon_sym_SEMI_SEMI] = ACTIONS(3921),
    [anon_sym_PIPE_AMP] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_GT_GT] = ACTIONS(3921),
    [anon_sym_AMP_GT] = ACTIONS(3923),
    [anon_sym_AMP_GT_GT] = ACTIONS(3921),
    [anon_sym_LT_AMP] = ACTIONS(3921),
    [anon_sym_GT_AMP] = ACTIONS(3921),
    [anon_sym_LT_LT] = ACTIONS(3923),
    [anon_sym_LT_LT_DASH] = ACTIONS(3921),
    [anon_sym_LT_LT_LT] = ACTIONS(3921),
    [sym__special_characters] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_DOLLAR] = ACTIONS(3923),
    [sym_raw_string] = ACTIONS(3921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3921),
    [anon_sym_BQUOTE] = ACTIONS(3921),
    [anon_sym_LT_LPAREN] = ACTIONS(3921),
    [anon_sym_GT_LPAREN] = ACTIONS(3921),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3923),
    [sym_word] = ACTIONS(3923),
    [anon_sym_LF] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3923),
  },
  [1666] = {
    [sym__simple_heredoc_body] = ACTIONS(3929),
    [sym__heredoc_body_beginning] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [sym__concat] = ACTIONS(3929),
    [ts_builtin_sym_end] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3931),
    [anon_sym_RPAREN] = ACTIONS(3929),
    [anon_sym_SEMI_SEMI] = ACTIONS(3929),
    [anon_sym_PIPE_AMP] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_AMP_GT] = ACTIONS(3931),
    [anon_sym_AMP_GT_GT] = ACTIONS(3929),
    [anon_sym_LT_AMP] = ACTIONS(3929),
    [anon_sym_GT_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_LT_LT_DASH] = ACTIONS(3929),
    [anon_sym_LT_LT_LT] = ACTIONS(3929),
    [sym__special_characters] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [sym_raw_string] = ACTIONS(3929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3929),
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [anon_sym_LT_LPAREN] = ACTIONS(3929),
    [anon_sym_GT_LPAREN] = ACTIONS(3929),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3931),
    [sym_word] = ACTIONS(3931),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
  },
  [1667] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4556),
    [sym_comment] = ACTIONS(57),
  },
  [1668] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4558),
    [sym_comment] = ACTIONS(57),
  },
  [1669] = {
    [anon_sym_RBRACE] = ACTIONS(4558),
    [sym_comment] = ACTIONS(57),
  },
  [1670] = {
    [sym_concatenation] = STATE(1978),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1978),
    [anon_sym_RBRACE] = ACTIONS(4560),
    [anon_sym_EQ] = ACTIONS(4562),
    [anon_sym_DASH] = ACTIONS(4562),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4562),
    [anon_sym_COLON_QMARK] = ACTIONS(4562),
    [anon_sym_COLON_DASH] = ACTIONS(4562),
    [anon_sym_PERCENT] = ACTIONS(4562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1671] = {
    [sym__simple_heredoc_body] = ACTIONS(3985),
    [sym__heredoc_body_beginning] = ACTIONS(3985),
    [sym_file_descriptor] = ACTIONS(3985),
    [sym__concat] = ACTIONS(3985),
    [ts_builtin_sym_end] = ACTIONS(3985),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_RPAREN] = ACTIONS(3985),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_AMP_GT] = ACTIONS(3987),
    [anon_sym_AMP_GT_GT] = ACTIONS(3985),
    [anon_sym_LT_AMP] = ACTIONS(3985),
    [anon_sym_GT_AMP] = ACTIONS(3985),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_LT_LT_DASH] = ACTIONS(3985),
    [anon_sym_LT_LT_LT] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3987),
    [sym_word] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [1672] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4560),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1673] = {
    [sym_concatenation] = STATE(1979),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1979),
    [anon_sym_RBRACE] = ACTIONS(4558),
    [anon_sym_EQ] = ACTIONS(4566),
    [anon_sym_DASH] = ACTIONS(4566),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4566),
    [anon_sym_COLON_QMARK] = ACTIONS(4566),
    [anon_sym_COLON_DASH] = ACTIONS(4566),
    [anon_sym_PERCENT] = ACTIONS(4566),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1674] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4558),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1675] = {
    [sym__simple_heredoc_body] = ACTIONS(4030),
    [sym__heredoc_body_beginning] = ACTIONS(4030),
    [sym_file_descriptor] = ACTIONS(4030),
    [sym__concat] = ACTIONS(4030),
    [ts_builtin_sym_end] = ACTIONS(4030),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_RPAREN] = ACTIONS(4030),
    [anon_sym_SEMI_SEMI] = ACTIONS(4030),
    [anon_sym_PIPE_AMP] = ACTIONS(4030),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_LT] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(4032),
    [anon_sym_GT_GT] = ACTIONS(4030),
    [anon_sym_AMP_GT] = ACTIONS(4032),
    [anon_sym_AMP_GT_GT] = ACTIONS(4030),
    [anon_sym_LT_AMP] = ACTIONS(4030),
    [anon_sym_GT_AMP] = ACTIONS(4030),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_LT_LT_DASH] = ACTIONS(4030),
    [anon_sym_LT_LT_LT] = ACTIONS(4030),
    [sym__special_characters] = ACTIONS(4030),
    [anon_sym_DQUOTE] = ACTIONS(4030),
    [anon_sym_DOLLAR] = ACTIONS(4032),
    [sym_raw_string] = ACTIONS(4030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4030),
    [anon_sym_BQUOTE] = ACTIONS(4030),
    [anon_sym_LT_LPAREN] = ACTIONS(4030),
    [anon_sym_GT_LPAREN] = ACTIONS(4030),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4032),
    [sym_word] = ACTIONS(4032),
    [anon_sym_LF] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4032),
  },
  [1676] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4570),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1677] = {
    [sym__simple_heredoc_body] = ACTIONS(4064),
    [sym__heredoc_body_beginning] = ACTIONS(4064),
    [sym_file_descriptor] = ACTIONS(4064),
    [sym__concat] = ACTIONS(4064),
    [ts_builtin_sym_end] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_RPAREN] = ACTIONS(4064),
    [anon_sym_SEMI_SEMI] = ACTIONS(4064),
    [anon_sym_PIPE_AMP] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_GT_GT] = ACTIONS(4064),
    [anon_sym_AMP_GT] = ACTIONS(4066),
    [anon_sym_AMP_GT_GT] = ACTIONS(4064),
    [anon_sym_LT_AMP] = ACTIONS(4064),
    [anon_sym_GT_AMP] = ACTIONS(4064),
    [anon_sym_LT_LT] = ACTIONS(4066),
    [anon_sym_LT_LT_DASH] = ACTIONS(4064),
    [anon_sym_LT_LT_LT] = ACTIONS(4064),
    [sym__special_characters] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_DOLLAR] = ACTIONS(4066),
    [sym_raw_string] = ACTIONS(4064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4064),
    [anon_sym_BQUOTE] = ACTIONS(4064),
    [anon_sym_LT_LPAREN] = ACTIONS(4064),
    [anon_sym_GT_LPAREN] = ACTIONS(4064),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4066),
    [sym_word] = ACTIONS(4066),
    [anon_sym_LF] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4066),
  },
  [1678] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4572),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1679] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(4572),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1680] = {
    [sym__simple_heredoc_body] = ACTIONS(4070),
    [sym__heredoc_body_beginning] = ACTIONS(4070),
    [sym_file_descriptor] = ACTIONS(4070),
    [sym__concat] = ACTIONS(4070),
    [ts_builtin_sym_end] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_PIPE] = ACTIONS(4072),
    [anon_sym_RPAREN] = ACTIONS(4070),
    [anon_sym_SEMI_SEMI] = ACTIONS(4070),
    [anon_sym_PIPE_AMP] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4070),
    [anon_sym_PIPE_PIPE] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_GT] = ACTIONS(4072),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_AMP_GT] = ACTIONS(4072),
    [anon_sym_AMP_GT_GT] = ACTIONS(4070),
    [anon_sym_LT_AMP] = ACTIONS(4070),
    [anon_sym_GT_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4072),
    [anon_sym_LT_LT_DASH] = ACTIONS(4070),
    [anon_sym_LT_LT_LT] = ACTIONS(4070),
    [sym__special_characters] = ACTIONS(4070),
    [anon_sym_DQUOTE] = ACTIONS(4070),
    [anon_sym_DOLLAR] = ACTIONS(4072),
    [sym_raw_string] = ACTIONS(4070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4070),
    [anon_sym_BQUOTE] = ACTIONS(4070),
    [anon_sym_LT_LPAREN] = ACTIONS(4070),
    [anon_sym_GT_LPAREN] = ACTIONS(4070),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4072),
    [sym_word] = ACTIONS(4072),
    [anon_sym_LF] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4072),
  },
  [1681] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4574),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1682] = {
    [sym_file_descriptor] = ACTIONS(3921),
    [sym__concat] = ACTIONS(3921),
    [sym_variable_name] = ACTIONS(3921),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_GT_GT] = ACTIONS(3921),
    [anon_sym_AMP_GT] = ACTIONS(3923),
    [anon_sym_AMP_GT_GT] = ACTIONS(3921),
    [anon_sym_LT_AMP] = ACTIONS(3921),
    [anon_sym_GT_AMP] = ACTIONS(3921),
    [sym__special_characters] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_DOLLAR] = ACTIONS(3923),
    [sym_raw_string] = ACTIONS(3921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3921),
    [anon_sym_BQUOTE] = ACTIONS(3921),
    [anon_sym_LT_LPAREN] = ACTIONS(3921),
    [anon_sym_GT_LPAREN] = ACTIONS(3921),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3921),
  },
  [1683] = {
    [sym_file_descriptor] = ACTIONS(3929),
    [sym__concat] = ACTIONS(3929),
    [sym_variable_name] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_AMP_GT] = ACTIONS(3931),
    [anon_sym_AMP_GT_GT] = ACTIONS(3929),
    [anon_sym_LT_AMP] = ACTIONS(3929),
    [anon_sym_GT_AMP] = ACTIONS(3929),
    [sym__special_characters] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [sym_raw_string] = ACTIONS(3929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3929),
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [anon_sym_LT_LPAREN] = ACTIONS(3929),
    [anon_sym_GT_LPAREN] = ACTIONS(3929),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3929),
  },
  [1684] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4576),
    [sym_comment] = ACTIONS(57),
  },
  [1685] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4578),
    [sym_comment] = ACTIONS(57),
  },
  [1686] = {
    [anon_sym_RBRACE] = ACTIONS(4578),
    [sym_comment] = ACTIONS(57),
  },
  [1687] = {
    [sym_concatenation] = STATE(1986),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1986),
    [anon_sym_RBRACE] = ACTIONS(4580),
    [anon_sym_EQ] = ACTIONS(4582),
    [anon_sym_DASH] = ACTIONS(4582),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4582),
    [anon_sym_COLON_QMARK] = ACTIONS(4582),
    [anon_sym_COLON_DASH] = ACTIONS(4582),
    [anon_sym_PERCENT] = ACTIONS(4582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1688] = {
    [sym_file_descriptor] = ACTIONS(3985),
    [sym__concat] = ACTIONS(3985),
    [sym_variable_name] = ACTIONS(3985),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_AMP_GT] = ACTIONS(3987),
    [anon_sym_AMP_GT_GT] = ACTIONS(3985),
    [anon_sym_LT_AMP] = ACTIONS(3985),
    [anon_sym_GT_AMP] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3985),
  },
  [1689] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4580),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1690] = {
    [sym_concatenation] = STATE(1987),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1987),
    [anon_sym_RBRACE] = ACTIONS(4578),
    [anon_sym_EQ] = ACTIONS(4586),
    [anon_sym_DASH] = ACTIONS(4586),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4588),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4586),
    [anon_sym_COLON_QMARK] = ACTIONS(4586),
    [anon_sym_COLON_DASH] = ACTIONS(4586),
    [anon_sym_PERCENT] = ACTIONS(4586),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1691] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4578),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1692] = {
    [sym_file_descriptor] = ACTIONS(4030),
    [sym__concat] = ACTIONS(4030),
    [sym_variable_name] = ACTIONS(4030),
    [anon_sym_LT] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(4032),
    [anon_sym_GT_GT] = ACTIONS(4030),
    [anon_sym_AMP_GT] = ACTIONS(4032),
    [anon_sym_AMP_GT_GT] = ACTIONS(4030),
    [anon_sym_LT_AMP] = ACTIONS(4030),
    [anon_sym_GT_AMP] = ACTIONS(4030),
    [sym__special_characters] = ACTIONS(4030),
    [anon_sym_DQUOTE] = ACTIONS(4030),
    [anon_sym_DOLLAR] = ACTIONS(4032),
    [sym_raw_string] = ACTIONS(4030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4030),
    [anon_sym_BQUOTE] = ACTIONS(4030),
    [anon_sym_LT_LPAREN] = ACTIONS(4030),
    [anon_sym_GT_LPAREN] = ACTIONS(4030),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4030),
  },
  [1693] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4590),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1694] = {
    [sym_file_descriptor] = ACTIONS(4064),
    [sym__concat] = ACTIONS(4064),
    [sym_variable_name] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_GT_GT] = ACTIONS(4064),
    [anon_sym_AMP_GT] = ACTIONS(4066),
    [anon_sym_AMP_GT_GT] = ACTIONS(4064),
    [anon_sym_LT_AMP] = ACTIONS(4064),
    [anon_sym_GT_AMP] = ACTIONS(4064),
    [sym__special_characters] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_DOLLAR] = ACTIONS(4066),
    [sym_raw_string] = ACTIONS(4064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4064),
    [anon_sym_BQUOTE] = ACTIONS(4064),
    [anon_sym_LT_LPAREN] = ACTIONS(4064),
    [anon_sym_GT_LPAREN] = ACTIONS(4064),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4064),
  },
  [1695] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4592),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1696] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(4592),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1697] = {
    [sym_file_descriptor] = ACTIONS(4070),
    [sym__concat] = ACTIONS(4070),
    [sym_variable_name] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_GT] = ACTIONS(4072),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_AMP_GT] = ACTIONS(4072),
    [anon_sym_AMP_GT_GT] = ACTIONS(4070),
    [anon_sym_LT_AMP] = ACTIONS(4070),
    [anon_sym_GT_AMP] = ACTIONS(4070),
    [sym__special_characters] = ACTIONS(4070),
    [anon_sym_DQUOTE] = ACTIONS(4070),
    [anon_sym_DOLLAR] = ACTIONS(4072),
    [sym_raw_string] = ACTIONS(4070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4070),
    [anon_sym_BQUOTE] = ACTIONS(4070),
    [anon_sym_LT_LPAREN] = ACTIONS(4070),
    [anon_sym_GT_LPAREN] = ACTIONS(4070),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4070),
  },
  [1698] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4594),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1699] = {
    [sym__concat] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3923),
    [sym__string_content] = ACTIONS(3921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3923),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3923),
    [anon_sym_BQUOTE] = ACTIONS(3923),
    [sym_comment] = ACTIONS(265),
  },
  [1700] = {
    [sym__concat] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3931),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [sym__string_content] = ACTIONS(3929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3931),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3931),
    [anon_sym_BQUOTE] = ACTIONS(3931),
    [sym_comment] = ACTIONS(265),
  },
  [1701] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4596),
    [sym_comment] = ACTIONS(57),
  },
  [1702] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4598),
    [sym_comment] = ACTIONS(57),
  },
  [1703] = {
    [anon_sym_RBRACE] = ACTIONS(4598),
    [sym_comment] = ACTIONS(57),
  },
  [1704] = {
    [sym_concatenation] = STATE(1994),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1994),
    [anon_sym_RBRACE] = ACTIONS(4600),
    [anon_sym_EQ] = ACTIONS(4602),
    [anon_sym_DASH] = ACTIONS(4602),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4604),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4602),
    [anon_sym_COLON_QMARK] = ACTIONS(4602),
    [anon_sym_COLON_DASH] = ACTIONS(4602),
    [anon_sym_PERCENT] = ACTIONS(4602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1705] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3987),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym__string_content] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3987),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3987),
    [anon_sym_BQUOTE] = ACTIONS(3987),
    [sym_comment] = ACTIONS(265),
  },
  [1706] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4600),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1707] = {
    [sym_concatenation] = STATE(1995),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(1995),
    [anon_sym_RBRACE] = ACTIONS(4598),
    [anon_sym_EQ] = ACTIONS(4606),
    [anon_sym_DASH] = ACTIONS(4606),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4606),
    [anon_sym_COLON_QMARK] = ACTIONS(4606),
    [anon_sym_COLON_DASH] = ACTIONS(4606),
    [anon_sym_PERCENT] = ACTIONS(4606),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1708] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4598),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1709] = {
    [sym__concat] = ACTIONS(4030),
    [anon_sym_DQUOTE] = ACTIONS(4032),
    [anon_sym_DOLLAR] = ACTIONS(4032),
    [sym__string_content] = ACTIONS(4030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4032),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4032),
    [anon_sym_BQUOTE] = ACTIONS(4032),
    [sym_comment] = ACTIONS(265),
  },
  [1710] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4610),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1711] = {
    [sym__concat] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4066),
    [anon_sym_DOLLAR] = ACTIONS(4066),
    [sym__string_content] = ACTIONS(4064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4066),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4066),
    [anon_sym_BQUOTE] = ACTIONS(4066),
    [sym_comment] = ACTIONS(265),
  },
  [1712] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4612),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1713] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(4612),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1714] = {
    [sym__concat] = ACTIONS(4614),
    [anon_sym_RBRACE] = ACTIONS(3184),
    [anon_sym_EQ] = ACTIONS(4616),
    [anon_sym_DASH] = ACTIONS(4616),
    [sym__special_characters] = ACTIONS(4616),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [anon_sym_DOLLAR] = ACTIONS(4616),
    [sym_raw_string] = ACTIONS(3184),
    [anon_sym_POUND] = ACTIONS(3184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3184),
    [anon_sym_SLASH] = ACTIONS(3184),
    [anon_sym_COLON] = ACTIONS(4616),
    [anon_sym_COLON_QMARK] = ACTIONS(4616),
    [anon_sym_COLON_DASH] = ACTIONS(4616),
    [anon_sym_PERCENT] = ACTIONS(4616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3184),
    [anon_sym_BQUOTE] = ACTIONS(3184),
    [anon_sym_LT_LPAREN] = ACTIONS(3184),
    [anon_sym_GT_LPAREN] = ACTIONS(3184),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4616),
  },
  [1715] = {
    [anon_sym_RBRACE] = ACTIONS(3184),
    [anon_sym_EQ] = ACTIONS(4616),
    [anon_sym_DASH] = ACTIONS(4616),
    [sym__special_characters] = ACTIONS(4616),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [anon_sym_DOLLAR] = ACTIONS(4616),
    [sym_raw_string] = ACTIONS(3184),
    [anon_sym_POUND] = ACTIONS(3184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3184),
    [anon_sym_SLASH] = ACTIONS(3184),
    [anon_sym_COLON] = ACTIONS(4616),
    [anon_sym_COLON_QMARK] = ACTIONS(4616),
    [anon_sym_COLON_DASH] = ACTIONS(4616),
    [anon_sym_PERCENT] = ACTIONS(4616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3184),
    [anon_sym_BQUOTE] = ACTIONS(3184),
    [anon_sym_LT_LPAREN] = ACTIONS(3184),
    [anon_sym_GT_LPAREN] = ACTIONS(3184),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4616),
  },
  [1716] = {
    [sym__concat] = ACTIONS(4618),
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_EQ] = ACTIONS(4620),
    [anon_sym_DASH] = ACTIONS(4620),
    [sym__special_characters] = ACTIONS(4620),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [anon_sym_DOLLAR] = ACTIONS(4620),
    [sym_raw_string] = ACTIONS(3188),
    [anon_sym_POUND] = ACTIONS(3188),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3188),
    [anon_sym_SLASH] = ACTIONS(3188),
    [anon_sym_COLON] = ACTIONS(4620),
    [anon_sym_COLON_QMARK] = ACTIONS(4620),
    [anon_sym_COLON_DASH] = ACTIONS(4620),
    [anon_sym_PERCENT] = ACTIONS(4620),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3188),
    [anon_sym_BQUOTE] = ACTIONS(3188),
    [anon_sym_LT_LPAREN] = ACTIONS(3188),
    [anon_sym_GT_LPAREN] = ACTIONS(3188),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4620),
  },
  [1717] = {
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_EQ] = ACTIONS(4620),
    [anon_sym_DASH] = ACTIONS(4620),
    [sym__special_characters] = ACTIONS(4620),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [anon_sym_DOLLAR] = ACTIONS(4620),
    [sym_raw_string] = ACTIONS(3188),
    [anon_sym_POUND] = ACTIONS(3188),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3188),
    [anon_sym_SLASH] = ACTIONS(3188),
    [anon_sym_COLON] = ACTIONS(4620),
    [anon_sym_COLON_QMARK] = ACTIONS(4620),
    [anon_sym_COLON_DASH] = ACTIONS(4620),
    [anon_sym_PERCENT] = ACTIONS(4620),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3188),
    [anon_sym_BQUOTE] = ACTIONS(3188),
    [anon_sym_LT_LPAREN] = ACTIONS(3188),
    [anon_sym_GT_LPAREN] = ACTIONS(3188),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4620),
  },
  [1718] = {
    [sym__concat] = ACTIONS(1726),
    [anon_sym_RBRACE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
  },
  [1719] = {
    [aux_sym_concatenation_repeat1] = STATE(1719),
    [sym__concat] = ACTIONS(4622),
    [anon_sym_RBRACE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
  },
  [1720] = {
    [sym__concat] = ACTIONS(1733),
    [anon_sym_RBRACE] = ACTIONS(1733),
    [sym_comment] = ACTIONS(57),
  },
  [1721] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(4625),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [1722] = {
    [sym_concatenation] = STATE(2004),
    [sym_string] = STATE(2003),
    [sym_simple_expansion] = STATE(2003),
    [sym_string_expansion] = STATE(2003),
    [sym_expansion] = STATE(2003),
    [sym_command_substitution] = STATE(2003),
    [sym_process_substitution] = STATE(2003),
    [anon_sym_RBRACE] = ACTIONS(4627),
    [sym__special_characters] = ACTIONS(4629),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(4631),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4631),
  },
  [1723] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(4633),
    [sym_comment] = ACTIONS(57),
  },
  [1724] = {
    [sym_concatenation] = STATE(2008),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2008),
    [anon_sym_RBRACE] = ACTIONS(4635),
    [anon_sym_EQ] = ACTIONS(4637),
    [anon_sym_DASH] = ACTIONS(4637),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(4641),
    [anon_sym_COLON] = ACTIONS(4637),
    [anon_sym_COLON_QMARK] = ACTIONS(4637),
    [anon_sym_COLON_DASH] = ACTIONS(4637),
    [anon_sym_PERCENT] = ACTIONS(4637),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1725] = {
    [sym_concatenation] = STATE(2010),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2010),
    [anon_sym_RBRACE] = ACTIONS(4627),
    [anon_sym_EQ] = ACTIONS(4643),
    [anon_sym_DASH] = ACTIONS(4643),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4645),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_COLON] = ACTIONS(4643),
    [anon_sym_COLON_QMARK] = ACTIONS(4643),
    [anon_sym_COLON_DASH] = ACTIONS(4643),
    [anon_sym_PERCENT] = ACTIONS(4643),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1726] = {
    [sym__concat] = ACTIONS(1834),
    [anon_sym_RBRACE] = ACTIONS(1834),
    [sym_comment] = ACTIONS(57),
  },
  [1727] = {
    [sym_concatenation] = STATE(2013),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2013),
    [sym_regex] = ACTIONS(4649),
    [anon_sym_RBRACE] = ACTIONS(4651),
    [anon_sym_EQ] = ACTIONS(4653),
    [anon_sym_DASH] = ACTIONS(4653),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4655),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4653),
    [anon_sym_COLON_QMARK] = ACTIONS(4653),
    [anon_sym_COLON_DASH] = ACTIONS(4653),
    [anon_sym_PERCENT] = ACTIONS(4653),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1728] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4651),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1729] = {
    [sym__concat] = ACTIONS(1882),
    [anon_sym_RBRACE] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
  },
  [1730] = {
    [sym_concatenation] = STATE(2010),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2010),
    [sym_regex] = ACTIONS(4657),
    [anon_sym_RBRACE] = ACTIONS(4627),
    [anon_sym_EQ] = ACTIONS(4643),
    [anon_sym_DASH] = ACTIONS(4643),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4645),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4643),
    [anon_sym_COLON_QMARK] = ACTIONS(4643),
    [anon_sym_COLON_DASH] = ACTIONS(4643),
    [anon_sym_PERCENT] = ACTIONS(4643),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1731] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4627),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1732] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4659),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1733] = {
    [sym__concat] = ACTIONS(1890),
    [anon_sym_RBRACE] = ACTIONS(1890),
    [sym_comment] = ACTIONS(57),
  },
  [1734] = {
    [anon_sym_SEMI] = ACTIONS(4661),
    [anon_sym_RPAREN] = ACTIONS(4659),
    [anon_sym_SEMI_SEMI] = ACTIONS(4663),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4663),
  },
  [1735] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2018),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(4665),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(4659),
    [anon_sym_SEMI_SEMI] = ACTIONS(4667),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4667),
    [anon_sym_AMP] = ACTIONS(4665),
  },
  [1736] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2018),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(4665),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(4659),
    [anon_sym_SEMI_SEMI] = ACTIONS(4667),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(4667),
    [anon_sym_AMP] = ACTIONS(4665),
  },
  [1737] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(4659),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1738] = {
    [anon_sym_SEMI] = ACTIONS(4669),
    [anon_sym_SEMI_SEMI] = ACTIONS(4671),
    [anon_sym_BQUOTE] = ACTIONS(4659),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4671),
    [anon_sym_AMP] = ACTIONS(4671),
  },
  [1739] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2021),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(4673),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(4675),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(4659),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(4673),
  },
  [1740] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2021),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(4673),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(4675),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(4659),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(4673),
  },
  [1741] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4677),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1742] = {
    [sym__concat] = ACTIONS(1924),
    [anon_sym_RBRACE] = ACTIONS(1924),
    [sym_comment] = ACTIONS(57),
  },
  [1743] = {
    [anon_sym_SEMI] = ACTIONS(4679),
    [anon_sym_RPAREN] = ACTIONS(4677),
    [anon_sym_SEMI_SEMI] = ACTIONS(4681),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4681),
    [anon_sym_AMP] = ACTIONS(4681),
  },
  [1744] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2025),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(4683),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(4677),
    [anon_sym_SEMI_SEMI] = ACTIONS(4685),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4685),
    [anon_sym_AMP] = ACTIONS(4683),
  },
  [1745] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2025),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(4683),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(4677),
    [anon_sym_SEMI_SEMI] = ACTIONS(4685),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(4685),
    [anon_sym_AMP] = ACTIONS(4683),
  },
  [1746] = {
    [sym__simple_heredoc_body] = ACTIONS(4687),
    [sym__heredoc_body_beginning] = ACTIONS(4687),
    [sym_file_descriptor] = ACTIONS(4687),
    [sym__concat] = ACTIONS(4687),
    [ts_builtin_sym_end] = ACTIONS(4687),
    [anon_sym_SEMI] = ACTIONS(4689),
    [anon_sym_PIPE] = ACTIONS(4689),
    [anon_sym_RPAREN] = ACTIONS(4687),
    [anon_sym_SEMI_SEMI] = ACTIONS(4687),
    [anon_sym_PIPE_AMP] = ACTIONS(4687),
    [anon_sym_AMP_AMP] = ACTIONS(4687),
    [anon_sym_PIPE_PIPE] = ACTIONS(4687),
    [anon_sym_EQ_TILDE] = ACTIONS(4689),
    [anon_sym_EQ_EQ] = ACTIONS(4689),
    [anon_sym_LT] = ACTIONS(4689),
    [anon_sym_GT] = ACTIONS(4689),
    [anon_sym_GT_GT] = ACTIONS(4687),
    [anon_sym_AMP_GT] = ACTIONS(4689),
    [anon_sym_AMP_GT_GT] = ACTIONS(4687),
    [anon_sym_LT_AMP] = ACTIONS(4687),
    [anon_sym_GT_AMP] = ACTIONS(4687),
    [anon_sym_LT_LT] = ACTIONS(4689),
    [anon_sym_LT_LT_DASH] = ACTIONS(4687),
    [anon_sym_LT_LT_LT] = ACTIONS(4687),
    [sym__special_characters] = ACTIONS(4687),
    [anon_sym_DQUOTE] = ACTIONS(4687),
    [anon_sym_DOLLAR] = ACTIONS(4689),
    [sym_raw_string] = ACTIONS(4687),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4687),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4687),
    [anon_sym_BQUOTE] = ACTIONS(4687),
    [anon_sym_LT_LPAREN] = ACTIONS(4687),
    [anon_sym_GT_LPAREN] = ACTIONS(4687),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4689),
    [anon_sym_LF] = ACTIONS(4687),
    [anon_sym_AMP] = ACTIONS(4689),
  },
  [1747] = {
    [sym__simple_heredoc_body] = ACTIONS(4691),
    [sym__heredoc_body_beginning] = ACTIONS(4691),
    [sym_file_descriptor] = ACTIONS(4691),
    [sym__concat] = ACTIONS(4691),
    [ts_builtin_sym_end] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_RPAREN] = ACTIONS(4691),
    [anon_sym_SEMI_SEMI] = ACTIONS(4691),
    [anon_sym_PIPE_AMP] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4691),
    [anon_sym_EQ_TILDE] = ACTIONS(4693),
    [anon_sym_EQ_EQ] = ACTIONS(4693),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4691),
    [anon_sym_AMP_GT] = ACTIONS(4693),
    [anon_sym_AMP_GT_GT] = ACTIONS(4691),
    [anon_sym_LT_AMP] = ACTIONS(4691),
    [anon_sym_GT_AMP] = ACTIONS(4691),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_LT_LT_DASH] = ACTIONS(4691),
    [anon_sym_LT_LT_LT] = ACTIONS(4691),
    [sym__special_characters] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4693),
    [sym_raw_string] = ACTIONS(4691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4691),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_LT_LPAREN] = ACTIONS(4691),
    [anon_sym_GT_LPAREN] = ACTIONS(4691),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4693),
    [anon_sym_LF] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4693),
  },
  [1748] = {
    [sym__simple_heredoc_body] = ACTIONS(4695),
    [sym__heredoc_body_beginning] = ACTIONS(4695),
    [sym_file_descriptor] = ACTIONS(4695),
    [sym__concat] = ACTIONS(4695),
    [ts_builtin_sym_end] = ACTIONS(4695),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_RPAREN] = ACTIONS(4695),
    [anon_sym_SEMI_SEMI] = ACTIONS(4695),
    [anon_sym_PIPE_AMP] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_EQ_TILDE] = ACTIONS(4697),
    [anon_sym_EQ_EQ] = ACTIONS(4697),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_GT_GT] = ACTIONS(4695),
    [anon_sym_AMP_GT] = ACTIONS(4697),
    [anon_sym_AMP_GT_GT] = ACTIONS(4695),
    [anon_sym_LT_AMP] = ACTIONS(4695),
    [anon_sym_GT_AMP] = ACTIONS(4695),
    [anon_sym_LT_LT] = ACTIONS(4697),
    [anon_sym_LT_LT_DASH] = ACTIONS(4695),
    [anon_sym_LT_LT_LT] = ACTIONS(4695),
    [sym__special_characters] = ACTIONS(4695),
    [anon_sym_DQUOTE] = ACTIONS(4695),
    [anon_sym_DOLLAR] = ACTIONS(4697),
    [sym_raw_string] = ACTIONS(4695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4695),
    [anon_sym_BQUOTE] = ACTIONS(4695),
    [anon_sym_LT_LPAREN] = ACTIONS(4695),
    [anon_sym_GT_LPAREN] = ACTIONS(4695),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4697),
    [anon_sym_LF] = ACTIONS(4695),
    [anon_sym_AMP] = ACTIONS(4697),
  },
  [1749] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4699),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1750] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4701),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1751] = {
    [sym__concat] = ACTIONS(2930),
    [anon_sym_RBRACE] = ACTIONS(2930),
    [anon_sym_EQ] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2932),
    [sym__special_characters] = ACTIONS(2932),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_DOLLAR] = ACTIONS(2932),
    [sym_raw_string] = ACTIONS(2930),
    [anon_sym_POUND] = ACTIONS(2930),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2930),
    [anon_sym_COLON] = ACTIONS(2932),
    [anon_sym_COLON_QMARK] = ACTIONS(2932),
    [anon_sym_COLON_DASH] = ACTIONS(2932),
    [anon_sym_PERCENT] = ACTIONS(2932),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2930),
    [anon_sym_BQUOTE] = ACTIONS(2930),
    [anon_sym_LT_LPAREN] = ACTIONS(2930),
    [anon_sym_GT_LPAREN] = ACTIONS(2930),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(2932),
  },
  [1752] = {
    [sym__concat] = ACTIONS(2944),
    [anon_sym_RBRACE] = ACTIONS(2944),
    [anon_sym_EQ] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [sym__special_characters] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [sym_raw_string] = ACTIONS(2944),
    [anon_sym_POUND] = ACTIONS(2944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2944),
    [anon_sym_COLON] = ACTIONS(2946),
    [anon_sym_COLON_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_DASH] = ACTIONS(2946),
    [anon_sym_PERCENT] = ACTIONS(2946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2944),
    [anon_sym_BQUOTE] = ACTIONS(2944),
    [anon_sym_LT_LPAREN] = ACTIONS(2944),
    [anon_sym_GT_LPAREN] = ACTIONS(2944),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(2946),
  },
  [1753] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4703),
    [sym_comment] = ACTIONS(57),
  },
  [1754] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4705),
    [sym_comment] = ACTIONS(57),
  },
  [1755] = {
    [anon_sym_RBRACE] = ACTIONS(4705),
    [sym_comment] = ACTIONS(57),
  },
  [1756] = {
    [sym_concatenation] = STATE(2032),
    [sym_string] = STATE(2031),
    [sym_simple_expansion] = STATE(2031),
    [sym_string_expansion] = STATE(2031),
    [sym_expansion] = STATE(2031),
    [sym_command_substitution] = STATE(2031),
    [sym_process_substitution] = STATE(2031),
    [anon_sym_RBRACE] = ACTIONS(4705),
    [sym__special_characters] = ACTIONS(4707),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(4709),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4709),
  },
  [1757] = {
    [sym__concat] = ACTIONS(2980),
    [anon_sym_RBRACE] = ACTIONS(2980),
    [anon_sym_EQ] = ACTIONS(2982),
    [anon_sym_DASH] = ACTIONS(2982),
    [sym__special_characters] = ACTIONS(2982),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2982),
    [sym_raw_string] = ACTIONS(2980),
    [anon_sym_POUND] = ACTIONS(2980),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2980),
    [anon_sym_COLON] = ACTIONS(2982),
    [anon_sym_COLON_QMARK] = ACTIONS(2982),
    [anon_sym_COLON_DASH] = ACTIONS(2982),
    [anon_sym_PERCENT] = ACTIONS(2982),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2980),
    [anon_sym_BQUOTE] = ACTIONS(2980),
    [anon_sym_LT_LPAREN] = ACTIONS(2980),
    [anon_sym_GT_LPAREN] = ACTIONS(2980),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(2982),
  },
  [1758] = {
    [sym_concatenation] = STATE(2035),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2035),
    [sym_regex] = ACTIONS(4711),
    [anon_sym_RBRACE] = ACTIONS(4713),
    [anon_sym_EQ] = ACTIONS(4715),
    [anon_sym_DASH] = ACTIONS(4715),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4717),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4715),
    [anon_sym_COLON_QMARK] = ACTIONS(4715),
    [anon_sym_COLON_DASH] = ACTIONS(4715),
    [anon_sym_PERCENT] = ACTIONS(4715),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1759] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4713),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1760] = {
    [sym_concatenation] = STATE(2037),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2037),
    [sym_regex] = ACTIONS(4719),
    [anon_sym_RBRACE] = ACTIONS(4705),
    [anon_sym_EQ] = ACTIONS(4721),
    [anon_sym_DASH] = ACTIONS(4721),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4723),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4721),
    [anon_sym_COLON_QMARK] = ACTIONS(4721),
    [anon_sym_COLON_DASH] = ACTIONS(4721),
    [anon_sym_PERCENT] = ACTIONS(4721),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1761] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4705),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1762] = {
    [sym_concatenation] = STATE(2039),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2039),
    [anon_sym_RBRACE] = ACTIONS(4725),
    [anon_sym_EQ] = ACTIONS(4727),
    [anon_sym_DASH] = ACTIONS(4727),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4727),
    [anon_sym_COLON_QMARK] = ACTIONS(4727),
    [anon_sym_COLON_DASH] = ACTIONS(4727),
    [anon_sym_PERCENT] = ACTIONS(4727),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1763] = {
    [sym__concat] = ACTIONS(3036),
    [anon_sym_RBRACE] = ACTIONS(3036),
    [anon_sym_EQ] = ACTIONS(3038),
    [anon_sym_DASH] = ACTIONS(3038),
    [sym__special_characters] = ACTIONS(3038),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [anon_sym_DOLLAR] = ACTIONS(3038),
    [sym_raw_string] = ACTIONS(3036),
    [anon_sym_POUND] = ACTIONS(3036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3036),
    [anon_sym_COLON] = ACTIONS(3038),
    [anon_sym_COLON_QMARK] = ACTIONS(3038),
    [anon_sym_COLON_DASH] = ACTIONS(3038),
    [anon_sym_PERCENT] = ACTIONS(3038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3036),
    [anon_sym_BQUOTE] = ACTIONS(3036),
    [anon_sym_LT_LPAREN] = ACTIONS(3036),
    [anon_sym_GT_LPAREN] = ACTIONS(3036),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3038),
  },
  [1764] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4725),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1765] = {
    [sym_concatenation] = STATE(2037),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2037),
    [anon_sym_RBRACE] = ACTIONS(4705),
    [anon_sym_EQ] = ACTIONS(4721),
    [anon_sym_DASH] = ACTIONS(4721),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4723),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4721),
    [anon_sym_COLON_QMARK] = ACTIONS(4721),
    [anon_sym_COLON_DASH] = ACTIONS(4721),
    [anon_sym_PERCENT] = ACTIONS(4721),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1766] = {
    [sym__simple_heredoc_body] = ACTIONS(4731),
    [sym__heredoc_body_beginning] = ACTIONS(4731),
    [sym_file_descriptor] = ACTIONS(4731),
    [sym__concat] = ACTIONS(4731),
    [ts_builtin_sym_end] = ACTIONS(4731),
    [anon_sym_SEMI] = ACTIONS(4733),
    [anon_sym_PIPE] = ACTIONS(4733),
    [anon_sym_RPAREN] = ACTIONS(4731),
    [anon_sym_SEMI_SEMI] = ACTIONS(4731),
    [anon_sym_PIPE_AMP] = ACTIONS(4731),
    [anon_sym_AMP_AMP] = ACTIONS(4731),
    [anon_sym_PIPE_PIPE] = ACTIONS(4731),
    [anon_sym_EQ_TILDE] = ACTIONS(4733),
    [anon_sym_EQ_EQ] = ACTIONS(4733),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_GT] = ACTIONS(4731),
    [anon_sym_AMP_GT] = ACTIONS(4733),
    [anon_sym_AMP_GT_GT] = ACTIONS(4731),
    [anon_sym_LT_AMP] = ACTIONS(4731),
    [anon_sym_GT_AMP] = ACTIONS(4731),
    [anon_sym_LT_LT] = ACTIONS(4733),
    [anon_sym_LT_LT_DASH] = ACTIONS(4731),
    [anon_sym_LT_LT_LT] = ACTIONS(4731),
    [sym__special_characters] = ACTIONS(4731),
    [anon_sym_DQUOTE] = ACTIONS(4731),
    [anon_sym_DOLLAR] = ACTIONS(4733),
    [sym_raw_string] = ACTIONS(4731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4731),
    [anon_sym_BQUOTE] = ACTIONS(4731),
    [anon_sym_LT_LPAREN] = ACTIONS(4731),
    [anon_sym_GT_LPAREN] = ACTIONS(4731),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4733),
    [anon_sym_LF] = ACTIONS(4731),
    [anon_sym_AMP] = ACTIONS(4733),
  },
  [1767] = {
    [sym__concat] = ACTIONS(3091),
    [anon_sym_RBRACE] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_DASH] = ACTIONS(3093),
    [sym__special_characters] = ACTIONS(3093),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_DOLLAR] = ACTIONS(3093),
    [sym_raw_string] = ACTIONS(3091),
    [anon_sym_POUND] = ACTIONS(3091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3091),
    [anon_sym_COLON] = ACTIONS(3093),
    [anon_sym_COLON_QMARK] = ACTIONS(3093),
    [anon_sym_COLON_DASH] = ACTIONS(3093),
    [anon_sym_PERCENT] = ACTIONS(3093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3091),
    [anon_sym_BQUOTE] = ACTIONS(3091),
    [anon_sym_LT_LPAREN] = ACTIONS(3091),
    [anon_sym_GT_LPAREN] = ACTIONS(3091),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3093),
  },
  [1768] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4735),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1769] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4735),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1770] = {
    [anon_sym_SEMI] = ACTIONS(4737),
    [anon_sym_RPAREN] = ACTIONS(4735),
    [anon_sym_SEMI_SEMI] = ACTIONS(4739),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4739),
    [anon_sym_AMP] = ACTIONS(4739),
  },
  [1771] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(4735),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1772] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(4735),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1773] = {
    [anon_sym_SEMI] = ACTIONS(4741),
    [anon_sym_SEMI_SEMI] = ACTIONS(4743),
    [anon_sym_BQUOTE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4743),
    [anon_sym_AMP] = ACTIONS(4743),
  },
  [1774] = {
    [sym__concat] = ACTIONS(3121),
    [anon_sym_RBRACE] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [sym__special_characters] = ACTIONS(3123),
    [anon_sym_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [sym_raw_string] = ACTIONS(3121),
    [anon_sym_POUND] = ACTIONS(3121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3121),
    [anon_sym_COLON] = ACTIONS(3123),
    [anon_sym_COLON_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_DASH] = ACTIONS(3123),
    [anon_sym_PERCENT] = ACTIONS(3123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3121),
    [anon_sym_BQUOTE] = ACTIONS(3121),
    [anon_sym_LT_LPAREN] = ACTIONS(3121),
    [anon_sym_GT_LPAREN] = ACTIONS(3121),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3123),
  },
  [1775] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4745),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1776] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4745),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1777] = {
    [anon_sym_SEMI] = ACTIONS(4747),
    [anon_sym_RPAREN] = ACTIONS(4745),
    [anon_sym_SEMI_SEMI] = ACTIONS(4749),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(4749),
  },
  [1778] = {
    [sym__simple_heredoc_body] = ACTIONS(4751),
    [sym__heredoc_body_beginning] = ACTIONS(4751),
    [sym_file_descriptor] = ACTIONS(4751),
    [sym__concat] = ACTIONS(4751),
    [ts_builtin_sym_end] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4753),
    [anon_sym_PIPE] = ACTIONS(4753),
    [anon_sym_RPAREN] = ACTIONS(4751),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_PIPE_AMP] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [anon_sym_EQ_TILDE] = ACTIONS(4753),
    [anon_sym_EQ_EQ] = ACTIONS(4753),
    [anon_sym_LT] = ACTIONS(4753),
    [anon_sym_GT] = ACTIONS(4753),
    [anon_sym_GT_GT] = ACTIONS(4751),
    [anon_sym_AMP_GT] = ACTIONS(4753),
    [anon_sym_AMP_GT_GT] = ACTIONS(4751),
    [anon_sym_LT_AMP] = ACTIONS(4751),
    [anon_sym_GT_AMP] = ACTIONS(4751),
    [anon_sym_LT_LT] = ACTIONS(4753),
    [anon_sym_LT_LT_DASH] = ACTIONS(4751),
    [anon_sym_LT_LT_LT] = ACTIONS(4751),
    [sym__special_characters] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4753),
    [sym_raw_string] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_LT_LPAREN] = ACTIONS(4751),
    [anon_sym_GT_LPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4753),
    [anon_sym_LF] = ACTIONS(4751),
    [anon_sym_AMP] = ACTIONS(4753),
  },
  [1779] = {
    [aux_sym_concatenation_repeat1] = STATE(1779),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(1730),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [1780] = {
    [sym__simple_heredoc_body] = ACTIONS(4755),
    [sym__heredoc_body_beginning] = ACTIONS(4755),
    [sym_file_descriptor] = ACTIONS(4755),
    [sym__concat] = ACTIONS(4755),
    [ts_builtin_sym_end] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4757),
    [anon_sym_PIPE] = ACTIONS(4757),
    [anon_sym_RPAREN] = ACTIONS(4755),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [anon_sym_PIPE_AMP] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [anon_sym_EQ_TILDE] = ACTIONS(4757),
    [anon_sym_EQ_EQ] = ACTIONS(4757),
    [anon_sym_LT] = ACTIONS(4757),
    [anon_sym_GT] = ACTIONS(4757),
    [anon_sym_GT_GT] = ACTIONS(4755),
    [anon_sym_AMP_GT] = ACTIONS(4757),
    [anon_sym_AMP_GT_GT] = ACTIONS(4755),
    [anon_sym_LT_AMP] = ACTIONS(4755),
    [anon_sym_GT_AMP] = ACTIONS(4755),
    [anon_sym_LT_LT] = ACTIONS(4757),
    [anon_sym_LT_LT_DASH] = ACTIONS(4755),
    [anon_sym_LT_LT_LT] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4757),
    [sym_raw_string] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_LT_LPAREN] = ACTIONS(4755),
    [anon_sym_GT_LPAREN] = ACTIONS(4755),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4757),
    [anon_sym_LF] = ACTIONS(4755),
    [anon_sym_AMP] = ACTIONS(4757),
  },
  [1781] = {
    [sym__heredoc_body_middle] = ACTIONS(2944),
    [sym__heredoc_body_end] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2944),
    [sym_comment] = ACTIONS(57),
  },
  [1782] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4759),
    [sym_comment] = ACTIONS(57),
  },
  [1783] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4761),
    [sym_comment] = ACTIONS(57),
  },
  [1784] = {
    [anon_sym_RBRACE] = ACTIONS(4761),
    [sym_comment] = ACTIONS(57),
  },
  [1785] = {
    [sym_concatenation] = STATE(2049),
    [sym_string] = STATE(2048),
    [sym_simple_expansion] = STATE(2048),
    [sym_string_expansion] = STATE(2048),
    [sym_expansion] = STATE(2048),
    [sym_command_substitution] = STATE(2048),
    [sym_process_substitution] = STATE(2048),
    [anon_sym_RBRACE] = ACTIONS(4761),
    [sym__special_characters] = ACTIONS(4763),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(4765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4765),
  },
  [1786] = {
    [sym__heredoc_body_middle] = ACTIONS(2980),
    [sym__heredoc_body_end] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2982),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2980),
    [sym_comment] = ACTIONS(57),
  },
  [1787] = {
    [sym_concatenation] = STATE(2052),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2052),
    [sym_regex] = ACTIONS(4767),
    [anon_sym_RBRACE] = ACTIONS(4769),
    [anon_sym_EQ] = ACTIONS(4771),
    [anon_sym_DASH] = ACTIONS(4771),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4773),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4771),
    [anon_sym_COLON_QMARK] = ACTIONS(4771),
    [anon_sym_COLON_DASH] = ACTIONS(4771),
    [anon_sym_PERCENT] = ACTIONS(4771),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1788] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4769),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1789] = {
    [sym_concatenation] = STATE(2054),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2054),
    [sym_regex] = ACTIONS(4775),
    [anon_sym_RBRACE] = ACTIONS(4761),
    [anon_sym_EQ] = ACTIONS(4777),
    [anon_sym_DASH] = ACTIONS(4777),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4777),
    [anon_sym_COLON_QMARK] = ACTIONS(4777),
    [anon_sym_COLON_DASH] = ACTIONS(4777),
    [anon_sym_PERCENT] = ACTIONS(4777),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1790] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4761),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1791] = {
    [sym_concatenation] = STATE(2056),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2056),
    [anon_sym_RBRACE] = ACTIONS(4781),
    [anon_sym_EQ] = ACTIONS(4783),
    [anon_sym_DASH] = ACTIONS(4783),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4785),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4783),
    [anon_sym_COLON_QMARK] = ACTIONS(4783),
    [anon_sym_COLON_DASH] = ACTIONS(4783),
    [anon_sym_PERCENT] = ACTIONS(4783),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1792] = {
    [sym__heredoc_body_middle] = ACTIONS(3036),
    [sym__heredoc_body_end] = ACTIONS(3036),
    [anon_sym_DOLLAR] = ACTIONS(3038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3036),
    [sym_comment] = ACTIONS(57),
  },
  [1793] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4781),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1794] = {
    [sym_concatenation] = STATE(2054),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2054),
    [anon_sym_RBRACE] = ACTIONS(4761),
    [anon_sym_EQ] = ACTIONS(4777),
    [anon_sym_DASH] = ACTIONS(4777),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4777),
    [anon_sym_COLON_QMARK] = ACTIONS(4777),
    [anon_sym_COLON_DASH] = ACTIONS(4777),
    [anon_sym_PERCENT] = ACTIONS(4777),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1795] = {
    [sym__concat] = ACTIONS(2930),
    [anon_sym_RPAREN] = ACTIONS(2930),
    [sym__special_characters] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_DOLLAR] = ACTIONS(2932),
    [sym_raw_string] = ACTIONS(2930),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2930),
    [anon_sym_BQUOTE] = ACTIONS(2930),
    [anon_sym_LT_LPAREN] = ACTIONS(2930),
    [anon_sym_GT_LPAREN] = ACTIONS(2930),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2930),
  },
  [1796] = {
    [sym__concat] = ACTIONS(2944),
    [anon_sym_RPAREN] = ACTIONS(2944),
    [sym__special_characters] = ACTIONS(2944),
    [anon_sym_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [sym_raw_string] = ACTIONS(2944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2944),
    [anon_sym_BQUOTE] = ACTIONS(2944),
    [anon_sym_LT_LPAREN] = ACTIONS(2944),
    [anon_sym_GT_LPAREN] = ACTIONS(2944),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2944),
  },
  [1797] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4787),
    [sym_comment] = ACTIONS(57),
  },
  [1798] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4789),
    [sym_comment] = ACTIONS(57),
  },
  [1799] = {
    [anon_sym_RBRACE] = ACTIONS(4789),
    [sym_comment] = ACTIONS(57),
  },
  [1800] = {
    [sym_concatenation] = STATE(2061),
    [sym_string] = STATE(2060),
    [sym_simple_expansion] = STATE(2060),
    [sym_string_expansion] = STATE(2060),
    [sym_expansion] = STATE(2060),
    [sym_command_substitution] = STATE(2060),
    [sym_process_substitution] = STATE(2060),
    [anon_sym_RBRACE] = ACTIONS(4789),
    [sym__special_characters] = ACTIONS(4791),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(4793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4793),
  },
  [1801] = {
    [sym__concat] = ACTIONS(2980),
    [anon_sym_RPAREN] = ACTIONS(2980),
    [sym__special_characters] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2982),
    [sym_raw_string] = ACTIONS(2980),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2980),
    [anon_sym_BQUOTE] = ACTIONS(2980),
    [anon_sym_LT_LPAREN] = ACTIONS(2980),
    [anon_sym_GT_LPAREN] = ACTIONS(2980),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2980),
  },
  [1802] = {
    [sym_concatenation] = STATE(2064),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2064),
    [sym_regex] = ACTIONS(4795),
    [anon_sym_RBRACE] = ACTIONS(4797),
    [anon_sym_EQ] = ACTIONS(4799),
    [anon_sym_DASH] = ACTIONS(4799),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4801),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4799),
    [anon_sym_COLON_QMARK] = ACTIONS(4799),
    [anon_sym_COLON_DASH] = ACTIONS(4799),
    [anon_sym_PERCENT] = ACTIONS(4799),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1803] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4797),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1804] = {
    [sym_concatenation] = STATE(2066),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2066),
    [sym_regex] = ACTIONS(4803),
    [anon_sym_RBRACE] = ACTIONS(4789),
    [anon_sym_EQ] = ACTIONS(4805),
    [anon_sym_DASH] = ACTIONS(4805),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4805),
    [anon_sym_COLON_QMARK] = ACTIONS(4805),
    [anon_sym_COLON_DASH] = ACTIONS(4805),
    [anon_sym_PERCENT] = ACTIONS(4805),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1805] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4789),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1806] = {
    [sym_concatenation] = STATE(2068),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2068),
    [anon_sym_RBRACE] = ACTIONS(4809),
    [anon_sym_EQ] = ACTIONS(4811),
    [anon_sym_DASH] = ACTIONS(4811),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4813),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4811),
    [anon_sym_COLON_QMARK] = ACTIONS(4811),
    [anon_sym_COLON_DASH] = ACTIONS(4811),
    [anon_sym_PERCENT] = ACTIONS(4811),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1807] = {
    [sym__concat] = ACTIONS(3036),
    [anon_sym_RPAREN] = ACTIONS(3036),
    [sym__special_characters] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [anon_sym_DOLLAR] = ACTIONS(3038),
    [sym_raw_string] = ACTIONS(3036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3036),
    [anon_sym_BQUOTE] = ACTIONS(3036),
    [anon_sym_LT_LPAREN] = ACTIONS(3036),
    [anon_sym_GT_LPAREN] = ACTIONS(3036),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3036),
  },
  [1808] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4809),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1809] = {
    [sym_concatenation] = STATE(2066),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2066),
    [anon_sym_RBRACE] = ACTIONS(4789),
    [anon_sym_EQ] = ACTIONS(4805),
    [anon_sym_DASH] = ACTIONS(4805),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4805),
    [anon_sym_COLON_QMARK] = ACTIONS(4805),
    [anon_sym_COLON_DASH] = ACTIONS(4805),
    [anon_sym_PERCENT] = ACTIONS(4805),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1810] = {
    [sym__concat] = ACTIONS(3091),
    [anon_sym_RPAREN] = ACTIONS(3091),
    [sym__special_characters] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_DOLLAR] = ACTIONS(3093),
    [sym_raw_string] = ACTIONS(3091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3091),
    [anon_sym_BQUOTE] = ACTIONS(3091),
    [anon_sym_LT_LPAREN] = ACTIONS(3091),
    [anon_sym_GT_LPAREN] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3091),
  },
  [1811] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4815),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1812] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4815),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1813] = {
    [anon_sym_SEMI] = ACTIONS(4817),
    [anon_sym_RPAREN] = ACTIONS(4815),
    [anon_sym_SEMI_SEMI] = ACTIONS(4819),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4819),
    [anon_sym_AMP] = ACTIONS(4819),
  },
  [1814] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(4815),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1815] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(4815),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1816] = {
    [anon_sym_SEMI] = ACTIONS(4821),
    [anon_sym_SEMI_SEMI] = ACTIONS(4823),
    [anon_sym_BQUOTE] = ACTIONS(4815),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4823),
    [anon_sym_AMP] = ACTIONS(4823),
  },
  [1817] = {
    [sym__concat] = ACTIONS(3121),
    [anon_sym_RPAREN] = ACTIONS(3121),
    [sym__special_characters] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [sym_raw_string] = ACTIONS(3121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3121),
    [anon_sym_BQUOTE] = ACTIONS(3121),
    [anon_sym_LT_LPAREN] = ACTIONS(3121),
    [anon_sym_GT_LPAREN] = ACTIONS(3121),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3121),
  },
  [1818] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4825),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1819] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4825),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1820] = {
    [anon_sym_SEMI] = ACTIONS(4827),
    [anon_sym_RPAREN] = ACTIONS(4825),
    [anon_sym_SEMI_SEMI] = ACTIONS(4829),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4829),
    [anon_sym_AMP] = ACTIONS(4829),
  },
  [1821] = {
    [sym__simple_heredoc_body] = ACTIONS(3921),
    [sym__heredoc_body_beginning] = ACTIONS(3921),
    [sym_file_descriptor] = ACTIONS(3921),
    [sym__concat] = ACTIONS(3921),
    [sym_variable_name] = ACTIONS(3921),
    [ts_builtin_sym_end] = ACTIONS(3921),
    [anon_sym_SEMI] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_RPAREN] = ACTIONS(3921),
    [anon_sym_SEMI_SEMI] = ACTIONS(3921),
    [anon_sym_PIPE_AMP] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_GT_GT] = ACTIONS(3921),
    [anon_sym_AMP_GT] = ACTIONS(3923),
    [anon_sym_AMP_GT_GT] = ACTIONS(3921),
    [anon_sym_LT_AMP] = ACTIONS(3921),
    [anon_sym_GT_AMP] = ACTIONS(3921),
    [anon_sym_LT_LT] = ACTIONS(3923),
    [anon_sym_LT_LT_DASH] = ACTIONS(3921),
    [anon_sym_LT_LT_LT] = ACTIONS(3921),
    [sym__special_characters] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_DOLLAR] = ACTIONS(3923),
    [sym_raw_string] = ACTIONS(3921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3921),
    [anon_sym_BQUOTE] = ACTIONS(3921),
    [anon_sym_LT_LPAREN] = ACTIONS(3921),
    [anon_sym_GT_LPAREN] = ACTIONS(3921),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3923),
    [anon_sym_LF] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3923),
  },
  [1822] = {
    [sym__simple_heredoc_body] = ACTIONS(3929),
    [sym__heredoc_body_beginning] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [sym__concat] = ACTIONS(3929),
    [sym_variable_name] = ACTIONS(3929),
    [ts_builtin_sym_end] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3931),
    [anon_sym_RPAREN] = ACTIONS(3929),
    [anon_sym_SEMI_SEMI] = ACTIONS(3929),
    [anon_sym_PIPE_AMP] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_AMP_GT] = ACTIONS(3931),
    [anon_sym_AMP_GT_GT] = ACTIONS(3929),
    [anon_sym_LT_AMP] = ACTIONS(3929),
    [anon_sym_GT_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_LT_LT_DASH] = ACTIONS(3929),
    [anon_sym_LT_LT_LT] = ACTIONS(3929),
    [sym__special_characters] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [sym_raw_string] = ACTIONS(3929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3929),
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [anon_sym_LT_LPAREN] = ACTIONS(3929),
    [anon_sym_GT_LPAREN] = ACTIONS(3929),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3931),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
  },
  [1823] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4831),
    [sym_comment] = ACTIONS(57),
  },
  [1824] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4833),
    [sym_comment] = ACTIONS(57),
  },
  [1825] = {
    [anon_sym_RBRACE] = ACTIONS(4833),
    [sym_comment] = ACTIONS(57),
  },
  [1826] = {
    [sym_concatenation] = STATE(2077),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2077),
    [anon_sym_RBRACE] = ACTIONS(4835),
    [anon_sym_EQ] = ACTIONS(4837),
    [anon_sym_DASH] = ACTIONS(4837),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4839),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4837),
    [anon_sym_COLON_QMARK] = ACTIONS(4837),
    [anon_sym_COLON_DASH] = ACTIONS(4837),
    [anon_sym_PERCENT] = ACTIONS(4837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1827] = {
    [sym__simple_heredoc_body] = ACTIONS(3985),
    [sym__heredoc_body_beginning] = ACTIONS(3985),
    [sym_file_descriptor] = ACTIONS(3985),
    [sym__concat] = ACTIONS(3985),
    [sym_variable_name] = ACTIONS(3985),
    [ts_builtin_sym_end] = ACTIONS(3985),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_RPAREN] = ACTIONS(3985),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_AMP_GT] = ACTIONS(3987),
    [anon_sym_AMP_GT_GT] = ACTIONS(3985),
    [anon_sym_LT_AMP] = ACTIONS(3985),
    [anon_sym_GT_AMP] = ACTIONS(3985),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_LT_LT_DASH] = ACTIONS(3985),
    [anon_sym_LT_LT_LT] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [1828] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4835),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1829] = {
    [sym_concatenation] = STATE(2078),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2078),
    [anon_sym_RBRACE] = ACTIONS(4833),
    [anon_sym_EQ] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(4841),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4843),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4841),
    [anon_sym_COLON_QMARK] = ACTIONS(4841),
    [anon_sym_COLON_DASH] = ACTIONS(4841),
    [anon_sym_PERCENT] = ACTIONS(4841),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1830] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4833),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1831] = {
    [sym__simple_heredoc_body] = ACTIONS(4030),
    [sym__heredoc_body_beginning] = ACTIONS(4030),
    [sym_file_descriptor] = ACTIONS(4030),
    [sym__concat] = ACTIONS(4030),
    [sym_variable_name] = ACTIONS(4030),
    [ts_builtin_sym_end] = ACTIONS(4030),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_RPAREN] = ACTIONS(4030),
    [anon_sym_SEMI_SEMI] = ACTIONS(4030),
    [anon_sym_PIPE_AMP] = ACTIONS(4030),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_LT] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(4032),
    [anon_sym_GT_GT] = ACTIONS(4030),
    [anon_sym_AMP_GT] = ACTIONS(4032),
    [anon_sym_AMP_GT_GT] = ACTIONS(4030),
    [anon_sym_LT_AMP] = ACTIONS(4030),
    [anon_sym_GT_AMP] = ACTIONS(4030),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_LT_LT_DASH] = ACTIONS(4030),
    [anon_sym_LT_LT_LT] = ACTIONS(4030),
    [sym__special_characters] = ACTIONS(4030),
    [anon_sym_DQUOTE] = ACTIONS(4030),
    [anon_sym_DOLLAR] = ACTIONS(4032),
    [sym_raw_string] = ACTIONS(4030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4030),
    [anon_sym_BQUOTE] = ACTIONS(4030),
    [anon_sym_LT_LPAREN] = ACTIONS(4030),
    [anon_sym_GT_LPAREN] = ACTIONS(4030),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4032),
    [anon_sym_LF] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4032),
  },
  [1832] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4845),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1833] = {
    [sym__simple_heredoc_body] = ACTIONS(4064),
    [sym__heredoc_body_beginning] = ACTIONS(4064),
    [sym_file_descriptor] = ACTIONS(4064),
    [sym__concat] = ACTIONS(4064),
    [sym_variable_name] = ACTIONS(4064),
    [ts_builtin_sym_end] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_RPAREN] = ACTIONS(4064),
    [anon_sym_SEMI_SEMI] = ACTIONS(4064),
    [anon_sym_PIPE_AMP] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_GT_GT] = ACTIONS(4064),
    [anon_sym_AMP_GT] = ACTIONS(4066),
    [anon_sym_AMP_GT_GT] = ACTIONS(4064),
    [anon_sym_LT_AMP] = ACTIONS(4064),
    [anon_sym_GT_AMP] = ACTIONS(4064),
    [anon_sym_LT_LT] = ACTIONS(4066),
    [anon_sym_LT_LT_DASH] = ACTIONS(4064),
    [anon_sym_LT_LT_LT] = ACTIONS(4064),
    [sym__special_characters] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_DOLLAR] = ACTIONS(4066),
    [sym_raw_string] = ACTIONS(4064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4064),
    [anon_sym_BQUOTE] = ACTIONS(4064),
    [anon_sym_LT_LPAREN] = ACTIONS(4064),
    [anon_sym_GT_LPAREN] = ACTIONS(4064),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4066),
    [anon_sym_LF] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4066),
  },
  [1834] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4847),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1835] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(4847),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1836] = {
    [sym__simple_heredoc_body] = ACTIONS(4070),
    [sym__heredoc_body_beginning] = ACTIONS(4070),
    [sym_file_descriptor] = ACTIONS(4070),
    [sym__concat] = ACTIONS(4070),
    [sym_variable_name] = ACTIONS(4070),
    [ts_builtin_sym_end] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_PIPE] = ACTIONS(4072),
    [anon_sym_RPAREN] = ACTIONS(4070),
    [anon_sym_SEMI_SEMI] = ACTIONS(4070),
    [anon_sym_PIPE_AMP] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4070),
    [anon_sym_PIPE_PIPE] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_GT] = ACTIONS(4072),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_AMP_GT] = ACTIONS(4072),
    [anon_sym_AMP_GT_GT] = ACTIONS(4070),
    [anon_sym_LT_AMP] = ACTIONS(4070),
    [anon_sym_GT_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4072),
    [anon_sym_LT_LT_DASH] = ACTIONS(4070),
    [anon_sym_LT_LT_LT] = ACTIONS(4070),
    [sym__special_characters] = ACTIONS(4070),
    [anon_sym_DQUOTE] = ACTIONS(4070),
    [anon_sym_DOLLAR] = ACTIONS(4072),
    [sym_raw_string] = ACTIONS(4070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4070),
    [anon_sym_BQUOTE] = ACTIONS(4070),
    [anon_sym_LT_LPAREN] = ACTIONS(4070),
    [anon_sym_GT_LPAREN] = ACTIONS(4070),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4072),
    [anon_sym_LF] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4072),
  },
  [1837] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4849),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1838] = {
    [sym__simple_heredoc_body] = ACTIONS(4851),
    [sym__heredoc_body_beginning] = ACTIONS(4851),
    [sym_file_descriptor] = ACTIONS(4851),
    [ts_builtin_sym_end] = ACTIONS(4851),
    [anon_sym_SEMI] = ACTIONS(4853),
    [anon_sym_esac] = ACTIONS(4851),
    [anon_sym_PIPE] = ACTIONS(4853),
    [anon_sym_RPAREN] = ACTIONS(4851),
    [anon_sym_SEMI_SEMI] = ACTIONS(4851),
    [anon_sym_PIPE_AMP] = ACTIONS(4851),
    [anon_sym_AMP_AMP] = ACTIONS(4851),
    [anon_sym_PIPE_PIPE] = ACTIONS(4851),
    [anon_sym_LT] = ACTIONS(4853),
    [anon_sym_GT] = ACTIONS(4853),
    [anon_sym_GT_GT] = ACTIONS(4851),
    [anon_sym_AMP_GT] = ACTIONS(4853),
    [anon_sym_AMP_GT_GT] = ACTIONS(4851),
    [anon_sym_LT_AMP] = ACTIONS(4851),
    [anon_sym_GT_AMP] = ACTIONS(4851),
    [anon_sym_LT_LT] = ACTIONS(4853),
    [anon_sym_LT_LT_DASH] = ACTIONS(4851),
    [anon_sym_LT_LT_LT] = ACTIONS(4851),
    [anon_sym_BQUOTE] = ACTIONS(4851),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4851),
    [anon_sym_AMP] = ACTIONS(4853),
  },
  [1839] = {
    [sym_do_group] = STATE(2082),
    [sym_compound_statement] = STATE(2082),
    [anon_sym_do] = ACTIONS(493),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [1840] = {
    [sym_do_group] = STATE(2082),
    [sym_compound_statement] = STATE(2082),
    [anon_sym_SEMI] = ACTIONS(4855),
    [anon_sym_do] = ACTIONS(493),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [1841] = {
    [sym__concat] = ACTIONS(3921),
    [anon_sym_SEMI] = ACTIONS(3923),
    [anon_sym_SEMI_SEMI] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_EQ_TILDE] = ACTIONS(3921),
    [anon_sym_EQ_EQ] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_PLUS_EQ] = ACTIONS(3921),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_EQ] = ACTIONS(3921),
    [anon_sym_LT_EQ] = ACTIONS(3921),
    [anon_sym_GT_EQ] = ACTIONS(3921),
    [anon_sym_PLUS_PLUS] = ACTIONS(3921),
    [anon_sym_DASH_DASH] = ACTIONS(3921),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3921),
    [anon_sym_LF] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3923),
  },
  [1842] = {
    [sym__concat] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3931),
    [anon_sym_SEMI_SEMI] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_EQ_TILDE] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_PLUS_EQ] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_DASH_EQ] = ACTIONS(3929),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3929),
    [anon_sym_DASH_DASH] = ACTIONS(3929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3929),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
  },
  [1843] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4857),
    [sym_comment] = ACTIONS(57),
  },
  [1844] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4859),
    [sym_comment] = ACTIONS(57),
  },
  [1845] = {
    [anon_sym_RBRACE] = ACTIONS(4859),
    [sym_comment] = ACTIONS(57),
  },
  [1846] = {
    [sym_concatenation] = STATE(2087),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2087),
    [anon_sym_RBRACE] = ACTIONS(4861),
    [anon_sym_EQ] = ACTIONS(4863),
    [anon_sym_DASH] = ACTIONS(4863),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4863),
    [anon_sym_COLON_QMARK] = ACTIONS(4863),
    [anon_sym_COLON_DASH] = ACTIONS(4863),
    [anon_sym_PERCENT] = ACTIONS(4863),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1847] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_EQ_TILDE] = ACTIONS(3985),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_EQ] = ACTIONS(3987),
    [anon_sym_PLUS_EQ] = ACTIONS(3985),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_PLUS] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3987),
    [anon_sym_DASH_EQ] = ACTIONS(3985),
    [anon_sym_LT_EQ] = ACTIONS(3985),
    [anon_sym_GT_EQ] = ACTIONS(3985),
    [anon_sym_PLUS_PLUS] = ACTIONS(3985),
    [anon_sym_DASH_DASH] = ACTIONS(3985),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3985),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [1848] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4861),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1849] = {
    [sym_concatenation] = STATE(2088),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2088),
    [anon_sym_RBRACE] = ACTIONS(4859),
    [anon_sym_EQ] = ACTIONS(4867),
    [anon_sym_DASH] = ACTIONS(4867),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4867),
    [anon_sym_COLON_QMARK] = ACTIONS(4867),
    [anon_sym_COLON_DASH] = ACTIONS(4867),
    [anon_sym_PERCENT] = ACTIONS(4867),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1850] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4859),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1851] = {
    [sym__concat] = ACTIONS(4030),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_SEMI_SEMI] = ACTIONS(4030),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_EQ_TILDE] = ACTIONS(4030),
    [anon_sym_EQ_EQ] = ACTIONS(4030),
    [anon_sym_EQ] = ACTIONS(4032),
    [anon_sym_PLUS_EQ] = ACTIONS(4030),
    [anon_sym_LT] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(4032),
    [anon_sym_BANG_EQ] = ACTIONS(4030),
    [anon_sym_PLUS] = ACTIONS(4032),
    [anon_sym_DASH] = ACTIONS(4032),
    [anon_sym_DASH_EQ] = ACTIONS(4030),
    [anon_sym_LT_EQ] = ACTIONS(4030),
    [anon_sym_GT_EQ] = ACTIONS(4030),
    [anon_sym_PLUS_PLUS] = ACTIONS(4030),
    [anon_sym_DASH_DASH] = ACTIONS(4030),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4030),
    [anon_sym_LF] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4032),
  },
  [1852] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4871),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1853] = {
    [sym__concat] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_SEMI_SEMI] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_EQ_TILDE] = ACTIONS(4064),
    [anon_sym_EQ_EQ] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4066),
    [anon_sym_PLUS_EQ] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_DASH_EQ] = ACTIONS(4064),
    [anon_sym_LT_EQ] = ACTIONS(4064),
    [anon_sym_GT_EQ] = ACTIONS(4064),
    [anon_sym_PLUS_PLUS] = ACTIONS(4064),
    [anon_sym_DASH_DASH] = ACTIONS(4064),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4064),
    [anon_sym_LF] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4066),
  },
  [1854] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4873),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1855] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(4873),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1856] = {
    [sym__concat] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_SEMI_SEMI] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4070),
    [anon_sym_PIPE_PIPE] = ACTIONS(4070),
    [anon_sym_EQ_TILDE] = ACTIONS(4070),
    [anon_sym_EQ_EQ] = ACTIONS(4070),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_PLUS_EQ] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_GT] = ACTIONS(4072),
    [anon_sym_BANG_EQ] = ACTIONS(4070),
    [anon_sym_PLUS] = ACTIONS(4072),
    [anon_sym_DASH] = ACTIONS(4072),
    [anon_sym_DASH_EQ] = ACTIONS(4070),
    [anon_sym_LT_EQ] = ACTIONS(4070),
    [anon_sym_GT_EQ] = ACTIONS(4070),
    [anon_sym_PLUS_PLUS] = ACTIONS(4070),
    [anon_sym_DASH_DASH] = ACTIONS(4070),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4070),
    [anon_sym_LF] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4072),
  },
  [1857] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4875),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1858] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4877),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE_PIPE] = ACTIONS(465),
    [anon_sym_EQ_TILDE] = ACTIONS(467),
    [anon_sym_EQ_EQ] = ACTIONS(467),
    [anon_sym_EQ] = ACTIONS(469),
    [anon_sym_PLUS_EQ] = ACTIONS(465),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_BANG_EQ] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(469),
    [anon_sym_DASH] = ACTIONS(469),
    [anon_sym_DASH_EQ] = ACTIONS(465),
    [anon_sym_LT_EQ] = ACTIONS(465),
    [anon_sym_GT_EQ] = ACTIONS(465),
    [anon_sym_PLUS_PLUS] = ACTIONS(471),
    [anon_sym_DASH_DASH] = ACTIONS(471),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(465),
  },
  [1859] = {
    [sym__concat] = ACTIONS(2930),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym_SEMI_SEMI] = ACTIONS(2930),
    [sym__special_characters] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_DOLLAR] = ACTIONS(2932),
    [sym_raw_string] = ACTIONS(2930),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2930),
    [anon_sym_BQUOTE] = ACTIONS(2930),
    [anon_sym_LT_LPAREN] = ACTIONS(2930),
    [anon_sym_GT_LPAREN] = ACTIONS(2930),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2932),
    [anon_sym_LF] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2930),
  },
  [1860] = {
    [sym__concat] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym_SEMI_SEMI] = ACTIONS(2944),
    [sym__special_characters] = ACTIONS(2944),
    [anon_sym_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [sym_raw_string] = ACTIONS(2944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2944),
    [anon_sym_BQUOTE] = ACTIONS(2944),
    [anon_sym_LT_LPAREN] = ACTIONS(2944),
    [anon_sym_GT_LPAREN] = ACTIONS(2944),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2946),
    [anon_sym_LF] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2944),
  },
  [1861] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4879),
    [sym_comment] = ACTIONS(57),
  },
  [1862] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4881),
    [sym_comment] = ACTIONS(57),
  },
  [1863] = {
    [anon_sym_RBRACE] = ACTIONS(4881),
    [sym_comment] = ACTIONS(57),
  },
  [1864] = {
    [sym_concatenation] = STATE(2097),
    [sym_string] = STATE(2096),
    [sym_simple_expansion] = STATE(2096),
    [sym_string_expansion] = STATE(2096),
    [sym_expansion] = STATE(2096),
    [sym_command_substitution] = STATE(2096),
    [sym_process_substitution] = STATE(2096),
    [anon_sym_RBRACE] = ACTIONS(4881),
    [sym__special_characters] = ACTIONS(4883),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(4885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4885),
  },
  [1865] = {
    [sym__concat] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym_SEMI_SEMI] = ACTIONS(2980),
    [sym__special_characters] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2982),
    [sym_raw_string] = ACTIONS(2980),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2980),
    [anon_sym_BQUOTE] = ACTIONS(2980),
    [anon_sym_LT_LPAREN] = ACTIONS(2980),
    [anon_sym_GT_LPAREN] = ACTIONS(2980),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2982),
    [anon_sym_LF] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2980),
  },
  [1866] = {
    [sym_concatenation] = STATE(2100),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2100),
    [sym_regex] = ACTIONS(4887),
    [anon_sym_RBRACE] = ACTIONS(4889),
    [anon_sym_EQ] = ACTIONS(4891),
    [anon_sym_DASH] = ACTIONS(4891),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4891),
    [anon_sym_COLON_QMARK] = ACTIONS(4891),
    [anon_sym_COLON_DASH] = ACTIONS(4891),
    [anon_sym_PERCENT] = ACTIONS(4891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1867] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4889),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1868] = {
    [sym_concatenation] = STATE(2102),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2102),
    [sym_regex] = ACTIONS(4895),
    [anon_sym_RBRACE] = ACTIONS(4881),
    [anon_sym_EQ] = ACTIONS(4897),
    [anon_sym_DASH] = ACTIONS(4897),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4897),
    [anon_sym_COLON_QMARK] = ACTIONS(4897),
    [anon_sym_COLON_DASH] = ACTIONS(4897),
    [anon_sym_PERCENT] = ACTIONS(4897),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1869] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4881),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1870] = {
    [sym_concatenation] = STATE(2104),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2104),
    [anon_sym_RBRACE] = ACTIONS(4901),
    [anon_sym_EQ] = ACTIONS(4903),
    [anon_sym_DASH] = ACTIONS(4903),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4903),
    [anon_sym_COLON_QMARK] = ACTIONS(4903),
    [anon_sym_COLON_DASH] = ACTIONS(4903),
    [anon_sym_PERCENT] = ACTIONS(4903),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1871] = {
    [sym__concat] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym_SEMI_SEMI] = ACTIONS(3036),
    [sym__special_characters] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [anon_sym_DOLLAR] = ACTIONS(3038),
    [sym_raw_string] = ACTIONS(3036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3036),
    [anon_sym_BQUOTE] = ACTIONS(3036),
    [anon_sym_LT_LPAREN] = ACTIONS(3036),
    [anon_sym_GT_LPAREN] = ACTIONS(3036),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3038),
    [anon_sym_LF] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3036),
  },
  [1872] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4901),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1873] = {
    [sym_concatenation] = STATE(2102),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2102),
    [anon_sym_RBRACE] = ACTIONS(4881),
    [anon_sym_EQ] = ACTIONS(4897),
    [anon_sym_DASH] = ACTIONS(4897),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4897),
    [anon_sym_COLON_QMARK] = ACTIONS(4897),
    [anon_sym_COLON_DASH] = ACTIONS(4897),
    [anon_sym_PERCENT] = ACTIONS(4897),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1874] = {
    [sym__concat] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_SEMI_SEMI] = ACTIONS(3091),
    [sym__special_characters] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_DOLLAR] = ACTIONS(3093),
    [sym_raw_string] = ACTIONS(3091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3091),
    [anon_sym_BQUOTE] = ACTIONS(3091),
    [anon_sym_LT_LPAREN] = ACTIONS(3091),
    [anon_sym_GT_LPAREN] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3093),
    [anon_sym_LF] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3091),
  },
  [1875] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4907),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1876] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4907),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1877] = {
    [anon_sym_SEMI] = ACTIONS(4909),
    [anon_sym_RPAREN] = ACTIONS(4907),
    [anon_sym_SEMI_SEMI] = ACTIONS(4911),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4911),
    [anon_sym_AMP] = ACTIONS(4911),
  },
  [1878] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(4907),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1879] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(4907),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1880] = {
    [anon_sym_SEMI] = ACTIONS(4913),
    [anon_sym_SEMI_SEMI] = ACTIONS(4915),
    [anon_sym_BQUOTE] = ACTIONS(4907),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4915),
  },
  [1881] = {
    [sym__concat] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3123),
    [anon_sym_SEMI_SEMI] = ACTIONS(3121),
    [sym__special_characters] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [sym_raw_string] = ACTIONS(3121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3121),
    [anon_sym_BQUOTE] = ACTIONS(3121),
    [anon_sym_LT_LPAREN] = ACTIONS(3121),
    [anon_sym_GT_LPAREN] = ACTIONS(3121),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3123),
    [anon_sym_LF] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3121),
  },
  [1882] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4917),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1883] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(4917),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [1884] = {
    [anon_sym_SEMI] = ACTIONS(4919),
    [anon_sym_RPAREN] = ACTIONS(4917),
    [anon_sym_SEMI_SEMI] = ACTIONS(4921),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4921),
    [anon_sym_AMP] = ACTIONS(4921),
  },
  [1885] = {
    [sym__concat] = ACTIONS(3921),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_RPAREN] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_EQ_TILDE] = ACTIONS(3921),
    [anon_sym_EQ_EQ] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_PLUS_EQ] = ACTIONS(3921),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_EQ] = ACTIONS(3921),
    [anon_sym_LT_EQ] = ACTIONS(3921),
    [anon_sym_GT_EQ] = ACTIONS(3921),
    [anon_sym_PLUS_PLUS] = ACTIONS(3921),
    [anon_sym_DASH_DASH] = ACTIONS(3921),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3921),
  },
  [1886] = {
    [sym__concat] = ACTIONS(3929),
    [anon_sym_PIPE] = ACTIONS(3931),
    [anon_sym_RPAREN] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_EQ_TILDE] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_PLUS_EQ] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_DASH_EQ] = ACTIONS(3929),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3929),
    [anon_sym_DASH_DASH] = ACTIONS(3929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3929),
  },
  [1887] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4923),
    [sym_comment] = ACTIONS(57),
  },
  [1888] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(4925),
    [sym_comment] = ACTIONS(57),
  },
  [1889] = {
    [anon_sym_RBRACE] = ACTIONS(4925),
    [sym_comment] = ACTIONS(57),
  },
  [1890] = {
    [sym_concatenation] = STATE(2113),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2113),
    [anon_sym_RBRACE] = ACTIONS(4927),
    [anon_sym_EQ] = ACTIONS(4929),
    [anon_sym_DASH] = ACTIONS(4929),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4931),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4929),
    [anon_sym_COLON_QMARK] = ACTIONS(4929),
    [anon_sym_COLON_DASH] = ACTIONS(4929),
    [anon_sym_PERCENT] = ACTIONS(4929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1891] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_RPAREN] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_EQ_TILDE] = ACTIONS(3985),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_EQ] = ACTIONS(3987),
    [anon_sym_PLUS_EQ] = ACTIONS(3985),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_PLUS] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3987),
    [anon_sym_DASH_EQ] = ACTIONS(3985),
    [anon_sym_LT_EQ] = ACTIONS(3985),
    [anon_sym_GT_EQ] = ACTIONS(3985),
    [anon_sym_PLUS_PLUS] = ACTIONS(3985),
    [anon_sym_DASH_DASH] = ACTIONS(3985),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(3985),
  },
  [1892] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4927),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1893] = {
    [sym_concatenation] = STATE(2114),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2114),
    [anon_sym_RBRACE] = ACTIONS(4925),
    [anon_sym_EQ] = ACTIONS(4933),
    [anon_sym_DASH] = ACTIONS(4933),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(4935),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_DASH] = ACTIONS(4933),
    [anon_sym_PERCENT] = ACTIONS(4933),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1894] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4925),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1895] = {
    [sym__concat] = ACTIONS(4030),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_RPAREN] = ACTIONS(4030),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_EQ_TILDE] = ACTIONS(4030),
    [anon_sym_EQ_EQ] = ACTIONS(4030),
    [anon_sym_EQ] = ACTIONS(4032),
    [anon_sym_PLUS_EQ] = ACTIONS(4030),
    [anon_sym_LT] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(4032),
    [anon_sym_BANG_EQ] = ACTIONS(4030),
    [anon_sym_PLUS] = ACTIONS(4032),
    [anon_sym_DASH] = ACTIONS(4032),
    [anon_sym_DASH_EQ] = ACTIONS(4030),
    [anon_sym_LT_EQ] = ACTIONS(4030),
    [anon_sym_GT_EQ] = ACTIONS(4030),
    [anon_sym_PLUS_PLUS] = ACTIONS(4030),
    [anon_sym_DASH_DASH] = ACTIONS(4030),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4030),
  },
  [1896] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4937),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1897] = {
    [sym__concat] = ACTIONS(4064),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_RPAREN] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_EQ_TILDE] = ACTIONS(4064),
    [anon_sym_EQ_EQ] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4066),
    [anon_sym_PLUS_EQ] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_DASH_EQ] = ACTIONS(4064),
    [anon_sym_LT_EQ] = ACTIONS(4064),
    [anon_sym_GT_EQ] = ACTIONS(4064),
    [anon_sym_PLUS_PLUS] = ACTIONS(4064),
    [anon_sym_DASH_DASH] = ACTIONS(4064),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4064),
  },
  [1898] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4939),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1899] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(4939),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1900] = {
    [sym__concat] = ACTIONS(4070),
    [anon_sym_PIPE] = ACTIONS(4072),
    [anon_sym_RPAREN] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4070),
    [anon_sym_PIPE_PIPE] = ACTIONS(4070),
    [anon_sym_EQ_TILDE] = ACTIONS(4070),
    [anon_sym_EQ_EQ] = ACTIONS(4070),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_PLUS_EQ] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_GT] = ACTIONS(4072),
    [anon_sym_BANG_EQ] = ACTIONS(4070),
    [anon_sym_PLUS] = ACTIONS(4072),
    [anon_sym_DASH] = ACTIONS(4072),
    [anon_sym_DASH_EQ] = ACTIONS(4070),
    [anon_sym_LT_EQ] = ACTIONS(4070),
    [anon_sym_GT_EQ] = ACTIONS(4070),
    [anon_sym_PLUS_PLUS] = ACTIONS(4070),
    [anon_sym_DASH_DASH] = ACTIONS(4070),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4070),
  },
  [1901] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(4941),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [1902] = {
    [sym__concat] = ACTIONS(4687),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4687),
    [anon_sym_AMP_AMP] = ACTIONS(4687),
    [anon_sym_PIPE_PIPE] = ACTIONS(4687),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4687),
    [anon_sym_EQ_TILDE] = ACTIONS(4687),
    [anon_sym_EQ_EQ] = ACTIONS(4687),
    [anon_sym_EQ] = ACTIONS(4689),
    [anon_sym_PLUS_EQ] = ACTIONS(4687),
    [anon_sym_LT] = ACTIONS(4689),
    [anon_sym_GT] = ACTIONS(4689),
    [anon_sym_BANG_EQ] = ACTIONS(4687),
    [anon_sym_PLUS] = ACTIONS(4689),
    [anon_sym_DASH] = ACTIONS(4689),
    [anon_sym_DASH_EQ] = ACTIONS(4687),
    [anon_sym_LT_EQ] = ACTIONS(4687),
    [anon_sym_GT_EQ] = ACTIONS(4687),
    [anon_sym_PLUS_PLUS] = ACTIONS(4687),
    [anon_sym_DASH_DASH] = ACTIONS(4687),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4687),
  },
  [1903] = {
    [sym__concat] = ACTIONS(4691),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4691),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4691),
    [anon_sym_EQ_TILDE] = ACTIONS(4691),
    [anon_sym_EQ_EQ] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_PLUS_EQ] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_BANG_EQ] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_DASH_EQ] = ACTIONS(4691),
    [anon_sym_LT_EQ] = ACTIONS(4691),
    [anon_sym_GT_EQ] = ACTIONS(4691),
    [anon_sym_PLUS_PLUS] = ACTIONS(4691),
    [anon_sym_DASH_DASH] = ACTIONS(4691),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4691),
  },
  [1904] = {
    [sym__concat] = ACTIONS(4695),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4695),
    [anon_sym_EQ_TILDE] = ACTIONS(4695),
    [anon_sym_EQ_EQ] = ACTIONS(4695),
    [anon_sym_EQ] = ACTIONS(4697),
    [anon_sym_PLUS_EQ] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_BANG_EQ] = ACTIONS(4695),
    [anon_sym_PLUS] = ACTIONS(4697),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_DASH_EQ] = ACTIONS(4695),
    [anon_sym_LT_EQ] = ACTIONS(4695),
    [anon_sym_GT_EQ] = ACTIONS(4695),
    [anon_sym_PLUS_PLUS] = ACTIONS(4695),
    [anon_sym_DASH_DASH] = ACTIONS(4695),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4695),
  },
  [1905] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4943),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1906] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(4945),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1907] = {
    [sym__concat] = ACTIONS(4731),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4731),
    [anon_sym_AMP_AMP] = ACTIONS(4731),
    [anon_sym_PIPE_PIPE] = ACTIONS(4731),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4731),
    [anon_sym_EQ_TILDE] = ACTIONS(4731),
    [anon_sym_EQ_EQ] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(4733),
    [anon_sym_PLUS_EQ] = ACTIONS(4731),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_BANG_EQ] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4733),
    [anon_sym_DASH_EQ] = ACTIONS(4731),
    [anon_sym_LT_EQ] = ACTIONS(4731),
    [anon_sym_GT_EQ] = ACTIONS(4731),
    [anon_sym_PLUS_PLUS] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(4731),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4731),
  },
  [1908] = {
    [sym__concat] = ACTIONS(4751),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4751),
    [anon_sym_EQ_TILDE] = ACTIONS(4751),
    [anon_sym_EQ_EQ] = ACTIONS(4751),
    [anon_sym_EQ] = ACTIONS(4753),
    [anon_sym_PLUS_EQ] = ACTIONS(4751),
    [anon_sym_LT] = ACTIONS(4753),
    [anon_sym_GT] = ACTIONS(4753),
    [anon_sym_BANG_EQ] = ACTIONS(4751),
    [anon_sym_PLUS] = ACTIONS(4753),
    [anon_sym_DASH] = ACTIONS(4753),
    [anon_sym_DASH_EQ] = ACTIONS(4751),
    [anon_sym_LT_EQ] = ACTIONS(4751),
    [anon_sym_GT_EQ] = ACTIONS(4751),
    [anon_sym_PLUS_PLUS] = ACTIONS(4751),
    [anon_sym_DASH_DASH] = ACTIONS(4751),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4751),
  },
  [1909] = {
    [sym__concat] = ACTIONS(4755),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4755),
    [anon_sym_EQ_TILDE] = ACTIONS(4755),
    [anon_sym_EQ_EQ] = ACTIONS(4755),
    [anon_sym_EQ] = ACTIONS(4757),
    [anon_sym_PLUS_EQ] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(4757),
    [anon_sym_GT] = ACTIONS(4757),
    [anon_sym_BANG_EQ] = ACTIONS(4755),
    [anon_sym_PLUS] = ACTIONS(4757),
    [anon_sym_DASH] = ACTIONS(4757),
    [anon_sym_DASH_EQ] = ACTIONS(4755),
    [anon_sym_LT_EQ] = ACTIONS(4755),
    [anon_sym_GT_EQ] = ACTIONS(4755),
    [anon_sym_PLUS_PLUS] = ACTIONS(4755),
    [anon_sym_DASH_DASH] = ACTIONS(4755),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4755),
  },
  [1910] = {
    [sym__terminated_statement] = STATE(1165),
    [sym_redirected_statement] = STATE(524),
    [sym_for_statement] = STATE(524),
    [sym_c_style_for_statement] = STATE(524),
    [sym_while_statement] = STATE(524),
    [sym_if_statement] = STATE(524),
    [sym_case_statement] = STATE(524),
    [sym_function_definition] = STATE(524),
    [sym_compound_statement] = STATE(524),
    [sym_subshell] = STATE(524),
    [sym_pipeline] = STATE(524),
    [sym_list] = STATE(524),
    [sym_negated_command] = STATE(524),
    [sym_test_command] = STATE(524),
    [sym_declaration_command] = STATE(524),
    [sym_unset_command] = STATE(524),
    [sym_command] = STATE(524),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(525),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(1165),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(4947),
    [anon_sym_elif] = ACTIONS(4947),
    [anon_sym_else] = ACTIONS(4947),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [1911] = {
    [sym__simple_heredoc_body] = ACTIONS(4949),
    [sym__heredoc_body_beginning] = ACTIONS(4949),
    [sym_file_descriptor] = ACTIONS(4949),
    [ts_builtin_sym_end] = ACTIONS(4949),
    [anon_sym_SEMI] = ACTIONS(4951),
    [anon_sym_esac] = ACTIONS(4949),
    [anon_sym_PIPE] = ACTIONS(4951),
    [anon_sym_RPAREN] = ACTIONS(4949),
    [anon_sym_SEMI_SEMI] = ACTIONS(4949),
    [anon_sym_PIPE_AMP] = ACTIONS(4949),
    [anon_sym_AMP_AMP] = ACTIONS(4949),
    [anon_sym_PIPE_PIPE] = ACTIONS(4949),
    [anon_sym_LT] = ACTIONS(4951),
    [anon_sym_GT] = ACTIONS(4951),
    [anon_sym_GT_GT] = ACTIONS(4949),
    [anon_sym_AMP_GT] = ACTIONS(4951),
    [anon_sym_AMP_GT_GT] = ACTIONS(4949),
    [anon_sym_LT_AMP] = ACTIONS(4949),
    [anon_sym_GT_AMP] = ACTIONS(4949),
    [anon_sym_LT_LT] = ACTIONS(4951),
    [anon_sym_LT_LT_DASH] = ACTIONS(4949),
    [anon_sym_LT_LT_LT] = ACTIONS(4949),
    [anon_sym_BQUOTE] = ACTIONS(4949),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4949),
    [anon_sym_AMP] = ACTIONS(4951),
  },
  [1912] = {
    [aux_sym_concatenation_repeat1] = STATE(1599),
    [sym__concat] = ACTIONS(1191),
    [anon_sym_PIPE] = ACTIONS(4953),
    [anon_sym_RPAREN] = ACTIONS(4953),
    [sym_comment] = ACTIONS(57),
  },
  [1913] = {
    [aux_sym_concatenation_repeat1] = STATE(1599),
    [sym__concat] = ACTIONS(1191),
    [anon_sym_PIPE] = ACTIONS(4955),
    [anon_sym_RPAREN] = ACTIONS(4955),
    [sym_comment] = ACTIONS(57),
  },
  [1914] = {
    [anon_sym_PIPE] = ACTIONS(4955),
    [anon_sym_RPAREN] = ACTIONS(4955),
    [sym_comment] = ACTIONS(57),
  },
  [1915] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(4957),
    [anon_sym_PLUS_EQ] = ACTIONS(4957),
    [sym_comment] = ACTIONS(57),
  },
  [1916] = {
    [anon_sym_esac] = ACTIONS(4959),
    [sym__special_characters] = ACTIONS(4961),
    [anon_sym_DQUOTE] = ACTIONS(4961),
    [anon_sym_DOLLAR] = ACTIONS(4963),
    [sym_raw_string] = ACTIONS(4961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4961),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4961),
    [anon_sym_BQUOTE] = ACTIONS(4961),
    [anon_sym_LT_LPAREN] = ACTIONS(4961),
    [anon_sym_GT_LPAREN] = ACTIONS(4961),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4963),
  },
  [1917] = {
    [sym_subshell] = STATE(93),
    [sym_test_command] = STATE(93),
    [sym_command] = STATE(93),
    [sym_command_name] = STATE(1930),
    [sym_variable_assignment] = STATE(1935),
    [sym_subscript] = STATE(94),
    [sym_file_redirect] = STATE(1935),
    [sym_concatenation] = STATE(1933),
    [sym_string] = STATE(1923),
    [sym_simple_expansion] = STATE(1923),
    [sym_string_expansion] = STATE(1923),
    [sym_expansion] = STATE(1923),
    [sym_command_substitution] = STATE(1923),
    [sym_process_substitution] = STATE(1923),
    [aux_sym_command_repeat1] = STATE(1935),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(145),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(4430),
    [anon_sym_DQUOTE] = ACTIONS(4432),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [sym_raw_string] = ACTIONS(4436),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_LT_LPAREN] = ACTIONS(4444),
    [anon_sym_GT_LPAREN] = ACTIONS(4444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4436),
  },
  [1918] = {
    [sym_variable_assignment] = STATE(2131),
    [sym_subscript] = STATE(2130),
    [sym_concatenation] = STATE(2131),
    [sym_string] = STATE(2125),
    [sym_simple_expansion] = STATE(2125),
    [sym_string_expansion] = STATE(2125),
    [sym_expansion] = STATE(2125),
    [sym_command_substitution] = STATE(2125),
    [sym_process_substitution] = STATE(2125),
    [aux_sym_declaration_command_repeat1] = STATE(2131),
    [sym__simple_heredoc_body] = ACTIONS(181),
    [sym__heredoc_body_beginning] = ACTIONS(181),
    [sym_file_descriptor] = ACTIONS(181),
    [sym_variable_name] = ACTIONS(4965),
    [anon_sym_SEMI] = ACTIONS(185),
    [anon_sym_esac] = ACTIONS(185),
    [anon_sym_PIPE] = ACTIONS(185),
    [anon_sym_SEMI_SEMI] = ACTIONS(181),
    [anon_sym_PIPE_AMP] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_GT] = ACTIONS(185),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_AMP_GT] = ACTIONS(185),
    [anon_sym_AMP_GT_GT] = ACTIONS(181),
    [anon_sym_LT_AMP] = ACTIONS(181),
    [anon_sym_GT_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(185),
    [anon_sym_LT_LT_DASH] = ACTIONS(181),
    [anon_sym_LT_LT_LT] = ACTIONS(181),
    [sym__special_characters] = ACTIONS(4967),
    [anon_sym_DQUOTE] = ACTIONS(4969),
    [anon_sym_DOLLAR] = ACTIONS(4971),
    [sym_raw_string] = ACTIONS(4973),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4975),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4977),
    [anon_sym_BQUOTE] = ACTIONS(4979),
    [anon_sym_LT_LPAREN] = ACTIONS(4981),
    [anon_sym_GT_LPAREN] = ACTIONS(4981),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4983),
    [sym_word] = ACTIONS(4985),
    [anon_sym_LF] = ACTIONS(181),
    [anon_sym_AMP] = ACTIONS(185),
  },
  [1919] = {
    [sym_concatenation] = STATE(2140),
    [sym_string] = STATE(2135),
    [sym_simple_expansion] = STATE(2135),
    [sym_string_expansion] = STATE(2135),
    [sym_expansion] = STATE(2135),
    [sym_command_substitution] = STATE(2135),
    [sym_process_substitution] = STATE(2135),
    [aux_sym_unset_command_repeat1] = STATE(2140),
    [sym__simple_heredoc_body] = ACTIONS(207),
    [sym__heredoc_body_beginning] = ACTIONS(207),
    [sym_file_descriptor] = ACTIONS(207),
    [anon_sym_SEMI] = ACTIONS(209),
    [anon_sym_esac] = ACTIONS(209),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_SEMI_SEMI] = ACTIONS(207),
    [anon_sym_PIPE_AMP] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_GT] = ACTIONS(209),
    [anon_sym_AMP_GT_GT] = ACTIONS(207),
    [anon_sym_LT_AMP] = ACTIONS(207),
    [anon_sym_GT_AMP] = ACTIONS(207),
    [anon_sym_LT_LT] = ACTIONS(209),
    [anon_sym_LT_LT_DASH] = ACTIONS(207),
    [anon_sym_LT_LT_LT] = ACTIONS(207),
    [sym__special_characters] = ACTIONS(4987),
    [anon_sym_DQUOTE] = ACTIONS(4989),
    [anon_sym_DOLLAR] = ACTIONS(4991),
    [sym_raw_string] = ACTIONS(4993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4995),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4997),
    [anon_sym_BQUOTE] = ACTIONS(4999),
    [anon_sym_LT_LPAREN] = ACTIONS(5001),
    [anon_sym_GT_LPAREN] = ACTIONS(5001),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5003),
    [sym_word] = ACTIONS(5005),
    [anon_sym_LF] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(209),
  },
  [1920] = {
    [aux_sym_concatenation_repeat1] = STATE(2142),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(5007),
    [anon_sym_SEMI] = ACTIONS(251),
    [anon_sym_esac] = ACTIONS(251),
    [anon_sym_PIPE] = ACTIONS(251),
    [anon_sym_SEMI_SEMI] = ACTIONS(247),
    [anon_sym_PIPE_AMP] = ACTIONS(247),
    [anon_sym_AMP_AMP] = ACTIONS(247),
    [anon_sym_PIPE_PIPE] = ACTIONS(247),
    [anon_sym_EQ_TILDE] = ACTIONS(251),
    [anon_sym_EQ_EQ] = ACTIONS(251),
    [anon_sym_LT] = ACTIONS(251),
    [anon_sym_GT] = ACTIONS(251),
    [anon_sym_GT_GT] = ACTIONS(247),
    [anon_sym_AMP_GT] = ACTIONS(251),
    [anon_sym_AMP_GT_GT] = ACTIONS(247),
    [anon_sym_LT_AMP] = ACTIONS(247),
    [anon_sym_GT_AMP] = ACTIONS(247),
    [anon_sym_LT_LT] = ACTIONS(251),
    [anon_sym_LT_LT_DASH] = ACTIONS(247),
    [anon_sym_LT_LT_LT] = ACTIONS(247),
    [sym__special_characters] = ACTIONS(247),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(251),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [anon_sym_BQUOTE] = ACTIONS(247),
    [anon_sym_LT_LPAREN] = ACTIONS(247),
    [anon_sym_GT_LPAREN] = ACTIONS(247),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(251),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(251),
  },
  [1921] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(2145),
    [anon_sym_DQUOTE] = ACTIONS(5009),
    [anon_sym_DOLLAR] = ACTIONS(5011),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [1922] = {
    [sym_string] = STATE(2147),
    [anon_sym_DASH] = ACTIONS(5013),
    [anon_sym_DQUOTE] = ACTIONS(4432),
    [anon_sym_DOLLAR] = ACTIONS(5013),
    [sym_raw_string] = ACTIONS(5015),
    [anon_sym_POUND] = ACTIONS(5013),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5017),
    [anon_sym_STAR] = ACTIONS(5019),
    [anon_sym_AT] = ACTIONS(5019),
    [anon_sym_QMARK] = ACTIONS(5019),
    [anon_sym_0] = ACTIONS(5017),
    [anon_sym__] = ACTIONS(5017),
  },
  [1923] = {
    [aux_sym_concatenation_repeat1] = STATE(2142),
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [sym__concat] = ACTIONS(5007),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_esac] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [1924] = {
    [sym_subscript] = STATE(2152),
    [sym_variable_name] = ACTIONS(5021),
    [anon_sym_BANG] = ACTIONS(5023),
    [anon_sym_DASH] = ACTIONS(5025),
    [anon_sym_DOLLAR] = ACTIONS(5025),
    [anon_sym_POUND] = ACTIONS(5023),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5027),
    [anon_sym_STAR] = ACTIONS(5029),
    [anon_sym_AT] = ACTIONS(5029),
    [anon_sym_QMARK] = ACTIONS(5029),
    [anon_sym_0] = ACTIONS(5027),
    [anon_sym__] = ACTIONS(5027),
  },
  [1925] = {
    [sym__terminated_statement] = STATE(2155),
    [sym_redirected_statement] = STATE(2153),
    [sym_for_statement] = STATE(2153),
    [sym_c_style_for_statement] = STATE(2153),
    [sym_while_statement] = STATE(2153),
    [sym_if_statement] = STATE(2153),
    [sym_case_statement] = STATE(2153),
    [sym_function_definition] = STATE(2153),
    [sym_compound_statement] = STATE(2153),
    [sym_subshell] = STATE(2153),
    [sym_pipeline] = STATE(2153),
    [sym_list] = STATE(2153),
    [sym_negated_command] = STATE(2153),
    [sym_test_command] = STATE(2153),
    [sym_declaration_command] = STATE(2153),
    [sym_unset_command] = STATE(2153),
    [sym_command] = STATE(2153),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2154),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(2155),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [1926] = {
    [sym__terminated_statement] = STATE(2158),
    [sym_redirected_statement] = STATE(2156),
    [sym_for_statement] = STATE(2156),
    [sym_c_style_for_statement] = STATE(2156),
    [sym_while_statement] = STATE(2156),
    [sym_if_statement] = STATE(2156),
    [sym_case_statement] = STATE(2156),
    [sym_function_definition] = STATE(2156),
    [sym_compound_statement] = STATE(2156),
    [sym_subshell] = STATE(2156),
    [sym_pipeline] = STATE(2156),
    [sym_list] = STATE(2156),
    [sym_negated_command] = STATE(2156),
    [sym_test_command] = STATE(2156),
    [sym_declaration_command] = STATE(2156),
    [sym_unset_command] = STATE(2156),
    [sym_command] = STATE(2156),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(2157),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(2158),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [1927] = {
    [sym__terminated_statement] = STATE(2161),
    [sym_redirected_statement] = STATE(2159),
    [sym_for_statement] = STATE(2159),
    [sym_c_style_for_statement] = STATE(2159),
    [sym_while_statement] = STATE(2159),
    [sym_if_statement] = STATE(2159),
    [sym_case_statement] = STATE(2159),
    [sym_function_definition] = STATE(2159),
    [sym_compound_statement] = STATE(2159),
    [sym_subshell] = STATE(2159),
    [sym_pipeline] = STATE(2159),
    [sym_list] = STATE(2159),
    [sym_negated_command] = STATE(2159),
    [sym_test_command] = STATE(2159),
    [sym_declaration_command] = STATE(2159),
    [sym_unset_command] = STATE(2159),
    [sym_command] = STATE(2159),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2160),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(2161),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [1928] = {
    [aux_sym_concatenation_repeat1] = STATE(2142),
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [sym__concat] = ACTIONS(5007),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_esac] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [1929] = {
    [sym_file_redirect] = STATE(2170),
    [sym_heredoc_redirect] = STATE(2170),
    [sym_heredoc_body] = STATE(2169),
    [sym_herestring_redirect] = STATE(2170),
    [aux_sym_redirected_statement_repeat1] = STATE(2170),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(5031),
    [anon_sym_SEMI] = ACTIONS(5033),
    [anon_sym_esac] = ACTIONS(5035),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI_SEMI] = ACTIONS(5039),
    [anon_sym_PIPE_AMP] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5043),
    [anon_sym_PIPE_PIPE] = ACTIONS(5043),
    [anon_sym_LT] = ACTIONS(5045),
    [anon_sym_GT] = ACTIONS(5045),
    [anon_sym_GT_GT] = ACTIONS(5047),
    [anon_sym_AMP_GT] = ACTIONS(5045),
    [anon_sym_AMP_GT_GT] = ACTIONS(5047),
    [anon_sym_LT_AMP] = ACTIONS(5047),
    [anon_sym_GT_AMP] = ACTIONS(5047),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(5049),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5051),
    [anon_sym_AMP] = ACTIONS(5033),
  },
  [1930] = {
    [sym_concatenation] = STATE(2174),
    [sym_string] = STATE(2173),
    [sym_simple_expansion] = STATE(2173),
    [sym_string_expansion] = STATE(2173),
    [sym_expansion] = STATE(2173),
    [sym_command_substitution] = STATE(2173),
    [sym_process_substitution] = STATE(2173),
    [aux_sym_command_repeat2] = STATE(2174),
    [sym__simple_heredoc_body] = ACTIONS(327),
    [sym__heredoc_body_beginning] = ACTIONS(327),
    [sym_file_descriptor] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_esac] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(327),
    [anon_sym_PIPE_AMP] = ACTIONS(327),
    [anon_sym_AMP_AMP] = ACTIONS(327),
    [anon_sym_PIPE_PIPE] = ACTIONS(327),
    [anon_sym_EQ_TILDE] = ACTIONS(5053),
    [anon_sym_EQ_EQ] = ACTIONS(5053),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(327),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(327),
    [anon_sym_LT_AMP] = ACTIONS(327),
    [anon_sym_GT_AMP] = ACTIONS(327),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(327),
    [anon_sym_LT_LT_LT] = ACTIONS(327),
    [sym__special_characters] = ACTIONS(5055),
    [anon_sym_DQUOTE] = ACTIONS(4432),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [sym_raw_string] = ACTIONS(5057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_LT_LPAREN] = ACTIONS(4444),
    [anon_sym_GT_LPAREN] = ACTIONS(4444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5059),
    [anon_sym_LF] = ACTIONS(327),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1931] = {
    [sym_file_redirect] = STATE(2170),
    [sym_heredoc_redirect] = STATE(2170),
    [sym_heredoc_body] = STATE(2169),
    [sym_herestring_redirect] = STATE(2170),
    [aux_sym_redirected_statement_repeat1] = STATE(2170),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5033),
    [anon_sym_esac] = ACTIONS(4959),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI_SEMI] = ACTIONS(5039),
    [anon_sym_PIPE_AMP] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5043),
    [anon_sym_PIPE_PIPE] = ACTIONS(5043),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(5049),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5051),
    [anon_sym_AMP] = ACTIONS(5033),
  },
  [1932] = {
    [anon_sym_EQ] = ACTIONS(4957),
    [anon_sym_PLUS_EQ] = ACTIONS(4957),
    [sym_comment] = ACTIONS(57),
  },
  [1933] = {
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_esac] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [1934] = {
    [sym__terminated_statement] = STATE(2178),
    [sym_redirected_statement] = STATE(2176),
    [sym_for_statement] = STATE(2176),
    [sym_c_style_for_statement] = STATE(2176),
    [sym_while_statement] = STATE(2176),
    [sym_if_statement] = STATE(2176),
    [sym_case_statement] = STATE(2176),
    [sym_function_definition] = STATE(2176),
    [sym_compound_statement] = STATE(2176),
    [sym_subshell] = STATE(2176),
    [sym_pipeline] = STATE(2176),
    [sym_list] = STATE(2176),
    [sym_negated_command] = STATE(2176),
    [sym_test_command] = STATE(2176),
    [sym_declaration_command] = STATE(2176),
    [sym_unset_command] = STATE(2176),
    [sym_command] = STATE(2176),
    [sym_command_name] = STATE(1930),
    [sym_variable_assignment] = STATE(2177),
    [sym_subscript] = STATE(1932),
    [sym_file_redirect] = STATE(1935),
    [sym_concatenation] = STATE(1933),
    [sym_string] = STATE(1923),
    [sym_simple_expansion] = STATE(1923),
    [sym_string_expansion] = STATE(1923),
    [sym_expansion] = STATE(1923),
    [sym_command_substitution] = STATE(1923),
    [sym_process_substitution] = STATE(1923),
    [aux_sym__statements_repeat1] = STATE(2178),
    [aux_sym_command_repeat1] = STATE(1935),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4418),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(4959),
    [anon_sym_SEMI_SEMI] = ACTIONS(5061),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4426),
    [anon_sym_typeset] = ACTIONS(4426),
    [anon_sym_export] = ACTIONS(4426),
    [anon_sym_readonly] = ACTIONS(4426),
    [anon_sym_local] = ACTIONS(4426),
    [anon_sym_unset] = ACTIONS(4428),
    [anon_sym_unsetenv] = ACTIONS(4428),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(4430),
    [anon_sym_DQUOTE] = ACTIONS(4432),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [sym_raw_string] = ACTIONS(4436),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_LT_LPAREN] = ACTIONS(4444),
    [anon_sym_GT_LPAREN] = ACTIONS(4444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4446),
  },
  [1935] = {
    [sym_command_name] = STATE(2179),
    [sym_variable_assignment] = STATE(189),
    [sym_subscript] = STATE(94),
    [sym_file_redirect] = STATE(189),
    [sym_concatenation] = STATE(1933),
    [sym_string] = STATE(1923),
    [sym_simple_expansion] = STATE(1923),
    [sym_string_expansion] = STATE(1923),
    [sym_expansion] = STATE(1923),
    [sym_command_substitution] = STATE(1923),
    [sym_process_substitution] = STATE(1923),
    [aux_sym_command_repeat1] = STATE(189),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(145),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(5063),
    [anon_sym_DQUOTE] = ACTIONS(4432),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [sym_raw_string] = ACTIONS(4436),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_LT_LPAREN] = ACTIONS(4444),
    [anon_sym_GT_LPAREN] = ACTIONS(4444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4436),
  },
  [1936] = {
    [sym__terminated_statement] = STATE(2180),
    [sym_redirected_statement] = STATE(2176),
    [sym_for_statement] = STATE(2176),
    [sym_c_style_for_statement] = STATE(2176),
    [sym_while_statement] = STATE(2176),
    [sym_if_statement] = STATE(2176),
    [sym_case_statement] = STATE(2176),
    [sym_function_definition] = STATE(2176),
    [sym_compound_statement] = STATE(2176),
    [sym_subshell] = STATE(2176),
    [sym_pipeline] = STATE(2176),
    [sym_list] = STATE(2176),
    [sym_negated_command] = STATE(2176),
    [sym_test_command] = STATE(2176),
    [sym_declaration_command] = STATE(2176),
    [sym_unset_command] = STATE(2176),
    [sym_command] = STATE(2176),
    [sym_command_name] = STATE(1930),
    [sym_variable_assignment] = STATE(2177),
    [sym_subscript] = STATE(1932),
    [sym_file_redirect] = STATE(1935),
    [sym_concatenation] = STATE(1933),
    [sym_string] = STATE(1923),
    [sym_simple_expansion] = STATE(1923),
    [sym_string_expansion] = STATE(1923),
    [sym_expansion] = STATE(1923),
    [sym_command_substitution] = STATE(1923),
    [sym_process_substitution] = STATE(1923),
    [aux_sym__statements_repeat1] = STATE(2180),
    [aux_sym_command_repeat1] = STATE(1935),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4418),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(4959),
    [anon_sym_SEMI_SEMI] = ACTIONS(5061),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4426),
    [anon_sym_typeset] = ACTIONS(4426),
    [anon_sym_export] = ACTIONS(4426),
    [anon_sym_readonly] = ACTIONS(4426),
    [anon_sym_local] = ACTIONS(4426),
    [anon_sym_unset] = ACTIONS(4428),
    [anon_sym_unsetenv] = ACTIONS(4428),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(4430),
    [anon_sym_DQUOTE] = ACTIONS(4432),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [sym_raw_string] = ACTIONS(4436),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_LT_LPAREN] = ACTIONS(4444),
    [anon_sym_GT_LPAREN] = ACTIONS(4444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4446),
  },
  [1937] = {
    [aux_sym_case_item_repeat1] = STATE(1937),
    [anon_sym_PIPE] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(4955),
    [sym_comment] = ACTIONS(57),
  },
  [1938] = {
    [aux_sym_concatenation_repeat1] = STATE(1938),
    [sym__concat] = ACTIONS(3483),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
  },
  [1939] = {
    [anon_sym_esac] = ACTIONS(5068),
    [sym__special_characters] = ACTIONS(5070),
    [anon_sym_DQUOTE] = ACTIONS(5070),
    [anon_sym_DOLLAR] = ACTIONS(5072),
    [sym_raw_string] = ACTIONS(5070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5070),
    [anon_sym_BQUOTE] = ACTIONS(5070),
    [anon_sym_LT_LPAREN] = ACTIONS(5070),
    [anon_sym_GT_LPAREN] = ACTIONS(5070),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5072),
  },
  [1940] = {
    [sym_file_redirect] = STATE(2170),
    [sym_heredoc_redirect] = STATE(2170),
    [sym_heredoc_body] = STATE(2169),
    [sym_herestring_redirect] = STATE(2170),
    [aux_sym_redirected_statement_repeat1] = STATE(2170),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(5031),
    [anon_sym_SEMI] = ACTIONS(5033),
    [anon_sym_esac] = ACTIONS(5074),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI_SEMI] = ACTIONS(5076),
    [anon_sym_PIPE_AMP] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5043),
    [anon_sym_PIPE_PIPE] = ACTIONS(5043),
    [anon_sym_LT] = ACTIONS(5045),
    [anon_sym_GT] = ACTIONS(5045),
    [anon_sym_GT_GT] = ACTIONS(5047),
    [anon_sym_AMP_GT] = ACTIONS(5045),
    [anon_sym_AMP_GT_GT] = ACTIONS(5047),
    [anon_sym_LT_AMP] = ACTIONS(5047),
    [anon_sym_GT_AMP] = ACTIONS(5047),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(5049),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5051),
    [anon_sym_AMP] = ACTIONS(5033),
  },
  [1941] = {
    [sym_file_redirect] = STATE(2170),
    [sym_heredoc_redirect] = STATE(2170),
    [sym_heredoc_body] = STATE(2169),
    [sym_herestring_redirect] = STATE(2170),
    [aux_sym_redirected_statement_repeat1] = STATE(2170),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5033),
    [anon_sym_esac] = ACTIONS(5068),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI_SEMI] = ACTIONS(5076),
    [anon_sym_PIPE_AMP] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5043),
    [anon_sym_PIPE_PIPE] = ACTIONS(5043),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(5049),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5051),
    [anon_sym_AMP] = ACTIONS(5033),
  },
  [1942] = {
    [sym__terminated_statement] = STATE(2178),
    [sym_redirected_statement] = STATE(2183),
    [sym_for_statement] = STATE(2183),
    [sym_c_style_for_statement] = STATE(2183),
    [sym_while_statement] = STATE(2183),
    [sym_if_statement] = STATE(2183),
    [sym_case_statement] = STATE(2183),
    [sym_function_definition] = STATE(2183),
    [sym_compound_statement] = STATE(2183),
    [sym_subshell] = STATE(2183),
    [sym_pipeline] = STATE(2183),
    [sym_list] = STATE(2183),
    [sym_negated_command] = STATE(2183),
    [sym_test_command] = STATE(2183),
    [sym_declaration_command] = STATE(2183),
    [sym_unset_command] = STATE(2183),
    [sym_command] = STATE(2183),
    [sym_command_name] = STATE(1930),
    [sym_variable_assignment] = STATE(2184),
    [sym_subscript] = STATE(1932),
    [sym_file_redirect] = STATE(1935),
    [sym_concatenation] = STATE(1933),
    [sym_string] = STATE(1923),
    [sym_simple_expansion] = STATE(1923),
    [sym_string_expansion] = STATE(1923),
    [sym_expansion] = STATE(1923),
    [sym_command_substitution] = STATE(1923),
    [sym_process_substitution] = STATE(1923),
    [aux_sym__statements_repeat1] = STATE(2178),
    [aux_sym_command_repeat1] = STATE(1935),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4418),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(5068),
    [anon_sym_SEMI_SEMI] = ACTIONS(5078),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4426),
    [anon_sym_typeset] = ACTIONS(4426),
    [anon_sym_export] = ACTIONS(4426),
    [anon_sym_readonly] = ACTIONS(4426),
    [anon_sym_local] = ACTIONS(4426),
    [anon_sym_unset] = ACTIONS(4428),
    [anon_sym_unsetenv] = ACTIONS(4428),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(4430),
    [anon_sym_DQUOTE] = ACTIONS(4432),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [sym_raw_string] = ACTIONS(4436),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_LT_LPAREN] = ACTIONS(4444),
    [anon_sym_GT_LPAREN] = ACTIONS(4444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4446),
  },
  [1943] = {
    [sym__terminated_statement] = STATE(2185),
    [sym_redirected_statement] = STATE(2183),
    [sym_for_statement] = STATE(2183),
    [sym_c_style_for_statement] = STATE(2183),
    [sym_while_statement] = STATE(2183),
    [sym_if_statement] = STATE(2183),
    [sym_case_statement] = STATE(2183),
    [sym_function_definition] = STATE(2183),
    [sym_compound_statement] = STATE(2183),
    [sym_subshell] = STATE(2183),
    [sym_pipeline] = STATE(2183),
    [sym_list] = STATE(2183),
    [sym_negated_command] = STATE(2183),
    [sym_test_command] = STATE(2183),
    [sym_declaration_command] = STATE(2183),
    [sym_unset_command] = STATE(2183),
    [sym_command] = STATE(2183),
    [sym_command_name] = STATE(1930),
    [sym_variable_assignment] = STATE(2184),
    [sym_subscript] = STATE(1932),
    [sym_file_redirect] = STATE(1935),
    [sym_concatenation] = STATE(1933),
    [sym_string] = STATE(1923),
    [sym_simple_expansion] = STATE(1923),
    [sym_string_expansion] = STATE(1923),
    [sym_expansion] = STATE(1923),
    [sym_command_substitution] = STATE(1923),
    [sym_process_substitution] = STATE(1923),
    [aux_sym__statements_repeat1] = STATE(2185),
    [aux_sym_command_repeat1] = STATE(1935),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4418),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(5068),
    [anon_sym_SEMI_SEMI] = ACTIONS(5078),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4426),
    [anon_sym_typeset] = ACTIONS(4426),
    [anon_sym_export] = ACTIONS(4426),
    [anon_sym_readonly] = ACTIONS(4426),
    [anon_sym_local] = ACTIONS(4426),
    [anon_sym_unset] = ACTIONS(4428),
    [anon_sym_unsetenv] = ACTIONS(4428),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(4430),
    [anon_sym_DQUOTE] = ACTIONS(4432),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [sym_raw_string] = ACTIONS(4436),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_LT_LPAREN] = ACTIONS(4444),
    [anon_sym_GT_LPAREN] = ACTIONS(4444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4446),
  },
  [1944] = {
    [sym__simple_heredoc_body] = ACTIONS(5080),
    [sym__heredoc_body_beginning] = ACTIONS(5080),
    [sym_file_descriptor] = ACTIONS(5080),
    [ts_builtin_sym_end] = ACTIONS(5080),
    [anon_sym_SEMI] = ACTIONS(5082),
    [anon_sym_esac] = ACTIONS(5080),
    [anon_sym_PIPE] = ACTIONS(5082),
    [anon_sym_RPAREN] = ACTIONS(5080),
    [anon_sym_SEMI_SEMI] = ACTIONS(5080),
    [anon_sym_PIPE_AMP] = ACTIONS(5080),
    [anon_sym_AMP_AMP] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE] = ACTIONS(5080),
    [anon_sym_LT] = ACTIONS(5082),
    [anon_sym_GT] = ACTIONS(5082),
    [anon_sym_GT_GT] = ACTIONS(5080),
    [anon_sym_AMP_GT] = ACTIONS(5082),
    [anon_sym_AMP_GT_GT] = ACTIONS(5080),
    [anon_sym_LT_AMP] = ACTIONS(5080),
    [anon_sym_GT_AMP] = ACTIONS(5080),
    [anon_sym_LT_LT] = ACTIONS(5082),
    [anon_sym_LT_LT_DASH] = ACTIONS(5080),
    [anon_sym_LT_LT_LT] = ACTIONS(5080),
    [anon_sym_BQUOTE] = ACTIONS(5080),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5080),
    [anon_sym_AMP] = ACTIONS(5082),
  },
  [1945] = {
    [aux_sym_case_item_repeat1] = STATE(2187),
    [aux_sym_concatenation_repeat1] = STATE(1599),
    [sym__concat] = ACTIONS(1191),
    [anon_sym_PIPE] = ACTIONS(3617),
    [anon_sym_RPAREN] = ACTIONS(5084),
    [sym_comment] = ACTIONS(57),
  },
  [1946] = {
    [aux_sym_case_item_repeat1] = STATE(2189),
    [aux_sym_concatenation_repeat1] = STATE(1599),
    [sym__concat] = ACTIONS(1191),
    [anon_sym_PIPE] = ACTIONS(3617),
    [anon_sym_RPAREN] = ACTIONS(5086),
    [sym_comment] = ACTIONS(57),
  },
  [1947] = {
    [aux_sym_case_item_repeat1] = STATE(2189),
    [anon_sym_PIPE] = ACTIONS(3617),
    [anon_sym_RPAREN] = ACTIONS(5086),
    [sym_comment] = ACTIONS(57),
  },
  [1948] = {
    [anon_sym_esac] = ACTIONS(5088),
    [sym_comment] = ACTIONS(57),
  },
  [1949] = {
    [sym__simple_heredoc_body] = ACTIONS(5090),
    [sym__heredoc_body_beginning] = ACTIONS(5090),
    [sym_file_descriptor] = ACTIONS(5090),
    [ts_builtin_sym_end] = ACTIONS(5090),
    [anon_sym_SEMI] = ACTIONS(5092),
    [anon_sym_esac] = ACTIONS(5090),
    [anon_sym_PIPE] = ACTIONS(5092),
    [anon_sym_RPAREN] = ACTIONS(5090),
    [anon_sym_SEMI_SEMI] = ACTIONS(5090),
    [anon_sym_PIPE_AMP] = ACTIONS(5090),
    [anon_sym_AMP_AMP] = ACTIONS(5090),
    [anon_sym_PIPE_PIPE] = ACTIONS(5090),
    [anon_sym_LT] = ACTIONS(5092),
    [anon_sym_GT] = ACTIONS(5092),
    [anon_sym_GT_GT] = ACTIONS(5090),
    [anon_sym_AMP_GT] = ACTIONS(5092),
    [anon_sym_AMP_GT_GT] = ACTIONS(5090),
    [anon_sym_LT_AMP] = ACTIONS(5090),
    [anon_sym_GT_AMP] = ACTIONS(5090),
    [anon_sym_LT_LT] = ACTIONS(5092),
    [anon_sym_LT_LT_DASH] = ACTIONS(5090),
    [anon_sym_LT_LT_LT] = ACTIONS(5090),
    [anon_sym_BQUOTE] = ACTIONS(5090),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(5092),
  },
  [1950] = {
    [anon_sym_esac] = ACTIONS(5094),
    [sym_comment] = ACTIONS(57),
  },
  [1951] = {
    [sym__concat] = ACTIONS(4687),
    [anon_sym_in] = ACTIONS(4687),
    [anon_sym_SEMI] = ACTIONS(4689),
    [anon_sym_SEMI_SEMI] = ACTIONS(4687),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4687),
    [anon_sym_AMP] = ACTIONS(4687),
  },
  [1952] = {
    [sym__concat] = ACTIONS(4691),
    [anon_sym_in] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4693),
    [anon_sym_SEMI_SEMI] = ACTIONS(4691),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4691),
  },
  [1953] = {
    [sym__concat] = ACTIONS(4695),
    [anon_sym_in] = ACTIONS(4695),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_SEMI_SEMI] = ACTIONS(4695),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4695),
    [anon_sym_AMP] = ACTIONS(4695),
  },
  [1954] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5096),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1955] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5098),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1956] = {
    [sym__concat] = ACTIONS(4731),
    [anon_sym_in] = ACTIONS(4731),
    [anon_sym_SEMI] = ACTIONS(4733),
    [anon_sym_SEMI_SEMI] = ACTIONS(4731),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4731),
    [anon_sym_AMP] = ACTIONS(4731),
  },
  [1957] = {
    [sym__concat] = ACTIONS(4751),
    [anon_sym_in] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4753),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4751),
    [anon_sym_AMP] = ACTIONS(4751),
  },
  [1958] = {
    [sym__concat] = ACTIONS(4755),
    [anon_sym_in] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4757),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4755),
    [anon_sym_AMP] = ACTIONS(4755),
  },
  [1959] = {
    [sym__concat] = ACTIONS(4687),
    [anon_sym_AMP_AMP] = ACTIONS(4687),
    [anon_sym_PIPE_PIPE] = ACTIONS(4687),
    [anon_sym_RBRACK] = ACTIONS(4687),
    [anon_sym_EQ_TILDE] = ACTIONS(4687),
    [anon_sym_EQ_EQ] = ACTIONS(4687),
    [anon_sym_EQ] = ACTIONS(4689),
    [anon_sym_PLUS_EQ] = ACTIONS(4687),
    [anon_sym_LT] = ACTIONS(4689),
    [anon_sym_GT] = ACTIONS(4689),
    [anon_sym_BANG_EQ] = ACTIONS(4687),
    [anon_sym_PLUS] = ACTIONS(4689),
    [anon_sym_DASH] = ACTIONS(4689),
    [anon_sym_DASH_EQ] = ACTIONS(4687),
    [anon_sym_LT_EQ] = ACTIONS(4687),
    [anon_sym_GT_EQ] = ACTIONS(4687),
    [anon_sym_PLUS_PLUS] = ACTIONS(4687),
    [anon_sym_DASH_DASH] = ACTIONS(4687),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4687),
  },
  [1960] = {
    [sym__concat] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4691),
    [anon_sym_RBRACK] = ACTIONS(4691),
    [anon_sym_EQ_TILDE] = ACTIONS(4691),
    [anon_sym_EQ_EQ] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_PLUS_EQ] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_BANG_EQ] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_DASH_EQ] = ACTIONS(4691),
    [anon_sym_LT_EQ] = ACTIONS(4691),
    [anon_sym_GT_EQ] = ACTIONS(4691),
    [anon_sym_PLUS_PLUS] = ACTIONS(4691),
    [anon_sym_DASH_DASH] = ACTIONS(4691),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4691),
  },
  [1961] = {
    [sym__concat] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_RBRACK] = ACTIONS(4695),
    [anon_sym_EQ_TILDE] = ACTIONS(4695),
    [anon_sym_EQ_EQ] = ACTIONS(4695),
    [anon_sym_EQ] = ACTIONS(4697),
    [anon_sym_PLUS_EQ] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_BANG_EQ] = ACTIONS(4695),
    [anon_sym_PLUS] = ACTIONS(4697),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_DASH_EQ] = ACTIONS(4695),
    [anon_sym_LT_EQ] = ACTIONS(4695),
    [anon_sym_GT_EQ] = ACTIONS(4695),
    [anon_sym_PLUS_PLUS] = ACTIONS(4695),
    [anon_sym_DASH_DASH] = ACTIONS(4695),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4695),
  },
  [1962] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5100),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1963] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5102),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1964] = {
    [sym__concat] = ACTIONS(4731),
    [anon_sym_AMP_AMP] = ACTIONS(4731),
    [anon_sym_PIPE_PIPE] = ACTIONS(4731),
    [anon_sym_RBRACK] = ACTIONS(4731),
    [anon_sym_EQ_TILDE] = ACTIONS(4731),
    [anon_sym_EQ_EQ] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(4733),
    [anon_sym_PLUS_EQ] = ACTIONS(4731),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_BANG_EQ] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4733),
    [anon_sym_DASH_EQ] = ACTIONS(4731),
    [anon_sym_LT_EQ] = ACTIONS(4731),
    [anon_sym_GT_EQ] = ACTIONS(4731),
    [anon_sym_PLUS_PLUS] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(4731),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4731),
  },
  [1965] = {
    [sym__concat] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [anon_sym_RBRACK] = ACTIONS(4751),
    [anon_sym_EQ_TILDE] = ACTIONS(4751),
    [anon_sym_EQ_EQ] = ACTIONS(4751),
    [anon_sym_EQ] = ACTIONS(4753),
    [anon_sym_PLUS_EQ] = ACTIONS(4751),
    [anon_sym_LT] = ACTIONS(4753),
    [anon_sym_GT] = ACTIONS(4753),
    [anon_sym_BANG_EQ] = ACTIONS(4751),
    [anon_sym_PLUS] = ACTIONS(4753),
    [anon_sym_DASH] = ACTIONS(4753),
    [anon_sym_DASH_EQ] = ACTIONS(4751),
    [anon_sym_LT_EQ] = ACTIONS(4751),
    [anon_sym_GT_EQ] = ACTIONS(4751),
    [anon_sym_PLUS_PLUS] = ACTIONS(4751),
    [anon_sym_DASH_DASH] = ACTIONS(4751),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4751),
  },
  [1966] = {
    [sym__concat] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [anon_sym_RBRACK] = ACTIONS(4755),
    [anon_sym_EQ_TILDE] = ACTIONS(4755),
    [anon_sym_EQ_EQ] = ACTIONS(4755),
    [anon_sym_EQ] = ACTIONS(4757),
    [anon_sym_PLUS_EQ] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(4757),
    [anon_sym_GT] = ACTIONS(4757),
    [anon_sym_BANG_EQ] = ACTIONS(4755),
    [anon_sym_PLUS] = ACTIONS(4757),
    [anon_sym_DASH] = ACTIONS(4757),
    [anon_sym_DASH_EQ] = ACTIONS(4755),
    [anon_sym_LT_EQ] = ACTIONS(4755),
    [anon_sym_GT_EQ] = ACTIONS(4755),
    [anon_sym_PLUS_PLUS] = ACTIONS(4755),
    [anon_sym_DASH_DASH] = ACTIONS(4755),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4755),
  },
  [1967] = {
    [sym__simple_heredoc_body] = ACTIONS(4687),
    [sym__heredoc_body_beginning] = ACTIONS(4687),
    [sym_file_descriptor] = ACTIONS(4687),
    [sym__concat] = ACTIONS(4687),
    [sym_variable_name] = ACTIONS(4687),
    [ts_builtin_sym_end] = ACTIONS(4687),
    [anon_sym_SEMI] = ACTIONS(4689),
    [anon_sym_PIPE] = ACTIONS(4689),
    [anon_sym_RPAREN] = ACTIONS(4687),
    [anon_sym_SEMI_SEMI] = ACTIONS(4687),
    [anon_sym_PIPE_AMP] = ACTIONS(4687),
    [anon_sym_AMP_AMP] = ACTIONS(4687),
    [anon_sym_PIPE_PIPE] = ACTIONS(4687),
    [anon_sym_LT] = ACTIONS(4689),
    [anon_sym_GT] = ACTIONS(4689),
    [anon_sym_GT_GT] = ACTIONS(4687),
    [anon_sym_AMP_GT] = ACTIONS(4689),
    [anon_sym_AMP_GT_GT] = ACTIONS(4687),
    [anon_sym_LT_AMP] = ACTIONS(4687),
    [anon_sym_GT_AMP] = ACTIONS(4687),
    [anon_sym_LT_LT] = ACTIONS(4689),
    [anon_sym_LT_LT_DASH] = ACTIONS(4687),
    [anon_sym_LT_LT_LT] = ACTIONS(4687),
    [sym__special_characters] = ACTIONS(4687),
    [anon_sym_DQUOTE] = ACTIONS(4687),
    [anon_sym_DOLLAR] = ACTIONS(4689),
    [sym_raw_string] = ACTIONS(4687),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4687),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4687),
    [anon_sym_BQUOTE] = ACTIONS(4687),
    [anon_sym_LT_LPAREN] = ACTIONS(4687),
    [anon_sym_GT_LPAREN] = ACTIONS(4687),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4689),
    [sym_word] = ACTIONS(4689),
    [anon_sym_LF] = ACTIONS(4687),
    [anon_sym_AMP] = ACTIONS(4689),
  },
  [1968] = {
    [sym__simple_heredoc_body] = ACTIONS(4691),
    [sym__heredoc_body_beginning] = ACTIONS(4691),
    [sym_file_descriptor] = ACTIONS(4691),
    [sym__concat] = ACTIONS(4691),
    [sym_variable_name] = ACTIONS(4691),
    [ts_builtin_sym_end] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_RPAREN] = ACTIONS(4691),
    [anon_sym_SEMI_SEMI] = ACTIONS(4691),
    [anon_sym_PIPE_AMP] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4691),
    [anon_sym_AMP_GT] = ACTIONS(4693),
    [anon_sym_AMP_GT_GT] = ACTIONS(4691),
    [anon_sym_LT_AMP] = ACTIONS(4691),
    [anon_sym_GT_AMP] = ACTIONS(4691),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_LT_LT_DASH] = ACTIONS(4691),
    [anon_sym_LT_LT_LT] = ACTIONS(4691),
    [sym__special_characters] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4693),
    [sym_raw_string] = ACTIONS(4691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4691),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_LT_LPAREN] = ACTIONS(4691),
    [anon_sym_GT_LPAREN] = ACTIONS(4691),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4693),
    [sym_word] = ACTIONS(4693),
    [anon_sym_LF] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4693),
  },
  [1969] = {
    [sym__simple_heredoc_body] = ACTIONS(4695),
    [sym__heredoc_body_beginning] = ACTIONS(4695),
    [sym_file_descriptor] = ACTIONS(4695),
    [sym__concat] = ACTIONS(4695),
    [sym_variable_name] = ACTIONS(4695),
    [ts_builtin_sym_end] = ACTIONS(4695),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_RPAREN] = ACTIONS(4695),
    [anon_sym_SEMI_SEMI] = ACTIONS(4695),
    [anon_sym_PIPE_AMP] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_GT_GT] = ACTIONS(4695),
    [anon_sym_AMP_GT] = ACTIONS(4697),
    [anon_sym_AMP_GT_GT] = ACTIONS(4695),
    [anon_sym_LT_AMP] = ACTIONS(4695),
    [anon_sym_GT_AMP] = ACTIONS(4695),
    [anon_sym_LT_LT] = ACTIONS(4697),
    [anon_sym_LT_LT_DASH] = ACTIONS(4695),
    [anon_sym_LT_LT_LT] = ACTIONS(4695),
    [sym__special_characters] = ACTIONS(4695),
    [anon_sym_DQUOTE] = ACTIONS(4695),
    [anon_sym_DOLLAR] = ACTIONS(4697),
    [sym_raw_string] = ACTIONS(4695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4695),
    [anon_sym_BQUOTE] = ACTIONS(4695),
    [anon_sym_LT_LPAREN] = ACTIONS(4695),
    [anon_sym_GT_LPAREN] = ACTIONS(4695),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4697),
    [sym_word] = ACTIONS(4697),
    [anon_sym_LF] = ACTIONS(4695),
    [anon_sym_AMP] = ACTIONS(4697),
  },
  [1970] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1971] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5106),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1972] = {
    [sym__simple_heredoc_body] = ACTIONS(4731),
    [sym__heredoc_body_beginning] = ACTIONS(4731),
    [sym_file_descriptor] = ACTIONS(4731),
    [sym__concat] = ACTIONS(4731),
    [sym_variable_name] = ACTIONS(4731),
    [ts_builtin_sym_end] = ACTIONS(4731),
    [anon_sym_SEMI] = ACTIONS(4733),
    [anon_sym_PIPE] = ACTIONS(4733),
    [anon_sym_RPAREN] = ACTIONS(4731),
    [anon_sym_SEMI_SEMI] = ACTIONS(4731),
    [anon_sym_PIPE_AMP] = ACTIONS(4731),
    [anon_sym_AMP_AMP] = ACTIONS(4731),
    [anon_sym_PIPE_PIPE] = ACTIONS(4731),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_GT] = ACTIONS(4731),
    [anon_sym_AMP_GT] = ACTIONS(4733),
    [anon_sym_AMP_GT_GT] = ACTIONS(4731),
    [anon_sym_LT_AMP] = ACTIONS(4731),
    [anon_sym_GT_AMP] = ACTIONS(4731),
    [anon_sym_LT_LT] = ACTIONS(4733),
    [anon_sym_LT_LT_DASH] = ACTIONS(4731),
    [anon_sym_LT_LT_LT] = ACTIONS(4731),
    [sym__special_characters] = ACTIONS(4731),
    [anon_sym_DQUOTE] = ACTIONS(4731),
    [anon_sym_DOLLAR] = ACTIONS(4733),
    [sym_raw_string] = ACTIONS(4731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4731),
    [anon_sym_BQUOTE] = ACTIONS(4731),
    [anon_sym_LT_LPAREN] = ACTIONS(4731),
    [anon_sym_GT_LPAREN] = ACTIONS(4731),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4733),
    [sym_word] = ACTIONS(4733),
    [anon_sym_LF] = ACTIONS(4731),
    [anon_sym_AMP] = ACTIONS(4733),
  },
  [1973] = {
    [sym__simple_heredoc_body] = ACTIONS(4751),
    [sym__heredoc_body_beginning] = ACTIONS(4751),
    [sym_file_descriptor] = ACTIONS(4751),
    [sym__concat] = ACTIONS(4751),
    [sym_variable_name] = ACTIONS(4751),
    [ts_builtin_sym_end] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4753),
    [anon_sym_PIPE] = ACTIONS(4753),
    [anon_sym_RPAREN] = ACTIONS(4751),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_PIPE_AMP] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [anon_sym_LT] = ACTIONS(4753),
    [anon_sym_GT] = ACTIONS(4753),
    [anon_sym_GT_GT] = ACTIONS(4751),
    [anon_sym_AMP_GT] = ACTIONS(4753),
    [anon_sym_AMP_GT_GT] = ACTIONS(4751),
    [anon_sym_LT_AMP] = ACTIONS(4751),
    [anon_sym_GT_AMP] = ACTIONS(4751),
    [anon_sym_LT_LT] = ACTIONS(4753),
    [anon_sym_LT_LT_DASH] = ACTIONS(4751),
    [anon_sym_LT_LT_LT] = ACTIONS(4751),
    [sym__special_characters] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4753),
    [sym_raw_string] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_LT_LPAREN] = ACTIONS(4751),
    [anon_sym_GT_LPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4753),
    [sym_word] = ACTIONS(4753),
    [anon_sym_LF] = ACTIONS(4751),
    [anon_sym_AMP] = ACTIONS(4753),
  },
  [1974] = {
    [sym__simple_heredoc_body] = ACTIONS(4755),
    [sym__heredoc_body_beginning] = ACTIONS(4755),
    [sym_file_descriptor] = ACTIONS(4755),
    [sym__concat] = ACTIONS(4755),
    [sym_variable_name] = ACTIONS(4755),
    [ts_builtin_sym_end] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4757),
    [anon_sym_PIPE] = ACTIONS(4757),
    [anon_sym_RPAREN] = ACTIONS(4755),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [anon_sym_PIPE_AMP] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(4757),
    [anon_sym_GT] = ACTIONS(4757),
    [anon_sym_GT_GT] = ACTIONS(4755),
    [anon_sym_AMP_GT] = ACTIONS(4757),
    [anon_sym_AMP_GT_GT] = ACTIONS(4755),
    [anon_sym_LT_AMP] = ACTIONS(4755),
    [anon_sym_GT_AMP] = ACTIONS(4755),
    [anon_sym_LT_LT] = ACTIONS(4757),
    [anon_sym_LT_LT_DASH] = ACTIONS(4755),
    [anon_sym_LT_LT_LT] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4757),
    [sym_raw_string] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_LT_LPAREN] = ACTIONS(4755),
    [anon_sym_GT_LPAREN] = ACTIONS(4755),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4757),
    [sym_word] = ACTIONS(4757),
    [anon_sym_LF] = ACTIONS(4755),
    [anon_sym_AMP] = ACTIONS(4757),
  },
  [1975] = {
    [sym__simple_heredoc_body] = ACTIONS(4687),
    [sym__heredoc_body_beginning] = ACTIONS(4687),
    [sym_file_descriptor] = ACTIONS(4687),
    [sym__concat] = ACTIONS(4687),
    [ts_builtin_sym_end] = ACTIONS(4687),
    [anon_sym_SEMI] = ACTIONS(4689),
    [anon_sym_PIPE] = ACTIONS(4689),
    [anon_sym_RPAREN] = ACTIONS(4687),
    [anon_sym_SEMI_SEMI] = ACTIONS(4687),
    [anon_sym_PIPE_AMP] = ACTIONS(4687),
    [anon_sym_AMP_AMP] = ACTIONS(4687),
    [anon_sym_PIPE_PIPE] = ACTIONS(4687),
    [anon_sym_LT] = ACTIONS(4689),
    [anon_sym_GT] = ACTIONS(4689),
    [anon_sym_GT_GT] = ACTIONS(4687),
    [anon_sym_AMP_GT] = ACTIONS(4689),
    [anon_sym_AMP_GT_GT] = ACTIONS(4687),
    [anon_sym_LT_AMP] = ACTIONS(4687),
    [anon_sym_GT_AMP] = ACTIONS(4687),
    [anon_sym_LT_LT] = ACTIONS(4689),
    [anon_sym_LT_LT_DASH] = ACTIONS(4687),
    [anon_sym_LT_LT_LT] = ACTIONS(4687),
    [sym__special_characters] = ACTIONS(4687),
    [anon_sym_DQUOTE] = ACTIONS(4687),
    [anon_sym_DOLLAR] = ACTIONS(4689),
    [sym_raw_string] = ACTIONS(4687),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4687),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4687),
    [anon_sym_BQUOTE] = ACTIONS(4687),
    [anon_sym_LT_LPAREN] = ACTIONS(4687),
    [anon_sym_GT_LPAREN] = ACTIONS(4687),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4689),
    [sym_word] = ACTIONS(4689),
    [anon_sym_LF] = ACTIONS(4687),
    [anon_sym_AMP] = ACTIONS(4689),
  },
  [1976] = {
    [sym__simple_heredoc_body] = ACTIONS(4691),
    [sym__heredoc_body_beginning] = ACTIONS(4691),
    [sym_file_descriptor] = ACTIONS(4691),
    [sym__concat] = ACTIONS(4691),
    [ts_builtin_sym_end] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_RPAREN] = ACTIONS(4691),
    [anon_sym_SEMI_SEMI] = ACTIONS(4691),
    [anon_sym_PIPE_AMP] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4691),
    [anon_sym_AMP_GT] = ACTIONS(4693),
    [anon_sym_AMP_GT_GT] = ACTIONS(4691),
    [anon_sym_LT_AMP] = ACTIONS(4691),
    [anon_sym_GT_AMP] = ACTIONS(4691),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_LT_LT_DASH] = ACTIONS(4691),
    [anon_sym_LT_LT_LT] = ACTIONS(4691),
    [sym__special_characters] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4693),
    [sym_raw_string] = ACTIONS(4691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4691),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_LT_LPAREN] = ACTIONS(4691),
    [anon_sym_GT_LPAREN] = ACTIONS(4691),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4693),
    [sym_word] = ACTIONS(4693),
    [anon_sym_LF] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4693),
  },
  [1977] = {
    [sym__simple_heredoc_body] = ACTIONS(4695),
    [sym__heredoc_body_beginning] = ACTIONS(4695),
    [sym_file_descriptor] = ACTIONS(4695),
    [sym__concat] = ACTIONS(4695),
    [ts_builtin_sym_end] = ACTIONS(4695),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_RPAREN] = ACTIONS(4695),
    [anon_sym_SEMI_SEMI] = ACTIONS(4695),
    [anon_sym_PIPE_AMP] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_GT_GT] = ACTIONS(4695),
    [anon_sym_AMP_GT] = ACTIONS(4697),
    [anon_sym_AMP_GT_GT] = ACTIONS(4695),
    [anon_sym_LT_AMP] = ACTIONS(4695),
    [anon_sym_GT_AMP] = ACTIONS(4695),
    [anon_sym_LT_LT] = ACTIONS(4697),
    [anon_sym_LT_LT_DASH] = ACTIONS(4695),
    [anon_sym_LT_LT_LT] = ACTIONS(4695),
    [sym__special_characters] = ACTIONS(4695),
    [anon_sym_DQUOTE] = ACTIONS(4695),
    [anon_sym_DOLLAR] = ACTIONS(4697),
    [sym_raw_string] = ACTIONS(4695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4695),
    [anon_sym_BQUOTE] = ACTIONS(4695),
    [anon_sym_LT_LPAREN] = ACTIONS(4695),
    [anon_sym_GT_LPAREN] = ACTIONS(4695),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4697),
    [sym_word] = ACTIONS(4697),
    [anon_sym_LF] = ACTIONS(4695),
    [anon_sym_AMP] = ACTIONS(4697),
  },
  [1978] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5108),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1979] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5110),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1980] = {
    [sym__simple_heredoc_body] = ACTIONS(4731),
    [sym__heredoc_body_beginning] = ACTIONS(4731),
    [sym_file_descriptor] = ACTIONS(4731),
    [sym__concat] = ACTIONS(4731),
    [ts_builtin_sym_end] = ACTIONS(4731),
    [anon_sym_SEMI] = ACTIONS(4733),
    [anon_sym_PIPE] = ACTIONS(4733),
    [anon_sym_RPAREN] = ACTIONS(4731),
    [anon_sym_SEMI_SEMI] = ACTIONS(4731),
    [anon_sym_PIPE_AMP] = ACTIONS(4731),
    [anon_sym_AMP_AMP] = ACTIONS(4731),
    [anon_sym_PIPE_PIPE] = ACTIONS(4731),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_GT] = ACTIONS(4731),
    [anon_sym_AMP_GT] = ACTIONS(4733),
    [anon_sym_AMP_GT_GT] = ACTIONS(4731),
    [anon_sym_LT_AMP] = ACTIONS(4731),
    [anon_sym_GT_AMP] = ACTIONS(4731),
    [anon_sym_LT_LT] = ACTIONS(4733),
    [anon_sym_LT_LT_DASH] = ACTIONS(4731),
    [anon_sym_LT_LT_LT] = ACTIONS(4731),
    [sym__special_characters] = ACTIONS(4731),
    [anon_sym_DQUOTE] = ACTIONS(4731),
    [anon_sym_DOLLAR] = ACTIONS(4733),
    [sym_raw_string] = ACTIONS(4731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4731),
    [anon_sym_BQUOTE] = ACTIONS(4731),
    [anon_sym_LT_LPAREN] = ACTIONS(4731),
    [anon_sym_GT_LPAREN] = ACTIONS(4731),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4733),
    [sym_word] = ACTIONS(4733),
    [anon_sym_LF] = ACTIONS(4731),
    [anon_sym_AMP] = ACTIONS(4733),
  },
  [1981] = {
    [sym__simple_heredoc_body] = ACTIONS(4751),
    [sym__heredoc_body_beginning] = ACTIONS(4751),
    [sym_file_descriptor] = ACTIONS(4751),
    [sym__concat] = ACTIONS(4751),
    [ts_builtin_sym_end] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4753),
    [anon_sym_PIPE] = ACTIONS(4753),
    [anon_sym_RPAREN] = ACTIONS(4751),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_PIPE_AMP] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [anon_sym_LT] = ACTIONS(4753),
    [anon_sym_GT] = ACTIONS(4753),
    [anon_sym_GT_GT] = ACTIONS(4751),
    [anon_sym_AMP_GT] = ACTIONS(4753),
    [anon_sym_AMP_GT_GT] = ACTIONS(4751),
    [anon_sym_LT_AMP] = ACTIONS(4751),
    [anon_sym_GT_AMP] = ACTIONS(4751),
    [anon_sym_LT_LT] = ACTIONS(4753),
    [anon_sym_LT_LT_DASH] = ACTIONS(4751),
    [anon_sym_LT_LT_LT] = ACTIONS(4751),
    [sym__special_characters] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4753),
    [sym_raw_string] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_LT_LPAREN] = ACTIONS(4751),
    [anon_sym_GT_LPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4753),
    [sym_word] = ACTIONS(4753),
    [anon_sym_LF] = ACTIONS(4751),
    [anon_sym_AMP] = ACTIONS(4753),
  },
  [1982] = {
    [sym__simple_heredoc_body] = ACTIONS(4755),
    [sym__heredoc_body_beginning] = ACTIONS(4755),
    [sym_file_descriptor] = ACTIONS(4755),
    [sym__concat] = ACTIONS(4755),
    [ts_builtin_sym_end] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4757),
    [anon_sym_PIPE] = ACTIONS(4757),
    [anon_sym_RPAREN] = ACTIONS(4755),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [anon_sym_PIPE_AMP] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(4757),
    [anon_sym_GT] = ACTIONS(4757),
    [anon_sym_GT_GT] = ACTIONS(4755),
    [anon_sym_AMP_GT] = ACTIONS(4757),
    [anon_sym_AMP_GT_GT] = ACTIONS(4755),
    [anon_sym_LT_AMP] = ACTIONS(4755),
    [anon_sym_GT_AMP] = ACTIONS(4755),
    [anon_sym_LT_LT] = ACTIONS(4757),
    [anon_sym_LT_LT_DASH] = ACTIONS(4755),
    [anon_sym_LT_LT_LT] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4757),
    [sym_raw_string] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_LT_LPAREN] = ACTIONS(4755),
    [anon_sym_GT_LPAREN] = ACTIONS(4755),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4757),
    [sym_word] = ACTIONS(4757),
    [anon_sym_LF] = ACTIONS(4755),
    [anon_sym_AMP] = ACTIONS(4757),
  },
  [1983] = {
    [sym_file_descriptor] = ACTIONS(4687),
    [sym__concat] = ACTIONS(4687),
    [sym_variable_name] = ACTIONS(4687),
    [anon_sym_LT] = ACTIONS(4689),
    [anon_sym_GT] = ACTIONS(4689),
    [anon_sym_GT_GT] = ACTIONS(4687),
    [anon_sym_AMP_GT] = ACTIONS(4689),
    [anon_sym_AMP_GT_GT] = ACTIONS(4687),
    [anon_sym_LT_AMP] = ACTIONS(4687),
    [anon_sym_GT_AMP] = ACTIONS(4687),
    [sym__special_characters] = ACTIONS(4687),
    [anon_sym_DQUOTE] = ACTIONS(4687),
    [anon_sym_DOLLAR] = ACTIONS(4689),
    [sym_raw_string] = ACTIONS(4687),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4687),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4687),
    [anon_sym_BQUOTE] = ACTIONS(4687),
    [anon_sym_LT_LPAREN] = ACTIONS(4687),
    [anon_sym_GT_LPAREN] = ACTIONS(4687),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4687),
  },
  [1984] = {
    [sym_file_descriptor] = ACTIONS(4691),
    [sym__concat] = ACTIONS(4691),
    [sym_variable_name] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4691),
    [anon_sym_AMP_GT] = ACTIONS(4693),
    [anon_sym_AMP_GT_GT] = ACTIONS(4691),
    [anon_sym_LT_AMP] = ACTIONS(4691),
    [anon_sym_GT_AMP] = ACTIONS(4691),
    [sym__special_characters] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4693),
    [sym_raw_string] = ACTIONS(4691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4691),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_LT_LPAREN] = ACTIONS(4691),
    [anon_sym_GT_LPAREN] = ACTIONS(4691),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4691),
  },
  [1985] = {
    [sym_file_descriptor] = ACTIONS(4695),
    [sym__concat] = ACTIONS(4695),
    [sym_variable_name] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_GT_GT] = ACTIONS(4695),
    [anon_sym_AMP_GT] = ACTIONS(4697),
    [anon_sym_AMP_GT_GT] = ACTIONS(4695),
    [anon_sym_LT_AMP] = ACTIONS(4695),
    [anon_sym_GT_AMP] = ACTIONS(4695),
    [sym__special_characters] = ACTIONS(4695),
    [anon_sym_DQUOTE] = ACTIONS(4695),
    [anon_sym_DOLLAR] = ACTIONS(4697),
    [sym_raw_string] = ACTIONS(4695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4695),
    [anon_sym_BQUOTE] = ACTIONS(4695),
    [anon_sym_LT_LPAREN] = ACTIONS(4695),
    [anon_sym_GT_LPAREN] = ACTIONS(4695),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4695),
  },
  [1986] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5112),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1987] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5114),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1988] = {
    [sym_file_descriptor] = ACTIONS(4731),
    [sym__concat] = ACTIONS(4731),
    [sym_variable_name] = ACTIONS(4731),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_GT] = ACTIONS(4731),
    [anon_sym_AMP_GT] = ACTIONS(4733),
    [anon_sym_AMP_GT_GT] = ACTIONS(4731),
    [anon_sym_LT_AMP] = ACTIONS(4731),
    [anon_sym_GT_AMP] = ACTIONS(4731),
    [sym__special_characters] = ACTIONS(4731),
    [anon_sym_DQUOTE] = ACTIONS(4731),
    [anon_sym_DOLLAR] = ACTIONS(4733),
    [sym_raw_string] = ACTIONS(4731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4731),
    [anon_sym_BQUOTE] = ACTIONS(4731),
    [anon_sym_LT_LPAREN] = ACTIONS(4731),
    [anon_sym_GT_LPAREN] = ACTIONS(4731),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4731),
  },
  [1989] = {
    [sym_file_descriptor] = ACTIONS(4751),
    [sym__concat] = ACTIONS(4751),
    [sym_variable_name] = ACTIONS(4751),
    [anon_sym_LT] = ACTIONS(4753),
    [anon_sym_GT] = ACTIONS(4753),
    [anon_sym_GT_GT] = ACTIONS(4751),
    [anon_sym_AMP_GT] = ACTIONS(4753),
    [anon_sym_AMP_GT_GT] = ACTIONS(4751),
    [anon_sym_LT_AMP] = ACTIONS(4751),
    [anon_sym_GT_AMP] = ACTIONS(4751),
    [sym__special_characters] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4753),
    [sym_raw_string] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_LT_LPAREN] = ACTIONS(4751),
    [anon_sym_GT_LPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4751),
  },
  [1990] = {
    [sym_file_descriptor] = ACTIONS(4755),
    [sym__concat] = ACTIONS(4755),
    [sym_variable_name] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(4757),
    [anon_sym_GT] = ACTIONS(4757),
    [anon_sym_GT_GT] = ACTIONS(4755),
    [anon_sym_AMP_GT] = ACTIONS(4757),
    [anon_sym_AMP_GT_GT] = ACTIONS(4755),
    [anon_sym_LT_AMP] = ACTIONS(4755),
    [anon_sym_GT_AMP] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4757),
    [sym_raw_string] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_LT_LPAREN] = ACTIONS(4755),
    [anon_sym_GT_LPAREN] = ACTIONS(4755),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4755),
  },
  [1991] = {
    [sym__concat] = ACTIONS(4687),
    [anon_sym_DQUOTE] = ACTIONS(4689),
    [anon_sym_DOLLAR] = ACTIONS(4689),
    [sym__string_content] = ACTIONS(4687),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4689),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4689),
    [anon_sym_BQUOTE] = ACTIONS(4689),
    [sym_comment] = ACTIONS(265),
  },
  [1992] = {
    [sym__concat] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4693),
    [anon_sym_DOLLAR] = ACTIONS(4693),
    [sym__string_content] = ACTIONS(4691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4693),
    [anon_sym_BQUOTE] = ACTIONS(4693),
    [sym_comment] = ACTIONS(265),
  },
  [1993] = {
    [sym__concat] = ACTIONS(4695),
    [anon_sym_DQUOTE] = ACTIONS(4697),
    [anon_sym_DOLLAR] = ACTIONS(4697),
    [sym__string_content] = ACTIONS(4695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4697),
    [anon_sym_BQUOTE] = ACTIONS(4697),
    [sym_comment] = ACTIONS(265),
  },
  [1994] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5116),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1995] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5118),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [1996] = {
    [sym__concat] = ACTIONS(4731),
    [anon_sym_DQUOTE] = ACTIONS(4733),
    [anon_sym_DOLLAR] = ACTIONS(4733),
    [sym__string_content] = ACTIONS(4731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4733),
    [anon_sym_BQUOTE] = ACTIONS(4733),
    [sym_comment] = ACTIONS(265),
  },
  [1997] = {
    [sym__concat] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4753),
    [anon_sym_DOLLAR] = ACTIONS(4753),
    [sym__string_content] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4753),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4753),
    [anon_sym_BQUOTE] = ACTIONS(4753),
    [sym_comment] = ACTIONS(265),
  },
  [1998] = {
    [anon_sym_RBRACE] = ACTIONS(4108),
    [anon_sym_EQ] = ACTIONS(5120),
    [anon_sym_DASH] = ACTIONS(5120),
    [sym__special_characters] = ACTIONS(5120),
    [anon_sym_DQUOTE] = ACTIONS(4108),
    [anon_sym_DOLLAR] = ACTIONS(5120),
    [sym_raw_string] = ACTIONS(4108),
    [anon_sym_POUND] = ACTIONS(4108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4108),
    [anon_sym_COLON] = ACTIONS(5120),
    [anon_sym_COLON_QMARK] = ACTIONS(5120),
    [anon_sym_COLON_DASH] = ACTIONS(5120),
    [anon_sym_PERCENT] = ACTIONS(5120),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4108),
    [anon_sym_BQUOTE] = ACTIONS(4108),
    [anon_sym_LT_LPAREN] = ACTIONS(4108),
    [anon_sym_GT_LPAREN] = ACTIONS(4108),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(5120),
  },
  [1999] = {
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_EQ] = ACTIONS(5122),
    [anon_sym_DASH] = ACTIONS(5122),
    [sym__special_characters] = ACTIONS(5122),
    [anon_sym_DQUOTE] = ACTIONS(4110),
    [anon_sym_DOLLAR] = ACTIONS(5122),
    [sym_raw_string] = ACTIONS(4110),
    [anon_sym_POUND] = ACTIONS(4110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4110),
    [anon_sym_SLASH] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(5122),
    [anon_sym_COLON_QMARK] = ACTIONS(5122),
    [anon_sym_COLON_DASH] = ACTIONS(5122),
    [anon_sym_PERCENT] = ACTIONS(5122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4110),
    [anon_sym_BQUOTE] = ACTIONS(4110),
    [anon_sym_LT_LPAREN] = ACTIONS(4110),
    [anon_sym_GT_LPAREN] = ACTIONS(4110),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(5122),
  },
  [2000] = {
    [sym__concat] = ACTIONS(2930),
    [anon_sym_RBRACE] = ACTIONS(2930),
    [sym_comment] = ACTIONS(57),
  },
  [2001] = {
    [sym__concat] = ACTIONS(2944),
    [anon_sym_RBRACE] = ACTIONS(2944),
    [sym_comment] = ACTIONS(57),
  },
  [2002] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(5124),
    [sym_comment] = ACTIONS(57),
  },
  [2003] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(5126),
    [sym_comment] = ACTIONS(57),
  },
  [2004] = {
    [anon_sym_RBRACE] = ACTIONS(5126),
    [sym_comment] = ACTIONS(57),
  },
  [2005] = {
    [sym_concatenation] = STATE(2208),
    [sym_string] = STATE(2207),
    [sym_simple_expansion] = STATE(2207),
    [sym_string_expansion] = STATE(2207),
    [sym_expansion] = STATE(2207),
    [sym_command_substitution] = STATE(2207),
    [sym_process_substitution] = STATE(2207),
    [anon_sym_RBRACE] = ACTIONS(5126),
    [sym__special_characters] = ACTIONS(5128),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(5130),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5130),
  },
  [2006] = {
    [sym__concat] = ACTIONS(2980),
    [anon_sym_RBRACE] = ACTIONS(2980),
    [sym_comment] = ACTIONS(57),
  },
  [2007] = {
    [sym_concatenation] = STATE(2211),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2211),
    [sym_regex] = ACTIONS(5132),
    [anon_sym_RBRACE] = ACTIONS(5134),
    [anon_sym_EQ] = ACTIONS(5136),
    [anon_sym_DASH] = ACTIONS(5136),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5138),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(5136),
    [anon_sym_COLON_QMARK] = ACTIONS(5136),
    [anon_sym_COLON_DASH] = ACTIONS(5136),
    [anon_sym_PERCENT] = ACTIONS(5136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2008] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5134),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2009] = {
    [sym_concatenation] = STATE(2213),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2213),
    [sym_regex] = ACTIONS(5140),
    [anon_sym_RBRACE] = ACTIONS(5126),
    [anon_sym_EQ] = ACTIONS(5142),
    [anon_sym_DASH] = ACTIONS(5142),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(5142),
    [anon_sym_COLON_QMARK] = ACTIONS(5142),
    [anon_sym_COLON_DASH] = ACTIONS(5142),
    [anon_sym_PERCENT] = ACTIONS(5142),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2010] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5126),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2011] = {
    [sym_concatenation] = STATE(2215),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2215),
    [anon_sym_RBRACE] = ACTIONS(5146),
    [anon_sym_EQ] = ACTIONS(5148),
    [anon_sym_DASH] = ACTIONS(5148),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5150),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(5148),
    [anon_sym_COLON_QMARK] = ACTIONS(5148),
    [anon_sym_COLON_DASH] = ACTIONS(5148),
    [anon_sym_PERCENT] = ACTIONS(5148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2012] = {
    [sym__concat] = ACTIONS(3036),
    [anon_sym_RBRACE] = ACTIONS(3036),
    [sym_comment] = ACTIONS(57),
  },
  [2013] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5146),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2014] = {
    [sym_concatenation] = STATE(2213),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2213),
    [anon_sym_RBRACE] = ACTIONS(5126),
    [anon_sym_EQ] = ACTIONS(5142),
    [anon_sym_DASH] = ACTIONS(5142),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(5142),
    [anon_sym_COLON_QMARK] = ACTIONS(5142),
    [anon_sym_COLON_DASH] = ACTIONS(5142),
    [anon_sym_PERCENT] = ACTIONS(5142),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2015] = {
    [sym__concat] = ACTIONS(3091),
    [anon_sym_RBRACE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
  },
  [2016] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(5152),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2017] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(5152),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2018] = {
    [anon_sym_SEMI] = ACTIONS(5154),
    [anon_sym_RPAREN] = ACTIONS(5152),
    [anon_sym_SEMI_SEMI] = ACTIONS(5156),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5156),
    [anon_sym_AMP] = ACTIONS(5156),
  },
  [2019] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(5152),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2020] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(5152),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2021] = {
    [anon_sym_SEMI] = ACTIONS(5158),
    [anon_sym_SEMI_SEMI] = ACTIONS(5160),
    [anon_sym_BQUOTE] = ACTIONS(5152),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5160),
    [anon_sym_AMP] = ACTIONS(5160),
  },
  [2022] = {
    [sym__concat] = ACTIONS(3121),
    [anon_sym_RBRACE] = ACTIONS(3121),
    [sym_comment] = ACTIONS(57),
  },
  [2023] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(5162),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2024] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(5162),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2025] = {
    [anon_sym_SEMI] = ACTIONS(5164),
    [anon_sym_RPAREN] = ACTIONS(5162),
    [anon_sym_SEMI_SEMI] = ACTIONS(5166),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5166),
    [anon_sym_AMP] = ACTIONS(5166),
  },
  [2026] = {
    [sym__simple_heredoc_body] = ACTIONS(5168),
    [sym__heredoc_body_beginning] = ACTIONS(5168),
    [sym_file_descriptor] = ACTIONS(5168),
    [sym__concat] = ACTIONS(5168),
    [ts_builtin_sym_end] = ACTIONS(5168),
    [anon_sym_SEMI] = ACTIONS(5170),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_RPAREN] = ACTIONS(5168),
    [anon_sym_SEMI_SEMI] = ACTIONS(5168),
    [anon_sym_PIPE_AMP] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_EQ_TILDE] = ACTIONS(5170),
    [anon_sym_EQ_EQ] = ACTIONS(5170),
    [anon_sym_LT] = ACTIONS(5170),
    [anon_sym_GT] = ACTIONS(5170),
    [anon_sym_GT_GT] = ACTIONS(5168),
    [anon_sym_AMP_GT] = ACTIONS(5170),
    [anon_sym_AMP_GT_GT] = ACTIONS(5168),
    [anon_sym_LT_AMP] = ACTIONS(5168),
    [anon_sym_GT_AMP] = ACTIONS(5168),
    [anon_sym_LT_LT] = ACTIONS(5170),
    [anon_sym_LT_LT_DASH] = ACTIONS(5168),
    [anon_sym_LT_LT_LT] = ACTIONS(5168),
    [sym__special_characters] = ACTIONS(5168),
    [anon_sym_DQUOTE] = ACTIONS(5168),
    [anon_sym_DOLLAR] = ACTIONS(5170),
    [sym_raw_string] = ACTIONS(5168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5168),
    [anon_sym_BQUOTE] = ACTIONS(5168),
    [anon_sym_LT_LPAREN] = ACTIONS(5168),
    [anon_sym_GT_LPAREN] = ACTIONS(5168),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5170),
    [anon_sym_LF] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5170),
  },
  [2027] = {
    [sym__simple_heredoc_body] = ACTIONS(5172),
    [sym__heredoc_body_beginning] = ACTIONS(5172),
    [sym_file_descriptor] = ACTIONS(5172),
    [sym__concat] = ACTIONS(5172),
    [ts_builtin_sym_end] = ACTIONS(5172),
    [anon_sym_SEMI] = ACTIONS(5174),
    [anon_sym_PIPE] = ACTIONS(5174),
    [anon_sym_RPAREN] = ACTIONS(5172),
    [anon_sym_SEMI_SEMI] = ACTIONS(5172),
    [anon_sym_PIPE_AMP] = ACTIONS(5172),
    [anon_sym_AMP_AMP] = ACTIONS(5172),
    [anon_sym_PIPE_PIPE] = ACTIONS(5172),
    [anon_sym_EQ_TILDE] = ACTIONS(5174),
    [anon_sym_EQ_EQ] = ACTIONS(5174),
    [anon_sym_LT] = ACTIONS(5174),
    [anon_sym_GT] = ACTIONS(5174),
    [anon_sym_GT_GT] = ACTIONS(5172),
    [anon_sym_AMP_GT] = ACTIONS(5174),
    [anon_sym_AMP_GT_GT] = ACTIONS(5172),
    [anon_sym_LT_AMP] = ACTIONS(5172),
    [anon_sym_GT_AMP] = ACTIONS(5172),
    [anon_sym_LT_LT] = ACTIONS(5174),
    [anon_sym_LT_LT_DASH] = ACTIONS(5172),
    [anon_sym_LT_LT_LT] = ACTIONS(5172),
    [sym__special_characters] = ACTIONS(5172),
    [anon_sym_DQUOTE] = ACTIONS(5172),
    [anon_sym_DOLLAR] = ACTIONS(5174),
    [sym_raw_string] = ACTIONS(5172),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5172),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5172),
    [anon_sym_BQUOTE] = ACTIONS(5172),
    [anon_sym_LT_LPAREN] = ACTIONS(5172),
    [anon_sym_GT_LPAREN] = ACTIONS(5172),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5174),
    [anon_sym_LF] = ACTIONS(5172),
    [anon_sym_AMP] = ACTIONS(5174),
  },
  [2028] = {
    [sym__concat] = ACTIONS(3921),
    [anon_sym_RBRACE] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [sym__special_characters] = ACTIONS(3923),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_DOLLAR] = ACTIONS(3923),
    [sym_raw_string] = ACTIONS(3921),
    [anon_sym_POUND] = ACTIONS(3921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3921),
    [anon_sym_COLON] = ACTIONS(3923),
    [anon_sym_COLON_QMARK] = ACTIONS(3923),
    [anon_sym_COLON_DASH] = ACTIONS(3923),
    [anon_sym_PERCENT] = ACTIONS(3923),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3921),
    [anon_sym_BQUOTE] = ACTIONS(3921),
    [anon_sym_LT_LPAREN] = ACTIONS(3921),
    [anon_sym_GT_LPAREN] = ACTIONS(3921),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3923),
  },
  [2029] = {
    [sym__concat] = ACTIONS(3929),
    [anon_sym_RBRACE] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [sym__special_characters] = ACTIONS(3931),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [sym_raw_string] = ACTIONS(3929),
    [anon_sym_POUND] = ACTIONS(3929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3929),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_COLON_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_DASH] = ACTIONS(3931),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3929),
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [anon_sym_LT_LPAREN] = ACTIONS(3929),
    [anon_sym_GT_LPAREN] = ACTIONS(3929),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3931),
  },
  [2030] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(5176),
    [sym_comment] = ACTIONS(57),
  },
  [2031] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(5178),
    [sym_comment] = ACTIONS(57),
  },
  [2032] = {
    [anon_sym_RBRACE] = ACTIONS(5178),
    [sym_comment] = ACTIONS(57),
  },
  [2033] = {
    [sym_concatenation] = STATE(2224),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2224),
    [anon_sym_RBRACE] = ACTIONS(5180),
    [anon_sym_EQ] = ACTIONS(5182),
    [anon_sym_DASH] = ACTIONS(5182),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(5182),
    [anon_sym_COLON_QMARK] = ACTIONS(5182),
    [anon_sym_COLON_DASH] = ACTIONS(5182),
    [anon_sym_PERCENT] = ACTIONS(5182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2034] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_RBRACE] = ACTIONS(3985),
    [anon_sym_EQ] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3987),
    [sym__special_characters] = ACTIONS(3987),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_POUND] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_COLON] = ACTIONS(3987),
    [anon_sym_COLON_QMARK] = ACTIONS(3987),
    [anon_sym_COLON_DASH] = ACTIONS(3987),
    [anon_sym_PERCENT] = ACTIONS(3987),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3987),
  },
  [2035] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5180),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2036] = {
    [sym_concatenation] = STATE(2225),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2225),
    [anon_sym_RBRACE] = ACTIONS(5178),
    [anon_sym_EQ] = ACTIONS(5186),
    [anon_sym_DASH] = ACTIONS(5186),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5188),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(5186),
    [anon_sym_COLON_QMARK] = ACTIONS(5186),
    [anon_sym_COLON_DASH] = ACTIONS(5186),
    [anon_sym_PERCENT] = ACTIONS(5186),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2037] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5178),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2038] = {
    [sym__concat] = ACTIONS(4030),
    [anon_sym_RBRACE] = ACTIONS(4030),
    [anon_sym_EQ] = ACTIONS(4032),
    [anon_sym_DASH] = ACTIONS(4032),
    [sym__special_characters] = ACTIONS(4032),
    [anon_sym_DQUOTE] = ACTIONS(4030),
    [anon_sym_DOLLAR] = ACTIONS(4032),
    [sym_raw_string] = ACTIONS(4030),
    [anon_sym_POUND] = ACTIONS(4030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4030),
    [anon_sym_COLON] = ACTIONS(4032),
    [anon_sym_COLON_QMARK] = ACTIONS(4032),
    [anon_sym_COLON_DASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4030),
    [anon_sym_BQUOTE] = ACTIONS(4030),
    [anon_sym_LT_LPAREN] = ACTIONS(4030),
    [anon_sym_GT_LPAREN] = ACTIONS(4030),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4032),
  },
  [2039] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5190),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2040] = {
    [sym__concat] = ACTIONS(4064),
    [anon_sym_RBRACE] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [sym__special_characters] = ACTIONS(4066),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_DOLLAR] = ACTIONS(4066),
    [sym_raw_string] = ACTIONS(4064),
    [anon_sym_POUND] = ACTIONS(4064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4064),
    [anon_sym_COLON] = ACTIONS(4066),
    [anon_sym_COLON_QMARK] = ACTIONS(4066),
    [anon_sym_COLON_DASH] = ACTIONS(4066),
    [anon_sym_PERCENT] = ACTIONS(4066),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4064),
    [anon_sym_BQUOTE] = ACTIONS(4064),
    [anon_sym_LT_LPAREN] = ACTIONS(4064),
    [anon_sym_GT_LPAREN] = ACTIONS(4064),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4066),
  },
  [2041] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(5192),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2042] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(5192),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2043] = {
    [sym__concat] = ACTIONS(4070),
    [anon_sym_RBRACE] = ACTIONS(4070),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_DASH] = ACTIONS(4072),
    [sym__special_characters] = ACTIONS(4072),
    [anon_sym_DQUOTE] = ACTIONS(4070),
    [anon_sym_DOLLAR] = ACTIONS(4072),
    [sym_raw_string] = ACTIONS(4070),
    [anon_sym_POUND] = ACTIONS(4070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4070),
    [anon_sym_COLON] = ACTIONS(4072),
    [anon_sym_COLON_QMARK] = ACTIONS(4072),
    [anon_sym_COLON_DASH] = ACTIONS(4072),
    [anon_sym_PERCENT] = ACTIONS(4072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4070),
    [anon_sym_BQUOTE] = ACTIONS(4070),
    [anon_sym_LT_LPAREN] = ACTIONS(4070),
    [anon_sym_GT_LPAREN] = ACTIONS(4070),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4072),
  },
  [2044] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(5194),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2045] = {
    [sym__heredoc_body_middle] = ACTIONS(3921),
    [sym__heredoc_body_end] = ACTIONS(3921),
    [anon_sym_DOLLAR] = ACTIONS(3923),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3921),
    [sym_comment] = ACTIONS(57),
  },
  [2046] = {
    [sym__heredoc_body_middle] = ACTIONS(3929),
    [sym__heredoc_body_end] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3929),
    [sym_comment] = ACTIONS(57),
  },
  [2047] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(5196),
    [sym_comment] = ACTIONS(57),
  },
  [2048] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(5198),
    [sym_comment] = ACTIONS(57),
  },
  [2049] = {
    [anon_sym_RBRACE] = ACTIONS(5198),
    [sym_comment] = ACTIONS(57),
  },
  [2050] = {
    [sym_concatenation] = STATE(2232),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2232),
    [anon_sym_RBRACE] = ACTIONS(5200),
    [anon_sym_EQ] = ACTIONS(5202),
    [anon_sym_DASH] = ACTIONS(5202),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(5202),
    [anon_sym_COLON_QMARK] = ACTIONS(5202),
    [anon_sym_COLON_DASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2051] = {
    [sym__heredoc_body_middle] = ACTIONS(3985),
    [sym__heredoc_body_end] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [sym_comment] = ACTIONS(57),
  },
  [2052] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5200),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2053] = {
    [sym_concatenation] = STATE(2233),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2233),
    [anon_sym_RBRACE] = ACTIONS(5198),
    [anon_sym_EQ] = ACTIONS(5206),
    [anon_sym_DASH] = ACTIONS(5206),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5208),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(5206),
    [anon_sym_COLON_QMARK] = ACTIONS(5206),
    [anon_sym_COLON_DASH] = ACTIONS(5206),
    [anon_sym_PERCENT] = ACTIONS(5206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2054] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5198),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2055] = {
    [sym__heredoc_body_middle] = ACTIONS(4030),
    [sym__heredoc_body_end] = ACTIONS(4030),
    [anon_sym_DOLLAR] = ACTIONS(4032),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4030),
    [sym_comment] = ACTIONS(57),
  },
  [2056] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5210),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2057] = {
    [sym__concat] = ACTIONS(3921),
    [anon_sym_RPAREN] = ACTIONS(3921),
    [sym__special_characters] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_DOLLAR] = ACTIONS(3923),
    [sym_raw_string] = ACTIONS(3921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3921),
    [anon_sym_BQUOTE] = ACTIONS(3921),
    [anon_sym_LT_LPAREN] = ACTIONS(3921),
    [anon_sym_GT_LPAREN] = ACTIONS(3921),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3921),
  },
  [2058] = {
    [sym__concat] = ACTIONS(3929),
    [anon_sym_RPAREN] = ACTIONS(3929),
    [sym__special_characters] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [sym_raw_string] = ACTIONS(3929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3929),
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [anon_sym_LT_LPAREN] = ACTIONS(3929),
    [anon_sym_GT_LPAREN] = ACTIONS(3929),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3929),
  },
  [2059] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [sym_comment] = ACTIONS(57),
  },
  [2060] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(5214),
    [sym_comment] = ACTIONS(57),
  },
  [2061] = {
    [anon_sym_RBRACE] = ACTIONS(5214),
    [sym_comment] = ACTIONS(57),
  },
  [2062] = {
    [sym_concatenation] = STATE(2238),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2238),
    [anon_sym_RBRACE] = ACTIONS(5216),
    [anon_sym_EQ] = ACTIONS(5218),
    [anon_sym_DASH] = ACTIONS(5218),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(5218),
    [anon_sym_COLON_QMARK] = ACTIONS(5218),
    [anon_sym_COLON_DASH] = ACTIONS(5218),
    [anon_sym_PERCENT] = ACTIONS(5218),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2063] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_RPAREN] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3985),
  },
  [2064] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5216),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2065] = {
    [sym_concatenation] = STATE(2239),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2239),
    [anon_sym_RBRACE] = ACTIONS(5214),
    [anon_sym_EQ] = ACTIONS(5222),
    [anon_sym_DASH] = ACTIONS(5222),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5224),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(5222),
    [anon_sym_COLON_QMARK] = ACTIONS(5222),
    [anon_sym_COLON_DASH] = ACTIONS(5222),
    [anon_sym_PERCENT] = ACTIONS(5222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2066] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5214),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2067] = {
    [sym__concat] = ACTIONS(4030),
    [anon_sym_RPAREN] = ACTIONS(4030),
    [sym__special_characters] = ACTIONS(4030),
    [anon_sym_DQUOTE] = ACTIONS(4030),
    [anon_sym_DOLLAR] = ACTIONS(4032),
    [sym_raw_string] = ACTIONS(4030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4030),
    [anon_sym_BQUOTE] = ACTIONS(4030),
    [anon_sym_LT_LPAREN] = ACTIONS(4030),
    [anon_sym_GT_LPAREN] = ACTIONS(4030),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4030),
  },
  [2068] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5226),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2069] = {
    [sym__concat] = ACTIONS(4064),
    [anon_sym_RPAREN] = ACTIONS(4064),
    [sym__special_characters] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_DOLLAR] = ACTIONS(4066),
    [sym_raw_string] = ACTIONS(4064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4064),
    [anon_sym_BQUOTE] = ACTIONS(4064),
    [anon_sym_LT_LPAREN] = ACTIONS(4064),
    [anon_sym_GT_LPAREN] = ACTIONS(4064),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4064),
  },
  [2070] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(5228),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2071] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(5228),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2072] = {
    [sym__concat] = ACTIONS(4070),
    [anon_sym_RPAREN] = ACTIONS(4070),
    [sym__special_characters] = ACTIONS(4070),
    [anon_sym_DQUOTE] = ACTIONS(4070),
    [anon_sym_DOLLAR] = ACTIONS(4072),
    [sym_raw_string] = ACTIONS(4070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4070),
    [anon_sym_BQUOTE] = ACTIONS(4070),
    [anon_sym_LT_LPAREN] = ACTIONS(4070),
    [anon_sym_GT_LPAREN] = ACTIONS(4070),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4070),
  },
  [2073] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(5230),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2074] = {
    [sym__simple_heredoc_body] = ACTIONS(4687),
    [sym__heredoc_body_beginning] = ACTIONS(4687),
    [sym_file_descriptor] = ACTIONS(4687),
    [sym__concat] = ACTIONS(4687),
    [sym_variable_name] = ACTIONS(4687),
    [ts_builtin_sym_end] = ACTIONS(4687),
    [anon_sym_SEMI] = ACTIONS(4689),
    [anon_sym_PIPE] = ACTIONS(4689),
    [anon_sym_RPAREN] = ACTIONS(4687),
    [anon_sym_SEMI_SEMI] = ACTIONS(4687),
    [anon_sym_PIPE_AMP] = ACTIONS(4687),
    [anon_sym_AMP_AMP] = ACTIONS(4687),
    [anon_sym_PIPE_PIPE] = ACTIONS(4687),
    [anon_sym_LT] = ACTIONS(4689),
    [anon_sym_GT] = ACTIONS(4689),
    [anon_sym_GT_GT] = ACTIONS(4687),
    [anon_sym_AMP_GT] = ACTIONS(4689),
    [anon_sym_AMP_GT_GT] = ACTIONS(4687),
    [anon_sym_LT_AMP] = ACTIONS(4687),
    [anon_sym_GT_AMP] = ACTIONS(4687),
    [anon_sym_LT_LT] = ACTIONS(4689),
    [anon_sym_LT_LT_DASH] = ACTIONS(4687),
    [anon_sym_LT_LT_LT] = ACTIONS(4687),
    [sym__special_characters] = ACTIONS(4687),
    [anon_sym_DQUOTE] = ACTIONS(4687),
    [anon_sym_DOLLAR] = ACTIONS(4689),
    [sym_raw_string] = ACTIONS(4687),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4687),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4687),
    [anon_sym_BQUOTE] = ACTIONS(4687),
    [anon_sym_LT_LPAREN] = ACTIONS(4687),
    [anon_sym_GT_LPAREN] = ACTIONS(4687),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4689),
    [anon_sym_LF] = ACTIONS(4687),
    [anon_sym_AMP] = ACTIONS(4689),
  },
  [2075] = {
    [sym__simple_heredoc_body] = ACTIONS(4691),
    [sym__heredoc_body_beginning] = ACTIONS(4691),
    [sym_file_descriptor] = ACTIONS(4691),
    [sym__concat] = ACTIONS(4691),
    [sym_variable_name] = ACTIONS(4691),
    [ts_builtin_sym_end] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_RPAREN] = ACTIONS(4691),
    [anon_sym_SEMI_SEMI] = ACTIONS(4691),
    [anon_sym_PIPE_AMP] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4691),
    [anon_sym_AMP_GT] = ACTIONS(4693),
    [anon_sym_AMP_GT_GT] = ACTIONS(4691),
    [anon_sym_LT_AMP] = ACTIONS(4691),
    [anon_sym_GT_AMP] = ACTIONS(4691),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_LT_LT_DASH] = ACTIONS(4691),
    [anon_sym_LT_LT_LT] = ACTIONS(4691),
    [sym__special_characters] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4693),
    [sym_raw_string] = ACTIONS(4691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4691),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_LT_LPAREN] = ACTIONS(4691),
    [anon_sym_GT_LPAREN] = ACTIONS(4691),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4693),
    [anon_sym_LF] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4693),
  },
  [2076] = {
    [sym__simple_heredoc_body] = ACTIONS(4695),
    [sym__heredoc_body_beginning] = ACTIONS(4695),
    [sym_file_descriptor] = ACTIONS(4695),
    [sym__concat] = ACTIONS(4695),
    [sym_variable_name] = ACTIONS(4695),
    [ts_builtin_sym_end] = ACTIONS(4695),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_RPAREN] = ACTIONS(4695),
    [anon_sym_SEMI_SEMI] = ACTIONS(4695),
    [anon_sym_PIPE_AMP] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_GT_GT] = ACTIONS(4695),
    [anon_sym_AMP_GT] = ACTIONS(4697),
    [anon_sym_AMP_GT_GT] = ACTIONS(4695),
    [anon_sym_LT_AMP] = ACTIONS(4695),
    [anon_sym_GT_AMP] = ACTIONS(4695),
    [anon_sym_LT_LT] = ACTIONS(4697),
    [anon_sym_LT_LT_DASH] = ACTIONS(4695),
    [anon_sym_LT_LT_LT] = ACTIONS(4695),
    [sym__special_characters] = ACTIONS(4695),
    [anon_sym_DQUOTE] = ACTIONS(4695),
    [anon_sym_DOLLAR] = ACTIONS(4697),
    [sym_raw_string] = ACTIONS(4695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4695),
    [anon_sym_BQUOTE] = ACTIONS(4695),
    [anon_sym_LT_LPAREN] = ACTIONS(4695),
    [anon_sym_GT_LPAREN] = ACTIONS(4695),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4697),
    [anon_sym_LF] = ACTIONS(4695),
    [anon_sym_AMP] = ACTIONS(4697),
  },
  [2077] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5232),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2078] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5234),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2079] = {
    [sym__simple_heredoc_body] = ACTIONS(4731),
    [sym__heredoc_body_beginning] = ACTIONS(4731),
    [sym_file_descriptor] = ACTIONS(4731),
    [sym__concat] = ACTIONS(4731),
    [sym_variable_name] = ACTIONS(4731),
    [ts_builtin_sym_end] = ACTIONS(4731),
    [anon_sym_SEMI] = ACTIONS(4733),
    [anon_sym_PIPE] = ACTIONS(4733),
    [anon_sym_RPAREN] = ACTIONS(4731),
    [anon_sym_SEMI_SEMI] = ACTIONS(4731),
    [anon_sym_PIPE_AMP] = ACTIONS(4731),
    [anon_sym_AMP_AMP] = ACTIONS(4731),
    [anon_sym_PIPE_PIPE] = ACTIONS(4731),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_GT] = ACTIONS(4731),
    [anon_sym_AMP_GT] = ACTIONS(4733),
    [anon_sym_AMP_GT_GT] = ACTIONS(4731),
    [anon_sym_LT_AMP] = ACTIONS(4731),
    [anon_sym_GT_AMP] = ACTIONS(4731),
    [anon_sym_LT_LT] = ACTIONS(4733),
    [anon_sym_LT_LT_DASH] = ACTIONS(4731),
    [anon_sym_LT_LT_LT] = ACTIONS(4731),
    [sym__special_characters] = ACTIONS(4731),
    [anon_sym_DQUOTE] = ACTIONS(4731),
    [anon_sym_DOLLAR] = ACTIONS(4733),
    [sym_raw_string] = ACTIONS(4731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4731),
    [anon_sym_BQUOTE] = ACTIONS(4731),
    [anon_sym_LT_LPAREN] = ACTIONS(4731),
    [anon_sym_GT_LPAREN] = ACTIONS(4731),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4733),
    [anon_sym_LF] = ACTIONS(4731),
    [anon_sym_AMP] = ACTIONS(4733),
  },
  [2080] = {
    [sym__simple_heredoc_body] = ACTIONS(4751),
    [sym__heredoc_body_beginning] = ACTIONS(4751),
    [sym_file_descriptor] = ACTIONS(4751),
    [sym__concat] = ACTIONS(4751),
    [sym_variable_name] = ACTIONS(4751),
    [ts_builtin_sym_end] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4753),
    [anon_sym_PIPE] = ACTIONS(4753),
    [anon_sym_RPAREN] = ACTIONS(4751),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_PIPE_AMP] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [anon_sym_LT] = ACTIONS(4753),
    [anon_sym_GT] = ACTIONS(4753),
    [anon_sym_GT_GT] = ACTIONS(4751),
    [anon_sym_AMP_GT] = ACTIONS(4753),
    [anon_sym_AMP_GT_GT] = ACTIONS(4751),
    [anon_sym_LT_AMP] = ACTIONS(4751),
    [anon_sym_GT_AMP] = ACTIONS(4751),
    [anon_sym_LT_LT] = ACTIONS(4753),
    [anon_sym_LT_LT_DASH] = ACTIONS(4751),
    [anon_sym_LT_LT_LT] = ACTIONS(4751),
    [sym__special_characters] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4753),
    [sym_raw_string] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_LT_LPAREN] = ACTIONS(4751),
    [anon_sym_GT_LPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4753),
    [anon_sym_LF] = ACTIONS(4751),
    [anon_sym_AMP] = ACTIONS(4753),
  },
  [2081] = {
    [sym__simple_heredoc_body] = ACTIONS(4755),
    [sym__heredoc_body_beginning] = ACTIONS(4755),
    [sym_file_descriptor] = ACTIONS(4755),
    [sym__concat] = ACTIONS(4755),
    [sym_variable_name] = ACTIONS(4755),
    [ts_builtin_sym_end] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4757),
    [anon_sym_PIPE] = ACTIONS(4757),
    [anon_sym_RPAREN] = ACTIONS(4755),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [anon_sym_PIPE_AMP] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(4757),
    [anon_sym_GT] = ACTIONS(4757),
    [anon_sym_GT_GT] = ACTIONS(4755),
    [anon_sym_AMP_GT] = ACTIONS(4757),
    [anon_sym_AMP_GT_GT] = ACTIONS(4755),
    [anon_sym_LT_AMP] = ACTIONS(4755),
    [anon_sym_GT_AMP] = ACTIONS(4755),
    [anon_sym_LT_LT] = ACTIONS(4757),
    [anon_sym_LT_LT_DASH] = ACTIONS(4755),
    [anon_sym_LT_LT_LT] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4757),
    [sym_raw_string] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_LT_LPAREN] = ACTIONS(4755),
    [anon_sym_GT_LPAREN] = ACTIONS(4755),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4757),
    [anon_sym_LF] = ACTIONS(4755),
    [anon_sym_AMP] = ACTIONS(4757),
  },
  [2082] = {
    [sym__simple_heredoc_body] = ACTIONS(5236),
    [sym__heredoc_body_beginning] = ACTIONS(5236),
    [sym_file_descriptor] = ACTIONS(5236),
    [ts_builtin_sym_end] = ACTIONS(5236),
    [anon_sym_SEMI] = ACTIONS(5238),
    [anon_sym_esac] = ACTIONS(5236),
    [anon_sym_PIPE] = ACTIONS(5238),
    [anon_sym_RPAREN] = ACTIONS(5236),
    [anon_sym_SEMI_SEMI] = ACTIONS(5236),
    [anon_sym_PIPE_AMP] = ACTIONS(5236),
    [anon_sym_AMP_AMP] = ACTIONS(5236),
    [anon_sym_PIPE_PIPE] = ACTIONS(5236),
    [anon_sym_LT] = ACTIONS(5238),
    [anon_sym_GT] = ACTIONS(5238),
    [anon_sym_GT_GT] = ACTIONS(5236),
    [anon_sym_AMP_GT] = ACTIONS(5238),
    [anon_sym_AMP_GT_GT] = ACTIONS(5236),
    [anon_sym_LT_AMP] = ACTIONS(5236),
    [anon_sym_GT_AMP] = ACTIONS(5236),
    [anon_sym_LT_LT] = ACTIONS(5238),
    [anon_sym_LT_LT_DASH] = ACTIONS(5236),
    [anon_sym_LT_LT_LT] = ACTIONS(5236),
    [anon_sym_BQUOTE] = ACTIONS(5236),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(5238),
  },
  [2083] = {
    [sym_do_group] = STATE(2245),
    [sym_compound_statement] = STATE(2245),
    [anon_sym_do] = ACTIONS(493),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [2084] = {
    [sym__concat] = ACTIONS(4687),
    [anon_sym_SEMI] = ACTIONS(4689),
    [anon_sym_SEMI_SEMI] = ACTIONS(4687),
    [anon_sym_AMP_AMP] = ACTIONS(4687),
    [anon_sym_PIPE_PIPE] = ACTIONS(4687),
    [anon_sym_EQ_TILDE] = ACTIONS(4687),
    [anon_sym_EQ_EQ] = ACTIONS(4687),
    [anon_sym_EQ] = ACTIONS(4689),
    [anon_sym_PLUS_EQ] = ACTIONS(4687),
    [anon_sym_LT] = ACTIONS(4689),
    [anon_sym_GT] = ACTIONS(4689),
    [anon_sym_BANG_EQ] = ACTIONS(4687),
    [anon_sym_PLUS] = ACTIONS(4689),
    [anon_sym_DASH] = ACTIONS(4689),
    [anon_sym_DASH_EQ] = ACTIONS(4687),
    [anon_sym_LT_EQ] = ACTIONS(4687),
    [anon_sym_GT_EQ] = ACTIONS(4687),
    [anon_sym_PLUS_PLUS] = ACTIONS(4687),
    [anon_sym_DASH_DASH] = ACTIONS(4687),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4687),
    [anon_sym_LF] = ACTIONS(4687),
    [anon_sym_AMP] = ACTIONS(4689),
  },
  [2085] = {
    [sym__concat] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4693),
    [anon_sym_SEMI_SEMI] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4691),
    [anon_sym_EQ_TILDE] = ACTIONS(4691),
    [anon_sym_EQ_EQ] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_PLUS_EQ] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_BANG_EQ] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_DASH_EQ] = ACTIONS(4691),
    [anon_sym_LT_EQ] = ACTIONS(4691),
    [anon_sym_GT_EQ] = ACTIONS(4691),
    [anon_sym_PLUS_PLUS] = ACTIONS(4691),
    [anon_sym_DASH_DASH] = ACTIONS(4691),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4691),
    [anon_sym_LF] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4693),
  },
  [2086] = {
    [sym__concat] = ACTIONS(4695),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_SEMI_SEMI] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_EQ_TILDE] = ACTIONS(4695),
    [anon_sym_EQ_EQ] = ACTIONS(4695),
    [anon_sym_EQ] = ACTIONS(4697),
    [anon_sym_PLUS_EQ] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_BANG_EQ] = ACTIONS(4695),
    [anon_sym_PLUS] = ACTIONS(4697),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_DASH_EQ] = ACTIONS(4695),
    [anon_sym_LT_EQ] = ACTIONS(4695),
    [anon_sym_GT_EQ] = ACTIONS(4695),
    [anon_sym_PLUS_PLUS] = ACTIONS(4695),
    [anon_sym_DASH_DASH] = ACTIONS(4695),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4695),
    [anon_sym_LF] = ACTIONS(4695),
    [anon_sym_AMP] = ACTIONS(4697),
  },
  [2087] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5240),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2088] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5242),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2089] = {
    [sym__concat] = ACTIONS(4731),
    [anon_sym_SEMI] = ACTIONS(4733),
    [anon_sym_SEMI_SEMI] = ACTIONS(4731),
    [anon_sym_AMP_AMP] = ACTIONS(4731),
    [anon_sym_PIPE_PIPE] = ACTIONS(4731),
    [anon_sym_EQ_TILDE] = ACTIONS(4731),
    [anon_sym_EQ_EQ] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(4733),
    [anon_sym_PLUS_EQ] = ACTIONS(4731),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_BANG_EQ] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4733),
    [anon_sym_DASH_EQ] = ACTIONS(4731),
    [anon_sym_LT_EQ] = ACTIONS(4731),
    [anon_sym_GT_EQ] = ACTIONS(4731),
    [anon_sym_PLUS_PLUS] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(4731),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4731),
    [anon_sym_LF] = ACTIONS(4731),
    [anon_sym_AMP] = ACTIONS(4733),
  },
  [2090] = {
    [sym__concat] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4753),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [anon_sym_EQ_TILDE] = ACTIONS(4751),
    [anon_sym_EQ_EQ] = ACTIONS(4751),
    [anon_sym_EQ] = ACTIONS(4753),
    [anon_sym_PLUS_EQ] = ACTIONS(4751),
    [anon_sym_LT] = ACTIONS(4753),
    [anon_sym_GT] = ACTIONS(4753),
    [anon_sym_BANG_EQ] = ACTIONS(4751),
    [anon_sym_PLUS] = ACTIONS(4753),
    [anon_sym_DASH] = ACTIONS(4753),
    [anon_sym_DASH_EQ] = ACTIONS(4751),
    [anon_sym_LT_EQ] = ACTIONS(4751),
    [anon_sym_GT_EQ] = ACTIONS(4751),
    [anon_sym_PLUS_PLUS] = ACTIONS(4751),
    [anon_sym_DASH_DASH] = ACTIONS(4751),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4751),
    [anon_sym_LF] = ACTIONS(4751),
    [anon_sym_AMP] = ACTIONS(4753),
  },
  [2091] = {
    [sym__concat] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4757),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [anon_sym_EQ_TILDE] = ACTIONS(4755),
    [anon_sym_EQ_EQ] = ACTIONS(4755),
    [anon_sym_EQ] = ACTIONS(4757),
    [anon_sym_PLUS_EQ] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(4757),
    [anon_sym_GT] = ACTIONS(4757),
    [anon_sym_BANG_EQ] = ACTIONS(4755),
    [anon_sym_PLUS] = ACTIONS(4757),
    [anon_sym_DASH] = ACTIONS(4757),
    [anon_sym_DASH_EQ] = ACTIONS(4755),
    [anon_sym_LT_EQ] = ACTIONS(4755),
    [anon_sym_GT_EQ] = ACTIONS(4755),
    [anon_sym_PLUS_PLUS] = ACTIONS(4755),
    [anon_sym_DASH_DASH] = ACTIONS(4755),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4755),
    [anon_sym_LF] = ACTIONS(4755),
    [anon_sym_AMP] = ACTIONS(4757),
  },
  [2092] = {
    [sym_do_group] = STATE(2245),
    [sym_compound_statement] = STATE(2245),
    [anon_sym_SEMI] = ACTIONS(5244),
    [anon_sym_do] = ACTIONS(493),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [2093] = {
    [sym__concat] = ACTIONS(3921),
    [anon_sym_SEMI] = ACTIONS(3923),
    [anon_sym_SEMI_SEMI] = ACTIONS(3921),
    [sym__special_characters] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_DOLLAR] = ACTIONS(3923),
    [sym_raw_string] = ACTIONS(3921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3921),
    [anon_sym_BQUOTE] = ACTIONS(3921),
    [anon_sym_LT_LPAREN] = ACTIONS(3921),
    [anon_sym_GT_LPAREN] = ACTIONS(3921),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3923),
    [anon_sym_LF] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3921),
  },
  [2094] = {
    [sym__concat] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3931),
    [anon_sym_SEMI_SEMI] = ACTIONS(3929),
    [sym__special_characters] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [sym_raw_string] = ACTIONS(3929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3929),
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [anon_sym_LT_LPAREN] = ACTIONS(3929),
    [anon_sym_GT_LPAREN] = ACTIONS(3929),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3931),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
  },
  [2095] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(5246),
    [sym_comment] = ACTIONS(57),
  },
  [2096] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(5248),
    [sym_comment] = ACTIONS(57),
  },
  [2097] = {
    [anon_sym_RBRACE] = ACTIONS(5248),
    [sym_comment] = ACTIONS(57),
  },
  [2098] = {
    [sym_concatenation] = STATE(2252),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2252),
    [anon_sym_RBRACE] = ACTIONS(5250),
    [anon_sym_EQ] = ACTIONS(5252),
    [anon_sym_DASH] = ACTIONS(5252),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(5252),
    [anon_sym_COLON_QMARK] = ACTIONS(5252),
    [anon_sym_COLON_DASH] = ACTIONS(5252),
    [anon_sym_PERCENT] = ACTIONS(5252),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2099] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3985),
  },
  [2100] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5250),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2101] = {
    [sym_concatenation] = STATE(2253),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2253),
    [anon_sym_RBRACE] = ACTIONS(5248),
    [anon_sym_EQ] = ACTIONS(5256),
    [anon_sym_DASH] = ACTIONS(5256),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(5256),
    [anon_sym_COLON_QMARK] = ACTIONS(5256),
    [anon_sym_COLON_DASH] = ACTIONS(5256),
    [anon_sym_PERCENT] = ACTIONS(5256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2102] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5248),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2103] = {
    [sym__concat] = ACTIONS(4030),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_SEMI_SEMI] = ACTIONS(4030),
    [sym__special_characters] = ACTIONS(4030),
    [anon_sym_DQUOTE] = ACTIONS(4030),
    [anon_sym_DOLLAR] = ACTIONS(4032),
    [sym_raw_string] = ACTIONS(4030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4030),
    [anon_sym_BQUOTE] = ACTIONS(4030),
    [anon_sym_LT_LPAREN] = ACTIONS(4030),
    [anon_sym_GT_LPAREN] = ACTIONS(4030),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4032),
    [anon_sym_LF] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4030),
  },
  [2104] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5260),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2105] = {
    [sym__concat] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_SEMI_SEMI] = ACTIONS(4064),
    [sym__special_characters] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_DOLLAR] = ACTIONS(4066),
    [sym_raw_string] = ACTIONS(4064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4064),
    [anon_sym_BQUOTE] = ACTIONS(4064),
    [anon_sym_LT_LPAREN] = ACTIONS(4064),
    [anon_sym_GT_LPAREN] = ACTIONS(4064),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4066),
    [anon_sym_LF] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4064),
  },
  [2106] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(5262),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2107] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(5262),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2108] = {
    [sym__concat] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_SEMI_SEMI] = ACTIONS(4070),
    [sym__special_characters] = ACTIONS(4070),
    [anon_sym_DQUOTE] = ACTIONS(4070),
    [anon_sym_DOLLAR] = ACTIONS(4072),
    [sym_raw_string] = ACTIONS(4070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4070),
    [anon_sym_BQUOTE] = ACTIONS(4070),
    [anon_sym_LT_LPAREN] = ACTIONS(4070),
    [anon_sym_GT_LPAREN] = ACTIONS(4070),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4072),
    [anon_sym_LF] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4070),
  },
  [2109] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(5264),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2110] = {
    [sym__concat] = ACTIONS(4687),
    [anon_sym_PIPE] = ACTIONS(4689),
    [anon_sym_RPAREN] = ACTIONS(4687),
    [anon_sym_AMP_AMP] = ACTIONS(4687),
    [anon_sym_PIPE_PIPE] = ACTIONS(4687),
    [anon_sym_EQ_TILDE] = ACTIONS(4687),
    [anon_sym_EQ_EQ] = ACTIONS(4687),
    [anon_sym_EQ] = ACTIONS(4689),
    [anon_sym_PLUS_EQ] = ACTIONS(4687),
    [anon_sym_LT] = ACTIONS(4689),
    [anon_sym_GT] = ACTIONS(4689),
    [anon_sym_BANG_EQ] = ACTIONS(4687),
    [anon_sym_PLUS] = ACTIONS(4689),
    [anon_sym_DASH] = ACTIONS(4689),
    [anon_sym_DASH_EQ] = ACTIONS(4687),
    [anon_sym_LT_EQ] = ACTIONS(4687),
    [anon_sym_GT_EQ] = ACTIONS(4687),
    [anon_sym_PLUS_PLUS] = ACTIONS(4687),
    [anon_sym_DASH_DASH] = ACTIONS(4687),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4687),
  },
  [2111] = {
    [sym__concat] = ACTIONS(4691),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_RPAREN] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4691),
    [anon_sym_EQ_TILDE] = ACTIONS(4691),
    [anon_sym_EQ_EQ] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_PLUS_EQ] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_BANG_EQ] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_DASH_EQ] = ACTIONS(4691),
    [anon_sym_LT_EQ] = ACTIONS(4691),
    [anon_sym_GT_EQ] = ACTIONS(4691),
    [anon_sym_PLUS_PLUS] = ACTIONS(4691),
    [anon_sym_DASH_DASH] = ACTIONS(4691),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4691),
  },
  [2112] = {
    [sym__concat] = ACTIONS(4695),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_RPAREN] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_EQ_TILDE] = ACTIONS(4695),
    [anon_sym_EQ_EQ] = ACTIONS(4695),
    [anon_sym_EQ] = ACTIONS(4697),
    [anon_sym_PLUS_EQ] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_BANG_EQ] = ACTIONS(4695),
    [anon_sym_PLUS] = ACTIONS(4697),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_DASH_EQ] = ACTIONS(4695),
    [anon_sym_LT_EQ] = ACTIONS(4695),
    [anon_sym_GT_EQ] = ACTIONS(4695),
    [anon_sym_PLUS_PLUS] = ACTIONS(4695),
    [anon_sym_DASH_DASH] = ACTIONS(4695),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4695),
  },
  [2113] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5266),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2114] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5268),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2115] = {
    [sym__concat] = ACTIONS(4731),
    [anon_sym_PIPE] = ACTIONS(4733),
    [anon_sym_RPAREN] = ACTIONS(4731),
    [anon_sym_AMP_AMP] = ACTIONS(4731),
    [anon_sym_PIPE_PIPE] = ACTIONS(4731),
    [anon_sym_EQ_TILDE] = ACTIONS(4731),
    [anon_sym_EQ_EQ] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(4733),
    [anon_sym_PLUS_EQ] = ACTIONS(4731),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_BANG_EQ] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4733),
    [anon_sym_DASH_EQ] = ACTIONS(4731),
    [anon_sym_LT_EQ] = ACTIONS(4731),
    [anon_sym_GT_EQ] = ACTIONS(4731),
    [anon_sym_PLUS_PLUS] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(4731),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4731),
  },
  [2116] = {
    [sym__concat] = ACTIONS(4751),
    [anon_sym_PIPE] = ACTIONS(4753),
    [anon_sym_RPAREN] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [anon_sym_EQ_TILDE] = ACTIONS(4751),
    [anon_sym_EQ_EQ] = ACTIONS(4751),
    [anon_sym_EQ] = ACTIONS(4753),
    [anon_sym_PLUS_EQ] = ACTIONS(4751),
    [anon_sym_LT] = ACTIONS(4753),
    [anon_sym_GT] = ACTIONS(4753),
    [anon_sym_BANG_EQ] = ACTIONS(4751),
    [anon_sym_PLUS] = ACTIONS(4753),
    [anon_sym_DASH] = ACTIONS(4753),
    [anon_sym_DASH_EQ] = ACTIONS(4751),
    [anon_sym_LT_EQ] = ACTIONS(4751),
    [anon_sym_GT_EQ] = ACTIONS(4751),
    [anon_sym_PLUS_PLUS] = ACTIONS(4751),
    [anon_sym_DASH_DASH] = ACTIONS(4751),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4751),
  },
  [2117] = {
    [sym__concat] = ACTIONS(4755),
    [anon_sym_PIPE] = ACTIONS(4757),
    [anon_sym_RPAREN] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [anon_sym_EQ_TILDE] = ACTIONS(4755),
    [anon_sym_EQ_EQ] = ACTIONS(4755),
    [anon_sym_EQ] = ACTIONS(4757),
    [anon_sym_PLUS_EQ] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(4757),
    [anon_sym_GT] = ACTIONS(4757),
    [anon_sym_BANG_EQ] = ACTIONS(4755),
    [anon_sym_PLUS] = ACTIONS(4757),
    [anon_sym_DASH] = ACTIONS(4757),
    [anon_sym_DASH_EQ] = ACTIONS(4755),
    [anon_sym_LT_EQ] = ACTIONS(4755),
    [anon_sym_GT_EQ] = ACTIONS(4755),
    [anon_sym_PLUS_PLUS] = ACTIONS(4755),
    [anon_sym_DASH_DASH] = ACTIONS(4755),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4755),
  },
  [2118] = {
    [sym__concat] = ACTIONS(5168),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5168),
    [anon_sym_EQ_TILDE] = ACTIONS(5168),
    [anon_sym_EQ_EQ] = ACTIONS(5168),
    [anon_sym_EQ] = ACTIONS(5170),
    [anon_sym_PLUS_EQ] = ACTIONS(5168),
    [anon_sym_LT] = ACTIONS(5170),
    [anon_sym_GT] = ACTIONS(5170),
    [anon_sym_BANG_EQ] = ACTIONS(5168),
    [anon_sym_PLUS] = ACTIONS(5170),
    [anon_sym_DASH] = ACTIONS(5170),
    [anon_sym_DASH_EQ] = ACTIONS(5168),
    [anon_sym_LT_EQ] = ACTIONS(5168),
    [anon_sym_GT_EQ] = ACTIONS(5168),
    [anon_sym_PLUS_PLUS] = ACTIONS(5168),
    [anon_sym_DASH_DASH] = ACTIONS(5168),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5168),
  },
  [2119] = {
    [sym__concat] = ACTIONS(5172),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5172),
    [anon_sym_AMP_AMP] = ACTIONS(5172),
    [anon_sym_PIPE_PIPE] = ACTIONS(5172),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5172),
    [anon_sym_EQ_TILDE] = ACTIONS(5172),
    [anon_sym_EQ_EQ] = ACTIONS(5172),
    [anon_sym_EQ] = ACTIONS(5174),
    [anon_sym_PLUS_EQ] = ACTIONS(5172),
    [anon_sym_LT] = ACTIONS(5174),
    [anon_sym_GT] = ACTIONS(5174),
    [anon_sym_BANG_EQ] = ACTIONS(5172),
    [anon_sym_PLUS] = ACTIONS(5174),
    [anon_sym_DASH] = ACTIONS(5174),
    [anon_sym_DASH_EQ] = ACTIONS(5172),
    [anon_sym_LT_EQ] = ACTIONS(5172),
    [anon_sym_GT_EQ] = ACTIONS(5172),
    [anon_sym_PLUS_PLUS] = ACTIONS(5172),
    [anon_sym_DASH_DASH] = ACTIONS(5172),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5172),
  },
  [2120] = {
    [sym_concatenation] = STATE(2259),
    [sym_string] = STATE(2264),
    [sym_array] = STATE(2259),
    [sym_simple_expansion] = STATE(2264),
    [sym_string_expansion] = STATE(2264),
    [sym_expansion] = STATE(2264),
    [sym_command_substitution] = STATE(2264),
    [sym_process_substitution] = STATE(2264),
    [sym__empty_value] = ACTIONS(5270),
    [anon_sym_LPAREN] = ACTIONS(5272),
    [sym__special_characters] = ACTIONS(5274),
    [anon_sym_DQUOTE] = ACTIONS(5276),
    [anon_sym_DOLLAR] = ACTIONS(5278),
    [sym_raw_string] = ACTIONS(5280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5284),
    [anon_sym_BQUOTE] = ACTIONS(5286),
    [anon_sym_LT_LPAREN] = ACTIONS(5288),
    [anon_sym_GT_LPAREN] = ACTIONS(5288),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5280),
  },
  [2121] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(5290),
    [anon_sym_PLUS_EQ] = ACTIONS(5290),
    [sym_comment] = ACTIONS(57),
  },
  [2122] = {
    [aux_sym_concatenation_repeat1] = STATE(2271),
    [sym__simple_heredoc_body] = ACTIONS(669),
    [sym__heredoc_body_beginning] = ACTIONS(669),
    [sym_file_descriptor] = ACTIONS(669),
    [sym__concat] = ACTIONS(5292),
    [sym_variable_name] = ACTIONS(669),
    [anon_sym_SEMI] = ACTIONS(673),
    [anon_sym_esac] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_SEMI_SEMI] = ACTIONS(669),
    [anon_sym_PIPE_AMP] = ACTIONS(669),
    [anon_sym_AMP_AMP] = ACTIONS(669),
    [anon_sym_PIPE_PIPE] = ACTIONS(669),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(669),
    [anon_sym_AMP_GT] = ACTIONS(673),
    [anon_sym_AMP_GT_GT] = ACTIONS(669),
    [anon_sym_LT_AMP] = ACTIONS(669),
    [anon_sym_GT_AMP] = ACTIONS(669),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_LT_LT_DASH] = ACTIONS(669),
    [anon_sym_LT_LT_LT] = ACTIONS(669),
    [sym__special_characters] = ACTIONS(669),
    [anon_sym_DQUOTE] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(673),
    [sym_raw_string] = ACTIONS(669),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(669),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(669),
    [anon_sym_BQUOTE] = ACTIONS(669),
    [anon_sym_LT_LPAREN] = ACTIONS(669),
    [anon_sym_GT_LPAREN] = ACTIONS(669),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(673),
    [sym_word] = ACTIONS(673),
    [anon_sym_LF] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(673),
  },
  [2123] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(2274),
    [anon_sym_DQUOTE] = ACTIONS(5294),
    [anon_sym_DOLLAR] = ACTIONS(5296),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [2124] = {
    [sym_string] = STATE(2276),
    [anon_sym_DASH] = ACTIONS(5298),
    [anon_sym_DQUOTE] = ACTIONS(4969),
    [anon_sym_DOLLAR] = ACTIONS(5298),
    [sym_raw_string] = ACTIONS(5300),
    [anon_sym_POUND] = ACTIONS(5298),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5302),
    [anon_sym_STAR] = ACTIONS(5304),
    [anon_sym_AT] = ACTIONS(5304),
    [anon_sym_QMARK] = ACTIONS(5304),
    [anon_sym_0] = ACTIONS(5302),
    [anon_sym__] = ACTIONS(5302),
  },
  [2125] = {
    [aux_sym_concatenation_repeat1] = STATE(2271),
    [sym__simple_heredoc_body] = ACTIONS(687),
    [sym__heredoc_body_beginning] = ACTIONS(687),
    [sym_file_descriptor] = ACTIONS(687),
    [sym__concat] = ACTIONS(5292),
    [sym_variable_name] = ACTIONS(687),
    [anon_sym_SEMI] = ACTIONS(689),
    [anon_sym_esac] = ACTIONS(689),
    [anon_sym_PIPE] = ACTIONS(689),
    [anon_sym_SEMI_SEMI] = ACTIONS(687),
    [anon_sym_PIPE_AMP] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(687),
    [anon_sym_PIPE_PIPE] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(689),
    [anon_sym_GT] = ACTIONS(689),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_AMP_GT] = ACTIONS(689),
    [anon_sym_AMP_GT_GT] = ACTIONS(687),
    [anon_sym_LT_AMP] = ACTIONS(687),
    [anon_sym_GT_AMP] = ACTIONS(687),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_LT_LT_LT] = ACTIONS(687),
    [sym__special_characters] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(687),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(687),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_LT_LPAREN] = ACTIONS(687),
    [anon_sym_GT_LPAREN] = ACTIONS(687),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(689),
    [sym_word] = ACTIONS(689),
    [anon_sym_LF] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(689),
  },
  [2126] = {
    [sym_subscript] = STATE(2281),
    [sym_variable_name] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5308),
    [anon_sym_DASH] = ACTIONS(5310),
    [anon_sym_DOLLAR] = ACTIONS(5310),
    [anon_sym_POUND] = ACTIONS(5308),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5312),
    [anon_sym_STAR] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(5314),
    [anon_sym_QMARK] = ACTIONS(5314),
    [anon_sym_0] = ACTIONS(5312),
    [anon_sym__] = ACTIONS(5312),
  },
  [2127] = {
    [sym__terminated_statement] = STATE(2284),
    [sym_redirected_statement] = STATE(2282),
    [sym_for_statement] = STATE(2282),
    [sym_c_style_for_statement] = STATE(2282),
    [sym_while_statement] = STATE(2282),
    [sym_if_statement] = STATE(2282),
    [sym_case_statement] = STATE(2282),
    [sym_function_definition] = STATE(2282),
    [sym_compound_statement] = STATE(2282),
    [sym_subshell] = STATE(2282),
    [sym_pipeline] = STATE(2282),
    [sym_list] = STATE(2282),
    [sym_negated_command] = STATE(2282),
    [sym_test_command] = STATE(2282),
    [sym_declaration_command] = STATE(2282),
    [sym_unset_command] = STATE(2282),
    [sym_command] = STATE(2282),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2283),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(2284),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [2128] = {
    [sym__terminated_statement] = STATE(2287),
    [sym_redirected_statement] = STATE(2285),
    [sym_for_statement] = STATE(2285),
    [sym_c_style_for_statement] = STATE(2285),
    [sym_while_statement] = STATE(2285),
    [sym_if_statement] = STATE(2285),
    [sym_case_statement] = STATE(2285),
    [sym_function_definition] = STATE(2285),
    [sym_compound_statement] = STATE(2285),
    [sym_subshell] = STATE(2285),
    [sym_pipeline] = STATE(2285),
    [sym_list] = STATE(2285),
    [sym_negated_command] = STATE(2285),
    [sym_test_command] = STATE(2285),
    [sym_declaration_command] = STATE(2285),
    [sym_unset_command] = STATE(2285),
    [sym_command] = STATE(2285),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(2286),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(2287),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [2129] = {
    [sym__terminated_statement] = STATE(2290),
    [sym_redirected_statement] = STATE(2288),
    [sym_for_statement] = STATE(2288),
    [sym_c_style_for_statement] = STATE(2288),
    [sym_while_statement] = STATE(2288),
    [sym_if_statement] = STATE(2288),
    [sym_case_statement] = STATE(2288),
    [sym_function_definition] = STATE(2288),
    [sym_compound_statement] = STATE(2288),
    [sym_subshell] = STATE(2288),
    [sym_pipeline] = STATE(2288),
    [sym_list] = STATE(2288),
    [sym_negated_command] = STATE(2288),
    [sym_test_command] = STATE(2288),
    [sym_declaration_command] = STATE(2288),
    [sym_unset_command] = STATE(2288),
    [sym_command] = STATE(2288),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2289),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(2290),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [2130] = {
    [anon_sym_EQ] = ACTIONS(5290),
    [anon_sym_PLUS_EQ] = ACTIONS(5290),
    [sym_comment] = ACTIONS(57),
  },
  [2131] = {
    [sym_variable_assignment] = STATE(2291),
    [sym_subscript] = STATE(2130),
    [sym_concatenation] = STATE(2291),
    [sym_string] = STATE(2125),
    [sym_simple_expansion] = STATE(2125),
    [sym_string_expansion] = STATE(2125),
    [sym_expansion] = STATE(2125),
    [sym_command_substitution] = STATE(2125),
    [sym_process_substitution] = STATE(2125),
    [aux_sym_declaration_command_repeat1] = STATE(2291),
    [sym__simple_heredoc_body] = ACTIONS(701),
    [sym__heredoc_body_beginning] = ACTIONS(701),
    [sym_file_descriptor] = ACTIONS(701),
    [sym_variable_name] = ACTIONS(4965),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_esac] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_SEMI_SEMI] = ACTIONS(701),
    [anon_sym_PIPE_AMP] = ACTIONS(701),
    [anon_sym_AMP_AMP] = ACTIONS(701),
    [anon_sym_PIPE_PIPE] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(703),
    [anon_sym_GT] = ACTIONS(703),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_AMP_GT] = ACTIONS(703),
    [anon_sym_AMP_GT_GT] = ACTIONS(701),
    [anon_sym_LT_AMP] = ACTIONS(701),
    [anon_sym_GT_AMP] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(703),
    [anon_sym_LT_LT_DASH] = ACTIONS(701),
    [anon_sym_LT_LT_LT] = ACTIONS(701),
    [sym__special_characters] = ACTIONS(4967),
    [anon_sym_DQUOTE] = ACTIONS(4969),
    [anon_sym_DOLLAR] = ACTIONS(4971),
    [sym_raw_string] = ACTIONS(4973),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4975),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4977),
    [anon_sym_BQUOTE] = ACTIONS(4979),
    [anon_sym_LT_LPAREN] = ACTIONS(4981),
    [anon_sym_GT_LPAREN] = ACTIONS(4981),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5316),
    [sym_word] = ACTIONS(4985),
    [anon_sym_LF] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(703),
  },
  [2132] = {
    [aux_sym_concatenation_repeat1] = STATE(2293),
    [sym__simple_heredoc_body] = ACTIONS(707),
    [sym__heredoc_body_beginning] = ACTIONS(707),
    [sym_file_descriptor] = ACTIONS(707),
    [sym__concat] = ACTIONS(5318),
    [anon_sym_SEMI] = ACTIONS(711),
    [anon_sym_esac] = ACTIONS(711),
    [anon_sym_PIPE] = ACTIONS(711),
    [anon_sym_SEMI_SEMI] = ACTIONS(707),
    [anon_sym_PIPE_AMP] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(707),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_GT] = ACTIONS(707),
    [anon_sym_AMP_GT] = ACTIONS(711),
    [anon_sym_AMP_GT_GT] = ACTIONS(707),
    [anon_sym_LT_AMP] = ACTIONS(707),
    [anon_sym_GT_AMP] = ACTIONS(707),
    [anon_sym_LT_LT] = ACTIONS(711),
    [anon_sym_LT_LT_DASH] = ACTIONS(707),
    [anon_sym_LT_LT_LT] = ACTIONS(707),
    [sym__special_characters] = ACTIONS(707),
    [anon_sym_DQUOTE] = ACTIONS(707),
    [anon_sym_DOLLAR] = ACTIONS(711),
    [sym_raw_string] = ACTIONS(707),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(707),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(707),
    [anon_sym_BQUOTE] = ACTIONS(707),
    [anon_sym_LT_LPAREN] = ACTIONS(707),
    [anon_sym_GT_LPAREN] = ACTIONS(707),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(711),
    [sym_word] = ACTIONS(711),
    [anon_sym_LF] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(711),
  },
  [2133] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(2296),
    [anon_sym_DQUOTE] = ACTIONS(5320),
    [anon_sym_DOLLAR] = ACTIONS(5322),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [2134] = {
    [sym_string] = STATE(2298),
    [anon_sym_DASH] = ACTIONS(5324),
    [anon_sym_DQUOTE] = ACTIONS(4989),
    [anon_sym_DOLLAR] = ACTIONS(5324),
    [sym_raw_string] = ACTIONS(5326),
    [anon_sym_POUND] = ACTIONS(5324),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5328),
    [anon_sym_STAR] = ACTIONS(5330),
    [anon_sym_AT] = ACTIONS(5330),
    [anon_sym_QMARK] = ACTIONS(5330),
    [anon_sym_0] = ACTIONS(5328),
    [anon_sym__] = ACTIONS(5328),
  },
  [2135] = {
    [aux_sym_concatenation_repeat1] = STATE(2293),
    [sym__simple_heredoc_body] = ACTIONS(725),
    [sym__heredoc_body_beginning] = ACTIONS(725),
    [sym_file_descriptor] = ACTIONS(725),
    [sym__concat] = ACTIONS(5318),
    [anon_sym_SEMI] = ACTIONS(727),
    [anon_sym_esac] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(727),
    [anon_sym_SEMI_SEMI] = ACTIONS(725),
    [anon_sym_PIPE_AMP] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_LT] = ACTIONS(727),
    [anon_sym_GT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_AMP_GT] = ACTIONS(727),
    [anon_sym_AMP_GT_GT] = ACTIONS(725),
    [anon_sym_LT_AMP] = ACTIONS(725),
    [anon_sym_GT_AMP] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_LT_LT_DASH] = ACTIONS(725),
    [anon_sym_LT_LT_LT] = ACTIONS(725),
    [sym__special_characters] = ACTIONS(725),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(727),
    [sym_raw_string] = ACTIONS(725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LT_LPAREN] = ACTIONS(725),
    [anon_sym_GT_LPAREN] = ACTIONS(725),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(727),
    [sym_word] = ACTIONS(727),
    [anon_sym_LF] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(727),
  },
  [2136] = {
    [sym_subscript] = STATE(2303),
    [sym_variable_name] = ACTIONS(5332),
    [anon_sym_BANG] = ACTIONS(5334),
    [anon_sym_DASH] = ACTIONS(5336),
    [anon_sym_DOLLAR] = ACTIONS(5336),
    [anon_sym_POUND] = ACTIONS(5334),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5338),
    [anon_sym_STAR] = ACTIONS(5340),
    [anon_sym_AT] = ACTIONS(5340),
    [anon_sym_QMARK] = ACTIONS(5340),
    [anon_sym_0] = ACTIONS(5338),
    [anon_sym__] = ACTIONS(5338),
  },
  [2137] = {
    [sym__terminated_statement] = STATE(2306),
    [sym_redirected_statement] = STATE(2304),
    [sym_for_statement] = STATE(2304),
    [sym_c_style_for_statement] = STATE(2304),
    [sym_while_statement] = STATE(2304),
    [sym_if_statement] = STATE(2304),
    [sym_case_statement] = STATE(2304),
    [sym_function_definition] = STATE(2304),
    [sym_compound_statement] = STATE(2304),
    [sym_subshell] = STATE(2304),
    [sym_pipeline] = STATE(2304),
    [sym_list] = STATE(2304),
    [sym_negated_command] = STATE(2304),
    [sym_test_command] = STATE(2304),
    [sym_declaration_command] = STATE(2304),
    [sym_unset_command] = STATE(2304),
    [sym_command] = STATE(2304),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2305),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(2306),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [2138] = {
    [sym__terminated_statement] = STATE(2309),
    [sym_redirected_statement] = STATE(2307),
    [sym_for_statement] = STATE(2307),
    [sym_c_style_for_statement] = STATE(2307),
    [sym_while_statement] = STATE(2307),
    [sym_if_statement] = STATE(2307),
    [sym_case_statement] = STATE(2307),
    [sym_function_definition] = STATE(2307),
    [sym_compound_statement] = STATE(2307),
    [sym_subshell] = STATE(2307),
    [sym_pipeline] = STATE(2307),
    [sym_list] = STATE(2307),
    [sym_negated_command] = STATE(2307),
    [sym_test_command] = STATE(2307),
    [sym_declaration_command] = STATE(2307),
    [sym_unset_command] = STATE(2307),
    [sym_command] = STATE(2307),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(2308),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(2309),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [2139] = {
    [sym__terminated_statement] = STATE(2312),
    [sym_redirected_statement] = STATE(2310),
    [sym_for_statement] = STATE(2310),
    [sym_c_style_for_statement] = STATE(2310),
    [sym_while_statement] = STATE(2310),
    [sym_if_statement] = STATE(2310),
    [sym_case_statement] = STATE(2310),
    [sym_function_definition] = STATE(2310),
    [sym_compound_statement] = STATE(2310),
    [sym_subshell] = STATE(2310),
    [sym_pipeline] = STATE(2310),
    [sym_list] = STATE(2310),
    [sym_negated_command] = STATE(2310),
    [sym_test_command] = STATE(2310),
    [sym_declaration_command] = STATE(2310),
    [sym_unset_command] = STATE(2310),
    [sym_command] = STATE(2310),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2311),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(2312),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [2140] = {
    [sym_concatenation] = STATE(2313),
    [sym_string] = STATE(2135),
    [sym_simple_expansion] = STATE(2135),
    [sym_string_expansion] = STATE(2135),
    [sym_expansion] = STATE(2135),
    [sym_command_substitution] = STATE(2135),
    [sym_process_substitution] = STATE(2135),
    [aux_sym_unset_command_repeat1] = STATE(2313),
    [sym__simple_heredoc_body] = ACTIONS(739),
    [sym__heredoc_body_beginning] = ACTIONS(739),
    [sym_file_descriptor] = ACTIONS(739),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_esac] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_GT] = ACTIONS(739),
    [anon_sym_AMP_GT] = ACTIONS(741),
    [anon_sym_AMP_GT_GT] = ACTIONS(739),
    [anon_sym_LT_AMP] = ACTIONS(739),
    [anon_sym_GT_AMP] = ACTIONS(739),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_LT_LT_DASH] = ACTIONS(739),
    [anon_sym_LT_LT_LT] = ACTIONS(739),
    [sym__special_characters] = ACTIONS(4987),
    [anon_sym_DQUOTE] = ACTIONS(4989),
    [anon_sym_DOLLAR] = ACTIONS(4991),
    [sym_raw_string] = ACTIONS(4993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4995),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4997),
    [anon_sym_BQUOTE] = ACTIONS(4999),
    [anon_sym_LT_LPAREN] = ACTIONS(5001),
    [anon_sym_GT_LPAREN] = ACTIONS(5001),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5342),
    [sym_word] = ACTIONS(5005),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(741),
  },
  [2141] = {
    [sym_string] = STATE(2314),
    [sym_simple_expansion] = STATE(2314),
    [sym_string_expansion] = STATE(2314),
    [sym_expansion] = STATE(2314),
    [sym_command_substitution] = STATE(2314),
    [sym_process_substitution] = STATE(2314),
    [sym__special_characters] = ACTIONS(5344),
    [anon_sym_DQUOTE] = ACTIONS(4432),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [sym_raw_string] = ACTIONS(5344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_LT_LPAREN] = ACTIONS(4444),
    [anon_sym_GT_LPAREN] = ACTIONS(4444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5344),
  },
  [2142] = {
    [aux_sym_concatenation_repeat1] = STATE(2315),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(5007),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_esac] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_EQ_TILDE] = ACTIONS(781),
    [anon_sym_EQ_EQ] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(781),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [2143] = {
    [sym__simple_heredoc_body] = ACTIONS(783),
    [sym__heredoc_body_beginning] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(783),
    [sym__concat] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_esac] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [anon_sym_PIPE_AMP] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_EQ_TILDE] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(785),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(783),
    [anon_sym_AMP_GT] = ACTIONS(785),
    [anon_sym_AMP_GT_GT] = ACTIONS(783),
    [anon_sym_LT_AMP] = ACTIONS(783),
    [anon_sym_GT_AMP] = ACTIONS(783),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_DASH] = ACTIONS(783),
    [anon_sym_LT_LT_LT] = ACTIONS(783),
    [sym__special_characters] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(783),
    [anon_sym_DOLLAR] = ACTIONS(785),
    [sym_raw_string] = ACTIONS(783),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(783),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(783),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [anon_sym_LT_LPAREN] = ACTIONS(783),
    [anon_sym_GT_LPAREN] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(785),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
  },
  [2144] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(5346),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [2145] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(5346),
    [anon_sym_DOLLAR] = ACTIONS(5348),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [2146] = {
    [sym__simple_heredoc_body] = ACTIONS(817),
    [sym__heredoc_body_beginning] = ACTIONS(817),
    [sym_file_descriptor] = ACTIONS(817),
    [sym__concat] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(819),
    [anon_sym_esac] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(819),
    [anon_sym_SEMI_SEMI] = ACTIONS(817),
    [anon_sym_PIPE_AMP] = ACTIONS(817),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_EQ_TILDE] = ACTIONS(819),
    [anon_sym_EQ_EQ] = ACTIONS(819),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(817),
    [anon_sym_AMP_GT] = ACTIONS(819),
    [anon_sym_AMP_GT_GT] = ACTIONS(817),
    [anon_sym_LT_AMP] = ACTIONS(817),
    [anon_sym_GT_AMP] = ACTIONS(817),
    [anon_sym_LT_LT] = ACTIONS(819),
    [anon_sym_LT_LT_DASH] = ACTIONS(817),
    [anon_sym_LT_LT_LT] = ACTIONS(817),
    [sym__special_characters] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR] = ACTIONS(819),
    [sym_raw_string] = ACTIONS(817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(817),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(817),
    [anon_sym_GT_LPAREN] = ACTIONS(817),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(819),
    [anon_sym_LF] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(819),
  },
  [2147] = {
    [sym__simple_heredoc_body] = ACTIONS(821),
    [sym__heredoc_body_beginning] = ACTIONS(821),
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_esac] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(823),
    [anon_sym_SEMI_SEMI] = ACTIONS(821),
    [anon_sym_PIPE_AMP] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_EQ_TILDE] = ACTIONS(823),
    [anon_sym_EQ_EQ] = ACTIONS(823),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(823),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(823),
    [anon_sym_LT_LT_DASH] = ACTIONS(821),
    [anon_sym_LT_LT_LT] = ACTIONS(821),
    [sym__special_characters] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [anon_sym_DOLLAR] = ACTIONS(823),
    [sym_raw_string] = ACTIONS(821),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(821),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(821),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(821),
    [anon_sym_GT_LPAREN] = ACTIONS(821),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(823),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [2148] = {
    [sym__simple_heredoc_body] = ACTIONS(825),
    [sym__heredoc_body_beginning] = ACTIONS(825),
    [sym_file_descriptor] = ACTIONS(825),
    [sym__concat] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(827),
    [anon_sym_esac] = ACTIONS(827),
    [anon_sym_PIPE] = ACTIONS(827),
    [anon_sym_SEMI_SEMI] = ACTIONS(825),
    [anon_sym_PIPE_AMP] = ACTIONS(825),
    [anon_sym_AMP_AMP] = ACTIONS(825),
    [anon_sym_PIPE_PIPE] = ACTIONS(825),
    [anon_sym_EQ_TILDE] = ACTIONS(827),
    [anon_sym_EQ_EQ] = ACTIONS(827),
    [anon_sym_LT] = ACTIONS(827),
    [anon_sym_GT] = ACTIONS(827),
    [anon_sym_GT_GT] = ACTIONS(825),
    [anon_sym_AMP_GT] = ACTIONS(827),
    [anon_sym_AMP_GT_GT] = ACTIONS(825),
    [anon_sym_LT_AMP] = ACTIONS(825),
    [anon_sym_GT_AMP] = ACTIONS(825),
    [anon_sym_LT_LT] = ACTIONS(827),
    [anon_sym_LT_LT_DASH] = ACTIONS(825),
    [anon_sym_LT_LT_LT] = ACTIONS(825),
    [sym__special_characters] = ACTIONS(825),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [sym_raw_string] = ACTIONS(825),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(825),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(825),
    [anon_sym_BQUOTE] = ACTIONS(825),
    [anon_sym_LT_LPAREN] = ACTIONS(825),
    [anon_sym_GT_LPAREN] = ACTIONS(825),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(827),
    [anon_sym_LF] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(827),
  },
  [2149] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(5350),
    [sym_comment] = ACTIONS(57),
  },
  [2150] = {
    [sym_subscript] = STATE(2321),
    [sym_variable_name] = ACTIONS(5352),
    [anon_sym_DASH] = ACTIONS(5354),
    [anon_sym_DOLLAR] = ACTIONS(5354),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5356),
    [anon_sym_STAR] = ACTIONS(5358),
    [anon_sym_AT] = ACTIONS(5358),
    [anon_sym_QMARK] = ACTIONS(5358),
    [anon_sym_0] = ACTIONS(5356),
    [anon_sym__] = ACTIONS(5356),
  },
  [2151] = {
    [sym_concatenation] = STATE(2324),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2324),
    [anon_sym_RBRACE] = ACTIONS(5360),
    [anon_sym_EQ] = ACTIONS(5362),
    [anon_sym_DASH] = ACTIONS(5362),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5364),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(5366),
    [anon_sym_COLON] = ACTIONS(5362),
    [anon_sym_COLON_QMARK] = ACTIONS(5362),
    [anon_sym_COLON_DASH] = ACTIONS(5362),
    [anon_sym_PERCENT] = ACTIONS(5362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2152] = {
    [sym_concatenation] = STATE(2327),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2327),
    [anon_sym_RBRACE] = ACTIONS(5368),
    [anon_sym_EQ] = ACTIONS(5370),
    [anon_sym_DASH] = ACTIONS(5370),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5372),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(5374),
    [anon_sym_COLON] = ACTIONS(5370),
    [anon_sym_COLON_QMARK] = ACTIONS(5370),
    [anon_sym_COLON_DASH] = ACTIONS(5370),
    [anon_sym_PERCENT] = ACTIONS(5370),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2153] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2330),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(5376),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5378),
    [anon_sym_SEMI_SEMI] = ACTIONS(5380),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5380),
    [anon_sym_AMP] = ACTIONS(5376),
  },
  [2154] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2330),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5376),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5378),
    [anon_sym_SEMI_SEMI] = ACTIONS(5380),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5380),
    [anon_sym_AMP] = ACTIONS(5376),
  },
  [2155] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(2331),
    [sym_for_statement] = STATE(2331),
    [sym_c_style_for_statement] = STATE(2331),
    [sym_while_statement] = STATE(2331),
    [sym_if_statement] = STATE(2331),
    [sym_case_statement] = STATE(2331),
    [sym_function_definition] = STATE(2331),
    [sym_compound_statement] = STATE(2331),
    [sym_subshell] = STATE(2331),
    [sym_pipeline] = STATE(2331),
    [sym_list] = STATE(2331),
    [sym_negated_command] = STATE(2331),
    [sym_test_command] = STATE(2331),
    [sym_declaration_command] = STATE(2331),
    [sym_unset_command] = STATE(2331),
    [sym_command] = STATE(2331),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2332),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [2156] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2334),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(5382),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(5384),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(5378),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5384),
    [anon_sym_AMP] = ACTIONS(5382),
  },
  [2157] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2334),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5382),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(5384),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(5378),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5384),
    [anon_sym_AMP] = ACTIONS(5382),
  },
  [2158] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(2335),
    [sym_for_statement] = STATE(2335),
    [sym_c_style_for_statement] = STATE(2335),
    [sym_while_statement] = STATE(2335),
    [sym_if_statement] = STATE(2335),
    [sym_case_statement] = STATE(2335),
    [sym_function_definition] = STATE(2335),
    [sym_compound_statement] = STATE(2335),
    [sym_subshell] = STATE(2335),
    [sym_pipeline] = STATE(2335),
    [sym_list] = STATE(2335),
    [sym_negated_command] = STATE(2335),
    [sym_test_command] = STATE(2335),
    [sym_declaration_command] = STATE(2335),
    [sym_unset_command] = STATE(2335),
    [sym_command] = STATE(2335),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(2336),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [2159] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2339),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(5386),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5388),
    [anon_sym_SEMI_SEMI] = ACTIONS(5390),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5390),
    [anon_sym_AMP] = ACTIONS(5386),
  },
  [2160] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2339),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5386),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5388),
    [anon_sym_SEMI_SEMI] = ACTIONS(5390),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5390),
    [anon_sym_AMP] = ACTIONS(5386),
  },
  [2161] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(2340),
    [sym_for_statement] = STATE(2340),
    [sym_c_style_for_statement] = STATE(2340),
    [sym_while_statement] = STATE(2340),
    [sym_if_statement] = STATE(2340),
    [sym_case_statement] = STATE(2340),
    [sym_function_definition] = STATE(2340),
    [sym_compound_statement] = STATE(2340),
    [sym_subshell] = STATE(2340),
    [sym_pipeline] = STATE(2340),
    [sym_list] = STATE(2340),
    [sym_negated_command] = STATE(2340),
    [sym_test_command] = STATE(2340),
    [sym_declaration_command] = STATE(2340),
    [sym_unset_command] = STATE(2340),
    [sym_command] = STATE(2340),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2341),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [2162] = {
    [anon_sym_LT] = ACTIONS(5392),
    [anon_sym_GT] = ACTIONS(5392),
    [anon_sym_GT_GT] = ACTIONS(5394),
    [anon_sym_AMP_GT] = ACTIONS(5392),
    [anon_sym_AMP_GT_GT] = ACTIONS(5394),
    [anon_sym_LT_AMP] = ACTIONS(5394),
    [anon_sym_GT_AMP] = ACTIONS(5394),
    [sym_comment] = ACTIONS(57),
  },
  [2163] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_esac] = ACTIONS(931),
    [anon_sym_SEMI_SEMI] = ACTIONS(927),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2164] = {
    [sym_redirected_statement] = STATE(2343),
    [sym_for_statement] = STATE(2343),
    [sym_c_style_for_statement] = STATE(2343),
    [sym_while_statement] = STATE(2343),
    [sym_if_statement] = STATE(2343),
    [sym_case_statement] = STATE(2343),
    [sym_function_definition] = STATE(2343),
    [sym_compound_statement] = STATE(2343),
    [sym_subshell] = STATE(2343),
    [sym_pipeline] = STATE(2343),
    [sym_list] = STATE(2343),
    [sym_negated_command] = STATE(2343),
    [sym_test_command] = STATE(2343),
    [sym_declaration_command] = STATE(2343),
    [sym_unset_command] = STATE(2343),
    [sym_command] = STATE(2343),
    [sym_command_name] = STATE(1930),
    [sym_variable_assignment] = STATE(2344),
    [sym_subscript] = STATE(1932),
    [sym_file_redirect] = STATE(1935),
    [sym_concatenation] = STATE(1933),
    [sym_string] = STATE(1923),
    [sym_simple_expansion] = STATE(1923),
    [sym_string_expansion] = STATE(1923),
    [sym_expansion] = STATE(1923),
    [sym_command_substitution] = STATE(1923),
    [sym_process_substitution] = STATE(1923),
    [aux_sym_command_repeat1] = STATE(1935),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4418),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4426),
    [anon_sym_typeset] = ACTIONS(4426),
    [anon_sym_export] = ACTIONS(4426),
    [anon_sym_readonly] = ACTIONS(4426),
    [anon_sym_local] = ACTIONS(4426),
    [anon_sym_unset] = ACTIONS(4428),
    [anon_sym_unsetenv] = ACTIONS(4428),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(4430),
    [anon_sym_DQUOTE] = ACTIONS(4432),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [sym_raw_string] = ACTIONS(4436),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_LT_LPAREN] = ACTIONS(4444),
    [anon_sym_GT_LPAREN] = ACTIONS(4444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4446),
  },
  [2165] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_esac] = ACTIONS(5396),
    [anon_sym_SEMI_SEMI] = ACTIONS(927),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(5398),
    [anon_sym_DQUOTE] = ACTIONS(5400),
    [anon_sym_DOLLAR] = ACTIONS(5398),
    [sym_raw_string] = ACTIONS(5400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5400),
    [anon_sym_BQUOTE] = ACTIONS(5400),
    [anon_sym_LT_LPAREN] = ACTIONS(5400),
    [anon_sym_GT_LPAREN] = ACTIONS(5400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5398),
  },
  [2166] = {
    [sym_redirected_statement] = STATE(2345),
    [sym_for_statement] = STATE(2345),
    [sym_c_style_for_statement] = STATE(2345),
    [sym_while_statement] = STATE(2345),
    [sym_if_statement] = STATE(2345),
    [sym_case_statement] = STATE(2345),
    [sym_function_definition] = STATE(2345),
    [sym_compound_statement] = STATE(2345),
    [sym_subshell] = STATE(2345),
    [sym_pipeline] = STATE(2345),
    [sym_list] = STATE(2345),
    [sym_negated_command] = STATE(2345),
    [sym_test_command] = STATE(2345),
    [sym_declaration_command] = STATE(2345),
    [sym_unset_command] = STATE(2345),
    [sym_command] = STATE(2345),
    [sym_command_name] = STATE(1930),
    [sym_variable_assignment] = STATE(2346),
    [sym_subscript] = STATE(1932),
    [sym_file_redirect] = STATE(1935),
    [sym_concatenation] = STATE(1933),
    [sym_string] = STATE(1923),
    [sym_simple_expansion] = STATE(1923),
    [sym_string_expansion] = STATE(1923),
    [sym_expansion] = STATE(1923),
    [sym_command_substitution] = STATE(1923),
    [sym_process_substitution] = STATE(1923),
    [aux_sym_command_repeat1] = STATE(1935),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4418),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4426),
    [anon_sym_typeset] = ACTIONS(4426),
    [anon_sym_export] = ACTIONS(4426),
    [anon_sym_readonly] = ACTIONS(4426),
    [anon_sym_local] = ACTIONS(4426),
    [anon_sym_unset] = ACTIONS(4428),
    [anon_sym_unsetenv] = ACTIONS(4428),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(4430),
    [anon_sym_DQUOTE] = ACTIONS(4432),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [sym_raw_string] = ACTIONS(4436),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_LT_LPAREN] = ACTIONS(4444),
    [anon_sym_GT_LPAREN] = ACTIONS(4444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4446),
  },
  [2167] = {
    [sym_concatenation] = STATE(511),
    [sym_string] = STATE(2350),
    [sym_simple_expansion] = STATE(2350),
    [sym_string_expansion] = STATE(2350),
    [sym_expansion] = STATE(2350),
    [sym_command_substitution] = STATE(2350),
    [sym_process_substitution] = STATE(2350),
    [sym__special_characters] = ACTIONS(5402),
    [anon_sym_DQUOTE] = ACTIONS(5404),
    [anon_sym_DOLLAR] = ACTIONS(5406),
    [sym_raw_string] = ACTIONS(5408),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5412),
    [anon_sym_BQUOTE] = ACTIONS(5414),
    [anon_sym_LT_LPAREN] = ACTIONS(5416),
    [anon_sym_GT_LPAREN] = ACTIONS(5416),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5408),
  },
  [2168] = {
    [sym_concatenation] = STATE(515),
    [sym_string] = STATE(2356),
    [sym_simple_expansion] = STATE(2356),
    [sym_string_expansion] = STATE(2356),
    [sym_expansion] = STATE(2356),
    [sym_command_substitution] = STATE(2356),
    [sym_process_substitution] = STATE(2356),
    [sym__special_characters] = ACTIONS(5418),
    [anon_sym_DQUOTE] = ACTIONS(5404),
    [anon_sym_DOLLAR] = ACTIONS(5406),
    [sym_raw_string] = ACTIONS(5420),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5412),
    [anon_sym_BQUOTE] = ACTIONS(5414),
    [anon_sym_LT_LPAREN] = ACTIONS(5416),
    [anon_sym_GT_LPAREN] = ACTIONS(5416),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5420),
  },
  [2169] = {
    [anon_sym_SEMI] = ACTIONS(5422),
    [anon_sym_SEMI_SEMI] = ACTIONS(5424),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5424),
    [anon_sym_AMP] = ACTIONS(5424),
  },
  [2170] = {
    [sym_file_redirect] = STATE(2358),
    [sym_heredoc_redirect] = STATE(2358),
    [sym_herestring_redirect] = STATE(2358),
    [aux_sym_redirected_statement_repeat1] = STATE(2358),
    [sym__simple_heredoc_body] = ACTIONS(947),
    [sym__heredoc_body_beginning] = ACTIONS(947),
    [sym_file_descriptor] = ACTIONS(5031),
    [anon_sym_SEMI] = ACTIONS(949),
    [anon_sym_esac] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI_SEMI] = ACTIONS(947),
    [anon_sym_PIPE_AMP] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_LT] = ACTIONS(5045),
    [anon_sym_GT] = ACTIONS(5045),
    [anon_sym_GT_GT] = ACTIONS(5047),
    [anon_sym_AMP_GT] = ACTIONS(5045),
    [anon_sym_AMP_GT_GT] = ACTIONS(5047),
    [anon_sym_LT_AMP] = ACTIONS(5047),
    [anon_sym_GT_AMP] = ACTIONS(5047),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(5049),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
  },
  [2171] = {
    [sym_concatenation] = STATE(2359),
    [sym_string] = STATE(2361),
    [sym_simple_expansion] = STATE(2361),
    [sym_string_expansion] = STATE(2361),
    [sym_expansion] = STATE(2361),
    [sym_command_substitution] = STATE(2361),
    [sym_process_substitution] = STATE(2361),
    [sym_regex] = ACTIONS(5426),
    [sym__special_characters] = ACTIONS(5428),
    [anon_sym_DQUOTE] = ACTIONS(4432),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [sym_raw_string] = ACTIONS(5430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_LT_LPAREN] = ACTIONS(4444),
    [anon_sym_GT_LPAREN] = ACTIONS(4444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5430),
  },
  [2172] = {
    [aux_sym_concatenation_repeat1] = STATE(2142),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(5007),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_esac] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_EQ_TILDE] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(959),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_characters] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [2173] = {
    [aux_sym_concatenation_repeat1] = STATE(2142),
    [sym__simple_heredoc_body] = ACTIONS(961),
    [sym__heredoc_body_beginning] = ACTIONS(961),
    [sym_file_descriptor] = ACTIONS(961),
    [sym__concat] = ACTIONS(5007),
    [anon_sym_SEMI] = ACTIONS(963),
    [anon_sym_esac] = ACTIONS(963),
    [anon_sym_PIPE] = ACTIONS(963),
    [anon_sym_SEMI_SEMI] = ACTIONS(961),
    [anon_sym_PIPE_AMP] = ACTIONS(961),
    [anon_sym_AMP_AMP] = ACTIONS(961),
    [anon_sym_PIPE_PIPE] = ACTIONS(961),
    [anon_sym_EQ_TILDE] = ACTIONS(963),
    [anon_sym_EQ_EQ] = ACTIONS(963),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_GT_GT] = ACTIONS(961),
    [anon_sym_AMP_GT] = ACTIONS(963),
    [anon_sym_AMP_GT_GT] = ACTIONS(961),
    [anon_sym_LT_AMP] = ACTIONS(961),
    [anon_sym_GT_AMP] = ACTIONS(961),
    [anon_sym_LT_LT] = ACTIONS(963),
    [anon_sym_LT_LT_DASH] = ACTIONS(961),
    [anon_sym_LT_LT_LT] = ACTIONS(961),
    [sym__special_characters] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(961),
    [anon_sym_DOLLAR] = ACTIONS(963),
    [sym_raw_string] = ACTIONS(961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(961),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(961),
    [anon_sym_BQUOTE] = ACTIONS(961),
    [anon_sym_LT_LPAREN] = ACTIONS(961),
    [anon_sym_GT_LPAREN] = ACTIONS(961),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(963),
    [anon_sym_LF] = ACTIONS(961),
    [anon_sym_AMP] = ACTIONS(963),
  },
  [2174] = {
    [sym_concatenation] = STATE(2362),
    [sym_string] = STATE(2173),
    [sym_simple_expansion] = STATE(2173),
    [sym_string_expansion] = STATE(2173),
    [sym_expansion] = STATE(2173),
    [sym_command_substitution] = STATE(2173),
    [sym_process_substitution] = STATE(2173),
    [aux_sym_command_repeat2] = STATE(2362),
    [sym__simple_heredoc_body] = ACTIONS(965),
    [sym__heredoc_body_beginning] = ACTIONS(965),
    [sym_file_descriptor] = ACTIONS(965),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_esac] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(967),
    [anon_sym_SEMI_SEMI] = ACTIONS(965),
    [anon_sym_PIPE_AMP] = ACTIONS(965),
    [anon_sym_AMP_AMP] = ACTIONS(965),
    [anon_sym_PIPE_PIPE] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(5053),
    [anon_sym_EQ_EQ] = ACTIONS(5053),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(965),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(965),
    [anon_sym_LT_AMP] = ACTIONS(965),
    [anon_sym_GT_AMP] = ACTIONS(965),
    [anon_sym_LT_LT] = ACTIONS(967),
    [anon_sym_LT_LT_DASH] = ACTIONS(965),
    [anon_sym_LT_LT_LT] = ACTIONS(965),
    [sym__special_characters] = ACTIONS(5055),
    [anon_sym_DQUOTE] = ACTIONS(4432),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [sym_raw_string] = ACTIONS(5057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_LT_LPAREN] = ACTIONS(4444),
    [anon_sym_GT_LPAREN] = ACTIONS(4444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5059),
    [anon_sym_LF] = ACTIONS(965),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [2175] = {
    [anon_sym_esac] = ACTIONS(5396),
    [sym__special_characters] = ACTIONS(5400),
    [anon_sym_DQUOTE] = ACTIONS(5400),
    [anon_sym_DOLLAR] = ACTIONS(5398),
    [sym_raw_string] = ACTIONS(5400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5400),
    [anon_sym_BQUOTE] = ACTIONS(5400),
    [anon_sym_LT_LPAREN] = ACTIONS(5400),
    [anon_sym_GT_LPAREN] = ACTIONS(5400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5398),
  },
  [2176] = {
    [sym_file_redirect] = STATE(2170),
    [sym_heredoc_redirect] = STATE(2170),
    [sym_heredoc_body] = STATE(2169),
    [sym_herestring_redirect] = STATE(2170),
    [aux_sym_redirected_statement_repeat1] = STATE(2170),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(5031),
    [anon_sym_SEMI] = ACTIONS(5033),
    [anon_sym_esac] = ACTIONS(5432),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI_SEMI] = ACTIONS(5434),
    [anon_sym_PIPE_AMP] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5043),
    [anon_sym_PIPE_PIPE] = ACTIONS(5043),
    [anon_sym_LT] = ACTIONS(5045),
    [anon_sym_GT] = ACTIONS(5045),
    [anon_sym_GT_GT] = ACTIONS(5047),
    [anon_sym_AMP_GT] = ACTIONS(5045),
    [anon_sym_AMP_GT_GT] = ACTIONS(5047),
    [anon_sym_LT_AMP] = ACTIONS(5047),
    [anon_sym_GT_AMP] = ACTIONS(5047),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(5049),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5051),
    [anon_sym_AMP] = ACTIONS(5033),
  },
  [2177] = {
    [sym_file_redirect] = STATE(2170),
    [sym_heredoc_redirect] = STATE(2170),
    [sym_heredoc_body] = STATE(2169),
    [sym_herestring_redirect] = STATE(2170),
    [aux_sym_redirected_statement_repeat1] = STATE(2170),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5033),
    [anon_sym_esac] = ACTIONS(5396),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI_SEMI] = ACTIONS(5434),
    [anon_sym_PIPE_AMP] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5043),
    [anon_sym_PIPE_PIPE] = ACTIONS(5043),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(5049),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5051),
    [anon_sym_AMP] = ACTIONS(5033),
  },
  [2178] = {
    [sym__terminated_statement] = STATE(2178),
    [sym_redirected_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_c_style_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_if_statement] = STATE(2364),
    [sym_case_statement] = STATE(2364),
    [sym_function_definition] = STATE(2364),
    [sym_compound_statement] = STATE(2364),
    [sym_subshell] = STATE(2364),
    [sym_pipeline] = STATE(2364),
    [sym_list] = STATE(2364),
    [sym_negated_command] = STATE(2364),
    [sym_test_command] = STATE(2364),
    [sym_declaration_command] = STATE(2364),
    [sym_unset_command] = STATE(2364),
    [sym_command] = STATE(2364),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(2365),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(2178),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(973),
    [sym_variable_name] = ACTIONS(976),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(982),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(988),
    [anon_sym_case] = ACTIONS(991),
    [anon_sym_esac] = ACTIONS(3596),
    [anon_sym_SEMI_SEMI] = ACTIONS(1441),
    [anon_sym_function] = ACTIONS(994),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(1000),
    [anon_sym_BANG] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1006),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1009),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_typeset] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_readonly] = ACTIONS(1012),
    [anon_sym_local] = ACTIONS(1012),
    [anon_sym_unset] = ACTIONS(1015),
    [anon_sym_unsetenv] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1018),
    [anon_sym_GT] = ACTIONS(1018),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1018),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [sym__special_characters] = ACTIONS(1024),
    [anon_sym_DQUOTE] = ACTIONS(1027),
    [anon_sym_DOLLAR] = ACTIONS(1030),
    [sym_raw_string] = ACTIONS(1033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1039),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LPAREN] = ACTIONS(1045),
    [anon_sym_GT_LPAREN] = ACTIONS(1045),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1048),
  },
  [2179] = {
    [sym_concatenation] = STATE(2366),
    [sym_string] = STATE(2173),
    [sym_simple_expansion] = STATE(2173),
    [sym_string_expansion] = STATE(2173),
    [sym_expansion] = STATE(2173),
    [sym_command_substitution] = STATE(2173),
    [sym_process_substitution] = STATE(2173),
    [aux_sym_command_repeat2] = STATE(2366),
    [sym__simple_heredoc_body] = ACTIONS(965),
    [sym__heredoc_body_beginning] = ACTIONS(965),
    [sym_file_descriptor] = ACTIONS(965),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_esac] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(967),
    [anon_sym_SEMI_SEMI] = ACTIONS(965),
    [anon_sym_PIPE_AMP] = ACTIONS(965),
    [anon_sym_AMP_AMP] = ACTIONS(965),
    [anon_sym_PIPE_PIPE] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(5053),
    [anon_sym_EQ_EQ] = ACTIONS(5053),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(965),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(965),
    [anon_sym_LT_AMP] = ACTIONS(965),
    [anon_sym_GT_AMP] = ACTIONS(965),
    [anon_sym_LT_LT] = ACTIONS(967),
    [anon_sym_LT_LT_DASH] = ACTIONS(965),
    [anon_sym_LT_LT_LT] = ACTIONS(965),
    [sym__special_characters] = ACTIONS(5055),
    [anon_sym_DQUOTE] = ACTIONS(4432),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [sym_raw_string] = ACTIONS(5057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_LT_LPAREN] = ACTIONS(4444),
    [anon_sym_GT_LPAREN] = ACTIONS(4444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5059),
    [anon_sym_LF] = ACTIONS(965),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [2180] = {
    [sym__terminated_statement] = STATE(2178),
    [sym_redirected_statement] = STATE(2368),
    [sym_for_statement] = STATE(2368),
    [sym_c_style_for_statement] = STATE(2368),
    [sym_while_statement] = STATE(2368),
    [sym_if_statement] = STATE(2368),
    [sym_case_statement] = STATE(2368),
    [sym_function_definition] = STATE(2368),
    [sym_compound_statement] = STATE(2368),
    [sym_subshell] = STATE(2368),
    [sym_pipeline] = STATE(2368),
    [sym_list] = STATE(2368),
    [sym_negated_command] = STATE(2368),
    [sym_test_command] = STATE(2368),
    [sym_declaration_command] = STATE(2368),
    [sym_unset_command] = STATE(2368),
    [sym_command] = STATE(2368),
    [sym_command_name] = STATE(1930),
    [sym_variable_assignment] = STATE(2369),
    [sym_subscript] = STATE(1932),
    [sym_file_redirect] = STATE(1935),
    [sym_concatenation] = STATE(1933),
    [sym_string] = STATE(1923),
    [sym_simple_expansion] = STATE(1923),
    [sym_string_expansion] = STATE(1923),
    [sym_expansion] = STATE(1923),
    [sym_command_substitution] = STATE(1923),
    [sym_process_substitution] = STATE(1923),
    [aux_sym__statements_repeat1] = STATE(2178),
    [aux_sym_command_repeat1] = STATE(1935),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4418),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(5396),
    [anon_sym_SEMI_SEMI] = ACTIONS(5436),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4426),
    [anon_sym_typeset] = ACTIONS(4426),
    [anon_sym_export] = ACTIONS(4426),
    [anon_sym_readonly] = ACTIONS(4426),
    [anon_sym_local] = ACTIONS(4426),
    [anon_sym_unset] = ACTIONS(4428),
    [anon_sym_unsetenv] = ACTIONS(4428),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(4430),
    [anon_sym_DQUOTE] = ACTIONS(4432),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [sym_raw_string] = ACTIONS(4436),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_LT_LPAREN] = ACTIONS(4444),
    [anon_sym_GT_LPAREN] = ACTIONS(4444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4446),
  },
  [2181] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_esac] = ACTIONS(5438),
    [anon_sym_SEMI_SEMI] = ACTIONS(927),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(5440),
    [anon_sym_DQUOTE] = ACTIONS(5442),
    [anon_sym_DOLLAR] = ACTIONS(5440),
    [sym_raw_string] = ACTIONS(5442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5442),
    [anon_sym_BQUOTE] = ACTIONS(5442),
    [anon_sym_LT_LPAREN] = ACTIONS(5442),
    [anon_sym_GT_LPAREN] = ACTIONS(5442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5440),
  },
  [2182] = {
    [anon_sym_esac] = ACTIONS(5438),
    [sym__special_characters] = ACTIONS(5442),
    [anon_sym_DQUOTE] = ACTIONS(5442),
    [anon_sym_DOLLAR] = ACTIONS(5440),
    [sym_raw_string] = ACTIONS(5442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5442),
    [anon_sym_BQUOTE] = ACTIONS(5442),
    [anon_sym_LT_LPAREN] = ACTIONS(5442),
    [anon_sym_GT_LPAREN] = ACTIONS(5442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5440),
  },
  [2183] = {
    [sym_file_redirect] = STATE(2170),
    [sym_heredoc_redirect] = STATE(2170),
    [sym_heredoc_body] = STATE(2169),
    [sym_herestring_redirect] = STATE(2170),
    [aux_sym_redirected_statement_repeat1] = STATE(2170),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(5031),
    [anon_sym_SEMI] = ACTIONS(5033),
    [anon_sym_esac] = ACTIONS(5444),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI_SEMI] = ACTIONS(5446),
    [anon_sym_PIPE_AMP] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5043),
    [anon_sym_PIPE_PIPE] = ACTIONS(5043),
    [anon_sym_LT] = ACTIONS(5045),
    [anon_sym_GT] = ACTIONS(5045),
    [anon_sym_GT_GT] = ACTIONS(5047),
    [anon_sym_AMP_GT] = ACTIONS(5045),
    [anon_sym_AMP_GT_GT] = ACTIONS(5047),
    [anon_sym_LT_AMP] = ACTIONS(5047),
    [anon_sym_GT_AMP] = ACTIONS(5047),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(5049),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5051),
    [anon_sym_AMP] = ACTIONS(5033),
  },
  [2184] = {
    [sym_file_redirect] = STATE(2170),
    [sym_heredoc_redirect] = STATE(2170),
    [sym_heredoc_body] = STATE(2169),
    [sym_herestring_redirect] = STATE(2170),
    [aux_sym_redirected_statement_repeat1] = STATE(2170),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5033),
    [anon_sym_esac] = ACTIONS(5438),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI_SEMI] = ACTIONS(5446),
    [anon_sym_PIPE_AMP] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5043),
    [anon_sym_PIPE_PIPE] = ACTIONS(5043),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(5049),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5051),
    [anon_sym_AMP] = ACTIONS(5033),
  },
  [2185] = {
    [sym__terminated_statement] = STATE(2178),
    [sym_redirected_statement] = STATE(2372),
    [sym_for_statement] = STATE(2372),
    [sym_c_style_for_statement] = STATE(2372),
    [sym_while_statement] = STATE(2372),
    [sym_if_statement] = STATE(2372),
    [sym_case_statement] = STATE(2372),
    [sym_function_definition] = STATE(2372),
    [sym_compound_statement] = STATE(2372),
    [sym_subshell] = STATE(2372),
    [sym_pipeline] = STATE(2372),
    [sym_list] = STATE(2372),
    [sym_negated_command] = STATE(2372),
    [sym_test_command] = STATE(2372),
    [sym_declaration_command] = STATE(2372),
    [sym_unset_command] = STATE(2372),
    [sym_command] = STATE(2372),
    [sym_command_name] = STATE(1930),
    [sym_variable_assignment] = STATE(2373),
    [sym_subscript] = STATE(1932),
    [sym_file_redirect] = STATE(1935),
    [sym_concatenation] = STATE(1933),
    [sym_string] = STATE(1923),
    [sym_simple_expansion] = STATE(1923),
    [sym_string_expansion] = STATE(1923),
    [sym_expansion] = STATE(1923),
    [sym_command_substitution] = STATE(1923),
    [sym_process_substitution] = STATE(1923),
    [aux_sym__statements_repeat1] = STATE(2178),
    [aux_sym_command_repeat1] = STATE(1935),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4418),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(5438),
    [anon_sym_SEMI_SEMI] = ACTIONS(5448),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4426),
    [anon_sym_typeset] = ACTIONS(4426),
    [anon_sym_export] = ACTIONS(4426),
    [anon_sym_readonly] = ACTIONS(4426),
    [anon_sym_local] = ACTIONS(4426),
    [anon_sym_unset] = ACTIONS(4428),
    [anon_sym_unsetenv] = ACTIONS(4428),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(4430),
    [anon_sym_DQUOTE] = ACTIONS(4432),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [sym_raw_string] = ACTIONS(4436),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_LT_LPAREN] = ACTIONS(4444),
    [anon_sym_GT_LPAREN] = ACTIONS(4444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4446),
  },
  [2186] = {
    [sym__terminated_statement] = STATE(2377),
    [sym_redirected_statement] = STATE(2375),
    [sym_for_statement] = STATE(2375),
    [sym_c_style_for_statement] = STATE(2375),
    [sym_while_statement] = STATE(2375),
    [sym_if_statement] = STATE(2375),
    [sym_case_statement] = STATE(2375),
    [sym_function_definition] = STATE(2375),
    [sym_compound_statement] = STATE(2375),
    [sym_subshell] = STATE(2375),
    [sym_pipeline] = STATE(2375),
    [sym_list] = STATE(2375),
    [sym_negated_command] = STATE(2375),
    [sym_test_command] = STATE(2375),
    [sym_declaration_command] = STATE(2375),
    [sym_unset_command] = STATE(2375),
    [sym_command] = STATE(2375),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(2376),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(2377),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(5450),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [2187] = {
    [aux_sym_case_item_repeat1] = STATE(1937),
    [anon_sym_PIPE] = ACTIONS(3617),
    [anon_sym_RPAREN] = ACTIONS(5452),
    [sym_comment] = ACTIONS(57),
  },
  [2188] = {
    [sym__terminated_statement] = STATE(2382),
    [sym_redirected_statement] = STATE(2380),
    [sym_for_statement] = STATE(2380),
    [sym_c_style_for_statement] = STATE(2380),
    [sym_while_statement] = STATE(2380),
    [sym_if_statement] = STATE(2380),
    [sym_case_statement] = STATE(2380),
    [sym_function_definition] = STATE(2380),
    [sym_compound_statement] = STATE(2380),
    [sym_subshell] = STATE(2380),
    [sym_pipeline] = STATE(2380),
    [sym_list] = STATE(2380),
    [sym_negated_command] = STATE(2380),
    [sym_test_command] = STATE(2380),
    [sym_declaration_command] = STATE(2380),
    [sym_unset_command] = STATE(2380),
    [sym_command] = STATE(2380),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(2381),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(2382),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(5454),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [2189] = {
    [aux_sym_case_item_repeat1] = STATE(1937),
    [anon_sym_PIPE] = ACTIONS(3617),
    [anon_sym_RPAREN] = ACTIONS(5456),
    [sym_comment] = ACTIONS(57),
  },
  [2190] = {
    [sym__simple_heredoc_body] = ACTIONS(5458),
    [sym__heredoc_body_beginning] = ACTIONS(5458),
    [sym_file_descriptor] = ACTIONS(5458),
    [ts_builtin_sym_end] = ACTIONS(5458),
    [anon_sym_SEMI] = ACTIONS(5460),
    [anon_sym_esac] = ACTIONS(5458),
    [anon_sym_PIPE] = ACTIONS(5460),
    [anon_sym_RPAREN] = ACTIONS(5458),
    [anon_sym_SEMI_SEMI] = ACTIONS(5458),
    [anon_sym_PIPE_AMP] = ACTIONS(5458),
    [anon_sym_AMP_AMP] = ACTIONS(5458),
    [anon_sym_PIPE_PIPE] = ACTIONS(5458),
    [anon_sym_LT] = ACTIONS(5460),
    [anon_sym_GT] = ACTIONS(5460),
    [anon_sym_GT_GT] = ACTIONS(5458),
    [anon_sym_AMP_GT] = ACTIONS(5460),
    [anon_sym_AMP_GT_GT] = ACTIONS(5458),
    [anon_sym_LT_AMP] = ACTIONS(5458),
    [anon_sym_GT_AMP] = ACTIONS(5458),
    [anon_sym_LT_LT] = ACTIONS(5460),
    [anon_sym_LT_LT_DASH] = ACTIONS(5458),
    [anon_sym_LT_LT_LT] = ACTIONS(5458),
    [anon_sym_BQUOTE] = ACTIONS(5458),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5460),
  },
  [2191] = {
    [sym__simple_heredoc_body] = ACTIONS(5462),
    [sym__heredoc_body_beginning] = ACTIONS(5462),
    [sym_file_descriptor] = ACTIONS(5462),
    [ts_builtin_sym_end] = ACTIONS(5462),
    [anon_sym_SEMI] = ACTIONS(5464),
    [anon_sym_esac] = ACTIONS(5462),
    [anon_sym_PIPE] = ACTIONS(5464),
    [anon_sym_RPAREN] = ACTIONS(5462),
    [anon_sym_SEMI_SEMI] = ACTIONS(5462),
    [anon_sym_PIPE_AMP] = ACTIONS(5462),
    [anon_sym_AMP_AMP] = ACTIONS(5462),
    [anon_sym_PIPE_PIPE] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5464),
    [anon_sym_GT] = ACTIONS(5464),
    [anon_sym_GT_GT] = ACTIONS(5462),
    [anon_sym_AMP_GT] = ACTIONS(5464),
    [anon_sym_AMP_GT_GT] = ACTIONS(5462),
    [anon_sym_LT_AMP] = ACTIONS(5462),
    [anon_sym_GT_AMP] = ACTIONS(5462),
    [anon_sym_LT_LT] = ACTIONS(5464),
    [anon_sym_LT_LT_DASH] = ACTIONS(5462),
    [anon_sym_LT_LT_LT] = ACTIONS(5462),
    [anon_sym_BQUOTE] = ACTIONS(5462),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5462),
    [anon_sym_AMP] = ACTIONS(5464),
  },
  [2192] = {
    [sym__concat] = ACTIONS(5168),
    [anon_sym_in] = ACTIONS(5168),
    [anon_sym_SEMI] = ACTIONS(5170),
    [anon_sym_SEMI_SEMI] = ACTIONS(5168),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5168),
  },
  [2193] = {
    [sym__concat] = ACTIONS(5172),
    [anon_sym_in] = ACTIONS(5172),
    [anon_sym_SEMI] = ACTIONS(5174),
    [anon_sym_SEMI_SEMI] = ACTIONS(5172),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5172),
    [anon_sym_AMP] = ACTIONS(5172),
  },
  [2194] = {
    [sym__concat] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_RBRACK] = ACTIONS(5168),
    [anon_sym_EQ_TILDE] = ACTIONS(5168),
    [anon_sym_EQ_EQ] = ACTIONS(5168),
    [anon_sym_EQ] = ACTIONS(5170),
    [anon_sym_PLUS_EQ] = ACTIONS(5168),
    [anon_sym_LT] = ACTIONS(5170),
    [anon_sym_GT] = ACTIONS(5170),
    [anon_sym_BANG_EQ] = ACTIONS(5168),
    [anon_sym_PLUS] = ACTIONS(5170),
    [anon_sym_DASH] = ACTIONS(5170),
    [anon_sym_DASH_EQ] = ACTIONS(5168),
    [anon_sym_LT_EQ] = ACTIONS(5168),
    [anon_sym_GT_EQ] = ACTIONS(5168),
    [anon_sym_PLUS_PLUS] = ACTIONS(5168),
    [anon_sym_DASH_DASH] = ACTIONS(5168),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5168),
  },
  [2195] = {
    [sym__concat] = ACTIONS(5172),
    [anon_sym_AMP_AMP] = ACTIONS(5172),
    [anon_sym_PIPE_PIPE] = ACTIONS(5172),
    [anon_sym_RBRACK] = ACTIONS(5172),
    [anon_sym_EQ_TILDE] = ACTIONS(5172),
    [anon_sym_EQ_EQ] = ACTIONS(5172),
    [anon_sym_EQ] = ACTIONS(5174),
    [anon_sym_PLUS_EQ] = ACTIONS(5172),
    [anon_sym_LT] = ACTIONS(5174),
    [anon_sym_GT] = ACTIONS(5174),
    [anon_sym_BANG_EQ] = ACTIONS(5172),
    [anon_sym_PLUS] = ACTIONS(5174),
    [anon_sym_DASH] = ACTIONS(5174),
    [anon_sym_DASH_EQ] = ACTIONS(5172),
    [anon_sym_LT_EQ] = ACTIONS(5172),
    [anon_sym_GT_EQ] = ACTIONS(5172),
    [anon_sym_PLUS_PLUS] = ACTIONS(5172),
    [anon_sym_DASH_DASH] = ACTIONS(5172),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5172),
  },
  [2196] = {
    [sym__simple_heredoc_body] = ACTIONS(5168),
    [sym__heredoc_body_beginning] = ACTIONS(5168),
    [sym_file_descriptor] = ACTIONS(5168),
    [sym__concat] = ACTIONS(5168),
    [sym_variable_name] = ACTIONS(5168),
    [ts_builtin_sym_end] = ACTIONS(5168),
    [anon_sym_SEMI] = ACTIONS(5170),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_RPAREN] = ACTIONS(5168),
    [anon_sym_SEMI_SEMI] = ACTIONS(5168),
    [anon_sym_PIPE_AMP] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_LT] = ACTIONS(5170),
    [anon_sym_GT] = ACTIONS(5170),
    [anon_sym_GT_GT] = ACTIONS(5168),
    [anon_sym_AMP_GT] = ACTIONS(5170),
    [anon_sym_AMP_GT_GT] = ACTIONS(5168),
    [anon_sym_LT_AMP] = ACTIONS(5168),
    [anon_sym_GT_AMP] = ACTIONS(5168),
    [anon_sym_LT_LT] = ACTIONS(5170),
    [anon_sym_LT_LT_DASH] = ACTIONS(5168),
    [anon_sym_LT_LT_LT] = ACTIONS(5168),
    [sym__special_characters] = ACTIONS(5168),
    [anon_sym_DQUOTE] = ACTIONS(5168),
    [anon_sym_DOLLAR] = ACTIONS(5170),
    [sym_raw_string] = ACTIONS(5168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5168),
    [anon_sym_BQUOTE] = ACTIONS(5168),
    [anon_sym_LT_LPAREN] = ACTIONS(5168),
    [anon_sym_GT_LPAREN] = ACTIONS(5168),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5170),
    [sym_word] = ACTIONS(5170),
    [anon_sym_LF] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5170),
  },
  [2197] = {
    [sym__simple_heredoc_body] = ACTIONS(5172),
    [sym__heredoc_body_beginning] = ACTIONS(5172),
    [sym_file_descriptor] = ACTIONS(5172),
    [sym__concat] = ACTIONS(5172),
    [sym_variable_name] = ACTIONS(5172),
    [ts_builtin_sym_end] = ACTIONS(5172),
    [anon_sym_SEMI] = ACTIONS(5174),
    [anon_sym_PIPE] = ACTIONS(5174),
    [anon_sym_RPAREN] = ACTIONS(5172),
    [anon_sym_SEMI_SEMI] = ACTIONS(5172),
    [anon_sym_PIPE_AMP] = ACTIONS(5172),
    [anon_sym_AMP_AMP] = ACTIONS(5172),
    [anon_sym_PIPE_PIPE] = ACTIONS(5172),
    [anon_sym_LT] = ACTIONS(5174),
    [anon_sym_GT] = ACTIONS(5174),
    [anon_sym_GT_GT] = ACTIONS(5172),
    [anon_sym_AMP_GT] = ACTIONS(5174),
    [anon_sym_AMP_GT_GT] = ACTIONS(5172),
    [anon_sym_LT_AMP] = ACTIONS(5172),
    [anon_sym_GT_AMP] = ACTIONS(5172),
    [anon_sym_LT_LT] = ACTIONS(5174),
    [anon_sym_LT_LT_DASH] = ACTIONS(5172),
    [anon_sym_LT_LT_LT] = ACTIONS(5172),
    [sym__special_characters] = ACTIONS(5172),
    [anon_sym_DQUOTE] = ACTIONS(5172),
    [anon_sym_DOLLAR] = ACTIONS(5174),
    [sym_raw_string] = ACTIONS(5172),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5172),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5172),
    [anon_sym_BQUOTE] = ACTIONS(5172),
    [anon_sym_LT_LPAREN] = ACTIONS(5172),
    [anon_sym_GT_LPAREN] = ACTIONS(5172),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5174),
    [sym_word] = ACTIONS(5174),
    [anon_sym_LF] = ACTIONS(5172),
    [anon_sym_AMP] = ACTIONS(5174),
  },
  [2198] = {
    [sym__simple_heredoc_body] = ACTIONS(5168),
    [sym__heredoc_body_beginning] = ACTIONS(5168),
    [sym_file_descriptor] = ACTIONS(5168),
    [sym__concat] = ACTIONS(5168),
    [ts_builtin_sym_end] = ACTIONS(5168),
    [anon_sym_SEMI] = ACTIONS(5170),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_RPAREN] = ACTIONS(5168),
    [anon_sym_SEMI_SEMI] = ACTIONS(5168),
    [anon_sym_PIPE_AMP] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_LT] = ACTIONS(5170),
    [anon_sym_GT] = ACTIONS(5170),
    [anon_sym_GT_GT] = ACTIONS(5168),
    [anon_sym_AMP_GT] = ACTIONS(5170),
    [anon_sym_AMP_GT_GT] = ACTIONS(5168),
    [anon_sym_LT_AMP] = ACTIONS(5168),
    [anon_sym_GT_AMP] = ACTIONS(5168),
    [anon_sym_LT_LT] = ACTIONS(5170),
    [anon_sym_LT_LT_DASH] = ACTIONS(5168),
    [anon_sym_LT_LT_LT] = ACTIONS(5168),
    [sym__special_characters] = ACTIONS(5168),
    [anon_sym_DQUOTE] = ACTIONS(5168),
    [anon_sym_DOLLAR] = ACTIONS(5170),
    [sym_raw_string] = ACTIONS(5168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5168),
    [anon_sym_BQUOTE] = ACTIONS(5168),
    [anon_sym_LT_LPAREN] = ACTIONS(5168),
    [anon_sym_GT_LPAREN] = ACTIONS(5168),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5170),
    [sym_word] = ACTIONS(5170),
    [anon_sym_LF] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5170),
  },
  [2199] = {
    [sym__simple_heredoc_body] = ACTIONS(5172),
    [sym__heredoc_body_beginning] = ACTIONS(5172),
    [sym_file_descriptor] = ACTIONS(5172),
    [sym__concat] = ACTIONS(5172),
    [ts_builtin_sym_end] = ACTIONS(5172),
    [anon_sym_SEMI] = ACTIONS(5174),
    [anon_sym_PIPE] = ACTIONS(5174),
    [anon_sym_RPAREN] = ACTIONS(5172),
    [anon_sym_SEMI_SEMI] = ACTIONS(5172),
    [anon_sym_PIPE_AMP] = ACTIONS(5172),
    [anon_sym_AMP_AMP] = ACTIONS(5172),
    [anon_sym_PIPE_PIPE] = ACTIONS(5172),
    [anon_sym_LT] = ACTIONS(5174),
    [anon_sym_GT] = ACTIONS(5174),
    [anon_sym_GT_GT] = ACTIONS(5172),
    [anon_sym_AMP_GT] = ACTIONS(5174),
    [anon_sym_AMP_GT_GT] = ACTIONS(5172),
    [anon_sym_LT_AMP] = ACTIONS(5172),
    [anon_sym_GT_AMP] = ACTIONS(5172),
    [anon_sym_LT_LT] = ACTIONS(5174),
    [anon_sym_LT_LT_DASH] = ACTIONS(5172),
    [anon_sym_LT_LT_LT] = ACTIONS(5172),
    [sym__special_characters] = ACTIONS(5172),
    [anon_sym_DQUOTE] = ACTIONS(5172),
    [anon_sym_DOLLAR] = ACTIONS(5174),
    [sym_raw_string] = ACTIONS(5172),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5172),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5172),
    [anon_sym_BQUOTE] = ACTIONS(5172),
    [anon_sym_LT_LPAREN] = ACTIONS(5172),
    [anon_sym_GT_LPAREN] = ACTIONS(5172),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5174),
    [sym_word] = ACTIONS(5174),
    [anon_sym_LF] = ACTIONS(5172),
    [anon_sym_AMP] = ACTIONS(5174),
  },
  [2200] = {
    [sym_file_descriptor] = ACTIONS(5168),
    [sym__concat] = ACTIONS(5168),
    [sym_variable_name] = ACTIONS(5168),
    [anon_sym_LT] = ACTIONS(5170),
    [anon_sym_GT] = ACTIONS(5170),
    [anon_sym_GT_GT] = ACTIONS(5168),
    [anon_sym_AMP_GT] = ACTIONS(5170),
    [anon_sym_AMP_GT_GT] = ACTIONS(5168),
    [anon_sym_LT_AMP] = ACTIONS(5168),
    [anon_sym_GT_AMP] = ACTIONS(5168),
    [sym__special_characters] = ACTIONS(5168),
    [anon_sym_DQUOTE] = ACTIONS(5168),
    [anon_sym_DOLLAR] = ACTIONS(5170),
    [sym_raw_string] = ACTIONS(5168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5168),
    [anon_sym_BQUOTE] = ACTIONS(5168),
    [anon_sym_LT_LPAREN] = ACTIONS(5168),
    [anon_sym_GT_LPAREN] = ACTIONS(5168),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5168),
  },
  [2201] = {
    [sym_file_descriptor] = ACTIONS(5172),
    [sym__concat] = ACTIONS(5172),
    [sym_variable_name] = ACTIONS(5172),
    [anon_sym_LT] = ACTIONS(5174),
    [anon_sym_GT] = ACTIONS(5174),
    [anon_sym_GT_GT] = ACTIONS(5172),
    [anon_sym_AMP_GT] = ACTIONS(5174),
    [anon_sym_AMP_GT_GT] = ACTIONS(5172),
    [anon_sym_LT_AMP] = ACTIONS(5172),
    [anon_sym_GT_AMP] = ACTIONS(5172),
    [sym__special_characters] = ACTIONS(5172),
    [anon_sym_DQUOTE] = ACTIONS(5172),
    [anon_sym_DOLLAR] = ACTIONS(5174),
    [sym_raw_string] = ACTIONS(5172),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5172),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5172),
    [anon_sym_BQUOTE] = ACTIONS(5172),
    [anon_sym_LT_LPAREN] = ACTIONS(5172),
    [anon_sym_GT_LPAREN] = ACTIONS(5172),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5172),
  },
  [2202] = {
    [sym__concat] = ACTIONS(5168),
    [anon_sym_DQUOTE] = ACTIONS(5170),
    [anon_sym_DOLLAR] = ACTIONS(5170),
    [sym__string_content] = ACTIONS(5168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5170),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5170),
    [anon_sym_BQUOTE] = ACTIONS(5170),
    [sym_comment] = ACTIONS(265),
  },
  [2203] = {
    [sym__concat] = ACTIONS(5172),
    [anon_sym_DQUOTE] = ACTIONS(5174),
    [anon_sym_DOLLAR] = ACTIONS(5174),
    [sym__string_content] = ACTIONS(5172),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5174),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5174),
    [anon_sym_BQUOTE] = ACTIONS(5174),
    [sym_comment] = ACTIONS(265),
  },
  [2204] = {
    [sym__concat] = ACTIONS(3921),
    [anon_sym_RBRACE] = ACTIONS(3921),
    [sym_comment] = ACTIONS(57),
  },
  [2205] = {
    [sym__concat] = ACTIONS(3929),
    [anon_sym_RBRACE] = ACTIONS(3929),
    [sym_comment] = ACTIONS(57),
  },
  [2206] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(5466),
    [sym_comment] = ACTIONS(57),
  },
  [2207] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [sym_comment] = ACTIONS(57),
  },
  [2208] = {
    [anon_sym_RBRACE] = ACTIONS(5468),
    [sym_comment] = ACTIONS(57),
  },
  [2209] = {
    [sym_concatenation] = STATE(2387),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2387),
    [anon_sym_RBRACE] = ACTIONS(5470),
    [anon_sym_EQ] = ACTIONS(5472),
    [anon_sym_DASH] = ACTIONS(5472),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(5472),
    [anon_sym_COLON_QMARK] = ACTIONS(5472),
    [anon_sym_COLON_DASH] = ACTIONS(5472),
    [anon_sym_PERCENT] = ACTIONS(5472),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2210] = {
    [sym__concat] = ACTIONS(3985),
    [anon_sym_RBRACE] = ACTIONS(3985),
    [sym_comment] = ACTIONS(57),
  },
  [2211] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5470),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2212] = {
    [sym_concatenation] = STATE(2388),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2388),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [anon_sym_EQ] = ACTIONS(5476),
    [anon_sym_DASH] = ACTIONS(5476),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5478),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(5476),
    [anon_sym_COLON_QMARK] = ACTIONS(5476),
    [anon_sym_COLON_DASH] = ACTIONS(5476),
    [anon_sym_PERCENT] = ACTIONS(5476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2213] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2214] = {
    [sym__concat] = ACTIONS(4030),
    [anon_sym_RBRACE] = ACTIONS(4030),
    [sym_comment] = ACTIONS(57),
  },
  [2215] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5480),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2216] = {
    [sym__concat] = ACTIONS(4064),
    [anon_sym_RBRACE] = ACTIONS(4064),
    [sym_comment] = ACTIONS(57),
  },
  [2217] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(5482),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2218] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(5482),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2219] = {
    [sym__concat] = ACTIONS(4070),
    [anon_sym_RBRACE] = ACTIONS(4070),
    [sym_comment] = ACTIONS(57),
  },
  [2220] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(5484),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2221] = {
    [sym__concat] = ACTIONS(4687),
    [anon_sym_RBRACE] = ACTIONS(4687),
    [anon_sym_EQ] = ACTIONS(4689),
    [anon_sym_DASH] = ACTIONS(4689),
    [sym__special_characters] = ACTIONS(4689),
    [anon_sym_DQUOTE] = ACTIONS(4687),
    [anon_sym_DOLLAR] = ACTIONS(4689),
    [sym_raw_string] = ACTIONS(4687),
    [anon_sym_POUND] = ACTIONS(4687),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4687),
    [anon_sym_COLON] = ACTIONS(4689),
    [anon_sym_COLON_QMARK] = ACTIONS(4689),
    [anon_sym_COLON_DASH] = ACTIONS(4689),
    [anon_sym_PERCENT] = ACTIONS(4689),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4687),
    [anon_sym_BQUOTE] = ACTIONS(4687),
    [anon_sym_LT_LPAREN] = ACTIONS(4687),
    [anon_sym_GT_LPAREN] = ACTIONS(4687),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4689),
  },
  [2222] = {
    [sym__concat] = ACTIONS(4691),
    [anon_sym_RBRACE] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [sym__special_characters] = ACTIONS(4693),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4693),
    [sym_raw_string] = ACTIONS(4691),
    [anon_sym_POUND] = ACTIONS(4691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4691),
    [anon_sym_COLON] = ACTIONS(4693),
    [anon_sym_COLON_QMARK] = ACTIONS(4693),
    [anon_sym_COLON_DASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4691),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_LT_LPAREN] = ACTIONS(4691),
    [anon_sym_GT_LPAREN] = ACTIONS(4691),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4693),
  },
  [2223] = {
    [sym__concat] = ACTIONS(4695),
    [anon_sym_RBRACE] = ACTIONS(4695),
    [anon_sym_EQ] = ACTIONS(4697),
    [anon_sym_DASH] = ACTIONS(4697),
    [sym__special_characters] = ACTIONS(4697),
    [anon_sym_DQUOTE] = ACTIONS(4695),
    [anon_sym_DOLLAR] = ACTIONS(4697),
    [sym_raw_string] = ACTIONS(4695),
    [anon_sym_POUND] = ACTIONS(4695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4695),
    [anon_sym_COLON] = ACTIONS(4697),
    [anon_sym_COLON_QMARK] = ACTIONS(4697),
    [anon_sym_COLON_DASH] = ACTIONS(4697),
    [anon_sym_PERCENT] = ACTIONS(4697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4695),
    [anon_sym_BQUOTE] = ACTIONS(4695),
    [anon_sym_LT_LPAREN] = ACTIONS(4695),
    [anon_sym_GT_LPAREN] = ACTIONS(4695),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4697),
  },
  [2224] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5486),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2225] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5488),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2226] = {
    [sym__concat] = ACTIONS(4731),
    [anon_sym_RBRACE] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4733),
    [sym__special_characters] = ACTIONS(4733),
    [anon_sym_DQUOTE] = ACTIONS(4731),
    [anon_sym_DOLLAR] = ACTIONS(4733),
    [sym_raw_string] = ACTIONS(4731),
    [anon_sym_POUND] = ACTIONS(4731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4731),
    [anon_sym_COLON] = ACTIONS(4733),
    [anon_sym_COLON_QMARK] = ACTIONS(4733),
    [anon_sym_COLON_DASH] = ACTIONS(4733),
    [anon_sym_PERCENT] = ACTIONS(4733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4731),
    [anon_sym_BQUOTE] = ACTIONS(4731),
    [anon_sym_LT_LPAREN] = ACTIONS(4731),
    [anon_sym_GT_LPAREN] = ACTIONS(4731),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4733),
  },
  [2227] = {
    [sym__concat] = ACTIONS(4751),
    [anon_sym_RBRACE] = ACTIONS(4751),
    [anon_sym_EQ] = ACTIONS(4753),
    [anon_sym_DASH] = ACTIONS(4753),
    [sym__special_characters] = ACTIONS(4753),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4753),
    [sym_raw_string] = ACTIONS(4751),
    [anon_sym_POUND] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_COLON] = ACTIONS(4753),
    [anon_sym_COLON_QMARK] = ACTIONS(4753),
    [anon_sym_COLON_DASH] = ACTIONS(4753),
    [anon_sym_PERCENT] = ACTIONS(4753),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_LT_LPAREN] = ACTIONS(4751),
    [anon_sym_GT_LPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4753),
  },
  [2228] = {
    [sym__concat] = ACTIONS(4755),
    [anon_sym_RBRACE] = ACTIONS(4755),
    [anon_sym_EQ] = ACTIONS(4757),
    [anon_sym_DASH] = ACTIONS(4757),
    [sym__special_characters] = ACTIONS(4757),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4757),
    [sym_raw_string] = ACTIONS(4755),
    [anon_sym_POUND] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_COLON] = ACTIONS(4757),
    [anon_sym_COLON_QMARK] = ACTIONS(4757),
    [anon_sym_COLON_DASH] = ACTIONS(4757),
    [anon_sym_PERCENT] = ACTIONS(4757),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_LT_LPAREN] = ACTIONS(4755),
    [anon_sym_GT_LPAREN] = ACTIONS(4755),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4757),
  },
  [2229] = {
    [sym__heredoc_body_middle] = ACTIONS(4687),
    [sym__heredoc_body_end] = ACTIONS(4687),
    [anon_sym_DOLLAR] = ACTIONS(4689),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4687),
    [sym_comment] = ACTIONS(57),
  },
  [2230] = {
    [sym__heredoc_body_middle] = ACTIONS(4691),
    [sym__heredoc_body_end] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4691),
    [sym_comment] = ACTIONS(57),
  },
  [2231] = {
    [sym__heredoc_body_middle] = ACTIONS(4695),
    [sym__heredoc_body_end] = ACTIONS(4695),
    [anon_sym_DOLLAR] = ACTIONS(4697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4695),
    [sym_comment] = ACTIONS(57),
  },
  [2232] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5490),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2233] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5492),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2234] = {
    [sym__heredoc_body_middle] = ACTIONS(4731),
    [sym__heredoc_body_end] = ACTIONS(4731),
    [anon_sym_DOLLAR] = ACTIONS(4733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4731),
    [sym_comment] = ACTIONS(57),
  },
  [2235] = {
    [sym__concat] = ACTIONS(4687),
    [anon_sym_RPAREN] = ACTIONS(4687),
    [sym__special_characters] = ACTIONS(4687),
    [anon_sym_DQUOTE] = ACTIONS(4687),
    [anon_sym_DOLLAR] = ACTIONS(4689),
    [sym_raw_string] = ACTIONS(4687),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4687),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4687),
    [anon_sym_BQUOTE] = ACTIONS(4687),
    [anon_sym_LT_LPAREN] = ACTIONS(4687),
    [anon_sym_GT_LPAREN] = ACTIONS(4687),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4687),
  },
  [2236] = {
    [sym__concat] = ACTIONS(4691),
    [anon_sym_RPAREN] = ACTIONS(4691),
    [sym__special_characters] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4693),
    [sym_raw_string] = ACTIONS(4691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4691),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_LT_LPAREN] = ACTIONS(4691),
    [anon_sym_GT_LPAREN] = ACTIONS(4691),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4691),
  },
  [2237] = {
    [sym__concat] = ACTIONS(4695),
    [anon_sym_RPAREN] = ACTIONS(4695),
    [sym__special_characters] = ACTIONS(4695),
    [anon_sym_DQUOTE] = ACTIONS(4695),
    [anon_sym_DOLLAR] = ACTIONS(4697),
    [sym_raw_string] = ACTIONS(4695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4695),
    [anon_sym_BQUOTE] = ACTIONS(4695),
    [anon_sym_LT_LPAREN] = ACTIONS(4695),
    [anon_sym_GT_LPAREN] = ACTIONS(4695),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4695),
  },
  [2238] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5494),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2239] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2240] = {
    [sym__concat] = ACTIONS(4731),
    [anon_sym_RPAREN] = ACTIONS(4731),
    [sym__special_characters] = ACTIONS(4731),
    [anon_sym_DQUOTE] = ACTIONS(4731),
    [anon_sym_DOLLAR] = ACTIONS(4733),
    [sym_raw_string] = ACTIONS(4731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4731),
    [anon_sym_BQUOTE] = ACTIONS(4731),
    [anon_sym_LT_LPAREN] = ACTIONS(4731),
    [anon_sym_GT_LPAREN] = ACTIONS(4731),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4731),
  },
  [2241] = {
    [sym__concat] = ACTIONS(4751),
    [anon_sym_RPAREN] = ACTIONS(4751),
    [sym__special_characters] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4753),
    [sym_raw_string] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_LT_LPAREN] = ACTIONS(4751),
    [anon_sym_GT_LPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4751),
  },
  [2242] = {
    [sym__concat] = ACTIONS(4755),
    [anon_sym_RPAREN] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4757),
    [sym_raw_string] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_LT_LPAREN] = ACTIONS(4755),
    [anon_sym_GT_LPAREN] = ACTIONS(4755),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4755),
  },
  [2243] = {
    [sym__simple_heredoc_body] = ACTIONS(5168),
    [sym__heredoc_body_beginning] = ACTIONS(5168),
    [sym_file_descriptor] = ACTIONS(5168),
    [sym__concat] = ACTIONS(5168),
    [sym_variable_name] = ACTIONS(5168),
    [ts_builtin_sym_end] = ACTIONS(5168),
    [anon_sym_SEMI] = ACTIONS(5170),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_RPAREN] = ACTIONS(5168),
    [anon_sym_SEMI_SEMI] = ACTIONS(5168),
    [anon_sym_PIPE_AMP] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_LT] = ACTIONS(5170),
    [anon_sym_GT] = ACTIONS(5170),
    [anon_sym_GT_GT] = ACTIONS(5168),
    [anon_sym_AMP_GT] = ACTIONS(5170),
    [anon_sym_AMP_GT_GT] = ACTIONS(5168),
    [anon_sym_LT_AMP] = ACTIONS(5168),
    [anon_sym_GT_AMP] = ACTIONS(5168),
    [anon_sym_LT_LT] = ACTIONS(5170),
    [anon_sym_LT_LT_DASH] = ACTIONS(5168),
    [anon_sym_LT_LT_LT] = ACTIONS(5168),
    [sym__special_characters] = ACTIONS(5168),
    [anon_sym_DQUOTE] = ACTIONS(5168),
    [anon_sym_DOLLAR] = ACTIONS(5170),
    [sym_raw_string] = ACTIONS(5168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5168),
    [anon_sym_BQUOTE] = ACTIONS(5168),
    [anon_sym_LT_LPAREN] = ACTIONS(5168),
    [anon_sym_GT_LPAREN] = ACTIONS(5168),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5170),
    [anon_sym_LF] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5170),
  },
  [2244] = {
    [sym__simple_heredoc_body] = ACTIONS(5172),
    [sym__heredoc_body_beginning] = ACTIONS(5172),
    [sym_file_descriptor] = ACTIONS(5172),
    [sym__concat] = ACTIONS(5172),
    [sym_variable_name] = ACTIONS(5172),
    [ts_builtin_sym_end] = ACTIONS(5172),
    [anon_sym_SEMI] = ACTIONS(5174),
    [anon_sym_PIPE] = ACTIONS(5174),
    [anon_sym_RPAREN] = ACTIONS(5172),
    [anon_sym_SEMI_SEMI] = ACTIONS(5172),
    [anon_sym_PIPE_AMP] = ACTIONS(5172),
    [anon_sym_AMP_AMP] = ACTIONS(5172),
    [anon_sym_PIPE_PIPE] = ACTIONS(5172),
    [anon_sym_LT] = ACTIONS(5174),
    [anon_sym_GT] = ACTIONS(5174),
    [anon_sym_GT_GT] = ACTIONS(5172),
    [anon_sym_AMP_GT] = ACTIONS(5174),
    [anon_sym_AMP_GT_GT] = ACTIONS(5172),
    [anon_sym_LT_AMP] = ACTIONS(5172),
    [anon_sym_GT_AMP] = ACTIONS(5172),
    [anon_sym_LT_LT] = ACTIONS(5174),
    [anon_sym_LT_LT_DASH] = ACTIONS(5172),
    [anon_sym_LT_LT_LT] = ACTIONS(5172),
    [sym__special_characters] = ACTIONS(5172),
    [anon_sym_DQUOTE] = ACTIONS(5172),
    [anon_sym_DOLLAR] = ACTIONS(5174),
    [sym_raw_string] = ACTIONS(5172),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5172),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5172),
    [anon_sym_BQUOTE] = ACTIONS(5172),
    [anon_sym_LT_LPAREN] = ACTIONS(5172),
    [anon_sym_GT_LPAREN] = ACTIONS(5172),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5174),
    [anon_sym_LF] = ACTIONS(5172),
    [anon_sym_AMP] = ACTIONS(5174),
  },
  [2245] = {
    [sym__simple_heredoc_body] = ACTIONS(5498),
    [sym__heredoc_body_beginning] = ACTIONS(5498),
    [sym_file_descriptor] = ACTIONS(5498),
    [ts_builtin_sym_end] = ACTIONS(5498),
    [anon_sym_SEMI] = ACTIONS(5500),
    [anon_sym_esac] = ACTIONS(5498),
    [anon_sym_PIPE] = ACTIONS(5500),
    [anon_sym_RPAREN] = ACTIONS(5498),
    [anon_sym_SEMI_SEMI] = ACTIONS(5498),
    [anon_sym_PIPE_AMP] = ACTIONS(5498),
    [anon_sym_AMP_AMP] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE] = ACTIONS(5498),
    [anon_sym_LT] = ACTIONS(5500),
    [anon_sym_GT] = ACTIONS(5500),
    [anon_sym_GT_GT] = ACTIONS(5498),
    [anon_sym_AMP_GT] = ACTIONS(5500),
    [anon_sym_AMP_GT_GT] = ACTIONS(5498),
    [anon_sym_LT_AMP] = ACTIONS(5498),
    [anon_sym_GT_AMP] = ACTIONS(5498),
    [anon_sym_LT_LT] = ACTIONS(5500),
    [anon_sym_LT_LT_DASH] = ACTIONS(5498),
    [anon_sym_LT_LT_LT] = ACTIONS(5498),
    [anon_sym_BQUOTE] = ACTIONS(5498),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5498),
    [anon_sym_AMP] = ACTIONS(5500),
  },
  [2246] = {
    [sym__concat] = ACTIONS(5168),
    [anon_sym_SEMI] = ACTIONS(5170),
    [anon_sym_SEMI_SEMI] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_EQ_TILDE] = ACTIONS(5168),
    [anon_sym_EQ_EQ] = ACTIONS(5168),
    [anon_sym_EQ] = ACTIONS(5170),
    [anon_sym_PLUS_EQ] = ACTIONS(5168),
    [anon_sym_LT] = ACTIONS(5170),
    [anon_sym_GT] = ACTIONS(5170),
    [anon_sym_BANG_EQ] = ACTIONS(5168),
    [anon_sym_PLUS] = ACTIONS(5170),
    [anon_sym_DASH] = ACTIONS(5170),
    [anon_sym_DASH_EQ] = ACTIONS(5168),
    [anon_sym_LT_EQ] = ACTIONS(5168),
    [anon_sym_GT_EQ] = ACTIONS(5168),
    [anon_sym_PLUS_PLUS] = ACTIONS(5168),
    [anon_sym_DASH_DASH] = ACTIONS(5168),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5168),
    [anon_sym_LF] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5170),
  },
  [2247] = {
    [sym__concat] = ACTIONS(5172),
    [anon_sym_SEMI] = ACTIONS(5174),
    [anon_sym_SEMI_SEMI] = ACTIONS(5172),
    [anon_sym_AMP_AMP] = ACTIONS(5172),
    [anon_sym_PIPE_PIPE] = ACTIONS(5172),
    [anon_sym_EQ_TILDE] = ACTIONS(5172),
    [anon_sym_EQ_EQ] = ACTIONS(5172),
    [anon_sym_EQ] = ACTIONS(5174),
    [anon_sym_PLUS_EQ] = ACTIONS(5172),
    [anon_sym_LT] = ACTIONS(5174),
    [anon_sym_GT] = ACTIONS(5174),
    [anon_sym_BANG_EQ] = ACTIONS(5172),
    [anon_sym_PLUS] = ACTIONS(5174),
    [anon_sym_DASH] = ACTIONS(5174),
    [anon_sym_DASH_EQ] = ACTIONS(5172),
    [anon_sym_LT_EQ] = ACTIONS(5172),
    [anon_sym_GT_EQ] = ACTIONS(5172),
    [anon_sym_PLUS_PLUS] = ACTIONS(5172),
    [anon_sym_DASH_DASH] = ACTIONS(5172),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5172),
    [anon_sym_LF] = ACTIONS(5172),
    [anon_sym_AMP] = ACTIONS(5174),
  },
  [2248] = {
    [sym_do_group] = STATE(2398),
    [sym_compound_statement] = STATE(2398),
    [anon_sym_do] = ACTIONS(493),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [2249] = {
    [sym__concat] = ACTIONS(4687),
    [anon_sym_SEMI] = ACTIONS(4689),
    [anon_sym_SEMI_SEMI] = ACTIONS(4687),
    [sym__special_characters] = ACTIONS(4687),
    [anon_sym_DQUOTE] = ACTIONS(4687),
    [anon_sym_DOLLAR] = ACTIONS(4689),
    [sym_raw_string] = ACTIONS(4687),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4687),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4687),
    [anon_sym_BQUOTE] = ACTIONS(4687),
    [anon_sym_LT_LPAREN] = ACTIONS(4687),
    [anon_sym_GT_LPAREN] = ACTIONS(4687),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4689),
    [anon_sym_LF] = ACTIONS(4687),
    [anon_sym_AMP] = ACTIONS(4687),
  },
  [2250] = {
    [sym__concat] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4693),
    [anon_sym_SEMI_SEMI] = ACTIONS(4691),
    [sym__special_characters] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4693),
    [sym_raw_string] = ACTIONS(4691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4691),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_LT_LPAREN] = ACTIONS(4691),
    [anon_sym_GT_LPAREN] = ACTIONS(4691),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4693),
    [anon_sym_LF] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4691),
  },
  [2251] = {
    [sym__concat] = ACTIONS(4695),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_SEMI_SEMI] = ACTIONS(4695),
    [sym__special_characters] = ACTIONS(4695),
    [anon_sym_DQUOTE] = ACTIONS(4695),
    [anon_sym_DOLLAR] = ACTIONS(4697),
    [sym_raw_string] = ACTIONS(4695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4695),
    [anon_sym_BQUOTE] = ACTIONS(4695),
    [anon_sym_LT_LPAREN] = ACTIONS(4695),
    [anon_sym_GT_LPAREN] = ACTIONS(4695),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4697),
    [anon_sym_LF] = ACTIONS(4695),
    [anon_sym_AMP] = ACTIONS(4695),
  },
  [2252] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5502),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2253] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5504),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2254] = {
    [sym__concat] = ACTIONS(4731),
    [anon_sym_SEMI] = ACTIONS(4733),
    [anon_sym_SEMI_SEMI] = ACTIONS(4731),
    [sym__special_characters] = ACTIONS(4731),
    [anon_sym_DQUOTE] = ACTIONS(4731),
    [anon_sym_DOLLAR] = ACTIONS(4733),
    [sym_raw_string] = ACTIONS(4731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4731),
    [anon_sym_BQUOTE] = ACTIONS(4731),
    [anon_sym_LT_LPAREN] = ACTIONS(4731),
    [anon_sym_GT_LPAREN] = ACTIONS(4731),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4733),
    [anon_sym_LF] = ACTIONS(4731),
    [anon_sym_AMP] = ACTIONS(4731),
  },
  [2255] = {
    [sym__concat] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4753),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [sym__special_characters] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4753),
    [sym_raw_string] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_LT_LPAREN] = ACTIONS(4751),
    [anon_sym_GT_LPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4753),
    [anon_sym_LF] = ACTIONS(4751),
    [anon_sym_AMP] = ACTIONS(4751),
  },
  [2256] = {
    [sym__concat] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4757),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4757),
    [sym_raw_string] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_LT_LPAREN] = ACTIONS(4755),
    [anon_sym_GT_LPAREN] = ACTIONS(4755),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4757),
    [anon_sym_LF] = ACTIONS(4755),
    [anon_sym_AMP] = ACTIONS(4755),
  },
  [2257] = {
    [sym__concat] = ACTIONS(5168),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_RPAREN] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_EQ_TILDE] = ACTIONS(5168),
    [anon_sym_EQ_EQ] = ACTIONS(5168),
    [anon_sym_EQ] = ACTIONS(5170),
    [anon_sym_PLUS_EQ] = ACTIONS(5168),
    [anon_sym_LT] = ACTIONS(5170),
    [anon_sym_GT] = ACTIONS(5170),
    [anon_sym_BANG_EQ] = ACTIONS(5168),
    [anon_sym_PLUS] = ACTIONS(5170),
    [anon_sym_DASH] = ACTIONS(5170),
    [anon_sym_DASH_EQ] = ACTIONS(5168),
    [anon_sym_LT_EQ] = ACTIONS(5168),
    [anon_sym_GT_EQ] = ACTIONS(5168),
    [anon_sym_PLUS_PLUS] = ACTIONS(5168),
    [anon_sym_DASH_DASH] = ACTIONS(5168),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5168),
  },
  [2258] = {
    [sym__concat] = ACTIONS(5172),
    [anon_sym_PIPE] = ACTIONS(5174),
    [anon_sym_RPAREN] = ACTIONS(5172),
    [anon_sym_AMP_AMP] = ACTIONS(5172),
    [anon_sym_PIPE_PIPE] = ACTIONS(5172),
    [anon_sym_EQ_TILDE] = ACTIONS(5172),
    [anon_sym_EQ_EQ] = ACTIONS(5172),
    [anon_sym_EQ] = ACTIONS(5174),
    [anon_sym_PLUS_EQ] = ACTIONS(5172),
    [anon_sym_LT] = ACTIONS(5174),
    [anon_sym_GT] = ACTIONS(5174),
    [anon_sym_BANG_EQ] = ACTIONS(5172),
    [anon_sym_PLUS] = ACTIONS(5174),
    [anon_sym_DASH] = ACTIONS(5174),
    [anon_sym_DASH_EQ] = ACTIONS(5172),
    [anon_sym_LT_EQ] = ACTIONS(5172),
    [anon_sym_GT_EQ] = ACTIONS(5172),
    [anon_sym_PLUS_PLUS] = ACTIONS(5172),
    [anon_sym_DASH_DASH] = ACTIONS(5172),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5172),
  },
  [2259] = {
    [sym__simple_heredoc_body] = ACTIONS(1085),
    [sym__heredoc_body_beginning] = ACTIONS(1085),
    [sym_file_descriptor] = ACTIONS(1085),
    [sym_variable_name] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(1087),
    [anon_sym_esac] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1087),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym__special_characters] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_DOLLAR] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1085),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [anon_sym_LT_LPAREN] = ACTIONS(1085),
    [anon_sym_GT_LPAREN] = ACTIONS(1085),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1087),
    [anon_sym_LF] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1087),
  },
  [2260] = {
    [sym_concatenation] = STATE(2402),
    [sym_string] = STATE(537),
    [sym_simple_expansion] = STATE(537),
    [sym_string_expansion] = STATE(537),
    [sym_expansion] = STATE(537),
    [sym_command_substitution] = STATE(537),
    [sym_process_substitution] = STATE(537),
    [aux_sym_for_statement_repeat1] = STATE(2402),
    [anon_sym_RPAREN] = ACTIONS(5506),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1095),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
  },
  [2261] = {
    [aux_sym_concatenation_repeat1] = STATE(2404),
    [sym__simple_heredoc_body] = ACTIONS(1107),
    [sym__heredoc_body_beginning] = ACTIONS(1107),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(5508),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_SEMI] = ACTIONS(1111),
    [anon_sym_esac] = ACTIONS(1111),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_SEMI_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT] = ACTIONS(1111),
    [anon_sym_AMP_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_AMP] = ACTIONS(1107),
    [anon_sym_GT_AMP] = ACTIONS(1107),
    [anon_sym_LT_LT] = ACTIONS(1111),
    [anon_sym_LT_LT_DASH] = ACTIONS(1107),
    [anon_sym_LT_LT_LT] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1111),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1111),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1111),
  },
  [2262] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(2407),
    [anon_sym_DQUOTE] = ACTIONS(5510),
    [anon_sym_DOLLAR] = ACTIONS(5512),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [2263] = {
    [sym_string] = STATE(2409),
    [anon_sym_DASH] = ACTIONS(5514),
    [anon_sym_DQUOTE] = ACTIONS(5276),
    [anon_sym_DOLLAR] = ACTIONS(5514),
    [sym_raw_string] = ACTIONS(5516),
    [anon_sym_POUND] = ACTIONS(5514),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5518),
    [anon_sym_STAR] = ACTIONS(5520),
    [anon_sym_AT] = ACTIONS(5520),
    [anon_sym_QMARK] = ACTIONS(5520),
    [anon_sym_0] = ACTIONS(5518),
    [anon_sym__] = ACTIONS(5518),
  },
  [2264] = {
    [aux_sym_concatenation_repeat1] = STATE(2404),
    [sym__simple_heredoc_body] = ACTIONS(1085),
    [sym__heredoc_body_beginning] = ACTIONS(1085),
    [sym_file_descriptor] = ACTIONS(1085),
    [sym__concat] = ACTIONS(5508),
    [sym_variable_name] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(1087),
    [anon_sym_esac] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1087),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym__special_characters] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_DOLLAR] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1085),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [anon_sym_LT_LPAREN] = ACTIONS(1085),
    [anon_sym_GT_LPAREN] = ACTIONS(1085),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1087),
    [anon_sym_LF] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1087),
  },
  [2265] = {
    [sym_subscript] = STATE(2414),
    [sym_variable_name] = ACTIONS(5522),
    [anon_sym_BANG] = ACTIONS(5524),
    [anon_sym_DASH] = ACTIONS(5526),
    [anon_sym_DOLLAR] = ACTIONS(5526),
    [anon_sym_POUND] = ACTIONS(5524),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5530),
    [anon_sym_AT] = ACTIONS(5530),
    [anon_sym_QMARK] = ACTIONS(5530),
    [anon_sym_0] = ACTIONS(5528),
    [anon_sym__] = ACTIONS(5528),
  },
  [2266] = {
    [sym__terminated_statement] = STATE(2417),
    [sym_redirected_statement] = STATE(2415),
    [sym_for_statement] = STATE(2415),
    [sym_c_style_for_statement] = STATE(2415),
    [sym_while_statement] = STATE(2415),
    [sym_if_statement] = STATE(2415),
    [sym_case_statement] = STATE(2415),
    [sym_function_definition] = STATE(2415),
    [sym_compound_statement] = STATE(2415),
    [sym_subshell] = STATE(2415),
    [sym_pipeline] = STATE(2415),
    [sym_list] = STATE(2415),
    [sym_negated_command] = STATE(2415),
    [sym_test_command] = STATE(2415),
    [sym_declaration_command] = STATE(2415),
    [sym_unset_command] = STATE(2415),
    [sym_command] = STATE(2415),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2416),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(2417),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [2267] = {
    [sym__terminated_statement] = STATE(2420),
    [sym_redirected_statement] = STATE(2418),
    [sym_for_statement] = STATE(2418),
    [sym_c_style_for_statement] = STATE(2418),
    [sym_while_statement] = STATE(2418),
    [sym_if_statement] = STATE(2418),
    [sym_case_statement] = STATE(2418),
    [sym_function_definition] = STATE(2418),
    [sym_compound_statement] = STATE(2418),
    [sym_subshell] = STATE(2418),
    [sym_pipeline] = STATE(2418),
    [sym_list] = STATE(2418),
    [sym_negated_command] = STATE(2418),
    [sym_test_command] = STATE(2418),
    [sym_declaration_command] = STATE(2418),
    [sym_unset_command] = STATE(2418),
    [sym_command] = STATE(2418),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(2419),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(2420),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [2268] = {
    [sym__terminated_statement] = STATE(2423),
    [sym_redirected_statement] = STATE(2421),
    [sym_for_statement] = STATE(2421),
    [sym_c_style_for_statement] = STATE(2421),
    [sym_while_statement] = STATE(2421),
    [sym_if_statement] = STATE(2421),
    [sym_case_statement] = STATE(2421),
    [sym_function_definition] = STATE(2421),
    [sym_compound_statement] = STATE(2421),
    [sym_subshell] = STATE(2421),
    [sym_pipeline] = STATE(2421),
    [sym_list] = STATE(2421),
    [sym_negated_command] = STATE(2421),
    [sym_test_command] = STATE(2421),
    [sym_declaration_command] = STATE(2421),
    [sym_unset_command] = STATE(2421),
    [sym_command] = STATE(2421),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2422),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(2423),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [2269] = {
    [sym_concatenation] = STATE(2424),
    [sym_string] = STATE(2427),
    [sym_array] = STATE(2424),
    [sym_simple_expansion] = STATE(2427),
    [sym_string_expansion] = STATE(2427),
    [sym_expansion] = STATE(2427),
    [sym_command_substitution] = STATE(2427),
    [sym_process_substitution] = STATE(2427),
    [sym__empty_value] = ACTIONS(5532),
    [anon_sym_LPAREN] = ACTIONS(5534),
    [sym__special_characters] = ACTIONS(5536),
    [anon_sym_DQUOTE] = ACTIONS(4969),
    [anon_sym_DOLLAR] = ACTIONS(4971),
    [sym_raw_string] = ACTIONS(5538),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4975),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4977),
    [anon_sym_BQUOTE] = ACTIONS(4979),
    [anon_sym_LT_LPAREN] = ACTIONS(4981),
    [anon_sym_GT_LPAREN] = ACTIONS(4981),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5538),
  },
  [2270] = {
    [sym_string] = STATE(2428),
    [sym_simple_expansion] = STATE(2428),
    [sym_string_expansion] = STATE(2428),
    [sym_expansion] = STATE(2428),
    [sym_command_substitution] = STATE(2428),
    [sym_process_substitution] = STATE(2428),
    [sym__special_characters] = ACTIONS(5540),
    [anon_sym_DQUOTE] = ACTIONS(4969),
    [anon_sym_DOLLAR] = ACTIONS(4971),
    [sym_raw_string] = ACTIONS(5540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4975),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4977),
    [anon_sym_BQUOTE] = ACTIONS(4979),
    [anon_sym_LT_LPAREN] = ACTIONS(4981),
    [anon_sym_GT_LPAREN] = ACTIONS(4981),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5540),
  },
  [2271] = {
    [aux_sym_concatenation_repeat1] = STATE(2429),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(5292),
    [sym_variable_name] = ACTIONS(779),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_esac] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [sym_word] = ACTIONS(781),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [2272] = {
    [sym__simple_heredoc_body] = ACTIONS(783),
    [sym__heredoc_body_beginning] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(783),
    [sym__concat] = ACTIONS(783),
    [sym_variable_name] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_esac] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [anon_sym_PIPE_AMP] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(783),
    [anon_sym_AMP_GT] = ACTIONS(785),
    [anon_sym_AMP_GT_GT] = ACTIONS(783),
    [anon_sym_LT_AMP] = ACTIONS(783),
    [anon_sym_GT_AMP] = ACTIONS(783),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_DASH] = ACTIONS(783),
    [anon_sym_LT_LT_LT] = ACTIONS(783),
    [sym__special_characters] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(783),
    [anon_sym_DOLLAR] = ACTIONS(785),
    [sym_raw_string] = ACTIONS(783),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(783),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(783),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [anon_sym_LT_LPAREN] = ACTIONS(783),
    [anon_sym_GT_LPAREN] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(785),
    [sym_word] = ACTIONS(785),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
  },
  [2273] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [2274] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5544),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [2275] = {
    [sym__simple_heredoc_body] = ACTIONS(817),
    [sym__heredoc_body_beginning] = ACTIONS(817),
    [sym_file_descriptor] = ACTIONS(817),
    [sym__concat] = ACTIONS(817),
    [sym_variable_name] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(819),
    [anon_sym_esac] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(819),
    [anon_sym_SEMI_SEMI] = ACTIONS(817),
    [anon_sym_PIPE_AMP] = ACTIONS(817),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(817),
    [anon_sym_AMP_GT] = ACTIONS(819),
    [anon_sym_AMP_GT_GT] = ACTIONS(817),
    [anon_sym_LT_AMP] = ACTIONS(817),
    [anon_sym_GT_AMP] = ACTIONS(817),
    [anon_sym_LT_LT] = ACTIONS(819),
    [anon_sym_LT_LT_DASH] = ACTIONS(817),
    [anon_sym_LT_LT_LT] = ACTIONS(817),
    [sym__special_characters] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR] = ACTIONS(819),
    [sym_raw_string] = ACTIONS(817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(817),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(817),
    [anon_sym_GT_LPAREN] = ACTIONS(817),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(819),
    [sym_word] = ACTIONS(819),
    [anon_sym_LF] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(819),
  },
  [2276] = {
    [sym__simple_heredoc_body] = ACTIONS(821),
    [sym__heredoc_body_beginning] = ACTIONS(821),
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [sym_variable_name] = ACTIONS(821),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_esac] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(823),
    [anon_sym_SEMI_SEMI] = ACTIONS(821),
    [anon_sym_PIPE_AMP] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(823),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(823),
    [anon_sym_LT_LT_DASH] = ACTIONS(821),
    [anon_sym_LT_LT_LT] = ACTIONS(821),
    [sym__special_characters] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [anon_sym_DOLLAR] = ACTIONS(823),
    [sym_raw_string] = ACTIONS(821),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(821),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(821),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(821),
    [anon_sym_GT_LPAREN] = ACTIONS(821),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(823),
    [sym_word] = ACTIONS(823),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [2277] = {
    [sym__simple_heredoc_body] = ACTIONS(825),
    [sym__heredoc_body_beginning] = ACTIONS(825),
    [sym_file_descriptor] = ACTIONS(825),
    [sym__concat] = ACTIONS(825),
    [sym_variable_name] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(827),
    [anon_sym_esac] = ACTIONS(827),
    [anon_sym_PIPE] = ACTIONS(827),
    [anon_sym_SEMI_SEMI] = ACTIONS(825),
    [anon_sym_PIPE_AMP] = ACTIONS(825),
    [anon_sym_AMP_AMP] = ACTIONS(825),
    [anon_sym_PIPE_PIPE] = ACTIONS(825),
    [anon_sym_LT] = ACTIONS(827),
    [anon_sym_GT] = ACTIONS(827),
    [anon_sym_GT_GT] = ACTIONS(825),
    [anon_sym_AMP_GT] = ACTIONS(827),
    [anon_sym_AMP_GT_GT] = ACTIONS(825),
    [anon_sym_LT_AMP] = ACTIONS(825),
    [anon_sym_GT_AMP] = ACTIONS(825),
    [anon_sym_LT_LT] = ACTIONS(827),
    [anon_sym_LT_LT_DASH] = ACTIONS(825),
    [anon_sym_LT_LT_LT] = ACTIONS(825),
    [sym__special_characters] = ACTIONS(825),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [sym_raw_string] = ACTIONS(825),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(825),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(825),
    [anon_sym_BQUOTE] = ACTIONS(825),
    [anon_sym_LT_LPAREN] = ACTIONS(825),
    [anon_sym_GT_LPAREN] = ACTIONS(825),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(827),
    [sym_word] = ACTIONS(827),
    [anon_sym_LF] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(827),
  },
  [2278] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(5546),
    [sym_comment] = ACTIONS(57),
  },
  [2279] = {
    [sym_subscript] = STATE(2435),
    [sym_variable_name] = ACTIONS(5548),
    [anon_sym_DASH] = ACTIONS(5550),
    [anon_sym_DOLLAR] = ACTIONS(5550),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5552),
    [anon_sym_STAR] = ACTIONS(5554),
    [anon_sym_AT] = ACTIONS(5554),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_0] = ACTIONS(5552),
    [anon_sym__] = ACTIONS(5552),
  },
  [2280] = {
    [sym_concatenation] = STATE(2438),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2438),
    [anon_sym_RBRACE] = ACTIONS(5556),
    [anon_sym_EQ] = ACTIONS(5558),
    [anon_sym_DASH] = ACTIONS(5558),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5560),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(5562),
    [anon_sym_COLON] = ACTIONS(5558),
    [anon_sym_COLON_QMARK] = ACTIONS(5558),
    [anon_sym_COLON_DASH] = ACTIONS(5558),
    [anon_sym_PERCENT] = ACTIONS(5558),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2281] = {
    [sym_concatenation] = STATE(2441),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2441),
    [anon_sym_RBRACE] = ACTIONS(5564),
    [anon_sym_EQ] = ACTIONS(5566),
    [anon_sym_DASH] = ACTIONS(5566),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(5570),
    [anon_sym_COLON] = ACTIONS(5566),
    [anon_sym_COLON_QMARK] = ACTIONS(5566),
    [anon_sym_COLON_DASH] = ACTIONS(5566),
    [anon_sym_PERCENT] = ACTIONS(5566),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2282] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2444),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(5572),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5574),
    [anon_sym_SEMI_SEMI] = ACTIONS(5576),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5576),
    [anon_sym_AMP] = ACTIONS(5572),
  },
  [2283] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2444),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5572),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5574),
    [anon_sym_SEMI_SEMI] = ACTIONS(5576),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5576),
    [anon_sym_AMP] = ACTIONS(5572),
  },
  [2284] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(2445),
    [sym_for_statement] = STATE(2445),
    [sym_c_style_for_statement] = STATE(2445),
    [sym_while_statement] = STATE(2445),
    [sym_if_statement] = STATE(2445),
    [sym_case_statement] = STATE(2445),
    [sym_function_definition] = STATE(2445),
    [sym_compound_statement] = STATE(2445),
    [sym_subshell] = STATE(2445),
    [sym_pipeline] = STATE(2445),
    [sym_list] = STATE(2445),
    [sym_negated_command] = STATE(2445),
    [sym_test_command] = STATE(2445),
    [sym_declaration_command] = STATE(2445),
    [sym_unset_command] = STATE(2445),
    [sym_command] = STATE(2445),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2446),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [2285] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2448),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(5578),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(5580),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(5574),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5580),
    [anon_sym_AMP] = ACTIONS(5578),
  },
  [2286] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2448),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5578),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(5580),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(5574),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5580),
    [anon_sym_AMP] = ACTIONS(5578),
  },
  [2287] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(2449),
    [sym_for_statement] = STATE(2449),
    [sym_c_style_for_statement] = STATE(2449),
    [sym_while_statement] = STATE(2449),
    [sym_if_statement] = STATE(2449),
    [sym_case_statement] = STATE(2449),
    [sym_function_definition] = STATE(2449),
    [sym_compound_statement] = STATE(2449),
    [sym_subshell] = STATE(2449),
    [sym_pipeline] = STATE(2449),
    [sym_list] = STATE(2449),
    [sym_negated_command] = STATE(2449),
    [sym_test_command] = STATE(2449),
    [sym_declaration_command] = STATE(2449),
    [sym_unset_command] = STATE(2449),
    [sym_command] = STATE(2449),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(2450),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [2288] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2453),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(5582),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5584),
    [anon_sym_SEMI_SEMI] = ACTIONS(5586),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5586),
    [anon_sym_AMP] = ACTIONS(5582),
  },
  [2289] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2453),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5582),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5584),
    [anon_sym_SEMI_SEMI] = ACTIONS(5586),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5586),
    [anon_sym_AMP] = ACTIONS(5582),
  },
  [2290] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(2454),
    [sym_for_statement] = STATE(2454),
    [sym_c_style_for_statement] = STATE(2454),
    [sym_while_statement] = STATE(2454),
    [sym_if_statement] = STATE(2454),
    [sym_case_statement] = STATE(2454),
    [sym_function_definition] = STATE(2454),
    [sym_compound_statement] = STATE(2454),
    [sym_subshell] = STATE(2454),
    [sym_pipeline] = STATE(2454),
    [sym_list] = STATE(2454),
    [sym_negated_command] = STATE(2454),
    [sym_test_command] = STATE(2454),
    [sym_declaration_command] = STATE(2454),
    [sym_unset_command] = STATE(2454),
    [sym_command] = STATE(2454),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2455),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [2291] = {
    [sym_variable_assignment] = STATE(2291),
    [sym_subscript] = STATE(2130),
    [sym_concatenation] = STATE(2291),
    [sym_string] = STATE(2125),
    [sym_simple_expansion] = STATE(2125),
    [sym_string_expansion] = STATE(2125),
    [sym_expansion] = STATE(2125),
    [sym_command_substitution] = STATE(2125),
    [sym_process_substitution] = STATE(2125),
    [aux_sym_declaration_command_repeat1] = STATE(2291),
    [sym__simple_heredoc_body] = ACTIONS(1559),
    [sym__heredoc_body_beginning] = ACTIONS(1559),
    [sym_file_descriptor] = ACTIONS(1559),
    [sym_variable_name] = ACTIONS(5588),
    [anon_sym_SEMI] = ACTIONS(1564),
    [anon_sym_esac] = ACTIONS(1564),
    [anon_sym_PIPE] = ACTIONS(1564),
    [anon_sym_SEMI_SEMI] = ACTIONS(1559),
    [anon_sym_PIPE_AMP] = ACTIONS(1559),
    [anon_sym_AMP_AMP] = ACTIONS(1559),
    [anon_sym_PIPE_PIPE] = ACTIONS(1559),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1564),
    [anon_sym_GT_GT] = ACTIONS(1559),
    [anon_sym_AMP_GT] = ACTIONS(1564),
    [anon_sym_AMP_GT_GT] = ACTIONS(1559),
    [anon_sym_LT_AMP] = ACTIONS(1559),
    [anon_sym_GT_AMP] = ACTIONS(1559),
    [anon_sym_LT_LT] = ACTIONS(1564),
    [anon_sym_LT_LT_DASH] = ACTIONS(1559),
    [anon_sym_LT_LT_LT] = ACTIONS(1559),
    [sym__special_characters] = ACTIONS(5591),
    [anon_sym_DQUOTE] = ACTIONS(5594),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5603),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5606),
    [anon_sym_BQUOTE] = ACTIONS(5609),
    [anon_sym_LT_LPAREN] = ACTIONS(5612),
    [anon_sym_GT_LPAREN] = ACTIONS(5612),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5615),
    [sym_word] = ACTIONS(5618),
    [anon_sym_LF] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1564),
  },
  [2292] = {
    [sym_string] = STATE(2456),
    [sym_simple_expansion] = STATE(2456),
    [sym_string_expansion] = STATE(2456),
    [sym_expansion] = STATE(2456),
    [sym_command_substitution] = STATE(2456),
    [sym_process_substitution] = STATE(2456),
    [sym__special_characters] = ACTIONS(5621),
    [anon_sym_DQUOTE] = ACTIONS(4989),
    [anon_sym_DOLLAR] = ACTIONS(4991),
    [sym_raw_string] = ACTIONS(5621),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4995),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4997),
    [anon_sym_BQUOTE] = ACTIONS(4999),
    [anon_sym_LT_LPAREN] = ACTIONS(5001),
    [anon_sym_GT_LPAREN] = ACTIONS(5001),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5621),
  },
  [2293] = {
    [aux_sym_concatenation_repeat1] = STATE(2457),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(5318),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_esac] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [sym_word] = ACTIONS(781),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [2294] = {
    [sym__simple_heredoc_body] = ACTIONS(783),
    [sym__heredoc_body_beginning] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(783),
    [sym__concat] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_esac] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [anon_sym_PIPE_AMP] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(783),
    [anon_sym_AMP_GT] = ACTIONS(785),
    [anon_sym_AMP_GT_GT] = ACTIONS(783),
    [anon_sym_LT_AMP] = ACTIONS(783),
    [anon_sym_GT_AMP] = ACTIONS(783),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_DASH] = ACTIONS(783),
    [anon_sym_LT_LT_LT] = ACTIONS(783),
    [sym__special_characters] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(783),
    [anon_sym_DOLLAR] = ACTIONS(785),
    [sym_raw_string] = ACTIONS(783),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(783),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(783),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [anon_sym_LT_LPAREN] = ACTIONS(783),
    [anon_sym_GT_LPAREN] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(785),
    [sym_word] = ACTIONS(785),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
  },
  [2295] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(5623),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [2296] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(5623),
    [anon_sym_DOLLAR] = ACTIONS(5625),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [2297] = {
    [sym__simple_heredoc_body] = ACTIONS(817),
    [sym__heredoc_body_beginning] = ACTIONS(817),
    [sym_file_descriptor] = ACTIONS(817),
    [sym__concat] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(819),
    [anon_sym_esac] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(819),
    [anon_sym_SEMI_SEMI] = ACTIONS(817),
    [anon_sym_PIPE_AMP] = ACTIONS(817),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(817),
    [anon_sym_AMP_GT] = ACTIONS(819),
    [anon_sym_AMP_GT_GT] = ACTIONS(817),
    [anon_sym_LT_AMP] = ACTIONS(817),
    [anon_sym_GT_AMP] = ACTIONS(817),
    [anon_sym_LT_LT] = ACTIONS(819),
    [anon_sym_LT_LT_DASH] = ACTIONS(817),
    [anon_sym_LT_LT_LT] = ACTIONS(817),
    [sym__special_characters] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR] = ACTIONS(819),
    [sym_raw_string] = ACTIONS(817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(817),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(817),
    [anon_sym_GT_LPAREN] = ACTIONS(817),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(819),
    [sym_word] = ACTIONS(819),
    [anon_sym_LF] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(819),
  },
  [2298] = {
    [sym__simple_heredoc_body] = ACTIONS(821),
    [sym__heredoc_body_beginning] = ACTIONS(821),
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_esac] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(823),
    [anon_sym_SEMI_SEMI] = ACTIONS(821),
    [anon_sym_PIPE_AMP] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(823),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(823),
    [anon_sym_LT_LT_DASH] = ACTIONS(821),
    [anon_sym_LT_LT_LT] = ACTIONS(821),
    [sym__special_characters] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [anon_sym_DOLLAR] = ACTIONS(823),
    [sym_raw_string] = ACTIONS(821),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(821),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(821),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(821),
    [anon_sym_GT_LPAREN] = ACTIONS(821),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(823),
    [sym_word] = ACTIONS(823),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [2299] = {
    [sym__simple_heredoc_body] = ACTIONS(825),
    [sym__heredoc_body_beginning] = ACTIONS(825),
    [sym_file_descriptor] = ACTIONS(825),
    [sym__concat] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(827),
    [anon_sym_esac] = ACTIONS(827),
    [anon_sym_PIPE] = ACTIONS(827),
    [anon_sym_SEMI_SEMI] = ACTIONS(825),
    [anon_sym_PIPE_AMP] = ACTIONS(825),
    [anon_sym_AMP_AMP] = ACTIONS(825),
    [anon_sym_PIPE_PIPE] = ACTIONS(825),
    [anon_sym_LT] = ACTIONS(827),
    [anon_sym_GT] = ACTIONS(827),
    [anon_sym_GT_GT] = ACTIONS(825),
    [anon_sym_AMP_GT] = ACTIONS(827),
    [anon_sym_AMP_GT_GT] = ACTIONS(825),
    [anon_sym_LT_AMP] = ACTIONS(825),
    [anon_sym_GT_AMP] = ACTIONS(825),
    [anon_sym_LT_LT] = ACTIONS(827),
    [anon_sym_LT_LT_DASH] = ACTIONS(825),
    [anon_sym_LT_LT_LT] = ACTIONS(825),
    [sym__special_characters] = ACTIONS(825),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [sym_raw_string] = ACTIONS(825),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(825),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(825),
    [anon_sym_BQUOTE] = ACTIONS(825),
    [anon_sym_LT_LPAREN] = ACTIONS(825),
    [anon_sym_GT_LPAREN] = ACTIONS(825),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(827),
    [sym_word] = ACTIONS(827),
    [anon_sym_LF] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(827),
  },
  [2300] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(5627),
    [sym_comment] = ACTIONS(57),
  },
  [2301] = {
    [sym_subscript] = STATE(2463),
    [sym_variable_name] = ACTIONS(5629),
    [anon_sym_DASH] = ACTIONS(5631),
    [anon_sym_DOLLAR] = ACTIONS(5631),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_AT] = ACTIONS(5635),
    [anon_sym_QMARK] = ACTIONS(5635),
    [anon_sym_0] = ACTIONS(5633),
    [anon_sym__] = ACTIONS(5633),
  },
  [2302] = {
    [sym_concatenation] = STATE(2466),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2466),
    [anon_sym_RBRACE] = ACTIONS(5637),
    [anon_sym_EQ] = ACTIONS(5639),
    [anon_sym_DASH] = ACTIONS(5639),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5641),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(5643),
    [anon_sym_COLON] = ACTIONS(5639),
    [anon_sym_COLON_QMARK] = ACTIONS(5639),
    [anon_sym_COLON_DASH] = ACTIONS(5639),
    [anon_sym_PERCENT] = ACTIONS(5639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2303] = {
    [sym_concatenation] = STATE(2469),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2469),
    [anon_sym_RBRACE] = ACTIONS(5645),
    [anon_sym_EQ] = ACTIONS(5647),
    [anon_sym_DASH] = ACTIONS(5647),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5649),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(5651),
    [anon_sym_COLON] = ACTIONS(5647),
    [anon_sym_COLON_QMARK] = ACTIONS(5647),
    [anon_sym_COLON_DASH] = ACTIONS(5647),
    [anon_sym_PERCENT] = ACTIONS(5647),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2304] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2472),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(5653),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5655),
    [anon_sym_SEMI_SEMI] = ACTIONS(5657),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5657),
    [anon_sym_AMP] = ACTIONS(5653),
  },
  [2305] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2472),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5653),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5655),
    [anon_sym_SEMI_SEMI] = ACTIONS(5657),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5657),
    [anon_sym_AMP] = ACTIONS(5653),
  },
  [2306] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(2473),
    [sym_for_statement] = STATE(2473),
    [sym_c_style_for_statement] = STATE(2473),
    [sym_while_statement] = STATE(2473),
    [sym_if_statement] = STATE(2473),
    [sym_case_statement] = STATE(2473),
    [sym_function_definition] = STATE(2473),
    [sym_compound_statement] = STATE(2473),
    [sym_subshell] = STATE(2473),
    [sym_pipeline] = STATE(2473),
    [sym_list] = STATE(2473),
    [sym_negated_command] = STATE(2473),
    [sym_test_command] = STATE(2473),
    [sym_declaration_command] = STATE(2473),
    [sym_unset_command] = STATE(2473),
    [sym_command] = STATE(2473),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2474),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [2307] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2476),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(5661),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(5655),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5661),
    [anon_sym_AMP] = ACTIONS(5659),
  },
  [2308] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2476),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(5661),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(5655),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5661),
    [anon_sym_AMP] = ACTIONS(5659),
  },
  [2309] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(2477),
    [sym_for_statement] = STATE(2477),
    [sym_c_style_for_statement] = STATE(2477),
    [sym_while_statement] = STATE(2477),
    [sym_if_statement] = STATE(2477),
    [sym_case_statement] = STATE(2477),
    [sym_function_definition] = STATE(2477),
    [sym_compound_statement] = STATE(2477),
    [sym_subshell] = STATE(2477),
    [sym_pipeline] = STATE(2477),
    [sym_list] = STATE(2477),
    [sym_negated_command] = STATE(2477),
    [sym_test_command] = STATE(2477),
    [sym_declaration_command] = STATE(2477),
    [sym_unset_command] = STATE(2477),
    [sym_command] = STATE(2477),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(2478),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [2310] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2481),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(5663),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5665),
    [anon_sym_SEMI_SEMI] = ACTIONS(5667),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5667),
    [anon_sym_AMP] = ACTIONS(5663),
  },
  [2311] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2481),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5663),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5665),
    [anon_sym_SEMI_SEMI] = ACTIONS(5667),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5667),
    [anon_sym_AMP] = ACTIONS(5663),
  },
  [2312] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(2482),
    [sym_for_statement] = STATE(2482),
    [sym_c_style_for_statement] = STATE(2482),
    [sym_while_statement] = STATE(2482),
    [sym_if_statement] = STATE(2482),
    [sym_case_statement] = STATE(2482),
    [sym_function_definition] = STATE(2482),
    [sym_compound_statement] = STATE(2482),
    [sym_subshell] = STATE(2482),
    [sym_pipeline] = STATE(2482),
    [sym_list] = STATE(2482),
    [sym_negated_command] = STATE(2482),
    [sym_test_command] = STATE(2482),
    [sym_declaration_command] = STATE(2482),
    [sym_unset_command] = STATE(2482),
    [sym_command] = STATE(2482),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2483),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [2313] = {
    [sym_concatenation] = STATE(2313),
    [sym_string] = STATE(2135),
    [sym_simple_expansion] = STATE(2135),
    [sym_string_expansion] = STATE(2135),
    [sym_expansion] = STATE(2135),
    [sym_command_substitution] = STATE(2135),
    [sym_process_substitution] = STATE(2135),
    [aux_sym_unset_command_repeat1] = STATE(2313),
    [sym__simple_heredoc_body] = ACTIONS(1644),
    [sym__heredoc_body_beginning] = ACTIONS(1644),
    [sym_file_descriptor] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1646),
    [anon_sym_esac] = ACTIONS(1646),
    [anon_sym_PIPE] = ACTIONS(1646),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1646),
    [anon_sym_GT] = ACTIONS(1646),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1646),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1644),
    [anon_sym_LT_LT_LT] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(5669),
    [anon_sym_DQUOTE] = ACTIONS(5672),
    [anon_sym_DOLLAR] = ACTIONS(5675),
    [sym_raw_string] = ACTIONS(5678),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5684),
    [anon_sym_BQUOTE] = ACTIONS(5687),
    [anon_sym_LT_LPAREN] = ACTIONS(5690),
    [anon_sym_GT_LPAREN] = ACTIONS(5690),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5693),
    [sym_word] = ACTIONS(5696),
    [anon_sym_LF] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1646),
  },
  [2314] = {
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_esac] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_EQ_TILDE] = ACTIONS(1728),
    [anon_sym_EQ_EQ] = ACTIONS(1728),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [2315] = {
    [aux_sym_concatenation_repeat1] = STATE(2315),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(5699),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_esac] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_EQ_TILDE] = ACTIONS(1728),
    [anon_sym_EQ_EQ] = ACTIONS(1728),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [2316] = {
    [sym__simple_heredoc_body] = ACTIONS(1733),
    [sym__heredoc_body_beginning] = ACTIONS(1733),
    [sym_file_descriptor] = ACTIONS(1733),
    [sym__concat] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_esac] = ACTIONS(1735),
    [anon_sym_PIPE] = ACTIONS(1735),
    [anon_sym_SEMI_SEMI] = ACTIONS(1733),
    [anon_sym_PIPE_AMP] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1733),
    [anon_sym_EQ_TILDE] = ACTIONS(1735),
    [anon_sym_EQ_EQ] = ACTIONS(1735),
    [anon_sym_LT] = ACTIONS(1735),
    [anon_sym_GT] = ACTIONS(1735),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_AMP_GT] = ACTIONS(1735),
    [anon_sym_AMP_GT_GT] = ACTIONS(1733),
    [anon_sym_LT_AMP] = ACTIONS(1733),
    [anon_sym_GT_AMP] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1735),
    [anon_sym_LT_LT_DASH] = ACTIONS(1733),
    [anon_sym_LT_LT_LT] = ACTIONS(1733),
    [sym__special_characters] = ACTIONS(1733),
    [anon_sym_DQUOTE] = ACTIONS(1733),
    [anon_sym_DOLLAR] = ACTIONS(1735),
    [sym_raw_string] = ACTIONS(1733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1733),
    [anon_sym_BQUOTE] = ACTIONS(1733),
    [anon_sym_LT_LPAREN] = ACTIONS(1733),
    [anon_sym_GT_LPAREN] = ACTIONS(1733),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1735),
    [anon_sym_LF] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1735),
  },
  [2317] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(5702),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [2318] = {
    [sym_concatenation] = STATE(2488),
    [sym_string] = STATE(2487),
    [sym_simple_expansion] = STATE(2487),
    [sym_string_expansion] = STATE(2487),
    [sym_expansion] = STATE(2487),
    [sym_command_substitution] = STATE(2487),
    [sym_process_substitution] = STATE(2487),
    [anon_sym_RBRACE] = ACTIONS(5704),
    [sym__special_characters] = ACTIONS(5706),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5708),
  },
  [2319] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(5710),
    [sym_comment] = ACTIONS(57),
  },
  [2320] = {
    [sym_concatenation] = STATE(2492),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2492),
    [anon_sym_RBRACE] = ACTIONS(5712),
    [anon_sym_EQ] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5714),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5716),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(5718),
    [anon_sym_COLON] = ACTIONS(5714),
    [anon_sym_COLON_QMARK] = ACTIONS(5714),
    [anon_sym_COLON_DASH] = ACTIONS(5714),
    [anon_sym_PERCENT] = ACTIONS(5714),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2321] = {
    [sym_concatenation] = STATE(2494),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2494),
    [anon_sym_RBRACE] = ACTIONS(5704),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_DASH] = ACTIONS(5720),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(5724),
    [anon_sym_COLON] = ACTIONS(5720),
    [anon_sym_COLON_QMARK] = ACTIONS(5720),
    [anon_sym_COLON_DASH] = ACTIONS(5720),
    [anon_sym_PERCENT] = ACTIONS(5720),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2322] = {
    [sym__simple_heredoc_body] = ACTIONS(1834),
    [sym__heredoc_body_beginning] = ACTIONS(1834),
    [sym_file_descriptor] = ACTIONS(1834),
    [sym__concat] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1836),
    [anon_sym_esac] = ACTIONS(1836),
    [anon_sym_PIPE] = ACTIONS(1836),
    [anon_sym_SEMI_SEMI] = ACTIONS(1834),
    [anon_sym_PIPE_AMP] = ACTIONS(1834),
    [anon_sym_AMP_AMP] = ACTIONS(1834),
    [anon_sym_PIPE_PIPE] = ACTIONS(1834),
    [anon_sym_EQ_TILDE] = ACTIONS(1836),
    [anon_sym_EQ_EQ] = ACTIONS(1836),
    [anon_sym_LT] = ACTIONS(1836),
    [anon_sym_GT] = ACTIONS(1836),
    [anon_sym_GT_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT] = ACTIONS(1836),
    [anon_sym_AMP_GT_GT] = ACTIONS(1834),
    [anon_sym_LT_AMP] = ACTIONS(1834),
    [anon_sym_GT_AMP] = ACTIONS(1834),
    [anon_sym_LT_LT] = ACTIONS(1836),
    [anon_sym_LT_LT_DASH] = ACTIONS(1834),
    [anon_sym_LT_LT_LT] = ACTIONS(1834),
    [sym__special_characters] = ACTIONS(1834),
    [anon_sym_DQUOTE] = ACTIONS(1834),
    [anon_sym_DOLLAR] = ACTIONS(1836),
    [sym_raw_string] = ACTIONS(1834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1834),
    [anon_sym_BQUOTE] = ACTIONS(1834),
    [anon_sym_LT_LPAREN] = ACTIONS(1834),
    [anon_sym_GT_LPAREN] = ACTIONS(1834),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1836),
    [anon_sym_LF] = ACTIONS(1834),
    [anon_sym_AMP] = ACTIONS(1836),
  },
  [2323] = {
    [sym_concatenation] = STATE(2497),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2497),
    [sym_regex] = ACTIONS(5726),
    [anon_sym_RBRACE] = ACTIONS(5728),
    [anon_sym_EQ] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5730),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(5730),
    [anon_sym_COLON_QMARK] = ACTIONS(5730),
    [anon_sym_COLON_DASH] = ACTIONS(5730),
    [anon_sym_PERCENT] = ACTIONS(5730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2324] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5728),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2325] = {
    [sym__simple_heredoc_body] = ACTIONS(1882),
    [sym__heredoc_body_beginning] = ACTIONS(1882),
    [sym_file_descriptor] = ACTIONS(1882),
    [sym__concat] = ACTIONS(1882),
    [anon_sym_SEMI] = ACTIONS(1884),
    [anon_sym_esac] = ACTIONS(1884),
    [anon_sym_PIPE] = ACTIONS(1884),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [anon_sym_PIPE_AMP] = ACTIONS(1882),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_EQ_TILDE] = ACTIONS(1884),
    [anon_sym_EQ_EQ] = ACTIONS(1884),
    [anon_sym_LT] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1884),
    [anon_sym_GT_GT] = ACTIONS(1882),
    [anon_sym_AMP_GT] = ACTIONS(1884),
    [anon_sym_AMP_GT_GT] = ACTIONS(1882),
    [anon_sym_LT_AMP] = ACTIONS(1882),
    [anon_sym_GT_AMP] = ACTIONS(1882),
    [anon_sym_LT_LT] = ACTIONS(1884),
    [anon_sym_LT_LT_DASH] = ACTIONS(1882),
    [anon_sym_LT_LT_LT] = ACTIONS(1882),
    [sym__special_characters] = ACTIONS(1882),
    [anon_sym_DQUOTE] = ACTIONS(1882),
    [anon_sym_DOLLAR] = ACTIONS(1884),
    [sym_raw_string] = ACTIONS(1882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1882),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [anon_sym_LT_LPAREN] = ACTIONS(1882),
    [anon_sym_GT_LPAREN] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1884),
    [anon_sym_LF] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1884),
  },
  [2326] = {
    [sym_concatenation] = STATE(2494),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2494),
    [sym_regex] = ACTIONS(5734),
    [anon_sym_RBRACE] = ACTIONS(5704),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_DASH] = ACTIONS(5720),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(5720),
    [anon_sym_COLON_QMARK] = ACTIONS(5720),
    [anon_sym_COLON_DASH] = ACTIONS(5720),
    [anon_sym_PERCENT] = ACTIONS(5720),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2327] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5704),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2328] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(5736),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2329] = {
    [sym__simple_heredoc_body] = ACTIONS(1890),
    [sym__heredoc_body_beginning] = ACTIONS(1890),
    [sym_file_descriptor] = ACTIONS(1890),
    [sym__concat] = ACTIONS(1890),
    [anon_sym_SEMI] = ACTIONS(1892),
    [anon_sym_esac] = ACTIONS(1892),
    [anon_sym_PIPE] = ACTIONS(1892),
    [anon_sym_SEMI_SEMI] = ACTIONS(1890),
    [anon_sym_PIPE_AMP] = ACTIONS(1890),
    [anon_sym_AMP_AMP] = ACTIONS(1890),
    [anon_sym_PIPE_PIPE] = ACTIONS(1890),
    [anon_sym_EQ_TILDE] = ACTIONS(1892),
    [anon_sym_EQ_EQ] = ACTIONS(1892),
    [anon_sym_LT] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(1892),
    [anon_sym_GT_GT] = ACTIONS(1890),
    [anon_sym_AMP_GT] = ACTIONS(1892),
    [anon_sym_AMP_GT_GT] = ACTIONS(1890),
    [anon_sym_LT_AMP] = ACTIONS(1890),
    [anon_sym_GT_AMP] = ACTIONS(1890),
    [anon_sym_LT_LT] = ACTIONS(1892),
    [anon_sym_LT_LT_DASH] = ACTIONS(1890),
    [anon_sym_LT_LT_LT] = ACTIONS(1890),
    [sym__special_characters] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1890),
    [anon_sym_DOLLAR] = ACTIONS(1892),
    [sym_raw_string] = ACTIONS(1890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1890),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [anon_sym_LT_LPAREN] = ACTIONS(1890),
    [anon_sym_GT_LPAREN] = ACTIONS(1890),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1892),
    [anon_sym_LF] = ACTIONS(1890),
    [anon_sym_AMP] = ACTIONS(1892),
  },
  [2330] = {
    [anon_sym_SEMI] = ACTIONS(5738),
    [anon_sym_RPAREN] = ACTIONS(5736),
    [anon_sym_SEMI_SEMI] = ACTIONS(5740),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5740),
    [anon_sym_AMP] = ACTIONS(5740),
  },
  [2331] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2502),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(5742),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5736),
    [anon_sym_SEMI_SEMI] = ACTIONS(5744),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5744),
    [anon_sym_AMP] = ACTIONS(5742),
  },
  [2332] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2502),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5742),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5736),
    [anon_sym_SEMI_SEMI] = ACTIONS(5744),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5744),
    [anon_sym_AMP] = ACTIONS(5742),
  },
  [2333] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(5736),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2334] = {
    [anon_sym_SEMI] = ACTIONS(5746),
    [anon_sym_SEMI_SEMI] = ACTIONS(5748),
    [anon_sym_BQUOTE] = ACTIONS(5736),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5748),
    [anon_sym_AMP] = ACTIONS(5748),
  },
  [2335] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2505),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(5752),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(5736),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5750),
  },
  [2336] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2505),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(5752),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(5736),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5750),
  },
  [2337] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(5754),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2338] = {
    [sym__simple_heredoc_body] = ACTIONS(1924),
    [sym__heredoc_body_beginning] = ACTIONS(1924),
    [sym_file_descriptor] = ACTIONS(1924),
    [sym__concat] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_esac] = ACTIONS(1926),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [anon_sym_PIPE_AMP] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_EQ_TILDE] = ACTIONS(1926),
    [anon_sym_EQ_EQ] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_GT_GT] = ACTIONS(1924),
    [anon_sym_AMP_GT] = ACTIONS(1926),
    [anon_sym_AMP_GT_GT] = ACTIONS(1924),
    [anon_sym_LT_AMP] = ACTIONS(1924),
    [anon_sym_GT_AMP] = ACTIONS(1924),
    [anon_sym_LT_LT] = ACTIONS(1926),
    [anon_sym_LT_LT_DASH] = ACTIONS(1924),
    [anon_sym_LT_LT_LT] = ACTIONS(1924),
    [sym__special_characters] = ACTIONS(1924),
    [anon_sym_DQUOTE] = ACTIONS(1924),
    [anon_sym_DOLLAR] = ACTIONS(1926),
    [sym_raw_string] = ACTIONS(1924),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1924),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1924),
    [anon_sym_BQUOTE] = ACTIONS(1924),
    [anon_sym_LT_LPAREN] = ACTIONS(1924),
    [anon_sym_GT_LPAREN] = ACTIONS(1924),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1926),
    [anon_sym_LF] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1926),
  },
  [2339] = {
    [anon_sym_SEMI] = ACTIONS(5756),
    [anon_sym_RPAREN] = ACTIONS(5754),
    [anon_sym_SEMI_SEMI] = ACTIONS(5758),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5758),
    [anon_sym_AMP] = ACTIONS(5758),
  },
  [2340] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2509),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(5760),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5754),
    [anon_sym_SEMI_SEMI] = ACTIONS(5762),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5762),
    [anon_sym_AMP] = ACTIONS(5760),
  },
  [2341] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2509),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5760),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5754),
    [anon_sym_SEMI_SEMI] = ACTIONS(5762),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5762),
    [anon_sym_AMP] = ACTIONS(5760),
  },
  [2342] = {
    [sym_concatenation] = STATE(975),
    [sym_string] = STATE(2511),
    [sym_simple_expansion] = STATE(2511),
    [sym_string_expansion] = STATE(2511),
    [sym_expansion] = STATE(2511),
    [sym_command_substitution] = STATE(2511),
    [sym_process_substitution] = STATE(2511),
    [sym__special_characters] = ACTIONS(5764),
    [anon_sym_DQUOTE] = ACTIONS(5404),
    [anon_sym_DOLLAR] = ACTIONS(5406),
    [sym_raw_string] = ACTIONS(5766),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5412),
    [anon_sym_BQUOTE] = ACTIONS(5414),
    [anon_sym_LT_LPAREN] = ACTIONS(5416),
    [anon_sym_GT_LPAREN] = ACTIONS(5416),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5766),
  },
  [2343] = {
    [sym_file_redirect] = STATE(2170),
    [sym_heredoc_redirect] = STATE(2170),
    [sym_herestring_redirect] = STATE(2170),
    [aux_sym_redirected_statement_repeat1] = STATE(2170),
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_esac] = ACTIONS(1964),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [2344] = {
    [sym_file_redirect] = STATE(2170),
    [sym_heredoc_redirect] = STATE(2170),
    [sym_herestring_redirect] = STATE(2170),
    [aux_sym_redirected_statement_repeat1] = STATE(2170),
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_esac] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [2345] = {
    [sym_file_redirect] = STATE(2170),
    [sym_heredoc_redirect] = STATE(2170),
    [sym_herestring_redirect] = STATE(2170),
    [aux_sym_redirected_statement_repeat1] = STATE(2170),
    [sym__simple_heredoc_body] = ACTIONS(1968),
    [sym__heredoc_body_beginning] = ACTIONS(1968),
    [sym_file_descriptor] = ACTIONS(1968),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_esac] = ACTIONS(1968),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI_SEMI] = ACTIONS(1968),
    [anon_sym_PIPE_AMP] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(1968),
    [anon_sym_PIPE_PIPE] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(1970),
    [anon_sym_GT] = ACTIONS(1970),
    [anon_sym_GT_GT] = ACTIONS(1968),
    [anon_sym_AMP_GT] = ACTIONS(1970),
    [anon_sym_AMP_GT_GT] = ACTIONS(1968),
    [anon_sym_LT_AMP] = ACTIONS(1968),
    [anon_sym_GT_AMP] = ACTIONS(1968),
    [anon_sym_LT_LT] = ACTIONS(1970),
    [anon_sym_LT_LT_DASH] = ACTIONS(1968),
    [anon_sym_LT_LT_LT] = ACTIONS(1968),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1968),
    [anon_sym_AMP] = ACTIONS(1970),
  },
  [2346] = {
    [sym_file_redirect] = STATE(2170),
    [sym_heredoc_redirect] = STATE(2170),
    [sym_herestring_redirect] = STATE(2170),
    [aux_sym_redirected_statement_repeat1] = STATE(2170),
    [sym__simple_heredoc_body] = ACTIONS(1968),
    [sym__heredoc_body_beginning] = ACTIONS(1968),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_esac] = ACTIONS(1970),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI_SEMI] = ACTIONS(1968),
    [anon_sym_PIPE_AMP] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(1968),
    [anon_sym_PIPE_PIPE] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(1970),
    [anon_sym_LT_LT_DASH] = ACTIONS(1968),
    [anon_sym_LT_LT_LT] = ACTIONS(1968),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(1968),
    [anon_sym_AMP] = ACTIONS(1970),
  },
  [2347] = {
    [aux_sym_concatenation_repeat1] = STATE(2513),
    [sym__simple_heredoc_body] = ACTIONS(745),
    [sym__heredoc_body_beginning] = ACTIONS(745),
    [sym_file_descriptor] = ACTIONS(745),
    [sym__concat] = ACTIONS(5768),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_esac] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_SEMI_SEMI] = ACTIONS(745),
    [anon_sym_PIPE_AMP] = ACTIONS(745),
    [anon_sym_AMP_AMP] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(745),
    [anon_sym_LT] = ACTIONS(749),
    [anon_sym_GT] = ACTIONS(749),
    [anon_sym_GT_GT] = ACTIONS(745),
    [anon_sym_AMP_GT] = ACTIONS(749),
    [anon_sym_AMP_GT_GT] = ACTIONS(745),
    [anon_sym_LT_AMP] = ACTIONS(745),
    [anon_sym_GT_AMP] = ACTIONS(745),
    [anon_sym_LT_LT] = ACTIONS(749),
    [anon_sym_LT_LT_DASH] = ACTIONS(745),
    [anon_sym_LT_LT_LT] = ACTIONS(745),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(749),
  },
  [2348] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(2516),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [2349] = {
    [sym_string] = STATE(2518),
    [anon_sym_DASH] = ACTIONS(5774),
    [anon_sym_DQUOTE] = ACTIONS(5404),
    [anon_sym_DOLLAR] = ACTIONS(5774),
    [sym_raw_string] = ACTIONS(5776),
    [anon_sym_POUND] = ACTIONS(5774),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5778),
    [anon_sym_STAR] = ACTIONS(5780),
    [anon_sym_AT] = ACTIONS(5780),
    [anon_sym_QMARK] = ACTIONS(5780),
    [anon_sym_0] = ACTIONS(5778),
    [anon_sym__] = ACTIONS(5778),
  },
  [2350] = {
    [aux_sym_concatenation_repeat1] = STATE(2513),
    [sym__simple_heredoc_body] = ACTIONS(763),
    [sym__heredoc_body_beginning] = ACTIONS(763),
    [sym_file_descriptor] = ACTIONS(763),
    [sym__concat] = ACTIONS(5768),
    [anon_sym_SEMI] = ACTIONS(765),
    [anon_sym_esac] = ACTIONS(763),
    [anon_sym_PIPE] = ACTIONS(765),
    [anon_sym_SEMI_SEMI] = ACTIONS(763),
    [anon_sym_PIPE_AMP] = ACTIONS(763),
    [anon_sym_AMP_AMP] = ACTIONS(763),
    [anon_sym_PIPE_PIPE] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(765),
    [anon_sym_GT_GT] = ACTIONS(763),
    [anon_sym_AMP_GT] = ACTIONS(765),
    [anon_sym_AMP_GT_GT] = ACTIONS(763),
    [anon_sym_LT_AMP] = ACTIONS(763),
    [anon_sym_GT_AMP] = ACTIONS(763),
    [anon_sym_LT_LT] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(763),
    [anon_sym_LT_LT_LT] = ACTIONS(763),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(763),
    [anon_sym_AMP] = ACTIONS(765),
  },
  [2351] = {
    [sym_subscript] = STATE(2523),
    [sym_variable_name] = ACTIONS(5782),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5786),
    [anon_sym_DOLLAR] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5784),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5788),
    [anon_sym_STAR] = ACTIONS(5790),
    [anon_sym_AT] = ACTIONS(5790),
    [anon_sym_QMARK] = ACTIONS(5790),
    [anon_sym_0] = ACTIONS(5788),
    [anon_sym__] = ACTIONS(5788),
  },
  [2352] = {
    [sym__terminated_statement] = STATE(2526),
    [sym_redirected_statement] = STATE(2524),
    [sym_for_statement] = STATE(2524),
    [sym_c_style_for_statement] = STATE(2524),
    [sym_while_statement] = STATE(2524),
    [sym_if_statement] = STATE(2524),
    [sym_case_statement] = STATE(2524),
    [sym_function_definition] = STATE(2524),
    [sym_compound_statement] = STATE(2524),
    [sym_subshell] = STATE(2524),
    [sym_pipeline] = STATE(2524),
    [sym_list] = STATE(2524),
    [sym_negated_command] = STATE(2524),
    [sym_test_command] = STATE(2524),
    [sym_declaration_command] = STATE(2524),
    [sym_unset_command] = STATE(2524),
    [sym_command] = STATE(2524),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2525),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(2526),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [2353] = {
    [sym__terminated_statement] = STATE(2529),
    [sym_redirected_statement] = STATE(2527),
    [sym_for_statement] = STATE(2527),
    [sym_c_style_for_statement] = STATE(2527),
    [sym_while_statement] = STATE(2527),
    [sym_if_statement] = STATE(2527),
    [sym_case_statement] = STATE(2527),
    [sym_function_definition] = STATE(2527),
    [sym_compound_statement] = STATE(2527),
    [sym_subshell] = STATE(2527),
    [sym_pipeline] = STATE(2527),
    [sym_list] = STATE(2527),
    [sym_negated_command] = STATE(2527),
    [sym_test_command] = STATE(2527),
    [sym_declaration_command] = STATE(2527),
    [sym_unset_command] = STATE(2527),
    [sym_command] = STATE(2527),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(2528),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(2529),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [2354] = {
    [sym__terminated_statement] = STATE(2532),
    [sym_redirected_statement] = STATE(2530),
    [sym_for_statement] = STATE(2530),
    [sym_c_style_for_statement] = STATE(2530),
    [sym_while_statement] = STATE(2530),
    [sym_if_statement] = STATE(2530),
    [sym_case_statement] = STATE(2530),
    [sym_function_definition] = STATE(2530),
    [sym_compound_statement] = STATE(2530),
    [sym_subshell] = STATE(2530),
    [sym_pipeline] = STATE(2530),
    [sym_list] = STATE(2530),
    [sym_negated_command] = STATE(2530),
    [sym_test_command] = STATE(2530),
    [sym_declaration_command] = STATE(2530),
    [sym_unset_command] = STATE(2530),
    [sym_command] = STATE(2530),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2531),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(2532),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [2355] = {
    [aux_sym_concatenation_repeat1] = STATE(2513),
    [sym__simple_heredoc_body] = ACTIONS(1976),
    [sym__heredoc_body_beginning] = ACTIONS(1976),
    [sym_file_descriptor] = ACTIONS(1976),
    [sym__concat] = ACTIONS(5768),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_esac] = ACTIONS(1976),
    [anon_sym_PIPE] = ACTIONS(1978),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(1976),
    [anon_sym_AMP_AMP] = ACTIONS(1976),
    [anon_sym_PIPE_PIPE] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1976),
    [anon_sym_AMP_GT] = ACTIONS(1978),
    [anon_sym_AMP_GT_GT] = ACTIONS(1976),
    [anon_sym_LT_AMP] = ACTIONS(1976),
    [anon_sym_GT_AMP] = ACTIONS(1976),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_LT_LT_DASH] = ACTIONS(1976),
    [anon_sym_LT_LT_LT] = ACTIONS(1976),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1978),
  },
  [2356] = {
    [aux_sym_concatenation_repeat1] = STATE(2513),
    [sym__simple_heredoc_body] = ACTIONS(1980),
    [sym__heredoc_body_beginning] = ACTIONS(1980),
    [sym_file_descriptor] = ACTIONS(1980),
    [sym__concat] = ACTIONS(5768),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_esac] = ACTIONS(1980),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_SEMI_SEMI] = ACTIONS(1980),
    [anon_sym_PIPE_AMP] = ACTIONS(1980),
    [anon_sym_AMP_AMP] = ACTIONS(1980),
    [anon_sym_PIPE_PIPE] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_AMP_GT] = ACTIONS(1982),
    [anon_sym_AMP_GT_GT] = ACTIONS(1980),
    [anon_sym_LT_AMP] = ACTIONS(1980),
    [anon_sym_GT_AMP] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1982),
    [anon_sym_LT_LT_DASH] = ACTIONS(1980),
    [anon_sym_LT_LT_LT] = ACTIONS(1980),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1982),
  },
  [2357] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_esac] = ACTIONS(1988),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2358] = {
    [sym_file_redirect] = STATE(2358),
    [sym_heredoc_redirect] = STATE(2358),
    [sym_herestring_redirect] = STATE(2358),
    [aux_sym_redirected_statement_repeat1] = STATE(2358),
    [sym__simple_heredoc_body] = ACTIONS(1990),
    [sym__heredoc_body_beginning] = ACTIONS(1990),
    [sym_file_descriptor] = ACTIONS(5792),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_esac] = ACTIONS(1990),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_SEMI_SEMI] = ACTIONS(1990),
    [anon_sym_PIPE_AMP] = ACTIONS(1990),
    [anon_sym_AMP_AMP] = ACTIONS(1990),
    [anon_sym_PIPE_PIPE] = ACTIONS(1990),
    [anon_sym_LT] = ACTIONS(5795),
    [anon_sym_GT] = ACTIONS(5795),
    [anon_sym_GT_GT] = ACTIONS(5798),
    [anon_sym_AMP_GT] = ACTIONS(5795),
    [anon_sym_AMP_GT_GT] = ACTIONS(5798),
    [anon_sym_LT_AMP] = ACTIONS(5798),
    [anon_sym_GT_AMP] = ACTIONS(5798),
    [anon_sym_LT_LT] = ACTIONS(2003),
    [anon_sym_LT_LT_DASH] = ACTIONS(2006),
    [anon_sym_LT_LT_LT] = ACTIONS(5801),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1995),
  },
  [2359] = {
    [sym__simple_heredoc_body] = ACTIONS(2012),
    [sym__heredoc_body_beginning] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_esac] = ACTIONS(2014),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_SEMI_SEMI] = ACTIONS(2012),
    [anon_sym_PIPE_AMP] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_EQ_TILDE] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_GT] = ACTIONS(2012),
    [anon_sym_AMP_GT] = ACTIONS(2014),
    [anon_sym_AMP_GT_GT] = ACTIONS(2012),
    [anon_sym_LT_AMP] = ACTIONS(2012),
    [anon_sym_GT_AMP] = ACTIONS(2012),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_DASH] = ACTIONS(2012),
    [anon_sym_LT_LT_LT] = ACTIONS(2012),
    [sym__special_characters] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2012),
    [anon_sym_DOLLAR] = ACTIONS(2014),
    [sym_raw_string] = ACTIONS(2012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2012),
    [anon_sym_BQUOTE] = ACTIONS(2012),
    [anon_sym_LT_LPAREN] = ACTIONS(2012),
    [anon_sym_GT_LPAREN] = ACTIONS(2012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2014),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2014),
  },
  [2360] = {
    [aux_sym_concatenation_repeat1] = STATE(2142),
    [sym__simple_heredoc_body] = ACTIONS(2016),
    [sym__heredoc_body_beginning] = ACTIONS(2016),
    [sym_file_descriptor] = ACTIONS(2016),
    [sym__concat] = ACTIONS(5007),
    [anon_sym_SEMI] = ACTIONS(2018),
    [anon_sym_esac] = ACTIONS(2018),
    [anon_sym_PIPE] = ACTIONS(2018),
    [anon_sym_SEMI_SEMI] = ACTIONS(2016),
    [anon_sym_PIPE_AMP] = ACTIONS(2016),
    [anon_sym_AMP_AMP] = ACTIONS(2016),
    [anon_sym_PIPE_PIPE] = ACTIONS(2016),
    [anon_sym_EQ_TILDE] = ACTIONS(2018),
    [anon_sym_EQ_EQ] = ACTIONS(2018),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(2018),
    [anon_sym_GT_GT] = ACTIONS(2016),
    [anon_sym_AMP_GT] = ACTIONS(2018),
    [anon_sym_AMP_GT_GT] = ACTIONS(2016),
    [anon_sym_LT_AMP] = ACTIONS(2016),
    [anon_sym_GT_AMP] = ACTIONS(2016),
    [anon_sym_LT_LT] = ACTIONS(2018),
    [anon_sym_LT_LT_DASH] = ACTIONS(2016),
    [anon_sym_LT_LT_LT] = ACTIONS(2016),
    [sym__special_characters] = ACTIONS(2016),
    [anon_sym_DQUOTE] = ACTIONS(2016),
    [anon_sym_DOLLAR] = ACTIONS(2018),
    [sym_raw_string] = ACTIONS(2016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2016),
    [anon_sym_BQUOTE] = ACTIONS(2016),
    [anon_sym_LT_LPAREN] = ACTIONS(2016),
    [anon_sym_GT_LPAREN] = ACTIONS(2016),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2018),
    [anon_sym_LF] = ACTIONS(2016),
    [anon_sym_AMP] = ACTIONS(2018),
  },
  [2361] = {
    [aux_sym_concatenation_repeat1] = STATE(2142),
    [sym__simple_heredoc_body] = ACTIONS(2012),
    [sym__heredoc_body_beginning] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [sym__concat] = ACTIONS(5007),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_esac] = ACTIONS(2014),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_SEMI_SEMI] = ACTIONS(2012),
    [anon_sym_PIPE_AMP] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_EQ_TILDE] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_GT] = ACTIONS(2012),
    [anon_sym_AMP_GT] = ACTIONS(2014),
    [anon_sym_AMP_GT_GT] = ACTIONS(2012),
    [anon_sym_LT_AMP] = ACTIONS(2012),
    [anon_sym_GT_AMP] = ACTIONS(2012),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_DASH] = ACTIONS(2012),
    [anon_sym_LT_LT_LT] = ACTIONS(2012),
    [sym__special_characters] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2012),
    [anon_sym_DOLLAR] = ACTIONS(2014),
    [sym_raw_string] = ACTIONS(2012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2012),
    [anon_sym_BQUOTE] = ACTIONS(2012),
    [anon_sym_LT_LPAREN] = ACTIONS(2012),
    [anon_sym_GT_LPAREN] = ACTIONS(2012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2014),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2014),
  },
  [2362] = {
    [sym_concatenation] = STATE(2362),
    [sym_string] = STATE(2173),
    [sym_simple_expansion] = STATE(2173),
    [sym_string_expansion] = STATE(2173),
    [sym_expansion] = STATE(2173),
    [sym_command_substitution] = STATE(2173),
    [sym_process_substitution] = STATE(2173),
    [aux_sym_command_repeat2] = STATE(2362),
    [sym__simple_heredoc_body] = ACTIONS(2012),
    [sym__heredoc_body_beginning] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_esac] = ACTIONS(2014),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_SEMI_SEMI] = ACTIONS(2012),
    [anon_sym_PIPE_AMP] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_EQ_TILDE] = ACTIONS(5804),
    [anon_sym_EQ_EQ] = ACTIONS(5804),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_GT] = ACTIONS(2012),
    [anon_sym_AMP_GT] = ACTIONS(2014),
    [anon_sym_AMP_GT_GT] = ACTIONS(2012),
    [anon_sym_LT_AMP] = ACTIONS(2012),
    [anon_sym_GT_AMP] = ACTIONS(2012),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_DASH] = ACTIONS(2012),
    [anon_sym_LT_LT_LT] = ACTIONS(2012),
    [sym__special_characters] = ACTIONS(5807),
    [anon_sym_DQUOTE] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5813),
    [sym_raw_string] = ACTIONS(5816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5819),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5822),
    [anon_sym_BQUOTE] = ACTIONS(5825),
    [anon_sym_LT_LPAREN] = ACTIONS(5828),
    [anon_sym_GT_LPAREN] = ACTIONS(5828),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5831),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2014),
  },
  [2363] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_esac] = ACTIONS(5834),
    [anon_sym_SEMI_SEMI] = ACTIONS(927),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(5836),
    [anon_sym_DQUOTE] = ACTIONS(5838),
    [anon_sym_DOLLAR] = ACTIONS(5836),
    [sym_raw_string] = ACTIONS(5838),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5838),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5838),
    [anon_sym_BQUOTE] = ACTIONS(5838),
    [anon_sym_LT_LPAREN] = ACTIONS(5838),
    [anon_sym_GT_LPAREN] = ACTIONS(5838),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5836),
  },
  [2364] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(2169),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(5033),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(5051),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(507),
    [anon_sym_GT_GT] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(507),
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5051),
    [anon_sym_AMP] = ACTIONS(5033),
  },
  [2365] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(2169),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5033),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(5051),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5051),
    [anon_sym_AMP] = ACTIONS(5033),
  },
  [2366] = {
    [sym_concatenation] = STATE(2362),
    [sym_string] = STATE(2173),
    [sym_simple_expansion] = STATE(2173),
    [sym_string_expansion] = STATE(2173),
    [sym_expansion] = STATE(2173),
    [sym_command_substitution] = STATE(2173),
    [sym_process_substitution] = STATE(2173),
    [aux_sym_command_repeat2] = STATE(2362),
    [sym__simple_heredoc_body] = ACTIONS(2058),
    [sym__heredoc_body_beginning] = ACTIONS(2058),
    [sym_file_descriptor] = ACTIONS(2058),
    [anon_sym_SEMI] = ACTIONS(2060),
    [anon_sym_esac] = ACTIONS(2060),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_SEMI_SEMI] = ACTIONS(2058),
    [anon_sym_PIPE_AMP] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_PIPE_PIPE] = ACTIONS(2058),
    [anon_sym_EQ_TILDE] = ACTIONS(5053),
    [anon_sym_EQ_EQ] = ACTIONS(5053),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2058),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2058),
    [anon_sym_LT_AMP] = ACTIONS(2058),
    [anon_sym_GT_AMP] = ACTIONS(2058),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2058),
    [anon_sym_LT_LT_LT] = ACTIONS(2058),
    [sym__special_characters] = ACTIONS(5055),
    [anon_sym_DQUOTE] = ACTIONS(4432),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [sym_raw_string] = ACTIONS(5057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_LT_LPAREN] = ACTIONS(4444),
    [anon_sym_GT_LPAREN] = ACTIONS(4444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5059),
    [anon_sym_LF] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2060),
  },
  [2367] = {
    [anon_sym_esac] = ACTIONS(5834),
    [sym__special_characters] = ACTIONS(5838),
    [anon_sym_DQUOTE] = ACTIONS(5838),
    [anon_sym_DOLLAR] = ACTIONS(5836),
    [sym_raw_string] = ACTIONS(5838),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5838),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5838),
    [anon_sym_BQUOTE] = ACTIONS(5838),
    [anon_sym_LT_LPAREN] = ACTIONS(5838),
    [anon_sym_GT_LPAREN] = ACTIONS(5838),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5836),
  },
  [2368] = {
    [sym_file_redirect] = STATE(2170),
    [sym_heredoc_redirect] = STATE(2170),
    [sym_heredoc_body] = STATE(2169),
    [sym_herestring_redirect] = STATE(2170),
    [aux_sym_redirected_statement_repeat1] = STATE(2170),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(5031),
    [anon_sym_SEMI] = ACTIONS(5033),
    [anon_sym_esac] = ACTIONS(5840),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI_SEMI] = ACTIONS(5842),
    [anon_sym_PIPE_AMP] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5043),
    [anon_sym_PIPE_PIPE] = ACTIONS(5043),
    [anon_sym_LT] = ACTIONS(5045),
    [anon_sym_GT] = ACTIONS(5045),
    [anon_sym_GT_GT] = ACTIONS(5047),
    [anon_sym_AMP_GT] = ACTIONS(5045),
    [anon_sym_AMP_GT_GT] = ACTIONS(5047),
    [anon_sym_LT_AMP] = ACTIONS(5047),
    [anon_sym_GT_AMP] = ACTIONS(5047),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(5049),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5051),
    [anon_sym_AMP] = ACTIONS(5033),
  },
  [2369] = {
    [sym_file_redirect] = STATE(2170),
    [sym_heredoc_redirect] = STATE(2170),
    [sym_heredoc_body] = STATE(2169),
    [sym_herestring_redirect] = STATE(2170),
    [aux_sym_redirected_statement_repeat1] = STATE(2170),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5033),
    [anon_sym_esac] = ACTIONS(5834),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI_SEMI] = ACTIONS(5842),
    [anon_sym_PIPE_AMP] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5043),
    [anon_sym_PIPE_PIPE] = ACTIONS(5043),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(5049),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5051),
    [anon_sym_AMP] = ACTIONS(5033),
  },
  [2370] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_esac] = ACTIONS(5844),
    [anon_sym_SEMI_SEMI] = ACTIONS(927),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(5846),
    [anon_sym_DQUOTE] = ACTIONS(5848),
    [anon_sym_DOLLAR] = ACTIONS(5846),
    [sym_raw_string] = ACTIONS(5848),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5848),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5848),
    [anon_sym_BQUOTE] = ACTIONS(5848),
    [anon_sym_LT_LPAREN] = ACTIONS(5848),
    [anon_sym_GT_LPAREN] = ACTIONS(5848),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5846),
  },
  [2371] = {
    [anon_sym_esac] = ACTIONS(5844),
    [sym__special_characters] = ACTIONS(5848),
    [anon_sym_DQUOTE] = ACTIONS(5848),
    [anon_sym_DOLLAR] = ACTIONS(5846),
    [sym_raw_string] = ACTIONS(5848),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5848),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5848),
    [anon_sym_BQUOTE] = ACTIONS(5848),
    [anon_sym_LT_LPAREN] = ACTIONS(5848),
    [anon_sym_GT_LPAREN] = ACTIONS(5848),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5846),
  },
  [2372] = {
    [sym_file_redirect] = STATE(2170),
    [sym_heredoc_redirect] = STATE(2170),
    [sym_heredoc_body] = STATE(2169),
    [sym_herestring_redirect] = STATE(2170),
    [aux_sym_redirected_statement_repeat1] = STATE(2170),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(5031),
    [anon_sym_SEMI] = ACTIONS(5033),
    [anon_sym_esac] = ACTIONS(5850),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI_SEMI] = ACTIONS(5852),
    [anon_sym_PIPE_AMP] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5043),
    [anon_sym_PIPE_PIPE] = ACTIONS(5043),
    [anon_sym_LT] = ACTIONS(5045),
    [anon_sym_GT] = ACTIONS(5045),
    [anon_sym_GT_GT] = ACTIONS(5047),
    [anon_sym_AMP_GT] = ACTIONS(5045),
    [anon_sym_AMP_GT_GT] = ACTIONS(5047),
    [anon_sym_LT_AMP] = ACTIONS(5047),
    [anon_sym_GT_AMP] = ACTIONS(5047),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(5049),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5051),
    [anon_sym_AMP] = ACTIONS(5033),
  },
  [2373] = {
    [sym_file_redirect] = STATE(2170),
    [sym_heredoc_redirect] = STATE(2170),
    [sym_heredoc_body] = STATE(2169),
    [sym_herestring_redirect] = STATE(2170),
    [aux_sym_redirected_statement_repeat1] = STATE(2170),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5033),
    [anon_sym_esac] = ACTIONS(5844),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_SEMI_SEMI] = ACTIONS(5852),
    [anon_sym_PIPE_AMP] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5043),
    [anon_sym_PIPE_PIPE] = ACTIONS(5043),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(5049),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5051),
    [anon_sym_AMP] = ACTIONS(5033),
  },
  [2374] = {
    [sym__special_characters] = ACTIONS(4961),
    [anon_sym_DQUOTE] = ACTIONS(4961),
    [anon_sym_DOLLAR] = ACTIONS(4963),
    [sym_raw_string] = ACTIONS(4961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4961),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4961),
    [anon_sym_BQUOTE] = ACTIONS(4961),
    [anon_sym_LT_LPAREN] = ACTIONS(4961),
    [anon_sym_GT_LPAREN] = ACTIONS(4961),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4961),
  },
  [2375] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(979),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(5854),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(507),
    [anon_sym_GT_GT] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(507),
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2056),
    [anon_sym_AMP] = ACTIONS(2054),
  },
  [2376] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(979),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(5854),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2056),
    [anon_sym_AMP] = ACTIONS(2054),
  },
  [2377] = {
    [sym__terminated_statement] = STATE(2539),
    [sym_redirected_statement] = STATE(2537),
    [sym_for_statement] = STATE(2537),
    [sym_c_style_for_statement] = STATE(2537),
    [sym_while_statement] = STATE(2537),
    [sym_if_statement] = STATE(2537),
    [sym_case_statement] = STATE(2537),
    [sym_function_definition] = STATE(2537),
    [sym_compound_statement] = STATE(2537),
    [sym_subshell] = STATE(2537),
    [sym_pipeline] = STATE(2537),
    [sym_list] = STATE(2537),
    [sym_negated_command] = STATE(2537),
    [sym_test_command] = STATE(2537),
    [sym_declaration_command] = STATE(2537),
    [sym_unset_command] = STATE(2537),
    [sym_command] = STATE(2537),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(2538),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(2539),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(5856),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [2378] = {
    [sym__terminated_statement] = STATE(2540),
    [sym_redirected_statement] = STATE(2537),
    [sym_for_statement] = STATE(2537),
    [sym_c_style_for_statement] = STATE(2537),
    [sym_while_statement] = STATE(2537),
    [sym_if_statement] = STATE(2537),
    [sym_case_statement] = STATE(2537),
    [sym_function_definition] = STATE(2537),
    [sym_compound_statement] = STATE(2537),
    [sym_subshell] = STATE(2537),
    [sym_pipeline] = STATE(2537),
    [sym_list] = STATE(2537),
    [sym_negated_command] = STATE(2537),
    [sym_test_command] = STATE(2537),
    [sym_declaration_command] = STATE(2537),
    [sym_unset_command] = STATE(2537),
    [sym_command] = STATE(2537),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(2538),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(2540),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(5856),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [2379] = {
    [sym__special_characters] = ACTIONS(5070),
    [anon_sym_DQUOTE] = ACTIONS(5070),
    [anon_sym_DOLLAR] = ACTIONS(5072),
    [sym_raw_string] = ACTIONS(5070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5070),
    [anon_sym_BQUOTE] = ACTIONS(5070),
    [anon_sym_LT_LPAREN] = ACTIONS(5070),
    [anon_sym_GT_LPAREN] = ACTIONS(5070),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5070),
  },
  [2380] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(979),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(5858),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(507),
    [anon_sym_GT_GT] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(507),
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2056),
    [anon_sym_AMP] = ACTIONS(2054),
  },
  [2381] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(979),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(5858),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2056),
    [anon_sym_AMP] = ACTIONS(2054),
  },
  [2382] = {
    [sym__terminated_statement] = STATE(2539),
    [sym_redirected_statement] = STATE(2543),
    [sym_for_statement] = STATE(2543),
    [sym_c_style_for_statement] = STATE(2543),
    [sym_while_statement] = STATE(2543),
    [sym_if_statement] = STATE(2543),
    [sym_case_statement] = STATE(2543),
    [sym_function_definition] = STATE(2543),
    [sym_compound_statement] = STATE(2543),
    [sym_subshell] = STATE(2543),
    [sym_pipeline] = STATE(2543),
    [sym_list] = STATE(2543),
    [sym_negated_command] = STATE(2543),
    [sym_test_command] = STATE(2543),
    [sym_declaration_command] = STATE(2543),
    [sym_unset_command] = STATE(2543),
    [sym_command] = STATE(2543),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(2544),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(2539),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(5860),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [2383] = {
    [sym__terminated_statement] = STATE(2545),
    [sym_redirected_statement] = STATE(2543),
    [sym_for_statement] = STATE(2543),
    [sym_c_style_for_statement] = STATE(2543),
    [sym_while_statement] = STATE(2543),
    [sym_if_statement] = STATE(2543),
    [sym_case_statement] = STATE(2543),
    [sym_function_definition] = STATE(2543),
    [sym_compound_statement] = STATE(2543),
    [sym_subshell] = STATE(2543),
    [sym_pipeline] = STATE(2543),
    [sym_list] = STATE(2543),
    [sym_negated_command] = STATE(2543),
    [sym_test_command] = STATE(2543),
    [sym_declaration_command] = STATE(2543),
    [sym_unset_command] = STATE(2543),
    [sym_command] = STATE(2543),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(2544),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(2545),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(5860),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [2384] = {
    [sym__concat] = ACTIONS(4687),
    [anon_sym_RBRACE] = ACTIONS(4687),
    [sym_comment] = ACTIONS(57),
  },
  [2385] = {
    [sym__concat] = ACTIONS(4691),
    [anon_sym_RBRACE] = ACTIONS(4691),
    [sym_comment] = ACTIONS(57),
  },
  [2386] = {
    [sym__concat] = ACTIONS(4695),
    [anon_sym_RBRACE] = ACTIONS(4695),
    [sym_comment] = ACTIONS(57),
  },
  [2387] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2388] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5864),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2389] = {
    [sym__concat] = ACTIONS(4731),
    [anon_sym_RBRACE] = ACTIONS(4731),
    [sym_comment] = ACTIONS(57),
  },
  [2390] = {
    [sym__concat] = ACTIONS(4751),
    [anon_sym_RBRACE] = ACTIONS(4751),
    [sym_comment] = ACTIONS(57),
  },
  [2391] = {
    [sym__concat] = ACTIONS(4755),
    [anon_sym_RBRACE] = ACTIONS(4755),
    [sym_comment] = ACTIONS(57),
  },
  [2392] = {
    [sym__concat] = ACTIONS(5168),
    [anon_sym_RBRACE] = ACTIONS(5168),
    [anon_sym_EQ] = ACTIONS(5170),
    [anon_sym_DASH] = ACTIONS(5170),
    [sym__special_characters] = ACTIONS(5170),
    [anon_sym_DQUOTE] = ACTIONS(5168),
    [anon_sym_DOLLAR] = ACTIONS(5170),
    [sym_raw_string] = ACTIONS(5168),
    [anon_sym_POUND] = ACTIONS(5168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5168),
    [anon_sym_COLON] = ACTIONS(5170),
    [anon_sym_COLON_QMARK] = ACTIONS(5170),
    [anon_sym_COLON_DASH] = ACTIONS(5170),
    [anon_sym_PERCENT] = ACTIONS(5170),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5168),
    [anon_sym_BQUOTE] = ACTIONS(5168),
    [anon_sym_LT_LPAREN] = ACTIONS(5168),
    [anon_sym_GT_LPAREN] = ACTIONS(5168),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(5170),
  },
  [2393] = {
    [sym__concat] = ACTIONS(5172),
    [anon_sym_RBRACE] = ACTIONS(5172),
    [anon_sym_EQ] = ACTIONS(5174),
    [anon_sym_DASH] = ACTIONS(5174),
    [sym__special_characters] = ACTIONS(5174),
    [anon_sym_DQUOTE] = ACTIONS(5172),
    [anon_sym_DOLLAR] = ACTIONS(5174),
    [sym_raw_string] = ACTIONS(5172),
    [anon_sym_POUND] = ACTIONS(5172),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5172),
    [anon_sym_COLON] = ACTIONS(5174),
    [anon_sym_COLON_QMARK] = ACTIONS(5174),
    [anon_sym_COLON_DASH] = ACTIONS(5174),
    [anon_sym_PERCENT] = ACTIONS(5174),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5172),
    [anon_sym_BQUOTE] = ACTIONS(5172),
    [anon_sym_LT_LPAREN] = ACTIONS(5172),
    [anon_sym_GT_LPAREN] = ACTIONS(5172),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(5174),
  },
  [2394] = {
    [sym__heredoc_body_middle] = ACTIONS(5168),
    [sym__heredoc_body_end] = ACTIONS(5168),
    [anon_sym_DOLLAR] = ACTIONS(5170),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5168),
    [sym_comment] = ACTIONS(57),
  },
  [2395] = {
    [sym__heredoc_body_middle] = ACTIONS(5172),
    [sym__heredoc_body_end] = ACTIONS(5172),
    [anon_sym_DOLLAR] = ACTIONS(5174),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5172),
    [sym_comment] = ACTIONS(57),
  },
  [2396] = {
    [sym__concat] = ACTIONS(5168),
    [anon_sym_RPAREN] = ACTIONS(5168),
    [sym__special_characters] = ACTIONS(5168),
    [anon_sym_DQUOTE] = ACTIONS(5168),
    [anon_sym_DOLLAR] = ACTIONS(5170),
    [sym_raw_string] = ACTIONS(5168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5168),
    [anon_sym_BQUOTE] = ACTIONS(5168),
    [anon_sym_LT_LPAREN] = ACTIONS(5168),
    [anon_sym_GT_LPAREN] = ACTIONS(5168),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5168),
  },
  [2397] = {
    [sym__concat] = ACTIONS(5172),
    [anon_sym_RPAREN] = ACTIONS(5172),
    [sym__special_characters] = ACTIONS(5172),
    [anon_sym_DQUOTE] = ACTIONS(5172),
    [anon_sym_DOLLAR] = ACTIONS(5174),
    [sym_raw_string] = ACTIONS(5172),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5172),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5172),
    [anon_sym_BQUOTE] = ACTIONS(5172),
    [anon_sym_LT_LPAREN] = ACTIONS(5172),
    [anon_sym_GT_LPAREN] = ACTIONS(5172),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5172),
  },
  [2398] = {
    [sym__simple_heredoc_body] = ACTIONS(5866),
    [sym__heredoc_body_beginning] = ACTIONS(5866),
    [sym_file_descriptor] = ACTIONS(5866),
    [ts_builtin_sym_end] = ACTIONS(5866),
    [anon_sym_SEMI] = ACTIONS(5868),
    [anon_sym_esac] = ACTIONS(5866),
    [anon_sym_PIPE] = ACTIONS(5868),
    [anon_sym_RPAREN] = ACTIONS(5866),
    [anon_sym_SEMI_SEMI] = ACTIONS(5866),
    [anon_sym_PIPE_AMP] = ACTIONS(5866),
    [anon_sym_AMP_AMP] = ACTIONS(5866),
    [anon_sym_PIPE_PIPE] = ACTIONS(5866),
    [anon_sym_LT] = ACTIONS(5868),
    [anon_sym_GT] = ACTIONS(5868),
    [anon_sym_GT_GT] = ACTIONS(5866),
    [anon_sym_AMP_GT] = ACTIONS(5868),
    [anon_sym_AMP_GT_GT] = ACTIONS(5866),
    [anon_sym_LT_AMP] = ACTIONS(5866),
    [anon_sym_GT_AMP] = ACTIONS(5866),
    [anon_sym_LT_LT] = ACTIONS(5868),
    [anon_sym_LT_LT_DASH] = ACTIONS(5866),
    [anon_sym_LT_LT_LT] = ACTIONS(5866),
    [anon_sym_BQUOTE] = ACTIONS(5866),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5866),
    [anon_sym_AMP] = ACTIONS(5868),
  },
  [2399] = {
    [sym__concat] = ACTIONS(5168),
    [anon_sym_SEMI] = ACTIONS(5170),
    [anon_sym_SEMI_SEMI] = ACTIONS(5168),
    [sym__special_characters] = ACTIONS(5168),
    [anon_sym_DQUOTE] = ACTIONS(5168),
    [anon_sym_DOLLAR] = ACTIONS(5170),
    [sym_raw_string] = ACTIONS(5168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5168),
    [anon_sym_BQUOTE] = ACTIONS(5168),
    [anon_sym_LT_LPAREN] = ACTIONS(5168),
    [anon_sym_GT_LPAREN] = ACTIONS(5168),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5170),
    [anon_sym_LF] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5168),
  },
  [2400] = {
    [sym__concat] = ACTIONS(5172),
    [anon_sym_SEMI] = ACTIONS(5174),
    [anon_sym_SEMI_SEMI] = ACTIONS(5172),
    [sym__special_characters] = ACTIONS(5172),
    [anon_sym_DQUOTE] = ACTIONS(5172),
    [anon_sym_DOLLAR] = ACTIONS(5174),
    [sym_raw_string] = ACTIONS(5172),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5172),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5172),
    [anon_sym_BQUOTE] = ACTIONS(5172),
    [anon_sym_LT_LPAREN] = ACTIONS(5172),
    [anon_sym_GT_LPAREN] = ACTIONS(5172),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5174),
    [anon_sym_LF] = ACTIONS(5172),
    [anon_sym_AMP] = ACTIONS(5172),
  },
  [2401] = {
    [sym__simple_heredoc_body] = ACTIONS(2076),
    [sym__heredoc_body_beginning] = ACTIONS(2076),
    [sym_file_descriptor] = ACTIONS(2076),
    [sym_variable_name] = ACTIONS(2076),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_esac] = ACTIONS(2078),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_SEMI_SEMI] = ACTIONS(2076),
    [anon_sym_PIPE_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2076),
    [anon_sym_PIPE_PIPE] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_GT] = ACTIONS(2078),
    [anon_sym_GT_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT_GT] = ACTIONS(2076),
    [anon_sym_LT_AMP] = ACTIONS(2076),
    [anon_sym_GT_AMP] = ACTIONS(2076),
    [anon_sym_LT_LT] = ACTIONS(2078),
    [anon_sym_LT_LT_DASH] = ACTIONS(2076),
    [anon_sym_LT_LT_LT] = ACTIONS(2076),
    [sym__special_characters] = ACTIONS(2076),
    [anon_sym_DQUOTE] = ACTIONS(2076),
    [anon_sym_DOLLAR] = ACTIONS(2078),
    [sym_raw_string] = ACTIONS(2076),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2076),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2076),
    [anon_sym_BQUOTE] = ACTIONS(2076),
    [anon_sym_LT_LPAREN] = ACTIONS(2076),
    [anon_sym_GT_LPAREN] = ACTIONS(2076),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2078),
    [anon_sym_LF] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [2402] = {
    [sym_concatenation] = STATE(1007),
    [sym_string] = STATE(537),
    [sym_simple_expansion] = STATE(537),
    [sym_string_expansion] = STATE(537),
    [sym_expansion] = STATE(537),
    [sym_command_substitution] = STATE(537),
    [sym_process_substitution] = STATE(537),
    [aux_sym_for_statement_repeat1] = STATE(1007),
    [anon_sym_RPAREN] = ACTIONS(5870),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1095),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
  },
  [2403] = {
    [sym_string] = STATE(2549),
    [sym_simple_expansion] = STATE(2549),
    [sym_string_expansion] = STATE(2549),
    [sym_expansion] = STATE(2549),
    [sym_command_substitution] = STATE(2549),
    [sym_process_substitution] = STATE(2549),
    [sym__special_characters] = ACTIONS(5872),
    [anon_sym_DQUOTE] = ACTIONS(5276),
    [anon_sym_DOLLAR] = ACTIONS(5278),
    [sym_raw_string] = ACTIONS(5872),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5284),
    [anon_sym_BQUOTE] = ACTIONS(5286),
    [anon_sym_LT_LPAREN] = ACTIONS(5288),
    [anon_sym_GT_LPAREN] = ACTIONS(5288),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5872),
  },
  [2404] = {
    [aux_sym_concatenation_repeat1] = STATE(2550),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(5508),
    [sym_variable_name] = ACTIONS(779),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_esac] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [sym_raw_string] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_LT_LPAREN] = ACTIONS(779),
    [anon_sym_GT_LPAREN] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(781),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [2405] = {
    [sym__simple_heredoc_body] = ACTIONS(783),
    [sym__heredoc_body_beginning] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(783),
    [sym__concat] = ACTIONS(783),
    [sym_variable_name] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_esac] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [anon_sym_PIPE_AMP] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(783),
    [anon_sym_AMP_GT] = ACTIONS(785),
    [anon_sym_AMP_GT_GT] = ACTIONS(783),
    [anon_sym_LT_AMP] = ACTIONS(783),
    [anon_sym_GT_AMP] = ACTIONS(783),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_DASH] = ACTIONS(783),
    [anon_sym_LT_LT_LT] = ACTIONS(783),
    [sym__special_characters] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(783),
    [anon_sym_DOLLAR] = ACTIONS(785),
    [sym_raw_string] = ACTIONS(783),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(783),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(783),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [anon_sym_LT_LPAREN] = ACTIONS(783),
    [anon_sym_GT_LPAREN] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(785),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
  },
  [2406] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(5874),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [2407] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(5874),
    [anon_sym_DOLLAR] = ACTIONS(5876),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [2408] = {
    [sym__simple_heredoc_body] = ACTIONS(817),
    [sym__heredoc_body_beginning] = ACTIONS(817),
    [sym_file_descriptor] = ACTIONS(817),
    [sym__concat] = ACTIONS(817),
    [sym_variable_name] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(819),
    [anon_sym_esac] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(819),
    [anon_sym_SEMI_SEMI] = ACTIONS(817),
    [anon_sym_PIPE_AMP] = ACTIONS(817),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(817),
    [anon_sym_AMP_GT] = ACTIONS(819),
    [anon_sym_AMP_GT_GT] = ACTIONS(817),
    [anon_sym_LT_AMP] = ACTIONS(817),
    [anon_sym_GT_AMP] = ACTIONS(817),
    [anon_sym_LT_LT] = ACTIONS(819),
    [anon_sym_LT_LT_DASH] = ACTIONS(817),
    [anon_sym_LT_LT_LT] = ACTIONS(817),
    [sym__special_characters] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR] = ACTIONS(819),
    [sym_raw_string] = ACTIONS(817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(817),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(817),
    [anon_sym_GT_LPAREN] = ACTIONS(817),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(819),
    [anon_sym_LF] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(819),
  },
  [2409] = {
    [sym__simple_heredoc_body] = ACTIONS(821),
    [sym__heredoc_body_beginning] = ACTIONS(821),
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [sym_variable_name] = ACTIONS(821),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_esac] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(823),
    [anon_sym_SEMI_SEMI] = ACTIONS(821),
    [anon_sym_PIPE_AMP] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(823),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(823),
    [anon_sym_LT_LT_DASH] = ACTIONS(821),
    [anon_sym_LT_LT_LT] = ACTIONS(821),
    [sym__special_characters] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [anon_sym_DOLLAR] = ACTIONS(823),
    [sym_raw_string] = ACTIONS(821),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(821),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(821),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(821),
    [anon_sym_GT_LPAREN] = ACTIONS(821),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(823),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [2410] = {
    [sym__simple_heredoc_body] = ACTIONS(825),
    [sym__heredoc_body_beginning] = ACTIONS(825),
    [sym_file_descriptor] = ACTIONS(825),
    [sym__concat] = ACTIONS(825),
    [sym_variable_name] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(827),
    [anon_sym_esac] = ACTIONS(827),
    [anon_sym_PIPE] = ACTIONS(827),
    [anon_sym_SEMI_SEMI] = ACTIONS(825),
    [anon_sym_PIPE_AMP] = ACTIONS(825),
    [anon_sym_AMP_AMP] = ACTIONS(825),
    [anon_sym_PIPE_PIPE] = ACTIONS(825),
    [anon_sym_LT] = ACTIONS(827),
    [anon_sym_GT] = ACTIONS(827),
    [anon_sym_GT_GT] = ACTIONS(825),
    [anon_sym_AMP_GT] = ACTIONS(827),
    [anon_sym_AMP_GT_GT] = ACTIONS(825),
    [anon_sym_LT_AMP] = ACTIONS(825),
    [anon_sym_GT_AMP] = ACTIONS(825),
    [anon_sym_LT_LT] = ACTIONS(827),
    [anon_sym_LT_LT_DASH] = ACTIONS(825),
    [anon_sym_LT_LT_LT] = ACTIONS(825),
    [sym__special_characters] = ACTIONS(825),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [sym_raw_string] = ACTIONS(825),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(825),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(825),
    [anon_sym_BQUOTE] = ACTIONS(825),
    [anon_sym_LT_LPAREN] = ACTIONS(825),
    [anon_sym_GT_LPAREN] = ACTIONS(825),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(827),
    [anon_sym_LF] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(827),
  },
  [2411] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(5878),
    [sym_comment] = ACTIONS(57),
  },
  [2412] = {
    [sym_subscript] = STATE(2556),
    [sym_variable_name] = ACTIONS(5880),
    [anon_sym_DASH] = ACTIONS(5882),
    [anon_sym_DOLLAR] = ACTIONS(5882),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5884),
    [anon_sym_STAR] = ACTIONS(5886),
    [anon_sym_AT] = ACTIONS(5886),
    [anon_sym_QMARK] = ACTIONS(5886),
    [anon_sym_0] = ACTIONS(5884),
    [anon_sym__] = ACTIONS(5884),
  },
  [2413] = {
    [sym_concatenation] = STATE(2559),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2559),
    [anon_sym_RBRACE] = ACTIONS(5888),
    [anon_sym_EQ] = ACTIONS(5890),
    [anon_sym_DASH] = ACTIONS(5890),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5892),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(5894),
    [anon_sym_COLON] = ACTIONS(5890),
    [anon_sym_COLON_QMARK] = ACTIONS(5890),
    [anon_sym_COLON_DASH] = ACTIONS(5890),
    [anon_sym_PERCENT] = ACTIONS(5890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2414] = {
    [sym_concatenation] = STATE(2562),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2562),
    [anon_sym_RBRACE] = ACTIONS(5896),
    [anon_sym_EQ] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5898),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5900),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_COLON] = ACTIONS(5898),
    [anon_sym_COLON_QMARK] = ACTIONS(5898),
    [anon_sym_COLON_DASH] = ACTIONS(5898),
    [anon_sym_PERCENT] = ACTIONS(5898),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2415] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2565),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(5904),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5906),
    [anon_sym_SEMI_SEMI] = ACTIONS(5908),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5908),
    [anon_sym_AMP] = ACTIONS(5904),
  },
  [2416] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2565),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5904),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5906),
    [anon_sym_SEMI_SEMI] = ACTIONS(5908),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5908),
    [anon_sym_AMP] = ACTIONS(5904),
  },
  [2417] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(2566),
    [sym_for_statement] = STATE(2566),
    [sym_c_style_for_statement] = STATE(2566),
    [sym_while_statement] = STATE(2566),
    [sym_if_statement] = STATE(2566),
    [sym_case_statement] = STATE(2566),
    [sym_function_definition] = STATE(2566),
    [sym_compound_statement] = STATE(2566),
    [sym_subshell] = STATE(2566),
    [sym_pipeline] = STATE(2566),
    [sym_list] = STATE(2566),
    [sym_negated_command] = STATE(2566),
    [sym_test_command] = STATE(2566),
    [sym_declaration_command] = STATE(2566),
    [sym_unset_command] = STATE(2566),
    [sym_command] = STATE(2566),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2567),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [2418] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2569),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(5910),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(5912),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(5906),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5912),
    [anon_sym_AMP] = ACTIONS(5910),
  },
  [2419] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2569),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5910),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(5912),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(5906),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5912),
    [anon_sym_AMP] = ACTIONS(5910),
  },
  [2420] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(2570),
    [sym_for_statement] = STATE(2570),
    [sym_c_style_for_statement] = STATE(2570),
    [sym_while_statement] = STATE(2570),
    [sym_if_statement] = STATE(2570),
    [sym_case_statement] = STATE(2570),
    [sym_function_definition] = STATE(2570),
    [sym_compound_statement] = STATE(2570),
    [sym_subshell] = STATE(2570),
    [sym_pipeline] = STATE(2570),
    [sym_list] = STATE(2570),
    [sym_negated_command] = STATE(2570),
    [sym_test_command] = STATE(2570),
    [sym_declaration_command] = STATE(2570),
    [sym_unset_command] = STATE(2570),
    [sym_command] = STATE(2570),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(2571),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [2421] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2574),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(5914),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5916),
    [anon_sym_SEMI_SEMI] = ACTIONS(5918),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5918),
    [anon_sym_AMP] = ACTIONS(5914),
  },
  [2422] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2574),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5914),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5916),
    [anon_sym_SEMI_SEMI] = ACTIONS(5918),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5918),
    [anon_sym_AMP] = ACTIONS(5914),
  },
  [2423] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(2575),
    [sym_for_statement] = STATE(2575),
    [sym_c_style_for_statement] = STATE(2575),
    [sym_while_statement] = STATE(2575),
    [sym_if_statement] = STATE(2575),
    [sym_case_statement] = STATE(2575),
    [sym_function_definition] = STATE(2575),
    [sym_compound_statement] = STATE(2575),
    [sym_subshell] = STATE(2575),
    [sym_pipeline] = STATE(2575),
    [sym_list] = STATE(2575),
    [sym_negated_command] = STATE(2575),
    [sym_test_command] = STATE(2575),
    [sym_declaration_command] = STATE(2575),
    [sym_unset_command] = STATE(2575),
    [sym_command] = STATE(2575),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2576),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [2424] = {
    [sym__simple_heredoc_body] = ACTIONS(1085),
    [sym__heredoc_body_beginning] = ACTIONS(1085),
    [sym_file_descriptor] = ACTIONS(1085),
    [sym_variable_name] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(1087),
    [anon_sym_esac] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1087),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym__special_characters] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_DOLLAR] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1085),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [anon_sym_LT_LPAREN] = ACTIONS(1085),
    [anon_sym_GT_LPAREN] = ACTIONS(1085),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1087),
    [sym_word] = ACTIONS(1087),
    [anon_sym_LF] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1087),
  },
  [2425] = {
    [sym_concatenation] = STATE(2578),
    [sym_string] = STATE(537),
    [sym_simple_expansion] = STATE(537),
    [sym_string_expansion] = STATE(537),
    [sym_expansion] = STATE(537),
    [sym_command_substitution] = STATE(537),
    [sym_process_substitution] = STATE(537),
    [aux_sym_for_statement_repeat1] = STATE(2578),
    [anon_sym_RPAREN] = ACTIONS(5920),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1095),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
  },
  [2426] = {
    [aux_sym_concatenation_repeat1] = STATE(2271),
    [sym__simple_heredoc_body] = ACTIONS(1107),
    [sym__heredoc_body_beginning] = ACTIONS(1107),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(5292),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_SEMI] = ACTIONS(1111),
    [anon_sym_esac] = ACTIONS(1111),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_SEMI_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT] = ACTIONS(1111),
    [anon_sym_AMP_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_AMP] = ACTIONS(1107),
    [anon_sym_GT_AMP] = ACTIONS(1107),
    [anon_sym_LT_LT] = ACTIONS(1111),
    [anon_sym_LT_LT_DASH] = ACTIONS(1107),
    [anon_sym_LT_LT_LT] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1111),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1111),
    [sym_word] = ACTIONS(1111),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1111),
  },
  [2427] = {
    [aux_sym_concatenation_repeat1] = STATE(2271),
    [sym__simple_heredoc_body] = ACTIONS(1085),
    [sym__heredoc_body_beginning] = ACTIONS(1085),
    [sym_file_descriptor] = ACTIONS(1085),
    [sym__concat] = ACTIONS(5292),
    [sym_variable_name] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(1087),
    [anon_sym_esac] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1087),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym__special_characters] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_DOLLAR] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1085),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [anon_sym_LT_LPAREN] = ACTIONS(1085),
    [anon_sym_GT_LPAREN] = ACTIONS(1085),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1087),
    [sym_word] = ACTIONS(1087),
    [anon_sym_LF] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1087),
  },
  [2428] = {
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(1726),
    [sym_variable_name] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_esac] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1728),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [2429] = {
    [aux_sym_concatenation_repeat1] = STATE(2429),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(5922),
    [sym_variable_name] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_esac] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1728),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [2430] = {
    [sym__simple_heredoc_body] = ACTIONS(1733),
    [sym__heredoc_body_beginning] = ACTIONS(1733),
    [sym_file_descriptor] = ACTIONS(1733),
    [sym__concat] = ACTIONS(1733),
    [sym_variable_name] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_esac] = ACTIONS(1735),
    [anon_sym_PIPE] = ACTIONS(1735),
    [anon_sym_SEMI_SEMI] = ACTIONS(1733),
    [anon_sym_PIPE_AMP] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1735),
    [anon_sym_GT] = ACTIONS(1735),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_AMP_GT] = ACTIONS(1735),
    [anon_sym_AMP_GT_GT] = ACTIONS(1733),
    [anon_sym_LT_AMP] = ACTIONS(1733),
    [anon_sym_GT_AMP] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1735),
    [anon_sym_LT_LT_DASH] = ACTIONS(1733),
    [anon_sym_LT_LT_LT] = ACTIONS(1733),
    [sym__special_characters] = ACTIONS(1733),
    [anon_sym_DQUOTE] = ACTIONS(1733),
    [anon_sym_DOLLAR] = ACTIONS(1735),
    [sym_raw_string] = ACTIONS(1733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1733),
    [anon_sym_BQUOTE] = ACTIONS(1733),
    [anon_sym_LT_LPAREN] = ACTIONS(1733),
    [anon_sym_GT_LPAREN] = ACTIONS(1733),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1735),
    [sym_word] = ACTIONS(1735),
    [anon_sym_LF] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1735),
  },
  [2431] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(5925),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [2432] = {
    [sym_concatenation] = STATE(2583),
    [sym_string] = STATE(2582),
    [sym_simple_expansion] = STATE(2582),
    [sym_string_expansion] = STATE(2582),
    [sym_expansion] = STATE(2582),
    [sym_command_substitution] = STATE(2582),
    [sym_process_substitution] = STATE(2582),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [sym__special_characters] = ACTIONS(5929),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(5931),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5931),
  },
  [2433] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(5933),
    [sym_comment] = ACTIONS(57),
  },
  [2434] = {
    [sym_concatenation] = STATE(2587),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2587),
    [anon_sym_RBRACE] = ACTIONS(5935),
    [anon_sym_EQ] = ACTIONS(5937),
    [anon_sym_DASH] = ACTIONS(5937),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(5941),
    [anon_sym_COLON] = ACTIONS(5937),
    [anon_sym_COLON_QMARK] = ACTIONS(5937),
    [anon_sym_COLON_DASH] = ACTIONS(5937),
    [anon_sym_PERCENT] = ACTIONS(5937),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2435] = {
    [sym_concatenation] = STATE(2589),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2589),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_EQ] = ACTIONS(5943),
    [anon_sym_DASH] = ACTIONS(5943),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(5947),
    [anon_sym_COLON] = ACTIONS(5943),
    [anon_sym_COLON_QMARK] = ACTIONS(5943),
    [anon_sym_COLON_DASH] = ACTIONS(5943),
    [anon_sym_PERCENT] = ACTIONS(5943),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2436] = {
    [sym__simple_heredoc_body] = ACTIONS(1834),
    [sym__heredoc_body_beginning] = ACTIONS(1834),
    [sym_file_descriptor] = ACTIONS(1834),
    [sym__concat] = ACTIONS(1834),
    [sym_variable_name] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1836),
    [anon_sym_esac] = ACTIONS(1836),
    [anon_sym_PIPE] = ACTIONS(1836),
    [anon_sym_SEMI_SEMI] = ACTIONS(1834),
    [anon_sym_PIPE_AMP] = ACTIONS(1834),
    [anon_sym_AMP_AMP] = ACTIONS(1834),
    [anon_sym_PIPE_PIPE] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1836),
    [anon_sym_GT] = ACTIONS(1836),
    [anon_sym_GT_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT] = ACTIONS(1836),
    [anon_sym_AMP_GT_GT] = ACTIONS(1834),
    [anon_sym_LT_AMP] = ACTIONS(1834),
    [anon_sym_GT_AMP] = ACTIONS(1834),
    [anon_sym_LT_LT] = ACTIONS(1836),
    [anon_sym_LT_LT_DASH] = ACTIONS(1834),
    [anon_sym_LT_LT_LT] = ACTIONS(1834),
    [sym__special_characters] = ACTIONS(1834),
    [anon_sym_DQUOTE] = ACTIONS(1834),
    [anon_sym_DOLLAR] = ACTIONS(1836),
    [sym_raw_string] = ACTIONS(1834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1834),
    [anon_sym_BQUOTE] = ACTIONS(1834),
    [anon_sym_LT_LPAREN] = ACTIONS(1834),
    [anon_sym_GT_LPAREN] = ACTIONS(1834),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1836),
    [sym_word] = ACTIONS(1836),
    [anon_sym_LF] = ACTIONS(1834),
    [anon_sym_AMP] = ACTIONS(1836),
  },
  [2437] = {
    [sym_concatenation] = STATE(2592),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2592),
    [sym_regex] = ACTIONS(5949),
    [anon_sym_RBRACE] = ACTIONS(5951),
    [anon_sym_EQ] = ACTIONS(5953),
    [anon_sym_DASH] = ACTIONS(5953),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_COLON_QMARK] = ACTIONS(5953),
    [anon_sym_COLON_DASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5953),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2438] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5951),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2439] = {
    [sym__simple_heredoc_body] = ACTIONS(1882),
    [sym__heredoc_body_beginning] = ACTIONS(1882),
    [sym_file_descriptor] = ACTIONS(1882),
    [sym__concat] = ACTIONS(1882),
    [sym_variable_name] = ACTIONS(1882),
    [anon_sym_SEMI] = ACTIONS(1884),
    [anon_sym_esac] = ACTIONS(1884),
    [anon_sym_PIPE] = ACTIONS(1884),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [anon_sym_PIPE_AMP] = ACTIONS(1882),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1884),
    [anon_sym_GT_GT] = ACTIONS(1882),
    [anon_sym_AMP_GT] = ACTIONS(1884),
    [anon_sym_AMP_GT_GT] = ACTIONS(1882),
    [anon_sym_LT_AMP] = ACTIONS(1882),
    [anon_sym_GT_AMP] = ACTIONS(1882),
    [anon_sym_LT_LT] = ACTIONS(1884),
    [anon_sym_LT_LT_DASH] = ACTIONS(1882),
    [anon_sym_LT_LT_LT] = ACTIONS(1882),
    [sym__special_characters] = ACTIONS(1882),
    [anon_sym_DQUOTE] = ACTIONS(1882),
    [anon_sym_DOLLAR] = ACTIONS(1884),
    [sym_raw_string] = ACTIONS(1882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1882),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [anon_sym_LT_LPAREN] = ACTIONS(1882),
    [anon_sym_GT_LPAREN] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1884),
    [sym_word] = ACTIONS(1884),
    [anon_sym_LF] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1884),
  },
  [2440] = {
    [sym_concatenation] = STATE(2589),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2589),
    [sym_regex] = ACTIONS(5957),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_EQ] = ACTIONS(5943),
    [anon_sym_DASH] = ACTIONS(5943),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(5945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(5943),
    [anon_sym_COLON_QMARK] = ACTIONS(5943),
    [anon_sym_COLON_DASH] = ACTIONS(5943),
    [anon_sym_PERCENT] = ACTIONS(5943),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2441] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2442] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2443] = {
    [sym__simple_heredoc_body] = ACTIONS(1890),
    [sym__heredoc_body_beginning] = ACTIONS(1890),
    [sym_file_descriptor] = ACTIONS(1890),
    [sym__concat] = ACTIONS(1890),
    [sym_variable_name] = ACTIONS(1890),
    [anon_sym_SEMI] = ACTIONS(1892),
    [anon_sym_esac] = ACTIONS(1892),
    [anon_sym_PIPE] = ACTIONS(1892),
    [anon_sym_SEMI_SEMI] = ACTIONS(1890),
    [anon_sym_PIPE_AMP] = ACTIONS(1890),
    [anon_sym_AMP_AMP] = ACTIONS(1890),
    [anon_sym_PIPE_PIPE] = ACTIONS(1890),
    [anon_sym_LT] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(1892),
    [anon_sym_GT_GT] = ACTIONS(1890),
    [anon_sym_AMP_GT] = ACTIONS(1892),
    [anon_sym_AMP_GT_GT] = ACTIONS(1890),
    [anon_sym_LT_AMP] = ACTIONS(1890),
    [anon_sym_GT_AMP] = ACTIONS(1890),
    [anon_sym_LT_LT] = ACTIONS(1892),
    [anon_sym_LT_LT_DASH] = ACTIONS(1890),
    [anon_sym_LT_LT_LT] = ACTIONS(1890),
    [sym__special_characters] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1890),
    [anon_sym_DOLLAR] = ACTIONS(1892),
    [sym_raw_string] = ACTIONS(1890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1890),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [anon_sym_LT_LPAREN] = ACTIONS(1890),
    [anon_sym_GT_LPAREN] = ACTIONS(1890),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1892),
    [sym_word] = ACTIONS(1892),
    [anon_sym_LF] = ACTIONS(1890),
    [anon_sym_AMP] = ACTIONS(1892),
  },
  [2444] = {
    [anon_sym_SEMI] = ACTIONS(5961),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_SEMI_SEMI] = ACTIONS(5963),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5963),
    [anon_sym_AMP] = ACTIONS(5963),
  },
  [2445] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2597),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(5965),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_SEMI_SEMI] = ACTIONS(5967),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5967),
    [anon_sym_AMP] = ACTIONS(5965),
  },
  [2446] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2597),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5965),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_SEMI_SEMI] = ACTIONS(5967),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5967),
    [anon_sym_AMP] = ACTIONS(5965),
  },
  [2447] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(5959),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2448] = {
    [anon_sym_SEMI] = ACTIONS(5969),
    [anon_sym_SEMI_SEMI] = ACTIONS(5971),
    [anon_sym_BQUOTE] = ACTIONS(5959),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5971),
    [anon_sym_AMP] = ACTIONS(5971),
  },
  [2449] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2600),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(5973),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(5975),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(5959),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5975),
    [anon_sym_AMP] = ACTIONS(5973),
  },
  [2450] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2600),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5973),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(5975),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(5959),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5975),
    [anon_sym_AMP] = ACTIONS(5973),
  },
  [2451] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(5977),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2452] = {
    [sym__simple_heredoc_body] = ACTIONS(1924),
    [sym__heredoc_body_beginning] = ACTIONS(1924),
    [sym_file_descriptor] = ACTIONS(1924),
    [sym__concat] = ACTIONS(1924),
    [sym_variable_name] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_esac] = ACTIONS(1926),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [anon_sym_PIPE_AMP] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_GT_GT] = ACTIONS(1924),
    [anon_sym_AMP_GT] = ACTIONS(1926),
    [anon_sym_AMP_GT_GT] = ACTIONS(1924),
    [anon_sym_LT_AMP] = ACTIONS(1924),
    [anon_sym_GT_AMP] = ACTIONS(1924),
    [anon_sym_LT_LT] = ACTIONS(1926),
    [anon_sym_LT_LT_DASH] = ACTIONS(1924),
    [anon_sym_LT_LT_LT] = ACTIONS(1924),
    [sym__special_characters] = ACTIONS(1924),
    [anon_sym_DQUOTE] = ACTIONS(1924),
    [anon_sym_DOLLAR] = ACTIONS(1926),
    [sym_raw_string] = ACTIONS(1924),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1924),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1924),
    [anon_sym_BQUOTE] = ACTIONS(1924),
    [anon_sym_LT_LPAREN] = ACTIONS(1924),
    [anon_sym_GT_LPAREN] = ACTIONS(1924),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1926),
    [sym_word] = ACTIONS(1926),
    [anon_sym_LF] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1926),
  },
  [2453] = {
    [anon_sym_SEMI] = ACTIONS(5979),
    [anon_sym_RPAREN] = ACTIONS(5977),
    [anon_sym_SEMI_SEMI] = ACTIONS(5981),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5981),
    [anon_sym_AMP] = ACTIONS(5981),
  },
  [2454] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2604),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(5983),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5977),
    [anon_sym_SEMI_SEMI] = ACTIONS(5985),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5985),
    [anon_sym_AMP] = ACTIONS(5983),
  },
  [2455] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2604),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(5983),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(5977),
    [anon_sym_SEMI_SEMI] = ACTIONS(5985),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(5985),
    [anon_sym_AMP] = ACTIONS(5983),
  },
  [2456] = {
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_esac] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1728),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [2457] = {
    [aux_sym_concatenation_repeat1] = STATE(2457),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(5987),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_esac] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1728),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [2458] = {
    [sym__simple_heredoc_body] = ACTIONS(1733),
    [sym__heredoc_body_beginning] = ACTIONS(1733),
    [sym_file_descriptor] = ACTIONS(1733),
    [sym__concat] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_esac] = ACTIONS(1735),
    [anon_sym_PIPE] = ACTIONS(1735),
    [anon_sym_SEMI_SEMI] = ACTIONS(1733),
    [anon_sym_PIPE_AMP] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1735),
    [anon_sym_GT] = ACTIONS(1735),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_AMP_GT] = ACTIONS(1735),
    [anon_sym_AMP_GT_GT] = ACTIONS(1733),
    [anon_sym_LT_AMP] = ACTIONS(1733),
    [anon_sym_GT_AMP] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1735),
    [anon_sym_LT_LT_DASH] = ACTIONS(1733),
    [anon_sym_LT_LT_LT] = ACTIONS(1733),
    [sym__special_characters] = ACTIONS(1733),
    [anon_sym_DQUOTE] = ACTIONS(1733),
    [anon_sym_DOLLAR] = ACTIONS(1735),
    [sym_raw_string] = ACTIONS(1733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1733),
    [anon_sym_BQUOTE] = ACTIONS(1733),
    [anon_sym_LT_LPAREN] = ACTIONS(1733),
    [anon_sym_GT_LPAREN] = ACTIONS(1733),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1735),
    [sym_word] = ACTIONS(1735),
    [anon_sym_LF] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1735),
  },
  [2459] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(5990),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [2460] = {
    [sym_concatenation] = STATE(2609),
    [sym_string] = STATE(2608),
    [sym_simple_expansion] = STATE(2608),
    [sym_string_expansion] = STATE(2608),
    [sym_expansion] = STATE(2608),
    [sym_command_substitution] = STATE(2608),
    [sym_process_substitution] = STATE(2608),
    [anon_sym_RBRACE] = ACTIONS(5992),
    [sym__special_characters] = ACTIONS(5994),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(5996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5996),
  },
  [2461] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(5998),
    [sym_comment] = ACTIONS(57),
  },
  [2462] = {
    [sym_concatenation] = STATE(2613),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2613),
    [anon_sym_RBRACE] = ACTIONS(6000),
    [anon_sym_EQ] = ACTIONS(6002),
    [anon_sym_DASH] = ACTIONS(6002),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6004),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(6006),
    [anon_sym_COLON] = ACTIONS(6002),
    [anon_sym_COLON_QMARK] = ACTIONS(6002),
    [anon_sym_COLON_DASH] = ACTIONS(6002),
    [anon_sym_PERCENT] = ACTIONS(6002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2463] = {
    [sym_concatenation] = STATE(2615),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2615),
    [anon_sym_RBRACE] = ACTIONS(5992),
    [anon_sym_EQ] = ACTIONS(6008),
    [anon_sym_DASH] = ACTIONS(6008),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(6012),
    [anon_sym_COLON] = ACTIONS(6008),
    [anon_sym_COLON_QMARK] = ACTIONS(6008),
    [anon_sym_COLON_DASH] = ACTIONS(6008),
    [anon_sym_PERCENT] = ACTIONS(6008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2464] = {
    [sym__simple_heredoc_body] = ACTIONS(1834),
    [sym__heredoc_body_beginning] = ACTIONS(1834),
    [sym_file_descriptor] = ACTIONS(1834),
    [sym__concat] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1836),
    [anon_sym_esac] = ACTIONS(1836),
    [anon_sym_PIPE] = ACTIONS(1836),
    [anon_sym_SEMI_SEMI] = ACTIONS(1834),
    [anon_sym_PIPE_AMP] = ACTIONS(1834),
    [anon_sym_AMP_AMP] = ACTIONS(1834),
    [anon_sym_PIPE_PIPE] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1836),
    [anon_sym_GT] = ACTIONS(1836),
    [anon_sym_GT_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT] = ACTIONS(1836),
    [anon_sym_AMP_GT_GT] = ACTIONS(1834),
    [anon_sym_LT_AMP] = ACTIONS(1834),
    [anon_sym_GT_AMP] = ACTIONS(1834),
    [anon_sym_LT_LT] = ACTIONS(1836),
    [anon_sym_LT_LT_DASH] = ACTIONS(1834),
    [anon_sym_LT_LT_LT] = ACTIONS(1834),
    [sym__special_characters] = ACTIONS(1834),
    [anon_sym_DQUOTE] = ACTIONS(1834),
    [anon_sym_DOLLAR] = ACTIONS(1836),
    [sym_raw_string] = ACTIONS(1834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1834),
    [anon_sym_BQUOTE] = ACTIONS(1834),
    [anon_sym_LT_LPAREN] = ACTIONS(1834),
    [anon_sym_GT_LPAREN] = ACTIONS(1834),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1836),
    [sym_word] = ACTIONS(1836),
    [anon_sym_LF] = ACTIONS(1834),
    [anon_sym_AMP] = ACTIONS(1836),
  },
  [2465] = {
    [sym_concatenation] = STATE(2618),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2618),
    [sym_regex] = ACTIONS(6014),
    [anon_sym_RBRACE] = ACTIONS(6016),
    [anon_sym_EQ] = ACTIONS(6018),
    [anon_sym_DASH] = ACTIONS(6018),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6018),
    [anon_sym_COLON_QMARK] = ACTIONS(6018),
    [anon_sym_COLON_DASH] = ACTIONS(6018),
    [anon_sym_PERCENT] = ACTIONS(6018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2466] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6016),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2467] = {
    [sym__simple_heredoc_body] = ACTIONS(1882),
    [sym__heredoc_body_beginning] = ACTIONS(1882),
    [sym_file_descriptor] = ACTIONS(1882),
    [sym__concat] = ACTIONS(1882),
    [anon_sym_SEMI] = ACTIONS(1884),
    [anon_sym_esac] = ACTIONS(1884),
    [anon_sym_PIPE] = ACTIONS(1884),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [anon_sym_PIPE_AMP] = ACTIONS(1882),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1884),
    [anon_sym_GT_GT] = ACTIONS(1882),
    [anon_sym_AMP_GT] = ACTIONS(1884),
    [anon_sym_AMP_GT_GT] = ACTIONS(1882),
    [anon_sym_LT_AMP] = ACTIONS(1882),
    [anon_sym_GT_AMP] = ACTIONS(1882),
    [anon_sym_LT_LT] = ACTIONS(1884),
    [anon_sym_LT_LT_DASH] = ACTIONS(1882),
    [anon_sym_LT_LT_LT] = ACTIONS(1882),
    [sym__special_characters] = ACTIONS(1882),
    [anon_sym_DQUOTE] = ACTIONS(1882),
    [anon_sym_DOLLAR] = ACTIONS(1884),
    [sym_raw_string] = ACTIONS(1882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1882),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [anon_sym_LT_LPAREN] = ACTIONS(1882),
    [anon_sym_GT_LPAREN] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1884),
    [sym_word] = ACTIONS(1884),
    [anon_sym_LF] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1884),
  },
  [2468] = {
    [sym_concatenation] = STATE(2615),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2615),
    [sym_regex] = ACTIONS(6022),
    [anon_sym_RBRACE] = ACTIONS(5992),
    [anon_sym_EQ] = ACTIONS(6008),
    [anon_sym_DASH] = ACTIONS(6008),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6008),
    [anon_sym_COLON_QMARK] = ACTIONS(6008),
    [anon_sym_COLON_DASH] = ACTIONS(6008),
    [anon_sym_PERCENT] = ACTIONS(6008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2469] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(5992),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2470] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(6024),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2471] = {
    [sym__simple_heredoc_body] = ACTIONS(1890),
    [sym__heredoc_body_beginning] = ACTIONS(1890),
    [sym_file_descriptor] = ACTIONS(1890),
    [sym__concat] = ACTIONS(1890),
    [anon_sym_SEMI] = ACTIONS(1892),
    [anon_sym_esac] = ACTIONS(1892),
    [anon_sym_PIPE] = ACTIONS(1892),
    [anon_sym_SEMI_SEMI] = ACTIONS(1890),
    [anon_sym_PIPE_AMP] = ACTIONS(1890),
    [anon_sym_AMP_AMP] = ACTIONS(1890),
    [anon_sym_PIPE_PIPE] = ACTIONS(1890),
    [anon_sym_LT] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(1892),
    [anon_sym_GT_GT] = ACTIONS(1890),
    [anon_sym_AMP_GT] = ACTIONS(1892),
    [anon_sym_AMP_GT_GT] = ACTIONS(1890),
    [anon_sym_LT_AMP] = ACTIONS(1890),
    [anon_sym_GT_AMP] = ACTIONS(1890),
    [anon_sym_LT_LT] = ACTIONS(1892),
    [anon_sym_LT_LT_DASH] = ACTIONS(1890),
    [anon_sym_LT_LT_LT] = ACTIONS(1890),
    [sym__special_characters] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1890),
    [anon_sym_DOLLAR] = ACTIONS(1892),
    [sym_raw_string] = ACTIONS(1890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1890),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [anon_sym_LT_LPAREN] = ACTIONS(1890),
    [anon_sym_GT_LPAREN] = ACTIONS(1890),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1892),
    [sym_word] = ACTIONS(1892),
    [anon_sym_LF] = ACTIONS(1890),
    [anon_sym_AMP] = ACTIONS(1892),
  },
  [2472] = {
    [anon_sym_SEMI] = ACTIONS(6026),
    [anon_sym_RPAREN] = ACTIONS(6024),
    [anon_sym_SEMI_SEMI] = ACTIONS(6028),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6028),
    [anon_sym_AMP] = ACTIONS(6028),
  },
  [2473] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2623),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(6030),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(6024),
    [anon_sym_SEMI_SEMI] = ACTIONS(6032),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6032),
    [anon_sym_AMP] = ACTIONS(6030),
  },
  [2474] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2623),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(6030),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(6024),
    [anon_sym_SEMI_SEMI] = ACTIONS(6032),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(6032),
    [anon_sym_AMP] = ACTIONS(6030),
  },
  [2475] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(6024),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2476] = {
    [anon_sym_SEMI] = ACTIONS(6034),
    [anon_sym_SEMI_SEMI] = ACTIONS(6036),
    [anon_sym_BQUOTE] = ACTIONS(6024),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6036),
    [anon_sym_AMP] = ACTIONS(6036),
  },
  [2477] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2626),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(6038),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(6040),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(6024),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(6038),
  },
  [2478] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2626),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(6038),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(6040),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(6024),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(6038),
  },
  [2479] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(6042),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2480] = {
    [sym__simple_heredoc_body] = ACTIONS(1924),
    [sym__heredoc_body_beginning] = ACTIONS(1924),
    [sym_file_descriptor] = ACTIONS(1924),
    [sym__concat] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_esac] = ACTIONS(1926),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [anon_sym_PIPE_AMP] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_GT_GT] = ACTIONS(1924),
    [anon_sym_AMP_GT] = ACTIONS(1926),
    [anon_sym_AMP_GT_GT] = ACTIONS(1924),
    [anon_sym_LT_AMP] = ACTIONS(1924),
    [anon_sym_GT_AMP] = ACTIONS(1924),
    [anon_sym_LT_LT] = ACTIONS(1926),
    [anon_sym_LT_LT_DASH] = ACTIONS(1924),
    [anon_sym_LT_LT_LT] = ACTIONS(1924),
    [sym__special_characters] = ACTIONS(1924),
    [anon_sym_DQUOTE] = ACTIONS(1924),
    [anon_sym_DOLLAR] = ACTIONS(1926),
    [sym_raw_string] = ACTIONS(1924),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1924),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1924),
    [anon_sym_BQUOTE] = ACTIONS(1924),
    [anon_sym_LT_LPAREN] = ACTIONS(1924),
    [anon_sym_GT_LPAREN] = ACTIONS(1924),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1926),
    [sym_word] = ACTIONS(1926),
    [anon_sym_LF] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1926),
  },
  [2481] = {
    [anon_sym_SEMI] = ACTIONS(6044),
    [anon_sym_RPAREN] = ACTIONS(6042),
    [anon_sym_SEMI_SEMI] = ACTIONS(6046),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6046),
    [anon_sym_AMP] = ACTIONS(6046),
  },
  [2482] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2630),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(6048),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(6042),
    [anon_sym_SEMI_SEMI] = ACTIONS(6050),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6050),
    [anon_sym_AMP] = ACTIONS(6048),
  },
  [2483] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2630),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(6048),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(6042),
    [anon_sym_SEMI_SEMI] = ACTIONS(6050),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(6050),
    [anon_sym_AMP] = ACTIONS(6048),
  },
  [2484] = {
    [sym__simple_heredoc_body] = ACTIONS(2930),
    [sym__heredoc_body_beginning] = ACTIONS(2930),
    [sym_file_descriptor] = ACTIONS(2930),
    [sym__concat] = ACTIONS(2930),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym_esac] = ACTIONS(2932),
    [anon_sym_PIPE] = ACTIONS(2932),
    [anon_sym_SEMI_SEMI] = ACTIONS(2930),
    [anon_sym_PIPE_AMP] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_EQ_TILDE] = ACTIONS(2932),
    [anon_sym_EQ_EQ] = ACTIONS(2932),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2932),
    [anon_sym_GT_GT] = ACTIONS(2930),
    [anon_sym_AMP_GT] = ACTIONS(2932),
    [anon_sym_AMP_GT_GT] = ACTIONS(2930),
    [anon_sym_LT_AMP] = ACTIONS(2930),
    [anon_sym_GT_AMP] = ACTIONS(2930),
    [anon_sym_LT_LT] = ACTIONS(2932),
    [anon_sym_LT_LT_DASH] = ACTIONS(2930),
    [anon_sym_LT_LT_LT] = ACTIONS(2930),
    [sym__special_characters] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_DOLLAR] = ACTIONS(2932),
    [sym_raw_string] = ACTIONS(2930),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2930),
    [anon_sym_BQUOTE] = ACTIONS(2930),
    [anon_sym_LT_LPAREN] = ACTIONS(2930),
    [anon_sym_GT_LPAREN] = ACTIONS(2930),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2932),
    [anon_sym_LF] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2932),
  },
  [2485] = {
    [sym__simple_heredoc_body] = ACTIONS(2944),
    [sym__heredoc_body_beginning] = ACTIONS(2944),
    [sym_file_descriptor] = ACTIONS(2944),
    [sym__concat] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym_esac] = ACTIONS(2946),
    [anon_sym_PIPE] = ACTIONS(2946),
    [anon_sym_SEMI_SEMI] = ACTIONS(2944),
    [anon_sym_PIPE_AMP] = ACTIONS(2944),
    [anon_sym_AMP_AMP] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2944),
    [anon_sym_EQ_TILDE] = ACTIONS(2946),
    [anon_sym_EQ_EQ] = ACTIONS(2946),
    [anon_sym_LT] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2946),
    [anon_sym_GT_GT] = ACTIONS(2944),
    [anon_sym_AMP_GT] = ACTIONS(2946),
    [anon_sym_AMP_GT_GT] = ACTIONS(2944),
    [anon_sym_LT_AMP] = ACTIONS(2944),
    [anon_sym_GT_AMP] = ACTIONS(2944),
    [anon_sym_LT_LT] = ACTIONS(2946),
    [anon_sym_LT_LT_DASH] = ACTIONS(2944),
    [anon_sym_LT_LT_LT] = ACTIONS(2944),
    [sym__special_characters] = ACTIONS(2944),
    [anon_sym_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [sym_raw_string] = ACTIONS(2944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2944),
    [anon_sym_BQUOTE] = ACTIONS(2944),
    [anon_sym_LT_LPAREN] = ACTIONS(2944),
    [anon_sym_GT_LPAREN] = ACTIONS(2944),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2946),
    [anon_sym_LF] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2946),
  },
  [2486] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6052),
    [sym_comment] = ACTIONS(57),
  },
  [2487] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6054),
    [sym_comment] = ACTIONS(57),
  },
  [2488] = {
    [anon_sym_RBRACE] = ACTIONS(6054),
    [sym_comment] = ACTIONS(57),
  },
  [2489] = {
    [sym_concatenation] = STATE(2635),
    [sym_string] = STATE(2634),
    [sym_simple_expansion] = STATE(2634),
    [sym_string_expansion] = STATE(2634),
    [sym_expansion] = STATE(2634),
    [sym_command_substitution] = STATE(2634),
    [sym_process_substitution] = STATE(2634),
    [anon_sym_RBRACE] = ACTIONS(6054),
    [sym__special_characters] = ACTIONS(6056),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(6058),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6058),
  },
  [2490] = {
    [sym__simple_heredoc_body] = ACTIONS(2980),
    [sym__heredoc_body_beginning] = ACTIONS(2980),
    [sym_file_descriptor] = ACTIONS(2980),
    [sym__concat] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym_esac] = ACTIONS(2982),
    [anon_sym_PIPE] = ACTIONS(2982),
    [anon_sym_SEMI_SEMI] = ACTIONS(2980),
    [anon_sym_PIPE_AMP] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_PIPE_PIPE] = ACTIONS(2980),
    [anon_sym_EQ_TILDE] = ACTIONS(2982),
    [anon_sym_EQ_EQ] = ACTIONS(2982),
    [anon_sym_LT] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2982),
    [anon_sym_GT_GT] = ACTIONS(2980),
    [anon_sym_AMP_GT] = ACTIONS(2982),
    [anon_sym_AMP_GT_GT] = ACTIONS(2980),
    [anon_sym_LT_AMP] = ACTIONS(2980),
    [anon_sym_GT_AMP] = ACTIONS(2980),
    [anon_sym_LT_LT] = ACTIONS(2982),
    [anon_sym_LT_LT_DASH] = ACTIONS(2980),
    [anon_sym_LT_LT_LT] = ACTIONS(2980),
    [sym__special_characters] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2982),
    [sym_raw_string] = ACTIONS(2980),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2980),
    [anon_sym_BQUOTE] = ACTIONS(2980),
    [anon_sym_LT_LPAREN] = ACTIONS(2980),
    [anon_sym_GT_LPAREN] = ACTIONS(2980),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2982),
    [anon_sym_LF] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2982),
  },
  [2491] = {
    [sym_concatenation] = STATE(2638),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2638),
    [sym_regex] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6064),
    [anon_sym_DASH] = ACTIONS(6064),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6066),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6064),
    [anon_sym_COLON_QMARK] = ACTIONS(6064),
    [anon_sym_COLON_DASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2492] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2493] = {
    [sym_concatenation] = STATE(2640),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2640),
    [sym_regex] = ACTIONS(6068),
    [anon_sym_RBRACE] = ACTIONS(6054),
    [anon_sym_EQ] = ACTIONS(6070),
    [anon_sym_DASH] = ACTIONS(6070),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6072),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6070),
    [anon_sym_COLON_QMARK] = ACTIONS(6070),
    [anon_sym_COLON_DASH] = ACTIONS(6070),
    [anon_sym_PERCENT] = ACTIONS(6070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2494] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6054),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2495] = {
    [sym_concatenation] = STATE(2642),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2642),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_EQ] = ACTIONS(6076),
    [anon_sym_DASH] = ACTIONS(6076),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6076),
    [anon_sym_COLON_QMARK] = ACTIONS(6076),
    [anon_sym_COLON_DASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2496] = {
    [sym__simple_heredoc_body] = ACTIONS(3036),
    [sym__heredoc_body_beginning] = ACTIONS(3036),
    [sym_file_descriptor] = ACTIONS(3036),
    [sym__concat] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym_esac] = ACTIONS(3038),
    [anon_sym_PIPE] = ACTIONS(3038),
    [anon_sym_SEMI_SEMI] = ACTIONS(3036),
    [anon_sym_PIPE_AMP] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_PIPE_PIPE] = ACTIONS(3036),
    [anon_sym_EQ_TILDE] = ACTIONS(3038),
    [anon_sym_EQ_EQ] = ACTIONS(3038),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_GT] = ACTIONS(3038),
    [anon_sym_GT_GT] = ACTIONS(3036),
    [anon_sym_AMP_GT] = ACTIONS(3038),
    [anon_sym_AMP_GT_GT] = ACTIONS(3036),
    [anon_sym_LT_AMP] = ACTIONS(3036),
    [anon_sym_GT_AMP] = ACTIONS(3036),
    [anon_sym_LT_LT] = ACTIONS(3038),
    [anon_sym_LT_LT_DASH] = ACTIONS(3036),
    [anon_sym_LT_LT_LT] = ACTIONS(3036),
    [sym__special_characters] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [anon_sym_DOLLAR] = ACTIONS(3038),
    [sym_raw_string] = ACTIONS(3036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3036),
    [anon_sym_BQUOTE] = ACTIONS(3036),
    [anon_sym_LT_LPAREN] = ACTIONS(3036),
    [anon_sym_GT_LPAREN] = ACTIONS(3036),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3038),
    [anon_sym_LF] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3038),
  },
  [2497] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2498] = {
    [sym_concatenation] = STATE(2640),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2640),
    [anon_sym_RBRACE] = ACTIONS(6054),
    [anon_sym_EQ] = ACTIONS(6070),
    [anon_sym_DASH] = ACTIONS(6070),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6072),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6070),
    [anon_sym_COLON_QMARK] = ACTIONS(6070),
    [anon_sym_COLON_DASH] = ACTIONS(6070),
    [anon_sym_PERCENT] = ACTIONS(6070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2499] = {
    [sym__simple_heredoc_body] = ACTIONS(3091),
    [sym__heredoc_body_beginning] = ACTIONS(3091),
    [sym_file_descriptor] = ACTIONS(3091),
    [sym__concat] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_esac] = ACTIONS(3093),
    [anon_sym_PIPE] = ACTIONS(3093),
    [anon_sym_SEMI_SEMI] = ACTIONS(3091),
    [anon_sym_PIPE_AMP] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_EQ_TILDE] = ACTIONS(3093),
    [anon_sym_EQ_EQ] = ACTIONS(3093),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_GT] = ACTIONS(3093),
    [anon_sym_GT_GT] = ACTIONS(3091),
    [anon_sym_AMP_GT] = ACTIONS(3093),
    [anon_sym_AMP_GT_GT] = ACTIONS(3091),
    [anon_sym_LT_AMP] = ACTIONS(3091),
    [anon_sym_GT_AMP] = ACTIONS(3091),
    [anon_sym_LT_LT] = ACTIONS(3093),
    [anon_sym_LT_LT_DASH] = ACTIONS(3091),
    [anon_sym_LT_LT_LT] = ACTIONS(3091),
    [sym__special_characters] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_DOLLAR] = ACTIONS(3093),
    [sym_raw_string] = ACTIONS(3091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3091),
    [anon_sym_BQUOTE] = ACTIONS(3091),
    [anon_sym_LT_LPAREN] = ACTIONS(3091),
    [anon_sym_GT_LPAREN] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3093),
    [anon_sym_LF] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3093),
  },
  [2500] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6080),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2501] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(6080),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2502] = {
    [anon_sym_SEMI] = ACTIONS(6082),
    [anon_sym_RPAREN] = ACTIONS(6080),
    [anon_sym_SEMI_SEMI] = ACTIONS(6084),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6084),
    [anon_sym_AMP] = ACTIONS(6084),
  },
  [2503] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(6080),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2504] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(6080),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2505] = {
    [anon_sym_SEMI] = ACTIONS(6086),
    [anon_sym_SEMI_SEMI] = ACTIONS(6088),
    [anon_sym_BQUOTE] = ACTIONS(6080),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6088),
    [anon_sym_AMP] = ACTIONS(6088),
  },
  [2506] = {
    [sym__simple_heredoc_body] = ACTIONS(3121),
    [sym__heredoc_body_beginning] = ACTIONS(3121),
    [sym_file_descriptor] = ACTIONS(3121),
    [sym__concat] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3123),
    [anon_sym_esac] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3123),
    [anon_sym_SEMI_SEMI] = ACTIONS(3121),
    [anon_sym_PIPE_AMP] = ACTIONS(3121),
    [anon_sym_AMP_AMP] = ACTIONS(3121),
    [anon_sym_PIPE_PIPE] = ACTIONS(3121),
    [anon_sym_EQ_TILDE] = ACTIONS(3123),
    [anon_sym_EQ_EQ] = ACTIONS(3123),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_GT] = ACTIONS(3123),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_AMP_GT] = ACTIONS(3123),
    [anon_sym_AMP_GT_GT] = ACTIONS(3121),
    [anon_sym_LT_AMP] = ACTIONS(3121),
    [anon_sym_GT_AMP] = ACTIONS(3121),
    [anon_sym_LT_LT] = ACTIONS(3123),
    [anon_sym_LT_LT_DASH] = ACTIONS(3121),
    [anon_sym_LT_LT_LT] = ACTIONS(3121),
    [sym__special_characters] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [sym_raw_string] = ACTIONS(3121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3121),
    [anon_sym_BQUOTE] = ACTIONS(3121),
    [anon_sym_LT_LPAREN] = ACTIONS(3121),
    [anon_sym_GT_LPAREN] = ACTIONS(3121),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3123),
    [anon_sym_LF] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
  },
  [2507] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6090),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2508] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(6090),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2509] = {
    [anon_sym_SEMI] = ACTIONS(6092),
    [anon_sym_RPAREN] = ACTIONS(6090),
    [anon_sym_SEMI_SEMI] = ACTIONS(6094),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6094),
    [anon_sym_AMP] = ACTIONS(6094),
  },
  [2510] = {
    [aux_sym_concatenation_repeat1] = STATE(2513),
    [sym__simple_heredoc_body] = ACTIONS(1067),
    [sym__heredoc_body_beginning] = ACTIONS(1067),
    [sym_file_descriptor] = ACTIONS(1067),
    [sym__concat] = ACTIONS(5768),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_esac] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1069),
    [anon_sym_SEMI_SEMI] = ACTIONS(1067),
    [anon_sym_PIPE_AMP] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1069),
    [anon_sym_GT_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT] = ACTIONS(1069),
    [anon_sym_AMP_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_AMP] = ACTIONS(1067),
    [anon_sym_GT_AMP] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1069),
    [anon_sym_LT_LT_DASH] = ACTIONS(1067),
    [anon_sym_LT_LT_LT] = ACTIONS(1067),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1069),
  },
  [2511] = {
    [aux_sym_concatenation_repeat1] = STATE(2513),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(5768),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_esac] = ACTIONS(1071),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
  },
  [2512] = {
    [sym_string] = STATE(2648),
    [sym_simple_expansion] = STATE(2648),
    [sym_string_expansion] = STATE(2648),
    [sym_expansion] = STATE(2648),
    [sym_command_substitution] = STATE(2648),
    [sym_process_substitution] = STATE(2648),
    [sym__special_characters] = ACTIONS(6096),
    [anon_sym_DQUOTE] = ACTIONS(5404),
    [anon_sym_DOLLAR] = ACTIONS(5406),
    [sym_raw_string] = ACTIONS(6096),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5412),
    [anon_sym_BQUOTE] = ACTIONS(5414),
    [anon_sym_LT_LPAREN] = ACTIONS(5416),
    [anon_sym_GT_LPAREN] = ACTIONS(5416),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6096),
  },
  [2513] = {
    [aux_sym_concatenation_repeat1] = STATE(2649),
    [sym__simple_heredoc_body] = ACTIONS(779),
    [sym__heredoc_body_beginning] = ACTIONS(779),
    [sym_file_descriptor] = ACTIONS(779),
    [sym__concat] = ACTIONS(5768),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_esac] = ACTIONS(779),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_SEMI_SEMI] = ACTIONS(779),
    [anon_sym_PIPE_AMP] = ACTIONS(779),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_AMP_GT] = ACTIONS(781),
    [anon_sym_AMP_GT_GT] = ACTIONS(779),
    [anon_sym_LT_AMP] = ACTIONS(779),
    [anon_sym_GT_AMP] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT_LT_DASH] = ACTIONS(779),
    [anon_sym_LT_LT_LT] = ACTIONS(779),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(781),
  },
  [2514] = {
    [sym__simple_heredoc_body] = ACTIONS(783),
    [sym__heredoc_body_beginning] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(783),
    [sym__concat] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_esac] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [anon_sym_PIPE_AMP] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(783),
    [anon_sym_AMP_GT] = ACTIONS(785),
    [anon_sym_AMP_GT_GT] = ACTIONS(783),
    [anon_sym_LT_AMP] = ACTIONS(783),
    [anon_sym_GT_AMP] = ACTIONS(783),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_DASH] = ACTIONS(783),
    [anon_sym_LT_LT_LT] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
  },
  [2515] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(6098),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [2516] = {
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [aux_sym_string_repeat1] = STATE(455),
    [anon_sym_DQUOTE] = ACTIONS(6098),
    [anon_sym_DOLLAR] = ACTIONS(6100),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [2517] = {
    [sym__simple_heredoc_body] = ACTIONS(817),
    [sym__heredoc_body_beginning] = ACTIONS(817),
    [sym_file_descriptor] = ACTIONS(817),
    [sym__concat] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(819),
    [anon_sym_esac] = ACTIONS(817),
    [anon_sym_PIPE] = ACTIONS(819),
    [anon_sym_SEMI_SEMI] = ACTIONS(817),
    [anon_sym_PIPE_AMP] = ACTIONS(817),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(817),
    [anon_sym_AMP_GT] = ACTIONS(819),
    [anon_sym_AMP_GT_GT] = ACTIONS(817),
    [anon_sym_LT_AMP] = ACTIONS(817),
    [anon_sym_GT_AMP] = ACTIONS(817),
    [anon_sym_LT_LT] = ACTIONS(819),
    [anon_sym_LT_LT_DASH] = ACTIONS(817),
    [anon_sym_LT_LT_LT] = ACTIONS(817),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(819),
  },
  [2518] = {
    [sym__simple_heredoc_body] = ACTIONS(821),
    [sym__heredoc_body_beginning] = ACTIONS(821),
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_esac] = ACTIONS(821),
    [anon_sym_PIPE] = ACTIONS(823),
    [anon_sym_SEMI_SEMI] = ACTIONS(821),
    [anon_sym_PIPE_AMP] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(823),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(823),
    [anon_sym_LT_LT_DASH] = ACTIONS(821),
    [anon_sym_LT_LT_LT] = ACTIONS(821),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [2519] = {
    [sym__simple_heredoc_body] = ACTIONS(825),
    [sym__heredoc_body_beginning] = ACTIONS(825),
    [sym_file_descriptor] = ACTIONS(825),
    [sym__concat] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(827),
    [anon_sym_esac] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(827),
    [anon_sym_SEMI_SEMI] = ACTIONS(825),
    [anon_sym_PIPE_AMP] = ACTIONS(825),
    [anon_sym_AMP_AMP] = ACTIONS(825),
    [anon_sym_PIPE_PIPE] = ACTIONS(825),
    [anon_sym_LT] = ACTIONS(827),
    [anon_sym_GT] = ACTIONS(827),
    [anon_sym_GT_GT] = ACTIONS(825),
    [anon_sym_AMP_GT] = ACTIONS(827),
    [anon_sym_AMP_GT_GT] = ACTIONS(825),
    [anon_sym_LT_AMP] = ACTIONS(825),
    [anon_sym_GT_AMP] = ACTIONS(825),
    [anon_sym_LT_LT] = ACTIONS(827),
    [anon_sym_LT_LT_DASH] = ACTIONS(825),
    [anon_sym_LT_LT_LT] = ACTIONS(825),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(827),
  },
  [2520] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(6102),
    [sym_comment] = ACTIONS(57),
  },
  [2521] = {
    [sym_subscript] = STATE(2655),
    [sym_variable_name] = ACTIONS(6104),
    [anon_sym_DASH] = ACTIONS(6106),
    [anon_sym_DOLLAR] = ACTIONS(6106),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6108),
    [anon_sym_STAR] = ACTIONS(6110),
    [anon_sym_AT] = ACTIONS(6110),
    [anon_sym_QMARK] = ACTIONS(6110),
    [anon_sym_0] = ACTIONS(6108),
    [anon_sym__] = ACTIONS(6108),
  },
  [2522] = {
    [sym_concatenation] = STATE(2658),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2658),
    [anon_sym_RBRACE] = ACTIONS(6112),
    [anon_sym_EQ] = ACTIONS(6114),
    [anon_sym_DASH] = ACTIONS(6114),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6116),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(6118),
    [anon_sym_COLON] = ACTIONS(6114),
    [anon_sym_COLON_QMARK] = ACTIONS(6114),
    [anon_sym_COLON_DASH] = ACTIONS(6114),
    [anon_sym_PERCENT] = ACTIONS(6114),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2523] = {
    [sym_concatenation] = STATE(2661),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2661),
    [anon_sym_RBRACE] = ACTIONS(6120),
    [anon_sym_EQ] = ACTIONS(6122),
    [anon_sym_DASH] = ACTIONS(6122),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(6126),
    [anon_sym_COLON] = ACTIONS(6122),
    [anon_sym_COLON_QMARK] = ACTIONS(6122),
    [anon_sym_COLON_DASH] = ACTIONS(6122),
    [anon_sym_PERCENT] = ACTIONS(6122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2524] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2664),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(6128),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(6130),
    [anon_sym_SEMI_SEMI] = ACTIONS(6132),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6132),
    [anon_sym_AMP] = ACTIONS(6128),
  },
  [2525] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2664),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(6128),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(6130),
    [anon_sym_SEMI_SEMI] = ACTIONS(6132),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(6132),
    [anon_sym_AMP] = ACTIONS(6128),
  },
  [2526] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(2665),
    [sym_for_statement] = STATE(2665),
    [sym_c_style_for_statement] = STATE(2665),
    [sym_while_statement] = STATE(2665),
    [sym_if_statement] = STATE(2665),
    [sym_case_statement] = STATE(2665),
    [sym_function_definition] = STATE(2665),
    [sym_compound_statement] = STATE(2665),
    [sym_subshell] = STATE(2665),
    [sym_pipeline] = STATE(2665),
    [sym_list] = STATE(2665),
    [sym_negated_command] = STATE(2665),
    [sym_test_command] = STATE(2665),
    [sym_declaration_command] = STATE(2665),
    [sym_unset_command] = STATE(2665),
    [sym_command] = STATE(2665),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2666),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [2527] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2668),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(6134),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(6136),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(6130),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6136),
    [anon_sym_AMP] = ACTIONS(6134),
  },
  [2528] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2668),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(6134),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(6136),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(6130),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(6136),
    [anon_sym_AMP] = ACTIONS(6134),
  },
  [2529] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(2669),
    [sym_for_statement] = STATE(2669),
    [sym_c_style_for_statement] = STATE(2669),
    [sym_while_statement] = STATE(2669),
    [sym_if_statement] = STATE(2669),
    [sym_case_statement] = STATE(2669),
    [sym_function_definition] = STATE(2669),
    [sym_compound_statement] = STATE(2669),
    [sym_subshell] = STATE(2669),
    [sym_pipeline] = STATE(2669),
    [sym_list] = STATE(2669),
    [sym_negated_command] = STATE(2669),
    [sym_test_command] = STATE(2669),
    [sym_declaration_command] = STATE(2669),
    [sym_unset_command] = STATE(2669),
    [sym_command] = STATE(2669),
    [sym_command_name] = STATE(162),
    [sym_variable_assignment] = STATE(2670),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(165),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(165),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_typeset] = ACTIONS(291),
    [anon_sym_export] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_local] = ACTIONS(291),
    [anon_sym_unset] = ACTIONS(293),
    [anon_sym_unsetenv] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [2530] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2673),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(6138),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(6140),
    [anon_sym_SEMI_SEMI] = ACTIONS(6142),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6142),
    [anon_sym_AMP] = ACTIONS(6138),
  },
  [2531] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2673),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(6138),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(6140),
    [anon_sym_SEMI_SEMI] = ACTIONS(6142),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(6142),
    [anon_sym_AMP] = ACTIONS(6138),
  },
  [2532] = {
    [sym__terminated_statement] = STATE(187),
    [sym_redirected_statement] = STATE(2674),
    [sym_for_statement] = STATE(2674),
    [sym_c_style_for_statement] = STATE(2674),
    [sym_while_statement] = STATE(2674),
    [sym_if_statement] = STATE(2674),
    [sym_case_statement] = STATE(2674),
    [sym_function_definition] = STATE(2674),
    [sym_compound_statement] = STATE(2674),
    [sym_subshell] = STATE(2674),
    [sym_pipeline] = STATE(2674),
    [sym_list] = STATE(2674),
    [sym_negated_command] = STATE(2674),
    [sym_test_command] = STATE(2674),
    [sym_declaration_command] = STATE(2674),
    [sym_unset_command] = STATE(2674),
    [sym_command] = STATE(2674),
    [sym_command_name] = STATE(83),
    [sym_variable_assignment] = STATE(2675),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(87),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(80),
    [sym_simple_expansion] = STATE(80),
    [sym_string_expansion] = STATE(80),
    [sym_expansion] = STATE(80),
    [sym_command_substitution] = STATE(80),
    [sym_process_substitution] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(187),
    [aux_sym_command_repeat1] = STATE(87),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(133),
    [anon_sym_typeset] = ACTIONS(133),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_readonly] = ACTIONS(133),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_unset] = ACTIONS(135),
    [anon_sym_unsetenv] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [2533] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_esac] = ACTIONS(6144),
    [anon_sym_SEMI_SEMI] = ACTIONS(927),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(6146),
    [anon_sym_DQUOTE] = ACTIONS(6148),
    [anon_sym_DOLLAR] = ACTIONS(6146),
    [sym_raw_string] = ACTIONS(6148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6148),
    [anon_sym_BQUOTE] = ACTIONS(6148),
    [anon_sym_LT_LPAREN] = ACTIONS(6148),
    [anon_sym_GT_LPAREN] = ACTIONS(6148),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6146),
  },
  [2534] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_esac] = ACTIONS(6150),
    [anon_sym_SEMI_SEMI] = ACTIONS(927),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(6152),
    [anon_sym_DQUOTE] = ACTIONS(6154),
    [anon_sym_DOLLAR] = ACTIONS(6152),
    [sym_raw_string] = ACTIONS(6154),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6154),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6154),
    [anon_sym_BQUOTE] = ACTIONS(6154),
    [anon_sym_LT_LPAREN] = ACTIONS(6154),
    [anon_sym_GT_LPAREN] = ACTIONS(6154),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6152),
  },
  [2535] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_SEMI_SEMI] = ACTIONS(927),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(5398),
    [anon_sym_DQUOTE] = ACTIONS(5400),
    [anon_sym_DOLLAR] = ACTIONS(5398),
    [sym_raw_string] = ACTIONS(5400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5400),
    [anon_sym_BQUOTE] = ACTIONS(5400),
    [anon_sym_LT_LPAREN] = ACTIONS(5400),
    [anon_sym_GT_LPAREN] = ACTIONS(5400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5398),
  },
  [2536] = {
    [sym__special_characters] = ACTIONS(5400),
    [anon_sym_DQUOTE] = ACTIONS(5400),
    [anon_sym_DOLLAR] = ACTIONS(5398),
    [sym_raw_string] = ACTIONS(5400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5400),
    [anon_sym_BQUOTE] = ACTIONS(5400),
    [anon_sym_LT_LPAREN] = ACTIONS(5400),
    [anon_sym_GT_LPAREN] = ACTIONS(5400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5400),
  },
  [2537] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(979),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(6156),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(507),
    [anon_sym_GT_GT] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(507),
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2056),
    [anon_sym_AMP] = ACTIONS(2054),
  },
  [2538] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(979),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(6156),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2056),
    [anon_sym_AMP] = ACTIONS(2054),
  },
  [2539] = {
    [sym__terminated_statement] = STATE(2539),
    [sym_redirected_statement] = STATE(524),
    [sym_for_statement] = STATE(524),
    [sym_c_style_for_statement] = STATE(524),
    [sym_while_statement] = STATE(524),
    [sym_if_statement] = STATE(524),
    [sym_case_statement] = STATE(524),
    [sym_function_definition] = STATE(524),
    [sym_compound_statement] = STATE(524),
    [sym_subshell] = STATE(524),
    [sym_pipeline] = STATE(524),
    [sym_list] = STATE(524),
    [sym_negated_command] = STATE(524),
    [sym_test_command] = STATE(524),
    [sym_declaration_command] = STATE(524),
    [sym_unset_command] = STATE(524),
    [sym_command] = STATE(524),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(525),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(2539),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(973),
    [sym_variable_name] = ACTIONS(976),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(982),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(988),
    [anon_sym_case] = ACTIONS(991),
    [anon_sym_SEMI_SEMI] = ACTIONS(1441),
    [anon_sym_function] = ACTIONS(994),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(1000),
    [anon_sym_BANG] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1006),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1009),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_typeset] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_readonly] = ACTIONS(1012),
    [anon_sym_local] = ACTIONS(1012),
    [anon_sym_unset] = ACTIONS(1015),
    [anon_sym_unsetenv] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1018),
    [anon_sym_GT] = ACTIONS(1018),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1018),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [sym__special_characters] = ACTIONS(1024),
    [anon_sym_DQUOTE] = ACTIONS(1027),
    [anon_sym_DOLLAR] = ACTIONS(1030),
    [sym_raw_string] = ACTIONS(1033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1039),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LPAREN] = ACTIONS(1045),
    [anon_sym_GT_LPAREN] = ACTIONS(1045),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1048),
  },
  [2540] = {
    [sym__terminated_statement] = STATE(2539),
    [sym_redirected_statement] = STATE(2678),
    [sym_for_statement] = STATE(2678),
    [sym_c_style_for_statement] = STATE(2678),
    [sym_while_statement] = STATE(2678),
    [sym_if_statement] = STATE(2678),
    [sym_case_statement] = STATE(2678),
    [sym_function_definition] = STATE(2678),
    [sym_compound_statement] = STATE(2678),
    [sym_subshell] = STATE(2678),
    [sym_pipeline] = STATE(2678),
    [sym_list] = STATE(2678),
    [sym_negated_command] = STATE(2678),
    [sym_test_command] = STATE(2678),
    [sym_declaration_command] = STATE(2678),
    [sym_unset_command] = STATE(2678),
    [sym_command] = STATE(2678),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(2679),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(2539),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(6158),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [2541] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_SEMI_SEMI] = ACTIONS(927),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(5440),
    [anon_sym_DQUOTE] = ACTIONS(5442),
    [anon_sym_DOLLAR] = ACTIONS(5440),
    [sym_raw_string] = ACTIONS(5442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5442),
    [anon_sym_BQUOTE] = ACTIONS(5442),
    [anon_sym_LT_LPAREN] = ACTIONS(5442),
    [anon_sym_GT_LPAREN] = ACTIONS(5442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5440),
  },
  [2542] = {
    [sym__special_characters] = ACTIONS(5442),
    [anon_sym_DQUOTE] = ACTIONS(5442),
    [anon_sym_DOLLAR] = ACTIONS(5440),
    [sym_raw_string] = ACTIONS(5442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5442),
    [anon_sym_BQUOTE] = ACTIONS(5442),
    [anon_sym_LT_LPAREN] = ACTIONS(5442),
    [anon_sym_GT_LPAREN] = ACTIONS(5442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5442),
  },
  [2543] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(979),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(6160),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(507),
    [anon_sym_GT_GT] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(507),
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2056),
    [anon_sym_AMP] = ACTIONS(2054),
  },
  [2544] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(979),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(6160),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2056),
    [anon_sym_AMP] = ACTIONS(2054),
  },
  [2545] = {
    [sym__terminated_statement] = STATE(2539),
    [sym_redirected_statement] = STATE(2682),
    [sym_for_statement] = STATE(2682),
    [sym_c_style_for_statement] = STATE(2682),
    [sym_while_statement] = STATE(2682),
    [sym_if_statement] = STATE(2682),
    [sym_case_statement] = STATE(2682),
    [sym_function_definition] = STATE(2682),
    [sym_compound_statement] = STATE(2682),
    [sym_subshell] = STATE(2682),
    [sym_pipeline] = STATE(2682),
    [sym_list] = STATE(2682),
    [sym_negated_command] = STATE(2682),
    [sym_test_command] = STATE(2682),
    [sym_declaration_command] = STATE(2682),
    [sym_unset_command] = STATE(2682),
    [sym_command] = STATE(2682),
    [sym_command_name] = STATE(60),
    [sym_variable_assignment] = STATE(2683),
    [sym_subscript] = STATE(62),
    [sym_file_redirect] = STATE(63),
    [sym_concatenation] = STATE(32),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_string_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym__statements_repeat1] = STATE(2539),
    [aux_sym_command_repeat1] = STATE(63),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(6162),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_typeset] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_unset] = ACTIONS(103),
    [anon_sym_unsetenv] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(109),
  },
  [2546] = {
    [sym__concat] = ACTIONS(5168),
    [anon_sym_RBRACE] = ACTIONS(5168),
    [sym_comment] = ACTIONS(57),
  },
  [2547] = {
    [sym__concat] = ACTIONS(5172),
    [anon_sym_RBRACE] = ACTIONS(5172),
    [sym_comment] = ACTIONS(57),
  },
  [2548] = {
    [sym__simple_heredoc_body] = ACTIONS(3238),
    [sym__heredoc_body_beginning] = ACTIONS(3238),
    [sym_file_descriptor] = ACTIONS(3238),
    [sym_variable_name] = ACTIONS(3238),
    [anon_sym_SEMI] = ACTIONS(3240),
    [anon_sym_esac] = ACTIONS(3240),
    [anon_sym_PIPE] = ACTIONS(3240),
    [anon_sym_SEMI_SEMI] = ACTIONS(3238),
    [anon_sym_PIPE_AMP] = ACTIONS(3238),
    [anon_sym_AMP_AMP] = ACTIONS(3238),
    [anon_sym_PIPE_PIPE] = ACTIONS(3238),
    [anon_sym_LT] = ACTIONS(3240),
    [anon_sym_GT] = ACTIONS(3240),
    [anon_sym_GT_GT] = ACTIONS(3238),
    [anon_sym_AMP_GT] = ACTIONS(3240),
    [anon_sym_AMP_GT_GT] = ACTIONS(3238),
    [anon_sym_LT_AMP] = ACTIONS(3238),
    [anon_sym_GT_AMP] = ACTIONS(3238),
    [anon_sym_LT_LT] = ACTIONS(3240),
    [anon_sym_LT_LT_DASH] = ACTIONS(3238),
    [anon_sym_LT_LT_LT] = ACTIONS(3238),
    [sym__special_characters] = ACTIONS(3238),
    [anon_sym_DQUOTE] = ACTIONS(3238),
    [anon_sym_DOLLAR] = ACTIONS(3240),
    [sym_raw_string] = ACTIONS(3238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3238),
    [anon_sym_BQUOTE] = ACTIONS(3238),
    [anon_sym_LT_LPAREN] = ACTIONS(3238),
    [anon_sym_GT_LPAREN] = ACTIONS(3238),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3240),
    [anon_sym_LF] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
  },
  [2549] = {
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(1726),
    [sym_variable_name] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_esac] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [2550] = {
    [aux_sym_concatenation_repeat1] = STATE(2550),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(6164),
    [sym_variable_name] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_esac] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [sym_raw_string] = ACTIONS(1726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LT_LPAREN] = ACTIONS(1726),
    [anon_sym_GT_LPAREN] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1728),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [2551] = {
    [sym__simple_heredoc_body] = ACTIONS(1733),
    [sym__heredoc_body_beginning] = ACTIONS(1733),
    [sym_file_descriptor] = ACTIONS(1733),
    [sym__concat] = ACTIONS(1733),
    [sym_variable_name] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_esac] = ACTIONS(1735),
    [anon_sym_PIPE] = ACTIONS(1735),
    [anon_sym_SEMI_SEMI] = ACTIONS(1733),
    [anon_sym_PIPE_AMP] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1735),
    [anon_sym_GT] = ACTIONS(1735),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_AMP_GT] = ACTIONS(1735),
    [anon_sym_AMP_GT_GT] = ACTIONS(1733),
    [anon_sym_LT_AMP] = ACTIONS(1733),
    [anon_sym_GT_AMP] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1735),
    [anon_sym_LT_LT_DASH] = ACTIONS(1733),
    [anon_sym_LT_LT_LT] = ACTIONS(1733),
    [sym__special_characters] = ACTIONS(1733),
    [anon_sym_DQUOTE] = ACTIONS(1733),
    [anon_sym_DOLLAR] = ACTIONS(1735),
    [sym_raw_string] = ACTIONS(1733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1733),
    [anon_sym_BQUOTE] = ACTIONS(1733),
    [anon_sym_LT_LPAREN] = ACTIONS(1733),
    [anon_sym_GT_LPAREN] = ACTIONS(1733),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1735),
    [anon_sym_LF] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1735),
  },
  [2552] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(6167),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [2553] = {
    [sym_concatenation] = STATE(2688),
    [sym_string] = STATE(2687),
    [sym_simple_expansion] = STATE(2687),
    [sym_string_expansion] = STATE(2687),
    [sym_expansion] = STATE(2687),
    [sym_command_substitution] = STATE(2687),
    [sym_process_substitution] = STATE(2687),
    [anon_sym_RBRACE] = ACTIONS(6169),
    [sym__special_characters] = ACTIONS(6171),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(6173),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6173),
  },
  [2554] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(6175),
    [sym_comment] = ACTIONS(57),
  },
  [2555] = {
    [sym_concatenation] = STATE(2692),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2692),
    [anon_sym_RBRACE] = ACTIONS(6177),
    [anon_sym_EQ] = ACTIONS(6179),
    [anon_sym_DASH] = ACTIONS(6179),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(6183),
    [anon_sym_COLON] = ACTIONS(6179),
    [anon_sym_COLON_QMARK] = ACTIONS(6179),
    [anon_sym_COLON_DASH] = ACTIONS(6179),
    [anon_sym_PERCENT] = ACTIONS(6179),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2556] = {
    [sym_concatenation] = STATE(2694),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2694),
    [anon_sym_RBRACE] = ACTIONS(6169),
    [anon_sym_EQ] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6185),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(6189),
    [anon_sym_COLON] = ACTIONS(6185),
    [anon_sym_COLON_QMARK] = ACTIONS(6185),
    [anon_sym_COLON_DASH] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6185),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2557] = {
    [sym__simple_heredoc_body] = ACTIONS(1834),
    [sym__heredoc_body_beginning] = ACTIONS(1834),
    [sym_file_descriptor] = ACTIONS(1834),
    [sym__concat] = ACTIONS(1834),
    [sym_variable_name] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1836),
    [anon_sym_esac] = ACTIONS(1836),
    [anon_sym_PIPE] = ACTIONS(1836),
    [anon_sym_SEMI_SEMI] = ACTIONS(1834),
    [anon_sym_PIPE_AMP] = ACTIONS(1834),
    [anon_sym_AMP_AMP] = ACTIONS(1834),
    [anon_sym_PIPE_PIPE] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1836),
    [anon_sym_GT] = ACTIONS(1836),
    [anon_sym_GT_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT] = ACTIONS(1836),
    [anon_sym_AMP_GT_GT] = ACTIONS(1834),
    [anon_sym_LT_AMP] = ACTIONS(1834),
    [anon_sym_GT_AMP] = ACTIONS(1834),
    [anon_sym_LT_LT] = ACTIONS(1836),
    [anon_sym_LT_LT_DASH] = ACTIONS(1834),
    [anon_sym_LT_LT_LT] = ACTIONS(1834),
    [sym__special_characters] = ACTIONS(1834),
    [anon_sym_DQUOTE] = ACTIONS(1834),
    [anon_sym_DOLLAR] = ACTIONS(1836),
    [sym_raw_string] = ACTIONS(1834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1834),
    [anon_sym_BQUOTE] = ACTIONS(1834),
    [anon_sym_LT_LPAREN] = ACTIONS(1834),
    [anon_sym_GT_LPAREN] = ACTIONS(1834),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1836),
    [anon_sym_LF] = ACTIONS(1834),
    [anon_sym_AMP] = ACTIONS(1836),
  },
  [2558] = {
    [sym_concatenation] = STATE(2697),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2697),
    [sym_regex] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6195),
    [anon_sym_DASH] = ACTIONS(6195),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6195),
    [anon_sym_COLON_QMARK] = ACTIONS(6195),
    [anon_sym_COLON_DASH] = ACTIONS(6195),
    [anon_sym_PERCENT] = ACTIONS(6195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2559] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2560] = {
    [sym__simple_heredoc_body] = ACTIONS(1882),
    [sym__heredoc_body_beginning] = ACTIONS(1882),
    [sym_file_descriptor] = ACTIONS(1882),
    [sym__concat] = ACTIONS(1882),
    [sym_variable_name] = ACTIONS(1882),
    [anon_sym_SEMI] = ACTIONS(1884),
    [anon_sym_esac] = ACTIONS(1884),
    [anon_sym_PIPE] = ACTIONS(1884),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [anon_sym_PIPE_AMP] = ACTIONS(1882),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1884),
    [anon_sym_GT_GT] = ACTIONS(1882),
    [anon_sym_AMP_GT] = ACTIONS(1884),
    [anon_sym_AMP_GT_GT] = ACTIONS(1882),
    [anon_sym_LT_AMP] = ACTIONS(1882),
    [anon_sym_GT_AMP] = ACTIONS(1882),
    [anon_sym_LT_LT] = ACTIONS(1884),
    [anon_sym_LT_LT_DASH] = ACTIONS(1882),
    [anon_sym_LT_LT_LT] = ACTIONS(1882),
    [sym__special_characters] = ACTIONS(1882),
    [anon_sym_DQUOTE] = ACTIONS(1882),
    [anon_sym_DOLLAR] = ACTIONS(1884),
    [sym_raw_string] = ACTIONS(1882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1882),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [anon_sym_LT_LPAREN] = ACTIONS(1882),
    [anon_sym_GT_LPAREN] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1884),
    [anon_sym_LF] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1884),
  },
  [2561] = {
    [sym_concatenation] = STATE(2694),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2694),
    [sym_regex] = ACTIONS(6199),
    [anon_sym_RBRACE] = ACTIONS(6169),
    [anon_sym_EQ] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6185),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6185),
    [anon_sym_COLON_QMARK] = ACTIONS(6185),
    [anon_sym_COLON_DASH] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6185),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2562] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6169),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2563] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(6201),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2564] = {
    [sym__simple_heredoc_body] = ACTIONS(1890),
    [sym__heredoc_body_beginning] = ACTIONS(1890),
    [sym_file_descriptor] = ACTIONS(1890),
    [sym__concat] = ACTIONS(1890),
    [sym_variable_name] = ACTIONS(1890),
    [anon_sym_SEMI] = ACTIONS(1892),
    [anon_sym_esac] = ACTIONS(1892),
    [anon_sym_PIPE] = ACTIONS(1892),
    [anon_sym_SEMI_SEMI] = ACTIONS(1890),
    [anon_sym_PIPE_AMP] = ACTIONS(1890),
    [anon_sym_AMP_AMP] = ACTIONS(1890),
    [anon_sym_PIPE_PIPE] = ACTIONS(1890),
    [anon_sym_LT] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(1892),
    [anon_sym_GT_GT] = ACTIONS(1890),
    [anon_sym_AMP_GT] = ACTIONS(1892),
    [anon_sym_AMP_GT_GT] = ACTIONS(1890),
    [anon_sym_LT_AMP] = ACTIONS(1890),
    [anon_sym_GT_AMP] = ACTIONS(1890),
    [anon_sym_LT_LT] = ACTIONS(1892),
    [anon_sym_LT_LT_DASH] = ACTIONS(1890),
    [anon_sym_LT_LT_LT] = ACTIONS(1890),
    [sym__special_characters] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1890),
    [anon_sym_DOLLAR] = ACTIONS(1892),
    [sym_raw_string] = ACTIONS(1890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1890),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [anon_sym_LT_LPAREN] = ACTIONS(1890),
    [anon_sym_GT_LPAREN] = ACTIONS(1890),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1892),
    [anon_sym_LF] = ACTIONS(1890),
    [anon_sym_AMP] = ACTIONS(1892),
  },
  [2565] = {
    [anon_sym_SEMI] = ACTIONS(6203),
    [anon_sym_RPAREN] = ACTIONS(6201),
    [anon_sym_SEMI_SEMI] = ACTIONS(6205),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6205),
    [anon_sym_AMP] = ACTIONS(6205),
  },
  [2566] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2702),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(6207),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(6201),
    [anon_sym_SEMI_SEMI] = ACTIONS(6209),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6209),
    [anon_sym_AMP] = ACTIONS(6207),
  },
  [2567] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2702),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(6207),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(6201),
    [anon_sym_SEMI_SEMI] = ACTIONS(6209),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(6209),
    [anon_sym_AMP] = ACTIONS(6207),
  },
  [2568] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(6201),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2569] = {
    [anon_sym_SEMI] = ACTIONS(6211),
    [anon_sym_SEMI_SEMI] = ACTIONS(6213),
    [anon_sym_BQUOTE] = ACTIONS(6201),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6213),
    [anon_sym_AMP] = ACTIONS(6213),
  },
  [2570] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2705),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(6215),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(6217),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(6201),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6215),
  },
  [2571] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2705),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(6215),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(6217),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(6201),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6215),
  },
  [2572] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(6219),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2573] = {
    [sym__simple_heredoc_body] = ACTIONS(1924),
    [sym__heredoc_body_beginning] = ACTIONS(1924),
    [sym_file_descriptor] = ACTIONS(1924),
    [sym__concat] = ACTIONS(1924),
    [sym_variable_name] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_esac] = ACTIONS(1926),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [anon_sym_PIPE_AMP] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_GT_GT] = ACTIONS(1924),
    [anon_sym_AMP_GT] = ACTIONS(1926),
    [anon_sym_AMP_GT_GT] = ACTIONS(1924),
    [anon_sym_LT_AMP] = ACTIONS(1924),
    [anon_sym_GT_AMP] = ACTIONS(1924),
    [anon_sym_LT_LT] = ACTIONS(1926),
    [anon_sym_LT_LT_DASH] = ACTIONS(1924),
    [anon_sym_LT_LT_LT] = ACTIONS(1924),
    [sym__special_characters] = ACTIONS(1924),
    [anon_sym_DQUOTE] = ACTIONS(1924),
    [anon_sym_DOLLAR] = ACTIONS(1926),
    [sym_raw_string] = ACTIONS(1924),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1924),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1924),
    [anon_sym_BQUOTE] = ACTIONS(1924),
    [anon_sym_LT_LPAREN] = ACTIONS(1924),
    [anon_sym_GT_LPAREN] = ACTIONS(1924),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1926),
    [anon_sym_LF] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1926),
  },
  [2574] = {
    [anon_sym_SEMI] = ACTIONS(6221),
    [anon_sym_RPAREN] = ACTIONS(6219),
    [anon_sym_SEMI_SEMI] = ACTIONS(6223),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6223),
    [anon_sym_AMP] = ACTIONS(6223),
  },
  [2575] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2709),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(6225),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(6219),
    [anon_sym_SEMI_SEMI] = ACTIONS(6227),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6227),
    [anon_sym_AMP] = ACTIONS(6225),
  },
  [2576] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2709),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(6225),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(6219),
    [anon_sym_SEMI_SEMI] = ACTIONS(6227),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(6227),
    [anon_sym_AMP] = ACTIONS(6225),
  },
  [2577] = {
    [sym__simple_heredoc_body] = ACTIONS(2076),
    [sym__heredoc_body_beginning] = ACTIONS(2076),
    [sym_file_descriptor] = ACTIONS(2076),
    [sym_variable_name] = ACTIONS(2076),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_esac] = ACTIONS(2078),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_SEMI_SEMI] = ACTIONS(2076),
    [anon_sym_PIPE_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2076),
    [anon_sym_PIPE_PIPE] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_GT] = ACTIONS(2078),
    [anon_sym_GT_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT_GT] = ACTIONS(2076),
    [anon_sym_LT_AMP] = ACTIONS(2076),
    [anon_sym_GT_AMP] = ACTIONS(2076),
    [anon_sym_LT_LT] = ACTIONS(2078),
    [anon_sym_LT_LT_DASH] = ACTIONS(2076),
    [anon_sym_LT_LT_LT] = ACTIONS(2076),
    [sym__special_characters] = ACTIONS(2076),
    [anon_sym_DQUOTE] = ACTIONS(2076),
    [anon_sym_DOLLAR] = ACTIONS(2078),
    [sym_raw_string] = ACTIONS(2076),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2076),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2076),
    [anon_sym_BQUOTE] = ACTIONS(2076),
    [anon_sym_LT_LPAREN] = ACTIONS(2076),
    [anon_sym_GT_LPAREN] = ACTIONS(2076),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2078),
    [sym_word] = ACTIONS(2078),
    [anon_sym_LF] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [2578] = {
    [sym_concatenation] = STATE(1007),
    [sym_string] = STATE(537),
    [sym_simple_expansion] = STATE(537),
    [sym_string_expansion] = STATE(537),
    [sym_expansion] = STATE(537),
    [sym_command_substitution] = STATE(537),
    [sym_process_substitution] = STATE(537),
    [aux_sym_for_statement_repeat1] = STATE(1007),
    [anon_sym_RPAREN] = ACTIONS(6229),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1095),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
  },
  [2579] = {
    [sym__simple_heredoc_body] = ACTIONS(2930),
    [sym__heredoc_body_beginning] = ACTIONS(2930),
    [sym_file_descriptor] = ACTIONS(2930),
    [sym__concat] = ACTIONS(2930),
    [sym_variable_name] = ACTIONS(2930),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym_esac] = ACTIONS(2932),
    [anon_sym_PIPE] = ACTIONS(2932),
    [anon_sym_SEMI_SEMI] = ACTIONS(2930),
    [anon_sym_PIPE_AMP] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2932),
    [anon_sym_GT_GT] = ACTIONS(2930),
    [anon_sym_AMP_GT] = ACTIONS(2932),
    [anon_sym_AMP_GT_GT] = ACTIONS(2930),
    [anon_sym_LT_AMP] = ACTIONS(2930),
    [anon_sym_GT_AMP] = ACTIONS(2930),
    [anon_sym_LT_LT] = ACTIONS(2932),
    [anon_sym_LT_LT_DASH] = ACTIONS(2930),
    [anon_sym_LT_LT_LT] = ACTIONS(2930),
    [sym__special_characters] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_DOLLAR] = ACTIONS(2932),
    [sym_raw_string] = ACTIONS(2930),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2930),
    [anon_sym_BQUOTE] = ACTIONS(2930),
    [anon_sym_LT_LPAREN] = ACTIONS(2930),
    [anon_sym_GT_LPAREN] = ACTIONS(2930),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2932),
    [sym_word] = ACTIONS(2932),
    [anon_sym_LF] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2932),
  },
  [2580] = {
    [sym__simple_heredoc_body] = ACTIONS(2944),
    [sym__heredoc_body_beginning] = ACTIONS(2944),
    [sym_file_descriptor] = ACTIONS(2944),
    [sym__concat] = ACTIONS(2944),
    [sym_variable_name] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym_esac] = ACTIONS(2946),
    [anon_sym_PIPE] = ACTIONS(2946),
    [anon_sym_SEMI_SEMI] = ACTIONS(2944),
    [anon_sym_PIPE_AMP] = ACTIONS(2944),
    [anon_sym_AMP_AMP] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2946),
    [anon_sym_GT_GT] = ACTIONS(2944),
    [anon_sym_AMP_GT] = ACTIONS(2946),
    [anon_sym_AMP_GT_GT] = ACTIONS(2944),
    [anon_sym_LT_AMP] = ACTIONS(2944),
    [anon_sym_GT_AMP] = ACTIONS(2944),
    [anon_sym_LT_LT] = ACTIONS(2946),
    [anon_sym_LT_LT_DASH] = ACTIONS(2944),
    [anon_sym_LT_LT_LT] = ACTIONS(2944),
    [sym__special_characters] = ACTIONS(2944),
    [anon_sym_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [sym_raw_string] = ACTIONS(2944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2944),
    [anon_sym_BQUOTE] = ACTIONS(2944),
    [anon_sym_LT_LPAREN] = ACTIONS(2944),
    [anon_sym_GT_LPAREN] = ACTIONS(2944),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2946),
    [sym_word] = ACTIONS(2946),
    [anon_sym_LF] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2946),
  },
  [2581] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6231),
    [sym_comment] = ACTIONS(57),
  },
  [2582] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6233),
    [sym_comment] = ACTIONS(57),
  },
  [2583] = {
    [anon_sym_RBRACE] = ACTIONS(6233),
    [sym_comment] = ACTIONS(57),
  },
  [2584] = {
    [sym_concatenation] = STATE(2715),
    [sym_string] = STATE(2714),
    [sym_simple_expansion] = STATE(2714),
    [sym_string_expansion] = STATE(2714),
    [sym_expansion] = STATE(2714),
    [sym_command_substitution] = STATE(2714),
    [sym_process_substitution] = STATE(2714),
    [anon_sym_RBRACE] = ACTIONS(6233),
    [sym__special_characters] = ACTIONS(6235),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(6237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6237),
  },
  [2585] = {
    [sym__simple_heredoc_body] = ACTIONS(2980),
    [sym__heredoc_body_beginning] = ACTIONS(2980),
    [sym_file_descriptor] = ACTIONS(2980),
    [sym__concat] = ACTIONS(2980),
    [sym_variable_name] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym_esac] = ACTIONS(2982),
    [anon_sym_PIPE] = ACTIONS(2982),
    [anon_sym_SEMI_SEMI] = ACTIONS(2980),
    [anon_sym_PIPE_AMP] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_PIPE_PIPE] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2982),
    [anon_sym_GT_GT] = ACTIONS(2980),
    [anon_sym_AMP_GT] = ACTIONS(2982),
    [anon_sym_AMP_GT_GT] = ACTIONS(2980),
    [anon_sym_LT_AMP] = ACTIONS(2980),
    [anon_sym_GT_AMP] = ACTIONS(2980),
    [anon_sym_LT_LT] = ACTIONS(2982),
    [anon_sym_LT_LT_DASH] = ACTIONS(2980),
    [anon_sym_LT_LT_LT] = ACTIONS(2980),
    [sym__special_characters] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2982),
    [sym_raw_string] = ACTIONS(2980),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2980),
    [anon_sym_BQUOTE] = ACTIONS(2980),
    [anon_sym_LT_LPAREN] = ACTIONS(2980),
    [anon_sym_GT_LPAREN] = ACTIONS(2980),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2982),
    [sym_word] = ACTIONS(2982),
    [anon_sym_LF] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2982),
  },
  [2586] = {
    [sym_concatenation] = STATE(2718),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2718),
    [sym_regex] = ACTIONS(6239),
    [anon_sym_RBRACE] = ACTIONS(6241),
    [anon_sym_EQ] = ACTIONS(6243),
    [anon_sym_DASH] = ACTIONS(6243),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6245),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6243),
    [anon_sym_COLON_QMARK] = ACTIONS(6243),
    [anon_sym_COLON_DASH] = ACTIONS(6243),
    [anon_sym_PERCENT] = ACTIONS(6243),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2587] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6241),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2588] = {
    [sym_concatenation] = STATE(2720),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2720),
    [sym_regex] = ACTIONS(6247),
    [anon_sym_RBRACE] = ACTIONS(6233),
    [anon_sym_EQ] = ACTIONS(6249),
    [anon_sym_DASH] = ACTIONS(6249),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6251),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6249),
    [anon_sym_COLON_QMARK] = ACTIONS(6249),
    [anon_sym_COLON_DASH] = ACTIONS(6249),
    [anon_sym_PERCENT] = ACTIONS(6249),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2589] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6233),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2590] = {
    [sym_concatenation] = STATE(2722),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2722),
    [anon_sym_RBRACE] = ACTIONS(6253),
    [anon_sym_EQ] = ACTIONS(6255),
    [anon_sym_DASH] = ACTIONS(6255),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6255),
    [anon_sym_COLON_QMARK] = ACTIONS(6255),
    [anon_sym_COLON_DASH] = ACTIONS(6255),
    [anon_sym_PERCENT] = ACTIONS(6255),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2591] = {
    [sym__simple_heredoc_body] = ACTIONS(3036),
    [sym__heredoc_body_beginning] = ACTIONS(3036),
    [sym_file_descriptor] = ACTIONS(3036),
    [sym__concat] = ACTIONS(3036),
    [sym_variable_name] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym_esac] = ACTIONS(3038),
    [anon_sym_PIPE] = ACTIONS(3038),
    [anon_sym_SEMI_SEMI] = ACTIONS(3036),
    [anon_sym_PIPE_AMP] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_PIPE_PIPE] = ACTIONS(3036),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_GT] = ACTIONS(3038),
    [anon_sym_GT_GT] = ACTIONS(3036),
    [anon_sym_AMP_GT] = ACTIONS(3038),
    [anon_sym_AMP_GT_GT] = ACTIONS(3036),
    [anon_sym_LT_AMP] = ACTIONS(3036),
    [anon_sym_GT_AMP] = ACTIONS(3036),
    [anon_sym_LT_LT] = ACTIONS(3038),
    [anon_sym_LT_LT_DASH] = ACTIONS(3036),
    [anon_sym_LT_LT_LT] = ACTIONS(3036),
    [sym__special_characters] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [anon_sym_DOLLAR] = ACTIONS(3038),
    [sym_raw_string] = ACTIONS(3036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3036),
    [anon_sym_BQUOTE] = ACTIONS(3036),
    [anon_sym_LT_LPAREN] = ACTIONS(3036),
    [anon_sym_GT_LPAREN] = ACTIONS(3036),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3038),
    [sym_word] = ACTIONS(3038),
    [anon_sym_LF] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3038),
  },
  [2592] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6253),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2593] = {
    [sym_concatenation] = STATE(2720),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2720),
    [anon_sym_RBRACE] = ACTIONS(6233),
    [anon_sym_EQ] = ACTIONS(6249),
    [anon_sym_DASH] = ACTIONS(6249),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6251),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6249),
    [anon_sym_COLON_QMARK] = ACTIONS(6249),
    [anon_sym_COLON_DASH] = ACTIONS(6249),
    [anon_sym_PERCENT] = ACTIONS(6249),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2594] = {
    [sym__simple_heredoc_body] = ACTIONS(3091),
    [sym__heredoc_body_beginning] = ACTIONS(3091),
    [sym_file_descriptor] = ACTIONS(3091),
    [sym__concat] = ACTIONS(3091),
    [sym_variable_name] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_esac] = ACTIONS(3093),
    [anon_sym_PIPE] = ACTIONS(3093),
    [anon_sym_SEMI_SEMI] = ACTIONS(3091),
    [anon_sym_PIPE_AMP] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_GT] = ACTIONS(3093),
    [anon_sym_GT_GT] = ACTIONS(3091),
    [anon_sym_AMP_GT] = ACTIONS(3093),
    [anon_sym_AMP_GT_GT] = ACTIONS(3091),
    [anon_sym_LT_AMP] = ACTIONS(3091),
    [anon_sym_GT_AMP] = ACTIONS(3091),
    [anon_sym_LT_LT] = ACTIONS(3093),
    [anon_sym_LT_LT_DASH] = ACTIONS(3091),
    [anon_sym_LT_LT_LT] = ACTIONS(3091),
    [sym__special_characters] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_DOLLAR] = ACTIONS(3093),
    [sym_raw_string] = ACTIONS(3091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3091),
    [anon_sym_BQUOTE] = ACTIONS(3091),
    [anon_sym_LT_LPAREN] = ACTIONS(3091),
    [anon_sym_GT_LPAREN] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3093),
    [sym_word] = ACTIONS(3093),
    [anon_sym_LF] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3093),
  },
  [2595] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6259),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2596] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(6259),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2597] = {
    [anon_sym_SEMI] = ACTIONS(6261),
    [anon_sym_RPAREN] = ACTIONS(6259),
    [anon_sym_SEMI_SEMI] = ACTIONS(6263),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6263),
    [anon_sym_AMP] = ACTIONS(6263),
  },
  [2598] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(6259),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2599] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(6259),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2600] = {
    [anon_sym_SEMI] = ACTIONS(6265),
    [anon_sym_SEMI_SEMI] = ACTIONS(6267),
    [anon_sym_BQUOTE] = ACTIONS(6259),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6267),
    [anon_sym_AMP] = ACTIONS(6267),
  },
  [2601] = {
    [sym__simple_heredoc_body] = ACTIONS(3121),
    [sym__heredoc_body_beginning] = ACTIONS(3121),
    [sym_file_descriptor] = ACTIONS(3121),
    [sym__concat] = ACTIONS(3121),
    [sym_variable_name] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3123),
    [anon_sym_esac] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3123),
    [anon_sym_SEMI_SEMI] = ACTIONS(3121),
    [anon_sym_PIPE_AMP] = ACTIONS(3121),
    [anon_sym_AMP_AMP] = ACTIONS(3121),
    [anon_sym_PIPE_PIPE] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_GT] = ACTIONS(3123),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_AMP_GT] = ACTIONS(3123),
    [anon_sym_AMP_GT_GT] = ACTIONS(3121),
    [anon_sym_LT_AMP] = ACTIONS(3121),
    [anon_sym_GT_AMP] = ACTIONS(3121),
    [anon_sym_LT_LT] = ACTIONS(3123),
    [anon_sym_LT_LT_DASH] = ACTIONS(3121),
    [anon_sym_LT_LT_LT] = ACTIONS(3121),
    [sym__special_characters] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [sym_raw_string] = ACTIONS(3121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3121),
    [anon_sym_BQUOTE] = ACTIONS(3121),
    [anon_sym_LT_LPAREN] = ACTIONS(3121),
    [anon_sym_GT_LPAREN] = ACTIONS(3121),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3123),
    [sym_word] = ACTIONS(3123),
    [anon_sym_LF] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
  },
  [2602] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6269),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2603] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(6269),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2604] = {
    [anon_sym_SEMI] = ACTIONS(6271),
    [anon_sym_RPAREN] = ACTIONS(6269),
    [anon_sym_SEMI_SEMI] = ACTIONS(6273),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
  },
  [2605] = {
    [sym__simple_heredoc_body] = ACTIONS(2930),
    [sym__heredoc_body_beginning] = ACTIONS(2930),
    [sym_file_descriptor] = ACTIONS(2930),
    [sym__concat] = ACTIONS(2930),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym_esac] = ACTIONS(2932),
    [anon_sym_PIPE] = ACTIONS(2932),
    [anon_sym_SEMI_SEMI] = ACTIONS(2930),
    [anon_sym_PIPE_AMP] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2932),
    [anon_sym_GT_GT] = ACTIONS(2930),
    [anon_sym_AMP_GT] = ACTIONS(2932),
    [anon_sym_AMP_GT_GT] = ACTIONS(2930),
    [anon_sym_LT_AMP] = ACTIONS(2930),
    [anon_sym_GT_AMP] = ACTIONS(2930),
    [anon_sym_LT_LT] = ACTIONS(2932),
    [anon_sym_LT_LT_DASH] = ACTIONS(2930),
    [anon_sym_LT_LT_LT] = ACTIONS(2930),
    [sym__special_characters] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_DOLLAR] = ACTIONS(2932),
    [sym_raw_string] = ACTIONS(2930),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2930),
    [anon_sym_BQUOTE] = ACTIONS(2930),
    [anon_sym_LT_LPAREN] = ACTIONS(2930),
    [anon_sym_GT_LPAREN] = ACTIONS(2930),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2932),
    [sym_word] = ACTIONS(2932),
    [anon_sym_LF] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2932),
  },
  [2606] = {
    [sym__simple_heredoc_body] = ACTIONS(2944),
    [sym__heredoc_body_beginning] = ACTIONS(2944),
    [sym_file_descriptor] = ACTIONS(2944),
    [sym__concat] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym_esac] = ACTIONS(2946),
    [anon_sym_PIPE] = ACTIONS(2946),
    [anon_sym_SEMI_SEMI] = ACTIONS(2944),
    [anon_sym_PIPE_AMP] = ACTIONS(2944),
    [anon_sym_AMP_AMP] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2946),
    [anon_sym_GT_GT] = ACTIONS(2944),
    [anon_sym_AMP_GT] = ACTIONS(2946),
    [anon_sym_AMP_GT_GT] = ACTIONS(2944),
    [anon_sym_LT_AMP] = ACTIONS(2944),
    [anon_sym_GT_AMP] = ACTIONS(2944),
    [anon_sym_LT_LT] = ACTIONS(2946),
    [anon_sym_LT_LT_DASH] = ACTIONS(2944),
    [anon_sym_LT_LT_LT] = ACTIONS(2944),
    [sym__special_characters] = ACTIONS(2944),
    [anon_sym_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [sym_raw_string] = ACTIONS(2944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2944),
    [anon_sym_BQUOTE] = ACTIONS(2944),
    [anon_sym_LT_LPAREN] = ACTIONS(2944),
    [anon_sym_GT_LPAREN] = ACTIONS(2944),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2946),
    [sym_word] = ACTIONS(2946),
    [anon_sym_LF] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2946),
  },
  [2607] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6275),
    [sym_comment] = ACTIONS(57),
  },
  [2608] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6277),
    [sym_comment] = ACTIONS(57),
  },
  [2609] = {
    [anon_sym_RBRACE] = ACTIONS(6277),
    [sym_comment] = ACTIONS(57),
  },
  [2610] = {
    [sym_concatenation] = STATE(2732),
    [sym_string] = STATE(2731),
    [sym_simple_expansion] = STATE(2731),
    [sym_string_expansion] = STATE(2731),
    [sym_expansion] = STATE(2731),
    [sym_command_substitution] = STATE(2731),
    [sym_process_substitution] = STATE(2731),
    [anon_sym_RBRACE] = ACTIONS(6277),
    [sym__special_characters] = ACTIONS(6279),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(6281),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6281),
  },
  [2611] = {
    [sym__simple_heredoc_body] = ACTIONS(2980),
    [sym__heredoc_body_beginning] = ACTIONS(2980),
    [sym_file_descriptor] = ACTIONS(2980),
    [sym__concat] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym_esac] = ACTIONS(2982),
    [anon_sym_PIPE] = ACTIONS(2982),
    [anon_sym_SEMI_SEMI] = ACTIONS(2980),
    [anon_sym_PIPE_AMP] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_PIPE_PIPE] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2982),
    [anon_sym_GT_GT] = ACTIONS(2980),
    [anon_sym_AMP_GT] = ACTIONS(2982),
    [anon_sym_AMP_GT_GT] = ACTIONS(2980),
    [anon_sym_LT_AMP] = ACTIONS(2980),
    [anon_sym_GT_AMP] = ACTIONS(2980),
    [anon_sym_LT_LT] = ACTIONS(2982),
    [anon_sym_LT_LT_DASH] = ACTIONS(2980),
    [anon_sym_LT_LT_LT] = ACTIONS(2980),
    [sym__special_characters] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2982),
    [sym_raw_string] = ACTIONS(2980),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2980),
    [anon_sym_BQUOTE] = ACTIONS(2980),
    [anon_sym_LT_LPAREN] = ACTIONS(2980),
    [anon_sym_GT_LPAREN] = ACTIONS(2980),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2982),
    [sym_word] = ACTIONS(2982),
    [anon_sym_LF] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2982),
  },
  [2612] = {
    [sym_concatenation] = STATE(2735),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2735),
    [sym_regex] = ACTIONS(6283),
    [anon_sym_RBRACE] = ACTIONS(6285),
    [anon_sym_EQ] = ACTIONS(6287),
    [anon_sym_DASH] = ACTIONS(6287),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6287),
    [anon_sym_COLON_QMARK] = ACTIONS(6287),
    [anon_sym_COLON_DASH] = ACTIONS(6287),
    [anon_sym_PERCENT] = ACTIONS(6287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2613] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6285),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2614] = {
    [sym_concatenation] = STATE(2737),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2737),
    [sym_regex] = ACTIONS(6291),
    [anon_sym_RBRACE] = ACTIONS(6277),
    [anon_sym_EQ] = ACTIONS(6293),
    [anon_sym_DASH] = ACTIONS(6293),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6293),
    [anon_sym_COLON_QMARK] = ACTIONS(6293),
    [anon_sym_COLON_DASH] = ACTIONS(6293),
    [anon_sym_PERCENT] = ACTIONS(6293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2615] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6277),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2616] = {
    [sym_concatenation] = STATE(2739),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2739),
    [anon_sym_RBRACE] = ACTIONS(6297),
    [anon_sym_EQ] = ACTIONS(6299),
    [anon_sym_DASH] = ACTIONS(6299),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6299),
    [anon_sym_COLON_QMARK] = ACTIONS(6299),
    [anon_sym_COLON_DASH] = ACTIONS(6299),
    [anon_sym_PERCENT] = ACTIONS(6299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2617] = {
    [sym__simple_heredoc_body] = ACTIONS(3036),
    [sym__heredoc_body_beginning] = ACTIONS(3036),
    [sym_file_descriptor] = ACTIONS(3036),
    [sym__concat] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym_esac] = ACTIONS(3038),
    [anon_sym_PIPE] = ACTIONS(3038),
    [anon_sym_SEMI_SEMI] = ACTIONS(3036),
    [anon_sym_PIPE_AMP] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_PIPE_PIPE] = ACTIONS(3036),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_GT] = ACTIONS(3038),
    [anon_sym_GT_GT] = ACTIONS(3036),
    [anon_sym_AMP_GT] = ACTIONS(3038),
    [anon_sym_AMP_GT_GT] = ACTIONS(3036),
    [anon_sym_LT_AMP] = ACTIONS(3036),
    [anon_sym_GT_AMP] = ACTIONS(3036),
    [anon_sym_LT_LT] = ACTIONS(3038),
    [anon_sym_LT_LT_DASH] = ACTIONS(3036),
    [anon_sym_LT_LT_LT] = ACTIONS(3036),
    [sym__special_characters] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [anon_sym_DOLLAR] = ACTIONS(3038),
    [sym_raw_string] = ACTIONS(3036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3036),
    [anon_sym_BQUOTE] = ACTIONS(3036),
    [anon_sym_LT_LPAREN] = ACTIONS(3036),
    [anon_sym_GT_LPAREN] = ACTIONS(3036),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3038),
    [sym_word] = ACTIONS(3038),
    [anon_sym_LF] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3038),
  },
  [2618] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6297),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2619] = {
    [sym_concatenation] = STATE(2737),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2737),
    [anon_sym_RBRACE] = ACTIONS(6277),
    [anon_sym_EQ] = ACTIONS(6293),
    [anon_sym_DASH] = ACTIONS(6293),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6293),
    [anon_sym_COLON_QMARK] = ACTIONS(6293),
    [anon_sym_COLON_DASH] = ACTIONS(6293),
    [anon_sym_PERCENT] = ACTIONS(6293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2620] = {
    [sym__simple_heredoc_body] = ACTIONS(3091),
    [sym__heredoc_body_beginning] = ACTIONS(3091),
    [sym_file_descriptor] = ACTIONS(3091),
    [sym__concat] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_esac] = ACTIONS(3093),
    [anon_sym_PIPE] = ACTIONS(3093),
    [anon_sym_SEMI_SEMI] = ACTIONS(3091),
    [anon_sym_PIPE_AMP] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_GT] = ACTIONS(3093),
    [anon_sym_GT_GT] = ACTIONS(3091),
    [anon_sym_AMP_GT] = ACTIONS(3093),
    [anon_sym_AMP_GT_GT] = ACTIONS(3091),
    [anon_sym_LT_AMP] = ACTIONS(3091),
    [anon_sym_GT_AMP] = ACTIONS(3091),
    [anon_sym_LT_LT] = ACTIONS(3093),
    [anon_sym_LT_LT_DASH] = ACTIONS(3091),
    [anon_sym_LT_LT_LT] = ACTIONS(3091),
    [sym__special_characters] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_DOLLAR] = ACTIONS(3093),
    [sym_raw_string] = ACTIONS(3091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3091),
    [anon_sym_BQUOTE] = ACTIONS(3091),
    [anon_sym_LT_LPAREN] = ACTIONS(3091),
    [anon_sym_GT_LPAREN] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3093),
    [sym_word] = ACTIONS(3093),
    [anon_sym_LF] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3093),
  },
  [2621] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6303),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2622] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(6303),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2623] = {
    [anon_sym_SEMI] = ACTIONS(6305),
    [anon_sym_RPAREN] = ACTIONS(6303),
    [anon_sym_SEMI_SEMI] = ACTIONS(6307),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6307),
    [anon_sym_AMP] = ACTIONS(6307),
  },
  [2624] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(6303),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2625] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(6303),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2626] = {
    [anon_sym_SEMI] = ACTIONS(6309),
    [anon_sym_SEMI_SEMI] = ACTIONS(6311),
    [anon_sym_BQUOTE] = ACTIONS(6303),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6311),
    [anon_sym_AMP] = ACTIONS(6311),
  },
  [2627] = {
    [sym__simple_heredoc_body] = ACTIONS(3121),
    [sym__heredoc_body_beginning] = ACTIONS(3121),
    [sym_file_descriptor] = ACTIONS(3121),
    [sym__concat] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3123),
    [anon_sym_esac] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3123),
    [anon_sym_SEMI_SEMI] = ACTIONS(3121),
    [anon_sym_PIPE_AMP] = ACTIONS(3121),
    [anon_sym_AMP_AMP] = ACTIONS(3121),
    [anon_sym_PIPE_PIPE] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_GT] = ACTIONS(3123),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_AMP_GT] = ACTIONS(3123),
    [anon_sym_AMP_GT_GT] = ACTIONS(3121),
    [anon_sym_LT_AMP] = ACTIONS(3121),
    [anon_sym_GT_AMP] = ACTIONS(3121),
    [anon_sym_LT_LT] = ACTIONS(3123),
    [anon_sym_LT_LT_DASH] = ACTIONS(3121),
    [anon_sym_LT_LT_LT] = ACTIONS(3121),
    [sym__special_characters] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [sym_raw_string] = ACTIONS(3121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3121),
    [anon_sym_BQUOTE] = ACTIONS(3121),
    [anon_sym_LT_LPAREN] = ACTIONS(3121),
    [anon_sym_GT_LPAREN] = ACTIONS(3121),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3123),
    [sym_word] = ACTIONS(3123),
    [anon_sym_LF] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
  },
  [2628] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6313),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2629] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(6313),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2630] = {
    [anon_sym_SEMI] = ACTIONS(6315),
    [anon_sym_RPAREN] = ACTIONS(6313),
    [anon_sym_SEMI_SEMI] = ACTIONS(6317),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6317),
    [anon_sym_AMP] = ACTIONS(6317),
  },
  [2631] = {
    [sym__simple_heredoc_body] = ACTIONS(3921),
    [sym__heredoc_body_beginning] = ACTIONS(3921),
    [sym_file_descriptor] = ACTIONS(3921),
    [sym__concat] = ACTIONS(3921),
    [anon_sym_SEMI] = ACTIONS(3923),
    [anon_sym_esac] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_SEMI_SEMI] = ACTIONS(3921),
    [anon_sym_PIPE_AMP] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_EQ_TILDE] = ACTIONS(3923),
    [anon_sym_EQ_EQ] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_GT_GT] = ACTIONS(3921),
    [anon_sym_AMP_GT] = ACTIONS(3923),
    [anon_sym_AMP_GT_GT] = ACTIONS(3921),
    [anon_sym_LT_AMP] = ACTIONS(3921),
    [anon_sym_GT_AMP] = ACTIONS(3921),
    [anon_sym_LT_LT] = ACTIONS(3923),
    [anon_sym_LT_LT_DASH] = ACTIONS(3921),
    [anon_sym_LT_LT_LT] = ACTIONS(3921),
    [sym__special_characters] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_DOLLAR] = ACTIONS(3923),
    [sym_raw_string] = ACTIONS(3921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3921),
    [anon_sym_BQUOTE] = ACTIONS(3921),
    [anon_sym_LT_LPAREN] = ACTIONS(3921),
    [anon_sym_GT_LPAREN] = ACTIONS(3921),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3923),
    [anon_sym_LF] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3923),
  },
  [2632] = {
    [sym__simple_heredoc_body] = ACTIONS(3929),
    [sym__heredoc_body_beginning] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [sym__concat] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3931),
    [anon_sym_esac] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3931),
    [anon_sym_SEMI_SEMI] = ACTIONS(3929),
    [anon_sym_PIPE_AMP] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_EQ_TILDE] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_AMP_GT] = ACTIONS(3931),
    [anon_sym_AMP_GT_GT] = ACTIONS(3929),
    [anon_sym_LT_AMP] = ACTIONS(3929),
    [anon_sym_GT_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_LT_LT_DASH] = ACTIONS(3929),
    [anon_sym_LT_LT_LT] = ACTIONS(3929),
    [sym__special_characters] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [sym_raw_string] = ACTIONS(3929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3929),
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [anon_sym_LT_LPAREN] = ACTIONS(3929),
    [anon_sym_GT_LPAREN] = ACTIONS(3929),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3931),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
  },
  [2633] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6319),
    [sym_comment] = ACTIONS(57),
  },
  [2634] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6321),
    [sym_comment] = ACTIONS(57),
  },
  [2635] = {
    [anon_sym_RBRACE] = ACTIONS(6321),
    [sym_comment] = ACTIONS(57),
  },
  [2636] = {
    [sym_concatenation] = STATE(2748),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2748),
    [anon_sym_RBRACE] = ACTIONS(6323),
    [anon_sym_EQ] = ACTIONS(6325),
    [anon_sym_DASH] = ACTIONS(6325),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6327),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6325),
    [anon_sym_COLON_QMARK] = ACTIONS(6325),
    [anon_sym_COLON_DASH] = ACTIONS(6325),
    [anon_sym_PERCENT] = ACTIONS(6325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2637] = {
    [sym__simple_heredoc_body] = ACTIONS(3985),
    [sym__heredoc_body_beginning] = ACTIONS(3985),
    [sym_file_descriptor] = ACTIONS(3985),
    [sym__concat] = ACTIONS(3985),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_esac] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_EQ_TILDE] = ACTIONS(3987),
    [anon_sym_EQ_EQ] = ACTIONS(3987),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_AMP_GT] = ACTIONS(3987),
    [anon_sym_AMP_GT_GT] = ACTIONS(3985),
    [anon_sym_LT_AMP] = ACTIONS(3985),
    [anon_sym_GT_AMP] = ACTIONS(3985),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_LT_LT_DASH] = ACTIONS(3985),
    [anon_sym_LT_LT_LT] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [2638] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6323),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2639] = {
    [sym_concatenation] = STATE(2749),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2749),
    [anon_sym_RBRACE] = ACTIONS(6321),
    [anon_sym_EQ] = ACTIONS(6329),
    [anon_sym_DASH] = ACTIONS(6329),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6329),
    [anon_sym_COLON_QMARK] = ACTIONS(6329),
    [anon_sym_COLON_DASH] = ACTIONS(6329),
    [anon_sym_PERCENT] = ACTIONS(6329),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2640] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6321),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2641] = {
    [sym__simple_heredoc_body] = ACTIONS(4030),
    [sym__heredoc_body_beginning] = ACTIONS(4030),
    [sym_file_descriptor] = ACTIONS(4030),
    [sym__concat] = ACTIONS(4030),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_esac] = ACTIONS(4032),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_SEMI_SEMI] = ACTIONS(4030),
    [anon_sym_PIPE_AMP] = ACTIONS(4030),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_EQ_TILDE] = ACTIONS(4032),
    [anon_sym_EQ_EQ] = ACTIONS(4032),
    [anon_sym_LT] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(4032),
    [anon_sym_GT_GT] = ACTIONS(4030),
    [anon_sym_AMP_GT] = ACTIONS(4032),
    [anon_sym_AMP_GT_GT] = ACTIONS(4030),
    [anon_sym_LT_AMP] = ACTIONS(4030),
    [anon_sym_GT_AMP] = ACTIONS(4030),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_LT_LT_DASH] = ACTIONS(4030),
    [anon_sym_LT_LT_LT] = ACTIONS(4030),
    [sym__special_characters] = ACTIONS(4030),
    [anon_sym_DQUOTE] = ACTIONS(4030),
    [anon_sym_DOLLAR] = ACTIONS(4032),
    [sym_raw_string] = ACTIONS(4030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4030),
    [anon_sym_BQUOTE] = ACTIONS(4030),
    [anon_sym_LT_LPAREN] = ACTIONS(4030),
    [anon_sym_GT_LPAREN] = ACTIONS(4030),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4032),
    [anon_sym_LF] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4032),
  },
  [2642] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6333),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2643] = {
    [sym__simple_heredoc_body] = ACTIONS(4064),
    [sym__heredoc_body_beginning] = ACTIONS(4064),
    [sym_file_descriptor] = ACTIONS(4064),
    [sym__concat] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_esac] = ACTIONS(4066),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_SEMI_SEMI] = ACTIONS(4064),
    [anon_sym_PIPE_AMP] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_EQ_TILDE] = ACTIONS(4066),
    [anon_sym_EQ_EQ] = ACTIONS(4066),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_GT_GT] = ACTIONS(4064),
    [anon_sym_AMP_GT] = ACTIONS(4066),
    [anon_sym_AMP_GT_GT] = ACTIONS(4064),
    [anon_sym_LT_AMP] = ACTIONS(4064),
    [anon_sym_GT_AMP] = ACTIONS(4064),
    [anon_sym_LT_LT] = ACTIONS(4066),
    [anon_sym_LT_LT_DASH] = ACTIONS(4064),
    [anon_sym_LT_LT_LT] = ACTIONS(4064),
    [sym__special_characters] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_DOLLAR] = ACTIONS(4066),
    [sym_raw_string] = ACTIONS(4064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4064),
    [anon_sym_BQUOTE] = ACTIONS(4064),
    [anon_sym_LT_LPAREN] = ACTIONS(4064),
    [anon_sym_GT_LPAREN] = ACTIONS(4064),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4066),
    [anon_sym_LF] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4066),
  },
  [2644] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6335),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2645] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(6335),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2646] = {
    [sym__simple_heredoc_body] = ACTIONS(4070),
    [sym__heredoc_body_beginning] = ACTIONS(4070),
    [sym_file_descriptor] = ACTIONS(4070),
    [sym__concat] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_esac] = ACTIONS(4072),
    [anon_sym_PIPE] = ACTIONS(4072),
    [anon_sym_SEMI_SEMI] = ACTIONS(4070),
    [anon_sym_PIPE_AMP] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4070),
    [anon_sym_PIPE_PIPE] = ACTIONS(4070),
    [anon_sym_EQ_TILDE] = ACTIONS(4072),
    [anon_sym_EQ_EQ] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_GT] = ACTIONS(4072),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_AMP_GT] = ACTIONS(4072),
    [anon_sym_AMP_GT_GT] = ACTIONS(4070),
    [anon_sym_LT_AMP] = ACTIONS(4070),
    [anon_sym_GT_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4072),
    [anon_sym_LT_LT_DASH] = ACTIONS(4070),
    [anon_sym_LT_LT_LT] = ACTIONS(4070),
    [sym__special_characters] = ACTIONS(4070),
    [anon_sym_DQUOTE] = ACTIONS(4070),
    [anon_sym_DOLLAR] = ACTIONS(4072),
    [sym_raw_string] = ACTIONS(4070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4070),
    [anon_sym_BQUOTE] = ACTIONS(4070),
    [anon_sym_LT_LPAREN] = ACTIONS(4070),
    [anon_sym_GT_LPAREN] = ACTIONS(4070),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4072),
    [anon_sym_LF] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4072),
  },
  [2647] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6337),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2648] = {
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_esac] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [2649] = {
    [aux_sym_concatenation_repeat1] = STATE(2649),
    [sym__simple_heredoc_body] = ACTIONS(1726),
    [sym__heredoc_body_beginning] = ACTIONS(1726),
    [sym_file_descriptor] = ACTIONS(1726),
    [sym__concat] = ACTIONS(6339),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_esac] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_SEMI_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT] = ACTIONS(1728),
    [anon_sym_AMP_GT_GT] = ACTIONS(1726),
    [anon_sym_LT_AMP] = ACTIONS(1726),
    [anon_sym_GT_AMP] = ACTIONS(1726),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1726),
    [anon_sym_LT_LT_LT] = ACTIONS(1726),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1728),
  },
  [2650] = {
    [sym__simple_heredoc_body] = ACTIONS(1733),
    [sym__heredoc_body_beginning] = ACTIONS(1733),
    [sym_file_descriptor] = ACTIONS(1733),
    [sym__concat] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_esac] = ACTIONS(1733),
    [anon_sym_PIPE] = ACTIONS(1735),
    [anon_sym_SEMI_SEMI] = ACTIONS(1733),
    [anon_sym_PIPE_AMP] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1735),
    [anon_sym_GT] = ACTIONS(1735),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_AMP_GT] = ACTIONS(1735),
    [anon_sym_AMP_GT_GT] = ACTIONS(1733),
    [anon_sym_LT_AMP] = ACTIONS(1733),
    [anon_sym_GT_AMP] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1735),
    [anon_sym_LT_LT_DASH] = ACTIONS(1733),
    [anon_sym_LT_LT_LT] = ACTIONS(1733),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1735),
  },
  [2651] = {
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(6342),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [sym__string_content] = ACTIONS(793),
    [anon_sym_POUND] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(795),
    [anon_sym__] = ACTIONS(795),
  },
  [2652] = {
    [sym_concatenation] = STATE(2757),
    [sym_string] = STATE(2756),
    [sym_simple_expansion] = STATE(2756),
    [sym_string_expansion] = STATE(2756),
    [sym_expansion] = STATE(2756),
    [sym_command_substitution] = STATE(2756),
    [sym_process_substitution] = STATE(2756),
    [anon_sym_RBRACE] = ACTIONS(6344),
    [sym__special_characters] = ACTIONS(6346),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(6348),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6348),
  },
  [2653] = {
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(6350),
    [sym_comment] = ACTIONS(57),
  },
  [2654] = {
    [sym_concatenation] = STATE(2761),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2761),
    [anon_sym_RBRACE] = ACTIONS(6352),
    [anon_sym_EQ] = ACTIONS(6354),
    [anon_sym_DASH] = ACTIONS(6354),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(6358),
    [anon_sym_COLON] = ACTIONS(6354),
    [anon_sym_COLON_QMARK] = ACTIONS(6354),
    [anon_sym_COLON_DASH] = ACTIONS(6354),
    [anon_sym_PERCENT] = ACTIONS(6354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2655] = {
    [sym_concatenation] = STATE(2763),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2763),
    [anon_sym_RBRACE] = ACTIONS(6344),
    [anon_sym_EQ] = ACTIONS(6360),
    [anon_sym_DASH] = ACTIONS(6360),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(6364),
    [anon_sym_COLON] = ACTIONS(6360),
    [anon_sym_COLON_QMARK] = ACTIONS(6360),
    [anon_sym_COLON_DASH] = ACTIONS(6360),
    [anon_sym_PERCENT] = ACTIONS(6360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2656] = {
    [sym__simple_heredoc_body] = ACTIONS(1834),
    [sym__heredoc_body_beginning] = ACTIONS(1834),
    [sym_file_descriptor] = ACTIONS(1834),
    [sym__concat] = ACTIONS(1834),
    [anon_sym_SEMI] = ACTIONS(1836),
    [anon_sym_esac] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1836),
    [anon_sym_SEMI_SEMI] = ACTIONS(1834),
    [anon_sym_PIPE_AMP] = ACTIONS(1834),
    [anon_sym_AMP_AMP] = ACTIONS(1834),
    [anon_sym_PIPE_PIPE] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1836),
    [anon_sym_GT] = ACTIONS(1836),
    [anon_sym_GT_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT] = ACTIONS(1836),
    [anon_sym_AMP_GT_GT] = ACTIONS(1834),
    [anon_sym_LT_AMP] = ACTIONS(1834),
    [anon_sym_GT_AMP] = ACTIONS(1834),
    [anon_sym_LT_LT] = ACTIONS(1836),
    [anon_sym_LT_LT_DASH] = ACTIONS(1834),
    [anon_sym_LT_LT_LT] = ACTIONS(1834),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1834),
    [anon_sym_AMP] = ACTIONS(1836),
  },
  [2657] = {
    [sym_concatenation] = STATE(2766),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2766),
    [sym_regex] = ACTIONS(6366),
    [anon_sym_RBRACE] = ACTIONS(6368),
    [anon_sym_EQ] = ACTIONS(6370),
    [anon_sym_DASH] = ACTIONS(6370),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6372),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6370),
    [anon_sym_COLON_QMARK] = ACTIONS(6370),
    [anon_sym_COLON_DASH] = ACTIONS(6370),
    [anon_sym_PERCENT] = ACTIONS(6370),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2658] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6368),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2659] = {
    [sym__simple_heredoc_body] = ACTIONS(1882),
    [sym__heredoc_body_beginning] = ACTIONS(1882),
    [sym_file_descriptor] = ACTIONS(1882),
    [sym__concat] = ACTIONS(1882),
    [anon_sym_SEMI] = ACTIONS(1884),
    [anon_sym_esac] = ACTIONS(1882),
    [anon_sym_PIPE] = ACTIONS(1884),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [anon_sym_PIPE_AMP] = ACTIONS(1882),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1884),
    [anon_sym_GT_GT] = ACTIONS(1882),
    [anon_sym_AMP_GT] = ACTIONS(1884),
    [anon_sym_AMP_GT_GT] = ACTIONS(1882),
    [anon_sym_LT_AMP] = ACTIONS(1882),
    [anon_sym_GT_AMP] = ACTIONS(1882),
    [anon_sym_LT_LT] = ACTIONS(1884),
    [anon_sym_LT_LT_DASH] = ACTIONS(1882),
    [anon_sym_LT_LT_LT] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1884),
  },
  [2660] = {
    [sym_concatenation] = STATE(2763),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2763),
    [sym_regex] = ACTIONS(6374),
    [anon_sym_RBRACE] = ACTIONS(6344),
    [anon_sym_EQ] = ACTIONS(6360),
    [anon_sym_DASH] = ACTIONS(6360),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6360),
    [anon_sym_COLON_QMARK] = ACTIONS(6360),
    [anon_sym_COLON_DASH] = ACTIONS(6360),
    [anon_sym_PERCENT] = ACTIONS(6360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2661] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6344),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2662] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(6376),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2663] = {
    [sym__simple_heredoc_body] = ACTIONS(1890),
    [sym__heredoc_body_beginning] = ACTIONS(1890),
    [sym_file_descriptor] = ACTIONS(1890),
    [sym__concat] = ACTIONS(1890),
    [anon_sym_SEMI] = ACTIONS(1892),
    [anon_sym_esac] = ACTIONS(1890),
    [anon_sym_PIPE] = ACTIONS(1892),
    [anon_sym_SEMI_SEMI] = ACTIONS(1890),
    [anon_sym_PIPE_AMP] = ACTIONS(1890),
    [anon_sym_AMP_AMP] = ACTIONS(1890),
    [anon_sym_PIPE_PIPE] = ACTIONS(1890),
    [anon_sym_LT] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(1892),
    [anon_sym_GT_GT] = ACTIONS(1890),
    [anon_sym_AMP_GT] = ACTIONS(1892),
    [anon_sym_AMP_GT_GT] = ACTIONS(1890),
    [anon_sym_LT_AMP] = ACTIONS(1890),
    [anon_sym_GT_AMP] = ACTIONS(1890),
    [anon_sym_LT_LT] = ACTIONS(1892),
    [anon_sym_LT_LT_DASH] = ACTIONS(1890),
    [anon_sym_LT_LT_LT] = ACTIONS(1890),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1890),
    [anon_sym_AMP] = ACTIONS(1892),
  },
  [2664] = {
    [anon_sym_SEMI] = ACTIONS(6378),
    [anon_sym_RPAREN] = ACTIONS(6376),
    [anon_sym_SEMI_SEMI] = ACTIONS(6380),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6380),
    [anon_sym_AMP] = ACTIONS(6380),
  },
  [2665] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2771),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(6382),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(6376),
    [anon_sym_SEMI_SEMI] = ACTIONS(6384),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6384),
    [anon_sym_AMP] = ACTIONS(6382),
  },
  [2666] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2771),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(6382),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(6376),
    [anon_sym_SEMI_SEMI] = ACTIONS(6384),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(6384),
    [anon_sym_AMP] = ACTIONS(6382),
  },
  [2667] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(6376),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2668] = {
    [anon_sym_SEMI] = ACTIONS(6386),
    [anon_sym_SEMI_SEMI] = ACTIONS(6388),
    [anon_sym_BQUOTE] = ACTIONS(6376),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6388),
    [anon_sym_AMP] = ACTIONS(6388),
  },
  [2669] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2774),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(6390),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(6392),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(6376),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6392),
    [anon_sym_AMP] = ACTIONS(6390),
  },
  [2670] = {
    [sym_file_redirect] = STATE(489),
    [sym_heredoc_redirect] = STATE(489),
    [sym_heredoc_body] = STATE(2774),
    [sym_herestring_redirect] = STATE(489),
    [aux_sym_redirected_statement_repeat1] = STATE(489),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(6390),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI_SEMI] = ACTIONS(6392),
    [anon_sym_PIPE_AMP] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(6376),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(6392),
    [anon_sym_AMP] = ACTIONS(6390),
  },
  [2671] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(6394),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2672] = {
    [sym__simple_heredoc_body] = ACTIONS(1924),
    [sym__heredoc_body_beginning] = ACTIONS(1924),
    [sym_file_descriptor] = ACTIONS(1924),
    [sym__concat] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_esac] = ACTIONS(1924),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [anon_sym_PIPE_AMP] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_GT_GT] = ACTIONS(1924),
    [anon_sym_AMP_GT] = ACTIONS(1926),
    [anon_sym_AMP_GT_GT] = ACTIONS(1924),
    [anon_sym_LT_AMP] = ACTIONS(1924),
    [anon_sym_GT_AMP] = ACTIONS(1924),
    [anon_sym_LT_LT] = ACTIONS(1926),
    [anon_sym_LT_LT_DASH] = ACTIONS(1924),
    [anon_sym_LT_LT_LT] = ACTIONS(1924),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1926),
  },
  [2673] = {
    [anon_sym_SEMI] = ACTIONS(6396),
    [anon_sym_RPAREN] = ACTIONS(6394),
    [anon_sym_SEMI_SEMI] = ACTIONS(6398),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6398),
    [anon_sym_AMP] = ACTIONS(6398),
  },
  [2674] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2778),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(6400),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(6394),
    [anon_sym_SEMI_SEMI] = ACTIONS(6402),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_AMP_GT] = ACTIONS(597),
    [anon_sym_AMP_GT_GT] = ACTIONS(599),
    [anon_sym_LT_AMP] = ACTIONS(599),
    [anon_sym_GT_AMP] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6402),
    [anon_sym_AMP] = ACTIONS(6400),
  },
  [2675] = {
    [sym_file_redirect] = STATE(328),
    [sym_heredoc_redirect] = STATE(328),
    [sym_heredoc_body] = STATE(2778),
    [sym_herestring_redirect] = STATE(328),
    [aux_sym_redirected_statement_repeat1] = STATE(328),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(6400),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(6394),
    [anon_sym_SEMI_SEMI] = ACTIONS(6402),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(6402),
    [anon_sym_AMP] = ACTIONS(6400),
  },
  [2676] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_SEMI_SEMI] = ACTIONS(927),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(5836),
    [anon_sym_DQUOTE] = ACTIONS(5838),
    [anon_sym_DOLLAR] = ACTIONS(5836),
    [sym_raw_string] = ACTIONS(5838),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5838),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5838),
    [anon_sym_BQUOTE] = ACTIONS(5838),
    [anon_sym_LT_LPAREN] = ACTIONS(5838),
    [anon_sym_GT_LPAREN] = ACTIONS(5838),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5836),
  },
  [2677] = {
    [sym__special_characters] = ACTIONS(5838),
    [anon_sym_DQUOTE] = ACTIONS(5838),
    [anon_sym_DOLLAR] = ACTIONS(5836),
    [sym_raw_string] = ACTIONS(5838),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5838),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5838),
    [anon_sym_BQUOTE] = ACTIONS(5838),
    [anon_sym_LT_LPAREN] = ACTIONS(5838),
    [anon_sym_GT_LPAREN] = ACTIONS(5838),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5838),
  },
  [2678] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(979),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(6404),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(507),
    [anon_sym_GT_GT] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(507),
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2056),
    [anon_sym_AMP] = ACTIONS(2054),
  },
  [2679] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(979),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(6404),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2056),
    [anon_sym_AMP] = ACTIONS(2054),
  },
  [2680] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_SEMI_SEMI] = ACTIONS(927),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(5846),
    [anon_sym_DQUOTE] = ACTIONS(5848),
    [anon_sym_DOLLAR] = ACTIONS(5846),
    [sym_raw_string] = ACTIONS(5848),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5848),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5848),
    [anon_sym_BQUOTE] = ACTIONS(5848),
    [anon_sym_LT_LPAREN] = ACTIONS(5848),
    [anon_sym_GT_LPAREN] = ACTIONS(5848),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5846),
  },
  [2681] = {
    [sym__special_characters] = ACTIONS(5848),
    [anon_sym_DQUOTE] = ACTIONS(5848),
    [anon_sym_DOLLAR] = ACTIONS(5846),
    [sym_raw_string] = ACTIONS(5848),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5848),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5848),
    [anon_sym_BQUOTE] = ACTIONS(5848),
    [anon_sym_LT_LPAREN] = ACTIONS(5848),
    [anon_sym_GT_LPAREN] = ACTIONS(5848),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5848),
  },
  [2682] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(979),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(6406),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(507),
    [anon_sym_GT_GT] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(507),
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2056),
    [anon_sym_AMP] = ACTIONS(2054),
  },
  [2683] = {
    [sym_file_redirect] = STATE(276),
    [sym_heredoc_redirect] = STATE(276),
    [sym_heredoc_body] = STATE(979),
    [sym_herestring_redirect] = STATE(276),
    [aux_sym_redirected_statement_repeat1] = STATE(276),
    [sym__simple_heredoc_body] = ACTIONS(299),
    [sym__heredoc_body_beginning] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(339),
    [sym_variable_name] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(6406),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(341),
    [anon_sym_GT] = ACTIONS(341),
    [anon_sym_GT_GT] = ACTIONS(339),
    [anon_sym_AMP_GT] = ACTIONS(341),
    [anon_sym_AMP_GT_GT] = ACTIONS(339),
    [anon_sym_LT_AMP] = ACTIONS(339),
    [anon_sym_GT_AMP] = ACTIONS(339),
    [anon_sym_LT_LT] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(511),
    [sym__special_characters] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [sym_raw_string] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(339),
    [anon_sym_GT_LPAREN] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(341),
    [anon_sym_LF] = ACTIONS(2056),
    [anon_sym_AMP] = ACTIONS(2054),
  },
  [2684] = {
    [sym__simple_heredoc_body] = ACTIONS(2930),
    [sym__heredoc_body_beginning] = ACTIONS(2930),
    [sym_file_descriptor] = ACTIONS(2930),
    [sym__concat] = ACTIONS(2930),
    [sym_variable_name] = ACTIONS(2930),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym_esac] = ACTIONS(2932),
    [anon_sym_PIPE] = ACTIONS(2932),
    [anon_sym_SEMI_SEMI] = ACTIONS(2930),
    [anon_sym_PIPE_AMP] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2932),
    [anon_sym_GT_GT] = ACTIONS(2930),
    [anon_sym_AMP_GT] = ACTIONS(2932),
    [anon_sym_AMP_GT_GT] = ACTIONS(2930),
    [anon_sym_LT_AMP] = ACTIONS(2930),
    [anon_sym_GT_AMP] = ACTIONS(2930),
    [anon_sym_LT_LT] = ACTIONS(2932),
    [anon_sym_LT_LT_DASH] = ACTIONS(2930),
    [anon_sym_LT_LT_LT] = ACTIONS(2930),
    [sym__special_characters] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_DOLLAR] = ACTIONS(2932),
    [sym_raw_string] = ACTIONS(2930),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2930),
    [anon_sym_BQUOTE] = ACTIONS(2930),
    [anon_sym_LT_LPAREN] = ACTIONS(2930),
    [anon_sym_GT_LPAREN] = ACTIONS(2930),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2932),
    [anon_sym_LF] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2932),
  },
  [2685] = {
    [sym__simple_heredoc_body] = ACTIONS(2944),
    [sym__heredoc_body_beginning] = ACTIONS(2944),
    [sym_file_descriptor] = ACTIONS(2944),
    [sym__concat] = ACTIONS(2944),
    [sym_variable_name] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym_esac] = ACTIONS(2946),
    [anon_sym_PIPE] = ACTIONS(2946),
    [anon_sym_SEMI_SEMI] = ACTIONS(2944),
    [anon_sym_PIPE_AMP] = ACTIONS(2944),
    [anon_sym_AMP_AMP] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2946),
    [anon_sym_GT_GT] = ACTIONS(2944),
    [anon_sym_AMP_GT] = ACTIONS(2946),
    [anon_sym_AMP_GT_GT] = ACTIONS(2944),
    [anon_sym_LT_AMP] = ACTIONS(2944),
    [anon_sym_GT_AMP] = ACTIONS(2944),
    [anon_sym_LT_LT] = ACTIONS(2946),
    [anon_sym_LT_LT_DASH] = ACTIONS(2944),
    [anon_sym_LT_LT_LT] = ACTIONS(2944),
    [sym__special_characters] = ACTIONS(2944),
    [anon_sym_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [sym_raw_string] = ACTIONS(2944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2944),
    [anon_sym_BQUOTE] = ACTIONS(2944),
    [anon_sym_LT_LPAREN] = ACTIONS(2944),
    [anon_sym_GT_LPAREN] = ACTIONS(2944),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2946),
    [anon_sym_LF] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2946),
  },
  [2686] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6408),
    [sym_comment] = ACTIONS(57),
  },
  [2687] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6410),
    [sym_comment] = ACTIONS(57),
  },
  [2688] = {
    [anon_sym_RBRACE] = ACTIONS(6410),
    [sym_comment] = ACTIONS(57),
  },
  [2689] = {
    [sym_concatenation] = STATE(2785),
    [sym_string] = STATE(2784),
    [sym_simple_expansion] = STATE(2784),
    [sym_string_expansion] = STATE(2784),
    [sym_expansion] = STATE(2784),
    [sym_command_substitution] = STATE(2784),
    [sym_process_substitution] = STATE(2784),
    [anon_sym_RBRACE] = ACTIONS(6410),
    [sym__special_characters] = ACTIONS(6412),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(6414),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6414),
  },
  [2690] = {
    [sym__simple_heredoc_body] = ACTIONS(2980),
    [sym__heredoc_body_beginning] = ACTIONS(2980),
    [sym_file_descriptor] = ACTIONS(2980),
    [sym__concat] = ACTIONS(2980),
    [sym_variable_name] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym_esac] = ACTIONS(2982),
    [anon_sym_PIPE] = ACTIONS(2982),
    [anon_sym_SEMI_SEMI] = ACTIONS(2980),
    [anon_sym_PIPE_AMP] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_PIPE_PIPE] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2982),
    [anon_sym_GT_GT] = ACTIONS(2980),
    [anon_sym_AMP_GT] = ACTIONS(2982),
    [anon_sym_AMP_GT_GT] = ACTIONS(2980),
    [anon_sym_LT_AMP] = ACTIONS(2980),
    [anon_sym_GT_AMP] = ACTIONS(2980),
    [anon_sym_LT_LT] = ACTIONS(2982),
    [anon_sym_LT_LT_DASH] = ACTIONS(2980),
    [anon_sym_LT_LT_LT] = ACTIONS(2980),
    [sym__special_characters] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2982),
    [sym_raw_string] = ACTIONS(2980),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2980),
    [anon_sym_BQUOTE] = ACTIONS(2980),
    [anon_sym_LT_LPAREN] = ACTIONS(2980),
    [anon_sym_GT_LPAREN] = ACTIONS(2980),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2982),
    [anon_sym_LF] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2982),
  },
  [2691] = {
    [sym_concatenation] = STATE(2788),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2788),
    [sym_regex] = ACTIONS(6416),
    [anon_sym_RBRACE] = ACTIONS(6418),
    [anon_sym_EQ] = ACTIONS(6420),
    [anon_sym_DASH] = ACTIONS(6420),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6422),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6420),
    [anon_sym_COLON_QMARK] = ACTIONS(6420),
    [anon_sym_COLON_DASH] = ACTIONS(6420),
    [anon_sym_PERCENT] = ACTIONS(6420),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2692] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6418),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2693] = {
    [sym_concatenation] = STATE(2790),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2790),
    [sym_regex] = ACTIONS(6424),
    [anon_sym_RBRACE] = ACTIONS(6410),
    [anon_sym_EQ] = ACTIONS(6426),
    [anon_sym_DASH] = ACTIONS(6426),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6428),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6426),
    [anon_sym_COLON_QMARK] = ACTIONS(6426),
    [anon_sym_COLON_DASH] = ACTIONS(6426),
    [anon_sym_PERCENT] = ACTIONS(6426),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2694] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6410),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2695] = {
    [sym_concatenation] = STATE(2792),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2792),
    [anon_sym_RBRACE] = ACTIONS(6430),
    [anon_sym_EQ] = ACTIONS(6432),
    [anon_sym_DASH] = ACTIONS(6432),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6432),
    [anon_sym_COLON_QMARK] = ACTIONS(6432),
    [anon_sym_COLON_DASH] = ACTIONS(6432),
    [anon_sym_PERCENT] = ACTIONS(6432),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2696] = {
    [sym__simple_heredoc_body] = ACTIONS(3036),
    [sym__heredoc_body_beginning] = ACTIONS(3036),
    [sym_file_descriptor] = ACTIONS(3036),
    [sym__concat] = ACTIONS(3036),
    [sym_variable_name] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym_esac] = ACTIONS(3038),
    [anon_sym_PIPE] = ACTIONS(3038),
    [anon_sym_SEMI_SEMI] = ACTIONS(3036),
    [anon_sym_PIPE_AMP] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_PIPE_PIPE] = ACTIONS(3036),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_GT] = ACTIONS(3038),
    [anon_sym_GT_GT] = ACTIONS(3036),
    [anon_sym_AMP_GT] = ACTIONS(3038),
    [anon_sym_AMP_GT_GT] = ACTIONS(3036),
    [anon_sym_LT_AMP] = ACTIONS(3036),
    [anon_sym_GT_AMP] = ACTIONS(3036),
    [anon_sym_LT_LT] = ACTIONS(3038),
    [anon_sym_LT_LT_DASH] = ACTIONS(3036),
    [anon_sym_LT_LT_LT] = ACTIONS(3036),
    [sym__special_characters] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [anon_sym_DOLLAR] = ACTIONS(3038),
    [sym_raw_string] = ACTIONS(3036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3036),
    [anon_sym_BQUOTE] = ACTIONS(3036),
    [anon_sym_LT_LPAREN] = ACTIONS(3036),
    [anon_sym_GT_LPAREN] = ACTIONS(3036),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3038),
    [anon_sym_LF] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3038),
  },
  [2697] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6430),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2698] = {
    [sym_concatenation] = STATE(2790),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2790),
    [anon_sym_RBRACE] = ACTIONS(6410),
    [anon_sym_EQ] = ACTIONS(6426),
    [anon_sym_DASH] = ACTIONS(6426),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6428),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6426),
    [anon_sym_COLON_QMARK] = ACTIONS(6426),
    [anon_sym_COLON_DASH] = ACTIONS(6426),
    [anon_sym_PERCENT] = ACTIONS(6426),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2699] = {
    [sym__simple_heredoc_body] = ACTIONS(3091),
    [sym__heredoc_body_beginning] = ACTIONS(3091),
    [sym_file_descriptor] = ACTIONS(3091),
    [sym__concat] = ACTIONS(3091),
    [sym_variable_name] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_esac] = ACTIONS(3093),
    [anon_sym_PIPE] = ACTIONS(3093),
    [anon_sym_SEMI_SEMI] = ACTIONS(3091),
    [anon_sym_PIPE_AMP] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_GT] = ACTIONS(3093),
    [anon_sym_GT_GT] = ACTIONS(3091),
    [anon_sym_AMP_GT] = ACTIONS(3093),
    [anon_sym_AMP_GT_GT] = ACTIONS(3091),
    [anon_sym_LT_AMP] = ACTIONS(3091),
    [anon_sym_GT_AMP] = ACTIONS(3091),
    [anon_sym_LT_LT] = ACTIONS(3093),
    [anon_sym_LT_LT_DASH] = ACTIONS(3091),
    [anon_sym_LT_LT_LT] = ACTIONS(3091),
    [sym__special_characters] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_DOLLAR] = ACTIONS(3093),
    [sym_raw_string] = ACTIONS(3091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3091),
    [anon_sym_BQUOTE] = ACTIONS(3091),
    [anon_sym_LT_LPAREN] = ACTIONS(3091),
    [anon_sym_GT_LPAREN] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3093),
    [anon_sym_LF] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3093),
  },
  [2700] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6436),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2701] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(6436),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2702] = {
    [anon_sym_SEMI] = ACTIONS(6438),
    [anon_sym_RPAREN] = ACTIONS(6436),
    [anon_sym_SEMI_SEMI] = ACTIONS(6440),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6440),
    [anon_sym_AMP] = ACTIONS(6440),
  },
  [2703] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(6436),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2704] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(6436),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2705] = {
    [anon_sym_SEMI] = ACTIONS(6442),
    [anon_sym_SEMI_SEMI] = ACTIONS(6444),
    [anon_sym_BQUOTE] = ACTIONS(6436),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6444),
    [anon_sym_AMP] = ACTIONS(6444),
  },
  [2706] = {
    [sym__simple_heredoc_body] = ACTIONS(3121),
    [sym__heredoc_body_beginning] = ACTIONS(3121),
    [sym_file_descriptor] = ACTIONS(3121),
    [sym__concat] = ACTIONS(3121),
    [sym_variable_name] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3123),
    [anon_sym_esac] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3123),
    [anon_sym_SEMI_SEMI] = ACTIONS(3121),
    [anon_sym_PIPE_AMP] = ACTIONS(3121),
    [anon_sym_AMP_AMP] = ACTIONS(3121),
    [anon_sym_PIPE_PIPE] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_GT] = ACTIONS(3123),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_AMP_GT] = ACTIONS(3123),
    [anon_sym_AMP_GT_GT] = ACTIONS(3121),
    [anon_sym_LT_AMP] = ACTIONS(3121),
    [anon_sym_GT_AMP] = ACTIONS(3121),
    [anon_sym_LT_LT] = ACTIONS(3123),
    [anon_sym_LT_LT_DASH] = ACTIONS(3121),
    [anon_sym_LT_LT_LT] = ACTIONS(3121),
    [sym__special_characters] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [sym_raw_string] = ACTIONS(3121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3121),
    [anon_sym_BQUOTE] = ACTIONS(3121),
    [anon_sym_LT_LPAREN] = ACTIONS(3121),
    [anon_sym_GT_LPAREN] = ACTIONS(3121),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3123),
    [anon_sym_LF] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
  },
  [2707] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6446),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2708] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(6446),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2709] = {
    [anon_sym_SEMI] = ACTIONS(6448),
    [anon_sym_RPAREN] = ACTIONS(6446),
    [anon_sym_SEMI_SEMI] = ACTIONS(6450),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6450),
    [anon_sym_AMP] = ACTIONS(6450),
  },
  [2710] = {
    [sym__simple_heredoc_body] = ACTIONS(3238),
    [sym__heredoc_body_beginning] = ACTIONS(3238),
    [sym_file_descriptor] = ACTIONS(3238),
    [sym_variable_name] = ACTIONS(3238),
    [anon_sym_SEMI] = ACTIONS(3240),
    [anon_sym_esac] = ACTIONS(3240),
    [anon_sym_PIPE] = ACTIONS(3240),
    [anon_sym_SEMI_SEMI] = ACTIONS(3238),
    [anon_sym_PIPE_AMP] = ACTIONS(3238),
    [anon_sym_AMP_AMP] = ACTIONS(3238),
    [anon_sym_PIPE_PIPE] = ACTIONS(3238),
    [anon_sym_LT] = ACTIONS(3240),
    [anon_sym_GT] = ACTIONS(3240),
    [anon_sym_GT_GT] = ACTIONS(3238),
    [anon_sym_AMP_GT] = ACTIONS(3240),
    [anon_sym_AMP_GT_GT] = ACTIONS(3238),
    [anon_sym_LT_AMP] = ACTIONS(3238),
    [anon_sym_GT_AMP] = ACTIONS(3238),
    [anon_sym_LT_LT] = ACTIONS(3240),
    [anon_sym_LT_LT_DASH] = ACTIONS(3238),
    [anon_sym_LT_LT_LT] = ACTIONS(3238),
    [sym__special_characters] = ACTIONS(3238),
    [anon_sym_DQUOTE] = ACTIONS(3238),
    [anon_sym_DOLLAR] = ACTIONS(3240),
    [sym_raw_string] = ACTIONS(3238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3238),
    [anon_sym_BQUOTE] = ACTIONS(3238),
    [anon_sym_LT_LPAREN] = ACTIONS(3238),
    [anon_sym_GT_LPAREN] = ACTIONS(3238),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3240),
    [sym_word] = ACTIONS(3240),
    [anon_sym_LF] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
  },
  [2711] = {
    [sym__simple_heredoc_body] = ACTIONS(3921),
    [sym__heredoc_body_beginning] = ACTIONS(3921),
    [sym_file_descriptor] = ACTIONS(3921),
    [sym__concat] = ACTIONS(3921),
    [sym_variable_name] = ACTIONS(3921),
    [anon_sym_SEMI] = ACTIONS(3923),
    [anon_sym_esac] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_SEMI_SEMI] = ACTIONS(3921),
    [anon_sym_PIPE_AMP] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_GT_GT] = ACTIONS(3921),
    [anon_sym_AMP_GT] = ACTIONS(3923),
    [anon_sym_AMP_GT_GT] = ACTIONS(3921),
    [anon_sym_LT_AMP] = ACTIONS(3921),
    [anon_sym_GT_AMP] = ACTIONS(3921),
    [anon_sym_LT_LT] = ACTIONS(3923),
    [anon_sym_LT_LT_DASH] = ACTIONS(3921),
    [anon_sym_LT_LT_LT] = ACTIONS(3921),
    [sym__special_characters] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_DOLLAR] = ACTIONS(3923),
    [sym_raw_string] = ACTIONS(3921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3921),
    [anon_sym_BQUOTE] = ACTIONS(3921),
    [anon_sym_LT_LPAREN] = ACTIONS(3921),
    [anon_sym_GT_LPAREN] = ACTIONS(3921),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3923),
    [sym_word] = ACTIONS(3923),
    [anon_sym_LF] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3923),
  },
  [2712] = {
    [sym__simple_heredoc_body] = ACTIONS(3929),
    [sym__heredoc_body_beginning] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [sym__concat] = ACTIONS(3929),
    [sym_variable_name] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3931),
    [anon_sym_esac] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3931),
    [anon_sym_SEMI_SEMI] = ACTIONS(3929),
    [anon_sym_PIPE_AMP] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_AMP_GT] = ACTIONS(3931),
    [anon_sym_AMP_GT_GT] = ACTIONS(3929),
    [anon_sym_LT_AMP] = ACTIONS(3929),
    [anon_sym_GT_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_LT_LT_DASH] = ACTIONS(3929),
    [anon_sym_LT_LT_LT] = ACTIONS(3929),
    [sym__special_characters] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [sym_raw_string] = ACTIONS(3929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3929),
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [anon_sym_LT_LPAREN] = ACTIONS(3929),
    [anon_sym_GT_LPAREN] = ACTIONS(3929),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3931),
    [sym_word] = ACTIONS(3931),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
  },
  [2713] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6452),
    [sym_comment] = ACTIONS(57),
  },
  [2714] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6454),
    [sym_comment] = ACTIONS(57),
  },
  [2715] = {
    [anon_sym_RBRACE] = ACTIONS(6454),
    [sym_comment] = ACTIONS(57),
  },
  [2716] = {
    [sym_concatenation] = STATE(2801),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2801),
    [anon_sym_RBRACE] = ACTIONS(6456),
    [anon_sym_EQ] = ACTIONS(6458),
    [anon_sym_DASH] = ACTIONS(6458),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6460),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6458),
    [anon_sym_COLON_QMARK] = ACTIONS(6458),
    [anon_sym_COLON_DASH] = ACTIONS(6458),
    [anon_sym_PERCENT] = ACTIONS(6458),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2717] = {
    [sym__simple_heredoc_body] = ACTIONS(3985),
    [sym__heredoc_body_beginning] = ACTIONS(3985),
    [sym_file_descriptor] = ACTIONS(3985),
    [sym__concat] = ACTIONS(3985),
    [sym_variable_name] = ACTIONS(3985),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_esac] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_AMP_GT] = ACTIONS(3987),
    [anon_sym_AMP_GT_GT] = ACTIONS(3985),
    [anon_sym_LT_AMP] = ACTIONS(3985),
    [anon_sym_GT_AMP] = ACTIONS(3985),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_LT_LT_DASH] = ACTIONS(3985),
    [anon_sym_LT_LT_LT] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3987),
    [sym_word] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [2718] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6456),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2719] = {
    [sym_concatenation] = STATE(2802),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2802),
    [anon_sym_RBRACE] = ACTIONS(6454),
    [anon_sym_EQ] = ACTIONS(6462),
    [anon_sym_DASH] = ACTIONS(6462),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6462),
    [anon_sym_COLON_QMARK] = ACTIONS(6462),
    [anon_sym_COLON_DASH] = ACTIONS(6462),
    [anon_sym_PERCENT] = ACTIONS(6462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2720] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6454),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2721] = {
    [sym__simple_heredoc_body] = ACTIONS(4030),
    [sym__heredoc_body_beginning] = ACTIONS(4030),
    [sym_file_descriptor] = ACTIONS(4030),
    [sym__concat] = ACTIONS(4030),
    [sym_variable_name] = ACTIONS(4030),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_esac] = ACTIONS(4032),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_SEMI_SEMI] = ACTIONS(4030),
    [anon_sym_PIPE_AMP] = ACTIONS(4030),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_LT] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(4032),
    [anon_sym_GT_GT] = ACTIONS(4030),
    [anon_sym_AMP_GT] = ACTIONS(4032),
    [anon_sym_AMP_GT_GT] = ACTIONS(4030),
    [anon_sym_LT_AMP] = ACTIONS(4030),
    [anon_sym_GT_AMP] = ACTIONS(4030),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_LT_LT_DASH] = ACTIONS(4030),
    [anon_sym_LT_LT_LT] = ACTIONS(4030),
    [sym__special_characters] = ACTIONS(4030),
    [anon_sym_DQUOTE] = ACTIONS(4030),
    [anon_sym_DOLLAR] = ACTIONS(4032),
    [sym_raw_string] = ACTIONS(4030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4030),
    [anon_sym_BQUOTE] = ACTIONS(4030),
    [anon_sym_LT_LPAREN] = ACTIONS(4030),
    [anon_sym_GT_LPAREN] = ACTIONS(4030),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4032),
    [sym_word] = ACTIONS(4032),
    [anon_sym_LF] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4032),
  },
  [2722] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6466),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2723] = {
    [sym__simple_heredoc_body] = ACTIONS(4064),
    [sym__heredoc_body_beginning] = ACTIONS(4064),
    [sym_file_descriptor] = ACTIONS(4064),
    [sym__concat] = ACTIONS(4064),
    [sym_variable_name] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_esac] = ACTIONS(4066),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_SEMI_SEMI] = ACTIONS(4064),
    [anon_sym_PIPE_AMP] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_GT_GT] = ACTIONS(4064),
    [anon_sym_AMP_GT] = ACTIONS(4066),
    [anon_sym_AMP_GT_GT] = ACTIONS(4064),
    [anon_sym_LT_AMP] = ACTIONS(4064),
    [anon_sym_GT_AMP] = ACTIONS(4064),
    [anon_sym_LT_LT] = ACTIONS(4066),
    [anon_sym_LT_LT_DASH] = ACTIONS(4064),
    [anon_sym_LT_LT_LT] = ACTIONS(4064),
    [sym__special_characters] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_DOLLAR] = ACTIONS(4066),
    [sym_raw_string] = ACTIONS(4064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4064),
    [anon_sym_BQUOTE] = ACTIONS(4064),
    [anon_sym_LT_LPAREN] = ACTIONS(4064),
    [anon_sym_GT_LPAREN] = ACTIONS(4064),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4066),
    [sym_word] = ACTIONS(4066),
    [anon_sym_LF] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4066),
  },
  [2724] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6468),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2725] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(6468),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2726] = {
    [sym__simple_heredoc_body] = ACTIONS(4070),
    [sym__heredoc_body_beginning] = ACTIONS(4070),
    [sym_file_descriptor] = ACTIONS(4070),
    [sym__concat] = ACTIONS(4070),
    [sym_variable_name] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_esac] = ACTIONS(4072),
    [anon_sym_PIPE] = ACTIONS(4072),
    [anon_sym_SEMI_SEMI] = ACTIONS(4070),
    [anon_sym_PIPE_AMP] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4070),
    [anon_sym_PIPE_PIPE] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_GT] = ACTIONS(4072),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_AMP_GT] = ACTIONS(4072),
    [anon_sym_AMP_GT_GT] = ACTIONS(4070),
    [anon_sym_LT_AMP] = ACTIONS(4070),
    [anon_sym_GT_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4072),
    [anon_sym_LT_LT_DASH] = ACTIONS(4070),
    [anon_sym_LT_LT_LT] = ACTIONS(4070),
    [sym__special_characters] = ACTIONS(4070),
    [anon_sym_DQUOTE] = ACTIONS(4070),
    [anon_sym_DOLLAR] = ACTIONS(4072),
    [sym_raw_string] = ACTIONS(4070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4070),
    [anon_sym_BQUOTE] = ACTIONS(4070),
    [anon_sym_LT_LPAREN] = ACTIONS(4070),
    [anon_sym_GT_LPAREN] = ACTIONS(4070),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4072),
    [sym_word] = ACTIONS(4072),
    [anon_sym_LF] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4072),
  },
  [2727] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6470),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2728] = {
    [sym__simple_heredoc_body] = ACTIONS(3921),
    [sym__heredoc_body_beginning] = ACTIONS(3921),
    [sym_file_descriptor] = ACTIONS(3921),
    [sym__concat] = ACTIONS(3921),
    [anon_sym_SEMI] = ACTIONS(3923),
    [anon_sym_esac] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_SEMI_SEMI] = ACTIONS(3921),
    [anon_sym_PIPE_AMP] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_GT_GT] = ACTIONS(3921),
    [anon_sym_AMP_GT] = ACTIONS(3923),
    [anon_sym_AMP_GT_GT] = ACTIONS(3921),
    [anon_sym_LT_AMP] = ACTIONS(3921),
    [anon_sym_GT_AMP] = ACTIONS(3921),
    [anon_sym_LT_LT] = ACTIONS(3923),
    [anon_sym_LT_LT_DASH] = ACTIONS(3921),
    [anon_sym_LT_LT_LT] = ACTIONS(3921),
    [sym__special_characters] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_DOLLAR] = ACTIONS(3923),
    [sym_raw_string] = ACTIONS(3921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3921),
    [anon_sym_BQUOTE] = ACTIONS(3921),
    [anon_sym_LT_LPAREN] = ACTIONS(3921),
    [anon_sym_GT_LPAREN] = ACTIONS(3921),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3923),
    [sym_word] = ACTIONS(3923),
    [anon_sym_LF] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3923),
  },
  [2729] = {
    [sym__simple_heredoc_body] = ACTIONS(3929),
    [sym__heredoc_body_beginning] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [sym__concat] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3931),
    [anon_sym_esac] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3931),
    [anon_sym_SEMI_SEMI] = ACTIONS(3929),
    [anon_sym_PIPE_AMP] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_AMP_GT] = ACTIONS(3931),
    [anon_sym_AMP_GT_GT] = ACTIONS(3929),
    [anon_sym_LT_AMP] = ACTIONS(3929),
    [anon_sym_GT_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_LT_LT_DASH] = ACTIONS(3929),
    [anon_sym_LT_LT_LT] = ACTIONS(3929),
    [sym__special_characters] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [sym_raw_string] = ACTIONS(3929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3929),
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [anon_sym_LT_LPAREN] = ACTIONS(3929),
    [anon_sym_GT_LPAREN] = ACTIONS(3929),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3931),
    [sym_word] = ACTIONS(3931),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
  },
  [2730] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6472),
    [sym_comment] = ACTIONS(57),
  },
  [2731] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6474),
    [sym_comment] = ACTIONS(57),
  },
  [2732] = {
    [anon_sym_RBRACE] = ACTIONS(6474),
    [sym_comment] = ACTIONS(57),
  },
  [2733] = {
    [sym_concatenation] = STATE(2809),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2809),
    [anon_sym_RBRACE] = ACTIONS(6476),
    [anon_sym_EQ] = ACTIONS(6478),
    [anon_sym_DASH] = ACTIONS(6478),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6480),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6478),
    [anon_sym_COLON_QMARK] = ACTIONS(6478),
    [anon_sym_COLON_DASH] = ACTIONS(6478),
    [anon_sym_PERCENT] = ACTIONS(6478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2734] = {
    [sym__simple_heredoc_body] = ACTIONS(3985),
    [sym__heredoc_body_beginning] = ACTIONS(3985),
    [sym_file_descriptor] = ACTIONS(3985),
    [sym__concat] = ACTIONS(3985),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_esac] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_AMP_GT] = ACTIONS(3987),
    [anon_sym_AMP_GT_GT] = ACTIONS(3985),
    [anon_sym_LT_AMP] = ACTIONS(3985),
    [anon_sym_GT_AMP] = ACTIONS(3985),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_LT_LT_DASH] = ACTIONS(3985),
    [anon_sym_LT_LT_LT] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3987),
    [sym_word] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [2735] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6476),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2736] = {
    [sym_concatenation] = STATE(2810),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2810),
    [anon_sym_RBRACE] = ACTIONS(6474),
    [anon_sym_EQ] = ACTIONS(6482),
    [anon_sym_DASH] = ACTIONS(6482),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6482),
    [anon_sym_COLON_QMARK] = ACTIONS(6482),
    [anon_sym_COLON_DASH] = ACTIONS(6482),
    [anon_sym_PERCENT] = ACTIONS(6482),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2737] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6474),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2738] = {
    [sym__simple_heredoc_body] = ACTIONS(4030),
    [sym__heredoc_body_beginning] = ACTIONS(4030),
    [sym_file_descriptor] = ACTIONS(4030),
    [sym__concat] = ACTIONS(4030),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_esac] = ACTIONS(4032),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_SEMI_SEMI] = ACTIONS(4030),
    [anon_sym_PIPE_AMP] = ACTIONS(4030),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_LT] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(4032),
    [anon_sym_GT_GT] = ACTIONS(4030),
    [anon_sym_AMP_GT] = ACTIONS(4032),
    [anon_sym_AMP_GT_GT] = ACTIONS(4030),
    [anon_sym_LT_AMP] = ACTIONS(4030),
    [anon_sym_GT_AMP] = ACTIONS(4030),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_LT_LT_DASH] = ACTIONS(4030),
    [anon_sym_LT_LT_LT] = ACTIONS(4030),
    [sym__special_characters] = ACTIONS(4030),
    [anon_sym_DQUOTE] = ACTIONS(4030),
    [anon_sym_DOLLAR] = ACTIONS(4032),
    [sym_raw_string] = ACTIONS(4030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4030),
    [anon_sym_BQUOTE] = ACTIONS(4030),
    [anon_sym_LT_LPAREN] = ACTIONS(4030),
    [anon_sym_GT_LPAREN] = ACTIONS(4030),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4032),
    [sym_word] = ACTIONS(4032),
    [anon_sym_LF] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4032),
  },
  [2739] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6486),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2740] = {
    [sym__simple_heredoc_body] = ACTIONS(4064),
    [sym__heredoc_body_beginning] = ACTIONS(4064),
    [sym_file_descriptor] = ACTIONS(4064),
    [sym__concat] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_esac] = ACTIONS(4066),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_SEMI_SEMI] = ACTIONS(4064),
    [anon_sym_PIPE_AMP] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_GT_GT] = ACTIONS(4064),
    [anon_sym_AMP_GT] = ACTIONS(4066),
    [anon_sym_AMP_GT_GT] = ACTIONS(4064),
    [anon_sym_LT_AMP] = ACTIONS(4064),
    [anon_sym_GT_AMP] = ACTIONS(4064),
    [anon_sym_LT_LT] = ACTIONS(4066),
    [anon_sym_LT_LT_DASH] = ACTIONS(4064),
    [anon_sym_LT_LT_LT] = ACTIONS(4064),
    [sym__special_characters] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_DOLLAR] = ACTIONS(4066),
    [sym_raw_string] = ACTIONS(4064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4064),
    [anon_sym_BQUOTE] = ACTIONS(4064),
    [anon_sym_LT_LPAREN] = ACTIONS(4064),
    [anon_sym_GT_LPAREN] = ACTIONS(4064),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4066),
    [sym_word] = ACTIONS(4066),
    [anon_sym_LF] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4066),
  },
  [2741] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6488),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2742] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(6488),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2743] = {
    [sym__simple_heredoc_body] = ACTIONS(4070),
    [sym__heredoc_body_beginning] = ACTIONS(4070),
    [sym_file_descriptor] = ACTIONS(4070),
    [sym__concat] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_esac] = ACTIONS(4072),
    [anon_sym_PIPE] = ACTIONS(4072),
    [anon_sym_SEMI_SEMI] = ACTIONS(4070),
    [anon_sym_PIPE_AMP] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4070),
    [anon_sym_PIPE_PIPE] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_GT] = ACTIONS(4072),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_AMP_GT] = ACTIONS(4072),
    [anon_sym_AMP_GT_GT] = ACTIONS(4070),
    [anon_sym_LT_AMP] = ACTIONS(4070),
    [anon_sym_GT_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4072),
    [anon_sym_LT_LT_DASH] = ACTIONS(4070),
    [anon_sym_LT_LT_LT] = ACTIONS(4070),
    [sym__special_characters] = ACTIONS(4070),
    [anon_sym_DQUOTE] = ACTIONS(4070),
    [anon_sym_DOLLAR] = ACTIONS(4072),
    [sym_raw_string] = ACTIONS(4070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4070),
    [anon_sym_BQUOTE] = ACTIONS(4070),
    [anon_sym_LT_LPAREN] = ACTIONS(4070),
    [anon_sym_GT_LPAREN] = ACTIONS(4070),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4072),
    [sym_word] = ACTIONS(4072),
    [anon_sym_LF] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4072),
  },
  [2744] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6490),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2745] = {
    [sym__simple_heredoc_body] = ACTIONS(4687),
    [sym__heredoc_body_beginning] = ACTIONS(4687),
    [sym_file_descriptor] = ACTIONS(4687),
    [sym__concat] = ACTIONS(4687),
    [anon_sym_SEMI] = ACTIONS(4689),
    [anon_sym_esac] = ACTIONS(4689),
    [anon_sym_PIPE] = ACTIONS(4689),
    [anon_sym_SEMI_SEMI] = ACTIONS(4687),
    [anon_sym_PIPE_AMP] = ACTIONS(4687),
    [anon_sym_AMP_AMP] = ACTIONS(4687),
    [anon_sym_PIPE_PIPE] = ACTIONS(4687),
    [anon_sym_EQ_TILDE] = ACTIONS(4689),
    [anon_sym_EQ_EQ] = ACTIONS(4689),
    [anon_sym_LT] = ACTIONS(4689),
    [anon_sym_GT] = ACTIONS(4689),
    [anon_sym_GT_GT] = ACTIONS(4687),
    [anon_sym_AMP_GT] = ACTIONS(4689),
    [anon_sym_AMP_GT_GT] = ACTIONS(4687),
    [anon_sym_LT_AMP] = ACTIONS(4687),
    [anon_sym_GT_AMP] = ACTIONS(4687),
    [anon_sym_LT_LT] = ACTIONS(4689),
    [anon_sym_LT_LT_DASH] = ACTIONS(4687),
    [anon_sym_LT_LT_LT] = ACTIONS(4687),
    [sym__special_characters] = ACTIONS(4687),
    [anon_sym_DQUOTE] = ACTIONS(4687),
    [anon_sym_DOLLAR] = ACTIONS(4689),
    [sym_raw_string] = ACTIONS(4687),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4687),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4687),
    [anon_sym_BQUOTE] = ACTIONS(4687),
    [anon_sym_LT_LPAREN] = ACTIONS(4687),
    [anon_sym_GT_LPAREN] = ACTIONS(4687),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4689),
    [anon_sym_LF] = ACTIONS(4687),
    [anon_sym_AMP] = ACTIONS(4689),
  },
  [2746] = {
    [sym__simple_heredoc_body] = ACTIONS(4691),
    [sym__heredoc_body_beginning] = ACTIONS(4691),
    [sym_file_descriptor] = ACTIONS(4691),
    [sym__concat] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4693),
    [anon_sym_esac] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_SEMI_SEMI] = ACTIONS(4691),
    [anon_sym_PIPE_AMP] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4691),
    [anon_sym_EQ_TILDE] = ACTIONS(4693),
    [anon_sym_EQ_EQ] = ACTIONS(4693),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4691),
    [anon_sym_AMP_GT] = ACTIONS(4693),
    [anon_sym_AMP_GT_GT] = ACTIONS(4691),
    [anon_sym_LT_AMP] = ACTIONS(4691),
    [anon_sym_GT_AMP] = ACTIONS(4691),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_LT_LT_DASH] = ACTIONS(4691),
    [anon_sym_LT_LT_LT] = ACTIONS(4691),
    [sym__special_characters] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4693),
    [sym_raw_string] = ACTIONS(4691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4691),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_LT_LPAREN] = ACTIONS(4691),
    [anon_sym_GT_LPAREN] = ACTIONS(4691),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4693),
    [anon_sym_LF] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4693),
  },
  [2747] = {
    [sym__simple_heredoc_body] = ACTIONS(4695),
    [sym__heredoc_body_beginning] = ACTIONS(4695),
    [sym_file_descriptor] = ACTIONS(4695),
    [sym__concat] = ACTIONS(4695),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_esac] = ACTIONS(4697),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_SEMI_SEMI] = ACTIONS(4695),
    [anon_sym_PIPE_AMP] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_EQ_TILDE] = ACTIONS(4697),
    [anon_sym_EQ_EQ] = ACTIONS(4697),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_GT_GT] = ACTIONS(4695),
    [anon_sym_AMP_GT] = ACTIONS(4697),
    [anon_sym_AMP_GT_GT] = ACTIONS(4695),
    [anon_sym_LT_AMP] = ACTIONS(4695),
    [anon_sym_GT_AMP] = ACTIONS(4695),
    [anon_sym_LT_LT] = ACTIONS(4697),
    [anon_sym_LT_LT_DASH] = ACTIONS(4695),
    [anon_sym_LT_LT_LT] = ACTIONS(4695),
    [sym__special_characters] = ACTIONS(4695),
    [anon_sym_DQUOTE] = ACTIONS(4695),
    [anon_sym_DOLLAR] = ACTIONS(4697),
    [sym_raw_string] = ACTIONS(4695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4695),
    [anon_sym_BQUOTE] = ACTIONS(4695),
    [anon_sym_LT_LPAREN] = ACTIONS(4695),
    [anon_sym_GT_LPAREN] = ACTIONS(4695),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4697),
    [anon_sym_LF] = ACTIONS(4695),
    [anon_sym_AMP] = ACTIONS(4697),
  },
  [2748] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6492),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2749] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6494),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2750] = {
    [sym__simple_heredoc_body] = ACTIONS(4731),
    [sym__heredoc_body_beginning] = ACTIONS(4731),
    [sym_file_descriptor] = ACTIONS(4731),
    [sym__concat] = ACTIONS(4731),
    [anon_sym_SEMI] = ACTIONS(4733),
    [anon_sym_esac] = ACTIONS(4733),
    [anon_sym_PIPE] = ACTIONS(4733),
    [anon_sym_SEMI_SEMI] = ACTIONS(4731),
    [anon_sym_PIPE_AMP] = ACTIONS(4731),
    [anon_sym_AMP_AMP] = ACTIONS(4731),
    [anon_sym_PIPE_PIPE] = ACTIONS(4731),
    [anon_sym_EQ_TILDE] = ACTIONS(4733),
    [anon_sym_EQ_EQ] = ACTIONS(4733),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_GT] = ACTIONS(4731),
    [anon_sym_AMP_GT] = ACTIONS(4733),
    [anon_sym_AMP_GT_GT] = ACTIONS(4731),
    [anon_sym_LT_AMP] = ACTIONS(4731),
    [anon_sym_GT_AMP] = ACTIONS(4731),
    [anon_sym_LT_LT] = ACTIONS(4733),
    [anon_sym_LT_LT_DASH] = ACTIONS(4731),
    [anon_sym_LT_LT_LT] = ACTIONS(4731),
    [sym__special_characters] = ACTIONS(4731),
    [anon_sym_DQUOTE] = ACTIONS(4731),
    [anon_sym_DOLLAR] = ACTIONS(4733),
    [sym_raw_string] = ACTIONS(4731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4731),
    [anon_sym_BQUOTE] = ACTIONS(4731),
    [anon_sym_LT_LPAREN] = ACTIONS(4731),
    [anon_sym_GT_LPAREN] = ACTIONS(4731),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4733),
    [anon_sym_LF] = ACTIONS(4731),
    [anon_sym_AMP] = ACTIONS(4733),
  },
  [2751] = {
    [sym__simple_heredoc_body] = ACTIONS(4751),
    [sym__heredoc_body_beginning] = ACTIONS(4751),
    [sym_file_descriptor] = ACTIONS(4751),
    [sym__concat] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4753),
    [anon_sym_esac] = ACTIONS(4753),
    [anon_sym_PIPE] = ACTIONS(4753),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_PIPE_AMP] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [anon_sym_EQ_TILDE] = ACTIONS(4753),
    [anon_sym_EQ_EQ] = ACTIONS(4753),
    [anon_sym_LT] = ACTIONS(4753),
    [anon_sym_GT] = ACTIONS(4753),
    [anon_sym_GT_GT] = ACTIONS(4751),
    [anon_sym_AMP_GT] = ACTIONS(4753),
    [anon_sym_AMP_GT_GT] = ACTIONS(4751),
    [anon_sym_LT_AMP] = ACTIONS(4751),
    [anon_sym_GT_AMP] = ACTIONS(4751),
    [anon_sym_LT_LT] = ACTIONS(4753),
    [anon_sym_LT_LT_DASH] = ACTIONS(4751),
    [anon_sym_LT_LT_LT] = ACTIONS(4751),
    [sym__special_characters] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4753),
    [sym_raw_string] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_LT_LPAREN] = ACTIONS(4751),
    [anon_sym_GT_LPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4753),
    [anon_sym_LF] = ACTIONS(4751),
    [anon_sym_AMP] = ACTIONS(4753),
  },
  [2752] = {
    [sym__simple_heredoc_body] = ACTIONS(4755),
    [sym__heredoc_body_beginning] = ACTIONS(4755),
    [sym_file_descriptor] = ACTIONS(4755),
    [sym__concat] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4757),
    [anon_sym_esac] = ACTIONS(4757),
    [anon_sym_PIPE] = ACTIONS(4757),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [anon_sym_PIPE_AMP] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [anon_sym_EQ_TILDE] = ACTIONS(4757),
    [anon_sym_EQ_EQ] = ACTIONS(4757),
    [anon_sym_LT] = ACTIONS(4757),
    [anon_sym_GT] = ACTIONS(4757),
    [anon_sym_GT_GT] = ACTIONS(4755),
    [anon_sym_AMP_GT] = ACTIONS(4757),
    [anon_sym_AMP_GT_GT] = ACTIONS(4755),
    [anon_sym_LT_AMP] = ACTIONS(4755),
    [anon_sym_GT_AMP] = ACTIONS(4755),
    [anon_sym_LT_LT] = ACTIONS(4757),
    [anon_sym_LT_LT_DASH] = ACTIONS(4755),
    [anon_sym_LT_LT_LT] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4757),
    [sym_raw_string] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_LT_LPAREN] = ACTIONS(4755),
    [anon_sym_GT_LPAREN] = ACTIONS(4755),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4757),
    [anon_sym_LF] = ACTIONS(4755),
    [anon_sym_AMP] = ACTIONS(4757),
  },
  [2753] = {
    [sym__simple_heredoc_body] = ACTIONS(2930),
    [sym__heredoc_body_beginning] = ACTIONS(2930),
    [sym_file_descriptor] = ACTIONS(2930),
    [sym__concat] = ACTIONS(2930),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym_esac] = ACTIONS(2930),
    [anon_sym_PIPE] = ACTIONS(2932),
    [anon_sym_SEMI_SEMI] = ACTIONS(2930),
    [anon_sym_PIPE_AMP] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2932),
    [anon_sym_GT_GT] = ACTIONS(2930),
    [anon_sym_AMP_GT] = ACTIONS(2932),
    [anon_sym_AMP_GT_GT] = ACTIONS(2930),
    [anon_sym_LT_AMP] = ACTIONS(2930),
    [anon_sym_GT_AMP] = ACTIONS(2930),
    [anon_sym_LT_LT] = ACTIONS(2932),
    [anon_sym_LT_LT_DASH] = ACTIONS(2930),
    [anon_sym_LT_LT_LT] = ACTIONS(2930),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2932),
  },
  [2754] = {
    [sym__simple_heredoc_body] = ACTIONS(2944),
    [sym__heredoc_body_beginning] = ACTIONS(2944),
    [sym_file_descriptor] = ACTIONS(2944),
    [sym__concat] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym_esac] = ACTIONS(2944),
    [anon_sym_PIPE] = ACTIONS(2946),
    [anon_sym_SEMI_SEMI] = ACTIONS(2944),
    [anon_sym_PIPE_AMP] = ACTIONS(2944),
    [anon_sym_AMP_AMP] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2946),
    [anon_sym_GT_GT] = ACTIONS(2944),
    [anon_sym_AMP_GT] = ACTIONS(2946),
    [anon_sym_AMP_GT_GT] = ACTIONS(2944),
    [anon_sym_LT_AMP] = ACTIONS(2944),
    [anon_sym_GT_AMP] = ACTIONS(2944),
    [anon_sym_LT_LT] = ACTIONS(2946),
    [anon_sym_LT_LT_DASH] = ACTIONS(2944),
    [anon_sym_LT_LT_LT] = ACTIONS(2944),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2946),
  },
  [2755] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6496),
    [sym_comment] = ACTIONS(57),
  },
  [2756] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6498),
    [sym_comment] = ACTIONS(57),
  },
  [2757] = {
    [anon_sym_RBRACE] = ACTIONS(6498),
    [sym_comment] = ACTIONS(57),
  },
  [2758] = {
    [sym_concatenation] = STATE(2820),
    [sym_string] = STATE(2819),
    [sym_simple_expansion] = STATE(2819),
    [sym_string_expansion] = STATE(2819),
    [sym_expansion] = STATE(2819),
    [sym_command_substitution] = STATE(2819),
    [sym_process_substitution] = STATE(2819),
    [anon_sym_RBRACE] = ACTIONS(6498),
    [sym__special_characters] = ACTIONS(6500),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(6502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6502),
  },
  [2759] = {
    [sym__simple_heredoc_body] = ACTIONS(2980),
    [sym__heredoc_body_beginning] = ACTIONS(2980),
    [sym_file_descriptor] = ACTIONS(2980),
    [sym__concat] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym_esac] = ACTIONS(2980),
    [anon_sym_PIPE] = ACTIONS(2982),
    [anon_sym_SEMI_SEMI] = ACTIONS(2980),
    [anon_sym_PIPE_AMP] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_PIPE_PIPE] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2982),
    [anon_sym_GT_GT] = ACTIONS(2980),
    [anon_sym_AMP_GT] = ACTIONS(2982),
    [anon_sym_AMP_GT_GT] = ACTIONS(2980),
    [anon_sym_LT_AMP] = ACTIONS(2980),
    [anon_sym_GT_AMP] = ACTIONS(2980),
    [anon_sym_LT_LT] = ACTIONS(2982),
    [anon_sym_LT_LT_DASH] = ACTIONS(2980),
    [anon_sym_LT_LT_LT] = ACTIONS(2980),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2982),
  },
  [2760] = {
    [sym_concatenation] = STATE(2823),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2823),
    [sym_regex] = ACTIONS(6504),
    [anon_sym_RBRACE] = ACTIONS(6506),
    [anon_sym_EQ] = ACTIONS(6508),
    [anon_sym_DASH] = ACTIONS(6508),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6508),
    [anon_sym_COLON_QMARK] = ACTIONS(6508),
    [anon_sym_COLON_DASH] = ACTIONS(6508),
    [anon_sym_PERCENT] = ACTIONS(6508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2761] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6506),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2762] = {
    [sym_concatenation] = STATE(2825),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2825),
    [sym_regex] = ACTIONS(6512),
    [anon_sym_RBRACE] = ACTIONS(6498),
    [anon_sym_EQ] = ACTIONS(6514),
    [anon_sym_DASH] = ACTIONS(6514),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6516),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6514),
    [anon_sym_COLON_QMARK] = ACTIONS(6514),
    [anon_sym_COLON_DASH] = ACTIONS(6514),
    [anon_sym_PERCENT] = ACTIONS(6514),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2763] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6498),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2764] = {
    [sym_concatenation] = STATE(2827),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2827),
    [anon_sym_RBRACE] = ACTIONS(6518),
    [anon_sym_EQ] = ACTIONS(6520),
    [anon_sym_DASH] = ACTIONS(6520),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6520),
    [anon_sym_COLON_QMARK] = ACTIONS(6520),
    [anon_sym_COLON_DASH] = ACTIONS(6520),
    [anon_sym_PERCENT] = ACTIONS(6520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2765] = {
    [sym__simple_heredoc_body] = ACTIONS(3036),
    [sym__heredoc_body_beginning] = ACTIONS(3036),
    [sym_file_descriptor] = ACTIONS(3036),
    [sym__concat] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym_esac] = ACTIONS(3036),
    [anon_sym_PIPE] = ACTIONS(3038),
    [anon_sym_SEMI_SEMI] = ACTIONS(3036),
    [anon_sym_PIPE_AMP] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_PIPE_PIPE] = ACTIONS(3036),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_GT] = ACTIONS(3038),
    [anon_sym_GT_GT] = ACTIONS(3036),
    [anon_sym_AMP_GT] = ACTIONS(3038),
    [anon_sym_AMP_GT_GT] = ACTIONS(3036),
    [anon_sym_LT_AMP] = ACTIONS(3036),
    [anon_sym_GT_AMP] = ACTIONS(3036),
    [anon_sym_LT_LT] = ACTIONS(3038),
    [anon_sym_LT_LT_DASH] = ACTIONS(3036),
    [anon_sym_LT_LT_LT] = ACTIONS(3036),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3038),
  },
  [2766] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6518),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2767] = {
    [sym_concatenation] = STATE(2825),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2825),
    [anon_sym_RBRACE] = ACTIONS(6498),
    [anon_sym_EQ] = ACTIONS(6514),
    [anon_sym_DASH] = ACTIONS(6514),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6516),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6514),
    [anon_sym_COLON_QMARK] = ACTIONS(6514),
    [anon_sym_COLON_DASH] = ACTIONS(6514),
    [anon_sym_PERCENT] = ACTIONS(6514),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2768] = {
    [sym__simple_heredoc_body] = ACTIONS(3091),
    [sym__heredoc_body_beginning] = ACTIONS(3091),
    [sym_file_descriptor] = ACTIONS(3091),
    [sym__concat] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_esac] = ACTIONS(3091),
    [anon_sym_PIPE] = ACTIONS(3093),
    [anon_sym_SEMI_SEMI] = ACTIONS(3091),
    [anon_sym_PIPE_AMP] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_GT] = ACTIONS(3093),
    [anon_sym_GT_GT] = ACTIONS(3091),
    [anon_sym_AMP_GT] = ACTIONS(3093),
    [anon_sym_AMP_GT_GT] = ACTIONS(3091),
    [anon_sym_LT_AMP] = ACTIONS(3091),
    [anon_sym_GT_AMP] = ACTIONS(3091),
    [anon_sym_LT_LT] = ACTIONS(3093),
    [anon_sym_LT_LT_DASH] = ACTIONS(3091),
    [anon_sym_LT_LT_LT] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3093),
  },
  [2769] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6524),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2770] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(6524),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2771] = {
    [anon_sym_SEMI] = ACTIONS(6526),
    [anon_sym_RPAREN] = ACTIONS(6524),
    [anon_sym_SEMI_SEMI] = ACTIONS(6528),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6528),
    [anon_sym_AMP] = ACTIONS(6528),
  },
  [2772] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(6524),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2773] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(6524),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2774] = {
    [anon_sym_SEMI] = ACTIONS(6530),
    [anon_sym_SEMI_SEMI] = ACTIONS(6532),
    [anon_sym_BQUOTE] = ACTIONS(6524),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6532),
    [anon_sym_AMP] = ACTIONS(6532),
  },
  [2775] = {
    [sym__simple_heredoc_body] = ACTIONS(3121),
    [sym__heredoc_body_beginning] = ACTIONS(3121),
    [sym_file_descriptor] = ACTIONS(3121),
    [sym__concat] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3123),
    [anon_sym_esac] = ACTIONS(3121),
    [anon_sym_PIPE] = ACTIONS(3123),
    [anon_sym_SEMI_SEMI] = ACTIONS(3121),
    [anon_sym_PIPE_AMP] = ACTIONS(3121),
    [anon_sym_AMP_AMP] = ACTIONS(3121),
    [anon_sym_PIPE_PIPE] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_GT] = ACTIONS(3123),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_AMP_GT] = ACTIONS(3123),
    [anon_sym_AMP_GT_GT] = ACTIONS(3121),
    [anon_sym_LT_AMP] = ACTIONS(3121),
    [anon_sym_GT_AMP] = ACTIONS(3121),
    [anon_sym_LT_LT] = ACTIONS(3123),
    [anon_sym_LT_LT_DASH] = ACTIONS(3121),
    [anon_sym_LT_LT_LT] = ACTIONS(3121),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
  },
  [2776] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6534),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2777] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(6534),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(927),
    [anon_sym_GT_LPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(931),
  },
  [2778] = {
    [anon_sym_SEMI] = ACTIONS(6536),
    [anon_sym_RPAREN] = ACTIONS(6534),
    [anon_sym_SEMI_SEMI] = ACTIONS(6538),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6538),
    [anon_sym_AMP] = ACTIONS(6538),
  },
  [2779] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_SEMI_SEMI] = ACTIONS(927),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(6146),
    [anon_sym_DQUOTE] = ACTIONS(6148),
    [anon_sym_DOLLAR] = ACTIONS(6146),
    [sym_raw_string] = ACTIONS(6148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6148),
    [anon_sym_BQUOTE] = ACTIONS(6148),
    [anon_sym_LT_LPAREN] = ACTIONS(6148),
    [anon_sym_GT_LPAREN] = ACTIONS(6148),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6146),
  },
  [2780] = {
    [sym_file_descriptor] = ACTIONS(927),
    [sym_variable_name] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_SEMI_SEMI] = ACTIONS(927),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_typeset] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(931),
    [anon_sym_readonly] = ACTIONS(931),
    [anon_sym_local] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_unsetenv] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_AMP_GT] = ACTIONS(931),
    [anon_sym_AMP_GT_GT] = ACTIONS(927),
    [anon_sym_LT_AMP] = ACTIONS(927),
    [anon_sym_GT_AMP] = ACTIONS(927),
    [sym__special_characters] = ACTIONS(6152),
    [anon_sym_DQUOTE] = ACTIONS(6154),
    [anon_sym_DOLLAR] = ACTIONS(6152),
    [sym_raw_string] = ACTIONS(6154),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6154),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6154),
    [anon_sym_BQUOTE] = ACTIONS(6154),
    [anon_sym_LT_LPAREN] = ACTIONS(6154),
    [anon_sym_GT_LPAREN] = ACTIONS(6154),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6152),
  },
  [2781] = {
    [sym__simple_heredoc_body] = ACTIONS(3921),
    [sym__heredoc_body_beginning] = ACTIONS(3921),
    [sym_file_descriptor] = ACTIONS(3921),
    [sym__concat] = ACTIONS(3921),
    [sym_variable_name] = ACTIONS(3921),
    [anon_sym_SEMI] = ACTIONS(3923),
    [anon_sym_esac] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_SEMI_SEMI] = ACTIONS(3921),
    [anon_sym_PIPE_AMP] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_GT_GT] = ACTIONS(3921),
    [anon_sym_AMP_GT] = ACTIONS(3923),
    [anon_sym_AMP_GT_GT] = ACTIONS(3921),
    [anon_sym_LT_AMP] = ACTIONS(3921),
    [anon_sym_GT_AMP] = ACTIONS(3921),
    [anon_sym_LT_LT] = ACTIONS(3923),
    [anon_sym_LT_LT_DASH] = ACTIONS(3921),
    [anon_sym_LT_LT_LT] = ACTIONS(3921),
    [sym__special_characters] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_DOLLAR] = ACTIONS(3923),
    [sym_raw_string] = ACTIONS(3921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3921),
    [anon_sym_BQUOTE] = ACTIONS(3921),
    [anon_sym_LT_LPAREN] = ACTIONS(3921),
    [anon_sym_GT_LPAREN] = ACTIONS(3921),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3923),
    [anon_sym_LF] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3923),
  },
  [2782] = {
    [sym__simple_heredoc_body] = ACTIONS(3929),
    [sym__heredoc_body_beginning] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [sym__concat] = ACTIONS(3929),
    [sym_variable_name] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3931),
    [anon_sym_esac] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3931),
    [anon_sym_SEMI_SEMI] = ACTIONS(3929),
    [anon_sym_PIPE_AMP] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_AMP_GT] = ACTIONS(3931),
    [anon_sym_AMP_GT_GT] = ACTIONS(3929),
    [anon_sym_LT_AMP] = ACTIONS(3929),
    [anon_sym_GT_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_LT_LT_DASH] = ACTIONS(3929),
    [anon_sym_LT_LT_LT] = ACTIONS(3929),
    [sym__special_characters] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [sym_raw_string] = ACTIONS(3929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3929),
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [anon_sym_LT_LPAREN] = ACTIONS(3929),
    [anon_sym_GT_LPAREN] = ACTIONS(3929),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3931),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
  },
  [2783] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6540),
    [sym_comment] = ACTIONS(57),
  },
  [2784] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6542),
    [sym_comment] = ACTIONS(57),
  },
  [2785] = {
    [anon_sym_RBRACE] = ACTIONS(6542),
    [sym_comment] = ACTIONS(57),
  },
  [2786] = {
    [sym_concatenation] = STATE(2836),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2836),
    [anon_sym_RBRACE] = ACTIONS(6544),
    [anon_sym_EQ] = ACTIONS(6546),
    [anon_sym_DASH] = ACTIONS(6546),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_COLON_QMARK] = ACTIONS(6546),
    [anon_sym_COLON_DASH] = ACTIONS(6546),
    [anon_sym_PERCENT] = ACTIONS(6546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2787] = {
    [sym__simple_heredoc_body] = ACTIONS(3985),
    [sym__heredoc_body_beginning] = ACTIONS(3985),
    [sym_file_descriptor] = ACTIONS(3985),
    [sym__concat] = ACTIONS(3985),
    [sym_variable_name] = ACTIONS(3985),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_esac] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_AMP_GT] = ACTIONS(3987),
    [anon_sym_AMP_GT_GT] = ACTIONS(3985),
    [anon_sym_LT_AMP] = ACTIONS(3985),
    [anon_sym_GT_AMP] = ACTIONS(3985),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_LT_LT_DASH] = ACTIONS(3985),
    [anon_sym_LT_LT_LT] = ACTIONS(3985),
    [sym__special_characters] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [anon_sym_DOLLAR] = ACTIONS(3987),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3985),
    [anon_sym_BQUOTE] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(3985),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3987),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [2788] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6544),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2789] = {
    [sym_concatenation] = STATE(2837),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2837),
    [anon_sym_RBRACE] = ACTIONS(6542),
    [anon_sym_EQ] = ACTIONS(6550),
    [anon_sym_DASH] = ACTIONS(6550),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6552),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_COLON_QMARK] = ACTIONS(6550),
    [anon_sym_COLON_DASH] = ACTIONS(6550),
    [anon_sym_PERCENT] = ACTIONS(6550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2790] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6542),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2791] = {
    [sym__simple_heredoc_body] = ACTIONS(4030),
    [sym__heredoc_body_beginning] = ACTIONS(4030),
    [sym_file_descriptor] = ACTIONS(4030),
    [sym__concat] = ACTIONS(4030),
    [sym_variable_name] = ACTIONS(4030),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_esac] = ACTIONS(4032),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_SEMI_SEMI] = ACTIONS(4030),
    [anon_sym_PIPE_AMP] = ACTIONS(4030),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_LT] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(4032),
    [anon_sym_GT_GT] = ACTIONS(4030),
    [anon_sym_AMP_GT] = ACTIONS(4032),
    [anon_sym_AMP_GT_GT] = ACTIONS(4030),
    [anon_sym_LT_AMP] = ACTIONS(4030),
    [anon_sym_GT_AMP] = ACTIONS(4030),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_LT_LT_DASH] = ACTIONS(4030),
    [anon_sym_LT_LT_LT] = ACTIONS(4030),
    [sym__special_characters] = ACTIONS(4030),
    [anon_sym_DQUOTE] = ACTIONS(4030),
    [anon_sym_DOLLAR] = ACTIONS(4032),
    [sym_raw_string] = ACTIONS(4030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4030),
    [anon_sym_BQUOTE] = ACTIONS(4030),
    [anon_sym_LT_LPAREN] = ACTIONS(4030),
    [anon_sym_GT_LPAREN] = ACTIONS(4030),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4032),
    [anon_sym_LF] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4032),
  },
  [2792] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6554),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2793] = {
    [sym__simple_heredoc_body] = ACTIONS(4064),
    [sym__heredoc_body_beginning] = ACTIONS(4064),
    [sym_file_descriptor] = ACTIONS(4064),
    [sym__concat] = ACTIONS(4064),
    [sym_variable_name] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_esac] = ACTIONS(4066),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_SEMI_SEMI] = ACTIONS(4064),
    [anon_sym_PIPE_AMP] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_GT_GT] = ACTIONS(4064),
    [anon_sym_AMP_GT] = ACTIONS(4066),
    [anon_sym_AMP_GT_GT] = ACTIONS(4064),
    [anon_sym_LT_AMP] = ACTIONS(4064),
    [anon_sym_GT_AMP] = ACTIONS(4064),
    [anon_sym_LT_LT] = ACTIONS(4066),
    [anon_sym_LT_LT_DASH] = ACTIONS(4064),
    [anon_sym_LT_LT_LT] = ACTIONS(4064),
    [sym__special_characters] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_DOLLAR] = ACTIONS(4066),
    [sym_raw_string] = ACTIONS(4064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4064),
    [anon_sym_BQUOTE] = ACTIONS(4064),
    [anon_sym_LT_LPAREN] = ACTIONS(4064),
    [anon_sym_GT_LPAREN] = ACTIONS(4064),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4066),
    [anon_sym_LF] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4066),
  },
  [2794] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6556),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2795] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(6556),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2796] = {
    [sym__simple_heredoc_body] = ACTIONS(4070),
    [sym__heredoc_body_beginning] = ACTIONS(4070),
    [sym_file_descriptor] = ACTIONS(4070),
    [sym__concat] = ACTIONS(4070),
    [sym_variable_name] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_esac] = ACTIONS(4072),
    [anon_sym_PIPE] = ACTIONS(4072),
    [anon_sym_SEMI_SEMI] = ACTIONS(4070),
    [anon_sym_PIPE_AMP] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4070),
    [anon_sym_PIPE_PIPE] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_GT] = ACTIONS(4072),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_AMP_GT] = ACTIONS(4072),
    [anon_sym_AMP_GT_GT] = ACTIONS(4070),
    [anon_sym_LT_AMP] = ACTIONS(4070),
    [anon_sym_GT_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4072),
    [anon_sym_LT_LT_DASH] = ACTIONS(4070),
    [anon_sym_LT_LT_LT] = ACTIONS(4070),
    [sym__special_characters] = ACTIONS(4070),
    [anon_sym_DQUOTE] = ACTIONS(4070),
    [anon_sym_DOLLAR] = ACTIONS(4072),
    [sym_raw_string] = ACTIONS(4070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4070),
    [anon_sym_BQUOTE] = ACTIONS(4070),
    [anon_sym_LT_LPAREN] = ACTIONS(4070),
    [anon_sym_GT_LPAREN] = ACTIONS(4070),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4072),
    [anon_sym_LF] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4072),
  },
  [2797] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6558),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2798] = {
    [sym__simple_heredoc_body] = ACTIONS(4687),
    [sym__heredoc_body_beginning] = ACTIONS(4687),
    [sym_file_descriptor] = ACTIONS(4687),
    [sym__concat] = ACTIONS(4687),
    [sym_variable_name] = ACTIONS(4687),
    [anon_sym_SEMI] = ACTIONS(4689),
    [anon_sym_esac] = ACTIONS(4689),
    [anon_sym_PIPE] = ACTIONS(4689),
    [anon_sym_SEMI_SEMI] = ACTIONS(4687),
    [anon_sym_PIPE_AMP] = ACTIONS(4687),
    [anon_sym_AMP_AMP] = ACTIONS(4687),
    [anon_sym_PIPE_PIPE] = ACTIONS(4687),
    [anon_sym_LT] = ACTIONS(4689),
    [anon_sym_GT] = ACTIONS(4689),
    [anon_sym_GT_GT] = ACTIONS(4687),
    [anon_sym_AMP_GT] = ACTIONS(4689),
    [anon_sym_AMP_GT_GT] = ACTIONS(4687),
    [anon_sym_LT_AMP] = ACTIONS(4687),
    [anon_sym_GT_AMP] = ACTIONS(4687),
    [anon_sym_LT_LT] = ACTIONS(4689),
    [anon_sym_LT_LT_DASH] = ACTIONS(4687),
    [anon_sym_LT_LT_LT] = ACTIONS(4687),
    [sym__special_characters] = ACTIONS(4687),
    [anon_sym_DQUOTE] = ACTIONS(4687),
    [anon_sym_DOLLAR] = ACTIONS(4689),
    [sym_raw_string] = ACTIONS(4687),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4687),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4687),
    [anon_sym_BQUOTE] = ACTIONS(4687),
    [anon_sym_LT_LPAREN] = ACTIONS(4687),
    [anon_sym_GT_LPAREN] = ACTIONS(4687),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4689),
    [sym_word] = ACTIONS(4689),
    [anon_sym_LF] = ACTIONS(4687),
    [anon_sym_AMP] = ACTIONS(4689),
  },
  [2799] = {
    [sym__simple_heredoc_body] = ACTIONS(4691),
    [sym__heredoc_body_beginning] = ACTIONS(4691),
    [sym_file_descriptor] = ACTIONS(4691),
    [sym__concat] = ACTIONS(4691),
    [sym_variable_name] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4693),
    [anon_sym_esac] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_SEMI_SEMI] = ACTIONS(4691),
    [anon_sym_PIPE_AMP] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4691),
    [anon_sym_AMP_GT] = ACTIONS(4693),
    [anon_sym_AMP_GT_GT] = ACTIONS(4691),
    [anon_sym_LT_AMP] = ACTIONS(4691),
    [anon_sym_GT_AMP] = ACTIONS(4691),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_LT_LT_DASH] = ACTIONS(4691),
    [anon_sym_LT_LT_LT] = ACTIONS(4691),
    [sym__special_characters] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4693),
    [sym_raw_string] = ACTIONS(4691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4691),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_LT_LPAREN] = ACTIONS(4691),
    [anon_sym_GT_LPAREN] = ACTIONS(4691),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4693),
    [sym_word] = ACTIONS(4693),
    [anon_sym_LF] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4693),
  },
  [2800] = {
    [sym__simple_heredoc_body] = ACTIONS(4695),
    [sym__heredoc_body_beginning] = ACTIONS(4695),
    [sym_file_descriptor] = ACTIONS(4695),
    [sym__concat] = ACTIONS(4695),
    [sym_variable_name] = ACTIONS(4695),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_esac] = ACTIONS(4697),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_SEMI_SEMI] = ACTIONS(4695),
    [anon_sym_PIPE_AMP] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_GT_GT] = ACTIONS(4695),
    [anon_sym_AMP_GT] = ACTIONS(4697),
    [anon_sym_AMP_GT_GT] = ACTIONS(4695),
    [anon_sym_LT_AMP] = ACTIONS(4695),
    [anon_sym_GT_AMP] = ACTIONS(4695),
    [anon_sym_LT_LT] = ACTIONS(4697),
    [anon_sym_LT_LT_DASH] = ACTIONS(4695),
    [anon_sym_LT_LT_LT] = ACTIONS(4695),
    [sym__special_characters] = ACTIONS(4695),
    [anon_sym_DQUOTE] = ACTIONS(4695),
    [anon_sym_DOLLAR] = ACTIONS(4697),
    [sym_raw_string] = ACTIONS(4695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4695),
    [anon_sym_BQUOTE] = ACTIONS(4695),
    [anon_sym_LT_LPAREN] = ACTIONS(4695),
    [anon_sym_GT_LPAREN] = ACTIONS(4695),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4697),
    [sym_word] = ACTIONS(4697),
    [anon_sym_LF] = ACTIONS(4695),
    [anon_sym_AMP] = ACTIONS(4697),
  },
  [2801] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6560),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2802] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6562),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2803] = {
    [sym__simple_heredoc_body] = ACTIONS(4731),
    [sym__heredoc_body_beginning] = ACTIONS(4731),
    [sym_file_descriptor] = ACTIONS(4731),
    [sym__concat] = ACTIONS(4731),
    [sym_variable_name] = ACTIONS(4731),
    [anon_sym_SEMI] = ACTIONS(4733),
    [anon_sym_esac] = ACTIONS(4733),
    [anon_sym_PIPE] = ACTIONS(4733),
    [anon_sym_SEMI_SEMI] = ACTIONS(4731),
    [anon_sym_PIPE_AMP] = ACTIONS(4731),
    [anon_sym_AMP_AMP] = ACTIONS(4731),
    [anon_sym_PIPE_PIPE] = ACTIONS(4731),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_GT] = ACTIONS(4731),
    [anon_sym_AMP_GT] = ACTIONS(4733),
    [anon_sym_AMP_GT_GT] = ACTIONS(4731),
    [anon_sym_LT_AMP] = ACTIONS(4731),
    [anon_sym_GT_AMP] = ACTIONS(4731),
    [anon_sym_LT_LT] = ACTIONS(4733),
    [anon_sym_LT_LT_DASH] = ACTIONS(4731),
    [anon_sym_LT_LT_LT] = ACTIONS(4731),
    [sym__special_characters] = ACTIONS(4731),
    [anon_sym_DQUOTE] = ACTIONS(4731),
    [anon_sym_DOLLAR] = ACTIONS(4733),
    [sym_raw_string] = ACTIONS(4731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4731),
    [anon_sym_BQUOTE] = ACTIONS(4731),
    [anon_sym_LT_LPAREN] = ACTIONS(4731),
    [anon_sym_GT_LPAREN] = ACTIONS(4731),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4733),
    [sym_word] = ACTIONS(4733),
    [anon_sym_LF] = ACTIONS(4731),
    [anon_sym_AMP] = ACTIONS(4733),
  },
  [2804] = {
    [sym__simple_heredoc_body] = ACTIONS(4751),
    [sym__heredoc_body_beginning] = ACTIONS(4751),
    [sym_file_descriptor] = ACTIONS(4751),
    [sym__concat] = ACTIONS(4751),
    [sym_variable_name] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4753),
    [anon_sym_esac] = ACTIONS(4753),
    [anon_sym_PIPE] = ACTIONS(4753),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_PIPE_AMP] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [anon_sym_LT] = ACTIONS(4753),
    [anon_sym_GT] = ACTIONS(4753),
    [anon_sym_GT_GT] = ACTIONS(4751),
    [anon_sym_AMP_GT] = ACTIONS(4753),
    [anon_sym_AMP_GT_GT] = ACTIONS(4751),
    [anon_sym_LT_AMP] = ACTIONS(4751),
    [anon_sym_GT_AMP] = ACTIONS(4751),
    [anon_sym_LT_LT] = ACTIONS(4753),
    [anon_sym_LT_LT_DASH] = ACTIONS(4751),
    [anon_sym_LT_LT_LT] = ACTIONS(4751),
    [sym__special_characters] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4753),
    [sym_raw_string] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_LT_LPAREN] = ACTIONS(4751),
    [anon_sym_GT_LPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4753),
    [sym_word] = ACTIONS(4753),
    [anon_sym_LF] = ACTIONS(4751),
    [anon_sym_AMP] = ACTIONS(4753),
  },
  [2805] = {
    [sym__simple_heredoc_body] = ACTIONS(4755),
    [sym__heredoc_body_beginning] = ACTIONS(4755),
    [sym_file_descriptor] = ACTIONS(4755),
    [sym__concat] = ACTIONS(4755),
    [sym_variable_name] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4757),
    [anon_sym_esac] = ACTIONS(4757),
    [anon_sym_PIPE] = ACTIONS(4757),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [anon_sym_PIPE_AMP] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(4757),
    [anon_sym_GT] = ACTIONS(4757),
    [anon_sym_GT_GT] = ACTIONS(4755),
    [anon_sym_AMP_GT] = ACTIONS(4757),
    [anon_sym_AMP_GT_GT] = ACTIONS(4755),
    [anon_sym_LT_AMP] = ACTIONS(4755),
    [anon_sym_GT_AMP] = ACTIONS(4755),
    [anon_sym_LT_LT] = ACTIONS(4757),
    [anon_sym_LT_LT_DASH] = ACTIONS(4755),
    [anon_sym_LT_LT_LT] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4757),
    [sym_raw_string] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_LT_LPAREN] = ACTIONS(4755),
    [anon_sym_GT_LPAREN] = ACTIONS(4755),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4757),
    [sym_word] = ACTIONS(4757),
    [anon_sym_LF] = ACTIONS(4755),
    [anon_sym_AMP] = ACTIONS(4757),
  },
  [2806] = {
    [sym__simple_heredoc_body] = ACTIONS(4687),
    [sym__heredoc_body_beginning] = ACTIONS(4687),
    [sym_file_descriptor] = ACTIONS(4687),
    [sym__concat] = ACTIONS(4687),
    [anon_sym_SEMI] = ACTIONS(4689),
    [anon_sym_esac] = ACTIONS(4689),
    [anon_sym_PIPE] = ACTIONS(4689),
    [anon_sym_SEMI_SEMI] = ACTIONS(4687),
    [anon_sym_PIPE_AMP] = ACTIONS(4687),
    [anon_sym_AMP_AMP] = ACTIONS(4687),
    [anon_sym_PIPE_PIPE] = ACTIONS(4687),
    [anon_sym_LT] = ACTIONS(4689),
    [anon_sym_GT] = ACTIONS(4689),
    [anon_sym_GT_GT] = ACTIONS(4687),
    [anon_sym_AMP_GT] = ACTIONS(4689),
    [anon_sym_AMP_GT_GT] = ACTIONS(4687),
    [anon_sym_LT_AMP] = ACTIONS(4687),
    [anon_sym_GT_AMP] = ACTIONS(4687),
    [anon_sym_LT_LT] = ACTIONS(4689),
    [anon_sym_LT_LT_DASH] = ACTIONS(4687),
    [anon_sym_LT_LT_LT] = ACTIONS(4687),
    [sym__special_characters] = ACTIONS(4687),
    [anon_sym_DQUOTE] = ACTIONS(4687),
    [anon_sym_DOLLAR] = ACTIONS(4689),
    [sym_raw_string] = ACTIONS(4687),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4687),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4687),
    [anon_sym_BQUOTE] = ACTIONS(4687),
    [anon_sym_LT_LPAREN] = ACTIONS(4687),
    [anon_sym_GT_LPAREN] = ACTIONS(4687),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4689),
    [sym_word] = ACTIONS(4689),
    [anon_sym_LF] = ACTIONS(4687),
    [anon_sym_AMP] = ACTIONS(4689),
  },
  [2807] = {
    [sym__simple_heredoc_body] = ACTIONS(4691),
    [sym__heredoc_body_beginning] = ACTIONS(4691),
    [sym_file_descriptor] = ACTIONS(4691),
    [sym__concat] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4693),
    [anon_sym_esac] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_SEMI_SEMI] = ACTIONS(4691),
    [anon_sym_PIPE_AMP] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4691),
    [anon_sym_AMP_GT] = ACTIONS(4693),
    [anon_sym_AMP_GT_GT] = ACTIONS(4691),
    [anon_sym_LT_AMP] = ACTIONS(4691),
    [anon_sym_GT_AMP] = ACTIONS(4691),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_LT_LT_DASH] = ACTIONS(4691),
    [anon_sym_LT_LT_LT] = ACTIONS(4691),
    [sym__special_characters] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4693),
    [sym_raw_string] = ACTIONS(4691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4691),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_LT_LPAREN] = ACTIONS(4691),
    [anon_sym_GT_LPAREN] = ACTIONS(4691),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4693),
    [sym_word] = ACTIONS(4693),
    [anon_sym_LF] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4693),
  },
  [2808] = {
    [sym__simple_heredoc_body] = ACTIONS(4695),
    [sym__heredoc_body_beginning] = ACTIONS(4695),
    [sym_file_descriptor] = ACTIONS(4695),
    [sym__concat] = ACTIONS(4695),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_esac] = ACTIONS(4697),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_SEMI_SEMI] = ACTIONS(4695),
    [anon_sym_PIPE_AMP] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_GT_GT] = ACTIONS(4695),
    [anon_sym_AMP_GT] = ACTIONS(4697),
    [anon_sym_AMP_GT_GT] = ACTIONS(4695),
    [anon_sym_LT_AMP] = ACTIONS(4695),
    [anon_sym_GT_AMP] = ACTIONS(4695),
    [anon_sym_LT_LT] = ACTIONS(4697),
    [anon_sym_LT_LT_DASH] = ACTIONS(4695),
    [anon_sym_LT_LT_LT] = ACTIONS(4695),
    [sym__special_characters] = ACTIONS(4695),
    [anon_sym_DQUOTE] = ACTIONS(4695),
    [anon_sym_DOLLAR] = ACTIONS(4697),
    [sym_raw_string] = ACTIONS(4695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4695),
    [anon_sym_BQUOTE] = ACTIONS(4695),
    [anon_sym_LT_LPAREN] = ACTIONS(4695),
    [anon_sym_GT_LPAREN] = ACTIONS(4695),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4697),
    [sym_word] = ACTIONS(4697),
    [anon_sym_LF] = ACTIONS(4695),
    [anon_sym_AMP] = ACTIONS(4697),
  },
  [2809] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6564),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2810] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6566),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2811] = {
    [sym__simple_heredoc_body] = ACTIONS(4731),
    [sym__heredoc_body_beginning] = ACTIONS(4731),
    [sym_file_descriptor] = ACTIONS(4731),
    [sym__concat] = ACTIONS(4731),
    [anon_sym_SEMI] = ACTIONS(4733),
    [anon_sym_esac] = ACTIONS(4733),
    [anon_sym_PIPE] = ACTIONS(4733),
    [anon_sym_SEMI_SEMI] = ACTIONS(4731),
    [anon_sym_PIPE_AMP] = ACTIONS(4731),
    [anon_sym_AMP_AMP] = ACTIONS(4731),
    [anon_sym_PIPE_PIPE] = ACTIONS(4731),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_GT] = ACTIONS(4731),
    [anon_sym_AMP_GT] = ACTIONS(4733),
    [anon_sym_AMP_GT_GT] = ACTIONS(4731),
    [anon_sym_LT_AMP] = ACTIONS(4731),
    [anon_sym_GT_AMP] = ACTIONS(4731),
    [anon_sym_LT_LT] = ACTIONS(4733),
    [anon_sym_LT_LT_DASH] = ACTIONS(4731),
    [anon_sym_LT_LT_LT] = ACTIONS(4731),
    [sym__special_characters] = ACTIONS(4731),
    [anon_sym_DQUOTE] = ACTIONS(4731),
    [anon_sym_DOLLAR] = ACTIONS(4733),
    [sym_raw_string] = ACTIONS(4731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4731),
    [anon_sym_BQUOTE] = ACTIONS(4731),
    [anon_sym_LT_LPAREN] = ACTIONS(4731),
    [anon_sym_GT_LPAREN] = ACTIONS(4731),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4733),
    [sym_word] = ACTIONS(4733),
    [anon_sym_LF] = ACTIONS(4731),
    [anon_sym_AMP] = ACTIONS(4733),
  },
  [2812] = {
    [sym__simple_heredoc_body] = ACTIONS(4751),
    [sym__heredoc_body_beginning] = ACTIONS(4751),
    [sym_file_descriptor] = ACTIONS(4751),
    [sym__concat] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4753),
    [anon_sym_esac] = ACTIONS(4753),
    [anon_sym_PIPE] = ACTIONS(4753),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_PIPE_AMP] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [anon_sym_LT] = ACTIONS(4753),
    [anon_sym_GT] = ACTIONS(4753),
    [anon_sym_GT_GT] = ACTIONS(4751),
    [anon_sym_AMP_GT] = ACTIONS(4753),
    [anon_sym_AMP_GT_GT] = ACTIONS(4751),
    [anon_sym_LT_AMP] = ACTIONS(4751),
    [anon_sym_GT_AMP] = ACTIONS(4751),
    [anon_sym_LT_LT] = ACTIONS(4753),
    [anon_sym_LT_LT_DASH] = ACTIONS(4751),
    [anon_sym_LT_LT_LT] = ACTIONS(4751),
    [sym__special_characters] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4753),
    [sym_raw_string] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_LT_LPAREN] = ACTIONS(4751),
    [anon_sym_GT_LPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4753),
    [sym_word] = ACTIONS(4753),
    [anon_sym_LF] = ACTIONS(4751),
    [anon_sym_AMP] = ACTIONS(4753),
  },
  [2813] = {
    [sym__simple_heredoc_body] = ACTIONS(4755),
    [sym__heredoc_body_beginning] = ACTIONS(4755),
    [sym_file_descriptor] = ACTIONS(4755),
    [sym__concat] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4757),
    [anon_sym_esac] = ACTIONS(4757),
    [anon_sym_PIPE] = ACTIONS(4757),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [anon_sym_PIPE_AMP] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(4757),
    [anon_sym_GT] = ACTIONS(4757),
    [anon_sym_GT_GT] = ACTIONS(4755),
    [anon_sym_AMP_GT] = ACTIONS(4757),
    [anon_sym_AMP_GT_GT] = ACTIONS(4755),
    [anon_sym_LT_AMP] = ACTIONS(4755),
    [anon_sym_GT_AMP] = ACTIONS(4755),
    [anon_sym_LT_LT] = ACTIONS(4757),
    [anon_sym_LT_LT_DASH] = ACTIONS(4755),
    [anon_sym_LT_LT_LT] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4757),
    [sym_raw_string] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_LT_LPAREN] = ACTIONS(4755),
    [anon_sym_GT_LPAREN] = ACTIONS(4755),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4757),
    [sym_word] = ACTIONS(4757),
    [anon_sym_LF] = ACTIONS(4755),
    [anon_sym_AMP] = ACTIONS(4757),
  },
  [2814] = {
    [sym__simple_heredoc_body] = ACTIONS(5168),
    [sym__heredoc_body_beginning] = ACTIONS(5168),
    [sym_file_descriptor] = ACTIONS(5168),
    [sym__concat] = ACTIONS(5168),
    [anon_sym_SEMI] = ACTIONS(5170),
    [anon_sym_esac] = ACTIONS(5170),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_SEMI_SEMI] = ACTIONS(5168),
    [anon_sym_PIPE_AMP] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_EQ_TILDE] = ACTIONS(5170),
    [anon_sym_EQ_EQ] = ACTIONS(5170),
    [anon_sym_LT] = ACTIONS(5170),
    [anon_sym_GT] = ACTIONS(5170),
    [anon_sym_GT_GT] = ACTIONS(5168),
    [anon_sym_AMP_GT] = ACTIONS(5170),
    [anon_sym_AMP_GT_GT] = ACTIONS(5168),
    [anon_sym_LT_AMP] = ACTIONS(5168),
    [anon_sym_GT_AMP] = ACTIONS(5168),
    [anon_sym_LT_LT] = ACTIONS(5170),
    [anon_sym_LT_LT_DASH] = ACTIONS(5168),
    [anon_sym_LT_LT_LT] = ACTIONS(5168),
    [sym__special_characters] = ACTIONS(5168),
    [anon_sym_DQUOTE] = ACTIONS(5168),
    [anon_sym_DOLLAR] = ACTIONS(5170),
    [sym_raw_string] = ACTIONS(5168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5168),
    [anon_sym_BQUOTE] = ACTIONS(5168),
    [anon_sym_LT_LPAREN] = ACTIONS(5168),
    [anon_sym_GT_LPAREN] = ACTIONS(5168),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5170),
    [anon_sym_LF] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5170),
  },
  [2815] = {
    [sym__simple_heredoc_body] = ACTIONS(5172),
    [sym__heredoc_body_beginning] = ACTIONS(5172),
    [sym_file_descriptor] = ACTIONS(5172),
    [sym__concat] = ACTIONS(5172),
    [anon_sym_SEMI] = ACTIONS(5174),
    [anon_sym_esac] = ACTIONS(5174),
    [anon_sym_PIPE] = ACTIONS(5174),
    [anon_sym_SEMI_SEMI] = ACTIONS(5172),
    [anon_sym_PIPE_AMP] = ACTIONS(5172),
    [anon_sym_AMP_AMP] = ACTIONS(5172),
    [anon_sym_PIPE_PIPE] = ACTIONS(5172),
    [anon_sym_EQ_TILDE] = ACTIONS(5174),
    [anon_sym_EQ_EQ] = ACTIONS(5174),
    [anon_sym_LT] = ACTIONS(5174),
    [anon_sym_GT] = ACTIONS(5174),
    [anon_sym_GT_GT] = ACTIONS(5172),
    [anon_sym_AMP_GT] = ACTIONS(5174),
    [anon_sym_AMP_GT_GT] = ACTIONS(5172),
    [anon_sym_LT_AMP] = ACTIONS(5172),
    [anon_sym_GT_AMP] = ACTIONS(5172),
    [anon_sym_LT_LT] = ACTIONS(5174),
    [anon_sym_LT_LT_DASH] = ACTIONS(5172),
    [anon_sym_LT_LT_LT] = ACTIONS(5172),
    [sym__special_characters] = ACTIONS(5172),
    [anon_sym_DQUOTE] = ACTIONS(5172),
    [anon_sym_DOLLAR] = ACTIONS(5174),
    [sym_raw_string] = ACTIONS(5172),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5172),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5172),
    [anon_sym_BQUOTE] = ACTIONS(5172),
    [anon_sym_LT_LPAREN] = ACTIONS(5172),
    [anon_sym_GT_LPAREN] = ACTIONS(5172),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5174),
    [anon_sym_LF] = ACTIONS(5172),
    [anon_sym_AMP] = ACTIONS(5174),
  },
  [2816] = {
    [sym__simple_heredoc_body] = ACTIONS(3921),
    [sym__heredoc_body_beginning] = ACTIONS(3921),
    [sym_file_descriptor] = ACTIONS(3921),
    [sym__concat] = ACTIONS(3921),
    [anon_sym_SEMI] = ACTIONS(3923),
    [anon_sym_esac] = ACTIONS(3921),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_SEMI_SEMI] = ACTIONS(3921),
    [anon_sym_PIPE_AMP] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_GT_GT] = ACTIONS(3921),
    [anon_sym_AMP_GT] = ACTIONS(3923),
    [anon_sym_AMP_GT_GT] = ACTIONS(3921),
    [anon_sym_LT_AMP] = ACTIONS(3921),
    [anon_sym_GT_AMP] = ACTIONS(3921),
    [anon_sym_LT_LT] = ACTIONS(3923),
    [anon_sym_LT_LT_DASH] = ACTIONS(3921),
    [anon_sym_LT_LT_LT] = ACTIONS(3921),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3923),
  },
  [2817] = {
    [sym__simple_heredoc_body] = ACTIONS(3929),
    [sym__heredoc_body_beginning] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [sym__concat] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3931),
    [anon_sym_esac] = ACTIONS(3929),
    [anon_sym_PIPE] = ACTIONS(3931),
    [anon_sym_SEMI_SEMI] = ACTIONS(3929),
    [anon_sym_PIPE_AMP] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_AMP_GT] = ACTIONS(3931),
    [anon_sym_AMP_GT_GT] = ACTIONS(3929),
    [anon_sym_LT_AMP] = ACTIONS(3929),
    [anon_sym_GT_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_LT_LT_DASH] = ACTIONS(3929),
    [anon_sym_LT_LT_LT] = ACTIONS(3929),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
  },
  [2818] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6568),
    [sym_comment] = ACTIONS(57),
  },
  [2819] = {
    [aux_sym_concatenation_repeat1] = STATE(1352),
    [sym__concat] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(6570),
    [sym_comment] = ACTIONS(57),
  },
  [2820] = {
    [anon_sym_RBRACE] = ACTIONS(6570),
    [sym_comment] = ACTIONS(57),
  },
  [2821] = {
    [sym_concatenation] = STATE(2848),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2848),
    [anon_sym_RBRACE] = ACTIONS(6572),
    [anon_sym_EQ] = ACTIONS(6574),
    [anon_sym_DASH] = ACTIONS(6574),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6574),
    [anon_sym_COLON_QMARK] = ACTIONS(6574),
    [anon_sym_COLON_DASH] = ACTIONS(6574),
    [anon_sym_PERCENT] = ACTIONS(6574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2822] = {
    [sym__simple_heredoc_body] = ACTIONS(3985),
    [sym__heredoc_body_beginning] = ACTIONS(3985),
    [sym_file_descriptor] = ACTIONS(3985),
    [sym__concat] = ACTIONS(3985),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_esac] = ACTIONS(3985),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_SEMI_SEMI] = ACTIONS(3985),
    [anon_sym_PIPE_AMP] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_AMP_GT] = ACTIONS(3987),
    [anon_sym_AMP_GT_GT] = ACTIONS(3985),
    [anon_sym_LT_AMP] = ACTIONS(3985),
    [anon_sym_GT_AMP] = ACTIONS(3985),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_LT_LT_DASH] = ACTIONS(3985),
    [anon_sym_LT_LT_LT] = ACTIONS(3985),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3987),
  },
  [2823] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6572),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2824] = {
    [sym_concatenation] = STATE(2849),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(2849),
    [anon_sym_RBRACE] = ACTIONS(6570),
    [anon_sym_EQ] = ACTIONS(6578),
    [anon_sym_DASH] = ACTIONS(6578),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(6580),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(6578),
    [anon_sym_COLON_QMARK] = ACTIONS(6578),
    [anon_sym_COLON_DASH] = ACTIONS(6578),
    [anon_sym_PERCENT] = ACTIONS(6578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2825] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6570),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2826] = {
    [sym__simple_heredoc_body] = ACTIONS(4030),
    [sym__heredoc_body_beginning] = ACTIONS(4030),
    [sym_file_descriptor] = ACTIONS(4030),
    [sym__concat] = ACTIONS(4030),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_esac] = ACTIONS(4030),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_SEMI_SEMI] = ACTIONS(4030),
    [anon_sym_PIPE_AMP] = ACTIONS(4030),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_LT] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(4032),
    [anon_sym_GT_GT] = ACTIONS(4030),
    [anon_sym_AMP_GT] = ACTIONS(4032),
    [anon_sym_AMP_GT_GT] = ACTIONS(4030),
    [anon_sym_LT_AMP] = ACTIONS(4030),
    [anon_sym_GT_AMP] = ACTIONS(4030),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_LT_LT_DASH] = ACTIONS(4030),
    [anon_sym_LT_LT_LT] = ACTIONS(4030),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4032),
  },
  [2827] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6582),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2828] = {
    [sym__simple_heredoc_body] = ACTIONS(4064),
    [sym__heredoc_body_beginning] = ACTIONS(4064),
    [sym_file_descriptor] = ACTIONS(4064),
    [sym__concat] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_esac] = ACTIONS(4064),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_SEMI_SEMI] = ACTIONS(4064),
    [anon_sym_PIPE_AMP] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_GT_GT] = ACTIONS(4064),
    [anon_sym_AMP_GT] = ACTIONS(4066),
    [anon_sym_AMP_GT_GT] = ACTIONS(4064),
    [anon_sym_LT_AMP] = ACTIONS(4064),
    [anon_sym_GT_AMP] = ACTIONS(4064),
    [anon_sym_LT_LT] = ACTIONS(4066),
    [anon_sym_LT_LT_DASH] = ACTIONS(4064),
    [anon_sym_LT_LT_LT] = ACTIONS(4064),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4066),
  },
  [2829] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6584),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2830] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(6584),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2831] = {
    [sym__simple_heredoc_body] = ACTIONS(4070),
    [sym__heredoc_body_beginning] = ACTIONS(4070),
    [sym_file_descriptor] = ACTIONS(4070),
    [sym__concat] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_esac] = ACTIONS(4070),
    [anon_sym_PIPE] = ACTIONS(4072),
    [anon_sym_SEMI_SEMI] = ACTIONS(4070),
    [anon_sym_PIPE_AMP] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4070),
    [anon_sym_PIPE_PIPE] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_GT] = ACTIONS(4072),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_AMP_GT] = ACTIONS(4072),
    [anon_sym_AMP_GT_GT] = ACTIONS(4070),
    [anon_sym_LT_AMP] = ACTIONS(4070),
    [anon_sym_GT_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4072),
    [anon_sym_LT_LT_DASH] = ACTIONS(4070),
    [anon_sym_LT_LT_LT] = ACTIONS(4070),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4072),
  },
  [2832] = {
    [sym_file_descriptor] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(6586),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_typeset] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_local] = ACTIONS(1988),
    [anon_sym_unset] = ACTIONS(1988),
    [anon_sym_unsetenv] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1988),
  },
  [2833] = {
    [sym__simple_heredoc_body] = ACTIONS(4687),
    [sym__heredoc_body_beginning] = ACTIONS(4687),
    [sym_file_descriptor] = ACTIONS(4687),
    [sym__concat] = ACTIONS(4687),
    [sym_variable_name] = ACTIONS(4687),
    [anon_sym_SEMI] = ACTIONS(4689),
    [anon_sym_esac] = ACTIONS(4689),
    [anon_sym_PIPE] = ACTIONS(4689),
    [anon_sym_SEMI_SEMI] = ACTIONS(4687),
    [anon_sym_PIPE_AMP] = ACTIONS(4687),
    [anon_sym_AMP_AMP] = ACTIONS(4687),
    [anon_sym_PIPE_PIPE] = ACTIONS(4687),
    [anon_sym_LT] = ACTIONS(4689),
    [anon_sym_GT] = ACTIONS(4689),
    [anon_sym_GT_GT] = ACTIONS(4687),
    [anon_sym_AMP_GT] = ACTIONS(4689),
    [anon_sym_AMP_GT_GT] = ACTIONS(4687),
    [anon_sym_LT_AMP] = ACTIONS(4687),
    [anon_sym_GT_AMP] = ACTIONS(4687),
    [anon_sym_LT_LT] = ACTIONS(4689),
    [anon_sym_LT_LT_DASH] = ACTIONS(4687),
    [anon_sym_LT_LT_LT] = ACTIONS(4687),
    [sym__special_characters] = ACTIONS(4687),
    [anon_sym_DQUOTE] = ACTIONS(4687),
    [anon_sym_DOLLAR] = ACTIONS(4689),
    [sym_raw_string] = ACTIONS(4687),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4687),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4687),
    [anon_sym_BQUOTE] = ACTIONS(4687),
    [anon_sym_LT_LPAREN] = ACTIONS(4687),
    [anon_sym_GT_LPAREN] = ACTIONS(4687),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4689),
    [anon_sym_LF] = ACTIONS(4687),
    [anon_sym_AMP] = ACTIONS(4689),
  },
  [2834] = {
    [sym__simple_heredoc_body] = ACTIONS(4691),
    [sym__heredoc_body_beginning] = ACTIONS(4691),
    [sym_file_descriptor] = ACTIONS(4691),
    [sym__concat] = ACTIONS(4691),
    [sym_variable_name] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4693),
    [anon_sym_esac] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_SEMI_SEMI] = ACTIONS(4691),
    [anon_sym_PIPE_AMP] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4691),
    [anon_sym_AMP_GT] = ACTIONS(4693),
    [anon_sym_AMP_GT_GT] = ACTIONS(4691),
    [anon_sym_LT_AMP] = ACTIONS(4691),
    [anon_sym_GT_AMP] = ACTIONS(4691),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_LT_LT_DASH] = ACTIONS(4691),
    [anon_sym_LT_LT_LT] = ACTIONS(4691),
    [sym__special_characters] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4693),
    [sym_raw_string] = ACTIONS(4691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4691),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_LT_LPAREN] = ACTIONS(4691),
    [anon_sym_GT_LPAREN] = ACTIONS(4691),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4693),
    [anon_sym_LF] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4693),
  },
  [2835] = {
    [sym__simple_heredoc_body] = ACTIONS(4695),
    [sym__heredoc_body_beginning] = ACTIONS(4695),
    [sym_file_descriptor] = ACTIONS(4695),
    [sym__concat] = ACTIONS(4695),
    [sym_variable_name] = ACTIONS(4695),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_esac] = ACTIONS(4697),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_SEMI_SEMI] = ACTIONS(4695),
    [anon_sym_PIPE_AMP] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_GT_GT] = ACTIONS(4695),
    [anon_sym_AMP_GT] = ACTIONS(4697),
    [anon_sym_AMP_GT_GT] = ACTIONS(4695),
    [anon_sym_LT_AMP] = ACTIONS(4695),
    [anon_sym_GT_AMP] = ACTIONS(4695),
    [anon_sym_LT_LT] = ACTIONS(4697),
    [anon_sym_LT_LT_DASH] = ACTIONS(4695),
    [anon_sym_LT_LT_LT] = ACTIONS(4695),
    [sym__special_characters] = ACTIONS(4695),
    [anon_sym_DQUOTE] = ACTIONS(4695),
    [anon_sym_DOLLAR] = ACTIONS(4697),
    [sym_raw_string] = ACTIONS(4695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4695),
    [anon_sym_BQUOTE] = ACTIONS(4695),
    [anon_sym_LT_LPAREN] = ACTIONS(4695),
    [anon_sym_GT_LPAREN] = ACTIONS(4695),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4697),
    [anon_sym_LF] = ACTIONS(4695),
    [anon_sym_AMP] = ACTIONS(4697),
  },
  [2836] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6588),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2837] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6590),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2838] = {
    [sym__simple_heredoc_body] = ACTIONS(4731),
    [sym__heredoc_body_beginning] = ACTIONS(4731),
    [sym_file_descriptor] = ACTIONS(4731),
    [sym__concat] = ACTIONS(4731),
    [sym_variable_name] = ACTIONS(4731),
    [anon_sym_SEMI] = ACTIONS(4733),
    [anon_sym_esac] = ACTIONS(4733),
    [anon_sym_PIPE] = ACTIONS(4733),
    [anon_sym_SEMI_SEMI] = ACTIONS(4731),
    [anon_sym_PIPE_AMP] = ACTIONS(4731),
    [anon_sym_AMP_AMP] = ACTIONS(4731),
    [anon_sym_PIPE_PIPE] = ACTIONS(4731),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_GT] = ACTIONS(4731),
    [anon_sym_AMP_GT] = ACTIONS(4733),
    [anon_sym_AMP_GT_GT] = ACTIONS(4731),
    [anon_sym_LT_AMP] = ACTIONS(4731),
    [anon_sym_GT_AMP] = ACTIONS(4731),
    [anon_sym_LT_LT] = ACTIONS(4733),
    [anon_sym_LT_LT_DASH] = ACTIONS(4731),
    [anon_sym_LT_LT_LT] = ACTIONS(4731),
    [sym__special_characters] = ACTIONS(4731),
    [anon_sym_DQUOTE] = ACTIONS(4731),
    [anon_sym_DOLLAR] = ACTIONS(4733),
    [sym_raw_string] = ACTIONS(4731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4731),
    [anon_sym_BQUOTE] = ACTIONS(4731),
    [anon_sym_LT_LPAREN] = ACTIONS(4731),
    [anon_sym_GT_LPAREN] = ACTIONS(4731),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4733),
    [anon_sym_LF] = ACTIONS(4731),
    [anon_sym_AMP] = ACTIONS(4733),
  },
  [2839] = {
    [sym__simple_heredoc_body] = ACTIONS(4751),
    [sym__heredoc_body_beginning] = ACTIONS(4751),
    [sym_file_descriptor] = ACTIONS(4751),
    [sym__concat] = ACTIONS(4751),
    [sym_variable_name] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4753),
    [anon_sym_esac] = ACTIONS(4753),
    [anon_sym_PIPE] = ACTIONS(4753),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_PIPE_AMP] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [anon_sym_LT] = ACTIONS(4753),
    [anon_sym_GT] = ACTIONS(4753),
    [anon_sym_GT_GT] = ACTIONS(4751),
    [anon_sym_AMP_GT] = ACTIONS(4753),
    [anon_sym_AMP_GT_GT] = ACTIONS(4751),
    [anon_sym_LT_AMP] = ACTIONS(4751),
    [anon_sym_GT_AMP] = ACTIONS(4751),
    [anon_sym_LT_LT] = ACTIONS(4753),
    [anon_sym_LT_LT_DASH] = ACTIONS(4751),
    [anon_sym_LT_LT_LT] = ACTIONS(4751),
    [sym__special_characters] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4753),
    [sym_raw_string] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_LT_LPAREN] = ACTIONS(4751),
    [anon_sym_GT_LPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4753),
    [anon_sym_LF] = ACTIONS(4751),
    [anon_sym_AMP] = ACTIONS(4753),
  },
  [2840] = {
    [sym__simple_heredoc_body] = ACTIONS(4755),
    [sym__heredoc_body_beginning] = ACTIONS(4755),
    [sym_file_descriptor] = ACTIONS(4755),
    [sym__concat] = ACTIONS(4755),
    [sym_variable_name] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4757),
    [anon_sym_esac] = ACTIONS(4757),
    [anon_sym_PIPE] = ACTIONS(4757),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [anon_sym_PIPE_AMP] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(4757),
    [anon_sym_GT] = ACTIONS(4757),
    [anon_sym_GT_GT] = ACTIONS(4755),
    [anon_sym_AMP_GT] = ACTIONS(4757),
    [anon_sym_AMP_GT_GT] = ACTIONS(4755),
    [anon_sym_LT_AMP] = ACTIONS(4755),
    [anon_sym_GT_AMP] = ACTIONS(4755),
    [anon_sym_LT_LT] = ACTIONS(4757),
    [anon_sym_LT_LT_DASH] = ACTIONS(4755),
    [anon_sym_LT_LT_LT] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4757),
    [sym_raw_string] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_LT_LPAREN] = ACTIONS(4755),
    [anon_sym_GT_LPAREN] = ACTIONS(4755),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4757),
    [anon_sym_LF] = ACTIONS(4755),
    [anon_sym_AMP] = ACTIONS(4757),
  },
  [2841] = {
    [sym__simple_heredoc_body] = ACTIONS(5168),
    [sym__heredoc_body_beginning] = ACTIONS(5168),
    [sym_file_descriptor] = ACTIONS(5168),
    [sym__concat] = ACTIONS(5168),
    [sym_variable_name] = ACTIONS(5168),
    [anon_sym_SEMI] = ACTIONS(5170),
    [anon_sym_esac] = ACTIONS(5170),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_SEMI_SEMI] = ACTIONS(5168),
    [anon_sym_PIPE_AMP] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_LT] = ACTIONS(5170),
    [anon_sym_GT] = ACTIONS(5170),
    [anon_sym_GT_GT] = ACTIONS(5168),
    [anon_sym_AMP_GT] = ACTIONS(5170),
    [anon_sym_AMP_GT_GT] = ACTIONS(5168),
    [anon_sym_LT_AMP] = ACTIONS(5168),
    [anon_sym_GT_AMP] = ACTIONS(5168),
    [anon_sym_LT_LT] = ACTIONS(5170),
    [anon_sym_LT_LT_DASH] = ACTIONS(5168),
    [anon_sym_LT_LT_LT] = ACTIONS(5168),
    [sym__special_characters] = ACTIONS(5168),
    [anon_sym_DQUOTE] = ACTIONS(5168),
    [anon_sym_DOLLAR] = ACTIONS(5170),
    [sym_raw_string] = ACTIONS(5168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5168),
    [anon_sym_BQUOTE] = ACTIONS(5168),
    [anon_sym_LT_LPAREN] = ACTIONS(5168),
    [anon_sym_GT_LPAREN] = ACTIONS(5168),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5170),
    [sym_word] = ACTIONS(5170),
    [anon_sym_LF] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5170),
  },
  [2842] = {
    [sym__simple_heredoc_body] = ACTIONS(5172),
    [sym__heredoc_body_beginning] = ACTIONS(5172),
    [sym_file_descriptor] = ACTIONS(5172),
    [sym__concat] = ACTIONS(5172),
    [sym_variable_name] = ACTIONS(5172),
    [anon_sym_SEMI] = ACTIONS(5174),
    [anon_sym_esac] = ACTIONS(5174),
    [anon_sym_PIPE] = ACTIONS(5174),
    [anon_sym_SEMI_SEMI] = ACTIONS(5172),
    [anon_sym_PIPE_AMP] = ACTIONS(5172),
    [anon_sym_AMP_AMP] = ACTIONS(5172),
    [anon_sym_PIPE_PIPE] = ACTIONS(5172),
    [anon_sym_LT] = ACTIONS(5174),
    [anon_sym_GT] = ACTIONS(5174),
    [anon_sym_GT_GT] = ACTIONS(5172),
    [anon_sym_AMP_GT] = ACTIONS(5174),
    [anon_sym_AMP_GT_GT] = ACTIONS(5172),
    [anon_sym_LT_AMP] = ACTIONS(5172),
    [anon_sym_GT_AMP] = ACTIONS(5172),
    [anon_sym_LT_LT] = ACTIONS(5174),
    [anon_sym_LT_LT_DASH] = ACTIONS(5172),
    [anon_sym_LT_LT_LT] = ACTIONS(5172),
    [sym__special_characters] = ACTIONS(5172),
    [anon_sym_DQUOTE] = ACTIONS(5172),
    [anon_sym_DOLLAR] = ACTIONS(5174),
    [sym_raw_string] = ACTIONS(5172),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5172),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5172),
    [anon_sym_BQUOTE] = ACTIONS(5172),
    [anon_sym_LT_LPAREN] = ACTIONS(5172),
    [anon_sym_GT_LPAREN] = ACTIONS(5172),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5174),
    [sym_word] = ACTIONS(5174),
    [anon_sym_LF] = ACTIONS(5172),
    [anon_sym_AMP] = ACTIONS(5174),
  },
  [2843] = {
    [sym__simple_heredoc_body] = ACTIONS(5168),
    [sym__heredoc_body_beginning] = ACTIONS(5168),
    [sym_file_descriptor] = ACTIONS(5168),
    [sym__concat] = ACTIONS(5168),
    [anon_sym_SEMI] = ACTIONS(5170),
    [anon_sym_esac] = ACTIONS(5170),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_SEMI_SEMI] = ACTIONS(5168),
    [anon_sym_PIPE_AMP] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_LT] = ACTIONS(5170),
    [anon_sym_GT] = ACTIONS(5170),
    [anon_sym_GT_GT] = ACTIONS(5168),
    [anon_sym_AMP_GT] = ACTIONS(5170),
    [anon_sym_AMP_GT_GT] = ACTIONS(5168),
    [anon_sym_LT_AMP] = ACTIONS(5168),
    [anon_sym_GT_AMP] = ACTIONS(5168),
    [anon_sym_LT_LT] = ACTIONS(5170),
    [anon_sym_LT_LT_DASH] = ACTIONS(5168),
    [anon_sym_LT_LT_LT] = ACTIONS(5168),
    [sym__special_characters] = ACTIONS(5168),
    [anon_sym_DQUOTE] = ACTIONS(5168),
    [anon_sym_DOLLAR] = ACTIONS(5170),
    [sym_raw_string] = ACTIONS(5168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5168),
    [anon_sym_BQUOTE] = ACTIONS(5168),
    [anon_sym_LT_LPAREN] = ACTIONS(5168),
    [anon_sym_GT_LPAREN] = ACTIONS(5168),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5170),
    [sym_word] = ACTIONS(5170),
    [anon_sym_LF] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5170),
  },
  [2844] = {
    [sym__simple_heredoc_body] = ACTIONS(5172),
    [sym__heredoc_body_beginning] = ACTIONS(5172),
    [sym_file_descriptor] = ACTIONS(5172),
    [sym__concat] = ACTIONS(5172),
    [anon_sym_SEMI] = ACTIONS(5174),
    [anon_sym_esac] = ACTIONS(5174),
    [anon_sym_PIPE] = ACTIONS(5174),
    [anon_sym_SEMI_SEMI] = ACTIONS(5172),
    [anon_sym_PIPE_AMP] = ACTIONS(5172),
    [anon_sym_AMP_AMP] = ACTIONS(5172),
    [anon_sym_PIPE_PIPE] = ACTIONS(5172),
    [anon_sym_LT] = ACTIONS(5174),
    [anon_sym_GT] = ACTIONS(5174),
    [anon_sym_GT_GT] = ACTIONS(5172),
    [anon_sym_AMP_GT] = ACTIONS(5174),
    [anon_sym_AMP_GT_GT] = ACTIONS(5172),
    [anon_sym_LT_AMP] = ACTIONS(5172),
    [anon_sym_GT_AMP] = ACTIONS(5172),
    [anon_sym_LT_LT] = ACTIONS(5174),
    [anon_sym_LT_LT_DASH] = ACTIONS(5172),
    [anon_sym_LT_LT_LT] = ACTIONS(5172),
    [sym__special_characters] = ACTIONS(5172),
    [anon_sym_DQUOTE] = ACTIONS(5172),
    [anon_sym_DOLLAR] = ACTIONS(5174),
    [sym_raw_string] = ACTIONS(5172),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5172),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5172),
    [anon_sym_BQUOTE] = ACTIONS(5172),
    [anon_sym_LT_LPAREN] = ACTIONS(5172),
    [anon_sym_GT_LPAREN] = ACTIONS(5172),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5174),
    [sym_word] = ACTIONS(5174),
    [anon_sym_LF] = ACTIONS(5172),
    [anon_sym_AMP] = ACTIONS(5174),
  },
  [2845] = {
    [sym__simple_heredoc_body] = ACTIONS(4687),
    [sym__heredoc_body_beginning] = ACTIONS(4687),
    [sym_file_descriptor] = ACTIONS(4687),
    [sym__concat] = ACTIONS(4687),
    [anon_sym_SEMI] = ACTIONS(4689),
    [anon_sym_esac] = ACTIONS(4687),
    [anon_sym_PIPE] = ACTIONS(4689),
    [anon_sym_SEMI_SEMI] = ACTIONS(4687),
    [anon_sym_PIPE_AMP] = ACTIONS(4687),
    [anon_sym_AMP_AMP] = ACTIONS(4687),
    [anon_sym_PIPE_PIPE] = ACTIONS(4687),
    [anon_sym_LT] = ACTIONS(4689),
    [anon_sym_GT] = ACTIONS(4689),
    [anon_sym_GT_GT] = ACTIONS(4687),
    [anon_sym_AMP_GT] = ACTIONS(4689),
    [anon_sym_AMP_GT_GT] = ACTIONS(4687),
    [anon_sym_LT_AMP] = ACTIONS(4687),
    [anon_sym_GT_AMP] = ACTIONS(4687),
    [anon_sym_LT_LT] = ACTIONS(4689),
    [anon_sym_LT_LT_DASH] = ACTIONS(4687),
    [anon_sym_LT_LT_LT] = ACTIONS(4687),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4687),
    [anon_sym_AMP] = ACTIONS(4689),
  },
  [2846] = {
    [sym__simple_heredoc_body] = ACTIONS(4691),
    [sym__heredoc_body_beginning] = ACTIONS(4691),
    [sym_file_descriptor] = ACTIONS(4691),
    [sym__concat] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4693),
    [anon_sym_esac] = ACTIONS(4691),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_SEMI_SEMI] = ACTIONS(4691),
    [anon_sym_PIPE_AMP] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4691),
    [anon_sym_AMP_GT] = ACTIONS(4693),
    [anon_sym_AMP_GT_GT] = ACTIONS(4691),
    [anon_sym_LT_AMP] = ACTIONS(4691),
    [anon_sym_GT_AMP] = ACTIONS(4691),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_LT_LT_DASH] = ACTIONS(4691),
    [anon_sym_LT_LT_LT] = ACTIONS(4691),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4693),
  },
  [2847] = {
    [sym__simple_heredoc_body] = ACTIONS(4695),
    [sym__heredoc_body_beginning] = ACTIONS(4695),
    [sym_file_descriptor] = ACTIONS(4695),
    [sym__concat] = ACTIONS(4695),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_esac] = ACTIONS(4695),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_SEMI_SEMI] = ACTIONS(4695),
    [anon_sym_PIPE_AMP] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_GT_GT] = ACTIONS(4695),
    [anon_sym_AMP_GT] = ACTIONS(4697),
    [anon_sym_AMP_GT_GT] = ACTIONS(4695),
    [anon_sym_LT_AMP] = ACTIONS(4695),
    [anon_sym_GT_AMP] = ACTIONS(4695),
    [anon_sym_LT_LT] = ACTIONS(4697),
    [anon_sym_LT_LT_DASH] = ACTIONS(4695),
    [anon_sym_LT_LT_LT] = ACTIONS(4695),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4695),
    [anon_sym_AMP] = ACTIONS(4697),
  },
  [2848] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6592),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2849] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_string_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_expansion_repeat1] = STATE(940),
    [anon_sym_RBRACE] = ACTIONS(6594),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(865),
  },
  [2850] = {
    [sym__simple_heredoc_body] = ACTIONS(4731),
    [sym__heredoc_body_beginning] = ACTIONS(4731),
    [sym_file_descriptor] = ACTIONS(4731),
    [sym__concat] = ACTIONS(4731),
    [anon_sym_SEMI] = ACTIONS(4733),
    [anon_sym_esac] = ACTIONS(4731),
    [anon_sym_PIPE] = ACTIONS(4733),
    [anon_sym_SEMI_SEMI] = ACTIONS(4731),
    [anon_sym_PIPE_AMP] = ACTIONS(4731),
    [anon_sym_AMP_AMP] = ACTIONS(4731),
    [anon_sym_PIPE_PIPE] = ACTIONS(4731),
    [anon_sym_LT] = ACTIONS(4733),
    [anon_sym_GT] = ACTIONS(4733),
    [anon_sym_GT_GT] = ACTIONS(4731),
    [anon_sym_AMP_GT] = ACTIONS(4733),
    [anon_sym_AMP_GT_GT] = ACTIONS(4731),
    [anon_sym_LT_AMP] = ACTIONS(4731),
    [anon_sym_GT_AMP] = ACTIONS(4731),
    [anon_sym_LT_LT] = ACTIONS(4733),
    [anon_sym_LT_LT_DASH] = ACTIONS(4731),
    [anon_sym_LT_LT_LT] = ACTIONS(4731),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4731),
    [anon_sym_AMP] = ACTIONS(4733),
  },
  [2851] = {
    [sym__simple_heredoc_body] = ACTIONS(4751),
    [sym__heredoc_body_beginning] = ACTIONS(4751),
    [sym_file_descriptor] = ACTIONS(4751),
    [sym__concat] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4753),
    [anon_sym_esac] = ACTIONS(4751),
    [anon_sym_PIPE] = ACTIONS(4753),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_PIPE_AMP] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [anon_sym_LT] = ACTIONS(4753),
    [anon_sym_GT] = ACTIONS(4753),
    [anon_sym_GT_GT] = ACTIONS(4751),
    [anon_sym_AMP_GT] = ACTIONS(4753),
    [anon_sym_AMP_GT_GT] = ACTIONS(4751),
    [anon_sym_LT_AMP] = ACTIONS(4751),
    [anon_sym_GT_AMP] = ACTIONS(4751),
    [anon_sym_LT_LT] = ACTIONS(4753),
    [anon_sym_LT_LT_DASH] = ACTIONS(4751),
    [anon_sym_LT_LT_LT] = ACTIONS(4751),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4751),
    [anon_sym_AMP] = ACTIONS(4753),
  },
  [2852] = {
    [sym__simple_heredoc_body] = ACTIONS(4755),
    [sym__heredoc_body_beginning] = ACTIONS(4755),
    [sym_file_descriptor] = ACTIONS(4755),
    [sym__concat] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4757),
    [anon_sym_esac] = ACTIONS(4755),
    [anon_sym_PIPE] = ACTIONS(4757),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [anon_sym_PIPE_AMP] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(4757),
    [anon_sym_GT] = ACTIONS(4757),
    [anon_sym_GT_GT] = ACTIONS(4755),
    [anon_sym_AMP_GT] = ACTIONS(4757),
    [anon_sym_AMP_GT_GT] = ACTIONS(4755),
    [anon_sym_LT_AMP] = ACTIONS(4755),
    [anon_sym_GT_AMP] = ACTIONS(4755),
    [anon_sym_LT_LT] = ACTIONS(4757),
    [anon_sym_LT_LT_DASH] = ACTIONS(4755),
    [anon_sym_LT_LT_LT] = ACTIONS(4755),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4755),
    [anon_sym_AMP] = ACTIONS(4757),
  },
  [2853] = {
    [sym__simple_heredoc_body] = ACTIONS(5168),
    [sym__heredoc_body_beginning] = ACTIONS(5168),
    [sym_file_descriptor] = ACTIONS(5168),
    [sym__concat] = ACTIONS(5168),
    [sym_variable_name] = ACTIONS(5168),
    [anon_sym_SEMI] = ACTIONS(5170),
    [anon_sym_esac] = ACTIONS(5170),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_SEMI_SEMI] = ACTIONS(5168),
    [anon_sym_PIPE_AMP] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_LT] = ACTIONS(5170),
    [anon_sym_GT] = ACTIONS(5170),
    [anon_sym_GT_GT] = ACTIONS(5168),
    [anon_sym_AMP_GT] = ACTIONS(5170),
    [anon_sym_AMP_GT_GT] = ACTIONS(5168),
    [anon_sym_LT_AMP] = ACTIONS(5168),
    [anon_sym_GT_AMP] = ACTIONS(5168),
    [anon_sym_LT_LT] = ACTIONS(5170),
    [anon_sym_LT_LT_DASH] = ACTIONS(5168),
    [anon_sym_LT_LT_LT] = ACTIONS(5168),
    [sym__special_characters] = ACTIONS(5168),
    [anon_sym_DQUOTE] = ACTIONS(5168),
    [anon_sym_DOLLAR] = ACTIONS(5170),
    [sym_raw_string] = ACTIONS(5168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5168),
    [anon_sym_BQUOTE] = ACTIONS(5168),
    [anon_sym_LT_LPAREN] = ACTIONS(5168),
    [anon_sym_GT_LPAREN] = ACTIONS(5168),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5170),
    [anon_sym_LF] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5170),
  },
  [2854] = {
    [sym__simple_heredoc_body] = ACTIONS(5172),
    [sym__heredoc_body_beginning] = ACTIONS(5172),
    [sym_file_descriptor] = ACTIONS(5172),
    [sym__concat] = ACTIONS(5172),
    [sym_variable_name] = ACTIONS(5172),
    [anon_sym_SEMI] = ACTIONS(5174),
    [anon_sym_esac] = ACTIONS(5174),
    [anon_sym_PIPE] = ACTIONS(5174),
    [anon_sym_SEMI_SEMI] = ACTIONS(5172),
    [anon_sym_PIPE_AMP] = ACTIONS(5172),
    [anon_sym_AMP_AMP] = ACTIONS(5172),
    [anon_sym_PIPE_PIPE] = ACTIONS(5172),
    [anon_sym_LT] = ACTIONS(5174),
    [anon_sym_GT] = ACTIONS(5174),
    [anon_sym_GT_GT] = ACTIONS(5172),
    [anon_sym_AMP_GT] = ACTIONS(5174),
    [anon_sym_AMP_GT_GT] = ACTIONS(5172),
    [anon_sym_LT_AMP] = ACTIONS(5172),
    [anon_sym_GT_AMP] = ACTIONS(5172),
    [anon_sym_LT_LT] = ACTIONS(5174),
    [anon_sym_LT_LT_DASH] = ACTIONS(5172),
    [anon_sym_LT_LT_LT] = ACTIONS(5172),
    [sym__special_characters] = ACTIONS(5172),
    [anon_sym_DQUOTE] = ACTIONS(5172),
    [anon_sym_DOLLAR] = ACTIONS(5174),
    [sym_raw_string] = ACTIONS(5172),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5172),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5172),
    [anon_sym_BQUOTE] = ACTIONS(5172),
    [anon_sym_LT_LPAREN] = ACTIONS(5172),
    [anon_sym_GT_LPAREN] = ACTIONS(5172),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5174),
    [anon_sym_LF] = ACTIONS(5172),
    [anon_sym_AMP] = ACTIONS(5174),
  },
  [2855] = {
    [sym__simple_heredoc_body] = ACTIONS(5168),
    [sym__heredoc_body_beginning] = ACTIONS(5168),
    [sym_file_descriptor] = ACTIONS(5168),
    [sym__concat] = ACTIONS(5168),
    [anon_sym_SEMI] = ACTIONS(5170),
    [anon_sym_esac] = ACTIONS(5168),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_SEMI_SEMI] = ACTIONS(5168),
    [anon_sym_PIPE_AMP] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_LT] = ACTIONS(5170),
    [anon_sym_GT] = ACTIONS(5170),
    [anon_sym_GT_GT] = ACTIONS(5168),
    [anon_sym_AMP_GT] = ACTIONS(5170),
    [anon_sym_AMP_GT_GT] = ACTIONS(5168),
    [anon_sym_LT_AMP] = ACTIONS(5168),
    [anon_sym_GT_AMP] = ACTIONS(5168),
    [anon_sym_LT_LT] = ACTIONS(5170),
    [anon_sym_LT_LT_DASH] = ACTIONS(5168),
    [anon_sym_LT_LT_LT] = ACTIONS(5168),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5170),
  },
  [2856] = {
    [sym__simple_heredoc_body] = ACTIONS(5172),
    [sym__heredoc_body_beginning] = ACTIONS(5172),
    [sym_file_descriptor] = ACTIONS(5172),
    [sym__concat] = ACTIONS(5172),
    [anon_sym_SEMI] = ACTIONS(5174),
    [anon_sym_esac] = ACTIONS(5172),
    [anon_sym_PIPE] = ACTIONS(5174),
    [anon_sym_SEMI_SEMI] = ACTIONS(5172),
    [anon_sym_PIPE_AMP] = ACTIONS(5172),
    [anon_sym_AMP_AMP] = ACTIONS(5172),
    [anon_sym_PIPE_PIPE] = ACTIONS(5172),
    [anon_sym_LT] = ACTIONS(5174),
    [anon_sym_GT] = ACTIONS(5174),
    [anon_sym_GT_GT] = ACTIONS(5172),
    [anon_sym_AMP_GT] = ACTIONS(5174),
    [anon_sym_AMP_GT_GT] = ACTIONS(5172),
    [anon_sym_LT_AMP] = ACTIONS(5172),
    [anon_sym_GT_AMP] = ACTIONS(5172),
    [anon_sym_LT_LT] = ACTIONS(5174),
    [anon_sym_LT_LT_DASH] = ACTIONS(5172),
    [anon_sym_LT_LT_LT] = ACTIONS(5172),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5172),
    [anon_sym_AMP] = ACTIONS(5174),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [11] = {.count = 1, .reusable = false}, SHIFT(4),
  [13] = {.count = 1, .reusable = true}, SHIFT(5),
  [15] = {.count = 1, .reusable = false}, SHIFT(6),
  [17] = {.count = 1, .reusable = false}, SHIFT(7),
  [19] = {.count = 1, .reusable = false}, SHIFT(8),
  [21] = {.count = 1, .reusable = false}, SHIFT(9),
  [23] = {.count = 1, .reusable = false}, SHIFT(10),
  [25] = {.count = 1, .reusable = true}, SHIFT(11),
  [27] = {.count = 1, .reusable = false}, SHIFT(12),
  [29] = {.count = 1, .reusable = false}, SHIFT(13),
  [31] = {.count = 1, .reusable = true}, SHIFT(14),
  [33] = {.count = 1, .reusable = false}, SHIFT(15),
  [35] = {.count = 1, .reusable = false}, SHIFT(16),
  [37] = {.count = 1, .reusable = false}, SHIFT(17),
  [39] = {.count = 1, .reusable = true}, SHIFT(17),
  [41] = {.count = 1, .reusable = false}, SHIFT(18),
  [43] = {.count = 1, .reusable = true}, SHIFT(19),
  [45] = {.count = 1, .reusable = false}, SHIFT(20),
  [47] = {.count = 1, .reusable = true}, SHIFT(21),
  [49] = {.count = 1, .reusable = true}, SHIFT(22),
  [51] = {.count = 1, .reusable = true}, SHIFT(23),
  [53] = {.count = 1, .reusable = true}, SHIFT(24),
  [55] = {.count = 1, .reusable = true}, SHIFT(25),
  [57] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [59] = {.count = 1, .reusable = false}, SHIFT(26),
  [61] = {.count = 1, .reusable = false}, SHIFT(35),
  [63] = {.count = 1, .reusable = true}, SHIFT(35),
  [65] = {.count = 1, .reusable = true}, SHIFT(36),
  [67] = {.count = 1, .reusable = true}, SHIFT(37),
  [69] = {.count = 1, .reusable = true}, SHIFT(38),
  [71] = {.count = 1, .reusable = true}, SHIFT(39),
  [73] = {.count = 1, .reusable = true}, SHIFT(40),
  [75] = {.count = 1, .reusable = false}, SHIFT(41),
  [77] = {.count = 1, .reusable = true}, SHIFT(42),
  [79] = {.count = 1, .reusable = true}, SHIFT(43),
  [81] = {.count = 1, .reusable = false}, SHIFT(44),
  [83] = {.count = 1, .reusable = true}, SHIFT(45),
  [85] = {.count = 1, .reusable = true}, SHIFT(46),
  [87] = {.count = 1, .reusable = true}, SHIFT(47),
  [89] = {.count = 1, .reusable = true}, SHIFT(48),
  [91] = {.count = 1, .reusable = true}, SHIFT(49),
  [93] = {.count = 1, .reusable = false}, SHIFT(45),
  [95] = {.count = 1, .reusable = true}, SHIFT(41),
  [97] = {.count = 1, .reusable = true}, SHIFT(51),
  [99] = {.count = 1, .reusable = false}, SHIFT(52),
  [101] = {.count = 1, .reusable = false}, SHIFT(53),
  [103] = {.count = 1, .reusable = false}, SHIFT(54),
  [105] = {.count = 1, .reusable = false}, SHIFT(55),
  [107] = {.count = 1, .reusable = true}, SHIFT(56),
  [109] = {.count = 1, .reusable = false}, SHIFT(57),
  [111] = {.count = 1, .reusable = true}, SHIFT(65),
  [113] = {.count = 1, .reusable = true}, SHIFT(66),
  [115] = {.count = 1, .reusable = false}, SHIFT(67),
  [117] = {.count = 1, .reusable = true}, SHIFT(68),
  [119] = {.count = 1, .reusable = true}, SHIFT(69),
  [121] = {.count = 1, .reusable = true}, SHIFT(70),
  [123] = {.count = 1, .reusable = true}, SHIFT(71),
  [125] = {.count = 1, .reusable = true}, SHIFT(72),
  [127] = {.count = 1, .reusable = true}, SHIFT(74),
  [129] = {.count = 1, .reusable = true}, SHIFT(75),
  [131] = {.count = 1, .reusable = false}, SHIFT(76),
  [133] = {.count = 1, .reusable = false}, SHIFT(77),
  [135] = {.count = 1, .reusable = false}, SHIFT(78),
  [137] = {.count = 1, .reusable = false}, SHIFT(79),
  [139] = {.count = 1, .reusable = true}, SHIFT(80),
  [141] = {.count = 1, .reusable = false}, SHIFT(81),
  [143] = {.count = 1, .reusable = true}, SHIFT(88),
  [145] = {.count = 1, .reusable = true}, SHIFT(92),
  [147] = {.count = 1, .reusable = true}, SHIFT(95),
  [149] = {.count = 1, .reusable = false}, SHIFT(96),
  [151] = {.count = 1, .reusable = true}, SHIFT(97),
  [153] = {.count = 1, .reusable = true}, SHIFT(98),
  [155] = {.count = 1, .reusable = false}, SHIFT(99),
  [157] = {.count = 1, .reusable = true}, SHIFT(100),
  [159] = {.count = 1, .reusable = true}, SHIFT(101),
  [161] = {.count = 1, .reusable = true}, SHIFT(102),
  [163] = {.count = 1, .reusable = true}, SHIFT(103),
  [165] = {.count = 1, .reusable = true}, SHIFT(104),
  [167] = {.count = 1, .reusable = false}, SHIFT(100),
  [169] = {.count = 1, .reusable = true}, SHIFT(96),
  [171] = {.count = 1, .reusable = false}, SHIFT(106),
  [173] = {.count = 1, .reusable = true}, SHIFT(107),
  [175] = {.count = 1, .reusable = true}, SHIFT(108),
  [177] = {.count = 1, .reusable = false}, SHIFT(108),
  [179] = {.count = 1, .reusable = true}, SHIFT(106),
  [181] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 1),
  [183] = {.count = 1, .reusable = true}, SHIFT(110),
  [185] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 1),
  [187] = {.count = 1, .reusable = true}, SHIFT(111),
  [189] = {.count = 1, .reusable = true}, SHIFT(112),
  [191] = {.count = 1, .reusable = false}, SHIFT(113),
  [193] = {.count = 1, .reusable = true}, SHIFT(114),
  [195] = {.count = 1, .reusable = true}, SHIFT(115),
  [197] = {.count = 1, .reusable = true}, SHIFT(116),
  [199] = {.count = 1, .reusable = true}, SHIFT(117),
  [201] = {.count = 1, .reusable = true}, SHIFT(118),
  [203] = {.count = 1, .reusable = false}, SHIFT(120),
  [205] = {.count = 1, .reusable = false}, SHIFT(114),
  [207] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 1),
  [209] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 1),
  [211] = {.count = 1, .reusable = true}, SHIFT(121),
  [213] = {.count = 1, .reusable = true}, SHIFT(122),
  [215] = {.count = 1, .reusable = false}, SHIFT(123),
  [217] = {.count = 1, .reusable = true}, SHIFT(124),
  [219] = {.count = 1, .reusable = true}, SHIFT(125),
  [221] = {.count = 1, .reusable = true}, SHIFT(126),
  [223] = {.count = 1, .reusable = true}, SHIFT(127),
  [225] = {.count = 1, .reusable = true}, SHIFT(128),
  [227] = {.count = 1, .reusable = false}, SHIFT(129),
  [229] = {.count = 1, .reusable = false}, SHIFT(124),
  [231] = {.count = 1, .reusable = true}, SHIFT(130),
  [233] = {.count = 1, .reusable = true}, SHIFT(131),
  [235] = {.count = 1, .reusable = false}, SHIFT(132),
  [237] = {.count = 1, .reusable = true}, SHIFT(133),
  [239] = {.count = 1, .reusable = true}, SHIFT(134),
  [241] = {.count = 1, .reusable = true}, SHIFT(135),
  [243] = {.count = 1, .reusable = true}, SHIFT(136),
  [245] = {.count = 1, .reusable = true}, SHIFT(137),
  [247] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [249] = {.count = 1, .reusable = true}, SHIFT(139),
  [251] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [253] = {.count = 1, .reusable = false}, SHIFT(141),
  [255] = {.count = 1, .reusable = false}, SHIFT(142),
  [257] = {.count = 1, .reusable = true}, SHIFT(143),
  [259] = {.count = 1, .reusable = false}, SHIFT(144),
  [261] = {.count = 1, .reusable = false}, SHIFT(145),
  [263] = {.count = 1, .reusable = false}, SHIFT(146),
  [265] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [267] = {.count = 1, .reusable = true}, SHIFT(148),
  [269] = {.count = 1, .reusable = true}, SHIFT(149),
  [271] = {.count = 1, .reusable = false}, SHIFT(150),
  [273] = {.count = 1, .reusable = true}, SHIFT(150),
  [275] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1),
  [277] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1),
  [279] = {.count = 1, .reusable = true}, SHIFT(151),
  [281] = {.count = 1, .reusable = true}, SHIFT(152),
  [283] = {.count = 1, .reusable = true}, SHIFT(153),
  [285] = {.count = 1, .reusable = false}, SHIFT(154),
  [287] = {.count = 1, .reusable = true}, SHIFT(154),
  [289] = {.count = 1, .reusable = false}, SHIFT(158),
  [291] = {.count = 1, .reusable = false}, SHIFT(159),
  [293] = {.count = 1, .reusable = false}, SHIFT(160),
  [295] = {.count = 1, .reusable = true}, SHIFT(169),
  [297] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [299] = {.count = 1, .reusable = true}, SHIFT(170),
  [301] = {.count = 1, .reusable = true}, SHIFT(171),
  [303] = {.count = 1, .reusable = true}, SHIFT(172),
  [305] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [307] = {.count = 1, .reusable = false}, SHIFT(173),
  [309] = {.count = 1, .reusable = false}, SHIFT(174),
  [311] = {.count = 1, .reusable = true}, SHIFT(173),
  [313] = {.count = 1, .reusable = true}, SHIFT(174),
  [315] = {.count = 1, .reusable = true}, SHIFT(175),
  [317] = {.count = 1, .reusable = false}, SHIFT(176),
  [319] = {.count = 1, .reusable = true}, SHIFT(176),
  [321] = {.count = 1, .reusable = false}, SHIFT(177),
  [323] = {.count = 1, .reusable = true}, SHIFT(177),
  [325] = {.count = 1, .reusable = true}, SHIFT(178),
  [327] = {.count = 1, .reusable = true}, REDUCE(sym_command, 1),
  [329] = {.count = 1, .reusable = false}, REDUCE(sym_command, 1),
  [331] = {.count = 1, .reusable = false}, SHIFT(181),
  [333] = {.count = 1, .reusable = true}, SHIFT(182),
  [335] = {.count = 1, .reusable = true}, SHIFT(183),
  [337] = {.count = 1, .reusable = false}, SHIFT(183),
  [339] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 1),
  [341] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 1),
  [343] = {.count = 1, .reusable = true}, SHIFT(18),
  [345] = {.count = 1, .reusable = true}, SHIFT(190),
  [347] = {.count = 1, .reusable = true}, SHIFT(191),
  [349] = {.count = 1, .reusable = true}, SHIFT(193),
  [351] = {.count = 1, .reusable = true}, SHIFT(194),
  [353] = {.count = 1, .reusable = true}, SHIFT(196),
  [355] = {.count = 1, .reusable = true}, SHIFT(197),
  [357] = {.count = 1, .reusable = true}, SHIFT(198),
  [359] = {.count = 1, .reusable = true}, SHIFT(199),
  [361] = {.count = 1, .reusable = false}, SHIFT(200),
  [363] = {.count = 1, .reusable = true}, SHIFT(201),
  [365] = {.count = 1, .reusable = true}, SHIFT(202),
  [367] = {.count = 1, .reusable = true}, SHIFT(203),
  [369] = {.count = 1, .reusable = true}, SHIFT(204),
  [371] = {.count = 1, .reusable = true}, SHIFT(205),
  [373] = {.count = 1, .reusable = false}, SHIFT(206),
  [375] = {.count = 1, .reusable = true}, SHIFT(206),
  [377] = {.count = 1, .reusable = true}, SHIFT(207),
  [379] = {.count = 1, .reusable = false}, SHIFT(208),
  [381] = {.count = 1, .reusable = true}, SHIFT(209),
  [383] = {.count = 1, .reusable = true}, SHIFT(210),
  [385] = {.count = 1, .reusable = false}, SHIFT(211),
  [387] = {.count = 1, .reusable = true}, SHIFT(212),
  [389] = {.count = 1, .reusable = true}, SHIFT(213),
  [391] = {.count = 1, .reusable = true}, SHIFT(214),
  [393] = {.count = 1, .reusable = true}, SHIFT(215),
  [395] = {.count = 1, .reusable = true}, SHIFT(216),
  [397] = {.count = 1, .reusable = false}, SHIFT(212),
  [399] = {.count = 1, .reusable = true}, SHIFT(208),
  [401] = {.count = 1, .reusable = true}, SHIFT(218),
  [403] = {.count = 1, .reusable = false}, SHIFT(219),
  [405] = {.count = 1, .reusable = true}, SHIFT(219),
  [407] = {.count = 1, .reusable = true}, SHIFT(220),
  [409] = {.count = 1, .reusable = false}, SHIFT(221),
  [411] = {.count = 1, .reusable = true}, SHIFT(222),
  [413] = {.count = 1, .reusable = true}, SHIFT(223),
  [415] = {.count = 1, .reusable = false}, SHIFT(224),
  [417] = {.count = 1, .reusable = true}, SHIFT(225),
  [419] = {.count = 1, .reusable = true}, SHIFT(226),
  [421] = {.count = 1, .reusable = true}, SHIFT(227),
  [423] = {.count = 1, .reusable = true}, SHIFT(228),
  [425] = {.count = 1, .reusable = true}, SHIFT(229),
  [427] = {.count = 1, .reusable = false}, SHIFT(225),
  [429] = {.count = 1, .reusable = true}, SHIFT(221),
  [431] = {.count = 1, .reusable = true}, SHIFT(232),
  [433] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [435] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [437] = {.count = 1, .reusable = false}, SHIFT(234),
  [439] = {.count = 1, .reusable = false}, SHIFT(235),
  [441] = {.count = 1, .reusable = true}, SHIFT(237),
  [443] = {.count = 1, .reusable = true}, SHIFT(238),
  [445] = {.count = 1, .reusable = false}, SHIFT(239),
  [447] = {.count = 1, .reusable = true}, SHIFT(239),
  [449] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [451] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [453] = {.count = 1, .reusable = true}, SHIFT(240),
  [455] = {.count = 1, .reusable = true}, SHIFT(241),
  [457] = {.count = 1, .reusable = true}, SHIFT(242),
  [459] = {.count = 1, .reusable = false}, SHIFT(243),
  [461] = {.count = 1, .reusable = true}, SHIFT(243),
  [463] = {.count = 1, .reusable = true}, SHIFT(253),
  [465] = {.count = 1, .reusable = true}, SHIFT(254),
  [467] = {.count = 1, .reusable = true}, SHIFT(255),
  [469] = {.count = 1, .reusable = false}, SHIFT(254),
  [471] = {.count = 1, .reusable = true}, SHIFT(256),
  [473] = {.count = 1, .reusable = true}, SHIFT(257),
  [475] = {.count = 1, .reusable = true}, SHIFT(258),
  [477] = {.count = 1, .reusable = true}, SHIFT(259),
  [479] = {.count = 1, .reusable = true}, SHIFT(260),
  [481] = {.count = 1, .reusable = false}, SHIFT(262),
  [483] = {.count = 1, .reusable = false}, SHIFT(260),
  [485] = {.count = 1, .reusable = true}, SHIFT(263),
  [487] = {.count = 1, .reusable = true}, SHIFT(264),
  [489] = {.count = 1, .reusable = false}, SHIFT(265),
  [491] = {.count = 1, .reusable = false}, SHIFT(264),
  [493] = {.count = 1, .reusable = true}, SHIFT(267),
  [495] = {.count = 1, .reusable = true}, SHIFT(269),
  [497] = {.count = 1, .reusable = false}, SHIFT(270),
  [499] = {.count = 1, .reusable = false}, SHIFT(271),
  [501] = {.count = 1, .reusable = true}, SHIFT(270),
  [503] = {.count = 1, .reusable = true}, SHIFT(271),
  [505] = {.count = 1, .reusable = true}, SHIFT(272),
  [507] = {.count = 1, .reusable = false}, SHIFT(273),
  [509] = {.count = 1, .reusable = true}, SHIFT(273),
  [511] = {.count = 1, .reusable = true}, SHIFT(274),
  [513] = {.count = 1, .reusable = false}, SHIFT(277),
  [515] = {.count = 1, .reusable = true}, SHIFT(278),
  [517] = {.count = 1, .reusable = true}, SHIFT(279),
  [519] = {.count = 1, .reusable = false}, SHIFT(279),
  [521] = {.count = 1, .reusable = true}, SHIFT(55),
  [523] = {.count = 1, .reusable = true}, SHIFT(282),
  [525] = {.count = 1, .reusable = true}, SHIFT(283),
  [527] = {.count = 1, .reusable = true}, SHIFT(284),
  [529] = {.count = 1, .reusable = false}, SHIFT(285),
  [531] = {.count = 1, .reusable = true}, SHIFT(285),
  [533] = {.count = 1, .reusable = false}, SHIFT(287),
  [535] = {.count = 1, .reusable = false}, SHIFT(288),
  [537] = {.count = 1, .reusable = true}, SHIFT(290),
  [539] = {.count = 1, .reusable = true}, SHIFT(291),
  [541] = {.count = 1, .reusable = false}, SHIFT(292),
  [543] = {.count = 1, .reusable = true}, SHIFT(292),
  [545] = {.count = 1, .reusable = true}, SHIFT(293),
  [547] = {.count = 1, .reusable = false}, SHIFT(294),
  [549] = {.count = 1, .reusable = true}, SHIFT(294),
  [551] = {.count = 1, .reusable = true}, SHIFT(295),
  [553] = {.count = 1, .reusable = true}, SHIFT(296),
  [555] = {.count = 1, .reusable = true}, SHIFT(297),
  [557] = {.count = 1, .reusable = false}, SHIFT(298),
  [559] = {.count = 1, .reusable = true}, SHIFT(298),
  [561] = {.count = 1, .reusable = true}, SHIFT(308),
  [563] = {.count = 1, .reusable = true}, SHIFT(310),
  [565] = {.count = 1, .reusable = true}, SHIFT(311),
  [567] = {.count = 1, .reusable = true}, SHIFT(312),
  [569] = {.count = 1, .reusable = true}, SHIFT(313),
  [571] = {.count = 1, .reusable = false}, SHIFT(315),
  [573] = {.count = 1, .reusable = false}, SHIFT(313),
  [575] = {.count = 1, .reusable = true}, SHIFT(316),
  [577] = {.count = 1, .reusable = true}, SHIFT(317),
  [579] = {.count = 1, .reusable = false}, SHIFT(318),
  [581] = {.count = 1, .reusable = false}, SHIFT(317),
  [583] = {.count = 1, .reusable = true}, SHIFT(320),
  [585] = {.count = 1, .reusable = false}, SHIFT(321),
  [587] = {.count = 1, .reusable = false}, SHIFT(322),
  [589] = {.count = 1, .reusable = true}, SHIFT(323),
  [591] = {.count = 1, .reusable = true}, SHIFT(321),
  [593] = {.count = 1, .reusable = true}, SHIFT(322),
  [595] = {.count = 1, .reusable = true}, SHIFT(324),
  [597] = {.count = 1, .reusable = false}, SHIFT(325),
  [599] = {.count = 1, .reusable = true}, SHIFT(325),
  [601] = {.count = 1, .reusable = true}, SHIFT(326),
  [603] = {.count = 1, .reusable = false}, SHIFT(329),
  [605] = {.count = 1, .reusable = true}, SHIFT(330),
  [607] = {.count = 1, .reusable = true}, SHIFT(331),
  [609] = {.count = 1, .reusable = false}, SHIFT(331),
  [611] = {.count = 1, .reusable = true}, SHIFT(79),
  [613] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 2),
  [615] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 2),
  [617] = {.count = 1, .reusable = false}, SHIFT(336),
  [619] = {.count = 1, .reusable = true}, SHIFT(336),
  [621] = {.count = 1, .reusable = true}, SHIFT(338),
  [623] = {.count = 1, .reusable = true}, SHIFT(340),
  [625] = {.count = 1, .reusable = true}, REDUCE(sym_negated_command, 2),
  [627] = {.count = 1, .reusable = false}, REDUCE(sym_negated_command, 2),
  [629] = {.count = 1, .reusable = true}, SHIFT(343),
  [631] = {.count = 1, .reusable = false}, SHIFT(345),
  [633] = {.count = 1, .reusable = false}, SHIFT(346),
  [635] = {.count = 1, .reusable = true}, SHIFT(348),
  [637] = {.count = 1, .reusable = true}, SHIFT(349),
  [639] = {.count = 1, .reusable = false}, SHIFT(350),
  [641] = {.count = 1, .reusable = true}, SHIFT(350),
  [643] = {.count = 1, .reusable = true}, SHIFT(351),
  [645] = {.count = 1, .reusable = true}, SHIFT(352),
  [647] = {.count = 1, .reusable = true}, SHIFT(353),
  [649] = {.count = 1, .reusable = false}, SHIFT(354),
  [651] = {.count = 1, .reusable = true}, SHIFT(354),
  [653] = {.count = 1, .reusable = true}, SHIFT(364),
  [655] = {.count = 1, .reusable = true}, SHIFT(365),
  [657] = {.count = 1, .reusable = false}, SHIFT(364),
  [659] = {.count = 1, .reusable = true}, SHIFT(366),
  [661] = {.count = 1, .reusable = true}, SHIFT(369),
  [663] = {.count = 1, .reusable = true}, SHIFT(370),
  [665] = {.count = 1, .reusable = false}, SHIFT(369),
  [667] = {.count = 1, .reusable = true}, SHIFT(371),
  [669] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [671] = {.count = 1, .reusable = true}, SHIFT(372),
  [673] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [675] = {.count = 1, .reusable = false}, SHIFT(374),
  [677] = {.count = 1, .reusable = false}, SHIFT(375),
  [679] = {.count = 1, .reusable = true}, SHIFT(377),
  [681] = {.count = 1, .reusable = true}, SHIFT(378),
  [683] = {.count = 1, .reusable = false}, SHIFT(379),
  [685] = {.count = 1, .reusable = true}, SHIFT(379),
  [687] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [689] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [691] = {.count = 1, .reusable = true}, SHIFT(380),
  [693] = {.count = 1, .reusable = true}, SHIFT(381),
  [695] = {.count = 1, .reusable = true}, SHIFT(382),
  [697] = {.count = 1, .reusable = false}, SHIFT(383),
  [699] = {.count = 1, .reusable = true}, SHIFT(383),
  [701] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 2),
  [703] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 2),
  [705] = {.count = 1, .reusable = false}, SHIFT(393),
  [707] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [709] = {.count = 1, .reusable = true}, SHIFT(394),
  [711] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [713] = {.count = 1, .reusable = false}, SHIFT(396),
  [715] = {.count = 1, .reusable = false}, SHIFT(397),
  [717] = {.count = 1, .reusable = true}, SHIFT(399),
  [719] = {.count = 1, .reusable = true}, SHIFT(400),
  [721] = {.count = 1, .reusable = false}, SHIFT(401),
  [723] = {.count = 1, .reusable = true}, SHIFT(401),
  [725] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [727] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [729] = {.count = 1, .reusable = true}, SHIFT(402),
  [731] = {.count = 1, .reusable = true}, SHIFT(403),
  [733] = {.count = 1, .reusable = true}, SHIFT(404),
  [735] = {.count = 1, .reusable = false}, SHIFT(405),
  [737] = {.count = 1, .reusable = true}, SHIFT(405),
  [739] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 2),
  [741] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 2),
  [743] = {.count = 1, .reusable = false}, SHIFT(415),
  [745] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 2),
  [747] = {.count = 1, .reusable = true}, SHIFT(416),
  [749] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 2),
  [751] = {.count = 1, .reusable = false}, SHIFT(418),
  [753] = {.count = 1, .reusable = false}, SHIFT(419),
  [755] = {.count = 1, .reusable = true}, SHIFT(421),
  [757] = {.count = 1, .reusable = true}, SHIFT(422),
  [759] = {.count = 1, .reusable = false}, SHIFT(423),
  [761] = {.count = 1, .reusable = true}, SHIFT(423),
  [763] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2),
  [765] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2),
  [767] = {.count = 1, .reusable = true}, SHIFT(424),
  [769] = {.count = 1, .reusable = true}, SHIFT(425),
  [771] = {.count = 1, .reusable = true}, SHIFT(426),
  [773] = {.count = 1, .reusable = false}, SHIFT(427),
  [775] = {.count = 1, .reusable = true}, SHIFT(427),
  [777] = {.count = 1, .reusable = true}, SHIFT(437),
  [779] = {.count = 1, .reusable = true}, REDUCE(sym_concatenation, 2),
  [781] = {.count = 1, .reusable = false}, REDUCE(sym_concatenation, 2),
  [783] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [785] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [787] = {.count = 1, .reusable = true}, SHIFT(439),
  [789] = {.count = 1, .reusable = false}, SHIFT(440),
  [791] = {.count = 1, .reusable = false}, SHIFT(439),
  [793] = {.count = 1, .reusable = false}, SHIFT(441),
  [795] = {.count = 1, .reusable = false}, SHIFT(442),
  [797] = {.count = 1, .reusable = true}, SHIFT(442),
  [799] = {.count = 1, .reusable = true}, SHIFT(443),
  [801] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 1),
  [803] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 1),
  [805] = {.count = 1, .reusable = true}, SHIFT(444),
  [807] = {.count = 1, .reusable = true}, SHIFT(445),
  [809] = {.count = 1, .reusable = true}, SHIFT(446),
  [811] = {.count = 1, .reusable = false}, SHIFT(447),
  [813] = {.count = 1, .reusable = true}, SHIFT(447),
  [815] = {.count = 1, .reusable = false}, SHIFT(454),
  [817] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 3),
  [819] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 3),
  [821] = {.count = 1, .reusable = true}, REDUCE(sym_string_expansion, 2),
  [823] = {.count = 1, .reusable = false}, REDUCE(sym_string_expansion, 2),
  [825] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2),
  [827] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2),
  [829] = {.count = 1, .reusable = true}, SHIFT(456),
  [831] = {.count = 1, .reusable = true}, SHIFT(457),
  [833] = {.count = 1, .reusable = true}, SHIFT(458),
  [835] = {.count = 1, .reusable = true}, SHIFT(459),
  [837] = {.count = 1, .reusable = false}, SHIFT(460),
  [839] = {.count = 1, .reusable = true}, SHIFT(460),
  [841] = {.count = 1, .reusable = true}, SHIFT(461),
  [843] = {.count = 1, .reusable = false}, SHIFT(471),
  [845] = {.count = 1, .reusable = false}, SHIFT(462),
  [847] = {.count = 1, .reusable = true}, SHIFT(463),
  [849] = {.count = 1, .reusable = false}, SHIFT(464),
  [851] = {.count = 1, .reusable = true}, SHIFT(465),
  [853] = {.count = 1, .reusable = true}, SHIFT(471),
  [855] = {.count = 1, .reusable = true}, SHIFT(466),
  [857] = {.count = 1, .reusable = true}, SHIFT(467),
  [859] = {.count = 1, .reusable = true}, SHIFT(468),
  [861] = {.count = 1, .reusable = true}, SHIFT(469),
  [863] = {.count = 1, .reusable = true}, SHIFT(470),
  [865] = {.count = 1, .reusable = false}, SHIFT(465),
  [867] = {.count = 1, .reusable = true}, SHIFT(472),
  [869] = {.count = 1, .reusable = false}, SHIFT(474),
  [871] = {.count = 1, .reusable = true}, SHIFT(474),
  [873] = {.count = 1, .reusable = true}, SHIFT(473),
  [875] = {.count = 1, .reusable = false}, SHIFT(475),
  [877] = {.count = 1, .reusable = true}, SHIFT(476),
  [879] = {.count = 1, .reusable = true}, SHIFT(475),
  [881] = {.count = 1, .reusable = false}, SHIFT(480),
  [883] = {.count = 1, .reusable = false}, SHIFT(481),
  [885] = {.count = 1, .reusable = true}, SHIFT(482),
  [887] = {.count = 1, .reusable = false}, SHIFT(483),
  [889] = {.count = 1, .reusable = false}, SHIFT(484),
  [891] = {.count = 1, .reusable = true}, SHIFT(483),
  [893] = {.count = 1, .reusable = true}, SHIFT(484),
  [895] = {.count = 1, .reusable = true}, SHIFT(485),
  [897] = {.count = 1, .reusable = false}, SHIFT(486),
  [899] = {.count = 1, .reusable = true}, SHIFT(486),
  [901] = {.count = 1, .reusable = true}, SHIFT(487),
  [903] = {.count = 1, .reusable = false}, SHIFT(494),
  [905] = {.count = 1, .reusable = true}, SHIFT(495),
  [907] = {.count = 1, .reusable = true}, SHIFT(494),
  [909] = {.count = 1, .reusable = true}, SHIFT(499),
  [911] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 1),
  [913] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 1),
  [915] = {.count = 1, .reusable = true}, SHIFT(503),
  [917] = {.count = 1, .reusable = true}, SHIFT(500),
  [919] = {.count = 1, .reusable = false}, SHIFT(501),
  [921] = {.count = 1, .reusable = true}, SHIFT(502),
  [923] = {.count = 1, .reusable = false}, SHIFT(504),
  [925] = {.count = 1, .reusable = true}, SHIFT(504),
  [927] = {.count = 1, .reusable = true}, REDUCE(sym__terminated_statement, 2),
  [929] = {.count = 1, .reusable = true}, REDUCE(sym_program, 2),
  [931] = {.count = 1, .reusable = false}, REDUCE(sym__terminated_statement, 2),
  [933] = {.count = 1, .reusable = true}, SHIFT(509),
  [935] = {.count = 1, .reusable = true}, SHIFT(510),
  [937] = {.count = 1, .reusable = true}, SHIFT(512),
  [939] = {.count = 1, .reusable = true}, SHIFT(513),
  [941] = {.count = 1, .reusable = true}, SHIFT(514),
  [943] = {.count = 1, .reusable = false}, SHIFT(516),
  [945] = {.count = 1, .reusable = true}, SHIFT(516),
  [947] = {.count = 1, .reusable = true}, REDUCE(sym_redirected_statement, 2),
  [949] = {.count = 1, .reusable = false}, REDUCE(sym_redirected_statement, 2),
  [951] = {.count = 1, .reusable = true}, SHIFT(518),
  [953] = {.count = 1, .reusable = true}, SHIFT(519),
  [955] = {.count = 1, .reusable = true}, SHIFT(520),
  [957] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [959] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [961] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1),
  [963] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1),
  [965] = {.count = 1, .reusable = true}, REDUCE(sym_command, 2),
  [967] = {.count = 1, .reusable = false}, REDUCE(sym_command, 2),
  [969] = {.count = 1, .reusable = false}, SHIFT(522),
  [971] = {.count = 1, .reusable = true}, SHIFT(522),
  [973] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2),
  [976] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(51),
  [979] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(4),
  [982] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(5),
  [985] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(6),
  [988] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(7),
  [991] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(8),
  [994] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(9),
  [997] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(10),
  [1000] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(11),
  [1003] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(52),
  [1006] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(13),
  [1009] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(14),
  [1012] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(53),
  [1015] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(54),
  [1018] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(17),
  [1021] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(17),
  [1024] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(55),
  [1027] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(19),
  [1030] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(20),
  [1033] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(56),
  [1036] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(22),
  [1039] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(23),
  [1042] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(24),
  [1045] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(25),
  [1048] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(57),
  [1051] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(2),
  [1054] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(92),
  [1057] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(17),
  [1060] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(17),
  [1063] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2),
  [1065] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2),
  [1067] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 4),
  [1069] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 4),
  [1071] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3),
  [1073] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3),
  [1075] = {.count = 1, .reusable = true}, SHIFT(527),
  [1077] = {.count = 1, .reusable = true}, SHIFT(528),
  [1079] = {.count = 1, .reusable = true}, SHIFT(530),
  [1081] = {.count = 1, .reusable = true}, SHIFT(531),
  [1083] = {.count = 1, .reusable = true}, SHIFT(532),
  [1085] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3),
  [1087] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3),
  [1089] = {.count = 1, .reusable = true}, SHIFT(533),
  [1091] = {.count = 1, .reusable = true}, SHIFT(534),
  [1093] = {.count = 1, .reusable = true}, SHIFT(535),
  [1095] = {.count = 1, .reusable = false}, SHIFT(536),
  [1097] = {.count = 1, .reusable = true}, SHIFT(537),
  [1099] = {.count = 1, .reusable = true}, SHIFT(538),
  [1101] = {.count = 1, .reusable = true}, SHIFT(539),
  [1103] = {.count = 1, .reusable = true}, SHIFT(540),
  [1105] = {.count = 1, .reusable = true}, SHIFT(541),
  [1107] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 4),
  [1109] = {.count = 1, .reusable = true}, SHIFT(543),
  [1111] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 4),
  [1113] = {.count = 1, .reusable = false}, SHIFT(545),
  [1115] = {.count = 1, .reusable = false}, SHIFT(546),
  [1117] = {.count = 1, .reusable = true}, SHIFT(548),
  [1119] = {.count = 1, .reusable = true}, SHIFT(549),
  [1121] = {.count = 1, .reusable = false}, SHIFT(550),
  [1123] = {.count = 1, .reusable = true}, SHIFT(550),
  [1125] = {.count = 1, .reusable = true}, SHIFT(551),
  [1127] = {.count = 1, .reusable = true}, SHIFT(552),
  [1129] = {.count = 1, .reusable = true}, SHIFT(553),
  [1131] = {.count = 1, .reusable = false}, SHIFT(554),
  [1133] = {.count = 1, .reusable = true}, SHIFT(554),
  [1135] = {.count = 1, .reusable = false}, SHIFT(564),
  [1137] = {.count = 1, .reusable = true}, SHIFT(564),
  [1139] = {.count = 1, .reusable = true}, SHIFT(568),
  [1141] = {.count = 1, .reusable = false}, SHIFT(570),
  [1143] = {.count = 1, .reusable = false}, SHIFT(571),
  [1145] = {.count = 1, .reusable = true}, SHIFT(573),
  [1147] = {.count = 1, .reusable = true}, SHIFT(574),
  [1149] = {.count = 1, .reusable = false}, SHIFT(575),
  [1151] = {.count = 1, .reusable = true}, SHIFT(575),
  [1153] = {.count = 1, .reusable = true}, SHIFT(576),
  [1155] = {.count = 1, .reusable = true}, SHIFT(577),
  [1157] = {.count = 1, .reusable = true}, SHIFT(578),
  [1159] = {.count = 1, .reusable = false}, SHIFT(579),
  [1161] = {.count = 1, .reusable = true}, SHIFT(579),
  [1163] = {.count = 1, .reusable = false}, SHIFT(589),
  [1165] = {.count = 1, .reusable = true}, SHIFT(589),
  [1167] = {.count = 1, .reusable = true}, SHIFT(590),
  [1169] = {.count = 1, .reusable = true}, SHIFT(591),
  [1171] = {.count = 1, .reusable = false}, SHIFT(590),
  [1173] = {.count = 1, .reusable = true}, SHIFT(592),
  [1175] = {.count = 1, .reusable = true}, SHIFT(593),
  [1177] = {.count = 1, .reusable = true}, SHIFT(594),
  [1179] = {.count = 1, .reusable = false}, SHIFT(595),
  [1181] = {.count = 1, .reusable = true}, SHIFT(596),
  [1183] = {.count = 1, .reusable = true}, SHIFT(597),
  [1185] = {.count = 1, .reusable = true}, SHIFT(598),
  [1187] = {.count = 1, .reusable = true}, SHIFT(599),
  [1189] = {.count = 1, .reusable = true}, SHIFT(600),
  [1191] = {.count = 1, .reusable = true}, SHIFT(605),
  [1193] = {.count = 1, .reusable = false}, SHIFT(607),
  [1195] = {.count = 1, .reusable = false}, SHIFT(608),
  [1197] = {.count = 1, .reusable = true}, SHIFT(610),
  [1199] = {.count = 1, .reusable = true}, SHIFT(611),
  [1201] = {.count = 1, .reusable = false}, SHIFT(612),
  [1203] = {.count = 1, .reusable = true}, SHIFT(612),
  [1205] = {.count = 1, .reusable = true}, SHIFT(613),
  [1207] = {.count = 1, .reusable = true}, SHIFT(614),
  [1209] = {.count = 1, .reusable = true}, SHIFT(615),
  [1211] = {.count = 1, .reusable = false}, SHIFT(616),
  [1213] = {.count = 1, .reusable = true}, SHIFT(616),
  [1215] = {.count = 1, .reusable = true}, SHIFT(626),
  [1217] = {.count = 1, .reusable = true}, SHIFT(627),
  [1219] = {.count = 1, .reusable = true}, SHIFT(628),
  [1221] = {.count = 1, .reusable = false}, SHIFT(627),
  [1223] = {.count = 1, .reusable = true}, SHIFT(629),
  [1225] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2),
  [1227] = {.count = 1, .reusable = true}, SHIFT(630),
  [1229] = {.count = 1, .reusable = false}, SHIFT(632),
  [1231] = {.count = 1, .reusable = false}, SHIFT(633),
  [1233] = {.count = 1, .reusable = true}, SHIFT(634),
  [1235] = {.count = 1, .reusable = true}, SHIFT(635),
  [1237] = {.count = 1, .reusable = true}, SHIFT(636),
  [1239] = {.count = 1, .reusable = false}, SHIFT(637),
  [1241] = {.count = 1, .reusable = true}, SHIFT(637),
  [1243] = {.count = 1, .reusable = true}, SHIFT(638),
  [1245] = {.count = 1, .reusable = false}, SHIFT(640),
  [1247] = {.count = 1, .reusable = true}, SHIFT(640),
  [1249] = {.count = 1, .reusable = true}, SHIFT(639),
  [1251] = {.count = 1, .reusable = true}, SHIFT(641),
  [1253] = {.count = 1, .reusable = false}, SHIFT(643),
  [1255] = {.count = 1, .reusable = true}, SHIFT(643),
  [1257] = {.count = 1, .reusable = true}, SHIFT(642),
  [1259] = {.count = 1, .reusable = false}, SHIFT(644),
  [1261] = {.count = 1, .reusable = true}, SHIFT(645),
  [1263] = {.count = 1, .reusable = true}, SHIFT(644),
  [1265] = {.count = 1, .reusable = false}, SHIFT(649),
  [1267] = {.count = 1, .reusable = true}, SHIFT(649),
  [1269] = {.count = 1, .reusable = false}, SHIFT(653),
  [1271] = {.count = 1, .reusable = true}, SHIFT(654),
  [1273] = {.count = 1, .reusable = true}, SHIFT(653),
  [1275] = {.count = 1, .reusable = true}, REDUCE(sym_test_command, 3),
  [1277] = {.count = 1, .reusable = false}, REDUCE(sym_test_command, 3),
  [1279] = {.count = 1, .reusable = true}, SHIFT(659),
  [1281] = {.count = 1, .reusable = true}, REDUCE(sym_postfix_expression, 2),
  [1283] = {.count = 1, .reusable = false}, REDUCE(sym_postfix_expression, 2),
  [1285] = {.count = 1, .reusable = true}, SHIFT(660),
  [1287] = {.count = 1, .reusable = true}, SHIFT(661),
  [1289] = {.count = 1, .reusable = true}, SHIFT(662),
  [1291] = {.count = 1, .reusable = false}, SHIFT(664),
  [1293] = {.count = 1, .reusable = false}, SHIFT(666),
  [1295] = {.count = 1, .reusable = false}, SHIFT(668),
  [1297] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3),
  [1299] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3),
  [1301] = {.count = 1, .reusable = false}, SHIFT(670),
  [1303] = {.count = 1, .reusable = true}, SHIFT(670),
  [1305] = {.count = 1, .reusable = true}, SHIFT(675),
  [1307] = {.count = 1, .reusable = true}, SHIFT(676),
  [1309] = {.count = 1, .reusable = true}, SHIFT(677),
  [1311] = {.count = 1, .reusable = true}, SHIFT(678),
  [1313] = {.count = 1, .reusable = false}, SHIFT(679),
  [1315] = {.count = 1, .reusable = true}, SHIFT(679),
  [1317] = {.count = 1, .reusable = true}, SHIFT(681),
  [1319] = {.count = 1, .reusable = true}, SHIFT(682),
  [1321] = {.count = 1, .reusable = false}, SHIFT(685),
  [1323] = {.count = 1, .reusable = false}, SHIFT(686),
  [1325] = {.count = 1, .reusable = false}, SHIFT(687),
  [1327] = {.count = 1, .reusable = true}, SHIFT(691),
  [1329] = {.count = 1, .reusable = false}, SHIFT(692),
  [1331] = {.count = 1, .reusable = true}, SHIFT(692),
  [1333] = {.count = 1, .reusable = true}, SHIFT(693),
  [1335] = {.count = 1, .reusable = false}, SHIFT(695),
  [1337] = {.count = 1, .reusable = false}, SHIFT(696),
  [1339] = {.count = 1, .reusable = false}, SHIFT(697),
  [1341] = {.count = 1, .reusable = true}, SHIFT(697),
  [1343] = {.count = 1, .reusable = true}, SHIFT(698),
  [1345] = {.count = 1, .reusable = true}, SHIFT(699),
  [1347] = {.count = 1, .reusable = true}, SHIFT(700),
  [1349] = {.count = 1, .reusable = true}, SHIFT(701),
  [1351] = {.count = 1, .reusable = false}, SHIFT(702),
  [1353] = {.count = 1, .reusable = true}, SHIFT(702),
  [1355] = {.count = 1, .reusable = true}, SHIFT(703),
  [1357] = {.count = 1, .reusable = false}, SHIFT(705),
  [1359] = {.count = 1, .reusable = true}, SHIFT(705),
  [1361] = {.count = 1, .reusable = true}, SHIFT(704),
  [1363] = {.count = 1, .reusable = true}, SHIFT(706),
  [1365] = {.count = 1, .reusable = false}, SHIFT(708),
  [1367] = {.count = 1, .reusable = true}, SHIFT(708),
  [1369] = {.count = 1, .reusable = true}, SHIFT(707),
  [1371] = {.count = 1, .reusable = false}, SHIFT(709),
  [1373] = {.count = 1, .reusable = true}, SHIFT(710),
  [1375] = {.count = 1, .reusable = true}, SHIFT(709),
  [1377] = {.count = 1, .reusable = false}, SHIFT(714),
  [1379] = {.count = 1, .reusable = true}, SHIFT(714),
  [1381] = {.count = 1, .reusable = false}, SHIFT(718),
  [1383] = {.count = 1, .reusable = true}, SHIFT(719),
  [1385] = {.count = 1, .reusable = true}, SHIFT(718),
  [1387] = {.count = 1, .reusable = true}, SHIFT(723),
  [1389] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 3),
  [1391] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 3),
  [1393] = {.count = 1, .reusable = true}, SHIFT(724),
  [1395] = {.count = 1, .reusable = true}, SHIFT(725),
  [1397] = {.count = 1, .reusable = true}, SHIFT(726),
  [1399] = {.count = 1, .reusable = false}, SHIFT(728),
  [1401] = {.count = 1, .reusable = false}, SHIFT(730),
  [1403] = {.count = 1, .reusable = false}, SHIFT(732),
  [1405] = {.count = 1, .reusable = true}, SHIFT(732),
  [1407] = {.count = 1, .reusable = true}, SHIFT(733),
  [1409] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 3),
  [1411] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 3),
  [1413] = {.count = 1, .reusable = true}, SHIFT(738),
  [1415] = {.count = 1, .reusable = true}, SHIFT(739),
  [1417] = {.count = 1, .reusable = true}, SHIFT(740),
  [1419] = {.count = 1, .reusable = true}, SHIFT(741),
  [1421] = {.count = 1, .reusable = false}, SHIFT(742),
  [1423] = {.count = 1, .reusable = true}, SHIFT(742),
  [1425] = {.count = 1, .reusable = true}, SHIFT(744),
  [1427] = {.count = 1, .reusable = true}, SHIFT(745),
  [1429] = {.count = 1, .reusable = false}, SHIFT(747),
  [1431] = {.count = 1, .reusable = true}, SHIFT(747),
  [1433] = {.count = 1, .reusable = false}, SHIFT(750),
  [1435] = {.count = 1, .reusable = true}, SHIFT(750),
  [1437] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 3),
  [1439] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 3),
  [1441] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2),
  [1443] = {.count = 1, .reusable = true}, SHIFT(751),
  [1445] = {.count = 1, .reusable = true}, SHIFT(752),
  [1447] = {.count = 1, .reusable = true}, SHIFT(753),
  [1449] = {.count = 1, .reusable = true}, SHIFT(754),
  [1451] = {.count = 1, .reusable = true}, SHIFT(755),
  [1453] = {.count = 1, .reusable = true}, SHIFT(756),
  [1455] = {.count = 1, .reusable = false}, SHIFT(758),
  [1457] = {.count = 1, .reusable = false}, SHIFT(759),
  [1459] = {.count = 1, .reusable = true}, SHIFT(760),
  [1461] = {.count = 1, .reusable = true}, SHIFT(761),
  [1463] = {.count = 1, .reusable = true}, SHIFT(762),
  [1465] = {.count = 1, .reusable = false}, SHIFT(763),
  [1467] = {.count = 1, .reusable = true}, SHIFT(763),
  [1469] = {.count = 1, .reusable = true}, SHIFT(764),
  [1471] = {.count = 1, .reusable = false}, SHIFT(766),
  [1473] = {.count = 1, .reusable = true}, SHIFT(766),
  [1475] = {.count = 1, .reusable = true}, SHIFT(765),
  [1477] = {.count = 1, .reusable = true}, SHIFT(767),
  [1479] = {.count = 1, .reusable = false}, SHIFT(769),
  [1481] = {.count = 1, .reusable = true}, SHIFT(769),
  [1483] = {.count = 1, .reusable = true}, SHIFT(768),
  [1485] = {.count = 1, .reusable = false}, SHIFT(770),
  [1487] = {.count = 1, .reusable = true}, SHIFT(771),
  [1489] = {.count = 1, .reusable = true}, SHIFT(770),
  [1491] = {.count = 1, .reusable = false}, SHIFT(775),
  [1493] = {.count = 1, .reusable = true}, SHIFT(775),
  [1495] = {.count = 1, .reusable = false}, SHIFT(779),
  [1497] = {.count = 1, .reusable = true}, SHIFT(780),
  [1499] = {.count = 1, .reusable = true}, SHIFT(779),
  [1501] = {.count = 1, .reusable = true}, SHIFT(785),
  [1503] = {.count = 1, .reusable = true}, SHIFT(787),
  [1505] = {.count = 1, .reusable = true}, SHIFT(788),
  [1507] = {.count = 1, .reusable = true}, SHIFT(789),
  [1509] = {.count = 1, .reusable = true}, SHIFT(790),
  [1511] = {.count = 1, .reusable = true}, SHIFT(791),
  [1513] = {.count = 1, .reusable = false}, SHIFT(793),
  [1515] = {.count = 1, .reusable = false}, SHIFT(794),
  [1517] = {.count = 1, .reusable = true}, SHIFT(795),
  [1519] = {.count = 1, .reusable = true}, SHIFT(796),
  [1521] = {.count = 1, .reusable = true}, SHIFT(797),
  [1523] = {.count = 1, .reusable = false}, SHIFT(798),
  [1525] = {.count = 1, .reusable = true}, SHIFT(798),
  [1527] = {.count = 1, .reusable = true}, SHIFT(799),
  [1529] = {.count = 1, .reusable = false}, SHIFT(801),
  [1531] = {.count = 1, .reusable = true}, SHIFT(801),
  [1533] = {.count = 1, .reusable = true}, SHIFT(800),
  [1535] = {.count = 1, .reusable = true}, SHIFT(802),
  [1537] = {.count = 1, .reusable = false}, SHIFT(804),
  [1539] = {.count = 1, .reusable = true}, SHIFT(804),
  [1541] = {.count = 1, .reusable = true}, SHIFT(803),
  [1543] = {.count = 1, .reusable = false}, SHIFT(805),
  [1545] = {.count = 1, .reusable = true}, SHIFT(806),
  [1547] = {.count = 1, .reusable = true}, SHIFT(805),
  [1549] = {.count = 1, .reusable = false}, SHIFT(810),
  [1551] = {.count = 1, .reusable = true}, SHIFT(810),
  [1553] = {.count = 1, .reusable = false}, SHIFT(814),
  [1555] = {.count = 1, .reusable = true}, SHIFT(815),
  [1557] = {.count = 1, .reusable = true}, SHIFT(814),
  [1559] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1561] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(110),
  [1564] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1566] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(111),
  [1569] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(112),
  [1572] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(113),
  [1575] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(114),
  [1578] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(115),
  [1581] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(116),
  [1584] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(117),
  [1587] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(118),
  [1590] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(393),
  [1593] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(114),
  [1596] = {.count = 1, .reusable = true}, SHIFT(819),
  [1598] = {.count = 1, .reusable = false}, SHIFT(821),
  [1600] = {.count = 1, .reusable = false}, SHIFT(822),
  [1602] = {.count = 1, .reusable = true}, SHIFT(823),
  [1604] = {.count = 1, .reusable = true}, SHIFT(824),
  [1606] = {.count = 1, .reusable = true}, SHIFT(825),
  [1608] = {.count = 1, .reusable = false}, SHIFT(826),
  [1610] = {.count = 1, .reusable = true}, SHIFT(826),
  [1612] = {.count = 1, .reusable = true}, SHIFT(827),
  [1614] = {.count = 1, .reusable = false}, SHIFT(829),
  [1616] = {.count = 1, .reusable = true}, SHIFT(829),
  [1618] = {.count = 1, .reusable = true}, SHIFT(828),
  [1620] = {.count = 1, .reusable = true}, SHIFT(830),
  [1622] = {.count = 1, .reusable = false}, SHIFT(832),
  [1624] = {.count = 1, .reusable = true}, SHIFT(832),
  [1626] = {.count = 1, .reusable = true}, SHIFT(831),
  [1628] = {.count = 1, .reusable = false}, SHIFT(833),
  [1630] = {.count = 1, .reusable = true}, SHIFT(834),
  [1632] = {.count = 1, .reusable = true}, SHIFT(833),
  [1634] = {.count = 1, .reusable = false}, SHIFT(838),
  [1636] = {.count = 1, .reusable = true}, SHIFT(838),
  [1638] = {.count = 1, .reusable = false}, SHIFT(842),
  [1640] = {.count = 1, .reusable = true}, SHIFT(843),
  [1642] = {.count = 1, .reusable = true}, SHIFT(842),
  [1644] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [1646] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [1648] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(121),
  [1651] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(122),
  [1654] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(123),
  [1657] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(124),
  [1660] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(125),
  [1663] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(126),
  [1666] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(127),
  [1669] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(128),
  [1672] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(415),
  [1675] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(124),
  [1678] = {.count = 1, .reusable = true}, SHIFT(847),
  [1680] = {.count = 1, .reusable = false}, SHIFT(849),
  [1682] = {.count = 1, .reusable = false}, SHIFT(850),
  [1684] = {.count = 1, .reusable = true}, SHIFT(851),
  [1686] = {.count = 1, .reusable = true}, SHIFT(852),
  [1688] = {.count = 1, .reusable = true}, SHIFT(853),
  [1690] = {.count = 1, .reusable = false}, SHIFT(854),
  [1692] = {.count = 1, .reusable = true}, SHIFT(854),
  [1694] = {.count = 1, .reusable = true}, SHIFT(855),
  [1696] = {.count = 1, .reusable = false}, SHIFT(857),
  [1698] = {.count = 1, .reusable = true}, SHIFT(857),
  [1700] = {.count = 1, .reusable = true}, SHIFT(856),
  [1702] = {.count = 1, .reusable = true}, SHIFT(858),
  [1704] = {.count = 1, .reusable = false}, SHIFT(860),
  [1706] = {.count = 1, .reusable = true}, SHIFT(860),
  [1708] = {.count = 1, .reusable = true}, SHIFT(859),
  [1710] = {.count = 1, .reusable = false}, SHIFT(861),
  [1712] = {.count = 1, .reusable = true}, SHIFT(862),
  [1714] = {.count = 1, .reusable = true}, SHIFT(861),
  [1716] = {.count = 1, .reusable = false}, SHIFT(866),
  [1718] = {.count = 1, .reusable = true}, SHIFT(866),
  [1720] = {.count = 1, .reusable = false}, SHIFT(870),
  [1722] = {.count = 1, .reusable = true}, SHIFT(871),
  [1724] = {.count = 1, .reusable = true}, SHIFT(870),
  [1726] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1728] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1730] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(139),
  [1733] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [1735] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [1737] = {.count = 1, .reusable = true}, SHIFT(875),
  [1739] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [1741] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2),
  [1743] = {.count = 1, .reusable = true}, SHIFT(876),
  [1745] = {.count = 1, .reusable = true}, SHIFT(877),
  [1747] = {.count = 1, .reusable = true}, SHIFT(878),
  [1749] = {.count = 1, .reusable = false}, SHIFT(879),
  [1751] = {.count = 1, .reusable = true}, SHIFT(879),
  [1753] = {.count = 1, .reusable = true}, SHIFT(880),
  [1755] = {.count = 1, .reusable = false}, SHIFT(882),
  [1757] = {.count = 1, .reusable = true}, SHIFT(882),
  [1759] = {.count = 1, .reusable = true}, SHIFT(881),
  [1761] = {.count = 1, .reusable = true}, SHIFT(883),
  [1763] = {.count = 1, .reusable = false}, SHIFT(885),
  [1765] = {.count = 1, .reusable = true}, SHIFT(885),
  [1767] = {.count = 1, .reusable = true}, SHIFT(884),
  [1769] = {.count = 1, .reusable = false}, SHIFT(886),
  [1771] = {.count = 1, .reusable = true}, SHIFT(887),
  [1773] = {.count = 1, .reusable = true}, SHIFT(886),
  [1775] = {.count = 1, .reusable = false}, SHIFT(891),
  [1777] = {.count = 1, .reusable = true}, SHIFT(891),
  [1779] = {.count = 1, .reusable = false}, SHIFT(895),
  [1781] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(896),
  [1784] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(143),
  [1787] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(144),
  [1790] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(145),
  [1793] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(146),
  [1796] = {.count = 1, .reusable = true}, SHIFT(897),
  [1798] = {.count = 1, .reusable = true}, SHIFT(898),
  [1800] = {.count = 1, .reusable = true}, SHIFT(900),
  [1802] = {.count = 1, .reusable = false}, SHIFT(901),
  [1804] = {.count = 1, .reusable = true}, SHIFT(902),
  [1806] = {.count = 1, .reusable = false}, SHIFT(903),
  [1808] = {.count = 1, .reusable = true}, SHIFT(904),
  [1810] = {.count = 1, .reusable = true}, SHIFT(905),
  [1812] = {.count = 1, .reusable = true}, SHIFT(906),
  [1814] = {.count = 1, .reusable = true}, SHIFT(907),
  [1816] = {.count = 1, .reusable = true}, SHIFT(908),
  [1818] = {.count = 1, .reusable = true}, SHIFT(910),
  [1820] = {.count = 1, .reusable = true}, SHIFT(911),
  [1822] = {.count = 1, .reusable = false}, SHIFT(913),
  [1824] = {.count = 1, .reusable = true}, SHIFT(913),
  [1826] = {.count = 1, .reusable = true}, SHIFT(912),
  [1828] = {.count = 1, .reusable = false}, SHIFT(915),
  [1830] = {.count = 1, .reusable = true}, SHIFT(915),
  [1832] = {.count = 1, .reusable = true}, SHIFT(914),
  [1834] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 3),
  [1836] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 3),
  [1838] = {.count = 1, .reusable = true}, SHIFT(916),
  [1840] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1842] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1844] = {.count = 1, .reusable = false}, SHIFT(918),
  [1846] = {.count = 1, .reusable = false}, SHIFT(919),
  [1848] = {.count = 1, .reusable = true}, SHIFT(921),
  [1850] = {.count = 1, .reusable = true}, SHIFT(922),
  [1852] = {.count = 1, .reusable = false}, SHIFT(923),
  [1854] = {.count = 1, .reusable = true}, SHIFT(923),
  [1856] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1858] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1860] = {.count = 1, .reusable = true}, SHIFT(924),
  [1862] = {.count = 1, .reusable = true}, SHIFT(925),
  [1864] = {.count = 1, .reusable = true}, SHIFT(926),
  [1866] = {.count = 1, .reusable = false}, SHIFT(927),
  [1868] = {.count = 1, .reusable = true}, SHIFT(927),
  [1870] = {.count = 1, .reusable = true}, SHIFT(928),
  [1872] = {.count = 1, .reusable = true}, SHIFT(929),
  [1874] = {.count = 1, .reusable = false}, SHIFT(930),
  [1876] = {.count = 1, .reusable = true}, SHIFT(930),
  [1878] = {.count = 1, .reusable = false}, SHIFT(940),
  [1880] = {.count = 1, .reusable = true}, SHIFT(940),
  [1882] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3),
  [1884] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3),
  [1886] = {.count = 1, .reusable = true}, SHIFT(941),
  [1888] = {.count = 1, .reusable = true}, SHIFT(942),
  [1890] = {.count = 1, .reusable = true}, REDUCE(sym_command_substitution, 3),
  [1892] = {.count = 1, .reusable = false}, REDUCE(sym_command_substitution, 3),
  [1894] = {.count = 1, .reusable = false}, SHIFT(943),
  [1896] = {.count = 1, .reusable = true}, SHIFT(943),
  [1898] = {.count = 1, .reusable = false}, SHIFT(944),
  [1900] = {.count = 1, .reusable = true}, SHIFT(944),
  [1902] = {.count = 1, .reusable = false}, SHIFT(946),
  [1904] = {.count = 1, .reusable = true}, SHIFT(946),
  [1906] = {.count = 1, .reusable = true}, SHIFT(951),
  [1908] = {.count = 1, .reusable = true}, SHIFT(952),
  [1910] = {.count = 1, .reusable = true}, SHIFT(953),
  [1912] = {.count = 1, .reusable = true}, SHIFT(954),
  [1914] = {.count = 1, .reusable = false}, SHIFT(955),
  [1916] = {.count = 1, .reusable = true}, SHIFT(955),
  [1918] = {.count = 1, .reusable = false}, SHIFT(957),
  [1920] = {.count = 1, .reusable = true}, SHIFT(957),
  [1922] = {.count = 1, .reusable = true}, SHIFT(960),
  [1924] = {.count = 1, .reusable = true}, REDUCE(sym_process_substitution, 3),
  [1926] = {.count = 1, .reusable = false}, REDUCE(sym_process_substitution, 3),
  [1928] = {.count = 1, .reusable = false}, SHIFT(961),
  [1930] = {.count = 1, .reusable = true}, SHIFT(961),
  [1932] = {.count = 1, .reusable = false}, SHIFT(962),
  [1934] = {.count = 1, .reusable = true}, SHIFT(962),
  [1936] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 2),
  [1938] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 2),
  [1940] = {.count = 1, .reusable = true}, SHIFT(965),
  [1942] = {.count = 1, .reusable = false}, SHIFT(966),
  [1944] = {.count = 1, .reusable = true}, SHIFT(966),
  [1946] = {.count = 1, .reusable = true}, SHIFT(967),
  [1948] = {.count = 1, .reusable = true}, SHIFT(968),
  [1950] = {.count = 1, .reusable = true}, SHIFT(969),
  [1952] = {.count = 1, .reusable = false}, SHIFT(970),
  [1954] = {.count = 1, .reusable = true}, SHIFT(970),
  [1956] = {.count = 1, .reusable = true}, SHIFT(972),
  [1958] = {.count = 1, .reusable = true}, SHIFT(971),
  [1960] = {.count = 1, .reusable = true}, SHIFT(973),
  [1962] = {.count = 1, .reusable = true}, SHIFT(974),
  [1964] = {.count = 1, .reusable = true}, REDUCE(sym_pipeline, 3),
  [1966] = {.count = 1, .reusable = false}, REDUCE(sym_pipeline, 3),
  [1968] = {.count = 1, .reusable = true}, REDUCE(sym_list, 3),
  [1970] = {.count = 1, .reusable = false}, REDUCE(sym_list, 3),
  [1972] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_redirect, 2),
  [1974] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_redirect, 2),
  [1976] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 2),
  [1978] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 2),
  [1980] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2),
  [1982] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2),
  [1984] = {.count = 1, .reusable = true}, REDUCE(sym__terminated_statement, 3),
  [1986] = {.count = 1, .reusable = true}, REDUCE(sym_program, 3),
  [1988] = {.count = 1, .reusable = false}, REDUCE(sym__terminated_statement, 3),
  [1990] = {.count = 1, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2),
  [1992] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(172),
  [1995] = {.count = 1, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2),
  [1997] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(176),
  [2000] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(176),
  [2003] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(177),
  [2006] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(177),
  [2009] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(178),
  [2012] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2),
  [2014] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2),
  [2016] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 2),
  [2018] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 2),
  [2020] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(181),
  [2023] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(182),
  [2026] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(19),
  [2029] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(20),
  [2032] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(183),
  [2035] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(22),
  [2038] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(23),
  [2041] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(24),
  [2044] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(25),
  [2047] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(183),
  [2050] = {.count = 1, .reusable = false}, SHIFT(977),
  [2052] = {.count = 1, .reusable = true}, SHIFT(977),
  [2054] = {.count = 1, .reusable = false}, SHIFT(978),
  [2056] = {.count = 1, .reusable = true}, SHIFT(978),
  [2058] = {.count = 1, .reusable = true}, REDUCE(sym_command, 3),
  [2060] = {.count = 1, .reusable = false}, REDUCE(sym_command, 3),
  [2062] = {.count = 1, .reusable = true}, SHIFT(980),
  [2064] = {.count = 1, .reusable = false}, SHIFT(756),
  [2066] = {.count = 1, .reusable = true}, SHIFT(981),
  [2068] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4, .alias_sequence_id = 4),
  [2070] = {.count = 1, .reusable = true}, SHIFT(983),
  [2072] = {.count = 1, .reusable = true}, SHIFT(984),
  [2074] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4),
  [2076] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [2078] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [2080] = {.count = 1, .reusable = true}, SHIFT(985),
  [2082] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2084] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2086] = {.count = 1, .reusable = false}, SHIFT(987),
  [2088] = {.count = 1, .reusable = false}, SHIFT(988),
  [2090] = {.count = 1, .reusable = true}, SHIFT(990),
  [2092] = {.count = 1, .reusable = true}, SHIFT(991),
  [2094] = {.count = 1, .reusable = false}, SHIFT(992),
  [2096] = {.count = 1, .reusable = true}, SHIFT(992),
  [2098] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2100] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2102] = {.count = 1, .reusable = true}, SHIFT(993),
  [2104] = {.count = 1, .reusable = true}, SHIFT(994),
  [2106] = {.count = 1, .reusable = true}, SHIFT(995),
  [2108] = {.count = 1, .reusable = false}, SHIFT(996),
  [2110] = {.count = 1, .reusable = true}, SHIFT(996),
  [2112] = {.count = 1, .reusable = true}, SHIFT(1006),
  [2114] = {.count = 1, .reusable = true}, SHIFT(1008),
  [2116] = {.count = 1, .reusable = false}, SHIFT(1010),
  [2118] = {.count = 1, .reusable = false}, SHIFT(1011),
  [2120] = {.count = 1, .reusable = true}, SHIFT(1012),
  [2122] = {.count = 1, .reusable = true}, SHIFT(1013),
  [2124] = {.count = 1, .reusable = true}, SHIFT(1014),
  [2126] = {.count = 1, .reusable = false}, SHIFT(1015),
  [2128] = {.count = 1, .reusable = true}, SHIFT(1015),
  [2130] = {.count = 1, .reusable = true}, SHIFT(1016),
  [2132] = {.count = 1, .reusable = false}, SHIFT(1018),
  [2134] = {.count = 1, .reusable = true}, SHIFT(1018),
  [2136] = {.count = 1, .reusable = true}, SHIFT(1017),
  [2138] = {.count = 1, .reusable = true}, SHIFT(1019),
  [2140] = {.count = 1, .reusable = false}, SHIFT(1021),
  [2142] = {.count = 1, .reusable = true}, SHIFT(1021),
  [2144] = {.count = 1, .reusable = true}, SHIFT(1020),
  [2146] = {.count = 1, .reusable = false}, SHIFT(1022),
  [2148] = {.count = 1, .reusable = true}, SHIFT(1023),
  [2150] = {.count = 1, .reusable = true}, SHIFT(1022),
  [2152] = {.count = 1, .reusable = false}, SHIFT(1027),
  [2154] = {.count = 1, .reusable = true}, SHIFT(1027),
  [2156] = {.count = 1, .reusable = false}, SHIFT(1031),
  [2158] = {.count = 1, .reusable = true}, SHIFT(1032),
  [2160] = {.count = 1, .reusable = true}, SHIFT(1031),
  [2162] = {.count = 1, .reusable = true}, SHIFT(1036),
  [2164] = {.count = 1, .reusable = false}, SHIFT(1038),
  [2166] = {.count = 1, .reusable = true}, SHIFT(1038),
  [2168] = {.count = 1, .reusable = true}, SHIFT(1039),
  [2170] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2),
  [2172] = {.count = 1, .reusable = true}, SHIFT(1040),
  [2174] = {.count = 1, .reusable = false}, SHIFT(1042),
  [2176] = {.count = 1, .reusable = false}, SHIFT(1043),
  [2178] = {.count = 1, .reusable = true}, SHIFT(1044),
  [2180] = {.count = 1, .reusable = true}, SHIFT(1045),
  [2182] = {.count = 1, .reusable = true}, SHIFT(1046),
  [2184] = {.count = 1, .reusable = false}, SHIFT(1047),
  [2186] = {.count = 1, .reusable = true}, SHIFT(1047),
  [2188] = {.count = 1, .reusable = true}, SHIFT(1048),
  [2190] = {.count = 1, .reusable = false}, SHIFT(1050),
  [2192] = {.count = 1, .reusable = true}, SHIFT(1050),
  [2194] = {.count = 1, .reusable = true}, SHIFT(1049),
  [2196] = {.count = 1, .reusable = true}, SHIFT(1051),
  [2198] = {.count = 1, .reusable = false}, SHIFT(1053),
  [2200] = {.count = 1, .reusable = true}, SHIFT(1053),
  [2202] = {.count = 1, .reusable = true}, SHIFT(1052),
  [2204] = {.count = 1, .reusable = false}, SHIFT(1054),
  [2206] = {.count = 1, .reusable = true}, SHIFT(1055),
  [2208] = {.count = 1, .reusable = true}, SHIFT(1054),
  [2210] = {.count = 1, .reusable = false}, SHIFT(1059),
  [2212] = {.count = 1, .reusable = true}, SHIFT(1059),
  [2214] = {.count = 1, .reusable = false}, SHIFT(1063),
  [2216] = {.count = 1, .reusable = true}, SHIFT(1064),
  [2218] = {.count = 1, .reusable = true}, SHIFT(1063),
  [2220] = {.count = 1, .reusable = true}, SHIFT(1070),
  [2222] = {.count = 1, .reusable = true}, SHIFT(1071),
  [2224] = {.count = 1, .reusable = false}, SHIFT(1073),
  [2226] = {.count = 1, .reusable = false}, SHIFT(1074),
  [2228] = {.count = 1, .reusable = true}, SHIFT(1076),
  [2230] = {.count = 1, .reusable = true}, SHIFT(1077),
  [2232] = {.count = 1, .reusable = false}, SHIFT(1078),
  [2234] = {.count = 1, .reusable = true}, SHIFT(1078),
  [2236] = {.count = 1, .reusable = true}, SHIFT(1079),
  [2238] = {.count = 1, .reusable = true}, SHIFT(1080),
  [2240] = {.count = 1, .reusable = true}, SHIFT(1081),
  [2242] = {.count = 1, .reusable = false}, SHIFT(1082),
  [2244] = {.count = 1, .reusable = true}, SHIFT(1082),
  [2246] = {.count = 1, .reusable = false}, SHIFT(1092),
  [2248] = {.count = 1, .reusable = true}, SHIFT(1092),
  [2250] = {.count = 1, .reusable = false}, SHIFT(596),
  [2252] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 4),
  [2254] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 4),
  [2256] = {.count = 1, .reusable = true}, SHIFT(1094),
  [2258] = {.count = 1, .reusable = true}, SHIFT(1095),
  [2260] = {.count = 1, .reusable = false}, SHIFT(1097),
  [2262] = {.count = 1, .reusable = false}, SHIFT(1098),
  [2264] = {.count = 1, .reusable = true}, SHIFT(1099),
  [2266] = {.count = 1, .reusable = true}, SHIFT(1100),
  [2268] = {.count = 1, .reusable = true}, SHIFT(1101),
  [2270] = {.count = 1, .reusable = false}, SHIFT(1102),
  [2272] = {.count = 1, .reusable = true}, SHIFT(1102),
  [2274] = {.count = 1, .reusable = true}, SHIFT(1103),
  [2276] = {.count = 1, .reusable = false}, SHIFT(1105),
  [2278] = {.count = 1, .reusable = true}, SHIFT(1105),
  [2280] = {.count = 1, .reusable = true}, SHIFT(1104),
  [2282] = {.count = 1, .reusable = true}, SHIFT(1106),
  [2284] = {.count = 1, .reusable = false}, SHIFT(1108),
  [2286] = {.count = 1, .reusable = true}, SHIFT(1108),
  [2288] = {.count = 1, .reusable = true}, SHIFT(1107),
  [2290] = {.count = 1, .reusable = false}, SHIFT(1109),
  [2292] = {.count = 1, .reusable = true}, SHIFT(1110),
  [2294] = {.count = 1, .reusable = true}, SHIFT(1109),
  [2296] = {.count = 1, .reusable = false}, SHIFT(1114),
  [2298] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2300] = {.count = 1, .reusable = false}, SHIFT(1118),
  [2302] = {.count = 1, .reusable = true}, SHIFT(1119),
  [2304] = {.count = 1, .reusable = true}, SHIFT(1118),
  [2306] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [2308] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [2310] = {.count = 1, .reusable = true}, SHIFT(1124),
  [2312] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(232),
  [2315] = {.count = 1, .reusable = false}, SHIFT(1125),
  [2317] = {.count = 1, .reusable = true}, SHIFT(1126),
  [2319] = {.count = 1, .reusable = false}, SHIFT(1127),
  [2321] = {.count = 1, .reusable = true}, SHIFT(1128),
  [2323] = {.count = 1, .reusable = true}, SHIFT(1130),
  [2325] = {.count = 1, .reusable = true}, SHIFT(1131),
  [2327] = {.count = 1, .reusable = false}, SHIFT(1133),
  [2329] = {.count = 1, .reusable = true}, SHIFT(1133),
  [2331] = {.count = 1, .reusable = true}, SHIFT(1132),
  [2333] = {.count = 1, .reusable = false}, SHIFT(1135),
  [2335] = {.count = 1, .reusable = true}, SHIFT(1135),
  [2337] = {.count = 1, .reusable = true}, SHIFT(1134),
  [2339] = {.count = 1, .reusable = true}, SHIFT(1136),
  [2341] = {.count = 1, .reusable = true}, SHIFT(1137),
  [2343] = {.count = 1, .reusable = false}, SHIFT(1138),
  [2345] = {.count = 1, .reusable = true}, SHIFT(1138),
  [2347] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2349] = {.count = 1, .reusable = true}, SHIFT(1140),
  [2351] = {.count = 1, .reusable = false}, SHIFT(1141),
  [2353] = {.count = 1, .reusable = true}, SHIFT(1141),
  [2355] = {.count = 1, .reusable = false}, SHIFT(1142),
  [2357] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2359] = {.count = 1, .reusable = false}, SHIFT(1144),
  [2361] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2363] = {.count = 1, .reusable = false}, SHIFT(1145),
  [2365] = {.count = 1, .reusable = true}, SHIFT(1145),
  [2367] = {.count = 1, .reusable = true}, SHIFT(1147),
  [2369] = {.count = 1, .reusable = false}, SHIFT(1148),
  [2371] = {.count = 1, .reusable = true}, SHIFT(1148),
  [2373] = {.count = 1, .reusable = false}, SHIFT(1149),
  [2375] = {.count = 1, .reusable = true}, SHIFT(1149),
  [2377] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3),
  [2379] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3),
  [2381] = {.count = 1, .reusable = true}, SHIFT(1152),
  [2383] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2385] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(258),
  [2388] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(259),
  [2391] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(260),
  [2394] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(664),
  [2397] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(260),
  [2400] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(263),
  [2403] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(264),
  [2406] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(666),
  [2409] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(264),
  [2412] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 2),
  [2414] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 2),
  [2416] = {.count = 1, .reusable = false}, SHIFT(1156),
  [2418] = {.count = 1, .reusable = true}, SHIFT(1158),
  [2420] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2422] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(269),
  [2425] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(273),
  [2428] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(273),
  [2431] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(274),
  [2434] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(277),
  [2437] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(278),
  [2440] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(279),
  [2443] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(279),
  [2446] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 4),
  [2448] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 4),
  [2450] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 1),
  [2452] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2454] = {.count = 1, .reusable = false}, SHIFT(1163),
  [2456] = {.count = 1, .reusable = true}, SHIFT(686),
  [2458] = {.count = 1, .reusable = true}, SHIFT(687),
  [2460] = {.count = 1, .reusable = false}, SHIFT(1168),
  [2462] = {.count = 1, .reusable = true}, SHIFT(1169),
  [2464] = {.count = 1, .reusable = true}, SHIFT(1170),
  [2466] = {.count = 1, .reusable = false}, SHIFT(1170),
  [2468] = {.count = 1, .reusable = false}, SHIFT(1174),
  [2470] = {.count = 1, .reusable = true}, SHIFT(1174),
  [2472] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(283),
  [2475] = {.count = 1, .reusable = false}, SHIFT(1175),
  [2477] = {.count = 1, .reusable = false}, SHIFT(1176),
  [2479] = {.count = 1, .reusable = false}, SHIFT(1179),
  [2481] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2483] = {.count = 1, .reusable = true}, SHIFT(1180),
  [2485] = {.count = 1, .reusable = false}, SHIFT(1181),
  [2487] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2489] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2491] = {.count = 1, .reusable = true}, SHIFT(1185),
  [2493] = {.count = 1, .reusable = false}, SHIFT(1187),
  [2495] = {.count = 1, .reusable = true}, SHIFT(1187),
  [2497] = {.count = 1, .reusable = true}, SHIFT(1186),
  [2499] = {.count = 1, .reusable = false}, SHIFT(1189),
  [2501] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2503] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2505] = {.count = 1, .reusable = true}, SHIFT(1190),
  [2507] = {.count = 1, .reusable = true}, SHIFT(1191),
  [2509] = {.count = 1, .reusable = false}, SHIFT(1192),
  [2511] = {.count = 1, .reusable = true}, SHIFT(1192),
  [2513] = {.count = 1, .reusable = true}, SHIFT(1193),
  [2515] = {.count = 1, .reusable = true}, SHIFT(1194),
  [2517] = {.count = 1, .reusable = false}, SHIFT(1195),
  [2519] = {.count = 1, .reusable = true}, SHIFT(1195),
  [2521] = {.count = 1, .reusable = false}, SHIFT(1196),
  [2523] = {.count = 1, .reusable = true}, SHIFT(1196),
  [2525] = {.count = 1, .reusable = false}, SHIFT(1198),
  [2527] = {.count = 1, .reusable = true}, SHIFT(1198),
  [2529] = {.count = 1, .reusable = false}, SHIFT(1199),
  [2531] = {.count = 1, .reusable = true}, SHIFT(1199),
  [2533] = {.count = 1, .reusable = true}, SHIFT(1201),
  [2535] = {.count = 1, .reusable = false}, SHIFT(1202),
  [2537] = {.count = 1, .reusable = true}, SHIFT(1202),
  [2539] = {.count = 1, .reusable = false}, SHIFT(1203),
  [2541] = {.count = 1, .reusable = true}, SHIFT(1203),
  [2543] = {.count = 1, .reusable = true}, SHIFT(1207),
  [2545] = {.count = 1, .reusable = true}, SHIFT(1208),
  [2547] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(311),
  [2550] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(312),
  [2553] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(313),
  [2556] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(728),
  [2559] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(313),
  [2562] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(316),
  [2565] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(317),
  [2568] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(730),
  [2571] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(317),
  [2574] = {.count = 1, .reusable = true}, SHIFT(1211),
  [2576] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2578] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 4),
  [2580] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 4),
  [2582] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2584] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(320),
  [2587] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(325),
  [2590] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(325),
  [2593] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(326),
  [2596] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(329),
  [2599] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(330),
  [2602] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(331),
  [2605] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(331),
  [2608] = {.count = 1, .reusable = false}, SHIFT(1215),
  [2610] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2612] = {.count = 1, .reusable = true}, SHIFT(1216),
  [2614] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(343),
  [2617] = {.count = 1, .reusable = false}, SHIFT(1218),
  [2619] = {.count = 1, .reusable = true}, SHIFT(1219),
  [2621] = {.count = 1, .reusable = false}, SHIFT(1220),
  [2623] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2625] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2627] = {.count = 1, .reusable = true}, SHIFT(1224),
  [2629] = {.count = 1, .reusable = false}, SHIFT(1226),
  [2631] = {.count = 1, .reusable = true}, SHIFT(1226),
  [2633] = {.count = 1, .reusable = true}, SHIFT(1225),
  [2635] = {.count = 1, .reusable = false}, SHIFT(1228),
  [2637] = {.count = 1, .reusable = true}, SHIFT(1228),
  [2639] = {.count = 1, .reusable = true}, SHIFT(1227),
  [2641] = {.count = 1, .reusable = true}, SHIFT(1229),
  [2643] = {.count = 1, .reusable = true}, SHIFT(1230),
  [2645] = {.count = 1, .reusable = false}, SHIFT(1231),
  [2647] = {.count = 1, .reusable = true}, SHIFT(1231),
  [2649] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2651] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2653] = {.count = 1, .reusable = false}, SHIFT(1234),
  [2655] = {.count = 1, .reusable = true}, SHIFT(1234),
  [2657] = {.count = 1, .reusable = false}, SHIFT(1235),
  [2659] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2661] = {.count = 1, .reusable = false}, SHIFT(1237),
  [2663] = {.count = 1, .reusable = true}, SHIFT(1237),
  [2665] = {.count = 1, .reusable = false}, SHIFT(1238),
  [2667] = {.count = 1, .reusable = true}, SHIFT(1238),
  [2669] = {.count = 1, .reusable = true}, SHIFT(1240),
  [2671] = {.count = 1, .reusable = false}, SHIFT(1241),
  [2673] = {.count = 1, .reusable = true}, SHIFT(1241),
  [2675] = {.count = 1, .reusable = false}, SHIFT(1242),
  [2677] = {.count = 1, .reusable = true}, SHIFT(1242),
  [2679] = {.count = 1, .reusable = true}, SHIFT(1244),
  [2681] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(372),
  [2684] = {.count = 1, .reusable = false}, SHIFT(1246),
  [2686] = {.count = 1, .reusable = true}, SHIFT(1247),
  [2688] = {.count = 1, .reusable = false}, SHIFT(1248),
  [2690] = {.count = 1, .reusable = true}, SHIFT(1249),
  [2692] = {.count = 1, .reusable = true}, SHIFT(1251),
  [2694] = {.count = 1, .reusable = true}, SHIFT(1252),
  [2696] = {.count = 1, .reusable = false}, SHIFT(1254),
  [2698] = {.count = 1, .reusable = true}, SHIFT(1254),
  [2700] = {.count = 1, .reusable = true}, SHIFT(1253),
  [2702] = {.count = 1, .reusable = false}, SHIFT(1256),
  [2704] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2706] = {.count = 1, .reusable = true}, SHIFT(1255),
  [2708] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2710] = {.count = 1, .reusable = true}, SHIFT(1258),
  [2712] = {.count = 1, .reusable = false}, SHIFT(1259),
  [2714] = {.count = 1, .reusable = true}, SHIFT(1259),
  [2716] = {.count = 1, .reusable = true}, SHIFT(1260),
  [2718] = {.count = 1, .reusable = true}, SHIFT(1261),
  [2720] = {.count = 1, .reusable = false}, SHIFT(1262),
  [2722] = {.count = 1, .reusable = true}, SHIFT(1262),
  [2724] = {.count = 1, .reusable = false}, SHIFT(1263),
  [2726] = {.count = 1, .reusable = true}, SHIFT(1263),
  [2728] = {.count = 1, .reusable = false}, SHIFT(1265),
  [2730] = {.count = 1, .reusable = true}, SHIFT(1265),
  [2732] = {.count = 1, .reusable = false}, SHIFT(1266),
  [2734] = {.count = 1, .reusable = true}, SHIFT(1266),
  [2736] = {.count = 1, .reusable = true}, SHIFT(1268),
  [2738] = {.count = 1, .reusable = false}, SHIFT(1269),
  [2740] = {.count = 1, .reusable = true}, SHIFT(1269),
  [2742] = {.count = 1, .reusable = false}, SHIFT(1270),
  [2744] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2746] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(394),
  [2749] = {.count = 1, .reusable = false}, SHIFT(1272),
  [2751] = {.count = 1, .reusable = true}, SHIFT(1273),
  [2753] = {.count = 1, .reusable = false}, SHIFT(1274),
  [2755] = {.count = 1, .reusable = true}, SHIFT(1275),
  [2757] = {.count = 1, .reusable = true}, SHIFT(1277),
  [2759] = {.count = 1, .reusable = true}, SHIFT(1278),
  [2761] = {.count = 1, .reusable = false}, SHIFT(1280),
  [2763] = {.count = 1, .reusable = true}, SHIFT(1280),
  [2765] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2767] = {.count = 1, .reusable = false}, SHIFT(1282),
  [2769] = {.count = 1, .reusable = true}, SHIFT(1282),
  [2771] = {.count = 1, .reusable = true}, SHIFT(1281),
  [2773] = {.count = 1, .reusable = true}, SHIFT(1283),
  [2775] = {.count = 1, .reusable = true}, SHIFT(1284),
  [2777] = {.count = 1, .reusable = false}, SHIFT(1285),
  [2779] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2781] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2783] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2785] = {.count = 1, .reusable = false}, SHIFT(1288),
  [2787] = {.count = 1, .reusable = true}, SHIFT(1288),
  [2789] = {.count = 1, .reusable = false}, SHIFT(1289),
  [2791] = {.count = 1, .reusable = true}, SHIFT(1289),
  [2793] = {.count = 1, .reusable = false}, SHIFT(1291),
  [2795] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2797] = {.count = 1, .reusable = false}, SHIFT(1292),
  [2799] = {.count = 1, .reusable = true}, SHIFT(1292),
  [2801] = {.count = 1, .reusable = true}, SHIFT(1294),
  [2803] = {.count = 1, .reusable = false}, SHIFT(1295),
  [2805] = {.count = 1, .reusable = true}, SHIFT(1295),
  [2807] = {.count = 1, .reusable = false}, SHIFT(1296),
  [2809] = {.count = 1, .reusable = true}, SHIFT(1296),
  [2811] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(416),
  [2814] = {.count = 1, .reusable = false}, SHIFT(1298),
  [2816] = {.count = 1, .reusable = true}, SHIFT(1299),
  [2818] = {.count = 1, .reusable = false}, SHIFT(1300),
  [2820] = {.count = 1, .reusable = true}, SHIFT(1301),
  [2822] = {.count = 1, .reusable = true}, SHIFT(1303),
  [2824] = {.count = 1, .reusable = true}, SHIFT(1304),
  [2826] = {.count = 1, .reusable = false}, SHIFT(1306),
  [2828] = {.count = 1, .reusable = true}, SHIFT(1306),
  [2830] = {.count = 1, .reusable = true}, SHIFT(1305),
  [2832] = {.count = 1, .reusable = false}, SHIFT(1308),
  [2834] = {.count = 1, .reusable = true}, SHIFT(1308),
  [2836] = {.count = 1, .reusable = true}, SHIFT(1307),
  [2838] = {.count = 1, .reusable = true}, SHIFT(1309),
  [2840] = {.count = 1, .reusable = true}, SHIFT(1310),
  [2842] = {.count = 1, .reusable = false}, SHIFT(1311),
  [2844] = {.count = 1, .reusable = true}, SHIFT(1311),
  [2846] = {.count = 1, .reusable = true}, SHIFT(1312),
  [2848] = {.count = 1, .reusable = true}, SHIFT(1313),
  [2850] = {.count = 1, .reusable = false}, SHIFT(1314),
  [2852] = {.count = 1, .reusable = true}, SHIFT(1314),
  [2854] = {.count = 1, .reusable = false}, SHIFT(1315),
  [2856] = {.count = 1, .reusable = true}, SHIFT(1315),
  [2858] = {.count = 1, .reusable = false}, SHIFT(1317),
  [2860] = {.count = 1, .reusable = true}, SHIFT(1317),
  [2862] = {.count = 1, .reusable = false}, SHIFT(1318),
  [2864] = {.count = 1, .reusable = true}, SHIFT(1318),
  [2866] = {.count = 1, .reusable = true}, SHIFT(1320),
  [2868] = {.count = 1, .reusable = false}, SHIFT(1321),
  [2870] = {.count = 1, .reusable = true}, SHIFT(1321),
  [2872] = {.count = 1, .reusable = false}, SHIFT(1322),
  [2874] = {.count = 1, .reusable = true}, SHIFT(1322),
  [2876] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 3),
  [2878] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 3),
  [2880] = {.count = 1, .reusable = true}, SHIFT(1324),
  [2882] = {.count = 1, .reusable = false}, SHIFT(1325),
  [2884] = {.count = 1, .reusable = true}, SHIFT(1326),
  [2886] = {.count = 1, .reusable = true}, SHIFT(1328),
  [2888] = {.count = 1, .reusable = true}, SHIFT(1329),
  [2890] = {.count = 1, .reusable = false}, SHIFT(1331),
  [2892] = {.count = 1, .reusable = true}, SHIFT(1331),
  [2894] = {.count = 1, .reusable = true}, SHIFT(1330),
  [2896] = {.count = 1, .reusable = false}, SHIFT(1333),
  [2898] = {.count = 1, .reusable = true}, SHIFT(1333),
  [2900] = {.count = 1, .reusable = true}, SHIFT(1332),
  [2902] = {.count = 1, .reusable = true}, SHIFT(1334),
  [2904] = {.count = 1, .reusable = true}, SHIFT(1335),
  [2906] = {.count = 1, .reusable = false}, SHIFT(1336),
  [2908] = {.count = 1, .reusable = true}, SHIFT(1336),
  [2910] = {.count = 1, .reusable = true}, SHIFT(1337),
  [2912] = {.count = 1, .reusable = true}, SHIFT(1338),
  [2914] = {.count = 1, .reusable = false}, SHIFT(1339),
  [2916] = {.count = 1, .reusable = true}, SHIFT(1339),
  [2918] = {.count = 1, .reusable = false}, SHIFT(1340),
  [2920] = {.count = 1, .reusable = true}, SHIFT(1340),
  [2922] = {.count = 1, .reusable = false}, SHIFT(1342),
  [2924] = {.count = 1, .reusable = true}, SHIFT(1342),
  [2926] = {.count = 1, .reusable = false}, SHIFT(1343),
  [2928] = {.count = 1, .reusable = true}, SHIFT(1343),
  [2930] = {.count = 1, .reusable = true}, REDUCE(sym_string, 4),
  [2932] = {.count = 1, .reusable = false}, REDUCE(sym_string, 4),
  [2934] = {.count = 1, .reusable = true}, SHIFT(1345),
  [2936] = {.count = 1, .reusable = true}, SHIFT(1346),
  [2938] = {.count = 1, .reusable = true}, SHIFT(1347),
  [2940] = {.count = 1, .reusable = true}, SHIFT(1348),
  [2942] = {.count = 1, .reusable = true}, SHIFT(1349),
  [2944] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4),
  [2946] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4),
  [2948] = {.count = 1, .reusable = true}, SHIFT(1350),
  [2950] = {.count = 1, .reusable = true}, SHIFT(1351),
  [2952] = {.count = 1, .reusable = false}, SHIFT(1353),
  [2954] = {.count = 1, .reusable = false}, SHIFT(1354),
  [2956] = {.count = 1, .reusable = true}, SHIFT(1356),
  [2958] = {.count = 1, .reusable = true}, SHIFT(1357),
  [2960] = {.count = 1, .reusable = false}, SHIFT(1358),
  [2962] = {.count = 1, .reusable = true}, SHIFT(1358),
  [2964] = {.count = 1, .reusable = true}, SHIFT(1359),
  [2966] = {.count = 1, .reusable = true}, SHIFT(1360),
  [2968] = {.count = 1, .reusable = true}, SHIFT(1361),
  [2970] = {.count = 1, .reusable = true}, SHIFT(1362),
  [2972] = {.count = 1, .reusable = false}, SHIFT(1363),
  [2974] = {.count = 1, .reusable = true}, SHIFT(1363),
  [2976] = {.count = 1, .reusable = false}, SHIFT(1373),
  [2978] = {.count = 1, .reusable = true}, SHIFT(1374),
  [2980] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [2982] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [2984] = {.count = 1, .reusable = true}, SHIFT(1376),
  [2986] = {.count = 1, .reusable = true}, SHIFT(1377),
  [2988] = {.count = 1, .reusable = false}, SHIFT(1378),
  [2990] = {.count = 1, .reusable = true}, SHIFT(1378),
  [2992] = {.count = 1, .reusable = true}, SHIFT(1379),
  [2994] = {.count = 1, .reusable = false}, SHIFT(1380),
  [2996] = {.count = 1, .reusable = true}, SHIFT(1380),
  [2998] = {.count = 1, .reusable = true}, SHIFT(1381),
  [3000] = {.count = 1, .reusable = false}, SHIFT(1383),
  [3002] = {.count = 1, .reusable = false}, SHIFT(1384),
  [3004] = {.count = 1, .reusable = true}, SHIFT(1385),
  [3006] = {.count = 1, .reusable = true}, SHIFT(1386),
  [3008] = {.count = 1, .reusable = true}, SHIFT(1387),
  [3010] = {.count = 1, .reusable = false}, SHIFT(1388),
  [3012] = {.count = 1, .reusable = true}, SHIFT(1388),
  [3014] = {.count = 1, .reusable = true}, SHIFT(1389),
  [3016] = {.count = 1, .reusable = false}, SHIFT(1391),
  [3018] = {.count = 1, .reusable = true}, SHIFT(1391),
  [3020] = {.count = 1, .reusable = true}, SHIFT(1390),
  [3022] = {.count = 1, .reusable = true}, SHIFT(1392),
  [3024] = {.count = 1, .reusable = false}, SHIFT(1394),
  [3026] = {.count = 1, .reusable = true}, SHIFT(1394),
  [3028] = {.count = 1, .reusable = true}, SHIFT(1393),
  [3030] = {.count = 1, .reusable = true}, SHIFT(1395),
  [3032] = {.count = 1, .reusable = false}, SHIFT(1396),
  [3034] = {.count = 1, .reusable = true}, SHIFT(1396),
  [3036] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 3),
  [3038] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 3),
  [3040] = {.count = 1, .reusable = false}, SHIFT(1397),
  [3042] = {.count = 1, .reusable = true}, SHIFT(1398),
  [3044] = {.count = 1, .reusable = true}, SHIFT(1397),
  [3046] = {.count = 1, .reusable = false}, SHIFT(1402),
  [3048] = {.count = 1, .reusable = true}, SHIFT(1402),
  [3050] = {.count = 1, .reusable = false}, SHIFT(1406),
  [3052] = {.count = 1, .reusable = true}, SHIFT(1407),
  [3054] = {.count = 1, .reusable = true}, SHIFT(1406),
  [3056] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2),
  [3058] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(940),
  [3061] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(462),
  [3064] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(463),
  [3067] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(464),
  [3070] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(465),
  [3073] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(940),
  [3076] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(466),
  [3079] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(468),
  [3082] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(469),
  [3085] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(470),
  [3088] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(465),
  [3091] = {.count = 1, .reusable = true}, REDUCE(sym_command_substitution, 4),
  [3093] = {.count = 1, .reusable = false}, REDUCE(sym_command_substitution, 4),
  [3095] = {.count = 1, .reusable = true}, SHIFT(1411),
  [3097] = {.count = 1, .reusable = false}, SHIFT(1412),
  [3099] = {.count = 1, .reusable = true}, SHIFT(1412),
  [3101] = {.count = 1, .reusable = true}, SHIFT(1413),
  [3103] = {.count = 1, .reusable = true}, SHIFT(1414),
  [3105] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(482),
  [3108] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(486),
  [3111] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(486),
  [3114] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(487),
  [3117] = {.count = 1, .reusable = false}, SHIFT(1416),
  [3119] = {.count = 1, .reusable = true}, SHIFT(1416),
  [3121] = {.count = 1, .reusable = true}, REDUCE(sym_process_substitution, 4),
  [3123] = {.count = 1, .reusable = false}, REDUCE(sym_process_substitution, 4),
  [3125] = {.count = 1, .reusable = true}, SHIFT(1417),
  [3127] = {.count = 1, .reusable = false}, SHIFT(1418),
  [3129] = {.count = 1, .reusable = true}, SHIFT(1418),
  [3131] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 4),
  [3133] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 4),
  [3135] = {.count = 1, .reusable = true}, SHIFT(1419),
  [3137] = {.count = 1, .reusable = true}, SHIFT(1420),
  [3139] = {.count = 1, .reusable = true}, SHIFT(1421),
  [3141] = {.count = 1, .reusable = false}, SHIFT(1422),
  [3143] = {.count = 1, .reusable = true}, SHIFT(1422),
  [3145] = {.count = 1, .reusable = true}, SHIFT(1423),
  [3147] = {.count = 1, .reusable = false}, SHIFT(1425),
  [3149] = {.count = 1, .reusable = true}, SHIFT(1425),
  [3151] = {.count = 1, .reusable = true}, SHIFT(1424),
  [3153] = {.count = 1, .reusable = true}, SHIFT(1426),
  [3155] = {.count = 1, .reusable = false}, SHIFT(1428),
  [3157] = {.count = 1, .reusable = true}, SHIFT(1428),
  [3159] = {.count = 1, .reusable = true}, SHIFT(1427),
  [3161] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 3),
  [3163] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 3),
  [3165] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(972),
  [3168] = {.count = 1, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [3170] = {.count = 2, .reusable = false}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(501),
  [3173] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(502),
  [3176] = {.count = 1, .reusable = true}, REDUCE(sym_program, 4),
  [3178] = {.count = 1, .reusable = false}, SHIFT(1430),
  [3180] = {.count = 1, .reusable = true}, SHIFT(1430),
  [3182] = {.count = 1, .reusable = true}, SHIFT(1431),
  [3184] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5, .alias_sequence_id = 4),
  [3186] = {.count = 1, .reusable = true}, SHIFT(1432),
  [3188] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5),
  [3190] = {.count = 1, .reusable = true}, SHIFT(1433),
  [3192] = {.count = 1, .reusable = false}, SHIFT(1435),
  [3194] = {.count = 1, .reusable = false}, SHIFT(1436),
  [3196] = {.count = 1, .reusable = true}, SHIFT(1437),
  [3198] = {.count = 1, .reusable = true}, SHIFT(1438),
  [3200] = {.count = 1, .reusable = true}, SHIFT(1439),
  [3202] = {.count = 1, .reusable = false}, SHIFT(1440),
  [3204] = {.count = 1, .reusable = true}, SHIFT(1440),
  [3206] = {.count = 1, .reusable = true}, SHIFT(1441),
  [3208] = {.count = 1, .reusable = false}, SHIFT(1443),
  [3210] = {.count = 1, .reusable = true}, SHIFT(1443),
  [3212] = {.count = 1, .reusable = true}, SHIFT(1442),
  [3214] = {.count = 1, .reusable = true}, SHIFT(1444),
  [3216] = {.count = 1, .reusable = false}, SHIFT(1446),
  [3218] = {.count = 1, .reusable = true}, SHIFT(1446),
  [3220] = {.count = 1, .reusable = true}, SHIFT(1445),
  [3222] = {.count = 1, .reusable = false}, SHIFT(1447),
  [3224] = {.count = 1, .reusable = true}, SHIFT(1448),
  [3226] = {.count = 1, .reusable = true}, SHIFT(1447),
  [3228] = {.count = 1, .reusable = false}, SHIFT(1452),
  [3230] = {.count = 1, .reusable = true}, SHIFT(1452),
  [3232] = {.count = 1, .reusable = false}, SHIFT(1456),
  [3234] = {.count = 1, .reusable = true}, SHIFT(1457),
  [3236] = {.count = 1, .reusable = true}, SHIFT(1456),
  [3238] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [3240] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [3242] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [3244] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(534),
  [3247] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(535),
  [3250] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(536),
  [3253] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(537),
  [3256] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(538),
  [3259] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(539),
  [3262] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(540),
  [3265] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(541),
  [3268] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(543),
  [3271] = {.count = 1, .reusable = false}, SHIFT(1461),
  [3273] = {.count = 1, .reusable = true}, SHIFT(1462),
  [3275] = {.count = 1, .reusable = false}, SHIFT(1463),
  [3277] = {.count = 1, .reusable = true}, SHIFT(1464),
  [3279] = {.count = 1, .reusable = true}, SHIFT(1466),
  [3281] = {.count = 1, .reusable = true}, SHIFT(1467),
  [3283] = {.count = 1, .reusable = false}, SHIFT(1469),
  [3285] = {.count = 1, .reusable = true}, SHIFT(1469),
  [3287] = {.count = 1, .reusable = true}, SHIFT(1468),
  [3289] = {.count = 1, .reusable = false}, SHIFT(1471),
  [3291] = {.count = 1, .reusable = true}, SHIFT(1471),
  [3293] = {.count = 1, .reusable = true}, SHIFT(1470),
  [3295] = {.count = 1, .reusable = true}, SHIFT(1472),
  [3297] = {.count = 1, .reusable = true}, SHIFT(1473),
  [3299] = {.count = 1, .reusable = false}, SHIFT(1474),
  [3301] = {.count = 1, .reusable = true}, SHIFT(1474),
  [3303] = {.count = 1, .reusable = true}, SHIFT(1475),
  [3305] = {.count = 1, .reusable = true}, SHIFT(1476),
  [3307] = {.count = 1, .reusable = false}, SHIFT(1477),
  [3309] = {.count = 1, .reusable = true}, SHIFT(1477),
  [3311] = {.count = 1, .reusable = false}, SHIFT(1478),
  [3313] = {.count = 1, .reusable = true}, SHIFT(1478),
  [3315] = {.count = 1, .reusable = false}, SHIFT(1480),
  [3317] = {.count = 1, .reusable = true}, SHIFT(1480),
  [3319] = {.count = 1, .reusable = false}, SHIFT(1481),
  [3321] = {.count = 1, .reusable = true}, SHIFT(1481),
  [3323] = {.count = 1, .reusable = true}, SHIFT(1483),
  [3325] = {.count = 1, .reusable = false}, SHIFT(1484),
  [3327] = {.count = 1, .reusable = true}, SHIFT(1484),
  [3329] = {.count = 1, .reusable = false}, SHIFT(1485),
  [3331] = {.count = 1, .reusable = true}, SHIFT(1485),
  [3333] = {.count = 1, .reusable = true}, SHIFT(1487),
  [3335] = {.count = 1, .reusable = true}, SHIFT(1489),
  [3337] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(568),
  [3340] = {.count = 1, .reusable = false}, SHIFT(1491),
  [3342] = {.count = 1, .reusable = true}, SHIFT(1492),
  [3344] = {.count = 1, .reusable = false}, SHIFT(1493),
  [3346] = {.count = 1, .reusable = true}, SHIFT(1494),
  [3348] = {.count = 1, .reusable = true}, SHIFT(1496),
  [3350] = {.count = 1, .reusable = true}, SHIFT(1497),
  [3352] = {.count = 1, .reusable = false}, SHIFT(1499),
  [3354] = {.count = 1, .reusable = true}, SHIFT(1499),
  [3356] = {.count = 1, .reusable = true}, SHIFT(1498),
  [3358] = {.count = 1, .reusable = false}, SHIFT(1501),
  [3360] = {.count = 1, .reusable = true}, SHIFT(1501),
  [3362] = {.count = 1, .reusable = true}, SHIFT(1500),
  [3364] = {.count = 1, .reusable = true}, SHIFT(1502),
  [3366] = {.count = 1, .reusable = true}, SHIFT(1503),
  [3368] = {.count = 1, .reusable = false}, SHIFT(1504),
  [3370] = {.count = 1, .reusable = true}, SHIFT(1504),
  [3372] = {.count = 1, .reusable = true}, SHIFT(1505),
  [3374] = {.count = 1, .reusable = true}, SHIFT(1506),
  [3376] = {.count = 1, .reusable = false}, SHIFT(1507),
  [3378] = {.count = 1, .reusable = true}, SHIFT(1507),
  [3380] = {.count = 1, .reusable = false}, SHIFT(1508),
  [3382] = {.count = 1, .reusable = true}, SHIFT(1508),
  [3384] = {.count = 1, .reusable = false}, SHIFT(1510),
  [3386] = {.count = 1, .reusable = true}, SHIFT(1510),
  [3388] = {.count = 1, .reusable = false}, SHIFT(1511),
  [3390] = {.count = 1, .reusable = true}, SHIFT(1511),
  [3392] = {.count = 1, .reusable = true}, SHIFT(1513),
  [3394] = {.count = 1, .reusable = false}, SHIFT(1514),
  [3396] = {.count = 1, .reusable = true}, SHIFT(1514),
  [3398] = {.count = 1, .reusable = false}, SHIFT(1515),
  [3400] = {.count = 1, .reusable = true}, SHIFT(1515),
  [3402] = {.count = 1, .reusable = false}, SHIFT(1517),
  [3404] = {.count = 1, .reusable = true}, SHIFT(1517),
  [3406] = {.count = 1, .reusable = true}, SHIFT(1518),
  [3408] = {.count = 1, .reusable = false}, SHIFT(1520),
  [3410] = {.count = 1, .reusable = false}, SHIFT(1521),
  [3412] = {.count = 1, .reusable = true}, SHIFT(1522),
  [3414] = {.count = 1, .reusable = true}, SHIFT(1523),
  [3416] = {.count = 1, .reusable = true}, SHIFT(1524),
  [3418] = {.count = 1, .reusable = false}, SHIFT(1525),
  [3420] = {.count = 1, .reusable = true}, SHIFT(1525),
  [3422] = {.count = 1, .reusable = true}, SHIFT(1526),
  [3424] = {.count = 1, .reusable = false}, SHIFT(1528),
  [3426] = {.count = 1, .reusable = true}, SHIFT(1528),
  [3428] = {.count = 1, .reusable = true}, SHIFT(1527),
  [3430] = {.count = 1, .reusable = true}, SHIFT(1529),
  [3432] = {.count = 1, .reusable = false}, SHIFT(1531),
  [3434] = {.count = 1, .reusable = true}, SHIFT(1531),
  [3436] = {.count = 1, .reusable = true}, SHIFT(1530),
  [3438] = {.count = 1, .reusable = false}, SHIFT(1532),
  [3440] = {.count = 1, .reusable = true}, SHIFT(1533),
  [3442] = {.count = 1, .reusable = true}, SHIFT(1532),
  [3444] = {.count = 1, .reusable = false}, SHIFT(1537),
  [3446] = {.count = 1, .reusable = true}, SHIFT(1537),
  [3448] = {.count = 1, .reusable = false}, SHIFT(1541),
  [3450] = {.count = 1, .reusable = true}, SHIFT(1542),
  [3452] = {.count = 1, .reusable = true}, SHIFT(1541),
  [3454] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [3456] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(593),
  [3459] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(594),
  [3462] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(595),
  [3465] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(596),
  [3468] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(597),
  [3471] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(598),
  [3474] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(599),
  [3477] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(600),
  [3480] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(596),
  [3483] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(605),
  [3486] = {.count = 1, .reusable = false}, SHIFT(1547),
  [3488] = {.count = 1, .reusable = true}, SHIFT(1548),
  [3490] = {.count = 1, .reusable = false}, SHIFT(1549),
  [3492] = {.count = 1, .reusable = true}, SHIFT(1550),
  [3494] = {.count = 1, .reusable = true}, SHIFT(1552),
  [3496] = {.count = 1, .reusable = true}, SHIFT(1553),
  [3498] = {.count = 1, .reusable = false}, SHIFT(1555),
  [3500] = {.count = 1, .reusable = true}, SHIFT(1555),
  [3502] = {.count = 1, .reusable = true}, SHIFT(1554),
  [3504] = {.count = 1, .reusable = false}, SHIFT(1557),
  [3506] = {.count = 1, .reusable = true}, SHIFT(1557),
  [3508] = {.count = 1, .reusable = true}, SHIFT(1556),
  [3510] = {.count = 1, .reusable = true}, SHIFT(1558),
  [3512] = {.count = 1, .reusable = true}, SHIFT(1559),
  [3514] = {.count = 1, .reusable = false}, SHIFT(1560),
  [3516] = {.count = 1, .reusable = true}, SHIFT(1560),
  [3518] = {.count = 1, .reusable = true}, SHIFT(1561),
  [3520] = {.count = 1, .reusable = true}, SHIFT(1562),
  [3522] = {.count = 1, .reusable = false}, SHIFT(1563),
  [3524] = {.count = 1, .reusable = true}, SHIFT(1563),
  [3526] = {.count = 1, .reusable = false}, SHIFT(1564),
  [3528] = {.count = 1, .reusable = true}, SHIFT(1564),
  [3530] = {.count = 1, .reusable = false}, SHIFT(1566),
  [3532] = {.count = 1, .reusable = true}, SHIFT(1566),
  [3534] = {.count = 1, .reusable = false}, SHIFT(1567),
  [3536] = {.count = 1, .reusable = true}, SHIFT(1567),
  [3538] = {.count = 1, .reusable = true}, SHIFT(1569),
  [3540] = {.count = 1, .reusable = false}, SHIFT(1570),
  [3542] = {.count = 1, .reusable = true}, SHIFT(1570),
  [3544] = {.count = 1, .reusable = false}, SHIFT(1571),
  [3546] = {.count = 1, .reusable = true}, SHIFT(1571),
  [3548] = {.count = 1, .reusable = true}, SHIFT(1573),
  [3550] = {.count = 1, .reusable = true}, SHIFT(1574),
  [3552] = {.count = 1, .reusable = false}, SHIFT(1575),
  [3554] = {.count = 1, .reusable = true}, SHIFT(1576),
  [3556] = {.count = 1, .reusable = true}, SHIFT(1578),
  [3558] = {.count = 1, .reusable = true}, SHIFT(1579),
  [3560] = {.count = 1, .reusable = false}, SHIFT(1580),
  [3562] = {.count = 1, .reusable = true}, SHIFT(1580),
  [3564] = {.count = 1, .reusable = true}, SHIFT(1581),
  [3566] = {.count = 1, .reusable = false}, SHIFT(1582),
  [3568] = {.count = 1, .reusable = true}, SHIFT(1582),
  [3570] = {.count = 1, .reusable = true}, SHIFT(1583),
  [3572] = {.count = 1, .reusable = false}, SHIFT(1584),
  [3574] = {.count = 1, .reusable = true}, SHIFT(1584),
  [3576] = {.count = 1, .reusable = true}, SHIFT(1585),
  [3578] = {.count = 1, .reusable = false}, SHIFT(1586),
  [3580] = {.count = 1, .reusable = true}, SHIFT(1586),
  [3582] = {.count = 1, .reusable = false}, SHIFT(1587),
  [3584] = {.count = 1, .reusable = true}, SHIFT(1587),
  [3586] = {.count = 1, .reusable = true}, SHIFT(1588),
  [3588] = {.count = 1, .reusable = false}, SHIFT(1589),
  [3590] = {.count = 1, .reusable = true}, SHIFT(1589),
  [3592] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 3),
  [3594] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 3),
  [3596] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2),
  [3598] = {.count = 1, .reusable = true}, SHIFT(1592),
  [3600] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 2),
  [3602] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [3604] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [3606] = {.count = 1, .reusable = true}, SHIFT(1594),
  [3608] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [3610] = {.count = 2, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(686),
  [3613] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 2),
  [3615] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 2),
  [3617] = {.count = 1, .reusable = true}, SHIFT(1596),
  [3619] = {.count = 1, .reusable = true}, SHIFT(1597),
  [3621] = {.count = 1, .reusable = true}, SHIFT(1600),
  [3623] = {.count = 1, .reusable = true}, SHIFT(1602),
  [3625] = {.count = 1, .reusable = false}, SHIFT(1602),
  [3627] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5),
  [3629] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5),
  [3631] = {.count = 1, .reusable = true}, SHIFT(1606),
  [3633] = {.count = 1, .reusable = false}, SHIFT(1606),
  [3635] = {.count = 1, .reusable = true}, SHIFT(1609),
  [3637] = {.count = 1, .reusable = true}, SHIFT(1610),
  [3639] = {.count = 1, .reusable = false}, SHIFT(1611),
  [3641] = {.count = 1, .reusable = true}, SHIFT(1612),
  [3643] = {.count = 1, .reusable = true}, SHIFT(1614),
  [3645] = {.count = 1, .reusable = true}, SHIFT(1615),
  [3647] = {.count = 1, .reusable = false}, SHIFT(1616),
  [3649] = {.count = 1, .reusable = true}, SHIFT(1616),
  [3651] = {.count = 1, .reusable = true}, SHIFT(1617),
  [3653] = {.count = 1, .reusable = false}, SHIFT(1618),
  [3655] = {.count = 1, .reusable = true}, SHIFT(1618),
  [3657] = {.count = 1, .reusable = true}, SHIFT(1619),
  [3659] = {.count = 1, .reusable = false}, SHIFT(1620),
  [3661] = {.count = 1, .reusable = true}, SHIFT(1620),
  [3663] = {.count = 1, .reusable = true}, SHIFT(1621),
  [3665] = {.count = 1, .reusable = false}, SHIFT(1622),
  [3667] = {.count = 1, .reusable = true}, SHIFT(1622),
  [3669] = {.count = 1, .reusable = false}, SHIFT(1623),
  [3671] = {.count = 1, .reusable = true}, SHIFT(1623),
  [3673] = {.count = 1, .reusable = true}, SHIFT(1624),
  [3675] = {.count = 1, .reusable = false}, SHIFT(1625),
  [3677] = {.count = 1, .reusable = true}, SHIFT(1625),
  [3679] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 5),
  [3681] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 5),
  [3683] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 5),
  [3685] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 5),
  [3687] = {.count = 1, .reusable = true}, SHIFT(1628),
  [3689] = {.count = 1, .reusable = true}, SHIFT(1629),
  [3691] = {.count = 1, .reusable = true}, SHIFT(1630),
  [3693] = {.count = 1, .reusable = true}, SHIFT(1631),
  [3695] = {.count = 1, .reusable = false}, SHIFT(1632),
  [3697] = {.count = 1, .reusable = true}, SHIFT(1633),
  [3699] = {.count = 1, .reusable = true}, SHIFT(1635),
  [3701] = {.count = 1, .reusable = true}, SHIFT(1636),
  [3703] = {.count = 1, .reusable = false}, SHIFT(1637),
  [3705] = {.count = 1, .reusable = true}, SHIFT(1637),
  [3707] = {.count = 1, .reusable = true}, SHIFT(1638),
  [3709] = {.count = 1, .reusable = false}, SHIFT(1639),
  [3711] = {.count = 1, .reusable = true}, SHIFT(1639),
  [3713] = {.count = 1, .reusable = true}, SHIFT(1640),
  [3715] = {.count = 1, .reusable = false}, SHIFT(1641),
  [3717] = {.count = 1, .reusable = true}, SHIFT(1641),
  [3719] = {.count = 1, .reusable = true}, SHIFT(1642),
  [3721] = {.count = 1, .reusable = false}, SHIFT(1643),
  [3723] = {.count = 1, .reusable = true}, SHIFT(1643),
  [3725] = {.count = 1, .reusable = false}, SHIFT(1644),
  [3727] = {.count = 1, .reusable = true}, SHIFT(1644),
  [3729] = {.count = 1, .reusable = true}, SHIFT(1645),
  [3731] = {.count = 1, .reusable = false}, SHIFT(1646),
  [3733] = {.count = 1, .reusable = true}, SHIFT(1646),
  [3735] = {.count = 1, .reusable = true}, SHIFT(1647),
  [3737] = {.count = 1, .reusable = true}, SHIFT(1648),
  [3739] = {.count = 1, .reusable = true}, SHIFT(1649),
  [3741] = {.count = 1, .reusable = false}, SHIFT(1650),
  [3743] = {.count = 1, .reusable = true}, SHIFT(1651),
  [3745] = {.count = 1, .reusable = true}, SHIFT(1653),
  [3747] = {.count = 1, .reusable = true}, SHIFT(1654),
  [3749] = {.count = 1, .reusable = false}, SHIFT(1655),
  [3751] = {.count = 1, .reusable = true}, SHIFT(1655),
  [3753] = {.count = 1, .reusable = true}, SHIFT(1656),
  [3755] = {.count = 1, .reusable = false}, SHIFT(1657),
  [3757] = {.count = 1, .reusable = true}, SHIFT(1657),
  [3759] = {.count = 1, .reusable = true}, SHIFT(1658),
  [3761] = {.count = 1, .reusable = false}, SHIFT(1659),
  [3763] = {.count = 1, .reusable = true}, SHIFT(1659),
  [3765] = {.count = 1, .reusable = true}, SHIFT(1660),
  [3767] = {.count = 1, .reusable = false}, SHIFT(1661),
  [3769] = {.count = 1, .reusable = true}, SHIFT(1661),
  [3771] = {.count = 1, .reusable = false}, SHIFT(1662),
  [3773] = {.count = 1, .reusable = true}, SHIFT(1662),
  [3775] = {.count = 1, .reusable = true}, SHIFT(1663),
  [3777] = {.count = 1, .reusable = false}, SHIFT(1664),
  [3779] = {.count = 1, .reusable = true}, SHIFT(1664),
  [3781] = {.count = 1, .reusable = true}, SHIFT(1665),
  [3783] = {.count = 1, .reusable = true}, SHIFT(1666),
  [3785] = {.count = 1, .reusable = false}, SHIFT(1667),
  [3787] = {.count = 1, .reusable = true}, SHIFT(1668),
  [3789] = {.count = 1, .reusable = true}, SHIFT(1670),
  [3791] = {.count = 1, .reusable = true}, SHIFT(1671),
  [3793] = {.count = 1, .reusable = false}, SHIFT(1672),
  [3795] = {.count = 1, .reusable = true}, SHIFT(1672),
  [3797] = {.count = 1, .reusable = true}, SHIFT(1673),
  [3799] = {.count = 1, .reusable = false}, SHIFT(1674),
  [3801] = {.count = 1, .reusable = true}, SHIFT(1674),
  [3803] = {.count = 1, .reusable = true}, SHIFT(1675),
  [3805] = {.count = 1, .reusable = false}, SHIFT(1676),
  [3807] = {.count = 1, .reusable = true}, SHIFT(1676),
  [3809] = {.count = 1, .reusable = true}, SHIFT(1677),
  [3811] = {.count = 1, .reusable = false}, SHIFT(1678),
  [3813] = {.count = 1, .reusable = true}, SHIFT(1678),
  [3815] = {.count = 1, .reusable = false}, SHIFT(1679),
  [3817] = {.count = 1, .reusable = true}, SHIFT(1679),
  [3819] = {.count = 1, .reusable = true}, SHIFT(1680),
  [3821] = {.count = 1, .reusable = false}, SHIFT(1681),
  [3823] = {.count = 1, .reusable = true}, SHIFT(1681),
  [3825] = {.count = 1, .reusable = true}, SHIFT(1682),
  [3827] = {.count = 1, .reusable = true}, SHIFT(1683),
  [3829] = {.count = 1, .reusable = false}, SHIFT(1684),
  [3831] = {.count = 1, .reusable = true}, SHIFT(1685),
  [3833] = {.count = 1, .reusable = true}, SHIFT(1687),
  [3835] = {.count = 1, .reusable = true}, SHIFT(1688),
  [3837] = {.count = 1, .reusable = false}, SHIFT(1689),
  [3839] = {.count = 1, .reusable = true}, SHIFT(1689),
  [3841] = {.count = 1, .reusable = true}, SHIFT(1690),
  [3843] = {.count = 1, .reusable = false}, SHIFT(1691),
  [3845] = {.count = 1, .reusable = true}, SHIFT(1691),
  [3847] = {.count = 1, .reusable = true}, SHIFT(1692),
  [3849] = {.count = 1, .reusable = false}, SHIFT(1693),
  [3851] = {.count = 1, .reusable = true}, SHIFT(1693),
  [3853] = {.count = 1, .reusable = true}, SHIFT(1694),
  [3855] = {.count = 1, .reusable = false}, SHIFT(1695),
  [3857] = {.count = 1, .reusable = true}, SHIFT(1695),
  [3859] = {.count = 1, .reusable = false}, SHIFT(1696),
  [3861] = {.count = 1, .reusable = true}, SHIFT(1696),
  [3863] = {.count = 1, .reusable = true}, SHIFT(1697),
  [3865] = {.count = 1, .reusable = false}, SHIFT(1698),
  [3867] = {.count = 1, .reusable = true}, SHIFT(1698),
  [3869] = {.count = 1, .reusable = true}, SHIFT(1699),
  [3871] = {.count = 1, .reusable = true}, SHIFT(1700),
  [3873] = {.count = 1, .reusable = false}, SHIFT(1701),
  [3875] = {.count = 1, .reusable = true}, SHIFT(1702),
  [3877] = {.count = 1, .reusable = true}, SHIFT(1704),
  [3879] = {.count = 1, .reusable = true}, SHIFT(1705),
  [3881] = {.count = 1, .reusable = false}, SHIFT(1706),
  [3883] = {.count = 1, .reusable = true}, SHIFT(1706),
  [3885] = {.count = 1, .reusable = true}, SHIFT(1707),
  [3887] = {.count = 1, .reusable = false}, SHIFT(1708),
  [3889] = {.count = 1, .reusable = true}, SHIFT(1708),
  [3891] = {.count = 1, .reusable = true}, SHIFT(1709),
  [3893] = {.count = 1, .reusable = false}, SHIFT(1710),
  [3895] = {.count = 1, .reusable = true}, SHIFT(1710),
  [3897] = {.count = 1, .reusable = true}, SHIFT(1711),
  [3899] = {.count = 1, .reusable = false}, SHIFT(1712),
  [3901] = {.count = 1, .reusable = true}, SHIFT(1712),
  [3903] = {.count = 1, .reusable = false}, SHIFT(1713),
  [3905] = {.count = 1, .reusable = true}, SHIFT(1713),
  [3907] = {.count = 1, .reusable = true}, SHIFT(1714),
  [3909] = {.count = 1, .reusable = true}, SHIFT(1715),
  [3911] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4, .alias_sequence_id = 4),
  [3913] = {.count = 1, .reusable = true}, SHIFT(1716),
  [3915] = {.count = 1, .reusable = true}, SHIFT(1717),
  [3917] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4),
  [3919] = {.count = 1, .reusable = true}, SHIFT(1718),
  [3921] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 6),
  [3923] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 6),
  [3925] = {.count = 1, .reusable = false}, SHIFT(1720),
  [3927] = {.count = 1, .reusable = false}, SHIFT(1721),
  [3929] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5),
  [3931] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5),
  [3933] = {.count = 1, .reusable = true}, SHIFT(1722),
  [3935] = {.count = 1, .reusable = true}, SHIFT(1723),
  [3937] = {.count = 1, .reusable = true}, SHIFT(1724),
  [3939] = {.count = 1, .reusable = false}, SHIFT(1725),
  [3941] = {.count = 1, .reusable = true}, SHIFT(1725),
  [3943] = {.count = 1, .reusable = true}, SHIFT(1726),
  [3945] = {.count = 1, .reusable = false}, SHIFT(1728),
  [3947] = {.count = 1, .reusable = true}, SHIFT(1728),
  [3949] = {.count = 1, .reusable = true}, SHIFT(1727),
  [3951] = {.count = 1, .reusable = true}, SHIFT(1729),
  [3953] = {.count = 1, .reusable = false}, SHIFT(1731),
  [3955] = {.count = 1, .reusable = true}, SHIFT(1731),
  [3957] = {.count = 1, .reusable = true}, SHIFT(1730),
  [3959] = {.count = 1, .reusable = false}, SHIFT(1732),
  [3961] = {.count = 1, .reusable = true}, SHIFT(1733),
  [3963] = {.count = 1, .reusable = true}, SHIFT(1732),
  [3965] = {.count = 1, .reusable = false}, SHIFT(1737),
  [3967] = {.count = 1, .reusable = true}, SHIFT(1737),
  [3969] = {.count = 1, .reusable = false}, SHIFT(1741),
  [3971] = {.count = 1, .reusable = true}, SHIFT(1742),
  [3973] = {.count = 1, .reusable = true}, SHIFT(1741),
  [3975] = {.count = 1, .reusable = true}, SHIFT(1746),
  [3977] = {.count = 1, .reusable = true}, SHIFT(1747),
  [3979] = {.count = 1, .reusable = true}, SHIFT(1748),
  [3981] = {.count = 1, .reusable = false}, SHIFT(1749),
  [3983] = {.count = 1, .reusable = true}, SHIFT(1749),
  [3985] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 5),
  [3987] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 5),
  [3989] = {.count = 1, .reusable = false}, SHIFT(1750),
  [3991] = {.count = 1, .reusable = true}, SHIFT(1750),
  [3993] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(916),
  [3996] = {.count = 1, .reusable = false}, SHIFT(1751),
  [3998] = {.count = 1, .reusable = true}, SHIFT(1752),
  [4000] = {.count = 1, .reusable = false}, SHIFT(1753),
  [4002] = {.count = 1, .reusable = true}, SHIFT(1754),
  [4004] = {.count = 1, .reusable = true}, SHIFT(1756),
  [4006] = {.count = 1, .reusable = true}, SHIFT(1757),
  [4008] = {.count = 1, .reusable = false}, SHIFT(1759),
  [4010] = {.count = 1, .reusable = true}, SHIFT(1759),
  [4012] = {.count = 1, .reusable = true}, SHIFT(1758),
  [4014] = {.count = 1, .reusable = false}, SHIFT(1761),
  [4016] = {.count = 1, .reusable = true}, SHIFT(1761),
  [4018] = {.count = 1, .reusable = true}, SHIFT(1760),
  [4020] = {.count = 1, .reusable = true}, SHIFT(1762),
  [4022] = {.count = 1, .reusable = true}, SHIFT(1763),
  [4024] = {.count = 1, .reusable = false}, SHIFT(1764),
  [4026] = {.count = 1, .reusable = true}, SHIFT(1764),
  [4028] = {.count = 1, .reusable = true}, SHIFT(1765),
  [4030] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 3),
  [4032] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 3),
  [4034] = {.count = 1, .reusable = true}, SHIFT(1766),
  [4036] = {.count = 1, .reusable = true}, SHIFT(1767),
  [4038] = {.count = 1, .reusable = false}, SHIFT(1768),
  [4040] = {.count = 1, .reusable = true}, SHIFT(1768),
  [4042] = {.count = 1, .reusable = false}, SHIFT(1769),
  [4044] = {.count = 1, .reusable = true}, SHIFT(1769),
  [4046] = {.count = 1, .reusable = false}, SHIFT(1771),
  [4048] = {.count = 1, .reusable = true}, SHIFT(1771),
  [4050] = {.count = 1, .reusable = false}, SHIFT(1772),
  [4052] = {.count = 1, .reusable = true}, SHIFT(1772),
  [4054] = {.count = 1, .reusable = true}, SHIFT(1774),
  [4056] = {.count = 1, .reusable = false}, SHIFT(1775),
  [4058] = {.count = 1, .reusable = true}, SHIFT(1775),
  [4060] = {.count = 1, .reusable = false}, SHIFT(1776),
  [4062] = {.count = 1, .reusable = true}, SHIFT(1776),
  [4064] = {.count = 1, .reusable = true}, REDUCE(sym_command_substitution, 5),
  [4066] = {.count = 1, .reusable = false}, REDUCE(sym_command_substitution, 5),
  [4068] = {.count = 1, .reusable = true}, SHIFT(1778),
  [4070] = {.count = 1, .reusable = true}, REDUCE(sym_process_substitution, 5),
  [4072] = {.count = 1, .reusable = false}, REDUCE(sym_process_substitution, 5),
  [4074] = {.count = 1, .reusable = true}, SHIFT(1780),
  [4076] = {.count = 1, .reusable = true}, SHIFT(1781),
  [4078] = {.count = 1, .reusable = false}, SHIFT(1782),
  [4080] = {.count = 1, .reusable = true}, SHIFT(1783),
  [4082] = {.count = 1, .reusable = true}, SHIFT(1785),
  [4084] = {.count = 1, .reusable = true}, SHIFT(1786),
  [4086] = {.count = 1, .reusable = false}, SHIFT(1788),
  [4088] = {.count = 1, .reusable = true}, SHIFT(1788),
  [4090] = {.count = 1, .reusable = true}, SHIFT(1787),
  [4092] = {.count = 1, .reusable = false}, SHIFT(1790),
  [4094] = {.count = 1, .reusable = true}, SHIFT(1790),
  [4096] = {.count = 1, .reusable = true}, SHIFT(1789),
  [4098] = {.count = 1, .reusable = true}, SHIFT(1791),
  [4100] = {.count = 1, .reusable = true}, SHIFT(1792),
  [4102] = {.count = 1, .reusable = false}, SHIFT(1793),
  [4104] = {.count = 1, .reusable = true}, SHIFT(1793),
  [4106] = {.count = 1, .reusable = true}, SHIFT(1794),
  [4108] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6, .alias_sequence_id = 4),
  [4110] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6),
  [4112] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(985),
  [4115] = {.count = 1, .reusable = false}, SHIFT(1795),
  [4117] = {.count = 1, .reusable = true}, SHIFT(1796),
  [4119] = {.count = 1, .reusable = false}, SHIFT(1797),
  [4121] = {.count = 1, .reusable = true}, SHIFT(1798),
  [4123] = {.count = 1, .reusable = true}, SHIFT(1800),
  [4125] = {.count = 1, .reusable = true}, SHIFT(1801),
  [4127] = {.count = 1, .reusable = false}, SHIFT(1803),
  [4129] = {.count = 1, .reusable = true}, SHIFT(1803),
  [4131] = {.count = 1, .reusable = true}, SHIFT(1802),
  [4133] = {.count = 1, .reusable = false}, SHIFT(1805),
  [4135] = {.count = 1, .reusable = true}, SHIFT(1805),
  [4137] = {.count = 1, .reusable = true}, SHIFT(1804),
  [4139] = {.count = 1, .reusable = true}, SHIFT(1806),
  [4141] = {.count = 1, .reusable = true}, SHIFT(1807),
  [4143] = {.count = 1, .reusable = false}, SHIFT(1808),
  [4145] = {.count = 1, .reusable = true}, SHIFT(1808),
  [4147] = {.count = 1, .reusable = true}, SHIFT(1809),
  [4149] = {.count = 1, .reusable = true}, SHIFT(1810),
  [4151] = {.count = 1, .reusable = false}, SHIFT(1811),
  [4153] = {.count = 1, .reusable = true}, SHIFT(1811),
  [4155] = {.count = 1, .reusable = false}, SHIFT(1812),
  [4157] = {.count = 1, .reusable = true}, SHIFT(1812),
  [4159] = {.count = 1, .reusable = false}, SHIFT(1814),
  [4161] = {.count = 1, .reusable = true}, SHIFT(1814),
  [4163] = {.count = 1, .reusable = false}, SHIFT(1815),
  [4165] = {.count = 1, .reusable = true}, SHIFT(1815),
  [4167] = {.count = 1, .reusable = true}, SHIFT(1817),
  [4169] = {.count = 1, .reusable = false}, SHIFT(1818),
  [4171] = {.count = 1, .reusable = true}, SHIFT(1818),
  [4173] = {.count = 1, .reusable = false}, SHIFT(1819),
  [4175] = {.count = 1, .reusable = true}, SHIFT(1819),
  [4177] = {.count = 1, .reusable = true}, SHIFT(1821),
  [4179] = {.count = 1, .reusable = true}, SHIFT(1822),
  [4181] = {.count = 1, .reusable = false}, SHIFT(1823),
  [4183] = {.count = 1, .reusable = true}, SHIFT(1824),
  [4185] = {.count = 1, .reusable = true}, SHIFT(1826),
  [4187] = {.count = 1, .reusable = true}, SHIFT(1827),
  [4189] = {.count = 1, .reusable = false}, SHIFT(1828),
  [4191] = {.count = 1, .reusable = true}, SHIFT(1828),
  [4193] = {.count = 1, .reusable = true}, SHIFT(1829),
  [4195] = {.count = 1, .reusable = false}, SHIFT(1830),
  [4197] = {.count = 1, .reusable = true}, SHIFT(1830),
  [4199] = {.count = 1, .reusable = true}, SHIFT(1831),
  [4201] = {.count = 1, .reusable = false}, SHIFT(1832),
  [4203] = {.count = 1, .reusable = true}, SHIFT(1832),
  [4205] = {.count = 1, .reusable = true}, SHIFT(1833),
  [4207] = {.count = 1, .reusable = false}, SHIFT(1834),
  [4209] = {.count = 1, .reusable = true}, SHIFT(1834),
  [4211] = {.count = 1, .reusable = false}, SHIFT(1835),
  [4213] = {.count = 1, .reusable = true}, SHIFT(1835),
  [4215] = {.count = 1, .reusable = true}, SHIFT(1836),
  [4217] = {.count = 1, .reusable = false}, SHIFT(1837),
  [4219] = {.count = 1, .reusable = true}, SHIFT(1837),
  [4221] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 6),
  [4223] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 6),
  [4225] = {.count = 1, .reusable = true}, SHIFT(1839),
  [4227] = {.count = 1, .reusable = true}, SHIFT(1840),
  [4229] = {.count = 1, .reusable = true}, SHIFT(1841),
  [4231] = {.count = 1, .reusable = true}, SHIFT(1842),
  [4233] = {.count = 1, .reusable = false}, SHIFT(1843),
  [4235] = {.count = 1, .reusable = true}, SHIFT(1844),
  [4237] = {.count = 1, .reusable = true}, SHIFT(1846),
  [4239] = {.count = 1, .reusable = true}, SHIFT(1847),
  [4241] = {.count = 1, .reusable = false}, SHIFT(1848),
  [4243] = {.count = 1, .reusable = true}, SHIFT(1848),
  [4245] = {.count = 1, .reusable = true}, SHIFT(1849),
  [4247] = {.count = 1, .reusable = false}, SHIFT(1850),
  [4249] = {.count = 1, .reusable = true}, SHIFT(1850),
  [4251] = {.count = 1, .reusable = true}, SHIFT(1851),
  [4253] = {.count = 1, .reusable = false}, SHIFT(1852),
  [4255] = {.count = 1, .reusable = true}, SHIFT(1852),
  [4257] = {.count = 1, .reusable = true}, SHIFT(1853),
  [4259] = {.count = 1, .reusable = false}, SHIFT(1854),
  [4261] = {.count = 1, .reusable = true}, SHIFT(1854),
  [4263] = {.count = 1, .reusable = false}, SHIFT(1855),
  [4265] = {.count = 1, .reusable = true}, SHIFT(1855),
  [4267] = {.count = 1, .reusable = true}, SHIFT(1856),
  [4269] = {.count = 1, .reusable = false}, SHIFT(1857),
  [4271] = {.count = 1, .reusable = true}, SHIFT(1857),
  [4273] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1071),
  [4276] = {.count = 1, .reusable = false}, SHIFT(1859),
  [4278] = {.count = 1, .reusable = true}, SHIFT(1860),
  [4280] = {.count = 1, .reusable = false}, SHIFT(1861),
  [4282] = {.count = 1, .reusable = true}, SHIFT(1862),
  [4284] = {.count = 1, .reusable = true}, SHIFT(1864),
  [4286] = {.count = 1, .reusable = true}, SHIFT(1865),
  [4288] = {.count = 1, .reusable = false}, SHIFT(1867),
  [4290] = {.count = 1, .reusable = true}, SHIFT(1867),
  [4292] = {.count = 1, .reusable = true}, SHIFT(1866),
  [4294] = {.count = 1, .reusable = false}, SHIFT(1869),
  [4296] = {.count = 1, .reusable = true}, SHIFT(1869),
  [4298] = {.count = 1, .reusable = true}, SHIFT(1868),
  [4300] = {.count = 1, .reusable = true}, SHIFT(1870),
  [4302] = {.count = 1, .reusable = true}, SHIFT(1871),
  [4304] = {.count = 1, .reusable = false}, SHIFT(1872),
  [4306] = {.count = 1, .reusable = true}, SHIFT(1872),
  [4308] = {.count = 1, .reusable = true}, SHIFT(1873),
  [4310] = {.count = 1, .reusable = true}, SHIFT(1874),
  [4312] = {.count = 1, .reusable = false}, SHIFT(1875),
  [4314] = {.count = 1, .reusable = true}, SHIFT(1875),
  [4316] = {.count = 1, .reusable = false}, SHIFT(1876),
  [4318] = {.count = 1, .reusable = true}, SHIFT(1876),
  [4320] = {.count = 1, .reusable = false}, SHIFT(1878),
  [4322] = {.count = 1, .reusable = true}, SHIFT(1878),
  [4324] = {.count = 1, .reusable = false}, SHIFT(1879),
  [4326] = {.count = 1, .reusable = true}, SHIFT(1879),
  [4328] = {.count = 1, .reusable = true}, SHIFT(1881),
  [4330] = {.count = 1, .reusable = false}, SHIFT(1882),
  [4332] = {.count = 1, .reusable = true}, SHIFT(1882),
  [4334] = {.count = 1, .reusable = false}, SHIFT(1883),
  [4336] = {.count = 1, .reusable = true}, SHIFT(1883),
  [4338] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [4340] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [4342] = {.count = 1, .reusable = true}, SHIFT(1885),
  [4344] = {.count = 1, .reusable = true}, SHIFT(1886),
  [4346] = {.count = 1, .reusable = false}, SHIFT(1887),
  [4348] = {.count = 1, .reusable = true}, SHIFT(1888),
  [4350] = {.count = 1, .reusable = true}, SHIFT(1890),
  [4352] = {.count = 1, .reusable = true}, SHIFT(1891),
  [4354] = {.count = 1, .reusable = false}, SHIFT(1892),
  [4356] = {.count = 1, .reusable = true}, SHIFT(1892),
  [4358] = {.count = 1, .reusable = true}, SHIFT(1893),
  [4360] = {.count = 1, .reusable = false}, SHIFT(1894),
  [4362] = {.count = 1, .reusable = true}, SHIFT(1894),
  [4364] = {.count = 1, .reusable = true}, SHIFT(1895),
  [4366] = {.count = 1, .reusable = false}, SHIFT(1896),
  [4368] = {.count = 1, .reusable = true}, SHIFT(1896),
  [4370] = {.count = 1, .reusable = true}, SHIFT(1897),
  [4372] = {.count = 1, .reusable = false}, SHIFT(1898),
  [4374] = {.count = 1, .reusable = true}, SHIFT(1898),
  [4376] = {.count = 1, .reusable = false}, SHIFT(1899),
  [4378] = {.count = 1, .reusable = true}, SHIFT(1899),
  [4380] = {.count = 1, .reusable = true}, SHIFT(1900),
  [4382] = {.count = 1, .reusable = false}, SHIFT(1901),
  [4384] = {.count = 1, .reusable = true}, SHIFT(1901),
  [4386] = {.count = 1, .reusable = true}, SHIFT(1902),
  [4388] = {.count = 1, .reusable = true}, SHIFT(1903),
  [4390] = {.count = 1, .reusable = true}, SHIFT(1904),
  [4392] = {.count = 1, .reusable = false}, SHIFT(1905),
  [4394] = {.count = 1, .reusable = true}, SHIFT(1905),
  [4396] = {.count = 1, .reusable = false}, SHIFT(1906),
  [4398] = {.count = 1, .reusable = true}, SHIFT(1906),
  [4400] = {.count = 1, .reusable = true}, SHIFT(1907),
  [4402] = {.count = 1, .reusable = true}, SHIFT(1908),
  [4404] = {.count = 1, .reusable = true}, SHIFT(1909),
  [4406] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 3),
  [4408] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6),
  [4410] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6),
  [4412] = {.count = 1, .reusable = true}, SHIFT(1911),
  [4414] = {.count = 1, .reusable = true}, SHIFT(1912),
  [4416] = {.count = 1, .reusable = true}, SHIFT(1913),
  [4418] = {.count = 1, .reusable = true}, SHIFT(1915),
  [4420] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2, .alias_sequence_id = 1),
  [4422] = {.count = 1, .reusable = true}, SHIFT(1916),
  [4424] = {.count = 1, .reusable = false}, SHIFT(1917),
  [4426] = {.count = 1, .reusable = false}, SHIFT(1918),
  [4428] = {.count = 1, .reusable = false}, SHIFT(1919),
  [4430] = {.count = 1, .reusable = false}, SHIFT(1920),
  [4432] = {.count = 1, .reusable = true}, SHIFT(1921),
  [4434] = {.count = 1, .reusable = false}, SHIFT(1922),
  [4436] = {.count = 1, .reusable = true}, SHIFT(1923),
  [4438] = {.count = 1, .reusable = true}, SHIFT(1924),
  [4440] = {.count = 1, .reusable = true}, SHIFT(1925),
  [4442] = {.count = 1, .reusable = true}, SHIFT(1926),
  [4444] = {.count = 1, .reusable = true}, SHIFT(1927),
  [4446] = {.count = 1, .reusable = false}, SHIFT(1928),
  [4448] = {.count = 1, .reusable = true}, SHIFT(1936),
  [4450] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2),
  [4452] = {.count = 1, .reusable = true}, SHIFT(1939),
  [4454] = {.count = 1, .reusable = true}, SHIFT(1943),
  [4456] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 2),
  [4458] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 2),
  [4460] = {.count = 1, .reusable = true}, SHIFT(1944),
  [4462] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1945),
  [4465] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(223),
  [4468] = {.count = 2, .reusable = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(224),
  [4471] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1946),
  [4474] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(226),
  [4477] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(227),
  [4480] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(228),
  [4483] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(229),
  [4486] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6),
  [4488] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6),
  [4490] = {.count = 1, .reusable = true}, SHIFT(1949),
  [4492] = {.count = 1, .reusable = true}, SHIFT(1951),
  [4494] = {.count = 1, .reusable = true}, SHIFT(1952),
  [4496] = {.count = 1, .reusable = true}, SHIFT(1953),
  [4498] = {.count = 1, .reusable = false}, SHIFT(1954),
  [4500] = {.count = 1, .reusable = true}, SHIFT(1954),
  [4502] = {.count = 1, .reusable = false}, SHIFT(1955),
  [4504] = {.count = 1, .reusable = true}, SHIFT(1955),
  [4506] = {.count = 1, .reusable = true}, SHIFT(1956),
  [4508] = {.count = 1, .reusable = true}, SHIFT(1957),
  [4510] = {.count = 1, .reusable = true}, SHIFT(1958),
  [4512] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 6),
  [4514] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 6),
  [4516] = {.count = 1, .reusable = true}, SHIFT(1959),
  [4518] = {.count = 1, .reusable = true}, SHIFT(1960),
  [4520] = {.count = 1, .reusable = true}, SHIFT(1961),
  [4522] = {.count = 1, .reusable = false}, SHIFT(1962),
  [4524] = {.count = 1, .reusable = true}, SHIFT(1962),
  [4526] = {.count = 1, .reusable = false}, SHIFT(1963),
  [4528] = {.count = 1, .reusable = true}, SHIFT(1963),
  [4530] = {.count = 1, .reusable = true}, SHIFT(1964),
  [4532] = {.count = 1, .reusable = true}, SHIFT(1965),
  [4534] = {.count = 1, .reusable = true}, SHIFT(1966),
  [4536] = {.count = 1, .reusable = true}, SHIFT(1967),
  [4538] = {.count = 1, .reusable = true}, SHIFT(1968),
  [4540] = {.count = 1, .reusable = true}, SHIFT(1969),
  [4542] = {.count = 1, .reusable = false}, SHIFT(1970),
  [4544] = {.count = 1, .reusable = true}, SHIFT(1970),
  [4546] = {.count = 1, .reusable = false}, SHIFT(1971),
  [4548] = {.count = 1, .reusable = true}, SHIFT(1971),
  [4550] = {.count = 1, .reusable = true}, SHIFT(1972),
  [4552] = {.count = 1, .reusable = true}, SHIFT(1973),
  [4554] = {.count = 1, .reusable = true}, SHIFT(1974),
  [4556] = {.count = 1, .reusable = true}, SHIFT(1975),
  [4558] = {.count = 1, .reusable = true}, SHIFT(1976),
  [4560] = {.count = 1, .reusable = true}, SHIFT(1977),
  [4562] = {.count = 1, .reusable = false}, SHIFT(1978),
  [4564] = {.count = 1, .reusable = true}, SHIFT(1978),
  [4566] = {.count = 1, .reusable = false}, SHIFT(1979),
  [4568] = {.count = 1, .reusable = true}, SHIFT(1979),
  [4570] = {.count = 1, .reusable = true}, SHIFT(1980),
  [4572] = {.count = 1, .reusable = true}, SHIFT(1981),
  [4574] = {.count = 1, .reusable = true}, SHIFT(1982),
  [4576] = {.count = 1, .reusable = true}, SHIFT(1983),
  [4578] = {.count = 1, .reusable = true}, SHIFT(1984),
  [4580] = {.count = 1, .reusable = true}, SHIFT(1985),
  [4582] = {.count = 1, .reusable = false}, SHIFT(1986),
  [4584] = {.count = 1, .reusable = true}, SHIFT(1986),
  [4586] = {.count = 1, .reusable = false}, SHIFT(1987),
  [4588] = {.count = 1, .reusable = true}, SHIFT(1987),
  [4590] = {.count = 1, .reusable = true}, SHIFT(1988),
  [4592] = {.count = 1, .reusable = true}, SHIFT(1989),
  [4594] = {.count = 1, .reusable = true}, SHIFT(1990),
  [4596] = {.count = 1, .reusable = true}, SHIFT(1991),
  [4598] = {.count = 1, .reusable = true}, SHIFT(1992),
  [4600] = {.count = 1, .reusable = true}, SHIFT(1993),
  [4602] = {.count = 1, .reusable = false}, SHIFT(1994),
  [4604] = {.count = 1, .reusable = true}, SHIFT(1994),
  [4606] = {.count = 1, .reusable = false}, SHIFT(1995),
  [4608] = {.count = 1, .reusable = true}, SHIFT(1995),
  [4610] = {.count = 1, .reusable = true}, SHIFT(1996),
  [4612] = {.count = 1, .reusable = true}, SHIFT(1997),
  [4614] = {.count = 1, .reusable = true}, SHIFT(1998),
  [4616] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5, .alias_sequence_id = 4),
  [4618] = {.count = 1, .reusable = true}, SHIFT(1999),
  [4620] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5),
  [4622] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1350),
  [4625] = {.count = 1, .reusable = false}, SHIFT(2000),
  [4627] = {.count = 1, .reusable = true}, SHIFT(2001),
  [4629] = {.count = 1, .reusable = false}, SHIFT(2002),
  [4631] = {.count = 1, .reusable = true}, SHIFT(2003),
  [4633] = {.count = 1, .reusable = true}, SHIFT(2005),
  [4635] = {.count = 1, .reusable = true}, SHIFT(2006),
  [4637] = {.count = 1, .reusable = false}, SHIFT(2008),
  [4639] = {.count = 1, .reusable = true}, SHIFT(2008),
  [4641] = {.count = 1, .reusable = true}, SHIFT(2007),
  [4643] = {.count = 1, .reusable = false}, SHIFT(2010),
  [4645] = {.count = 1, .reusable = true}, SHIFT(2010),
  [4647] = {.count = 1, .reusable = true}, SHIFT(2009),
  [4649] = {.count = 1, .reusable = true}, SHIFT(2011),
  [4651] = {.count = 1, .reusable = true}, SHIFT(2012),
  [4653] = {.count = 1, .reusable = false}, SHIFT(2013),
  [4655] = {.count = 1, .reusable = true}, SHIFT(2013),
  [4657] = {.count = 1, .reusable = true}, SHIFT(2014),
  [4659] = {.count = 1, .reusable = true}, SHIFT(2015),
  [4661] = {.count = 1, .reusable = false}, SHIFT(2016),
  [4663] = {.count = 1, .reusable = true}, SHIFT(2016),
  [4665] = {.count = 1, .reusable = false}, SHIFT(2017),
  [4667] = {.count = 1, .reusable = true}, SHIFT(2017),
  [4669] = {.count = 1, .reusable = false}, SHIFT(2019),
  [4671] = {.count = 1, .reusable = true}, SHIFT(2019),
  [4673] = {.count = 1, .reusable = false}, SHIFT(2020),
  [4675] = {.count = 1, .reusable = true}, SHIFT(2020),
  [4677] = {.count = 1, .reusable = true}, SHIFT(2022),
  [4679] = {.count = 1, .reusable = false}, SHIFT(2023),
  [4681] = {.count = 1, .reusable = true}, SHIFT(2023),
  [4683] = {.count = 1, .reusable = false}, SHIFT(2024),
  [4685] = {.count = 1, .reusable = true}, SHIFT(2024),
  [4687] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 7),
  [4689] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 7),
  [4691] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6),
  [4693] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6),
  [4695] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 5),
  [4697] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 5),
  [4699] = {.count = 1, .reusable = true}, SHIFT(2026),
  [4701] = {.count = 1, .reusable = true}, SHIFT(2027),
  [4703] = {.count = 1, .reusable = true}, SHIFT(2028),
  [4705] = {.count = 1, .reusable = true}, SHIFT(2029),
  [4707] = {.count = 1, .reusable = false}, SHIFT(2030),
  [4709] = {.count = 1, .reusable = true}, SHIFT(2031),
  [4711] = {.count = 1, .reusable = true}, SHIFT(2033),
  [4713] = {.count = 1, .reusable = true}, SHIFT(2034),
  [4715] = {.count = 1, .reusable = false}, SHIFT(2035),
  [4717] = {.count = 1, .reusable = true}, SHIFT(2035),
  [4719] = {.count = 1, .reusable = true}, SHIFT(2036),
  [4721] = {.count = 1, .reusable = false}, SHIFT(2037),
  [4723] = {.count = 1, .reusable = true}, SHIFT(2037),
  [4725] = {.count = 1, .reusable = true}, SHIFT(2038),
  [4727] = {.count = 1, .reusable = false}, SHIFT(2039),
  [4729] = {.count = 1, .reusable = true}, SHIFT(2039),
  [4731] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 3),
  [4733] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 3),
  [4735] = {.count = 1, .reusable = true}, SHIFT(2040),
  [4737] = {.count = 1, .reusable = false}, SHIFT(2041),
  [4739] = {.count = 1, .reusable = true}, SHIFT(2041),
  [4741] = {.count = 1, .reusable = false}, SHIFT(2042),
  [4743] = {.count = 1, .reusable = true}, SHIFT(2042),
  [4745] = {.count = 1, .reusable = true}, SHIFT(2043),
  [4747] = {.count = 1, .reusable = false}, SHIFT(2044),
  [4749] = {.count = 1, .reusable = true}, SHIFT(2044),
  [4751] = {.count = 1, .reusable = true}, REDUCE(sym_command_substitution, 6),
  [4753] = {.count = 1, .reusable = false}, REDUCE(sym_command_substitution, 6),
  [4755] = {.count = 1, .reusable = true}, REDUCE(sym_process_substitution, 6),
  [4757] = {.count = 1, .reusable = false}, REDUCE(sym_process_substitution, 6),
  [4759] = {.count = 1, .reusable = true}, SHIFT(2045),
  [4761] = {.count = 1, .reusable = true}, SHIFT(2046),
  [4763] = {.count = 1, .reusable = false}, SHIFT(2047),
  [4765] = {.count = 1, .reusable = true}, SHIFT(2048),
  [4767] = {.count = 1, .reusable = true}, SHIFT(2050),
  [4769] = {.count = 1, .reusable = true}, SHIFT(2051),
  [4771] = {.count = 1, .reusable = false}, SHIFT(2052),
  [4773] = {.count = 1, .reusable = true}, SHIFT(2052),
  [4775] = {.count = 1, .reusable = true}, SHIFT(2053),
  [4777] = {.count = 1, .reusable = false}, SHIFT(2054),
  [4779] = {.count = 1, .reusable = true}, SHIFT(2054),
  [4781] = {.count = 1, .reusable = true}, SHIFT(2055),
  [4783] = {.count = 1, .reusable = false}, SHIFT(2056),
  [4785] = {.count = 1, .reusable = true}, SHIFT(2056),
  [4787] = {.count = 1, .reusable = true}, SHIFT(2057),
  [4789] = {.count = 1, .reusable = true}, SHIFT(2058),
  [4791] = {.count = 1, .reusable = false}, SHIFT(2059),
  [4793] = {.count = 1, .reusable = true}, SHIFT(2060),
  [4795] = {.count = 1, .reusable = true}, SHIFT(2062),
  [4797] = {.count = 1, .reusable = true}, SHIFT(2063),
  [4799] = {.count = 1, .reusable = false}, SHIFT(2064),
  [4801] = {.count = 1, .reusable = true}, SHIFT(2064),
  [4803] = {.count = 1, .reusable = true}, SHIFT(2065),
  [4805] = {.count = 1, .reusable = false}, SHIFT(2066),
  [4807] = {.count = 1, .reusable = true}, SHIFT(2066),
  [4809] = {.count = 1, .reusable = true}, SHIFT(2067),
  [4811] = {.count = 1, .reusable = false}, SHIFT(2068),
  [4813] = {.count = 1, .reusable = true}, SHIFT(2068),
  [4815] = {.count = 1, .reusable = true}, SHIFT(2069),
  [4817] = {.count = 1, .reusable = false}, SHIFT(2070),
  [4819] = {.count = 1, .reusable = true}, SHIFT(2070),
  [4821] = {.count = 1, .reusable = false}, SHIFT(2071),
  [4823] = {.count = 1, .reusable = true}, SHIFT(2071),
  [4825] = {.count = 1, .reusable = true}, SHIFT(2072),
  [4827] = {.count = 1, .reusable = false}, SHIFT(2073),
  [4829] = {.count = 1, .reusable = true}, SHIFT(2073),
  [4831] = {.count = 1, .reusable = true}, SHIFT(2074),
  [4833] = {.count = 1, .reusable = true}, SHIFT(2075),
  [4835] = {.count = 1, .reusable = true}, SHIFT(2076),
  [4837] = {.count = 1, .reusable = false}, SHIFT(2077),
  [4839] = {.count = 1, .reusable = true}, SHIFT(2077),
  [4841] = {.count = 1, .reusable = false}, SHIFT(2078),
  [4843] = {.count = 1, .reusable = true}, SHIFT(2078),
  [4845] = {.count = 1, .reusable = true}, SHIFT(2079),
  [4847] = {.count = 1, .reusable = true}, SHIFT(2080),
  [4849] = {.count = 1, .reusable = true}, SHIFT(2081),
  [4851] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 7),
  [4853] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 7),
  [4855] = {.count = 1, .reusable = true}, SHIFT(2083),
  [4857] = {.count = 1, .reusable = true}, SHIFT(2084),
  [4859] = {.count = 1, .reusable = true}, SHIFT(2085),
  [4861] = {.count = 1, .reusable = true}, SHIFT(2086),
  [4863] = {.count = 1, .reusable = false}, SHIFT(2087),
  [4865] = {.count = 1, .reusable = true}, SHIFT(2087),
  [4867] = {.count = 1, .reusable = false}, SHIFT(2088),
  [4869] = {.count = 1, .reusable = true}, SHIFT(2088),
  [4871] = {.count = 1, .reusable = true}, SHIFT(2089),
  [4873] = {.count = 1, .reusable = true}, SHIFT(2090),
  [4875] = {.count = 1, .reusable = true}, SHIFT(2091),
  [4877] = {.count = 1, .reusable = true}, SHIFT(2092),
  [4879] = {.count = 1, .reusable = true}, SHIFT(2093),
  [4881] = {.count = 1, .reusable = true}, SHIFT(2094),
  [4883] = {.count = 1, .reusable = false}, SHIFT(2095),
  [4885] = {.count = 1, .reusable = true}, SHIFT(2096),
  [4887] = {.count = 1, .reusable = true}, SHIFT(2098),
  [4889] = {.count = 1, .reusable = true}, SHIFT(2099),
  [4891] = {.count = 1, .reusable = false}, SHIFT(2100),
  [4893] = {.count = 1, .reusable = true}, SHIFT(2100),
  [4895] = {.count = 1, .reusable = true}, SHIFT(2101),
  [4897] = {.count = 1, .reusable = false}, SHIFT(2102),
  [4899] = {.count = 1, .reusable = true}, SHIFT(2102),
  [4901] = {.count = 1, .reusable = true}, SHIFT(2103),
  [4903] = {.count = 1, .reusable = false}, SHIFT(2104),
  [4905] = {.count = 1, .reusable = true}, SHIFT(2104),
  [4907] = {.count = 1, .reusable = true}, SHIFT(2105),
  [4909] = {.count = 1, .reusable = false}, SHIFT(2106),
  [4911] = {.count = 1, .reusable = true}, SHIFT(2106),
  [4913] = {.count = 1, .reusable = false}, SHIFT(2107),
  [4915] = {.count = 1, .reusable = true}, SHIFT(2107),
  [4917] = {.count = 1, .reusable = true}, SHIFT(2108),
  [4919] = {.count = 1, .reusable = false}, SHIFT(2109),
  [4921] = {.count = 1, .reusable = true}, SHIFT(2109),
  [4923] = {.count = 1, .reusable = true}, SHIFT(2110),
  [4925] = {.count = 1, .reusable = true}, SHIFT(2111),
  [4927] = {.count = 1, .reusable = true}, SHIFT(2112),
  [4929] = {.count = 1, .reusable = false}, SHIFT(2113),
  [4931] = {.count = 1, .reusable = true}, SHIFT(2113),
  [4933] = {.count = 1, .reusable = false}, SHIFT(2114),
  [4935] = {.count = 1, .reusable = true}, SHIFT(2114),
  [4937] = {.count = 1, .reusable = true}, SHIFT(2115),
  [4939] = {.count = 1, .reusable = true}, SHIFT(2116),
  [4941] = {.count = 1, .reusable = true}, SHIFT(2117),
  [4943] = {.count = 1, .reusable = true}, SHIFT(2118),
  [4945] = {.count = 1, .reusable = true}, SHIFT(2119),
  [4947] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 4),
  [4949] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7),
  [4951] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7),
  [4953] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2, .alias_sequence_id = 2),
  [4955] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2),
  [4957] = {.count = 1, .reusable = true}, SHIFT(2120),
  [4959] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [4961] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [4963] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [4965] = {.count = 1, .reusable = true}, SHIFT(2121),
  [4967] = {.count = 1, .reusable = true}, SHIFT(2122),
  [4969] = {.count = 1, .reusable = true}, SHIFT(2123),
  [4971] = {.count = 1, .reusable = false}, SHIFT(2124),
  [4973] = {.count = 1, .reusable = true}, SHIFT(2125),
  [4975] = {.count = 1, .reusable = true}, SHIFT(2126),
  [4977] = {.count = 1, .reusable = true}, SHIFT(2127),
  [4979] = {.count = 1, .reusable = true}, SHIFT(2128),
  [4981] = {.count = 1, .reusable = true}, SHIFT(2129),
  [4983] = {.count = 1, .reusable = false}, SHIFT(2131),
  [4985] = {.count = 1, .reusable = false}, SHIFT(2125),
  [4987] = {.count = 1, .reusable = true}, SHIFT(2132),
  [4989] = {.count = 1, .reusable = true}, SHIFT(2133),
  [4991] = {.count = 1, .reusable = false}, SHIFT(2134),
  [4993] = {.count = 1, .reusable = true}, SHIFT(2135),
  [4995] = {.count = 1, .reusable = true}, SHIFT(2136),
  [4997] = {.count = 1, .reusable = true}, SHIFT(2137),
  [4999] = {.count = 1, .reusable = true}, SHIFT(2138),
  [5001] = {.count = 1, .reusable = true}, SHIFT(2139),
  [5003] = {.count = 1, .reusable = false}, SHIFT(2140),
  [5005] = {.count = 1, .reusable = false}, SHIFT(2135),
  [5007] = {.count = 1, .reusable = true}, SHIFT(2141),
  [5009] = {.count = 1, .reusable = false}, SHIFT(2143),
  [5011] = {.count = 1, .reusable = false}, SHIFT(2144),
  [5013] = {.count = 1, .reusable = true}, SHIFT(2146),
  [5015] = {.count = 1, .reusable = true}, SHIFT(2147),
  [5017] = {.count = 1, .reusable = false}, SHIFT(2148),
  [5019] = {.count = 1, .reusable = true}, SHIFT(2148),
  [5021] = {.count = 1, .reusable = true}, SHIFT(2149),
  [5023] = {.count = 1, .reusable = true}, SHIFT(2150),
  [5025] = {.count = 1, .reusable = true}, SHIFT(2151),
  [5027] = {.count = 1, .reusable = false}, SHIFT(2152),
  [5029] = {.count = 1, .reusable = true}, SHIFT(2152),
  [5031] = {.count = 1, .reusable = true}, SHIFT(2162),
  [5033] = {.count = 1, .reusable = false}, SHIFT(2163),
  [5035] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [5037] = {.count = 1, .reusable = false}, SHIFT(2164),
  [5039] = {.count = 1, .reusable = true}, SHIFT(2165),
  [5041] = {.count = 1, .reusable = true}, SHIFT(2164),
  [5043] = {.count = 1, .reusable = true}, SHIFT(2166),
  [5045] = {.count = 1, .reusable = false}, SHIFT(2167),
  [5047] = {.count = 1, .reusable = true}, SHIFT(2167),
  [5049] = {.count = 1, .reusable = true}, SHIFT(2168),
  [5051] = {.count = 1, .reusable = true}, SHIFT(2163),
  [5053] = {.count = 1, .reusable = false}, SHIFT(2171),
  [5055] = {.count = 1, .reusable = true}, SHIFT(2172),
  [5057] = {.count = 1, .reusable = true}, SHIFT(2173),
  [5059] = {.count = 1, .reusable = false}, SHIFT(2173),
  [5061] = {.count = 1, .reusable = true}, SHIFT(2175),
  [5063] = {.count = 1, .reusable = true}, SHIFT(1920),
  [5065] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2), SHIFT_REPEAT(1596),
  [5068] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3),
  [5070] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3),
  [5072] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3),
  [5074] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 3),
  [5076] = {.count = 1, .reusable = true}, SHIFT(2181),
  [5078] = {.count = 1, .reusable = true}, SHIFT(2182),
  [5080] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 2),
  [5082] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 2),
  [5084] = {.count = 1, .reusable = true}, SHIFT(2186),
  [5086] = {.count = 1, .reusable = true}, SHIFT(2188),
  [5088] = {.count = 1, .reusable = true}, SHIFT(2190),
  [5090] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7),
  [5092] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7),
  [5094] = {.count = 1, .reusable = true}, SHIFT(2191),
  [5096] = {.count = 1, .reusable = true}, SHIFT(2192),
  [5098] = {.count = 1, .reusable = true}, SHIFT(2193),
  [5100] = {.count = 1, .reusable = true}, SHIFT(2194),
  [5102] = {.count = 1, .reusable = true}, SHIFT(2195),
  [5104] = {.count = 1, .reusable = true}, SHIFT(2196),
  [5106] = {.count = 1, .reusable = true}, SHIFT(2197),
  [5108] = {.count = 1, .reusable = true}, SHIFT(2198),
  [5110] = {.count = 1, .reusable = true}, SHIFT(2199),
  [5112] = {.count = 1, .reusable = true}, SHIFT(2200),
  [5114] = {.count = 1, .reusable = true}, SHIFT(2201),
  [5116] = {.count = 1, .reusable = true}, SHIFT(2202),
  [5118] = {.count = 1, .reusable = true}, SHIFT(2203),
  [5120] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6, .alias_sequence_id = 4),
  [5122] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6),
  [5124] = {.count = 1, .reusable = true}, SHIFT(2204),
  [5126] = {.count = 1, .reusable = true}, SHIFT(2205),
  [5128] = {.count = 1, .reusable = false}, SHIFT(2206),
  [5130] = {.count = 1, .reusable = true}, SHIFT(2207),
  [5132] = {.count = 1, .reusable = true}, SHIFT(2209),
  [5134] = {.count = 1, .reusable = true}, SHIFT(2210),
  [5136] = {.count = 1, .reusable = false}, SHIFT(2211),
  [5138] = {.count = 1, .reusable = true}, SHIFT(2211),
  [5140] = {.count = 1, .reusable = true}, SHIFT(2212),
  [5142] = {.count = 1, .reusable = false}, SHIFT(2213),
  [5144] = {.count = 1, .reusable = true}, SHIFT(2213),
  [5146] = {.count = 1, .reusable = true}, SHIFT(2214),
  [5148] = {.count = 1, .reusable = false}, SHIFT(2215),
  [5150] = {.count = 1, .reusable = true}, SHIFT(2215),
  [5152] = {.count = 1, .reusable = true}, SHIFT(2216),
  [5154] = {.count = 1, .reusable = false}, SHIFT(2217),
  [5156] = {.count = 1, .reusable = true}, SHIFT(2217),
  [5158] = {.count = 1, .reusable = false}, SHIFT(2218),
  [5160] = {.count = 1, .reusable = true}, SHIFT(2218),
  [5162] = {.count = 1, .reusable = true}, SHIFT(2219),
  [5164] = {.count = 1, .reusable = false}, SHIFT(2220),
  [5166] = {.count = 1, .reusable = true}, SHIFT(2220),
  [5168] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 5),
  [5170] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 5),
  [5172] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7),
  [5174] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7),
  [5176] = {.count = 1, .reusable = true}, SHIFT(2221),
  [5178] = {.count = 1, .reusable = true}, SHIFT(2222),
  [5180] = {.count = 1, .reusable = true}, SHIFT(2223),
  [5182] = {.count = 1, .reusable = false}, SHIFT(2224),
  [5184] = {.count = 1, .reusable = true}, SHIFT(2224),
  [5186] = {.count = 1, .reusable = false}, SHIFT(2225),
  [5188] = {.count = 1, .reusable = true}, SHIFT(2225),
  [5190] = {.count = 1, .reusable = true}, SHIFT(2226),
  [5192] = {.count = 1, .reusable = true}, SHIFT(2227),
  [5194] = {.count = 1, .reusable = true}, SHIFT(2228),
  [5196] = {.count = 1, .reusable = true}, SHIFT(2229),
  [5198] = {.count = 1, .reusable = true}, SHIFT(2230),
  [5200] = {.count = 1, .reusable = true}, SHIFT(2231),
  [5202] = {.count = 1, .reusable = false}, SHIFT(2232),
  [5204] = {.count = 1, .reusable = true}, SHIFT(2232),
  [5206] = {.count = 1, .reusable = false}, SHIFT(2233),
  [5208] = {.count = 1, .reusable = true}, SHIFT(2233),
  [5210] = {.count = 1, .reusable = true}, SHIFT(2234),
  [5212] = {.count = 1, .reusable = true}, SHIFT(2235),
  [5214] = {.count = 1, .reusable = true}, SHIFT(2236),
  [5216] = {.count = 1, .reusable = true}, SHIFT(2237),
  [5218] = {.count = 1, .reusable = false}, SHIFT(2238),
  [5220] = {.count = 1, .reusable = true}, SHIFT(2238),
  [5222] = {.count = 1, .reusable = false}, SHIFT(2239),
  [5224] = {.count = 1, .reusable = true}, SHIFT(2239),
  [5226] = {.count = 1, .reusable = true}, SHIFT(2240),
  [5228] = {.count = 1, .reusable = true}, SHIFT(2241),
  [5230] = {.count = 1, .reusable = true}, SHIFT(2242),
  [5232] = {.count = 1, .reusable = true}, SHIFT(2243),
  [5234] = {.count = 1, .reusable = true}, SHIFT(2244),
  [5236] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 8),
  [5238] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 8),
  [5240] = {.count = 1, .reusable = true}, SHIFT(2246),
  [5242] = {.count = 1, .reusable = true}, SHIFT(2247),
  [5244] = {.count = 1, .reusable = true}, SHIFT(2248),
  [5246] = {.count = 1, .reusable = true}, SHIFT(2249),
  [5248] = {.count = 1, .reusable = true}, SHIFT(2250),
  [5250] = {.count = 1, .reusable = true}, SHIFT(2251),
  [5252] = {.count = 1, .reusable = false}, SHIFT(2252),
  [5254] = {.count = 1, .reusable = true}, SHIFT(2252),
  [5256] = {.count = 1, .reusable = false}, SHIFT(2253),
  [5258] = {.count = 1, .reusable = true}, SHIFT(2253),
  [5260] = {.count = 1, .reusable = true}, SHIFT(2254),
  [5262] = {.count = 1, .reusable = true}, SHIFT(2255),
  [5264] = {.count = 1, .reusable = true}, SHIFT(2256),
  [5266] = {.count = 1, .reusable = true}, SHIFT(2257),
  [5268] = {.count = 1, .reusable = true}, SHIFT(2258),
  [5270] = {.count = 1, .reusable = true}, SHIFT(2259),
  [5272] = {.count = 1, .reusable = true}, SHIFT(2260),
  [5274] = {.count = 1, .reusable = true}, SHIFT(2261),
  [5276] = {.count = 1, .reusable = true}, SHIFT(2262),
  [5278] = {.count = 1, .reusable = false}, SHIFT(2263),
  [5280] = {.count = 1, .reusable = true}, SHIFT(2264),
  [5282] = {.count = 1, .reusable = true}, SHIFT(2265),
  [5284] = {.count = 1, .reusable = true}, SHIFT(2266),
  [5286] = {.count = 1, .reusable = true}, SHIFT(2267),
  [5288] = {.count = 1, .reusable = true}, SHIFT(2268),
  [5290] = {.count = 1, .reusable = true}, SHIFT(2269),
  [5292] = {.count = 1, .reusable = true}, SHIFT(2270),
  [5294] = {.count = 1, .reusable = false}, SHIFT(2272),
  [5296] = {.count = 1, .reusable = false}, SHIFT(2273),
  [5298] = {.count = 1, .reusable = true}, SHIFT(2275),
  [5300] = {.count = 1, .reusable = true}, SHIFT(2276),
  [5302] = {.count = 1, .reusable = false}, SHIFT(2277),
  [5304] = {.count = 1, .reusable = true}, SHIFT(2277),
  [5306] = {.count = 1, .reusable = true}, SHIFT(2278),
  [5308] = {.count = 1, .reusable = true}, SHIFT(2279),
  [5310] = {.count = 1, .reusable = true}, SHIFT(2280),
  [5312] = {.count = 1, .reusable = false}, SHIFT(2281),
  [5314] = {.count = 1, .reusable = true}, SHIFT(2281),
  [5316] = {.count = 1, .reusable = false}, SHIFT(2291),
  [5318] = {.count = 1, .reusable = true}, SHIFT(2292),
  [5320] = {.count = 1, .reusable = false}, SHIFT(2294),
  [5322] = {.count = 1, .reusable = false}, SHIFT(2295),
  [5324] = {.count = 1, .reusable = true}, SHIFT(2297),
  [5326] = {.count = 1, .reusable = true}, SHIFT(2298),
  [5328] = {.count = 1, .reusable = false}, SHIFT(2299),
  [5330] = {.count = 1, .reusable = true}, SHIFT(2299),
  [5332] = {.count = 1, .reusable = true}, SHIFT(2300),
  [5334] = {.count = 1, .reusable = true}, SHIFT(2301),
  [5336] = {.count = 1, .reusable = true}, SHIFT(2302),
  [5338] = {.count = 1, .reusable = false}, SHIFT(2303),
  [5340] = {.count = 1, .reusable = true}, SHIFT(2303),
  [5342] = {.count = 1, .reusable = false}, SHIFT(2313),
  [5344] = {.count = 1, .reusable = true}, SHIFT(2314),
  [5346] = {.count = 1, .reusable = false}, SHIFT(2316),
  [5348] = {.count = 1, .reusable = false}, SHIFT(2317),
  [5350] = {.count = 1, .reusable = true}, SHIFT(2318),
  [5352] = {.count = 1, .reusable = true}, SHIFT(2319),
  [5354] = {.count = 1, .reusable = true}, SHIFT(2320),
  [5356] = {.count = 1, .reusable = false}, SHIFT(2321),
  [5358] = {.count = 1, .reusable = true}, SHIFT(2321),
  [5360] = {.count = 1, .reusable = true}, SHIFT(2322),
  [5362] = {.count = 1, .reusable = false}, SHIFT(2324),
  [5364] = {.count = 1, .reusable = true}, SHIFT(2324),
  [5366] = {.count = 1, .reusable = true}, SHIFT(2323),
  [5368] = {.count = 1, .reusable = true}, SHIFT(2325),
  [5370] = {.count = 1, .reusable = false}, SHIFT(2327),
  [5372] = {.count = 1, .reusable = true}, SHIFT(2327),
  [5374] = {.count = 1, .reusable = true}, SHIFT(2326),
  [5376] = {.count = 1, .reusable = false}, SHIFT(2328),
  [5378] = {.count = 1, .reusable = true}, SHIFT(2329),
  [5380] = {.count = 1, .reusable = true}, SHIFT(2328),
  [5382] = {.count = 1, .reusable = false}, SHIFT(2333),
  [5384] = {.count = 1, .reusable = true}, SHIFT(2333),
  [5386] = {.count = 1, .reusable = false}, SHIFT(2337),
  [5388] = {.count = 1, .reusable = true}, SHIFT(2338),
  [5390] = {.count = 1, .reusable = true}, SHIFT(2337),
  [5392] = {.count = 1, .reusable = false}, SHIFT(2342),
  [5394] = {.count = 1, .reusable = true}, SHIFT(2342),
  [5396] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [5398] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [5400] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [5402] = {.count = 1, .reusable = true}, SHIFT(2347),
  [5404] = {.count = 1, .reusable = true}, SHIFT(2348),
  [5406] = {.count = 1, .reusable = false}, SHIFT(2349),
  [5408] = {.count = 1, .reusable = true}, SHIFT(2350),
  [5410] = {.count = 1, .reusable = true}, SHIFT(2351),
  [5412] = {.count = 1, .reusable = true}, SHIFT(2352),
  [5414] = {.count = 1, .reusable = true}, SHIFT(2353),
  [5416] = {.count = 1, .reusable = true}, SHIFT(2354),
  [5418] = {.count = 1, .reusable = true}, SHIFT(2355),
  [5420] = {.count = 1, .reusable = true}, SHIFT(2356),
  [5422] = {.count = 1, .reusable = false}, SHIFT(2357),
  [5424] = {.count = 1, .reusable = true}, SHIFT(2357),
  [5426] = {.count = 1, .reusable = true}, SHIFT(2359),
  [5428] = {.count = 1, .reusable = true}, SHIFT(2360),
  [5430] = {.count = 1, .reusable = true}, SHIFT(2361),
  [5432] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [5434] = {.count = 1, .reusable = true}, SHIFT(2363),
  [5436] = {.count = 1, .reusable = true}, SHIFT(2367),
  [5438] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4),
  [5440] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4),
  [5442] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4),
  [5444] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 4),
  [5446] = {.count = 1, .reusable = true}, SHIFT(2370),
  [5448] = {.count = 1, .reusable = true}, SHIFT(2371),
  [5450] = {.count = 1, .reusable = true}, SHIFT(2374),
  [5452] = {.count = 1, .reusable = true}, SHIFT(2378),
  [5454] = {.count = 1, .reusable = true}, SHIFT(2379),
  [5456] = {.count = 1, .reusable = true}, SHIFT(2383),
  [5458] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 2),
  [5460] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 2),
  [5462] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8),
  [5464] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8),
  [5466] = {.count = 1, .reusable = true}, SHIFT(2384),
  [5468] = {.count = 1, .reusable = true}, SHIFT(2385),
  [5470] = {.count = 1, .reusable = true}, SHIFT(2386),
  [5472] = {.count = 1, .reusable = false}, SHIFT(2387),
  [5474] = {.count = 1, .reusable = true}, SHIFT(2387),
  [5476] = {.count = 1, .reusable = false}, SHIFT(2388),
  [5478] = {.count = 1, .reusable = true}, SHIFT(2388),
  [5480] = {.count = 1, .reusable = true}, SHIFT(2389),
  [5482] = {.count = 1, .reusable = true}, SHIFT(2390),
  [5484] = {.count = 1, .reusable = true}, SHIFT(2391),
  [5486] = {.count = 1, .reusable = true}, SHIFT(2392),
  [5488] = {.count = 1, .reusable = true}, SHIFT(2393),
  [5490] = {.count = 1, .reusable = true}, SHIFT(2394),
  [5492] = {.count = 1, .reusable = true}, SHIFT(2395),
  [5494] = {.count = 1, .reusable = true}, SHIFT(2396),
  [5496] = {.count = 1, .reusable = true}, SHIFT(2397),
  [5498] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 9),
  [5500] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 9),
  [5502] = {.count = 1, .reusable = true}, SHIFT(2399),
  [5504] = {.count = 1, .reusable = true}, SHIFT(2400),
  [5506] = {.count = 1, .reusable = true}, SHIFT(2401),
  [5508] = {.count = 1, .reusable = true}, SHIFT(2403),
  [5510] = {.count = 1, .reusable = false}, SHIFT(2405),
  [5512] = {.count = 1, .reusable = false}, SHIFT(2406),
  [5514] = {.count = 1, .reusable = true}, SHIFT(2408),
  [5516] = {.count = 1, .reusable = true}, SHIFT(2409),
  [5518] = {.count = 1, .reusable = false}, SHIFT(2410),
  [5520] = {.count = 1, .reusable = true}, SHIFT(2410),
  [5522] = {.count = 1, .reusable = true}, SHIFT(2411),
  [5524] = {.count = 1, .reusable = true}, SHIFT(2412),
  [5526] = {.count = 1, .reusable = true}, SHIFT(2413),
  [5528] = {.count = 1, .reusable = false}, SHIFT(2414),
  [5530] = {.count = 1, .reusable = true}, SHIFT(2414),
  [5532] = {.count = 1, .reusable = true}, SHIFT(2424),
  [5534] = {.count = 1, .reusable = true}, SHIFT(2425),
  [5536] = {.count = 1, .reusable = true}, SHIFT(2426),
  [5538] = {.count = 1, .reusable = true}, SHIFT(2427),
  [5540] = {.count = 1, .reusable = true}, SHIFT(2428),
  [5542] = {.count = 1, .reusable = false}, SHIFT(2430),
  [5544] = {.count = 1, .reusable = false}, SHIFT(2431),
  [5546] = {.count = 1, .reusable = true}, SHIFT(2432),
  [5548] = {.count = 1, .reusable = true}, SHIFT(2433),
  [5550] = {.count = 1, .reusable = true}, SHIFT(2434),
  [5552] = {.count = 1, .reusable = false}, SHIFT(2435),
  [5554] = {.count = 1, .reusable = true}, SHIFT(2435),
  [5556] = {.count = 1, .reusable = true}, SHIFT(2436),
  [5558] = {.count = 1, .reusable = false}, SHIFT(2438),
  [5560] = {.count = 1, .reusable = true}, SHIFT(2438),
  [5562] = {.count = 1, .reusable = true}, SHIFT(2437),
  [5564] = {.count = 1, .reusable = true}, SHIFT(2439),
  [5566] = {.count = 1, .reusable = false}, SHIFT(2441),
  [5568] = {.count = 1, .reusable = true}, SHIFT(2441),
  [5570] = {.count = 1, .reusable = true}, SHIFT(2440),
  [5572] = {.count = 1, .reusable = false}, SHIFT(2442),
  [5574] = {.count = 1, .reusable = true}, SHIFT(2443),
  [5576] = {.count = 1, .reusable = true}, SHIFT(2442),
  [5578] = {.count = 1, .reusable = false}, SHIFT(2447),
  [5580] = {.count = 1, .reusable = true}, SHIFT(2447),
  [5582] = {.count = 1, .reusable = false}, SHIFT(2451),
  [5584] = {.count = 1, .reusable = true}, SHIFT(2452),
  [5586] = {.count = 1, .reusable = true}, SHIFT(2451),
  [5588] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2121),
  [5591] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2122),
  [5594] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2123),
  [5597] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2124),
  [5600] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2125),
  [5603] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2126),
  [5606] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2127),
  [5609] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2128),
  [5612] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2129),
  [5615] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2291),
  [5618] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2125),
  [5621] = {.count = 1, .reusable = true}, SHIFT(2456),
  [5623] = {.count = 1, .reusable = false}, SHIFT(2458),
  [5625] = {.count = 1, .reusable = false}, SHIFT(2459),
  [5627] = {.count = 1, .reusable = true}, SHIFT(2460),
  [5629] = {.count = 1, .reusable = true}, SHIFT(2461),
  [5631] = {.count = 1, .reusable = true}, SHIFT(2462),
  [5633] = {.count = 1, .reusable = false}, SHIFT(2463),
  [5635] = {.count = 1, .reusable = true}, SHIFT(2463),
  [5637] = {.count = 1, .reusable = true}, SHIFT(2464),
  [5639] = {.count = 1, .reusable = false}, SHIFT(2466),
  [5641] = {.count = 1, .reusable = true}, SHIFT(2466),
  [5643] = {.count = 1, .reusable = true}, SHIFT(2465),
  [5645] = {.count = 1, .reusable = true}, SHIFT(2467),
  [5647] = {.count = 1, .reusable = false}, SHIFT(2469),
  [5649] = {.count = 1, .reusable = true}, SHIFT(2469),
  [5651] = {.count = 1, .reusable = true}, SHIFT(2468),
  [5653] = {.count = 1, .reusable = false}, SHIFT(2470),
  [5655] = {.count = 1, .reusable = true}, SHIFT(2471),
  [5657] = {.count = 1, .reusable = true}, SHIFT(2470),
  [5659] = {.count = 1, .reusable = false}, SHIFT(2475),
  [5661] = {.count = 1, .reusable = true}, SHIFT(2475),
  [5663] = {.count = 1, .reusable = false}, SHIFT(2479),
  [5665] = {.count = 1, .reusable = true}, SHIFT(2480),
  [5667] = {.count = 1, .reusable = true}, SHIFT(2479),
  [5669] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2132),
  [5672] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2133),
  [5675] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2134),
  [5678] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2135),
  [5681] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2136),
  [5684] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2137),
  [5687] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2138),
  [5690] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2139),
  [5693] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2313),
  [5696] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2135),
  [5699] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2141),
  [5702] = {.count = 1, .reusable = false}, SHIFT(2484),
  [5704] = {.count = 1, .reusable = true}, SHIFT(2485),
  [5706] = {.count = 1, .reusable = false}, SHIFT(2486),
  [5708] = {.count = 1, .reusable = true}, SHIFT(2487),
  [5710] = {.count = 1, .reusable = true}, SHIFT(2489),
  [5712] = {.count = 1, .reusable = true}, SHIFT(2490),
  [5714] = {.count = 1, .reusable = false}, SHIFT(2492),
  [5716] = {.count = 1, .reusable = true}, SHIFT(2492),
  [5718] = {.count = 1, .reusable = true}, SHIFT(2491),
  [5720] = {.count = 1, .reusable = false}, SHIFT(2494),
  [5722] = {.count = 1, .reusable = true}, SHIFT(2494),
  [5724] = {.count = 1, .reusable = true}, SHIFT(2493),
  [5726] = {.count = 1, .reusable = true}, SHIFT(2495),
  [5728] = {.count = 1, .reusable = true}, SHIFT(2496),
  [5730] = {.count = 1, .reusable = false}, SHIFT(2497),
  [5732] = {.count = 1, .reusable = true}, SHIFT(2497),
  [5734] = {.count = 1, .reusable = true}, SHIFT(2498),
  [5736] = {.count = 1, .reusable = true}, SHIFT(2499),
  [5738] = {.count = 1, .reusable = false}, SHIFT(2500),
  [5740] = {.count = 1, .reusable = true}, SHIFT(2500),
  [5742] = {.count = 1, .reusable = false}, SHIFT(2501),
  [5744] = {.count = 1, .reusable = true}, SHIFT(2501),
  [5746] = {.count = 1, .reusable = false}, SHIFT(2503),
  [5748] = {.count = 1, .reusable = true}, SHIFT(2503),
  [5750] = {.count = 1, .reusable = false}, SHIFT(2504),
  [5752] = {.count = 1, .reusable = true}, SHIFT(2504),
  [5754] = {.count = 1, .reusable = true}, SHIFT(2506),
  [5756] = {.count = 1, .reusable = false}, SHIFT(2507),
  [5758] = {.count = 1, .reusable = true}, SHIFT(2507),
  [5760] = {.count = 1, .reusable = false}, SHIFT(2508),
  [5762] = {.count = 1, .reusable = true}, SHIFT(2508),
  [5764] = {.count = 1, .reusable = true}, SHIFT(2510),
  [5766] = {.count = 1, .reusable = true}, SHIFT(2511),
  [5768] = {.count = 1, .reusable = true}, SHIFT(2512),
  [5770] = {.count = 1, .reusable = false}, SHIFT(2514),
  [5772] = {.count = 1, .reusable = false}, SHIFT(2515),
  [5774] = {.count = 1, .reusable = true}, SHIFT(2517),
  [5776] = {.count = 1, .reusable = true}, SHIFT(2518),
  [5778] = {.count = 1, .reusable = false}, SHIFT(2519),
  [5780] = {.count = 1, .reusable = true}, SHIFT(2519),
  [5782] = {.count = 1, .reusable = true}, SHIFT(2520),
  [5784] = {.count = 1, .reusable = true}, SHIFT(2521),
  [5786] = {.count = 1, .reusable = true}, SHIFT(2522),
  [5788] = {.count = 1, .reusable = false}, SHIFT(2523),
  [5790] = {.count = 1, .reusable = true}, SHIFT(2523),
  [5792] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2162),
  [5795] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2167),
  [5798] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2167),
  [5801] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2168),
  [5804] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2171),
  [5807] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2172),
  [5810] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1921),
  [5813] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1922),
  [5816] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2173),
  [5819] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1924),
  [5822] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1925),
  [5825] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1926),
  [5828] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1927),
  [5831] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2173),
  [5834] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5, .alias_sequence_id = 1),
  [5836] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [5838] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [5840] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 5, .alias_sequence_id = 1),
  [5842] = {.count = 1, .reusable = true}, SHIFT(2533),
  [5844] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5),
  [5846] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5),
  [5848] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5),
  [5850] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 5),
  [5852] = {.count = 1, .reusable = true}, SHIFT(2534),
  [5854] = {.count = 1, .reusable = true}, SHIFT(2535),
  [5856] = {.count = 1, .reusable = true}, SHIFT(2536),
  [5858] = {.count = 1, .reusable = true}, SHIFT(2541),
  [5860] = {.count = 1, .reusable = true}, SHIFT(2542),
  [5862] = {.count = 1, .reusable = true}, SHIFT(2546),
  [5864] = {.count = 1, .reusable = true}, SHIFT(2547),
  [5866] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 10),
  [5868] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 10),
  [5870] = {.count = 1, .reusable = true}, SHIFT(2548),
  [5872] = {.count = 1, .reusable = true}, SHIFT(2549),
  [5874] = {.count = 1, .reusable = false}, SHIFT(2551),
  [5876] = {.count = 1, .reusable = false}, SHIFT(2552),
  [5878] = {.count = 1, .reusable = true}, SHIFT(2553),
  [5880] = {.count = 1, .reusable = true}, SHIFT(2554),
  [5882] = {.count = 1, .reusable = true}, SHIFT(2555),
  [5884] = {.count = 1, .reusable = false}, SHIFT(2556),
  [5886] = {.count = 1, .reusable = true}, SHIFT(2556),
  [5888] = {.count = 1, .reusable = true}, SHIFT(2557),
  [5890] = {.count = 1, .reusable = false}, SHIFT(2559),
  [5892] = {.count = 1, .reusable = true}, SHIFT(2559),
  [5894] = {.count = 1, .reusable = true}, SHIFT(2558),
  [5896] = {.count = 1, .reusable = true}, SHIFT(2560),
  [5898] = {.count = 1, .reusable = false}, SHIFT(2562),
  [5900] = {.count = 1, .reusable = true}, SHIFT(2562),
  [5902] = {.count = 1, .reusable = true}, SHIFT(2561),
  [5904] = {.count = 1, .reusable = false}, SHIFT(2563),
  [5906] = {.count = 1, .reusable = true}, SHIFT(2564),
  [5908] = {.count = 1, .reusable = true}, SHIFT(2563),
  [5910] = {.count = 1, .reusable = false}, SHIFT(2568),
  [5912] = {.count = 1, .reusable = true}, SHIFT(2568),
  [5914] = {.count = 1, .reusable = false}, SHIFT(2572),
  [5916] = {.count = 1, .reusable = true}, SHIFT(2573),
  [5918] = {.count = 1, .reusable = true}, SHIFT(2572),
  [5920] = {.count = 1, .reusable = true}, SHIFT(2577),
  [5922] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2270),
  [5925] = {.count = 1, .reusable = false}, SHIFT(2579),
  [5927] = {.count = 1, .reusable = true}, SHIFT(2580),
  [5929] = {.count = 1, .reusable = false}, SHIFT(2581),
  [5931] = {.count = 1, .reusable = true}, SHIFT(2582),
  [5933] = {.count = 1, .reusable = true}, SHIFT(2584),
  [5935] = {.count = 1, .reusable = true}, SHIFT(2585),
  [5937] = {.count = 1, .reusable = false}, SHIFT(2587),
  [5939] = {.count = 1, .reusable = true}, SHIFT(2587),
  [5941] = {.count = 1, .reusable = true}, SHIFT(2586),
  [5943] = {.count = 1, .reusable = false}, SHIFT(2589),
  [5945] = {.count = 1, .reusable = true}, SHIFT(2589),
  [5947] = {.count = 1, .reusable = true}, SHIFT(2588),
  [5949] = {.count = 1, .reusable = true}, SHIFT(2590),
  [5951] = {.count = 1, .reusable = true}, SHIFT(2591),
  [5953] = {.count = 1, .reusable = false}, SHIFT(2592),
  [5955] = {.count = 1, .reusable = true}, SHIFT(2592),
  [5957] = {.count = 1, .reusable = true}, SHIFT(2593),
  [5959] = {.count = 1, .reusable = true}, SHIFT(2594),
  [5961] = {.count = 1, .reusable = false}, SHIFT(2595),
  [5963] = {.count = 1, .reusable = true}, SHIFT(2595),
  [5965] = {.count = 1, .reusable = false}, SHIFT(2596),
  [5967] = {.count = 1, .reusable = true}, SHIFT(2596),
  [5969] = {.count = 1, .reusable = false}, SHIFT(2598),
  [5971] = {.count = 1, .reusable = true}, SHIFT(2598),
  [5973] = {.count = 1, .reusable = false}, SHIFT(2599),
  [5975] = {.count = 1, .reusable = true}, SHIFT(2599),
  [5977] = {.count = 1, .reusable = true}, SHIFT(2601),
  [5979] = {.count = 1, .reusable = false}, SHIFT(2602),
  [5981] = {.count = 1, .reusable = true}, SHIFT(2602),
  [5983] = {.count = 1, .reusable = false}, SHIFT(2603),
  [5985] = {.count = 1, .reusable = true}, SHIFT(2603),
  [5987] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2292),
  [5990] = {.count = 1, .reusable = false}, SHIFT(2605),
  [5992] = {.count = 1, .reusable = true}, SHIFT(2606),
  [5994] = {.count = 1, .reusable = false}, SHIFT(2607),
  [5996] = {.count = 1, .reusable = true}, SHIFT(2608),
  [5998] = {.count = 1, .reusable = true}, SHIFT(2610),
  [6000] = {.count = 1, .reusable = true}, SHIFT(2611),
  [6002] = {.count = 1, .reusable = false}, SHIFT(2613),
  [6004] = {.count = 1, .reusable = true}, SHIFT(2613),
  [6006] = {.count = 1, .reusable = true}, SHIFT(2612),
  [6008] = {.count = 1, .reusable = false}, SHIFT(2615),
  [6010] = {.count = 1, .reusable = true}, SHIFT(2615),
  [6012] = {.count = 1, .reusable = true}, SHIFT(2614),
  [6014] = {.count = 1, .reusable = true}, SHIFT(2616),
  [6016] = {.count = 1, .reusable = true}, SHIFT(2617),
  [6018] = {.count = 1, .reusable = false}, SHIFT(2618),
  [6020] = {.count = 1, .reusable = true}, SHIFT(2618),
  [6022] = {.count = 1, .reusable = true}, SHIFT(2619),
  [6024] = {.count = 1, .reusable = true}, SHIFT(2620),
  [6026] = {.count = 1, .reusable = false}, SHIFT(2621),
  [6028] = {.count = 1, .reusable = true}, SHIFT(2621),
  [6030] = {.count = 1, .reusable = false}, SHIFT(2622),
  [6032] = {.count = 1, .reusable = true}, SHIFT(2622),
  [6034] = {.count = 1, .reusable = false}, SHIFT(2624),
  [6036] = {.count = 1, .reusable = true}, SHIFT(2624),
  [6038] = {.count = 1, .reusable = false}, SHIFT(2625),
  [6040] = {.count = 1, .reusable = true}, SHIFT(2625),
  [6042] = {.count = 1, .reusable = true}, SHIFT(2627),
  [6044] = {.count = 1, .reusable = false}, SHIFT(2628),
  [6046] = {.count = 1, .reusable = true}, SHIFT(2628),
  [6048] = {.count = 1, .reusable = false}, SHIFT(2629),
  [6050] = {.count = 1, .reusable = true}, SHIFT(2629),
  [6052] = {.count = 1, .reusable = true}, SHIFT(2631),
  [6054] = {.count = 1, .reusable = true}, SHIFT(2632),
  [6056] = {.count = 1, .reusable = false}, SHIFT(2633),
  [6058] = {.count = 1, .reusable = true}, SHIFT(2634),
  [6060] = {.count = 1, .reusable = true}, SHIFT(2636),
  [6062] = {.count = 1, .reusable = true}, SHIFT(2637),
  [6064] = {.count = 1, .reusable = false}, SHIFT(2638),
  [6066] = {.count = 1, .reusable = true}, SHIFT(2638),
  [6068] = {.count = 1, .reusable = true}, SHIFT(2639),
  [6070] = {.count = 1, .reusable = false}, SHIFT(2640),
  [6072] = {.count = 1, .reusable = true}, SHIFT(2640),
  [6074] = {.count = 1, .reusable = true}, SHIFT(2641),
  [6076] = {.count = 1, .reusable = false}, SHIFT(2642),
  [6078] = {.count = 1, .reusable = true}, SHIFT(2642),
  [6080] = {.count = 1, .reusable = true}, SHIFT(2643),
  [6082] = {.count = 1, .reusable = false}, SHIFT(2644),
  [6084] = {.count = 1, .reusable = true}, SHIFT(2644),
  [6086] = {.count = 1, .reusable = false}, SHIFT(2645),
  [6088] = {.count = 1, .reusable = true}, SHIFT(2645),
  [6090] = {.count = 1, .reusable = true}, SHIFT(2646),
  [6092] = {.count = 1, .reusable = false}, SHIFT(2647),
  [6094] = {.count = 1, .reusable = true}, SHIFT(2647),
  [6096] = {.count = 1, .reusable = true}, SHIFT(2648),
  [6098] = {.count = 1, .reusable = false}, SHIFT(2650),
  [6100] = {.count = 1, .reusable = false}, SHIFT(2651),
  [6102] = {.count = 1, .reusable = true}, SHIFT(2652),
  [6104] = {.count = 1, .reusable = true}, SHIFT(2653),
  [6106] = {.count = 1, .reusable = true}, SHIFT(2654),
  [6108] = {.count = 1, .reusable = false}, SHIFT(2655),
  [6110] = {.count = 1, .reusable = true}, SHIFT(2655),
  [6112] = {.count = 1, .reusable = true}, SHIFT(2656),
  [6114] = {.count = 1, .reusable = false}, SHIFT(2658),
  [6116] = {.count = 1, .reusable = true}, SHIFT(2658),
  [6118] = {.count = 1, .reusable = true}, SHIFT(2657),
  [6120] = {.count = 1, .reusable = true}, SHIFT(2659),
  [6122] = {.count = 1, .reusable = false}, SHIFT(2661),
  [6124] = {.count = 1, .reusable = true}, SHIFT(2661),
  [6126] = {.count = 1, .reusable = true}, SHIFT(2660),
  [6128] = {.count = 1, .reusable = false}, SHIFT(2662),
  [6130] = {.count = 1, .reusable = true}, SHIFT(2663),
  [6132] = {.count = 1, .reusable = true}, SHIFT(2662),
  [6134] = {.count = 1, .reusable = false}, SHIFT(2667),
  [6136] = {.count = 1, .reusable = true}, SHIFT(2667),
  [6138] = {.count = 1, .reusable = false}, SHIFT(2671),
  [6140] = {.count = 1, .reusable = true}, SHIFT(2672),
  [6142] = {.count = 1, .reusable = true}, SHIFT(2671),
  [6144] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 6, .alias_sequence_id = 1),
  [6146] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 6, .alias_sequence_id = 1),
  [6148] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 6, .alias_sequence_id = 1),
  [6150] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 6),
  [6152] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 6),
  [6154] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 6),
  [6156] = {.count = 1, .reusable = true}, SHIFT(2676),
  [6158] = {.count = 1, .reusable = true}, SHIFT(2677),
  [6160] = {.count = 1, .reusable = true}, SHIFT(2680),
  [6162] = {.count = 1, .reusable = true}, SHIFT(2681),
  [6164] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2403),
  [6167] = {.count = 1, .reusable = false}, SHIFT(2684),
  [6169] = {.count = 1, .reusable = true}, SHIFT(2685),
  [6171] = {.count = 1, .reusable = false}, SHIFT(2686),
  [6173] = {.count = 1, .reusable = true}, SHIFT(2687),
  [6175] = {.count = 1, .reusable = true}, SHIFT(2689),
  [6177] = {.count = 1, .reusable = true}, SHIFT(2690),
  [6179] = {.count = 1, .reusable = false}, SHIFT(2692),
  [6181] = {.count = 1, .reusable = true}, SHIFT(2692),
  [6183] = {.count = 1, .reusable = true}, SHIFT(2691),
  [6185] = {.count = 1, .reusable = false}, SHIFT(2694),
  [6187] = {.count = 1, .reusable = true}, SHIFT(2694),
  [6189] = {.count = 1, .reusable = true}, SHIFT(2693),
  [6191] = {.count = 1, .reusable = true}, SHIFT(2695),
  [6193] = {.count = 1, .reusable = true}, SHIFT(2696),
  [6195] = {.count = 1, .reusable = false}, SHIFT(2697),
  [6197] = {.count = 1, .reusable = true}, SHIFT(2697),
  [6199] = {.count = 1, .reusable = true}, SHIFT(2698),
  [6201] = {.count = 1, .reusable = true}, SHIFT(2699),
  [6203] = {.count = 1, .reusable = false}, SHIFT(2700),
  [6205] = {.count = 1, .reusable = true}, SHIFT(2700),
  [6207] = {.count = 1, .reusable = false}, SHIFT(2701),
  [6209] = {.count = 1, .reusable = true}, SHIFT(2701),
  [6211] = {.count = 1, .reusable = false}, SHIFT(2703),
  [6213] = {.count = 1, .reusable = true}, SHIFT(2703),
  [6215] = {.count = 1, .reusable = false}, SHIFT(2704),
  [6217] = {.count = 1, .reusable = true}, SHIFT(2704),
  [6219] = {.count = 1, .reusable = true}, SHIFT(2706),
  [6221] = {.count = 1, .reusable = false}, SHIFT(2707),
  [6223] = {.count = 1, .reusable = true}, SHIFT(2707),
  [6225] = {.count = 1, .reusable = false}, SHIFT(2708),
  [6227] = {.count = 1, .reusable = true}, SHIFT(2708),
  [6229] = {.count = 1, .reusable = true}, SHIFT(2710),
  [6231] = {.count = 1, .reusable = true}, SHIFT(2711),
  [6233] = {.count = 1, .reusable = true}, SHIFT(2712),
  [6235] = {.count = 1, .reusable = false}, SHIFT(2713),
  [6237] = {.count = 1, .reusable = true}, SHIFT(2714),
  [6239] = {.count = 1, .reusable = true}, SHIFT(2716),
  [6241] = {.count = 1, .reusable = true}, SHIFT(2717),
  [6243] = {.count = 1, .reusable = false}, SHIFT(2718),
  [6245] = {.count = 1, .reusable = true}, SHIFT(2718),
  [6247] = {.count = 1, .reusable = true}, SHIFT(2719),
  [6249] = {.count = 1, .reusable = false}, SHIFT(2720),
  [6251] = {.count = 1, .reusable = true}, SHIFT(2720),
  [6253] = {.count = 1, .reusable = true}, SHIFT(2721),
  [6255] = {.count = 1, .reusable = false}, SHIFT(2722),
  [6257] = {.count = 1, .reusable = true}, SHIFT(2722),
  [6259] = {.count = 1, .reusable = true}, SHIFT(2723),
  [6261] = {.count = 1, .reusable = false}, SHIFT(2724),
  [6263] = {.count = 1, .reusable = true}, SHIFT(2724),
  [6265] = {.count = 1, .reusable = false}, SHIFT(2725),
  [6267] = {.count = 1, .reusable = true}, SHIFT(2725),
  [6269] = {.count = 1, .reusable = true}, SHIFT(2726),
  [6271] = {.count = 1, .reusable = false}, SHIFT(2727),
  [6273] = {.count = 1, .reusable = true}, SHIFT(2727),
  [6275] = {.count = 1, .reusable = true}, SHIFT(2728),
  [6277] = {.count = 1, .reusable = true}, SHIFT(2729),
  [6279] = {.count = 1, .reusable = false}, SHIFT(2730),
  [6281] = {.count = 1, .reusable = true}, SHIFT(2731),
  [6283] = {.count = 1, .reusable = true}, SHIFT(2733),
  [6285] = {.count = 1, .reusable = true}, SHIFT(2734),
  [6287] = {.count = 1, .reusable = false}, SHIFT(2735),
  [6289] = {.count = 1, .reusable = true}, SHIFT(2735),
  [6291] = {.count = 1, .reusable = true}, SHIFT(2736),
  [6293] = {.count = 1, .reusable = false}, SHIFT(2737),
  [6295] = {.count = 1, .reusable = true}, SHIFT(2737),
  [6297] = {.count = 1, .reusable = true}, SHIFT(2738),
  [6299] = {.count = 1, .reusable = false}, SHIFT(2739),
  [6301] = {.count = 1, .reusable = true}, SHIFT(2739),
  [6303] = {.count = 1, .reusable = true}, SHIFT(2740),
  [6305] = {.count = 1, .reusable = false}, SHIFT(2741),
  [6307] = {.count = 1, .reusable = true}, SHIFT(2741),
  [6309] = {.count = 1, .reusable = false}, SHIFT(2742),
  [6311] = {.count = 1, .reusable = true}, SHIFT(2742),
  [6313] = {.count = 1, .reusable = true}, SHIFT(2743),
  [6315] = {.count = 1, .reusable = false}, SHIFT(2744),
  [6317] = {.count = 1, .reusable = true}, SHIFT(2744),
  [6319] = {.count = 1, .reusable = true}, SHIFT(2745),
  [6321] = {.count = 1, .reusable = true}, SHIFT(2746),
  [6323] = {.count = 1, .reusable = true}, SHIFT(2747),
  [6325] = {.count = 1, .reusable = false}, SHIFT(2748),
  [6327] = {.count = 1, .reusable = true}, SHIFT(2748),
  [6329] = {.count = 1, .reusable = false}, SHIFT(2749),
  [6331] = {.count = 1, .reusable = true}, SHIFT(2749),
  [6333] = {.count = 1, .reusable = true}, SHIFT(2750),
  [6335] = {.count = 1, .reusable = true}, SHIFT(2751),
  [6337] = {.count = 1, .reusable = true}, SHIFT(2752),
  [6339] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2512),
  [6342] = {.count = 1, .reusable = false}, SHIFT(2753),
  [6344] = {.count = 1, .reusable = true}, SHIFT(2754),
  [6346] = {.count = 1, .reusable = false}, SHIFT(2755),
  [6348] = {.count = 1, .reusable = true}, SHIFT(2756),
  [6350] = {.count = 1, .reusable = true}, SHIFT(2758),
  [6352] = {.count = 1, .reusable = true}, SHIFT(2759),
  [6354] = {.count = 1, .reusable = false}, SHIFT(2761),
  [6356] = {.count = 1, .reusable = true}, SHIFT(2761),
  [6358] = {.count = 1, .reusable = true}, SHIFT(2760),
  [6360] = {.count = 1, .reusable = false}, SHIFT(2763),
  [6362] = {.count = 1, .reusable = true}, SHIFT(2763),
  [6364] = {.count = 1, .reusable = true}, SHIFT(2762),
  [6366] = {.count = 1, .reusable = true}, SHIFT(2764),
  [6368] = {.count = 1, .reusable = true}, SHIFT(2765),
  [6370] = {.count = 1, .reusable = false}, SHIFT(2766),
  [6372] = {.count = 1, .reusable = true}, SHIFT(2766),
  [6374] = {.count = 1, .reusable = true}, SHIFT(2767),
  [6376] = {.count = 1, .reusable = true}, SHIFT(2768),
  [6378] = {.count = 1, .reusable = false}, SHIFT(2769),
  [6380] = {.count = 1, .reusable = true}, SHIFT(2769),
  [6382] = {.count = 1, .reusable = false}, SHIFT(2770),
  [6384] = {.count = 1, .reusable = true}, SHIFT(2770),
  [6386] = {.count = 1, .reusable = false}, SHIFT(2772),
  [6388] = {.count = 1, .reusable = true}, SHIFT(2772),
  [6390] = {.count = 1, .reusable = false}, SHIFT(2773),
  [6392] = {.count = 1, .reusable = true}, SHIFT(2773),
  [6394] = {.count = 1, .reusable = true}, SHIFT(2775),
  [6396] = {.count = 1, .reusable = false}, SHIFT(2776),
  [6398] = {.count = 1, .reusable = true}, SHIFT(2776),
  [6400] = {.count = 1, .reusable = false}, SHIFT(2777),
  [6402] = {.count = 1, .reusable = true}, SHIFT(2777),
  [6404] = {.count = 1, .reusable = true}, SHIFT(2779),
  [6406] = {.count = 1, .reusable = true}, SHIFT(2780),
  [6408] = {.count = 1, .reusable = true}, SHIFT(2781),
  [6410] = {.count = 1, .reusable = true}, SHIFT(2782),
  [6412] = {.count = 1, .reusable = false}, SHIFT(2783),
  [6414] = {.count = 1, .reusable = true}, SHIFT(2784),
  [6416] = {.count = 1, .reusable = true}, SHIFT(2786),
  [6418] = {.count = 1, .reusable = true}, SHIFT(2787),
  [6420] = {.count = 1, .reusable = false}, SHIFT(2788),
  [6422] = {.count = 1, .reusable = true}, SHIFT(2788),
  [6424] = {.count = 1, .reusable = true}, SHIFT(2789),
  [6426] = {.count = 1, .reusable = false}, SHIFT(2790),
  [6428] = {.count = 1, .reusable = true}, SHIFT(2790),
  [6430] = {.count = 1, .reusable = true}, SHIFT(2791),
  [6432] = {.count = 1, .reusable = false}, SHIFT(2792),
  [6434] = {.count = 1, .reusable = true}, SHIFT(2792),
  [6436] = {.count = 1, .reusable = true}, SHIFT(2793),
  [6438] = {.count = 1, .reusable = false}, SHIFT(2794),
  [6440] = {.count = 1, .reusable = true}, SHIFT(2794),
  [6442] = {.count = 1, .reusable = false}, SHIFT(2795),
  [6444] = {.count = 1, .reusable = true}, SHIFT(2795),
  [6446] = {.count = 1, .reusable = true}, SHIFT(2796),
  [6448] = {.count = 1, .reusable = false}, SHIFT(2797),
  [6450] = {.count = 1, .reusable = true}, SHIFT(2797),
  [6452] = {.count = 1, .reusable = true}, SHIFT(2798),
  [6454] = {.count = 1, .reusable = true}, SHIFT(2799),
  [6456] = {.count = 1, .reusable = true}, SHIFT(2800),
  [6458] = {.count = 1, .reusable = false}, SHIFT(2801),
  [6460] = {.count = 1, .reusable = true}, SHIFT(2801),
  [6462] = {.count = 1, .reusable = false}, SHIFT(2802),
  [6464] = {.count = 1, .reusable = true}, SHIFT(2802),
  [6466] = {.count = 1, .reusable = true}, SHIFT(2803),
  [6468] = {.count = 1, .reusable = true}, SHIFT(2804),
  [6470] = {.count = 1, .reusable = true}, SHIFT(2805),
  [6472] = {.count = 1, .reusable = true}, SHIFT(2806),
  [6474] = {.count = 1, .reusable = true}, SHIFT(2807),
  [6476] = {.count = 1, .reusable = true}, SHIFT(2808),
  [6478] = {.count = 1, .reusable = false}, SHIFT(2809),
  [6480] = {.count = 1, .reusable = true}, SHIFT(2809),
  [6482] = {.count = 1, .reusable = false}, SHIFT(2810),
  [6484] = {.count = 1, .reusable = true}, SHIFT(2810),
  [6486] = {.count = 1, .reusable = true}, SHIFT(2811),
  [6488] = {.count = 1, .reusable = true}, SHIFT(2812),
  [6490] = {.count = 1, .reusable = true}, SHIFT(2813),
  [6492] = {.count = 1, .reusable = true}, SHIFT(2814),
  [6494] = {.count = 1, .reusable = true}, SHIFT(2815),
  [6496] = {.count = 1, .reusable = true}, SHIFT(2816),
  [6498] = {.count = 1, .reusable = true}, SHIFT(2817),
  [6500] = {.count = 1, .reusable = false}, SHIFT(2818),
  [6502] = {.count = 1, .reusable = true}, SHIFT(2819),
  [6504] = {.count = 1, .reusable = true}, SHIFT(2821),
  [6506] = {.count = 1, .reusable = true}, SHIFT(2822),
  [6508] = {.count = 1, .reusable = false}, SHIFT(2823),
  [6510] = {.count = 1, .reusable = true}, SHIFT(2823),
  [6512] = {.count = 1, .reusable = true}, SHIFT(2824),
  [6514] = {.count = 1, .reusable = false}, SHIFT(2825),
  [6516] = {.count = 1, .reusable = true}, SHIFT(2825),
  [6518] = {.count = 1, .reusable = true}, SHIFT(2826),
  [6520] = {.count = 1, .reusable = false}, SHIFT(2827),
  [6522] = {.count = 1, .reusable = true}, SHIFT(2827),
  [6524] = {.count = 1, .reusable = true}, SHIFT(2828),
  [6526] = {.count = 1, .reusable = false}, SHIFT(2829),
  [6528] = {.count = 1, .reusable = true}, SHIFT(2829),
  [6530] = {.count = 1, .reusable = false}, SHIFT(2830),
  [6532] = {.count = 1, .reusable = true}, SHIFT(2830),
  [6534] = {.count = 1, .reusable = true}, SHIFT(2831),
  [6536] = {.count = 1, .reusable = false}, SHIFT(2832),
  [6538] = {.count = 1, .reusable = true}, SHIFT(2832),
  [6540] = {.count = 1, .reusable = true}, SHIFT(2833),
  [6542] = {.count = 1, .reusable = true}, SHIFT(2834),
  [6544] = {.count = 1, .reusable = true}, SHIFT(2835),
  [6546] = {.count = 1, .reusable = false}, SHIFT(2836),
  [6548] = {.count = 1, .reusable = true}, SHIFT(2836),
  [6550] = {.count = 1, .reusable = false}, SHIFT(2837),
  [6552] = {.count = 1, .reusable = true}, SHIFT(2837),
  [6554] = {.count = 1, .reusable = true}, SHIFT(2838),
  [6556] = {.count = 1, .reusable = true}, SHIFT(2839),
  [6558] = {.count = 1, .reusable = true}, SHIFT(2840),
  [6560] = {.count = 1, .reusable = true}, SHIFT(2841),
  [6562] = {.count = 1, .reusable = true}, SHIFT(2842),
  [6564] = {.count = 1, .reusable = true}, SHIFT(2843),
  [6566] = {.count = 1, .reusable = true}, SHIFT(2844),
  [6568] = {.count = 1, .reusable = true}, SHIFT(2845),
  [6570] = {.count = 1, .reusable = true}, SHIFT(2846),
  [6572] = {.count = 1, .reusable = true}, SHIFT(2847),
  [6574] = {.count = 1, .reusable = false}, SHIFT(2848),
  [6576] = {.count = 1, .reusable = true}, SHIFT(2848),
  [6578] = {.count = 1, .reusable = false}, SHIFT(2849),
  [6580] = {.count = 1, .reusable = true}, SHIFT(2849),
  [6582] = {.count = 1, .reusable = true}, SHIFT(2850),
  [6584] = {.count = 1, .reusable = true}, SHIFT(2851),
  [6586] = {.count = 1, .reusable = true}, SHIFT(2852),
  [6588] = {.count = 1, .reusable = true}, SHIFT(2853),
  [6590] = {.count = 1, .reusable = true}, SHIFT(2854),
  [6592] = {.count = 1, .reusable = true}, SHIFT(2855),
  [6594] = {.count = 1, .reusable = true}, SHIFT(2856),
};

void *tree_sitter_bash_external_scanner_create();
void tree_sitter_bash_external_scanner_destroy(void *);
bool tree_sitter_bash_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_bash_external_scanner_serialize(void *, char *);
void tree_sitter_bash_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_bash() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_word,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_bash_external_scanner_create,
      tree_sitter_bash_external_scanner_destroy,
      tree_sitter_bash_external_scanner_scan,
      tree_sitter_bash_external_scanner_serialize,
      tree_sitter_bash_external_scanner_deserialize,
    },
  };
  return &language;
}
